/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ 7833:
/***/ ((module, exports, __webpack_require__) => {

/* eslint-env browser */

/**
 * This is the web browser implementation of `debug()`.
 */

exports.formatArgs = formatArgs;
exports.save = save;
exports.load = load;
exports.useColors = useColors;
exports.storage = localstorage();
exports.destroy = (() => {
	let warned = false;

	return () => {
		if (!warned) {
			warned = true;
			console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
		}
	};
})();

/**
 * Colors.
 */

exports.colors = [
	'#0000CC',
	'#0000FF',
	'#0033CC',
	'#0033FF',
	'#0066CC',
	'#0066FF',
	'#0099CC',
	'#0099FF',
	'#00CC00',
	'#00CC33',
	'#00CC66',
	'#00CC99',
	'#00CCCC',
	'#00CCFF',
	'#3300CC',
	'#3300FF',
	'#3333CC',
	'#3333FF',
	'#3366CC',
	'#3366FF',
	'#3399CC',
	'#3399FF',
	'#33CC00',
	'#33CC33',
	'#33CC66',
	'#33CC99',
	'#33CCCC',
	'#33CCFF',
	'#6600CC',
	'#6600FF',
	'#6633CC',
	'#6633FF',
	'#66CC00',
	'#66CC33',
	'#9900CC',
	'#9900FF',
	'#9933CC',
	'#9933FF',
	'#99CC00',
	'#99CC33',
	'#CC0000',
	'#CC0033',
	'#CC0066',
	'#CC0099',
	'#CC00CC',
	'#CC00FF',
	'#CC3300',
	'#CC3333',
	'#CC3366',
	'#CC3399',
	'#CC33CC',
	'#CC33FF',
	'#CC6600',
	'#CC6633',
	'#CC9900',
	'#CC9933',
	'#CCCC00',
	'#CCCC33',
	'#FF0000',
	'#FF0033',
	'#FF0066',
	'#FF0099',
	'#FF00CC',
	'#FF00FF',
	'#FF3300',
	'#FF3333',
	'#FF3366',
	'#FF3399',
	'#FF33CC',
	'#FF33FF',
	'#FF6600',
	'#FF6633',
	'#FF9900',
	'#FF9933',
	'#FFCC00',
	'#FFCC33'
];

/**
 * Currently only WebKit-based Web Inspectors, Firefox >= v31,
 * and the Firebug extension (any Firefox version) are known
 * to support "%c" CSS customizations.
 *
 * TODO: add a `localStorage` variable to explicitly enable/disable colors
 */

// eslint-disable-next-line complexity
function useColors() {
	// NB: In an Electron preload script, document will be defined but not fully
	// initialized. Since we know we're in Chrome, we'll just detect this case
	// explicitly
	if (typeof window !== 'undefined' && window.process && (window.process.type === 'renderer' || window.process.__nwjs)) {
		return true;
	}

	// Internet Explorer and Edge do not support colors.
	if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
		return false;
	}

	// Is webkit? http://stackoverflow.com/a/16459606/376773
	// document is undefined in react-native: https://github.com/facebook/react-native/pull/1632
	return (typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance) ||
		// Is firebug? http://stackoverflow.com/a/398120/376773
		(typeof window !== 'undefined' && window.console && (window.console.firebug || (window.console.exception && window.console.table))) ||
		// Is firefox >= v31?
		// https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
		(typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31) ||
		// Double check webkit in userAgent just in case we are in a worker
		(typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
}

/**
 * Colorize log arguments if enabled.
 *
 * @api public
 */

function formatArgs(args) {
	args[0] = (this.useColors ? '%c' : '') +
		this.namespace +
		(this.useColors ? ' %c' : ' ') +
		args[0] +
		(this.useColors ? '%c ' : ' ') +
		'+' + module.exports.humanize(this.diff);

	if (!this.useColors) {
		return;
	}

	const c = 'color: ' + this.color;
	args.splice(1, 0, c, 'color: inherit');

	// The final "%c" is somewhat tricky, because there could be other
	// arguments passed either before or after the %c, so we need to
	// figure out the correct index to insert the CSS into
	let index = 0;
	let lastC = 0;
	args[0].replace(/%[a-zA-Z%]/g, match => {
		if (match === '%%') {
			return;
		}
		index++;
		if (match === '%c') {
			// We only are interested in the *last* %c
			// (the user may have provided their own)
			lastC = index;
		}
	});

	args.splice(lastC, 0, c);
}

/**
 * Invokes `console.debug()` when available.
 * No-op when `console.debug` is not a "function".
 * If `console.debug` is not available, falls back
 * to `console.log`.
 *
 * @api public
 */
exports.log = console.debug || console.log || (() => {});

/**
 * Save `namespaces`.
 *
 * @param {String} namespaces
 * @api private
 */
function save(namespaces) {
	try {
		if (namespaces) {
			exports.storage.setItem('debug', namespaces);
		} else {
			exports.storage.removeItem('debug');
		}
	} catch (error) {
		// Swallow
		// XXX (@Qix-) should we be logging these?
	}
}

/**
 * Load `namespaces`.
 *
 * @return {String} returns the previously persisted debug modes
 * @api private
 */
function load() {
	let r;
	try {
		r = exports.storage.getItem('debug');
	} catch (error) {
		// Swallow
		// XXX (@Qix-) should we be logging these?
	}

	// If debug isn't set in LS, and we're in Electron, try to load $DEBUG
	if (!r && typeof process !== 'undefined' && 'env' in process) {
		r = ({"NODE_ENV":"production"}).DEBUG;
	}

	return r;
}

/**
 * Localstorage attempts to return the localstorage.
 *
 * This is necessary because safari throws
 * when a user disables cookies/localstorage
 * and you attempt to access it.
 *
 * @return {LocalStorage}
 * @api private
 */

function localstorage() {
	try {
		// TVMLKit (Apple TV JS Runtime) does not have a window object, just localStorage in the global context
		// The Browser also has localStorage in the global context.
		return localStorage;
	} catch (error) {
		// Swallow
		// XXX (@Qix-) should we be logging these?
	}
}

module.exports = __webpack_require__(736)(exports);

const {formatters} = module.exports;

/**
 * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
 */

formatters.j = function (v) {
	try {
		return JSON.stringify(v);
	} catch (error) {
		return '[UnexpectedJSONParseError]: ' + error.message;
	}
};


/***/ }),

/***/ 736:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/**
 * This is the common logic for both the Node.js and web browser
 * implementations of `debug()`.
 */

function setup(env) {
	createDebug.debug = createDebug;
	createDebug.default = createDebug;
	createDebug.coerce = coerce;
	createDebug.disable = disable;
	createDebug.enable = enable;
	createDebug.enabled = enabled;
	createDebug.humanize = __webpack_require__(6585);
	createDebug.destroy = destroy;

	Object.keys(env).forEach(key => {
		createDebug[key] = env[key];
	});

	/**
	* The currently active debug mode names, and names to skip.
	*/

	createDebug.names = [];
	createDebug.skips = [];

	/**
	* Map of special "%n" handling functions, for the debug "format" argument.
	*
	* Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
	*/
	createDebug.formatters = {};

	/**
	* Selects a color for a debug namespace
	* @param {String} namespace The namespace string for the debug instance to be colored
	* @return {Number|String} An ANSI color code for the given namespace
	* @api private
	*/
	function selectColor(namespace) {
		let hash = 0;

		for (let i = 0; i < namespace.length; i++) {
			hash = ((hash << 5) - hash) + namespace.charCodeAt(i);
			hash |= 0; // Convert to 32bit integer
		}

		return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
	}
	createDebug.selectColor = selectColor;

	/**
	* Create a debugger with the given `namespace`.
	*
	* @param {String} namespace
	* @return {Function}
	* @api public
	*/
	function createDebug(namespace) {
		let prevTime;
		let enableOverride = null;
		let namespacesCache;
		let enabledCache;

		function debug(...args) {
			// Disabled?
			if (!debug.enabled) {
				return;
			}

			const self = debug;

			// Set `diff` timestamp
			const curr = Number(new Date());
			const ms = curr - (prevTime || curr);
			self.diff = ms;
			self.prev = prevTime;
			self.curr = curr;
			prevTime = curr;

			args[0] = createDebug.coerce(args[0]);

			if (typeof args[0] !== 'string') {
				// Anything else let's inspect with %O
				args.unshift('%O');
			}

			// Apply any `formatters` transformations
			let index = 0;
			args[0] = args[0].replace(/%([a-zA-Z%])/g, (match, format) => {
				// If we encounter an escaped % then don't increase the array index
				if (match === '%%') {
					return '%';
				}
				index++;
				const formatter = createDebug.formatters[format];
				if (typeof formatter === 'function') {
					const val = args[index];
					match = formatter.call(self, val);

					// Now we need to remove `args[index]` since it's inlined in the `format`
					args.splice(index, 1);
					index--;
				}
				return match;
			});

			// Apply env-specific formatting (colors, etc.)
			createDebug.formatArgs.call(self, args);

			const logFn = self.log || createDebug.log;
			logFn.apply(self, args);
		}

		debug.namespace = namespace;
		debug.useColors = createDebug.useColors();
		debug.color = createDebug.selectColor(namespace);
		debug.extend = extend;
		debug.destroy = createDebug.destroy; // XXX Temporary. Will be removed in the next major release.

		Object.defineProperty(debug, 'enabled', {
			enumerable: true,
			configurable: false,
			get: () => {
				if (enableOverride !== null) {
					return enableOverride;
				}
				if (namespacesCache !== createDebug.namespaces) {
					namespacesCache = createDebug.namespaces;
					enabledCache = createDebug.enabled(namespace);
				}

				return enabledCache;
			},
			set: v => {
				enableOverride = v;
			}
		});

		// Env-specific initialization logic for debug instances
		if (typeof createDebug.init === 'function') {
			createDebug.init(debug);
		}

		return debug;
	}

	function extend(namespace, delimiter) {
		const newDebug = createDebug(this.namespace + (typeof delimiter === 'undefined' ? ':' : delimiter) + namespace);
		newDebug.log = this.log;
		return newDebug;
	}

	/**
	* Enables a debug mode by namespaces. This can include modes
	* separated by a colon and wildcards.
	*
	* @param {String} namespaces
	* @api public
	*/
	function enable(namespaces) {
		createDebug.save(namespaces);
		createDebug.namespaces = namespaces;

		createDebug.names = [];
		createDebug.skips = [];

		let i;
		const split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
		const len = split.length;

		for (i = 0; i < len; i++) {
			if (!split[i]) {
				// ignore empty strings
				continue;
			}

			namespaces = split[i].replace(/\*/g, '.*?');

			if (namespaces[0] === '-') {
				createDebug.skips.push(new RegExp('^' + namespaces.slice(1) + '$'));
			} else {
				createDebug.names.push(new RegExp('^' + namespaces + '$'));
			}
		}
	}

	/**
	* Disable debug output.
	*
	* @return {String} namespaces
	* @api public
	*/
	function disable() {
		const namespaces = [
			...createDebug.names.map(toNamespace),
			...createDebug.skips.map(toNamespace).map(namespace => '-' + namespace)
		].join(',');
		createDebug.enable('');
		return namespaces;
	}

	/**
	* Returns true if the given mode name is enabled, false otherwise.
	*
	* @param {String} name
	* @return {Boolean}
	* @api public
	*/
	function enabled(name) {
		if (name[name.length - 1] === '*') {
			return true;
		}

		let i;
		let len;

		for (i = 0, len = createDebug.skips.length; i < len; i++) {
			if (createDebug.skips[i].test(name)) {
				return false;
			}
		}

		for (i = 0, len = createDebug.names.length; i < len; i++) {
			if (createDebug.names[i].test(name)) {
				return true;
			}
		}

		return false;
	}

	/**
	* Convert regexp to namespace
	*
	* @param {RegExp} regxep
	* @return {String} namespace
	* @api private
	*/
	function toNamespace(regexp) {
		return regexp.toString()
			.substring(2, regexp.toString().length - 2)
			.replace(/\.\*\?$/, '*');
	}

	/**
	* Coerce `val`.
	*
	* @param {Mixed} val
	* @return {Mixed}
	* @api private
	*/
	function coerce(val) {
		if (val instanceof Error) {
			return val.stack || val.message;
		}
		return val;
	}

	/**
	* XXX DO NOT USE. This is a temporary stub function.
	* XXX It WILL be removed in the next major release.
	*/
	function destroy() {
		console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
	}

	createDebug.enable(createDebug.load());

	return createDebug;
}

module.exports = setup;


/***/ }),

/***/ 5753:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

/**
 * Detect Electron renderer / nwjs process, which is node, but we should
 * treat as a browser.
 */

if (typeof process === 'undefined' || process.type === 'renderer' || process.browser === true || process.__nwjs) {
	module.exports = __webpack_require__(7833);
} else {
	module.exports = __webpack_require__(6033);
}


/***/ }),

/***/ 6033:
/***/ ((module, exports, __webpack_require__) => {

/**
 * Module dependencies.
 */

const tty = __webpack_require__(2018);
const util = __webpack_require__(9023);

/**
 * This is the Node.js implementation of `debug()`.
 */

exports.init = init;
exports.log = log;
exports.formatArgs = formatArgs;
exports.save = save;
exports.load = load;
exports.useColors = useColors;
exports.destroy = util.deprecate(
	() => {},
	'Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.'
);

/**
 * Colors.
 */

exports.colors = [6, 2, 3, 4, 5, 1];

try {
	// Optional dependency (as in, doesn't need to be installed, NOT like optionalDependencies in package.json)
	// eslint-disable-next-line import/no-extraneous-dependencies
	const supportsColor = __webpack_require__(7687);

	if (supportsColor && (supportsColor.stderr || supportsColor).level >= 2) {
		exports.colors = [
			20,
			21,
			26,
			27,
			32,
			33,
			38,
			39,
			40,
			41,
			42,
			43,
			44,
			45,
			56,
			57,
			62,
			63,
			68,
			69,
			74,
			75,
			76,
			77,
			78,
			79,
			80,
			81,
			92,
			93,
			98,
			99,
			112,
			113,
			128,
			129,
			134,
			135,
			148,
			149,
			160,
			161,
			162,
			163,
			164,
			165,
			166,
			167,
			168,
			169,
			170,
			171,
			172,
			173,
			178,
			179,
			184,
			185,
			196,
			197,
			198,
			199,
			200,
			201,
			202,
			203,
			204,
			205,
			206,
			207,
			208,
			209,
			214,
			215,
			220,
			221
		];
	}
} catch (error) {
	// Swallow - we only care if `supports-color` is available; it doesn't have to be.
}

/**
 * Build up the default `inspectOpts` object from the environment variables.
 *
 *   $ DEBUG_COLORS=no DEBUG_DEPTH=10 DEBUG_SHOW_HIDDEN=enabled node script.js
 */

exports.inspectOpts = Object.keys(({"NODE_ENV":"production"})).filter(key => {
	return /^debug_/i.test(key);
}).reduce((obj, key) => {
	// Camel-case
	const prop = key
		.substring(6)
		.toLowerCase()
		.replace(/_([a-z])/g, (_, k) => {
			return k.toUpperCase();
		});

	// Coerce string value into JS value
	let val = ({"NODE_ENV":"production"})[key];
	if (/^(yes|on|true|enabled)$/i.test(val)) {
		val = true;
	} else if (/^(no|off|false|disabled)$/i.test(val)) {
		val = false;
	} else if (val === 'null') {
		val = null;
	} else {
		val = Number(val);
	}

	obj[prop] = val;
	return obj;
}, {});

/**
 * Is stdout a TTY? Colored output is enabled when `true`.
 */

function useColors() {
	return 'colors' in exports.inspectOpts ?
		Boolean(exports.inspectOpts.colors) :
		tty.isatty(process.stderr.fd);
}

/**
 * Adds ANSI color escape codes if enabled.
 *
 * @api public
 */

function formatArgs(args) {
	const {namespace: name, useColors} = this;

	if (useColors) {
		const c = this.color;
		const colorCode = '\u001B[3' + (c < 8 ? c : '8;5;' + c);
		const prefix = `  ${colorCode};1m${name} \u001B[0m`;

		args[0] = prefix + args[0].split('\n').join('\n' + prefix);
		args.push(colorCode + 'm+' + module.exports.humanize(this.diff) + '\u001B[0m');
	} else {
		args[0] = getDate() + name + ' ' + args[0];
	}
}

function getDate() {
	if (exports.inspectOpts.hideDate) {
		return '';
	}
	return new Date().toISOString() + ' ';
}

/**
 * Invokes `util.format()` with the specified arguments and writes to stderr.
 */

function log(...args) {
	return process.stderr.write(util.format(...args) + '\n');
}

/**
 * Save `namespaces`.
 *
 * @param {String} namespaces
 * @api private
 */
function save(namespaces) {
	if (namespaces) {
		({"NODE_ENV":"production"}).DEBUG = namespaces;
	} else {
		// If you set a process.env field to null or undefined, it gets cast to the
		// string 'null' or 'undefined'. Just delete instead.
		delete ({"NODE_ENV":"production"}).DEBUG;
	}
}

/**
 * Load `namespaces`.
 *
 * @return {String} returns the previously persisted debug modes
 * @api private
 */

function load() {
	return ({"NODE_ENV":"production"}).DEBUG;
}

/**
 * Init logic for `debug` instances.
 *
 * Create a new `inspectOpts` object in case `useColors` is set
 * differently for a particular `debug` instance.
 */

function init(debug) {
	debug.inspectOpts = {};

	const keys = Object.keys(exports.inspectOpts);
	for (let i = 0; i < keys.length; i++) {
		debug.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
	}
}

module.exports = __webpack_require__(736)(exports);

const {formatters} = module.exports;

/**
 * Map %o to `util.inspect()`, all on a single line.
 */

formatters.o = function (v) {
	this.inspectOpts.colors = this.useColors;
	return util.inspect(v, this.inspectOpts)
		.split('\n')
		.map(str => str.trim())
		.join(' ');
};

/**
 * Map %O to `util.inspect()`, allowing multiple lines if needed.
 */

formatters.O = function (v) {
	this.inspectOpts.colors = this.useColors;
	return util.inspect(v, this.inspectOpts);
};


/***/ }),

/***/ 894:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const node = __webpack_require__(4746);

module.exports = node;


/***/ }),

/***/ 885:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const scopeFactory = __webpack_require__(61);

/**
 * @property {Function} error
 * @property {Function} warn
 * @property {Function} info
 * @property {Function} verbose
 * @property {Function} debug
 * @property {Function} silly
 */
class Logger {
  static instances = {};

  dependencies = {};
  errorHandler = null;
  eventLogger = null;
  functions = {};
  hooks = [];
  isDev = false;
  levels = null;
  logId = null;
  scope = null;
  transports = {};
  variables = {};

  constructor({
    allowUnknownLevel = false,
    dependencies = {},
    errorHandler,
    eventLogger,
    initializeFn,
    isDev = false,
    levels = ['error', 'warn', 'info', 'verbose', 'debug', 'silly'],
    logId,
    transportFactories = {},
    variables,
  } = {}) {
    this.addLevel = this.addLevel.bind(this);
    this.create = this.create.bind(this);
    this.initialize = this.initialize.bind(this);
    this.logData = this.logData.bind(this);
    this.processMessage = this.processMessage.bind(this);

    this.allowUnknownLevel = allowUnknownLevel;
    this.dependencies = dependencies;
    this.initializeFn = initializeFn;
    this.isDev = isDev;
    this.levels = levels;
    this.logId = logId;
    this.transportFactories = transportFactories;
    this.variables = variables || {};
    this.scope = scopeFactory(this);

    this.addLevel('log', false);
    for (const name of this.levels) {
      this.addLevel(name, false);
    }

    this.errorHandler = errorHandler;
    errorHandler?.setOptions({ ...dependencies, logFn: this.error });

    this.eventLogger = eventLogger;
    eventLogger?.setOptions({ ...dependencies, logger: this });

    for (const [name, factory] of Object.entries(transportFactories)) {
      this.transports[name] = factory(this, dependencies);
    }

    Logger.instances[logId] = this;
  }

  static getInstance({ logId }) {
    return this.instances[logId] || this.instances.default;
  }

  addLevel(level, index = this.levels.length) {
    if (index !== false) {
      this.levels.splice(index, 0, level);
    }

    this[level] = (...args) => this.logData(args, { level });
    this.functions[level] = this[level];
  }

  catchErrors(options) {
    this.processMessage(
      {
        data: ['log.catchErrors is deprecated. Use log.errorHandler instead'],
        level: 'warn',
      },
      { transports: ['console'] },
    );
    return this.errorHandler.startCatching(options);
  }

  create(options) {
    if (typeof options === 'string') {
      options = { logId: options };
    }

    return new Logger({
      dependencies: this.dependencies,
      errorHandler: this.errorHandler,
      initializeFn: this.initializeFn,
      isDev: this.isDev,
      transportFactories: this.transportFactories,
      variables: { ...this.variables },
      ...options,
    });
  }

  compareLevels(passLevel, checkLevel, levels = this.levels) {
    const pass = levels.indexOf(passLevel);
    const check = levels.indexOf(checkLevel);
    if (check === -1 || pass === -1) {
      return true;
    }

    return check <= pass;
  }

  initialize(options = {}) {
    this.initializeFn({ logger: this, ...this.dependencies, ...options });
  }

  logData(data, options = {}) {
    this.processMessage({ data, ...options });
  }

  processMessage(message, { transports = this.transports } = {}) {
    if (message.cmd === 'errorHandler') {
      this.errorHandler.handle(message.error, {
        errorName: message.errorName,
        processType: 'renderer',
        showDialog: Boolean(message.showDialog),
      });
      return;
    }

    let level = message.level;
    if (!this.allowUnknownLevel) {
      level = this.levels.includes(message.level) ? message.level : 'info';
    }

    const normalizedMessage = {
      date: new Date(),
      ...message,
      level,
      variables: {
        ...this.variables,
        ...message.variables,
      },
    };

    for (const [transName, transFn] of this.transportEntries(transports)) {
      if (typeof transFn !== 'function' || transFn.level === false) {
        continue;
      }

      if (!this.compareLevels(transFn.level, message.level)) {
        continue;
      }

      try {
        // eslint-disable-next-line arrow-body-style
        const transformedMsg = this.hooks.reduce((msg, hook) => {
          return msg ? hook(msg, transFn, transName) : msg;
        }, normalizedMessage);

        if (transformedMsg) {
          transFn({ ...transformedMsg, data: [...transformedMsg.data] });
        }
      } catch (e) {
        this.processInternalErrorFn(e);
      }
    }
  }

  processInternalErrorFn(_e) {
    // Do nothing by default
  }

  transportEntries(transports = this.transports) {
    const transportArray = Array.isArray(transports)
      ? transports
      : Object.entries(transports);

    return transportArray
      .map((item) => {
        switch (typeof item) {
          case 'string':
            return this.transports[item] ? [item, this.transports[item]] : null;
          case 'function':
            return [item.name, item];
          default:
            return Array.isArray(item) ? item : null;
        }
      })
      .filter(Boolean);
  }
}

module.exports = Logger;


/***/ }),

/***/ 61:
/***/ ((module) => {

"use strict";


module.exports = scopeFactory;

function scopeFactory(logger) {
  return Object.defineProperties(scope, {
    defaultLabel: { value: '', writable: true },
    labelPadding: { value: true, writable: true },
    maxLabelLength: { value: 0, writable: true },
    labelLength: {
      get() {
        switch (typeof scope.labelPadding) {
          case 'boolean': return scope.labelPadding ? scope.maxLabelLength : 0;
          case 'number': return scope.labelPadding;
          default: return 0;
        }
      },
    },
  });

  function scope(label) {
    scope.maxLabelLength = Math.max(scope.maxLabelLength, label.length);

    const newScope = {};
    for (const level of [...logger.levels, 'log']) {
      newScope[level] = (...d) => logger.logData(d, { level, scope: label });
    }
    return newScope;
  }
}


/***/ }),

/***/ 4454:
/***/ ((module) => {

"use strict";


class ErrorHandler {
  externalApi = undefined;
  isActive = false;
  logFn = undefined;
  onError = undefined;
  showDialog = true;

  constructor({
    externalApi,
    logFn = undefined,
    onError = undefined,
    showDialog = undefined,
  } = {}) {
    this.createIssue = this.createIssue.bind(this);
    this.handleError = this.handleError.bind(this);
    this.handleRejection = this.handleRejection.bind(this);
    this.setOptions({ externalApi, logFn, onError, showDialog });
    this.startCatching = this.startCatching.bind(this);
    this.stopCatching = this.stopCatching.bind(this);
  }

  handle(error, {
    logFn = this.logFn,
    onError = this.onError,
    processType = 'browser',
    showDialog = this.showDialog,
    errorName = '',
  } = {}) {
    error = normalizeError(error);

    try {
      if (typeof onError === 'function') {
        const versions = this.externalApi?.getVersions() || {};
        const createIssue = this.createIssue;
        const result = onError({
          createIssue,
          error,
          errorName,
          processType,
          versions,
        });
        if (result === false) {
          return;
        }
      }

      errorName ? logFn(errorName, error) : logFn(error);

      if (showDialog && !errorName.includes('rejection') && this.externalApi) {
        this.externalApi.showErrorBox(
          `A JavaScript error occurred in the ${processType} process`,
          error.stack,
        );
      }
    } catch {
      console.error(error); // eslint-disable-line no-console
    }
  }

  setOptions({ externalApi, logFn, onError, showDialog }) {
    if (typeof externalApi === 'object') {
      this.externalApi = externalApi;
    }

    if (typeof logFn === 'function') {
      this.logFn = logFn;
    }

    if (typeof onError === 'function') {
      this.onError = onError;
    }

    if (typeof showDialog === 'boolean') {
      this.showDialog = showDialog;
    }
  }

  startCatching({ onError, showDialog } = {}) {
    if (this.isActive) {
      return;
    }

    this.isActive = true;
    this.setOptions({ onError, showDialog });
    process.on('uncaughtException', this.handleError);
    process.on('unhandledRejection', this.handleRejection);
  }

  stopCatching() {
    this.isActive = false;
    process.removeListener('uncaughtException', this.handleError);
    process.removeListener('unhandledRejection', this.handleRejection);
  }

  createIssue(pageUrl, queryParams) {
    this.externalApi?.openUrl(
      `${pageUrl}?${new URLSearchParams(queryParams).toString()}`,
    );
  }

  handleError(error) {
    this.handle(error, { errorName: 'Unhandled' });
  }

  handleRejection(reason) {
    const error = reason instanceof Error
      ? reason
      : new Error(JSON.stringify(reason));
    this.handle(error, { errorName: 'Unhandled rejection' });
  }
}

function normalizeError(e) {
  if (e instanceof Error) {
    return e;
  }

  if (e && typeof e === 'object') {
    if (e.message) {
      return Object.assign(new Error(e.message), e);
    }
    try {
      return new Error(JSON.stringify(e));
    } catch (serErr) {
      return new Error(`Couldn't normalize error ${String(e)}: ${serErr}`);
    }
  }

  return new Error(`Can't normalize error ${String(e)}`);
}

module.exports = ErrorHandler;


/***/ }),

/***/ 2050:
/***/ ((module) => {

"use strict";


class EventLogger {
  disposers = [];
  format = '{eventSource}#{eventName}:';
  formatters = {
    app: {
      'certificate-error': ({ args }) => {
        return this.arrayToObject(args.slice(1, 4), [
          'url',
          'error',
          'certificate',
        ]);
      },
      'child-process-gone': ({ args }) => {
        return args.length === 1 ? args[0] : args;
      },
      'render-process-gone': ({ args: [webContents, details] }) => {
        return details && typeof details === 'object'
          ? { ...details, ...this.getWebContentsDetails(webContents) }
          : [];
      },
    },

    webContents: {
      'console-message': ({ args: [level, message, line, sourceId] }) => {
        // 0: debug, 1: info, 2: warning, 3: error
        if (level < 3) {
          return undefined;
        }

        return { message, source: `${sourceId}:${line}` };
      },
      'did-fail-load': ({ args }) => {
        return this.arrayToObject(args, [
          'errorCode',
          'errorDescription',
          'validatedURL',
          'isMainFrame',
          'frameProcessId',
          'frameRoutingId',
        ]);
      },
      'did-fail-provisional-load': ({ args }) => {
        return this.arrayToObject(args, [
          'errorCode',
          'errorDescription',
          'validatedURL',
          'isMainFrame',
          'frameProcessId',
          'frameRoutingId',
        ]);
      },
      'plugin-crashed': ({ args }) => {
        return this.arrayToObject(args, ['name', 'version']);
      },
      'preload-error': ({ args }) => {
        return this.arrayToObject(args, ['preloadPath', 'error']);
      },
    },
  };

  events = {
    app: {
      'certificate-error': true,
      'child-process-gone': true,
      'render-process-gone': true,
    },

    webContents: {
      // 'console-message': true,
      'did-fail-load': true,
      'did-fail-provisional-load': true,
      'plugin-crashed': true,
      'preload-error': true,
      'unresponsive': true,
    },
  };

  externalApi = undefined;
  level = 'error';
  scope = '';

  constructor(options = {}) {
    this.setOptions(options);
  }

  setOptions({
    events,
    externalApi,
    level,
    logger,
    format,
    formatters,
    scope,
  }) {
    if (typeof events === 'object') {
      this.events = events;
    }

    if (typeof externalApi === 'object') {
      this.externalApi = externalApi;
    }

    if (typeof level === 'string') {
      this.level = level;
    }

    if (typeof logger === 'object') {
      this.logger = logger;
    }

    if (typeof format === 'string' || typeof format === 'function') {
      this.format = format;
    }

    if (typeof formatters === 'object') {
      this.formatters = formatters;
    }

    if (typeof scope === 'string') {
      this.scope = scope;
    }
  }

  startLogging(options = {}) {
    this.setOptions(options);

    this.disposeListeners();

    for (const eventName of this.getEventNames(this.events.app)) {
      this.disposers.push(
        this.externalApi.onAppEvent(eventName, (...handlerArgs) => {
          this.handleEvent({ eventSource: 'app', eventName, handlerArgs });
        }),
      );
    }

    for (const eventName of this.getEventNames(this.events.webContents)) {
      this.disposers.push(
        this.externalApi.onEveryWebContentsEvent(
          eventName,
          (...handlerArgs) => {
            this.handleEvent(
              { eventSource: 'webContents', eventName, handlerArgs },
            );
          },
        ),
      );
    }
  }

  stopLogging() {
    this.disposeListeners();
  }

  arrayToObject(array, fieldNames) {
    const obj = {};

    fieldNames.forEach((fieldName, index) => {
      obj[fieldName] = array[index];
    });

    if (array.length > fieldNames.length) {
      obj.unknownArgs = array.slice(fieldNames.length);
    }

    return obj;
  }

  disposeListeners() {
    this.disposers.forEach((disposer) => disposer());
    this.disposers = [];
  }

  formatEventLog({ eventName, eventSource, handlerArgs }) {
    const [event, ...args] = handlerArgs;
    if (typeof this.format === 'function') {
      return this.format({ args, event, eventName, eventSource });
    }

    const formatter = this.formatters[eventSource]?.[eventName];
    let formattedArgs = args;
    if (typeof formatter === 'function') {
      formattedArgs = formatter({ args, event, eventName, eventSource });
    }

    if (!formattedArgs) {
      return undefined;
    }

    const eventData = {};

    if (Array.isArray(formattedArgs)) {
      eventData.args = formattedArgs;
    } else if (typeof formattedArgs === 'object') {
      Object.assign(eventData, formattedArgs);
    }

    if (eventSource === 'webContents') {
      Object.assign(eventData, this.getWebContentsDetails(event?.sender));
    }

    const title = this.format
      .replace('{eventSource}', eventSource === 'app' ? 'App' : 'WebContents')
      .replace('{eventName}', eventName);

    return [title, eventData];
  }

  getEventNames(eventMap) {
    if (!eventMap || typeof eventMap !== 'object') {
      return [];
    }

    return Object.entries(eventMap)
      .filter(([_, listen]) => listen)
      .map(([eventName]) => eventName);
  }

  getWebContentsDetails(webContents) {
    if (!webContents?.loadURL) {
      return {};
    }

    try {
      return {
        webContents: {
          id: webContents.id,
          url: webContents.getURL(),
        },
      };
    } catch {
      return {};
    }
  }

  handleEvent({ eventName, eventSource, handlerArgs }) {
    const log = this.formatEventLog({ eventName, eventSource, handlerArgs });
    if (log) {
      const logFns = this.scope ? this.logger.scope(this.scope) : this.logger;
      logFns?.[this.level]?.(...log);
    }
  }
}

module.exports = EventLogger;


/***/ }),

/***/ 407:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


/* eslint-disable no-unused-vars */

const childProcess = __webpack_require__(5317);
const os = __webpack_require__(857);
const path = __webpack_require__(6928);
const packageJson = __webpack_require__(9084);

class NodeExternalApi {
  appName = undefined;
  appPackageJson = undefined;
  platform = process.platform;

  getAppLogPath(appName = this.getAppName()) {
    if (this.platform === 'darwin') {
      return path.join(this.getSystemPathHome(), 'Library/Logs', appName);
    }

    return path.join(this.getAppUserDataPath(appName), 'logs');
  }

  getAppName() {
    const appName = this.appName || this.getAppPackageJson()?.name;
    if (!appName) {
      throw new Error(
        'electron-log can\'t determine the app name. It tried these methods:\n'
        + '1. Use `electron.app.name`\n'
        + '2. Use productName or name from the nearest package.json`\n'
        + 'You can also set it through log.transports.file.setAppName()',
      );
    }

    return appName;
  }

  /**
   * @private
   * @returns {undefined}
   */
  getAppPackageJson() {
    if (typeof this.appPackageJson !== 'object') {
      this.appPackageJson = packageJson.findAndReadPackageJson();
    }

    return this.appPackageJson;
  }

  getAppUserDataPath(appName = this.getAppName()) {
    return appName
      ? path.join(this.getSystemPathAppData(), appName)
      : undefined;
  }

  getAppVersion() {
    return this.getAppPackageJson()?.version;
  }

  getElectronLogPath() {
    return this.getAppLogPath();
  }

  getMacOsVersion() {
    const release = Number(os.release().split('.')[0]);
    if (release <= 19) {
      return `10.${release - 4}`;
    }

    return release - 9;
  }

  /**
   * @protected
   * @returns {string}
   */
  getOsVersion() {
    let osName = os.type().replace('_', ' ');
    let osVersion = os.release();

    if (osName === 'Darwin') {
      osName = 'macOS';
      osVersion = this.getMacOsVersion();
    }

    return `${osName} ${osVersion}`;
  }

  /**
   * @return {PathVariables}
   */
  getPathVariables() {
    const appName = this.getAppName();
    const appVersion = this.getAppVersion();

    const self = this;

    return {
      appData: this.getSystemPathAppData(),
      appName,
      appVersion,
      get electronDefaultDir() {
        return self.getElectronLogPath();
      },
      home: this.getSystemPathHome(),
      libraryDefaultDir: this.getAppLogPath(appName),
      libraryTemplate: this.getAppLogPath('{appName}'),
      temp: this.getSystemPathTemp(),
      userData: this.getAppUserDataPath(appName),
    };
  }

  getSystemPathAppData() {
    const home = this.getSystemPathHome();

    switch (this.platform) {
      case 'darwin': {
        return path.join(home, 'Library/Application Support');
      }

      case 'win32': {
        return ({"NODE_ENV":"production"}).APPDATA || path.join(home, 'AppData/Roaming');
      }

      default: {
        return ({"NODE_ENV":"production"}).XDG_CONFIG_HOME || path.join(home, '.config');
      }
    }
  }

  getSystemPathHome() {
    return os.homedir?.() || ({"NODE_ENV":"production"}).HOME;
  }

  getSystemPathTemp() {
    return os.tmpdir();
  }

  getVersions() {
    return {
      app: `${this.getAppName()} ${this.getAppVersion()}`,
      electron: undefined,
      os: this.getOsVersion(),
    };
  }

  isDev() {
    return  false
      || ({"NODE_ENV":"production"}).ELECTRON_IS_DEV === '1';
  }

  isElectron() {
    return Boolean(process.versions.electron);
  }

  onAppEvent(_eventName, _handler) {
    // Ignored in node.js
  }

  onAppReady(handler) {
    handler();
  }

  onEveryWebContentsEvent(eventName, handler) {
    // Ignored in node.js
  }

  /**
   * Listen to async messages sent from opposite process
   * @param {string} channel
   * @param {function} listener
   */
  onIpc(channel, listener) {
    // Ignored in node.js
  }

  onIpcInvoke(channel, listener) {
    // Ignored in node.js
  }

  /**
   * @param {string} url
   * @param {Function} [logFunction]
   */
  openUrl(url, logFunction = console.error) { // eslint-disable-line no-console
    const startMap = { darwin: 'open', win32: 'start', linux: 'xdg-open' };
    const start = startMap[process.platform] || 'xdg-open';
    childProcess.exec(`${start} ${url}`, {}, (err) => {
      if (err) {
        logFunction(err);
      }
    });
  }

  setAppName(appName) {
    this.appName = appName;
  }

  setPlatform(platform) {
    this.platform = platform;
  }

  setPreloadFileForSessions({
    filePath, // eslint-disable-line no-unused-vars
    includeFutureSession = true, // eslint-disable-line no-unused-vars
    getSessions = () => [], // eslint-disable-line no-unused-vars
  }) {
    // Ignored in node.js
  }

  /**
   * Sent a message to opposite process
   * @param {string} channel
   * @param {any} message
   */
  sendIpc(channel, message) {
    // Ignored in node.js
  }

  showErrorBox(title, message) {
    // Ignored in node.js
  }
}

module.exports = NodeExternalApi;


/***/ }),

/***/ 8559:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const Logger = __webpack_require__(885);
const ErrorHandler = __webpack_require__(4454);
const EventLogger = __webpack_require__(2050);
const transportConsole = __webpack_require__(9456);
const transportFile = __webpack_require__(1548);
const transportIpc = __webpack_require__(4631);
const transportRemote = __webpack_require__(9359);

module.exports = createDefaultLogger;

function createDefaultLogger({ dependencies, initializeFn }) {
  const defaultLogger = new Logger({
    dependencies,
    errorHandler: new ErrorHandler(),
    eventLogger: new EventLogger(),
    initializeFn,
    isDev: dependencies.externalApi?.isDev(),
    logId: 'default',
    transportFactories: {
      console: transportConsole,
      file: transportFile,
      ipc: transportIpc,
      remote: transportRemote,
    },
    variables: {
      processType: 'main',
    },
  });

  defaultLogger.default = defaultLogger;
  defaultLogger.Logger = Logger;

  defaultLogger.processInternalErrorFn = (e) => {
    defaultLogger.transports.console.writeFn({
      message: {
        data: ['Unhandled electron-log error', e],
        level: 'error',
      },
    });
  };

  return defaultLogger;
}


/***/ }),

/***/ 4746:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const NodeExternalApi = __webpack_require__(407);
const createDefaultLogger = __webpack_require__(8559);

const externalApi = new NodeExternalApi();

const defaultLogger = createDefaultLogger({
  dependencies: { externalApi },
});

module.exports = defaultLogger;


/***/ }),

/***/ 9084:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(9896);
const path = __webpack_require__(6928);

module.exports = {
  findAndReadPackageJson,
  tryReadJsonAt,
};

/**
 * @return {{ name?: string, version?: string}}
 */
function findAndReadPackageJson() {
  return tryReadJsonAt(getMainModulePath())
    || tryReadJsonAt(extractPathFromArgs())
    || tryReadJsonAt(process.resourcesPath, 'app.asar')
    || tryReadJsonAt(process.resourcesPath, 'app')
    || tryReadJsonAt(process.cwd())
    || { name: undefined, version: undefined };
}

/**
 * @param {...string} searchPaths
 * @return {{ name?: string, version?: string } | undefined}
 */
function tryReadJsonAt(...searchPaths) {
  if (!searchPaths[0]) {
    return undefined;
  }

  try {
    const searchPath = path.join(...searchPaths);
    const fileName = findUp('package.json', searchPath);
    if (!fileName) {
      return undefined;
    }

    const json = JSON.parse(fs.readFileSync(fileName, 'utf8'));
    const name = json?.productName || json?.name;
    if (!name || name.toLowerCase() === 'electron') {
      return undefined;
    }

    if (name) {
      return { name, version: json?.version };
    }

    return undefined;
  } catch (e) {
    return undefined;
  }
}

/**
 * @param {string} fileName
 * @param {string} [cwd]
 * @return {string | null}
 */
function findUp(fileName, cwd) {
  let currentPath = cwd;
  // eslint-disable-next-line no-constant-condition
  while (true) {
    const parsedPath = path.parse(currentPath);
    const root = parsedPath.root;
    const dir = parsedPath.dir;

    if (fs.existsSync(path.join(currentPath, fileName))) {
      return path.resolve(path.join(currentPath, fileName));
    }

    if (currentPath === root) {
      return null;
    }

    currentPath = dir;
  }
}

/**
 * Get app path from --user-data-dir cmd arg, passed to a renderer process
 * @return {string|null}
 */
function extractPathFromArgs() {
  const matchedArgs = process.argv.filter((arg) => {
    return arg.indexOf('--user-data-dir=') === 0;
  });

  if (matchedArgs.length === 0 || typeof matchedArgs[0] !== 'string') {
    return null;
  }

  const userDataDir = matchedArgs[0];
  return userDataDir.replace('--user-data-dir=', '');
}

function getMainModulePath() {
  try {
    // Requires isn't available in ESM
    return __webpack_require__.c[__webpack_require__.s]?.filename;
  } catch {
    return undefined;
  }
}


/***/ }),

/***/ 1935:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { transform } = __webpack_require__(8018);

module.exports = {
  concatFirstStringElements,
  formatScope,
  formatText,
  formatVariables,
  timeZoneFromOffset,

  format({ message, logger, transport, data = message?.data }) {
    switch (typeof transport.format) {
      case 'string': {
        return transform({
          message,
          logger,
          transforms: [formatVariables, formatScope, formatText],
          transport,
          initialData: [transport.format, ...data],
        });
      }

      case 'function': {
        return transport.format({
          data,
          level: message?.level || 'info',
          logger,
          message,
          transport,
        });
      }

      default: {
        return data;
      }
    }
  },
};

/**
 * The first argument of console.log may contain a template. In the library
 * the first element is a string related to transports.console.format. So
 * this function concatenates first two elements to make templates like %d
 * work
 * @param {*[]} data
 * @return {*[]}
 */
function concatFirstStringElements({ data }) {
  if (typeof data[0] !== 'string' || typeof data[1] !== 'string') {
    return data;
  }

  if (data[0].match(/%[1cdfiOos]/)) {
    return data;
  }

  return [`${data[0]} ${data[1]}`, ...data.slice(2)];
}

function timeZoneFromOffset(minutesOffset) {
  const minutesPositive = Math.abs(minutesOffset);
  const sign = minutesOffset >= 0 ? '-' : '+';
  const hours = Math.floor(minutesPositive / 60).toString().padStart(2, '0');
  const minutes = (minutesPositive % 60).toString().padStart(2, '0');
  return `${sign}${hours}:${minutes}`;
}

function formatScope({ data, logger, message }) {
  const { defaultLabel, labelLength } = logger?.scope || {};
  const template = data[0];
  let label = message.scope;

  if (!label) {
    label = defaultLabel;
  }

  let scopeText;
  if (label === '') {
    scopeText = labelLength > 0 ? ''.padEnd(labelLength + 3) : '';
  } else if (typeof label === 'string') {
    scopeText = ` (${label})`.padEnd(labelLength + 3);
  } else {
    scopeText = '';
  }

  data[0] = template.replace('{scope}', scopeText);
  return data;
}

function formatVariables({ data, message }) {
  let template = data[0];
  if (typeof template !== 'string') {
    return data;
  }

  // Add additional space to the end of {level}] template to align messages
  template = template.replace('{level}]', `${message.level}]`.padEnd(6, ' '));

  const date = message.date || new Date();
  data[0] = template
    .replace(/\{(\w+)}/g, (substring, name) => {
      switch (name) {
        case 'level': return message.level || 'info';
        case 'logId': return message.logId;

        case 'y': return date.getFullYear().toString(10);
        case 'm': return (date.getMonth() + 1).toString(10).padStart(2, '0');
        case 'd': return date.getDate().toString(10).padStart(2, '0');
        case 'h': return date.getHours().toString(10).padStart(2, '0');
        case 'i': return date.getMinutes().toString(10).padStart(2, '0');
        case 's': return date.getSeconds().toString(10).padStart(2, '0');
        case 'ms': return date.getMilliseconds().toString(10).padStart(3, '0');
        case 'z': return timeZoneFromOffset(date.getTimezoneOffset());
        case 'iso': return date.toISOString();

        default: {
          return message.variables?.[name] || substring;
        }
      }
    })
    .trim();

  return data;
}

function formatText({ data }) {
  const template = data[0];
  if (typeof template !== 'string') {
    return data;
  }

  const textTplPosition = template.lastIndexOf('{text}');
  if (textTplPosition === template.length - 6) {
    data[0] = template.replace(/\s?{text}/, '');
    if (data[0] === '') {
      data.shift();
    }

    return data;
  }

  const templatePieces = template.split('{text}');
  let result = [];

  if (templatePieces[0] !== '') {
    result.push(templatePieces[0]);
  }

  result = result.concat(data.slice(1));

  if (templatePieces[1] !== '') {
    result.push(templatePieces[1]);
  }

  return result;
}


/***/ }),

/***/ 8915:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const util = __webpack_require__(9023);

module.exports = {
  serialize,

  maxDepth({ data, transport, depth = transport?.depth ?? 6 }) {
    if (!data) {
      return data;
    }

    if (depth < 1) {
      if (Array.isArray(data)) return '[array]';
      if (typeof data === 'object' && data) return '[object]';

      return data;
    }

    if (Array.isArray(data)) {
      return data.map((child) => module.exports.maxDepth({
        data: child,
        depth: depth - 1,
      }));
    }

    if (typeof data !== 'object') {
      return data;
    }

    if (data && typeof data.toISOString === 'function') {
      return data;
    }

    // noinspection PointlessBooleanExpressionJS
    if (data === null) {
      return null;
    }

    if (data instanceof Error) {
      return data;
    }

    const newJson = {};
    for (const i in data) {
      if (!Object.prototype.hasOwnProperty.call(data, i)) continue;
      newJson[i] = module.exports.maxDepth({
        data: data[i],
        depth: depth - 1,
      });
    }

    return newJson;
  },

  toJSON({ data }) {
    return JSON.parse(JSON.stringify(data, createSerializer()));
  },

  toString({ data, transport }) {
    const inspectOptions = transport?.inspectOptions || {};

    const simplifiedData = data.map((item) => {
      if (item === undefined) {
        return undefined;
      }

      try {
        const str = JSON.stringify(item, createSerializer(), '  ');
        return str === undefined ? undefined : JSON.parse(str);
      } catch (e) {
        // There are some rare cases when an item can't be simplified.
        // In that case, it's fine to pass it to util.format directly.
        return item;
      }
    });

    return util.formatWithOptions(inspectOptions, ...simplifiedData);
  },
};

/**
 * @param {object} options?
 * @param {boolean} options.serializeMapAndSet?
 * @return {function}
 */
function createSerializer(options = {}) {
  const seen = new WeakSet();

  return function (key, value) {
    if (typeof value === 'object' && value !== null) {
      if (seen.has(value)) {
        return undefined;
      }

      seen.add(value);
    }

    return serialize(key, value, options);
  };
}

/**
 * @param {string} key
 * @param {any} value
 * @param {object} options?
 * @return {any}
 */
function serialize(key, value, options = {}) {
  const serializeMapAndSet = options?.serializeMapAndSet !== false;

  if (value instanceof Error) {
    return value.stack;
  }

  if (!value) {
    return value;
  }

  if (typeof value === 'function') {
    return `[function] ${value.toString()}`;
  }

  if (value instanceof Date) {
    return value.toISOString();
  }

  if (serializeMapAndSet && value instanceof Map && Object.fromEntries) {
    return Object.fromEntries(value);
  }

  if (serializeMapAndSet && value instanceof Set && Array.from) {
    return Array.from(value);
  }

  return value;
}


/***/ }),

/***/ 8503:
/***/ ((module) => {

"use strict";


module.exports = {
  transformStyles,

  applyAnsiStyles({ data }) {
    return transformStyles(data, styleToAnsi, resetAnsiStyle);
  },

  removeStyles({ data }) {
    return transformStyles(data, () => '');
  },
};

const ANSI_COLORS = {
  unset: '\x1b[0m',
  black: '\x1b[30m',
  red: '\x1b[31m',
  green: '\x1b[32m',
  yellow: '\x1b[33m',
  blue: '\x1b[34m',
  magenta: '\x1b[35m',
  cyan: '\x1b[36m',
  white: '\x1b[37m',
};

function styleToAnsi(style) {
  const color = style.replace(/color:\s*(\w+).*/, '$1').toLowerCase();
  return ANSI_COLORS[color] || '';
}

function resetAnsiStyle(string) {
  return string + ANSI_COLORS.unset;
}

function transformStyles(data, onStyleFound, onStyleApplied) {
  const foundStyles = {};

  return data.reduce((result, item, index, array) => {
    if (foundStyles[index]) {
      return result;
    }

    if (typeof item === 'string') {
      let valueIndex = index;
      let styleApplied = false;

      item = item.replace(/%[1cdfiOos]/g, (match) => {
        valueIndex += 1;

        if (match !== '%c') {
          return match;
        }

        const style = array[valueIndex];
        if (typeof style === 'string') {
          foundStyles[valueIndex] = true;
          styleApplied = true;
          return onStyleFound(style, item);
        }

        return match;
      });

      if (styleApplied && onStyleApplied) {
        item = onStyleApplied(item);
      }
    }

    result.push(item);
    return result;
  }, []);
}


/***/ }),

/***/ 8018:
/***/ ((module) => {

"use strict";


module.exports = { transform };

function transform({
  logger,
  message,
  transport,

  initialData = message?.data || [],
  transforms = transport?.transforms,
}) {
  return transforms.reduce((data, trans) => {
    if (typeof trans === 'function') {
      return trans({ data, logger, message, transport });
    }

    return data;
  }, initialData);
}


/***/ }),

/***/ 9456:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


/* eslint-disable no-console */

const { concatFirstStringElements, format } = __webpack_require__(1935);
const { maxDepth, toJSON } = __webpack_require__(8915);
const { applyAnsiStyles, removeStyles } = __webpack_require__(8503);
const { transform } = __webpack_require__(8018);

const consoleMethods = {
  error: console.error,
  warn: console.warn,
  info: console.info,
  verbose: console.info,
  debug: console.debug,
  silly: console.debug,
  log: console.log,
};

module.exports = consoleTransportFactory;

const separator = process.platform === 'win32' ? '>' : '›';
const DEFAULT_FORMAT = `%c{h}:{i}:{s}.{ms}{scope}%c ${separator} {text}`;

Object.assign(consoleTransportFactory, {
  DEFAULT_FORMAT,
});

function consoleTransportFactory(logger) {
  return Object.assign(transport, {
    format: DEFAULT_FORMAT,
    level: 'silly',
    transforms: [
      addTemplateColors,
      format,
      formatStyles,
      concatFirstStringElements,
      maxDepth,
      toJSON,
    ],
    useStyles: ({"NODE_ENV":"production"}).FORCE_STYLES,

    writeFn({ message }) {
      const consoleLogFn = consoleMethods[message.level] || consoleMethods.info;
      consoleLogFn(...message.data);
    },
  });

  function transport(message) {
    const data = transform({ logger, message, transport });
    transport.writeFn({
      message: { ...message, data },
    });
  }
}

function addTemplateColors({ data, message, transport }) {
  if (transport.format !== DEFAULT_FORMAT) {
    return data;
  }

  return [`color:${levelToStyle(message.level)}`, 'color:unset', ...data];
}

function canUseStyles(useStyleValue, level) {
  if (typeof useStyleValue === 'boolean') {
    return useStyleValue;
  }

  const useStderr = level === 'error' || level === 'warn';
  const stream = useStderr ? process.stderr : process.stdout;
  return stream && stream.isTTY;
}

function formatStyles(args) {
  const { message, transport } = args;
  const useStyles = canUseStyles(transport.useStyles, message.level);
  const nextTransform = useStyles ? applyAnsiStyles : removeStyles;
  return nextTransform(args);
}

function levelToStyle(level) {
  const map = { error: 'red', warn: 'yellow', info: 'cyan', default: 'unset' };
  return map[level] || map.default;
}


/***/ }),

/***/ 7364:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const EventEmitter = __webpack_require__(4434);
const fs = __webpack_require__(9896);
const os = __webpack_require__(857);

class File extends EventEmitter {
  asyncWriteQueue = [];
  bytesWritten = 0;
  hasActiveAsyncWriting = false;
  path = null;
  initialSize = undefined;
  writeOptions = null;
  writeAsync = false;

  constructor({
    path,
    writeOptions = { encoding: 'utf8', flag: 'a', mode: 0o666 },
    writeAsync = false,
  }) {
    super();

    this.path = path;
    this.writeOptions = writeOptions;
    this.writeAsync = writeAsync;
  }

  get size() {
    return this.getSize();
  }

  clear() {
    try {
      fs.writeFileSync(this.path, '', {
        mode: this.writeOptions.mode,
        flag: 'w',
      });
      this.reset();
      return true;
    } catch (e) {
      if (e.code === 'ENOENT') {
        return true;
      }

      this.emit('error', e, this);
      return false;
    }
  }

  crop(bytesAfter) {
    try {
      const content = readFileSyncFromEnd(this.path, bytesAfter || 4096);
      this.clear();
      this.writeLine(`[log cropped]${os.EOL}${content}`);
    } catch (e) {
      this.emit(
        'error',
        new Error(`Couldn't crop file ${this.path}. ${e.message}`),
        this,
      );
    }
  }

  getSize() {
    if (this.initialSize === undefined) {
      try {
        const stats = fs.statSync(this.path);
        this.initialSize = stats.size;
      } catch (e) {
        this.initialSize = 0;
      }
    }

    return this.initialSize + this.bytesWritten;
  }

  increaseBytesWrittenCounter(text) {
    this.bytesWritten += Buffer.byteLength(text, this.writeOptions.encoding);
  }

  isNull() {
    return false;
  }

  nextAsyncWrite() {
    const file = this;

    if (this.hasActiveAsyncWriting || this.asyncWriteQueue.length === 0) {
      return;
    }

    const text = this.asyncWriteQueue.join('');
    this.asyncWriteQueue = [];
    this.hasActiveAsyncWriting = true;

    fs.writeFile(this.path, text, this.writeOptions, (e) => {
      file.hasActiveAsyncWriting = false;

      if (e) {
        file.emit(
          'error',
          new Error(`Couldn't write to ${file.path}. ${e.message}`),
          this,
        );
      } else {
        file.increaseBytesWrittenCounter(text);
      }

      file.nextAsyncWrite();
    });
  }

  reset() {
    this.initialSize = undefined;
    this.bytesWritten = 0;
  }

  toString() {
    return this.path;
  }

  writeLine(text) {
    text += os.EOL;

    if (this.writeAsync) {
      this.asyncWriteQueue.push(text);
      this.nextAsyncWrite();
      return;
    }

    try {
      fs.writeFileSync(this.path, text, this.writeOptions);
      this.increaseBytesWrittenCounter(text);
    } catch (e) {
      this.emit(
        'error',
        new Error(`Couldn't write to ${this.path}. ${e.message}`),
        this,
      );
    }
  }
}

module.exports = File;

function readFileSyncFromEnd(filePath, bytesCount) {
  const buffer = Buffer.alloc(bytesCount);
  const stats = fs.statSync(filePath);

  const readLength = Math.min(stats.size, bytesCount);
  const offset = Math.max(0, stats.size - bytesCount);

  const fd = fs.openSync(filePath, 'r');
  const totalBytes = fs.readSync(fd, buffer, 0, readLength, offset);
  fs.closeSync(fd);

  return buffer.toString('utf8', 0, totalBytes);
}


/***/ }),

/***/ 5255:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const EventEmitter = __webpack_require__(4434);
const fs = __webpack_require__(9896);
const path = __webpack_require__(6928);
const File = __webpack_require__(7364);
const NullFile = __webpack_require__(8369);

class FileRegistry extends EventEmitter {
  store = {};

  constructor() {
    super();
    this.emitError = this.emitError.bind(this);
  }

  /**
   * Provide a File object corresponding to the filePath
   * @param {string} filePath
   * @param {WriteOptions} [writeOptions]
   * @param {boolean} [writeAsync]
   * @return {File}
   */
  provide({ filePath, writeOptions, writeAsync = false }) {
    let file;
    try {
      filePath = path.resolve(filePath);

      if (this.store[filePath]) {
        return this.store[filePath];
      }

      file = this.createFile({ filePath, writeOptions, writeAsync });
    } catch (e) {
      file = new NullFile({ path: filePath });
      this.emitError(e, file);
    }

    file.on('error', this.emitError);
    this.store[filePath] = file;
    return file;
  }

  /**
   * @param {string} filePath
   * @param {WriteOptions} writeOptions
   * @param {boolean} async
   * @return {File}
   * @private
   */
  createFile({ filePath, writeOptions, writeAsync }) {
    this.testFileWriting(filePath);
    return new File({ path: filePath, writeOptions, writeAsync });
  }

  /**
   * @param {Error} error
   * @param {File} file
   * @private
   */
  emitError(error, file) {
    this.emit('error', error, file);
  }

  /**
   * @param {string} filePath
   * @private
   */
  testFileWriting(filePath) {
    fs.mkdirSync(path.dirname(filePath), { recursive: true });
    fs.writeFileSync(filePath, '', { flag: 'a' });
  }
}

module.exports = FileRegistry;


/***/ }),

/***/ 8369:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const File = __webpack_require__(7364);

class NullFile extends File {
  clear() {

  }

  crop() {

  }

  getSize() {
    return 0;
  }

  isNull() {
    return true;
  }

  writeLine() {

  }
}

module.exports = NullFile;


/***/ }),

/***/ 1548:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(9896);
const os = __webpack_require__(857);
const path = __webpack_require__(6928);
const FileRegistry = __webpack_require__(5255);
const { transform } = __webpack_require__(8018);
const { removeStyles } = __webpack_require__(8503);
const { format } = __webpack_require__(1935);
const { toString } = __webpack_require__(8915);

module.exports = fileTransportFactory;

// Shared between multiple file transport instances
const globalRegistry = new FileRegistry();

function fileTransportFactory(
  logger,
  { registry = globalRegistry, externalApi } = {},
) {
  /** @type {PathVariables} */
  let pathVariables;

  if (registry.listenerCount('error') < 1) {
    registry.on('error', (e, file) => {
      logConsole(`Can't write to ${file}`, e);
    });
  }

  return Object.assign(transport, {
    fileName: getDefaultFileName(logger.variables.processType),
    format: '[{y}-{m}-{d} {h}:{i}:{s}.{ms}] [{level}]{scope} {text}',
    getFile,
    inspectOptions: { depth: 5 },
    level: 'silly',
    maxSize: 1024 ** 2,
    readAllLogs,
    sync: true,
    transforms: [removeStyles, format, toString],
    writeOptions: { flag: 'a', mode: 0o666, encoding: 'utf8' },

    archiveLogFn(file) {
      const oldPath = file.toString();
      const inf = path.parse(oldPath);
      try {
        fs.renameSync(oldPath, path.join(inf.dir, `${inf.name}.old${inf.ext}`));
      } catch (e) {
        logConsole('Could not rotate log', e);
        const quarterOfMaxSize = Math.round(transport.maxSize / 4);
        file.crop(Math.min(quarterOfMaxSize, 256 * 1024));
      }
    },

    resolvePathFn(vars) {
      return path.join(vars.libraryDefaultDir, vars.fileName);
    },

    setAppName(name) {
      logger.dependencies.externalApi.setAppName(name);
    },
  });

  function transport(message) {
    const file = getFile(message);

    const needLogRotation = transport.maxSize > 0
      && file.size > transport.maxSize;

    if (needLogRotation) {
      transport.archiveLogFn(file);
      file.reset();
    }

    const content = transform({ logger, message, transport });
    file.writeLine(content);
  }

  function initializeOnFirstAccess() {
    if (pathVariables) {
      return;
    }

    // Make a shallow copy of pathVariables to keep getters intact
    pathVariables = Object.create(
      Object.prototype,
      {
        ...Object.getOwnPropertyDescriptors(
          externalApi.getPathVariables(),
        ),
        fileName: {
          get() {
            return transport.fileName;
          },
          enumerable: true,
        },
      },
    );

    if (typeof transport.archiveLog === 'function') {
      transport.archiveLogFn = transport.archiveLog;
      logConsole('archiveLog is deprecated. Use archiveLogFn instead');
    }

    if (typeof transport.resolvePath === 'function') {
      transport.resolvePathFn = transport.resolvePath;
      logConsole('resolvePath is deprecated. Use resolvePathFn instead');
    }
  }

  function logConsole(message, error = null, level = 'error') {
    const data = [`electron-log.transports.file: ${message}`];

    if (error) {
      data.push(error);
    }

    logger.transports.console({ data, date: new Date(), level });
  }

  function getFile(msg) {
    initializeOnFirstAccess();

    const filePath = transport.resolvePathFn(pathVariables, msg);
    return registry.provide({
      filePath,
      writeAsync: !transport.sync,
      writeOptions: transport.writeOptions,
    });
  }

  function readAllLogs({ fileFilter = (f) => f.endsWith('.log') } = {}) {
    initializeOnFirstAccess();
    const logsPath = path.dirname(transport.resolvePathFn(pathVariables));

    if (!fs.existsSync(logsPath)) {
      return [];
    }

    return fs.readdirSync(logsPath)
      .map((fileName) => path.join(logsPath, fileName))
      .filter(fileFilter)
      .map((logPath) => {
        try {
          return {
            path: logPath,
            lines: fs.readFileSync(logPath, 'utf8').split(os.EOL),
          };
        } catch {
          return null;
        }
      })
      .filter(Boolean);
  }
}

function getDefaultFileName(processType = process.type) {
  switch (processType) {
    case 'renderer': return 'renderer.log';
    case 'worker': return 'worker.log';
    default: return 'main.log';
  }
}


/***/ }),

/***/ 4631:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { maxDepth, toJSON } = __webpack_require__(8915);
const { transform } = __webpack_require__(8018);

module.exports = ipcTransportFactory;

/**
 * @param logger
 * @param {ElectronExternalApi} externalApi
 * @returns {transport|null}
 */
function ipcTransportFactory(logger, { externalApi }) {
  Object.assign(transport, {
    depth: 3,
    eventId: '__ELECTRON_LOG_IPC__',
    level: logger.isDev ? 'silly' : false,
    transforms: [toJSON, maxDepth],
  });

  return externalApi?.isElectron() ? transport : undefined;

  function transport(message) {
    if (message?.variables?.processType === 'renderer') {
      return;
    }

    externalApi?.sendIpc(transport.eventId, {
      ...message,
      data: transform({ logger, message, transport }),
    });
  }
}


/***/ }),

/***/ 9359:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const http = __webpack_require__(8611);
const https = __webpack_require__(5692);
const { transform } = __webpack_require__(8018);
const { removeStyles } = __webpack_require__(8503);
const { toJSON, maxDepth } = __webpack_require__(8915);

module.exports = remoteTransportFactory;

function remoteTransportFactory(logger) {
  return Object.assign(transport, {
    client: { name: 'electron-application' },
    depth: 6,
    level: false,
    requestOptions: {},
    transforms: [removeStyles, toJSON, maxDepth],

    makeBodyFn({ message }) {
      return JSON.stringify({
        client: transport.client,
        data: message.data,
        date: message.date.getTime(),
        level: message.level,
        scope: message.scope,
        variables: message.variables,
      });
    },

    processErrorFn({ error }) {
      logger.processMessage(
        {
          data: [`electron-log: can't POST ${transport.url}`, error],
          level: 'warn',
        },
        { transports: ['console', 'file'] },
      );
    },

    sendRequestFn({ serverUrl, requestOptions, body }) {
      const httpTransport = serverUrl.startsWith('https:') ? https : http;

      const request = httpTransport.request(serverUrl, {
        method: 'POST',
        ...requestOptions,
        headers: {
          'Content-Type': 'application/json',
          'Content-Length': body.length,
          ...requestOptions.headers,
        },
      });

      request.write(body);
      request.end();

      return request;
    },
  });

  function transport(message) {
    if (!transport.url) {
      return;
    }

    const body = transport.makeBodyFn({
      logger,
      message: { ...message, data: transform({ logger, message, transport }) },
      transport,
    });

    const request = transport.sendRequestFn({
      serverUrl: transport.url,
      requestOptions: transport.requestOptions,
      body: Buffer.from(body, 'utf8'),
    });

    request.on('error', (error) => transport.processErrorFn({
      error,
      logger,
      message,
      request,
      transport,
    }));
  }
}


/***/ }),

/***/ 3411:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.CancellationError = exports.CancellationToken = void 0;
const events_1 = __webpack_require__(4434);
class CancellationToken extends events_1.EventEmitter {
    get cancelled() {
        return this._cancelled || (this._parent != null && this._parent.cancelled);
    }
    set parent(value) {
        this.removeParentCancelHandler();
        this._parent = value;
        this.parentCancelHandler = () => this.cancel();
        this._parent.onCancel(this.parentCancelHandler);
    }
    // babel cannot compile ... correctly for super calls
    constructor(parent) {
        super();
        this.parentCancelHandler = null;
        this._parent = null;
        this._cancelled = false;
        if (parent != null) {
            this.parent = parent;
        }
    }
    cancel() {
        this._cancelled = true;
        this.emit("cancel");
    }
    onCancel(handler) {
        if (this.cancelled) {
            handler();
        }
        else {
            this.once("cancel", handler);
        }
    }
    createPromise(callback) {
        if (this.cancelled) {
            return Promise.reject(new CancellationError());
        }
        const finallyHandler = () => {
            if (cancelHandler != null) {
                try {
                    this.removeListener("cancel", cancelHandler);
                    cancelHandler = null;
                }
                catch (ignore) {
                    // ignore
                }
            }
        };
        let cancelHandler = null;
        return new Promise((resolve, reject) => {
            let addedCancelHandler = null;
            cancelHandler = () => {
                try {
                    if (addedCancelHandler != null) {
                        addedCancelHandler();
                        addedCancelHandler = null;
                    }
                }
                finally {
                    reject(new CancellationError());
                }
            };
            if (this.cancelled) {
                cancelHandler();
                return;
            }
            this.onCancel(cancelHandler);
            callback(resolve, reject, (callback) => {
                addedCancelHandler = callback;
            });
        })
            .then(it => {
            finallyHandler();
            return it;
        })
            .catch((e) => {
            finallyHandler();
            throw e;
        });
    }
    removeParentCancelHandler() {
        const parent = this._parent;
        if (parent != null && this.parentCancelHandler != null) {
            parent.removeListener("cancel", this.parentCancelHandler);
            this.parentCancelHandler = null;
        }
    }
    dispose() {
        try {
            this.removeParentCancelHandler();
        }
        finally {
            this.removeAllListeners();
            this._parent = null;
        }
    }
}
exports.CancellationToken = CancellationToken;
class CancellationError extends Error {
    constructor() {
        super("cancelled");
    }
}
exports.CancellationError = CancellationError;
//# sourceMappingURL=CancellationToken.js.map

/***/ }),

/***/ 9067:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ProgressCallbackTransform = void 0;
const stream_1 = __webpack_require__(2203);
class ProgressCallbackTransform extends stream_1.Transform {
    constructor(total, cancellationToken, onProgress) {
        super();
        this.total = total;
        this.cancellationToken = cancellationToken;
        this.onProgress = onProgress;
        this.start = Date.now();
        this.transferred = 0;
        this.delta = 0;
        this.nextUpdate = this.start + 1000;
    }
    _transform(chunk, encoding, callback) {
        if (this.cancellationToken.cancelled) {
            callback(new Error("cancelled"), null);
            return;
        }
        this.transferred += chunk.length;
        this.delta += chunk.length;
        const now = Date.now();
        if (now >= this.nextUpdate && this.transferred !== this.total /* will be emitted on _flush */) {
            this.nextUpdate = now + 1000;
            this.onProgress({
                total: this.total,
                delta: this.delta,
                transferred: this.transferred,
                percent: (this.transferred / this.total) * 100,
                bytesPerSecond: Math.round(this.transferred / ((now - this.start) / 1000)),
            });
            this.delta = 0;
        }
        callback(null, chunk);
    }
    _flush(callback) {
        if (this.cancellationToken.cancelled) {
            callback(new Error("cancelled"));
            return;
        }
        this.onProgress({
            total: this.total,
            delta: this.delta,
            transferred: this.total,
            percent: 100,
            bytesPerSecond: Math.round(this.transferred / ((Date.now() - this.start) / 1000)),
        });
        this.delta = 0;
        callback(null);
    }
}
exports.ProgressCallbackTransform = ProgressCallbackTransform;
//# sourceMappingURL=ProgressCallbackTransform.js.map

/***/ }),

/***/ 6146:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.safeStringifyJson = exports.configureRequestOptions = exports.safeGetHeader = exports.DigestTransform = exports.configureRequestUrl = exports.configureRequestOptionsFromUrl = exports.HttpExecutor = exports.parseJson = exports.HttpError = exports.createHttpError = void 0;
const crypto_1 = __webpack_require__(6982);
const debug_1 = __webpack_require__(5753);
const fs_1 = __webpack_require__(9896);
const stream_1 = __webpack_require__(2203);
const url_1 = __webpack_require__(7016);
const CancellationToken_1 = __webpack_require__(3411);
const index_1 = __webpack_require__(6551);
const ProgressCallbackTransform_1 = __webpack_require__(9067);
const debug = (0, debug_1.default)("electron-builder");
function createHttpError(response, description = null) {
    return new HttpError(response.statusCode || -1, `${response.statusCode} ${response.statusMessage}` +
        (description == null ? "" : "\n" + JSON.stringify(description, null, "  ")) +
        "\nHeaders: " +
        safeStringifyJson(response.headers), description);
}
exports.createHttpError = createHttpError;
const HTTP_STATUS_CODES = new Map([
    [429, "Too many requests"],
    [400, "Bad request"],
    [403, "Forbidden"],
    [404, "Not found"],
    [405, "Method not allowed"],
    [406, "Not acceptable"],
    [408, "Request timeout"],
    [413, "Request entity too large"],
    [500, "Internal server error"],
    [502, "Bad gateway"],
    [503, "Service unavailable"],
    [504, "Gateway timeout"],
    [505, "HTTP version not supported"],
]);
class HttpError extends Error {
    constructor(statusCode, message = `HTTP error: ${HTTP_STATUS_CODES.get(statusCode) || statusCode}`, description = null) {
        super(message);
        this.statusCode = statusCode;
        this.description = description;
        this.name = "HttpError";
        this.code = `HTTP_ERROR_${statusCode}`;
    }
    isServerError() {
        return this.statusCode >= 500 && this.statusCode <= 599;
    }
}
exports.HttpError = HttpError;
function parseJson(result) {
    return result.then(it => (it == null || it.length === 0 ? null : JSON.parse(it)));
}
exports.parseJson = parseJson;
class HttpExecutor {
    constructor() {
        this.maxRedirects = 10;
    }
    request(options, cancellationToken = new CancellationToken_1.CancellationToken(), data) {
        configureRequestOptions(options);
        const json = data == null ? undefined : JSON.stringify(data);
        const encodedData = json ? Buffer.from(json) : undefined;
        if (encodedData != null) {
            debug(json);
            const { headers, ...opts } = options;
            options = {
                method: "post",
                headers: {
                    "Content-Type": "application/json",
                    "Content-Length": encodedData.length,
                    ...headers,
                },
                ...opts,
            };
        }
        return this.doApiRequest(options, cancellationToken, it => it.end(encodedData));
    }
    doApiRequest(options, cancellationToken, requestProcessor, redirectCount = 0) {
        if (debug.enabled) {
            debug(`Request: ${safeStringifyJson(options)}`);
        }
        return cancellationToken.createPromise((resolve, reject, onCancel) => {
            const request = this.createRequest(options, (response) => {
                try {
                    this.handleResponse(response, options, cancellationToken, resolve, reject, redirectCount, requestProcessor);
                }
                catch (e) {
                    reject(e);
                }
            });
            this.addErrorAndTimeoutHandlers(request, reject, options.timeout);
            this.addRedirectHandlers(request, options, reject, redirectCount, options => {
                this.doApiRequest(options, cancellationToken, requestProcessor, redirectCount).then(resolve).catch(reject);
            });
            requestProcessor(request, reject);
            onCancel(() => request.abort());
        });
    }
    // noinspection JSUnusedLocalSymbols
    // eslint-disable-next-line
    addRedirectHandlers(request, options, reject, redirectCount, handler) {
        // not required for NodeJS
    }
    addErrorAndTimeoutHandlers(request, reject, timeout = 60 * 1000) {
        this.addTimeOutHandler(request, reject, timeout);
        request.on("error", reject);
        request.on("aborted", () => {
            reject(new Error("Request has been aborted by the server"));
        });
    }
    handleResponse(response, options, cancellationToken, resolve, reject, redirectCount, requestProcessor) {
        var _a;
        if (debug.enabled) {
            debug(`Response: ${response.statusCode} ${response.statusMessage}, request options: ${safeStringifyJson(options)}`);
        }
        // we handle any other >= 400 error on request end (read detailed message in the response body)
        if (response.statusCode === 404) {
            // error is clear, we don't need to read detailed error description
            reject(createHttpError(response, `method: ${options.method || "GET"} url: ${options.protocol || "https:"}//${options.hostname}${options.port ? `:${options.port}` : ""}${options.path}

Please double check that your authentication token is correct. Due to security reasons, actual status maybe not reported, but 404.
`));
            return;
        }
        else if (response.statusCode === 204) {
            // on DELETE request
            resolve();
            return;
        }
        const code = (_a = response.statusCode) !== null && _a !== void 0 ? _a : 0;
        const shouldRedirect = code >= 300 && code < 400;
        const redirectUrl = safeGetHeader(response, "location");
        if (shouldRedirect && redirectUrl != null) {
            if (redirectCount > this.maxRedirects) {
                reject(this.createMaxRedirectError());
                return;
            }
            this.doApiRequest(HttpExecutor.prepareRedirectUrlOptions(redirectUrl, options), cancellationToken, requestProcessor, redirectCount).then(resolve).catch(reject);
            return;
        }
        response.setEncoding("utf8");
        let data = "";
        response.on("error", reject);
        response.on("data", (chunk) => (data += chunk));
        response.on("end", () => {
            try {
                if (response.statusCode != null && response.statusCode >= 400) {
                    const contentType = safeGetHeader(response, "content-type");
                    const isJson = contentType != null && (Array.isArray(contentType) ? contentType.find(it => it.includes("json")) != null : contentType.includes("json"));
                    reject(createHttpError(response, `method: ${options.method || "GET"} url: ${options.protocol || "https:"}//${options.hostname}${options.port ? `:${options.port}` : ""}${options.path}

          Data:
          ${isJson ? JSON.stringify(JSON.parse(data)) : data}
          `));
                }
                else {
                    resolve(data.length === 0 ? null : data);
                }
            }
            catch (e) {
                reject(e);
            }
        });
    }
    async downloadToBuffer(url, options) {
        return await options.cancellationToken.createPromise((resolve, reject, onCancel) => {
            const responseChunks = [];
            const requestOptions = {
                headers: options.headers || undefined,
                // because PrivateGitHubProvider requires HttpExecutor.prepareRedirectUrlOptions logic, so, we need to redirect manually
                redirect: "manual",
            };
            configureRequestUrl(url, requestOptions);
            configureRequestOptions(requestOptions);
            this.doDownload(requestOptions, {
                destination: null,
                options,
                onCancel,
                callback: error => {
                    if (error == null) {
                        resolve(Buffer.concat(responseChunks));
                    }
                    else {
                        reject(error);
                    }
                },
                responseHandler: (response, callback) => {
                    let receivedLength = 0;
                    response.on("data", (chunk) => {
                        receivedLength += chunk.length;
                        if (receivedLength > 524288000) {
                            callback(new Error("Maximum allowed size is 500 MB"));
                            return;
                        }
                        responseChunks.push(chunk);
                    });
                    response.on("end", () => {
                        callback(null);
                    });
                },
            }, 0);
        });
    }
    doDownload(requestOptions, options, redirectCount) {
        const request = this.createRequest(requestOptions, (response) => {
            if (response.statusCode >= 400) {
                options.callback(new Error(`Cannot download "${requestOptions.protocol || "https:"}//${requestOptions.hostname}${requestOptions.path}", status ${response.statusCode}: ${response.statusMessage}`));
                return;
            }
            // It is possible for the response stream to fail, e.g. when a network is lost while
            // response stream is in progress. Stop waiting and reject so consumer can catch the error.
            response.on("error", options.callback);
            // this code not relevant for Electron (redirect event instead handled)
            const redirectUrl = safeGetHeader(response, "location");
            if (redirectUrl != null) {
                if (redirectCount < this.maxRedirects) {
                    this.doDownload(HttpExecutor.prepareRedirectUrlOptions(redirectUrl, requestOptions), options, redirectCount++);
                }
                else {
                    options.callback(this.createMaxRedirectError());
                }
                return;
            }
            if (options.responseHandler == null) {
                configurePipes(options, response);
            }
            else {
                options.responseHandler(response, options.callback);
            }
        });
        this.addErrorAndTimeoutHandlers(request, options.callback, requestOptions.timeout);
        this.addRedirectHandlers(request, requestOptions, options.callback, redirectCount, requestOptions => {
            this.doDownload(requestOptions, options, redirectCount++);
        });
        request.end();
    }
    createMaxRedirectError() {
        return new Error(`Too many redirects (> ${this.maxRedirects})`);
    }
    addTimeOutHandler(request, callback, timeout) {
        request.on("socket", (socket) => {
            socket.setTimeout(timeout, () => {
                request.abort();
                callback(new Error("Request timed out"));
            });
        });
    }
    static prepareRedirectUrlOptions(redirectUrl, options) {
        const newOptions = configureRequestOptionsFromUrl(redirectUrl, { ...options });
        const headers = newOptions.headers;
        if (headers === null || headers === void 0 ? void 0 : headers.authorization) {
            const parsedNewUrl = new url_1.URL(redirectUrl);
            if (parsedNewUrl.hostname.endsWith(".amazonaws.com") || parsedNewUrl.searchParams.has("X-Amz-Credential")) {
                delete headers.authorization;
            }
        }
        return newOptions;
    }
    static retryOnServerError(task, maxRetries = 3) {
        for (let attemptNumber = 0;; attemptNumber++) {
            try {
                return task();
            }
            catch (e) {
                if (attemptNumber < maxRetries && ((e instanceof HttpError && e.isServerError()) || e.code === "EPIPE")) {
                    continue;
                }
                throw e;
            }
        }
    }
}
exports.HttpExecutor = HttpExecutor;
function configureRequestOptionsFromUrl(url, options) {
    const result = configureRequestOptions(options);
    configureRequestUrl(new url_1.URL(url), result);
    return result;
}
exports.configureRequestOptionsFromUrl = configureRequestOptionsFromUrl;
function configureRequestUrl(url, options) {
    options.protocol = url.protocol;
    options.hostname = url.hostname;
    if (url.port) {
        options.port = url.port;
    }
    else if (options.port) {
        delete options.port;
    }
    options.path = url.pathname + url.search;
}
exports.configureRequestUrl = configureRequestUrl;
class DigestTransform extends stream_1.Transform {
    // noinspection JSUnusedGlobalSymbols
    get actual() {
        return this._actual;
    }
    constructor(expected, algorithm = "sha512", encoding = "base64") {
        super();
        this.expected = expected;
        this.algorithm = algorithm;
        this.encoding = encoding;
        this._actual = null;
        this.isValidateOnEnd = true;
        this.digester = (0, crypto_1.createHash)(algorithm);
    }
    // noinspection JSUnusedGlobalSymbols
    _transform(chunk, encoding, callback) {
        this.digester.update(chunk);
        callback(null, chunk);
    }
    // noinspection JSUnusedGlobalSymbols
    _flush(callback) {
        this._actual = this.digester.digest(this.encoding);
        if (this.isValidateOnEnd) {
            try {
                this.validate();
            }
            catch (e) {
                callback(e);
                return;
            }
        }
        callback(null);
    }
    validate() {
        if (this._actual == null) {
            throw (0, index_1.newError)("Not finished yet", "ERR_STREAM_NOT_FINISHED");
        }
        if (this._actual !== this.expected) {
            throw (0, index_1.newError)(`${this.algorithm} checksum mismatch, expected ${this.expected}, got ${this._actual}`, "ERR_CHECKSUM_MISMATCH");
        }
        return null;
    }
}
exports.DigestTransform = DigestTransform;
function checkSha2(sha2Header, sha2, callback) {
    if (sha2Header != null && sha2 != null && sha2Header !== sha2) {
        callback(new Error(`checksum mismatch: expected ${sha2} but got ${sha2Header} (X-Checksum-Sha2 header)`));
        return false;
    }
    return true;
}
function safeGetHeader(response, headerKey) {
    const value = response.headers[headerKey];
    if (value == null) {
        return null;
    }
    else if (Array.isArray(value)) {
        // electron API
        return value.length === 0 ? null : value[value.length - 1];
    }
    else {
        return value;
    }
}
exports.safeGetHeader = safeGetHeader;
function configurePipes(options, response) {
    if (!checkSha2(safeGetHeader(response, "X-Checksum-Sha2"), options.options.sha2, options.callback)) {
        return;
    }
    const streams = [];
    if (options.options.onProgress != null) {
        const contentLength = safeGetHeader(response, "content-length");
        if (contentLength != null) {
            streams.push(new ProgressCallbackTransform_1.ProgressCallbackTransform(parseInt(contentLength, 10), options.options.cancellationToken, options.options.onProgress));
        }
    }
    const sha512 = options.options.sha512;
    if (sha512 != null) {
        streams.push(new DigestTransform(sha512, "sha512", sha512.length === 128 && !sha512.includes("+") && !sha512.includes("Z") && !sha512.includes("=") ? "hex" : "base64"));
    }
    else if (options.options.sha2 != null) {
        streams.push(new DigestTransform(options.options.sha2, "sha256", "hex"));
    }
    const fileOut = (0, fs_1.createWriteStream)(options.destination);
    streams.push(fileOut);
    let lastStream = response;
    for (const stream of streams) {
        stream.on("error", (error) => {
            fileOut.close();
            if (!options.options.cancellationToken.cancelled) {
                options.callback(error);
            }
        });
        lastStream = lastStream.pipe(stream);
    }
    fileOut.on("finish", () => {
        ;
        fileOut.close(options.callback);
    });
}
function configureRequestOptions(options, token, method) {
    if (method != null) {
        options.method = method;
    }
    options.headers = { ...options.headers };
    const headers = options.headers;
    if (token != null) {
        ;
        headers.authorization = token.startsWith("Basic") || token.startsWith("Bearer") ? token : `token ${token}`;
    }
    if (headers["User-Agent"] == null) {
        headers["User-Agent"] = "electron-builder";
    }
    if (method == null || method === "GET" || headers["Cache-Control"] == null) {
        headers["Cache-Control"] = "no-cache";
    }
    // do not specify for node (in any case we use https module)
    if (options.protocol == null && process.versions.electron != null) {
        options.protocol = "https:";
    }
    return options;
}
exports.configureRequestOptions = configureRequestOptions;
function safeStringifyJson(data, skippedNames) {
    return JSON.stringify(data, (name, value) => {
        if (name.endsWith("Authorization") ||
            name.endsWith("authorization") ||
            name.endsWith("Password") ||
            name.endsWith("PASSWORD") ||
            name.endsWith("Token") ||
            name.includes("password") ||
            name.includes("token") ||
            (skippedNames != null && skippedNames.has(name))) {
            return "<stripped sensitive data>";
        }
        return value;
    }, 2);
}
exports.safeStringifyJson = safeStringifyJson;
//# sourceMappingURL=httpExecutor.js.map

/***/ }),

/***/ 6551:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.newError = exports.asArray = exports.CURRENT_APP_PACKAGE_FILE_NAME = exports.CURRENT_APP_INSTALLER_FILE_NAME = exports.XElement = exports.parseXml = exports.ProgressCallbackTransform = exports.UUID = exports.parseDn = exports.githubUrl = exports.getS3LikeProviderBaseUrl = exports.configureRequestUrl = exports.parseJson = exports.safeStringifyJson = exports.configureRequestOptionsFromUrl = exports.configureRequestOptions = exports.safeGetHeader = exports.DigestTransform = exports.HttpExecutor = exports.createHttpError = exports.HttpError = exports.CancellationError = exports.CancellationToken = void 0;
var CancellationToken_1 = __webpack_require__(3411);
Object.defineProperty(exports, "CancellationToken", ({ enumerable: true, get: function () { return CancellationToken_1.CancellationToken; } }));
Object.defineProperty(exports, "CancellationError", ({ enumerable: true, get: function () { return CancellationToken_1.CancellationError; } }));
var httpExecutor_1 = __webpack_require__(6146);
Object.defineProperty(exports, "HttpError", ({ enumerable: true, get: function () { return httpExecutor_1.HttpError; } }));
Object.defineProperty(exports, "createHttpError", ({ enumerable: true, get: function () { return httpExecutor_1.createHttpError; } }));
Object.defineProperty(exports, "HttpExecutor", ({ enumerable: true, get: function () { return httpExecutor_1.HttpExecutor; } }));
Object.defineProperty(exports, "DigestTransform", ({ enumerable: true, get: function () { return httpExecutor_1.DigestTransform; } }));
Object.defineProperty(exports, "safeGetHeader", ({ enumerable: true, get: function () { return httpExecutor_1.safeGetHeader; } }));
Object.defineProperty(exports, "configureRequestOptions", ({ enumerable: true, get: function () { return httpExecutor_1.configureRequestOptions; } }));
Object.defineProperty(exports, "configureRequestOptionsFromUrl", ({ enumerable: true, get: function () { return httpExecutor_1.configureRequestOptionsFromUrl; } }));
Object.defineProperty(exports, "safeStringifyJson", ({ enumerable: true, get: function () { return httpExecutor_1.safeStringifyJson; } }));
Object.defineProperty(exports, "parseJson", ({ enumerable: true, get: function () { return httpExecutor_1.parseJson; } }));
Object.defineProperty(exports, "configureRequestUrl", ({ enumerable: true, get: function () { return httpExecutor_1.configureRequestUrl; } }));
var publishOptions_1 = __webpack_require__(2128);
Object.defineProperty(exports, "getS3LikeProviderBaseUrl", ({ enumerable: true, get: function () { return publishOptions_1.getS3LikeProviderBaseUrl; } }));
Object.defineProperty(exports, "githubUrl", ({ enumerable: true, get: function () { return publishOptions_1.githubUrl; } }));
var rfc2253Parser_1 = __webpack_require__(9345);
Object.defineProperty(exports, "parseDn", ({ enumerable: true, get: function () { return rfc2253Parser_1.parseDn; } }));
var uuid_1 = __webpack_require__(1868);
Object.defineProperty(exports, "UUID", ({ enumerable: true, get: function () { return uuid_1.UUID; } }));
var ProgressCallbackTransform_1 = __webpack_require__(9067);
Object.defineProperty(exports, "ProgressCallbackTransform", ({ enumerable: true, get: function () { return ProgressCallbackTransform_1.ProgressCallbackTransform; } }));
var xml_1 = __webpack_require__(9318);
Object.defineProperty(exports, "parseXml", ({ enumerable: true, get: function () { return xml_1.parseXml; } }));
Object.defineProperty(exports, "XElement", ({ enumerable: true, get: function () { return xml_1.XElement; } }));
// nsis
exports.CURRENT_APP_INSTALLER_FILE_NAME = "installer.exe";
// nsis-web
exports.CURRENT_APP_PACKAGE_FILE_NAME = "package.7z";
function asArray(v) {
    if (v == null) {
        return [];
    }
    else if (Array.isArray(v)) {
        return v;
    }
    else {
        return [v];
    }
}
exports.asArray = asArray;
function newError(message, code) {
    const error = new Error(message);
    error.code = code;
    return error;
}
exports.newError = newError;
//# sourceMappingURL=index.js.map

/***/ }),

/***/ 2128:
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.getS3LikeProviderBaseUrl = exports.githubUrl = void 0;
/** @private */
function githubUrl(options, defaultHost = "github.com") {
    return `${options.protocol || "https"}://${options.host || defaultHost}`;
}
exports.githubUrl = githubUrl;
function getS3LikeProviderBaseUrl(configuration) {
    const provider = configuration.provider;
    if (provider === "s3") {
        return s3Url(configuration);
    }
    if (provider === "spaces") {
        return spacesUrl(configuration);
    }
    throw new Error(`Not supported provider: ${provider}`);
}
exports.getS3LikeProviderBaseUrl = getS3LikeProviderBaseUrl;
function s3Url(options) {
    let url;
    if (options.accelerate == true) {
        url = `https://${options.bucket}.s3-accelerate.amazonaws.com`;
    }
    else if (options.endpoint != null) {
        url = `${options.endpoint}/${options.bucket}`;
    }
    else if (options.bucket.includes(".")) {
        if (options.region == null) {
            throw new Error(`Bucket name "${options.bucket}" includes a dot, but S3 region is missing`);
        }
        // special case, see http://docs.aws.amazon.com/AmazonS3/latest/dev/UsingBucket.html#access-bucket-intro
        if (options.region === "us-east-1") {
            url = `https://s3.amazonaws.com/${options.bucket}`;
        }
        else {
            url = `https://s3-${options.region}.amazonaws.com/${options.bucket}`;
        }
    }
    else if (options.region === "cn-north-1") {
        url = `https://${options.bucket}.s3.${options.region}.amazonaws.com.cn`;
    }
    else {
        url = `https://${options.bucket}.s3.amazonaws.com`;
    }
    return appendPath(url, options.path);
}
function appendPath(url, p) {
    if (p != null && p.length > 0) {
        if (!p.startsWith("/")) {
            url += "/";
        }
        url += p;
    }
    return url;
}
function spacesUrl(options) {
    if (options.name == null) {
        throw new Error(`name is missing`);
    }
    if (options.region == null) {
        throw new Error(`region is missing`);
    }
    return appendPath(`https://${options.name}.${options.region}.digitaloceanspaces.com`, options.path);
}
//# sourceMappingURL=publishOptions.js.map

/***/ }),

/***/ 9345:
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.parseDn = void 0;
function parseDn(seq) {
    let quoted = false;
    let key = null;
    let token = "";
    let nextNonSpace = 0;
    seq = seq.trim();
    const result = new Map();
    for (let i = 0; i <= seq.length; i++) {
        if (i === seq.length) {
            if (key !== null) {
                result.set(key, token);
            }
            break;
        }
        const ch = seq[i];
        if (quoted) {
            if (ch === '"') {
                quoted = false;
                continue;
            }
        }
        else {
            if (ch === '"') {
                quoted = true;
                continue;
            }
            if (ch === "\\") {
                i++;
                const ord = parseInt(seq.slice(i, i + 2), 16);
                if (Number.isNaN(ord)) {
                    token += seq[i];
                }
                else {
                    i++;
                    token += String.fromCharCode(ord);
                }
                continue;
            }
            if (key === null && ch === "=") {
                key = token;
                token = "";
                continue;
            }
            if (ch === "," || ch === ";" || ch === "+") {
                if (key !== null) {
                    result.set(key, token);
                }
                key = null;
                token = "";
                continue;
            }
        }
        if (ch === " " && !quoted) {
            if (token.length === 0) {
                continue;
            }
            if (i > nextNonSpace) {
                let j = i;
                while (seq[j] === " ") {
                    j++;
                }
                nextNonSpace = j;
            }
            if (nextNonSpace >= seq.length ||
                seq[nextNonSpace] === "," ||
                seq[nextNonSpace] === ";" ||
                (key === null && seq[nextNonSpace] === "=") ||
                (key !== null && seq[nextNonSpace] === "+")) {
                i = nextNonSpace - 1;
                continue;
            }
        }
        token += ch;
    }
    return result;
}
exports.parseDn = parseDn;
//# sourceMappingURL=rfc2253Parser.js.map

/***/ }),

/***/ 1868:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.nil = exports.UUID = void 0;
const crypto_1 = __webpack_require__(6982);
const index_1 = __webpack_require__(6551);
const invalidName = "options.name must be either a string or a Buffer";
// Node ID according to rfc4122#section-4.5
const randomHost = (0, crypto_1.randomBytes)(16);
randomHost[0] = randomHost[0] | 0x01;
// lookup table hex to byte
const hex2byte = {};
// lookup table byte to hex
const byte2hex = [];
// populate lookup tables
for (let i = 0; i < 256; i++) {
    const hex = (i + 0x100).toString(16).substr(1);
    hex2byte[hex] = i;
    byte2hex[i] = hex;
}
// UUID class
class UUID {
    constructor(uuid) {
        this.ascii = null;
        this.binary = null;
        const check = UUID.check(uuid);
        if (!check) {
            throw new Error("not a UUID");
        }
        this.version = check.version;
        if (check.format === "ascii") {
            this.ascii = uuid;
        }
        else {
            this.binary = uuid;
        }
    }
    static v5(name, namespace) {
        return uuidNamed(name, "sha1", 0x50, namespace);
    }
    toString() {
        if (this.ascii == null) {
            this.ascii = stringify(this.binary);
        }
        return this.ascii;
    }
    inspect() {
        return `UUID v${this.version} ${this.toString()}`;
    }
    static check(uuid, offset = 0) {
        if (typeof uuid === "string") {
            uuid = uuid.toLowerCase();
            if (!/^[a-f0-9]{8}(-[a-f0-9]{4}){3}-([a-f0-9]{12})$/.test(uuid)) {
                return false;
            }
            if (uuid === "00000000-0000-0000-0000-000000000000") {
                return { version: undefined, variant: "nil", format: "ascii" };
            }
            return {
                version: (hex2byte[uuid[14] + uuid[15]] & 0xf0) >> 4,
                variant: getVariant((hex2byte[uuid[19] + uuid[20]] & 0xe0) >> 5),
                format: "ascii",
            };
        }
        if (Buffer.isBuffer(uuid)) {
            if (uuid.length < offset + 16) {
                return false;
            }
            let i = 0;
            for (; i < 16; i++) {
                if (uuid[offset + i] !== 0) {
                    break;
                }
            }
            if (i === 16) {
                return { version: undefined, variant: "nil", format: "binary" };
            }
            return {
                version: (uuid[offset + 6] & 0xf0) >> 4,
                variant: getVariant((uuid[offset + 8] & 0xe0) >> 5),
                format: "binary",
            };
        }
        throw (0, index_1.newError)("Unknown type of uuid", "ERR_UNKNOWN_UUID_TYPE");
    }
    // read stringified uuid into a Buffer
    static parse(input) {
        const buffer = Buffer.allocUnsafe(16);
        let j = 0;
        for (let i = 0; i < 16; i++) {
            buffer[i] = hex2byte[input[j++] + input[j++]];
            if (i === 3 || i === 5 || i === 7 || i === 9) {
                j += 1;
            }
        }
        return buffer;
    }
}
exports.UUID = UUID;
// from rfc4122#appendix-C
UUID.OID = UUID.parse("6ba7b812-9dad-11d1-80b4-00c04fd430c8");
// according to rfc4122#section-4.1.1
function getVariant(bits) {
    switch (bits) {
        case 0:
        case 1:
        case 3:
            return "ncs";
        case 4:
        case 5:
            return "rfc4122";
        case 6:
            return "microsoft";
        default:
            return "future";
    }
}
var UuidEncoding;
(function (UuidEncoding) {
    UuidEncoding[UuidEncoding["ASCII"] = 0] = "ASCII";
    UuidEncoding[UuidEncoding["BINARY"] = 1] = "BINARY";
    UuidEncoding[UuidEncoding["OBJECT"] = 2] = "OBJECT";
})(UuidEncoding || (UuidEncoding = {}));
// v3 + v5
function uuidNamed(name, hashMethod, version, namespace, encoding = UuidEncoding.ASCII) {
    const hash = (0, crypto_1.createHash)(hashMethod);
    const nameIsNotAString = typeof name !== "string";
    if (nameIsNotAString && !Buffer.isBuffer(name)) {
        throw (0, index_1.newError)(invalidName, "ERR_INVALID_UUID_NAME");
    }
    hash.update(namespace);
    hash.update(name);
    const buffer = hash.digest();
    let result;
    switch (encoding) {
        case UuidEncoding.BINARY:
            buffer[6] = (buffer[6] & 0x0f) | version;
            buffer[8] = (buffer[8] & 0x3f) | 0x80;
            result = buffer;
            break;
        case UuidEncoding.OBJECT:
            buffer[6] = (buffer[6] & 0x0f) | version;
            buffer[8] = (buffer[8] & 0x3f) | 0x80;
            result = new UUID(buffer);
            break;
        default:
            result =
                byte2hex[buffer[0]] +
                    byte2hex[buffer[1]] +
                    byte2hex[buffer[2]] +
                    byte2hex[buffer[3]] +
                    "-" +
                    byte2hex[buffer[4]] +
                    byte2hex[buffer[5]] +
                    "-" +
                    byte2hex[(buffer[6] & 0x0f) | version] +
                    byte2hex[buffer[7]] +
                    "-" +
                    byte2hex[(buffer[8] & 0x3f) | 0x80] +
                    byte2hex[buffer[9]] +
                    "-" +
                    byte2hex[buffer[10]] +
                    byte2hex[buffer[11]] +
                    byte2hex[buffer[12]] +
                    byte2hex[buffer[13]] +
                    byte2hex[buffer[14]] +
                    byte2hex[buffer[15]];
            break;
    }
    return result;
}
function stringify(buffer) {
    return (byte2hex[buffer[0]] +
        byte2hex[buffer[1]] +
        byte2hex[buffer[2]] +
        byte2hex[buffer[3]] +
        "-" +
        byte2hex[buffer[4]] +
        byte2hex[buffer[5]] +
        "-" +
        byte2hex[buffer[6]] +
        byte2hex[buffer[7]] +
        "-" +
        byte2hex[buffer[8]] +
        byte2hex[buffer[9]] +
        "-" +
        byte2hex[buffer[10]] +
        byte2hex[buffer[11]] +
        byte2hex[buffer[12]] +
        byte2hex[buffer[13]] +
        byte2hex[buffer[14]] +
        byte2hex[buffer[15]]);
}
// according to rfc4122#section-4.1.7
exports.nil = new UUID("00000000-0000-0000-0000-000000000000");
// UUID.v4 = uuidRandom
// UUID.v4fast = uuidRandomFast
// UUID.v3 = function(options, callback) {
//     return uuidNamed("md5", 0x30, options, callback)
// }
//# sourceMappingURL=uuid.js.map

/***/ }),

/***/ 9318:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.parseXml = exports.XElement = void 0;
const sax = __webpack_require__(4043);
const index_1 = __webpack_require__(6551);
class XElement {
    constructor(name) {
        this.name = name;
        this.value = "";
        this.attributes = null;
        this.isCData = false;
        this.elements = null;
        if (!name) {
            throw (0, index_1.newError)("Element name cannot be empty", "ERR_XML_ELEMENT_NAME_EMPTY");
        }
        if (!isValidName(name)) {
            throw (0, index_1.newError)(`Invalid element name: ${name}`, "ERR_XML_ELEMENT_INVALID_NAME");
        }
    }
    attribute(name) {
        const result = this.attributes === null ? null : this.attributes[name];
        if (result == null) {
            throw (0, index_1.newError)(`No attribute "${name}"`, "ERR_XML_MISSED_ATTRIBUTE");
        }
        return result;
    }
    removeAttribute(name) {
        if (this.attributes !== null) {
            delete this.attributes[name];
        }
    }
    element(name, ignoreCase = false, errorIfMissed = null) {
        const result = this.elementOrNull(name, ignoreCase);
        if (result === null) {
            throw (0, index_1.newError)(errorIfMissed || `No element "${name}"`, "ERR_XML_MISSED_ELEMENT");
        }
        return result;
    }
    elementOrNull(name, ignoreCase = false) {
        if (this.elements === null) {
            return null;
        }
        for (const element of this.elements) {
            if (isNameEquals(element, name, ignoreCase)) {
                return element;
            }
        }
        return null;
    }
    getElements(name, ignoreCase = false) {
        if (this.elements === null) {
            return [];
        }
        return this.elements.filter(it => isNameEquals(it, name, ignoreCase));
    }
    elementValueOrEmpty(name, ignoreCase = false) {
        const element = this.elementOrNull(name, ignoreCase);
        return element === null ? "" : element.value;
    }
}
exports.XElement = XElement;
const NAME_REG_EXP = new RegExp(/^[A-Za-z_][:A-Za-z0-9_-]*$/i);
function isValidName(name) {
    return NAME_REG_EXP.test(name);
}
function isNameEquals(element, name, ignoreCase) {
    const elementName = element.name;
    return elementName === name || (ignoreCase === true && elementName.length === name.length && elementName.toLowerCase() === name.toLowerCase());
}
function parseXml(data) {
    let rootElement = null;
    const parser = sax.parser(true, {});
    const elements = [];
    parser.onopentag = saxElement => {
        const element = new XElement(saxElement.name);
        element.attributes = saxElement.attributes;
        if (rootElement === null) {
            rootElement = element;
        }
        else {
            const parent = elements[elements.length - 1];
            if (parent.elements == null) {
                parent.elements = [];
            }
            parent.elements.push(element);
        }
        elements.push(element);
    };
    parser.onclosetag = () => {
        elements.pop();
    };
    parser.ontext = text => {
        if (elements.length > 0) {
            elements[elements.length - 1].value = text;
        }
    };
    parser.oncdata = cdata => {
        const element = elements[elements.length - 1];
        element.value = cdata;
        element.isCData = true;
    };
    parser.onerror = err => {
        throw err;
    };
    parser.write(data);
    return rootElement;
}
exports.parseXml = parseXml;
//# sourceMappingURL=xml.js.map

/***/ }),

/***/ 2958:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(3735)
const path = __webpack_require__(6928)
const mkdirsSync = (__webpack_require__(8860).mkdirsSync)
const utimesMillisSync = (__webpack_require__(9633).utimesMillisSync)
const stat = __webpack_require__(396)

function copySync (src, dest, opts) {
  if (typeof opts === 'function') {
    opts = { filter: opts }
  }

  opts = opts || {}
  opts.clobber = 'clobber' in opts ? !!opts.clobber : true // default to true for now
  opts.overwrite = 'overwrite' in opts ? !!opts.overwrite : opts.clobber // overwrite falls back to clobber

  // Warn about using preserveTimestamps on 32-bit node
  if (opts.preserveTimestamps && process.arch === 'ia32') {
    process.emitWarning(
      'Using the preserveTimestamps option in 32-bit node is not recommended;\n\n' +
      '\tsee https://github.com/jprichardson/node-fs-extra/issues/269',
      'Warning', 'fs-extra-WARN0002'
    )
  }

  const { srcStat, destStat } = stat.checkPathsSync(src, dest, 'copy', opts)
  stat.checkParentPathsSync(src, srcStat, dest, 'copy')
  return handleFilterAndCopy(destStat, src, dest, opts)
}

function handleFilterAndCopy (destStat, src, dest, opts) {
  if (opts.filter && !opts.filter(src, dest)) return
  const destParent = path.dirname(dest)
  if (!fs.existsSync(destParent)) mkdirsSync(destParent)
  return getStats(destStat, src, dest, opts)
}

function startCopy (destStat, src, dest, opts) {
  if (opts.filter && !opts.filter(src, dest)) return
  return getStats(destStat, src, dest, opts)
}

function getStats (destStat, src, dest, opts) {
  const statSync = opts.dereference ? fs.statSync : fs.lstatSync
  const srcStat = statSync(src)

  if (srcStat.isDirectory()) return onDir(srcStat, destStat, src, dest, opts)
  else if (srcStat.isFile() ||
           srcStat.isCharacterDevice() ||
           srcStat.isBlockDevice()) return onFile(srcStat, destStat, src, dest, opts)
  else if (srcStat.isSymbolicLink()) return onLink(destStat, src, dest, opts)
  else if (srcStat.isSocket()) throw new Error(`Cannot copy a socket file: ${src}`)
  else if (srcStat.isFIFO()) throw new Error(`Cannot copy a FIFO pipe: ${src}`)
  throw new Error(`Unknown file: ${src}`)
}

function onFile (srcStat, destStat, src, dest, opts) {
  if (!destStat) return copyFile(srcStat, src, dest, opts)
  return mayCopyFile(srcStat, src, dest, opts)
}

function mayCopyFile (srcStat, src, dest, opts) {
  if (opts.overwrite) {
    fs.unlinkSync(dest)
    return copyFile(srcStat, src, dest, opts)
  } else if (opts.errorOnExist) {
    throw new Error(`'${dest}' already exists`)
  }
}

function copyFile (srcStat, src, dest, opts) {
  fs.copyFileSync(src, dest)
  if (opts.preserveTimestamps) handleTimestamps(srcStat.mode, src, dest)
  return setDestMode(dest, srcStat.mode)
}

function handleTimestamps (srcMode, src, dest) {
  // Make sure the file is writable before setting the timestamp
  // otherwise open fails with EPERM when invoked with 'r+'
  // (through utimes call)
  if (fileIsNotWritable(srcMode)) makeFileWritable(dest, srcMode)
  return setDestTimestamps(src, dest)
}

function fileIsNotWritable (srcMode) {
  return (srcMode & 0o200) === 0
}

function makeFileWritable (dest, srcMode) {
  return setDestMode(dest, srcMode | 0o200)
}

function setDestMode (dest, srcMode) {
  return fs.chmodSync(dest, srcMode)
}

function setDestTimestamps (src, dest) {
  // The initial srcStat.atime cannot be trusted
  // because it is modified by the read(2) system call
  // (See https://nodejs.org/api/fs.html#fs_stat_time_values)
  const updatedSrcStat = fs.statSync(src)
  return utimesMillisSync(dest, updatedSrcStat.atime, updatedSrcStat.mtime)
}

function onDir (srcStat, destStat, src, dest, opts) {
  if (!destStat) return mkDirAndCopy(srcStat.mode, src, dest, opts)
  return copyDir(src, dest, opts)
}

function mkDirAndCopy (srcMode, src, dest, opts) {
  fs.mkdirSync(dest)
  copyDir(src, dest, opts)
  return setDestMode(dest, srcMode)
}

function copyDir (src, dest, opts) {
  fs.readdirSync(src).forEach(item => copyDirItem(item, src, dest, opts))
}

function copyDirItem (item, src, dest, opts) {
  const srcItem = path.join(src, item)
  const destItem = path.join(dest, item)
  const { destStat } = stat.checkPathsSync(srcItem, destItem, 'copy', opts)
  return startCopy(destStat, srcItem, destItem, opts)
}

function onLink (destStat, src, dest, opts) {
  let resolvedSrc = fs.readlinkSync(src)
  if (opts.dereference) {
    resolvedSrc = path.resolve(process.cwd(), resolvedSrc)
  }

  if (!destStat) {
    return fs.symlinkSync(resolvedSrc, dest)
  } else {
    let resolvedDest
    try {
      resolvedDest = fs.readlinkSync(dest)
    } catch (err) {
      // dest exists and is a regular file or directory,
      // Windows may throw UNKNOWN error. If dest already exists,
      // fs throws error anyway, so no need to guard against it here.
      if (err.code === 'EINVAL' || err.code === 'UNKNOWN') return fs.symlinkSync(resolvedSrc, dest)
      throw err
    }
    if (opts.dereference) {
      resolvedDest = path.resolve(process.cwd(), resolvedDest)
    }
    if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
      throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`)
    }

    // prevent copy if src is a subdir of dest since unlinking
    // dest in this case would result in removing src contents
    // and therefore a broken symlink would be created.
    if (fs.statSync(dest).isDirectory() && stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
      throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`)
    }
    return copyLink(resolvedSrc, dest)
  }
}

function copyLink (resolvedSrc, dest) {
  fs.unlinkSync(dest)
  return fs.symlinkSync(resolvedSrc, dest)
}

module.exports = copySync


/***/ }),

/***/ 2492:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(3735)
const path = __webpack_require__(6928)
const mkdirs = (__webpack_require__(8860).mkdirs)
const pathExists = (__webpack_require__(6566).pathExists)
const utimesMillis = (__webpack_require__(9633).utimesMillis)
const stat = __webpack_require__(396)

function copy (src, dest, opts, cb) {
  if (typeof opts === 'function' && !cb) {
    cb = opts
    opts = {}
  } else if (typeof opts === 'function') {
    opts = { filter: opts }
  }

  cb = cb || function () {}
  opts = opts || {}

  opts.clobber = 'clobber' in opts ? !!opts.clobber : true // default to true for now
  opts.overwrite = 'overwrite' in opts ? !!opts.overwrite : opts.clobber // overwrite falls back to clobber

  // Warn about using preserveTimestamps on 32-bit node
  if (opts.preserveTimestamps && process.arch === 'ia32') {
    process.emitWarning(
      'Using the preserveTimestamps option in 32-bit node is not recommended;\n\n' +
      '\tsee https://github.com/jprichardson/node-fs-extra/issues/269',
      'Warning', 'fs-extra-WARN0001'
    )
  }

  stat.checkPaths(src, dest, 'copy', opts, (err, stats) => {
    if (err) return cb(err)
    const { srcStat, destStat } = stats
    stat.checkParentPaths(src, srcStat, dest, 'copy', err => {
      if (err) return cb(err)
      if (opts.filter) return handleFilter(checkParentDir, destStat, src, dest, opts, cb)
      return checkParentDir(destStat, src, dest, opts, cb)
    })
  })
}

function checkParentDir (destStat, src, dest, opts, cb) {
  const destParent = path.dirname(dest)
  pathExists(destParent, (err, dirExists) => {
    if (err) return cb(err)
    if (dirExists) return getStats(destStat, src, dest, opts, cb)
    mkdirs(destParent, err => {
      if (err) return cb(err)
      return getStats(destStat, src, dest, opts, cb)
    })
  })
}

function handleFilter (onInclude, destStat, src, dest, opts, cb) {
  Promise.resolve(opts.filter(src, dest)).then(include => {
    if (include) return onInclude(destStat, src, dest, opts, cb)
    return cb()
  }, error => cb(error))
}

function startCopy (destStat, src, dest, opts, cb) {
  if (opts.filter) return handleFilter(getStats, destStat, src, dest, opts, cb)
  return getStats(destStat, src, dest, opts, cb)
}

function getStats (destStat, src, dest, opts, cb) {
  const stat = opts.dereference ? fs.stat : fs.lstat
  stat(src, (err, srcStat) => {
    if (err) return cb(err)

    if (srcStat.isDirectory()) return onDir(srcStat, destStat, src, dest, opts, cb)
    else if (srcStat.isFile() ||
             srcStat.isCharacterDevice() ||
             srcStat.isBlockDevice()) return onFile(srcStat, destStat, src, dest, opts, cb)
    else if (srcStat.isSymbolicLink()) return onLink(destStat, src, dest, opts, cb)
    else if (srcStat.isSocket()) return cb(new Error(`Cannot copy a socket file: ${src}`))
    else if (srcStat.isFIFO()) return cb(new Error(`Cannot copy a FIFO pipe: ${src}`))
    return cb(new Error(`Unknown file: ${src}`))
  })
}

function onFile (srcStat, destStat, src, dest, opts, cb) {
  if (!destStat) return copyFile(srcStat, src, dest, opts, cb)
  return mayCopyFile(srcStat, src, dest, opts, cb)
}

function mayCopyFile (srcStat, src, dest, opts, cb) {
  if (opts.overwrite) {
    fs.unlink(dest, err => {
      if (err) return cb(err)
      return copyFile(srcStat, src, dest, opts, cb)
    })
  } else if (opts.errorOnExist) {
    return cb(new Error(`'${dest}' already exists`))
  } else return cb()
}

function copyFile (srcStat, src, dest, opts, cb) {
  fs.copyFile(src, dest, err => {
    if (err) return cb(err)
    if (opts.preserveTimestamps) return handleTimestampsAndMode(srcStat.mode, src, dest, cb)
    return setDestMode(dest, srcStat.mode, cb)
  })
}

function handleTimestampsAndMode (srcMode, src, dest, cb) {
  // Make sure the file is writable before setting the timestamp
  // otherwise open fails with EPERM when invoked with 'r+'
  // (through utimes call)
  if (fileIsNotWritable(srcMode)) {
    return makeFileWritable(dest, srcMode, err => {
      if (err) return cb(err)
      return setDestTimestampsAndMode(srcMode, src, dest, cb)
    })
  }
  return setDestTimestampsAndMode(srcMode, src, dest, cb)
}

function fileIsNotWritable (srcMode) {
  return (srcMode & 0o200) === 0
}

function makeFileWritable (dest, srcMode, cb) {
  return setDestMode(dest, srcMode | 0o200, cb)
}

function setDestTimestampsAndMode (srcMode, src, dest, cb) {
  setDestTimestamps(src, dest, err => {
    if (err) return cb(err)
    return setDestMode(dest, srcMode, cb)
  })
}

function setDestMode (dest, srcMode, cb) {
  return fs.chmod(dest, srcMode, cb)
}

function setDestTimestamps (src, dest, cb) {
  // The initial srcStat.atime cannot be trusted
  // because it is modified by the read(2) system call
  // (See https://nodejs.org/api/fs.html#fs_stat_time_values)
  fs.stat(src, (err, updatedSrcStat) => {
    if (err) return cb(err)
    return utimesMillis(dest, updatedSrcStat.atime, updatedSrcStat.mtime, cb)
  })
}

function onDir (srcStat, destStat, src, dest, opts, cb) {
  if (!destStat) return mkDirAndCopy(srcStat.mode, src, dest, opts, cb)
  return copyDir(src, dest, opts, cb)
}

function mkDirAndCopy (srcMode, src, dest, opts, cb) {
  fs.mkdir(dest, err => {
    if (err) return cb(err)
    copyDir(src, dest, opts, err => {
      if (err) return cb(err)
      return setDestMode(dest, srcMode, cb)
    })
  })
}

function copyDir (src, dest, opts, cb) {
  fs.readdir(src, (err, items) => {
    if (err) return cb(err)
    return copyDirItems(items, src, dest, opts, cb)
  })
}

function copyDirItems (items, src, dest, opts, cb) {
  const item = items.pop()
  if (!item) return cb()
  return copyDirItem(items, item, src, dest, opts, cb)
}

function copyDirItem (items, item, src, dest, opts, cb) {
  const srcItem = path.join(src, item)
  const destItem = path.join(dest, item)
  stat.checkPaths(srcItem, destItem, 'copy', opts, (err, stats) => {
    if (err) return cb(err)
    const { destStat } = stats
    startCopy(destStat, srcItem, destItem, opts, err => {
      if (err) return cb(err)
      return copyDirItems(items, src, dest, opts, cb)
    })
  })
}

function onLink (destStat, src, dest, opts, cb) {
  fs.readlink(src, (err, resolvedSrc) => {
    if (err) return cb(err)
    if (opts.dereference) {
      resolvedSrc = path.resolve(process.cwd(), resolvedSrc)
    }

    if (!destStat) {
      return fs.symlink(resolvedSrc, dest, cb)
    } else {
      fs.readlink(dest, (err, resolvedDest) => {
        if (err) {
          // dest exists and is a regular file or directory,
          // Windows may throw UNKNOWN error. If dest already exists,
          // fs throws error anyway, so no need to guard against it here.
          if (err.code === 'EINVAL' || err.code === 'UNKNOWN') return fs.symlink(resolvedSrc, dest, cb)
          return cb(err)
        }
        if (opts.dereference) {
          resolvedDest = path.resolve(process.cwd(), resolvedDest)
        }
        if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
          return cb(new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`))
        }

        // do not copy if src is a subdir of dest since unlinking
        // dest in this case would result in removing src contents
        // and therefore a broken symlink would be created.
        if (destStat.isDirectory() && stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
          return cb(new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`))
        }
        return copyLink(resolvedSrc, dest, cb)
      })
    }
  })
}

function copyLink (resolvedSrc, dest, cb) {
  fs.unlink(dest, err => {
    if (err) return cb(err)
    return fs.symlink(resolvedSrc, dest, cb)
  })
}

module.exports = copy


/***/ }),

/***/ 2057:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const u = (__webpack_require__(3950).fromCallback)
module.exports = {
  copy: u(__webpack_require__(2492)),
  copySync: __webpack_require__(2958)
}


/***/ }),

/***/ 7045:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const u = (__webpack_require__(3950).fromPromise)
const fs = __webpack_require__(4603)
const path = __webpack_require__(6928)
const mkdir = __webpack_require__(8860)
const remove = __webpack_require__(5532)

const emptyDir = u(async function emptyDir (dir) {
  let items
  try {
    items = await fs.readdir(dir)
  } catch {
    return mkdir.mkdirs(dir)
  }

  return Promise.all(items.map(item => remove.remove(path.join(dir, item))))
})

function emptyDirSync (dir) {
  let items
  try {
    items = fs.readdirSync(dir)
  } catch {
    return mkdir.mkdirsSync(dir)
  }

  items.forEach(item => {
    item = path.join(dir, item)
    remove.removeSync(item)
  })
}

module.exports = {
  emptyDirSync,
  emptydirSync: emptyDirSync,
  emptyDir,
  emptydir: emptyDir
}


/***/ }),

/***/ 6338:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const u = (__webpack_require__(3950).fromCallback)
const path = __webpack_require__(6928)
const fs = __webpack_require__(3735)
const mkdir = __webpack_require__(8860)

function createFile (file, callback) {
  function makeFile () {
    fs.writeFile(file, '', err => {
      if (err) return callback(err)
      callback()
    })
  }

  fs.stat(file, (err, stats) => { // eslint-disable-line handle-callback-err
    if (!err && stats.isFile()) return callback()
    const dir = path.dirname(file)
    fs.stat(dir, (err, stats) => {
      if (err) {
        // if the directory doesn't exist, make it
        if (err.code === 'ENOENT') {
          return mkdir.mkdirs(dir, err => {
            if (err) return callback(err)
            makeFile()
          })
        }
        return callback(err)
      }

      if (stats.isDirectory()) makeFile()
      else {
        // parent is not a directory
        // This is just to cause an internal ENOTDIR error to be thrown
        fs.readdir(dir, err => {
          if (err) return callback(err)
        })
      }
    })
  })
}

function createFileSync (file) {
  let stats
  try {
    stats = fs.statSync(file)
  } catch {}
  if (stats && stats.isFile()) return

  const dir = path.dirname(file)
  try {
    if (!fs.statSync(dir).isDirectory()) {
      // parent is not a directory
      // This is just to cause an internal ENOTDIR error to be thrown
      fs.readdirSync(dir)
    }
  } catch (err) {
    // If the stat call above failed because the directory doesn't exist, create it
    if (err && err.code === 'ENOENT') mkdir.mkdirsSync(dir)
    else throw err
  }

  fs.writeFileSync(file, '')
}

module.exports = {
  createFile: u(createFile),
  createFileSync
}


/***/ }),

/***/ 4694:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { createFile, createFileSync } = __webpack_require__(6338)
const { createLink, createLinkSync } = __webpack_require__(4776)
const { createSymlink, createSymlinkSync } = __webpack_require__(4945)

module.exports = {
  // file
  createFile,
  createFileSync,
  ensureFile: createFile,
  ensureFileSync: createFileSync,
  // link
  createLink,
  createLinkSync,
  ensureLink: createLink,
  ensureLinkSync: createLinkSync,
  // symlink
  createSymlink,
  createSymlinkSync,
  ensureSymlink: createSymlink,
  ensureSymlinkSync: createSymlinkSync
}


/***/ }),

/***/ 4776:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const u = (__webpack_require__(3950).fromCallback)
const path = __webpack_require__(6928)
const fs = __webpack_require__(3735)
const mkdir = __webpack_require__(8860)
const pathExists = (__webpack_require__(6566).pathExists)
const { areIdentical } = __webpack_require__(396)

function createLink (srcpath, dstpath, callback) {
  function makeLink (srcpath, dstpath) {
    fs.link(srcpath, dstpath, err => {
      if (err) return callback(err)
      callback(null)
    })
  }

  fs.lstat(dstpath, (_, dstStat) => {
    fs.lstat(srcpath, (err, srcStat) => {
      if (err) {
        err.message = err.message.replace('lstat', 'ensureLink')
        return callback(err)
      }
      if (dstStat && areIdentical(srcStat, dstStat)) return callback(null)

      const dir = path.dirname(dstpath)
      pathExists(dir, (err, dirExists) => {
        if (err) return callback(err)
        if (dirExists) return makeLink(srcpath, dstpath)
        mkdir.mkdirs(dir, err => {
          if (err) return callback(err)
          makeLink(srcpath, dstpath)
        })
      })
    })
  })
}

function createLinkSync (srcpath, dstpath) {
  let dstStat
  try {
    dstStat = fs.lstatSync(dstpath)
  } catch {}

  try {
    const srcStat = fs.lstatSync(srcpath)
    if (dstStat && areIdentical(srcStat, dstStat)) return
  } catch (err) {
    err.message = err.message.replace('lstat', 'ensureLink')
    throw err
  }

  const dir = path.dirname(dstpath)
  const dirExists = fs.existsSync(dir)
  if (dirExists) return fs.linkSync(srcpath, dstpath)
  mkdir.mkdirsSync(dir)

  return fs.linkSync(srcpath, dstpath)
}

module.exports = {
  createLink: u(createLink),
  createLinkSync
}


/***/ }),

/***/ 9392:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const path = __webpack_require__(6928)
const fs = __webpack_require__(3735)
const pathExists = (__webpack_require__(6566).pathExists)

/**
 * Function that returns two types of paths, one relative to symlink, and one
 * relative to the current working directory. Checks if path is absolute or
 * relative. If the path is relative, this function checks if the path is
 * relative to symlink or relative to current working directory. This is an
 * initiative to find a smarter `srcpath` to supply when building symlinks.
 * This allows you to determine which path to use out of one of three possible
 * types of source paths. The first is an absolute path. This is detected by
 * `path.isAbsolute()`. When an absolute path is provided, it is checked to
 * see if it exists. If it does it's used, if not an error is returned
 * (callback)/ thrown (sync). The other two options for `srcpath` are a
 * relative url. By default Node's `fs.symlink` works by creating a symlink
 * using `dstpath` and expects the `srcpath` to be relative to the newly
 * created symlink. If you provide a `srcpath` that does not exist on the file
 * system it results in a broken symlink. To minimize this, the function
 * checks to see if the 'relative to symlink' source file exists, and if it
 * does it will use it. If it does not, it checks if there's a file that
 * exists that is relative to the current working directory, if does its used.
 * This preserves the expectations of the original fs.symlink spec and adds
 * the ability to pass in `relative to current working direcotry` paths.
 */

function symlinkPaths (srcpath, dstpath, callback) {
  if (path.isAbsolute(srcpath)) {
    return fs.lstat(srcpath, (err) => {
      if (err) {
        err.message = err.message.replace('lstat', 'ensureSymlink')
        return callback(err)
      }
      return callback(null, {
        toCwd: srcpath,
        toDst: srcpath
      })
    })
  } else {
    const dstdir = path.dirname(dstpath)
    const relativeToDst = path.join(dstdir, srcpath)
    return pathExists(relativeToDst, (err, exists) => {
      if (err) return callback(err)
      if (exists) {
        return callback(null, {
          toCwd: relativeToDst,
          toDst: srcpath
        })
      } else {
        return fs.lstat(srcpath, (err) => {
          if (err) {
            err.message = err.message.replace('lstat', 'ensureSymlink')
            return callback(err)
          }
          return callback(null, {
            toCwd: srcpath,
            toDst: path.relative(dstdir, srcpath)
          })
        })
      }
    })
  }
}

function symlinkPathsSync (srcpath, dstpath) {
  let exists
  if (path.isAbsolute(srcpath)) {
    exists = fs.existsSync(srcpath)
    if (!exists) throw new Error('absolute srcpath does not exist')
    return {
      toCwd: srcpath,
      toDst: srcpath
    }
  } else {
    const dstdir = path.dirname(dstpath)
    const relativeToDst = path.join(dstdir, srcpath)
    exists = fs.existsSync(relativeToDst)
    if (exists) {
      return {
        toCwd: relativeToDst,
        toDst: srcpath
      }
    } else {
      exists = fs.existsSync(srcpath)
      if (!exists) throw new Error('relative srcpath does not exist')
      return {
        toCwd: srcpath,
        toDst: path.relative(dstdir, srcpath)
      }
    }
  }
}

module.exports = {
  symlinkPaths,
  symlinkPathsSync
}


/***/ }),

/***/ 6162:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(3735)

function symlinkType (srcpath, type, callback) {
  callback = (typeof type === 'function') ? type : callback
  type = (typeof type === 'function') ? false : type
  if (type) return callback(null, type)
  fs.lstat(srcpath, (err, stats) => {
    if (err) return callback(null, 'file')
    type = (stats && stats.isDirectory()) ? 'dir' : 'file'
    callback(null, type)
  })
}

function symlinkTypeSync (srcpath, type) {
  let stats

  if (type) return type
  try {
    stats = fs.lstatSync(srcpath)
  } catch {
    return 'file'
  }
  return (stats && stats.isDirectory()) ? 'dir' : 'file'
}

module.exports = {
  symlinkType,
  symlinkTypeSync
}


/***/ }),

/***/ 4945:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const u = (__webpack_require__(3950).fromCallback)
const path = __webpack_require__(6928)
const fs = __webpack_require__(4603)
const _mkdirs = __webpack_require__(8860)
const mkdirs = _mkdirs.mkdirs
const mkdirsSync = _mkdirs.mkdirsSync

const _symlinkPaths = __webpack_require__(9392)
const symlinkPaths = _symlinkPaths.symlinkPaths
const symlinkPathsSync = _symlinkPaths.symlinkPathsSync

const _symlinkType = __webpack_require__(6162)
const symlinkType = _symlinkType.symlinkType
const symlinkTypeSync = _symlinkType.symlinkTypeSync

const pathExists = (__webpack_require__(6566).pathExists)

const { areIdentical } = __webpack_require__(396)

function createSymlink (srcpath, dstpath, type, callback) {
  callback = (typeof type === 'function') ? type : callback
  type = (typeof type === 'function') ? false : type

  fs.lstat(dstpath, (err, stats) => {
    if (!err && stats.isSymbolicLink()) {
      Promise.all([
        fs.stat(srcpath),
        fs.stat(dstpath)
      ]).then(([srcStat, dstStat]) => {
        if (areIdentical(srcStat, dstStat)) return callback(null)
        _createSymlink(srcpath, dstpath, type, callback)
      })
    } else _createSymlink(srcpath, dstpath, type, callback)
  })
}

function _createSymlink (srcpath, dstpath, type, callback) {
  symlinkPaths(srcpath, dstpath, (err, relative) => {
    if (err) return callback(err)
    srcpath = relative.toDst
    symlinkType(relative.toCwd, type, (err, type) => {
      if (err) return callback(err)
      const dir = path.dirname(dstpath)
      pathExists(dir, (err, dirExists) => {
        if (err) return callback(err)
        if (dirExists) return fs.symlink(srcpath, dstpath, type, callback)
        mkdirs(dir, err => {
          if (err) return callback(err)
          fs.symlink(srcpath, dstpath, type, callback)
        })
      })
    })
  })
}

function createSymlinkSync (srcpath, dstpath, type) {
  let stats
  try {
    stats = fs.lstatSync(dstpath)
  } catch {}
  if (stats && stats.isSymbolicLink()) {
    const srcStat = fs.statSync(srcpath)
    const dstStat = fs.statSync(dstpath)
    if (areIdentical(srcStat, dstStat)) return
  }

  const relative = symlinkPathsSync(srcpath, dstpath)
  srcpath = relative.toDst
  type = symlinkTypeSync(relative.toCwd, type)
  const dir = path.dirname(dstpath)
  const exists = fs.existsSync(dir)
  if (exists) return fs.symlinkSync(srcpath, dstpath, type)
  mkdirsSync(dir)
  return fs.symlinkSync(srcpath, dstpath, type)
}

module.exports = {
  createSymlink: u(createSymlink),
  createSymlinkSync
}


/***/ }),

/***/ 4603:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

// This is adapted from https://github.com/normalize/mz
// Copyright (c) 2014-2016 Jonathan Ong me@jongleberry.com and Contributors
const u = (__webpack_require__(3950).fromCallback)
const fs = __webpack_require__(3735)

const api = [
  'access',
  'appendFile',
  'chmod',
  'chown',
  'close',
  'copyFile',
  'fchmod',
  'fchown',
  'fdatasync',
  'fstat',
  'fsync',
  'ftruncate',
  'futimes',
  'lchmod',
  'lchown',
  'link',
  'lstat',
  'mkdir',
  'mkdtemp',
  'open',
  'opendir',
  'readdir',
  'readFile',
  'readlink',
  'realpath',
  'rename',
  'rm',
  'rmdir',
  'stat',
  'symlink',
  'truncate',
  'unlink',
  'utimes',
  'writeFile'
].filter(key => {
  // Some commands are not available on some systems. Ex:
  // fs.opendir was added in Node.js v12.12.0
  // fs.rm was added in Node.js v14.14.0
  // fs.lchown is not available on at least some Linux
  return typeof fs[key] === 'function'
})

// Export cloned fs:
Object.assign(exports, fs)

// Universalify async methods:
api.forEach(method => {
  exports[method] = u(fs[method])
})

// We differ from mz/fs in that we still ship the old, broken, fs.exists()
// since we are a drop-in replacement for the native module
exports.exists = function (filename, callback) {
  if (typeof callback === 'function') {
    return fs.exists(filename, callback)
  }
  return new Promise(resolve => {
    return fs.exists(filename, resolve)
  })
}

// fs.read(), fs.write(), & fs.writev() need special treatment due to multiple callback args

exports.read = function (fd, buffer, offset, length, position, callback) {
  if (typeof callback === 'function') {
    return fs.read(fd, buffer, offset, length, position, callback)
  }
  return new Promise((resolve, reject) => {
    fs.read(fd, buffer, offset, length, position, (err, bytesRead, buffer) => {
      if (err) return reject(err)
      resolve({ bytesRead, buffer })
    })
  })
}

// Function signature can be
// fs.write(fd, buffer[, offset[, length[, position]]], callback)
// OR
// fs.write(fd, string[, position[, encoding]], callback)
// We need to handle both cases, so we use ...args
exports.write = function (fd, buffer, ...args) {
  if (typeof args[args.length - 1] === 'function') {
    return fs.write(fd, buffer, ...args)
  }

  return new Promise((resolve, reject) => {
    fs.write(fd, buffer, ...args, (err, bytesWritten, buffer) => {
      if (err) return reject(err)
      resolve({ bytesWritten, buffer })
    })
  })
}

// fs.writev only available in Node v12.9.0+
if (typeof fs.writev === 'function') {
  // Function signature is
  // s.writev(fd, buffers[, position], callback)
  // We need to handle the optional arg, so we use ...args
  exports.writev = function (fd, buffers, ...args) {
    if (typeof args[args.length - 1] === 'function') {
      return fs.writev(fd, buffers, ...args)
    }

    return new Promise((resolve, reject) => {
      fs.writev(fd, buffers, ...args, (err, bytesWritten, buffers) => {
        if (err) return reject(err)
        resolve({ bytesWritten, buffers })
      })
    })
  }
}

// fs.realpath.native sometimes not available if fs is monkey-patched
if (typeof fs.realpath.native === 'function') {
  exports.realpath.native = u(fs.realpath.native)
} else {
  process.emitWarning(
    'fs.realpath.native is not a function. Is fs being monkey-patched?',
    'Warning', 'fs-extra-WARN0003'
  )
}


/***/ }),

/***/ 8799:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


module.exports = {
  // Export promiseified graceful-fs:
  ...__webpack_require__(4603),
  // Export extra methods:
  ...__webpack_require__(2057),
  ...__webpack_require__(7045),
  ...__webpack_require__(4694),
  ...__webpack_require__(3194),
  ...__webpack_require__(8860),
  ...__webpack_require__(345),
  ...__webpack_require__(7542),
  ...__webpack_require__(6566),
  ...__webpack_require__(5532)
}


/***/ }),

/***/ 3194:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const u = (__webpack_require__(3950).fromPromise)
const jsonFile = __webpack_require__(5332)

jsonFile.outputJson = u(__webpack_require__(7764))
jsonFile.outputJsonSync = __webpack_require__(1030)
// aliases
jsonFile.outputJSON = jsonFile.outputJson
jsonFile.outputJSONSync = jsonFile.outputJsonSync
jsonFile.writeJSON = jsonFile.writeJson
jsonFile.writeJSONSync = jsonFile.writeJsonSync
jsonFile.readJSON = jsonFile.readJson
jsonFile.readJSONSync = jsonFile.readJsonSync

module.exports = jsonFile


/***/ }),

/***/ 5332:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const jsonFile = __webpack_require__(9279)

module.exports = {
  // jsonfile exports
  readJson: jsonFile.readFile,
  readJsonSync: jsonFile.readFileSync,
  writeJson: jsonFile.writeFile,
  writeJsonSync: jsonFile.writeFileSync
}


/***/ }),

/***/ 1030:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { stringify } = __webpack_require__(6317)
const { outputFileSync } = __webpack_require__(7542)

function outputJsonSync (file, data, options) {
  const str = stringify(data, options)

  outputFileSync(file, str, options)
}

module.exports = outputJsonSync


/***/ }),

/***/ 7764:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { stringify } = __webpack_require__(6317)
const { outputFile } = __webpack_require__(7542)

async function outputJson (file, data, options = {}) {
  const str = stringify(data, options)

  await outputFile(file, str, options)
}

module.exports = outputJson


/***/ }),

/***/ 8860:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

const u = (__webpack_require__(3950).fromPromise)
const { makeDir: _makeDir, makeDirSync } = __webpack_require__(8330)
const makeDir = u(_makeDir)

module.exports = {
  mkdirs: makeDir,
  mkdirsSync: makeDirSync,
  // alias
  mkdirp: makeDir,
  mkdirpSync: makeDirSync,
  ensureDir: makeDir,
  ensureDirSync: makeDirSync
}


/***/ }),

/***/ 8330:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

const fs = __webpack_require__(4603)
const { checkPath } = __webpack_require__(805)

const getMode = options => {
  const defaults = { mode: 0o777 }
  if (typeof options === 'number') return options
  return ({ ...defaults, ...options }).mode
}

module.exports.makeDir = async (dir, options) => {
  checkPath(dir)

  return fs.mkdir(dir, {
    mode: getMode(options),
    recursive: true
  })
}

module.exports.makeDirSync = (dir, options) => {
  checkPath(dir)

  return fs.mkdirSync(dir, {
    mode: getMode(options),
    recursive: true
  })
}


/***/ }),

/***/ 805:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
// Adapted from https://github.com/sindresorhus/make-dir
// Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

const path = __webpack_require__(6928)

// https://github.com/nodejs/node/issues/8987
// https://github.com/libuv/libuv/pull/1088
module.exports.checkPath = function checkPath (pth) {
  if (process.platform === 'win32') {
    const pathHasInvalidWinCharacters = /[<>:"|?*]/.test(pth.replace(path.parse(pth).root, ''))

    if (pathHasInvalidWinCharacters) {
      const error = new Error(`Path contains invalid characters: ${pth}`)
      error.code = 'EINVAL'
      throw error
    }
  }
}


/***/ }),

/***/ 345:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const u = (__webpack_require__(3950).fromCallback)
module.exports = {
  move: u(__webpack_require__(6820)),
  moveSync: __webpack_require__(6358)
}


/***/ }),

/***/ 6358:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(3735)
const path = __webpack_require__(6928)
const copySync = (__webpack_require__(2057).copySync)
const removeSync = (__webpack_require__(5532).removeSync)
const mkdirpSync = (__webpack_require__(8860).mkdirpSync)
const stat = __webpack_require__(396)

function moveSync (src, dest, opts) {
  opts = opts || {}
  const overwrite = opts.overwrite || opts.clobber || false

  const { srcStat, isChangingCase = false } = stat.checkPathsSync(src, dest, 'move', opts)
  stat.checkParentPathsSync(src, srcStat, dest, 'move')
  if (!isParentRoot(dest)) mkdirpSync(path.dirname(dest))
  return doRename(src, dest, overwrite, isChangingCase)
}

function isParentRoot (dest) {
  const parent = path.dirname(dest)
  const parsedPath = path.parse(parent)
  return parsedPath.root === parent
}

function doRename (src, dest, overwrite, isChangingCase) {
  if (isChangingCase) return rename(src, dest, overwrite)
  if (overwrite) {
    removeSync(dest)
    return rename(src, dest, overwrite)
  }
  if (fs.existsSync(dest)) throw new Error('dest already exists.')
  return rename(src, dest, overwrite)
}

function rename (src, dest, overwrite) {
  try {
    fs.renameSync(src, dest)
  } catch (err) {
    if (err.code !== 'EXDEV') throw err
    return moveAcrossDevice(src, dest, overwrite)
  }
}

function moveAcrossDevice (src, dest, overwrite) {
  const opts = {
    overwrite,
    errorOnExist: true
  }
  copySync(src, dest, opts)
  return removeSync(src)
}

module.exports = moveSync


/***/ }),

/***/ 6820:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(3735)
const path = __webpack_require__(6928)
const copy = (__webpack_require__(2057).copy)
const remove = (__webpack_require__(5532).remove)
const mkdirp = (__webpack_require__(8860).mkdirp)
const pathExists = (__webpack_require__(6566).pathExists)
const stat = __webpack_require__(396)

function move (src, dest, opts, cb) {
  if (typeof opts === 'function') {
    cb = opts
    opts = {}
  }

  opts = opts || {}

  const overwrite = opts.overwrite || opts.clobber || false

  stat.checkPaths(src, dest, 'move', opts, (err, stats) => {
    if (err) return cb(err)
    const { srcStat, isChangingCase = false } = stats
    stat.checkParentPaths(src, srcStat, dest, 'move', err => {
      if (err) return cb(err)
      if (isParentRoot(dest)) return doRename(src, dest, overwrite, isChangingCase, cb)
      mkdirp(path.dirname(dest), err => {
        if (err) return cb(err)
        return doRename(src, dest, overwrite, isChangingCase, cb)
      })
    })
  })
}

function isParentRoot (dest) {
  const parent = path.dirname(dest)
  const parsedPath = path.parse(parent)
  return parsedPath.root === parent
}

function doRename (src, dest, overwrite, isChangingCase, cb) {
  if (isChangingCase) return rename(src, dest, overwrite, cb)
  if (overwrite) {
    return remove(dest, err => {
      if (err) return cb(err)
      return rename(src, dest, overwrite, cb)
    })
  }
  pathExists(dest, (err, destExists) => {
    if (err) return cb(err)
    if (destExists) return cb(new Error('dest already exists.'))
    return rename(src, dest, overwrite, cb)
  })
}

function rename (src, dest, overwrite, cb) {
  fs.rename(src, dest, err => {
    if (!err) return cb()
    if (err.code !== 'EXDEV') return cb(err)
    return moveAcrossDevice(src, dest, overwrite, cb)
  })
}

function moveAcrossDevice (src, dest, overwrite, cb) {
  const opts = {
    overwrite,
    errorOnExist: true
  }
  copy(src, dest, opts, err => {
    if (err) return cb(err)
    return remove(src, cb)
  })
}

module.exports = move


/***/ }),

/***/ 7542:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const u = (__webpack_require__(3950).fromCallback)
const fs = __webpack_require__(3735)
const path = __webpack_require__(6928)
const mkdir = __webpack_require__(8860)
const pathExists = (__webpack_require__(6566).pathExists)

function outputFile (file, data, encoding, callback) {
  if (typeof encoding === 'function') {
    callback = encoding
    encoding = 'utf8'
  }

  const dir = path.dirname(file)
  pathExists(dir, (err, itDoes) => {
    if (err) return callback(err)
    if (itDoes) return fs.writeFile(file, data, encoding, callback)

    mkdir.mkdirs(dir, err => {
      if (err) return callback(err)

      fs.writeFile(file, data, encoding, callback)
    })
  })
}

function outputFileSync (file, ...args) {
  const dir = path.dirname(file)
  if (fs.existsSync(dir)) {
    return fs.writeFileSync(file, ...args)
  }
  mkdir.mkdirsSync(dir)
  fs.writeFileSync(file, ...args)
}

module.exports = {
  outputFile: u(outputFile),
  outputFileSync
}


/***/ }),

/***/ 6566:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

const u = (__webpack_require__(3950).fromPromise)
const fs = __webpack_require__(4603)

function pathExists (path) {
  return fs.access(path).then(() => true).catch(() => false)
}

module.exports = {
  pathExists: u(pathExists),
  pathExistsSync: fs.existsSync
}


/***/ }),

/***/ 5532:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(3735)
const u = (__webpack_require__(3950).fromCallback)
const rimraf = __webpack_require__(1619)

function remove (path, callback) {
  // Node 14.14.0+
  if (fs.rm) return fs.rm(path, { recursive: true, force: true }, callback)
  rimraf(path, callback)
}

function removeSync (path) {
  // Node 14.14.0+
  if (fs.rmSync) return fs.rmSync(path, { recursive: true, force: true })
  rimraf.sync(path)
}

module.exports = {
  remove: u(remove),
  removeSync
}


/***/ }),

/***/ 1619:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(3735)
const path = __webpack_require__(6928)
const assert = __webpack_require__(2613)

const isWindows = (process.platform === 'win32')

function defaults (options) {
  const methods = [
    'unlink',
    'chmod',
    'stat',
    'lstat',
    'rmdir',
    'readdir'
  ]
  methods.forEach(m => {
    options[m] = options[m] || fs[m]
    m = m + 'Sync'
    options[m] = options[m] || fs[m]
  })

  options.maxBusyTries = options.maxBusyTries || 3
}

function rimraf (p, options, cb) {
  let busyTries = 0

  if (typeof options === 'function') {
    cb = options
    options = {}
  }

  assert(p, 'rimraf: missing path')
  assert.strictEqual(typeof p, 'string', 'rimraf: path should be a string')
  assert.strictEqual(typeof cb, 'function', 'rimraf: callback function required')
  assert(options, 'rimraf: invalid options argument provided')
  assert.strictEqual(typeof options, 'object', 'rimraf: options should be object')

  defaults(options)

  rimraf_(p, options, function CB (er) {
    if (er) {
      if ((er.code === 'EBUSY' || er.code === 'ENOTEMPTY' || er.code === 'EPERM') &&
          busyTries < options.maxBusyTries) {
        busyTries++
        const time = busyTries * 100
        // try again, with the same exact callback as this one.
        return setTimeout(() => rimraf_(p, options, CB), time)
      }

      // already gone
      if (er.code === 'ENOENT') er = null
    }

    cb(er)
  })
}

// Two possible strategies.
// 1. Assume it's a file.  unlink it, then do the dir stuff on EPERM or EISDIR
// 2. Assume it's a directory.  readdir, then do the file stuff on ENOTDIR
//
// Both result in an extra syscall when you guess wrong.  However, there
// are likely far more normal files in the world than directories.  This
// is based on the assumption that a the average number of files per
// directory is >= 1.
//
// If anyone ever complains about this, then I guess the strategy could
// be made configurable somehow.  But until then, YAGNI.
function rimraf_ (p, options, cb) {
  assert(p)
  assert(options)
  assert(typeof cb === 'function')

  // sunos lets the root user unlink directories, which is... weird.
  // so we have to lstat here and make sure it's not a dir.
  options.lstat(p, (er, st) => {
    if (er && er.code === 'ENOENT') {
      return cb(null)
    }

    // Windows can EPERM on stat.  Life is suffering.
    if (er && er.code === 'EPERM' && isWindows) {
      return fixWinEPERM(p, options, er, cb)
    }

    if (st && st.isDirectory()) {
      return rmdir(p, options, er, cb)
    }

    options.unlink(p, er => {
      if (er) {
        if (er.code === 'ENOENT') {
          return cb(null)
        }
        if (er.code === 'EPERM') {
          return (isWindows)
            ? fixWinEPERM(p, options, er, cb)
            : rmdir(p, options, er, cb)
        }
        if (er.code === 'EISDIR') {
          return rmdir(p, options, er, cb)
        }
      }
      return cb(er)
    })
  })
}

function fixWinEPERM (p, options, er, cb) {
  assert(p)
  assert(options)
  assert(typeof cb === 'function')

  options.chmod(p, 0o666, er2 => {
    if (er2) {
      cb(er2.code === 'ENOENT' ? null : er)
    } else {
      options.stat(p, (er3, stats) => {
        if (er3) {
          cb(er3.code === 'ENOENT' ? null : er)
        } else if (stats.isDirectory()) {
          rmdir(p, options, er, cb)
        } else {
          options.unlink(p, cb)
        }
      })
    }
  })
}

function fixWinEPERMSync (p, options, er) {
  let stats

  assert(p)
  assert(options)

  try {
    options.chmodSync(p, 0o666)
  } catch (er2) {
    if (er2.code === 'ENOENT') {
      return
    } else {
      throw er
    }
  }

  try {
    stats = options.statSync(p)
  } catch (er3) {
    if (er3.code === 'ENOENT') {
      return
    } else {
      throw er
    }
  }

  if (stats.isDirectory()) {
    rmdirSync(p, options, er)
  } else {
    options.unlinkSync(p)
  }
}

function rmdir (p, options, originalEr, cb) {
  assert(p)
  assert(options)
  assert(typeof cb === 'function')

  // try to rmdir first, and only readdir on ENOTEMPTY or EEXIST (SunOS)
  // if we guessed wrong, and it's not a directory, then
  // raise the original error.
  options.rmdir(p, er => {
    if (er && (er.code === 'ENOTEMPTY' || er.code === 'EEXIST' || er.code === 'EPERM')) {
      rmkids(p, options, cb)
    } else if (er && er.code === 'ENOTDIR') {
      cb(originalEr)
    } else {
      cb(er)
    }
  })
}

function rmkids (p, options, cb) {
  assert(p)
  assert(options)
  assert(typeof cb === 'function')

  options.readdir(p, (er, files) => {
    if (er) return cb(er)

    let n = files.length
    let errState

    if (n === 0) return options.rmdir(p, cb)

    files.forEach(f => {
      rimraf(path.join(p, f), options, er => {
        if (errState) {
          return
        }
        if (er) return cb(errState = er)
        if (--n === 0) {
          options.rmdir(p, cb)
        }
      })
    })
  })
}

// this looks simpler, and is strictly *faster*, but will
// tie up the JavaScript thread and fail on excessively
// deep directory trees.
function rimrafSync (p, options) {
  let st

  options = options || {}
  defaults(options)

  assert(p, 'rimraf: missing path')
  assert.strictEqual(typeof p, 'string', 'rimraf: path should be a string')
  assert(options, 'rimraf: missing options')
  assert.strictEqual(typeof options, 'object', 'rimraf: options should be object')

  try {
    st = options.lstatSync(p)
  } catch (er) {
    if (er.code === 'ENOENT') {
      return
    }

    // Windows can EPERM on stat.  Life is suffering.
    if (er.code === 'EPERM' && isWindows) {
      fixWinEPERMSync(p, options, er)
    }
  }

  try {
    // sunos lets the root user unlink directories, which is... weird.
    if (st && st.isDirectory()) {
      rmdirSync(p, options, null)
    } else {
      options.unlinkSync(p)
    }
  } catch (er) {
    if (er.code === 'ENOENT') {
      return
    } else if (er.code === 'EPERM') {
      return isWindows ? fixWinEPERMSync(p, options, er) : rmdirSync(p, options, er)
    } else if (er.code !== 'EISDIR') {
      throw er
    }
    rmdirSync(p, options, er)
  }
}

function rmdirSync (p, options, originalEr) {
  assert(p)
  assert(options)

  try {
    options.rmdirSync(p)
  } catch (er) {
    if (er.code === 'ENOTDIR') {
      throw originalEr
    } else if (er.code === 'ENOTEMPTY' || er.code === 'EEXIST' || er.code === 'EPERM') {
      rmkidsSync(p, options)
    } else if (er.code !== 'ENOENT') {
      throw er
    }
  }
}

function rmkidsSync (p, options) {
  assert(p)
  assert(options)
  options.readdirSync(p).forEach(f => rimrafSync(path.join(p, f), options))

  if (isWindows) {
    // We only end up here once we got ENOTEMPTY at least once, and
    // at this point, we are guaranteed to have removed all the kids.
    // So, we know that it won't be ENOENT or ENOTDIR or anything else.
    // try really hard to delete stuff on windows, because it has a
    // PROFOUNDLY annoying habit of not closing handles promptly when
    // files are deleted, resulting in spurious ENOTEMPTY errors.
    const startTime = Date.now()
    do {
      try {
        const ret = options.rmdirSync(p, options)
        return ret
      } catch {}
    } while (Date.now() - startTime < 500) // give up after 500ms
  } else {
    const ret = options.rmdirSync(p, options)
    return ret
  }
}

module.exports = rimraf
rimraf.sync = rimrafSync


/***/ }),

/***/ 396:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(4603)
const path = __webpack_require__(6928)
const util = __webpack_require__(9023)

function getStats (src, dest, opts) {
  const statFunc = opts.dereference
    ? (file) => fs.stat(file, { bigint: true })
    : (file) => fs.lstat(file, { bigint: true })
  return Promise.all([
    statFunc(src),
    statFunc(dest).catch(err => {
      if (err.code === 'ENOENT') return null
      throw err
    })
  ]).then(([srcStat, destStat]) => ({ srcStat, destStat }))
}

function getStatsSync (src, dest, opts) {
  let destStat
  const statFunc = opts.dereference
    ? (file) => fs.statSync(file, { bigint: true })
    : (file) => fs.lstatSync(file, { bigint: true })
  const srcStat = statFunc(src)
  try {
    destStat = statFunc(dest)
  } catch (err) {
    if (err.code === 'ENOENT') return { srcStat, destStat: null }
    throw err
  }
  return { srcStat, destStat }
}

function checkPaths (src, dest, funcName, opts, cb) {
  util.callbackify(getStats)(src, dest, opts, (err, stats) => {
    if (err) return cb(err)
    const { srcStat, destStat } = stats

    if (destStat) {
      if (areIdentical(srcStat, destStat)) {
        const srcBaseName = path.basename(src)
        const destBaseName = path.basename(dest)
        if (funcName === 'move' &&
          srcBaseName !== destBaseName &&
          srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
          return cb(null, { srcStat, destStat, isChangingCase: true })
        }
        return cb(new Error('Source and destination must not be the same.'))
      }
      if (srcStat.isDirectory() && !destStat.isDirectory()) {
        return cb(new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`))
      }
      if (!srcStat.isDirectory() && destStat.isDirectory()) {
        return cb(new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`))
      }
    }

    if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
      return cb(new Error(errMsg(src, dest, funcName)))
    }
    return cb(null, { srcStat, destStat })
  })
}

function checkPathsSync (src, dest, funcName, opts) {
  const { srcStat, destStat } = getStatsSync(src, dest, opts)

  if (destStat) {
    if (areIdentical(srcStat, destStat)) {
      const srcBaseName = path.basename(src)
      const destBaseName = path.basename(dest)
      if (funcName === 'move' &&
        srcBaseName !== destBaseName &&
        srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
        return { srcStat, destStat, isChangingCase: true }
      }
      throw new Error('Source and destination must not be the same.')
    }
    if (srcStat.isDirectory() && !destStat.isDirectory()) {
      throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`)
    }
    if (!srcStat.isDirectory() && destStat.isDirectory()) {
      throw new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`)
    }
  }

  if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
    throw new Error(errMsg(src, dest, funcName))
  }
  return { srcStat, destStat }
}

// recursively check if dest parent is a subdirectory of src.
// It works for all file types including symlinks since it
// checks the src and dest inodes. It starts from the deepest
// parent and stops once it reaches the src parent or the root path.
function checkParentPaths (src, srcStat, dest, funcName, cb) {
  const srcParent = path.resolve(path.dirname(src))
  const destParent = path.resolve(path.dirname(dest))
  if (destParent === srcParent || destParent === path.parse(destParent).root) return cb()
  fs.stat(destParent, { bigint: true }, (err, destStat) => {
    if (err) {
      if (err.code === 'ENOENT') return cb()
      return cb(err)
    }
    if (areIdentical(srcStat, destStat)) {
      return cb(new Error(errMsg(src, dest, funcName)))
    }
    return checkParentPaths(src, srcStat, destParent, funcName, cb)
  })
}

function checkParentPathsSync (src, srcStat, dest, funcName) {
  const srcParent = path.resolve(path.dirname(src))
  const destParent = path.resolve(path.dirname(dest))
  if (destParent === srcParent || destParent === path.parse(destParent).root) return
  let destStat
  try {
    destStat = fs.statSync(destParent, { bigint: true })
  } catch (err) {
    if (err.code === 'ENOENT') return
    throw err
  }
  if (areIdentical(srcStat, destStat)) {
    throw new Error(errMsg(src, dest, funcName))
  }
  return checkParentPathsSync(src, srcStat, destParent, funcName)
}

function areIdentical (srcStat, destStat) {
  return destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev
}

// return true if dest is a subdir of src, otherwise false.
// It only checks the path strings.
function isSrcSubdir (src, dest) {
  const srcArr = path.resolve(src).split(path.sep).filter(i => i)
  const destArr = path.resolve(dest).split(path.sep).filter(i => i)
  return srcArr.reduce((acc, cur, i) => acc && destArr[i] === cur, true)
}

function errMsg (src, dest, funcName) {
  return `Cannot ${funcName} '${src}' to a subdirectory of itself, '${dest}'.`
}

module.exports = {
  checkPaths,
  checkPathsSync,
  checkParentPaths,
  checkParentPathsSync,
  isSrcSubdir,
  areIdentical
}


/***/ }),

/***/ 9633:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const fs = __webpack_require__(3735)

function utimesMillis (path, atime, mtime, callback) {
  // if (!HAS_MILLIS_RES) return fs.utimes(path, atime, mtime, callback)
  fs.open(path, 'r+', (err, fd) => {
    if (err) return callback(err)
    fs.futimes(fd, atime, mtime, futimesErr => {
      fs.close(fd, closeErr => {
        if (callback) callback(futimesErr || closeErr)
      })
    })
  })
}

function utimesMillisSync (path, atime, mtime) {
  const fd = fs.openSync(path, 'r+')
  fs.futimesSync(fd, atime, mtime)
  return fs.closeSync(fd)
}

module.exports = {
  utimesMillis,
  utimesMillisSync
}


/***/ }),

/***/ 9279:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

let _fs
try {
  _fs = __webpack_require__(3735)
} catch (_) {
  _fs = __webpack_require__(9896)
}
const universalify = __webpack_require__(3950)
const { stringify, stripBom } = __webpack_require__(6317)

async function _readFile (file, options = {}) {
  if (typeof options === 'string') {
    options = { encoding: options }
  }

  const fs = options.fs || _fs

  const shouldThrow = 'throws' in options ? options.throws : true

  let data = await universalify.fromCallback(fs.readFile)(file, options)

  data = stripBom(data)

  let obj
  try {
    obj = JSON.parse(data, options ? options.reviver : null)
  } catch (err) {
    if (shouldThrow) {
      err.message = `${file}: ${err.message}`
      throw err
    } else {
      return null
    }
  }

  return obj
}

const readFile = universalify.fromPromise(_readFile)

function readFileSync (file, options = {}) {
  if (typeof options === 'string') {
    options = { encoding: options }
  }

  const fs = options.fs || _fs

  const shouldThrow = 'throws' in options ? options.throws : true

  try {
    let content = fs.readFileSync(file, options)
    content = stripBom(content)
    return JSON.parse(content, options.reviver)
  } catch (err) {
    if (shouldThrow) {
      err.message = `${file}: ${err.message}`
      throw err
    } else {
      return null
    }
  }
}

async function _writeFile (file, obj, options = {}) {
  const fs = options.fs || _fs

  const str = stringify(obj, options)

  await universalify.fromCallback(fs.writeFile)(file, str, options)
}

const writeFile = universalify.fromPromise(_writeFile)

function writeFileSync (file, obj, options = {}) {
  const fs = options.fs || _fs

  const str = stringify(obj, options)
  // not sure if fs.writeFileSync returns anything, but just in case
  return fs.writeFileSync(file, str, options)
}

const jsonfile = {
  readFile,
  readFileSync,
  writeFile,
  writeFileSync
}

module.exports = jsonfile


/***/ }),

/***/ 6317:
/***/ ((module) => {

function stringify (obj, { EOL = '\n', finalEOL = true, replacer = null, spaces } = {}) {
  const EOF = finalEOL ? EOL : ''
  const str = JSON.stringify(obj, replacer, spaces)

  return str.replace(/\n/g, EOL) + EOF
}

function stripBom (content) {
  // we do this because JSON.parse would convert it to a utf8 string if encoding wasn't specified
  if (Buffer.isBuffer(content)) content = content.toString('utf8')
  return content.replace(/^\uFEFF/, '')
}

module.exports = { stringify, stripBom }


/***/ }),

/***/ 3950:
/***/ ((__unused_webpack_module, exports) => {

"use strict";


exports.fromCallback = function (fn) {
  return Object.defineProperty(function (...args) {
    if (typeof args[args.length - 1] === 'function') fn.apply(this, args)
    else {
      return new Promise((resolve, reject) => {
        args.push((err, res) => (err != null) ? reject(err) : resolve(res))
        fn.apply(this, args)
      })
    }
  }, 'name', { value: fn.name })
}

exports.fromPromise = function (fn) {
  return Object.defineProperty(function (...args) {
    const cb = args[args.length - 1]
    if (typeof cb !== 'function') return fn.apply(this, args)
    else {
      args.pop()
      fn.apply(this, args).then(r => cb(null, r), cb)
    }
  }, 'name', { value: fn.name })
}


/***/ }),

/***/ 6176:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.getAppCacheDir = void 0;
const path = __webpack_require__(6928);
const os_1 = __webpack_require__(857);
function getAppCacheDir() {
    const homedir = (0, os_1.homedir)();
    // https://github.com/electron/electron/issues/1404#issuecomment-194391247
    let result;
    if (process.platform === "win32") {
        result = ({"NODE_ENV":"production"})["LOCALAPPDATA"] || path.join(homedir, "AppData", "Local");
    }
    else if (process.platform === "darwin") {
        result = path.join(homedir, "Library", "Caches");
    }
    else {
        result = ({"NODE_ENV":"production"})["XDG_CACHE_HOME"] || path.join(homedir, ".cache");
    }
    return result;
}
exports.getAppCacheDir = getAppCacheDir;
//# sourceMappingURL=AppAdapter.js.map

/***/ }),

/***/ 6441:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AppImageUpdater = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const child_process_1 = __webpack_require__(5317);
const fs_extra_1 = __webpack_require__(8799);
const fs_1 = __webpack_require__(9896);
const path = __webpack_require__(6928);
const BaseUpdater_1 = __webpack_require__(9322);
const FileWithEmbeddedBlockMapDifferentialDownloader_1 = __webpack_require__(1972);
const main_1 = __webpack_require__(5879);
const Provider_1 = __webpack_require__(5776);
class AppImageUpdater extends BaseUpdater_1.BaseUpdater {
    constructor(options, app) {
        super(options, app);
    }
    isUpdaterActive() {
        if (({"NODE_ENV":"production"})["APPIMAGE"] == null) {
            if (({"NODE_ENV":"production"})["SNAP"] == null) {
                this._logger.warn("APPIMAGE env is not defined, current application is not an AppImage");
            }
            else {
                this._logger.info("SNAP env is defined, updater is disabled");
            }
            return false;
        }
        return super.isUpdaterActive();
    }
    /*** @private */
    doDownloadUpdate(downloadUpdateOptions) {
        const provider = downloadUpdateOptions.updateInfoAndProvider.provider;
        const fileInfo = (0, Provider_1.findFile)(provider.resolveFiles(downloadUpdateOptions.updateInfoAndProvider.info), "AppImage", ["rpm", "deb"]);
        return this.executeDownload({
            fileExtension: "AppImage",
            fileInfo,
            downloadUpdateOptions,
            task: async (updateFile, downloadOptions) => {
                const oldFile = ({"NODE_ENV":"production"})["APPIMAGE"];
                if (oldFile == null) {
                    throw (0, builder_util_runtime_1.newError)("APPIMAGE env is not defined", "ERR_UPDATER_OLD_FILE_NOT_FOUND");
                }
                let isDownloadFull = false;
                try {
                    const downloadOptions = {
                        newUrl: fileInfo.url,
                        oldFile,
                        logger: this._logger,
                        newFile: updateFile,
                        isUseMultipleRangeRequest: provider.isUseMultipleRangeRequest,
                        requestHeaders: downloadUpdateOptions.requestHeaders,
                        cancellationToken: downloadUpdateOptions.cancellationToken,
                    };
                    if (this.listenerCount(main_1.DOWNLOAD_PROGRESS) > 0) {
                        downloadOptions.onProgress = it => this.emit(main_1.DOWNLOAD_PROGRESS, it);
                    }
                    await new FileWithEmbeddedBlockMapDifferentialDownloader_1.FileWithEmbeddedBlockMapDifferentialDownloader(fileInfo.info, this.httpExecutor, downloadOptions).download();
                }
                catch (e) {
                    this._logger.error(`Cannot download differentially, fallback to full download: ${e.stack || e}`);
                    // during test (developer machine mac) we must throw error
                    isDownloadFull = process.platform === "linux";
                }
                if (isDownloadFull) {
                    await this.httpExecutor.download(fileInfo.url, updateFile, downloadOptions);
                }
                await (0, fs_extra_1.chmod)(updateFile, 0o755);
            },
        });
    }
    doInstall(options) {
        const appImageFile = ({"NODE_ENV":"production"})["APPIMAGE"];
        if (appImageFile == null) {
            throw (0, builder_util_runtime_1.newError)("APPIMAGE env is not defined", "ERR_UPDATER_OLD_FILE_NOT_FOUND");
        }
        // https://stackoverflow.com/a/1712051/1910191
        (0, fs_1.unlinkSync)(appImageFile);
        let destination;
        const existingBaseName = path.basename(appImageFile);
        // https://github.com/electron-userland/electron-builder/issues/2964
        // if no version in existing file name, it means that user wants to preserve current custom name
        if (path.basename(options.installerPath) === existingBaseName || !/\d+\.\d+\.\d+/.test(existingBaseName)) {
            // no version in the file name, overwrite existing
            destination = appImageFile;
        }
        else {
            destination = path.join(path.dirname(appImageFile), path.basename(options.installerPath));
        }
        (0, child_process_1.execFileSync)("mv", ["-f", options.installerPath, destination]);
        if (destination !== appImageFile) {
            this.emit("appimage-filename-updated", destination);
        }
        const env = {
            ...({"NODE_ENV":"production"}),
            APPIMAGE_SILENT_INSTALL: "true",
        };
        if (options.isForceRunAfter) {
            // eslint-disable-next-line @typescript-eslint/no-floating-promises
            this.spawnLog(destination, [], env);
        }
        else {
            env.APPIMAGE_EXIT_AFTER_INSTALL = "true";
            (0, child_process_1.execFileSync)(destination, [], { env });
        }
        return true;
    }
}
exports.AppImageUpdater = AppImageUpdater;
//# sourceMappingURL=AppImageUpdater.js.map

/***/ }),

/***/ 4718:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.NoOpLogger = exports.AppUpdater = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const crypto_1 = __webpack_require__(6982);
const events_1 = __webpack_require__(4434);
const fs_extra_1 = __webpack_require__(8799);
const js_yaml_1 = __webpack_require__(7210);
const lazy_val_1 = __webpack_require__(8801);
const path = __webpack_require__(6928);
const semver_1 = __webpack_require__(9589);
const DownloadedUpdateHelper_1 = __webpack_require__(2474);
const ElectronAppAdapter_1 = __webpack_require__(910);
const electronHttpExecutor_1 = __webpack_require__(369);
const GenericProvider_1 = __webpack_require__(2705);
const main_1 = __webpack_require__(5879);
const providerFactory_1 = __webpack_require__(7981);
class AppUpdater extends events_1.EventEmitter {
    /**
     * Get the update channel. Not applicable for GitHub. Doesn't return `channel` from the update configuration, only if was previously set.
     */
    get channel() {
        return this._channel;
    }
    /**
     * Set the update channel. Not applicable for GitHub. Overrides `channel` in the update configuration.
     *
     * `allowDowngrade` will be automatically set to `true`. If this behavior is not suitable for you, simple set `allowDowngrade` explicitly after.
     */
    set channel(value) {
        if (this._channel != null) {
            // noinspection SuspiciousTypeOfGuard
            if (typeof value !== "string") {
                throw (0, builder_util_runtime_1.newError)(`Channel must be a string, but got: ${value}`, "ERR_UPDATER_INVALID_CHANNEL");
            }
            else if (value.length === 0) {
                throw (0, builder_util_runtime_1.newError)(`Channel must be not an empty string`, "ERR_UPDATER_INVALID_CHANNEL");
            }
        }
        this._channel = value;
        this.allowDowngrade = true;
    }
    /**
     *  Shortcut for explicitly adding auth tokens to request headers
     */
    addAuthHeader(token) {
        this.requestHeaders = Object.assign({}, this.requestHeaders, {
            authorization: token,
        });
    }
    // noinspection JSMethodCanBeStatic,JSUnusedGlobalSymbols
    get netSession() {
        return (0, electronHttpExecutor_1.getNetSession)();
    }
    /**
     * The logger. You can pass [electron-log](https://github.com/megahertz/electron-log), [winston](https://github.com/winstonjs/winston) or another logger with the following interface: `{ info(), warn(), error() }`.
     * Set it to `null` if you would like to disable a logging feature.
     */
    get logger() {
        return this._logger;
    }
    set logger(value) {
        this._logger = value == null ? new NoOpLogger() : value;
    }
    // noinspection JSUnusedGlobalSymbols
    /**
     * test only
     * @private
     */
    set updateConfigPath(value) {
        this.clientPromise = null;
        this._appUpdateConfigPath = value;
        this.configOnDisk = new lazy_val_1.Lazy(() => this.loadUpdateConfig());
    }
    constructor(options, app) {
        super();
        /**
         * Whether to automatically download an update when it is found.
         */
        this.autoDownload = true;
        /**
         * Whether to automatically install a downloaded update on app quit (if `quitAndInstall` was not called before).
         */
        this.autoInstallOnAppQuit = true;
        /**
         * *windows-only* Whether to run the app after finish install when run the installer NOT in silent mode.
         * @default true
         */
        this.autoRunAppAfterInstall = true;
        /**
         * *GitHub provider only.* Whether to allow update to pre-release versions. Defaults to `true` if application version contains prerelease components (e.g. `0.12.1-alpha.1`, here `alpha` is a prerelease component), otherwise `false`.
         *
         * If `true`, downgrade will be allowed (`allowDowngrade` will be set to `true`).
         */
        this.allowPrerelease = false;
        /**
         * *GitHub provider only.* Get all release notes (from current version to latest), not just the latest.
         * @default false
         */
        this.fullChangelog = false;
        /**
         * Whether to allow version downgrade (when a user from the beta channel wants to go back to the stable channel).
         *
         * Taken in account only if channel differs (pre-release version component in terms of semantic versioning).
         *
         * @default false
         */
        this.allowDowngrade = false;
        /**
         * Web installer files might not have signature verification, this switch prevents to load them unless it is needed.
         *
         * Currently false to prevent breaking the current API, but it should be changed to default true at some point that
         * breaking changes are allowed.
         *
         * @default false
         */
        this.disableWebInstaller = false;
        /**
         * *NSIS only* Disable differential downloads and always perform full download of installer.
         *
         * @default false
         */
        this.disableDifferentialDownload = false;
        /**
         * Allows developer to force the updater to work in "dev" mode, looking for "dev-app-update.yml" instead of "app-update.yml"
         * Dev: `path.join(this.app.getAppPath(), "dev-app-update.yml")`
         * Prod: `path.join(process.resourcesPath!, "app-update.yml")`
         *
         * @default false
         */
        this.forceDevUpdateConfig = false;
        this._channel = null;
        this.downloadedUpdateHelper = null;
        /**
         *  The request headers.
         */
        this.requestHeaders = null;
        this._logger = console;
        // noinspection JSUnusedGlobalSymbols
        /**
         * For type safety you can use signals, e.g. `autoUpdater.signals.updateDownloaded(() => {})` instead of `autoUpdater.on('update-available', () => {})`
         */
        this.signals = new main_1.UpdaterSignal(this);
        this._appUpdateConfigPath = null;
        this.clientPromise = null;
        this.stagingUserIdPromise = new lazy_val_1.Lazy(() => this.getOrCreateStagingUserId());
        // public, allow to read old config for anyone
        /** @internal */
        this.configOnDisk = new lazy_val_1.Lazy(() => this.loadUpdateConfig());
        this.checkForUpdatesPromise = null;
        this.updateInfoAndProvider = null;
        /**
         * @private
         * @internal
         */
        this._testOnlyOptions = null;
        this.on("error", (error) => {
            this._logger.error(`Error: ${error.stack || error.message}`);
        });
        if (app == null) {
            this.app = new ElectronAppAdapter_1.ElectronAppAdapter();
            this.httpExecutor = new electronHttpExecutor_1.ElectronHttpExecutor((authInfo, callback) => this.emit("login", authInfo, callback));
        }
        else {
            this.app = app;
            this.httpExecutor = null;
        }
        const currentVersionString = this.app.version;
        const currentVersion = (0, semver_1.parse)(currentVersionString);
        if (currentVersion == null) {
            throw (0, builder_util_runtime_1.newError)(`App version is not a valid semver version: "${currentVersionString}"`, "ERR_UPDATER_INVALID_VERSION");
        }
        this.currentVersion = currentVersion;
        this.allowPrerelease = hasPrereleaseComponents(currentVersion);
        if (options != null) {
            this.setFeedURL(options);
            if (typeof options !== "string" && options.requestHeaders) {
                this.requestHeaders = options.requestHeaders;
            }
        }
    }
    //noinspection JSMethodCanBeStatic,JSUnusedGlobalSymbols
    getFeedURL() {
        return "Deprecated. Do not use it.";
    }
    /**
     * Configure update provider. If value is `string`, [GenericServerOptions](/configuration/publish#genericserveroptions) will be set with value as `url`.
     * @param options If you want to override configuration in the `app-update.yml`.
     */
    setFeedURL(options) {
        const runtimeOptions = this.createProviderRuntimeOptions();
        // https://github.com/electron-userland/electron-builder/issues/1105
        let provider;
        if (typeof options === "string") {
            provider = new GenericProvider_1.GenericProvider({ provider: "generic", url: options }, this, {
                ...runtimeOptions,
                isUseMultipleRangeRequest: (0, providerFactory_1.isUrlProbablySupportMultiRangeRequests)(options),
            });
        }
        else {
            provider = (0, providerFactory_1.createClient)(options, this, runtimeOptions);
        }
        this.clientPromise = Promise.resolve(provider);
    }
    /**
     * Asks the server whether there is an update.
     */
    checkForUpdates() {
        if (!this.isUpdaterActive()) {
            return Promise.resolve(null);
        }
        let checkForUpdatesPromise = this.checkForUpdatesPromise;
        if (checkForUpdatesPromise != null) {
            this._logger.info("Checking for update (already in progress)");
            return checkForUpdatesPromise;
        }
        const nullizePromise = () => (this.checkForUpdatesPromise = null);
        this._logger.info("Checking for update");
        checkForUpdatesPromise = this.doCheckForUpdates()
            .then(it => {
            nullizePromise();
            return it;
        })
            .catch((e) => {
            nullizePromise();
            this.emit("error", e, `Cannot check for updates: ${(e.stack || e).toString()}`);
            throw e;
        });
        this.checkForUpdatesPromise = checkForUpdatesPromise;
        return checkForUpdatesPromise;
    }
    isUpdaterActive() {
        const isEnabled = this.app.isPackaged || this.forceDevUpdateConfig;
        if (!isEnabled) {
            this._logger.info("Skip checkForUpdates because application is not packed and dev update config is not forced");
            return false;
        }
        return true;
    }
    // noinspection JSUnusedGlobalSymbols
    checkForUpdatesAndNotify(downloadNotification) {
        return this.checkForUpdates().then(it => {
            if (!(it === null || it === void 0 ? void 0 : it.downloadPromise)) {
                if (this._logger.debug != null) {
                    this._logger.debug("checkForUpdatesAndNotify called, downloadPromise is null");
                }
                return it;
            }
            void it.downloadPromise.then(() => {
                const notificationContent = AppUpdater.formatDownloadNotification(it.updateInfo.version, this.app.name, downloadNotification);
                new ((__webpack_require__(4157).Notification))(notificationContent).show();
            });
            return it;
        });
    }
    static formatDownloadNotification(version, appName, downloadNotification) {
        if (downloadNotification == null) {
            downloadNotification = {
                title: "A new update is ready to install",
                body: `{appName} version {version} has been downloaded and will be automatically installed on exit`,
            };
        }
        downloadNotification = {
            title: downloadNotification.title.replace("{appName}", appName).replace("{version}", version),
            body: downloadNotification.body.replace("{appName}", appName).replace("{version}", version),
        };
        return downloadNotification;
    }
    async isStagingMatch(updateInfo) {
        const rawStagingPercentage = updateInfo.stagingPercentage;
        let stagingPercentage = rawStagingPercentage;
        if (stagingPercentage == null) {
            return true;
        }
        stagingPercentage = parseInt(stagingPercentage, 10);
        if (isNaN(stagingPercentage)) {
            this._logger.warn(`Staging percentage is NaN: ${rawStagingPercentage}`);
            return true;
        }
        // convert from user 0-100 to internal 0-1
        stagingPercentage = stagingPercentage / 100;
        const stagingUserId = await this.stagingUserIdPromise.value;
        const val = builder_util_runtime_1.UUID.parse(stagingUserId).readUInt32BE(12);
        const percentage = val / 0xffffffff;
        this._logger.info(`Staging percentage: ${stagingPercentage}, percentage: ${percentage}, user id: ${stagingUserId}`);
        return percentage < stagingPercentage;
    }
    computeFinalHeaders(headers) {
        if (this.requestHeaders != null) {
            Object.assign(headers, this.requestHeaders);
        }
        return headers;
    }
    async isUpdateAvailable(updateInfo) {
        const latestVersion = (0, semver_1.parse)(updateInfo.version);
        if (latestVersion == null) {
            throw (0, builder_util_runtime_1.newError)(`This file could not be downloaded, or the latest version (from update server) does not have a valid semver version: "${updateInfo.version}"`, "ERR_UPDATER_INVALID_VERSION");
        }
        const currentVersion = this.currentVersion;
        if ((0, semver_1.eq)(latestVersion, currentVersion)) {
            return false;
        }
        const isStagingMatch = await this.isStagingMatch(updateInfo);
        if (!isStagingMatch) {
            return false;
        }
        // https://github.com/electron-userland/electron-builder/pull/3111#issuecomment-405033227
        // https://github.com/electron-userland/electron-builder/pull/3111#issuecomment-405030797
        const isLatestVersionNewer = (0, semver_1.gt)(latestVersion, currentVersion);
        const isLatestVersionOlder = (0, semver_1.lt)(latestVersion, currentVersion);
        if (isLatestVersionNewer) {
            return true;
        }
        return this.allowDowngrade && isLatestVersionOlder;
    }
    async getUpdateInfoAndProvider() {
        await this.app.whenReady();
        if (this.clientPromise == null) {
            this.clientPromise = this.configOnDisk.value.then(it => (0, providerFactory_1.createClient)(it, this, this.createProviderRuntimeOptions()));
        }
        const client = await this.clientPromise;
        const stagingUserId = await this.stagingUserIdPromise.value;
        client.setRequestHeaders(this.computeFinalHeaders({ "x-user-staging-id": stagingUserId }));
        return {
            info: await client.getLatestVersion(),
            provider: client,
        };
    }
    // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
    createProviderRuntimeOptions() {
        return {
            isUseMultipleRangeRequest: true,
            platform: this._testOnlyOptions == null ? process.platform : this._testOnlyOptions.platform,
            executor: this.httpExecutor,
        };
    }
    async doCheckForUpdates() {
        this.emit("checking-for-update");
        const result = await this.getUpdateInfoAndProvider();
        const updateInfo = result.info;
        if (!(await this.isUpdateAvailable(updateInfo))) {
            this._logger.info(`Update for version ${this.currentVersion} is not available (latest version: ${updateInfo.version}, downgrade is ${this.allowDowngrade ? "allowed" : "disallowed"}).`);
            this.emit("update-not-available", updateInfo);
            return {
                versionInfo: updateInfo,
                updateInfo,
            };
        }
        this.updateInfoAndProvider = result;
        this.onUpdateAvailable(updateInfo);
        const cancellationToken = new builder_util_runtime_1.CancellationToken();
        //noinspection ES6MissingAwait
        return {
            versionInfo: updateInfo,
            updateInfo,
            cancellationToken,
            downloadPromise: this.autoDownload ? this.downloadUpdate(cancellationToken) : null,
        };
    }
    onUpdateAvailable(updateInfo) {
        this._logger.info(`Found version ${updateInfo.version} (url: ${(0, builder_util_runtime_1.asArray)(updateInfo.files)
            .map(it => it.url)
            .join(", ")})`);
        this.emit("update-available", updateInfo);
    }
    /**
     * Start downloading update manually. You can use this method if `autoDownload` option is set to `false`.
     * @returns {Promise<Array<string>>} Paths to downloaded files.
     */
    downloadUpdate(cancellationToken = new builder_util_runtime_1.CancellationToken()) {
        const updateInfoAndProvider = this.updateInfoAndProvider;
        if (updateInfoAndProvider == null) {
            const error = new Error("Please check update first");
            this.dispatchError(error);
            return Promise.reject(error);
        }
        this._logger.info(`Downloading update from ${(0, builder_util_runtime_1.asArray)(updateInfoAndProvider.info.files)
            .map(it => it.url)
            .join(", ")}`);
        const errorHandler = (e) => {
            // https://github.com/electron-userland/electron-builder/issues/1150#issuecomment-436891159
            if (!(e instanceof builder_util_runtime_1.CancellationError)) {
                try {
                    this.dispatchError(e);
                }
                catch (nestedError) {
                    this._logger.warn(`Cannot dispatch error event: ${nestedError.stack || nestedError}`);
                }
            }
            return e;
        };
        try {
            return this.doDownloadUpdate({
                updateInfoAndProvider,
                requestHeaders: this.computeRequestHeaders(updateInfoAndProvider.provider),
                cancellationToken,
                disableWebInstaller: this.disableWebInstaller,
                disableDifferentialDownload: this.disableDifferentialDownload,
            }).catch((e) => {
                throw errorHandler(e);
            });
        }
        catch (e) {
            return Promise.reject(errorHandler(e));
        }
    }
    dispatchError(e) {
        this.emit("error", e, (e.stack || e).toString());
    }
    dispatchUpdateDownloaded(event) {
        this.emit(main_1.UPDATE_DOWNLOADED, event);
    }
    async loadUpdateConfig() {
        if (this._appUpdateConfigPath == null) {
            this._appUpdateConfigPath = this.app.appUpdateConfigPath;
        }
        return (0, js_yaml_1.load)(await (0, fs_extra_1.readFile)(this._appUpdateConfigPath, "utf-8"));
    }
    computeRequestHeaders(provider) {
        const fileExtraDownloadHeaders = provider.fileExtraDownloadHeaders;
        if (fileExtraDownloadHeaders != null) {
            const requestHeaders = this.requestHeaders;
            return requestHeaders == null
                ? fileExtraDownloadHeaders
                : {
                    ...fileExtraDownloadHeaders,
                    ...requestHeaders,
                };
        }
        return this.computeFinalHeaders({ accept: "*/*" });
    }
    async getOrCreateStagingUserId() {
        const file = path.join(this.app.userDataPath, ".updaterId");
        try {
            const id = await (0, fs_extra_1.readFile)(file, "utf-8");
            if (builder_util_runtime_1.UUID.check(id)) {
                return id;
            }
            else {
                this._logger.warn(`Staging user id file exists, but content was invalid: ${id}`);
            }
        }
        catch (e) {
            if (e.code !== "ENOENT") {
                this._logger.warn(`Couldn't read staging user ID, creating a blank one: ${e}`);
            }
        }
        const id = builder_util_runtime_1.UUID.v5((0, crypto_1.randomBytes)(4096), builder_util_runtime_1.UUID.OID);
        this._logger.info(`Generated new staging user ID: ${id}`);
        try {
            await (0, fs_extra_1.outputFile)(file, id);
        }
        catch (e) {
            this._logger.warn(`Couldn't write out staging user ID: ${e}`);
        }
        return id;
    }
    /** @internal */
    get isAddNoCacheQuery() {
        const headers = this.requestHeaders;
        // https://github.com/electron-userland/electron-builder/issues/3021
        if (headers == null) {
            return true;
        }
        for (const headerName of Object.keys(headers)) {
            const s = headerName.toLowerCase();
            if (s === "authorization" || s === "private-token") {
                return false;
            }
        }
        return true;
    }
    async getOrCreateDownloadHelper() {
        let result = this.downloadedUpdateHelper;
        if (result == null) {
            const dirName = (await this.configOnDisk.value).updaterCacheDirName;
            const logger = this._logger;
            if (dirName == null) {
                logger.error("updaterCacheDirName is not specified in app-update.yml Was app build using at least electron-builder 20.34.0?");
            }
            const cacheDir = path.join(this.app.baseCachePath, dirName || this.app.name);
            if (logger.debug != null) {
                logger.debug(`updater cache dir: ${cacheDir}`);
            }
            result = new DownloadedUpdateHelper_1.DownloadedUpdateHelper(cacheDir);
            this.downloadedUpdateHelper = result;
        }
        return result;
    }
    async executeDownload(taskOptions) {
        const fileInfo = taskOptions.fileInfo;
        const downloadOptions = {
            headers: taskOptions.downloadUpdateOptions.requestHeaders,
            cancellationToken: taskOptions.downloadUpdateOptions.cancellationToken,
            sha2: fileInfo.info.sha2,
            sha512: fileInfo.info.sha512,
        };
        if (this.listenerCount(main_1.DOWNLOAD_PROGRESS) > 0) {
            downloadOptions.onProgress = it => this.emit(main_1.DOWNLOAD_PROGRESS, it);
        }
        const updateInfo = taskOptions.downloadUpdateOptions.updateInfoAndProvider.info;
        const version = updateInfo.version;
        const packageInfo = fileInfo.packageInfo;
        function getCacheUpdateFileName() {
            // NodeJS URL doesn't decode automatically
            const urlPath = decodeURIComponent(taskOptions.fileInfo.url.pathname);
            if (urlPath.endsWith(`.${taskOptions.fileExtension}`)) {
                return path.basename(urlPath);
            }
            else {
                // url like /latest, generate name
                return taskOptions.fileInfo.info.url;
            }
        }
        const downloadedUpdateHelper = await this.getOrCreateDownloadHelper();
        const cacheDir = downloadedUpdateHelper.cacheDirForPendingUpdate;
        await (0, fs_extra_1.mkdir)(cacheDir, { recursive: true });
        const updateFileName = getCacheUpdateFileName();
        let updateFile = path.join(cacheDir, updateFileName);
        const packageFile = packageInfo == null ? null : path.join(cacheDir, `package-${version}${path.extname(packageInfo.path) || ".7z"}`);
        const done = async (isSaveCache) => {
            await downloadedUpdateHelper.setDownloadedFile(updateFile, packageFile, updateInfo, fileInfo, updateFileName, isSaveCache);
            await taskOptions.done({
                ...updateInfo,
                downloadedFile: updateFile,
            });
            return packageFile == null ? [updateFile] : [updateFile, packageFile];
        };
        const log = this._logger;
        const cachedUpdateFile = await downloadedUpdateHelper.validateDownloadedPath(updateFile, updateInfo, fileInfo, log);
        if (cachedUpdateFile != null) {
            updateFile = cachedUpdateFile;
            return await done(false);
        }
        const removeFileIfAny = async () => {
            await downloadedUpdateHelper.clear().catch(() => {
                // ignore
            });
            return await (0, fs_extra_1.unlink)(updateFile).catch(() => {
                // ignore
            });
        };
        const tempUpdateFile = await (0, DownloadedUpdateHelper_1.createTempUpdateFile)(`temp-${updateFileName}`, cacheDir, log);
        try {
            await taskOptions.task(tempUpdateFile, downloadOptions, packageFile, removeFileIfAny);
            await (0, fs_extra_1.rename)(tempUpdateFile, updateFile);
        }
        catch (e) {
            await removeFileIfAny();
            if (e instanceof builder_util_runtime_1.CancellationError) {
                log.info("cancelled");
                this.emit("update-cancelled", updateInfo);
            }
            throw e;
        }
        log.info(`New version ${version} has been downloaded to ${updateFile}`);
        return await done(true);
    }
}
exports.AppUpdater = AppUpdater;
function hasPrereleaseComponents(version) {
    const versionPrereleaseComponent = (0, semver_1.prerelease)(version);
    return versionPrereleaseComponent != null && versionPrereleaseComponent.length > 0;
}
/** @private */
class NoOpLogger {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    info(message) {
        // ignore
    }
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    warn(message) {
        // ignore
    }
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    error(message) {
        // ignore
    }
}
exports.NoOpLogger = NoOpLogger;
//# sourceMappingURL=AppUpdater.js.map

/***/ }),

/***/ 9322:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.BaseUpdater = void 0;
const child_process_1 = __webpack_require__(5317);
const AppUpdater_1 = __webpack_require__(4718);
class BaseUpdater extends AppUpdater_1.AppUpdater {
    constructor(options, app) {
        super(options, app);
        this.quitAndInstallCalled = false;
        this.quitHandlerAdded = false;
    }
    quitAndInstall(isSilent = false, isForceRunAfter = false) {
        this._logger.info(`Install on explicit quitAndInstall`);
        // If NOT in silent mode use `autoRunAppAfterInstall` to determine whether to force run the app
        const isInstalled = this.install(isSilent, isSilent ? isForceRunAfter : this.autoRunAppAfterInstall);
        if (isInstalled) {
            setImmediate(() => {
                // this event is normally emitted when calling quitAndInstall, this emulates that
                (__webpack_require__(4157).autoUpdater).emit("before-quit-for-update");
                this.app.quit();
            });
        }
        else {
            this.quitAndInstallCalled = false;
        }
    }
    executeDownload(taskOptions) {
        return super.executeDownload({
            ...taskOptions,
            done: event => {
                this.dispatchUpdateDownloaded(event);
                this.addQuitHandler();
                return Promise.resolve();
            },
        });
    }
    // must be sync (because quit even handler is not async)
    install(isSilent = false, isForceRunAfter = false) {
        if (this.quitAndInstallCalled) {
            this._logger.warn("install call ignored: quitAndInstallCalled is set to true");
            return false;
        }
        const downloadedUpdateHelper = this.downloadedUpdateHelper;
        const installerPath = downloadedUpdateHelper == null ? null : downloadedUpdateHelper.file;
        const downloadedFileInfo = downloadedUpdateHelper == null ? null : downloadedUpdateHelper.downloadedFileInfo;
        if (installerPath == null || downloadedFileInfo == null) {
            this.dispatchError(new Error("No valid update available, can't quit and install"));
            return false;
        }
        // prevent calling several times
        this.quitAndInstallCalled = true;
        try {
            this._logger.info(`Install: isSilent: ${isSilent}, isForceRunAfter: ${isForceRunAfter}`);
            return this.doInstall({
                installerPath,
                isSilent,
                isForceRunAfter,
                isAdminRightsRequired: downloadedFileInfo.isAdminRightsRequired,
            });
        }
        catch (e) {
            this.dispatchError(e);
            return false;
        }
    }
    addQuitHandler() {
        if (this.quitHandlerAdded || !this.autoInstallOnAppQuit) {
            return;
        }
        this.quitHandlerAdded = true;
        this.app.onQuit(exitCode => {
            if (this.quitAndInstallCalled) {
                this._logger.info("Update installer has already been triggered. Quitting application.");
                return;
            }
            if (!this.autoInstallOnAppQuit) {
                this._logger.info("Update will not be installed on quit because autoInstallOnAppQuit is set to false.");
                return;
            }
            if (exitCode !== 0) {
                this._logger.info(`Update will be not installed on quit because application is quitting with exit code ${exitCode}`);
                return;
            }
            this._logger.info("Auto install update on quit");
            this.install(true, false);
        });
    }
    wrapSudo() {
        const { name } = this.app;
        const installComment = `"${name} would like to update"`;
        const sudo = this.spawnSyncLog("which gksudo || which kdesudo || which pkexec || which beesu");
        const command = [sudo];
        if (/kdesudo/i.test(sudo)) {
            command.push("--comment", installComment);
            command.push("-c");
        }
        else if (/gksudo/i.test(sudo)) {
            command.push("--message", installComment);
        }
        else if (/pkexec/i.test(sudo)) {
            command.push("--disable-internal-agent");
        }
        return command.join(" ");
    }
    spawnSyncLog(cmd, args = [], env = {}) {
        this._logger.info(`Executing: ${cmd} with args: ${args}`);
        const response = (0, child_process_1.spawnSync)(cmd, args, {
            env: { ...({"NODE_ENV":"production"}), ...env },
            encoding: "utf-8",
            shell: true,
        });
        return response.stdout.trim();
    }
    /**
     * This handles both node 8 and node 10 way of emitting error when spawning a process
     *   - node 8: Throws the error
     *   - node 10: Emit the error(Need to listen with on)
     */
    // https://github.com/electron-userland/electron-builder/issues/1129
    // Node 8 sends errors: https://nodejs.org/dist/latest-v8.x/docs/api/errors.html#errors_common_system_errors
    async spawnLog(cmd, args = [], env = undefined, stdio = "ignore") {
        this._logger.info(`Executing: ${cmd} with args: ${args}`);
        return new Promise((resolve, reject) => {
            try {
                const params = { stdio, env, detached: true };
                const p = (0, child_process_1.spawn)(cmd, args, params);
                p.on("error", error => {
                    reject(error);
                });
                p.unref();
                if (p.pid !== undefined) {
                    resolve(true);
                }
            }
            catch (error) {
                reject(error);
            }
        });
    }
}
exports.BaseUpdater = BaseUpdater;
//# sourceMappingURL=BaseUpdater.js.map

/***/ }),

/***/ 3378:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.DebUpdater = void 0;
const BaseUpdater_1 = __webpack_require__(9322);
const main_1 = __webpack_require__(5879);
const Provider_1 = __webpack_require__(5776);
class DebUpdater extends BaseUpdater_1.BaseUpdater {
    constructor(options, app) {
        super(options, app);
    }
    /*** @private */
    doDownloadUpdate(downloadUpdateOptions) {
        const provider = downloadUpdateOptions.updateInfoAndProvider.provider;
        const fileInfo = (0, Provider_1.findFile)(provider.resolveFiles(downloadUpdateOptions.updateInfoAndProvider.info), "deb", ["AppImage", "rpm"]);
        return this.executeDownload({
            fileExtension: "deb",
            fileInfo,
            downloadUpdateOptions,
            task: async (updateFile, downloadOptions) => {
                if (this.listenerCount(main_1.DOWNLOAD_PROGRESS) > 0) {
                    downloadOptions.onProgress = it => this.emit(main_1.DOWNLOAD_PROGRESS, it);
                }
                await this.httpExecutor.download(fileInfo.url, updateFile, downloadOptions);
            },
        });
    }
    doInstall(options) {
        const sudo = this.wrapSudo();
        // pkexec doesn't want the command to be wrapped in " quotes
        const wrapper = /pkexec/i.test(sudo) ? "" : `"`;
        const cmd = ["dpkg", "-i", options.installerPath, "||", "apt-get", "install", "-f", "-y"];
        this.spawnSyncLog(sudo, [`${wrapper}/bin/bash`, "-c", `'${cmd.join(" ")}'${wrapper}`]);
        if (options.isForceRunAfter) {
            this.app.relaunch();
        }
        return true;
    }
}
exports.DebUpdater = DebUpdater;
//# sourceMappingURL=DebUpdater.js.map

/***/ }),

/***/ 2474:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.createTempUpdateFile = exports.DownloadedUpdateHelper = void 0;
const crypto_1 = __webpack_require__(6982);
const fs_1 = __webpack_require__(9896);
// @ts-ignore
const isEqual = __webpack_require__(8142);
const fs_extra_1 = __webpack_require__(8799);
const path = __webpack_require__(6928);
/** @private **/
class DownloadedUpdateHelper {
    constructor(cacheDir) {
        this.cacheDir = cacheDir;
        this._file = null;
        this._packageFile = null;
        this.versionInfo = null;
        this.fileInfo = null;
        this._downloadedFileInfo = null;
    }
    get downloadedFileInfo() {
        return this._downloadedFileInfo;
    }
    get file() {
        return this._file;
    }
    get packageFile() {
        return this._packageFile;
    }
    get cacheDirForPendingUpdate() {
        return path.join(this.cacheDir, "pending");
    }
    async validateDownloadedPath(updateFile, updateInfo, fileInfo, logger) {
        if (this.versionInfo != null && this.file === updateFile && this.fileInfo != null) {
            // update has already been downloaded from this running instance
            // check here only existence, not checksum
            if (isEqual(this.versionInfo, updateInfo) && isEqual(this.fileInfo.info, fileInfo.info) && (await (0, fs_extra_1.pathExists)(updateFile))) {
                return updateFile;
            }
            else {
                return null;
            }
        }
        // update has already been downloaded from some previous app launch
        const cachedUpdateFile = await this.getValidCachedUpdateFile(fileInfo, logger);
        if (cachedUpdateFile === null) {
            return null;
        }
        logger.info(`Update has already been downloaded to ${updateFile}).`);
        this._file = cachedUpdateFile;
        return cachedUpdateFile;
    }
    async setDownloadedFile(downloadedFile, packageFile, versionInfo, fileInfo, updateFileName, isSaveCache) {
        this._file = downloadedFile;
        this._packageFile = packageFile;
        this.versionInfo = versionInfo;
        this.fileInfo = fileInfo;
        this._downloadedFileInfo = {
            fileName: updateFileName,
            sha512: fileInfo.info.sha512,
            isAdminRightsRequired: fileInfo.info.isAdminRightsRequired === true,
        };
        if (isSaveCache) {
            await (0, fs_extra_1.outputJson)(this.getUpdateInfoFile(), this._downloadedFileInfo);
        }
    }
    async clear() {
        this._file = null;
        this._packageFile = null;
        this.versionInfo = null;
        this.fileInfo = null;
        await this.cleanCacheDirForPendingUpdate();
    }
    async cleanCacheDirForPendingUpdate() {
        try {
            // remove stale data
            await (0, fs_extra_1.emptyDir)(this.cacheDirForPendingUpdate);
        }
        catch (ignore) {
            // ignore
        }
    }
    /**
     * Returns "update-info.json" which is created in the update cache directory's "pending" subfolder after the first update is downloaded.  If the update file does not exist then the cache is cleared and recreated.  If the update file exists then its properties are validated.
     * @param fileInfo
     * @param logger
     */
    async getValidCachedUpdateFile(fileInfo, logger) {
        var _a;
        const updateInfoFilePath = this.getUpdateInfoFile();
        const doesUpdateInfoFileExist = await (0, fs_extra_1.pathExists)(updateInfoFilePath);
        if (!doesUpdateInfoFileExist) {
            return null;
        }
        let cachedInfo;
        try {
            cachedInfo = await (0, fs_extra_1.readJson)(updateInfoFilePath);
        }
        catch (error) {
            let message = `No cached update info available`;
            if (error.code !== "ENOENT") {
                await this.cleanCacheDirForPendingUpdate();
                message += ` (error on read: ${error.message})`;
            }
            logger.info(message);
            return null;
        }
        const isCachedInfoFileNameValid = (_a = (cachedInfo === null || cachedInfo === void 0 ? void 0 : cachedInfo.fileName) !== null) !== null && _a !== void 0 ? _a : false;
        if (!isCachedInfoFileNameValid) {
            logger.warn(`Cached update info is corrupted: no fileName, directory for cached update will be cleaned`);
            await this.cleanCacheDirForPendingUpdate();
            return null;
        }
        if (fileInfo.info.sha512 !== cachedInfo.sha512) {
            logger.info(`Cached update sha512 checksum doesn't match the latest available update. New update must be downloaded. Cached: ${cachedInfo.sha512}, expected: ${fileInfo.info.sha512}. Directory for cached update will be cleaned`);
            await this.cleanCacheDirForPendingUpdate();
            return null;
        }
        const updateFile = path.join(this.cacheDirForPendingUpdate, cachedInfo.fileName);
        if (!(await (0, fs_extra_1.pathExists)(updateFile))) {
            logger.info("Cached update file doesn't exist");
            return null;
        }
        const sha512 = await hashFile(updateFile);
        if (fileInfo.info.sha512 !== sha512) {
            logger.warn(`Sha512 checksum doesn't match the latest available update. New update must be downloaded. Cached: ${sha512}, expected: ${fileInfo.info.sha512}`);
            await this.cleanCacheDirForPendingUpdate();
            return null;
        }
        this._downloadedFileInfo = cachedInfo;
        return updateFile;
    }
    getUpdateInfoFile() {
        return path.join(this.cacheDirForPendingUpdate, "update-info.json");
    }
}
exports.DownloadedUpdateHelper = DownloadedUpdateHelper;
function hashFile(file, algorithm = "sha512", encoding = "base64", options) {
    return new Promise((resolve, reject) => {
        const hash = (0, crypto_1.createHash)(algorithm);
        hash.on("error", reject).setEncoding(encoding);
        (0, fs_1.createReadStream)(file, { ...options, highWaterMark: 1024 * 1024 /* better to use more memory but hash faster */ })
            .on("error", reject)
            .on("end", () => {
            hash.end();
            resolve(hash.read());
        })
            .pipe(hash, { end: false });
    });
}
async function createTempUpdateFile(name, cacheDir, log) {
    // https://github.com/electron-userland/electron-builder/pull/2474#issuecomment-366481912
    let nameCounter = 0;
    let result = path.join(cacheDir, name);
    for (let i = 0; i < 3; i++) {
        try {
            await (0, fs_extra_1.unlink)(result);
            return result;
        }
        catch (e) {
            if (e.code === "ENOENT") {
                return result;
            }
            log.warn(`Error on remove temp update file: ${e}`);
            result = path.join(cacheDir, `${nameCounter++}-${name}`);
        }
    }
    return result;
}
exports.createTempUpdateFile = createTempUpdateFile;
//# sourceMappingURL=DownloadedUpdateHelper.js.map

/***/ }),

/***/ 910:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ElectronAppAdapter = void 0;
const path = __webpack_require__(6928);
const AppAdapter_1 = __webpack_require__(6176);
class ElectronAppAdapter {
    constructor(app = (__webpack_require__(4157).app)) {
        this.app = app;
    }
    whenReady() {
        return this.app.whenReady();
    }
    get version() {
        return this.app.getVersion();
    }
    get name() {
        return this.app.getName();
    }
    get isPackaged() {
        return this.app.isPackaged === true;
    }
    get appUpdateConfigPath() {
        return this.isPackaged ? path.join(process.resourcesPath, "app-update.yml") : path.join(this.app.getAppPath(), "dev-app-update.yml");
    }
    get userDataPath() {
        return this.app.getPath("userData");
    }
    get baseCachePath() {
        return (0, AppAdapter_1.getAppCacheDir)();
    }
    quit() {
        this.app.quit();
    }
    relaunch() {
        this.app.relaunch();
    }
    onQuit(handler) {
        this.app.once("quit", (_, exitCode) => handler(exitCode));
    }
}
exports.ElectronAppAdapter = ElectronAppAdapter;
//# sourceMappingURL=ElectronAppAdapter.js.map

/***/ }),

/***/ 2658:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.MacUpdater = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const fs_extra_1 = __webpack_require__(8799);
const fs_1 = __webpack_require__(9896);
const http_1 = __webpack_require__(8611);
const AppUpdater_1 = __webpack_require__(4718);
const Provider_1 = __webpack_require__(5776);
const child_process_1 = __webpack_require__(5317);
const crypto_1 = __webpack_require__(6982);
class MacUpdater extends AppUpdater_1.AppUpdater {
    constructor(options, app) {
        super(options, app);
        this.nativeUpdater = (__webpack_require__(4157).autoUpdater);
        this.squirrelDownloadedUpdate = false;
        this.nativeUpdater.on("error", it => {
            this._logger.warn(it);
            this.emit("error", it);
        });
        this.nativeUpdater.on("update-downloaded", () => {
            this.squirrelDownloadedUpdate = true;
        });
    }
    debug(message) {
        if (this._logger.debug != null) {
            this._logger.debug(message);
        }
    }
    async doDownloadUpdate(downloadUpdateOptions) {
        let files = downloadUpdateOptions.updateInfoAndProvider.provider.resolveFiles(downloadUpdateOptions.updateInfoAndProvider.info);
        const log = this._logger;
        // detect if we are running inside Rosetta emulation
        const sysctlRosettaInfoKey = "sysctl.proc_translated";
        let isRosetta = false;
        try {
            this.debug("Checking for macOS Rosetta environment");
            const result = (0, child_process_1.execFileSync)("sysctl", [sysctlRosettaInfoKey], { encoding: "utf8" });
            isRosetta = result.includes(`${sysctlRosettaInfoKey}: 1`);
            log.info(`Checked for macOS Rosetta environment (isRosetta=${isRosetta})`);
        }
        catch (e) {
            log.warn(`sysctl shell command to check for macOS Rosetta environment failed: ${e}`);
        }
        let isArm64Mac = false;
        try {
            this.debug("Checking for arm64 in uname");
            const result = (0, child_process_1.execFileSync)("uname", ["-a"], { encoding: "utf8" });
            const isArm = result.includes("ARM");
            log.info(`Checked 'uname -a': arm64=${isArm}`);
            isArm64Mac = isArm64Mac || isArm;
        }
        catch (e) {
            log.warn(`uname shell command to check for arm64 failed: ${e}`);
        }
        isArm64Mac = isArm64Mac || process.arch === "arm64" || isRosetta;
        // allow arm64 macs to install universal or rosetta2(x64) - https://github.com/electron-userland/electron-builder/pull/5524
        const isArm64 = (file) => { var _a; return file.url.pathname.includes("arm64") || ((_a = file.info.url) === null || _a === void 0 ? void 0 : _a.includes("arm64")); };
        if (isArm64Mac && files.some(isArm64)) {
            files = files.filter(file => isArm64Mac === isArm64(file));
        }
        else {
            files = files.filter(file => !isArm64(file));
        }
        const zipFileInfo = (0, Provider_1.findFile)(files, "zip", ["pkg", "dmg"]);
        if (zipFileInfo == null) {
            throw (0, builder_util_runtime_1.newError)(`ZIP file not provided: ${(0, builder_util_runtime_1.safeStringifyJson)(files)}`, "ERR_UPDATER_ZIP_FILE_NOT_FOUND");
        }
        return this.executeDownload({
            fileExtension: "zip",
            fileInfo: zipFileInfo,
            downloadUpdateOptions,
            task: (destinationFile, downloadOptions) => {
                return this.httpExecutor.download(zipFileInfo.url, destinationFile, downloadOptions);
            },
            done: event => this.updateDownloaded(zipFileInfo, event),
        });
    }
    async updateDownloaded(zipFileInfo, event) {
        var _a, _b;
        const downloadedFile = event.downloadedFile;
        const updateFileSize = (_a = zipFileInfo.info.size) !== null && _a !== void 0 ? _a : (await (0, fs_extra_1.stat)(downloadedFile)).size;
        const log = this._logger;
        const logContext = `fileToProxy=${zipFileInfo.url.href}`;
        this.debug(`Creating proxy server for native Squirrel.Mac (${logContext})`);
        (_b = this.server) === null || _b === void 0 ? void 0 : _b.close();
        this.server = (0, http_1.createServer)();
        this.debug(`Proxy server for native Squirrel.Mac is created (${logContext})`);
        this.server.on("close", () => {
            log.info(`Proxy server for native Squirrel.Mac is closed (${logContext})`);
        });
        // must be called after server is listening, otherwise address is null
        const getServerUrl = (s) => {
            const address = s.address();
            if (typeof address === "string") {
                return address;
            }
            return `http://127.0.0.1:${address === null || address === void 0 ? void 0 : address.port}`;
        };
        return await new Promise((resolve, reject) => {
            const pass = (0, crypto_1.randomBytes)(64).toString("base64").replace(/\//g, "_").replace(/\+/g, "-");
            const authInfo = Buffer.from(`autoupdater:${pass}`, "ascii");
            // insecure random is ok
            const fileUrl = `/${(0, crypto_1.randomBytes)(64).toString("hex")}.zip`;
            this.server.on("request", (request, response) => {
                const requestUrl = request.url;
                log.info(`${requestUrl} requested`);
                if (requestUrl === "/") {
                    // check for basic auth header
                    if (!request.headers.authorization || request.headers.authorization.indexOf("Basic ") === -1) {
                        response.statusCode = 401;
                        response.statusMessage = "Invalid Authentication Credentials";
                        response.end();
                        log.warn("No authenthication info");
                        return;
                    }
                    // verify auth credentials
                    const base64Credentials = request.headers.authorization.split(" ")[1];
                    const credentials = Buffer.from(base64Credentials, "base64").toString("ascii");
                    const [username, password] = credentials.split(":");
                    if (username !== "autoupdater" || password !== pass) {
                        response.statusCode = 401;
                        response.statusMessage = "Invalid Authentication Credentials";
                        response.end();
                        log.warn("Invalid authenthication credentials");
                        return;
                    }
                    const data = Buffer.from(`{ "url": "${getServerUrl(this.server)}${fileUrl}" }`);
                    response.writeHead(200, { "Content-Type": "application/json", "Content-Length": data.length });
                    response.end(data);
                    return;
                }
                if (!requestUrl.startsWith(fileUrl)) {
                    log.warn(`${requestUrl} requested, but not supported`);
                    response.writeHead(404);
                    response.end();
                    return;
                }
                log.info(`${fileUrl} requested by Squirrel.Mac, pipe ${downloadedFile}`);
                let errorOccurred = false;
                response.on("finish", () => {
                    if (!errorOccurred) {
                        this.nativeUpdater.removeListener("error", reject);
                        resolve([]);
                    }
                });
                const readStream = (0, fs_1.createReadStream)(downloadedFile);
                readStream.on("error", error => {
                    try {
                        response.end();
                    }
                    catch (e) {
                        log.warn(`cannot end response: ${e}`);
                    }
                    errorOccurred = true;
                    this.nativeUpdater.removeListener("error", reject);
                    reject(new Error(`Cannot pipe "${downloadedFile}": ${error}`));
                });
                response.writeHead(200, {
                    "Content-Type": "application/zip",
                    "Content-Length": updateFileSize,
                });
                readStream.pipe(response);
            });
            this.debug(`Proxy server for native Squirrel.Mac is starting to listen (${logContext})`);
            this.server.listen(0, "127.0.0.1", () => {
                this.debug(`Proxy server for native Squirrel.Mac is listening (address=${getServerUrl(this.server)}, ${logContext})`);
                this.nativeUpdater.setFeedURL({
                    url: getServerUrl(this.server),
                    headers: {
                        "Cache-Control": "no-cache",
                        Authorization: `Basic ${authInfo.toString("base64")}`,
                    },
                });
                // The update has been downloaded and is ready to be served to Squirrel
                this.dispatchUpdateDownloaded(event);
                if (this.autoInstallOnAppQuit) {
                    this.nativeUpdater.once("error", reject);
                    // This will trigger fetching and installing the file on Squirrel side
                    this.nativeUpdater.checkForUpdates();
                }
                else {
                    resolve([]);
                }
            });
        });
    }
    quitAndInstall() {
        var _a;
        if (this.squirrelDownloadedUpdate) {
            // update already fetched by Squirrel, it's ready to install
            this.nativeUpdater.quitAndInstall();
            (_a = this.server) === null || _a === void 0 ? void 0 : _a.close();
        }
        else {
            // Quit and install as soon as Squirrel get the update
            this.nativeUpdater.on("update-downloaded", () => {
                var _a;
                this.nativeUpdater.quitAndInstall();
                (_a = this.server) === null || _a === void 0 ? void 0 : _a.close();
            });
            if (!this.autoInstallOnAppQuit) {
                /**
                 * If this was not `true` previously then MacUpdater.doDownloadUpdate()
                 * would not actually initiate the downloading by electron's autoUpdater
                 */
                this.nativeUpdater.checkForUpdates();
            }
        }
    }
}
exports.MacUpdater = MacUpdater;
//# sourceMappingURL=MacUpdater.js.map

/***/ }),

/***/ 776:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.NsisUpdater = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const path = __webpack_require__(6928);
const BaseUpdater_1 = __webpack_require__(9322);
const FileWithEmbeddedBlockMapDifferentialDownloader_1 = __webpack_require__(1972);
const GenericDifferentialDownloader_1 = __webpack_require__(2444);
const main_1 = __webpack_require__(5879);
const util_1 = __webpack_require__(906);
const Provider_1 = __webpack_require__(5776);
const fs_extra_1 = __webpack_require__(8799);
const windowsExecutableCodeSignatureVerifier_1 = __webpack_require__(6578);
const url_1 = __webpack_require__(7016);
const zlib_1 = __webpack_require__(3106);
class NsisUpdater extends BaseUpdater_1.BaseUpdater {
    constructor(options, app) {
        super(options, app);
        this._verifyUpdateCodeSignature = (publisherNames, unescapedTempUpdateFile) => (0, windowsExecutableCodeSignatureVerifier_1.verifySignature)(publisherNames, unescapedTempUpdateFile, this._logger);
    }
    /**
     * The verifyUpdateCodeSignature. You can pass [win-verify-signature](https://github.com/beyondkmp/win-verify-trust) or another custom verify function: ` (publisherName: string[], path: string) => Promise<string | null>`.
     * The default verify function uses [windowsExecutableCodeSignatureVerifier](https://github.com/electron-userland/electron-builder/blob/master/packages/electron-updater/src/windowsExecutableCodeSignatureVerifier.ts)
     */
    get verifyUpdateCodeSignature() {
        return this._verifyUpdateCodeSignature;
    }
    set verifyUpdateCodeSignature(value) {
        if (value) {
            this._verifyUpdateCodeSignature = value;
        }
    }
    /*** @private */
    doDownloadUpdate(downloadUpdateOptions) {
        const provider = downloadUpdateOptions.updateInfoAndProvider.provider;
        const fileInfo = (0, Provider_1.findFile)(provider.resolveFiles(downloadUpdateOptions.updateInfoAndProvider.info), "exe");
        return this.executeDownload({
            fileExtension: "exe",
            downloadUpdateOptions,
            fileInfo,
            task: async (destinationFile, downloadOptions, packageFile, removeTempDirIfAny) => {
                const packageInfo = fileInfo.packageInfo;
                const isWebInstaller = packageInfo != null && packageFile != null;
                if (isWebInstaller && downloadUpdateOptions.disableWebInstaller) {
                    throw (0, builder_util_runtime_1.newError)(`Unable to download new version ${downloadUpdateOptions.updateInfoAndProvider.info.version}. Web Installers are disabled`, "ERR_UPDATER_WEB_INSTALLER_DISABLED");
                }
                if (!isWebInstaller && !downloadUpdateOptions.disableWebInstaller) {
                    this._logger.warn("disableWebInstaller is set to false, you should set it to true if you do not plan on using a web installer. This will default to true in a future version.");
                }
                if (isWebInstaller ||
                    downloadUpdateOptions.disableDifferentialDownload ||
                    (await this.differentialDownloadInstaller(fileInfo, downloadUpdateOptions, destinationFile, provider))) {
                    await this.httpExecutor.download(fileInfo.url, destinationFile, downloadOptions);
                }
                const signatureVerificationStatus = await this.verifySignature(destinationFile);
                if (signatureVerificationStatus != null) {
                    await removeTempDirIfAny();
                    // noinspection ThrowInsideFinallyBlockJS
                    throw (0, builder_util_runtime_1.newError)(`New version ${downloadUpdateOptions.updateInfoAndProvider.info.version} is not signed by the application owner: ${signatureVerificationStatus}`, "ERR_UPDATER_INVALID_SIGNATURE");
                }
                if (isWebInstaller) {
                    if (await this.differentialDownloadWebPackage(downloadUpdateOptions, packageInfo, packageFile, provider)) {
                        try {
                            await this.httpExecutor.download(new url_1.URL(packageInfo.path), packageFile, {
                                headers: downloadUpdateOptions.requestHeaders,
                                cancellationToken: downloadUpdateOptions.cancellationToken,
                                sha512: packageInfo.sha512,
                            });
                        }
                        catch (e) {
                            try {
                                await (0, fs_extra_1.unlink)(packageFile);
                            }
                            catch (ignored) {
                                // ignore
                            }
                            throw e;
                        }
                    }
                }
            },
        });
    }
    // $certificateInfo = (Get-AuthenticodeSignature 'xxx\yyy.exe'
    // | where {$_.Status.Equals([System.Management.Automation.SignatureStatus]::Valid) -and $_.SignerCertificate.Subject.Contains("CN=siemens.com")})
    // | Out-String ; if ($certificateInfo) { exit 0 } else { exit 1 }
    async verifySignature(tempUpdateFile) {
        let publisherName;
        try {
            publisherName = (await this.configOnDisk.value).publisherName;
            if (publisherName == null) {
                return null;
            }
        }
        catch (e) {
            if (e.code === "ENOENT") {
                // no app-update.yml
                return null;
            }
            throw e;
        }
        return await this._verifyUpdateCodeSignature(Array.isArray(publisherName) ? publisherName : [publisherName], tempUpdateFile);
    }
    doInstall(options) {
        const args = ["--updated"];
        if (options.isSilent) {
            args.push("/S");
        }
        if (options.isForceRunAfter) {
            args.push("--force-run");
        }
        if (this.installDirectory) {
            // maybe check if folder exists
            args.push(`/D=${this.installDirectory}`);
        }
        const packagePath = this.downloadedUpdateHelper == null ? null : this.downloadedUpdateHelper.packageFile;
        if (packagePath != null) {
            // only = form is supported
            args.push(`--package-file=${packagePath}`);
        }
        const callUsingElevation = () => {
            this.spawnLog(path.join(process.resourcesPath, "elevate.exe"), [options.installerPath].concat(args)).catch(e => this.dispatchError(e));
        };
        if (options.isAdminRightsRequired) {
            this._logger.info("isAdminRightsRequired is set to true, run installer using elevate.exe");
            callUsingElevation();
            return true;
        }
        this.spawnLog(options.installerPath, args).catch((e) => {
            // https://github.com/electron-userland/electron-builder/issues/1129
            // Node 8 sends errors: https://nodejs.org/dist/latest-v8.x/docs/api/errors.html#errors_common_system_errors
            const errorCode = e.code;
            this._logger.info(`Cannot run installer: error code: ${errorCode}, error message: "${e.message}", will be executed again using elevate if EACCES, and will try to use electron.shell.openItem if ENOENT`);
            if (errorCode === "UNKNOWN" || errorCode === "EACCES") {
                callUsingElevation();
            }
            else if (errorCode === "ENOENT") {
                (__webpack_require__(4157).shell).openPath(options.installerPath)
                    .catch((err) => this.dispatchError(err));
            }
            else {
                this.dispatchError(e);
            }
        });
        return true;
    }
    async differentialDownloadInstaller(fileInfo, downloadUpdateOptions, installerPath, provider) {
        try {
            if (this._testOnlyOptions != null && !this._testOnlyOptions.isUseDifferentialDownload) {
                return true;
            }
            const blockmapFileUrls = (0, util_1.blockmapFiles)(fileInfo.url, this.app.version, downloadUpdateOptions.updateInfoAndProvider.info.version);
            this._logger.info(`Download block maps (old: "${blockmapFileUrls[0]}", new: ${blockmapFileUrls[1]})`);
            const downloadBlockMap = async (url) => {
                const data = await this.httpExecutor.downloadToBuffer(url, {
                    headers: downloadUpdateOptions.requestHeaders,
                    cancellationToken: downloadUpdateOptions.cancellationToken,
                });
                if (data == null || data.length === 0) {
                    throw new Error(`Blockmap "${url.href}" is empty`);
                }
                try {
                    return JSON.parse((0, zlib_1.gunzipSync)(data).toString());
                }
                catch (e) {
                    throw new Error(`Cannot parse blockmap "${url.href}", error: ${e}`);
                }
            };
            const downloadOptions = {
                newUrl: fileInfo.url,
                oldFile: path.join(this.downloadedUpdateHelper.cacheDir, builder_util_runtime_1.CURRENT_APP_INSTALLER_FILE_NAME),
                logger: this._logger,
                newFile: installerPath,
                isUseMultipleRangeRequest: provider.isUseMultipleRangeRequest,
                requestHeaders: downloadUpdateOptions.requestHeaders,
                cancellationToken: downloadUpdateOptions.cancellationToken,
            };
            if (this.listenerCount(main_1.DOWNLOAD_PROGRESS) > 0) {
                downloadOptions.onProgress = it => this.emit(main_1.DOWNLOAD_PROGRESS, it);
            }
            const blockMapDataList = await Promise.all(blockmapFileUrls.map(u => downloadBlockMap(u)));
            await new GenericDifferentialDownloader_1.GenericDifferentialDownloader(fileInfo.info, this.httpExecutor, downloadOptions).download(blockMapDataList[0], blockMapDataList[1]);
            return false;
        }
        catch (e) {
            this._logger.error(`Cannot download differentially, fallback to full download: ${e.stack || e}`);
            if (this._testOnlyOptions != null) {
                // test mode
                throw e;
            }
            return true;
        }
    }
    async differentialDownloadWebPackage(downloadUpdateOptions, packageInfo, packagePath, provider) {
        if (packageInfo.blockMapSize == null) {
            return true;
        }
        try {
            const downloadOptions = {
                newUrl: new url_1.URL(packageInfo.path),
                oldFile: path.join(this.downloadedUpdateHelper.cacheDir, builder_util_runtime_1.CURRENT_APP_PACKAGE_FILE_NAME),
                logger: this._logger,
                newFile: packagePath,
                requestHeaders: this.requestHeaders,
                isUseMultipleRangeRequest: provider.isUseMultipleRangeRequest,
                cancellationToken: downloadUpdateOptions.cancellationToken,
            };
            if (this.listenerCount(main_1.DOWNLOAD_PROGRESS) > 0) {
                downloadOptions.onProgress = it => this.emit(main_1.DOWNLOAD_PROGRESS, it);
            }
            await new FileWithEmbeddedBlockMapDifferentialDownloader_1.FileWithEmbeddedBlockMapDifferentialDownloader(packageInfo, this.httpExecutor, downloadOptions).download();
        }
        catch (e) {
            this._logger.error(`Cannot download differentially, fallback to full download: ${e.stack || e}`);
            // during test (developer machine mac or linux) we must throw error
            return process.platform === "win32";
        }
        return false;
    }
}
exports.NsisUpdater = NsisUpdater;
//# sourceMappingURL=NsisUpdater.js.map

/***/ }),

/***/ 3916:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.RpmUpdater = void 0;
const BaseUpdater_1 = __webpack_require__(9322);
const main_1 = __webpack_require__(5879);
const Provider_1 = __webpack_require__(5776);
class RpmUpdater extends BaseUpdater_1.BaseUpdater {
    constructor(options, app) {
        super(options, app);
    }
    /*** @private */
    doDownloadUpdate(downloadUpdateOptions) {
        const provider = downloadUpdateOptions.updateInfoAndProvider.provider;
        const fileInfo = (0, Provider_1.findFile)(provider.resolveFiles(downloadUpdateOptions.updateInfoAndProvider.info), "rpm", ["AppImage", "deb"]);
        return this.executeDownload({
            fileExtension: "rpm",
            fileInfo,
            downloadUpdateOptions,
            task: async (updateFile, downloadOptions) => {
                if (this.listenerCount(main_1.DOWNLOAD_PROGRESS) > 0) {
                    downloadOptions.onProgress = it => this.emit(main_1.DOWNLOAD_PROGRESS, it);
                }
                await this.httpExecutor.download(fileInfo.url, updateFile, downloadOptions);
            },
        });
    }
    doInstall(options) {
        const upgradePath = options.installerPath;
        const sudo = this.wrapSudo();
        // pkexec doesn't want the command to be wrapped in " quotes
        const wrapper = /pkexec/i.test(sudo) ? "" : `"`;
        const packageManager = this.spawnSyncLog("which zypper");
        let cmd;
        if (!packageManager) {
            const packageManager = this.spawnSyncLog("which dnf || which yum");
            cmd = [packageManager, "-y", "remove", `'${this.app.name}'`, ";", packageManager, "-y", "install", upgradePath];
        }
        else {
            cmd = [
                packageManager,
                "remove",
                "-y",
                `'${this.app.name}'`,
                ";",
                packageManager,
                "clean",
                "--all",
                ";",
                packageManager,
                "--no-refresh",
                "install",
                "--allow-unsigned-rpm",
                "-y",
                "-f",
                upgradePath,
            ];
        }
        this.spawnSyncLog(sudo, [`${wrapper}/bin/bash`, "-c", `'${cmd.join(" ")}'${wrapper}`]);
        if (options.isForceRunAfter) {
            this.app.relaunch();
        }
        return true;
    }
}
exports.RpmUpdater = RpmUpdater;
//# sourceMappingURL=RpmUpdater.js.map

/***/ }),

/***/ 2652:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.DataSplitter = exports.copyData = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const fs_1 = __webpack_require__(9896);
const stream_1 = __webpack_require__(2203);
const downloadPlanBuilder_1 = __webpack_require__(1305);
const DOUBLE_CRLF = Buffer.from("\r\n\r\n");
var ReadState;
(function (ReadState) {
    ReadState[ReadState["INIT"] = 0] = "INIT";
    ReadState[ReadState["HEADER"] = 1] = "HEADER";
    ReadState[ReadState["BODY"] = 2] = "BODY";
})(ReadState || (ReadState = {}));
function copyData(task, out, oldFileFd, reject, resolve) {
    const readStream = (0, fs_1.createReadStream)("", {
        fd: oldFileFd,
        autoClose: false,
        start: task.start,
        // end is inclusive
        end: task.end - 1,
    });
    readStream.on("error", reject);
    readStream.once("end", resolve);
    readStream.pipe(out, {
        end: false,
    });
}
exports.copyData = copyData;
class DataSplitter extends stream_1.Writable {
    constructor(out, options, partIndexToTaskIndex, boundary, partIndexToLength, finishHandler) {
        super();
        this.out = out;
        this.options = options;
        this.partIndexToTaskIndex = partIndexToTaskIndex;
        this.partIndexToLength = partIndexToLength;
        this.finishHandler = finishHandler;
        this.partIndex = -1;
        this.headerListBuffer = null;
        this.readState = ReadState.INIT;
        this.ignoreByteCount = 0;
        this.remainingPartDataCount = 0;
        this.actualPartLength = 0;
        this.boundaryLength = boundary.length + 4; /* size of \r\n-- */
        // first chunk doesn't start with \r\n
        this.ignoreByteCount = this.boundaryLength - 2;
    }
    get isFinished() {
        return this.partIndex === this.partIndexToLength.length;
    }
    // noinspection JSUnusedGlobalSymbols
    _write(data, encoding, callback) {
        if (this.isFinished) {
            console.error(`Trailing ignored data: ${data.length} bytes`);
            return;
        }
        this.handleData(data).then(callback).catch(callback);
    }
    async handleData(chunk) {
        let start = 0;
        if (this.ignoreByteCount !== 0 && this.remainingPartDataCount !== 0) {
            throw (0, builder_util_runtime_1.newError)("Internal error", "ERR_DATA_SPLITTER_BYTE_COUNT_MISMATCH");
        }
        if (this.ignoreByteCount > 0) {
            const toIgnore = Math.min(this.ignoreByteCount, chunk.length);
            this.ignoreByteCount -= toIgnore;
            start = toIgnore;
        }
        else if (this.remainingPartDataCount > 0) {
            const toRead = Math.min(this.remainingPartDataCount, chunk.length);
            this.remainingPartDataCount -= toRead;
            await this.processPartData(chunk, 0, toRead);
            start = toRead;
        }
        if (start === chunk.length) {
            return;
        }
        if (this.readState === ReadState.HEADER) {
            const headerListEnd = this.searchHeaderListEnd(chunk, start);
            if (headerListEnd === -1) {
                return;
            }
            start = headerListEnd;
            this.readState = ReadState.BODY;
            // header list is ignored, we don't need it
            this.headerListBuffer = null;
        }
        while (true) {
            if (this.readState === ReadState.BODY) {
                this.readState = ReadState.INIT;
            }
            else {
                this.partIndex++;
                let taskIndex = this.partIndexToTaskIndex.get(this.partIndex);
                if (taskIndex == null) {
                    if (this.isFinished) {
                        taskIndex = this.options.end;
                    }
                    else {
                        throw (0, builder_util_runtime_1.newError)("taskIndex is null", "ERR_DATA_SPLITTER_TASK_INDEX_IS_NULL");
                    }
                }
                const prevTaskIndex = this.partIndex === 0 ? this.options.start : this.partIndexToTaskIndex.get(this.partIndex - 1) + 1; /* prev part is download, next maybe copy */
                if (prevTaskIndex < taskIndex) {
                    await this.copyExistingData(prevTaskIndex, taskIndex);
                }
                else if (prevTaskIndex > taskIndex) {
                    throw (0, builder_util_runtime_1.newError)("prevTaskIndex must be < taskIndex", "ERR_DATA_SPLITTER_TASK_INDEX_ASSERT_FAILED");
                }
                if (this.isFinished) {
                    this.onPartEnd();
                    this.finishHandler();
                    return;
                }
                start = this.searchHeaderListEnd(chunk, start);
                if (start === -1) {
                    this.readState = ReadState.HEADER;
                    return;
                }
            }
            const partLength = this.partIndexToLength[this.partIndex];
            const end = start + partLength;
            const effectiveEnd = Math.min(end, chunk.length);
            await this.processPartStarted(chunk, start, effectiveEnd);
            this.remainingPartDataCount = partLength - (effectiveEnd - start);
            if (this.remainingPartDataCount > 0) {
                return;
            }
            start = end + this.boundaryLength;
            if (start >= chunk.length) {
                this.ignoreByteCount = this.boundaryLength - (chunk.length - end);
                return;
            }
        }
    }
    copyExistingData(index, end) {
        return new Promise((resolve, reject) => {
            const w = () => {
                if (index === end) {
                    resolve();
                    return;
                }
                const task = this.options.tasks[index];
                if (task.kind !== downloadPlanBuilder_1.OperationKind.COPY) {
                    reject(new Error("Task kind must be COPY"));
                    return;
                }
                copyData(task, this.out, this.options.oldFileFd, reject, () => {
                    index++;
                    w();
                });
            };
            w();
        });
    }
    searchHeaderListEnd(chunk, readOffset) {
        const headerListEnd = chunk.indexOf(DOUBLE_CRLF, readOffset);
        if (headerListEnd !== -1) {
            return headerListEnd + DOUBLE_CRLF.length;
        }
        // not all headers data were received, save to buffer
        const partialChunk = readOffset === 0 ? chunk : chunk.slice(readOffset);
        if (this.headerListBuffer == null) {
            this.headerListBuffer = partialChunk;
        }
        else {
            this.headerListBuffer = Buffer.concat([this.headerListBuffer, partialChunk]);
        }
        return -1;
    }
    onPartEnd() {
        const expectedLength = this.partIndexToLength[this.partIndex - 1];
        if (this.actualPartLength !== expectedLength) {
            throw (0, builder_util_runtime_1.newError)(`Expected length: ${expectedLength} differs from actual: ${this.actualPartLength}`, "ERR_DATA_SPLITTER_LENGTH_MISMATCH");
        }
        this.actualPartLength = 0;
    }
    processPartStarted(data, start, end) {
        if (this.partIndex !== 0) {
            this.onPartEnd();
        }
        return this.processPartData(data, start, end);
    }
    processPartData(data, start, end) {
        this.actualPartLength += end - start;
        const out = this.out;
        if (out.write(start === 0 && data.length === end ? data : data.slice(start, end))) {
            return Promise.resolve();
        }
        else {
            return new Promise((resolve, reject) => {
                out.on("error", reject);
                out.once("drain", () => {
                    out.removeListener("error", reject);
                    resolve();
                });
            });
        }
    }
}
exports.DataSplitter = DataSplitter;
//# sourceMappingURL=DataSplitter.js.map

/***/ }),

/***/ 9:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.DifferentialDownloader = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const fs_extra_1 = __webpack_require__(8799);
const fs_1 = __webpack_require__(9896);
const DataSplitter_1 = __webpack_require__(2652);
const url_1 = __webpack_require__(7016);
const downloadPlanBuilder_1 = __webpack_require__(1305);
const multipleRangeDownloader_1 = __webpack_require__(4405);
const ProgressDifferentialDownloadCallbackTransform_1 = __webpack_require__(9516);
class DifferentialDownloader {
    // noinspection TypeScriptAbstractClassConstructorCanBeMadeProtected
    constructor(blockAwareFileInfo, httpExecutor, options) {
        this.blockAwareFileInfo = blockAwareFileInfo;
        this.httpExecutor = httpExecutor;
        this.options = options;
        this.fileMetadataBuffer = null;
        this.logger = options.logger;
    }
    createRequestOptions() {
        const result = {
            headers: {
                ...this.options.requestHeaders,
                accept: "*/*",
            },
        };
        (0, builder_util_runtime_1.configureRequestUrl)(this.options.newUrl, result);
        // user-agent, cache-control and other common options
        (0, builder_util_runtime_1.configureRequestOptions)(result);
        return result;
    }
    doDownload(oldBlockMap, newBlockMap) {
        // we don't check other metadata like compressionMethod - generic check that it is make sense to differentially update is suitable for it
        if (oldBlockMap.version !== newBlockMap.version) {
            throw new Error(`version is different (${oldBlockMap.version} - ${newBlockMap.version}), full download is required`);
        }
        const logger = this.logger;
        const operations = (0, downloadPlanBuilder_1.computeOperations)(oldBlockMap, newBlockMap, logger);
        if (logger.debug != null) {
            logger.debug(JSON.stringify(operations, null, 2));
        }
        let downloadSize = 0;
        let copySize = 0;
        for (const operation of operations) {
            const length = operation.end - operation.start;
            if (operation.kind === downloadPlanBuilder_1.OperationKind.DOWNLOAD) {
                downloadSize += length;
            }
            else {
                copySize += length;
            }
        }
        const newSize = this.blockAwareFileInfo.size;
        if (downloadSize + copySize + (this.fileMetadataBuffer == null ? 0 : this.fileMetadataBuffer.length) !== newSize) {
            throw new Error(`Internal error, size mismatch: downloadSize: ${downloadSize}, copySize: ${copySize}, newSize: ${newSize}`);
        }
        logger.info(`Full: ${formatBytes(newSize)}, To download: ${formatBytes(downloadSize)} (${Math.round(downloadSize / (newSize / 100))}%)`);
        return this.downloadFile(operations);
    }
    downloadFile(tasks) {
        const fdList = [];
        const closeFiles = () => {
            return Promise.all(fdList.map(openedFile => {
                return (0, fs_extra_1.close)(openedFile.descriptor).catch((e) => {
                    this.logger.error(`cannot close file "${openedFile.path}": ${e}`);
                });
            }));
        };
        return this.doDownloadFile(tasks, fdList)
            .then(closeFiles)
            .catch((e) => {
            // then must be after catch here (since then always throws error)
            return closeFiles()
                .catch(closeFilesError => {
                // closeFiles never throw error, but just to be sure
                try {
                    this.logger.error(`cannot close files: ${closeFilesError}`);
                }
                catch (errorOnLog) {
                    try {
                        console.error(errorOnLog);
                    }
                    catch (ignored) {
                        // ok, give up and ignore error
                    }
                }
                throw e;
            })
                .then(() => {
                throw e;
            });
        });
    }
    async doDownloadFile(tasks, fdList) {
        const oldFileFd = await (0, fs_extra_1.open)(this.options.oldFile, "r");
        fdList.push({ descriptor: oldFileFd, path: this.options.oldFile });
        const newFileFd = await (0, fs_extra_1.open)(this.options.newFile, "w");
        fdList.push({ descriptor: newFileFd, path: this.options.newFile });
        const fileOut = (0, fs_1.createWriteStream)(this.options.newFile, { fd: newFileFd });
        await new Promise((resolve, reject) => {
            const streams = [];
            // Create our download info transformer if we have one
            let downloadInfoTransform = undefined;
            if (!this.options.isUseMultipleRangeRequest && this.options.onProgress) {
                // TODO: Does not support multiple ranges (someone feel free to PR this!)
                const expectedByteCounts = [];
                let grandTotalBytes = 0;
                for (const task of tasks) {
                    if (task.kind === downloadPlanBuilder_1.OperationKind.DOWNLOAD) {
                        expectedByteCounts.push(task.end - task.start);
                        grandTotalBytes += task.end - task.start;
                    }
                }
                const progressDifferentialDownloadInfo = {
                    expectedByteCounts: expectedByteCounts,
                    grandTotal: grandTotalBytes,
                };
                downloadInfoTransform = new ProgressDifferentialDownloadCallbackTransform_1.ProgressDifferentialDownloadCallbackTransform(progressDifferentialDownloadInfo, this.options.cancellationToken, this.options.onProgress);
                streams.push(downloadInfoTransform);
            }
            const digestTransform = new builder_util_runtime_1.DigestTransform(this.blockAwareFileInfo.sha512);
            // to simply debug, do manual validation to allow file to be fully written
            digestTransform.isValidateOnEnd = false;
            streams.push(digestTransform);
            // noinspection JSArrowFunctionCanBeReplacedWithShorthand
            fileOut.on("finish", () => {
                ;
                fileOut.close(() => {
                    // remove from fd list because closed successfully
                    fdList.splice(1, 1);
                    try {
                        digestTransform.validate();
                    }
                    catch (e) {
                        reject(e);
                        return;
                    }
                    resolve(undefined);
                });
            });
            streams.push(fileOut);
            let lastStream = null;
            for (const stream of streams) {
                stream.on("error", reject);
                if (lastStream == null) {
                    lastStream = stream;
                }
                else {
                    lastStream = lastStream.pipe(stream);
                }
            }
            const firstStream = streams[0];
            let w;
            if (this.options.isUseMultipleRangeRequest) {
                w = (0, multipleRangeDownloader_1.executeTasksUsingMultipleRangeRequests)(this, tasks, firstStream, oldFileFd, reject);
                w(0);
                return;
            }
            let downloadOperationCount = 0;
            let actualUrl = null;
            this.logger.info(`Differential download: ${this.options.newUrl}`);
            const requestOptions = this.createRequestOptions();
            requestOptions.redirect = "manual";
            w = (index) => {
                var _a, _b;
                if (index >= tasks.length) {
                    if (this.fileMetadataBuffer != null) {
                        firstStream.write(this.fileMetadataBuffer);
                    }
                    firstStream.end();
                    return;
                }
                const operation = tasks[index++];
                if (operation.kind === downloadPlanBuilder_1.OperationKind.COPY) {
                    // We are copying, let's not send status updates to the UI
                    if (downloadInfoTransform) {
                        downloadInfoTransform.beginFileCopy();
                    }
                    (0, DataSplitter_1.copyData)(operation, firstStream, oldFileFd, reject, () => w(index));
                    return;
                }
                const range = `bytes=${operation.start}-${operation.end - 1}`;
                requestOptions.headers.range = range;
                (_b = (_a = this.logger) === null || _a === void 0 ? void 0 : _a.debug) === null || _b === void 0 ? void 0 : _b.call(_a, `download range: ${range}`);
                // We are starting to download
                if (downloadInfoTransform) {
                    downloadInfoTransform.beginRangeDownload();
                }
                const request = this.httpExecutor.createRequest(requestOptions, response => {
                    response.on("error", reject);
                    response.on("abort", () => {
                        reject(new Error("response has been aborted by the server"));
                    });
                    // Electron net handles redirects automatically, our NodeJS test server doesn't use redirects - so, we don't check 3xx codes.
                    if (response.statusCode >= 400) {
                        reject((0, builder_util_runtime_1.createHttpError)(response));
                    }
                    response.pipe(firstStream, {
                        end: false,
                    });
                    response.once("end", () => {
                        // Pass on that we are downloading a segment
                        if (downloadInfoTransform) {
                            downloadInfoTransform.endRangeDownload();
                        }
                        if (++downloadOperationCount === 100) {
                            downloadOperationCount = 0;
                            setTimeout(() => w(index), 1000);
                        }
                        else {
                            w(index);
                        }
                    });
                });
                request.on("redirect", (statusCode, method, redirectUrl) => {
                    this.logger.info(`Redirect to ${removeQuery(redirectUrl)}`);
                    actualUrl = redirectUrl;
                    (0, builder_util_runtime_1.configureRequestUrl)(new url_1.URL(actualUrl), requestOptions);
                    request.followRedirect();
                });
                this.httpExecutor.addErrorAndTimeoutHandlers(request, reject);
                request.end();
            };
            w(0);
        });
    }
    async readRemoteBytes(start, endInclusive) {
        const buffer = Buffer.allocUnsafe(endInclusive + 1 - start);
        const requestOptions = this.createRequestOptions();
        requestOptions.headers.range = `bytes=${start}-${endInclusive}`;
        let position = 0;
        await this.request(requestOptions, chunk => {
            chunk.copy(buffer, position);
            position += chunk.length;
        });
        if (position !== buffer.length) {
            throw new Error(`Received data length ${position} is not equal to expected ${buffer.length}`);
        }
        return buffer;
    }
    request(requestOptions, dataHandler) {
        return new Promise((resolve, reject) => {
            const request = this.httpExecutor.createRequest(requestOptions, response => {
                if (!(0, multipleRangeDownloader_1.checkIsRangesSupported)(response, reject)) {
                    return;
                }
                response.on("data", dataHandler);
                response.on("end", () => resolve());
            });
            this.httpExecutor.addErrorAndTimeoutHandlers(request, reject);
            request.end();
        });
    }
}
exports.DifferentialDownloader = DifferentialDownloader;
function formatBytes(value, symbol = " KB") {
    return new Intl.NumberFormat("en").format((value / 1024).toFixed(2)) + symbol;
}
// safety
function removeQuery(url) {
    const index = url.indexOf("?");
    return index < 0 ? url : url.substring(0, index);
}
//# sourceMappingURL=DifferentialDownloader.js.map

/***/ }),

/***/ 1972:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.FileWithEmbeddedBlockMapDifferentialDownloader = void 0;
const fs_extra_1 = __webpack_require__(8799);
const DifferentialDownloader_1 = __webpack_require__(9);
const zlib_1 = __webpack_require__(3106);
class FileWithEmbeddedBlockMapDifferentialDownloader extends DifferentialDownloader_1.DifferentialDownloader {
    async download() {
        const packageInfo = this.blockAwareFileInfo;
        const fileSize = packageInfo.size;
        const offset = fileSize - (packageInfo.blockMapSize + 4);
        this.fileMetadataBuffer = await this.readRemoteBytes(offset, fileSize - 1);
        const newBlockMap = readBlockMap(this.fileMetadataBuffer.slice(0, this.fileMetadataBuffer.length - 4));
        await this.doDownload(await readEmbeddedBlockMapData(this.options.oldFile), newBlockMap);
    }
}
exports.FileWithEmbeddedBlockMapDifferentialDownloader = FileWithEmbeddedBlockMapDifferentialDownloader;
function readBlockMap(data) {
    return JSON.parse((0, zlib_1.inflateRawSync)(data).toString());
}
async function readEmbeddedBlockMapData(file) {
    const fd = await (0, fs_extra_1.open)(file, "r");
    try {
        const fileSize = (await (0, fs_extra_1.fstat)(fd)).size;
        const sizeBuffer = Buffer.allocUnsafe(4);
        await (0, fs_extra_1.read)(fd, sizeBuffer, 0, sizeBuffer.length, fileSize - sizeBuffer.length);
        const dataBuffer = Buffer.allocUnsafe(sizeBuffer.readUInt32BE(0));
        await (0, fs_extra_1.read)(fd, dataBuffer, 0, dataBuffer.length, fileSize - sizeBuffer.length - dataBuffer.length);
        await (0, fs_extra_1.close)(fd);
        return readBlockMap(dataBuffer);
    }
    catch (e) {
        await (0, fs_extra_1.close)(fd);
        throw e;
    }
}
//# sourceMappingURL=FileWithEmbeddedBlockMapDifferentialDownloader.js.map

/***/ }),

/***/ 2444:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.GenericDifferentialDownloader = void 0;
const DifferentialDownloader_1 = __webpack_require__(9);
class GenericDifferentialDownloader extends DifferentialDownloader_1.DifferentialDownloader {
    download(oldBlockMap, newBlockMap) {
        return this.doDownload(oldBlockMap, newBlockMap);
    }
}
exports.GenericDifferentialDownloader = GenericDifferentialDownloader;
//# sourceMappingURL=GenericDifferentialDownloader.js.map

/***/ }),

/***/ 9516:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ProgressDifferentialDownloadCallbackTransform = void 0;
const stream_1 = __webpack_require__(2203);
var OperationKind;
(function (OperationKind) {
    OperationKind[OperationKind["COPY"] = 0] = "COPY";
    OperationKind[OperationKind["DOWNLOAD"] = 1] = "DOWNLOAD";
})(OperationKind || (OperationKind = {}));
class ProgressDifferentialDownloadCallbackTransform extends stream_1.Transform {
    constructor(progressDifferentialDownloadInfo, cancellationToken, onProgress) {
        super();
        this.progressDifferentialDownloadInfo = progressDifferentialDownloadInfo;
        this.cancellationToken = cancellationToken;
        this.onProgress = onProgress;
        this.start = Date.now();
        this.transferred = 0;
        this.delta = 0;
        this.expectedBytes = 0;
        this.index = 0;
        this.operationType = OperationKind.COPY;
        this.nextUpdate = this.start + 1000;
    }
    _transform(chunk, encoding, callback) {
        if (this.cancellationToken.cancelled) {
            callback(new Error("cancelled"), null);
            return;
        }
        // Don't send progress update when copying from disk
        if (this.operationType == OperationKind.COPY) {
            callback(null, chunk);
            return;
        }
        this.transferred += chunk.length;
        this.delta += chunk.length;
        const now = Date.now();
        if (now >= this.nextUpdate &&
            this.transferred !== this.expectedBytes /* will be emitted by endRangeDownload() */ &&
            this.transferred !== this.progressDifferentialDownloadInfo.grandTotal /* will be emitted on _flush */) {
            this.nextUpdate = now + 1000;
            this.onProgress({
                total: this.progressDifferentialDownloadInfo.grandTotal,
                delta: this.delta,
                transferred: this.transferred,
                percent: (this.transferred / this.progressDifferentialDownloadInfo.grandTotal) * 100,
                bytesPerSecond: Math.round(this.transferred / ((now - this.start) / 1000)),
            });
            this.delta = 0;
        }
        callback(null, chunk);
    }
    beginFileCopy() {
        this.operationType = OperationKind.COPY;
    }
    beginRangeDownload() {
        this.operationType = OperationKind.DOWNLOAD;
        this.expectedBytes += this.progressDifferentialDownloadInfo.expectedByteCounts[this.index++];
    }
    endRangeDownload() {
        // _flush() will doour final 100%
        if (this.transferred !== this.progressDifferentialDownloadInfo.grandTotal) {
            this.onProgress({
                total: this.progressDifferentialDownloadInfo.grandTotal,
                delta: this.delta,
                transferred: this.transferred,
                percent: (this.transferred / this.progressDifferentialDownloadInfo.grandTotal) * 100,
                bytesPerSecond: Math.round(this.transferred / ((Date.now() - this.start) / 1000)),
            });
        }
    }
    // Called when we are 100% done with the connection/download
    _flush(callback) {
        if (this.cancellationToken.cancelled) {
            callback(new Error("cancelled"));
            return;
        }
        this.onProgress({
            total: this.progressDifferentialDownloadInfo.grandTotal,
            delta: this.delta,
            transferred: this.transferred,
            percent: 100,
            bytesPerSecond: Math.round(this.transferred / ((Date.now() - this.start) / 1000)),
        });
        this.delta = 0;
        this.transferred = 0;
        callback(null);
    }
}
exports.ProgressDifferentialDownloadCallbackTransform = ProgressDifferentialDownloadCallbackTransform;
//# sourceMappingURL=ProgressDifferentialDownloadCallbackTransform.js.map

/***/ }),

/***/ 1305:
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.computeOperations = exports.OperationKind = void 0;
var OperationKind;
(function (OperationKind) {
    OperationKind[OperationKind["COPY"] = 0] = "COPY";
    OperationKind[OperationKind["DOWNLOAD"] = 1] = "DOWNLOAD";
})(OperationKind || (exports.OperationKind = OperationKind = {}));
function computeOperations(oldBlockMap, newBlockMap, logger) {
    const nameToOldBlocks = buildBlockFileMap(oldBlockMap.files);
    const nameToNewBlocks = buildBlockFileMap(newBlockMap.files);
    let lastOperation = null;
    // for now only one file is supported in block map
    const blockMapFile = newBlockMap.files[0];
    const operations = [];
    const name = blockMapFile.name;
    const oldEntry = nameToOldBlocks.get(name);
    if (oldEntry == null) {
        // new file (unrealistic case for now, because in any case both blockmap contain the only file named as "file")
        throw new Error(`no file ${name} in old blockmap`);
    }
    const newFile = nameToNewBlocks.get(name);
    let changedBlockCount = 0;
    const { checksumToOffset: checksumToOldOffset, checksumToOldSize } = buildChecksumMap(nameToOldBlocks.get(name), oldEntry.offset, logger);
    let newOffset = blockMapFile.offset;
    for (let i = 0; i < newFile.checksums.length; newOffset += newFile.sizes[i], i++) {
        const blockSize = newFile.sizes[i];
        const checksum = newFile.checksums[i];
        let oldOffset = checksumToOldOffset.get(checksum);
        if (oldOffset != null && checksumToOldSize.get(checksum) !== blockSize) {
            logger.warn(`Checksum ("${checksum}") matches, but size differs (old: ${checksumToOldSize.get(checksum)}, new: ${blockSize})`);
            oldOffset = undefined;
        }
        if (oldOffset === undefined) {
            // download data from new file
            changedBlockCount++;
            if (lastOperation != null && lastOperation.kind === OperationKind.DOWNLOAD && lastOperation.end === newOffset) {
                lastOperation.end += blockSize;
            }
            else {
                lastOperation = {
                    kind: OperationKind.DOWNLOAD,
                    start: newOffset,
                    end: newOffset + blockSize,
                    // oldBlocks: null,
                };
                validateAndAdd(lastOperation, operations, checksum, i);
            }
        }
        else {
            // reuse data from old file
            if (lastOperation != null && lastOperation.kind === OperationKind.COPY && lastOperation.end === oldOffset) {
                lastOperation.end += blockSize;
                // lastOperation.oldBlocks!!.push(checksum)
            }
            else {
                lastOperation = {
                    kind: OperationKind.COPY,
                    start: oldOffset,
                    end: oldOffset + blockSize,
                    // oldBlocks: [checksum]
                };
                validateAndAdd(lastOperation, operations, checksum, i);
            }
        }
    }
    if (changedBlockCount > 0) {
        logger.info(`File${blockMapFile.name === "file" ? "" : " " + blockMapFile.name} has ${changedBlockCount} changed blocks`);
    }
    return operations;
}
exports.computeOperations = computeOperations;
const isValidateOperationRange = ({"NODE_ENV":"production"})["DIFFERENTIAL_DOWNLOAD_PLAN_BUILDER_VALIDATE_RANGES"] === "true";
function validateAndAdd(operation, operations, checksum, index) {
    if (isValidateOperationRange && operations.length !== 0) {
        const lastOperation = operations[operations.length - 1];
        if (lastOperation.kind === operation.kind && operation.start < lastOperation.end && operation.start > lastOperation.start) {
            const min = [lastOperation.start, lastOperation.end, operation.start, operation.end].reduce((p, v) => (p < v ? p : v));
            throw new Error(`operation (block index: ${index}, checksum: ${checksum}, kind: ${OperationKind[operation.kind]}) overlaps previous operation (checksum: ${checksum}):\n` +
                `abs: ${lastOperation.start} until ${lastOperation.end} and ${operation.start} until ${operation.end}\n` +
                `rel: ${lastOperation.start - min} until ${lastOperation.end - min} and ${operation.start - min} until ${operation.end - min}`);
        }
    }
    operations.push(operation);
}
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
function buildChecksumMap(file, fileOffset, logger) {
    const checksumToOffset = new Map();
    const checksumToSize = new Map();
    let offset = fileOffset;
    for (let i = 0; i < file.checksums.length; i++) {
        const checksum = file.checksums[i];
        const size = file.sizes[i];
        const existing = checksumToSize.get(checksum);
        if (existing === undefined) {
            checksumToOffset.set(checksum, offset);
            checksumToSize.set(checksum, size);
        }
        else if (logger.debug != null) {
            const sizeExplanation = existing === size ? "(same size)" : `(size: ${existing}, this size: ${size})`;
            logger.debug(`${checksum} duplicated in blockmap ${sizeExplanation}, it doesn't lead to broken differential downloader, just corresponding block will be skipped)`);
        }
        offset += size;
    }
    return { checksumToOffset, checksumToOldSize: checksumToSize };
}
function buildBlockFileMap(list) {
    const result = new Map();
    for (const item of list) {
        result.set(item.name, item);
    }
    return result;
}
//# sourceMappingURL=downloadPlanBuilder.js.map

/***/ }),

/***/ 4405:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.checkIsRangesSupported = exports.executeTasksUsingMultipleRangeRequests = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const DataSplitter_1 = __webpack_require__(2652);
const downloadPlanBuilder_1 = __webpack_require__(1305);
function executeTasksUsingMultipleRangeRequests(differentialDownloader, tasks, out, oldFileFd, reject) {
    const w = (taskOffset) => {
        if (taskOffset >= tasks.length) {
            if (differentialDownloader.fileMetadataBuffer != null) {
                out.write(differentialDownloader.fileMetadataBuffer);
            }
            out.end();
            return;
        }
        const nextOffset = taskOffset + 1000;
        doExecuteTasks(differentialDownloader, {
            tasks,
            start: taskOffset,
            end: Math.min(tasks.length, nextOffset),
            oldFileFd,
        }, out, () => w(nextOffset), reject);
    };
    return w;
}
exports.executeTasksUsingMultipleRangeRequests = executeTasksUsingMultipleRangeRequests;
function doExecuteTasks(differentialDownloader, options, out, resolve, reject) {
    let ranges = "bytes=";
    let partCount = 0;
    const partIndexToTaskIndex = new Map();
    const partIndexToLength = [];
    for (let i = options.start; i < options.end; i++) {
        const task = options.tasks[i];
        if (task.kind === downloadPlanBuilder_1.OperationKind.DOWNLOAD) {
            ranges += `${task.start}-${task.end - 1}, `;
            partIndexToTaskIndex.set(partCount, i);
            partCount++;
            partIndexToLength.push(task.end - task.start);
        }
    }
    if (partCount <= 1) {
        // the only remote range - copy
        const w = (index) => {
            if (index >= options.end) {
                resolve();
                return;
            }
            const task = options.tasks[index++];
            if (task.kind === downloadPlanBuilder_1.OperationKind.COPY) {
                (0, DataSplitter_1.copyData)(task, out, options.oldFileFd, reject, () => w(index));
            }
            else {
                const requestOptions = differentialDownloader.createRequestOptions();
                requestOptions.headers.Range = `bytes=${task.start}-${task.end - 1}`;
                const request = differentialDownloader.httpExecutor.createRequest(requestOptions, response => {
                    if (!checkIsRangesSupported(response, reject)) {
                        return;
                    }
                    response.pipe(out, {
                        end: false,
                    });
                    response.once("end", () => w(index));
                });
                differentialDownloader.httpExecutor.addErrorAndTimeoutHandlers(request, reject);
                request.end();
            }
        };
        w(options.start);
        return;
    }
    const requestOptions = differentialDownloader.createRequestOptions();
    requestOptions.headers.Range = ranges.substring(0, ranges.length - 2);
    const request = differentialDownloader.httpExecutor.createRequest(requestOptions, response => {
        if (!checkIsRangesSupported(response, reject)) {
            return;
        }
        const contentType = (0, builder_util_runtime_1.safeGetHeader)(response, "content-type");
        const m = /^multipart\/.+?(?:; boundary=(?:(?:"(.+)")|(?:([^\s]+))))$/i.exec(contentType);
        if (m == null) {
            reject(new Error(`Content-Type "multipart/byteranges" is expected, but got "${contentType}"`));
            return;
        }
        const dicer = new DataSplitter_1.DataSplitter(out, options, partIndexToTaskIndex, m[1] || m[2], partIndexToLength, resolve);
        dicer.on("error", reject);
        response.pipe(dicer);
        response.on("end", () => {
            setTimeout(() => {
                request.abort();
                reject(new Error("Response ends without calling any handlers"));
            }, 10000);
        });
    });
    differentialDownloader.httpExecutor.addErrorAndTimeoutHandlers(request, reject);
    request.end();
}
function checkIsRangesSupported(response, reject) {
    // Electron net handles redirects automatically, our NodeJS test server doesn't use redirects - so, we don't check 3xx codes.
    if (response.statusCode >= 400) {
        reject((0, builder_util_runtime_1.createHttpError)(response));
        return false;
    }
    if (response.statusCode !== 206) {
        const acceptRanges = (0, builder_util_runtime_1.safeGetHeader)(response, "accept-ranges");
        if (acceptRanges == null || acceptRanges === "none") {
            reject(new Error(`Server doesn't support Accept-Ranges (response code ${response.statusCode})`));
            return false;
        }
    }
    return true;
}
exports.checkIsRangesSupported = checkIsRangesSupported;
//# sourceMappingURL=multipleRangeDownloader.js.map

/***/ }),

/***/ 369:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.ElectronHttpExecutor = exports.getNetSession = exports.NET_SESSION_NAME = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
exports.NET_SESSION_NAME = "electron-updater";
function getNetSession() {
    return (__webpack_require__(4157).session).fromPartition(exports.NET_SESSION_NAME, {
        cache: false,
    });
}
exports.getNetSession = getNetSession;
class ElectronHttpExecutor extends builder_util_runtime_1.HttpExecutor {
    constructor(proxyLoginCallback) {
        super();
        this.proxyLoginCallback = proxyLoginCallback;
        this.cachedSession = null;
    }
    async download(url, destination, options) {
        return await options.cancellationToken.createPromise((resolve, reject, onCancel) => {
            const requestOptions = {
                headers: options.headers || undefined,
                redirect: "manual",
            };
            (0, builder_util_runtime_1.configureRequestUrl)(url, requestOptions);
            (0, builder_util_runtime_1.configureRequestOptions)(requestOptions);
            this.doDownload(requestOptions, {
                destination,
                options,
                onCancel,
                callback: error => {
                    if (error == null) {
                        resolve(destination);
                    }
                    else {
                        reject(error);
                    }
                },
                responseHandler: null,
            }, 0);
        });
    }
    createRequest(options, callback) {
        // fix (node 7+) for making electron updater work when using AWS private buckets, check if headers contain Host property
        if (options.headers && options.headers.Host) {
            // set host value from headers.Host
            options.host = options.headers.Host;
            // remove header property 'Host', if not removed causes net::ERR_INVALID_ARGUMENT exception
            delete options.headers.Host;
        }
        // differential downloader can call this method very often, so, better to cache session
        if (this.cachedSession == null) {
            this.cachedSession = getNetSession();
        }
        const request = (__webpack_require__(4157).net).request({
            ...options,
            session: this.cachedSession,
        });
        request.on("response", callback);
        if (this.proxyLoginCallback != null) {
            request.on("login", this.proxyLoginCallback);
        }
        return request;
    }
    addRedirectHandlers(request, options, reject, redirectCount, handler) {
        request.on("redirect", (statusCode, method, redirectUrl) => {
            // no way to modify request options, abort old and make a new one
            // https://github.com/electron/electron/issues/11505
            request.abort();
            if (redirectCount > this.maxRedirects) {
                reject(this.createMaxRedirectError());
            }
            else {
                handler(builder_util_runtime_1.HttpExecutor.prepareRedirectUrlOptions(redirectUrl, options));
            }
        });
    }
}
exports.ElectronHttpExecutor = ElectronHttpExecutor;
//# sourceMappingURL=electronHttpExecutor.js.map

/***/ }),

/***/ 5879:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.UpdaterSignal = exports.UPDATE_DOWNLOADED = exports.DOWNLOAD_PROGRESS = exports.NsisUpdater = exports.MacUpdater = exports.RpmUpdater = exports.DebUpdater = exports.AppImageUpdater = exports.Provider = exports.CancellationToken = exports.NoOpLogger = exports.AppUpdater = exports.BaseUpdater = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
Object.defineProperty(exports, "CancellationToken", ({ enumerable: true, get: function () { return builder_util_runtime_1.CancellationToken; } }));
const fs_extra_1 = __webpack_require__(8799);
const path = __webpack_require__(6928);
var BaseUpdater_1 = __webpack_require__(9322);
Object.defineProperty(exports, "BaseUpdater", ({ enumerable: true, get: function () { return BaseUpdater_1.BaseUpdater; } }));
var AppUpdater_1 = __webpack_require__(4718);
Object.defineProperty(exports, "AppUpdater", ({ enumerable: true, get: function () { return AppUpdater_1.AppUpdater; } }));
Object.defineProperty(exports, "NoOpLogger", ({ enumerable: true, get: function () { return AppUpdater_1.NoOpLogger; } }));
var Provider_1 = __webpack_require__(5776);
Object.defineProperty(exports, "Provider", ({ enumerable: true, get: function () { return Provider_1.Provider; } }));
var AppImageUpdater_1 = __webpack_require__(6441);
Object.defineProperty(exports, "AppImageUpdater", ({ enumerable: true, get: function () { return AppImageUpdater_1.AppImageUpdater; } }));
var DebUpdater_1 = __webpack_require__(3378);
Object.defineProperty(exports, "DebUpdater", ({ enumerable: true, get: function () { return DebUpdater_1.DebUpdater; } }));
var RpmUpdater_1 = __webpack_require__(3916);
Object.defineProperty(exports, "RpmUpdater", ({ enumerable: true, get: function () { return RpmUpdater_1.RpmUpdater; } }));
var MacUpdater_1 = __webpack_require__(2658);
Object.defineProperty(exports, "MacUpdater", ({ enumerable: true, get: function () { return MacUpdater_1.MacUpdater; } }));
var NsisUpdater_1 = __webpack_require__(776);
Object.defineProperty(exports, "NsisUpdater", ({ enumerable: true, get: function () { return NsisUpdater_1.NsisUpdater; } }));
// autoUpdater to mimic electron bundled autoUpdater
let _autoUpdater;
function doLoadAutoUpdater() {
    // tslint:disable:prefer-conditional-expression
    if (process.platform === "win32") {
        _autoUpdater = new ((__webpack_require__(776).NsisUpdater))();
    }
    else if (process.platform === "darwin") {
        _autoUpdater = new ((__webpack_require__(2658).MacUpdater))();
    }
    else {
        _autoUpdater = new ((__webpack_require__(6441).AppImageUpdater))();
        try {
            const identity = path.join(process.resourcesPath, "package-type");
            if (!(0, fs_extra_1.existsSync)(identity)) {
                return _autoUpdater;
            }
            console.info("Checking for beta autoupdate feature for deb/rpm distributions");
            const fileType = (0, fs_extra_1.readFileSync)(identity).toString().trim();
            console.info("Found package-type:", fileType);
            switch (fileType) {
                case "deb":
                    _autoUpdater = new ((__webpack_require__(3378).DebUpdater))();
                    break;
                case "rpm":
                    _autoUpdater = new ((__webpack_require__(3916).RpmUpdater))();
                    break;
                default:
                    break;
            }
        }
        catch (error) {
            console.warn("Unable to detect 'package-type' for autoUpdater (beta rpm/deb support). If you'd like to expand support, please consider contributing to electron-builder", error.message);
        }
    }
    return _autoUpdater;
}
Object.defineProperty(exports, "autoUpdater", ({
    enumerable: true,
    get: () => {
        return _autoUpdater || doLoadAutoUpdater();
    },
}));
exports.DOWNLOAD_PROGRESS = "download-progress";
exports.UPDATE_DOWNLOADED = "update-downloaded";
class UpdaterSignal {
    constructor(emitter) {
        this.emitter = emitter;
    }
    /**
     * Emitted when an authenticating proxy is [asking for user credentials](https://github.com/electron/electron/blob/master/docs/api/client-request.md#event-login).
     */
    login(handler) {
        addHandler(this.emitter, "login", handler);
    }
    progress(handler) {
        addHandler(this.emitter, exports.DOWNLOAD_PROGRESS, handler);
    }
    updateDownloaded(handler) {
        addHandler(this.emitter, exports.UPDATE_DOWNLOADED, handler);
    }
    updateCancelled(handler) {
        addHandler(this.emitter, "update-cancelled", handler);
    }
}
exports.UpdaterSignal = UpdaterSignal;
const isLogEvent = false;
function addHandler(emitter, event, handler) {
    if (isLogEvent) {
        emitter.on(event, (...args) => {
            console.log("%s %s", event, args);
            handler(...args);
        });
    }
    else {
        emitter.on(event, handler);
    }
}
//# sourceMappingURL=main.js.map

/***/ }),

/***/ 7981:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.createClient = exports.isUrlProbablySupportMultiRangeRequests = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const BitbucketProvider_1 = __webpack_require__(1325);
const GenericProvider_1 = __webpack_require__(2705);
const GitHubProvider_1 = __webpack_require__(1203);
const KeygenProvider_1 = __webpack_require__(8067);
const PrivateGitHubProvider_1 = __webpack_require__(4572);
function isUrlProbablySupportMultiRangeRequests(url) {
    return !url.includes("s3.amazonaws.com");
}
exports.isUrlProbablySupportMultiRangeRequests = isUrlProbablySupportMultiRangeRequests;
function createClient(data, updater, runtimeOptions) {
    // noinspection SuspiciousTypeOfGuard
    if (typeof data === "string") {
        throw (0, builder_util_runtime_1.newError)("Please pass PublishConfiguration object", "ERR_UPDATER_INVALID_PROVIDER_CONFIGURATION");
    }
    const provider = data.provider;
    switch (provider) {
        case "github": {
            const githubOptions = data;
            const token = (githubOptions.private ? ({"NODE_ENV":"production"})["GH_TOKEN"] || ({"NODE_ENV":"production"})["GITHUB_TOKEN"] : null) || githubOptions.token;
            if (token == null) {
                return new GitHubProvider_1.GitHubProvider(githubOptions, updater, runtimeOptions);
            }
            else {
                return new PrivateGitHubProvider_1.PrivateGitHubProvider(githubOptions, updater, token, runtimeOptions);
            }
        }
        case "bitbucket":
            return new BitbucketProvider_1.BitbucketProvider(data, updater, runtimeOptions);
        case "keygen":
            return new KeygenProvider_1.KeygenProvider(data, updater, runtimeOptions);
        case "s3":
        case "spaces":
            return new GenericProvider_1.GenericProvider({
                provider: "generic",
                url: (0, builder_util_runtime_1.getS3LikeProviderBaseUrl)(data),
                channel: data.channel || null,
            }, updater, {
                ...runtimeOptions,
                // https://github.com/minio/minio/issues/5285#issuecomment-350428955
                isUseMultipleRangeRequest: false,
            });
        case "generic": {
            const options = data;
            return new GenericProvider_1.GenericProvider(options, updater, {
                ...runtimeOptions,
                isUseMultipleRangeRequest: options.useMultipleRangeRequest !== false && isUrlProbablySupportMultiRangeRequests(options.url),
            });
        }
        case "custom": {
            const options = data;
            const constructor = options.updateProvider;
            if (!constructor) {
                throw (0, builder_util_runtime_1.newError)("Custom provider not specified", "ERR_UPDATER_INVALID_PROVIDER_CONFIGURATION");
            }
            return new constructor(options, updater, runtimeOptions);
        }
        default:
            throw (0, builder_util_runtime_1.newError)(`Unsupported provider: ${provider}`, "ERR_UPDATER_UNSUPPORTED_PROVIDER");
    }
}
exports.createClient = createClient;
//# sourceMappingURL=providerFactory.js.map

/***/ }),

/***/ 1325:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.BitbucketProvider = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const util_1 = __webpack_require__(906);
const Provider_1 = __webpack_require__(5776);
class BitbucketProvider extends Provider_1.Provider {
    constructor(configuration, updater, runtimeOptions) {
        super({
            ...runtimeOptions,
            isUseMultipleRangeRequest: false,
        });
        this.configuration = configuration;
        this.updater = updater;
        const { owner, slug } = configuration;
        this.baseUrl = (0, util_1.newBaseUrl)(`https://api.bitbucket.org/2.0/repositories/${owner}/${slug}/downloads`);
    }
    get channel() {
        return this.updater.channel || this.configuration.channel || "latest";
    }
    async getLatestVersion() {
        const cancellationToken = new builder_util_runtime_1.CancellationToken();
        const channelFile = (0, util_1.getChannelFilename)(this.getCustomChannelName(this.channel));
        const channelUrl = (0, util_1.newUrlFromBase)(channelFile, this.baseUrl, this.updater.isAddNoCacheQuery);
        try {
            const updateInfo = await this.httpRequest(channelUrl, undefined, cancellationToken);
            return (0, Provider_1.parseUpdateInfo)(updateInfo, channelFile, channelUrl);
        }
        catch (e) {
            throw (0, builder_util_runtime_1.newError)(`Unable to find latest version on ${this.toString()}, please ensure release exists: ${e.stack || e.message}`, "ERR_UPDATER_LATEST_VERSION_NOT_FOUND");
        }
    }
    resolveFiles(updateInfo) {
        return (0, Provider_1.resolveFiles)(updateInfo, this.baseUrl);
    }
    toString() {
        const { owner, slug } = this.configuration;
        return `Bitbucket (owner: ${owner}, slug: ${slug}, channel: ${this.channel})`;
    }
}
exports.BitbucketProvider = BitbucketProvider;
//# sourceMappingURL=BitbucketProvider.js.map

/***/ }),

/***/ 2705:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.GenericProvider = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const util_1 = __webpack_require__(906);
const Provider_1 = __webpack_require__(5776);
class GenericProvider extends Provider_1.Provider {
    constructor(configuration, updater, runtimeOptions) {
        super(runtimeOptions);
        this.configuration = configuration;
        this.updater = updater;
        this.baseUrl = (0, util_1.newBaseUrl)(this.configuration.url);
    }
    get channel() {
        const result = this.updater.channel || this.configuration.channel;
        return result == null ? this.getDefaultChannelName() : this.getCustomChannelName(result);
    }
    async getLatestVersion() {
        const channelFile = (0, util_1.getChannelFilename)(this.channel);
        const channelUrl = (0, util_1.newUrlFromBase)(channelFile, this.baseUrl, this.updater.isAddNoCacheQuery);
        for (let attemptNumber = 0;; attemptNumber++) {
            try {
                return (0, Provider_1.parseUpdateInfo)(await this.httpRequest(channelUrl), channelFile, channelUrl);
            }
            catch (e) {
                if (e instanceof builder_util_runtime_1.HttpError && e.statusCode === 404) {
                    throw (0, builder_util_runtime_1.newError)(`Cannot find channel "${channelFile}" update info: ${e.stack || e.message}`, "ERR_UPDATER_CHANNEL_FILE_NOT_FOUND");
                }
                else if (e.code === "ECONNREFUSED") {
                    if (attemptNumber < 3) {
                        await new Promise((resolve, reject) => {
                            try {
                                setTimeout(resolve, 1000 * attemptNumber);
                            }
                            catch (e) {
                                reject(e);
                            }
                        });
                        continue;
                    }
                }
                throw e;
            }
        }
    }
    resolveFiles(updateInfo) {
        return (0, Provider_1.resolveFiles)(updateInfo, this.baseUrl);
    }
}
exports.GenericProvider = GenericProvider;
//# sourceMappingURL=GenericProvider.js.map

/***/ }),

/***/ 1203:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.computeReleaseNotes = exports.GitHubProvider = exports.BaseGitHubProvider = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const semver = __webpack_require__(9589);
const url_1 = __webpack_require__(7016);
const util_1 = __webpack_require__(906);
const Provider_1 = __webpack_require__(5776);
const hrefRegExp = /\/tag\/([^/]+)$/;
class BaseGitHubProvider extends Provider_1.Provider {
    constructor(options, defaultHost, runtimeOptions) {
        super({
            ...runtimeOptions,
            /* because GitHib uses S3 */
            isUseMultipleRangeRequest: false,
        });
        this.options = options;
        this.baseUrl = (0, util_1.newBaseUrl)((0, builder_util_runtime_1.githubUrl)(options, defaultHost));
        const apiHost = defaultHost === "github.com" ? "api.github.com" : defaultHost;
        this.baseApiUrl = (0, util_1.newBaseUrl)((0, builder_util_runtime_1.githubUrl)(options, apiHost));
    }
    computeGithubBasePath(result) {
        // https://github.com/electron-userland/electron-builder/issues/1903#issuecomment-320881211
        const host = this.options.host;
        return host && !["github.com", "api.github.com"].includes(host) ? `/api/v3${result}` : result;
    }
}
exports.BaseGitHubProvider = BaseGitHubProvider;
class GitHubProvider extends BaseGitHubProvider {
    constructor(options, updater, runtimeOptions) {
        super(options, "github.com", runtimeOptions);
        this.options = options;
        this.updater = updater;
    }
    async getLatestVersion() {
        var _a, _b, _c, _d;
        const cancellationToken = new builder_util_runtime_1.CancellationToken();
        const feedXml = (await this.httpRequest((0, util_1.newUrlFromBase)(`${this.basePath}.atom`, this.baseUrl), {
            accept: "application/xml, application/atom+xml, text/xml, */*",
        }, cancellationToken));
        const feed = (0, builder_util_runtime_1.parseXml)(feedXml);
        // noinspection TypeScriptValidateJSTypes
        let latestRelease = feed.element("entry", false, `No published versions on GitHub`);
        let tag = null;
        try {
            if (this.updater.allowPrerelease) {
                const currentChannel = ((_a = this.updater) === null || _a === void 0 ? void 0 : _a.channel) || ((_b = semver.prerelease(this.updater.currentVersion)) === null || _b === void 0 ? void 0 : _b[0]) || null;
                if (currentChannel === null) {
                    // noinspection TypeScriptValidateJSTypes
                    tag = hrefRegExp.exec(latestRelease.element("link").attribute("href"))[1];
                }
                else {
                    for (const element of feed.getElements("entry")) {
                        // noinspection TypeScriptValidateJSTypes
                        const hrefElement = hrefRegExp.exec(element.element("link").attribute("href"));
                        // If this is null then something is wrong and skip this release
                        if (hrefElement === null)
                            continue;
                        // This Release's Tag
                        const hrefTag = hrefElement[1];
                        //Get Channel from this release's tag
                        const hrefChannel = ((_c = semver.prerelease(hrefTag)) === null || _c === void 0 ? void 0 : _c[0]) || null;
                        const shouldFetchVersion = !currentChannel || ["alpha", "beta"].includes(currentChannel);
                        const isCustomChannel = hrefChannel !== null && !["alpha", "beta"].includes(String(hrefChannel));
                        // Allow moving from alpha to beta but not down
                        const channelMismatch = currentChannel === "beta" && hrefChannel === "alpha";
                        if (shouldFetchVersion && !isCustomChannel && !channelMismatch) {
                            tag = hrefTag;
                            break;
                        }
                        const isNextPreRelease = hrefChannel && hrefChannel === currentChannel;
                        if (isNextPreRelease) {
                            tag = hrefTag;
                            break;
                        }
                    }
                }
            }
            else {
                tag = await this.getLatestTagName(cancellationToken);
                for (const element of feed.getElements("entry")) {
                    // noinspection TypeScriptValidateJSTypes
                    if (hrefRegExp.exec(element.element("link").attribute("href"))[1] === tag) {
                        latestRelease = element;
                        break;
                    }
                }
            }
        }
        catch (e) {
            throw (0, builder_util_runtime_1.newError)(`Cannot parse releases feed: ${e.stack || e.message},\nXML:\n${feedXml}`, "ERR_UPDATER_INVALID_RELEASE_FEED");
        }
        if (tag == null) {
            throw (0, builder_util_runtime_1.newError)(`No published versions on GitHub`, "ERR_UPDATER_NO_PUBLISHED_VERSIONS");
        }
        let rawData;
        let channelFile = "";
        let channelFileUrl = "";
        const fetchData = async (channelName) => {
            channelFile = (0, util_1.getChannelFilename)(channelName);
            channelFileUrl = (0, util_1.newUrlFromBase)(this.getBaseDownloadPath(String(tag), channelFile), this.baseUrl);
            const requestOptions = this.createRequestOptions(channelFileUrl);
            try {
                return (await this.executor.request(requestOptions, cancellationToken));
            }
            catch (e) {
                if (e instanceof builder_util_runtime_1.HttpError && e.statusCode === 404) {
                    throw (0, builder_util_runtime_1.newError)(`Cannot find ${channelFile} in the latest release artifacts (${channelFileUrl}): ${e.stack || e.message}`, "ERR_UPDATER_CHANNEL_FILE_NOT_FOUND");
                }
                throw e;
            }
        };
        try {
            const channel = this.updater.allowPrerelease ? this.getCustomChannelName(String(((_d = semver.prerelease(tag)) === null || _d === void 0 ? void 0 : _d[0]) || "latest")) : this.getDefaultChannelName();
            rawData = await fetchData(channel);
        }
        catch (e) {
            if (this.updater.allowPrerelease) {
                // Allow fallback to `latest.yml`
                rawData = await fetchData(this.getDefaultChannelName());
            }
            else {
                throw e;
            }
        }
        const result = (0, Provider_1.parseUpdateInfo)(rawData, channelFile, channelFileUrl);
        if (result.releaseName == null) {
            result.releaseName = latestRelease.elementValueOrEmpty("title");
        }
        if (result.releaseNotes == null) {
            result.releaseNotes = computeReleaseNotes(this.updater.currentVersion, this.updater.fullChangelog, feed, latestRelease);
        }
        return {
            tag: tag,
            ...result,
        };
    }
    async getLatestTagName(cancellationToken) {
        const options = this.options;
        // do not use API for GitHub to avoid limit, only for custom host or GitHub Enterprise
        const url = options.host == null || options.host === "github.com"
            ? (0, util_1.newUrlFromBase)(`${this.basePath}/latest`, this.baseUrl)
            : new url_1.URL(`${this.computeGithubBasePath(`/repos/${options.owner}/${options.repo}/releases`)}/latest`, this.baseApiUrl);
        try {
            const rawData = await this.httpRequest(url, { Accept: "application/json" }, cancellationToken);
            if (rawData == null) {
                return null;
            }
            const releaseInfo = JSON.parse(rawData);
            return releaseInfo.tag_name;
        }
        catch (e) {
            throw (0, builder_util_runtime_1.newError)(`Unable to find latest version on GitHub (${url}), please ensure a production release exists: ${e.stack || e.message}`, "ERR_UPDATER_LATEST_VERSION_NOT_FOUND");
        }
    }
    get basePath() {
        return `/${this.options.owner}/${this.options.repo}/releases`;
    }
    resolveFiles(updateInfo) {
        // still replace space to - due to backward compatibility
        return (0, Provider_1.resolveFiles)(updateInfo, this.baseUrl, p => this.getBaseDownloadPath(updateInfo.tag, p.replace(/ /g, "-")));
    }
    getBaseDownloadPath(tag, fileName) {
        return `${this.basePath}/download/${tag}/${fileName}`;
    }
}
exports.GitHubProvider = GitHubProvider;
function getNoteValue(parent) {
    const result = parent.elementValueOrEmpty("content");
    // GitHub reports empty notes as <content>No content.</content>
    return result === "No content." ? "" : result;
}
function computeReleaseNotes(currentVersion, isFullChangelog, feed, latestRelease) {
    if (!isFullChangelog) {
        return getNoteValue(latestRelease);
    }
    const releaseNotes = [];
    for (const release of feed.getElements("entry")) {
        // noinspection TypeScriptValidateJSTypes
        const versionRelease = /\/tag\/v?([^/]+)$/.exec(release.element("link").attribute("href"))[1];
        if (semver.lt(currentVersion, versionRelease)) {
            releaseNotes.push({
                version: versionRelease,
                note: getNoteValue(release),
            });
        }
    }
    return releaseNotes.sort((a, b) => semver.rcompare(a.version, b.version));
}
exports.computeReleaseNotes = computeReleaseNotes;
//# sourceMappingURL=GitHubProvider.js.map

/***/ }),

/***/ 8067:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.KeygenProvider = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const util_1 = __webpack_require__(906);
const Provider_1 = __webpack_require__(5776);
class KeygenProvider extends Provider_1.Provider {
    constructor(configuration, updater, runtimeOptions) {
        super({
            ...runtimeOptions,
            isUseMultipleRangeRequest: false,
        });
        this.configuration = configuration;
        this.updater = updater;
        this.baseUrl = (0, util_1.newBaseUrl)(`https://api.keygen.sh/v1/accounts/${this.configuration.account}/artifacts?product=${this.configuration.product}`);
    }
    get channel() {
        return this.updater.channel || this.configuration.channel || "stable";
    }
    async getLatestVersion() {
        const cancellationToken = new builder_util_runtime_1.CancellationToken();
        const channelFile = (0, util_1.getChannelFilename)(this.getCustomChannelName(this.channel));
        const channelUrl = (0, util_1.newUrlFromBase)(channelFile, this.baseUrl, this.updater.isAddNoCacheQuery);
        try {
            const updateInfo = await this.httpRequest(channelUrl, {
                Accept: "application/vnd.api+json",
                "Keygen-Version": "1.1",
            }, cancellationToken);
            return (0, Provider_1.parseUpdateInfo)(updateInfo, channelFile, channelUrl);
        }
        catch (e) {
            throw (0, builder_util_runtime_1.newError)(`Unable to find latest version on ${this.toString()}, please ensure release exists: ${e.stack || e.message}`, "ERR_UPDATER_LATEST_VERSION_NOT_FOUND");
        }
    }
    resolveFiles(updateInfo) {
        return (0, Provider_1.resolveFiles)(updateInfo, this.baseUrl);
    }
    toString() {
        const { account, product, platform } = this.configuration;
        return `Keygen (account: ${account}, product: ${product}, platform: ${platform}, channel: ${this.channel})`;
    }
}
exports.KeygenProvider = KeygenProvider;
//# sourceMappingURL=KeygenProvider.js.map

/***/ }),

/***/ 4572:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.PrivateGitHubProvider = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const js_yaml_1 = __webpack_require__(7210);
const path = __webpack_require__(6928);
const url_1 = __webpack_require__(7016);
const util_1 = __webpack_require__(906);
const GitHubProvider_1 = __webpack_require__(1203);
const Provider_1 = __webpack_require__(5776);
class PrivateGitHubProvider extends GitHubProvider_1.BaseGitHubProvider {
    constructor(options, updater, token, runtimeOptions) {
        super(options, "api.github.com", runtimeOptions);
        this.updater = updater;
        this.token = token;
    }
    createRequestOptions(url, headers) {
        const result = super.createRequestOptions(url, headers);
        result.redirect = "manual";
        return result;
    }
    async getLatestVersion() {
        const cancellationToken = new builder_util_runtime_1.CancellationToken();
        const channelFile = (0, util_1.getChannelFilename)(this.getDefaultChannelName());
        const releaseInfo = await this.getLatestVersionInfo(cancellationToken);
        const asset = releaseInfo.assets.find(it => it.name === channelFile);
        if (asset == null) {
            // html_url must be always, but just to be sure
            throw (0, builder_util_runtime_1.newError)(`Cannot find ${channelFile} in the release ${releaseInfo.html_url || releaseInfo.name}`, "ERR_UPDATER_CHANNEL_FILE_NOT_FOUND");
        }
        const url = new url_1.URL(asset.url);
        let result;
        try {
            result = (0, js_yaml_1.load)((await this.httpRequest(url, this.configureHeaders("application/octet-stream"), cancellationToken)));
        }
        catch (e) {
            if (e instanceof builder_util_runtime_1.HttpError && e.statusCode === 404) {
                throw (0, builder_util_runtime_1.newError)(`Cannot find ${channelFile} in the latest release artifacts (${url}): ${e.stack || e.message}`, "ERR_UPDATER_CHANNEL_FILE_NOT_FOUND");
            }
            throw e;
        }
        ;
        result.assets = releaseInfo.assets;
        return result;
    }
    get fileExtraDownloadHeaders() {
        return this.configureHeaders("application/octet-stream");
    }
    // eslint-disable-next-line @typescript-eslint/explicit-function-return-type
    configureHeaders(accept) {
        return {
            accept,
            authorization: `token ${this.token}`,
        };
    }
    async getLatestVersionInfo(cancellationToken) {
        const allowPrerelease = this.updater.allowPrerelease;
        let basePath = this.basePath;
        if (!allowPrerelease) {
            basePath = `${basePath}/latest`;
        }
        const url = (0, util_1.newUrlFromBase)(basePath, this.baseUrl);
        try {
            const version = JSON.parse((await this.httpRequest(url, this.configureHeaders("application/vnd.github.v3+json"), cancellationToken)));
            if (allowPrerelease) {
                return version.find(it => it.prerelease) || version[0];
            }
            else {
                return version;
            }
        }
        catch (e) {
            throw (0, builder_util_runtime_1.newError)(`Unable to find latest version on GitHub (${url}), please ensure a production release exists: ${e.stack || e.message}`, "ERR_UPDATER_LATEST_VERSION_NOT_FOUND");
        }
    }
    get basePath() {
        return this.computeGithubBasePath(`/repos/${this.options.owner}/${this.options.repo}/releases`);
    }
    resolveFiles(updateInfo) {
        return (0, Provider_1.getFileList)(updateInfo).map(it => {
            const name = path.posix.basename(it.url).replace(/ /g, "-");
            const asset = updateInfo.assets.find(it => it != null && it.name === name);
            if (asset == null) {
                throw (0, builder_util_runtime_1.newError)(`Cannot find asset "${name}" in: ${JSON.stringify(updateInfo.assets, null, 2)}`, "ERR_UPDATER_ASSET_NOT_FOUND");
            }
            return {
                url: new url_1.URL(asset.url),
                info: it,
            };
        });
    }
}
exports.PrivateGitHubProvider = PrivateGitHubProvider;
//# sourceMappingURL=PrivateGitHubProvider.js.map

/***/ }),

/***/ 5776:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.resolveFiles = exports.getFileList = exports.parseUpdateInfo = exports.findFile = exports.Provider = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const js_yaml_1 = __webpack_require__(7210);
const util_1 = __webpack_require__(906);
class Provider {
    constructor(runtimeOptions) {
        this.runtimeOptions = runtimeOptions;
        this.requestHeaders = null;
        this.executor = runtimeOptions.executor;
    }
    get isUseMultipleRangeRequest() {
        return this.runtimeOptions.isUseMultipleRangeRequest !== false;
    }
    getChannelFilePrefix() {
        if (this.runtimeOptions.platform === "linux") {
            const arch = ({"NODE_ENV":"production"})["TEST_UPDATER_ARCH"] || process.arch;
            const archSuffix = arch === "x64" ? "" : `-${arch}`;
            return "-linux" + archSuffix;
        }
        else {
            return this.runtimeOptions.platform === "darwin" ? "-mac" : "";
        }
    }
    // due to historical reasons for windows we use channel name without platform specifier
    getDefaultChannelName() {
        return this.getCustomChannelName("latest");
    }
    getCustomChannelName(channel) {
        return `${channel}${this.getChannelFilePrefix()}`;
    }
    get fileExtraDownloadHeaders() {
        return null;
    }
    setRequestHeaders(value) {
        this.requestHeaders = value;
    }
    /**
     * Method to perform API request only to resolve update info, but not to download update.
     */
    httpRequest(url, headers, cancellationToken) {
        return this.executor.request(this.createRequestOptions(url, headers), cancellationToken);
    }
    createRequestOptions(url, headers) {
        const result = {};
        if (this.requestHeaders == null) {
            if (headers != null) {
                result.headers = headers;
            }
        }
        else {
            result.headers = headers == null ? this.requestHeaders : { ...this.requestHeaders, ...headers };
        }
        (0, builder_util_runtime_1.configureRequestUrl)(url, result);
        return result;
    }
}
exports.Provider = Provider;
function findFile(files, extension, not) {
    if (files.length === 0) {
        throw (0, builder_util_runtime_1.newError)("No files provided", "ERR_UPDATER_NO_FILES_PROVIDED");
    }
    const result = files.find(it => it.url.pathname.toLowerCase().endsWith(`.${extension}`));
    if (result != null) {
        return result;
    }
    else if (not == null) {
        return files[0];
    }
    else {
        return files.find(fileInfo => !not.some(ext => fileInfo.url.pathname.toLowerCase().endsWith(`.${ext}`)));
    }
}
exports.findFile = findFile;
function parseUpdateInfo(rawData, channelFile, channelFileUrl) {
    if (rawData == null) {
        throw (0, builder_util_runtime_1.newError)(`Cannot parse update info from ${channelFile} in the latest release artifacts (${channelFileUrl}): rawData: null`, "ERR_UPDATER_INVALID_UPDATE_INFO");
    }
    let result;
    try {
        result = (0, js_yaml_1.load)(rawData);
    }
    catch (e) {
        throw (0, builder_util_runtime_1.newError)(`Cannot parse update info from ${channelFile} in the latest release artifacts (${channelFileUrl}): ${e.stack || e.message}, rawData: ${rawData}`, "ERR_UPDATER_INVALID_UPDATE_INFO");
    }
    return result;
}
exports.parseUpdateInfo = parseUpdateInfo;
function getFileList(updateInfo) {
    const files = updateInfo.files;
    if (files != null && files.length > 0) {
        return files;
    }
    // noinspection JSDeprecatedSymbols
    if (updateInfo.path != null) {
        // noinspection JSDeprecatedSymbols
        return [
            {
                url: updateInfo.path,
                sha2: updateInfo.sha2,
                sha512: updateInfo.sha512,
            },
        ];
    }
    else {
        throw (0, builder_util_runtime_1.newError)(`No files provided: ${(0, builder_util_runtime_1.safeStringifyJson)(updateInfo)}`, "ERR_UPDATER_NO_FILES_PROVIDED");
    }
}
exports.getFileList = getFileList;
function resolveFiles(updateInfo, baseUrl, pathTransformer = (p) => p) {
    const files = getFileList(updateInfo);
    const result = files.map(fileInfo => {
        if (fileInfo.sha2 == null && fileInfo.sha512 == null) {
            throw (0, builder_util_runtime_1.newError)(`Update info doesn't contain nor sha256 neither sha512 checksum: ${(0, builder_util_runtime_1.safeStringifyJson)(fileInfo)}`, "ERR_UPDATER_NO_CHECKSUM");
        }
        return {
            url: (0, util_1.newUrlFromBase)(pathTransformer(fileInfo.url), baseUrl),
            info: fileInfo,
        };
    });
    const packages = updateInfo.packages;
    const packageInfo = packages == null ? null : packages[process.arch] || packages.ia32;
    if (packageInfo != null) {
        ;
        result[0].packageInfo = {
            ...packageInfo,
            path: (0, util_1.newUrlFromBase)(pathTransformer(packageInfo.path), baseUrl).href,
        };
    }
    return result;
}
exports.resolveFiles = resolveFiles;
//# sourceMappingURL=Provider.js.map

/***/ }),

/***/ 906:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.blockmapFiles = exports.getChannelFilename = exports.newUrlFromBase = exports.newBaseUrl = void 0;
// if baseUrl path doesn't ends with /, this path will be not prepended to passed pathname for new URL(input, base)
const url_1 = __webpack_require__(7016);
// @ts-ignore
const escapeRegExp = __webpack_require__(912);
/** @internal */
function newBaseUrl(url) {
    const result = new url_1.URL(url);
    if (!result.pathname.endsWith("/")) {
        result.pathname += "/";
    }
    return result;
}
exports.newBaseUrl = newBaseUrl;
// addRandomQueryToAvoidCaching is false by default because in most cases URL already contains version number,
// so, it makes sense only for Generic Provider for channel files
function newUrlFromBase(pathname, baseUrl, addRandomQueryToAvoidCaching = false) {
    const result = new url_1.URL(pathname, baseUrl);
    // search is not propagated (search is an empty string if not specified)
    const search = baseUrl.search;
    if (search != null && search.length !== 0) {
        result.search = search;
    }
    else if (addRandomQueryToAvoidCaching) {
        result.search = `noCache=${Date.now().toString(32)}`;
    }
    return result;
}
exports.newUrlFromBase = newUrlFromBase;
function getChannelFilename(channel) {
    return `${channel}.yml`;
}
exports.getChannelFilename = getChannelFilename;
function blockmapFiles(baseUrl, oldVersion, newVersion) {
    const newBlockMapUrl = newUrlFromBase(`${baseUrl.pathname}.blockmap`, baseUrl);
    const oldBlockMapUrl = newUrlFromBase(`${baseUrl.pathname.replace(new RegExp(escapeRegExp(newVersion), "g"), oldVersion)}.blockmap`, baseUrl);
    return [oldBlockMapUrl, newBlockMapUrl];
}
exports.blockmapFiles = blockmapFiles;
//# sourceMappingURL=util.js.map

/***/ }),

/***/ 6578:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.verifySignature = void 0;
const builder_util_runtime_1 = __webpack_require__(6551);
const child_process_1 = __webpack_require__(5317);
const os = __webpack_require__(857);
// $certificateInfo = (Get-AuthenticodeSignature 'xxx\yyy.exe'
// | where {$_.Status.Equals([System.Management.Automation.SignatureStatus]::Valid) -and $_.SignerCertificate.Subject.Contains("CN=siemens.com")})
// | Out-String ; if ($certificateInfo) { exit 0 } else { exit 1 }
function verifySignature(publisherNames, unescapedTempUpdateFile, logger) {
    return new Promise((resolve, reject) => {
        // Escape quotes and backticks in filenames to prevent user from breaking the
        // arguments and perform a remote command injection.
        //
        // Consider example powershell command:
        // ```powershell
        // Get-AuthenticodeSignature 'C:\\path\\my-bad-';calc;'filename.exe'
        // ```
        // The above would work expected and find the file name, however, it will also execute `;calc;`
        // command and start the calculator app.
        //
        // From Powershell quoting rules:
        // https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_quoting_rules?view=powershell-7
        // * Double quotes `"` are treated literally within single-quoted strings;
        // * Single quotes can be escaped by doubling them: 'don''t' -> don't;
        //
        // Also note that at this point the file has already been written to the disk, thus we are
        // guaranteed that the path will not contain any illegal characters like <>:"/\|?*
        // https://docs.microsoft.com/en-us/windows/win32/fileio/naming-a-file
        const tempUpdateFile = unescapedTempUpdateFile.replace(/'/g, "''");
        // https://github.com/electron-userland/electron-builder/issues/2421
        // https://github.com/electron-userland/electron-builder/issues/2535
        (0, child_process_1.execFile)("chcp 65001 >NUL & powershell.exe", ["-NoProfile", "-NonInteractive", "-InputFormat", "None", "-Command", `"Get-AuthenticodeSignature -LiteralPath '${tempUpdateFile}' | ConvertTo-Json -Compress"`], {
            shell: true,
            timeout: 20 * 1000,
        }, (error, stdout, stderr) => {
            try {
                if (error != null || stderr) {
                    handleError(logger, error, stderr, reject);
                    resolve(null);
                    return;
                }
                const data = parseOut(stdout);
                if (data.Status === 0) {
                    const subject = (0, builder_util_runtime_1.parseDn)(data.SignerCertificate.Subject);
                    let match = false;
                    for (const name of publisherNames) {
                        const dn = (0, builder_util_runtime_1.parseDn)(name);
                        if (dn.size) {
                            // if we have a full DN, compare all values
                            const allKeys = Array.from(dn.keys());
                            match = allKeys.every(key => {
                                return dn.get(key) === subject.get(key);
                            });
                        }
                        else if (name === subject.get("CN")) {
                            logger.warn(`Signature validated using only CN ${name}. Please add your full Distinguished Name (DN) to publisherNames configuration`);
                            match = true;
                        }
                        if (match) {
                            resolve(null);
                            return;
                        }
                    }
                }
                const result = `publisherNames: ${publisherNames.join(" | ")}, raw info: ` + JSON.stringify(data, (name, value) => (name === "RawData" ? undefined : value), 2);
                logger.warn(`Sign verification failed, installer signed with incorrect certificate: ${result}`);
                resolve(result);
            }
            catch (e) {
                handleError(logger, e, null, reject);
                resolve(null);
                return;
            }
        });
    });
}
exports.verifySignature = verifySignature;
function parseOut(out) {
    const data = JSON.parse(out);
    delete data.PrivateKey;
    delete data.IsOSBinary;
    delete data.SignatureType;
    const signerCertificate = data.SignerCertificate;
    if (signerCertificate != null) {
        delete signerCertificate.Archived;
        delete signerCertificate.Extensions;
        delete signerCertificate.Handle;
        delete signerCertificate.HasPrivateKey;
        // duplicates data.SignerCertificate (contains RawData)
        delete signerCertificate.SubjectName;
    }
    delete data.Path;
    return data;
}
function handleError(logger, error, stderr, reject) {
    if (isOldWin6()) {
        logger.warn(`Cannot execute Get-AuthenticodeSignature: ${error || stderr}. Ignoring signature validation due to unsupported powershell version. Please upgrade to powershell 3 or higher.`);
        return;
    }
    try {
        (0, child_process_1.execFileSync)("powershell.exe", ["-NoProfile", "-NonInteractive", "-Command", "ConvertTo-Json test"], { timeout: 10 * 1000 });
    }
    catch (testError) {
        logger.warn(`Cannot execute ConvertTo-Json: ${testError.message}. Ignoring signature validation due to unsupported powershell version. Please upgrade to powershell 3 or higher.`);
        return;
    }
    if (error != null) {
        reject(error);
    }
    if (stderr) {
        reject(new Error(`Cannot execute Get-AuthenticodeSignature, stderr: ${stderr}. Failing signature validation due to unknown stderr.`));
    }
}
function isOldWin6() {
    const winVersion = os.release();
    return winVersion.startsWith("6.") && !winVersion.startsWith("6.3");
}
//# sourceMappingURL=windowsExecutableCodeSignatureVerifier.js.map

/***/ }),

/***/ 1283:
/***/ ((module) => {

"use strict";


module.exports = clone

var getPrototypeOf = Object.getPrototypeOf || function (obj) {
  return obj.__proto__
}

function clone (obj) {
  if (obj === null || typeof obj !== 'object')
    return obj

  if (obj instanceof Object)
    var copy = { __proto__: getPrototypeOf(obj) }
  else
    var copy = Object.create(null)

  Object.getOwnPropertyNames(obj).forEach(function (key) {
    Object.defineProperty(copy, key, Object.getOwnPropertyDescriptor(obj, key))
  })

  return copy
}


/***/ }),

/***/ 3735:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var fs = __webpack_require__(9896)
var polyfills = __webpack_require__(9106)
var legacy = __webpack_require__(1995)
var clone = __webpack_require__(1283)

var util = __webpack_require__(9023)

/* istanbul ignore next - node 0.x polyfill */
var gracefulQueue
var previousSymbol

/* istanbul ignore else - node 0.x polyfill */
if (typeof Symbol === 'function' && typeof Symbol.for === 'function') {
  gracefulQueue = Symbol.for('graceful-fs.queue')
  // This is used in testing by future versions
  previousSymbol = Symbol.for('graceful-fs.previous')
} else {
  gracefulQueue = '___graceful-fs.queue'
  previousSymbol = '___graceful-fs.previous'
}

function noop () {}

function publishQueue(context, queue) {
  Object.defineProperty(context, gracefulQueue, {
    get: function() {
      return queue
    }
  })
}

var debug = noop
if (util.debuglog)
  debug = util.debuglog('gfs4')
else if (/\bgfs4\b/i.test(({"NODE_ENV":"production"}).NODE_DEBUG || ''))
  debug = function() {
    var m = util.format.apply(util, arguments)
    m = 'GFS4: ' + m.split(/\n/).join('\nGFS4: ')
    console.error(m)
  }

// Once time initialization
if (!fs[gracefulQueue]) {
  // This queue can be shared by multiple loaded instances
  var queue = global[gracefulQueue] || []
  publishQueue(fs, queue)

  // Patch fs.close/closeSync to shared queue version, because we need
  // to retry() whenever a close happens *anywhere* in the program.
  // This is essential when multiple graceful-fs instances are
  // in play at the same time.
  fs.close = (function (fs$close) {
    function close (fd, cb) {
      return fs$close.call(fs, fd, function (err) {
        // This function uses the graceful-fs shared queue
        if (!err) {
          resetQueue()
        }

        if (typeof cb === 'function')
          cb.apply(this, arguments)
      })
    }

    Object.defineProperty(close, previousSymbol, {
      value: fs$close
    })
    return close
  })(fs.close)

  fs.closeSync = (function (fs$closeSync) {
    function closeSync (fd) {
      // This function uses the graceful-fs shared queue
      fs$closeSync.apply(fs, arguments)
      resetQueue()
    }

    Object.defineProperty(closeSync, previousSymbol, {
      value: fs$closeSync
    })
    return closeSync
  })(fs.closeSync)

  if (/\bgfs4\b/i.test(({"NODE_ENV":"production"}).NODE_DEBUG || '')) {
    process.on('exit', function() {
      debug(fs[gracefulQueue])
      __webpack_require__(2613).equal(fs[gracefulQueue].length, 0)
    })
  }
}

if (!global[gracefulQueue]) {
  publishQueue(global, fs[gracefulQueue]);
}

module.exports = patch(clone(fs))
if (({"NODE_ENV":"production"}).TEST_GRACEFUL_FS_GLOBAL_PATCH && !fs.__patched) {
    module.exports = patch(fs)
    fs.__patched = true;
}

function patch (fs) {
  // Everything that references the open() function needs to be in here
  polyfills(fs)
  fs.gracefulify = patch

  fs.createReadStream = createReadStream
  fs.createWriteStream = createWriteStream
  var fs$readFile = fs.readFile
  fs.readFile = readFile
  function readFile (path, options, cb) {
    if (typeof options === 'function')
      cb = options, options = null

    return go$readFile(path, options, cb)

    function go$readFile (path, options, cb, startTime) {
      return fs$readFile(path, options, function (err) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$readFile, [path, options, cb], err, startTime || Date.now(), Date.now()])
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments)
        }
      })
    }
  }

  var fs$writeFile = fs.writeFile
  fs.writeFile = writeFile
  function writeFile (path, data, options, cb) {
    if (typeof options === 'function')
      cb = options, options = null

    return go$writeFile(path, data, options, cb)

    function go$writeFile (path, data, options, cb, startTime) {
      return fs$writeFile(path, data, options, function (err) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$writeFile, [path, data, options, cb], err, startTime || Date.now(), Date.now()])
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments)
        }
      })
    }
  }

  var fs$appendFile = fs.appendFile
  if (fs$appendFile)
    fs.appendFile = appendFile
  function appendFile (path, data, options, cb) {
    if (typeof options === 'function')
      cb = options, options = null

    return go$appendFile(path, data, options, cb)

    function go$appendFile (path, data, options, cb, startTime) {
      return fs$appendFile(path, data, options, function (err) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$appendFile, [path, data, options, cb], err, startTime || Date.now(), Date.now()])
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments)
        }
      })
    }
  }

  var fs$copyFile = fs.copyFile
  if (fs$copyFile)
    fs.copyFile = copyFile
  function copyFile (src, dest, flags, cb) {
    if (typeof flags === 'function') {
      cb = flags
      flags = 0
    }
    return go$copyFile(src, dest, flags, cb)

    function go$copyFile (src, dest, flags, cb, startTime) {
      return fs$copyFile(src, dest, flags, function (err) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$copyFile, [src, dest, flags, cb], err, startTime || Date.now(), Date.now()])
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments)
        }
      })
    }
  }

  var fs$readdir = fs.readdir
  fs.readdir = readdir
  var noReaddirOptionVersions = /^v[0-5]\./
  function readdir (path, options, cb) {
    if (typeof options === 'function')
      cb = options, options = null

    var go$readdir = noReaddirOptionVersions.test(process.version)
      ? function go$readdir (path, options, cb, startTime) {
        return fs$readdir(path, fs$readdirCallback(
          path, options, cb, startTime
        ))
      }
      : function go$readdir (path, options, cb, startTime) {
        return fs$readdir(path, options, fs$readdirCallback(
          path, options, cb, startTime
        ))
      }

    return go$readdir(path, options, cb)

    function fs$readdirCallback (path, options, cb, startTime) {
      return function (err, files) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([
            go$readdir,
            [path, options, cb],
            err,
            startTime || Date.now(),
            Date.now()
          ])
        else {
          if (files && files.sort)
            files.sort()

          if (typeof cb === 'function')
            cb.call(this, err, files)
        }
      }
    }
  }

  if (process.version.substr(0, 4) === 'v0.8') {
    var legStreams = legacy(fs)
    ReadStream = legStreams.ReadStream
    WriteStream = legStreams.WriteStream
  }

  var fs$ReadStream = fs.ReadStream
  if (fs$ReadStream) {
    ReadStream.prototype = Object.create(fs$ReadStream.prototype)
    ReadStream.prototype.open = ReadStream$open
  }

  var fs$WriteStream = fs.WriteStream
  if (fs$WriteStream) {
    WriteStream.prototype = Object.create(fs$WriteStream.prototype)
    WriteStream.prototype.open = WriteStream$open
  }

  Object.defineProperty(fs, 'ReadStream', {
    get: function () {
      return ReadStream
    },
    set: function (val) {
      ReadStream = val
    },
    enumerable: true,
    configurable: true
  })
  Object.defineProperty(fs, 'WriteStream', {
    get: function () {
      return WriteStream
    },
    set: function (val) {
      WriteStream = val
    },
    enumerable: true,
    configurable: true
  })

  // legacy names
  var FileReadStream = ReadStream
  Object.defineProperty(fs, 'FileReadStream', {
    get: function () {
      return FileReadStream
    },
    set: function (val) {
      FileReadStream = val
    },
    enumerable: true,
    configurable: true
  })
  var FileWriteStream = WriteStream
  Object.defineProperty(fs, 'FileWriteStream', {
    get: function () {
      return FileWriteStream
    },
    set: function (val) {
      FileWriteStream = val
    },
    enumerable: true,
    configurable: true
  })

  function ReadStream (path, options) {
    if (this instanceof ReadStream)
      return fs$ReadStream.apply(this, arguments), this
    else
      return ReadStream.apply(Object.create(ReadStream.prototype), arguments)
  }

  function ReadStream$open () {
    var that = this
    open(that.path, that.flags, that.mode, function (err, fd) {
      if (err) {
        if (that.autoClose)
          that.destroy()

        that.emit('error', err)
      } else {
        that.fd = fd
        that.emit('open', fd)
        that.read()
      }
    })
  }

  function WriteStream (path, options) {
    if (this instanceof WriteStream)
      return fs$WriteStream.apply(this, arguments), this
    else
      return WriteStream.apply(Object.create(WriteStream.prototype), arguments)
  }

  function WriteStream$open () {
    var that = this
    open(that.path, that.flags, that.mode, function (err, fd) {
      if (err) {
        that.destroy()
        that.emit('error', err)
      } else {
        that.fd = fd
        that.emit('open', fd)
      }
    })
  }

  function createReadStream (path, options) {
    return new fs.ReadStream(path, options)
  }

  function createWriteStream (path, options) {
    return new fs.WriteStream(path, options)
  }

  var fs$open = fs.open
  fs.open = open
  function open (path, flags, mode, cb) {
    if (typeof mode === 'function')
      cb = mode, mode = null

    return go$open(path, flags, mode, cb)

    function go$open (path, flags, mode, cb, startTime) {
      return fs$open(path, flags, mode, function (err, fd) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$open, [path, flags, mode, cb], err, startTime || Date.now(), Date.now()])
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments)
        }
      })
    }
  }

  return fs
}

function enqueue (elem) {
  debug('ENQUEUE', elem[0].name, elem[1])
  fs[gracefulQueue].push(elem)
  retry()
}

// keep track of the timeout between retry() calls
var retryTimer

// reset the startTime and lastTime to now
// this resets the start of the 60 second overall timeout as well as the
// delay between attempts so that we'll retry these jobs sooner
function resetQueue () {
  var now = Date.now()
  for (var i = 0; i < fs[gracefulQueue].length; ++i) {
    // entries that are only a length of 2 are from an older version, don't
    // bother modifying those since they'll be retried anyway.
    if (fs[gracefulQueue][i].length > 2) {
      fs[gracefulQueue][i][3] = now // startTime
      fs[gracefulQueue][i][4] = now // lastTime
    }
  }
  // call retry to make sure we're actively processing the queue
  retry()
}

function retry () {
  // clear the timer and remove it to help prevent unintended concurrency
  clearTimeout(retryTimer)
  retryTimer = undefined

  if (fs[gracefulQueue].length === 0)
    return

  var elem = fs[gracefulQueue].shift()
  var fn = elem[0]
  var args = elem[1]
  // these items may be unset if they were added by an older graceful-fs
  var err = elem[2]
  var startTime = elem[3]
  var lastTime = elem[4]

  // if we don't have a startTime we have no way of knowing if we've waited
  // long enough, so go ahead and retry this item now
  if (startTime === undefined) {
    debug('RETRY', fn.name, args)
    fn.apply(null, args)
  } else if (Date.now() - startTime >= 60000) {
    // it's been more than 60 seconds total, bail now
    debug('TIMEOUT', fn.name, args)
    var cb = args.pop()
    if (typeof cb === 'function')
      cb.call(null, err)
  } else {
    // the amount of time between the last attempt and right now
    var sinceAttempt = Date.now() - lastTime
    // the amount of time between when we first tried, and when we last tried
    // rounded up to at least 1
    var sinceStart = Math.max(lastTime - startTime, 1)
    // backoff. wait longer than the total time we've been retrying, but only
    // up to a maximum of 100ms
    var desiredDelay = Math.min(sinceStart * 1.2, 100)
    // it's been long enough since the last retry, do it again
    if (sinceAttempt >= desiredDelay) {
      debug('RETRY', fn.name, args)
      fn.apply(null, args.concat([startTime]))
    } else {
      // if we can't do this job yet, push it to the end of the queue
      // and let the next iteration check again
      fs[gracefulQueue].push(elem)
    }
  }

  // schedule our next run if one isn't already scheduled
  if (retryTimer === undefined) {
    retryTimer = setTimeout(retry, 0)
  }
}


/***/ }),

/***/ 1995:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Stream = (__webpack_require__(2203).Stream)

module.exports = legacy

function legacy (fs) {
  return {
    ReadStream: ReadStream,
    WriteStream: WriteStream
  }

  function ReadStream (path, options) {
    if (!(this instanceof ReadStream)) return new ReadStream(path, options);

    Stream.call(this);

    var self = this;

    this.path = path;
    this.fd = null;
    this.readable = true;
    this.paused = false;

    this.flags = 'r';
    this.mode = 438; /*=0666*/
    this.bufferSize = 64 * 1024;

    options = options || {};

    // Mixin options into this
    var keys = Object.keys(options);
    for (var index = 0, length = keys.length; index < length; index++) {
      var key = keys[index];
      this[key] = options[key];
    }

    if (this.encoding) this.setEncoding(this.encoding);

    if (this.start !== undefined) {
      if ('number' !== typeof this.start) {
        throw TypeError('start must be a Number');
      }
      if (this.end === undefined) {
        this.end = Infinity;
      } else if ('number' !== typeof this.end) {
        throw TypeError('end must be a Number');
      }

      if (this.start > this.end) {
        throw new Error('start must be <= end');
      }

      this.pos = this.start;
    }

    if (this.fd !== null) {
      process.nextTick(function() {
        self._read();
      });
      return;
    }

    fs.open(this.path, this.flags, this.mode, function (err, fd) {
      if (err) {
        self.emit('error', err);
        self.readable = false;
        return;
      }

      self.fd = fd;
      self.emit('open', fd);
      self._read();
    })
  }

  function WriteStream (path, options) {
    if (!(this instanceof WriteStream)) return new WriteStream(path, options);

    Stream.call(this);

    this.path = path;
    this.fd = null;
    this.writable = true;

    this.flags = 'w';
    this.encoding = 'binary';
    this.mode = 438; /*=0666*/
    this.bytesWritten = 0;

    options = options || {};

    // Mixin options into this
    var keys = Object.keys(options);
    for (var index = 0, length = keys.length; index < length; index++) {
      var key = keys[index];
      this[key] = options[key];
    }

    if (this.start !== undefined) {
      if ('number' !== typeof this.start) {
        throw TypeError('start must be a Number');
      }
      if (this.start < 0) {
        throw new Error('start must be >= zero');
      }

      this.pos = this.start;
    }

    this.busy = false;
    this._queue = [];

    if (this.fd === null) {
      this._open = fs.open;
      this._queue.push([this._open, this.path, this.flags, this.mode, undefined]);
      this.flush();
    }
  }
}


/***/ }),

/***/ 9106:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var constants = __webpack_require__(9140)

var origCwd = process.cwd
var cwd = null

var platform = ({"NODE_ENV":"production"}).GRACEFUL_FS_PLATFORM || process.platform

process.cwd = function() {
  if (!cwd)
    cwd = origCwd.call(process)
  return cwd
}
try {
  process.cwd()
} catch (er) {}

// This check is needed until node.js 12 is required
if (typeof process.chdir === 'function') {
  var chdir = process.chdir
  process.chdir = function (d) {
    cwd = null
    chdir.call(process, d)
  }
  if (Object.setPrototypeOf) Object.setPrototypeOf(process.chdir, chdir)
}

module.exports = patch

function patch (fs) {
  // (re-)implement some things that are known busted or missing.

  // lchmod, broken prior to 0.6.2
  // back-port the fix here.
  if (constants.hasOwnProperty('O_SYMLINK') &&
      process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
    patchLchmod(fs)
  }

  // lutimes implementation, or no-op
  if (!fs.lutimes) {
    patchLutimes(fs)
  }

  // https://github.com/isaacs/node-graceful-fs/issues/4
  // Chown should not fail on einval or eperm if non-root.
  // It should not fail on enosys ever, as this just indicates
  // that a fs doesn't support the intended operation.

  fs.chown = chownFix(fs.chown)
  fs.fchown = chownFix(fs.fchown)
  fs.lchown = chownFix(fs.lchown)

  fs.chmod = chmodFix(fs.chmod)
  fs.fchmod = chmodFix(fs.fchmod)
  fs.lchmod = chmodFix(fs.lchmod)

  fs.chownSync = chownFixSync(fs.chownSync)
  fs.fchownSync = chownFixSync(fs.fchownSync)
  fs.lchownSync = chownFixSync(fs.lchownSync)

  fs.chmodSync = chmodFixSync(fs.chmodSync)
  fs.fchmodSync = chmodFixSync(fs.fchmodSync)
  fs.lchmodSync = chmodFixSync(fs.lchmodSync)

  fs.stat = statFix(fs.stat)
  fs.fstat = statFix(fs.fstat)
  fs.lstat = statFix(fs.lstat)

  fs.statSync = statFixSync(fs.statSync)
  fs.fstatSync = statFixSync(fs.fstatSync)
  fs.lstatSync = statFixSync(fs.lstatSync)

  // if lchmod/lchown do not exist, then make them no-ops
  if (fs.chmod && !fs.lchmod) {
    fs.lchmod = function (path, mode, cb) {
      if (cb) process.nextTick(cb)
    }
    fs.lchmodSync = function () {}
  }
  if (fs.chown && !fs.lchown) {
    fs.lchown = function (path, uid, gid, cb) {
      if (cb) process.nextTick(cb)
    }
    fs.lchownSync = function () {}
  }

  // on Windows, A/V software can lock the directory, causing this
  // to fail with an EACCES or EPERM if the directory contains newly
  // created files.  Try again on failure, for up to 60 seconds.

  // Set the timeout this long because some Windows Anti-Virus, such as Parity
  // bit9, may lock files for up to a minute, causing npm package install
  // failures. Also, take care to yield the scheduler. Windows scheduling gives
  // CPU to a busy looping process, which can cause the program causing the lock
  // contention to be starved of CPU by node, so the contention doesn't resolve.
  if (platform === "win32") {
    fs.rename = typeof fs.rename !== 'function' ? fs.rename
    : (function (fs$rename) {
      function rename (from, to, cb) {
        var start = Date.now()
        var backoff = 0;
        fs$rename(from, to, function CB (er) {
          if (er
              && (er.code === "EACCES" || er.code === "EPERM" || er.code === "EBUSY")
              && Date.now() - start < 60000) {
            setTimeout(function() {
              fs.stat(to, function (stater, st) {
                if (stater && stater.code === "ENOENT")
                  fs$rename(from, to, CB);
                else
                  cb(er)
              })
            }, backoff)
            if (backoff < 100)
              backoff += 10;
            return;
          }
          if (cb) cb(er)
        })
      }
      if (Object.setPrototypeOf) Object.setPrototypeOf(rename, fs$rename)
      return rename
    })(fs.rename)
  }

  // if read() returns EAGAIN, then just try it again.
  fs.read = typeof fs.read !== 'function' ? fs.read
  : (function (fs$read) {
    function read (fd, buffer, offset, length, position, callback_) {
      var callback
      if (callback_ && typeof callback_ === 'function') {
        var eagCounter = 0
        callback = function (er, _, __) {
          if (er && er.code === 'EAGAIN' && eagCounter < 10) {
            eagCounter ++
            return fs$read.call(fs, fd, buffer, offset, length, position, callback)
          }
          callback_.apply(this, arguments)
        }
      }
      return fs$read.call(fs, fd, buffer, offset, length, position, callback)
    }

    // This ensures `util.promisify` works as it does for native `fs.read`.
    if (Object.setPrototypeOf) Object.setPrototypeOf(read, fs$read)
    return read
  })(fs.read)

  fs.readSync = typeof fs.readSync !== 'function' ? fs.readSync
  : (function (fs$readSync) { return function (fd, buffer, offset, length, position) {
    var eagCounter = 0
    while (true) {
      try {
        return fs$readSync.call(fs, fd, buffer, offset, length, position)
      } catch (er) {
        if (er.code === 'EAGAIN' && eagCounter < 10) {
          eagCounter ++
          continue
        }
        throw er
      }
    }
  }})(fs.readSync)

  function patchLchmod (fs) {
    fs.lchmod = function (path, mode, callback) {
      fs.open( path
             , constants.O_WRONLY | constants.O_SYMLINK
             , mode
             , function (err, fd) {
        if (err) {
          if (callback) callback(err)
          return
        }
        // prefer to return the chmod error, if one occurs,
        // but still try to close, and report closing errors if they occur.
        fs.fchmod(fd, mode, function (err) {
          fs.close(fd, function(err2) {
            if (callback) callback(err || err2)
          })
        })
      })
    }

    fs.lchmodSync = function (path, mode) {
      var fd = fs.openSync(path, constants.O_WRONLY | constants.O_SYMLINK, mode)

      // prefer to return the chmod error, if one occurs,
      // but still try to close, and report closing errors if they occur.
      var threw = true
      var ret
      try {
        ret = fs.fchmodSync(fd, mode)
        threw = false
      } finally {
        if (threw) {
          try {
            fs.closeSync(fd)
          } catch (er) {}
        } else {
          fs.closeSync(fd)
        }
      }
      return ret
    }
  }

  function patchLutimes (fs) {
    if (constants.hasOwnProperty("O_SYMLINK") && fs.futimes) {
      fs.lutimes = function (path, at, mt, cb) {
        fs.open(path, constants.O_SYMLINK, function (er, fd) {
          if (er) {
            if (cb) cb(er)
            return
          }
          fs.futimes(fd, at, mt, function (er) {
            fs.close(fd, function (er2) {
              if (cb) cb(er || er2)
            })
          })
        })
      }

      fs.lutimesSync = function (path, at, mt) {
        var fd = fs.openSync(path, constants.O_SYMLINK)
        var ret
        var threw = true
        try {
          ret = fs.futimesSync(fd, at, mt)
          threw = false
        } finally {
          if (threw) {
            try {
              fs.closeSync(fd)
            } catch (er) {}
          } else {
            fs.closeSync(fd)
          }
        }
        return ret
      }

    } else if (fs.futimes) {
      fs.lutimes = function (_a, _b, _c, cb) { if (cb) process.nextTick(cb) }
      fs.lutimesSync = function () {}
    }
  }

  function chmodFix (orig) {
    if (!orig) return orig
    return function (target, mode, cb) {
      return orig.call(fs, target, mode, function (er) {
        if (chownErOk(er)) er = null
        if (cb) cb.apply(this, arguments)
      })
    }
  }

  function chmodFixSync (orig) {
    if (!orig) return orig
    return function (target, mode) {
      try {
        return orig.call(fs, target, mode)
      } catch (er) {
        if (!chownErOk(er)) throw er
      }
    }
  }


  function chownFix (orig) {
    if (!orig) return orig
    return function (target, uid, gid, cb) {
      return orig.call(fs, target, uid, gid, function (er) {
        if (chownErOk(er)) er = null
        if (cb) cb.apply(this, arguments)
      })
    }
  }

  function chownFixSync (orig) {
    if (!orig) return orig
    return function (target, uid, gid) {
      try {
        return orig.call(fs, target, uid, gid)
      } catch (er) {
        if (!chownErOk(er)) throw er
      }
    }
  }

  function statFix (orig) {
    if (!orig) return orig
    // Older versions of Node erroneously returned signed integers for
    // uid + gid.
    return function (target, options, cb) {
      if (typeof options === 'function') {
        cb = options
        options = null
      }
      function callback (er, stats) {
        if (stats) {
          if (stats.uid < 0) stats.uid += 0x100000000
          if (stats.gid < 0) stats.gid += 0x100000000
        }
        if (cb) cb.apply(this, arguments)
      }
      return options ? orig.call(fs, target, options, callback)
        : orig.call(fs, target, callback)
    }
  }

  function statFixSync (orig) {
    if (!orig) return orig
    // Older versions of Node erroneously returned signed integers for
    // uid + gid.
    return function (target, options) {
      var stats = options ? orig.call(fs, target, options)
        : orig.call(fs, target)
      if (stats) {
        if (stats.uid < 0) stats.uid += 0x100000000
        if (stats.gid < 0) stats.gid += 0x100000000
      }
      return stats;
    }
  }

  // ENOSYS means that the fs doesn't support the op. Just ignore
  // that, because it doesn't matter.
  //
  // if there's no getuid, or if getuid() is something other
  // than 0, and the error is EINVAL or EPERM, then just ignore
  // it.
  //
  // This specific case is a silent failure in cp, install, tar,
  // and most other unix tools that manage permissions.
  //
  // When running as root, or if other types of errors are
  // encountered, then it's strict.
  function chownErOk (er) {
    if (!er)
      return true

    if (er.code === "ENOSYS")
      return true

    var nonroot = !process.getuid || process.getuid() !== 0
    if (nonroot) {
      if (er.code === "EINVAL" || er.code === "EPERM")
        return true
    }

    return false
  }
}


/***/ }),

/***/ 5884:
/***/ ((module) => {

"use strict";


module.exports = (flag, argv = process.argv) => {
	const prefix = flag.startsWith('-') ? '' : (flag.length === 1 ? '-' : '--');
	const position = argv.indexOf(prefix + flag);
	const terminatorPosition = argv.indexOf('--');
	return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
};


/***/ }),

/***/ 7161:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

var Buffer = (__webpack_require__(4774).Buffer);

// Multibyte codec. In this scheme, a character is represented by 1 or more bytes.
// Our codec supports UTF-16 surrogates, extensions for GB18030 and unicode sequences.
// To save memory and loading time, we read table files only when requested.

exports._dbcs = DBCSCodec;

var UNASSIGNED = -1,
    GB18030_CODE = -2,
    SEQ_START  = -10,
    NODE_START = -1000,
    UNASSIGNED_NODE = new Array(0x100),
    DEF_CHAR = -1;

for (var i = 0; i < 0x100; i++)
    UNASSIGNED_NODE[i] = UNASSIGNED;


// Class DBCSCodec reads and initializes mapping tables.
function DBCSCodec(codecOptions, iconv) {
    this.encodingName = codecOptions.encodingName;
    if (!codecOptions)
        throw new Error("DBCS codec is called without the data.")
    if (!codecOptions.table)
        throw new Error("Encoding '" + this.encodingName + "' has no data.");

    // Load tables.
    var mappingTable = codecOptions.table();


    // Decode tables: MBCS -> Unicode.

    // decodeTables is a trie, encoded as an array of arrays of integers. Internal arrays are trie nodes and all have len = 256.
    // Trie root is decodeTables[0].
    // Values: >=  0 -> unicode character code. can be > 0xFFFF
    //         == UNASSIGNED -> unknown/unassigned sequence.
    //         == GB18030_CODE -> this is the end of a GB18030 4-byte sequence.
    //         <= NODE_START -> index of the next node in our trie to process next byte.
    //         <= SEQ_START  -> index of the start of a character code sequence, in decodeTableSeq.
    this.decodeTables = [];
    this.decodeTables[0] = UNASSIGNED_NODE.slice(0); // Create root node.

    // Sometimes a MBCS char corresponds to a sequence of unicode chars. We store them as arrays of integers here. 
    this.decodeTableSeq = [];

    // Actual mapping tables consist of chunks. Use them to fill up decode tables.
    for (var i = 0; i < mappingTable.length; i++)
        this._addDecodeChunk(mappingTable[i]);

    // Load & create GB18030 tables when needed.
    if (typeof codecOptions.gb18030 === 'function') {
        this.gb18030 = codecOptions.gb18030(); // Load GB18030 ranges.

        // Add GB18030 common decode nodes.
        var commonThirdByteNodeIdx = this.decodeTables.length;
        this.decodeTables.push(UNASSIGNED_NODE.slice(0));

        var commonFourthByteNodeIdx = this.decodeTables.length;
        this.decodeTables.push(UNASSIGNED_NODE.slice(0));

        // Fill out the tree
        var firstByteNode = this.decodeTables[0];
        for (var i = 0x81; i <= 0xFE; i++) {
            var secondByteNode = this.decodeTables[NODE_START - firstByteNode[i]];
            for (var j = 0x30; j <= 0x39; j++) {
                if (secondByteNode[j] === UNASSIGNED) {
                    secondByteNode[j] = NODE_START - commonThirdByteNodeIdx;
                } else if (secondByteNode[j] > NODE_START) {
                    throw new Error("gb18030 decode tables conflict at byte 2");
                }

                var thirdByteNode = this.decodeTables[NODE_START - secondByteNode[j]];
                for (var k = 0x81; k <= 0xFE; k++) {
                    if (thirdByteNode[k] === UNASSIGNED) {
                        thirdByteNode[k] = NODE_START - commonFourthByteNodeIdx;
                    } else if (thirdByteNode[k] === NODE_START - commonFourthByteNodeIdx) {
                        continue;
                    } else if (thirdByteNode[k] > NODE_START) {
                        throw new Error("gb18030 decode tables conflict at byte 3");
                    }

                    var fourthByteNode = this.decodeTables[NODE_START - thirdByteNode[k]];
                    for (var l = 0x30; l <= 0x39; l++) {
                        if (fourthByteNode[l] === UNASSIGNED)
                            fourthByteNode[l] = GB18030_CODE;
                    }
                }
            }
        }
    }

    this.defaultCharUnicode = iconv.defaultCharUnicode;

    
    // Encode tables: Unicode -> DBCS.

    // `encodeTable` is array mapping from unicode char to encoded char. All its values are integers for performance.
    // Because it can be sparse, it is represented as array of buckets by 256 chars each. Bucket can be null.
    // Values: >=  0 -> it is a normal char. Write the value (if <=256 then 1 byte, if <=65536 then 2 bytes, etc.).
    //         == UNASSIGNED -> no conversion found. Output a default char.
    //         <= SEQ_START  -> it's an index in encodeTableSeq, see below. The character starts a sequence.
    this.encodeTable = [];
    
    // `encodeTableSeq` is used when a sequence of unicode characters is encoded as a single code. We use a tree of
    // objects where keys correspond to characters in sequence and leafs are the encoded dbcs values. A special DEF_CHAR key
    // means end of sequence (needed when one sequence is a strict subsequence of another).
    // Objects are kept separately from encodeTable to increase performance.
    this.encodeTableSeq = [];

    // Some chars can be decoded, but need not be encoded.
    var skipEncodeChars = {};
    if (codecOptions.encodeSkipVals)
        for (var i = 0; i < codecOptions.encodeSkipVals.length; i++) {
            var val = codecOptions.encodeSkipVals[i];
            if (typeof val === 'number')
                skipEncodeChars[val] = true;
            else
                for (var j = val.from; j <= val.to; j++)
                    skipEncodeChars[j] = true;
        }
        
    // Use decode trie to recursively fill out encode tables.
    this._fillEncodeTable(0, 0, skipEncodeChars);

    // Add more encoding pairs when needed.
    if (codecOptions.encodeAdd) {
        for (var uChar in codecOptions.encodeAdd)
            if (Object.prototype.hasOwnProperty.call(codecOptions.encodeAdd, uChar))
                this._setEncodeChar(uChar.charCodeAt(0), codecOptions.encodeAdd[uChar]);
    }

    this.defCharSB  = this.encodeTable[0][iconv.defaultCharSingleByte.charCodeAt(0)];
    if (this.defCharSB === UNASSIGNED) this.defCharSB = this.encodeTable[0]['?'];
    if (this.defCharSB === UNASSIGNED) this.defCharSB = "?".charCodeAt(0);
}

DBCSCodec.prototype.encoder = DBCSEncoder;
DBCSCodec.prototype.decoder = DBCSDecoder;

// Decoder helpers
DBCSCodec.prototype._getDecodeTrieNode = function(addr) {
    var bytes = [];
    for (; addr > 0; addr >>>= 8)
        bytes.push(addr & 0xFF);
    if (bytes.length == 0)
        bytes.push(0);

    var node = this.decodeTables[0];
    for (var i = bytes.length-1; i > 0; i--) { // Traverse nodes deeper into the trie.
        var val = node[bytes[i]];

        if (val == UNASSIGNED) { // Create new node.
            node[bytes[i]] = NODE_START - this.decodeTables.length;
            this.decodeTables.push(node = UNASSIGNED_NODE.slice(0));
        }
        else if (val <= NODE_START) { // Existing node.
            node = this.decodeTables[NODE_START - val];
        }
        else
            throw new Error("Overwrite byte in " + this.encodingName + ", addr: " + addr.toString(16));
    }
    return node;
}


DBCSCodec.prototype._addDecodeChunk = function(chunk) {
    // First element of chunk is the hex mbcs code where we start.
    var curAddr = parseInt(chunk[0], 16);

    // Choose the decoding node where we'll write our chars.
    var writeTable = this._getDecodeTrieNode(curAddr);
    curAddr = curAddr & 0xFF;

    // Write all other elements of the chunk to the table.
    for (var k = 1; k < chunk.length; k++) {
        var part = chunk[k];
        if (typeof part === "string") { // String, write as-is.
            for (var l = 0; l < part.length;) {
                var code = part.charCodeAt(l++);
                if (0xD800 <= code && code < 0xDC00) { // Decode surrogate
                    var codeTrail = part.charCodeAt(l++);
                    if (0xDC00 <= codeTrail && codeTrail < 0xE000)
                        writeTable[curAddr++] = 0x10000 + (code - 0xD800) * 0x400 + (codeTrail - 0xDC00);
                    else
                        throw new Error("Incorrect surrogate pair in "  + this.encodingName + " at chunk " + chunk[0]);
                }
                else if (0x0FF0 < code && code <= 0x0FFF) { // Character sequence (our own encoding used)
                    var len = 0xFFF - code + 2;
                    var seq = [];
                    for (var m = 0; m < len; m++)
                        seq.push(part.charCodeAt(l++)); // Simple variation: don't support surrogates or subsequences in seq.

                    writeTable[curAddr++] = SEQ_START - this.decodeTableSeq.length;
                    this.decodeTableSeq.push(seq);
                }
                else
                    writeTable[curAddr++] = code; // Basic char
            }
        } 
        else if (typeof part === "number") { // Integer, meaning increasing sequence starting with prev character.
            var charCode = writeTable[curAddr - 1] + 1;
            for (var l = 0; l < part; l++)
                writeTable[curAddr++] = charCode++;
        }
        else
            throw new Error("Incorrect type '" + typeof part + "' given in "  + this.encodingName + " at chunk " + chunk[0]);
    }
    if (curAddr > 0xFF)
        throw new Error("Incorrect chunk in "  + this.encodingName + " at addr " + chunk[0] + ": too long" + curAddr);
}

// Encoder helpers
DBCSCodec.prototype._getEncodeBucket = function(uCode) {
    var high = uCode >> 8; // This could be > 0xFF because of astral characters.
    if (this.encodeTable[high] === undefined)
        this.encodeTable[high] = UNASSIGNED_NODE.slice(0); // Create bucket on demand.
    return this.encodeTable[high];
}

DBCSCodec.prototype._setEncodeChar = function(uCode, dbcsCode) {
    var bucket = this._getEncodeBucket(uCode);
    var low = uCode & 0xFF;
    if (bucket[low] <= SEQ_START)
        this.encodeTableSeq[SEQ_START-bucket[low]][DEF_CHAR] = dbcsCode; // There's already a sequence, set a single-char subsequence of it.
    else if (bucket[low] == UNASSIGNED)
        bucket[low] = dbcsCode;
}

DBCSCodec.prototype._setEncodeSequence = function(seq, dbcsCode) {
    
    // Get the root of character tree according to first character of the sequence.
    var uCode = seq[0];
    var bucket = this._getEncodeBucket(uCode);
    var low = uCode & 0xFF;

    var node;
    if (bucket[low] <= SEQ_START) {
        // There's already a sequence with  - use it.
        node = this.encodeTableSeq[SEQ_START-bucket[low]];
    }
    else {
        // There was no sequence object - allocate a new one.
        node = {};
        if (bucket[low] !== UNASSIGNED) node[DEF_CHAR] = bucket[low]; // If a char was set before - make it a single-char subsequence.
        bucket[low] = SEQ_START - this.encodeTableSeq.length;
        this.encodeTableSeq.push(node);
    }

    // Traverse the character tree, allocating new nodes as needed.
    for (var j = 1; j < seq.length-1; j++) {
        var oldVal = node[uCode];
        if (typeof oldVal === 'object')
            node = oldVal;
        else {
            node = node[uCode] = {}
            if (oldVal !== undefined)
                node[DEF_CHAR] = oldVal
        }
    }

    // Set the leaf to given dbcsCode.
    uCode = seq[seq.length-1];
    node[uCode] = dbcsCode;
}

DBCSCodec.prototype._fillEncodeTable = function(nodeIdx, prefix, skipEncodeChars) {
    var node = this.decodeTables[nodeIdx];
    var hasValues = false;
    var subNodeEmpty = {};
    for (var i = 0; i < 0x100; i++) {
        var uCode = node[i];
        var mbCode = prefix + i;
        if (skipEncodeChars[mbCode])
            continue;

        if (uCode >= 0) {
            this._setEncodeChar(uCode, mbCode);
            hasValues = true;
        } else if (uCode <= NODE_START) {
            var subNodeIdx = NODE_START - uCode;
            if (!subNodeEmpty[subNodeIdx]) {  // Skip empty subtrees (they are too large in gb18030).
                var newPrefix = (mbCode << 8) >>> 0;  // NOTE: '>>> 0' keeps 32-bit num positive.
                if (this._fillEncodeTable(subNodeIdx, newPrefix, skipEncodeChars))
                    hasValues = true;
                else
                    subNodeEmpty[subNodeIdx] = true;
            }
        } else if (uCode <= SEQ_START) {
            this._setEncodeSequence(this.decodeTableSeq[SEQ_START - uCode], mbCode);
            hasValues = true;
        }
    }
    return hasValues;
}



// == Encoder ==================================================================

function DBCSEncoder(options, codec) {
    // Encoder state
    this.leadSurrogate = -1;
    this.seqObj = undefined;
    
    // Static data
    this.encodeTable = codec.encodeTable;
    this.encodeTableSeq = codec.encodeTableSeq;
    this.defaultCharSingleByte = codec.defCharSB;
    this.gb18030 = codec.gb18030;
}

DBCSEncoder.prototype.write = function(str) {
    var newBuf = Buffer.alloc(str.length * (this.gb18030 ? 4 : 3)),
        leadSurrogate = this.leadSurrogate,
        seqObj = this.seqObj, nextChar = -1,
        i = 0, j = 0;

    while (true) {
        // 0. Get next character.
        if (nextChar === -1) {
            if (i == str.length) break;
            var uCode = str.charCodeAt(i++);
        }
        else {
            var uCode = nextChar;
            nextChar = -1;    
        }

        // 1. Handle surrogates.
        if (0xD800 <= uCode && uCode < 0xE000) { // Char is one of surrogates.
            if (uCode < 0xDC00) { // We've got lead surrogate.
                if (leadSurrogate === -1) {
                    leadSurrogate = uCode;
                    continue;
                } else {
                    leadSurrogate = uCode;
                    // Double lead surrogate found.
                    uCode = UNASSIGNED;
                }
            } else { // We've got trail surrogate.
                if (leadSurrogate !== -1) {
                    uCode = 0x10000 + (leadSurrogate - 0xD800) * 0x400 + (uCode - 0xDC00);
                    leadSurrogate = -1;
                } else {
                    // Incomplete surrogate pair - only trail surrogate found.
                    uCode = UNASSIGNED;
                }
                
            }
        }
        else if (leadSurrogate !== -1) {
            // Incomplete surrogate pair - only lead surrogate found.
            nextChar = uCode; uCode = UNASSIGNED; // Write an error, then current char.
            leadSurrogate = -1;
        }

        // 2. Convert uCode character.
        var dbcsCode = UNASSIGNED;
        if (seqObj !== undefined && uCode != UNASSIGNED) { // We are in the middle of the sequence
            var resCode = seqObj[uCode];
            if (typeof resCode === 'object') { // Sequence continues.
                seqObj = resCode;
                continue;

            } else if (typeof resCode == 'number') { // Sequence finished. Write it.
                dbcsCode = resCode;

            } else if (resCode == undefined) { // Current character is not part of the sequence.

                // Try default character for this sequence
                resCode = seqObj[DEF_CHAR];
                if (resCode !== undefined) {
                    dbcsCode = resCode; // Found. Write it.
                    nextChar = uCode; // Current character will be written too in the next iteration.

                } else {
                    // TODO: What if we have no default? (resCode == undefined)
                    // Then, we should write first char of the sequence as-is and try the rest recursively.
                    // Didn't do it for now because no encoding has this situation yet.
                    // Currently, just skip the sequence and write current char.
                }
            }
            seqObj = undefined;
        }
        else if (uCode >= 0) {  // Regular character
            var subtable = this.encodeTable[uCode >> 8];
            if (subtable !== undefined)
                dbcsCode = subtable[uCode & 0xFF];
            
            if (dbcsCode <= SEQ_START) { // Sequence start
                seqObj = this.encodeTableSeq[SEQ_START-dbcsCode];
                continue;
            }

            if (dbcsCode == UNASSIGNED && this.gb18030) {
                // Use GB18030 algorithm to find character(s) to write.
                var idx = findIdx(this.gb18030.uChars, uCode);
                if (idx != -1) {
                    var dbcsCode = this.gb18030.gbChars[idx] + (uCode - this.gb18030.uChars[idx]);
                    newBuf[j++] = 0x81 + Math.floor(dbcsCode / 12600); dbcsCode = dbcsCode % 12600;
                    newBuf[j++] = 0x30 + Math.floor(dbcsCode / 1260); dbcsCode = dbcsCode % 1260;
                    newBuf[j++] = 0x81 + Math.floor(dbcsCode / 10); dbcsCode = dbcsCode % 10;
                    newBuf[j++] = 0x30 + dbcsCode;
                    continue;
                }
            }
        }

        // 3. Write dbcsCode character.
        if (dbcsCode === UNASSIGNED)
            dbcsCode = this.defaultCharSingleByte;
        
        if (dbcsCode < 0x100) {
            newBuf[j++] = dbcsCode;
        }
        else if (dbcsCode < 0x10000) {
            newBuf[j++] = dbcsCode >> 8;   // high byte
            newBuf[j++] = dbcsCode & 0xFF; // low byte
        }
        else if (dbcsCode < 0x1000000) {
            newBuf[j++] = dbcsCode >> 16;
            newBuf[j++] = (dbcsCode >> 8) & 0xFF;
            newBuf[j++] = dbcsCode & 0xFF;
        } else {
            newBuf[j++] = dbcsCode >>> 24;
            newBuf[j++] = (dbcsCode >>> 16) & 0xFF;
            newBuf[j++] = (dbcsCode >>> 8) & 0xFF;
            newBuf[j++] = dbcsCode & 0xFF;
        }
    }

    this.seqObj = seqObj;
    this.leadSurrogate = leadSurrogate;
    return newBuf.slice(0, j);
}

DBCSEncoder.prototype.end = function() {
    if (this.leadSurrogate === -1 && this.seqObj === undefined)
        return; // All clean. Most often case.

    var newBuf = Buffer.alloc(10), j = 0;

    if (this.seqObj) { // We're in the sequence.
        var dbcsCode = this.seqObj[DEF_CHAR];
        if (dbcsCode !== undefined) { // Write beginning of the sequence.
            if (dbcsCode < 0x100) {
                newBuf[j++] = dbcsCode;
            }
            else {
                newBuf[j++] = dbcsCode >> 8;   // high byte
                newBuf[j++] = dbcsCode & 0xFF; // low byte
            }
        } else {
            // See todo above.
        }
        this.seqObj = undefined;
    }

    if (this.leadSurrogate !== -1) {
        // Incomplete surrogate pair - only lead surrogate found.
        newBuf[j++] = this.defaultCharSingleByte;
        this.leadSurrogate = -1;
    }
    
    return newBuf.slice(0, j);
}

// Export for testing
DBCSEncoder.prototype.findIdx = findIdx;


// == Decoder ==================================================================

function DBCSDecoder(options, codec) {
    // Decoder state
    this.nodeIdx = 0;
    this.prevBytes = [];

    // Static data
    this.decodeTables = codec.decodeTables;
    this.decodeTableSeq = codec.decodeTableSeq;
    this.defaultCharUnicode = codec.defaultCharUnicode;
    this.gb18030 = codec.gb18030;
}

DBCSDecoder.prototype.write = function(buf) {
    var newBuf = Buffer.alloc(buf.length*2),
        nodeIdx = this.nodeIdx, 
        prevBytes = this.prevBytes, prevOffset = this.prevBytes.length,
        seqStart = -this.prevBytes.length, // idx of the start of current parsed sequence.
        uCode;

    for (var i = 0, j = 0; i < buf.length; i++) {
        var curByte = (i >= 0) ? buf[i] : prevBytes[i + prevOffset];

        // Lookup in current trie node.
        var uCode = this.decodeTables[nodeIdx][curByte];

        if (uCode >= 0) { 
            // Normal character, just use it.
        }
        else if (uCode === UNASSIGNED) { // Unknown char.
            // TODO: Callback with seq.
            uCode = this.defaultCharUnicode.charCodeAt(0);
            i = seqStart; // Skip one byte ('i' will be incremented by the for loop) and try to parse again.
        }
        else if (uCode === GB18030_CODE) {
            if (i >= 3) {
                var ptr = (buf[i-3]-0x81)*12600 + (buf[i-2]-0x30)*1260 + (buf[i-1]-0x81)*10 + (curByte-0x30);
            } else {
                var ptr = (prevBytes[i-3+prevOffset]-0x81)*12600 + 
                          (((i-2 >= 0) ? buf[i-2] : prevBytes[i-2+prevOffset])-0x30)*1260 + 
                          (((i-1 >= 0) ? buf[i-1] : prevBytes[i-1+prevOffset])-0x81)*10 + 
                          (curByte-0x30);
            }
            var idx = findIdx(this.gb18030.gbChars, ptr);
            uCode = this.gb18030.uChars[idx] + ptr - this.gb18030.gbChars[idx];
        }
        else if (uCode <= NODE_START) { // Go to next trie node.
            nodeIdx = NODE_START - uCode;
            continue;
        }
        else if (uCode <= SEQ_START) { // Output a sequence of chars.
            var seq = this.decodeTableSeq[SEQ_START - uCode];
            for (var k = 0; k < seq.length - 1; k++) {
                uCode = seq[k];
                newBuf[j++] = uCode & 0xFF;
                newBuf[j++] = uCode >> 8;
            }
            uCode = seq[seq.length-1];
        }
        else
            throw new Error("iconv-lite internal error: invalid decoding table value " + uCode + " at " + nodeIdx + "/" + curByte);

        // Write the character to buffer, handling higher planes using surrogate pair.
        if (uCode >= 0x10000) { 
            uCode -= 0x10000;
            var uCodeLead = 0xD800 | (uCode >> 10);
            newBuf[j++] = uCodeLead & 0xFF;
            newBuf[j++] = uCodeLead >> 8;

            uCode = 0xDC00 | (uCode & 0x3FF);
        }
        newBuf[j++] = uCode & 0xFF;
        newBuf[j++] = uCode >> 8;

        // Reset trie node.
        nodeIdx = 0; seqStart = i+1;
    }

    this.nodeIdx = nodeIdx;
    this.prevBytes = (seqStart >= 0)
        ? Array.prototype.slice.call(buf, seqStart)
        : prevBytes.slice(seqStart + prevOffset).concat(Array.prototype.slice.call(buf));

    return newBuf.slice(0, j).toString('ucs2');
}

DBCSDecoder.prototype.end = function() {
    var ret = '';

    // Try to parse all remaining chars.
    while (this.prevBytes.length > 0) {
        // Skip 1 character in the buffer.
        ret += this.defaultCharUnicode;
        var bytesArr = this.prevBytes.slice(1);

        // Parse remaining as usual.
        this.prevBytes = [];
        this.nodeIdx = 0;
        if (bytesArr.length > 0)
            ret += this.write(bytesArr);
    }

    this.prevBytes = [];
    this.nodeIdx = 0;
    return ret;
}

// Binary search for GB18030. Returns largest i such that table[i] <= val.
function findIdx(table, val) {
    if (table[0] > val)
        return -1;

    var l = 0, r = table.length;
    while (l < r-1) { // always table[l] <= val < table[r]
        var mid = l + ((r-l+1) >> 1);
        if (table[mid] <= val)
            l = mid;
        else
            r = mid;
    }
    return l;
}



/***/ }),

/***/ 7003:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


// Description of supported double byte encodings and aliases.
// Tables are not require()-d until they are needed to speed up library load.
// require()-s are direct to support Browserify.

module.exports = {
    
    // == Japanese/ShiftJIS ====================================================
    // All japanese encodings are based on JIS X set of standards:
    // JIS X 0201 - Single-byte encoding of ASCII + ¥ + Kana chars at 0xA1-0xDF.
    // JIS X 0208 - Main set of 6879 characters, placed in 94x94 plane, to be encoded by 2 bytes. 
    //              Has several variations in 1978, 1983, 1990 and 1997.
    // JIS X 0212 - Supplementary plane of 6067 chars in 94x94 plane. 1990. Effectively dead.
    // JIS X 0213 - Extension and modern replacement of 0208 and 0212. Total chars: 11233.
    //              2 planes, first is superset of 0208, second - revised 0212.
    //              Introduced in 2000, revised 2004. Some characters are in Unicode Plane 2 (0x2xxxx)

    // Byte encodings are:
    //  * Shift_JIS: Compatible with 0201, uses not defined chars in top half as lead bytes for double-byte
    //               encoding of 0208. Lead byte ranges: 0x81-0x9F, 0xE0-0xEF; Trail byte ranges: 0x40-0x7E, 0x80-0x9E, 0x9F-0xFC.
    //               Windows CP932 is a superset of Shift_JIS. Some companies added more chars, notably KDDI.
    //  * EUC-JP:    Up to 3 bytes per character. Used mostly on *nixes.
    //               0x00-0x7F       - lower part of 0201
    //               0x8E, 0xA1-0xDF - upper part of 0201
    //               (0xA1-0xFE)x2   - 0208 plane (94x94).
    //               0x8F, (0xA1-0xFE)x2 - 0212 plane (94x94).
    //  * JIS X 208: 7-bit, direct encoding of 0208. Byte ranges: 0x21-0x7E (94 values). Uncommon.
    //               Used as-is in ISO2022 family.
    //  * ISO2022-JP: Stateful encoding, with escape sequences to switch between ASCII, 
    //                0201-1976 Roman, 0208-1978, 0208-1983.
    //  * ISO2022-JP-1: Adds esc seq for 0212-1990.
    //  * ISO2022-JP-2: Adds esc seq for GB2313-1980, KSX1001-1992, ISO8859-1, ISO8859-7.
    //  * ISO2022-JP-3: Adds esc seq for 0201-1976 Kana set, 0213-2000 Planes 1, 2.
    //  * ISO2022-JP-2004: Adds 0213-2004 Plane 1.
    //
    // After JIS X 0213 appeared, Shift_JIS-2004, EUC-JISX0213 and ISO2022-JP-2004 followed, with just changing the planes.
    //
    // Overall, it seems that it's a mess :( http://www8.plala.or.jp/tkubota1/unicode-symbols-map2.html

    'shiftjis': {
        type: '_dbcs',
        table: function() { return __webpack_require__(679) },
        encodeAdd: {'\u00a5': 0x5C, '\u203E': 0x7E},
        encodeSkipVals: [{from: 0xED40, to: 0xF940}],
    },
    'csshiftjis': 'shiftjis',
    'mskanji': 'shiftjis',
    'sjis': 'shiftjis',
    'windows31j': 'shiftjis',
    'ms31j': 'shiftjis',
    'xsjis': 'shiftjis',
    'windows932': 'shiftjis',
    'ms932': 'shiftjis',
    '932': 'shiftjis',
    'cp932': 'shiftjis',

    'eucjp': {
        type: '_dbcs',
        table: function() { return __webpack_require__(6406) },
        encodeAdd: {'\u00a5': 0x5C, '\u203E': 0x7E},
    },

    // TODO: KDDI extension to Shift_JIS
    // TODO: IBM CCSID 942 = CP932, but F0-F9 custom chars and other char changes.
    // TODO: IBM CCSID 943 = Shift_JIS = CP932 with original Shift_JIS lower 128 chars.


    // == Chinese/GBK ==========================================================
    // http://en.wikipedia.org/wiki/GBK
    // We mostly implement W3C recommendation: https://www.w3.org/TR/encoding/#gbk-encoder

    // Oldest GB2312 (1981, ~7600 chars) is a subset of CP936
    'gb2312': 'cp936',
    'gb231280': 'cp936',
    'gb23121980': 'cp936',
    'csgb2312': 'cp936',
    'csiso58gb231280': 'cp936',
    'euccn': 'cp936',

    // Microsoft's CP936 is a subset and approximation of GBK.
    'windows936': 'cp936',
    'ms936': 'cp936',
    '936': 'cp936',
    'cp936': {
        type: '_dbcs',
        table: function() { return __webpack_require__(4488) },
    },

    // GBK (~22000 chars) is an extension of CP936 that added user-mapped chars and some other.
    'gbk': {
        type: '_dbcs',
        table: function() { return (__webpack_require__(4488).concat)(__webpack_require__(5914)) },
    },
    'xgbk': 'gbk',
    'isoir58': 'gbk',

    // GB18030 is an algorithmic extension of GBK.
    // Main source: https://www.w3.org/TR/encoding/#gbk-encoder
    // http://icu-project.org/docs/papers/gb18030.html
    // http://source.icu-project.org/repos/icu/data/trunk/charset/data/xml/gb-18030-2000.xml
    // http://www.khngai.com/chinese/charmap/tblgbk.php?page=0
    'gb18030': {
        type: '_dbcs',
        table: function() { return (__webpack_require__(4488).concat)(__webpack_require__(5914)) },
        gb18030: function() { return __webpack_require__(9129) },
        encodeSkipVals: [0x80],
        encodeAdd: {'€': 0xA2E3},
    },

    'chinese': 'gb18030',


    // == Korean ===============================================================
    // EUC-KR, KS_C_5601 and KS X 1001 are exactly the same.
    'windows949': 'cp949',
    'ms949': 'cp949',
    '949': 'cp949',
    'cp949': {
        type: '_dbcs',
        table: function() { return __webpack_require__(1166) },
    },

    'cseuckr': 'cp949',
    'csksc56011987': 'cp949',
    'euckr': 'cp949',
    'isoir149': 'cp949',
    'korean': 'cp949',
    'ksc56011987': 'cp949',
    'ksc56011989': 'cp949',
    'ksc5601': 'cp949',


    // == Big5/Taiwan/Hong Kong ================================================
    // There are lots of tables for Big5 and cp950. Please see the following links for history:
    // http://moztw.org/docs/big5/  http://www.haible.de/bruno/charsets/conversion-tables/Big5.html
    // Variations, in roughly number of defined chars:
    //  * Windows CP 950: Microsoft variant of Big5. Canonical: http://www.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/WINDOWS/CP950.TXT
    //  * Windows CP 951: Microsoft variant of Big5-HKSCS-2001. Seems to be never public. http://me.abelcheung.org/articles/research/what-is-cp951/
    //  * Big5-2003 (Taiwan standard) almost superset of cp950.
    //  * Unicode-at-on (UAO) / Mozilla 1.8. Falling out of use on the Web. Not supported by other browsers.
    //  * Big5-HKSCS (-2001, -2004, -2008). Hong Kong standard. 
    //    many unicode code points moved from PUA to Supplementary plane (U+2XXXX) over the years.
    //    Plus, it has 4 combining sequences.
    //    Seems that Mozilla refused to support it for 10 yrs. https://bugzilla.mozilla.org/show_bug.cgi?id=162431 https://bugzilla.mozilla.org/show_bug.cgi?id=310299
    //    because big5-hkscs is the only encoding to include astral characters in non-algorithmic way.
    //    Implementations are not consistent within browsers; sometimes labeled as just big5.
    //    MS Internet Explorer switches from big5 to big5-hkscs when a patch applied.
    //    Great discussion & recap of what's going on https://bugzilla.mozilla.org/show_bug.cgi?id=912470#c31
    //    In the encoder, it might make sense to support encoding old PUA mappings to Big5 bytes seq-s.
    //    Official spec: http://www.ogcio.gov.hk/en/business/tech_promotion/ccli/terms/doc/2003cmp_2008.txt
    //                   http://www.ogcio.gov.hk/tc/business/tech_promotion/ccli/terms/doc/hkscs-2008-big5-iso.txt
    // 
    // Current understanding of how to deal with Big5(-HKSCS) is in the Encoding Standard, http://encoding.spec.whatwg.org/#big5-encoder
    // Unicode mapping (http://www.unicode.org/Public/MAPPINGS/OBSOLETE/EASTASIA/OTHER/BIG5.TXT) is said to be wrong.

    'windows950': 'cp950',
    'ms950': 'cp950',
    '950': 'cp950',
    'cp950': {
        type: '_dbcs',
        table: function() { return __webpack_require__(2324) },
    },

    // Big5 has many variations and is an extension of cp950. We use Encoding Standard's as a consensus.
    'big5': 'big5hkscs',
    'big5hkscs': {
        type: '_dbcs',
        table: function() { return (__webpack_require__(2324).concat)(__webpack_require__(3267)) },
        encodeSkipVals: [
            // Although Encoding Standard says we should avoid encoding to HKSCS area (See Step 1 of
            // https://encoding.spec.whatwg.org/#index-big5-pointer), we still do it to increase compatibility with ICU.
            // But if a single unicode point can be encoded both as HKSCS and regular Big5, we prefer the latter.
            0x8e69, 0x8e6f, 0x8e7e, 0x8eab, 0x8eb4, 0x8ecd, 0x8ed0, 0x8f57, 0x8f69, 0x8f6e, 0x8fcb, 0x8ffe,
            0x906d, 0x907a, 0x90c4, 0x90dc, 0x90f1, 0x91bf, 0x92af, 0x92b0, 0x92b1, 0x92b2, 0x92d1, 0x9447, 0x94ca,
            0x95d9, 0x96fc, 0x9975, 0x9b76, 0x9b78, 0x9b7b, 0x9bc6, 0x9bde, 0x9bec, 0x9bf6, 0x9c42, 0x9c53, 0x9c62,
            0x9c68, 0x9c6b, 0x9c77, 0x9cbc, 0x9cbd, 0x9cd0, 0x9d57, 0x9d5a, 0x9dc4, 0x9def, 0x9dfb, 0x9ea9, 0x9eef,
            0x9efd, 0x9f60, 0x9fcb, 0xa077, 0xa0dc, 0xa0df, 0x8fcc, 0x92c8, 0x9644, 0x96ed,

            // Step 2 of https://encoding.spec.whatwg.org/#index-big5-pointer: Use last pointer for U+2550, U+255E, U+2561, U+256A, U+5341, or U+5345
            0xa2a4, 0xa2a5, 0xa2a7, 0xa2a6, 0xa2cc, 0xa2ce,
        ],
    },

    'cnbig5': 'big5hkscs',
    'csbig5': 'big5hkscs',
    'xxbig5': 'big5hkscs',
};


/***/ }),

/***/ 3336:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


// Update this array if you add/rename/remove files in this directory.
// We support Browserify by skipping automatic module discovery and requiring modules directly.
var modules = [
    __webpack_require__(2911),
    __webpack_require__(5172),
    __webpack_require__(5082),
    __webpack_require__(1336),
    __webpack_require__(3770),
    __webpack_require__(8698),
    __webpack_require__(7446),
    __webpack_require__(7161),
    __webpack_require__(7003),
];

// Put all encoding/alias/codec definitions to single object and export it.
for (var i = 0; i < modules.length; i++) {
    var module = modules[i];
    for (var enc in module)
        if (Object.prototype.hasOwnProperty.call(module, enc))
            exports[enc] = module[enc];
}


/***/ }),

/***/ 2911:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

var Buffer = (__webpack_require__(4774).Buffer);

// Export Node.js internal encodings.

module.exports = {
    // Encodings
    utf8:   { type: "_internal", bomAware: true},
    cesu8:  { type: "_internal", bomAware: true},
    unicode11utf8: "utf8",

    ucs2:   { type: "_internal", bomAware: true},
    utf16le: "ucs2",

    binary: { type: "_internal" },
    base64: { type: "_internal" },
    hex:    { type: "_internal" },

    // Codec.
    _internal: InternalCodec,
};

//------------------------------------------------------------------------------

function InternalCodec(codecOptions, iconv) {
    this.enc = codecOptions.encodingName;
    this.bomAware = codecOptions.bomAware;

    if (this.enc === "base64")
        this.encoder = InternalEncoderBase64;
    else if (this.enc === "cesu8") {
        this.enc = "utf8"; // Use utf8 for decoding.
        this.encoder = InternalEncoderCesu8;

        // Add decoder for versions of Node not supporting CESU-8
        if (Buffer.from('eda0bdedb2a9', 'hex').toString() !== '💩') {
            this.decoder = InternalDecoderCesu8;
            this.defaultCharUnicode = iconv.defaultCharUnicode;
        }
    }
}

InternalCodec.prototype.encoder = InternalEncoder;
InternalCodec.prototype.decoder = InternalDecoder;

//------------------------------------------------------------------------------

// We use node.js internal decoder. Its signature is the same as ours.
var StringDecoder = (__webpack_require__(3193).StringDecoder);

if (!StringDecoder.prototype.end) // Node v0.8 doesn't have this method.
    StringDecoder.prototype.end = function() {};


function InternalDecoder(options, codec) {
    this.decoder = new StringDecoder(codec.enc);
}

InternalDecoder.prototype.write = function(buf) {
    if (!Buffer.isBuffer(buf)) {
        buf = Buffer.from(buf);
    }

    return this.decoder.write(buf);
}

InternalDecoder.prototype.end = function() {
    return this.decoder.end();
}


//------------------------------------------------------------------------------
// Encoder is mostly trivial

function InternalEncoder(options, codec) {
    this.enc = codec.enc;
}

InternalEncoder.prototype.write = function(str) {
    return Buffer.from(str, this.enc);
}

InternalEncoder.prototype.end = function() {
}


//------------------------------------------------------------------------------
// Except base64 encoder, which must keep its state.

function InternalEncoderBase64(options, codec) {
    this.prevStr = '';
}

InternalEncoderBase64.prototype.write = function(str) {
    str = this.prevStr + str;
    var completeQuads = str.length - (str.length % 4);
    this.prevStr = str.slice(completeQuads);
    str = str.slice(0, completeQuads);

    return Buffer.from(str, "base64");
}

InternalEncoderBase64.prototype.end = function() {
    return Buffer.from(this.prevStr, "base64");
}


//------------------------------------------------------------------------------
// CESU-8 encoder is also special.

function InternalEncoderCesu8(options, codec) {
}

InternalEncoderCesu8.prototype.write = function(str) {
    var buf = Buffer.alloc(str.length * 3), bufIdx = 0;
    for (var i = 0; i < str.length; i++) {
        var charCode = str.charCodeAt(i);
        // Naive implementation, but it works because CESU-8 is especially easy
        // to convert from UTF-16 (which all JS strings are encoded in).
        if (charCode < 0x80)
            buf[bufIdx++] = charCode;
        else if (charCode < 0x800) {
            buf[bufIdx++] = 0xC0 + (charCode >>> 6);
            buf[bufIdx++] = 0x80 + (charCode & 0x3f);
        }
        else { // charCode will always be < 0x10000 in javascript.
            buf[bufIdx++] = 0xE0 + (charCode >>> 12);
            buf[bufIdx++] = 0x80 + ((charCode >>> 6) & 0x3f);
            buf[bufIdx++] = 0x80 + (charCode & 0x3f);
        }
    }
    return buf.slice(0, bufIdx);
}

InternalEncoderCesu8.prototype.end = function() {
}

//------------------------------------------------------------------------------
// CESU-8 decoder is not implemented in Node v4.0+

function InternalDecoderCesu8(options, codec) {
    this.acc = 0;
    this.contBytes = 0;
    this.accBytes = 0;
    this.defaultCharUnicode = codec.defaultCharUnicode;
}

InternalDecoderCesu8.prototype.write = function(buf) {
    var acc = this.acc, contBytes = this.contBytes, accBytes = this.accBytes, 
        res = '';
    for (var i = 0; i < buf.length; i++) {
        var curByte = buf[i];
        if ((curByte & 0xC0) !== 0x80) { // Leading byte
            if (contBytes > 0) { // Previous code is invalid
                res += this.defaultCharUnicode;
                contBytes = 0;
            }

            if (curByte < 0x80) { // Single-byte code
                res += String.fromCharCode(curByte);
            } else if (curByte < 0xE0) { // Two-byte code
                acc = curByte & 0x1F;
                contBytes = 1; accBytes = 1;
            } else if (curByte < 0xF0) { // Three-byte code
                acc = curByte & 0x0F;
                contBytes = 2; accBytes = 1;
            } else { // Four or more are not supported for CESU-8.
                res += this.defaultCharUnicode;
            }
        } else { // Continuation byte
            if (contBytes > 0) { // We're waiting for it.
                acc = (acc << 6) | (curByte & 0x3f);
                contBytes--; accBytes++;
                if (contBytes === 0) {
                    // Check for overlong encoding, but support Modified UTF-8 (encoding NULL as C0 80)
                    if (accBytes === 2 && acc < 0x80 && acc > 0)
                        res += this.defaultCharUnicode;
                    else if (accBytes === 3 && acc < 0x800)
                        res += this.defaultCharUnicode;
                    else
                        // Actually add character.
                        res += String.fromCharCode(acc);
                }
            } else { // Unexpected continuation byte
                res += this.defaultCharUnicode;
            }
        }
    }
    this.acc = acc; this.contBytes = contBytes; this.accBytes = accBytes;
    return res;
}

InternalDecoderCesu8.prototype.end = function() {
    var res = 0;
    if (this.contBytes > 0)
        res += this.defaultCharUnicode;
    return res;
}


/***/ }),

/***/ 3770:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

var Buffer = (__webpack_require__(4774).Buffer);

// Single-byte codec. Needs a 'chars' string parameter that contains 256 or 128 chars that
// correspond to encoded bytes (if 128 - then lower half is ASCII). 

exports._sbcs = SBCSCodec;
function SBCSCodec(codecOptions, iconv) {
    if (!codecOptions)
        throw new Error("SBCS codec is called without the data.")
    
    // Prepare char buffer for decoding.
    if (!codecOptions.chars || (codecOptions.chars.length !== 128 && codecOptions.chars.length !== 256))
        throw new Error("Encoding '"+codecOptions.type+"' has incorrect 'chars' (must be of len 128 or 256)");
    
    if (codecOptions.chars.length === 128) {
        var asciiString = "";
        for (var i = 0; i < 128; i++)
            asciiString += String.fromCharCode(i);
        codecOptions.chars = asciiString + codecOptions.chars;
    }

    this.decodeBuf = Buffer.from(codecOptions.chars, 'ucs2');
    
    // Encoding buffer.
    var encodeBuf = Buffer.alloc(65536, iconv.defaultCharSingleByte.charCodeAt(0));

    for (var i = 0; i < codecOptions.chars.length; i++)
        encodeBuf[codecOptions.chars.charCodeAt(i)] = i;

    this.encodeBuf = encodeBuf;
}

SBCSCodec.prototype.encoder = SBCSEncoder;
SBCSCodec.prototype.decoder = SBCSDecoder;


function SBCSEncoder(options, codec) {
    this.encodeBuf = codec.encodeBuf;
}

SBCSEncoder.prototype.write = function(str) {
    var buf = Buffer.alloc(str.length);
    for (var i = 0; i < str.length; i++)
        buf[i] = this.encodeBuf[str.charCodeAt(i)];
    
    return buf;
}

SBCSEncoder.prototype.end = function() {
}


function SBCSDecoder(options, codec) {
    this.decodeBuf = codec.decodeBuf;
}

SBCSDecoder.prototype.write = function(buf) {
    // Strings are immutable in JS -> we use ucs2 buffer to speed up computations.
    var decodeBuf = this.decodeBuf;
    var newBuf = Buffer.alloc(buf.length*2);
    var idx1 = 0, idx2 = 0;
    for (var i = 0; i < buf.length; i++) {
        idx1 = buf[i]*2; idx2 = i*2;
        newBuf[idx2] = decodeBuf[idx1];
        newBuf[idx2+1] = decodeBuf[idx1+1];
    }
    return newBuf.toString('ucs2');
}

SBCSDecoder.prototype.end = function() {
}


/***/ }),

/***/ 7446:
/***/ ((module) => {

"use strict";


// Generated data for sbcs codec. Don't edit manually. Regenerate using generation/gen-sbcs.js script.
module.exports = {
  "437": "cp437",
  "737": "cp737",
  "775": "cp775",
  "850": "cp850",
  "852": "cp852",
  "855": "cp855",
  "856": "cp856",
  "857": "cp857",
  "858": "cp858",
  "860": "cp860",
  "861": "cp861",
  "862": "cp862",
  "863": "cp863",
  "864": "cp864",
  "865": "cp865",
  "866": "cp866",
  "869": "cp869",
  "874": "windows874",
  "922": "cp922",
  "1046": "cp1046",
  "1124": "cp1124",
  "1125": "cp1125",
  "1129": "cp1129",
  "1133": "cp1133",
  "1161": "cp1161",
  "1162": "cp1162",
  "1163": "cp1163",
  "1250": "windows1250",
  "1251": "windows1251",
  "1252": "windows1252",
  "1253": "windows1253",
  "1254": "windows1254",
  "1255": "windows1255",
  "1256": "windows1256",
  "1257": "windows1257",
  "1258": "windows1258",
  "28591": "iso88591",
  "28592": "iso88592",
  "28593": "iso88593",
  "28594": "iso88594",
  "28595": "iso88595",
  "28596": "iso88596",
  "28597": "iso88597",
  "28598": "iso88598",
  "28599": "iso88599",
  "28600": "iso885910",
  "28601": "iso885911",
  "28603": "iso885913",
  "28604": "iso885914",
  "28605": "iso885915",
  "28606": "iso885916",
  "windows874": {
    "type": "_sbcs",
    "chars": "€����…�����������‘’“”•–—�������� กขฃคฅฆงจฉชซฌญฎฏฐฑฒณดตถทธนบปผฝพฟภมยรฤลฦวศษสหฬอฮฯะัาำิีึืฺุู����฿เแโใไๅๆ็่้๊๋์ํ๎๏๐๑๒๓๔๕๖๗๘๙๚๛����"
  },
  "win874": "windows874",
  "cp874": "windows874",
  "windows1250": {
    "type": "_sbcs",
    "chars": "€�‚�„…†‡�‰Š‹ŚŤŽŹ�‘’“”•–—�™š›śťžź ˇ˘Ł¤Ą¦§¨©Ş«¬­®Ż°±˛ł´µ¶·¸ąş»Ľ˝ľżŔÁÂĂÄĹĆÇČÉĘËĚÍÎĎĐŃŇÓÔŐÖ×ŘŮÚŰÜÝŢßŕáâăäĺćçčéęëěíîďđńňóôőö÷řůúűüýţ˙"
  },
  "win1250": "windows1250",
  "cp1250": "windows1250",
  "windows1251": {
    "type": "_sbcs",
    "chars": "ЂЃ‚ѓ„…†‡€‰Љ‹ЊЌЋЏђ‘’“”•–—�™љ›њќћџ ЎўЈ¤Ґ¦§Ё©Є«¬­®Ї°±Ііґµ¶·ё№є»јЅѕїАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюя"
  },
  "win1251": "windows1251",
  "cp1251": "windows1251",
  "windows1252": {
    "type": "_sbcs",
    "chars": "€�‚ƒ„…†‡ˆ‰Š‹Œ�Ž��‘’“”•–—˜™š›œ�žŸ ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿ"
  },
  "win1252": "windows1252",
  "cp1252": "windows1252",
  "windows1253": {
    "type": "_sbcs",
    "chars": "€�‚ƒ„…†‡�‰�‹�����‘’“”•–—�™�›���� ΅Ά£¤¥¦§¨©�«¬­®―°±²³΄µ¶·ΈΉΊ»Ό½ΎΏΐΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡ�ΣΤΥΦΧΨΩΪΫάέήίΰαβγδεζηθικλμνξοπρςστυφχψωϊϋόύώ�"
  },
  "win1253": "windows1253",
  "cp1253": "windows1253",
  "windows1254": {
    "type": "_sbcs",
    "chars": "€�‚ƒ„…†‡ˆ‰Š‹Œ����‘’“”•–—˜™š›œ��Ÿ ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏĞÑÒÓÔÕÖ×ØÙÚÛÜİŞßàáâãäåæçèéêëìíîïğñòóôõö÷øùúûüışÿ"
  },
  "win1254": "windows1254",
  "cp1254": "windows1254",
  "windows1255": {
    "type": "_sbcs",
    "chars": "€�‚ƒ„…†‡ˆ‰�‹�����‘’“”•–—˜™�›���� ¡¢£₪¥¦§¨©×«¬­®¯°±²³´µ¶·¸¹÷»¼½¾¿ְֱֲֳִֵֶַָֹֺֻּֽ־ֿ׀ׁׂ׃װױײ׳״�������אבגדהוזחטיךכלםמןנסעףפץצקרשת��‎‏�"
  },
  "win1255": "windows1255",
  "cp1255": "windows1255",
  "windows1256": {
    "type": "_sbcs",
    "chars": "€پ‚ƒ„…†‡ˆ‰ٹ‹Œچژڈگ‘’“”•–—ک™ڑ›œ‌‍ں ،¢£¤¥¦§¨©ھ«¬­®¯°±²³´µ¶·¸¹؛»¼½¾؟ہءآأؤإئابةتثجحخدذرزسشصض×طظعغـفقكàلâمنهوçèéêëىيîïًٌٍَôُِ÷ّùْûü‎‏ے"
  },
  "win1256": "windows1256",
  "cp1256": "windows1256",
  "windows1257": {
    "type": "_sbcs",
    "chars": "€�‚�„…†‡�‰�‹�¨ˇ¸�‘’“”•–—�™�›�¯˛� �¢£¤�¦§Ø©Ŗ«¬­®Æ°±²³´µ¶·ø¹ŗ»¼½¾æĄĮĀĆÄÅĘĒČÉŹĖĢĶĪĻŠŃŅÓŌÕÖ×ŲŁŚŪÜŻŽßąįāćäåęēčéźėģķīļšńņóōõö÷ųłśūüżž˙"
  },
  "win1257": "windows1257",
  "cp1257": "windows1257",
  "windows1258": {
    "type": "_sbcs",
    "chars": "€�‚ƒ„…†‡ˆ‰�‹Œ����‘’“”•–—˜™�›œ��Ÿ ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂĂÄÅÆÇÈÉÊË̀ÍÎÏĐÑ̉ÓÔƠÖ×ØÙÚÛÜỮßàáâăäåæçèéêë́íîïđṇ̃óôơö÷øùúûüư₫ÿ"
  },
  "win1258": "windows1258",
  "cp1258": "windows1258",
  "iso88591": {
    "type": "_sbcs",
    "chars": " ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿ"
  },
  "cp28591": "iso88591",
  "iso88592": {
    "type": "_sbcs",
    "chars": " Ą˘Ł¤ĽŚ§¨ŠŞŤŹ­ŽŻ°ą˛ł´ľśˇ¸šşťź˝žżŔÁÂĂÄĹĆÇČÉĘËĚÍÎĎĐŃŇÓÔŐÖ×ŘŮÚŰÜÝŢßŕáâăäĺćçčéęëěíîďđńňóôőö÷řůúűüýţ˙"
  },
  "cp28592": "iso88592",
  "iso88593": {
    "type": "_sbcs",
    "chars": " Ħ˘£¤�Ĥ§¨İŞĞĴ­�Ż°ħ²³´µĥ·¸ışğĵ½�żÀÁÂ�ÄĊĈÇÈÉÊËÌÍÎÏ�ÑÒÓÔĠÖ×ĜÙÚÛÜŬŜßàáâ�äċĉçèéêëìíîï�ñòóôġö÷ĝùúûüŭŝ˙"
  },
  "cp28593": "iso88593",
  "iso88594": {
    "type": "_sbcs",
    "chars": " ĄĸŖ¤ĨĻ§¨ŠĒĢŦ­Ž¯°ą˛ŗ´ĩļˇ¸šēģŧŊžŋĀÁÂÃÄÅÆĮČÉĘËĖÍÎĪĐŅŌĶÔÕÖ×ØŲÚÛÜŨŪßāáâãäåæįčéęëėíîīđņōķôõö÷øųúûüũū˙"
  },
  "cp28594": "iso88594",
  "iso88595": {
    "type": "_sbcs",
    "chars": " ЁЂЃЄЅІЇЈЉЊЋЌ­ЎЏАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюя№ёђѓєѕіїјљњћќ§ўџ"
  },
  "cp28595": "iso88595",
  "iso88596": {
    "type": "_sbcs",
    "chars": " ���¤�������،­�������������؛���؟�ءآأؤإئابةتثجحخدذرزسشصضطظعغ�����ـفقكلمنهوىيًٌٍَُِّْ�������������"
  },
  "cp28596": "iso88596",
  "iso88597": {
    "type": "_sbcs",
    "chars": " ‘’£€₯¦§¨©ͺ«¬­�―°±²³΄΅Ά·ΈΉΊ»Ό½ΎΏΐΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡ�ΣΤΥΦΧΨΩΪΫάέήίΰαβγδεζηθικλμνξοπρςστυφχψωϊϋόύώ�"
  },
  "cp28597": "iso88597",
  "iso88598": {
    "type": "_sbcs",
    "chars": " �¢£¤¥¦§¨©×«¬­®¯°±²³´µ¶·¸¹÷»¼½¾��������������������������������‗אבגדהוזחטיךכלםמןנסעףפץצקרשת��‎‏�"
  },
  "cp28598": "iso88598",
  "iso88599": {
    "type": "_sbcs",
    "chars": " ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏĞÑÒÓÔÕÖ×ØÙÚÛÜİŞßàáâãäåæçèéêëìíîïğñòóôõö÷øùúûüışÿ"
  },
  "cp28599": "iso88599",
  "iso885910": {
    "type": "_sbcs",
    "chars": " ĄĒĢĪĨĶ§ĻĐŠŦŽ­ŪŊ°ąēģīĩķ·ļđšŧž―ūŋĀÁÂÃÄÅÆĮČÉĘËĖÍÎÏÐŅŌÓÔÕÖŨØŲÚÛÜÝÞßāáâãäåæįčéęëėíîïðņōóôõöũøųúûüýþĸ"
  },
  "cp28600": "iso885910",
  "iso885911": {
    "type": "_sbcs",
    "chars": " กขฃคฅฆงจฉชซฌญฎฏฐฑฒณดตถทธนบปผฝพฟภมยรฤลฦวศษสหฬอฮฯะัาำิีึืฺุู����฿เแโใไๅๆ็่้๊๋์ํ๎๏๐๑๒๓๔๕๖๗๘๙๚๛����"
  },
  "cp28601": "iso885911",
  "iso885913": {
    "type": "_sbcs",
    "chars": " ”¢£¤„¦§Ø©Ŗ«¬­®Æ°±²³“µ¶·ø¹ŗ»¼½¾æĄĮĀĆÄÅĘĒČÉŹĖĢĶĪĻŠŃŅÓŌÕÖ×ŲŁŚŪÜŻŽßąįāćäåęēčéźėģķīļšńņóōõö÷ųłśūüżž’"
  },
  "cp28603": "iso885913",
  "iso885914": {
    "type": "_sbcs",
    "chars": " Ḃḃ£ĊċḊ§Ẁ©ẂḋỲ­®ŸḞḟĠġṀṁ¶ṖẁṗẃṠỳẄẅṡÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏŴÑÒÓÔÕÖṪØÙÚÛÜÝŶßàáâãäåæçèéêëìíîïŵñòóôõöṫøùúûüýŷÿ"
  },
  "cp28604": "iso885914",
  "iso885915": {
    "type": "_sbcs",
    "chars": " ¡¢£€¥Š§š©ª«¬­®¯°±²³Žµ¶·ž¹º»ŒœŸ¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖ×ØÙÚÛÜÝÞßàáâãäåæçèéêëìíîïðñòóôõö÷øùúûüýþÿ"
  },
  "cp28605": "iso885915",
  "iso885916": {
    "type": "_sbcs",
    "chars": " ĄąŁ€„Š§š©Ș«Ź­źŻ°±ČłŽ”¶·žčș»ŒœŸżÀÁÂĂÄĆÆÇÈÉÊËÌÍÎÏĐŃÒÓÔŐÖŚŰÙÚÛÜĘȚßàáâăäćæçèéêëìíîïđńòóôőöśűùúûüęțÿ"
  },
  "cp28606": "iso885916",
  "cp437": {
    "type": "_sbcs",
    "chars": "ÇüéâäàåçêëèïîìÄÅÉæÆôöòûùÿÖÜ¢£¥₧ƒáíóúñÑªº¿⌐¬½¼¡«»░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ "
  },
  "ibm437": "cp437",
  "csibm437": "cp437",
  "cp737": {
    "type": "_sbcs",
    "chars": "ΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩαβγδεζηθικλμνξοπρσςτυφχψ░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀ωάέήϊίόύϋώΆΈΉΊΌΎΏ±≥≤ΪΫ÷≈°∙·√ⁿ²■ "
  },
  "ibm737": "cp737",
  "csibm737": "cp737",
  "cp775": {
    "type": "_sbcs",
    "chars": "ĆüéāäģåćłēŖŗīŹÄÅÉæÆōöĢ¢ŚśÖÜø£Ø×¤ĀĪóŻżź”¦©®¬½¼Ł«»░▒▓│┤ĄČĘĖ╣║╗╝ĮŠ┐└┴┬├─┼ŲŪ╚╔╩╦╠═╬Žąčęėįšųūž┘┌█▄▌▐▀ÓßŌŃõÕµńĶķĻļņĒŅ’­±“¾¶§÷„°∙·¹³²■ "
  },
  "ibm775": "cp775",
  "csibm775": "cp775",
  "cp850": {
    "type": "_sbcs",
    "chars": "ÇüéâäàåçêëèïîìÄÅÉæÆôöòûùÿÖÜø£Ø×ƒáíóúñÑªº¿®¬½¼¡«»░▒▓│┤ÁÂÀ©╣║╗╝¢¥┐└┴┬├─┼ãÃ╚╔╩╦╠═╬¤ðÐÊËÈıÍÎÏ┘┌█▄¦Ì▀ÓßÔÒõÕµþÞÚÛÙýÝ¯´­±‗¾¶§÷¸°¨·¹³²■ "
  },
  "ibm850": "cp850",
  "csibm850": "cp850",
  "cp852": {
    "type": "_sbcs",
    "chars": "ÇüéâäůćçłëŐőîŹÄĆÉĹĺôöĽľŚśÖÜŤťŁ×čáíóúĄąŽžĘę¬źČş«»░▒▓│┤ÁÂĚŞ╣║╗╝Żż┐└┴┬├─┼Ăă╚╔╩╦╠═╬¤đĐĎËďŇÍÎě┘┌█▄ŢŮ▀ÓßÔŃńňŠšŔÚŕŰýÝţ´­˝˛ˇ˘§÷¸°¨˙űŘř■ "
  },
  "ibm852": "cp852",
  "csibm852": "cp852",
  "cp855": {
    "type": "_sbcs",
    "chars": "ђЂѓЃёЁєЄѕЅіІїЇјЈљЉњЊћЋќЌўЎџЏюЮъЪаАбБцЦдДеЕфФгГ«»░▒▓│┤хХиИ╣║╗╝йЙ┐└┴┬├─┼кК╚╔╩╦╠═╬¤лЛмМнНоОп┘┌█▄Пя▀ЯрРсСтТуУжЖвВьЬ№­ыЫзЗшШэЭщЩчЧ§■ "
  },
  "ibm855": "cp855",
  "csibm855": "cp855",
  "cp856": {
    "type": "_sbcs",
    "chars": "אבגדהוזחטיךכלםמןנסעףפץצקרשת�£�×����������®¬½¼�«»░▒▓│┤���©╣║╗╝¢¥┐└┴┬├─┼��╚╔╩╦╠═╬¤���������┘┌█▄¦�▀������µ�������¯´­±‗¾¶§÷¸°¨·¹³²■ "
  },
  "ibm856": "cp856",
  "csibm856": "cp856",
  "cp857": {
    "type": "_sbcs",
    "chars": "ÇüéâäàåçêëèïîıÄÅÉæÆôöòûùİÖÜø£ØŞşáíóúñÑĞğ¿®¬½¼¡«»░▒▓│┤ÁÂÀ©╣║╗╝¢¥┐└┴┬├─┼ãÃ╚╔╩╦╠═╬¤ºªÊËÈ�ÍÎÏ┘┌█▄¦Ì▀ÓßÔÒõÕµ�×ÚÛÙìÿ¯´­±�¾¶§÷¸°¨·¹³²■ "
  },
  "ibm857": "cp857",
  "csibm857": "cp857",
  "cp858": {
    "type": "_sbcs",
    "chars": "ÇüéâäàåçêëèïîìÄÅÉæÆôöòûùÿÖÜø£Ø×ƒáíóúñÑªº¿®¬½¼¡«»░▒▓│┤ÁÂÀ©╣║╗╝¢¥┐└┴┬├─┼ãÃ╚╔╩╦╠═╬¤ðÐÊËÈ€ÍÎÏ┘┌█▄¦Ì▀ÓßÔÒõÕµþÞÚÛÙýÝ¯´­±‗¾¶§÷¸°¨·¹³²■ "
  },
  "ibm858": "cp858",
  "csibm858": "cp858",
  "cp860": {
    "type": "_sbcs",
    "chars": "ÇüéâãàÁçêÊèÍÔìÃÂÉÀÈôõòÚùÌÕÜ¢£Ù₧ÓáíóúñÑªº¿Ò¬½¼¡«»░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ "
  },
  "ibm860": "cp860",
  "csibm860": "cp860",
  "cp861": {
    "type": "_sbcs",
    "chars": "ÇüéâäàåçêëèÐðÞÄÅÉæÆôöþûÝýÖÜø£Ø₧ƒáíóúÁÍÓÚ¿⌐¬½¼¡«»░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ "
  },
  "ibm861": "cp861",
  "csibm861": "cp861",
  "cp862": {
    "type": "_sbcs",
    "chars": "אבגדהוזחטיךכלםמןנסעףפץצקרשת¢£¥₧ƒáíóúñÑªº¿⌐¬½¼¡«»░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ "
  },
  "ibm862": "cp862",
  "csibm862": "cp862",
  "cp863": {
    "type": "_sbcs",
    "chars": "ÇüéâÂà¶çêëèïî‗À§ÉÈÊôËÏûù¤ÔÜ¢£ÙÛƒ¦´óú¨¸³¯Î⌐¬½¼¾«»░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ "
  },
  "ibm863": "cp863",
  "csibm863": "cp863",
  "cp864": {
    "type": "_sbcs",
    "chars": "\u0000\u0001\u0002\u0003\u0004\u0005\u0006\u0007\b\t\n\u000b\f\r\u000e\u000f\u0010\u0011\u0012\u0013\u0014\u0015\u0016\u0017\u0018\u0019\u001a\u001b\u001c\u001d\u001e\u001f !\"#$٪&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~°·∙√▒─│┼┤┬├┴┐┌└┘β∞φ±½¼≈«»ﻷﻸ��ﻻﻼ� ­ﺂ£¤ﺄ��ﺎﺏﺕﺙ،ﺝﺡﺥ٠١٢٣٤٥٦٧٨٩ﻑ؛ﺱﺵﺹ؟¢ﺀﺁﺃﺅﻊﺋﺍﺑﺓﺗﺛﺟﺣﺧﺩﺫﺭﺯﺳﺷﺻﺿﻁﻅﻋﻏ¦¬÷×ﻉـﻓﻗﻛﻟﻣﻧﻫﻭﻯﻳﺽﻌﻎﻍﻡﹽّﻥﻩﻬﻰﻲﻐﻕﻵﻶﻝﻙﻱ■�"
  },
  "ibm864": "cp864",
  "csibm864": "cp864",
  "cp865": {
    "type": "_sbcs",
    "chars": "ÇüéâäàåçêëèïîìÄÅÉæÆôöòûùÿÖÜø£Ø₧ƒáíóúñÑªº¿⌐¬½¼¡«¤░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ "
  },
  "ibm865": "cp865",
  "csibm865": "cp865",
  "cp866": {
    "type": "_sbcs",
    "chars": "АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмноп░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀рстуфхцчшщъыьэюяЁёЄєЇїЎў°∙·√№¤■ "
  },
  "ibm866": "cp866",
  "csibm866": "cp866",
  "cp869": {
    "type": "_sbcs",
    "chars": "������Ά�·¬¦‘’Έ―ΉΊΪΌ��ΎΫ©Ώ²³ά£έήίϊΐόύΑΒΓΔΕΖΗ½ΘΙ«»░▒▓│┤ΚΛΜΝ╣║╗╝ΞΟ┐└┴┬├─┼ΠΡ╚╔╩╦╠═╬ΣΤΥΦΧΨΩαβγ┘┌█▄δε▀ζηθικλμνξοπρσςτ΄­±υφχ§ψ΅°¨ωϋΰώ■ "
  },
  "ibm869": "cp869",
  "csibm869": "cp869",
  "cp922": {
    "type": "_sbcs",
    "chars": " ¡¢£¤¥¦§¨©ª«¬­®‾°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏŠÑÒÓÔÕÖ×ØÙÚÛÜÝŽßàáâãäåæçèéêëìíîïšñòóôõö÷øùúûüýžÿ"
  },
  "ibm922": "cp922",
  "csibm922": "cp922",
  "cp1046": {
    "type": "_sbcs",
    "chars": "ﺈ×÷ﹱ■│─┐┌└┘ﹹﹻﹽﹿﹷﺊﻰﻳﻲﻎﻏﻐﻶﻸﻺﻼ ¤ﺋﺑﺗﺛﺟﺣ،­ﺧﺳ٠١٢٣٤٥٦٧٨٩ﺷ؛ﺻﺿﻊ؟ﻋءآأؤإئابةتثجحخدذرزسشصضطﻇعغﻌﺂﺄﺎﻓـفقكلمنهوىيًٌٍَُِّْﻗﻛﻟﻵﻷﻹﻻﻣﻧﻬﻩ�"
  },
  "ibm1046": "cp1046",
  "csibm1046": "cp1046",
  "cp1124": {
    "type": "_sbcs",
    "chars": " ЁЂҐЄЅІЇЈЉЊЋЌ­ЎЏАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюя№ёђґєѕіїјљњћќ§ўџ"
  },
  "ibm1124": "cp1124",
  "csibm1124": "cp1124",
  "cp1125": {
    "type": "_sbcs",
    "chars": "АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмноп░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀рстуфхцчшщъыьэюяЁёҐґЄєІіЇї·√№¤■ "
  },
  "ibm1125": "cp1125",
  "csibm1125": "cp1125",
  "cp1129": {
    "type": "_sbcs",
    "chars": " ¡¢£¤¥¦§œ©ª«¬­®¯°±²³Ÿµ¶·Œ¹º»¼½¾¿ÀÁÂĂÄÅÆÇÈÉÊË̀ÍÎÏĐÑ̉ÓÔƠÖ×ØÙÚÛÜỮßàáâăäåæçèéêë́íîïđṇ̃óôơö÷øùúûüư₫ÿ"
  },
  "ibm1129": "cp1129",
  "csibm1129": "cp1129",
  "cp1133": {
    "type": "_sbcs",
    "chars": " ກຂຄງຈສຊຍດຕຖທນບປຜຝພຟມຢຣລວຫອຮ���ຯະາຳິີຶືຸູຼັົຽ���ເແໂໃໄ່້໊໋໌ໍໆ�ໜໝ₭����������������໐໑໒໓໔໕໖໗໘໙��¢¬¦�"
  },
  "ibm1133": "cp1133",
  "csibm1133": "cp1133",
  "cp1161": {
    "type": "_sbcs",
    "chars": "��������������������������������่กขฃคฅฆงจฉชซฌญฎฏฐฑฒณดตถทธนบปผฝพฟภมยรฤลฦวศษสหฬอฮฯะัาำิีึืฺุู้๊๋€฿เแโใไๅๆ็่้๊๋์ํ๎๏๐๑๒๓๔๕๖๗๘๙๚๛¢¬¦ "
  },
  "ibm1161": "cp1161",
  "csibm1161": "cp1161",
  "cp1162": {
    "type": "_sbcs",
    "chars": "€…‘’“”•–— กขฃคฅฆงจฉชซฌญฎฏฐฑฒณดตถทธนบปผฝพฟภมยรฤลฦวศษสหฬอฮฯะัาำิีึืฺุู����฿เแโใไๅๆ็่้๊๋์ํ๎๏๐๑๒๓๔๕๖๗๘๙๚๛����"
  },
  "ibm1162": "cp1162",
  "csibm1162": "cp1162",
  "cp1163": {
    "type": "_sbcs",
    "chars": " ¡¢£€¥¦§œ©ª«¬­®¯°±²³Ÿµ¶·Œ¹º»¼½¾¿ÀÁÂĂÄÅÆÇÈÉÊË̀ÍÎÏĐÑ̉ÓÔƠÖ×ØÙÚÛÜỮßàáâăäåæçèéêë́íîïđṇ̃óôơö÷øùúûüư₫ÿ"
  },
  "ibm1163": "cp1163",
  "csibm1163": "cp1163",
  "maccroatian": {
    "type": "_sbcs",
    "chars": "ÄÅÇÉÑÖÜáàâäãåçéèêëíìîïñóòôöõúùûü†°¢£§•¶ß®Š™´¨≠ŽØ∞±≤≥∆µ∂∑∏š∫ªºΩžø¿¡¬√ƒ≈Ć«Č… ÀÃÕŒœĐ—“”‘’÷◊�©⁄¤‹›Æ»–·‚„‰ÂćÁčÈÍÎÏÌÓÔđÒÚÛÙıˆ˜¯πË˚¸Êæˇ"
  },
  "maccyrillic": {
    "type": "_sbcs",
    "chars": "АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ†°¢£§•¶І®©™Ђђ≠Ѓѓ∞±≤≥іµ∂ЈЄєЇїЉљЊњјЅ¬√ƒ≈∆«»… ЋћЌќѕ–—“”‘’÷„ЎўЏџ№Ёёяабвгдежзийклмнопрстуфхцчшщъыьэю¤"
  },
  "macgreek": {
    "type": "_sbcs",
    "chars": "Ä¹²É³ÖÜ΅àâä΄¨çéèêë£™îï•½‰ôö¦­ùûü†ΓΔΘΛΞΠß®©ΣΪ§≠°·Α±≤≥¥ΒΕΖΗΙΚΜΦΫΨΩάΝ¬ΟΡ≈Τ«»… ΥΧΆΈœ–―“”‘’÷ΉΊΌΎέήίόΏύαβψδεφγηιξκλμνοπώρστθωςχυζϊϋΐΰ�"
  },
  "maciceland": {
    "type": "_sbcs",
    "chars": "ÄÅÇÉÑÖÜáàâäãåçéèêëíìîïñóòôöõúùûüÝ°¢£§•¶ß®©™´¨≠ÆØ∞±≤≥¥µ∂∑∏π∫ªºΩæø¿¡¬√ƒ≈∆«»… ÀÃÕŒœ–—“”‘’÷◊ÿŸ⁄¤ÐðÞþý·‚„‰ÂÊÁËÈÍÎÏÌÓÔ�ÒÚÛÙıˆ˜¯˘˙˚¸˝˛ˇ"
  },
  "macroman": {
    "type": "_sbcs",
    "chars": "ÄÅÇÉÑÖÜáàâäãåçéèêëíìîïñóòôöõúùûü†°¢£§•¶ß®©™´¨≠ÆØ∞±≤≥¥µ∂∑∏π∫ªºΩæø¿¡¬√ƒ≈∆«»… ÀÃÕŒœ–—“”‘’÷◊ÿŸ⁄¤‹›ﬁﬂ‡·‚„‰ÂÊÁËÈÍÎÏÌÓÔ�ÒÚÛÙıˆ˜¯˘˙˚¸˝˛ˇ"
  },
  "macromania": {
    "type": "_sbcs",
    "chars": "ÄÅÇÉÑÖÜáàâäãåçéèêëíìîïñóòôöõúùûü†°¢£§•¶ß®©™´¨≠ĂŞ∞±≤≥¥µ∂∑∏π∫ªºΩăş¿¡¬√ƒ≈∆«»… ÀÃÕŒœ–—“”‘’÷◊ÿŸ⁄¤‹›Ţţ‡·‚„‰ÂÊÁËÈÍÎÏÌÓÔ�ÒÚÛÙıˆ˜¯˘˙˚¸˝˛ˇ"
  },
  "macthai": {
    "type": "_sbcs",
    "chars": "«»…“”�•‘’� กขฃคฅฆงจฉชซฌญฎฏฐฑฒณดตถทธนบปผฝพฟภมยรฤลฦวศษสหฬอฮฯะัาำิีึืฺุู﻿​–—฿เแโใไๅๆ็่้๊๋์ํ™๏๐๑๒๓๔๕๖๗๘๙®©����"
  },
  "macturkish": {
    "type": "_sbcs",
    "chars": "ÄÅÇÉÑÖÜáàâäãåçéèêëíìîïñóòôöõúùûü†°¢£§•¶ß®©™´¨≠ÆØ∞±≤≥¥µ∂∑∏π∫ªºΩæø¿¡¬√ƒ≈∆«»… ÀÃÕŒœ–—“”‘’÷◊ÿŸĞğİıŞş‡·‚„‰ÂÊÁËÈÍÎÏÌÓÔ�ÒÚÛÙ�ˆ˜¯˘˙˚¸˝˛ˇ"
  },
  "macukraine": {
    "type": "_sbcs",
    "chars": "АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ†°Ґ£§•¶І®©™Ђђ≠Ѓѓ∞±≤≥іµґЈЄєЇїЉљЊњјЅ¬√ƒ≈∆«»… ЋћЌќѕ–—“”‘’÷„ЎўЏџ№Ёёяабвгдежзийклмнопрстуфхцчшщъыьэю¤"
  },
  "koi8r": {
    "type": "_sbcs",
    "chars": "─│┌┐└┘├┤┬┴┼▀▄█▌▐░▒▓⌠■∙√≈≤≥ ⌡°²·÷═║╒ё╓╔╕╖╗╘╙╚╛╜╝╞╟╠╡Ё╢╣╤╥╦╧╨╩╪╫╬©юабцдефгхийклмнопярстужвьызшэщчъЮАБЦДЕФГХИЙКЛМНОПЯРСТУЖВЬЫЗШЭЩЧЪ"
  },
  "koi8u": {
    "type": "_sbcs",
    "chars": "─│┌┐└┘├┤┬┴┼▀▄█▌▐░▒▓⌠■∙√≈≤≥ ⌡°²·÷═║╒ёє╔ії╗╘╙╚╛ґ╝╞╟╠╡ЁЄ╣ІЇ╦╧╨╩╪Ґ╬©юабцдефгхийклмнопярстужвьызшэщчъЮАБЦДЕФГХИЙКЛМНОПЯРСТУЖВЬЫЗШЭЩЧЪ"
  },
  "koi8ru": {
    "type": "_sbcs",
    "chars": "─│┌┐└┘├┤┬┴┼▀▄█▌▐░▒▓⌠■∙√≈≤≥ ⌡°²·÷═║╒ёє╔ії╗╘╙╚╛ґў╞╟╠╡ЁЄ╣ІЇ╦╧╨╩╪ҐЎ©юабцдефгхийклмнопярстужвьызшэщчъЮАБЦДЕФГХИЙКЛМНОПЯРСТУЖВЬЫЗШЭЩЧЪ"
  },
  "koi8t": {
    "type": "_sbcs",
    "chars": "қғ‚Ғ„…†‡�‰ҳ‹ҲҷҶ�Қ‘’“”•–—�™�›�����ӯӮё¤ӣ¦§���«¬­®�°±²Ё�Ӣ¶·�№�»���©юабцдефгхийклмнопярстужвьызшэщчъЮАБЦДЕФГХИЙКЛМНОПЯРСТУЖВЬЫЗШЭЩЧЪ"
  },
  "armscii8": {
    "type": "_sbcs",
    "chars": " �և։)(»«—.՝,-֊…՜՛՞ԱաԲբԳգԴդԵեԶզԷէԸըԹթԺժԻիԼլԽխԾծԿկՀհՁձՂղՃճՄմՅյՆնՇշՈոՉչՊպՋջՌռՍսՎվՏտՐրՑցՒւՓփՔքՕօՖֆ՚�"
  },
  "rk1048": {
    "type": "_sbcs",
    "chars": "ЂЃ‚ѓ„…†‡€‰Љ‹ЊҚҺЏђ‘’“”•–—�™љ›њқһџ ҰұӘ¤Ө¦§Ё©Ғ«¬­®Ү°±Ііөµ¶·ё№ғ»әҢңүАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюя"
  },
  "tcvn": {
    "type": "_sbcs",
    "chars": "\u0000ÚỤ\u0003ỪỬỮ\u0007\b\t\n\u000b\f\r\u000e\u000f\u0010ỨỰỲỶỸÝỴ\u0018\u0019\u001a\u001b\u001c\u001d\u001e\u001f !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~ÀẢÃÁẠẶẬÈẺẼÉẸỆÌỈĨÍỊÒỎÕÓỌỘỜỞỠỚỢÙỦŨ ĂÂÊÔƠƯĐăâêôơưđẶ̀̀̉̃́àảãáạẲằẳẵắẴẮẦẨẪẤỀặầẩẫấậèỂẻẽéẹềểễếệìỉỄẾỒĩíịòỔỏõóọồổỗốộờởỡớợùỖủũúụừửữứựỳỷỹýỵỐ"
  },
  "georgianacademy": {
    "type": "_sbcs",
    "chars": "‚ƒ„…†‡ˆ‰Š‹Œ‘’“”•–—˜™š›œŸ ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶·¸¹º»¼½¾¿აბგდევზთიკლმნოპჟრსტუფქღყშჩცძწჭხჯჰჱჲჳჴჵჶçèéêëìíîïðñòóôõö÷øùúûüýþÿ"
  },
  "georgianps": {
    "type": "_sbcs",
    "chars": "‚ƒ„…†‡ˆ‰Š‹Œ‘’“”•–—˜™š›œŸ ¡¢£¤¥¦§¨©ª«¬­®¯°±²³´µ¶·¸¹º»¼½¾¿აბგდევზჱთიკლმნჲოპჟრსტჳუფქღყშჩცძწჭხჴჯჰჵæçèéêëìíîïðñòóôõö÷øùúûüýþÿ"
  },
  "pt154": {
    "type": "_sbcs",
    "chars": "ҖҒӮғ„…ҶҮҲүҠӢҢҚҺҸҗ‘’“”•–—ҳҷҡӣңқһҹ ЎўЈӨҘҰ§Ё©Ә«¬ӯ®Ҝ°ұІіҙө¶·ё№ә»јҪҫҝАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюя"
  },
  "viscii": {
    "type": "_sbcs",
    "chars": "\u0000\u0001Ẳ\u0003\u0004ẴẪ\u0007\b\t\n\u000b\f\r\u000e\u000f\u0010\u0011\u0012\u0013Ỷ\u0015\u0016\u0017\u0018Ỹ\u001a\u001b\u001c\u001dỴ\u001f !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~ẠẮẰẶẤẦẨẬẼẸẾỀỂỄỆỐỒỔỖỘỢỚỜỞỊỎỌỈỦŨỤỲÕắằặấầẩậẽẹếềểễệốồổỗỠƠộờởịỰỨỪỬơớƯÀÁÂÃẢĂẳẵÈÉÊẺÌÍĨỳĐứÒÓÔạỷừửÙÚỹỵÝỡưàáâãảăữẫèéêẻìíĩỉđựòóôõỏọụùúũủýợỮ"
  },
  "iso646cn": {
    "type": "_sbcs",
    "chars": "\u0000\u0001\u0002\u0003\u0004\u0005\u0006\u0007\b\t\n\u000b\f\r\u000e\u000f\u0010\u0011\u0012\u0013\u0014\u0015\u0016\u0017\u0018\u0019\u001a\u001b\u001c\u001d\u001e\u001f !\"#¥%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}‾��������������������������������������������������������������������������������������������������������������������������������"
  },
  "iso646jp": {
    "type": "_sbcs",
    "chars": "\u0000\u0001\u0002\u0003\u0004\u0005\u0006\u0007\b\t\n\u000b\f\r\u000e\u000f\u0010\u0011\u0012\u0013\u0014\u0015\u0016\u0017\u0018\u0019\u001a\u001b\u001c\u001d\u001e\u001f !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[¥]^_`abcdefghijklmnopqrstuvwxyz{|}‾��������������������������������������������������������������������������������������������������������������������������������"
  },
  "hproman8": {
    "type": "_sbcs",
    "chars": " ÀÂÈÊËÎÏ´ˋˆ¨˜ÙÛ₤¯Ýý°ÇçÑñ¡¿¤£¥§ƒ¢âêôûáéóúàèòùäëöüÅîØÆåíøæÄìÖÜÉïßÔÁÃãÐðÍÌÓÒÕõŠšÚŸÿÞþ·µ¶¾—¼½ªº«■»±�"
  },
  "macintosh": {
    "type": "_sbcs",
    "chars": "ÄÅÇÉÑÖÜáàâäãåçéèêëíìîïñóòôöõúùûü†°¢£§•¶ß®©™´¨≠ÆØ∞±≤≥¥µ∂∑∏π∫ªºΩæø¿¡¬√ƒ≈∆«»… ÀÃÕŒœ–—“”‘’÷◊ÿŸ⁄¤‹›ﬁﬂ‡·‚„‰ÂÊÁËÈÍÎÏÌÓÔ�ÒÚÛÙıˆ˜¯˘˙˚¸˝˛ˇ"
  },
  "ascii": {
    "type": "_sbcs",
    "chars": "��������������������������������������������������������������������������������������������������������������������������������"
  },
  "tis620": {
    "type": "_sbcs",
    "chars": "���������������������������������กขฃคฅฆงจฉชซฌญฎฏฐฑฒณดตถทธนบปผฝพฟภมยรฤลฦวศษสหฬอฮฯะัาำิีึืฺุู����฿เแโใไๅๆ็่้๊๋์ํ๎๏๐๑๒๓๔๕๖๗๘๙๚๛����"
  }
}

/***/ }),

/***/ 8698:
/***/ ((module) => {

"use strict";


// Manually added data to be used by sbcs codec in addition to generated one.

module.exports = {
    // Not supported by iconv, not sure why.
    "10029": "maccenteuro",
    "maccenteuro": {
        "type": "_sbcs",
        "chars": "ÄĀāÉĄÖÜáąČäčĆćéŹźĎíďĒēĖóėôöõúĚěü†°Ę£§•¶ß®©™ę¨≠ģĮįĪ≤≥īĶ∂∑łĻļĽľĹĺŅņŃ¬√ńŇ∆«»… ňŐÕőŌ–—“”‘’÷◊ōŔŕŘ‹›řŖŗŠ‚„šŚśÁŤťÍŽžŪÓÔūŮÚůŰűŲųÝýķŻŁżĢˇ"
    },

    "808": "cp808",
    "ibm808": "cp808",
    "cp808": {
        "type": "_sbcs",
        "chars": "АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмноп░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀рстуфхцчшщъыьэюяЁёЄєЇїЎў°∙·√№€■ "
    },

    "mik": {
        "type": "_sbcs",
        "chars": "АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюя└┴┬├─┼╣║╚╔╩╦╠═╬┐░▒▓│┤№§╗╝┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ "
    },

    "cp720": {
        "type": "_sbcs",
        "chars": "\x80\x81éâ\x84à\x86çêëèïî\x8d\x8e\x8f\x90\u0651\u0652ô¤ـûùءآأؤ£إئابةتثجحخدذرزسشص«»░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀ضطظعغفµقكلمنهوىي≡\u064b\u064c\u064d\u064e\u064f\u0650≈°∙·√ⁿ²■\u00a0"
    },

    // Aliases of generated encodings.
    "ascii8bit": "ascii",
    "usascii": "ascii",
    "ansix34": "ascii",
    "ansix341968": "ascii",
    "ansix341986": "ascii",
    "csascii": "ascii",
    "cp367": "ascii",
    "ibm367": "ascii",
    "isoir6": "ascii",
    "iso646us": "ascii",
    "iso646irv": "ascii",
    "us": "ascii",

    "latin1": "iso88591",
    "latin2": "iso88592",
    "latin3": "iso88593",
    "latin4": "iso88594",
    "latin5": "iso88599",
    "latin6": "iso885910",
    "latin7": "iso885913",
    "latin8": "iso885914",
    "latin9": "iso885915",
    "latin10": "iso885916",

    "csisolatin1": "iso88591",
    "csisolatin2": "iso88592",
    "csisolatin3": "iso88593",
    "csisolatin4": "iso88594",
    "csisolatincyrillic": "iso88595",
    "csisolatinarabic": "iso88596",
    "csisolatingreek" : "iso88597",
    "csisolatinhebrew": "iso88598",
    "csisolatin5": "iso88599",
    "csisolatin6": "iso885910",

    "l1": "iso88591",
    "l2": "iso88592",
    "l3": "iso88593",
    "l4": "iso88594",
    "l5": "iso88599",
    "l6": "iso885910",
    "l7": "iso885913",
    "l8": "iso885914",
    "l9": "iso885915",
    "l10": "iso885916",

    "isoir14": "iso646jp",
    "isoir57": "iso646cn",
    "isoir100": "iso88591",
    "isoir101": "iso88592",
    "isoir109": "iso88593",
    "isoir110": "iso88594",
    "isoir144": "iso88595",
    "isoir127": "iso88596",
    "isoir126": "iso88597",
    "isoir138": "iso88598",
    "isoir148": "iso88599",
    "isoir157": "iso885910",
    "isoir166": "tis620",
    "isoir179": "iso885913",
    "isoir199": "iso885914",
    "isoir203": "iso885915",
    "isoir226": "iso885916",

    "cp819": "iso88591",
    "ibm819": "iso88591",

    "cyrillic": "iso88595",

    "arabic": "iso88596",
    "arabic8": "iso88596",
    "ecma114": "iso88596",
    "asmo708": "iso88596",

    "greek" : "iso88597",
    "greek8" : "iso88597",
    "ecma118" : "iso88597",
    "elot928" : "iso88597",

    "hebrew": "iso88598",
    "hebrew8": "iso88598",

    "turkish": "iso88599",
    "turkish8": "iso88599",

    "thai": "iso885911",
    "thai8": "iso885911",

    "celtic": "iso885914",
    "celtic8": "iso885914",
    "isoceltic": "iso885914",

    "tis6200": "tis620",
    "tis62025291": "tis620",
    "tis62025330": "tis620",

    "10000": "macroman",
    "10006": "macgreek",
    "10007": "maccyrillic",
    "10079": "maciceland",
    "10081": "macturkish",

    "cspc8codepage437": "cp437",
    "cspc775baltic": "cp775",
    "cspc850multilingual": "cp850",
    "cspcp852": "cp852",
    "cspc862latinhebrew": "cp862",
    "cpgr": "cp869",

    "msee": "cp1250",
    "mscyrl": "cp1251",
    "msansi": "cp1252",
    "msgreek": "cp1253",
    "msturk": "cp1254",
    "mshebr": "cp1255",
    "msarab": "cp1256",
    "winbaltrim": "cp1257",

    "cp20866": "koi8r",
    "20866": "koi8r",
    "ibm878": "koi8r",
    "cskoi8r": "koi8r",

    "cp21866": "koi8u",
    "21866": "koi8u",
    "ibm1168": "koi8u",

    "strk10482002": "rk1048",

    "tcvn5712": "tcvn",
    "tcvn57121": "tcvn",

    "gb198880": "iso646cn",
    "cn": "iso646cn",

    "csiso14jisc6220ro": "iso646jp",
    "jisc62201969ro": "iso646jp",
    "jp": "iso646jp",

    "cshproman8": "hproman8",
    "r8": "hproman8",
    "roman8": "hproman8",
    "xroman8": "hproman8",
    "ibm1051": "hproman8",

    "mac": "macintosh",
    "csmacintosh": "macintosh",
};



/***/ }),

/***/ 5082:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

var Buffer = (__webpack_require__(4774).Buffer);

// Note: UTF16-LE (or UCS2) codec is Node.js native. See encodings/internal.js

// == UTF16-BE codec. ==========================================================

exports.utf16be = Utf16BECodec;
function Utf16BECodec() {
}

Utf16BECodec.prototype.encoder = Utf16BEEncoder;
Utf16BECodec.prototype.decoder = Utf16BEDecoder;
Utf16BECodec.prototype.bomAware = true;


// -- Encoding

function Utf16BEEncoder() {
}

Utf16BEEncoder.prototype.write = function(str) {
    var buf = Buffer.from(str, 'ucs2');
    for (var i = 0; i < buf.length; i += 2) {
        var tmp = buf[i]; buf[i] = buf[i+1]; buf[i+1] = tmp;
    }
    return buf;
}

Utf16BEEncoder.prototype.end = function() {
}


// -- Decoding

function Utf16BEDecoder() {
    this.overflowByte = -1;
}

Utf16BEDecoder.prototype.write = function(buf) {
    if (buf.length == 0)
        return '';

    var buf2 = Buffer.alloc(buf.length + 1),
        i = 0, j = 0;

    if (this.overflowByte !== -1) {
        buf2[0] = buf[0];
        buf2[1] = this.overflowByte;
        i = 1; j = 2;
    }

    for (; i < buf.length-1; i += 2, j+= 2) {
        buf2[j] = buf[i+1];
        buf2[j+1] = buf[i];
    }

    this.overflowByte = (i == buf.length-1) ? buf[buf.length-1] : -1;

    return buf2.slice(0, j).toString('ucs2');
}

Utf16BEDecoder.prototype.end = function() {
    this.overflowByte = -1;
}


// == UTF-16 codec =============================================================
// Decoder chooses automatically from UTF-16LE and UTF-16BE using BOM and space-based heuristic.
// Defaults to UTF-16LE, as it's prevalent and default in Node.
// http://en.wikipedia.org/wiki/UTF-16 and http://encoding.spec.whatwg.org/#utf-16le
// Decoder default can be changed: iconv.decode(buf, 'utf16', {defaultEncoding: 'utf-16be'});

// Encoder uses UTF-16LE and prepends BOM (which can be overridden with addBOM: false).

exports.utf16 = Utf16Codec;
function Utf16Codec(codecOptions, iconv) {
    this.iconv = iconv;
}

Utf16Codec.prototype.encoder = Utf16Encoder;
Utf16Codec.prototype.decoder = Utf16Decoder;


// -- Encoding (pass-through)

function Utf16Encoder(options, codec) {
    options = options || {};
    if (options.addBOM === undefined)
        options.addBOM = true;
    this.encoder = codec.iconv.getEncoder('utf-16le', options);
}

Utf16Encoder.prototype.write = function(str) {
    return this.encoder.write(str);
}

Utf16Encoder.prototype.end = function() {
    return this.encoder.end();
}


// -- Decoding

function Utf16Decoder(options, codec) {
    this.decoder = null;
    this.initialBufs = [];
    this.initialBufsLen = 0;

    this.options = options || {};
    this.iconv = codec.iconv;
}

Utf16Decoder.prototype.write = function(buf) {
    if (!this.decoder) {
        // Codec is not chosen yet. Accumulate initial bytes.
        this.initialBufs.push(buf);
        this.initialBufsLen += buf.length;
        
        if (this.initialBufsLen < 16) // We need more bytes to use space heuristic (see below)
            return '';

        // We have enough bytes -> detect endianness.
        var encoding = detectEncoding(this.initialBufs, this.options.defaultEncoding);
        this.decoder = this.iconv.getDecoder(encoding, this.options);

        var resStr = '';
        for (var i = 0; i < this.initialBufs.length; i++)
            resStr += this.decoder.write(this.initialBufs[i]);

        this.initialBufs.length = this.initialBufsLen = 0;
        return resStr;
    }

    return this.decoder.write(buf);
}

Utf16Decoder.prototype.end = function() {
    if (!this.decoder) {
        var encoding = detectEncoding(this.initialBufs, this.options.defaultEncoding);
        this.decoder = this.iconv.getDecoder(encoding, this.options);

        var resStr = '';
        for (var i = 0; i < this.initialBufs.length; i++)
            resStr += this.decoder.write(this.initialBufs[i]);

        var trail = this.decoder.end();
        if (trail)
            resStr += trail;

        this.initialBufs.length = this.initialBufsLen = 0;
        return resStr;
    }
    return this.decoder.end();
}

function detectEncoding(bufs, defaultEncoding) {
    var b = [];
    var charsProcessed = 0;
    var asciiCharsLE = 0, asciiCharsBE = 0; // Number of ASCII chars when decoded as LE or BE.

    outer_loop:
    for (var i = 0; i < bufs.length; i++) {
        var buf = bufs[i];
        for (var j = 0; j < buf.length; j++) {
            b.push(buf[j]);
            if (b.length === 2) {
                if (charsProcessed === 0) {
                    // Check BOM first.
                    if (b[0] === 0xFF && b[1] === 0xFE) return 'utf-16le';
                    if (b[0] === 0xFE && b[1] === 0xFF) return 'utf-16be';
                }

                if (b[0] === 0 && b[1] !== 0) asciiCharsBE++;
                if (b[0] !== 0 && b[1] === 0) asciiCharsLE++;

                b.length = 0;
                charsProcessed++;

                if (charsProcessed >= 100) {
                    break outer_loop;
                }
            }
        }
    }

    // Make decisions.
    // Most of the time, the content has ASCII chars (U+00**), but the opposite (U+**00) is uncommon.
    // So, we count ASCII as if it was LE or BE, and decide from that.
    if (asciiCharsBE > asciiCharsLE) return 'utf-16be';
    if (asciiCharsBE < asciiCharsLE) return 'utf-16le';

    // Couldn't decide (likely all zeros or not enough data).
    return defaultEncoding || 'utf-16le';
}




/***/ }),

/***/ 5172:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";


var Buffer = (__webpack_require__(4774).Buffer);

// == UTF32-LE/BE codec. ==========================================================

exports._utf32 = Utf32Codec;

function Utf32Codec(codecOptions, iconv) {
    this.iconv = iconv;
    this.bomAware = true;
    this.isLE = codecOptions.isLE;
}

exports.utf32le = { type: '_utf32', isLE: true };
exports.utf32be = { type: '_utf32', isLE: false };

// Aliases
exports.ucs4le = 'utf32le';
exports.ucs4be = 'utf32be';

Utf32Codec.prototype.encoder = Utf32Encoder;
Utf32Codec.prototype.decoder = Utf32Decoder;

// -- Encoding

function Utf32Encoder(options, codec) {
    this.isLE = codec.isLE;
    this.highSurrogate = 0;
}

Utf32Encoder.prototype.write = function(str) {
    var src = Buffer.from(str, 'ucs2');
    var dst = Buffer.alloc(src.length * 2);
    var write32 = this.isLE ? dst.writeUInt32LE : dst.writeUInt32BE;
    var offset = 0;

    for (var i = 0; i < src.length; i += 2) {
        var code = src.readUInt16LE(i);
        var isHighSurrogate = (0xD800 <= code && code < 0xDC00);
        var isLowSurrogate = (0xDC00 <= code && code < 0xE000);

        if (this.highSurrogate) {
            if (isHighSurrogate || !isLowSurrogate) {
                // There shouldn't be two high surrogates in a row, nor a high surrogate which isn't followed by a low
                // surrogate. If this happens, keep the pending high surrogate as a stand-alone semi-invalid character
                // (technically wrong, but expected by some applications, like Windows file names).
                write32.call(dst, this.highSurrogate, offset);
                offset += 4;
            }
            else {
                // Create 32-bit value from high and low surrogates;
                var codepoint = (((this.highSurrogate - 0xD800) << 10) | (code - 0xDC00)) + 0x10000;

                write32.call(dst, codepoint, offset);
                offset += 4;
                this.highSurrogate = 0;

                continue;
            }
        }

        if (isHighSurrogate)
            this.highSurrogate = code;
        else {
            // Even if the current character is a low surrogate, with no previous high surrogate, we'll
            // encode it as a semi-invalid stand-alone character for the same reasons expressed above for
            // unpaired high surrogates.
            write32.call(dst, code, offset);
            offset += 4;
            this.highSurrogate = 0;
        }
    }

    if (offset < dst.length)
        dst = dst.slice(0, offset);

    return dst;
};

Utf32Encoder.prototype.end = function() {
    // Treat any leftover high surrogate as a semi-valid independent character.
    if (!this.highSurrogate)
        return;

    var buf = Buffer.alloc(4);

    if (this.isLE)
        buf.writeUInt32LE(this.highSurrogate, 0);
    else
        buf.writeUInt32BE(this.highSurrogate, 0);

    this.highSurrogate = 0;

    return buf;
};

// -- Decoding

function Utf32Decoder(options, codec) {
    this.isLE = codec.isLE;
    this.badChar = codec.iconv.defaultCharUnicode.charCodeAt(0);
    this.overflow = [];
}

Utf32Decoder.prototype.write = function(src) {
    if (src.length === 0)
        return '';

    var i = 0;
    var codepoint = 0;
    var dst = Buffer.alloc(src.length + 4);
    var offset = 0;
    var isLE = this.isLE;
    var overflow = this.overflow;
    var badChar = this.badChar;

    if (overflow.length > 0) {
        for (; i < src.length && overflow.length < 4; i++)
            overflow.push(src[i]);
        
        if (overflow.length === 4) {
            // NOTE: codepoint is a signed int32 and can be negative.
            // NOTE: We copied this block from below to help V8 optimize it (it works with array, not buffer).
            if (isLE) {
                codepoint = overflow[i] | (overflow[i+1] << 8) | (overflow[i+2] << 16) | (overflow[i+3] << 24);
            } else {
                codepoint = overflow[i+3] | (overflow[i+2] << 8) | (overflow[i+1] << 16) | (overflow[i] << 24);
            }
            overflow.length = 0;

            offset = _writeCodepoint(dst, offset, codepoint, badChar);
        }
    }

    // Main loop. Should be as optimized as possible.
    for (; i < src.length - 3; i += 4) {
        // NOTE: codepoint is a signed int32 and can be negative.
        if (isLE) {
            codepoint = src[i] | (src[i+1] << 8) | (src[i+2] << 16) | (src[i+3] << 24);
        } else {
            codepoint = src[i+3] | (src[i+2] << 8) | (src[i+1] << 16) | (src[i] << 24);
        }
        offset = _writeCodepoint(dst, offset, codepoint, badChar);
    }

    // Keep overflowing bytes.
    for (; i < src.length; i++) {
        overflow.push(src[i]);
    }

    return dst.slice(0, offset).toString('ucs2');
};

function _writeCodepoint(dst, offset, codepoint, badChar) {
    // NOTE: codepoint is signed int32 and can be negative. We keep it that way to help V8 with optimizations.
    if (codepoint < 0 || codepoint > 0x10FFFF) {
        // Not a valid Unicode codepoint
        codepoint = badChar;
    } 

    // Ephemeral Planes: Write high surrogate.
    if (codepoint >= 0x10000) {
        codepoint -= 0x10000;

        var high = 0xD800 | (codepoint >> 10);
        dst[offset++] = high & 0xff;
        dst[offset++] = high >> 8;

        // Low surrogate is written below.
        var codepoint = 0xDC00 | (codepoint & 0x3FF);
    }

    // Write BMP char or low surrogate.
    dst[offset++] = codepoint & 0xff;
    dst[offset++] = codepoint >> 8;

    return offset;
};

Utf32Decoder.prototype.end = function() {
    this.overflow.length = 0;
};

// == UTF-32 Auto codec =============================================================
// Decoder chooses automatically from UTF-32LE and UTF-32BE using BOM and space-based heuristic.
// Defaults to UTF-32LE. http://en.wikipedia.org/wiki/UTF-32
// Encoder/decoder default can be changed: iconv.decode(buf, 'utf32', {defaultEncoding: 'utf-32be'});

// Encoder prepends BOM (which can be overridden with (addBOM: false}).

exports.utf32 = Utf32AutoCodec;
exports.ucs4 = 'utf32';

function Utf32AutoCodec(options, iconv) {
    this.iconv = iconv;
}

Utf32AutoCodec.prototype.encoder = Utf32AutoEncoder;
Utf32AutoCodec.prototype.decoder = Utf32AutoDecoder;

// -- Encoding

function Utf32AutoEncoder(options, codec) {
    options = options || {};

    if (options.addBOM === undefined)
        options.addBOM = true;

    this.encoder = codec.iconv.getEncoder(options.defaultEncoding || 'utf-32le', options);
}

Utf32AutoEncoder.prototype.write = function(str) {
    return this.encoder.write(str);
};

Utf32AutoEncoder.prototype.end = function() {
    return this.encoder.end();
};

// -- Decoding

function Utf32AutoDecoder(options, codec) {
    this.decoder = null;
    this.initialBufs = [];
    this.initialBufsLen = 0;
    this.options = options || {};
    this.iconv = codec.iconv;
}

Utf32AutoDecoder.prototype.write = function(buf) {
    if (!this.decoder) { 
        // Codec is not chosen yet. Accumulate initial bytes.
        this.initialBufs.push(buf);
        this.initialBufsLen += buf.length;

        if (this.initialBufsLen < 32) // We need more bytes to use space heuristic (see below)
            return '';

        // We have enough bytes -> detect endianness.
        var encoding = detectEncoding(this.initialBufs, this.options.defaultEncoding);
        this.decoder = this.iconv.getDecoder(encoding, this.options);

        var resStr = '';
        for (var i = 0; i < this.initialBufs.length; i++)
            resStr += this.decoder.write(this.initialBufs[i]);

        this.initialBufs.length = this.initialBufsLen = 0;
        return resStr;
    }

    return this.decoder.write(buf);
};

Utf32AutoDecoder.prototype.end = function() {
    if (!this.decoder) {
        var encoding = detectEncoding(this.initialBufs, this.options.defaultEncoding);
        this.decoder = this.iconv.getDecoder(encoding, this.options);

        var resStr = '';
        for (var i = 0; i < this.initialBufs.length; i++)
            resStr += this.decoder.write(this.initialBufs[i]);

        var trail = this.decoder.end();
        if (trail)
            resStr += trail;

        this.initialBufs.length = this.initialBufsLen = 0;
        return resStr;
    }

    return this.decoder.end();
};

function detectEncoding(bufs, defaultEncoding) {
    var b = [];
    var charsProcessed = 0;
    var invalidLE = 0, invalidBE = 0;   // Number of invalid chars when decoded as LE or BE.
    var bmpCharsLE = 0, bmpCharsBE = 0; // Number of BMP chars when decoded as LE or BE.

    outer_loop:
    for (var i = 0; i < bufs.length; i++) {
        var buf = bufs[i];
        for (var j = 0; j < buf.length; j++) {
            b.push(buf[j]);
            if (b.length === 4) {
                if (charsProcessed === 0) {
                    // Check BOM first.
                    if (b[0] === 0xFF && b[1] === 0xFE && b[2] === 0 && b[3] === 0) {
                        return 'utf-32le';
                    }
                    if (b[0] === 0 && b[1] === 0 && b[2] === 0xFE && b[3] === 0xFF) {
                        return 'utf-32be';
                    }
                }

                if (b[0] !== 0 || b[1] > 0x10) invalidBE++;
                if (b[3] !== 0 || b[2] > 0x10) invalidLE++;

                if (b[0] === 0 && b[1] === 0 && (b[2] !== 0 || b[3] !== 0)) bmpCharsBE++;
                if ((b[0] !== 0 || b[1] !== 0) && b[2] === 0 && b[3] === 0) bmpCharsLE++;

                b.length = 0;
                charsProcessed++;

                if (charsProcessed >= 100) {
                    break outer_loop;
                }
            }
        }
    }

    // Make decisions.
    if (bmpCharsBE - invalidBE > bmpCharsLE - invalidLE)  return 'utf-32be';
    if (bmpCharsBE - invalidBE < bmpCharsLE - invalidLE)  return 'utf-32le';

    // Couldn't decide (likely all zeros or not enough data).
    return defaultEncoding || 'utf-32le';
}


/***/ }),

/***/ 1336:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

var Buffer = (__webpack_require__(4774).Buffer);

// UTF-7 codec, according to https://tools.ietf.org/html/rfc2152
// See also below a UTF-7-IMAP codec, according to http://tools.ietf.org/html/rfc3501#section-5.1.3

exports.utf7 = Utf7Codec;
exports.unicode11utf7 = 'utf7'; // Alias UNICODE-1-1-UTF-7
function Utf7Codec(codecOptions, iconv) {
    this.iconv = iconv;
};

Utf7Codec.prototype.encoder = Utf7Encoder;
Utf7Codec.prototype.decoder = Utf7Decoder;
Utf7Codec.prototype.bomAware = true;


// -- Encoding

var nonDirectChars = /[^A-Za-z0-9'\(\),-\.\/:\? \n\r\t]+/g;

function Utf7Encoder(options, codec) {
    this.iconv = codec.iconv;
}

Utf7Encoder.prototype.write = function(str) {
    // Naive implementation.
    // Non-direct chars are encoded as "+<base64>-"; single "+" char is encoded as "+-".
    return Buffer.from(str.replace(nonDirectChars, function(chunk) {
        return "+" + (chunk === '+' ? '' : 
            this.iconv.encode(chunk, 'utf16-be').toString('base64').replace(/=+$/, '')) 
            + "-";
    }.bind(this)));
}

Utf7Encoder.prototype.end = function() {
}


// -- Decoding

function Utf7Decoder(options, codec) {
    this.iconv = codec.iconv;
    this.inBase64 = false;
    this.base64Accum = '';
}

var base64Regex = /[A-Za-z0-9\/+]/;
var base64Chars = [];
for (var i = 0; i < 256; i++)
    base64Chars[i] = base64Regex.test(String.fromCharCode(i));

var plusChar = '+'.charCodeAt(0), 
    minusChar = '-'.charCodeAt(0),
    andChar = '&'.charCodeAt(0);

Utf7Decoder.prototype.write = function(buf) {
    var res = "", lastI = 0,
        inBase64 = this.inBase64,
        base64Accum = this.base64Accum;

    // The decoder is more involved as we must handle chunks in stream.

    for (var i = 0; i < buf.length; i++) {
        if (!inBase64) { // We're in direct mode.
            // Write direct chars until '+'
            if (buf[i] == plusChar) {
                res += this.iconv.decode(buf.slice(lastI, i), "ascii"); // Write direct chars.
                lastI = i+1;
                inBase64 = true;
            }
        } else { // We decode base64.
            if (!base64Chars[buf[i]]) { // Base64 ended.
                if (i == lastI && buf[i] == minusChar) {// "+-" -> "+"
                    res += "+";
                } else {
                    var b64str = base64Accum + this.iconv.decode(buf.slice(lastI, i), "ascii");
                    res += this.iconv.decode(Buffer.from(b64str, 'base64'), "utf16-be");
                }

                if (buf[i] != minusChar) // Minus is absorbed after base64.
                    i--;

                lastI = i+1;
                inBase64 = false;
                base64Accum = '';
            }
        }
    }

    if (!inBase64) {
        res += this.iconv.decode(buf.slice(lastI), "ascii"); // Write direct chars.
    } else {
        var b64str = base64Accum + this.iconv.decode(buf.slice(lastI), "ascii");

        var canBeDecoded = b64str.length - (b64str.length % 8); // Minimal chunk: 2 quads -> 2x3 bytes -> 3 chars.
        base64Accum = b64str.slice(canBeDecoded); // The rest will be decoded in future.
        b64str = b64str.slice(0, canBeDecoded);

        res += this.iconv.decode(Buffer.from(b64str, 'base64'), "utf16-be");
    }

    this.inBase64 = inBase64;
    this.base64Accum = base64Accum;

    return res;
}

Utf7Decoder.prototype.end = function() {
    var res = "";
    if (this.inBase64 && this.base64Accum.length > 0)
        res = this.iconv.decode(Buffer.from(this.base64Accum, 'base64'), "utf16-be");

    this.inBase64 = false;
    this.base64Accum = '';
    return res;
}


// UTF-7-IMAP codec.
// RFC3501 Sec. 5.1.3 Modified UTF-7 (http://tools.ietf.org/html/rfc3501#section-5.1.3)
// Differences:
//  * Base64 part is started by "&" instead of "+"
//  * Direct characters are 0x20-0x7E, except "&" (0x26)
//  * In Base64, "," is used instead of "/"
//  * Base64 must not be used to represent direct characters.
//  * No implicit shift back from Base64 (should always end with '-')
//  * String must end in non-shifted position.
//  * "-&" while in base64 is not allowed.


exports.utf7imap = Utf7IMAPCodec;
function Utf7IMAPCodec(codecOptions, iconv) {
    this.iconv = iconv;
};

Utf7IMAPCodec.prototype.encoder = Utf7IMAPEncoder;
Utf7IMAPCodec.prototype.decoder = Utf7IMAPDecoder;
Utf7IMAPCodec.prototype.bomAware = true;


// -- Encoding

function Utf7IMAPEncoder(options, codec) {
    this.iconv = codec.iconv;
    this.inBase64 = false;
    this.base64Accum = Buffer.alloc(6);
    this.base64AccumIdx = 0;
}

Utf7IMAPEncoder.prototype.write = function(str) {
    var inBase64 = this.inBase64,
        base64Accum = this.base64Accum,
        base64AccumIdx = this.base64AccumIdx,
        buf = Buffer.alloc(str.length*5 + 10), bufIdx = 0;

    for (var i = 0; i < str.length; i++) {
        var uChar = str.charCodeAt(i);
        if (0x20 <= uChar && uChar <= 0x7E) { // Direct character or '&'.
            if (inBase64) {
                if (base64AccumIdx > 0) {
                    bufIdx += buf.write(base64Accum.slice(0, base64AccumIdx).toString('base64').replace(/\//g, ',').replace(/=+$/, ''), bufIdx);
                    base64AccumIdx = 0;
                }

                buf[bufIdx++] = minusChar; // Write '-', then go to direct mode.
                inBase64 = false;
            }

            if (!inBase64) {
                buf[bufIdx++] = uChar; // Write direct character

                if (uChar === andChar)  // Ampersand -> '&-'
                    buf[bufIdx++] = minusChar;
            }

        } else { // Non-direct character
            if (!inBase64) {
                buf[bufIdx++] = andChar; // Write '&', then go to base64 mode.
                inBase64 = true;
            }
            if (inBase64) {
                base64Accum[base64AccumIdx++] = uChar >> 8;
                base64Accum[base64AccumIdx++] = uChar & 0xFF;

                if (base64AccumIdx == base64Accum.length) {
                    bufIdx += buf.write(base64Accum.toString('base64').replace(/\//g, ','), bufIdx);
                    base64AccumIdx = 0;
                }
            }
        }
    }

    this.inBase64 = inBase64;
    this.base64AccumIdx = base64AccumIdx;

    return buf.slice(0, bufIdx);
}

Utf7IMAPEncoder.prototype.end = function() {
    var buf = Buffer.alloc(10), bufIdx = 0;
    if (this.inBase64) {
        if (this.base64AccumIdx > 0) {
            bufIdx += buf.write(this.base64Accum.slice(0, this.base64AccumIdx).toString('base64').replace(/\//g, ',').replace(/=+$/, ''), bufIdx);
            this.base64AccumIdx = 0;
        }

        buf[bufIdx++] = minusChar; // Write '-', then go to direct mode.
        this.inBase64 = false;
    }

    return buf.slice(0, bufIdx);
}


// -- Decoding

function Utf7IMAPDecoder(options, codec) {
    this.iconv = codec.iconv;
    this.inBase64 = false;
    this.base64Accum = '';
}

var base64IMAPChars = base64Chars.slice();
base64IMAPChars[','.charCodeAt(0)] = true;

Utf7IMAPDecoder.prototype.write = function(buf) {
    var res = "", lastI = 0,
        inBase64 = this.inBase64,
        base64Accum = this.base64Accum;

    // The decoder is more involved as we must handle chunks in stream.
    // It is forgiving, closer to standard UTF-7 (for example, '-' is optional at the end).

    for (var i = 0; i < buf.length; i++) {
        if (!inBase64) { // We're in direct mode.
            // Write direct chars until '&'
            if (buf[i] == andChar) {
                res += this.iconv.decode(buf.slice(lastI, i), "ascii"); // Write direct chars.
                lastI = i+1;
                inBase64 = true;
            }
        } else { // We decode base64.
            if (!base64IMAPChars[buf[i]]) { // Base64 ended.
                if (i == lastI && buf[i] == minusChar) { // "&-" -> "&"
                    res += "&";
                } else {
                    var b64str = base64Accum + this.iconv.decode(buf.slice(lastI, i), "ascii").replace(/,/g, '/');
                    res += this.iconv.decode(Buffer.from(b64str, 'base64'), "utf16-be");
                }

                if (buf[i] != minusChar) // Minus may be absorbed after base64.
                    i--;

                lastI = i+1;
                inBase64 = false;
                base64Accum = '';
            }
        }
    }

    if (!inBase64) {
        res += this.iconv.decode(buf.slice(lastI), "ascii"); // Write direct chars.
    } else {
        var b64str = base64Accum + this.iconv.decode(buf.slice(lastI), "ascii").replace(/,/g, '/');

        var canBeDecoded = b64str.length - (b64str.length % 8); // Minimal chunk: 2 quads -> 2x3 bytes -> 3 chars.
        base64Accum = b64str.slice(canBeDecoded); // The rest will be decoded in future.
        b64str = b64str.slice(0, canBeDecoded);

        res += this.iconv.decode(Buffer.from(b64str, 'base64'), "utf16-be");
    }

    this.inBase64 = inBase64;
    this.base64Accum = base64Accum;

    return res;
}

Utf7IMAPDecoder.prototype.end = function() {
    var res = "";
    if (this.inBase64 && this.base64Accum.length > 0)
        res = this.iconv.decode(Buffer.from(this.base64Accum, 'base64'), "utf16-be");

    this.inBase64 = false;
    this.base64Accum = '';
    return res;
}




/***/ }),

/***/ 557:
/***/ ((__unused_webpack_module, exports) => {

"use strict";


var BOMChar = '\uFEFF';

exports.PrependBOM = PrependBOMWrapper
function PrependBOMWrapper(encoder, options) {
    this.encoder = encoder;
    this.addBOM = true;
}

PrependBOMWrapper.prototype.write = function(str) {
    if (this.addBOM) {
        str = BOMChar + str;
        this.addBOM = false;
    }

    return this.encoder.write(str);
}

PrependBOMWrapper.prototype.end = function() {
    return this.encoder.end();
}


//------------------------------------------------------------------------------

exports.StripBOM = StripBOMWrapper;
function StripBOMWrapper(decoder, options) {
    this.decoder = decoder;
    this.pass = false;
    this.options = options || {};
}

StripBOMWrapper.prototype.write = function(buf) {
    var res = this.decoder.write(buf);
    if (this.pass || !res)
        return res;

    if (res[0] === BOMChar) {
        res = res.slice(1);
        if (typeof this.options.stripBOM === 'function')
            this.options.stripBOM();
    }

    this.pass = true;
    return res;
}

StripBOMWrapper.prototype.end = function() {
    return this.decoder.end();
}



/***/ }),

/***/ 5249:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Buffer = (__webpack_require__(4774).Buffer);

var bomHandling = __webpack_require__(557),
    iconv = module.exports;

// All codecs and aliases are kept here, keyed by encoding name/alias.
// They are lazy loaded in `iconv.getCodec` from `encodings/index.js`.
iconv.encodings = null;

// Characters emitted in case of error.
iconv.defaultCharUnicode = '�';
iconv.defaultCharSingleByte = '?';

// Public API.
iconv.encode = function encode(str, encoding, options) {
    str = "" + (str || ""); // Ensure string.

    var encoder = iconv.getEncoder(encoding, options);

    var res = encoder.write(str);
    var trail = encoder.end();
    
    return (trail && trail.length > 0) ? Buffer.concat([res, trail]) : res;
}

iconv.decode = function decode(buf, encoding, options) {
    if (typeof buf === 'string') {
        if (!iconv.skipDecodeWarning) {
            console.error('Iconv-lite warning: decode()-ing strings is deprecated. Refer to https://github.com/ashtuchkin/iconv-lite/wiki/Use-Buffers-when-decoding');
            iconv.skipDecodeWarning = true;
        }

        buf = Buffer.from("" + (buf || ""), "binary"); // Ensure buffer.
    }

    var decoder = iconv.getDecoder(encoding, options);

    var res = decoder.write(buf);
    var trail = decoder.end();

    return trail ? (res + trail) : res;
}

iconv.encodingExists = function encodingExists(enc) {
    try {
        iconv.getCodec(enc);
        return true;
    } catch (e) {
        return false;
    }
}

// Legacy aliases to convert functions
iconv.toEncoding = iconv.encode;
iconv.fromEncoding = iconv.decode;

// Search for a codec in iconv.encodings. Cache codec data in iconv._codecDataCache.
iconv._codecDataCache = {};
iconv.getCodec = function getCodec(encoding) {
    if (!iconv.encodings)
        iconv.encodings = __webpack_require__(3336); // Lazy load all encoding definitions.
    
    // Canonicalize encoding name: strip all non-alphanumeric chars and appended year.
    var enc = iconv._canonicalizeEncoding(encoding);

    // Traverse iconv.encodings to find actual codec.
    var codecOptions = {};
    while (true) {
        var codec = iconv._codecDataCache[enc];
        if (codec)
            return codec;

        var codecDef = iconv.encodings[enc];

        switch (typeof codecDef) {
            case "string": // Direct alias to other encoding.
                enc = codecDef;
                break;

            case "object": // Alias with options. Can be layered.
                for (var key in codecDef)
                    codecOptions[key] = codecDef[key];

                if (!codecOptions.encodingName)
                    codecOptions.encodingName = enc;
                
                enc = codecDef.type;
                break;

            case "function": // Codec itself.
                if (!codecOptions.encodingName)
                    codecOptions.encodingName = enc;

                // The codec function must load all tables and return object with .encoder and .decoder methods.
                // It'll be called only once (for each different options object).
                codec = new codecDef(codecOptions, iconv);

                iconv._codecDataCache[codecOptions.encodingName] = codec; // Save it to be reused later.
                return codec;

            default:
                throw new Error("Encoding not recognized: '" + encoding + "' (searched as: '"+enc+"')");
        }
    }
}

iconv._canonicalizeEncoding = function(encoding) {
    // Canonicalize encoding name: strip all non-alphanumeric chars and appended year.
    return (''+encoding).toLowerCase().replace(/:\d{4}$|[^0-9a-z]/g, "");
}

iconv.getEncoder = function getEncoder(encoding, options) {
    var codec = iconv.getCodec(encoding),
        encoder = new codec.encoder(options, codec);

    if (codec.bomAware && options && options.addBOM)
        encoder = new bomHandling.PrependBOM(encoder, options);

    return encoder;
}

iconv.getDecoder = function getDecoder(encoding, options) {
    var codec = iconv.getCodec(encoding),
        decoder = new codec.decoder(options, codec);

    if (codec.bomAware && !(options && options.stripBOM === false))
        decoder = new bomHandling.StripBOM(decoder, options);

    return decoder;
}

// Streaming API
// NOTE: Streaming API naturally depends on 'stream' module from Node.js. Unfortunately in browser environments this module can add
// up to 100Kb to the output bundle. To avoid unnecessary code bloat, we don't enable Streaming API in browser by default.
// If you would like to enable it explicitly, please add the following code to your app:
// > iconv.enableStreamingAPI(require('stream'));
iconv.enableStreamingAPI = function enableStreamingAPI(stream_module) {
    if (iconv.supportsStreams)
        return;

    // Dependency-inject stream module to create IconvLite stream classes.
    var streams = __webpack_require__(7792)(stream_module);

    // Not public API yet, but expose the stream classes.
    iconv.IconvLiteEncoderStream = streams.IconvLiteEncoderStream;
    iconv.IconvLiteDecoderStream = streams.IconvLiteDecoderStream;

    // Streaming API.
    iconv.encodeStream = function encodeStream(encoding, options) {
        return new iconv.IconvLiteEncoderStream(iconv.getEncoder(encoding, options), options);
    }

    iconv.decodeStream = function decodeStream(encoding, options) {
        return new iconv.IconvLiteDecoderStream(iconv.getDecoder(encoding, options), options);
    }

    iconv.supportsStreams = true;
}

// Enable Streaming API automatically if 'stream' module is available and non-empty (the majority of environments).
var stream_module;
try {
    stream_module = __webpack_require__(2203);
} catch (e) {}

if (stream_module && stream_module.Transform) {
    iconv.enableStreamingAPI(stream_module);

} else {
    // In rare cases where 'stream' module is not available by default, throw a helpful exception.
    iconv.encodeStream = iconv.decodeStream = function() {
        throw new Error("iconv-lite Streaming API is not enabled. Use iconv.enableStreamingAPI(require('stream')); to enable it.");
    };
}

if (false) {}


/***/ }),

/***/ 7792:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Buffer = (__webpack_require__(4774).Buffer);

// NOTE: Due to 'stream' module being pretty large (~100Kb, significant in browser environments), 
// we opt to dependency-inject it instead of creating a hard dependency.
module.exports = function(stream_module) {
    var Transform = stream_module.Transform;

    // == Encoder stream =======================================================

    function IconvLiteEncoderStream(conv, options) {
        this.conv = conv;
        options = options || {};
        options.decodeStrings = false; // We accept only strings, so we don't need to decode them.
        Transform.call(this, options);
    }

    IconvLiteEncoderStream.prototype = Object.create(Transform.prototype, {
        constructor: { value: IconvLiteEncoderStream }
    });

    IconvLiteEncoderStream.prototype._transform = function(chunk, encoding, done) {
        if (typeof chunk != 'string')
            return done(new Error("Iconv encoding stream needs strings as its input."));
        try {
            var res = this.conv.write(chunk);
            if (res && res.length) this.push(res);
            done();
        }
        catch (e) {
            done(e);
        }
    }

    IconvLiteEncoderStream.prototype._flush = function(done) {
        try {
            var res = this.conv.end();
            if (res && res.length) this.push(res);
            done();
        }
        catch (e) {
            done(e);
        }
    }

    IconvLiteEncoderStream.prototype.collect = function(cb) {
        var chunks = [];
        this.on('error', cb);
        this.on('data', function(chunk) { chunks.push(chunk); });
        this.on('end', function() {
            cb(null, Buffer.concat(chunks));
        });
        return this;
    }


    // == Decoder stream =======================================================

    function IconvLiteDecoderStream(conv, options) {
        this.conv = conv;
        options = options || {};
        options.encoding = this.encoding = 'utf8'; // We output strings.
        Transform.call(this, options);
    }

    IconvLiteDecoderStream.prototype = Object.create(Transform.prototype, {
        constructor: { value: IconvLiteDecoderStream }
    });

    IconvLiteDecoderStream.prototype._transform = function(chunk, encoding, done) {
        if (!Buffer.isBuffer(chunk) && !(chunk instanceof Uint8Array))
            return done(new Error("Iconv decoding stream needs buffers as its input."));
        try {
            var res = this.conv.write(chunk);
            if (res && res.length) this.push(res, this.encoding);
            done();
        }
        catch (e) {
            done(e);
        }
    }

    IconvLiteDecoderStream.prototype._flush = function(done) {
        try {
            var res = this.conv.end();
            if (res && res.length) this.push(res, this.encoding);                
            done();
        }
        catch (e) {
            done(e);
        }
    }

    IconvLiteDecoderStream.prototype.collect = function(cb) {
        var res = '';
        this.on('error', cb);
        this.on('data', function(chunk) { res += chunk; });
        this.on('end', function() {
            cb(null, res);
        });
        return this;
    }

    return {
        IconvLiteEncoderStream: IconvLiteEncoderStream,
        IconvLiteDecoderStream: IconvLiteDecoderStream,
    };
};


/***/ }),

/***/ 7210:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";



var loader = __webpack_require__(9243);
var dumper = __webpack_require__(4781);


function renamed(from, to) {
  return function () {
    throw new Error('Function yaml.' + from + ' is removed in js-yaml 4. ' +
      'Use yaml.' + to + ' instead, which is now safe by default.');
  };
}


module.exports.Type = __webpack_require__(5388);
module.exports.Schema = __webpack_require__(2119);
module.exports.FAILSAFE_SCHEMA = __webpack_require__(7759);
module.exports.JSON_SCHEMA = __webpack_require__(6184);
module.exports.CORE_SCHEMA = __webpack_require__(1769);
module.exports.DEFAULT_SCHEMA = __webpack_require__(5489);
module.exports.load                = loader.load;
module.exports.loadAll             = loader.loadAll;
module.exports.dump                = dumper.dump;
module.exports.YAMLException = __webpack_require__(1231);

// Re-export all types in case user wants to create custom schema
module.exports.types = {
  binary:    __webpack_require__(9342),
  float:     __webpack_require__(1461),
  map:       __webpack_require__(2369),
  null:      __webpack_require__(9198),
  pairs:     __webpack_require__(6942),
  set:       __webpack_require__(6663),
  timestamp: __webpack_require__(127),
  bool:      __webpack_require__(6199),
  int:       __webpack_require__(4466),
  merge:     __webpack_require__(1851),
  omap:      __webpack_require__(6946),
  seq:       __webpack_require__(8636),
  str:       __webpack_require__(7212)
};

// Removed functions from JS-YAML 3.0.x
module.exports.safeLoad            = renamed('safeLoad', 'load');
module.exports.safeLoadAll         = renamed('safeLoadAll', 'loadAll');
module.exports.safeDump            = renamed('safeDump', 'dump');


/***/ }),

/***/ 8433:
/***/ ((module) => {

"use strict";



function isNothing(subject) {
  return (typeof subject === 'undefined') || (subject === null);
}


function isObject(subject) {
  return (typeof subject === 'object') && (subject !== null);
}


function toArray(sequence) {
  if (Array.isArray(sequence)) return sequence;
  else if (isNothing(sequence)) return [];

  return [ sequence ];
}


function extend(target, source) {
  var index, length, key, sourceKeys;

  if (source) {
    sourceKeys = Object.keys(source);

    for (index = 0, length = sourceKeys.length; index < length; index += 1) {
      key = sourceKeys[index];
      target[key] = source[key];
    }
  }

  return target;
}


function repeat(string, count) {
  var result = '', cycle;

  for (cycle = 0; cycle < count; cycle += 1) {
    result += string;
  }

  return result;
}


function isNegativeZero(number) {
  return (number === 0) && (Number.NEGATIVE_INFINITY === 1 / number);
}


module.exports.isNothing      = isNothing;
module.exports.isObject       = isObject;
module.exports.toArray        = toArray;
module.exports.repeat         = repeat;
module.exports.isNegativeZero = isNegativeZero;
module.exports.extend         = extend;


/***/ }),

/***/ 4781:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


/*eslint-disable no-use-before-define*/

var common              = __webpack_require__(8433);
var YAMLException       = __webpack_require__(1231);
var DEFAULT_SCHEMA      = __webpack_require__(5489);

var _toString       = Object.prototype.toString;
var _hasOwnProperty = Object.prototype.hasOwnProperty;

var CHAR_BOM                  = 0xFEFF;
var CHAR_TAB                  = 0x09; /* Tab */
var CHAR_LINE_FEED            = 0x0A; /* LF */
var CHAR_CARRIAGE_RETURN      = 0x0D; /* CR */
var CHAR_SPACE                = 0x20; /* Space */
var CHAR_EXCLAMATION          = 0x21; /* ! */
var CHAR_DOUBLE_QUOTE         = 0x22; /* " */
var CHAR_SHARP                = 0x23; /* # */
var CHAR_PERCENT              = 0x25; /* % */
var CHAR_AMPERSAND            = 0x26; /* & */
var CHAR_SINGLE_QUOTE         = 0x27; /* ' */
var CHAR_ASTERISK             = 0x2A; /* * */
var CHAR_COMMA                = 0x2C; /* , */
var CHAR_MINUS                = 0x2D; /* - */
var CHAR_COLON                = 0x3A; /* : */
var CHAR_EQUALS               = 0x3D; /* = */
var CHAR_GREATER_THAN         = 0x3E; /* > */
var CHAR_QUESTION             = 0x3F; /* ? */
var CHAR_COMMERCIAL_AT        = 0x40; /* @ */
var CHAR_LEFT_SQUARE_BRACKET  = 0x5B; /* [ */
var CHAR_RIGHT_SQUARE_BRACKET = 0x5D; /* ] */
var CHAR_GRAVE_ACCENT         = 0x60; /* ` */
var CHAR_LEFT_CURLY_BRACKET   = 0x7B; /* { */
var CHAR_VERTICAL_LINE        = 0x7C; /* | */
var CHAR_RIGHT_CURLY_BRACKET  = 0x7D; /* } */

var ESCAPE_SEQUENCES = {};

ESCAPE_SEQUENCES[0x00]   = '\\0';
ESCAPE_SEQUENCES[0x07]   = '\\a';
ESCAPE_SEQUENCES[0x08]   = '\\b';
ESCAPE_SEQUENCES[0x09]   = '\\t';
ESCAPE_SEQUENCES[0x0A]   = '\\n';
ESCAPE_SEQUENCES[0x0B]   = '\\v';
ESCAPE_SEQUENCES[0x0C]   = '\\f';
ESCAPE_SEQUENCES[0x0D]   = '\\r';
ESCAPE_SEQUENCES[0x1B]   = '\\e';
ESCAPE_SEQUENCES[0x22]   = '\\"';
ESCAPE_SEQUENCES[0x5C]   = '\\\\';
ESCAPE_SEQUENCES[0x85]   = '\\N';
ESCAPE_SEQUENCES[0xA0]   = '\\_';
ESCAPE_SEQUENCES[0x2028] = '\\L';
ESCAPE_SEQUENCES[0x2029] = '\\P';

var DEPRECATED_BOOLEANS_SYNTAX = [
  'y', 'Y', 'yes', 'Yes', 'YES', 'on', 'On', 'ON',
  'n', 'N', 'no', 'No', 'NO', 'off', 'Off', 'OFF'
];

var DEPRECATED_BASE60_SYNTAX = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;

function compileStyleMap(schema, map) {
  var result, keys, index, length, tag, style, type;

  if (map === null) return {};

  result = {};
  keys = Object.keys(map);

  for (index = 0, length = keys.length; index < length; index += 1) {
    tag = keys[index];
    style = String(map[tag]);

    if (tag.slice(0, 2) === '!!') {
      tag = 'tag:yaml.org,2002:' + tag.slice(2);
    }
    type = schema.compiledTypeMap['fallback'][tag];

    if (type && _hasOwnProperty.call(type.styleAliases, style)) {
      style = type.styleAliases[style];
    }

    result[tag] = style;
  }

  return result;
}

function encodeHex(character) {
  var string, handle, length;

  string = character.toString(16).toUpperCase();

  if (character <= 0xFF) {
    handle = 'x';
    length = 2;
  } else if (character <= 0xFFFF) {
    handle = 'u';
    length = 4;
  } else if (character <= 0xFFFFFFFF) {
    handle = 'U';
    length = 8;
  } else {
    throw new YAMLException('code point within a string may not be greater than 0xFFFFFFFF');
  }

  return '\\' + handle + common.repeat('0', length - string.length) + string;
}


var QUOTING_TYPE_SINGLE = 1,
    QUOTING_TYPE_DOUBLE = 2;

function State(options) {
  this.schema        = options['schema'] || DEFAULT_SCHEMA;
  this.indent        = Math.max(1, (options['indent'] || 2));
  this.noArrayIndent = options['noArrayIndent'] || false;
  this.skipInvalid   = options['skipInvalid'] || false;
  this.flowLevel     = (common.isNothing(options['flowLevel']) ? -1 : options['flowLevel']);
  this.styleMap      = compileStyleMap(this.schema, options['styles'] || null);
  this.sortKeys      = options['sortKeys'] || false;
  this.lineWidth     = options['lineWidth'] || 80;
  this.noRefs        = options['noRefs'] || false;
  this.noCompatMode  = options['noCompatMode'] || false;
  this.condenseFlow  = options['condenseFlow'] || false;
  this.quotingType   = options['quotingType'] === '"' ? QUOTING_TYPE_DOUBLE : QUOTING_TYPE_SINGLE;
  this.forceQuotes   = options['forceQuotes'] || false;
  this.replacer      = typeof options['replacer'] === 'function' ? options['replacer'] : null;

  this.implicitTypes = this.schema.compiledImplicit;
  this.explicitTypes = this.schema.compiledExplicit;

  this.tag = null;
  this.result = '';

  this.duplicates = [];
  this.usedDuplicates = null;
}

// Indents every line in a string. Empty lines (\n only) are not indented.
function indentString(string, spaces) {
  var ind = common.repeat(' ', spaces),
      position = 0,
      next = -1,
      result = '',
      line,
      length = string.length;

  while (position < length) {
    next = string.indexOf('\n', position);
    if (next === -1) {
      line = string.slice(position);
      position = length;
    } else {
      line = string.slice(position, next + 1);
      position = next + 1;
    }

    if (line.length && line !== '\n') result += ind;

    result += line;
  }

  return result;
}

function generateNextLine(state, level) {
  return '\n' + common.repeat(' ', state.indent * level);
}

function testImplicitResolving(state, str) {
  var index, length, type;

  for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
    type = state.implicitTypes[index];

    if (type.resolve(str)) {
      return true;
    }
  }

  return false;
}

// [33] s-white ::= s-space | s-tab
function isWhitespace(c) {
  return c === CHAR_SPACE || c === CHAR_TAB;
}

// Returns true if the character can be printed without escaping.
// From YAML 1.2: "any allowed characters known to be non-printable
// should also be escaped. [However,] This isn’t mandatory"
// Derived from nb-char - \t - #x85 - #xA0 - #x2028 - #x2029.
function isPrintable(c) {
  return  (0x00020 <= c && c <= 0x00007E)
      || ((0x000A1 <= c && c <= 0x00D7FF) && c !== 0x2028 && c !== 0x2029)
      || ((0x0E000 <= c && c <= 0x00FFFD) && c !== CHAR_BOM)
      ||  (0x10000 <= c && c <= 0x10FFFF);
}

// [34] ns-char ::= nb-char - s-white
// [27] nb-char ::= c-printable - b-char - c-byte-order-mark
// [26] b-char  ::= b-line-feed | b-carriage-return
// Including s-white (for some reason, examples doesn't match specs in this aspect)
// ns-char ::= c-printable - b-line-feed - b-carriage-return - c-byte-order-mark
function isNsCharOrWhitespace(c) {
  return isPrintable(c)
    && c !== CHAR_BOM
    // - b-char
    && c !== CHAR_CARRIAGE_RETURN
    && c !== CHAR_LINE_FEED;
}

// [127]  ns-plain-safe(c) ::= c = flow-out  ⇒ ns-plain-safe-out
//                             c = flow-in   ⇒ ns-plain-safe-in
//                             c = block-key ⇒ ns-plain-safe-out
//                             c = flow-key  ⇒ ns-plain-safe-in
// [128] ns-plain-safe-out ::= ns-char
// [129]  ns-plain-safe-in ::= ns-char - c-flow-indicator
// [130]  ns-plain-char(c) ::=  ( ns-plain-safe(c) - “:” - “#” )
//                            | ( /* An ns-char preceding */ “#” )
//                            | ( “:” /* Followed by an ns-plain-safe(c) */ )
function isPlainSafe(c, prev, inblock) {
  var cIsNsCharOrWhitespace = isNsCharOrWhitespace(c);
  var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace(c);
  return (
    // ns-plain-safe
    inblock ? // c = flow-in
      cIsNsCharOrWhitespace
      : cIsNsCharOrWhitespace
        // - c-flow-indicator
        && c !== CHAR_COMMA
        && c !== CHAR_LEFT_SQUARE_BRACKET
        && c !== CHAR_RIGHT_SQUARE_BRACKET
        && c !== CHAR_LEFT_CURLY_BRACKET
        && c !== CHAR_RIGHT_CURLY_BRACKET
  )
    // ns-plain-char
    && c !== CHAR_SHARP // false on '#'
    && !(prev === CHAR_COLON && !cIsNsChar) // false on ': '
    || (isNsCharOrWhitespace(prev) && !isWhitespace(prev) && c === CHAR_SHARP) // change to true on '[^ ]#'
    || (prev === CHAR_COLON && cIsNsChar); // change to true on ':[^ ]'
}

// Simplified test for values allowed as the first character in plain style.
function isPlainSafeFirst(c) {
  // Uses a subset of ns-char - c-indicator
  // where ns-char = nb-char - s-white.
  // No support of ( ( “?” | “:” | “-” ) /* Followed by an ns-plain-safe(c)) */ ) part
  return isPrintable(c) && c !== CHAR_BOM
    && !isWhitespace(c) // - s-white
    // - (c-indicator ::=
    // “-” | “?” | “:” | “,” | “[” | “]” | “{” | “}”
    && c !== CHAR_MINUS
    && c !== CHAR_QUESTION
    && c !== CHAR_COLON
    && c !== CHAR_COMMA
    && c !== CHAR_LEFT_SQUARE_BRACKET
    && c !== CHAR_RIGHT_SQUARE_BRACKET
    && c !== CHAR_LEFT_CURLY_BRACKET
    && c !== CHAR_RIGHT_CURLY_BRACKET
    // | “#” | “&” | “*” | “!” | “|” | “=” | “>” | “'” | “"”
    && c !== CHAR_SHARP
    && c !== CHAR_AMPERSAND
    && c !== CHAR_ASTERISK
    && c !== CHAR_EXCLAMATION
    && c !== CHAR_VERTICAL_LINE
    && c !== CHAR_EQUALS
    && c !== CHAR_GREATER_THAN
    && c !== CHAR_SINGLE_QUOTE
    && c !== CHAR_DOUBLE_QUOTE
    // | “%” | “@” | “`”)
    && c !== CHAR_PERCENT
    && c !== CHAR_COMMERCIAL_AT
    && c !== CHAR_GRAVE_ACCENT;
}

// Simplified test for values allowed as the last character in plain style.
function isPlainSafeLast(c) {
  // just not whitespace or colon, it will be checked to be plain character later
  return !isWhitespace(c) && c !== CHAR_COLON;
}

// Same as 'string'.codePointAt(pos), but works in older browsers.
function codePointAt(string, pos) {
  var first = string.charCodeAt(pos), second;
  if (first >= 0xD800 && first <= 0xDBFF && pos + 1 < string.length) {
    second = string.charCodeAt(pos + 1);
    if (second >= 0xDC00 && second <= 0xDFFF) {
      // https://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
      return (first - 0xD800) * 0x400 + second - 0xDC00 + 0x10000;
    }
  }
  return first;
}

// Determines whether block indentation indicator is required.
function needIndentIndicator(string) {
  var leadingSpaceRe = /^\n* /;
  return leadingSpaceRe.test(string);
}

var STYLE_PLAIN   = 1,
    STYLE_SINGLE  = 2,
    STYLE_LITERAL = 3,
    STYLE_FOLDED  = 4,
    STYLE_DOUBLE  = 5;

// Determines which scalar styles are possible and returns the preferred style.
// lineWidth = -1 => no limit.
// Pre-conditions: str.length > 0.
// Post-conditions:
//    STYLE_PLAIN or STYLE_SINGLE => no \n are in the string.
//    STYLE_LITERAL => no lines are suitable for folding (or lineWidth is -1).
//    STYLE_FOLDED => a line > lineWidth and can be folded (and lineWidth != -1).
function chooseScalarStyle(string, singleLineOnly, indentPerLevel, lineWidth,
  testAmbiguousType, quotingType, forceQuotes, inblock) {

  var i;
  var char = 0;
  var prevChar = null;
  var hasLineBreak = false;
  var hasFoldableLine = false; // only checked if shouldTrackWidth
  var shouldTrackWidth = lineWidth !== -1;
  var previousLineBreak = -1; // count the first line correctly
  var plain = isPlainSafeFirst(codePointAt(string, 0))
          && isPlainSafeLast(codePointAt(string, string.length - 1));

  if (singleLineOnly || forceQuotes) {
    // Case: no block styles.
    // Check for disallowed characters to rule out plain and single.
    for (i = 0; i < string.length; char >= 0x10000 ? i += 2 : i++) {
      char = codePointAt(string, i);
      if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
  } else {
    // Case: block styles permitted.
    for (i = 0; i < string.length; char >= 0x10000 ? i += 2 : i++) {
      char = codePointAt(string, i);
      if (char === CHAR_LINE_FEED) {
        hasLineBreak = true;
        // Check if any line can be folded.
        if (shouldTrackWidth) {
          hasFoldableLine = hasFoldableLine ||
            // Foldable line = too long, and not more-indented.
            (i - previousLineBreak - 1 > lineWidth &&
             string[previousLineBreak + 1] !== ' ');
          previousLineBreak = i;
        }
      } else if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
    // in case the end is missing a \n
    hasFoldableLine = hasFoldableLine || (shouldTrackWidth &&
      (i - previousLineBreak - 1 > lineWidth &&
       string[previousLineBreak + 1] !== ' '));
  }
  // Although every style can represent \n without escaping, prefer block styles
  // for multiline, since they're more readable and they don't add empty lines.
  // Also prefer folding a super-long line.
  if (!hasLineBreak && !hasFoldableLine) {
    // Strings interpretable as another type have to be quoted;
    // e.g. the string 'true' vs. the boolean true.
    if (plain && !forceQuotes && !testAmbiguousType(string)) {
      return STYLE_PLAIN;
    }
    return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
  }
  // Edge case: block indentation indicator can only have one digit.
  if (indentPerLevel > 9 && needIndentIndicator(string)) {
    return STYLE_DOUBLE;
  }
  // At this point we know block styles are valid.
  // Prefer literal style unless we want to fold.
  if (!forceQuotes) {
    return hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
  }
  return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
}

// Note: line breaking/folding is implemented for only the folded style.
// NB. We drop the last trailing newline (if any) of a returned block scalar
//  since the dumper adds its own newline. This always works:
//    • No ending newline => unaffected; already using strip "-" chomping.
//    • Ending newline    => removed then restored.
//  Importantly, this keeps the "+" chomp indicator from gaining an extra line.
function writeScalar(state, string, level, iskey, inblock) {
  state.dump = (function () {
    if (string.length === 0) {
      return state.quotingType === QUOTING_TYPE_DOUBLE ? '""' : "''";
    }
    if (!state.noCompatMode) {
      if (DEPRECATED_BOOLEANS_SYNTAX.indexOf(string) !== -1 || DEPRECATED_BASE60_SYNTAX.test(string)) {
        return state.quotingType === QUOTING_TYPE_DOUBLE ? ('"' + string + '"') : ("'" + string + "'");
      }
    }

    var indent = state.indent * Math.max(1, level); // no 0-indent scalars
    // As indentation gets deeper, let the width decrease monotonically
    // to the lower bound min(state.lineWidth, 40).
    // Note that this implies
    //  state.lineWidth ≤ 40 + state.indent: width is fixed at the lower bound.
    //  state.lineWidth > 40 + state.indent: width decreases until the lower bound.
    // This behaves better than a constant minimum width which disallows narrower options,
    // or an indent threshold which causes the width to suddenly increase.
    var lineWidth = state.lineWidth === -1
      ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);

    // Without knowing if keys are implicit/explicit, assume implicit for safety.
    var singleLineOnly = iskey
      // No block styles in flow mode.
      || (state.flowLevel > -1 && level >= state.flowLevel);
    function testAmbiguity(string) {
      return testImplicitResolving(state, string);
    }

    switch (chooseScalarStyle(string, singleLineOnly, state.indent, lineWidth,
      testAmbiguity, state.quotingType, state.forceQuotes && !iskey, inblock)) {

      case STYLE_PLAIN:
        return string;
      case STYLE_SINGLE:
        return "'" + string.replace(/'/g, "''") + "'";
      case STYLE_LITERAL:
        return '|' + blockHeader(string, state.indent)
          + dropEndingNewline(indentString(string, indent));
      case STYLE_FOLDED:
        return '>' + blockHeader(string, state.indent)
          + dropEndingNewline(indentString(foldString(string, lineWidth), indent));
      case STYLE_DOUBLE:
        return '"' + escapeString(string, lineWidth) + '"';
      default:
        throw new YAMLException('impossible error: invalid scalar style');
    }
  }());
}

// Pre-conditions: string is valid for a block scalar, 1 <= indentPerLevel <= 9.
function blockHeader(string, indentPerLevel) {
  var indentIndicator = needIndentIndicator(string) ? String(indentPerLevel) : '';

  // note the special case: the string '\n' counts as a "trailing" empty line.
  var clip =          string[string.length - 1] === '\n';
  var keep = clip && (string[string.length - 2] === '\n' || string === '\n');
  var chomp = keep ? '+' : (clip ? '' : '-');

  return indentIndicator + chomp + '\n';
}

// (See the note for writeScalar.)
function dropEndingNewline(string) {
  return string[string.length - 1] === '\n' ? string.slice(0, -1) : string;
}

// Note: a long line without a suitable break point will exceed the width limit.
// Pre-conditions: every char in str isPrintable, str.length > 0, width > 0.
function foldString(string, width) {
  // In folded style, $k$ consecutive newlines output as $k+1$ newlines—
  // unless they're before or after a more-indented line, or at the very
  // beginning or end, in which case $k$ maps to $k$.
  // Therefore, parse each chunk as newline(s) followed by a content line.
  var lineRe = /(\n+)([^\n]*)/g;

  // first line (possibly an empty line)
  var result = (function () {
    var nextLF = string.indexOf('\n');
    nextLF = nextLF !== -1 ? nextLF : string.length;
    lineRe.lastIndex = nextLF;
    return foldLine(string.slice(0, nextLF), width);
  }());
  // If we haven't reached the first content line yet, don't add an extra \n.
  var prevMoreIndented = string[0] === '\n' || string[0] === ' ';
  var moreIndented;

  // rest of the lines
  var match;
  while ((match = lineRe.exec(string))) {
    var prefix = match[1], line = match[2];
    moreIndented = (line[0] === ' ');
    result += prefix
      + (!prevMoreIndented && !moreIndented && line !== ''
        ? '\n' : '')
      + foldLine(line, width);
    prevMoreIndented = moreIndented;
  }

  return result;
}

// Greedy line breaking.
// Picks the longest line under the limit each time,
// otherwise settles for the shortest line over the limit.
// NB. More-indented lines *cannot* be folded, as that would add an extra \n.
function foldLine(line, width) {
  if (line === '' || line[0] === ' ') return line;

  // Since a more-indented line adds a \n, breaks can't be followed by a space.
  var breakRe = / [^ ]/g; // note: the match index will always be <= length-2.
  var match;
  // start is an inclusive index. end, curr, and next are exclusive.
  var start = 0, end, curr = 0, next = 0;
  var result = '';

  // Invariants: 0 <= start <= length-1.
  //   0 <= curr <= next <= max(0, length-2). curr - start <= width.
  // Inside the loop:
  //   A match implies length >= 2, so curr and next are <= length-2.
  while ((match = breakRe.exec(line))) {
    next = match.index;
    // maintain invariant: curr - start <= width
    if (next - start > width) {
      end = (curr > start) ? curr : next; // derive end <= length-2
      result += '\n' + line.slice(start, end);
      // skip the space that was output as \n
      start = end + 1;                    // derive start <= length-1
    }
    curr = next;
  }

  // By the invariants, start <= length-1, so there is something left over.
  // It is either the whole string or a part starting from non-whitespace.
  result += '\n';
  // Insert a break if the remainder is too long and there is a break available.
  if (line.length - start > width && curr > start) {
    result += line.slice(start, curr) + '\n' + line.slice(curr + 1);
  } else {
    result += line.slice(start);
  }

  return result.slice(1); // drop extra \n joiner
}

// Escapes a double-quoted string.
function escapeString(string) {
  var result = '';
  var char = 0;
  var escapeSeq;

  for (var i = 0; i < string.length; char >= 0x10000 ? i += 2 : i++) {
    char = codePointAt(string, i);
    escapeSeq = ESCAPE_SEQUENCES[char];

    if (!escapeSeq && isPrintable(char)) {
      result += string[i];
      if (char >= 0x10000) result += string[i + 1];
    } else {
      result += escapeSeq || encodeHex(char);
    }
  }

  return result;
}

function writeFlowSequence(state, level, object) {
  var _result = '',
      _tag    = state.tag,
      index,
      length,
      value;

  for (index = 0, length = object.length; index < length; index += 1) {
    value = object[index];

    if (state.replacer) {
      value = state.replacer.call(object, String(index), value);
    }

    // Write only valid elements, put null instead of invalid elements.
    if (writeNode(state, level, value, false, false) ||
        (typeof value === 'undefined' &&
         writeNode(state, level, null, false, false))) {

      if (_result !== '') _result += ',' + (!state.condenseFlow ? ' ' : '');
      _result += state.dump;
    }
  }

  state.tag = _tag;
  state.dump = '[' + _result + ']';
}

function writeBlockSequence(state, level, object, compact) {
  var _result = '',
      _tag    = state.tag,
      index,
      length,
      value;

  for (index = 0, length = object.length; index < length; index += 1) {
    value = object[index];

    if (state.replacer) {
      value = state.replacer.call(object, String(index), value);
    }

    // Write only valid elements, put null instead of invalid elements.
    if (writeNode(state, level + 1, value, true, true, false, true) ||
        (typeof value === 'undefined' &&
         writeNode(state, level + 1, null, true, true, false, true))) {

      if (!compact || _result !== '') {
        _result += generateNextLine(state, level);
      }

      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        _result += '-';
      } else {
        _result += '- ';
      }

      _result += state.dump;
    }
  }

  state.tag = _tag;
  state.dump = _result || '[]'; // Empty sequence if no valid values.
}

function writeFlowMapping(state, level, object) {
  var _result       = '',
      _tag          = state.tag,
      objectKeyList = Object.keys(object),
      index,
      length,
      objectKey,
      objectValue,
      pairBuffer;

  for (index = 0, length = objectKeyList.length; index < length; index += 1) {

    pairBuffer = '';
    if (_result !== '') pairBuffer += ', ';

    if (state.condenseFlow) pairBuffer += '"';

    objectKey = objectKeyList[index];
    objectValue = object[objectKey];

    if (state.replacer) {
      objectValue = state.replacer.call(object, objectKey, objectValue);
    }

    if (!writeNode(state, level, objectKey, false, false)) {
      continue; // Skip this pair because of invalid key;
    }

    if (state.dump.length > 1024) pairBuffer += '? ';

    pairBuffer += state.dump + (state.condenseFlow ? '"' : '') + ':' + (state.condenseFlow ? '' : ' ');

    if (!writeNode(state, level, objectValue, false, false)) {
      continue; // Skip this pair because of invalid value.
    }

    pairBuffer += state.dump;

    // Both key and value are valid.
    _result += pairBuffer;
  }

  state.tag = _tag;
  state.dump = '{' + _result + '}';
}

function writeBlockMapping(state, level, object, compact) {
  var _result       = '',
      _tag          = state.tag,
      objectKeyList = Object.keys(object),
      index,
      length,
      objectKey,
      objectValue,
      explicitPair,
      pairBuffer;

  // Allow sorting keys so that the output file is deterministic
  if (state.sortKeys === true) {
    // Default sorting
    objectKeyList.sort();
  } else if (typeof state.sortKeys === 'function') {
    // Custom sort function
    objectKeyList.sort(state.sortKeys);
  } else if (state.sortKeys) {
    // Something is wrong
    throw new YAMLException('sortKeys must be a boolean or a function');
  }

  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = '';

    if (!compact || _result !== '') {
      pairBuffer += generateNextLine(state, level);
    }

    objectKey = objectKeyList[index];
    objectValue = object[objectKey];

    if (state.replacer) {
      objectValue = state.replacer.call(object, objectKey, objectValue);
    }

    if (!writeNode(state, level + 1, objectKey, true, true, true)) {
      continue; // Skip this pair because of invalid key.
    }

    explicitPair = (state.tag !== null && state.tag !== '?') ||
                   (state.dump && state.dump.length > 1024);

    if (explicitPair) {
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        pairBuffer += '?';
      } else {
        pairBuffer += '? ';
      }
    }

    pairBuffer += state.dump;

    if (explicitPair) {
      pairBuffer += generateNextLine(state, level);
    }

    if (!writeNode(state, level + 1, objectValue, true, explicitPair)) {
      continue; // Skip this pair because of invalid value.
    }

    if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
      pairBuffer += ':';
    } else {
      pairBuffer += ': ';
    }

    pairBuffer += state.dump;

    // Both key and value are valid.
    _result += pairBuffer;
  }

  state.tag = _tag;
  state.dump = _result || '{}'; // Empty mapping if no valid pairs.
}

function detectType(state, object, explicit) {
  var _result, typeList, index, length, type, style;

  typeList = explicit ? state.explicitTypes : state.implicitTypes;

  for (index = 0, length = typeList.length; index < length; index += 1) {
    type = typeList[index];

    if ((type.instanceOf  || type.predicate) &&
        (!type.instanceOf || ((typeof object === 'object') && (object instanceof type.instanceOf))) &&
        (!type.predicate  || type.predicate(object))) {

      if (explicit) {
        if (type.multi && type.representName) {
          state.tag = type.representName(object);
        } else {
          state.tag = type.tag;
        }
      } else {
        state.tag = '?';
      }

      if (type.represent) {
        style = state.styleMap[type.tag] || type.defaultStyle;

        if (_toString.call(type.represent) === '[object Function]') {
          _result = type.represent(object, style);
        } else if (_hasOwnProperty.call(type.represent, style)) {
          _result = type.represent[style](object, style);
        } else {
          throw new YAMLException('!<' + type.tag + '> tag resolver accepts not "' + style + '" style');
        }

        state.dump = _result;
      }

      return true;
    }
  }

  return false;
}

// Serializes `object` and writes it to global `result`.
// Returns true on success, or false on invalid object.
//
function writeNode(state, level, object, block, compact, iskey, isblockseq) {
  state.tag = null;
  state.dump = object;

  if (!detectType(state, object, false)) {
    detectType(state, object, true);
  }

  var type = _toString.call(state.dump);
  var inblock = block;
  var tagStr;

  if (block) {
    block = (state.flowLevel < 0 || state.flowLevel > level);
  }

  var objectOrArray = type === '[object Object]' || type === '[object Array]',
      duplicateIndex,
      duplicate;

  if (objectOrArray) {
    duplicateIndex = state.duplicates.indexOf(object);
    duplicate = duplicateIndex !== -1;
  }

  if ((state.tag !== null && state.tag !== '?') || duplicate || (state.indent !== 2 && level > 0)) {
    compact = false;
  }

  if (duplicate && state.usedDuplicates[duplicateIndex]) {
    state.dump = '*ref_' + duplicateIndex;
  } else {
    if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
      state.usedDuplicates[duplicateIndex] = true;
    }
    if (type === '[object Object]') {
      if (block && (Object.keys(state.dump).length !== 0)) {
        writeBlockMapping(state, level, state.dump, compact);
        if (duplicate) {
          state.dump = '&ref_' + duplicateIndex + state.dump;
        }
      } else {
        writeFlowMapping(state, level, state.dump);
        if (duplicate) {
          state.dump = '&ref_' + duplicateIndex + ' ' + state.dump;
        }
      }
    } else if (type === '[object Array]') {
      if (block && (state.dump.length !== 0)) {
        if (state.noArrayIndent && !isblockseq && level > 0) {
          writeBlockSequence(state, level - 1, state.dump, compact);
        } else {
          writeBlockSequence(state, level, state.dump, compact);
        }
        if (duplicate) {
          state.dump = '&ref_' + duplicateIndex + state.dump;
        }
      } else {
        writeFlowSequence(state, level, state.dump);
        if (duplicate) {
          state.dump = '&ref_' + duplicateIndex + ' ' + state.dump;
        }
      }
    } else if (type === '[object String]') {
      if (state.tag !== '?') {
        writeScalar(state, state.dump, level, iskey, inblock);
      }
    } else if (type === '[object Undefined]') {
      return false;
    } else {
      if (state.skipInvalid) return false;
      throw new YAMLException('unacceptable kind of an object to dump ' + type);
    }

    if (state.tag !== null && state.tag !== '?') {
      // Need to encode all characters except those allowed by the spec:
      //
      // [35] ns-dec-digit    ::=  [#x30-#x39] /* 0-9 */
      // [36] ns-hex-digit    ::=  ns-dec-digit
      //                         | [#x41-#x46] /* A-F */ | [#x61-#x66] /* a-f */
      // [37] ns-ascii-letter ::=  [#x41-#x5A] /* A-Z */ | [#x61-#x7A] /* a-z */
      // [38] ns-word-char    ::=  ns-dec-digit | ns-ascii-letter | “-”
      // [39] ns-uri-char     ::=  “%” ns-hex-digit ns-hex-digit | ns-word-char | “#”
      //                         | “;” | “/” | “?” | “:” | “@” | “&” | “=” | “+” | “$” | “,”
      //                         | “_” | “.” | “!” | “~” | “*” | “'” | “(” | “)” | “[” | “]”
      //
      // Also need to encode '!' because it has special meaning (end of tag prefix).
      //
      tagStr = encodeURI(
        state.tag[0] === '!' ? state.tag.slice(1) : state.tag
      ).replace(/!/g, '%21');

      if (state.tag[0] === '!') {
        tagStr = '!' + tagStr;
      } else if (tagStr.slice(0, 18) === 'tag:yaml.org,2002:') {
        tagStr = '!!' + tagStr.slice(18);
      } else {
        tagStr = '!<' + tagStr + '>';
      }

      state.dump = tagStr + ' ' + state.dump;
    }
  }

  return true;
}

function getDuplicateReferences(object, state) {
  var objects = [],
      duplicatesIndexes = [],
      index,
      length;

  inspectNode(object, objects, duplicatesIndexes);

  for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
    state.duplicates.push(objects[duplicatesIndexes[index]]);
  }
  state.usedDuplicates = new Array(length);
}

function inspectNode(object, objects, duplicatesIndexes) {
  var objectKeyList,
      index,
      length;

  if (object !== null && typeof object === 'object') {
    index = objects.indexOf(object);
    if (index !== -1) {
      if (duplicatesIndexes.indexOf(index) === -1) {
        duplicatesIndexes.push(index);
      }
    } else {
      objects.push(object);

      if (Array.isArray(object)) {
        for (index = 0, length = object.length; index < length; index += 1) {
          inspectNode(object[index], objects, duplicatesIndexes);
        }
      } else {
        objectKeyList = Object.keys(object);

        for (index = 0, length = objectKeyList.length; index < length; index += 1) {
          inspectNode(object[objectKeyList[index]], objects, duplicatesIndexes);
        }
      }
    }
  }
}

function dump(input, options) {
  options = options || {};

  var state = new State(options);

  if (!state.noRefs) getDuplicateReferences(input, state);

  var value = input;

  if (state.replacer) {
    value = state.replacer.call({ '': value }, '', value);
  }

  if (writeNode(state, 0, value, true, true)) return state.dump + '\n';

  return '';
}

module.exports.dump = dump;


/***/ }),

/***/ 1231:
/***/ ((module) => {

"use strict";
// YAML error class. http://stackoverflow.com/questions/8458984
//



function formatError(exception, compact) {
  var where = '', message = exception.reason || '(unknown reason)';

  if (!exception.mark) return message;

  if (exception.mark.name) {
    where += 'in "' + exception.mark.name + '" ';
  }

  where += '(' + (exception.mark.line + 1) + ':' + (exception.mark.column + 1) + ')';

  if (!compact && exception.mark.snippet) {
    where += '\n\n' + exception.mark.snippet;
  }

  return message + ' ' + where;
}


function YAMLException(reason, mark) {
  // Super constructor
  Error.call(this);

  this.name = 'YAMLException';
  this.reason = reason;
  this.mark = mark;
  this.message = formatError(this, false);

  // Include stack trace in error object
  if (Error.captureStackTrace) {
    // Chrome and NodeJS
    Error.captureStackTrace(this, this.constructor);
  } else {
    // FF, IE 10+ and Safari 6+. Fallback for others
    this.stack = (new Error()).stack || '';
  }
}


// Inherit from Error
YAMLException.prototype = Object.create(Error.prototype);
YAMLException.prototype.constructor = YAMLException;


YAMLException.prototype.toString = function toString(compact) {
  return this.name + ': ' + formatError(this, compact);
};


module.exports = YAMLException;


/***/ }),

/***/ 9243:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


/*eslint-disable max-len,no-use-before-define*/

var common              = __webpack_require__(8433);
var YAMLException       = __webpack_require__(1231);
var makeSnippet         = __webpack_require__(8083);
var DEFAULT_SCHEMA      = __webpack_require__(5489);


var _hasOwnProperty = Object.prototype.hasOwnProperty;


var CONTEXT_FLOW_IN   = 1;
var CONTEXT_FLOW_OUT  = 2;
var CONTEXT_BLOCK_IN  = 3;
var CONTEXT_BLOCK_OUT = 4;


var CHOMPING_CLIP  = 1;
var CHOMPING_STRIP = 2;
var CHOMPING_KEEP  = 3;


var PATTERN_NON_PRINTABLE         = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
var PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/;
var PATTERN_FLOW_INDICATORS       = /[,\[\]\{\}]/;
var PATTERN_TAG_HANDLE            = /^(?:!|!!|![a-z\-]+!)$/i;
var PATTERN_TAG_URI               = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;


function _class(obj) { return Object.prototype.toString.call(obj); }

function is_EOL(c) {
  return (c === 0x0A/* LF */) || (c === 0x0D/* CR */);
}

function is_WHITE_SPACE(c) {
  return (c === 0x09/* Tab */) || (c === 0x20/* Space */);
}

function is_WS_OR_EOL(c) {
  return (c === 0x09/* Tab */) ||
         (c === 0x20/* Space */) ||
         (c === 0x0A/* LF */) ||
         (c === 0x0D/* CR */);
}

function is_FLOW_INDICATOR(c) {
  return c === 0x2C/* , */ ||
         c === 0x5B/* [ */ ||
         c === 0x5D/* ] */ ||
         c === 0x7B/* { */ ||
         c === 0x7D/* } */;
}

function fromHexCode(c) {
  var lc;

  if ((0x30/* 0 */ <= c) && (c <= 0x39/* 9 */)) {
    return c - 0x30;
  }

  /*eslint-disable no-bitwise*/
  lc = c | 0x20;

  if ((0x61/* a */ <= lc) && (lc <= 0x66/* f */)) {
    return lc - 0x61 + 10;
  }

  return -1;
}

function escapedHexLen(c) {
  if (c === 0x78/* x */) { return 2; }
  if (c === 0x75/* u */) { return 4; }
  if (c === 0x55/* U */) { return 8; }
  return 0;
}

function fromDecimalCode(c) {
  if ((0x30/* 0 */ <= c) && (c <= 0x39/* 9 */)) {
    return c - 0x30;
  }

  return -1;
}

function simpleEscapeSequence(c) {
  /* eslint-disable indent */
  return (c === 0x30/* 0 */) ? '\x00' :
        (c === 0x61/* a */) ? '\x07' :
        (c === 0x62/* b */) ? '\x08' :
        (c === 0x74/* t */) ? '\x09' :
        (c === 0x09/* Tab */) ? '\x09' :
        (c === 0x6E/* n */) ? '\x0A' :
        (c === 0x76/* v */) ? '\x0B' :
        (c === 0x66/* f */) ? '\x0C' :
        (c === 0x72/* r */) ? '\x0D' :
        (c === 0x65/* e */) ? '\x1B' :
        (c === 0x20/* Space */) ? ' ' :
        (c === 0x22/* " */) ? '\x22' :
        (c === 0x2F/* / */) ? '/' :
        (c === 0x5C/* \ */) ? '\x5C' :
        (c === 0x4E/* N */) ? '\x85' :
        (c === 0x5F/* _ */) ? '\xA0' :
        (c === 0x4C/* L */) ? '\u2028' :
        (c === 0x50/* P */) ? '\u2029' : '';
}

function charFromCodepoint(c) {
  if (c <= 0xFFFF) {
    return String.fromCharCode(c);
  }
  // Encode UTF-16 surrogate pair
  // https://en.wikipedia.org/wiki/UTF-16#Code_points_U.2B010000_to_U.2B10FFFF
  return String.fromCharCode(
    ((c - 0x010000) >> 10) + 0xD800,
    ((c - 0x010000) & 0x03FF) + 0xDC00
  );
}

var simpleEscapeCheck = new Array(256); // integer, for fast access
var simpleEscapeMap = new Array(256);
for (var i = 0; i < 256; i++) {
  simpleEscapeCheck[i] = simpleEscapeSequence(i) ? 1 : 0;
  simpleEscapeMap[i] = simpleEscapeSequence(i);
}


function State(input, options) {
  this.input = input;

  this.filename  = options['filename']  || null;
  this.schema    = options['schema']    || DEFAULT_SCHEMA;
  this.onWarning = options['onWarning'] || null;
  // (Hidden) Remove? makes the loader to expect YAML 1.1 documents
  // if such documents have no explicit %YAML directive
  this.legacy    = options['legacy']    || false;

  this.json      = options['json']      || false;
  this.listener  = options['listener']  || null;

  this.implicitTypes = this.schema.compiledImplicit;
  this.typeMap       = this.schema.compiledTypeMap;

  this.length     = input.length;
  this.position   = 0;
  this.line       = 0;
  this.lineStart  = 0;
  this.lineIndent = 0;

  // position of first leading tab in the current line,
  // used to make sure there are no tabs in the indentation
  this.firstTabInLine = -1;

  this.documents = [];

  /*
  this.version;
  this.checkLineBreaks;
  this.tagMap;
  this.anchorMap;
  this.tag;
  this.anchor;
  this.kind;
  this.result;*/

}


function generateError(state, message) {
  var mark = {
    name:     state.filename,
    buffer:   state.input.slice(0, -1), // omit trailing \0
    position: state.position,
    line:     state.line,
    column:   state.position - state.lineStart
  };

  mark.snippet = makeSnippet(mark);

  return new YAMLException(message, mark);
}

function throwError(state, message) {
  throw generateError(state, message);
}

function throwWarning(state, message) {
  if (state.onWarning) {
    state.onWarning.call(null, generateError(state, message));
  }
}


var directiveHandlers = {

  YAML: function handleYamlDirective(state, name, args) {

    var match, major, minor;

    if (state.version !== null) {
      throwError(state, 'duplication of %YAML directive');
    }

    if (args.length !== 1) {
      throwError(state, 'YAML directive accepts exactly one argument');
    }

    match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);

    if (match === null) {
      throwError(state, 'ill-formed argument of the YAML directive');
    }

    major = parseInt(match[1], 10);
    minor = parseInt(match[2], 10);

    if (major !== 1) {
      throwError(state, 'unacceptable YAML version of the document');
    }

    state.version = args[0];
    state.checkLineBreaks = (minor < 2);

    if (minor !== 1 && minor !== 2) {
      throwWarning(state, 'unsupported YAML version of the document');
    }
  },

  TAG: function handleTagDirective(state, name, args) {

    var handle, prefix;

    if (args.length !== 2) {
      throwError(state, 'TAG directive accepts exactly two arguments');
    }

    handle = args[0];
    prefix = args[1];

    if (!PATTERN_TAG_HANDLE.test(handle)) {
      throwError(state, 'ill-formed tag handle (first argument) of the TAG directive');
    }

    if (_hasOwnProperty.call(state.tagMap, handle)) {
      throwError(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
    }

    if (!PATTERN_TAG_URI.test(prefix)) {
      throwError(state, 'ill-formed tag prefix (second argument) of the TAG directive');
    }

    try {
      prefix = decodeURIComponent(prefix);
    } catch (err) {
      throwError(state, 'tag prefix is malformed: ' + prefix);
    }

    state.tagMap[handle] = prefix;
  }
};


function captureSegment(state, start, end, checkJson) {
  var _position, _length, _character, _result;

  if (start < end) {
    _result = state.input.slice(start, end);

    if (checkJson) {
      for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
        _character = _result.charCodeAt(_position);
        if (!(_character === 0x09 ||
              (0x20 <= _character && _character <= 0x10FFFF))) {
          throwError(state, 'expected valid JSON character');
        }
      }
    } else if (PATTERN_NON_PRINTABLE.test(_result)) {
      throwError(state, 'the stream contains non-printable characters');
    }

    state.result += _result;
  }
}

function mergeMappings(state, destination, source, overridableKeys) {
  var sourceKeys, key, index, quantity;

  if (!common.isObject(source)) {
    throwError(state, 'cannot merge mappings; the provided source object is unacceptable');
  }

  sourceKeys = Object.keys(source);

  for (index = 0, quantity = sourceKeys.length; index < quantity; index += 1) {
    key = sourceKeys[index];

    if (!_hasOwnProperty.call(destination, key)) {
      destination[key] = source[key];
      overridableKeys[key] = true;
    }
  }
}

function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode,
  startLine, startLineStart, startPos) {

  var index, quantity;

  // The output is a plain object here, so keys can only be strings.
  // We need to convert keyNode to a string, but doing so can hang the process
  // (deeply nested arrays that explode exponentially using aliases).
  if (Array.isArray(keyNode)) {
    keyNode = Array.prototype.slice.call(keyNode);

    for (index = 0, quantity = keyNode.length; index < quantity; index += 1) {
      if (Array.isArray(keyNode[index])) {
        throwError(state, 'nested arrays are not supported inside keys');
      }

      if (typeof keyNode === 'object' && _class(keyNode[index]) === '[object Object]') {
        keyNode[index] = '[object Object]';
      }
    }
  }

  // Avoid code execution in load() via toString property
  // (still use its own toString for arrays, timestamps,
  // and whatever user schema extensions happen to have @@toStringTag)
  if (typeof keyNode === 'object' && _class(keyNode) === '[object Object]') {
    keyNode = '[object Object]';
  }


  keyNode = String(keyNode);

  if (_result === null) {
    _result = {};
  }

  if (keyTag === 'tag:yaml.org,2002:merge') {
    if (Array.isArray(valueNode)) {
      for (index = 0, quantity = valueNode.length; index < quantity; index += 1) {
        mergeMappings(state, _result, valueNode[index], overridableKeys);
      }
    } else {
      mergeMappings(state, _result, valueNode, overridableKeys);
    }
  } else {
    if (!state.json &&
        !_hasOwnProperty.call(overridableKeys, keyNode) &&
        _hasOwnProperty.call(_result, keyNode)) {
      state.line = startLine || state.line;
      state.lineStart = startLineStart || state.lineStart;
      state.position = startPos || state.position;
      throwError(state, 'duplicated mapping key');
    }

    // used for this specific key only because Object.defineProperty is slow
    if (keyNode === '__proto__') {
      Object.defineProperty(_result, keyNode, {
        configurable: true,
        enumerable: true,
        writable: true,
        value: valueNode
      });
    } else {
      _result[keyNode] = valueNode;
    }
    delete overridableKeys[keyNode];
  }

  return _result;
}

function readLineBreak(state) {
  var ch;

  ch = state.input.charCodeAt(state.position);

  if (ch === 0x0A/* LF */) {
    state.position++;
  } else if (ch === 0x0D/* CR */) {
    state.position++;
    if (state.input.charCodeAt(state.position) === 0x0A/* LF */) {
      state.position++;
    }
  } else {
    throwError(state, 'a line break is expected');
  }

  state.line += 1;
  state.lineStart = state.position;
  state.firstTabInLine = -1;
}

function skipSeparationSpace(state, allowComments, checkIndent) {
  var lineBreaks = 0,
      ch = state.input.charCodeAt(state.position);

  while (ch !== 0) {
    while (is_WHITE_SPACE(ch)) {
      if (ch === 0x09/* Tab */ && state.firstTabInLine === -1) {
        state.firstTabInLine = state.position;
      }
      ch = state.input.charCodeAt(++state.position);
    }

    if (allowComments && ch === 0x23/* # */) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (ch !== 0x0A/* LF */ && ch !== 0x0D/* CR */ && ch !== 0);
    }

    if (is_EOL(ch)) {
      readLineBreak(state);

      ch = state.input.charCodeAt(state.position);
      lineBreaks++;
      state.lineIndent = 0;

      while (ch === 0x20/* Space */) {
        state.lineIndent++;
        ch = state.input.charCodeAt(++state.position);
      }
    } else {
      break;
    }
  }

  if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
    throwWarning(state, 'deficient indentation');
  }

  return lineBreaks;
}

function testDocumentSeparator(state) {
  var _position = state.position,
      ch;

  ch = state.input.charCodeAt(_position);

  // Condition state.position === state.lineStart is tested
  // in parent on each call, for efficiency. No needs to test here again.
  if ((ch === 0x2D/* - */ || ch === 0x2E/* . */) &&
      ch === state.input.charCodeAt(_position + 1) &&
      ch === state.input.charCodeAt(_position + 2)) {

    _position += 3;

    ch = state.input.charCodeAt(_position);

    if (ch === 0 || is_WS_OR_EOL(ch)) {
      return true;
    }
  }

  return false;
}

function writeFoldedLines(state, count) {
  if (count === 1) {
    state.result += ' ';
  } else if (count > 1) {
    state.result += common.repeat('\n', count - 1);
  }
}


function readPlainScalar(state, nodeIndent, withinFlowCollection) {
  var preceding,
      following,
      captureStart,
      captureEnd,
      hasPendingContent,
      _line,
      _lineStart,
      _lineIndent,
      _kind = state.kind,
      _result = state.result,
      ch;

  ch = state.input.charCodeAt(state.position);

  if (is_WS_OR_EOL(ch)      ||
      is_FLOW_INDICATOR(ch) ||
      ch === 0x23/* # */    ||
      ch === 0x26/* & */    ||
      ch === 0x2A/* * */    ||
      ch === 0x21/* ! */    ||
      ch === 0x7C/* | */    ||
      ch === 0x3E/* > */    ||
      ch === 0x27/* ' */    ||
      ch === 0x22/* " */    ||
      ch === 0x25/* % */    ||
      ch === 0x40/* @ */    ||
      ch === 0x60/* ` */) {
    return false;
  }

  if (ch === 0x3F/* ? */ || ch === 0x2D/* - */) {
    following = state.input.charCodeAt(state.position + 1);

    if (is_WS_OR_EOL(following) ||
        withinFlowCollection && is_FLOW_INDICATOR(following)) {
      return false;
    }
  }

  state.kind = 'scalar';
  state.result = '';
  captureStart = captureEnd = state.position;
  hasPendingContent = false;

  while (ch !== 0) {
    if (ch === 0x3A/* : */) {
      following = state.input.charCodeAt(state.position + 1);

      if (is_WS_OR_EOL(following) ||
          withinFlowCollection && is_FLOW_INDICATOR(following)) {
        break;
      }

    } else if (ch === 0x23/* # */) {
      preceding = state.input.charCodeAt(state.position - 1);

      if (is_WS_OR_EOL(preceding)) {
        break;
      }

    } else if ((state.position === state.lineStart && testDocumentSeparator(state)) ||
               withinFlowCollection && is_FLOW_INDICATOR(ch)) {
      break;

    } else if (is_EOL(ch)) {
      _line = state.line;
      _lineStart = state.lineStart;
      _lineIndent = state.lineIndent;
      skipSeparationSpace(state, false, -1);

      if (state.lineIndent >= nodeIndent) {
        hasPendingContent = true;
        ch = state.input.charCodeAt(state.position);
        continue;
      } else {
        state.position = captureEnd;
        state.line = _line;
        state.lineStart = _lineStart;
        state.lineIndent = _lineIndent;
        break;
      }
    }

    if (hasPendingContent) {
      captureSegment(state, captureStart, captureEnd, false);
      writeFoldedLines(state, state.line - _line);
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
    }

    if (!is_WHITE_SPACE(ch)) {
      captureEnd = state.position + 1;
    }

    ch = state.input.charCodeAt(++state.position);
  }

  captureSegment(state, captureStart, captureEnd, false);

  if (state.result) {
    return true;
  }

  state.kind = _kind;
  state.result = _result;
  return false;
}

function readSingleQuotedScalar(state, nodeIndent) {
  var ch,
      captureStart, captureEnd;

  ch = state.input.charCodeAt(state.position);

  if (ch !== 0x27/* ' */) {
    return false;
  }

  state.kind = 'scalar';
  state.result = '';
  state.position++;
  captureStart = captureEnd = state.position;

  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 0x27/* ' */) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);

      if (ch === 0x27/* ' */) {
        captureStart = state.position;
        state.position++;
        captureEnd = state.position;
      } else {
        return true;
      }

    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;

    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, 'unexpected end of the document within a single quoted scalar');

    } else {
      state.position++;
      captureEnd = state.position;
    }
  }

  throwError(state, 'unexpected end of the stream within a single quoted scalar');
}

function readDoubleQuotedScalar(state, nodeIndent) {
  var captureStart,
      captureEnd,
      hexLength,
      hexResult,
      tmp,
      ch;

  ch = state.input.charCodeAt(state.position);

  if (ch !== 0x22/* " */) {
    return false;
  }

  state.kind = 'scalar';
  state.result = '';
  state.position++;
  captureStart = captureEnd = state.position;

  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 0x22/* " */) {
      captureSegment(state, captureStart, state.position, true);
      state.position++;
      return true;

    } else if (ch === 0x5C/* \ */) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);

      if (is_EOL(ch)) {
        skipSeparationSpace(state, false, nodeIndent);

        // TODO: rework to inline fn with no type cast?
      } else if (ch < 256 && simpleEscapeCheck[ch]) {
        state.result += simpleEscapeMap[ch];
        state.position++;

      } else if ((tmp = escapedHexLen(ch)) > 0) {
        hexLength = tmp;
        hexResult = 0;

        for (; hexLength > 0; hexLength--) {
          ch = state.input.charCodeAt(++state.position);

          if ((tmp = fromHexCode(ch)) >= 0) {
            hexResult = (hexResult << 4) + tmp;

          } else {
            throwError(state, 'expected hexadecimal character');
          }
        }

        state.result += charFromCodepoint(hexResult);

        state.position++;

      } else {
        throwError(state, 'unknown escape sequence');
      }

      captureStart = captureEnd = state.position;

    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;

    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, 'unexpected end of the document within a double quoted scalar');

    } else {
      state.position++;
      captureEnd = state.position;
    }
  }

  throwError(state, 'unexpected end of the stream within a double quoted scalar');
}

function readFlowCollection(state, nodeIndent) {
  var readNext = true,
      _line,
      _lineStart,
      _pos,
      _tag     = state.tag,
      _result,
      _anchor  = state.anchor,
      following,
      terminator,
      isPair,
      isExplicitPair,
      isMapping,
      overridableKeys = Object.create(null),
      keyNode,
      keyTag,
      valueNode,
      ch;

  ch = state.input.charCodeAt(state.position);

  if (ch === 0x5B/* [ */) {
    terminator = 0x5D;/* ] */
    isMapping = false;
    _result = [];
  } else if (ch === 0x7B/* { */) {
    terminator = 0x7D;/* } */
    isMapping = true;
    _result = {};
  } else {
    return false;
  }

  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }

  ch = state.input.charCodeAt(++state.position);

  while (ch !== 0) {
    skipSeparationSpace(state, true, nodeIndent);

    ch = state.input.charCodeAt(state.position);

    if (ch === terminator) {
      state.position++;
      state.tag = _tag;
      state.anchor = _anchor;
      state.kind = isMapping ? 'mapping' : 'sequence';
      state.result = _result;
      return true;
    } else if (!readNext) {
      throwError(state, 'missed comma between flow collection entries');
    } else if (ch === 0x2C/* , */) {
      // "flow collection entries can never be completely empty", as per YAML 1.2, section 7.4
      throwError(state, "expected the node content, but found ','");
    }

    keyTag = keyNode = valueNode = null;
    isPair = isExplicitPair = false;

    if (ch === 0x3F/* ? */) {
      following = state.input.charCodeAt(state.position + 1);

      if (is_WS_OR_EOL(following)) {
        isPair = isExplicitPair = true;
        state.position++;
        skipSeparationSpace(state, true, nodeIndent);
      }
    }

    _line = state.line; // Save the current line.
    _lineStart = state.lineStart;
    _pos = state.position;
    composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
    keyTag = state.tag;
    keyNode = state.result;
    skipSeparationSpace(state, true, nodeIndent);

    ch = state.input.charCodeAt(state.position);

    if ((isExplicitPair || state.line === _line) && ch === 0x3A/* : */) {
      isPair = true;
      ch = state.input.charCodeAt(++state.position);
      skipSeparationSpace(state, true, nodeIndent);
      composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
      valueNode = state.result;
    }

    if (isMapping) {
      storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
    } else if (isPair) {
      _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
    } else {
      _result.push(keyNode);
    }

    skipSeparationSpace(state, true, nodeIndent);

    ch = state.input.charCodeAt(state.position);

    if (ch === 0x2C/* , */) {
      readNext = true;
      ch = state.input.charCodeAt(++state.position);
    } else {
      readNext = false;
    }
  }

  throwError(state, 'unexpected end of the stream within a flow collection');
}

function readBlockScalar(state, nodeIndent) {
  var captureStart,
      folding,
      chomping       = CHOMPING_CLIP,
      didReadContent = false,
      detectedIndent = false,
      textIndent     = nodeIndent,
      emptyLines     = 0,
      atMoreIndented = false,
      tmp,
      ch;

  ch = state.input.charCodeAt(state.position);

  if (ch === 0x7C/* | */) {
    folding = false;
  } else if (ch === 0x3E/* > */) {
    folding = true;
  } else {
    return false;
  }

  state.kind = 'scalar';
  state.result = '';

  while (ch !== 0) {
    ch = state.input.charCodeAt(++state.position);

    if (ch === 0x2B/* + */ || ch === 0x2D/* - */) {
      if (CHOMPING_CLIP === chomping) {
        chomping = (ch === 0x2B/* + */) ? CHOMPING_KEEP : CHOMPING_STRIP;
      } else {
        throwError(state, 'repeat of a chomping mode identifier');
      }

    } else if ((tmp = fromDecimalCode(ch)) >= 0) {
      if (tmp === 0) {
        throwError(state, 'bad explicit indentation width of a block scalar; it cannot be less than one');
      } else if (!detectedIndent) {
        textIndent = nodeIndent + tmp - 1;
        detectedIndent = true;
      } else {
        throwError(state, 'repeat of an indentation width identifier');
      }

    } else {
      break;
    }
  }

  if (is_WHITE_SPACE(ch)) {
    do { ch = state.input.charCodeAt(++state.position); }
    while (is_WHITE_SPACE(ch));

    if (ch === 0x23/* # */) {
      do { ch = state.input.charCodeAt(++state.position); }
      while (!is_EOL(ch) && (ch !== 0));
    }
  }

  while (ch !== 0) {
    readLineBreak(state);
    state.lineIndent = 0;

    ch = state.input.charCodeAt(state.position);

    while ((!detectedIndent || state.lineIndent < textIndent) &&
           (ch === 0x20/* Space */)) {
      state.lineIndent++;
      ch = state.input.charCodeAt(++state.position);
    }

    if (!detectedIndent && state.lineIndent > textIndent) {
      textIndent = state.lineIndent;
    }

    if (is_EOL(ch)) {
      emptyLines++;
      continue;
    }

    // End of the scalar.
    if (state.lineIndent < textIndent) {

      // Perform the chomping.
      if (chomping === CHOMPING_KEEP) {
        state.result += common.repeat('\n', didReadContent ? 1 + emptyLines : emptyLines);
      } else if (chomping === CHOMPING_CLIP) {
        if (didReadContent) { // i.e. only if the scalar is not empty.
          state.result += '\n';
        }
      }

      // Break this `while` cycle and go to the funciton's epilogue.
      break;
    }

    // Folded style: use fancy rules to handle line breaks.
    if (folding) {

      // Lines starting with white space characters (more-indented lines) are not folded.
      if (is_WHITE_SPACE(ch)) {
        atMoreIndented = true;
        // except for the first content line (cf. Example 8.1)
        state.result += common.repeat('\n', didReadContent ? 1 + emptyLines : emptyLines);

      // End of more-indented block.
      } else if (atMoreIndented) {
        atMoreIndented = false;
        state.result += common.repeat('\n', emptyLines + 1);

      // Just one line break - perceive as the same line.
      } else if (emptyLines === 0) {
        if (didReadContent) { // i.e. only if we have already read some scalar content.
          state.result += ' ';
        }

      // Several line breaks - perceive as different lines.
      } else {
        state.result += common.repeat('\n', emptyLines);
      }

    // Literal style: just add exact number of line breaks between content lines.
    } else {
      // Keep all line breaks except the header line break.
      state.result += common.repeat('\n', didReadContent ? 1 + emptyLines : emptyLines);
    }

    didReadContent = true;
    detectedIndent = true;
    emptyLines = 0;
    captureStart = state.position;

    while (!is_EOL(ch) && (ch !== 0)) {
      ch = state.input.charCodeAt(++state.position);
    }

    captureSegment(state, captureStart, state.position, false);
  }

  return true;
}

function readBlockSequence(state, nodeIndent) {
  var _line,
      _tag      = state.tag,
      _anchor   = state.anchor,
      _result   = [],
      following,
      detected  = false,
      ch;

  // there is a leading tab before this token, so it can't be a block sequence/mapping;
  // it can still be flow sequence/mapping or a scalar
  if (state.firstTabInLine !== -1) return false;

  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }

  ch = state.input.charCodeAt(state.position);

  while (ch !== 0) {
    if (state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, 'tab characters must not be used in indentation');
    }

    if (ch !== 0x2D/* - */) {
      break;
    }

    following = state.input.charCodeAt(state.position + 1);

    if (!is_WS_OR_EOL(following)) {
      break;
    }

    detected = true;
    state.position++;

    if (skipSeparationSpace(state, true, -1)) {
      if (state.lineIndent <= nodeIndent) {
        _result.push(null);
        ch = state.input.charCodeAt(state.position);
        continue;
      }
    }

    _line = state.line;
    composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, false, true);
    _result.push(state.result);
    skipSeparationSpace(state, true, -1);

    ch = state.input.charCodeAt(state.position);

    if ((state.line === _line || state.lineIndent > nodeIndent) && (ch !== 0)) {
      throwError(state, 'bad indentation of a sequence entry');
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }

  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = 'sequence';
    state.result = _result;
    return true;
  }
  return false;
}

function readBlockMapping(state, nodeIndent, flowIndent) {
  var following,
      allowCompact,
      _line,
      _keyLine,
      _keyLineStart,
      _keyPos,
      _tag          = state.tag,
      _anchor       = state.anchor,
      _result       = {},
      overridableKeys = Object.create(null),
      keyTag        = null,
      keyNode       = null,
      valueNode     = null,
      atExplicitKey = false,
      detected      = false,
      ch;

  // there is a leading tab before this token, so it can't be a block sequence/mapping;
  // it can still be flow sequence/mapping or a scalar
  if (state.firstTabInLine !== -1) return false;

  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }

  ch = state.input.charCodeAt(state.position);

  while (ch !== 0) {
    if (!atExplicitKey && state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, 'tab characters must not be used in indentation');
    }

    following = state.input.charCodeAt(state.position + 1);
    _line = state.line; // Save the current line.

    //
    // Explicit notation case. There are two separate blocks:
    // first for the key (denoted by "?") and second for the value (denoted by ":")
    //
    if ((ch === 0x3F/* ? */ || ch === 0x3A/* : */) && is_WS_OR_EOL(following)) {

      if (ch === 0x3F/* ? */) {
        if (atExplicitKey) {
          storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
          keyTag = keyNode = valueNode = null;
        }

        detected = true;
        atExplicitKey = true;
        allowCompact = true;

      } else if (atExplicitKey) {
        // i.e. 0x3A/* : */ === character after the explicit key.
        atExplicitKey = false;
        allowCompact = true;

      } else {
        throwError(state, 'incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line');
      }

      state.position += 1;
      ch = following;

    //
    // Implicit notation case. Flow-style node as the key first, then ":", and the value.
    //
    } else {
      _keyLine = state.line;
      _keyLineStart = state.lineStart;
      _keyPos = state.position;

      if (!composeNode(state, flowIndent, CONTEXT_FLOW_OUT, false, true)) {
        // Neither implicit nor explicit notation.
        // Reading is done. Go to the epilogue.
        break;
      }

      if (state.line === _line) {
        ch = state.input.charCodeAt(state.position);

        while (is_WHITE_SPACE(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }

        if (ch === 0x3A/* : */) {
          ch = state.input.charCodeAt(++state.position);

          if (!is_WS_OR_EOL(ch)) {
            throwError(state, 'a whitespace character is expected after the key-value separator within a block mapping');
          }

          if (atExplicitKey) {
            storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
            keyTag = keyNode = valueNode = null;
          }

          detected = true;
          atExplicitKey = false;
          allowCompact = false;
          keyTag = state.tag;
          keyNode = state.result;

        } else if (detected) {
          throwError(state, 'can not read an implicit mapping pair; a colon is missed');

        } else {
          state.tag = _tag;
          state.anchor = _anchor;
          return true; // Keep the result of `composeNode`.
        }

      } else if (detected) {
        throwError(state, 'can not read a block mapping entry; a multiline key may not be an implicit key');

      } else {
        state.tag = _tag;
        state.anchor = _anchor;
        return true; // Keep the result of `composeNode`.
      }
    }

    //
    // Common reading code for both explicit and implicit notations.
    //
    if (state.line === _line || state.lineIndent > nodeIndent) {
      if (atExplicitKey) {
        _keyLine = state.line;
        _keyLineStart = state.lineStart;
        _keyPos = state.position;
      }

      if (composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, true, allowCompact)) {
        if (atExplicitKey) {
          keyNode = state.result;
        } else {
          valueNode = state.result;
        }
      }

      if (!atExplicitKey) {
        storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
        keyTag = keyNode = valueNode = null;
      }

      skipSeparationSpace(state, true, -1);
      ch = state.input.charCodeAt(state.position);
    }

    if ((state.line === _line || state.lineIndent > nodeIndent) && (ch !== 0)) {
      throwError(state, 'bad indentation of a mapping entry');
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }

  //
  // Epilogue.
  //

  // Special case: last mapping's node contains only the key in explicit notation.
  if (atExplicitKey) {
    storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
  }

  // Expose the resulting mapping.
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = 'mapping';
    state.result = _result;
  }

  return detected;
}

function readTagProperty(state) {
  var _position,
      isVerbatim = false,
      isNamed    = false,
      tagHandle,
      tagName,
      ch;

  ch = state.input.charCodeAt(state.position);

  if (ch !== 0x21/* ! */) return false;

  if (state.tag !== null) {
    throwError(state, 'duplication of a tag property');
  }

  ch = state.input.charCodeAt(++state.position);

  if (ch === 0x3C/* < */) {
    isVerbatim = true;
    ch = state.input.charCodeAt(++state.position);

  } else if (ch === 0x21/* ! */) {
    isNamed = true;
    tagHandle = '!!';
    ch = state.input.charCodeAt(++state.position);

  } else {
    tagHandle = '!';
  }

  _position = state.position;

  if (isVerbatim) {
    do { ch = state.input.charCodeAt(++state.position); }
    while (ch !== 0 && ch !== 0x3E/* > */);

    if (state.position < state.length) {
      tagName = state.input.slice(_position, state.position);
      ch = state.input.charCodeAt(++state.position);
    } else {
      throwError(state, 'unexpected end of the stream within a verbatim tag');
    }
  } else {
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {

      if (ch === 0x21/* ! */) {
        if (!isNamed) {
          tagHandle = state.input.slice(_position - 1, state.position + 1);

          if (!PATTERN_TAG_HANDLE.test(tagHandle)) {
            throwError(state, 'named tag handle cannot contain such characters');
          }

          isNamed = true;
          _position = state.position + 1;
        } else {
          throwError(state, 'tag suffix cannot contain exclamation marks');
        }
      }

      ch = state.input.charCodeAt(++state.position);
    }

    tagName = state.input.slice(_position, state.position);

    if (PATTERN_FLOW_INDICATORS.test(tagName)) {
      throwError(state, 'tag suffix cannot contain flow indicator characters');
    }
  }

  if (tagName && !PATTERN_TAG_URI.test(tagName)) {
    throwError(state, 'tag name cannot contain such characters: ' + tagName);
  }

  try {
    tagName = decodeURIComponent(tagName);
  } catch (err) {
    throwError(state, 'tag name is malformed: ' + tagName);
  }

  if (isVerbatim) {
    state.tag = tagName;

  } else if (_hasOwnProperty.call(state.tagMap, tagHandle)) {
    state.tag = state.tagMap[tagHandle] + tagName;

  } else if (tagHandle === '!') {
    state.tag = '!' + tagName;

  } else if (tagHandle === '!!') {
    state.tag = 'tag:yaml.org,2002:' + tagName;

  } else {
    throwError(state, 'undeclared tag handle "' + tagHandle + '"');
  }

  return true;
}

function readAnchorProperty(state) {
  var _position,
      ch;

  ch = state.input.charCodeAt(state.position);

  if (ch !== 0x26/* & */) return false;

  if (state.anchor !== null) {
    throwError(state, 'duplication of an anchor property');
  }

  ch = state.input.charCodeAt(++state.position);
  _position = state.position;

  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }

  if (state.position === _position) {
    throwError(state, 'name of an anchor node must contain at least one character');
  }

  state.anchor = state.input.slice(_position, state.position);
  return true;
}

function readAlias(state) {
  var _position, alias,
      ch;

  ch = state.input.charCodeAt(state.position);

  if (ch !== 0x2A/* * */) return false;

  ch = state.input.charCodeAt(++state.position);
  _position = state.position;

  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }

  if (state.position === _position) {
    throwError(state, 'name of an alias node must contain at least one character');
  }

  alias = state.input.slice(_position, state.position);

  if (!_hasOwnProperty.call(state.anchorMap, alias)) {
    throwError(state, 'unidentified alias "' + alias + '"');
  }

  state.result = state.anchorMap[alias];
  skipSeparationSpace(state, true, -1);
  return true;
}

function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
  var allowBlockStyles,
      allowBlockScalars,
      allowBlockCollections,
      indentStatus = 1, // 1: this>parent, 0: this=parent, -1: this<parent
      atNewLine  = false,
      hasContent = false,
      typeIndex,
      typeQuantity,
      typeList,
      type,
      flowIndent,
      blockIndent;

  if (state.listener !== null) {
    state.listener('open', state);
  }

  state.tag    = null;
  state.anchor = null;
  state.kind   = null;
  state.result = null;

  allowBlockStyles = allowBlockScalars = allowBlockCollections =
    CONTEXT_BLOCK_OUT === nodeContext ||
    CONTEXT_BLOCK_IN  === nodeContext;

  if (allowToSeek) {
    if (skipSeparationSpace(state, true, -1)) {
      atNewLine = true;

      if (state.lineIndent > parentIndent) {
        indentStatus = 1;
      } else if (state.lineIndent === parentIndent) {
        indentStatus = 0;
      } else if (state.lineIndent < parentIndent) {
        indentStatus = -1;
      }
    }
  }

  if (indentStatus === 1) {
    while (readTagProperty(state) || readAnchorProperty(state)) {
      if (skipSeparationSpace(state, true, -1)) {
        atNewLine = true;
        allowBlockCollections = allowBlockStyles;

        if (state.lineIndent > parentIndent) {
          indentStatus = 1;
        } else if (state.lineIndent === parentIndent) {
          indentStatus = 0;
        } else if (state.lineIndent < parentIndent) {
          indentStatus = -1;
        }
      } else {
        allowBlockCollections = false;
      }
    }
  }

  if (allowBlockCollections) {
    allowBlockCollections = atNewLine || allowCompact;
  }

  if (indentStatus === 1 || CONTEXT_BLOCK_OUT === nodeContext) {
    if (CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext) {
      flowIndent = parentIndent;
    } else {
      flowIndent = parentIndent + 1;
    }

    blockIndent = state.position - state.lineStart;

    if (indentStatus === 1) {
      if (allowBlockCollections &&
          (readBlockSequence(state, blockIndent) ||
           readBlockMapping(state, blockIndent, flowIndent)) ||
          readFlowCollection(state, flowIndent)) {
        hasContent = true;
      } else {
        if ((allowBlockScalars && readBlockScalar(state, flowIndent)) ||
            readSingleQuotedScalar(state, flowIndent) ||
            readDoubleQuotedScalar(state, flowIndent)) {
          hasContent = true;

        } else if (readAlias(state)) {
          hasContent = true;

          if (state.tag !== null || state.anchor !== null) {
            throwError(state, 'alias node should not have any properties');
          }

        } else if (readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext)) {
          hasContent = true;

          if (state.tag === null) {
            state.tag = '?';
          }
        }

        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
      }
    } else if (indentStatus === 0) {
      // Special case: block sequences are allowed to have same indentation level as the parent.
      // http://www.yaml.org/spec/1.2/spec.html#id2799784
      hasContent = allowBlockCollections && readBlockSequence(state, blockIndent);
    }
  }

  if (state.tag === null) {
    if (state.anchor !== null) {
      state.anchorMap[state.anchor] = state.result;
    }

  } else if (state.tag === '?') {
    // Implicit resolving is not allowed for non-scalar types, and '?'
    // non-specific tag is only automatically assigned to plain scalars.
    //
    // We only need to check kind conformity in case user explicitly assigns '?'
    // tag, for example like this: "!<?> [0]"
    //
    if (state.result !== null && state.kind !== 'scalar') {
      throwError(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
    }

    for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
      type = state.implicitTypes[typeIndex];

      if (type.resolve(state.result)) { // `state.result` updated in resolver if matched
        state.result = type.construct(state.result);
        state.tag = type.tag;
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
        break;
      }
    }
  } else if (state.tag !== '!') {
    if (_hasOwnProperty.call(state.typeMap[state.kind || 'fallback'], state.tag)) {
      type = state.typeMap[state.kind || 'fallback'][state.tag];
    } else {
      // looking for multi type
      type = null;
      typeList = state.typeMap.multi[state.kind || 'fallback'];

      for (typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1) {
        if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
          type = typeList[typeIndex];
          break;
        }
      }
    }

    if (!type) {
      throwError(state, 'unknown tag !<' + state.tag + '>');
    }

    if (state.result !== null && type.kind !== state.kind) {
      throwError(state, 'unacceptable node kind for !<' + state.tag + '> tag; it should be "' + type.kind + '", not "' + state.kind + '"');
    }

    if (!type.resolve(state.result, state.tag)) { // `state.result` updated in resolver if matched
      throwError(state, 'cannot resolve a node with !<' + state.tag + '> explicit tag');
    } else {
      state.result = type.construct(state.result, state.tag);
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = state.result;
      }
    }
  }

  if (state.listener !== null) {
    state.listener('close', state);
  }
  return state.tag !== null ||  state.anchor !== null || hasContent;
}

function readDocument(state) {
  var documentStart = state.position,
      _position,
      directiveName,
      directiveArgs,
      hasDirectives = false,
      ch;

  state.version = null;
  state.checkLineBreaks = state.legacy;
  state.tagMap = Object.create(null);
  state.anchorMap = Object.create(null);

  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    skipSeparationSpace(state, true, -1);

    ch = state.input.charCodeAt(state.position);

    if (state.lineIndent > 0 || ch !== 0x25/* % */) {
      break;
    }

    hasDirectives = true;
    ch = state.input.charCodeAt(++state.position);
    _position = state.position;

    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      ch = state.input.charCodeAt(++state.position);
    }

    directiveName = state.input.slice(_position, state.position);
    directiveArgs = [];

    if (directiveName.length < 1) {
      throwError(state, 'directive name must not be less than one character in length');
    }

    while (ch !== 0) {
      while (is_WHITE_SPACE(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }

      if (ch === 0x23/* # */) {
        do { ch = state.input.charCodeAt(++state.position); }
        while (ch !== 0 && !is_EOL(ch));
        break;
      }

      if (is_EOL(ch)) break;

      _position = state.position;

      while (ch !== 0 && !is_WS_OR_EOL(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }

      directiveArgs.push(state.input.slice(_position, state.position));
    }

    if (ch !== 0) readLineBreak(state);

    if (_hasOwnProperty.call(directiveHandlers, directiveName)) {
      directiveHandlers[directiveName](state, directiveName, directiveArgs);
    } else {
      throwWarning(state, 'unknown document directive "' + directiveName + '"');
    }
  }

  skipSeparationSpace(state, true, -1);

  if (state.lineIndent === 0 &&
      state.input.charCodeAt(state.position)     === 0x2D/* - */ &&
      state.input.charCodeAt(state.position + 1) === 0x2D/* - */ &&
      state.input.charCodeAt(state.position + 2) === 0x2D/* - */) {
    state.position += 3;
    skipSeparationSpace(state, true, -1);

  } else if (hasDirectives) {
    throwError(state, 'directives end mark is expected');
  }

  composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, false, true);
  skipSeparationSpace(state, true, -1);

  if (state.checkLineBreaks &&
      PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position))) {
    throwWarning(state, 'non-ASCII line breaks are interpreted as content');
  }

  state.documents.push(state.result);

  if (state.position === state.lineStart && testDocumentSeparator(state)) {

    if (state.input.charCodeAt(state.position) === 0x2E/* . */) {
      state.position += 3;
      skipSeparationSpace(state, true, -1);
    }
    return;
  }

  if (state.position < (state.length - 1)) {
    throwError(state, 'end of the stream or a document separator is expected');
  } else {
    return;
  }
}


function loadDocuments(input, options) {
  input = String(input);
  options = options || {};

  if (input.length !== 0) {

    // Add tailing `\n` if not exists
    if (input.charCodeAt(input.length - 1) !== 0x0A/* LF */ &&
        input.charCodeAt(input.length - 1) !== 0x0D/* CR */) {
      input += '\n';
    }

    // Strip BOM
    if (input.charCodeAt(0) === 0xFEFF) {
      input = input.slice(1);
    }
  }

  var state = new State(input, options);

  var nullpos = input.indexOf('\0');

  if (nullpos !== -1) {
    state.position = nullpos;
    throwError(state, 'null byte is not allowed in input');
  }

  // Use 0 as string terminator. That significantly simplifies bounds check.
  state.input += '\0';

  while (state.input.charCodeAt(state.position) === 0x20/* Space */) {
    state.lineIndent += 1;
    state.position += 1;
  }

  while (state.position < (state.length - 1)) {
    readDocument(state);
  }

  return state.documents;
}


function loadAll(input, iterator, options) {
  if (iterator !== null && typeof iterator === 'object' && typeof options === 'undefined') {
    options = iterator;
    iterator = null;
  }

  var documents = loadDocuments(input, options);

  if (typeof iterator !== 'function') {
    return documents;
  }

  for (var index = 0, length = documents.length; index < length; index += 1) {
    iterator(documents[index]);
  }
}


function load(input, options) {
  var documents = loadDocuments(input, options);

  if (documents.length === 0) {
    /*eslint-disable no-undefined*/
    return undefined;
  } else if (documents.length === 1) {
    return documents[0];
  }
  throw new YAMLException('expected a single document in the stream, but found more');
}


module.exports.loadAll = loadAll;
module.exports.load    = load;


/***/ }),

/***/ 2119:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


/*eslint-disable max-len*/

var YAMLException = __webpack_require__(1231);
var Type          = __webpack_require__(5388);


function compileList(schema, name) {
  var result = [];

  schema[name].forEach(function (currentType) {
    var newIndex = result.length;

    result.forEach(function (previousType, previousIndex) {
      if (previousType.tag === currentType.tag &&
          previousType.kind === currentType.kind &&
          previousType.multi === currentType.multi) {

        newIndex = previousIndex;
      }
    });

    result[newIndex] = currentType;
  });

  return result;
}


function compileMap(/* lists... */) {
  var result = {
        scalar: {},
        sequence: {},
        mapping: {},
        fallback: {},
        multi: {
          scalar: [],
          sequence: [],
          mapping: [],
          fallback: []
        }
      }, index, length;

  function collectType(type) {
    if (type.multi) {
      result.multi[type.kind].push(type);
      result.multi['fallback'].push(type);
    } else {
      result[type.kind][type.tag] = result['fallback'][type.tag] = type;
    }
  }

  for (index = 0, length = arguments.length; index < length; index += 1) {
    arguments[index].forEach(collectType);
  }
  return result;
}


function Schema(definition) {
  return this.extend(definition);
}


Schema.prototype.extend = function extend(definition) {
  var implicit = [];
  var explicit = [];

  if (definition instanceof Type) {
    // Schema.extend(type)
    explicit.push(definition);

  } else if (Array.isArray(definition)) {
    // Schema.extend([ type1, type2, ... ])
    explicit = explicit.concat(definition);

  } else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
    // Schema.extend({ explicit: [ type1, type2, ... ], implicit: [ type1, type2, ... ] })
    if (definition.implicit) implicit = implicit.concat(definition.implicit);
    if (definition.explicit) explicit = explicit.concat(definition.explicit);

  } else {
    throw new YAMLException('Schema.extend argument should be a Type, [ Type ], ' +
      'or a schema definition ({ implicit: [...], explicit: [...] })');
  }

  implicit.forEach(function (type) {
    if (!(type instanceof Type)) {
      throw new YAMLException('Specified list of YAML types (or a single Type object) contains a non-Type object.');
    }

    if (type.loadKind && type.loadKind !== 'scalar') {
      throw new YAMLException('There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.');
    }

    if (type.multi) {
      throw new YAMLException('There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.');
    }
  });

  explicit.forEach(function (type) {
    if (!(type instanceof Type)) {
      throw new YAMLException('Specified list of YAML types (or a single Type object) contains a non-Type object.');
    }
  });

  var result = Object.create(Schema.prototype);

  result.implicit = (this.implicit || []).concat(implicit);
  result.explicit = (this.explicit || []).concat(explicit);

  result.compiledImplicit = compileList(result, 'implicit');
  result.compiledExplicit = compileList(result, 'explicit');
  result.compiledTypeMap  = compileMap(result.compiledImplicit, result.compiledExplicit);

  return result;
};


module.exports = Schema;


/***/ }),

/***/ 1769:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
// Standard YAML's Core schema.
// http://www.yaml.org/spec/1.2/spec.html#id2804923
//
// NOTE: JS-YAML does not support schema-specific tag resolution restrictions.
// So, Core schema has no distinctions from JSON schema is JS-YAML.





module.exports = __webpack_require__(6184);


/***/ }),

/***/ 5489:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
// JS-YAML's default schema for `safeLoad` function.
// It is not described in the YAML specification.
//
// This schema is based on standard YAML's Core schema and includes most of
// extra types described at YAML tag repository. (http://yaml.org/type/)





module.exports = (__webpack_require__(1769).extend)({
  implicit: [
    __webpack_require__(127),
    __webpack_require__(1851)
  ],
  explicit: [
    __webpack_require__(9342),
    __webpack_require__(6946),
    __webpack_require__(6942),
    __webpack_require__(6663)
  ]
});


/***/ }),

/***/ 7759:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
// Standard YAML's Failsafe schema.
// http://www.yaml.org/spec/1.2/spec.html#id2802346





var Schema = __webpack_require__(2119);


module.exports = new Schema({
  explicit: [
    __webpack_require__(7212),
    __webpack_require__(8636),
    __webpack_require__(2369)
  ]
});


/***/ }),

/***/ 6184:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
// Standard YAML's JSON schema.
// http://www.yaml.org/spec/1.2/spec.html#id2803231
//
// NOTE: JS-YAML does not support schema-specific tag resolution restrictions.
// So, this schema is not such strict as defined in the YAML specification.
// It allows numbers in binary notaion, use `Null` and `NULL` as `null`, etc.





module.exports = (__webpack_require__(7759).extend)({
  implicit: [
    __webpack_require__(9198),
    __webpack_require__(6199),
    __webpack_require__(4466),
    __webpack_require__(1461)
  ]
});


/***/ }),

/***/ 8083:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";



var common = __webpack_require__(8433);


// get snippet for a single line, respecting maxLength
function getLine(buffer, lineStart, lineEnd, position, maxLineLength) {
  var head = '';
  var tail = '';
  var maxHalfLength = Math.floor(maxLineLength / 2) - 1;

  if (position - lineStart > maxHalfLength) {
    head = ' ... ';
    lineStart = position - maxHalfLength + head.length;
  }

  if (lineEnd - position > maxHalfLength) {
    tail = ' ...';
    lineEnd = position + maxHalfLength - tail.length;
  }

  return {
    str: head + buffer.slice(lineStart, lineEnd).replace(/\t/g, '→') + tail,
    pos: position - lineStart + head.length // relative position
  };
}


function padStart(string, max) {
  return common.repeat(' ', max - string.length) + string;
}


function makeSnippet(mark, options) {
  options = Object.create(options || null);

  if (!mark.buffer) return null;

  if (!options.maxLength) options.maxLength = 79;
  if (typeof options.indent      !== 'number') options.indent      = 1;
  if (typeof options.linesBefore !== 'number') options.linesBefore = 3;
  if (typeof options.linesAfter  !== 'number') options.linesAfter  = 2;

  var re = /\r?\n|\r|\0/g;
  var lineStarts = [ 0 ];
  var lineEnds = [];
  var match;
  var foundLineNo = -1;

  while ((match = re.exec(mark.buffer))) {
    lineEnds.push(match.index);
    lineStarts.push(match.index + match[0].length);

    if (mark.position <= match.index && foundLineNo < 0) {
      foundLineNo = lineStarts.length - 2;
    }
  }

  if (foundLineNo < 0) foundLineNo = lineStarts.length - 1;

  var result = '', i, line;
  var lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length;
  var maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);

  for (i = 1; i <= options.linesBefore; i++) {
    if (foundLineNo - i < 0) break;
    line = getLine(
      mark.buffer,
      lineStarts[foundLineNo - i],
      lineEnds[foundLineNo - i],
      mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i]),
      maxLineLength
    );
    result = common.repeat(' ', options.indent) + padStart((mark.line - i + 1).toString(), lineNoLength) +
      ' | ' + line.str + '\n' + result;
  }

  line = getLine(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength);
  result += common.repeat(' ', options.indent) + padStart((mark.line + 1).toString(), lineNoLength) +
    ' | ' + line.str + '\n';
  result += common.repeat('-', options.indent + lineNoLength + 3 + line.pos) + '^' + '\n';

  for (i = 1; i <= options.linesAfter; i++) {
    if (foundLineNo + i >= lineEnds.length) break;
    line = getLine(
      mark.buffer,
      lineStarts[foundLineNo + i],
      lineEnds[foundLineNo + i],
      mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i]),
      maxLineLength
    );
    result += common.repeat(' ', options.indent) + padStart((mark.line + i + 1).toString(), lineNoLength) +
      ' | ' + line.str + '\n';
  }

  return result.replace(/\n$/, '');
}


module.exports = makeSnippet;


/***/ }),

/***/ 5388:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var YAMLException = __webpack_require__(1231);

var TYPE_CONSTRUCTOR_OPTIONS = [
  'kind',
  'multi',
  'resolve',
  'construct',
  'instanceOf',
  'predicate',
  'represent',
  'representName',
  'defaultStyle',
  'styleAliases'
];

var YAML_NODE_KINDS = [
  'scalar',
  'sequence',
  'mapping'
];

function compileStyleAliases(map) {
  var result = {};

  if (map !== null) {
    Object.keys(map).forEach(function (style) {
      map[style].forEach(function (alias) {
        result[String(alias)] = style;
      });
    });
  }

  return result;
}

function Type(tag, options) {
  options = options || {};

  Object.keys(options).forEach(function (name) {
    if (TYPE_CONSTRUCTOR_OPTIONS.indexOf(name) === -1) {
      throw new YAMLException('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
    }
  });

  // TODO: Add tag format check.
  this.options       = options; // keep original options in case user wants to extend this type later
  this.tag           = tag;
  this.kind          = options['kind']          || null;
  this.resolve       = options['resolve']       || function () { return true; };
  this.construct     = options['construct']     || function (data) { return data; };
  this.instanceOf    = options['instanceOf']    || null;
  this.predicate     = options['predicate']     || null;
  this.represent     = options['represent']     || null;
  this.representName = options['representName'] || null;
  this.defaultStyle  = options['defaultStyle']  || null;
  this.multi         = options['multi']         || false;
  this.styleAliases  = compileStyleAliases(options['styleAliases'] || null);

  if (YAML_NODE_KINDS.indexOf(this.kind) === -1) {
    throw new YAMLException('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
  }
}

module.exports = Type;


/***/ }),

/***/ 9342:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


/*eslint-disable no-bitwise*/


var Type = __webpack_require__(5388);


// [ 64, 65, 66 ] -> [ padding, CR, LF ]
var BASE64_MAP = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r';


function resolveYamlBinary(data) {
  if (data === null) return false;

  var code, idx, bitlen = 0, max = data.length, map = BASE64_MAP;

  // Convert one by one.
  for (idx = 0; idx < max; idx++) {
    code = map.indexOf(data.charAt(idx));

    // Skip CR/LF
    if (code > 64) continue;

    // Fail on illegal characters
    if (code < 0) return false;

    bitlen += 6;
  }

  // If there are any bits left, source was corrupted
  return (bitlen % 8) === 0;
}

function constructYamlBinary(data) {
  var idx, tailbits,
      input = data.replace(/[\r\n=]/g, ''), // remove CR/LF & padding to simplify scan
      max = input.length,
      map = BASE64_MAP,
      bits = 0,
      result = [];

  // Collect by 6*4 bits (3 bytes)

  for (idx = 0; idx < max; idx++) {
    if ((idx % 4 === 0) && idx) {
      result.push((bits >> 16) & 0xFF);
      result.push((bits >> 8) & 0xFF);
      result.push(bits & 0xFF);
    }

    bits = (bits << 6) | map.indexOf(input.charAt(idx));
  }

  // Dump tail

  tailbits = (max % 4) * 6;

  if (tailbits === 0) {
    result.push((bits >> 16) & 0xFF);
    result.push((bits >> 8) & 0xFF);
    result.push(bits & 0xFF);
  } else if (tailbits === 18) {
    result.push((bits >> 10) & 0xFF);
    result.push((bits >> 2) & 0xFF);
  } else if (tailbits === 12) {
    result.push((bits >> 4) & 0xFF);
  }

  return new Uint8Array(result);
}

function representYamlBinary(object /*, style*/) {
  var result = '', bits = 0, idx, tail,
      max = object.length,
      map = BASE64_MAP;

  // Convert every three bytes to 4 ASCII characters.

  for (idx = 0; idx < max; idx++) {
    if ((idx % 3 === 0) && idx) {
      result += map[(bits >> 18) & 0x3F];
      result += map[(bits >> 12) & 0x3F];
      result += map[(bits >> 6) & 0x3F];
      result += map[bits & 0x3F];
    }

    bits = (bits << 8) + object[idx];
  }

  // Dump tail

  tail = max % 3;

  if (tail === 0) {
    result += map[(bits >> 18) & 0x3F];
    result += map[(bits >> 12) & 0x3F];
    result += map[(bits >> 6) & 0x3F];
    result += map[bits & 0x3F];
  } else if (tail === 2) {
    result += map[(bits >> 10) & 0x3F];
    result += map[(bits >> 4) & 0x3F];
    result += map[(bits << 2) & 0x3F];
    result += map[64];
  } else if (tail === 1) {
    result += map[(bits >> 2) & 0x3F];
    result += map[(bits << 4) & 0x3F];
    result += map[64];
    result += map[64];
  }

  return result;
}

function isBinary(obj) {
  return Object.prototype.toString.call(obj) ===  '[object Uint8Array]';
}

module.exports = new Type('tag:yaml.org,2002:binary', {
  kind: 'scalar',
  resolve: resolveYamlBinary,
  construct: constructYamlBinary,
  predicate: isBinary,
  represent: representYamlBinary
});


/***/ }),

/***/ 6199:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

function resolveYamlBoolean(data) {
  if (data === null) return false;

  var max = data.length;

  return (max === 4 && (data === 'true' || data === 'True' || data === 'TRUE')) ||
         (max === 5 && (data === 'false' || data === 'False' || data === 'FALSE'));
}

function constructYamlBoolean(data) {
  return data === 'true' ||
         data === 'True' ||
         data === 'TRUE';
}

function isBoolean(object) {
  return Object.prototype.toString.call(object) === '[object Boolean]';
}

module.exports = new Type('tag:yaml.org,2002:bool', {
  kind: 'scalar',
  resolve: resolveYamlBoolean,
  construct: constructYamlBoolean,
  predicate: isBoolean,
  represent: {
    lowercase: function (object) { return object ? 'true' : 'false'; },
    uppercase: function (object) { return object ? 'TRUE' : 'FALSE'; },
    camelcase: function (object) { return object ? 'True' : 'False'; }
  },
  defaultStyle: 'lowercase'
});


/***/ }),

/***/ 1461:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var common = __webpack_require__(8433);
var Type   = __webpack_require__(5388);

var YAML_FLOAT_PATTERN = new RegExp(
  // 2.5e4, 2.5 and integers
  '^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?' +
  // .2e4, .2
  // special case, seems not from spec
  '|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?' +
  // .inf
  '|[-+]?\\.(?:inf|Inf|INF)' +
  // .nan
  '|\\.(?:nan|NaN|NAN))$');

function resolveYamlFloat(data) {
  if (data === null) return false;

  if (!YAML_FLOAT_PATTERN.test(data) ||
      // Quick hack to not allow integers end with `_`
      // Probably should update regexp & check speed
      data[data.length - 1] === '_') {
    return false;
  }

  return true;
}

function constructYamlFloat(data) {
  var value, sign;

  value  = data.replace(/_/g, '').toLowerCase();
  sign   = value[0] === '-' ? -1 : 1;

  if ('+-'.indexOf(value[0]) >= 0) {
    value = value.slice(1);
  }

  if (value === '.inf') {
    return (sign === 1) ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;

  } else if (value === '.nan') {
    return NaN;
  }
  return sign * parseFloat(value, 10);
}


var SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;

function representYamlFloat(object, style) {
  var res;

  if (isNaN(object)) {
    switch (style) {
      case 'lowercase': return '.nan';
      case 'uppercase': return '.NAN';
      case 'camelcase': return '.NaN';
    }
  } else if (Number.POSITIVE_INFINITY === object) {
    switch (style) {
      case 'lowercase': return '.inf';
      case 'uppercase': return '.INF';
      case 'camelcase': return '.Inf';
    }
  } else if (Number.NEGATIVE_INFINITY === object) {
    switch (style) {
      case 'lowercase': return '-.inf';
      case 'uppercase': return '-.INF';
      case 'camelcase': return '-.Inf';
    }
  } else if (common.isNegativeZero(object)) {
    return '-0.0';
  }

  res = object.toString(10);

  // JS stringifier can build scientific format without dots: 5e-100,
  // while YAML requres dot: 5.e-100. Fix it with simple hack

  return SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace('e', '.e') : res;
}

function isFloat(object) {
  return (Object.prototype.toString.call(object) === '[object Number]') &&
         (object % 1 !== 0 || common.isNegativeZero(object));
}

module.exports = new Type('tag:yaml.org,2002:float', {
  kind: 'scalar',
  resolve: resolveYamlFloat,
  construct: constructYamlFloat,
  predicate: isFloat,
  represent: representYamlFloat,
  defaultStyle: 'lowercase'
});


/***/ }),

/***/ 4466:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var common = __webpack_require__(8433);
var Type   = __webpack_require__(5388);

function isHexCode(c) {
  return ((0x30/* 0 */ <= c) && (c <= 0x39/* 9 */)) ||
         ((0x41/* A */ <= c) && (c <= 0x46/* F */)) ||
         ((0x61/* a */ <= c) && (c <= 0x66/* f */));
}

function isOctCode(c) {
  return ((0x30/* 0 */ <= c) && (c <= 0x37/* 7 */));
}

function isDecCode(c) {
  return ((0x30/* 0 */ <= c) && (c <= 0x39/* 9 */));
}

function resolveYamlInteger(data) {
  if (data === null) return false;

  var max = data.length,
      index = 0,
      hasDigits = false,
      ch;

  if (!max) return false;

  ch = data[index];

  // sign
  if (ch === '-' || ch === '+') {
    ch = data[++index];
  }

  if (ch === '0') {
    // 0
    if (index + 1 === max) return true;
    ch = data[++index];

    // base 2, base 8, base 16

    if (ch === 'b') {
      // base 2
      index++;

      for (; index < max; index++) {
        ch = data[index];
        if (ch === '_') continue;
        if (ch !== '0' && ch !== '1') return false;
        hasDigits = true;
      }
      return hasDigits && ch !== '_';
    }


    if (ch === 'x') {
      // base 16
      index++;

      for (; index < max; index++) {
        ch = data[index];
        if (ch === '_') continue;
        if (!isHexCode(data.charCodeAt(index))) return false;
        hasDigits = true;
      }
      return hasDigits && ch !== '_';
    }


    if (ch === 'o') {
      // base 8
      index++;

      for (; index < max; index++) {
        ch = data[index];
        if (ch === '_') continue;
        if (!isOctCode(data.charCodeAt(index))) return false;
        hasDigits = true;
      }
      return hasDigits && ch !== '_';
    }
  }

  // base 10 (except 0)

  // value should not start with `_`;
  if (ch === '_') return false;

  for (; index < max; index++) {
    ch = data[index];
    if (ch === '_') continue;
    if (!isDecCode(data.charCodeAt(index))) {
      return false;
    }
    hasDigits = true;
  }

  // Should have digits and should not end with `_`
  if (!hasDigits || ch === '_') return false;

  return true;
}

function constructYamlInteger(data) {
  var value = data, sign = 1, ch;

  if (value.indexOf('_') !== -1) {
    value = value.replace(/_/g, '');
  }

  ch = value[0];

  if (ch === '-' || ch === '+') {
    if (ch === '-') sign = -1;
    value = value.slice(1);
    ch = value[0];
  }

  if (value === '0') return 0;

  if (ch === '0') {
    if (value[1] === 'b') return sign * parseInt(value.slice(2), 2);
    if (value[1] === 'x') return sign * parseInt(value.slice(2), 16);
    if (value[1] === 'o') return sign * parseInt(value.slice(2), 8);
  }

  return sign * parseInt(value, 10);
}

function isInteger(object) {
  return (Object.prototype.toString.call(object)) === '[object Number]' &&
         (object % 1 === 0 && !common.isNegativeZero(object));
}

module.exports = new Type('tag:yaml.org,2002:int', {
  kind: 'scalar',
  resolve: resolveYamlInteger,
  construct: constructYamlInteger,
  predicate: isInteger,
  represent: {
    binary:      function (obj) { return obj >= 0 ? '0b' + obj.toString(2) : '-0b' + obj.toString(2).slice(1); },
    octal:       function (obj) { return obj >= 0 ? '0o'  + obj.toString(8) : '-0o'  + obj.toString(8).slice(1); },
    decimal:     function (obj) { return obj.toString(10); },
    /* eslint-disable max-len */
    hexadecimal: function (obj) { return obj >= 0 ? '0x' + obj.toString(16).toUpperCase() :  '-0x' + obj.toString(16).toUpperCase().slice(1); }
  },
  defaultStyle: 'decimal',
  styleAliases: {
    binary:      [ 2,  'bin' ],
    octal:       [ 8,  'oct' ],
    decimal:     [ 10, 'dec' ],
    hexadecimal: [ 16, 'hex' ]
  }
});


/***/ }),

/***/ 2369:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

module.exports = new Type('tag:yaml.org,2002:map', {
  kind: 'mapping',
  construct: function (data) { return data !== null ? data : {}; }
});


/***/ }),

/***/ 1851:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

function resolveYamlMerge(data) {
  return data === '<<' || data === null;
}

module.exports = new Type('tag:yaml.org,2002:merge', {
  kind: 'scalar',
  resolve: resolveYamlMerge
});


/***/ }),

/***/ 9198:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

function resolveYamlNull(data) {
  if (data === null) return true;

  var max = data.length;

  return (max === 1 && data === '~') ||
         (max === 4 && (data === 'null' || data === 'Null' || data === 'NULL'));
}

function constructYamlNull() {
  return null;
}

function isNull(object) {
  return object === null;
}

module.exports = new Type('tag:yaml.org,2002:null', {
  kind: 'scalar',
  resolve: resolveYamlNull,
  construct: constructYamlNull,
  predicate: isNull,
  represent: {
    canonical: function () { return '~';    },
    lowercase: function () { return 'null'; },
    uppercase: function () { return 'NULL'; },
    camelcase: function () { return 'Null'; },
    empty:     function () { return '';     }
  },
  defaultStyle: 'lowercase'
});


/***/ }),

/***/ 6946:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

var _hasOwnProperty = Object.prototype.hasOwnProperty;
var _toString       = Object.prototype.toString;

function resolveYamlOmap(data) {
  if (data === null) return true;

  var objectKeys = [], index, length, pair, pairKey, pairHasKey,
      object = data;

  for (index = 0, length = object.length; index < length; index += 1) {
    pair = object[index];
    pairHasKey = false;

    if (_toString.call(pair) !== '[object Object]') return false;

    for (pairKey in pair) {
      if (_hasOwnProperty.call(pair, pairKey)) {
        if (!pairHasKey) pairHasKey = true;
        else return false;
      }
    }

    if (!pairHasKey) return false;

    if (objectKeys.indexOf(pairKey) === -1) objectKeys.push(pairKey);
    else return false;
  }

  return true;
}

function constructYamlOmap(data) {
  return data !== null ? data : [];
}

module.exports = new Type('tag:yaml.org,2002:omap', {
  kind: 'sequence',
  resolve: resolveYamlOmap,
  construct: constructYamlOmap
});


/***/ }),

/***/ 6942:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

var _toString = Object.prototype.toString;

function resolveYamlPairs(data) {
  if (data === null) return true;

  var index, length, pair, keys, result,
      object = data;

  result = new Array(object.length);

  for (index = 0, length = object.length; index < length; index += 1) {
    pair = object[index];

    if (_toString.call(pair) !== '[object Object]') return false;

    keys = Object.keys(pair);

    if (keys.length !== 1) return false;

    result[index] = [ keys[0], pair[keys[0]] ];
  }

  return true;
}

function constructYamlPairs(data) {
  if (data === null) return [];

  var index, length, pair, keys, result,
      object = data;

  result = new Array(object.length);

  for (index = 0, length = object.length; index < length; index += 1) {
    pair = object[index];

    keys = Object.keys(pair);

    result[index] = [ keys[0], pair[keys[0]] ];
  }

  return result;
}

module.exports = new Type('tag:yaml.org,2002:pairs', {
  kind: 'sequence',
  resolve: resolveYamlPairs,
  construct: constructYamlPairs
});


/***/ }),

/***/ 8636:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

module.exports = new Type('tag:yaml.org,2002:seq', {
  kind: 'sequence',
  construct: function (data) { return data !== null ? data : []; }
});


/***/ }),

/***/ 6663:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

var _hasOwnProperty = Object.prototype.hasOwnProperty;

function resolveYamlSet(data) {
  if (data === null) return true;

  var key, object = data;

  for (key in object) {
    if (_hasOwnProperty.call(object, key)) {
      if (object[key] !== null) return false;
    }
  }

  return true;
}

function constructYamlSet(data) {
  return data !== null ? data : {};
}

module.exports = new Type('tag:yaml.org,2002:set', {
  kind: 'mapping',
  resolve: resolveYamlSet,
  construct: constructYamlSet
});


/***/ }),

/***/ 7212:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

module.exports = new Type('tag:yaml.org,2002:str', {
  kind: 'scalar',
  construct: function (data) { return data !== null ? data : ''; }
});


/***/ }),

/***/ 127:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var Type = __webpack_require__(5388);

var YAML_DATE_REGEXP = new RegExp(
  '^([0-9][0-9][0-9][0-9])'          + // [1] year
  '-([0-9][0-9])'                    + // [2] month
  '-([0-9][0-9])$');                   // [3] day

var YAML_TIMESTAMP_REGEXP = new RegExp(
  '^([0-9][0-9][0-9][0-9])'          + // [1] year
  '-([0-9][0-9]?)'                   + // [2] month
  '-([0-9][0-9]?)'                   + // [3] day
  '(?:[Tt]|[ \\t]+)'                 + // ...
  '([0-9][0-9]?)'                    + // [4] hour
  ':([0-9][0-9])'                    + // [5] minute
  ':([0-9][0-9])'                    + // [6] second
  '(?:\\.([0-9]*))?'                 + // [7] fraction
  '(?:[ \\t]*(Z|([-+])([0-9][0-9]?)' + // [8] tz [9] tz_sign [10] tz_hour
  '(?::([0-9][0-9]))?))?$');           // [11] tz_minute

function resolveYamlTimestamp(data) {
  if (data === null) return false;
  if (YAML_DATE_REGEXP.exec(data) !== null) return true;
  if (YAML_TIMESTAMP_REGEXP.exec(data) !== null) return true;
  return false;
}

function constructYamlTimestamp(data) {
  var match, year, month, day, hour, minute, second, fraction = 0,
      delta = null, tz_hour, tz_minute, date;

  match = YAML_DATE_REGEXP.exec(data);
  if (match === null) match = YAML_TIMESTAMP_REGEXP.exec(data);

  if (match === null) throw new Error('Date resolve error');

  // match: [1] year [2] month [3] day

  year = +(match[1]);
  month = +(match[2]) - 1; // JS month starts with 0
  day = +(match[3]);

  if (!match[4]) { // no hour
    return new Date(Date.UTC(year, month, day));
  }

  // match: [4] hour [5] minute [6] second [7] fraction

  hour = +(match[4]);
  minute = +(match[5]);
  second = +(match[6]);

  if (match[7]) {
    fraction = match[7].slice(0, 3);
    while (fraction.length < 3) { // milli-seconds
      fraction += '0';
    }
    fraction = +fraction;
  }

  // match: [8] tz [9] tz_sign [10] tz_hour [11] tz_minute

  if (match[9]) {
    tz_hour = +(match[10]);
    tz_minute = +(match[11] || 0);
    delta = (tz_hour * 60 + tz_minute) * 60000; // delta in mili-seconds
    if (match[9] === '-') delta = -delta;
  }

  date = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));

  if (delta) date.setTime(date.getTime() - delta);

  return date;
}

function representYamlTimestamp(object /*, style*/) {
  return object.toISOString();
}

module.exports = new Type('tag:yaml.org,2002:timestamp', {
  kind: 'scalar',
  resolve: resolveYamlTimestamp,
  construct: constructYamlTimestamp,
  instanceOf: Date,
  represent: representYamlTimestamp
});


/***/ }),

/***/ 8801:
/***/ ((__unused_webpack_module, exports) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Lazy = void 0;
class Lazy {
    constructor(creator) {
        this._value = null;
        this.creator = creator;
    }
    get hasValue() {
        return this.creator == null;
    }
    get value() {
        if (this.creator == null) {
            return this._value;
        }
        const result = this.creator();
        this.value = result;
        return result;
    }
    set value(value) {
        this._value = value;
        this.creator = null;
    }
}
exports.Lazy = Lazy;
//# sourceMappingURL=main.js.map

/***/ }),

/***/ 912:
/***/ ((module) => {

/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/6.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g,
    reHasRegExpChar = RegExp(reRegExpChar.source);

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/** Built-in value references. */
var Symbol = root.Symbol;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && objectToString.call(value) == symbolTag);
}

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

/**
 * Escapes the `RegExp` special characters "^", "$", "\", ".", "*", "+",
 * "?", "(", ")", "[", "]", "{", "}", and "|" in `string`.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category String
 * @param {string} [string=''] The string to escape.
 * @returns {string} Returns the escaped string.
 * @example
 *
 * _.escapeRegExp('[lodash](https://lodash.com/)');
 * // => '\[lodash\]\(https://lodash\.com/\)'
 */
function escapeRegExp(string) {
  string = toString(string);
  return (string && reHasRegExpChar.test(string))
    ? string.replace(reRegExpChar, '\\$&')
    : string;
}

module.exports = escapeRegExp;


/***/ }),

/***/ 8142:
/***/ ((module, exports, __webpack_require__) => {

/* module decorator */ module = __webpack_require__.nmd(module);
/**
 * Lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright JS Foundation and other contributors <https://js.foundation/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    asyncTag = '[object AsyncFunction]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    nullTag = '[object Null]',
    objectTag = '[object Object]',
    promiseTag = '[object Promise]',
    proxyTag = '[object Proxy]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]',
    undefinedTag = '[object Undefined]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
typedArrayTags[errorTag] = typedArrayTags[funcTag] =
typedArrayTags[mapTag] = typedArrayTags[numberTag] =
typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
typedArrayTags[setTag] = typedArrayTags[stringTag] =
typedArrayTags[weakMapTag] = false;

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/** Detect free variable `exports`. */
var freeExports =  true && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && "object" == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Detect free variable `process` from Node.js. */
var freeProcess = moduleExports && freeGlobal.process;

/** Used to access faster Node.js helpers. */
var nodeUtil = (function() {
  try {
    return freeProcess && freeProcess.binding && freeProcess.binding('util');
  } catch (e) {}
}());

/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function arrayFilter(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */
function arrayPush(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;

  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function arraySome(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}

/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function cacheHas(cache, key) {
  return cache.has(key);
}

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
  return object == null ? undefined : object[key];
}

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */
function setToArray(set) {
  var index = -1,
      result = Array(set.size);

  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}

/** Used for built-in method references. */
var arrayProto = Array.prototype,
    funcProto = Function.prototype,
    objectProto = Object.prototype;

/** Used to detect overreaching core-js shims. */
var coreJsData = root['__core-js_shared__'];

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto.toString;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/** Built-in value references. */
var Buffer = moduleExports ? root.Buffer : undefined,
    Symbol = root.Symbol,
    Uint8Array = root.Uint8Array,
    propertyIsEnumerable = objectProto.propertyIsEnumerable,
    splice = arrayProto.splice,
    symToStringTag = Symbol ? Symbol.toStringTag : undefined;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols,
    nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined,
    nativeKeys = overArg(Object.keys, Object);

/* Built-in method references that are verified to be native. */
var DataView = getNative(root, 'DataView'),
    Map = getNative(root, 'Map'),
    Promise = getNative(root, 'Promise'),
    Set = getNative(root, 'Set'),
    WeakMap = getNative(root, 'WeakMap'),
    nativeCreate = getNative(Object, 'create');

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap);

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
  this.size = 0;
}

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? undefined : result;
  }
  return hasOwnProperty.call(data, key) ? data[key] : undefined;
}

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? (data[key] !== undefined) : hasOwnProperty.call(data, key);
}

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
  return this;
}

// Add methods to `Hash`.
Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  return index < 0 ? undefined : data[index][1];
}

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

// Add methods to `ListCache`.
ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map || ListCache),
    'string': new Hash
  };
}

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete(key) {
  var result = getMapData(this, key)['delete'](key);
  this.size -= result ? 1 : 0;
  return result;
}

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet(key, value) {
  var data = getMapData(this, key),
      size = data.size;

  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}

// Add methods to `MapCache`.
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache(values) {
  var index = -1,
      length = values == null ? 0 : values.length;

  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}

/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}

/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */
function setCacheHas(value) {
  return this.__data__.has(value);
}

// Add methods to `SetCache`.
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Stack(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */
function stackClear() {
  this.__data__ = new ListCache;
  this.size = 0;
}

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function stackDelete(key) {
  var data = this.__data__,
      result = data['delete'](key);

  this.size = data.size;
  return result;
}

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function stackGet(key) {
  return this.__data__.get(key);
}

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function stackHas(key) {
  return this.__data__.has(key);
}

/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache) {
    var pairs = data.__data__;
    if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}

// Add methods to `Stack`.
Stack.prototype.clear = stackClear;
Stack.prototype['delete'] = stackDelete;
Stack.prototype.get = stackGet;
Stack.prototype.has = stackHas;
Stack.prototype.set = stackSet;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
  var isArr = isArray(value),
      isArg = !isArr && isArguments(value),
      isBuff = !isArr && !isArg && isBuffer(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;

  for (var key in value) {
    if ((inherited || hasOwnProperty.call(value, key)) &&
        !(skipIndexes && (
           // Safari 9 has enumerable `arguments.length` in strict mode.
           key == 'length' ||
           // Node.js 0.10 has enumerable non-index properties on buffers.
           (isBuff && (key == 'offset' || key == 'parent')) ||
           // PhantomJS 2 has enumerable non-index properties on typed arrays.
           (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
           // Skip index properties.
           isIndex(key, length)
        ))) {
      result.push(key);
    }
  }
  return result;
}

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */
function baseGetAllKeys(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
}

/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }
  return (symToStringTag && symToStringTag in Object(value))
    ? getRawTag(value)
    : objectToString(value);
}

/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */
function baseIsArguments(value) {
  return isObjectLike(value) && baseGetTag(value) == argsTag;
}

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
}

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray(object),
      othIsArr = isArray(other),
      objTag = objIsArr ? arrayTag : getTag(object),
      othTag = othIsArr ? arrayTag : getTag(other);

  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;

  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray(object))
      ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
      : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}

/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray(value) {
  return isObjectLike(value) &&
    isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
}

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Assume cyclic values are equal.
  var stacked = stack.get(array);
  if (stacked && stack.get(other)) {
    return stacked == other;
  }
  var index = -1,
      result = true,
      seen = (bitmask & COMPARE_UNORDERED_FLAG) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
        return false;
      }
      return true;

    case boolTag:
    case dateTag:
    case numberTag:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag:
      return object.name == other.name && object.message == other.message;

    case regexpTag:
    case stringTag:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag:
      var convert = mapToArray;

    case setTag:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack['delete'](object);
      return result;

    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
      return false;
    }
  }
  // Assume cyclic values are equal.
  var stacked = stack.get(object);
  if (stacked && stack.get(other)) {
    return stacked == other;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeys(object) {
  return baseGetAllKeys(object, keys, getSymbols);
}

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag),
      tag = value[symToStringTag];

  try {
    value[symToStringTag] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}

/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
    (Map && getTag(new Map) != mapTag) ||
    (Promise && getTag(Promise.resolve()) != promiseTag) ||
    (Set && getTag(new Set) != setTag) ||
    (WeakMap && getTag(new WeakMap) != weakMapTag)) {
  getTag = function(value) {
    var result = baseGetTag(value),
        Ctor = result == objectTag ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag;
        case mapCtorString: return mapTag;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag;
        case weakMapCtorString: return weakMapTag;
      }
    }
    return result;
  };
}

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex(value, length) {
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length &&
    (typeof value == 'number' || reIsUint.test(value)) &&
    (value > -1 && value % 1 == 0 && value < length);
}

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

  return value === proto;
}

/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */
function objectToString(value) {
  return nativeObjectToString.call(value);
}

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 */
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
  return isObjectLike(value) && hasOwnProperty.call(value, 'callee') &&
    !propertyIsEnumerable.call(value, 'callee');
};

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray = Array.isArray;

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}

/**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */
var isBuffer = nativeIsBuffer || stubFalse;

/**
 * Performs a deep comparison between two values to determine if they are
 * equivalent.
 *
 * **Note:** This method supports comparing arrays, array buffers, booleans,
 * date objects, error objects, maps, numbers, `Object` objects, regexes,
 * sets, strings, symbols, and typed arrays. `Object` objects are compared
 * by their own, not inherited, enumerable properties. Functions and DOM
 * nodes are compared by strict equality, i.e. `===`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.isEqual(object, other);
 * // => true
 *
 * object === other;
 * // => false
 */
function isEqual(value, other) {
  return baseIsEqual(value, other);
}

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  if (!isObject(value)) {
    return false;
  }
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 9 which returns 'object' for typed arrays and other constructors.
  var tag = baseGetTag(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return value != null && (type == 'object' || type == 'function');
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return value != null && typeof value == 'object';
}

/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */
function stubArray() {
  return [];
}

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse() {
  return false;
}

module.exports = isEqual;


/***/ }),

/***/ 6585:
/***/ ((module) => {

/**
 * Helpers.
 */

var s = 1000;
var m = s * 60;
var h = m * 60;
var d = h * 24;
var w = d * 7;
var y = d * 365.25;

/**
 * Parse or format the given `val`.
 *
 * Options:
 *
 *  - `long` verbose formatting [false]
 *
 * @param {String|Number} val
 * @param {Object} [options]
 * @throws {Error} throw an error if val is not a non-empty string or a number
 * @return {String|Number}
 * @api public
 */

module.exports = function(val, options) {
  options = options || {};
  var type = typeof val;
  if (type === 'string' && val.length > 0) {
    return parse(val);
  } else if (type === 'number' && isFinite(val)) {
    return options.long ? fmtLong(val) : fmtShort(val);
  }
  throw new Error(
    'val is not a non-empty string or a valid number. val=' +
      JSON.stringify(val)
  );
};

/**
 * Parse the given `str` and return milliseconds.
 *
 * @param {String} str
 * @return {Number}
 * @api private
 */

function parse(str) {
  str = String(str);
  if (str.length > 100) {
    return;
  }
  var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(
    str
  );
  if (!match) {
    return;
  }
  var n = parseFloat(match[1]);
  var type = (match[2] || 'ms').toLowerCase();
  switch (type) {
    case 'years':
    case 'year':
    case 'yrs':
    case 'yr':
    case 'y':
      return n * y;
    case 'weeks':
    case 'week':
    case 'w':
      return n * w;
    case 'days':
    case 'day':
    case 'd':
      return n * d;
    case 'hours':
    case 'hour':
    case 'hrs':
    case 'hr':
    case 'h':
      return n * h;
    case 'minutes':
    case 'minute':
    case 'mins':
    case 'min':
    case 'm':
      return n * m;
    case 'seconds':
    case 'second':
    case 'secs':
    case 'sec':
    case 's':
      return n * s;
    case 'milliseconds':
    case 'millisecond':
    case 'msecs':
    case 'msec':
    case 'ms':
      return n;
    default:
      return undefined;
  }
}

/**
 * Short format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtShort(ms) {
  var msAbs = Math.abs(ms);
  if (msAbs >= d) {
    return Math.round(ms / d) + 'd';
  }
  if (msAbs >= h) {
    return Math.round(ms / h) + 'h';
  }
  if (msAbs >= m) {
    return Math.round(ms / m) + 'm';
  }
  if (msAbs >= s) {
    return Math.round(ms / s) + 's';
  }
  return ms + 'ms';
}

/**
 * Long format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtLong(ms) {
  var msAbs = Math.abs(ms);
  if (msAbs >= d) {
    return plural(ms, msAbs, d, 'day');
  }
  if (msAbs >= h) {
    return plural(ms, msAbs, h, 'hour');
  }
  if (msAbs >= m) {
    return plural(ms, msAbs, m, 'minute');
  }
  if (msAbs >= s) {
    return plural(ms, msAbs, s, 'second');
  }
  return ms + ' ms';
}

/**
 * Pluralization helper.
 */

function plural(ms, msAbs, n, name) {
  var isPlural = msAbs >= n * 1.5;
  return Math.round(ms / n) + ' ' + name + (isPlural ? 's' : '');
}


/***/ }),

/***/ 8998:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var createHash = (__webpack_require__(6982).createHash);

function get_header(header, credentials, opts) {
  var type = header.split(' ')[0],
      user = credentials[0],
      pass = credentials[1];

  if (type == 'Digest') {
    return digest.generate(header, user, pass, opts.method, opts.path);
  } else if (type == 'Basic') {
    return basic(user, pass);
  }
}

////////////////////
// basic

function md5(string) {
  return createHash('md5').update(string).digest('hex');
}

function basic(user, pass) {
  var str  = typeof pass == 'undefined' ? user : [user, pass].join(':');
  return 'Basic ' + Buffer.from(str).toString('base64');
}

////////////////////
// digest
// logic inspired from https://github.com/simme/node-http-digest-client

var digest = {};

digest.parse_header = function(header) {
  var challenge = {},
      matches   = header.match(/([a-z0-9_-]+)="?([a-z0-9_=\/\.@\s-\+:)()]+)"?/gi);

  for (var i = 0, l = matches.length; i < l; i++) {
    var parts = matches[i].split('='),
        key   = parts.shift(),
        val   = parts.join('=').replace(/^"/, '').replace(/"$/, '');

    challenge[key] = val;
  }

  return challenge;
}

digest.update_nc = function(nc) {
  var max = 99999999;
  nc++;

  if (nc > max)
    nc = 1;

  var padding = new Array(8).join('0') + '';
  nc = nc + '';
  return padding.substr(0, 8 - nc.length) + nc;
}

digest.generate = function(header, user, pass, method, path) {

  var nc        = 1,
      cnonce    = null,
      challenge = digest.parse_header(header);

  var ha1  = md5(user + ':' + challenge.realm + ':' + pass),
      ha2  = md5(method.toUpperCase() + ':' + path),
      resp = [ha1, challenge.nonce];

  if (typeof challenge.qop === 'string') {
    cnonce = md5(Math.random().toString(36)).substr(0, 8);
    nc     = digest.update_nc(nc);
    resp   = resp.concat(nc, cnonce);
    resp   = resp.concat(challenge.qop, ha2);
  } else {
    resp   = resp.concat(ha2);
  }

  var params = {
    uri      : path,
    realm    : challenge.realm,
    nonce    : challenge.nonce,
    username : user,
    response : md5(resp.join(':'))
  }

  if (challenge.qop) {
    params.qop = challenge.qop;
  }

  if (challenge.opaque) {
    params.opaque = challenge.opaque;
  }

  if (cnonce) {
    params.nc = nc;
    params.cnonce = cnonce;
  }

  header = []
  for (var k in params)
    header.push(k + '="' + params[k] + '"')

  return 'Digest ' + header.join(', ');
}

module.exports = {
  header : get_header,
  basic  : basic,
  digest : digest.generate
}


/***/ }),

/***/ 2069:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


//  Simple cookie handling implementation based on the standard RFC 6265.
//
//  This module just has two functionalities:
//    - Parse a set-cookie-header as a key value object
//    - Write a cookie-string from a key value object
//
//  All cookie attributes are ignored.

var unescape = (__webpack_require__(3480).unescape);

var COOKIE_PAIR        = /^([^=\s]+)\s*=\s*("?)\s*(.*)\s*\2\s*$/;
var EXCLUDED_CHARS     = /[\x00-\x1F\x7F\x3B\x3B\s\"\,\\"%]/g;
var TRAILING_SEMICOLON = /\x3B+$/;
var SEP_SEMICOLON      = /\s*\x3B\s*/;

// i know these should be 'const', but I'd like to keep
// supporting earlier node.js versions as long as I can. :)

var KEY_INDEX   = 1; // index of key from COOKIE_PAIR match
var VALUE_INDEX = 3; // index of value from COOKIE_PAIR match

// Returns a copy str trimmed and without trainling semicolon.
function cleanCookieString(str) {
  return str.trim().replace(/\x3B+$/, '');
}

function getFirstPair(str) {
  var index = str.indexOf('\x3B');
  return index === -1 ? str : str.substr(0, index);
}

// Returns a encoded copy of str based on RFC6265 S4.1.1.
function encodeCookieComponent(str) {
  return str.toString().replace(EXCLUDED_CHARS, encodeURIComponent);
}

// Parses a set-cookie-string based on the standard defined in RFC6265 S4.1.1.
function parseSetCookieString(str) {
  str = cleanCookieString(str);
  str = getFirstPair(str);

  var res = COOKIE_PAIR.exec(str);
  if (!res || !res[VALUE_INDEX]) return null;

  return {
    name  : unescape(res[KEY_INDEX]),
    value : unescape(res[VALUE_INDEX])
  };
}

// Parses a set-cookie-header and returns a key/value object.
// Each key represents the name of a cookie.
function parseSetCookieHeader(header) {
  if (!header) return {};
  header = Array.isArray(header) ? header : [header];

  return header.reduce(function(res, str) {
    var cookie = parseSetCookieString(str);
    if (cookie) res[cookie.name] = cookie.value;
    return res;
  }, {});
}

// Writes a set-cookie-string based on the standard definded in RFC6265 S4.1.1.
function writeCookieString(obj) {
  return Object.keys(obj).reduce(function(str, name) {
    var encodedName  = encodeCookieComponent(name);
    var encodedValue = encodeCookieComponent(obj[name]);
    str += (str ? '; ' : '') + encodedName + '=' + encodedValue;
    return str;
  }, '');
}

// returns a key/val object from an array of cookie strings
exports.read = parseSetCookieHeader;

// writes a cookie string header
exports.write = writeCookieString;


/***/ }),

/***/ 6958:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var iconv,
    inherits  = (__webpack_require__(9023).inherits),
    stream    = __webpack_require__(2203);

var regex = /(?:charset|encoding)\s*=\s*['"]? *([\w\-]+)/i;

inherits(StreamDecoder, stream.Transform);

function StreamDecoder(charset) {
  if (!(this instanceof StreamDecoder))
    return new StreamDecoder(charset);

  stream.Transform.call(this, charset);
  this.charset = charset;
  this.parsed_chunk = false;
}

StreamDecoder.prototype._transform = function(chunk, encoding, done) {
  // try to get charset from chunk, but just once
  if (!this.parsed_chunk && (this.charset == 'utf-8' || this.charset == 'utf8')) {
    this.parsed_chunk = true;

    var matches = regex.exec(chunk.toString());

    if (matches) {
      var found = matches[1].toLowerCase().replace('utf8', 'utf-8'); // canonicalize;
      // set charset, but only if iconv can handle it
      if (iconv.encodingExists(found)) this.charset = found;
    }
  }

  // if charset is already utf-8 or given encoding isn't supported, just pass through
  if (this.charset == 'utf-8' || !iconv.encodingExists(this.charset)) {
    this.push(chunk);
    return done();
  }

  // initialize stream decoder if not present
  var self = this;
  if (!this.decoder) {
    this.decoder = iconv.decodeStream(this.charset);
    this.decoder.on('data', function(decoded_chunk) {
      self.push(decoded_chunk);
    });
  };

  this.decoder.write(chunk);
  done();
}

module.exports = function(charset) {
  try {
    if (!iconv) iconv = __webpack_require__(5249);
  } catch(e) {
    /* iconv not found */
  }

  if (iconv)
    return new StreamDecoder(charset);
  else
    return new stream.PassThrough;
}


/***/ }),

/***/ 1058:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

var readFile = (__webpack_require__(9896).readFile),
    basename = (__webpack_require__(6928).basename);

exports.build = function(data, boundary, callback) {

  if (typeof data != 'object' || typeof data.pipe == 'function')
    return callback(new Error('Multipart builder expects data as key/val object.'));

  var body   = '',
      object = flatten(data),
      count  = Object.keys(object).length;

  if (count === 0)
    return callback(new Error('Empty multipart body. Invalid data.'))

  function done(err, section) {
    if (err) return callback(err);
    if (section) body += section;
    --count || callback(null, body + '--' + boundary + '--');
  };

  for (var key in object) {
    var value = object[key];
    if (value === null || typeof value == 'undefined') {
      done();
    } else if (Buffer.isBuffer(value)) {
      var part = { buffer: value, content_type: 'application/octet-stream' };
      generate_part(key, part, boundary, done);
    } else {
      var part = (value.buffer || value.file || value.content_type) ? value : { value: value };
      generate_part(key, part, boundary, done);
    }
  }

}

function generate_part(name, part, boundary, callback) {

  var return_part = '--' + boundary + '\r\n';
  return_part += 'Content-Disposition: form-data; name="' + name + '"';

  function append(data, filename) {

    if (data) {
      var binary = part.content_type.indexOf('text') == -1;
      return_part += '; filename="' + encodeURIComponent(filename) + '"\r\n';
      if (binary) return_part += 'Content-Transfer-Encoding: binary\r\n';
      return_part += 'Content-Type: ' + part.content_type + '\r\n\r\n';
      return_part += binary ? data.toString('binary') : data.toString('utf8');
    }

    callback(null, return_part + '\r\n');
  };

  if ((part.file || part.buffer) && part.content_type) {

    var filename = part.filename ? part.filename : part.file ? basename(part.file) : name;
    if (part.buffer) return append(part.buffer, filename);

    readFile(part.file, function(err, data) {
      if (err) return callback(err);
      append(data, filename);
    });

  } else {

    if (typeof part.value == 'object')
      return callback(new Error('Object received for ' + name + ', expected string.'))

    if (part.content_type) {
      return_part += '\r\n';
      return_part += 'Content-Type: ' + part.content_type;
    }

    return_part += '\r\n\r\n';
    return_part += Buffer.from(String(part.value), 'utf8').toString('binary');
    append();

  }

}

// flattens nested objects for multipart body
function flatten(object, into, prefix) {
  into = into || {};

  for(var key in object) {
    var prefix_key = prefix ? prefix + '[' + key + ']' : key;
    var prop = object[key];

    if (prop && typeof prop === 'object' && !(prop.buffer || prop.file || prop.content_type))
      flatten(prop, into, prefix_key)
    else
      into[prefix_key] = prop;
  }

  return into;
}


/***/ }),

/***/ 8747:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

//////////////////////////////////////////
// Needle -- HTTP Client for Node.js
// Written by Tomás Pollak <tomas@forkhq.com>
// (c) 2012-2020 - Fork Ltd.
// MIT Licensed
//////////////////////////////////////////

var fs          = __webpack_require__(9896),
    http        = __webpack_require__(8611),
    https       = __webpack_require__(5692),
    url         = __webpack_require__(7016),
    stream      = __webpack_require__(2203),
    // debug       = require('debug')('needle'),
    stringify   = (__webpack_require__(7579)/* .build */ .j),
    multipart   = __webpack_require__(1058),
    auth        = __webpack_require__(8998),
    cookies     = __webpack_require__(2069),
    parsers     = __webpack_require__(678),
    decoder     = __webpack_require__(6958),
    utils       = __webpack_require__(795);

//////////////////////////////////////////
// variabilia
var debug = () => {}

var version     = (__webpack_require__(2145)/* .version */ .rE);

var user_agent  = 'Needle/' + version;
user_agent     += ' (Node.js ' + process.version + '; ' + process.platform + ' ' + process.arch + ')';

var tls_options = 'pfx key passphrase cert ca ciphers rejectUnauthorized secureProtocol checkServerIdentity family';

// older versions of node (< 0.11.4) prevent the runtime from exiting
// because of connections in keep-alive state. so if this is the case
// we'll default new requests to set a Connection: close header.
var close_by_default = !http.Agent || http.Agent.defaultMaxSockets != Infinity;

// see if we have Object.assign. otherwise fall back to util._extend
var extend = Object.assign ? Object.assign : (__webpack_require__(9023)._extend);

// these are the status codes that Needle interprets as redirects.
var redirect_codes = [301, 302, 303, 307, 308];

//////////////////////////////////////////
// decompressors for gzip/deflate/br bodies

function bind_opts(fn, options) {
  return fn.bind(null, options);
}

var decompressors = {};

try {

  var zlib = __webpack_require__(3106);

  // Enable Z_SYNC_FLUSH to avoid Z_BUF_ERROR errors (Node PR #2595)
  var zlib_options = {
    flush: zlib.Z_SYNC_FLUSH,
    finishFlush: zlib.Z_SYNC_FLUSH
  };

  var br_options = {
    flush: zlib.BROTLI_OPERATION_FLUSH,
    finishFlush: zlib.BROTLI_OPERATION_FLUSH
  };

  decompressors['x-deflate'] = bind_opts(zlib.Inflate, zlib_options);
  decompressors['deflate']   = bind_opts(zlib.Inflate, zlib_options);
  decompressors['x-gzip']    = bind_opts(zlib.Gunzip, zlib_options);
  decompressors['gzip']      = bind_opts(zlib.Gunzip, zlib_options);
  if (typeof zlib.BrotliDecompress === 'function') {
    decompressors['br']      = bind_opts(zlib.BrotliDecompress, br_options);
  }

} catch(e) { /* zlib not available */ }

//////////////////////////////////////////
// options and aliases

var defaults = {
  // data
  boundary                : '--------------------NODENEEDLEHTTPCLIENT',
  encoding                : 'utf8',
  parse_response          : 'all', // same as true. valid options: 'json', 'xml' or false/null
  proxy                   : null,

  // agent & headers
  agent                   : null,
  headers                 : {},
  accept                  : '*/*',
  user_agent              : user_agent,

  // numbers
  open_timeout            : 10000,
  response_timeout        : 0,
  read_timeout            : 0,
  follow_max              : 0,
  stream_length           : -1,

  // booleans
  compressed              : false,
  decode_response         : true,
  parse_cookies           : true,
  follow_set_cookies      : false,
  follow_set_referer      : false,
  follow_keep_method      : false,
  follow_if_same_host     : false,
  follow_if_same_protocol : false,
  follow_if_same_location : false
}

var aliased = {
  options: {
    decode  : 'decode_response',
    parse   : 'parse_response',
    timeout : 'open_timeout',
    follow  : 'follow_max'
  },
  inverted: {}
}

// only once, invert aliased keys so we can get passed options.
Object.keys(aliased.options).map(function(k) {
  var value = aliased.options[k];
  aliased.inverted[value] = k;
});

//////////////////////////////////////////
// helpers

function keys_by_type(type) {
  return Object.keys(defaults).map(function(el) {
    if (defaults[el] !== null && defaults[el].constructor == type)
      return el;
  }).filter(function(el) { return el })
}

//////////////////////////////////////////
// the main act

function Needle(method, uri, data, options, callback) {
  // if (!(this instanceof Needle)) {
  //   return new Needle(method, uri, data, options, callback);
  // }

  if (typeof uri !== 'string')
    throw new TypeError('URL must be a string, not ' + uri);

  this.method   = method.toLowerCase();
  this.uri      = uri;
  this.data     = data;

  if (typeof options == 'function') {
    this.callback = options;
    this.options  = {};
  } else {
    this.callback = callback;
    this.options  = options;
  }

}

Needle.prototype.setup = function(uri, options) {

  function get_option(key, fallback) {
    // if original is in options, return that value
    if (typeof options[key] != 'undefined') return options[key];

    // otherwise, return value from alias or fallback/undefined
    return typeof options[aliased.inverted[key]] != 'undefined'
                ? options[aliased.inverted[key]] : fallback;
  }

  function check_value(expected, key) {
    var value = get_option(key),
        type  = typeof value;

    if (type != 'undefined' && type != expected)
      throw new TypeError(type + ' received for ' + key + ', but expected a ' + expected);

    return (type == expected) ? value : defaults[key];
  }

  //////////////////////////////////////////////////
  // the basics

  var config = {
    http_opts : {
      agent: get_option('agent', defaults.agent),
      localAddress: get_option('localAddress', undefined),
      lookup: get_option('lookup', undefined)
    }, // passed later to http.request() directly
    headers   : {},
    output    : options.output,
    proxy     : get_option('proxy', defaults.proxy),
    parser    : get_option('parse_response', defaults.parse_response),
    encoding  : options.encoding || (options.multipart ? 'binary' : defaults.encoding)
  }

  keys_by_type(Boolean).forEach(function(key) {
    config[key] = check_value('boolean', key);
  })

  keys_by_type(Number).forEach(function(key) {
    config[key] = check_value('number', key);
  })

  // populate http_opts with given TLS options
  tls_options.split(' ').forEach(function(key) {
    if (typeof options[key] != 'undefined') {
      if (config.http_opts.agent) { // pass option to existing agent
        config.http_opts.agent.options[key] = options[key];
      } else {
        config.http_opts[key] = options[key];
      }
    }
  });

  //////////////////////////////////////////////////
  // headers, cookies

  for (var key in defaults.headers)
    config.headers[key] = defaults.headers[key];

  config.headers['accept'] = options.accept || defaults.accept;
  config.headers['user-agent'] = options.user_agent || defaults.user_agent;

  if (options.content_type)
    config.headers['content-type'] = options.content_type;

  // set connection header if opts.connection was passed, or if node < 0.11.4 (close)
  if (options.connection || close_by_default)
    config.headers['connection'] = options.connection || 'close';

  if ((options.compressed || defaults.compressed) && typeof zlib != 'undefined')
    config.headers['accept-encoding'] = decompressors['br'] ? 'gzip, deflate, br' : 'gzip, deflate';

  if (options.cookies)
    config.headers['cookie'] = cookies.write(options.cookies);

  //////////////////////////////////////////////////
  // basic/digest auth

  if (uri.match(/[^\/]@/)) { // url contains user:pass@host, so parse it.
    var parts = (url.parse(uri).auth || '').split(':');
    options.username = parts[0];
    options.password = parts[1];
  }

  if (options.username) {
    if (options.auth && (options.auth == 'auto' || options.auth == 'digest')) {
      config.credentials = [options.username, options.password];
    } else {
      config.headers['authorization'] = auth.basic(options.username, options.password);
    }
  }

  // var env_proxy = utils.get_env_var(['HTTP_PROXY', 'HTTPS_PROXY'], true);
  // if (!config.proxy && env_proxy) config.proxy = env_proxy;

  // if proxy is present, set auth header from either url or proxy_user option.
  if (config.proxy) {
    // if (utils.should_proxy_to(uri)) {
    if (config.proxy.indexOf('http') === -1)
      config.proxy = 'http://' + config.proxy;

    if (config.proxy.indexOf('@') !== -1) {
      var proxy = (url.parse(config.proxy).auth || '').split(':');
      options.proxy_user = proxy[0];
      options.proxy_pass = proxy[1];
    }

    if (options.proxy_user)
      config.headers['proxy-authorization'] = auth.basic(options.proxy_user, options.proxy_pass);
    // } else {
    //   delete config.proxy;
    // }
  }

  // now that all our headers are set, overwrite them if instructed.
  for (var h in options.headers)
    config.headers[h.toLowerCase()] = options.headers[h];

  config.uri_modifier = get_option('uri_modifier', null);

  return config;
}

Needle.prototype.start = function() {

  var out      = new stream.PassThrough({ objectMode: false }),
      uri      = this.uri,
      data     = this.data,
      method   = this.method,
      callback = (typeof this.options == 'function') ? this.options : this.callback,
      options  = this.options || {};

  // if no 'http' is found on URL, prepend it.
  if (uri.indexOf('http') === -1)
    uri = uri.replace(/^(\/\/)?/, 'http://');

  var self = this, body, waiting = false, config = this.setup(uri, options);

  // unless options.json was set to false, assume boss also wants JSON if content-type matches.
  var json = options.json || (options.json !== false && config.headers['content-type'] == 'application/json');

  if (data) {

    if (options.multipart) { // boss says we do multipart. so we do it.
      var boundary = options.boundary || defaults.boundary;

      waiting = true;
      multipart.build(data, boundary, function(err, parts) {
        if (err) throw(err);

        config.headers['content-type'] = 'multipart/form-data; boundary=' + boundary;
        next(parts);
      });

    } else if (utils.is_stream(data)) {

      if (method == 'get')
        throw new Error('Refusing to pipe() a stream via GET. Did you mean .post?');

      if (config.stream_length > 0 || (config.stream_length === 0 && data.path)) {
        // ok, let's get the stream's length and set it as the content-length header.
        // this prevents some servers from cutting us off before all the data is sent.
        waiting = true;
        utils.get_stream_length(data, config.stream_length, function(length) {
          data.length = length;
          next(data);
        })

      } else {
        // if the boss doesn't want us to get the stream's length, or if it doesn't
        // have a file descriptor for that purpose, then just head on.
        body = data;
      }

    } else if (Buffer.isBuffer(data)) {

      body = data; // use the raw buffer as request body.

    } else if (method == 'get' && !json) {

      // append the data to the URI as a querystring.
      uri = uri.replace(/\?.*|$/, '?' + stringify(data));

    } else { // string or object data, no multipart.

      // if string, leave it as it is, otherwise, stringify.
      body = (typeof(data) === 'string') ? data
             : json ? JSON.stringify(data) : stringify(data);

      // ensure we have a buffer so bytecount is correct.
      body = Buffer.from(body, config.encoding);
    }

  }

  function next(body) {
    if (body) {
      if (body.length) config.headers['content-length'] = body.length;

      // if no content-type was passed, determine if json or not.
      if (!config.headers['content-type']) {
        config.headers['content-type'] = json
        ? 'application/json; charset=utf-8'
        : 'application/x-www-form-urlencoded'; // no charset says W3 spec.
      }
    }

    // unless a specific accept header was set, assume json: true wants JSON back.
    if (options.json && (!options.accept && !(options.headers || {}).accept))
      config.headers['accept'] = 'application/json';

    self.send_request(1, method, uri, config, body, out, callback);
  }

  if (!waiting) next(body);
  return out;
}

Needle.prototype.get_request_opts = function(method, uri, config) {
  var opts      = config.http_opts,
      proxy     = config.proxy,
      remote    = proxy ? url.parse(proxy) : url.parse(uri);

  opts.protocol = remote.protocol;
  opts.host     = remote.hostname;
  opts.port     = remote.port || (remote.protocol == 'https:' ? 443 : 80);
  opts.path     = proxy ? uri : remote.pathname + (remote.search || '');
  opts.method   = method;
  opts.headers  = config.headers;

  if (!opts.headers['host']) {
    // if using proxy, make sure the host header shows the final destination
    var target = proxy ? url.parse(uri) : remote;
    opts.headers['host'] = target.hostname;

    // and if a non standard port was passed, append it to the port header
    if (target.port && [80, 443].indexOf(target.port) === -1) {
      opts.headers['host'] += ':' + target.port;
    }
  }

  return opts;
}

Needle.prototype.should_follow = function(location, config, original) {
  if (!location) return false;

  // returns true if location contains matching property (host or protocol)
  function matches(property) {
    var property = original[property];
    return location.indexOf(property) !== -1;
  }

  // first, check whether the requested location is actually different from the original
  if (!config.follow_if_same_location && location === original)
    return false;

  if (config.follow_if_same_host && !matches('host'))
    return false; // host does not match, so not following

  if (config.follow_if_same_protocol && !matches('protocol'))
    return false; // procotol does not match, so not following

  return true;
}

Needle.prototype.send_request = function(count, method, uri, config, post_data, out, callback) {

  if (typeof config.uri_modifier === 'function') {
    var modified_uri = config.uri_modifier(uri);
    debug('Modifying request URI', uri + ' => ' + modified_uri);
    uri = modified_uri;
  }

  var request,
      timer,
      returned     = 0,
      self         = this,
      request_opts = this.get_request_opts(method, uri, config),
      protocol     = request_opts.protocol == 'https:' ? https : http;

  function done(err, resp) {
    if (returned++ > 0)
      return debug('Already finished, stopping here.');

    if (timer) clearTimeout(timer);
    request.removeListener('error', had_error);
    out.done = true;

    // An error can still be fired after closing.  In particular, on macOS.
    // See also:
    //  - https://github.com/tomas/needle/issues/391
    //  - https://github.com/less/less.js/issues/3693
    //  - https://github.com/nodejs/node/issues/27916
    request.once('error', function() {});

    if (callback)
      return callback(err, resp, resp ? resp.body : undefined);

    // NOTE: this event used to be called 'end', but the behaviour was confusing
    // when errors ocurred, because the stream would still emit an 'end' event.
    out.emit('done', err);

    // trigger the 'done' event on streams we're being piped to, if any
    var pipes = out._readableState.pipes || [];
    if (!pipes.forEach) pipes = [pipes];
    pipes.forEach(function(st) { st.emit('done', err); })
  }

  function had_error(err) {
    debug('Request error', err);
    out.emit('err', err);
    done(err || new Error('Unknown error when making request.'));
  }

  function set_timeout(type, milisecs) {
    if (timer) clearTimeout(timer);
    if (milisecs <= 0) return;

    timer = setTimeout(function() {
      out.emit('timeout', type);
      request.abort();
      // also invoke done() to terminate job on read_timeout
      if (type == 'read') done(new Error(type + ' timeout'));
    }, milisecs);
  }


  debug('Making request #' + count, request_opts);
  request = protocol.request(request_opts, function(resp) {

    var headers = resp.headers;
    debug('Got response', resp.statusCode, headers);
    out.emit('response', resp);

    set_timeout('read', config.read_timeout);

    // if we got cookies, parse them unless we were instructed not to. make sure to include any
    // cookies that might have been set on previous redirects.
    if (config.parse_cookies && (headers['set-cookie'] || config.previous_resp_cookies)) {
      resp.cookies = extend(config.previous_resp_cookies || {}, cookies.read(headers['set-cookie']));
      debug('Got cookies', resp.cookies);
    }

    // if redirect code is found, determine if we should follow it according to the given options.
    if (redirect_codes.indexOf(resp.statusCode) !== -1 && self.should_follow(headers.location, config, uri)) {
      // clear timer before following redirects to prevent unexpected setTimeout consequence
      clearTimeout(timer);

      if (count <= config.follow_max) {
        out.emit('redirect', headers.location);

        // unless 'follow_keep_method' is true, rewrite the request to GET before continuing.
        if (!config.follow_keep_method) {
          method    = 'GET';
          post_data = null;
          delete config.headers['content-length']; // in case the original was a multipart POST request.
        }

        // if follow_set_cookies is true, insert cookies in the next request's headers.
        // we set both the original request cookies plus any response cookies we might have received.
        if (config.follow_set_cookies && utils.host_and_ports_match(headers.location, uri)) {
          var request_cookies = cookies.read(config.headers['cookie']);
          config.previous_resp_cookies = resp.cookies;
          if (Object.keys(request_cookies).length || Object.keys(resp.cookies || {}).length) {
            config.headers['cookie'] = cookies.write(extend(request_cookies, resp.cookies));
          }
        } else if (config.headers['cookie']) {
          debug('Clearing original request cookie', config.headers['cookie']);
          delete config.headers['cookie'];
        }

        if (config.follow_set_referer)
          config.headers['referer'] = encodeURI(uri); // the original, not the destination URL.

        config.headers['host'] = null; // clear previous Host header to avoid conflicts.

        var redirect_url = utils.resolve_url(headers.location, uri);
        debug('Redirecting to ' +  redirect_url.toString());
        return self.send_request(++count, method, redirect_url.toString(), config, post_data, out, callback);
      } else if (config.follow_max > 0) {
        return done(new Error('Max redirects reached. Possible loop in: ' + headers.location));
      }
    }

    // if auth is requested and credentials were not passed, resend request, provided we have user/pass.
    if (resp.statusCode == 401 && headers['www-authenticate'] && config.credentials) {
      if (!config.headers['authorization']) { // only if authentication hasn't been sent
        var auth_header = auth.header(headers['www-authenticate'], config.credentials, request_opts);

        if (auth_header) {
          config.headers['authorization'] = auth_header;
          return self.send_request(count, method, uri, config, post_data, out, callback);
        }
      }
    }

    // ok, so we got a valid (non-redirect & authorized) response. let's notify the stream guys.
    out.emit('header', resp.statusCode, headers);
    out.emit('headers', headers);

    var pipeline      = [],
        mime          = utils.parse_content_type(headers['content-type']),
        text_response = mime.type && (mime.type.indexOf('text/') != -1 || !!mime.type.match(/(\/|\+)(xml|json)$/));

    // To start, if our body is compressed and we're able to inflate it, do it.
    if (headers['content-encoding'] && decompressors[headers['content-encoding']]) {

      var decompressor = decompressors[headers['content-encoding']]();

      // make sure we catch errors triggered by the decompressor.
      decompressor.on('error', had_error);
      pipeline.push(decompressor);
    }

    // If parse is enabled and we have a parser for it, then go for it.
    if (config.parser && parsers[mime.type]) {

      // If a specific parser was requested, make sure we don't parse other types.
      var parser_name = config.parser.toString().toLowerCase();
      if (['json'].indexOf(parser_name) == -1 || parsers[mime.type].name == parser_name) {

        // OK, so either we're parsing all content types or the one requested matches.
        out.parser = parsers[mime.type].name;
        pipeline.push(parsers[mime.type].fn());

        // Set objectMode on out stream to improve performance.
        out._writableState.objectMode = true;
        out._readableState.objectMode = true;
      }

    // If we're not parsing, and unless decoding was disabled, we'll try
    // decoding non UTF-8 bodies to UTF-8, using the iconv-lite library.
    } else if (text_response && config.decode_response && mime.charset) {
      pipeline.push(decoder(mime.charset));
    }

    // And `out` is the stream we finally push the decoded/parsed output to.
    pipeline.push(out);

    // Now, release the kraken!
    utils.pump_streams([resp].concat(pipeline), function(err) {
      if (err) debug(err)

      // on node v8.x, if an error ocurrs on the receiving end,
      // then we want to abort the request to avoid having dangling sockets
      if (err && err.message == 'write after end') request.destroy();
    });

    // If the user has requested and output file, pipe the output stream to it.
    // In stream mode, we will still get the response stream to play with.
    if (config.output && resp.statusCode == 200) {

      // for some reason, simply piping resp to the writable stream doesn't
      // work all the time (stream gets cut in the middle with no warning).
      // so we'll manually need to do the readable/write(chunk) trick.
      var file = fs.createWriteStream(config.output);
      file.on('error', had_error);

      out.on('end', function() {
        if (file.writable) file.end();
      });

      file.on('close', function() {
        delete out.file;
      })

      out.on('readable', function() {
        var chunk;
        while ((chunk = this.read()) !== null) {
          if (file.writable) file.write(chunk);

          // if callback was requested, also push it to resp.body
          if (resp.body) resp.body.push(chunk);
        }
      })

      out.file = file;
    }

    // Only aggregate the full body if a callback was requested.
    if (callback) {
      resp.raw   = [];
      resp.body  = [];
      resp.bytes = 0;

      // Gather and count the amount of (raw) bytes using a PassThrough stream.
      var clean_pipe = new stream.PassThrough();

      clean_pipe.on('readable', function() {
        var chunk;
        while ((chunk = this.read()) != null) {
          resp.bytes += chunk.length;
          resp.raw.push(chunk);
        }
      })

      utils.pump_streams([resp, clean_pipe], function(err) {
        if (err) debug(err);
      });

      // Listen on the 'readable' event to aggregate the chunks, but only if
      // file output wasn't requested. Otherwise we'd have two stream readers.
      if (!config.output || resp.statusCode != 200) {
        out.on('readable', function() {
          var chunk;
          while ((chunk = this.read()) !== null) {
            // We're either pushing buffers or objects, never strings.
            if (typeof chunk == 'string') chunk = Buffer.from(chunk);

            // Push all chunks to resp.body. We'll bind them in resp.end().
            resp.body.push(chunk);
          }
        })
      }
    }

    // And set the .body property once all data is in.
    out.on('end', function() {
      if (resp.body) { // callback mode

        // we want to be able to access to the raw data later, so keep a reference.
        resp.raw = Buffer.concat(resp.raw);

        // if parse was successful, we should have an array with one object
        if (resp.body[0] !== undefined && !Buffer.isBuffer(resp.body[0])) {

          // that's our body right there.
          resp.body = resp.body[0];

          // set the parser property on our response. we may want to check.
          if (out.parser) resp.parser = out.parser;

        } else { // we got one or several buffers. string or binary.
          resp.body = Buffer.concat(resp.body);

          // if we're here and parsed is true, it means we tried to but it didn't work.
          // so given that we got a text response, let's stringify it.
          if (text_response || out.parser) {
            resp.body = resp.body.toString();
          }
        }
      }

      // if an output file is being written to, make sure the callback
      // is triggered after all data has been written to it.
      if (out.file) {
        out.file.on('close', function() {
          done(null, resp);
        })
      } else { // elvis has left the building.
        done(null, resp);
      }

    });

    // out.on('error', function(err) {
    //   had_error(err);
    //   if (err.code == 'ERR_STREAM_DESTROYED' || err.code == 'ERR_STREAM_PREMATURE_CLOSE') {
    //     request.abort();
    //   }
    // })

  }); // end request call

  // unless open_timeout was disabled, set a timeout to abort the request.
  set_timeout('open', config.open_timeout);

  // handle errors on the request object. things might get bumpy.
  request.on('error', had_error);

  // make sure timer is cleared if request is aborted (issue #257)
  request.once('abort', function() {
    if (timer) clearTimeout(timer);
  })

  // set response timeout once we get a valid socket
  request.once('socket', function(socket) {
    if (socket.connecting) {
      socket.once('connect', function() {
        set_timeout('response', config.response_timeout);
      })
    } else {
      set_timeout('response', config.response_timeout);
    }
  })

  if (post_data) {
    if (utils.is_stream(post_data)) {
      utils.pump_streams([post_data, request], function(err) {
        if (err) debug(err);
      });
    } else {
      request.write(post_data, config.encoding);
      request.end();
    }
  } else {
    request.end();
  }

  out.abort = function() { request.abort() }; // easier access
  out.request = request;
  return out;
}

//////////////////////////////////////////
// exports

if (typeof Promise !== 'undefined') {
  module.exports = function() {
    var verb, args = [].slice.call(arguments);

    if (args[0].match(/\.|\//)) // first argument looks like a URL
      verb = (args.length > 2) ? 'post' : 'get';
    else
      verb = args.shift();

    if (verb.match(/get|head/i) && args.length == 2)
      args.splice(1, 0, null); // assume no data if head/get with two args (url, options)

    return new Promise(function(resolve, reject) {
      module.exports.request(verb, args[0], args[1], args[2], function(err, resp) {
        return err ? reject(err) : resolve(resp);
      });
    })
  }
}

module.exports.version = version;

module.exports.defaults = function(obj) {
  for (var key in obj) {
    var target_key = aliased.options[key] || key;

    if (defaults.hasOwnProperty(target_key) && typeof obj[key] != 'undefined') {
      if (target_key != 'parse_response' && target_key != 'proxy' && target_key != 'agent') {
        // ensure type matches the original, except for proxy/parse_response that can be null/bool or string
        var valid_type = defaults[target_key].constructor.name;

        if (obj[key].constructor.name != valid_type)
          throw new TypeError('Invalid type for ' + key + ', should be ' + valid_type);
      }
      defaults[target_key] = obj[key];
    } else {
      throw new Error('Invalid property for defaults:' + target_key);
    }
  }

  return defaults;
}

'head get'.split(' ').forEach(function(method) {
  module.exports[method] = function(uri, options, callback) {
    return new Needle(method, uri, null, options, callback).start();
  }
})

'post put patch delete'.split(' ').forEach(function(method) {
  module.exports[method] = function(uri, data, options, callback) {
    return new Needle(method, uri, data, options, callback).start();
  }
})

module.exports.request = function(method, uri, data, opts, callback) {
  return new Needle(method, uri, data, opts, callback).start();
};


/***/ }),

/***/ 678:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

//////////////////////////////////////////
// Defines mappings between content-type
// and the appropriate parsers.
//////////////////////////////////////////

var Transform = (__webpack_require__(2203).Transform);
// var sax = require('sax');

// function parseXML(str, cb) {
//   var obj, current, parser = sax.parser(true, { trim: true, lowercase: true })
//   parser.onerror = parser.onend = done;

//   function done(err) {
//     parser.onerror = parser.onend = function() { }
//     cb(err, obj)
//   }

//   function newElement(name, attributes) {
//     return {
//       name: name || '',
//       value: '',
//       attributes: attributes || {},
//       children: []
//     }
//   }

//   parser.oncdata = parser.ontext = function(t) {
//     if (current) current.value += t
//   }

//   parser.onopentag = function(node) {
//     var element = newElement(node.name, node.attributes)
//     if (current) {
//       element.parent = current
//       current.children.push(element)
//     } else { // root object
//       obj = element
//     }

//     current = element
//   };

//   parser.onclosetag = function() {
//     if (typeof current.parent !== 'undefined') {
//       var just_closed = current
//       current = current.parent
//       delete just_closed.parent
//     }
//   }

//   parser.write(str).close()
// }

function parserFactory(name, fn) {

  function parser() {
    var chunks = [],
        stream = new Transform({ objectMode: true });

    // Buffer all our data
    stream._transform = function(chunk, encoding, done) {
      chunks.push(chunk);
      done();
    }

    // And call the parser when all is there.
    stream._flush = function(done) {
      var self = this,
          data = Buffer.concat(chunks);

      try {
        fn(data, function(err, result) {
          if (err) throw err;
          self.push(result);
        });
      } catch (err) {
        self.push(data); // just pass the original data
      } finally {
        done();
      }
    }

    return stream;
  }

  return { fn: parser, name: name };
}

var parsers = {}

function buildParser(name, types, fn) {
  var parser = parserFactory(name, fn);
  types.forEach(function(type) {
    parsers[type] = parser;
  })
}

buildParser('json', [
  'application/json',
  'text/javascript',
  'application/vnd.api+json'
], function(buffer, cb) {
  var err, data;
  try { data = JSON.parse(buffer); } catch (e) { err = e; }
  cb(err, data);
});

// buildParser('xml', [
//   'text/xml',
//   'application/xml',
//   'application/rdf+xml',
//   'application/rss+xml',
//   'application/atom+xml'
// ], function(buffer, cb) {
//   parseXML(buffer.toString(), function(err, obj) {
//     cb(err, obj)
//   })
// });

module.exports = parsers;
module.exports.use = buildParser;


/***/ }),

/***/ 7579:
/***/ ((__unused_webpack_module, exports) => {

// based on the qs module, but handles null objects as expected
// fixes by Tomas Pollak.

var toString = Object.prototype.toString;

function stringify(obj, prefix) {
  if (prefix && (obj === null || typeof obj == 'undefined')) {
    return prefix + '=';
  } else if (toString.call(obj) == '[object Array]') {
    return stringifyArray(obj, prefix);
  } else if (toString.call(obj) == '[object Object]') {
    return stringifyObject(obj, prefix);
  } else if (toString.call(obj) == '[object Date]') {
    return obj.toISOString();
  } else if (prefix) { // string inside array or hash
    return prefix + '=' + encodeURIComponent(String(obj));
  } else if (String(obj).indexOf('=') !== -1) { // string with equal sign
    return String(obj);
  } else {
    throw new TypeError('Cannot build a querystring out of: ' + obj);
  }
};

function stringifyArray(arr, prefix) {
  var ret = [];

  for (var i = 0, len = arr.length; i < len; i++) {
    if (prefix)
      ret.push(stringify(arr[i], prefix + '[]'));
    else
      ret.push(stringify(arr[i]));
  }

  return ret.join('&');
}

function stringifyObject(obj, prefix) {
  var ret = [];

  Object.keys(obj).forEach(function(key) {
    ret.push(stringify(obj[key], prefix
      ? prefix + '[' + encodeURIComponent(key) + ']'
      : encodeURIComponent(key)));
  })

  return ret.join('&');
}

exports.j = stringify;


/***/ }),

/***/ 795:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var fs = __webpack_require__(9896),
    url = __webpack_require__(7016),
    stream = __webpack_require__(2203);

function resolve_url(href, base) {
  if (url.URL)
    return new url.URL(href, base);

  // older Node version (< v6.13)
  return base ? url.resolve(base, href) : href;
}

function host_and_ports_match(url1, url2) {
  if (url1.indexOf('http') < 0) url1 = 'http://' + url1;
  if (url2.indexOf('http') < 0) url2 = 'http://' + url2;
  var a = url.parse(url1), b = url.parse(url2);

  return a.host == b.host
    && String(a.port || (a.protocol == 'https:' ? 443 : 80))
    == String(b.port || (b.protocol == 'https:' ? 443 : 80));
}

// returns false if a no_proxy host or pattern matches given url
function should_proxy_to(uri) {
  var no_proxy = get_env_var(['NO_PROXY'], true);
  if (!no_proxy) return true;

  // previous (naive, simple) strategy
  // var host, hosts = no_proxy.split(',');
  // for (var i in hosts) {
  //   host = hosts[i];
  //   if (host_and_ports_match(host, uri)) {
  //     return false;
  //   }
  // }

  var pattern, pattern_list = no_proxy.split(/[\s,]+/);
  for (var i in pattern_list) {
    pattern = pattern_list[i];
    if (pattern.trim().length == 0) continue;

    // replace leading dot by asterisk, escape dots and finally replace asterisk by .*
    var regex = new RegExp(pattern.replace(/^\./, "*").replace(/[.]/g, '\\$&').replace(/\*/g, '.*'))
    if (uri.match(regex)) return false;
  }

  return true;
}

function get_env_var(keys, try_lower) {
  var val, i = -1, env = ({"NODE_ENV":"production"});
  while (!val && i < keys.length-1) {
    val = env[keys[++i]];
    if (!val && try_lower) {
      val = env[keys[i].toLowerCase()];
    }
  }
  return val;
}

function parse_content_type(header) {
  if (!header || header === '') return {};

  var found, charset = 'utf8', arr = header.split(';');

  if (arr.length > 1 && (found = arr[1].match(/charset=(.+)/)))
    charset = found[1];

  return { type: arr[0], charset: charset };
}

function is_stream(obj) {
  return typeof obj.pipe === 'function';
}

function get_stream_length(stream, given_length, cb) {
  if (given_length > 0)
    return cb(given_length);

  if (stream.end !== void 0 && stream.end !== Infinity && stream.start !== void 0)
    return cb((stream.end + 1) - (stream.start || 0));

  fs.stat(stream.path, function(err, stat) {
    cb(stat ? stat.size - (stream.start || 0) : null);
  });
}

function pump_streams(streams, cb) {
  if (stream.pipeline)
    return stream.pipeline.apply(null, streams.concat(cb));

  var tmp = streams.shift();
  while (streams.length) {
    tmp = tmp.pipe(streams.shift());
    tmp.once('error', function(e) {
      cb && cb(e);
      cb = null;
    })
  }
}

module.exports = {
  resolve_url: resolve_url,
  get_env_var: get_env_var,
  host_and_ports_match: host_and_ports_match,
  should_proxy_to: should_proxy_to,
  parse_content_type: parse_content_type,
  is_stream: is_stream,
  get_stream_length: get_stream_length,
  pump_streams: pump_streams
}

/***/ }),

/***/ 4774:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
/* eslint-disable node/no-deprecated-api */



var buffer = __webpack_require__(181)
var Buffer = buffer.Buffer

var safer = {}

var key

for (key in buffer) {
  if (!buffer.hasOwnProperty(key)) continue
  if (key === 'SlowBuffer' || key === 'Buffer') continue
  safer[key] = buffer[key]
}

var Safer = safer.Buffer = {}
for (key in Buffer) {
  if (!Buffer.hasOwnProperty(key)) continue
  if (key === 'allocUnsafe' || key === 'allocUnsafeSlow') continue
  Safer[key] = Buffer[key]
}

safer.Buffer.prototype = Buffer.prototype

if (!Safer.from || Safer.from === Uint8Array.from) {
  Safer.from = function (value, encodingOrOffset, length) {
    if (typeof value === 'number') {
      throw new TypeError('The "value" argument must not be of type number. Received type ' + typeof value)
    }
    if (value && typeof value.length === 'undefined') {
      throw new TypeError('The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type ' + typeof value)
    }
    return Buffer(value, encodingOrOffset, length)
  }
}

if (!Safer.alloc) {
  Safer.alloc = function (size, fill, encoding) {
    if (typeof size !== 'number') {
      throw new TypeError('The "size" argument must be of type number. Received type ' + typeof size)
    }
    if (size < 0 || size >= 2 * (1 << 30)) {
      throw new RangeError('The value "' + size + '" is invalid for option "size"')
    }
    var buf = Buffer(size)
    if (!fill || fill.length === 0) {
      buf.fill(0)
    } else if (typeof encoding === 'string') {
      buf.fill(fill, encoding)
    } else {
      buf.fill(fill)
    }
    return buf
  }
}

if (!safer.kStringMaxLength) {
  try {
    safer.kStringMaxLength = process.binding('buffer').kStringMaxLength
  } catch (e) {
    // we can't determine kStringMaxLength in environments where process.binding
    // is unsupported, so let's not set it
  }
}

if (!safer.constants) {
  safer.constants = {
    MAX_LENGTH: safer.kMaxLength
  }
  if (safer.kStringMaxLength) {
    safer.constants.MAX_STRING_LENGTH = safer.kStringMaxLength
  }
}

module.exports = safer


/***/ }),

/***/ 4043:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

;(function (sax) { // wrapper for non-node envs
  sax.parser = function (strict, opt) { return new SAXParser(strict, opt) }
  sax.SAXParser = SAXParser
  sax.SAXStream = SAXStream
  sax.createStream = createStream

  // When we pass the MAX_BUFFER_LENGTH position, start checking for buffer overruns.
  // When we check, schedule the next check for MAX_BUFFER_LENGTH - (max(buffer lengths)),
  // since that's the earliest that a buffer overrun could occur.  This way, checks are
  // as rare as required, but as often as necessary to ensure never crossing this bound.
  // Furthermore, buffers are only tested at most once per write(), so passing a very
  // large string into write() might have undesirable effects, but this is manageable by
  // the caller, so it is assumed to be safe.  Thus, a call to write() may, in the extreme
  // edge case, result in creating at most one complete copy of the string passed in.
  // Set to Infinity to have unlimited buffers.
  sax.MAX_BUFFER_LENGTH = 64 * 1024

  var buffers = [
    'comment', 'sgmlDecl', 'textNode', 'tagName', 'doctype',
    'procInstName', 'procInstBody', 'entity', 'attribName',
    'attribValue', 'cdata', 'script'
  ]

  sax.EVENTS = [
    'text',
    'processinginstruction',
    'sgmldeclaration',
    'doctype',
    'comment',
    'opentagstart',
    'attribute',
    'opentag',
    'closetag',
    'opencdata',
    'cdata',
    'closecdata',
    'error',
    'end',
    'ready',
    'script',
    'opennamespace',
    'closenamespace'
  ]

  function SAXParser (strict, opt) {
    if (!(this instanceof SAXParser)) {
      return new SAXParser(strict, opt)
    }

    var parser = this
    clearBuffers(parser)
    parser.q = parser.c = ''
    parser.bufferCheckPosition = sax.MAX_BUFFER_LENGTH
    parser.opt = opt || {}
    parser.opt.lowercase = parser.opt.lowercase || parser.opt.lowercasetags
    parser.looseCase = parser.opt.lowercase ? 'toLowerCase' : 'toUpperCase'
    parser.tags = []
    parser.closed = parser.closedRoot = parser.sawRoot = false
    parser.tag = parser.error = null
    parser.strict = !!strict
    parser.noscript = !!(strict || parser.opt.noscript)
    parser.state = S.BEGIN
    parser.strictEntities = parser.opt.strictEntities
    parser.ENTITIES = parser.strictEntities ? Object.create(sax.XML_ENTITIES) : Object.create(sax.ENTITIES)
    parser.attribList = []

    // namespaces form a prototype chain.
    // it always points at the current tag,
    // which protos to its parent tag.
    if (parser.opt.xmlns) {
      parser.ns = Object.create(rootNS)
    }

    // mostly just for error reporting
    parser.trackPosition = parser.opt.position !== false
    if (parser.trackPosition) {
      parser.position = parser.line = parser.column = 0
    }
    emit(parser, 'onready')
  }

  if (!Object.create) {
    Object.create = function (o) {
      function F () {}
      F.prototype = o
      var newf = new F()
      return newf
    }
  }

  if (!Object.keys) {
    Object.keys = function (o) {
      var a = []
      for (var i in o) if (o.hasOwnProperty(i)) a.push(i)
      return a
    }
  }

  function checkBufferLength (parser) {
    var maxAllowed = Math.max(sax.MAX_BUFFER_LENGTH, 10)
    var maxActual = 0
    for (var i = 0, l = buffers.length; i < l; i++) {
      var len = parser[buffers[i]].length
      if (len > maxAllowed) {
        // Text/cdata nodes can get big, and since they're buffered,
        // we can get here under normal conditions.
        // Avoid issues by emitting the text node now,
        // so at least it won't get any bigger.
        switch (buffers[i]) {
          case 'textNode':
            closeText(parser)
            break

          case 'cdata':
            emitNode(parser, 'oncdata', parser.cdata)
            parser.cdata = ''
            break

          case 'script':
            emitNode(parser, 'onscript', parser.script)
            parser.script = ''
            break

          default:
            error(parser, 'Max buffer length exceeded: ' + buffers[i])
        }
      }
      maxActual = Math.max(maxActual, len)
    }
    // schedule the next check for the earliest possible buffer overrun.
    var m = sax.MAX_BUFFER_LENGTH - maxActual
    parser.bufferCheckPosition = m + parser.position
  }

  function clearBuffers (parser) {
    for (var i = 0, l = buffers.length; i < l; i++) {
      parser[buffers[i]] = ''
    }
  }

  function flushBuffers (parser) {
    closeText(parser)
    if (parser.cdata !== '') {
      emitNode(parser, 'oncdata', parser.cdata)
      parser.cdata = ''
    }
    if (parser.script !== '') {
      emitNode(parser, 'onscript', parser.script)
      parser.script = ''
    }
  }

  SAXParser.prototype = {
    end: function () { end(this) },
    write: write,
    resume: function () { this.error = null; return this },
    close: function () { return this.write(null) },
    flush: function () { flushBuffers(this) }
  }

  var Stream
  try {
    Stream = (__webpack_require__(2203).Stream)
  } catch (ex) {
    Stream = function () {}
  }
  if (!Stream) Stream = function () {}

  var streamWraps = sax.EVENTS.filter(function (ev) {
    return ev !== 'error' && ev !== 'end'
  })

  function createStream (strict, opt) {
    return new SAXStream(strict, opt)
  }

  function SAXStream (strict, opt) {
    if (!(this instanceof SAXStream)) {
      return new SAXStream(strict, opt)
    }

    Stream.apply(this)

    this._parser = new SAXParser(strict, opt)
    this.writable = true
    this.readable = true

    var me = this

    this._parser.onend = function () {
      me.emit('end')
    }

    this._parser.onerror = function (er) {
      me.emit('error', er)

      // if didn't throw, then means error was handled.
      // go ahead and clear error, so we can write again.
      me._parser.error = null
    }

    this._decoder = null

    streamWraps.forEach(function (ev) {
      Object.defineProperty(me, 'on' + ev, {
        get: function () {
          return me._parser['on' + ev]
        },
        set: function (h) {
          if (!h) {
            me.removeAllListeners(ev)
            me._parser['on' + ev] = h
            return h
          }
          me.on(ev, h)
        },
        enumerable: true,
        configurable: false
      })
    })
  }

  SAXStream.prototype = Object.create(Stream.prototype, {
    constructor: {
      value: SAXStream
    }
  })

  SAXStream.prototype.write = function (data) {
    if (typeof Buffer === 'function' &&
      typeof Buffer.isBuffer === 'function' &&
      Buffer.isBuffer(data)) {
      if (!this._decoder) {
        var SD = (__webpack_require__(3193).StringDecoder)
        this._decoder = new SD('utf8')
      }
      data = this._decoder.write(data)
    }

    this._parser.write(data.toString())
    this.emit('data', data)
    return true
  }

  SAXStream.prototype.end = function (chunk) {
    if (chunk && chunk.length) {
      this.write(chunk)
    }
    this._parser.end()
    return true
  }

  SAXStream.prototype.on = function (ev, handler) {
    var me = this
    if (!me._parser['on' + ev] && streamWraps.indexOf(ev) !== -1) {
      me._parser['on' + ev] = function () {
        var args = arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments)
        args.splice(0, 0, ev)
        me.emit.apply(me, args)
      }
    }

    return Stream.prototype.on.call(me, ev, handler)
  }

  // this really needs to be replaced with character classes.
  // XML allows all manner of ridiculous numbers and digits.
  var CDATA = '[CDATA['
  var DOCTYPE = 'DOCTYPE'
  var XML_NAMESPACE = 'http://www.w3.org/XML/1998/namespace'
  var XMLNS_NAMESPACE = 'http://www.w3.org/2000/xmlns/'
  var rootNS = { xml: XML_NAMESPACE, xmlns: XMLNS_NAMESPACE }

  // http://www.w3.org/TR/REC-xml/#NT-NameStartChar
  // This implementation works on strings, a single character at a time
  // as such, it cannot ever support astral-plane characters (10000-EFFFF)
  // without a significant breaking change to either this  parser, or the
  // JavaScript language.  Implementation of an emoji-capable xml parser
  // is left as an exercise for the reader.
  var nameStart = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/

  var nameBody = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/

  var entityStart = /[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/
  var entityBody = /[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/

  function isWhitespace (c) {
    return c === ' ' || c === '\n' || c === '\r' || c === '\t'
  }

  function isQuote (c) {
    return c === '"' || c === '\''
  }

  function isAttribEnd (c) {
    return c === '>' || isWhitespace(c)
  }

  function isMatch (regex, c) {
    return regex.test(c)
  }

  function notMatch (regex, c) {
    return !isMatch(regex, c)
  }

  var S = 0
  sax.STATE = {
    BEGIN: S++, // leading byte order mark or whitespace
    BEGIN_WHITESPACE: S++, // leading whitespace
    TEXT: S++, // general stuff
    TEXT_ENTITY: S++, // &amp and such.
    OPEN_WAKA: S++, // <
    SGML_DECL: S++, // <!BLARG
    SGML_DECL_QUOTED: S++, // <!BLARG foo "bar
    DOCTYPE: S++, // <!DOCTYPE
    DOCTYPE_QUOTED: S++, // <!DOCTYPE "//blah
    DOCTYPE_DTD: S++, // <!DOCTYPE "//blah" [ ...
    DOCTYPE_DTD_QUOTED: S++, // <!DOCTYPE "//blah" [ "foo
    COMMENT_STARTING: S++, // <!-
    COMMENT: S++, // <!--
    COMMENT_ENDING: S++, // <!-- blah -
    COMMENT_ENDED: S++, // <!-- blah --
    CDATA: S++, // <![CDATA[ something
    CDATA_ENDING: S++, // ]
    CDATA_ENDING_2: S++, // ]]
    PROC_INST: S++, // <?hi
    PROC_INST_BODY: S++, // <?hi there
    PROC_INST_ENDING: S++, // <?hi "there" ?
    OPEN_TAG: S++, // <strong
    OPEN_TAG_SLASH: S++, // <strong /
    ATTRIB: S++, // <a
    ATTRIB_NAME: S++, // <a foo
    ATTRIB_NAME_SAW_WHITE: S++, // <a foo _
    ATTRIB_VALUE: S++, // <a foo=
    ATTRIB_VALUE_QUOTED: S++, // <a foo="bar
    ATTRIB_VALUE_CLOSED: S++, // <a foo="bar"
    ATTRIB_VALUE_UNQUOTED: S++, // <a foo=bar
    ATTRIB_VALUE_ENTITY_Q: S++, // <foo bar="&quot;"
    ATTRIB_VALUE_ENTITY_U: S++, // <foo bar=&quot
    CLOSE_TAG: S++, // </a
    CLOSE_TAG_SAW_WHITE: S++, // </a   >
    SCRIPT: S++, // <script> ...
    SCRIPT_ENDING: S++ // <script> ... <
  }

  sax.XML_ENTITIES = {
    'amp': '&',
    'gt': '>',
    'lt': '<',
    'quot': '"',
    'apos': "'"
  }

  sax.ENTITIES = {
    'amp': '&',
    'gt': '>',
    'lt': '<',
    'quot': '"',
    'apos': "'",
    'AElig': 198,
    'Aacute': 193,
    'Acirc': 194,
    'Agrave': 192,
    'Aring': 197,
    'Atilde': 195,
    'Auml': 196,
    'Ccedil': 199,
    'ETH': 208,
    'Eacute': 201,
    'Ecirc': 202,
    'Egrave': 200,
    'Euml': 203,
    'Iacute': 205,
    'Icirc': 206,
    'Igrave': 204,
    'Iuml': 207,
    'Ntilde': 209,
    'Oacute': 211,
    'Ocirc': 212,
    'Ograve': 210,
    'Oslash': 216,
    'Otilde': 213,
    'Ouml': 214,
    'THORN': 222,
    'Uacute': 218,
    'Ucirc': 219,
    'Ugrave': 217,
    'Uuml': 220,
    'Yacute': 221,
    'aacute': 225,
    'acirc': 226,
    'aelig': 230,
    'agrave': 224,
    'aring': 229,
    'atilde': 227,
    'auml': 228,
    'ccedil': 231,
    'eacute': 233,
    'ecirc': 234,
    'egrave': 232,
    'eth': 240,
    'euml': 235,
    'iacute': 237,
    'icirc': 238,
    'igrave': 236,
    'iuml': 239,
    'ntilde': 241,
    'oacute': 243,
    'ocirc': 244,
    'ograve': 242,
    'oslash': 248,
    'otilde': 245,
    'ouml': 246,
    'szlig': 223,
    'thorn': 254,
    'uacute': 250,
    'ucirc': 251,
    'ugrave': 249,
    'uuml': 252,
    'yacute': 253,
    'yuml': 255,
    'copy': 169,
    'reg': 174,
    'nbsp': 160,
    'iexcl': 161,
    'cent': 162,
    'pound': 163,
    'curren': 164,
    'yen': 165,
    'brvbar': 166,
    'sect': 167,
    'uml': 168,
    'ordf': 170,
    'laquo': 171,
    'not': 172,
    'shy': 173,
    'macr': 175,
    'deg': 176,
    'plusmn': 177,
    'sup1': 185,
    'sup2': 178,
    'sup3': 179,
    'acute': 180,
    'micro': 181,
    'para': 182,
    'middot': 183,
    'cedil': 184,
    'ordm': 186,
    'raquo': 187,
    'frac14': 188,
    'frac12': 189,
    'frac34': 190,
    'iquest': 191,
    'times': 215,
    'divide': 247,
    'OElig': 338,
    'oelig': 339,
    'Scaron': 352,
    'scaron': 353,
    'Yuml': 376,
    'fnof': 402,
    'circ': 710,
    'tilde': 732,
    'Alpha': 913,
    'Beta': 914,
    'Gamma': 915,
    'Delta': 916,
    'Epsilon': 917,
    'Zeta': 918,
    'Eta': 919,
    'Theta': 920,
    'Iota': 921,
    'Kappa': 922,
    'Lambda': 923,
    'Mu': 924,
    'Nu': 925,
    'Xi': 926,
    'Omicron': 927,
    'Pi': 928,
    'Rho': 929,
    'Sigma': 931,
    'Tau': 932,
    'Upsilon': 933,
    'Phi': 934,
    'Chi': 935,
    'Psi': 936,
    'Omega': 937,
    'alpha': 945,
    'beta': 946,
    'gamma': 947,
    'delta': 948,
    'epsilon': 949,
    'zeta': 950,
    'eta': 951,
    'theta': 952,
    'iota': 953,
    'kappa': 954,
    'lambda': 955,
    'mu': 956,
    'nu': 957,
    'xi': 958,
    'omicron': 959,
    'pi': 960,
    'rho': 961,
    'sigmaf': 962,
    'sigma': 963,
    'tau': 964,
    'upsilon': 965,
    'phi': 966,
    'chi': 967,
    'psi': 968,
    'omega': 969,
    'thetasym': 977,
    'upsih': 978,
    'piv': 982,
    'ensp': 8194,
    'emsp': 8195,
    'thinsp': 8201,
    'zwnj': 8204,
    'zwj': 8205,
    'lrm': 8206,
    'rlm': 8207,
    'ndash': 8211,
    'mdash': 8212,
    'lsquo': 8216,
    'rsquo': 8217,
    'sbquo': 8218,
    'ldquo': 8220,
    'rdquo': 8221,
    'bdquo': 8222,
    'dagger': 8224,
    'Dagger': 8225,
    'bull': 8226,
    'hellip': 8230,
    'permil': 8240,
    'prime': 8242,
    'Prime': 8243,
    'lsaquo': 8249,
    'rsaquo': 8250,
    'oline': 8254,
    'frasl': 8260,
    'euro': 8364,
    'image': 8465,
    'weierp': 8472,
    'real': 8476,
    'trade': 8482,
    'alefsym': 8501,
    'larr': 8592,
    'uarr': 8593,
    'rarr': 8594,
    'darr': 8595,
    'harr': 8596,
    'crarr': 8629,
    'lArr': 8656,
    'uArr': 8657,
    'rArr': 8658,
    'dArr': 8659,
    'hArr': 8660,
    'forall': 8704,
    'part': 8706,
    'exist': 8707,
    'empty': 8709,
    'nabla': 8711,
    'isin': 8712,
    'notin': 8713,
    'ni': 8715,
    'prod': 8719,
    'sum': 8721,
    'minus': 8722,
    'lowast': 8727,
    'radic': 8730,
    'prop': 8733,
    'infin': 8734,
    'ang': 8736,
    'and': 8743,
    'or': 8744,
    'cap': 8745,
    'cup': 8746,
    'int': 8747,
    'there4': 8756,
    'sim': 8764,
    'cong': 8773,
    'asymp': 8776,
    'ne': 8800,
    'equiv': 8801,
    'le': 8804,
    'ge': 8805,
    'sub': 8834,
    'sup': 8835,
    'nsub': 8836,
    'sube': 8838,
    'supe': 8839,
    'oplus': 8853,
    'otimes': 8855,
    'perp': 8869,
    'sdot': 8901,
    'lceil': 8968,
    'rceil': 8969,
    'lfloor': 8970,
    'rfloor': 8971,
    'lang': 9001,
    'rang': 9002,
    'loz': 9674,
    'spades': 9824,
    'clubs': 9827,
    'hearts': 9829,
    'diams': 9830
  }

  Object.keys(sax.ENTITIES).forEach(function (key) {
    var e = sax.ENTITIES[key]
    var s = typeof e === 'number' ? String.fromCharCode(e) : e
    sax.ENTITIES[key] = s
  })

  for (var s in sax.STATE) {
    sax.STATE[sax.STATE[s]] = s
  }

  // shorthand
  S = sax.STATE

  function emit (parser, event, data) {
    parser[event] && parser[event](data)
  }

  function emitNode (parser, nodeType, data) {
    if (parser.textNode) closeText(parser)
    emit(parser, nodeType, data)
  }

  function closeText (parser) {
    parser.textNode = textopts(parser.opt, parser.textNode)
    if (parser.textNode) emit(parser, 'ontext', parser.textNode)
    parser.textNode = ''
  }

  function textopts (opt, text) {
    if (opt.trim) text = text.trim()
    if (opt.normalize) text = text.replace(/\s+/g, ' ')
    return text
  }

  function error (parser, er) {
    closeText(parser)
    if (parser.trackPosition) {
      er += '\nLine: ' + parser.line +
        '\nColumn: ' + parser.column +
        '\nChar: ' + parser.c
    }
    er = new Error(er)
    parser.error = er
    emit(parser, 'onerror', er)
    return parser
  }

  function end (parser) {
    if (parser.sawRoot && !parser.closedRoot) strictFail(parser, 'Unclosed root tag')
    if ((parser.state !== S.BEGIN) &&
      (parser.state !== S.BEGIN_WHITESPACE) &&
      (parser.state !== S.TEXT)) {
      error(parser, 'Unexpected end')
    }
    closeText(parser)
    parser.c = ''
    parser.closed = true
    emit(parser, 'onend')
    SAXParser.call(parser, parser.strict, parser.opt)
    return parser
  }

  function strictFail (parser, message) {
    if (typeof parser !== 'object' || !(parser instanceof SAXParser)) {
      throw new Error('bad call to strictFail')
    }
    if (parser.strict) {
      error(parser, message)
    }
  }

  function newTag (parser) {
    if (!parser.strict) parser.tagName = parser.tagName[parser.looseCase]()
    var parent = parser.tags[parser.tags.length - 1] || parser
    var tag = parser.tag = { name: parser.tagName, attributes: {} }

    // will be overridden if tag contails an xmlns="foo" or xmlns:foo="bar"
    if (parser.opt.xmlns) {
      tag.ns = parent.ns
    }
    parser.attribList.length = 0
    emitNode(parser, 'onopentagstart', tag)
  }

  function qname (name, attribute) {
    var i = name.indexOf(':')
    var qualName = i < 0 ? [ '', name ] : name.split(':')
    var prefix = qualName[0]
    var local = qualName[1]

    // <x "xmlns"="http://foo">
    if (attribute && name === 'xmlns') {
      prefix = 'xmlns'
      local = ''
    }

    return { prefix: prefix, local: local }
  }

  function attrib (parser) {
    if (!parser.strict) {
      parser.attribName = parser.attribName[parser.looseCase]()
    }

    if (parser.attribList.indexOf(parser.attribName) !== -1 ||
      parser.tag.attributes.hasOwnProperty(parser.attribName)) {
      parser.attribName = parser.attribValue = ''
      return
    }

    if (parser.opt.xmlns) {
      var qn = qname(parser.attribName, true)
      var prefix = qn.prefix
      var local = qn.local

      if (prefix === 'xmlns') {
        // namespace binding attribute. push the binding into scope
        if (local === 'xml' && parser.attribValue !== XML_NAMESPACE) {
          strictFail(parser,
            'xml: prefix must be bound to ' + XML_NAMESPACE + '\n' +
            'Actual: ' + parser.attribValue)
        } else if (local === 'xmlns' && parser.attribValue !== XMLNS_NAMESPACE) {
          strictFail(parser,
            'xmlns: prefix must be bound to ' + XMLNS_NAMESPACE + '\n' +
            'Actual: ' + parser.attribValue)
        } else {
          var tag = parser.tag
          var parent = parser.tags[parser.tags.length - 1] || parser
          if (tag.ns === parent.ns) {
            tag.ns = Object.create(parent.ns)
          }
          tag.ns[local] = parser.attribValue
        }
      }

      // defer onattribute events until all attributes have been seen
      // so any new bindings can take effect. preserve attribute order
      // so deferred events can be emitted in document order
      parser.attribList.push([parser.attribName, parser.attribValue])
    } else {
      // in non-xmlns mode, we can emit the event right away
      parser.tag.attributes[parser.attribName] = parser.attribValue
      emitNode(parser, 'onattribute', {
        name: parser.attribName,
        value: parser.attribValue
      })
    }

    parser.attribName = parser.attribValue = ''
  }

  function openTag (parser, selfClosing) {
    if (parser.opt.xmlns) {
      // emit namespace binding events
      var tag = parser.tag

      // add namespace info to tag
      var qn = qname(parser.tagName)
      tag.prefix = qn.prefix
      tag.local = qn.local
      tag.uri = tag.ns[qn.prefix] || ''

      if (tag.prefix && !tag.uri) {
        strictFail(parser, 'Unbound namespace prefix: ' +
          JSON.stringify(parser.tagName))
        tag.uri = qn.prefix
      }

      var parent = parser.tags[parser.tags.length - 1] || parser
      if (tag.ns && parent.ns !== tag.ns) {
        Object.keys(tag.ns).forEach(function (p) {
          emitNode(parser, 'onopennamespace', {
            prefix: p,
            uri: tag.ns[p]
          })
        })
      }

      // handle deferred onattribute events
      // Note: do not apply default ns to attributes:
      //   http://www.w3.org/TR/REC-xml-names/#defaulting
      for (var i = 0, l = parser.attribList.length; i < l; i++) {
        var nv = parser.attribList[i]
        var name = nv[0]
        var value = nv[1]
        var qualName = qname(name, true)
        var prefix = qualName.prefix
        var local = qualName.local
        var uri = prefix === '' ? '' : (tag.ns[prefix] || '')
        var a = {
          name: name,
          value: value,
          prefix: prefix,
          local: local,
          uri: uri
        }

        // if there's any attributes with an undefined namespace,
        // then fail on them now.
        if (prefix && prefix !== 'xmlns' && !uri) {
          strictFail(parser, 'Unbound namespace prefix: ' +
            JSON.stringify(prefix))
          a.uri = prefix
        }
        parser.tag.attributes[name] = a
        emitNode(parser, 'onattribute', a)
      }
      parser.attribList.length = 0
    }

    parser.tag.isSelfClosing = !!selfClosing

    // process the tag
    parser.sawRoot = true
    parser.tags.push(parser.tag)
    emitNode(parser, 'onopentag', parser.tag)
    if (!selfClosing) {
      // special case for <script> in non-strict mode.
      if (!parser.noscript && parser.tagName.toLowerCase() === 'script') {
        parser.state = S.SCRIPT
      } else {
        parser.state = S.TEXT
      }
      parser.tag = null
      parser.tagName = ''
    }
    parser.attribName = parser.attribValue = ''
    parser.attribList.length = 0
  }

  function closeTag (parser) {
    if (!parser.tagName) {
      strictFail(parser, 'Weird empty close tag.')
      parser.textNode += '</>'
      parser.state = S.TEXT
      return
    }

    if (parser.script) {
      if (parser.tagName !== 'script') {
        parser.script += '</' + parser.tagName + '>'
        parser.tagName = ''
        parser.state = S.SCRIPT
        return
      }
      emitNode(parser, 'onscript', parser.script)
      parser.script = ''
    }

    // first make sure that the closing tag actually exists.
    // <a><b></c></b></a> will close everything, otherwise.
    var t = parser.tags.length
    var tagName = parser.tagName
    if (!parser.strict) {
      tagName = tagName[parser.looseCase]()
    }
    var closeTo = tagName
    while (t--) {
      var close = parser.tags[t]
      if (close.name !== closeTo) {
        // fail the first time in strict mode
        strictFail(parser, 'Unexpected close tag')
      } else {
        break
      }
    }

    // didn't find it.  we already failed for strict, so just abort.
    if (t < 0) {
      strictFail(parser, 'Unmatched closing tag: ' + parser.tagName)
      parser.textNode += '</' + parser.tagName + '>'
      parser.state = S.TEXT
      return
    }
    parser.tagName = tagName
    var s = parser.tags.length
    while (s-- > t) {
      var tag = parser.tag = parser.tags.pop()
      parser.tagName = parser.tag.name
      emitNode(parser, 'onclosetag', parser.tagName)

      var x = {}
      for (var i in tag.ns) {
        x[i] = tag.ns[i]
      }

      var parent = parser.tags[parser.tags.length - 1] || parser
      if (parser.opt.xmlns && tag.ns !== parent.ns) {
        // remove namespace bindings introduced by tag
        Object.keys(tag.ns).forEach(function (p) {
          var n = tag.ns[p]
          emitNode(parser, 'onclosenamespace', { prefix: p, uri: n })
        })
      }
    }
    if (t === 0) parser.closedRoot = true
    parser.tagName = parser.attribValue = parser.attribName = ''
    parser.attribList.length = 0
    parser.state = S.TEXT
  }

  function parseEntity (parser) {
    var entity = parser.entity
    var entityLC = entity.toLowerCase()
    var num
    var numStr = ''

    if (parser.ENTITIES[entity]) {
      return parser.ENTITIES[entity]
    }
    if (parser.ENTITIES[entityLC]) {
      return parser.ENTITIES[entityLC]
    }
    entity = entityLC
    if (entity.charAt(0) === '#') {
      if (entity.charAt(1) === 'x') {
        entity = entity.slice(2)
        num = parseInt(entity, 16)
        numStr = num.toString(16)
      } else {
        entity = entity.slice(1)
        num = parseInt(entity, 10)
        numStr = num.toString(10)
      }
    }
    entity = entity.replace(/^0+/, '')
    if (isNaN(num) || numStr.toLowerCase() !== entity) {
      strictFail(parser, 'Invalid character entity')
      return '&' + parser.entity + ';'
    }

    return String.fromCodePoint(num)
  }

  function beginWhiteSpace (parser, c) {
    if (c === '<') {
      parser.state = S.OPEN_WAKA
      parser.startTagPosition = parser.position
    } else if (!isWhitespace(c)) {
      // have to process this as a text node.
      // weird, but happens.
      strictFail(parser, 'Non-whitespace before first tag.')
      parser.textNode = c
      parser.state = S.TEXT
    }
  }

  function charAt (chunk, i) {
    var result = ''
    if (i < chunk.length) {
      result = chunk.charAt(i)
    }
    return result
  }

  function write (chunk) {
    var parser = this
    if (this.error) {
      throw this.error
    }
    if (parser.closed) {
      return error(parser,
        'Cannot write after close. Assign an onready handler.')
    }
    if (chunk === null) {
      return end(parser)
    }
    if (typeof chunk === 'object') {
      chunk = chunk.toString()
    }
    var i = 0
    var c = ''
    while (true) {
      c = charAt(chunk, i++)
      parser.c = c

      if (!c) {
        break
      }

      if (parser.trackPosition) {
        parser.position++
        if (c === '\n') {
          parser.line++
          parser.column = 0
        } else {
          parser.column++
        }
      }

      switch (parser.state) {
        case S.BEGIN:
          parser.state = S.BEGIN_WHITESPACE
          if (c === '\uFEFF') {
            continue
          }
          beginWhiteSpace(parser, c)
          continue

        case S.BEGIN_WHITESPACE:
          beginWhiteSpace(parser, c)
          continue

        case S.TEXT:
          if (parser.sawRoot && !parser.closedRoot) {
            var starti = i - 1
            while (c && c !== '<' && c !== '&') {
              c = charAt(chunk, i++)
              if (c && parser.trackPosition) {
                parser.position++
                if (c === '\n') {
                  parser.line++
                  parser.column = 0
                } else {
                  parser.column++
                }
              }
            }
            parser.textNode += chunk.substring(starti, i - 1)
          }
          if (c === '<' && !(parser.sawRoot && parser.closedRoot && !parser.strict)) {
            parser.state = S.OPEN_WAKA
            parser.startTagPosition = parser.position
          } else {
            if (!isWhitespace(c) && (!parser.sawRoot || parser.closedRoot)) {
              strictFail(parser, 'Text data outside of root node.')
            }
            if (c === '&') {
              parser.state = S.TEXT_ENTITY
            } else {
              parser.textNode += c
            }
          }
          continue

        case S.SCRIPT:
          // only non-strict
          if (c === '<') {
            parser.state = S.SCRIPT_ENDING
          } else {
            parser.script += c
          }
          continue

        case S.SCRIPT_ENDING:
          if (c === '/') {
            parser.state = S.CLOSE_TAG
          } else {
            parser.script += '<' + c
            parser.state = S.SCRIPT
          }
          continue

        case S.OPEN_WAKA:
          // either a /, ?, !, or text is coming next.
          if (c === '!') {
            parser.state = S.SGML_DECL
            parser.sgmlDecl = ''
          } else if (isWhitespace(c)) {
            // wait for it...
          } else if (isMatch(nameStart, c)) {
            parser.state = S.OPEN_TAG
            parser.tagName = c
          } else if (c === '/') {
            parser.state = S.CLOSE_TAG
            parser.tagName = ''
          } else if (c === '?') {
            parser.state = S.PROC_INST
            parser.procInstName = parser.procInstBody = ''
          } else {
            strictFail(parser, 'Unencoded <')
            // if there was some whitespace, then add that in.
            if (parser.startTagPosition + 1 < parser.position) {
              var pad = parser.position - parser.startTagPosition
              c = new Array(pad).join(' ') + c
            }
            parser.textNode += '<' + c
            parser.state = S.TEXT
          }
          continue

        case S.SGML_DECL:
          if ((parser.sgmlDecl + c).toUpperCase() === CDATA) {
            emitNode(parser, 'onopencdata')
            parser.state = S.CDATA
            parser.sgmlDecl = ''
            parser.cdata = ''
          } else if (parser.sgmlDecl + c === '--') {
            parser.state = S.COMMENT
            parser.comment = ''
            parser.sgmlDecl = ''
          } else if ((parser.sgmlDecl + c).toUpperCase() === DOCTYPE) {
            parser.state = S.DOCTYPE
            if (parser.doctype || parser.sawRoot) {
              strictFail(parser,
                'Inappropriately located doctype declaration')
            }
            parser.doctype = ''
            parser.sgmlDecl = ''
          } else if (c === '>') {
            emitNode(parser, 'onsgmldeclaration', parser.sgmlDecl)
            parser.sgmlDecl = ''
            parser.state = S.TEXT
          } else if (isQuote(c)) {
            parser.state = S.SGML_DECL_QUOTED
            parser.sgmlDecl += c
          } else {
            parser.sgmlDecl += c
          }
          continue

        case S.SGML_DECL_QUOTED:
          if (c === parser.q) {
            parser.state = S.SGML_DECL
            parser.q = ''
          }
          parser.sgmlDecl += c
          continue

        case S.DOCTYPE:
          if (c === '>') {
            parser.state = S.TEXT
            emitNode(parser, 'ondoctype', parser.doctype)
            parser.doctype = true // just remember that we saw it.
          } else {
            parser.doctype += c
            if (c === '[') {
              parser.state = S.DOCTYPE_DTD
            } else if (isQuote(c)) {
              parser.state = S.DOCTYPE_QUOTED
              parser.q = c
            }
          }
          continue

        case S.DOCTYPE_QUOTED:
          parser.doctype += c
          if (c === parser.q) {
            parser.q = ''
            parser.state = S.DOCTYPE
          }
          continue

        case S.DOCTYPE_DTD:
          parser.doctype += c
          if (c === ']') {
            parser.state = S.DOCTYPE
          } else if (isQuote(c)) {
            parser.state = S.DOCTYPE_DTD_QUOTED
            parser.q = c
          }
          continue

        case S.DOCTYPE_DTD_QUOTED:
          parser.doctype += c
          if (c === parser.q) {
            parser.state = S.DOCTYPE_DTD
            parser.q = ''
          }
          continue

        case S.COMMENT:
          if (c === '-') {
            parser.state = S.COMMENT_ENDING
          } else {
            parser.comment += c
          }
          continue

        case S.COMMENT_ENDING:
          if (c === '-') {
            parser.state = S.COMMENT_ENDED
            parser.comment = textopts(parser.opt, parser.comment)
            if (parser.comment) {
              emitNode(parser, 'oncomment', parser.comment)
            }
            parser.comment = ''
          } else {
            parser.comment += '-' + c
            parser.state = S.COMMENT
          }
          continue

        case S.COMMENT_ENDED:
          if (c !== '>') {
            strictFail(parser, 'Malformed comment')
            // allow <!-- blah -- bloo --> in non-strict mode,
            // which is a comment of " blah -- bloo "
            parser.comment += '--' + c
            parser.state = S.COMMENT
          } else {
            parser.state = S.TEXT
          }
          continue

        case S.CDATA:
          if (c === ']') {
            parser.state = S.CDATA_ENDING
          } else {
            parser.cdata += c
          }
          continue

        case S.CDATA_ENDING:
          if (c === ']') {
            parser.state = S.CDATA_ENDING_2
          } else {
            parser.cdata += ']' + c
            parser.state = S.CDATA
          }
          continue

        case S.CDATA_ENDING_2:
          if (c === '>') {
            if (parser.cdata) {
              emitNode(parser, 'oncdata', parser.cdata)
            }
            emitNode(parser, 'onclosecdata')
            parser.cdata = ''
            parser.state = S.TEXT
          } else if (c === ']') {
            parser.cdata += ']'
          } else {
            parser.cdata += ']]' + c
            parser.state = S.CDATA
          }
          continue

        case S.PROC_INST:
          if (c === '?') {
            parser.state = S.PROC_INST_ENDING
          } else if (isWhitespace(c)) {
            parser.state = S.PROC_INST_BODY
          } else {
            parser.procInstName += c
          }
          continue

        case S.PROC_INST_BODY:
          if (!parser.procInstBody && isWhitespace(c)) {
            continue
          } else if (c === '?') {
            parser.state = S.PROC_INST_ENDING
          } else {
            parser.procInstBody += c
          }
          continue

        case S.PROC_INST_ENDING:
          if (c === '>') {
            emitNode(parser, 'onprocessinginstruction', {
              name: parser.procInstName,
              body: parser.procInstBody
            })
            parser.procInstName = parser.procInstBody = ''
            parser.state = S.TEXT
          } else {
            parser.procInstBody += '?' + c
            parser.state = S.PROC_INST_BODY
          }
          continue

        case S.OPEN_TAG:
          if (isMatch(nameBody, c)) {
            parser.tagName += c
          } else {
            newTag(parser)
            if (c === '>') {
              openTag(parser)
            } else if (c === '/') {
              parser.state = S.OPEN_TAG_SLASH
            } else {
              if (!isWhitespace(c)) {
                strictFail(parser, 'Invalid character in tag name')
              }
              parser.state = S.ATTRIB
            }
          }
          continue

        case S.OPEN_TAG_SLASH:
          if (c === '>') {
            openTag(parser, true)
            closeTag(parser)
          } else {
            strictFail(parser, 'Forward-slash in opening tag not followed by >')
            parser.state = S.ATTRIB
          }
          continue

        case S.ATTRIB:
          // haven't read the attribute name yet.
          if (isWhitespace(c)) {
            continue
          } else if (c === '>') {
            openTag(parser)
          } else if (c === '/') {
            parser.state = S.OPEN_TAG_SLASH
          } else if (isMatch(nameStart, c)) {
            parser.attribName = c
            parser.attribValue = ''
            parser.state = S.ATTRIB_NAME
          } else {
            strictFail(parser, 'Invalid attribute name')
          }
          continue

        case S.ATTRIB_NAME:
          if (c === '=') {
            parser.state = S.ATTRIB_VALUE
          } else if (c === '>') {
            strictFail(parser, 'Attribute without value')
            parser.attribValue = parser.attribName
            attrib(parser)
            openTag(parser)
          } else if (isWhitespace(c)) {
            parser.state = S.ATTRIB_NAME_SAW_WHITE
          } else if (isMatch(nameBody, c)) {
            parser.attribName += c
          } else {
            strictFail(parser, 'Invalid attribute name')
          }
          continue

        case S.ATTRIB_NAME_SAW_WHITE:
          if (c === '=') {
            parser.state = S.ATTRIB_VALUE
          } else if (isWhitespace(c)) {
            continue
          } else {
            strictFail(parser, 'Attribute without value')
            parser.tag.attributes[parser.attribName] = ''
            parser.attribValue = ''
            emitNode(parser, 'onattribute', {
              name: parser.attribName,
              value: ''
            })
            parser.attribName = ''
            if (c === '>') {
              openTag(parser)
            } else if (isMatch(nameStart, c)) {
              parser.attribName = c
              parser.state = S.ATTRIB_NAME
            } else {
              strictFail(parser, 'Invalid attribute name')
              parser.state = S.ATTRIB
            }
          }
          continue

        case S.ATTRIB_VALUE:
          if (isWhitespace(c)) {
            continue
          } else if (isQuote(c)) {
            parser.q = c
            parser.state = S.ATTRIB_VALUE_QUOTED
          } else {
            strictFail(parser, 'Unquoted attribute value')
            parser.state = S.ATTRIB_VALUE_UNQUOTED
            parser.attribValue = c
          }
          continue

        case S.ATTRIB_VALUE_QUOTED:
          if (c !== parser.q) {
            if (c === '&') {
              parser.state = S.ATTRIB_VALUE_ENTITY_Q
            } else {
              parser.attribValue += c
            }
            continue
          }
          attrib(parser)
          parser.q = ''
          parser.state = S.ATTRIB_VALUE_CLOSED
          continue

        case S.ATTRIB_VALUE_CLOSED:
          if (isWhitespace(c)) {
            parser.state = S.ATTRIB
          } else if (c === '>') {
            openTag(parser)
          } else if (c === '/') {
            parser.state = S.OPEN_TAG_SLASH
          } else if (isMatch(nameStart, c)) {
            strictFail(parser, 'No whitespace between attributes')
            parser.attribName = c
            parser.attribValue = ''
            parser.state = S.ATTRIB_NAME
          } else {
            strictFail(parser, 'Invalid attribute name')
          }
          continue

        case S.ATTRIB_VALUE_UNQUOTED:
          if (!isAttribEnd(c)) {
            if (c === '&') {
              parser.state = S.ATTRIB_VALUE_ENTITY_U
            } else {
              parser.attribValue += c
            }
            continue
          }
          attrib(parser)
          if (c === '>') {
            openTag(parser)
          } else {
            parser.state = S.ATTRIB
          }
          continue

        case S.CLOSE_TAG:
          if (!parser.tagName) {
            if (isWhitespace(c)) {
              continue
            } else if (notMatch(nameStart, c)) {
              if (parser.script) {
                parser.script += '</' + c
                parser.state = S.SCRIPT
              } else {
                strictFail(parser, 'Invalid tagname in closing tag.')
              }
            } else {
              parser.tagName = c
            }
          } else if (c === '>') {
            closeTag(parser)
          } else if (isMatch(nameBody, c)) {
            parser.tagName += c
          } else if (parser.script) {
            parser.script += '</' + parser.tagName
            parser.tagName = ''
            parser.state = S.SCRIPT
          } else {
            if (!isWhitespace(c)) {
              strictFail(parser, 'Invalid tagname in closing tag')
            }
            parser.state = S.CLOSE_TAG_SAW_WHITE
          }
          continue

        case S.CLOSE_TAG_SAW_WHITE:
          if (isWhitespace(c)) {
            continue
          }
          if (c === '>') {
            closeTag(parser)
          } else {
            strictFail(parser, 'Invalid characters in closing tag')
          }
          continue

        case S.TEXT_ENTITY:
        case S.ATTRIB_VALUE_ENTITY_Q:
        case S.ATTRIB_VALUE_ENTITY_U:
          var returnState
          var buffer
          switch (parser.state) {
            case S.TEXT_ENTITY:
              returnState = S.TEXT
              buffer = 'textNode'
              break

            case S.ATTRIB_VALUE_ENTITY_Q:
              returnState = S.ATTRIB_VALUE_QUOTED
              buffer = 'attribValue'
              break

            case S.ATTRIB_VALUE_ENTITY_U:
              returnState = S.ATTRIB_VALUE_UNQUOTED
              buffer = 'attribValue'
              break
          }

          if (c === ';') {
            if (parser.opt.unparsedEntities) {
              var parsedEntity = parseEntity(parser)
              parser.entity = ''
              parser.state = returnState
              parser.write(parsedEntity)
            } else {
              parser[buffer] += parseEntity(parser)
              parser.entity = ''
              parser.state = returnState
            }
          } else if (isMatch(parser.entity.length ? entityBody : entityStart, c)) {
            parser.entity += c
          } else {
            strictFail(parser, 'Invalid character in entity name')
            parser[buffer] += '&' + parser.entity + c
            parser.entity = ''
            parser.state = returnState
          }

          continue

        default: /* istanbul ignore next */ {
          throw new Error(parser, 'Unknown state: ' + parser.state)
        }
      }
    } // while

    if (parser.position >= parser.bufferCheckPosition) {
      checkBufferLength(parser)
    }
    return parser
  }

  /*! http://mths.be/fromcodepoint v0.1.0 by @mathias */
  /* istanbul ignore next */
  if (!String.fromCodePoint) {
    (function () {
      var stringFromCharCode = String.fromCharCode
      var floor = Math.floor
      var fromCodePoint = function () {
        var MAX_SIZE = 0x4000
        var codeUnits = []
        var highSurrogate
        var lowSurrogate
        var index = -1
        var length = arguments.length
        if (!length) {
          return ''
        }
        var result = ''
        while (++index < length) {
          var codePoint = Number(arguments[index])
          if (
            !isFinite(codePoint) || // `NaN`, `+Infinity`, or `-Infinity`
            codePoint < 0 || // not a valid Unicode code point
            codePoint > 0x10FFFF || // not a valid Unicode code point
            floor(codePoint) !== codePoint // not an integer
          ) {
            throw RangeError('Invalid code point: ' + codePoint)
          }
          if (codePoint <= 0xFFFF) { // BMP code point
            codeUnits.push(codePoint)
          } else { // Astral code point; split in surrogate halves
            // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
            codePoint -= 0x10000
            highSurrogate = (codePoint >> 10) + 0xD800
            lowSurrogate = (codePoint % 0x400) + 0xDC00
            codeUnits.push(highSurrogate, lowSurrogate)
          }
          if (index + 1 === length || codeUnits.length > MAX_SIZE) {
            result += stringFromCharCode.apply(null, codeUnits)
            codeUnits.length = 0
          }
        }
        return result
      }
      /* istanbul ignore next */
      if (Object.defineProperty) {
        Object.defineProperty(String, 'fromCodePoint', {
          value: fromCodePoint,
          configurable: true,
          writable: true
        })
      } else {
        String.fromCodePoint = fromCodePoint
      }
    }())
  }
})( false ? 0 : exports)


/***/ }),

/***/ 3904:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const ANY = Symbol('SemVer ANY')
// hoisted class for cyclic dependency
class Comparator {
  static get ANY () {
    return ANY
  }

  constructor (comp, options) {
    options = parseOptions(options)

    if (comp instanceof Comparator) {
      if (comp.loose === !!options.loose) {
        return comp
      } else {
        comp = comp.value
      }
    }

    comp = comp.trim().split(/\s+/).join(' ')
    debug('comparator', comp, options)
    this.options = options
    this.loose = !!options.loose
    this.parse(comp)

    if (this.semver === ANY) {
      this.value = ''
    } else {
      this.value = this.operator + this.semver.version
    }

    debug('comp', this)
  }

  parse (comp) {
    const r = this.options.loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR]
    const m = comp.match(r)

    if (!m) {
      throw new TypeError(`Invalid comparator: ${comp}`)
    }

    this.operator = m[1] !== undefined ? m[1] : ''
    if (this.operator === '=') {
      this.operator = ''
    }

    // if it literally is just '>' or '' then allow anything.
    if (!m[2]) {
      this.semver = ANY
    } else {
      this.semver = new SemVer(m[2], this.options.loose)
    }
  }

  toString () {
    return this.value
  }

  test (version) {
    debug('Comparator.test', version, this.options.loose)

    if (this.semver === ANY || version === ANY) {
      return true
    }

    if (typeof version === 'string') {
      try {
        version = new SemVer(version, this.options)
      } catch (er) {
        return false
      }
    }

    return cmp(version, this.operator, this.semver, this.options)
  }

  intersects (comp, options) {
    if (!(comp instanceof Comparator)) {
      throw new TypeError('a Comparator is required')
    }

    if (this.operator === '') {
      if (this.value === '') {
        return true
      }
      return new Range(comp.value, options).test(this.value)
    } else if (comp.operator === '') {
      if (comp.value === '') {
        return true
      }
      return new Range(this.value, options).test(comp.semver)
    }

    options = parseOptions(options)

    // Special cases where nothing can possibly be lower
    if (options.includePrerelease &&
      (this.value === '<0.0.0-0' || comp.value === '<0.0.0-0')) {
      return false
    }
    if (!options.includePrerelease &&
      (this.value.startsWith('<0.0.0') || comp.value.startsWith('<0.0.0'))) {
      return false
    }

    // Same direction increasing (> or >=)
    if (this.operator.startsWith('>') && comp.operator.startsWith('>')) {
      return true
    }
    // Same direction decreasing (< or <=)
    if (this.operator.startsWith('<') && comp.operator.startsWith('<')) {
      return true
    }
    // same SemVer and both sides are inclusive (<= or >=)
    if (
      (this.semver.version === comp.semver.version) &&
      this.operator.includes('=') && comp.operator.includes('=')) {
      return true
    }
    // opposite directions less than
    if (cmp(this.semver, '<', comp.semver, options) &&
      this.operator.startsWith('>') && comp.operator.startsWith('<')) {
      return true
    }
    // opposite directions greater than
    if (cmp(this.semver, '>', comp.semver, options) &&
      this.operator.startsWith('<') && comp.operator.startsWith('>')) {
      return true
    }
    return false
  }
}

module.exports = Comparator

const parseOptions = __webpack_require__(8587)
const { safeRe: re, t } = __webpack_require__(9718)
const cmp = __webpack_require__(2111)
const debug = __webpack_require__(7272)
const SemVer = __webpack_require__(3908)
const Range = __webpack_require__(8311)


/***/ }),

/***/ 8311:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// hoisted class for cyclic dependency
class Range {
  constructor (range, options) {
    options = parseOptions(options)

    if (range instanceof Range) {
      if (
        range.loose === !!options.loose &&
        range.includePrerelease === !!options.includePrerelease
      ) {
        return range
      } else {
        return new Range(range.raw, options)
      }
    }

    if (range instanceof Comparator) {
      // just put it in the set and return
      this.raw = range.value
      this.set = [[range]]
      this.format()
      return this
    }

    this.options = options
    this.loose = !!options.loose
    this.includePrerelease = !!options.includePrerelease

    // First reduce all whitespace as much as possible so we do not have to rely
    // on potentially slow regexes like \s*. This is then stored and used for
    // future error messages as well.
    this.raw = range
      .trim()
      .split(/\s+/)
      .join(' ')

    // First, split on ||
    this.set = this.raw
      .split('||')
      // map the range to a 2d array of comparators
      .map(r => this.parseRange(r.trim()))
      // throw out any comparator lists that are empty
      // this generally means that it was not a valid range, which is allowed
      // in loose mode, but will still throw if the WHOLE range is invalid.
      .filter(c => c.length)

    if (!this.set.length) {
      throw new TypeError(`Invalid SemVer Range: ${this.raw}`)
    }

    // if we have any that are not the null set, throw out null sets.
    if (this.set.length > 1) {
      // keep the first one, in case they're all null sets
      const first = this.set[0]
      this.set = this.set.filter(c => !isNullSet(c[0]))
      if (this.set.length === 0) {
        this.set = [first]
      } else if (this.set.length > 1) {
        // if we have any that are *, then the range is just *
        for (const c of this.set) {
          if (c.length === 1 && isAny(c[0])) {
            this.set = [c]
            break
          }
        }
      }
    }

    this.format()
  }

  format () {
    this.range = this.set
      .map((comps) => comps.join(' ').trim())
      .join('||')
      .trim()
    return this.range
  }

  toString () {
    return this.range
  }

  parseRange (range) {
    // memoize range parsing for performance.
    // this is a very hot path, and fully deterministic.
    const memoOpts =
      (this.options.includePrerelease && FLAG_INCLUDE_PRERELEASE) |
      (this.options.loose && FLAG_LOOSE)
    const memoKey = memoOpts + ':' + range
    const cached = cache.get(memoKey)
    if (cached) {
      return cached
    }

    const loose = this.options.loose
    // `1.2.3 - 1.2.4` => `>=1.2.3 <=1.2.4`
    const hr = loose ? re[t.HYPHENRANGELOOSE] : re[t.HYPHENRANGE]
    range = range.replace(hr, hyphenReplace(this.options.includePrerelease))
    debug('hyphen replace', range)

    // `> 1.2.3 < 1.2.5` => `>1.2.3 <1.2.5`
    range = range.replace(re[t.COMPARATORTRIM], comparatorTrimReplace)
    debug('comparator trim', range)

    // `~ 1.2.3` => `~1.2.3`
    range = range.replace(re[t.TILDETRIM], tildeTrimReplace)
    debug('tilde trim', range)

    // `^ 1.2.3` => `^1.2.3`
    range = range.replace(re[t.CARETTRIM], caretTrimReplace)
    debug('caret trim', range)

    // At this point, the range is completely trimmed and
    // ready to be split into comparators.

    let rangeList = range
      .split(' ')
      .map(comp => parseComparator(comp, this.options))
      .join(' ')
      .split(/\s+/)
      // >=0.0.0 is equivalent to *
      .map(comp => replaceGTE0(comp, this.options))

    if (loose) {
      // in loose mode, throw out any that are not valid comparators
      rangeList = rangeList.filter(comp => {
        debug('loose invalid filter', comp, this.options)
        return !!comp.match(re[t.COMPARATORLOOSE])
      })
    }
    debug('range list', rangeList)

    // if any comparators are the null set, then replace with JUST null set
    // if more than one comparator, remove any * comparators
    // also, don't include the same comparator more than once
    const rangeMap = new Map()
    const comparators = rangeList.map(comp => new Comparator(comp, this.options))
    for (const comp of comparators) {
      if (isNullSet(comp)) {
        return [comp]
      }
      rangeMap.set(comp.value, comp)
    }
    if (rangeMap.size > 1 && rangeMap.has('')) {
      rangeMap.delete('')
    }

    const result = [...rangeMap.values()]
    cache.set(memoKey, result)
    return result
  }

  intersects (range, options) {
    if (!(range instanceof Range)) {
      throw new TypeError('a Range is required')
    }

    return this.set.some((thisComparators) => {
      return (
        isSatisfiable(thisComparators, options) &&
        range.set.some((rangeComparators) => {
          return (
            isSatisfiable(rangeComparators, options) &&
            thisComparators.every((thisComparator) => {
              return rangeComparators.every((rangeComparator) => {
                return thisComparator.intersects(rangeComparator, options)
              })
            })
          )
        })
      )
    })
  }

  // if ANY of the sets match ALL of its comparators, then pass
  test (version) {
    if (!version) {
      return false
    }

    if (typeof version === 'string') {
      try {
        version = new SemVer(version, this.options)
      } catch (er) {
        return false
      }
    }

    for (let i = 0; i < this.set.length; i++) {
      if (testSet(this.set[i], version, this.options)) {
        return true
      }
    }
    return false
  }
}

module.exports = Range

const LRU = __webpack_require__(8794)
const cache = new LRU()

const parseOptions = __webpack_require__(8587)
const Comparator = __webpack_require__(3904)
const debug = __webpack_require__(7272)
const SemVer = __webpack_require__(3908)
const {
  safeRe: re,
  t,
  comparatorTrimReplace,
  tildeTrimReplace,
  caretTrimReplace,
} = __webpack_require__(9718)
const { FLAG_INCLUDE_PRERELEASE, FLAG_LOOSE } = __webpack_require__(6874)

const isNullSet = c => c.value === '<0.0.0-0'
const isAny = c => c.value === ''

// take a set of comparators and determine whether there
// exists a version which can satisfy it
const isSatisfiable = (comparators, options) => {
  let result = true
  const remainingComparators = comparators.slice()
  let testComparator = remainingComparators.pop()

  while (result && remainingComparators.length) {
    result = remainingComparators.every((otherComparator) => {
      return testComparator.intersects(otherComparator, options)
    })

    testComparator = remainingComparators.pop()
  }

  return result
}

// comprised of xranges, tildes, stars, and gtlt's at this point.
// already replaced the hyphen ranges
// turn into a set of JUST comparators.
const parseComparator = (comp, options) => {
  debug('comp', comp, options)
  comp = replaceCarets(comp, options)
  debug('caret', comp)
  comp = replaceTildes(comp, options)
  debug('tildes', comp)
  comp = replaceXRanges(comp, options)
  debug('xrange', comp)
  comp = replaceStars(comp, options)
  debug('stars', comp)
  return comp
}

const isX = id => !id || id.toLowerCase() === 'x' || id === '*'

// ~, ~> --> * (any, kinda silly)
// ~2, ~2.x, ~2.x.x, ~>2, ~>2.x ~>2.x.x --> >=2.0.0 <3.0.0-0
// ~2.0, ~2.0.x, ~>2.0, ~>2.0.x --> >=2.0.0 <2.1.0-0
// ~1.2, ~1.2.x, ~>1.2, ~>1.2.x --> >=1.2.0 <1.3.0-0
// ~1.2.3, ~>1.2.3 --> >=1.2.3 <1.3.0-0
// ~1.2.0, ~>1.2.0 --> >=1.2.0 <1.3.0-0
// ~0.0.1 --> >=0.0.1 <0.1.0-0
const replaceTildes = (comp, options) => {
  return comp
    .trim()
    .split(/\s+/)
    .map((c) => replaceTilde(c, options))
    .join(' ')
}

const replaceTilde = (comp, options) => {
  const r = options.loose ? re[t.TILDELOOSE] : re[t.TILDE]
  return comp.replace(r, (_, M, m, p, pr) => {
    debug('tilde', comp, _, M, m, p, pr)
    let ret

    if (isX(M)) {
      ret = ''
    } else if (isX(m)) {
      ret = `>=${M}.0.0 <${+M + 1}.0.0-0`
    } else if (isX(p)) {
      // ~1.2 == >=1.2.0 <1.3.0-0
      ret = `>=${M}.${m}.0 <${M}.${+m + 1}.0-0`
    } else if (pr) {
      debug('replaceTilde pr', pr)
      ret = `>=${M}.${m}.${p}-${pr
      } <${M}.${+m + 1}.0-0`
    } else {
      // ~1.2.3 == >=1.2.3 <1.3.0-0
      ret = `>=${M}.${m}.${p
      } <${M}.${+m + 1}.0-0`
    }

    debug('tilde return', ret)
    return ret
  })
}

// ^ --> * (any, kinda silly)
// ^2, ^2.x, ^2.x.x --> >=2.0.0 <3.0.0-0
// ^2.0, ^2.0.x --> >=2.0.0 <3.0.0-0
// ^1.2, ^1.2.x --> >=1.2.0 <2.0.0-0
// ^1.2.3 --> >=1.2.3 <2.0.0-0
// ^1.2.0 --> >=1.2.0 <2.0.0-0
// ^0.0.1 --> >=0.0.1 <0.0.2-0
// ^0.1.0 --> >=0.1.0 <0.2.0-0
const replaceCarets = (comp, options) => {
  return comp
    .trim()
    .split(/\s+/)
    .map((c) => replaceCaret(c, options))
    .join(' ')
}

const replaceCaret = (comp, options) => {
  debug('caret', comp, options)
  const r = options.loose ? re[t.CARETLOOSE] : re[t.CARET]
  const z = options.includePrerelease ? '-0' : ''
  return comp.replace(r, (_, M, m, p, pr) => {
    debug('caret', comp, _, M, m, p, pr)
    let ret

    if (isX(M)) {
      ret = ''
    } else if (isX(m)) {
      ret = `>=${M}.0.0${z} <${+M + 1}.0.0-0`
    } else if (isX(p)) {
      if (M === '0') {
        ret = `>=${M}.${m}.0${z} <${M}.${+m + 1}.0-0`
      } else {
        ret = `>=${M}.${m}.0${z} <${+M + 1}.0.0-0`
      }
    } else if (pr) {
      debug('replaceCaret pr', pr)
      if (M === '0') {
        if (m === '0') {
          ret = `>=${M}.${m}.${p}-${pr
          } <${M}.${m}.${+p + 1}-0`
        } else {
          ret = `>=${M}.${m}.${p}-${pr
          } <${M}.${+m + 1}.0-0`
        }
      } else {
        ret = `>=${M}.${m}.${p}-${pr
        } <${+M + 1}.0.0-0`
      }
    } else {
      debug('no pr')
      if (M === '0') {
        if (m === '0') {
          ret = `>=${M}.${m}.${p
          }${z} <${M}.${m}.${+p + 1}-0`
        } else {
          ret = `>=${M}.${m}.${p
          }${z} <${M}.${+m + 1}.0-0`
        }
      } else {
        ret = `>=${M}.${m}.${p
        } <${+M + 1}.0.0-0`
      }
    }

    debug('caret return', ret)
    return ret
  })
}

const replaceXRanges = (comp, options) => {
  debug('replaceXRanges', comp, options)
  return comp
    .split(/\s+/)
    .map((c) => replaceXRange(c, options))
    .join(' ')
}

const replaceXRange = (comp, options) => {
  comp = comp.trim()
  const r = options.loose ? re[t.XRANGELOOSE] : re[t.XRANGE]
  return comp.replace(r, (ret, gtlt, M, m, p, pr) => {
    debug('xRange', comp, ret, gtlt, M, m, p, pr)
    const xM = isX(M)
    const xm = xM || isX(m)
    const xp = xm || isX(p)
    const anyX = xp

    if (gtlt === '=' && anyX) {
      gtlt = ''
    }

    // if we're including prereleases in the match, then we need
    // to fix this to -0, the lowest possible prerelease value
    pr = options.includePrerelease ? '-0' : ''

    if (xM) {
      if (gtlt === '>' || gtlt === '<') {
        // nothing is allowed
        ret = '<0.0.0-0'
      } else {
        // nothing is forbidden
        ret = '*'
      }
    } else if (gtlt && anyX) {
      // we know patch is an x, because we have any x at all.
      // replace X with 0
      if (xm) {
        m = 0
      }
      p = 0

      if (gtlt === '>') {
        // >1 => >=2.0.0
        // >1.2 => >=1.3.0
        gtlt = '>='
        if (xm) {
          M = +M + 1
          m = 0
          p = 0
        } else {
          m = +m + 1
          p = 0
        }
      } else if (gtlt === '<=') {
        // <=0.7.x is actually <0.8.0, since any 0.7.x should
        // pass.  Similarly, <=7.x is actually <8.0.0, etc.
        gtlt = '<'
        if (xm) {
          M = +M + 1
        } else {
          m = +m + 1
        }
      }

      if (gtlt === '<') {
        pr = '-0'
      }

      ret = `${gtlt + M}.${m}.${p}${pr}`
    } else if (xm) {
      ret = `>=${M}.0.0${pr} <${+M + 1}.0.0-0`
    } else if (xp) {
      ret = `>=${M}.${m}.0${pr
      } <${M}.${+m + 1}.0-0`
    }

    debug('xRange return', ret)

    return ret
  })
}

// Because * is AND-ed with everything else in the comparator,
// and '' means "any version", just remove the *s entirely.
const replaceStars = (comp, options) => {
  debug('replaceStars', comp, options)
  // Looseness is ignored here.  star is always as loose as it gets!
  return comp
    .trim()
    .replace(re[t.STAR], '')
}

const replaceGTE0 = (comp, options) => {
  debug('replaceGTE0', comp, options)
  return comp
    .trim()
    .replace(re[options.includePrerelease ? t.GTE0PRE : t.GTE0], '')
}

// This function is passed to string.replace(re[t.HYPHENRANGE])
// M, m, patch, prerelease, build
// 1.2 - 3.4.5 => >=1.2.0 <=3.4.5
// 1.2.3 - 3.4 => >=1.2.0 <3.5.0-0 Any 3.4.x will do
// 1.2 - 3.4 => >=1.2.0 <3.5.0-0
// TODO build?
const hyphenReplace = incPr => ($0,
  from, fM, fm, fp, fpr, fb,
  to, tM, tm, tp, tpr) => {
  if (isX(fM)) {
    from = ''
  } else if (isX(fm)) {
    from = `>=${fM}.0.0${incPr ? '-0' : ''}`
  } else if (isX(fp)) {
    from = `>=${fM}.${fm}.0${incPr ? '-0' : ''}`
  } else if (fpr) {
    from = `>=${from}`
  } else {
    from = `>=${from}${incPr ? '-0' : ''}`
  }

  if (isX(tM)) {
    to = ''
  } else if (isX(tm)) {
    to = `<${+tM + 1}.0.0-0`
  } else if (isX(tp)) {
    to = `<${tM}.${+tm + 1}.0-0`
  } else if (tpr) {
    to = `<=${tM}.${tm}.${tp}-${tpr}`
  } else if (incPr) {
    to = `<${tM}.${tm}.${+tp + 1}-0`
  } else {
    to = `<=${to}`
  }

  return `${from} ${to}`.trim()
}

const testSet = (set, version, options) => {
  for (let i = 0; i < set.length; i++) {
    if (!set[i].test(version)) {
      return false
    }
  }

  if (version.prerelease.length && !options.includePrerelease) {
    // Find the set of versions that are allowed to have prereleases
    // For example, ^1.2.3-pr.1 desugars to >=1.2.3-pr.1 <2.0.0
    // That should allow `1.2.3-pr.2` to pass.
    // However, `1.2.4-alpha.notready` should NOT be allowed,
    // even though it's within the range set by the comparators.
    for (let i = 0; i < set.length; i++) {
      debug(set[i].semver)
      if (set[i].semver === Comparator.ANY) {
        continue
      }

      if (set[i].semver.prerelease.length > 0) {
        const allowed = set[i].semver
        if (allowed.major === version.major &&
            allowed.minor === version.minor &&
            allowed.patch === version.patch) {
          return true
        }
      }
    }

    // Version has a -pre, but it's not one of the ones we like.
    return false
  }

  return true
}


/***/ }),

/***/ 3908:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const debug = __webpack_require__(7272)
const { MAX_LENGTH, MAX_SAFE_INTEGER } = __webpack_require__(6874)
const { safeRe: re, t } = __webpack_require__(9718)

const parseOptions = __webpack_require__(8587)
const { compareIdentifiers } = __webpack_require__(1123)
class SemVer {
  constructor (version, options) {
    options = parseOptions(options)

    if (version instanceof SemVer) {
      if (version.loose === !!options.loose &&
          version.includePrerelease === !!options.includePrerelease) {
        return version
      } else {
        version = version.version
      }
    } else if (typeof version !== 'string') {
      throw new TypeError(`Invalid version. Must be a string. Got type "${typeof version}".`)
    }

    if (version.length > MAX_LENGTH) {
      throw new TypeError(
        `version is longer than ${MAX_LENGTH} characters`
      )
    }

    debug('SemVer', version, options)
    this.options = options
    this.loose = !!options.loose
    // this isn't actually relevant for versions, but keep it so that we
    // don't run into trouble passing this.options around.
    this.includePrerelease = !!options.includePrerelease

    const m = version.trim().match(options.loose ? re[t.LOOSE] : re[t.FULL])

    if (!m) {
      throw new TypeError(`Invalid Version: ${version}`)
    }

    this.raw = version

    // these are actually numbers
    this.major = +m[1]
    this.minor = +m[2]
    this.patch = +m[3]

    if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
      throw new TypeError('Invalid major version')
    }

    if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
      throw new TypeError('Invalid minor version')
    }

    if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
      throw new TypeError('Invalid patch version')
    }

    // numberify any prerelease numeric ids
    if (!m[4]) {
      this.prerelease = []
    } else {
      this.prerelease = m[4].split('.').map((id) => {
        if (/^[0-9]+$/.test(id)) {
          const num = +id
          if (num >= 0 && num < MAX_SAFE_INTEGER) {
            return num
          }
        }
        return id
      })
    }

    this.build = m[5] ? m[5].split('.') : []
    this.format()
  }

  format () {
    this.version = `${this.major}.${this.minor}.${this.patch}`
    if (this.prerelease.length) {
      this.version += `-${this.prerelease.join('.')}`
    }
    return this.version
  }

  toString () {
    return this.version
  }

  compare (other) {
    debug('SemVer.compare', this.version, this.options, other)
    if (!(other instanceof SemVer)) {
      if (typeof other === 'string' && other === this.version) {
        return 0
      }
      other = new SemVer(other, this.options)
    }

    if (other.version === this.version) {
      return 0
    }

    return this.compareMain(other) || this.comparePre(other)
  }

  compareMain (other) {
    if (!(other instanceof SemVer)) {
      other = new SemVer(other, this.options)
    }

    return (
      compareIdentifiers(this.major, other.major) ||
      compareIdentifiers(this.minor, other.minor) ||
      compareIdentifiers(this.patch, other.patch)
    )
  }

  comparePre (other) {
    if (!(other instanceof SemVer)) {
      other = new SemVer(other, this.options)
    }

    // NOT having a prerelease is > having one
    if (this.prerelease.length && !other.prerelease.length) {
      return -1
    } else if (!this.prerelease.length && other.prerelease.length) {
      return 1
    } else if (!this.prerelease.length && !other.prerelease.length) {
      return 0
    }

    let i = 0
    do {
      const a = this.prerelease[i]
      const b = other.prerelease[i]
      debug('prerelease compare', i, a, b)
      if (a === undefined && b === undefined) {
        return 0
      } else if (b === undefined) {
        return 1
      } else if (a === undefined) {
        return -1
      } else if (a === b) {
        continue
      } else {
        return compareIdentifiers(a, b)
      }
    } while (++i)
  }

  compareBuild (other) {
    if (!(other instanceof SemVer)) {
      other = new SemVer(other, this.options)
    }

    let i = 0
    do {
      const a = this.build[i]
      const b = other.build[i]
      debug('build compare', i, a, b)
      if (a === undefined && b === undefined) {
        return 0
      } else if (b === undefined) {
        return 1
      } else if (a === undefined) {
        return -1
      } else if (a === b) {
        continue
      } else {
        return compareIdentifiers(a, b)
      }
    } while (++i)
  }

  // preminor will bump the version up to the next minor release, and immediately
  // down to pre-release. premajor and prepatch work the same way.
  inc (release, identifier, identifierBase) {
    switch (release) {
      case 'premajor':
        this.prerelease.length = 0
        this.patch = 0
        this.minor = 0
        this.major++
        this.inc('pre', identifier, identifierBase)
        break
      case 'preminor':
        this.prerelease.length = 0
        this.patch = 0
        this.minor++
        this.inc('pre', identifier, identifierBase)
        break
      case 'prepatch':
        // If this is already a prerelease, it will bump to the next version
        // drop any prereleases that might already exist, since they are not
        // relevant at this point.
        this.prerelease.length = 0
        this.inc('patch', identifier, identifierBase)
        this.inc('pre', identifier, identifierBase)
        break
      // If the input is a non-prerelease version, this acts the same as
      // prepatch.
      case 'prerelease':
        if (this.prerelease.length === 0) {
          this.inc('patch', identifier, identifierBase)
        }
        this.inc('pre', identifier, identifierBase)
        break

      case 'major':
        // If this is a pre-major version, bump up to the same major version.
        // Otherwise increment major.
        // 1.0.0-5 bumps to 1.0.0
        // 1.1.0 bumps to 2.0.0
        if (
          this.minor !== 0 ||
          this.patch !== 0 ||
          this.prerelease.length === 0
        ) {
          this.major++
        }
        this.minor = 0
        this.patch = 0
        this.prerelease = []
        break
      case 'minor':
        // If this is a pre-minor version, bump up to the same minor version.
        // Otherwise increment minor.
        // 1.2.0-5 bumps to 1.2.0
        // 1.2.1 bumps to 1.3.0
        if (this.patch !== 0 || this.prerelease.length === 0) {
          this.minor++
        }
        this.patch = 0
        this.prerelease = []
        break
      case 'patch':
        // If this is not a pre-release version, it will increment the patch.
        // If it is a pre-release it will bump up to the same patch version.
        // 1.2.0-5 patches to 1.2.0
        // 1.2.0 patches to 1.2.1
        if (this.prerelease.length === 0) {
          this.patch++
        }
        this.prerelease = []
        break
      // This probably shouldn't be used publicly.
      // 1.0.0 'pre' would become 1.0.0-0 which is the wrong direction.
      case 'pre': {
        const base = Number(identifierBase) ? 1 : 0

        if (!identifier && identifierBase === false) {
          throw new Error('invalid increment argument: identifier is empty')
        }

        if (this.prerelease.length === 0) {
          this.prerelease = [base]
        } else {
          let i = this.prerelease.length
          while (--i >= 0) {
            if (typeof this.prerelease[i] === 'number') {
              this.prerelease[i]++
              i = -2
            }
          }
          if (i === -1) {
            // didn't increment anything
            if (identifier === this.prerelease.join('.') && identifierBase === false) {
              throw new Error('invalid increment argument: identifier already exists')
            }
            this.prerelease.push(base)
          }
        }
        if (identifier) {
          // 1.2.0-beta.1 bumps to 1.2.0-beta.2,
          // 1.2.0-beta.fooblz or 1.2.0-beta bumps to 1.2.0-beta.0
          let prerelease = [identifier, base]
          if (identifierBase === false) {
            prerelease = [identifier]
          }
          if (compareIdentifiers(this.prerelease[0], identifier) === 0) {
            if (isNaN(this.prerelease[1])) {
              this.prerelease = prerelease
            }
          } else {
            this.prerelease = prerelease
          }
        }
        break
      }
      default:
        throw new Error(`invalid increment argument: ${release}`)
    }
    this.raw = this.format()
    if (this.build.length) {
      this.raw += `+${this.build.join('.')}`
    }
    return this
  }
}

module.exports = SemVer


/***/ }),

/***/ 7414:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const parse = __webpack_require__(144)
const clean = (version, options) => {
  const s = parse(version.trim().replace(/^[=v]+/, ''), options)
  return s ? s.version : null
}
module.exports = clean


/***/ }),

/***/ 2111:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const eq = __webpack_require__(4641)
const neq = __webpack_require__(3999)
const gt = __webpack_require__(5580)
const gte = __webpack_require__(4089)
const lt = __webpack_require__(7059)
const lte = __webpack_require__(5200)

const cmp = (a, op, b, loose) => {
  switch (op) {
    case '===':
      if (typeof a === 'object') {
        a = a.version
      }
      if (typeof b === 'object') {
        b = b.version
      }
      return a === b

    case '!==':
      if (typeof a === 'object') {
        a = a.version
      }
      if (typeof b === 'object') {
        b = b.version
      }
      return a !== b

    case '':
    case '=':
    case '==':
      return eq(a, b, loose)

    case '!=':
      return neq(a, b, loose)

    case '>':
      return gt(a, b, loose)

    case '>=':
      return gte(a, b, loose)

    case '<':
      return lt(a, b, loose)

    case '<=':
      return lte(a, b, loose)

    default:
      throw new TypeError(`Invalid operator: ${op}`)
  }
}
module.exports = cmp


/***/ }),

/***/ 6170:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const parse = __webpack_require__(144)
const { safeRe: re, t } = __webpack_require__(9718)

const coerce = (version, options) => {
  if (version instanceof SemVer) {
    return version
  }

  if (typeof version === 'number') {
    version = String(version)
  }

  if (typeof version !== 'string') {
    return null
  }

  options = options || {}

  let match = null
  if (!options.rtl) {
    match = version.match(options.includePrerelease ? re[t.COERCEFULL] : re[t.COERCE])
  } else {
    // Find the right-most coercible string that does not share
    // a terminus with a more left-ward coercible string.
    // Eg, '1.2.3.4' wants to coerce '2.3.4', not '3.4' or '4'
    // With includePrerelease option set, '1.2.3.4-rc' wants to coerce '2.3.4-rc', not '2.3.4'
    //
    // Walk through the string checking with a /g regexp
    // Manually set the index so as to pick up overlapping matches.
    // Stop when we get a match that ends at the string end, since no
    // coercible string can be more right-ward without the same terminus.
    const coerceRtlRegex = options.includePrerelease ? re[t.COERCERTLFULL] : re[t.COERCERTL]
    let next
    while ((next = coerceRtlRegex.exec(version)) &&
        (!match || match.index + match[0].length !== version.length)
    ) {
      if (!match ||
            next.index + next[0].length !== match.index + match[0].length) {
        match = next
      }
      coerceRtlRegex.lastIndex = next.index + next[1].length + next[2].length
    }
    // leave it in a clean state
    coerceRtlRegex.lastIndex = -1
  }

  if (match === null) {
    return null
  }

  const major = match[2]
  const minor = match[3] || '0'
  const patch = match[4] || '0'
  const prerelease = options.includePrerelease && match[5] ? `-${match[5]}` : ''
  const build = options.includePrerelease && match[6] ? `+${match[6]}` : ''

  return parse(`${major}.${minor}.${patch}${prerelease}${build}`, options)
}
module.exports = coerce


/***/ }),

/***/ 909:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const compareBuild = (a, b, loose) => {
  const versionA = new SemVer(a, loose)
  const versionB = new SemVer(b, loose)
  return versionA.compare(versionB) || versionA.compareBuild(versionB)
}
module.exports = compareBuild


/***/ }),

/***/ 1763:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compare = __webpack_require__(560)
const compareLoose = (a, b) => compare(a, b, true)
module.exports = compareLoose


/***/ }),

/***/ 560:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const compare = (a, b, loose) =>
  new SemVer(a, loose).compare(new SemVer(b, loose))

module.exports = compare


/***/ }),

/***/ 1832:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const parse = __webpack_require__(144)

const diff = (version1, version2) => {
  const v1 = parse(version1, null, true)
  const v2 = parse(version2, null, true)
  const comparison = v1.compare(v2)

  if (comparison === 0) {
    return null
  }

  const v1Higher = comparison > 0
  const highVersion = v1Higher ? v1 : v2
  const lowVersion = v1Higher ? v2 : v1
  const highHasPre = !!highVersion.prerelease.length
  const lowHasPre = !!lowVersion.prerelease.length

  if (lowHasPre && !highHasPre) {
    // Going from prerelease -> no prerelease requires some special casing

    // If the low version has only a major, then it will always be a major
    // Some examples:
    // 1.0.0-1 -> 1.0.0
    // 1.0.0-1 -> 1.1.1
    // 1.0.0-1 -> 2.0.0
    if (!lowVersion.patch && !lowVersion.minor) {
      return 'major'
    }

    // Otherwise it can be determined by checking the high version

    if (highVersion.patch) {
      // anything higher than a patch bump would result in the wrong version
      return 'patch'
    }

    if (highVersion.minor) {
      // anything higher than a minor bump would result in the wrong version
      return 'minor'
    }

    // bumping major/minor/patch all have same result
    return 'major'
  }

  // add the `pre` prefix if we are going to a prerelease version
  const prefix = highHasPre ? 'pre' : ''

  if (v1.major !== v2.major) {
    return prefix + 'major'
  }

  if (v1.minor !== v2.minor) {
    return prefix + 'minor'
  }

  if (v1.patch !== v2.patch) {
    return prefix + 'patch'
  }

  // high and low are preleases
  return 'prerelease'
}

module.exports = diff


/***/ }),

/***/ 4641:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compare = __webpack_require__(560)
const eq = (a, b, loose) => compare(a, b, loose) === 0
module.exports = eq


/***/ }),

/***/ 5580:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compare = __webpack_require__(560)
const gt = (a, b, loose) => compare(a, b, loose) > 0
module.exports = gt


/***/ }),

/***/ 4089:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compare = __webpack_require__(560)
const gte = (a, b, loose) => compare(a, b, loose) >= 0
module.exports = gte


/***/ }),

/***/ 3007:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)

const inc = (version, release, options, identifier, identifierBase) => {
  if (typeof (options) === 'string') {
    identifierBase = identifier
    identifier = options
    options = undefined
  }

  try {
    return new SemVer(
      version instanceof SemVer ? version.version : version,
      options
    ).inc(release, identifier, identifierBase).version
  } catch (er) {
    return null
  }
}
module.exports = inc


/***/ }),

/***/ 7059:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compare = __webpack_require__(560)
const lt = (a, b, loose) => compare(a, b, loose) < 0
module.exports = lt


/***/ }),

/***/ 5200:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compare = __webpack_require__(560)
const lte = (a, b, loose) => compare(a, b, loose) <= 0
module.exports = lte


/***/ }),

/***/ 2938:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const major = (a, loose) => new SemVer(a, loose).major
module.exports = major


/***/ }),

/***/ 6254:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const minor = (a, loose) => new SemVer(a, loose).minor
module.exports = minor


/***/ }),

/***/ 3999:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compare = __webpack_require__(560)
const neq = (a, b, loose) => compare(a, b, loose) !== 0
module.exports = neq


/***/ }),

/***/ 144:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const parse = (version, options, throwErrors = false) => {
  if (version instanceof SemVer) {
    return version
  }
  try {
    return new SemVer(version, options)
  } catch (er) {
    if (!throwErrors) {
      return null
    }
    throw er
  }
}

module.exports = parse


/***/ }),

/***/ 4493:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const patch = (a, loose) => new SemVer(a, loose).patch
module.exports = patch


/***/ }),

/***/ 1729:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const parse = __webpack_require__(144)
const prerelease = (version, options) => {
  const parsed = parse(version, options)
  return (parsed && parsed.prerelease.length) ? parsed.prerelease : null
}
module.exports = prerelease


/***/ }),

/***/ 9970:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compare = __webpack_require__(560)
const rcompare = (a, b, loose) => compare(b, a, loose)
module.exports = rcompare


/***/ }),

/***/ 4277:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compareBuild = __webpack_require__(909)
const rsort = (list, loose) => list.sort((a, b) => compareBuild(b, a, loose))
module.exports = rsort


/***/ }),

/***/ 7638:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const Range = __webpack_require__(8311)
const satisfies = (version, range, options) => {
  try {
    range = new Range(range, options)
  } catch (er) {
    return false
  }
  return range.test(version)
}
module.exports = satisfies


/***/ }),

/***/ 3927:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const compareBuild = __webpack_require__(909)
const sort = (list, loose) => list.sort((a, b) => compareBuild(a, b, loose))
module.exports = sort


/***/ }),

/***/ 6953:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const parse = __webpack_require__(144)
const valid = (version, options) => {
  const v = parse(version, options)
  return v ? v.version : null
}
module.exports = valid


/***/ }),

/***/ 9589:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// just pre-load all the stuff that index.js lazily exports
const internalRe = __webpack_require__(9718)
const constants = __webpack_require__(6874)
const SemVer = __webpack_require__(3908)
const identifiers = __webpack_require__(1123)
const parse = __webpack_require__(144)
const valid = __webpack_require__(6953)
const clean = __webpack_require__(7414)
const inc = __webpack_require__(3007)
const diff = __webpack_require__(1832)
const major = __webpack_require__(2938)
const minor = __webpack_require__(6254)
const patch = __webpack_require__(4493)
const prerelease = __webpack_require__(1729)
const compare = __webpack_require__(560)
const rcompare = __webpack_require__(9970)
const compareLoose = __webpack_require__(1763)
const compareBuild = __webpack_require__(909)
const sort = __webpack_require__(3927)
const rsort = __webpack_require__(4277)
const gt = __webpack_require__(5580)
const lt = __webpack_require__(7059)
const eq = __webpack_require__(4641)
const neq = __webpack_require__(3999)
const gte = __webpack_require__(4089)
const lte = __webpack_require__(5200)
const cmp = __webpack_require__(2111)
const coerce = __webpack_require__(6170)
const Comparator = __webpack_require__(3904)
const Range = __webpack_require__(8311)
const satisfies = __webpack_require__(7638)
const toComparators = __webpack_require__(7631)
const maxSatisfying = __webpack_require__(9628)
const minSatisfying = __webpack_require__(270)
const minVersion = __webpack_require__(1261)
const validRange = __webpack_require__(3874)
const outside = __webpack_require__(7075)
const gtr = __webpack_require__(5571)
const ltr = __webpack_require__(5342)
const intersects = __webpack_require__(6780)
const simplifyRange = __webpack_require__(2525)
const subset = __webpack_require__(5032)
module.exports = {
  parse,
  valid,
  clean,
  inc,
  diff,
  major,
  minor,
  patch,
  prerelease,
  compare,
  rcompare,
  compareLoose,
  compareBuild,
  sort,
  rsort,
  gt,
  lt,
  eq,
  neq,
  gte,
  lte,
  cmp,
  coerce,
  Comparator,
  Range,
  satisfies,
  toComparators,
  maxSatisfying,
  minSatisfying,
  minVersion,
  validRange,
  outside,
  gtr,
  ltr,
  intersects,
  simplifyRange,
  subset,
  SemVer,
  re: internalRe.re,
  src: internalRe.src,
  tokens: internalRe.t,
  SEMVER_SPEC_VERSION: constants.SEMVER_SPEC_VERSION,
  RELEASE_TYPES: constants.RELEASE_TYPES,
  compareIdentifiers: identifiers.compareIdentifiers,
  rcompareIdentifiers: identifiers.rcompareIdentifiers,
}


/***/ }),

/***/ 6874:
/***/ ((module) => {

// Note: this is the semver.org version of the spec that it implements
// Not necessarily the package version of this code.
const SEMVER_SPEC_VERSION = '2.0.0'

const MAX_LENGTH = 256
const MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER ||
/* istanbul ignore next */ 9007199254740991

// Max safe segment length for coercion.
const MAX_SAFE_COMPONENT_LENGTH = 16

// Max safe length for a build identifier. The max length minus 6 characters for
// the shortest version with a build 0.0.0+BUILD.
const MAX_SAFE_BUILD_LENGTH = MAX_LENGTH - 6

const RELEASE_TYPES = [
  'major',
  'premajor',
  'minor',
  'preminor',
  'patch',
  'prepatch',
  'prerelease',
]

module.exports = {
  MAX_LENGTH,
  MAX_SAFE_COMPONENT_LENGTH,
  MAX_SAFE_BUILD_LENGTH,
  MAX_SAFE_INTEGER,
  RELEASE_TYPES,
  SEMVER_SPEC_VERSION,
  FLAG_INCLUDE_PRERELEASE: 0b001,
  FLAG_LOOSE: 0b010,
}


/***/ }),

/***/ 7272:
/***/ ((module) => {

const debug = (
  typeof process === 'object' &&
  ({"NODE_ENV":"production"}) &&
  ({"NODE_ENV":"production"}).NODE_DEBUG &&
  /\bsemver\b/i.test(({"NODE_ENV":"production"}).NODE_DEBUG)
) ? (...args) => console.error('SEMVER', ...args)
  : () => {}

module.exports = debug


/***/ }),

/***/ 1123:
/***/ ((module) => {

const numeric = /^[0-9]+$/
const compareIdentifiers = (a, b) => {
  const anum = numeric.test(a)
  const bnum = numeric.test(b)

  if (anum && bnum) {
    a = +a
    b = +b
  }

  return a === b ? 0
    : (anum && !bnum) ? -1
    : (bnum && !anum) ? 1
    : a < b ? -1
    : 1
}

const rcompareIdentifiers = (a, b) => compareIdentifiers(b, a)

module.exports = {
  compareIdentifiers,
  rcompareIdentifiers,
}


/***/ }),

/***/ 8794:
/***/ ((module) => {

class LRUCache {
  constructor () {
    this.max = 1000
    this.map = new Map()
  }

  get (key) {
    const value = this.map.get(key)
    if (value === undefined) {
      return undefined
    } else {
      // Remove the key from the map and add it to the end
      this.map.delete(key)
      this.map.set(key, value)
      return value
    }
  }

  delete (key) {
    return this.map.delete(key)
  }

  set (key, value) {
    const deleted = this.delete(key)

    if (!deleted && value !== undefined) {
      // If cache is full, delete the least recently used item
      if (this.map.size >= this.max) {
        const firstKey = this.map.keys().next().value
        this.delete(firstKey)
      }

      this.map.set(key, value)
    }

    return this
  }
}

module.exports = LRUCache


/***/ }),

/***/ 8587:
/***/ ((module) => {

// parse out just the options we care about
const looseOption = Object.freeze({ loose: true })
const emptyOpts = Object.freeze({ })
const parseOptions = options => {
  if (!options) {
    return emptyOpts
  }

  if (typeof options !== 'object') {
    return looseOption
  }

  return options
}
module.exports = parseOptions


/***/ }),

/***/ 9718:
/***/ ((module, exports, __webpack_require__) => {

const {
  MAX_SAFE_COMPONENT_LENGTH,
  MAX_SAFE_BUILD_LENGTH,
  MAX_LENGTH,
} = __webpack_require__(6874)
const debug = __webpack_require__(7272)
exports = module.exports = {}

// The actual regexps go on exports.re
const re = exports.re = []
const safeRe = exports.safeRe = []
const src = exports.src = []
const t = exports.t = {}
let R = 0

const LETTERDASHNUMBER = '[a-zA-Z0-9-]'

// Replace some greedy regex tokens to prevent regex dos issues. These regex are
// used internally via the safeRe object since all inputs in this library get
// normalized first to trim and collapse all extra whitespace. The original
// regexes are exported for userland consumption and lower level usage. A
// future breaking change could export the safer regex only with a note that
// all input should have extra whitespace removed.
const safeRegexReplacements = [
  ['\\s', 1],
  ['\\d', MAX_LENGTH],
  [LETTERDASHNUMBER, MAX_SAFE_BUILD_LENGTH],
]

const makeSafeRegex = (value) => {
  for (const [token, max] of safeRegexReplacements) {
    value = value
      .split(`${token}*`).join(`${token}{0,${max}}`)
      .split(`${token}+`).join(`${token}{1,${max}}`)
  }
  return value
}

const createToken = (name, value, isGlobal) => {
  const safe = makeSafeRegex(value)
  const index = R++
  debug(name, index, value)
  t[name] = index
  src[index] = value
  re[index] = new RegExp(value, isGlobal ? 'g' : undefined)
  safeRe[index] = new RegExp(safe, isGlobal ? 'g' : undefined)
}

// The following Regular Expressions can be used for tokenizing,
// validating, and parsing SemVer version strings.

// ## Numeric Identifier
// A single `0`, or a non-zero digit followed by zero or more digits.

createToken('NUMERICIDENTIFIER', '0|[1-9]\\d*')
createToken('NUMERICIDENTIFIERLOOSE', '\\d+')

// ## Non-numeric Identifier
// Zero or more digits, followed by a letter or hyphen, and then zero or
// more letters, digits, or hyphens.

createToken('NONNUMERICIDENTIFIER', `\\d*[a-zA-Z-]${LETTERDASHNUMBER}*`)

// ## Main Version
// Three dot-separated numeric identifiers.

createToken('MAINVERSION', `(${src[t.NUMERICIDENTIFIER]})\\.` +
                   `(${src[t.NUMERICIDENTIFIER]})\\.` +
                   `(${src[t.NUMERICIDENTIFIER]})`)

createToken('MAINVERSIONLOOSE', `(${src[t.NUMERICIDENTIFIERLOOSE]})\\.` +
                        `(${src[t.NUMERICIDENTIFIERLOOSE]})\\.` +
                        `(${src[t.NUMERICIDENTIFIERLOOSE]})`)

// ## Pre-release Version Identifier
// A numeric identifier, or a non-numeric identifier.

createToken('PRERELEASEIDENTIFIER', `(?:${src[t.NUMERICIDENTIFIER]
}|${src[t.NONNUMERICIDENTIFIER]})`)

createToken('PRERELEASEIDENTIFIERLOOSE', `(?:${src[t.NUMERICIDENTIFIERLOOSE]
}|${src[t.NONNUMERICIDENTIFIER]})`)

// ## Pre-release Version
// Hyphen, followed by one or more dot-separated pre-release version
// identifiers.

createToken('PRERELEASE', `(?:-(${src[t.PRERELEASEIDENTIFIER]
}(?:\\.${src[t.PRERELEASEIDENTIFIER]})*))`)

createToken('PRERELEASELOOSE', `(?:-?(${src[t.PRERELEASEIDENTIFIERLOOSE]
}(?:\\.${src[t.PRERELEASEIDENTIFIERLOOSE]})*))`)

// ## Build Metadata Identifier
// Any combination of digits, letters, or hyphens.

createToken('BUILDIDENTIFIER', `${LETTERDASHNUMBER}+`)

// ## Build Metadata
// Plus sign, followed by one or more period-separated build metadata
// identifiers.

createToken('BUILD', `(?:\\+(${src[t.BUILDIDENTIFIER]
}(?:\\.${src[t.BUILDIDENTIFIER]})*))`)

// ## Full Version String
// A main version, followed optionally by a pre-release version and
// build metadata.

// Note that the only major, minor, patch, and pre-release sections of
// the version string are capturing groups.  The build metadata is not a
// capturing group, because it should not ever be used in version
// comparison.

createToken('FULLPLAIN', `v?${src[t.MAINVERSION]
}${src[t.PRERELEASE]}?${
  src[t.BUILD]}?`)

createToken('FULL', `^${src[t.FULLPLAIN]}$`)

// like full, but allows v1.2.3 and =1.2.3, which people do sometimes.
// also, 1.0.0alpha1 (prerelease without the hyphen) which is pretty
// common in the npm registry.
createToken('LOOSEPLAIN', `[v=\\s]*${src[t.MAINVERSIONLOOSE]
}${src[t.PRERELEASELOOSE]}?${
  src[t.BUILD]}?`)

createToken('LOOSE', `^${src[t.LOOSEPLAIN]}$`)

createToken('GTLT', '((?:<|>)?=?)')

// Something like "2.*" or "1.2.x".
// Note that "x.x" is a valid xRange identifer, meaning "any version"
// Only the first item is strictly required.
createToken('XRANGEIDENTIFIERLOOSE', `${src[t.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`)
createToken('XRANGEIDENTIFIER', `${src[t.NUMERICIDENTIFIER]}|x|X|\\*`)

createToken('XRANGEPLAIN', `[v=\\s]*(${src[t.XRANGEIDENTIFIER]})` +
                   `(?:\\.(${src[t.XRANGEIDENTIFIER]})` +
                   `(?:\\.(${src[t.XRANGEIDENTIFIER]})` +
                   `(?:${src[t.PRERELEASE]})?${
                     src[t.BUILD]}?` +
                   `)?)?`)

createToken('XRANGEPLAINLOOSE', `[v=\\s]*(${src[t.XRANGEIDENTIFIERLOOSE]})` +
                        `(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})` +
                        `(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})` +
                        `(?:${src[t.PRERELEASELOOSE]})?${
                          src[t.BUILD]}?` +
                        `)?)?`)

createToken('XRANGE', `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAIN]}$`)
createToken('XRANGELOOSE', `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAINLOOSE]}$`)

// Coercion.
// Extract anything that could conceivably be a part of a valid semver
createToken('COERCEPLAIN', `${'(^|[^\\d])' +
              '(\\d{1,'}${MAX_SAFE_COMPONENT_LENGTH}})` +
              `(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?` +
              `(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?`)
createToken('COERCE', `${src[t.COERCEPLAIN]}(?:$|[^\\d])`)
createToken('COERCEFULL', src[t.COERCEPLAIN] +
              `(?:${src[t.PRERELEASE]})?` +
              `(?:${src[t.BUILD]})?` +
              `(?:$|[^\\d])`)
createToken('COERCERTL', src[t.COERCE], true)
createToken('COERCERTLFULL', src[t.COERCEFULL], true)

// Tilde ranges.
// Meaning is "reasonably at or greater than"
createToken('LONETILDE', '(?:~>?)')

createToken('TILDETRIM', `(\\s*)${src[t.LONETILDE]}\\s+`, true)
exports.tildeTrimReplace = '$1~'

createToken('TILDE', `^${src[t.LONETILDE]}${src[t.XRANGEPLAIN]}$`)
createToken('TILDELOOSE', `^${src[t.LONETILDE]}${src[t.XRANGEPLAINLOOSE]}$`)

// Caret ranges.
// Meaning is "at least and backwards compatible with"
createToken('LONECARET', '(?:\\^)')

createToken('CARETTRIM', `(\\s*)${src[t.LONECARET]}\\s+`, true)
exports.caretTrimReplace = '$1^'

createToken('CARET', `^${src[t.LONECARET]}${src[t.XRANGEPLAIN]}$`)
createToken('CARETLOOSE', `^${src[t.LONECARET]}${src[t.XRANGEPLAINLOOSE]}$`)

// A simple gt/lt/eq thing, or just "" to indicate "any version"
createToken('COMPARATORLOOSE', `^${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]})$|^$`)
createToken('COMPARATOR', `^${src[t.GTLT]}\\s*(${src[t.FULLPLAIN]})$|^$`)

// An expression to strip any whitespace between the gtlt and the thing
// it modifies, so that `> 1.2.3` ==> `>1.2.3`
createToken('COMPARATORTRIM', `(\\s*)${src[t.GTLT]
}\\s*(${src[t.LOOSEPLAIN]}|${src[t.XRANGEPLAIN]})`, true)
exports.comparatorTrimReplace = '$1$2$3'

// Something like `1.2.3 - 1.2.4`
// Note that these all use the loose form, because they'll be
// checked against either the strict or loose comparator form
// later.
createToken('HYPHENRANGE', `^\\s*(${src[t.XRANGEPLAIN]})` +
                   `\\s+-\\s+` +
                   `(${src[t.XRANGEPLAIN]})` +
                   `\\s*$`)

createToken('HYPHENRANGELOOSE', `^\\s*(${src[t.XRANGEPLAINLOOSE]})` +
                        `\\s+-\\s+` +
                        `(${src[t.XRANGEPLAINLOOSE]})` +
                        `\\s*$`)

// Star ranges basically just allow anything at all.
createToken('STAR', '(<|>)?=?\\s*\\*')
// >=0.0.0 is like a star
createToken('GTE0', '^\\s*>=\\s*0\\.0\\.0\\s*$')
createToken('GTE0PRE', '^\\s*>=\\s*0\\.0\\.0-0\\s*$')


/***/ }),

/***/ 5571:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// Determine if version is greater than all the versions possible in the range.
const outside = __webpack_require__(7075)
const gtr = (version, range, options) => outside(version, range, '>', options)
module.exports = gtr


/***/ }),

/***/ 6780:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const Range = __webpack_require__(8311)
const intersects = (r1, r2, options) => {
  r1 = new Range(r1, options)
  r2 = new Range(r2, options)
  return r1.intersects(r2, options)
}
module.exports = intersects


/***/ }),

/***/ 5342:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const outside = __webpack_require__(7075)
// Determine if version is less than all the versions possible in the range
const ltr = (version, range, options) => outside(version, range, '<', options)
module.exports = ltr


/***/ }),

/***/ 9628:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const Range = __webpack_require__(8311)

const maxSatisfying = (versions, range, options) => {
  let max = null
  let maxSV = null
  let rangeObj = null
  try {
    rangeObj = new Range(range, options)
  } catch (er) {
    return null
  }
  versions.forEach((v) => {
    if (rangeObj.test(v)) {
      // satisfies(v, range, options)
      if (!max || maxSV.compare(v) === -1) {
        // compare(max, v, true)
        max = v
        maxSV = new SemVer(max, options)
      }
    }
  })
  return max
}
module.exports = maxSatisfying


/***/ }),

/***/ 270:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const Range = __webpack_require__(8311)
const minSatisfying = (versions, range, options) => {
  let min = null
  let minSV = null
  let rangeObj = null
  try {
    rangeObj = new Range(range, options)
  } catch (er) {
    return null
  }
  versions.forEach((v) => {
    if (rangeObj.test(v)) {
      // satisfies(v, range, options)
      if (!min || minSV.compare(v) === 1) {
        // compare(min, v, true)
        min = v
        minSV = new SemVer(min, options)
      }
    }
  })
  return min
}
module.exports = minSatisfying


/***/ }),

/***/ 1261:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const Range = __webpack_require__(8311)
const gt = __webpack_require__(5580)

const minVersion = (range, loose) => {
  range = new Range(range, loose)

  let minver = new SemVer('0.0.0')
  if (range.test(minver)) {
    return minver
  }

  minver = new SemVer('0.0.0-0')
  if (range.test(minver)) {
    return minver
  }

  minver = null
  for (let i = 0; i < range.set.length; ++i) {
    const comparators = range.set[i]

    let setMin = null
    comparators.forEach((comparator) => {
      // Clone to avoid manipulating the comparator's semver object.
      const compver = new SemVer(comparator.semver.version)
      switch (comparator.operator) {
        case '>':
          if (compver.prerelease.length === 0) {
            compver.patch++
          } else {
            compver.prerelease.push(0)
          }
          compver.raw = compver.format()
          /* fallthrough */
        case '':
        case '>=':
          if (!setMin || gt(compver, setMin)) {
            setMin = compver
          }
          break
        case '<':
        case '<=':
          /* Ignore maximum versions */
          break
        /* istanbul ignore next */
        default:
          throw new Error(`Unexpected operation: ${comparator.operator}`)
      }
    })
    if (setMin && (!minver || gt(minver, setMin))) {
      minver = setMin
    }
  }

  if (minver && range.test(minver)) {
    return minver
  }

  return null
}
module.exports = minVersion


/***/ }),

/***/ 7075:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const SemVer = __webpack_require__(3908)
const Comparator = __webpack_require__(3904)
const { ANY } = Comparator
const Range = __webpack_require__(8311)
const satisfies = __webpack_require__(7638)
const gt = __webpack_require__(5580)
const lt = __webpack_require__(7059)
const lte = __webpack_require__(5200)
const gte = __webpack_require__(4089)

const outside = (version, range, hilo, options) => {
  version = new SemVer(version, options)
  range = new Range(range, options)

  let gtfn, ltefn, ltfn, comp, ecomp
  switch (hilo) {
    case '>':
      gtfn = gt
      ltefn = lte
      ltfn = lt
      comp = '>'
      ecomp = '>='
      break
    case '<':
      gtfn = lt
      ltefn = gte
      ltfn = gt
      comp = '<'
      ecomp = '<='
      break
    default:
      throw new TypeError('Must provide a hilo val of "<" or ">"')
  }

  // If it satisfies the range it is not outside
  if (satisfies(version, range, options)) {
    return false
  }

  // From now on, variable terms are as if we're in "gtr" mode.
  // but note that everything is flipped for the "ltr" function.

  for (let i = 0; i < range.set.length; ++i) {
    const comparators = range.set[i]

    let high = null
    let low = null

    comparators.forEach((comparator) => {
      if (comparator.semver === ANY) {
        comparator = new Comparator('>=0.0.0')
      }
      high = high || comparator
      low = low || comparator
      if (gtfn(comparator.semver, high.semver, options)) {
        high = comparator
      } else if (ltfn(comparator.semver, low.semver, options)) {
        low = comparator
      }
    })

    // If the edge version comparator has a operator then our version
    // isn't outside it
    if (high.operator === comp || high.operator === ecomp) {
      return false
    }

    // If the lowest version comparator has an operator and our version
    // is less than it then it isn't higher than the range
    if ((!low.operator || low.operator === comp) &&
        ltefn(version, low.semver)) {
      return false
    } else if (low.operator === ecomp && ltfn(version, low.semver)) {
      return false
    }
  }
  return true
}

module.exports = outside


/***/ }),

/***/ 2525:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// given a set of versions and a range, create a "simplified" range
// that includes the same versions that the original range does
// If the original range is shorter than the simplified one, return that.
const satisfies = __webpack_require__(7638)
const compare = __webpack_require__(560)
module.exports = (versions, range, options) => {
  const set = []
  let first = null
  let prev = null
  const v = versions.sort((a, b) => compare(a, b, options))
  for (const version of v) {
    const included = satisfies(version, range, options)
    if (included) {
      prev = version
      if (!first) {
        first = version
      }
    } else {
      if (prev) {
        set.push([first, prev])
      }
      prev = null
      first = null
    }
  }
  if (first) {
    set.push([first, null])
  }

  const ranges = []
  for (const [min, max] of set) {
    if (min === max) {
      ranges.push(min)
    } else if (!max && min === v[0]) {
      ranges.push('*')
    } else if (!max) {
      ranges.push(`>=${min}`)
    } else if (min === v[0]) {
      ranges.push(`<=${max}`)
    } else {
      ranges.push(`${min} - ${max}`)
    }
  }
  const simplified = ranges.join(' || ')
  const original = typeof range.raw === 'string' ? range.raw : String(range)
  return simplified.length < original.length ? simplified : range
}


/***/ }),

/***/ 5032:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const Range = __webpack_require__(8311)
const Comparator = __webpack_require__(3904)
const { ANY } = Comparator
const satisfies = __webpack_require__(7638)
const compare = __webpack_require__(560)

// Complex range `r1 || r2 || ...` is a subset of `R1 || R2 || ...` iff:
// - Every simple range `r1, r2, ...` is a null set, OR
// - Every simple range `r1, r2, ...` which is not a null set is a subset of
//   some `R1, R2, ...`
//
// Simple range `c1 c2 ...` is a subset of simple range `C1 C2 ...` iff:
// - If c is only the ANY comparator
//   - If C is only the ANY comparator, return true
//   - Else if in prerelease mode, return false
//   - else replace c with `[>=0.0.0]`
// - If C is only the ANY comparator
//   - if in prerelease mode, return true
//   - else replace C with `[>=0.0.0]`
// - Let EQ be the set of = comparators in c
// - If EQ is more than one, return true (null set)
// - Let GT be the highest > or >= comparator in c
// - Let LT be the lowest < or <= comparator in c
// - If GT and LT, and GT.semver > LT.semver, return true (null set)
// - If any C is a = range, and GT or LT are set, return false
// - If EQ
//   - If GT, and EQ does not satisfy GT, return true (null set)
//   - If LT, and EQ does not satisfy LT, return true (null set)
//   - If EQ satisfies every C, return true
//   - Else return false
// - If GT
//   - If GT.semver is lower than any > or >= comp in C, return false
//   - If GT is >=, and GT.semver does not satisfy every C, return false
//   - If GT.semver has a prerelease, and not in prerelease mode
//     - If no C has a prerelease and the GT.semver tuple, return false
// - If LT
//   - If LT.semver is greater than any < or <= comp in C, return false
//   - If LT is <=, and LT.semver does not satisfy every C, return false
//   - If GT.semver has a prerelease, and not in prerelease mode
//     - If no C has a prerelease and the LT.semver tuple, return false
// - Else return true

const subset = (sub, dom, options = {}) => {
  if (sub === dom) {
    return true
  }

  sub = new Range(sub, options)
  dom = new Range(dom, options)
  let sawNonNull = false

  OUTER: for (const simpleSub of sub.set) {
    for (const simpleDom of dom.set) {
      const isSub = simpleSubset(simpleSub, simpleDom, options)
      sawNonNull = sawNonNull || isSub !== null
      if (isSub) {
        continue OUTER
      }
    }
    // the null set is a subset of everything, but null simple ranges in
    // a complex range should be ignored.  so if we saw a non-null range,
    // then we know this isn't a subset, but if EVERY simple range was null,
    // then it is a subset.
    if (sawNonNull) {
      return false
    }
  }
  return true
}

const minimumVersionWithPreRelease = [new Comparator('>=0.0.0-0')]
const minimumVersion = [new Comparator('>=0.0.0')]

const simpleSubset = (sub, dom, options) => {
  if (sub === dom) {
    return true
  }

  if (sub.length === 1 && sub[0].semver === ANY) {
    if (dom.length === 1 && dom[0].semver === ANY) {
      return true
    } else if (options.includePrerelease) {
      sub = minimumVersionWithPreRelease
    } else {
      sub = minimumVersion
    }
  }

  if (dom.length === 1 && dom[0].semver === ANY) {
    if (options.includePrerelease) {
      return true
    } else {
      dom = minimumVersion
    }
  }

  const eqSet = new Set()
  let gt, lt
  for (const c of sub) {
    if (c.operator === '>' || c.operator === '>=') {
      gt = higherGT(gt, c, options)
    } else if (c.operator === '<' || c.operator === '<=') {
      lt = lowerLT(lt, c, options)
    } else {
      eqSet.add(c.semver)
    }
  }

  if (eqSet.size > 1) {
    return null
  }

  let gtltComp
  if (gt && lt) {
    gtltComp = compare(gt.semver, lt.semver, options)
    if (gtltComp > 0) {
      return null
    } else if (gtltComp === 0 && (gt.operator !== '>=' || lt.operator !== '<=')) {
      return null
    }
  }

  // will iterate one or zero times
  for (const eq of eqSet) {
    if (gt && !satisfies(eq, String(gt), options)) {
      return null
    }

    if (lt && !satisfies(eq, String(lt), options)) {
      return null
    }

    for (const c of dom) {
      if (!satisfies(eq, String(c), options)) {
        return false
      }
    }

    return true
  }

  let higher, lower
  let hasDomLT, hasDomGT
  // if the subset has a prerelease, we need a comparator in the superset
  // with the same tuple and a prerelease, or it's not a subset
  let needDomLTPre = lt &&
    !options.includePrerelease &&
    lt.semver.prerelease.length ? lt.semver : false
  let needDomGTPre = gt &&
    !options.includePrerelease &&
    gt.semver.prerelease.length ? gt.semver : false
  // exception: <1.2.3-0 is the same as <1.2.3
  if (needDomLTPre && needDomLTPre.prerelease.length === 1 &&
      lt.operator === '<' && needDomLTPre.prerelease[0] === 0) {
    needDomLTPre = false
  }

  for (const c of dom) {
    hasDomGT = hasDomGT || c.operator === '>' || c.operator === '>='
    hasDomLT = hasDomLT || c.operator === '<' || c.operator === '<='
    if (gt) {
      if (needDomGTPre) {
        if (c.semver.prerelease && c.semver.prerelease.length &&
            c.semver.major === needDomGTPre.major &&
            c.semver.minor === needDomGTPre.minor &&
            c.semver.patch === needDomGTPre.patch) {
          needDomGTPre = false
        }
      }
      if (c.operator === '>' || c.operator === '>=') {
        higher = higherGT(gt, c, options)
        if (higher === c && higher !== gt) {
          return false
        }
      } else if (gt.operator === '>=' && !satisfies(gt.semver, String(c), options)) {
        return false
      }
    }
    if (lt) {
      if (needDomLTPre) {
        if (c.semver.prerelease && c.semver.prerelease.length &&
            c.semver.major === needDomLTPre.major &&
            c.semver.minor === needDomLTPre.minor &&
            c.semver.patch === needDomLTPre.patch) {
          needDomLTPre = false
        }
      }
      if (c.operator === '<' || c.operator === '<=') {
        lower = lowerLT(lt, c, options)
        if (lower === c && lower !== lt) {
          return false
        }
      } else if (lt.operator === '<=' && !satisfies(lt.semver, String(c), options)) {
        return false
      }
    }
    if (!c.operator && (lt || gt) && gtltComp !== 0) {
      return false
    }
  }

  // if there was a < or >, and nothing in the dom, then must be false
  // UNLESS it was limited by another range in the other direction.
  // Eg, >1.0.0 <1.0.1 is still a subset of <2.0.0
  if (gt && hasDomLT && !lt && gtltComp !== 0) {
    return false
  }

  if (lt && hasDomGT && !gt && gtltComp !== 0) {
    return false
  }

  // we needed a prerelease range in a specific tuple, but didn't get one
  // then this isn't a subset.  eg >=1.2.3-pre is not a subset of >=1.0.0,
  // because it includes prereleases in the 1.2.3 tuple
  if (needDomGTPre || needDomLTPre) {
    return false
  }

  return true
}

// >=1.2.3 is lower than >1.2.3
const higherGT = (a, b, options) => {
  if (!a) {
    return b
  }
  const comp = compare(a.semver, b.semver, options)
  return comp > 0 ? a
    : comp < 0 ? b
    : b.operator === '>' && a.operator === '>=' ? b
    : a
}

// <=1.2.3 is higher than <1.2.3
const lowerLT = (a, b, options) => {
  if (!a) {
    return b
  }
  const comp = compare(a.semver, b.semver, options)
  return comp < 0 ? a
    : comp > 0 ? b
    : b.operator === '<' && a.operator === '<=' ? b
    : a
}

module.exports = subset


/***/ }),

/***/ 7631:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const Range = __webpack_require__(8311)

// Mostly just for testing and legacy API reasons
const toComparators = (range, options) =>
  new Range(range, options).set
    .map(comp => comp.map(c => c.value).join(' ').trim().split(' '))

module.exports = toComparators


/***/ }),

/***/ 3874:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

const Range = __webpack_require__(8311)
const validRange = (range, options) => {
  try {
    // Return '*' instead of '' so that truthiness works.
    // This will throw if it's invalid anyway
    return new Range(range, options).range || '*'
  } catch (er) {
    return null
  }
}
module.exports = validRange


/***/ }),

/***/ 7687:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

const os = __webpack_require__(857);
const tty = __webpack_require__(2018);
const hasFlag = __webpack_require__(5884);

const {env} = process;

let forceColor;
if (hasFlag('no-color') ||
	hasFlag('no-colors') ||
	hasFlag('color=false') ||
	hasFlag('color=never')) {
	forceColor = 0;
} else if (hasFlag('color') ||
	hasFlag('colors') ||
	hasFlag('color=true') ||
	hasFlag('color=always')) {
	forceColor = 1;
}

if ('FORCE_COLOR' in env) {
	if (env.FORCE_COLOR === 'true') {
		forceColor = 1;
	} else if (env.FORCE_COLOR === 'false') {
		forceColor = 0;
	} else {
		forceColor = env.FORCE_COLOR.length === 0 ? 1 : Math.min(parseInt(env.FORCE_COLOR, 10), 3);
	}
}

function translateLevel(level) {
	if (level === 0) {
		return false;
	}

	return {
		level,
		hasBasic: true,
		has256: level >= 2,
		has16m: level >= 3
	};
}

function supportsColor(haveStream, streamIsTTY) {
	if (forceColor === 0) {
		return 0;
	}

	if (hasFlag('color=16m') ||
		hasFlag('color=full') ||
		hasFlag('color=truecolor')) {
		return 3;
	}

	if (hasFlag('color=256')) {
		return 2;
	}

	if (haveStream && !streamIsTTY && forceColor === undefined) {
		return 0;
	}

	const min = forceColor || 0;

	if (env.TERM === 'dumb') {
		return min;
	}

	if (process.platform === 'win32') {
		// Windows 10 build 10586 is the first Windows release that supports 256 colors.
		// Windows 10 build 14931 is the first release that supports 16m/TrueColor.
		const osRelease = os.release().split('.');
		if (
			Number(osRelease[0]) >= 10 &&
			Number(osRelease[2]) >= 10586
		) {
			return Number(osRelease[2]) >= 14931 ? 3 : 2;
		}

		return 1;
	}

	if ('CI' in env) {
		if (['TRAVIS', 'CIRCLECI', 'APPVEYOR', 'GITLAB_CI', 'GITHUB_ACTIONS', 'BUILDKITE'].some(sign => sign in env) || env.CI_NAME === 'codeship') {
			return 1;
		}

		return min;
	}

	if ('TEAMCITY_VERSION' in env) {
		return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
	}

	if (env.COLORTERM === 'truecolor') {
		return 3;
	}

	if ('TERM_PROGRAM' in env) {
		const version = parseInt((env.TERM_PROGRAM_VERSION || '').split('.')[0], 10);

		switch (env.TERM_PROGRAM) {
			case 'iTerm.app':
				return version >= 3 ? 3 : 2;
			case 'Apple_Terminal':
				return 2;
			// No default
		}
	}

	if (/-256(color)?$/i.test(env.TERM)) {
		return 2;
	}

	if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
		return 1;
	}

	if ('COLORTERM' in env) {
		return 1;
	}

	return min;
}

function getSupportLevel(stream) {
	const level = supportsColor(stream, stream && stream.isTTY);
	return translateLevel(level);
}

module.exports = {
	supportsColor: getSupportLevel,
	stdout: translateLevel(supportsColor(true, tty.isatty(1))),
	stderr: translateLevel(supportsColor(true, tty.isatty(2)))
};


/***/ }),

/***/ 1055:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// NAMESPACE OBJECT: ./src/main/modules/sync/client/modules/list/index.ts
var modules_list_namespaceObject = {};
__webpack_require__.r(modules_list_namespaceObject);
__webpack_require__.d(modules_list_namespaceObject, {
  handler: () => (list_handler),
  registerEvent: () => (registerEvent),
  unregisterEvent: () => (unregisterEvent)
});

// NAMESPACE OBJECT: ./src/main/modules/sync/client/modules/dislike/index.ts
var modules_dislike_namespaceObject = {};
__webpack_require__.r(modules_dislike_namespaceObject);
__webpack_require__.d(modules_dislike_namespaceObject, {
  handler: () => (dislike_handler),
  registerEvent: () => (localEvent_registerEvent),
  unregisterEvent: () => (localEvent_unregisterEvent)
});

// NAMESPACE OBJECT: ./src/main/modules/sync/server/modules/list/sync/index.ts
var list_sync_namespaceObject = {};
__webpack_require__.r(list_sync_namespaceObject);
__webpack_require__.d(list_sync_namespaceObject, {
  handler: () => (list_sync_handler),
  registerEvent: () => (sync_localEvent_registerEvent),
  sync: () => (sync),
  unregisterEvent: () => (sync_localEvent_unregisterEvent)
});

// NAMESPACE OBJECT: ./src/main/modules/sync/server/modules/dislike/sync/index.ts
var dislike_sync_namespaceObject = {};
__webpack_require__.r(dislike_sync_namespaceObject);
__webpack_require__.d(dislike_sync_namespaceObject, {
  handler: () => (dislike_sync_handler),
  registerEvent: () => (dislike_sync_localEvent_registerEvent),
  sync: () => (sync_sync),
  unregisterEvent: () => (dislike_sync_localEvent_unregisterEvent)
});

// EXTERNAL MODULE: external "electron"
var external_electron_ = __webpack_require__(4157);
// EXTERNAL MODULE: ./node_modules/electron-log/node.js
var node = __webpack_require__(894);
var node_default = /*#__PURE__*/__webpack_require__.n(node);
;// CONCATENATED MODULE: ./src/main/utils/logInit.ts

(node_default()).transports.file.level = 'info';
// log.initialize()

;// CONCATENATED MODULE: ./src/common/utils/common.ts
// 非业务工具方法
/**
 * 获取两个数之间的随机整数，大于等于min，小于max
 * @param {*} min
 * @param {*} max
 */
const getRandom = (min, max) => Math.floor(Math.random() * (max - min)) + min;
const sizeFormate = (size) => {
    // https://gist.github.com/thomseddon/3511330
    if (!size)
        return '0 B';
    let units = ['B', 'KB', 'MB', 'GB', 'TB'];
    let number = Math.floor(Math.log(size) / Math.log(1024));
    return `${(size / Math.pow(1024, Math.floor(number))).toFixed(2)} ${units[number]}`;
};
/**
 * 将字符串、时间戳等格式转成时间对象
 * @param date 时间
 * @returns 时间对象或空字符串
 */
const toDateObj = (date) => {
    // console.log(date)
    if (!date)
        return '';
    switch (typeof date) {
        case 'string':
            if (!date.includes('T'))
                date = date.split('.')[0].replace(/-/g, '/');
        // eslint-disable-next-line no-fallthrough
        case 'number':
            date = new Date(date);
        // eslint-disable-next-line no-fallthrough
        case 'object':
            break;
        default: return '';
    }
    return date;
};
const numFix = (n) => n < 10 ? (`0${n}`) : n.toString();
/**
 * 时间格式化
 * @param _date 时间
 * @param format Y-M-D h:m:s Y年 M月 D日 h时 m分 s秒
 */
const dateFormat = (_date, format = 'Y-M-D h:m:s') => {
    // console.log(date)
    const date = toDateObj(_date);
    if (!date)
        return '';
    return format
        .replace('Y', date.getFullYear().toString())
        .replace('M', numFix(date.getMonth() + 1))
        .replace('D', numFix(date.getDate()))
        .replace('h', numFix(date.getHours()))
        .replace('m', numFix(date.getMinutes()))
        .replace('s', numFix(date.getSeconds()));
};
const formatPlayTime = (time) => {
    let m = Math.trunc(time / 60);
    let s = Math.trunc(time % 60);
    return m == 0 && s == 0 ? '--/--' : numFix(m) + ':' + numFix(s);
};
const formatPlayTime2 = (time) => {
    let m = Math.trunc(time / 60);
    let s = Math.trunc(time % 60);
    return numFix(m) + ':' + numFix(s);
};
const encodeNames = {
    '&nbsp;': ' ',
    '&amp;': '&',
    '&lt;': '<',
    '&gt;': '>',
    '&quot;': '"',
    '&apos;': "'",
    '&#039;': "'",
};
const decodeName = (str = '') => {
    return str?.replace(/(?:&amp;|&lt;|&gt;|&quot;|&apos;|&#039;|&nbsp;)/gm, (s) => encodeNames[s]) ?? '';
};
const isUrl = (path) => /https?:\/\//.test(path);
// 解析URL参数为对象
const parseUrlParams = (str) => {
    const params = {};
    if (typeof str !== 'string')
        return params;
    const paramsArr = str.split('&');
    for (const param of paramsArr) {
        let [key, value] = param.split('=');
        params[key] = value;
    }
    return params;
};
/**
 * 生成节流函数
 * @param fn 回调
 * @param delay 延迟
 * @returns
 */
function throttle(fn, delay = 100) {
    let timer = null;
    let _args;
    return (...args) => {
        _args = args;
        if (timer)
            return;
        timer = setTimeout(() => {
            timer = null;
            void fn(..._args);
        }, delay);
    };
}
/**
 * 生成防抖函数
 * @param fn 回调
 * @param delay 延迟
 * @returns
 */
function debounce(fn, delay = 100) {
    let timer = null;
    let _args;
    return (...args) => {
        _args = args;
        if (timer)
            clearTimeout(timer);
        timer = setTimeout(() => {
            timer = null;
            void fn(..._args);
        }, delay);
    };
}
const fileNameRxp = /[\\/:*?#"<>|]/g;
const common_filterFileName = (name) => name.replace(fileNameRxp, '');
// https://blog.csdn.net/xcxy2015/article/details/77164126#comments
/**
 *
 * @param a
 * @param b
 */
const similar = (a, b) => {
    if (!a || !b)
        return 0;
    if (a.length > b.length) { // 保证 a <= b
        let t = b;
        b = a;
        a = t;
    }
    let al = a.length;
    let bl = b.length;
    let mp = []; // 一个表
    let i, j, ai, lt, tmp; // ai：字符串a的第i个字符。 lt：左上角的值。 tmp：暂存新的值。
    for (i = 0; i <= bl; i++)
        mp[i] = i;
    for (i = 1; i <= al; i++) {
        ai = a.charAt(i - 1);
        lt = mp[0];
        mp[0] = mp[0] + 1;
        for (j = 1; j <= bl; j++) {
            tmp = Math.min(mp[j] + 1, mp[j - 1] + 1, lt + (ai == b.charAt(j - 1) ? 0 : 1));
            lt = mp[j];
            mp[j] = tmp;
        }
    }
    return 1 - (mp[bl] / bl);
};
/**
 * 排序字符串
 * @param arr
 * @param data
 */
const sortInsert = (arr, data) => {
    let key = data.num;
    let left = 0;
    let right = arr.length - 1;
    while (left <= right) {
        let middle = Math.trunc((left + right) / 2);
        if (key == arr[middle].num) {
            left = middle;
            break;
        }
        else if (key < arr[middle].num) {
            right = middle - 1;
        }
        else {
            left = middle + 1;
        }
    }
    while (left > 0) {
        if (arr[left - 1].num != key)
            break;
        left--;
    }
    arr.splice(left, 0, data);
};
const encodePath = (path) => {
    return encodeURI(path.replaceAll('\\', '/'));
};
const arrPush = (list, newList) => {
    for (let i = 0; i * 1000 < newList.length; i++) {
        list.push(...newList.slice(i * 1000, (i + 1) * 1000));
    }
    return list;
};
const arrUnshift = (list, newList) => {
    for (let i = 0; i * 1000 < newList.length; i++) {
        list.splice(i * 1000, 0, ...newList.slice(i * 1000, (i + 1) * 1000));
    }
    return list;
};
const arrPushByPosition = (list, newList, position) => {
    for (let i = 0; i * 1000 < newList.length; i++) {
        list.splice(position + i * 1000, 0, ...newList.slice(i * 1000, (i + 1) * 1000));
    }
    return list;
};
// https://stackoverflow.com/a/2450976
const arrShuffle = (array) => {
    let currentIndex = array.length;
    let randomIndex;
    // While there remain elements to shuffle.
    while (currentIndex != 0) {
        // Pick a remaining element.
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex--;
        // And swap it with the current element.
        [array[currentIndex], array[randomIndex]] = [
            array[randomIndex], array[currentIndex]
        ];
    }
    return array;
};

;// CONCATENATED MODULE: ./src/common/utils/index.ts

const isLinux = process.platform == 'linux';
const isWin = process.platform == 'win32';
const isMac = process.platform == 'darwin';
const isProd = (/* unused pure expression or super */ null && ("production" == 'production'));
// https://stackoverflow.com/a/53387532
function compareVer(currentVer, targetVer) {
    // treat non-numerical characters as lower version
    // replacing them with a negative number based on charcode of each character
    const fix = (s) => `.${s.toLowerCase().charCodeAt(0) - 2147483647}.`;
    const currentVerArr = ('' + currentVer).replace(/[^0-9.]/g, fix).split('.');
    const targetVerArr = ('' + targetVer).replace(/[^0-9.]/g, fix).split('.');
    let c = Math.max(currentVerArr.length, targetVerArr.length);
    for (let i = 0; i < c; i++) {
        // convert to integer the most efficient way
        currentVerArr[i] = ~~currentVerArr[i];
        targetVerArr[i] = ~~targetVerArr[i];
        if (currentVerArr[i] > targetVerArr[i])
            return 1;
        else if (currentVerArr[i] < targetVerArr[i])
            return -1;
    }
    return 0;
}



;// CONCATENATED MODULE: ./src/common/error.ts

const ignoreErrorMessage = [
    'Possible side-effect in debug-evaluate',
    'Unexpected end of input',
];
process.on('uncaughtException', err => {
    if (ignoreErrorMessage.includes(err?.message))
        return;
    console.error('An uncaught error occurred!');
    console.error(err);
    node_default().error(err);
});
process.on('unhandledRejection', (reason, p) => {
    console.error('Unhandled Rejection at: Promise ', p);
    console.error(' reason: ', reason);
    node_default().error(reason);
});

;// CONCATENATED MODULE: external "node:path"
const external_node_path_namespaceObject = require("node:path");
var external_node_path_default = /*#__PURE__*/__webpack_require__.n(external_node_path_namespaceObject);
// EXTERNAL MODULE: external "fs"
var external_fs_ = __webpack_require__(9896);
var external_fs_default = /*#__PURE__*/__webpack_require__.n(external_fs_);
;// CONCATENATED MODULE: ./src/common/constants.ts
const URL_SCHEME_RXP = /^lxmusic:\/\//;
const SPLIT_CHAR = {
    DISLIKE_NAME: '@',
    DISLIKE_NAME_ALIAS: '#',
};
const STORE_NAMES = {
    APP_SETTINGS: 'config_v2',
    DATA: 'data',
    SYNC: 'sync',
    HOTKEY: 'hot_key',
    USER_API: 'user_api',
    LRC_RAW: 'lyrics',
    LRC_EDITED: 'lyrics_edited',
    THEME: 'theme',
    SOUND_EFFECT: 'sound_effect',
};
const APP_EVENT_NAMES = {
    winMainName: 'win_main',
    winLyricName: 'win_lyric',
    trayName: 'tray',
};
const LIST_IDS = {
    DEFAULT: 'default',
    LOVE: 'love',
    TEMP: 'temp',
    DOWNLOAD: 'download',
    PLAY_LATER: null,
};
const DATA_KEYS = {
    viewPrevState: 'viewPrevState',
    playInfo: 'playInfo',
    searchHistoryList: 'searchHistoryList',
    listScrollPosition: 'listScrollPosition',
    listPrevSelectId: 'listPrevSelectId',
    listUpdateInfo: 'listUpdateInfo',
    ignoreVersion: 'ignoreVersion',
    leaderboardSetting: 'leaderboardSetting',
    songListSetting: 'songListSetting',
    searchSetting: 'searchSetting',
    lastStartInfo: 'lastStartInfo',
};
const DEFAULT_SETTING = {
    leaderboard: {
        source: 'kw',
        boardId: 'kw__16',
    },
    songList: {
        source: 'kw',
        sortId: 'new',
        tagId: '',
    },
    search: {
        temp_source: 'kw',
        source: 'all',
        type: 'music',
    },
    viewPrevState: {
        url: '/search',
        query: {},
    },
};
const DOWNLOAD_STATUS = {
    RUN: 'run',
    WAITING: 'waiting',
    PAUSE: 'pause',
    ERROR: 'error',
    COMPLETED: 'completed',
};
const QUALITYS = (/* unused pure expression or super */ null && (['flac24bit', 'flac', 'wav', 'ape', '320k', '192k', '128k']));

;// CONCATENATED MODULE: ./src/common/utils/migrateSetting.ts

const oldThemeMap = {
    0: 'green',
    1: 'blue',
    2: 'yellow',
    3: 'orange',
    4: 'red',
    10: 'pink',
    5: 'purple',
    6: 'grey',
    11: 'ming',
    12: 'blue2',
    13: 'black',
    7: 'mid_autumn',
    8: 'naruto',
    9: 'happy_new_year',
};
/* harmony default export */ const migrateSetting = ((setting) => {
    setting = { ...setting };
    // 迁移 v2.0.0 之前的配置
    if (compareVer(setting.version, '2.0.0') < 0) {
        // 迁移列表滚动位置设置 ~0.18.3
        if (setting.list?.scroll) {
            let scroll = setting.list.scroll;
            setting.list.isSaveScrollLocation &&= scroll.enable;
            delete setting.list.scroll;
        }
        // 修正拼写问题 v1.8.2 及以前
        if (setting.player?.isShowLyricTransition != null) {
            setting.player.isShowLyricTranslation = setting.player.isShowLyricTransition;
            delete setting.player.isShowLyricTransition;
        }
        // 迁移v1.19.0之前的主题设置
        if (setting.themeId != null) {
            setting.theme = {
                id: setting.themeId,
            };
            delete setting.themeId;
        }
        if (setting.tray?.isShow != null)
            setting.tray.enable = setting.tray?.isShow;
        setting['common.windowSizeId'] = setting.windowSizeId;
        setting['common.startInFullscreen'] = setting.startInFullscreen;
        setting['common.langId'] = setting.langId;
        setting['common.apiSource'] = setting.apiSource;
        setting['common.sourceNameType'] = setting.sourceNameType;
        setting['common.font'] = setting.font;
        setting['common.isShowAnimation'] = setting.isShowAnimation;
        setting['common.randomAnimate'] = setting.randomAnimate;
        setting['common.isAgreePact'] = setting.isAgreePact;
        setting['common.controlBtnPosition'] = setting.controlBtnPosition;
        setting['player.togglePlayMethod'] = setting.player?.togglePlayMethod;
        setting['player.isShowTaskProgess'] = setting.player?.isShowTaskProgess;
        setting['player.volume'] = setting.player?.volume;
        setting['player.isMute'] = setting.player?.isMute;
        setting['player.mediaDeviceId'] = setting.player?.mediaDeviceId;
        setting['player.isMediaDeviceRemovedStopPlay'] = setting.player?.isMediaDeviceRemovedStopPlay;
        setting['player.isShowLyricTranslation'] = setting.player?.isShowLyricTranslation;
        setting['player.isShowLyricRoma'] = setting.player?.isShowLyricRoma;
        setting['player.isS2t'] = setting.player?.isS2t;
        setting['player.isPlayLxlrc'] = setting.player?.isPlayLxlrc;
        setting['player.isSavePlayTime'] = setting.player?.isSavePlayTime;
        setting['player.audioVisualization'] = setting.player?.audioVisualization;
        setting['player.waitPlayEndStop'] = setting.player?.waitPlayEndStop;
        setting['player.waitPlayEndStopTime'] = setting.player?.waitPlayEndStopTime;
        setting['player.autoSkipOnError'] = setting.player?.autoSkipOnError;
        setting['playDetail.isZoomActiveLrc'] = setting.playDetail?.isZoomActiveLrc;
        setting['playDetail.isShowLyricProgressSetting'] = setting.playDetail?.isShowLyricProgressSetting;
        setting['playDetail.style.fontSize'] = setting.playDetail?.style?.fontSize;
        setting['playDetail.style.align'] = setting.playDetail?.style?.align;
        setting['desktopLyric.enable'] = setting.desktopLyric?.enable;
        setting['desktopLyric.isLock'] = setting.desktopLyric?.isLock;
        setting['desktopLyric.isAlwaysOnTop'] = setting.desktopLyric?.isAlwaysOnTop;
        setting['desktopLyric.isAlwaysOnTopLoop'] = setting.desktopLyric?.isAlwaysOnTopLoop;
        setting['desktopLyric.width'] = setting.desktopLyric?.width;
        setting['desktopLyric.height'] = setting.desktopLyric?.height;
        setting['desktopLyric.x'] = setting.desktopLyric?.x;
        setting['desktopLyric.y'] = setting.desktopLyric?.y;
        setting['desktopLyric.isLockScreen'] = setting.desktopLyric?.isLockScreen;
        setting['desktopLyric.isDelayScroll'] = setting.desktopLyric?.isDelayScroll;
        setting['desktopLyric.isHoverHide'] = setting.desktopLyric?.isHoverHide;
        setting['desktopLyric.style.font'] = setting.desktopLyric?.style?.font;
        if (setting.desktopLyric?.style?.fontSize)
            setting['desktopLyric.style.fontSize'] = setting.desktopLyric.style.fontSize / 100 * 16;
        setting['desktopLyric.style.opacity'] = setting.desktopLyric?.style?.opacity;
        setting['desktopLyric.style.isZoomActiveLrc'] = setting.desktopLyric?.style?.isZoomActiveLrc;
        setting['list.isClickPlayList'] = setting.list?.isClickPlayList;
        setting['list.isShowAlbumName'] = setting.list?.isShowAlbumName;
        setting['list.isShowSource'] = setting.list?.isShowSource;
        setting['list.isSaveScrollLocation'] = setting.list?.isSaveScrollLocation;
        setting['list.addMusicLocationType'] = setting.list?.addMusicLocationType;
        setting['download.enable'] = setting.download?.enable;
        setting['download.savePath'] = setting.download?.savePath;
        setting['download.fileName'] = setting.download?.fileName;
        setting['download.maxDownloadNum'] = setting.download?.maxDownloadNum;
        setting['download.isDownloadLrc'] = setting.download?.isDownloadLrc;
        setting['download.lrcFormat'] = setting.download?.lrcFormat;
        setting['download.isEmbedPic'] = setting.download?.isEmbedPic;
        setting['download.isEmbedLyric'] = setting.download?.isEmbedLyric;
        setting['download.isUseOtherSource'] = setting.download?.isUseOtherSource;
        setting['search.isShowHotSearch'] = setting.search?.isShowHotSearch;
        setting['search.isShowHistorySearch'] = setting.search?.isShowHistorySearch;
        setting['search.isFocusSearchBox'] = setting.search?.isFocusSearchBox;
        setting['network.proxy.enable'] = setting.network?.proxy?.enable;
        setting['network.proxy.host'] = setting.network?.proxy?.host;
        setting['network.proxy.port'] = setting.network?.proxy?.port;
        setting['tray.enable'] = setting.tray?.enable;
        setting['tray.themeId'] = setting.tray?.themeId;
        setting['sync.enable'] = setting.sync?.enable;
        setting['sync.port'] = setting.sync?.port;
        setting['theme.id'] = oldThemeMap[setting.theme?.id];
        setting['theme.lightId'] = oldThemeMap[setting.theme?.lightId];
        setting['theme.darkId'] = oldThemeMap[setting.theme?.darkId];
        setting['odc.isAutoClearSearchInput'] = setting.odc?.isAutoClearSearchInput;
        setting['odc.isAutoClearSearchList'] = setting.odc?.isAutoClearSearchList;
        setting.version = '2.0.0';
    }
    // 迁移 v2.2.0 之前的设置数据
    if (compareVer(setting.version, '2.1.0') < 0) {
        setting['sync.erver.port'] = setting['sync.port'];
        setting.version = '2.1.0';
    }
    return setting;
});

;// CONCATENATED MODULE: external "node:fs"
const external_node_fs_namespaceObject = require("node:fs");
var external_node_fs_default = /*#__PURE__*/__webpack_require__.n(external_node_fs_namespaceObject);
;// CONCATENATED MODULE: ./src/main/utils/store.ts
// import { writeFileSync } from 'atomically'




const stores = {};
class Store {
    filePath;
    dirPath;
    store;
    writeFile() {
        const tempPath = this.filePath + '.' + Math.random().toString().substring(2, 10) + '.temp';
        try {
            external_node_fs_default().writeFileSync(tempPath, JSON.stringify(this.store, null, '\t'), 'utf8');
        }
        catch (err) {
            if (err.code === 'ENOENT') {
                external_node_fs_default().mkdirSync(this.dirPath, { recursive: true });
                external_node_fs_default().writeFileSync(tempPath, JSON.stringify(this.store, null, '\t'), 'utf8');
            }
            else
                throw err;
        }
        external_node_fs_default().renameSync(tempPath, this.filePath);
    }
    constructor(filePath, clearInvalidConfig = false) {
        this.filePath = filePath;
        this.dirPath = external_node_path_default().dirname(this.filePath);
        let store;
        if (external_node_fs_default().existsSync(this.filePath)) {
            if (clearInvalidConfig) {
                try {
                    store = JSON.parse(external_node_fs_default().readFileSync(this.filePath, 'utf8'));
                }
                catch {
                    store = {};
                }
            }
            else
                store = JSON.parse(external_node_fs_default().readFileSync(this.filePath, 'utf8'));
        }
        else
            store = {};
        if (typeof store != 'object') {
            if (clearInvalidConfig)
                store = {};
            else
                throw new Error('parse data error: ' + String(store));
        }
        this.store = store;
    }
    get(key) {
        return this.store[key];
    }
    has(key) {
        return key in this.store;
    }
    set(key, value) {
        this.store[key] = value;
        this.writeFile();
    }
    override(value) {
        this.store = value;
        this.writeFile();
    }
}
/**
 * 获取 Store 对象
 * @param name store 名
 * @param isIgnoredError 是否忽略错误
 * @param isShowErrorAlert=true 是否显示错误弹窗
 * @returns Store
 */
/* harmony default export */ const store = ((name, isIgnoredError = true, isShowErrorAlert = true) => {
    if (stores[name])
        return stores[name];
    let store;
    const storePath = external_node_path_default().join(global.lxDataPath, name + '.json');
    try {
        store = stores[name] = new Store(storePath, false);
    }
    catch (err) {
        const error = err;
        node_default().error(error);
        if (!isIgnoredError)
            throw error;
        const backPath = storePath + '.bak';
        external_node_fs_default().renameSync(storePath, backPath);
        if (isShowErrorAlert) {
            external_electron_.dialog.showMessageBoxSync({
                type: 'error',
                message: name + ' data load error',
                detail: `We have helped you back up the old ${name} file to: ${backPath}\nYou can try to repair and restore it manually\n\nError detail: ${error.message}`,
            });
            external_electron_.shell.showItemInFolder(backPath);
        }
        store = new Store(storePath, true);
    }
    return store;
});


;// CONCATENATED MODULE: external "node:os"
const external_node_os_namespaceObject = require("node:os");
var external_node_os_default = /*#__PURE__*/__webpack_require__.n(external_node_os_namespaceObject);
;// CONCATENATED MODULE: ./src/common/defaultSetting.ts


const defaultSetting_isMac = process.platform == 'darwin';
const defaultSetting_isWin = process.platform == 'win32';
const defaultSetting = {
    version: '2.1.0',
    'common.windowSizeId': 3,
    'common.fontSize': 16,
    'common.startInFullscreen': false,
    'common.langId': null,
    'common.apiSource': 'temp',
    'common.sourceNameType': 'alias',
    'common.font': '',
    'common.isShowAnimation': true,
    'common.randomAnimate': true,
    'common.isAgreePact': false,
    'common.controlBtnPosition': defaultSetting_isMac ? 'left' : 'right',
    'common.playBarProgressStyle': 'mini',
    'common.tryAutoUpdate': false,
    'common.showChangeLog': true,
    'player.startupAutoPlay': false,
    'player.togglePlayMethod': 'listLoop',
    'player.playQuality': '128k',
    'player.isShowTaskProgess': true,
    'player.volume': 1,
    'player.powerSaveBlocker': true,
    'player.isMute': false,
    'player.playbackRate': 1,
    'player.preservesPitch': true,
    'player.isMaxOutputChannelCount': false,
    'player.mediaDeviceId': 'default',
    'player.isMediaDeviceRemovedStopPlay': false,
    'player.isShowLyricTranslation': false,
    'player.isShowLyricRoma': false,
    'player.isS2t': false,
    'player.isPlayLxlrc': !defaultSetting_isMac,
    'player.isSavePlayTime': false,
    'player.audioVisualization': false,
    'player.waitPlayEndStop': true,
    'player.waitPlayEndStopTime': '',
    'player.autoSkipOnError': true,
    'player.isAutoCleanPlayedList': false,
    'player.soundEffect.convolution.fileName': '',
    'player.soundEffect.convolution.mainGain': 10,
    'player.soundEffect.convolution.sendGain': 0,
    'player.soundEffect.biquadFilter.hz31': 0,
    'player.soundEffect.biquadFilter.hz62': 0,
    'player.soundEffect.biquadFilter.hz125': 0,
    'player.soundEffect.biquadFilter.hz250': 0,
    'player.soundEffect.biquadFilter.hz500': 0,
    'player.soundEffect.biquadFilter.hz1000': 0,
    'player.soundEffect.biquadFilter.hz2000': 0,
    'player.soundEffect.biquadFilter.hz4000': 0,
    'player.soundEffect.biquadFilter.hz8000': 0,
    'player.soundEffect.biquadFilter.hz16000': 0,
    'player.soundEffect.panner.enable': false,
    'player.soundEffect.panner.soundR': 5,
    'player.soundEffect.panner.speed': 25,
    'player.soundEffect.pitchShifter.playbackRate': 1,
    'playDetail.isZoomActiveLrc': false,
    'playDetail.isShowLyricProgressSetting': false,
    'playDetail.style.fontSize': 140,
    'playDetail.style.align': 'center',
    'desktopLyric.enable': false,
    'desktopLyric.isLock': false,
    'desktopLyric.isAlwaysOnTop': false,
    'desktopLyric.isAlwaysOnTopLoop': false,
    'desktopLyric.isShowTaskbar': false,
    'desktopLyric.audioVisualization': false,
    'desktopLyric.fullscreenHide': true,
    'desktopLyric.width': 450,
    'desktopLyric.height': 300,
    'desktopLyric.x': null,
    'desktopLyric.y': null,
    'desktopLyric.isLockScreen': defaultSetting_isWin,
    'desktopLyric.isDelayScroll': true,
    'desktopLyric.scrollAlign': 'center',
    'desktopLyric.isHoverHide': false,
    'desktopLyric.direction': 'horizontal',
    'desktopLyric.style.align': 'center',
    'desktopLyric.style.font': '',
    'desktopLyric.style.fontSize': 20,
    'desktopLyric.style.lineGap': 15,
    'desktopLyric.style.lyricUnplayColor': 'rgba(255, 255, 255, 1)',
    'desktopLyric.style.lyricPlayedColor': 'rgba(7, 197, 86, 1)',
    'desktopLyric.style.lyricShadowColor': 'rgba(0, 0, 0, 0.18)',
    // 'desktopLyric.style.fontWeight': false,
    'desktopLyric.style.opacity': 95,
    'desktopLyric.style.ellipsis': false,
    'desktopLyric.style.isZoomActiveLrc': false,
    'desktopLyric.style.isFontWeightFont': true,
    'desktopLyric.style.isFontWeightLine': true,
    'desktopLyric.style.isFontWeightExtended': true,
    'list.isClickPlayList': false,
    'list.isShowSource': true,
    'list.isSaveScrollLocation': true,
    'list.addMusicLocationType': 'top',
    'list.actionButtonsVisible': false,
    'download.enable': false,
    'download.savePath': external_node_path_default().join(external_node_os_default().homedir(), 'Desktop'),
    'download.fileName': '歌名 - 歌手',
    'download.maxDownloadNum': 3,
    'download.skipExistFile': true,
    'download.isDownloadLrc': false,
    'download.isDownloadTLrc': false,
    'download.isDownloadRLrc': false,
    'download.lrcFormat': 'utf8',
    'download.isEmbedPic': true,
    'download.isEmbedLyric': false,
    'download.isEmbedLyricT': false,
    'download.isEmbedLyricR': false,
    'download.isUseOtherSource': false,
    'search.isShowHotSearch': false,
    'search.isShowHistorySearch': false,
    'search.isFocusSearchBox': false,
    'network.proxy.enable': false,
    'network.proxy.host': '',
    'network.proxy.port': '',
    'tray.enable': false,
    // 'tray.isToTray': false,
    'tray.themeId': 0,
    'sync.mode': 'server',
    'sync.enable': false,
    'sync.server.port': '23332',
    'sync.server.maxSsnapshotNum': 5,
    'sync.client.host': '',
    'openAPI.enable': false,
    'openAPI.port': '23330',
    'openAPI.bindLan': false,
    // 'theme.id': 'blue_plus',
    'theme.id': 'green',
    'theme.lightId': 'green',
    'theme.darkId': 'black',
    'odc.isAutoClearSearchInput': false,
    'odc.isAutoClearSearchList': false,
};
// 使用新年皮肤
if (new Date().getMonth() < 2) {
    defaultSetting['theme.id'] = 'happy_new_year';
    defaultSetting['desktopLyric.style.lyricPlayedColor'] = 'rgba(255, 57, 71, 1)';
}
/* harmony default export */ const common_defaultSetting = (defaultSetting);

;// CONCATENATED MODULE: ./src/common/hotKey.ts

const keyName = {
    common: APP_EVENT_NAMES.winMainName,
    player: APP_EVENT_NAMES.winMainName,
    desktop_lyric: APP_EVENT_NAMES.winLyricName,
};
const hotKey = {
    common: {
        min: {
            name: 'min',
            action: 'min',
            type: '',
        },
        min_toggle: {
            name: 'toggle_min',
            action: 'toggle_min',
            type: '',
        },
        hide_toggle: {
            name: 'toggle_hide',
            action: 'toggle_hide',
            type: '',
        },
        close: {
            name: 'toggle_close',
            action: 'toggle_close',
            type: '',
        },
        focusSearchInput: {
            name: 'focus_search_input',
            action: 'focus_search_input',
            type: '',
        },
    },
    player: {
        toggle_play: {
            name: 'toggle_play',
            action: 'toggle_play',
            type: '',
        },
        next: {
            name: 'next',
            action: 'next',
            type: '',
        },
        prev: {
            name: 'prev',
            action: 'prev',
            type: '',
        },
        volume_up: {
            name: 'volume_up',
            action: 'volume_up',
            type: '',
        },
        volume_down: {
            name: 'volume_down',
            action: 'volume_down',
            type: '',
        },
        volume_mute: {
            name: 'volume_mute',
            action: 'volume_mute',
            type: '',
        },
        music_love: {
            name: 'music_love',
            action: 'music_love',
            type: '',
        },
        music_unlove: {
            name: 'music_unlove',
            action: 'music_unlove',
            type: '',
        },
        music_dislike: {
            name: 'music_dislike',
            action: 'music_dislike',
            type: '',
        },
    },
    desktop_lyric: {
        toggle_visible: {
            name: 'toggle_visible',
            action: 'toggle_visible',
            type: '',
        },
        toggle_lock: {
            name: 'toggle_lock',
            action: 'toggle_lock',
            type: '',
        },
        toggle_always_top: {
            name: 'toggle_always_top',
            action: 'toggle_always_top',
            type: '',
        },
    },
};
for (const type of Object.keys(hotKey)) {
    let keys = hotKey[type];
    for (const key of Object.keys(keys)) {
        const keyInfo = keys[key];
        keyInfo.action = `${type}_${keyInfo.action}`;
        keyInfo.name = `${type}_${keyInfo.name}`;
        keyInfo.type = keyName[type];
    }
}
const HOTKEY_COMMON = hotKey.common;
const HOTKEY_PLAYER = hotKey.player;
const HOTKEY_DESKTOP_LYRIC = hotKey.desktop_lyric;

;// CONCATENATED MODULE: ./src/common/defaultHotKey.ts

const local = {
    enable: true,
    keys: {
        'mod+f5': {
            type: HOTKEY_PLAYER.toggle_play.type,
            name: HOTKEY_PLAYER.toggle_play.name,
            action: HOTKEY_PLAYER.toggle_play.action,
        },
        'mod+arrowleft': {
            type: HOTKEY_PLAYER.prev.type,
            name: HOTKEY_PLAYER.prev.name,
            action: HOTKEY_PLAYER.prev.action,
        },
        'mod+arrowright': {
            type: HOTKEY_PLAYER.next.type,
            name: HOTKEY_PLAYER.next.name,
            action: HOTKEY_PLAYER.next.action,
        },
        f1: {
            type: HOTKEY_COMMON.focusSearchInput.type,
            name: HOTKEY_COMMON.focusSearchInput.name,
            action: HOTKEY_COMMON.focusSearchInput.action,
        },
    },
};
const defaultHotKey_global = {
    enable: false,
    keys: {
        // MediaPlayPause: {
        //   type: HOTKEY_PLAYER.toggle_play.type,
        //   name: '',
        //   action: HOTKEY_PLAYER.toggle_play.action,
        // },
        // MediaPreviousTrack: {
        //   type: HOTKEY_PLAYER.prev.type,
        //   name: '',
        //   action: HOTKEY_PLAYER.prev.action,
        // },
        // MediaNextTrack: {
        //   type: HOTKEY_PLAYER.next.type,
        //   name: '',
        //   action: HOTKEY_PLAYER.next.action,
        // },
        'mod+alt+f5': {
            type: HOTKEY_PLAYER.toggle_play.type,
            name: HOTKEY_PLAYER.toggle_play.name,
            action: HOTKEY_PLAYER.toggle_play.action,
        },
        'mod+alt+arrowleft': {
            type: HOTKEY_PLAYER.prev.type,
            name: HOTKEY_PLAYER.prev.name,
            action: HOTKEY_PLAYER.prev.action,
        },
        'mod+alt+arrowright': {
            type: HOTKEY_PLAYER.next.type,
            name: HOTKEY_PLAYER.next.name,
            action: HOTKEY_PLAYER.next.action,
        },
        'mod+alt+arrowup': {
            type: HOTKEY_PLAYER.volume_up.type,
            name: HOTKEY_PLAYER.volume_up.name,
            action: HOTKEY_PLAYER.volume_up.action,
        },
        'mod+alt+arrowdown': {
            type: HOTKEY_PLAYER.volume_down.type,
            name: HOTKEY_PLAYER.volume_down.name,
            action: HOTKEY_PLAYER.volume_down.action,
        },
        'mod+alt+0': {
            type: HOTKEY_DESKTOP_LYRIC.toggle_visible.type,
            name: HOTKEY_DESKTOP_LYRIC.toggle_visible.name,
            action: HOTKEY_DESKTOP_LYRIC.toggle_visible.action,
        },
        'mod+alt+-': {
            type: HOTKEY_DESKTOP_LYRIC.toggle_lock.type,
            name: HOTKEY_DESKTOP_LYRIC.toggle_lock.name,
            action: HOTKEY_DESKTOP_LYRIC.toggle_lock.action,
        },
        'mod+alt+=': {
            type: HOTKEY_DESKTOP_LYRIC.toggle_always_top.type,
            name: HOTKEY_DESKTOP_LYRIC.toggle_always_top.name,
            action: HOTKEY_DESKTOP_LYRIC.toggle_always_top.action,
        },
    },
};
/* harmony default export */ const defaultHotKey = ({
    local,
    global: defaultHotKey_global,
});

;// CONCATENATED MODULE: external "node:crypto"
const external_node_crypto_namespaceObject = require("node:crypto");
var external_node_crypto_default = /*#__PURE__*/__webpack_require__.n(external_node_crypto_namespaceObject);
;// CONCATENATED MODULE: external "node:zlib"
const external_node_zlib_namespaceObject = require("node:zlib");
var external_node_zlib_default = /*#__PURE__*/__webpack_require__.n(external_node_zlib_namespaceObject);
;// CONCATENATED MODULE: ./src/common/utils/nodejs.ts






const joinPath = (...paths) => external_node_path_default().join(...paths);
const extname = (p) => path.extname(p);
const basename = (p, ext) => path.basename(p, ext);
const dirname = (p) => path.dirname(p);
/**
 * 检查路径是否存在
 * @param {*} path 路径
 */
const checkPath = async (path) => {
    return new Promise(resolve => {
        if (!path) {
            resolve(false);
            return;
        }
        external_node_fs_default().access(path, (external_node_fs_default()).constants.F_OK, err => {
            if (err) {
                resolve(false);
                return;
            }
            resolve(true);
        });
    });
};
const getFileStats = async (path) => {
    return new Promise(resolve => {
        if (!path) {
            resolve(null);
            return;
        }
        fs.stat(path, (err, stats) => {
            if (err) {
                resolve(null);
                return;
            }
            resolve(stats);
        });
    });
};
/**
 * 检查路径并创建目录
 * @param path
 * @returns
 */
const createDir = async (path) => new Promise((resolve, reject) => {
    fs.access(path, fs.constants.F_OK | fs.constants.W_OK, err => {
        if (err) {
            if (err.code === 'ENOENT') {
                fs.mkdir(path, { recursive: true }, err => {
                    if (err) {
                        reject(err);
                        return;
                    }
                    resolve();
                });
                return;
            }
            reject(err);
            return;
        }
        resolve();
    });
});
const removeFile = async (path) => new Promise((resolve, reject) => {
    fs.access(path, fs.constants.F_OK, err => {
        if (err) {
            err.code == 'ENOENT' ? resolve() : reject(err);
            return;
        }
        fs.unlink(path, err => {
            if (err) {
                reject(err);
                return;
            }
            resolve();
        });
    });
});
const readFile = async (path) => fs.promises.readFile(path);
/**
 * 创建 MD5 hash
 * @param {*} str
 */
const nodejs_toMD5 = (str) => external_node_crypto_default().createHash('md5').update(str).digest('hex');
const gzipData = async (str) => {
    return new Promise((resolve, reject) => {
        gzip(str, (err, result) => {
            if (err) {
                reject(err);
                return;
            }
            resolve(result);
        });
    });
};
const gunzipData = async (buf) => {
    return new Promise((resolve, reject) => {
        gunzip(buf, (err, result) => {
            if (err) {
                reject(err);
                return;
            }
            resolve(result.toString());
        });
    });
};
/**
 * 保存lx配置文件
 * @param path 保存路径
 * @param data 数据
 */
const saveLxConfigFile = async (path, data) => {
    if (!path.endsWith('.lxmc'))
        path += '.lxmc';
    fs.writeFile(path, await gzipData(JSON.stringify(data)), 'binary', err => {
        console.log(err);
    });
};
/**
 * 读取lx配置文件
 * @param path 文件路径
 * @returns 数据
 */
const readLxConfigFile = async (path) => {
    let isJSON = path.endsWith('.json');
    let data = await fs.promises.readFile(path, isJSON ? 'utf8' : 'binary');
    if (!data)
        return data;
    if (!isJSON)
        data = await gunzipData(Buffer.from(data, 'binary'));
    data = JSON.parse(data);
    // 修复v1.14.0出现的导出数据被序列化两次的问题
    if (typeof data != 'object') {
        try {
            data = JSON.parse(data);
        }
        catch (err) {
            return data;
        }
    }
    return data;
};
const saveStrToFile = async (path, str) => {
    await new Promise((resolve, reject) => {
        fs.writeFile(path, str, err => {
            if (err) {
                log.error(err);
                reject(err);
                return;
            }
            resolve();
        });
    });
};
const b64DecodeUnicode = (str) => {
    // Going backwards: from bytestream, to percent-encoding, to original string.
    // return decodeURIComponent(window.atob(str).split('').map(function(c) {
    //   return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2)
    // }).join(''))
    return Buffer.from(str, 'base64').toString();
};
const copyFile = async (sourcePath, distPath) => {
    return fs.promises.copyFile(sourcePath, distPath);
};
const moveFile = async (sourcePath, distPath) => {
    return fs.promises.rename(sourcePath, distPath);
};
const getAddress = () => {
    const nets = (0,external_node_os_namespaceObject.networkInterfaces)();
    const results = [];
    // console.log(nets)
    for (const interfaceInfos of Object.values(nets)) {
        if (!interfaceInfos)
            continue;
        // Skip over non-IPv4 and internal (i.e. 127.0.0.1) addresses
        for (const interfaceInfo of interfaceInfos) {
            if (interfaceInfo.family === 'IPv4' && !interfaceInfo.internal) {
                results.push(interfaceInfo.address);
            }
        }
    }
    return results;
};

;// CONCATENATED MODULE: ./src/common/utils/tools.ts
// 业务工具方法
const toNewMusicInfo = (oldMusicInfo) => {
    const meta = {
        songId: oldMusicInfo.songmid, // 歌曲ID，local为文件路径
        albumName: oldMusicInfo.albumName, // 歌曲专辑名称
        picUrl: oldMusicInfo.img, // 歌曲图片链接
    };
    if (oldMusicInfo.source == 'local') {
        meta.filePath = oldMusicInfo.filePath ?? oldMusicInfo.songmid ?? '';
        meta.ext = oldMusicInfo.ext ?? /\.(\w+)$/.exec(meta.filePath)?.[1] ?? '';
    }
    else {
        meta.qualitys = oldMusicInfo.types;
        meta._qualitys = oldMusicInfo._types;
        meta.albumId = oldMusicInfo.albumId;
        if (meta._qualitys.flac32bit && !meta._qualitys.flac24bit) {
            meta._qualitys.flac24bit = meta._qualitys.flac32bit;
            delete meta._qualitys.flac32bit;
            meta.qualitys = meta.qualitys.map(quality => {
                if (quality.type == 'flac32bit')
                    quality.type = 'flac24bit';
                return quality;
            });
        }
        switch (oldMusicInfo.source) {
            case 'kg':
                meta.hash = oldMusicInfo.hash;
                break;
            case 'tx':
                meta.strMediaMid = oldMusicInfo.strMediaMid;
                meta.id = oldMusicInfo.songId;
                meta.albumMid = oldMusicInfo.albumMid;
                break;
            case 'mg':
                meta.copyrightId = oldMusicInfo.copyrightId;
                meta.lrcUrl = oldMusicInfo.lrcUrl;
                meta.mrcUrl = oldMusicInfo.mrcUrl;
                meta.trcUrl = oldMusicInfo.trcUrl;
                break;
        }
    }
    return {
        id: `${oldMusicInfo.source}_${oldMusicInfo.songmid}`,
        name: oldMusicInfo.name,
        singer: oldMusicInfo.singer,
        source: oldMusicInfo.source,
        interval: oldMusicInfo.interval,
        meta: meta,
    };
};
const toOldMusicInfo = (minfo) => {
    const oInfo = {
        name: minfo.name,
        singer: minfo.singer,
        source: minfo.source,
        songmid: minfo.meta.songId,
        interval: minfo.interval,
        albumName: minfo.meta.albumName,
        img: minfo.meta.picUrl ?? '',
        typeUrl: {},
    };
    if (minfo.source == 'local') {
        oInfo.filePath = minfo.meta.filePath;
        oInfo.ext = minfo.meta.ext;
        oInfo.albumId = '';
        oInfo.types = [];
        oInfo._types = {};
    }
    else {
        oInfo.albumId = minfo.meta.albumId;
        oInfo.types = minfo.meta.qualitys;
        oInfo._types = minfo.meta._qualitys;
        switch (minfo.source) {
            case 'kg':
                oInfo.hash = minfo.meta.hash;
                break;
            case 'tx':
                oInfo.strMediaMid = minfo.meta.strMediaMid;
                oInfo.albumMid = minfo.meta.albumMid;
                oInfo.songId = minfo.meta.id;
                break;
            case 'mg':
                oInfo.copyrightId = minfo.meta.copyrightId;
                oInfo.lrcUrl = minfo.meta.lrcUrl;
                oInfo.mrcUrl = minfo.meta.mrcUrl;
                oInfo.trcUrl = minfo.meta.trcUrl;
                break;
        }
    }
    return oInfo;
};
/**
 * 修复2.0.0-dev.8之前的新列表数据音质
 * @param musicInfo
 */
const fixNewMusicInfoQuality = (musicInfo) => {
    if (musicInfo.source == 'local')
        return musicInfo;
    // @ts-expect-error
    if (musicInfo.meta._qualitys.flac32bit && !musicInfo.meta._qualitys.flac24bit) {
        // @ts-expect-error
        musicInfo.meta._qualitys.flac24bit = musicInfo.meta._qualitys.flac32bit;
        // @ts-expect-error
        delete musicInfo.meta._qualitys.flac32bit;
        musicInfo.meta.qualitys = musicInfo.meta.qualitys.map(quality => {
            // @ts-expect-error
            if (quality.type == 'flac32bit')
                quality.type = 'flac24bit';
            return quality;
        });
    }
    return musicInfo;
};
const filterMusicList = (list) => {
    const ids = new Set();
    return list.filter(s => {
        if (!s.id || ids.has(s.id) || !s.name)
            return false;
        if (s.singer == null)
            s.singer = '';
        ids.add(s.id);
        return true;
    });
};

;// CONCATENATED MODULE: ./src/main/utils/migrate.ts





/**
 * 读取配置文件
 * @returns
 */
const parseDataFile = async (name) => {
    const path = joinPath(global.lxOldDataPath, name);
    if (await checkPath(path)) {
        try {
            return JSON.parse((await external_node_fs_default().promises.readFile(path)).toString());
        }
        catch (err) {
            node_default().error(err);
        }
    }
    return null;
};
/**
 * 迁移 v2.0.0 之前的 list data
 * @returns
 */
const migrateDBData = async () => {
    let playList = await parseDataFile('playList.json');
    let listDataAll = {
        defaultList: [],
        loveList: [],
        userList: [],
        tempList: [],
    };
    let isRequiredSave = false;
    if (playList) {
        if (playList.defaultList)
            listDataAll.defaultList = filterMusicList(playList.defaultList.list.map(m => toNewMusicInfo(m)));
        if (playList.loveList)
            listDataAll.loveList = filterMusicList(playList.loveList.list.map(m => toNewMusicInfo(m)));
        if (playList.tempList)
            listDataAll.tempList = filterMusicList(playList.tempList.list.map(m => toNewMusicInfo(m)));
        if (playList.userList) {
            listDataAll.userList = playList.userList.map(l => {
                return {
                    ...l,
                    locationUpdateTime: l.locationUpdateTime ?? null,
                    list: filterMusicList(l.list.map(m => toNewMusicInfo(m))),
                };
            });
        }
        isRequiredSave = true;
    }
    else {
        const config = await parseDataFile('config.json');
        if (config?.list) {
            const list = config.list;
            if (list.defaultList)
                listDataAll.defaultList = filterMusicList(list.defaultList.map(m => toNewMusicInfo(m)));
            if (list.loveList)
                listDataAll.loveList = filterMusicList(list.loveList.map(m => toNewMusicInfo(m)));
            isRequiredSave = true;
        }
    }
    if (isRequiredSave)
        await global.lx.worker.dbService.listDataOverwrite(listDataAll);
    const lyricData = await parseDataFile('lyrics_edited.json');
    if (lyricData) {
        for await (const [id, info] of Object.entries(lyricData)) {
            await global.lx.worker.dbService.editedLyricAdd(id, info);
        }
    }
};
// 迁移文件
const migrateFile = async (name, targetName) => {
    let path = joinPath(global.lxDataPath, targetName);
    let oldPath = joinPath(global.lxOldDataPath, name);
    if (!await checkPath(path) && await checkPath(oldPath)) {
        await external_node_fs_default().promises.copyFile(oldPath, path).catch(err => {
            node_default().error(err);
        }).catch(err => {
            node_default().error(err);
        });
    }
};
/**
 * 迁移 v2.0.0 之前的 data.json
 * @returns
 */
const migrateDataJson = async () => {
    const path = joinPath(global.lxDataPath, 'data.json');
    if (await checkPath(path))
        return;
    const oldDataFile = await parseDataFile('data.json');
    if (!oldDataFile)
        return;
    const newData = {};
    if (oldDataFile.searchHistoryList)
        newData.searchHistoryList = oldDataFile.searchHistoryList;
    if (oldDataFile.playInfo)
        newData.playInfo = oldDataFile.playInfo;
    if (oldDataFile.listPrevSelectId)
        newData.listPrevSelectId = oldDataFile.listPrevSelectId;
    if (oldDataFile.listPosition)
        newData.listScrollPosition = oldDataFile.listPosition;
    if (oldDataFile.listUpdateInfo)
        newData.listUpdateInfo = oldDataFile.listUpdateInfo;
    await external_node_fs_default().promises.writeFile(path, JSON.stringify(newData)).catch(err => {
        node_default().error(err);
    });
};
const hotKeyNameMap = {
    mainWindow: APP_EVENT_NAMES.winMainName,
    winLyric: APP_EVENT_NAMES.winLyricName,
};
const updateHotKeyTypeName = (config) => {
    for (const keyConfig of Object.values(config.keys)) {
        if (hotKeyNameMap[keyConfig.type])
            keyConfig.type = hotKeyNameMap[keyConfig.type];
    }
};
/**
 * 迁移 v2.0.0 之前的 hotkey
 * @returns
 */
const migrateHotKey = async () => {
    const oldConfig = await parseDataFile('hotKey.json');
    if (oldConfig) {
        let localConfig;
        let globalConfig;
        updateHotKeyTypeName(oldConfig.local);
        updateHotKeyTypeName(oldConfig.global);
        localConfig = oldConfig.local;
        globalConfig = oldConfig.global;
        // 移除v1.0.1及之前设置的全局声音媒体快捷键接管
        if (globalConfig.keys.VolumeUp) {
            delete globalConfig.keys.VolumeUp;
            delete globalConfig.keys.VolumeDown;
            delete globalConfig.keys.VolumeMute;
        }
        return {
            local: localConfig,
            global: globalConfig,
        };
    }
    return null;
};
/**
 * 迁移 v2.0.0 之前的user api
 * @returns
 */
const migrateUserApi = async () => migrateFile('userApi.json', STORE_NAMES.USER_API + '.json');

;// CONCATENATED MODULE: ./src/common/theme/index.json
const theme_namespaceObject = /*#__PURE__*/JSON.parse('[{"id":"green","name":"绿意盎然","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(77, 175, 124)","--color-primary-dark-100":"rgb(69,158,112)","--color-primary-dark-100-alpha-100":"rgba(69, 158, 112, 0.90)","--color-primary-alpha-100":"rgba(77, 175, 124, 0.90)","--color-primary-dark-100-alpha-200":"rgba(69, 158, 112, 0.80)","--color-primary-alpha-200":"rgba(77, 175, 124, 0.80)","--color-primary-dark-100-alpha-300":"rgba(69, 158, 112, 0.70)","--color-primary-alpha-300":"rgba(77, 175, 124, 0.70)","--color-primary-dark-100-alpha-400":"rgba(69, 158, 112, 0.60)","--color-primary-alpha-400":"rgba(77, 175, 124, 0.60)","--color-primary-dark-100-alpha-500":"rgba(69, 158, 112, 0.50)","--color-primary-alpha-500":"rgba(77, 175, 124, 0.50)","--color-primary-dark-100-alpha-600":"rgba(69, 158, 112, 0.40)","--color-primary-alpha-600":"rgba(77, 175, 124, 0.40)","--color-primary-dark-100-alpha-700":"rgba(69, 158, 112, 0.30)","--color-primary-alpha-700":"rgba(77, 175, 124, 0.30)","--color-primary-dark-100-alpha-800":"rgba(69, 158, 112, 0.20)","--color-primary-alpha-800":"rgba(77, 175, 124, 0.20)","--color-primary-dark-100-alpha-900":"rgba(69, 158, 112, 0.10)","--color-primary-alpha-900":"rgba(77, 175, 124, 0.10)","--color-primary-dark-200":"rgb(62,142,101)","--color-primary-dark-200-alpha-100":"rgba(62, 142, 101, 0.90)","--color-primary-dark-200-alpha-200":"rgba(62, 142, 101, 0.80)","--color-primary-dark-200-alpha-300":"rgba(62, 142, 101, 0.70)","--color-primary-dark-200-alpha-400":"rgba(62, 142, 101, 0.60)","--color-primary-dark-200-alpha-500":"rgba(62, 142, 101, 0.50)","--color-primary-dark-200-alpha-600":"rgba(62, 142, 101, 0.40)","--color-primary-dark-200-alpha-700":"rgba(62, 142, 101, 0.30)","--color-primary-dark-200-alpha-800":"rgba(62, 142, 101, 0.20)","--color-primary-dark-200-alpha-900":"rgba(62, 142, 101, 0.10)","--color-primary-dark-300":"rgb(56,128,91)","--color-primary-dark-300-alpha-100":"rgba(56, 128, 91, 0.90)","--color-primary-dark-300-alpha-200":"rgba(56, 128, 91, 0.80)","--color-primary-dark-300-alpha-300":"rgba(56, 128, 91, 0.70)","--color-primary-dark-300-alpha-400":"rgba(56, 128, 91, 0.60)","--color-primary-dark-300-alpha-500":"rgba(56, 128, 91, 0.50)","--color-primary-dark-300-alpha-600":"rgba(56, 128, 91, 0.40)","--color-primary-dark-300-alpha-700":"rgba(56, 128, 91, 0.30)","--color-primary-dark-300-alpha-800":"rgba(56, 128, 91, 0.20)","--color-primary-dark-300-alpha-900":"rgba(56, 128, 91, 0.10)","--color-primary-dark-400":"rgb(50,115,82)","--color-primary-dark-400-alpha-100":"rgba(50, 115, 82, 0.90)","--color-primary-dark-400-alpha-200":"rgba(50, 115, 82, 0.80)","--color-primary-dark-400-alpha-300":"rgba(50, 115, 82, 0.70)","--color-primary-dark-400-alpha-400":"rgba(50, 115, 82, 0.60)","--color-primary-dark-400-alpha-500":"rgba(50, 115, 82, 0.50)","--color-primary-dark-400-alpha-600":"rgba(50, 115, 82, 0.40)","--color-primary-dark-400-alpha-700":"rgba(50, 115, 82, 0.30)","--color-primary-dark-400-alpha-800":"rgba(50, 115, 82, 0.20)","--color-primary-dark-400-alpha-900":"rgba(50, 115, 82, 0.10)","--color-primary-dark-500":"rgb(45,104,74)","--color-primary-dark-500-alpha-100":"rgba(45, 104, 74, 0.90)","--color-primary-dark-500-alpha-200":"rgba(45, 104, 74, 0.80)","--color-primary-dark-500-alpha-300":"rgba(45, 104, 74, 0.70)","--color-primary-dark-500-alpha-400":"rgba(45, 104, 74, 0.60)","--color-primary-dark-500-alpha-500":"rgba(45, 104, 74, 0.50)","--color-primary-dark-500-alpha-600":"rgba(45, 104, 74, 0.40)","--color-primary-dark-500-alpha-700":"rgba(45, 104, 74, 0.30)","--color-primary-dark-500-alpha-800":"rgba(45, 104, 74, 0.20)","--color-primary-dark-500-alpha-900":"rgba(45, 104, 74, 0.10)","--color-primary-dark-600":"rgb(41,94,67)","--color-primary-dark-600-alpha-100":"rgba(41, 94, 67, 0.90)","--color-primary-dark-600-alpha-200":"rgba(41, 94, 67, 0.80)","--color-primary-dark-600-alpha-300":"rgba(41, 94, 67, 0.70)","--color-primary-dark-600-alpha-400":"rgba(41, 94, 67, 0.60)","--color-primary-dark-600-alpha-500":"rgba(41, 94, 67, 0.50)","--color-primary-dark-600-alpha-600":"rgba(41, 94, 67, 0.40)","--color-primary-dark-600-alpha-700":"rgba(41, 94, 67, 0.30)","--color-primary-dark-600-alpha-800":"rgba(41, 94, 67, 0.20)","--color-primary-dark-600-alpha-900":"rgba(41, 94, 67, 0.10)","--color-primary-dark-700":"rgb(37,85,60)","--color-primary-dark-700-alpha-100":"rgba(37, 85, 60, 0.90)","--color-primary-dark-700-alpha-200":"rgba(37, 85, 60, 0.80)","--color-primary-dark-700-alpha-300":"rgba(37, 85, 60, 0.70)","--color-primary-dark-700-alpha-400":"rgba(37, 85, 60, 0.60)","--color-primary-dark-700-alpha-500":"rgba(37, 85, 60, 0.50)","--color-primary-dark-700-alpha-600":"rgba(37, 85, 60, 0.40)","--color-primary-dark-700-alpha-700":"rgba(37, 85, 60, 0.30)","--color-primary-dark-700-alpha-800":"rgba(37, 85, 60, 0.20)","--color-primary-dark-700-alpha-900":"rgba(37, 85, 60, 0.10)","--color-primary-dark-800":"rgb(33,77,54)","--color-primary-dark-800-alpha-100":"rgba(33, 77, 54, 0.90)","--color-primary-dark-800-alpha-200":"rgba(33, 77, 54, 0.80)","--color-primary-dark-800-alpha-300":"rgba(33, 77, 54, 0.70)","--color-primary-dark-800-alpha-400":"rgba(33, 77, 54, 0.60)","--color-primary-dark-800-alpha-500":"rgba(33, 77, 54, 0.50)","--color-primary-dark-800-alpha-600":"rgba(33, 77, 54, 0.40)","--color-primary-dark-800-alpha-700":"rgba(33, 77, 54, 0.30)","--color-primary-dark-800-alpha-800":"rgba(33, 77, 54, 0.20)","--color-primary-dark-800-alpha-900":"rgba(33, 77, 54, 0.10)","--color-primary-dark-900":"rgb(30,69,49)","--color-primary-dark-900-alpha-100":"rgba(30, 69, 49, 0.90)","--color-primary-dark-900-alpha-200":"rgba(30, 69, 49, 0.80)","--color-primary-dark-900-alpha-300":"rgba(30, 69, 49, 0.70)","--color-primary-dark-900-alpha-400":"rgba(30, 69, 49, 0.60)","--color-primary-dark-900-alpha-500":"rgba(30, 69, 49, 0.50)","--color-primary-dark-900-alpha-600":"rgba(30, 69, 49, 0.40)","--color-primary-dark-900-alpha-700":"rgba(30, 69, 49, 0.30)","--color-primary-dark-900-alpha-800":"rgba(30, 69, 49, 0.20)","--color-primary-dark-900-alpha-900":"rgba(30, 69, 49, 0.10)","--color-primary-dark-1000":"rgb(27,62,44)","--color-primary-dark-1000-alpha-100":"rgba(27, 62, 44, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(27, 62, 44, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(27, 62, 44, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(27, 62, 44, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(27, 62, 44, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(27, 62, 44, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(27, 62, 44, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(27, 62, 44, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(27, 62, 44, 0.10)","--color-primary-light-100":"rgb(113,191,150)","--color-primary-light-100-alpha-100":"rgba(113, 191, 150, 0.90)","--color-primary-light-100-alpha-200":"rgba(113, 191, 150, 0.80)","--color-primary-light-100-alpha-300":"rgba(113, 191, 150, 0.70)","--color-primary-light-100-alpha-400":"rgba(113, 191, 150, 0.60)","--color-primary-light-100-alpha-500":"rgba(113, 191, 150, 0.50)","--color-primary-light-100-alpha-600":"rgba(113, 191, 150, 0.40)","--color-primary-light-100-alpha-700":"rgba(113, 191, 150, 0.30)","--color-primary-light-100-alpha-800":"rgba(113, 191, 150, 0.20)","--color-primary-light-100-alpha-900":"rgba(113, 191, 150, 0.10)","--color-primary-light-200":"rgb(141,204,171)","--color-primary-light-200-alpha-100":"rgba(141, 204, 171, 0.90)","--color-primary-light-200-alpha-200":"rgba(141, 204, 171, 0.80)","--color-primary-light-200-alpha-300":"rgba(141, 204, 171, 0.70)","--color-primary-light-200-alpha-400":"rgba(141, 204, 171, 0.60)","--color-primary-light-200-alpha-500":"rgba(141, 204, 171, 0.50)","--color-primary-light-200-alpha-600":"rgba(141, 204, 171, 0.40)","--color-primary-light-200-alpha-700":"rgba(141, 204, 171, 0.30)","--color-primary-light-200-alpha-800":"rgba(141, 204, 171, 0.20)","--color-primary-light-200-alpha-900":"rgba(141, 204, 171, 0.10)","--color-primary-light-300":"rgb(164,214,188)","--color-primary-light-300-alpha-100":"rgba(164, 214, 188, 0.90)","--color-primary-light-300-alpha-200":"rgba(164, 214, 188, 0.80)","--color-primary-light-300-alpha-300":"rgba(164, 214, 188, 0.70)","--color-primary-light-300-alpha-400":"rgba(164, 214, 188, 0.60)","--color-primary-light-300-alpha-500":"rgba(164, 214, 188, 0.50)","--color-primary-light-300-alpha-600":"rgba(164, 214, 188, 0.40)","--color-primary-light-300-alpha-700":"rgba(164, 214, 188, 0.30)","--color-primary-light-300-alpha-800":"rgba(164, 214, 188, 0.20)","--color-primary-light-300-alpha-900":"rgba(164, 214, 188, 0.10)","--color-primary-light-400":"rgb(182,222,201)","--color-primary-light-400-alpha-100":"rgba(182, 222, 201, 0.90)","--color-primary-light-400-alpha-200":"rgba(182, 222, 201, 0.80)","--color-primary-light-400-alpha-300":"rgba(182, 222, 201, 0.70)","--color-primary-light-400-alpha-400":"rgba(182, 222, 201, 0.60)","--color-primary-light-400-alpha-500":"rgba(182, 222, 201, 0.50)","--color-primary-light-400-alpha-600":"rgba(182, 222, 201, 0.40)","--color-primary-light-400-alpha-700":"rgba(182, 222, 201, 0.30)","--color-primary-light-400-alpha-800":"rgba(182, 222, 201, 0.20)","--color-primary-light-400-alpha-900":"rgba(182, 222, 201, 0.10)","--color-primary-light-500":"rgb(197,229,212)","--color-primary-light-500-alpha-100":"rgba(197, 229, 212, 0.90)","--color-primary-light-500-alpha-200":"rgba(197, 229, 212, 0.80)","--color-primary-light-500-alpha-300":"rgba(197, 229, 212, 0.70)","--color-primary-light-500-alpha-400":"rgba(197, 229, 212, 0.60)","--color-primary-light-500-alpha-500":"rgba(197, 229, 212, 0.50)","--color-primary-light-500-alpha-600":"rgba(197, 229, 212, 0.40)","--color-primary-light-500-alpha-700":"rgba(197, 229, 212, 0.30)","--color-primary-light-500-alpha-800":"rgba(197, 229, 212, 0.20)","--color-primary-light-500-alpha-900":"rgba(197, 229, 212, 0.10)","--color-primary-light-600":"rgb(209,234,221)","--color-primary-light-600-alpha-100":"rgba(209, 234, 221, 0.90)","--color-primary-light-600-alpha-200":"rgba(209, 234, 221, 0.80)","--color-primary-light-600-alpha-300":"rgba(209, 234, 221, 0.70)","--color-primary-light-600-alpha-400":"rgba(209, 234, 221, 0.60)","--color-primary-light-600-alpha-500":"rgba(209, 234, 221, 0.50)","--color-primary-light-600-alpha-600":"rgba(209, 234, 221, 0.40)","--color-primary-light-600-alpha-700":"rgba(209, 234, 221, 0.30)","--color-primary-light-600-alpha-800":"rgba(209, 234, 221, 0.20)","--color-primary-light-600-alpha-900":"rgba(209, 234, 221, 0.10)","--color-primary-light-700":"rgb(218,238,228)","--color-primary-light-700-alpha-100":"rgba(218, 238, 228, 0.90)","--color-primary-light-700-alpha-200":"rgba(218, 238, 228, 0.80)","--color-primary-light-700-alpha-300":"rgba(218, 238, 228, 0.70)","--color-primary-light-700-alpha-400":"rgba(218, 238, 228, 0.60)","--color-primary-light-700-alpha-500":"rgba(218, 238, 228, 0.50)","--color-primary-light-700-alpha-600":"rgba(218, 238, 228, 0.40)","--color-primary-light-700-alpha-700":"rgba(218, 238, 228, 0.30)","--color-primary-light-700-alpha-800":"rgba(218, 238, 228, 0.20)","--color-primary-light-700-alpha-900":"rgba(218, 238, 228, 0.10)","--color-primary-light-800":"rgb(225,241,233)","--color-primary-light-800-alpha-100":"rgba(225, 241, 233, 0.90)","--color-primary-light-800-alpha-200":"rgba(225, 241, 233, 0.80)","--color-primary-light-800-alpha-300":"rgba(225, 241, 233, 0.70)","--color-primary-light-800-alpha-400":"rgba(225, 241, 233, 0.60)","--color-primary-light-800-alpha-500":"rgba(225, 241, 233, 0.50)","--color-primary-light-800-alpha-600":"rgba(225, 241, 233, 0.40)","--color-primary-light-800-alpha-700":"rgba(225, 241, 233, 0.30)","--color-primary-light-800-alpha-800":"rgba(225, 241, 233, 0.20)","--color-primary-light-800-alpha-900":"rgba(225, 241, 233, 0.10)","--color-primary-light-900":"rgb(231,244,237)","--color-primary-light-900-alpha-100":"rgba(231, 244, 237, 0.90)","--color-primary-light-900-alpha-200":"rgba(231, 244, 237, 0.80)","--color-primary-light-900-alpha-300":"rgba(231, 244, 237, 0.70)","--color-primary-light-900-alpha-400":"rgba(231, 244, 237, 0.60)","--color-primary-light-900-alpha-500":"rgba(231, 244, 237, 0.50)","--color-primary-light-900-alpha-600":"rgba(231, 244, 237, 0.40)","--color-primary-light-900-alpha-700":"rgba(231, 244, 237, 0.30)","--color-primary-light-900-alpha-800":"rgba(231, 244, 237, 0.20)","--color-primary-light-900-alpha-900":"rgba(231, 244, 237, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(77, 175, 124)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-700)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#4baed5","--color-badge-tertiary":"#e7aa36"}}},{"id":"blue","name":"蓝田生玉","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(52, 152, 219)","--color-primary-dark-100":"rgb(47,137,197)","--color-primary-dark-100-alpha-100":"rgba(47, 137, 197, 0.90)","--color-primary-alpha-100":"rgba(52, 152, 219, 0.90)","--color-primary-dark-100-alpha-200":"rgba(47, 137, 197, 0.80)","--color-primary-alpha-200":"rgba(52, 152, 219, 0.80)","--color-primary-dark-100-alpha-300":"rgba(47, 137, 197, 0.70)","--color-primary-alpha-300":"rgba(52, 152, 219, 0.70)","--color-primary-dark-100-alpha-400":"rgba(47, 137, 197, 0.60)","--color-primary-alpha-400":"rgba(52, 152, 219, 0.60)","--color-primary-dark-100-alpha-500":"rgba(47, 137, 197, 0.50)","--color-primary-alpha-500":"rgba(52, 152, 219, 0.50)","--color-primary-dark-100-alpha-600":"rgba(47, 137, 197, 0.40)","--color-primary-alpha-600":"rgba(52, 152, 219, 0.40)","--color-primary-dark-100-alpha-700":"rgba(47, 137, 197, 0.30)","--color-primary-alpha-700":"rgba(52, 152, 219, 0.30)","--color-primary-dark-100-alpha-800":"rgba(47, 137, 197, 0.20)","--color-primary-alpha-800":"rgba(52, 152, 219, 0.20)","--color-primary-dark-100-alpha-900":"rgba(47, 137, 197, 0.10)","--color-primary-alpha-900":"rgba(52, 152, 219, 0.10)","--color-primary-dark-200":"rgb(42,123,177)","--color-primary-dark-200-alpha-100":"rgba(42, 123, 177, 0.90)","--color-primary-dark-200-alpha-200":"rgba(42, 123, 177, 0.80)","--color-primary-dark-200-alpha-300":"rgba(42, 123, 177, 0.70)","--color-primary-dark-200-alpha-400":"rgba(42, 123, 177, 0.60)","--color-primary-dark-200-alpha-500":"rgba(42, 123, 177, 0.50)","--color-primary-dark-200-alpha-600":"rgba(42, 123, 177, 0.40)","--color-primary-dark-200-alpha-700":"rgba(42, 123, 177, 0.30)","--color-primary-dark-200-alpha-800":"rgba(42, 123, 177, 0.20)","--color-primary-dark-200-alpha-900":"rgba(42, 123, 177, 0.10)","--color-primary-dark-300":"rgb(38,111,159)","--color-primary-dark-300-alpha-100":"rgba(38, 111, 159, 0.90)","--color-primary-dark-300-alpha-200":"rgba(38, 111, 159, 0.80)","--color-primary-dark-300-alpha-300":"rgba(38, 111, 159, 0.70)","--color-primary-dark-300-alpha-400":"rgba(38, 111, 159, 0.60)","--color-primary-dark-300-alpha-500":"rgba(38, 111, 159, 0.50)","--color-primary-dark-300-alpha-600":"rgba(38, 111, 159, 0.40)","--color-primary-dark-300-alpha-700":"rgba(38, 111, 159, 0.30)","--color-primary-dark-300-alpha-800":"rgba(38, 111, 159, 0.20)","--color-primary-dark-300-alpha-900":"rgba(38, 111, 159, 0.10)","--color-primary-dark-400":"rgb(34,100,143)","--color-primary-dark-400-alpha-100":"rgba(34, 100, 143, 0.90)","--color-primary-dark-400-alpha-200":"rgba(34, 100, 143, 0.80)","--color-primary-dark-400-alpha-300":"rgba(34, 100, 143, 0.70)","--color-primary-dark-400-alpha-400":"rgba(34, 100, 143, 0.60)","--color-primary-dark-400-alpha-500":"rgba(34, 100, 143, 0.50)","--color-primary-dark-400-alpha-600":"rgba(34, 100, 143, 0.40)","--color-primary-dark-400-alpha-700":"rgba(34, 100, 143, 0.30)","--color-primary-dark-400-alpha-800":"rgba(34, 100, 143, 0.20)","--color-primary-dark-400-alpha-900":"rgba(34, 100, 143, 0.10)","--color-primary-dark-500":"rgb(31,90,129)","--color-primary-dark-500-alpha-100":"rgba(31, 90, 129, 0.90)","--color-primary-dark-500-alpha-200":"rgba(31, 90, 129, 0.80)","--color-primary-dark-500-alpha-300":"rgba(31, 90, 129, 0.70)","--color-primary-dark-500-alpha-400":"rgba(31, 90, 129, 0.60)","--color-primary-dark-500-alpha-500":"rgba(31, 90, 129, 0.50)","--color-primary-dark-500-alpha-600":"rgba(31, 90, 129, 0.40)","--color-primary-dark-500-alpha-700":"rgba(31, 90, 129, 0.30)","--color-primary-dark-500-alpha-800":"rgba(31, 90, 129, 0.20)","--color-primary-dark-500-alpha-900":"rgba(31, 90, 129, 0.10)","--color-primary-dark-600":"rgb(28,81,116)","--color-primary-dark-600-alpha-100":"rgba(28, 81, 116, 0.90)","--color-primary-dark-600-alpha-200":"rgba(28, 81, 116, 0.80)","--color-primary-dark-600-alpha-300":"rgba(28, 81, 116, 0.70)","--color-primary-dark-600-alpha-400":"rgba(28, 81, 116, 0.60)","--color-primary-dark-600-alpha-500":"rgba(28, 81, 116, 0.50)","--color-primary-dark-600-alpha-600":"rgba(28, 81, 116, 0.40)","--color-primary-dark-600-alpha-700":"rgba(28, 81, 116, 0.30)","--color-primary-dark-600-alpha-800":"rgba(28, 81, 116, 0.20)","--color-primary-dark-600-alpha-900":"rgba(28, 81, 116, 0.10)","--color-primary-dark-700":"rgb(25,73,104)","--color-primary-dark-700-alpha-100":"rgba(25, 73, 104, 0.90)","--color-primary-dark-700-alpha-200":"rgba(25, 73, 104, 0.80)","--color-primary-dark-700-alpha-300":"rgba(25, 73, 104, 0.70)","--color-primary-dark-700-alpha-400":"rgba(25, 73, 104, 0.60)","--color-primary-dark-700-alpha-500":"rgba(25, 73, 104, 0.50)","--color-primary-dark-700-alpha-600":"rgba(25, 73, 104, 0.40)","--color-primary-dark-700-alpha-700":"rgba(25, 73, 104, 0.30)","--color-primary-dark-700-alpha-800":"rgba(25, 73, 104, 0.20)","--color-primary-dark-700-alpha-900":"rgba(25, 73, 104, 0.10)","--color-primary-dark-800":"rgb(23,66,94)","--color-primary-dark-800-alpha-100":"rgba(23, 66, 94, 0.90)","--color-primary-dark-800-alpha-200":"rgba(23, 66, 94, 0.80)","--color-primary-dark-800-alpha-300":"rgba(23, 66, 94, 0.70)","--color-primary-dark-800-alpha-400":"rgba(23, 66, 94, 0.60)","--color-primary-dark-800-alpha-500":"rgba(23, 66, 94, 0.50)","--color-primary-dark-800-alpha-600":"rgba(23, 66, 94, 0.40)","--color-primary-dark-800-alpha-700":"rgba(23, 66, 94, 0.30)","--color-primary-dark-800-alpha-800":"rgba(23, 66, 94, 0.20)","--color-primary-dark-800-alpha-900":"rgba(23, 66, 94, 0.10)","--color-primary-dark-900":"rgb(21,59,85)","--color-primary-dark-900-alpha-100":"rgba(21, 59, 85, 0.90)","--color-primary-dark-900-alpha-200":"rgba(21, 59, 85, 0.80)","--color-primary-dark-900-alpha-300":"rgba(21, 59, 85, 0.70)","--color-primary-dark-900-alpha-400":"rgba(21, 59, 85, 0.60)","--color-primary-dark-900-alpha-500":"rgba(21, 59, 85, 0.50)","--color-primary-dark-900-alpha-600":"rgba(21, 59, 85, 0.40)","--color-primary-dark-900-alpha-700":"rgba(21, 59, 85, 0.30)","--color-primary-dark-900-alpha-800":"rgba(21, 59, 85, 0.20)","--color-primary-dark-900-alpha-900":"rgba(21, 59, 85, 0.10)","--color-primary-dark-1000":"rgb(19,53,77)","--color-primary-dark-1000-alpha-100":"rgba(19, 53, 77, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(19, 53, 77, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(19, 53, 77, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(19, 53, 77, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(19, 53, 77, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(19, 53, 77, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(19, 53, 77, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(19, 53, 77, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(19, 53, 77, 0.10)","--color-primary-light-100":"rgb(93,173,226)","--color-primary-light-100-alpha-100":"rgba(93, 173, 226, 0.90)","--color-primary-light-100-alpha-200":"rgba(93, 173, 226, 0.80)","--color-primary-light-100-alpha-300":"rgba(93, 173, 226, 0.70)","--color-primary-light-100-alpha-400":"rgba(93, 173, 226, 0.60)","--color-primary-light-100-alpha-500":"rgba(93, 173, 226, 0.50)","--color-primary-light-100-alpha-600":"rgba(93, 173, 226, 0.40)","--color-primary-light-100-alpha-700":"rgba(93, 173, 226, 0.30)","--color-primary-light-100-alpha-800":"rgba(93, 173, 226, 0.20)","--color-primary-light-100-alpha-900":"rgba(93, 173, 226, 0.10)","--color-primary-light-200":"rgb(125,189,232)","--color-primary-light-200-alpha-100":"rgba(125, 189, 232, 0.90)","--color-primary-light-200-alpha-200":"rgba(125, 189, 232, 0.80)","--color-primary-light-200-alpha-300":"rgba(125, 189, 232, 0.70)","--color-primary-light-200-alpha-400":"rgba(125, 189, 232, 0.60)","--color-primary-light-200-alpha-500":"rgba(125, 189, 232, 0.50)","--color-primary-light-200-alpha-600":"rgba(125, 189, 232, 0.40)","--color-primary-light-200-alpha-700":"rgba(125, 189, 232, 0.30)","--color-primary-light-200-alpha-800":"rgba(125, 189, 232, 0.20)","--color-primary-light-200-alpha-900":"rgba(125, 189, 232, 0.10)","--color-primary-light-300":"rgb(151,202,237)","--color-primary-light-300-alpha-100":"rgba(151, 202, 237, 0.90)","--color-primary-light-300-alpha-200":"rgba(151, 202, 237, 0.80)","--color-primary-light-300-alpha-300":"rgba(151, 202, 237, 0.70)","--color-primary-light-300-alpha-400":"rgba(151, 202, 237, 0.60)","--color-primary-light-300-alpha-500":"rgba(151, 202, 237, 0.50)","--color-primary-light-300-alpha-600":"rgba(151, 202, 237, 0.40)","--color-primary-light-300-alpha-700":"rgba(151, 202, 237, 0.30)","--color-primary-light-300-alpha-800":"rgba(151, 202, 237, 0.20)","--color-primary-light-300-alpha-900":"rgba(151, 202, 237, 0.10)","--color-primary-light-400":"rgb(172,213,241)","--color-primary-light-400-alpha-100":"rgba(172, 213, 241, 0.90)","--color-primary-light-400-alpha-200":"rgba(172, 213, 241, 0.80)","--color-primary-light-400-alpha-300":"rgba(172, 213, 241, 0.70)","--color-primary-light-400-alpha-400":"rgba(172, 213, 241, 0.60)","--color-primary-light-400-alpha-500":"rgba(172, 213, 241, 0.50)","--color-primary-light-400-alpha-600":"rgba(172, 213, 241, 0.40)","--color-primary-light-400-alpha-700":"rgba(172, 213, 241, 0.30)","--color-primary-light-400-alpha-800":"rgba(172, 213, 241, 0.20)","--color-primary-light-400-alpha-900":"rgba(172, 213, 241, 0.10)","--color-primary-light-500":"rgb(189,221,244)","--color-primary-light-500-alpha-100":"rgba(189, 221, 244, 0.90)","--color-primary-light-500-alpha-200":"rgba(189, 221, 244, 0.80)","--color-primary-light-500-alpha-300":"rgba(189, 221, 244, 0.70)","--color-primary-light-500-alpha-400":"rgba(189, 221, 244, 0.60)","--color-primary-light-500-alpha-500":"rgba(189, 221, 244, 0.50)","--color-primary-light-500-alpha-600":"rgba(189, 221, 244, 0.40)","--color-primary-light-500-alpha-700":"rgba(189, 221, 244, 0.30)","--color-primary-light-500-alpha-800":"rgba(189, 221, 244, 0.20)","--color-primary-light-500-alpha-900":"rgba(189, 221, 244, 0.10)","--color-primary-light-600":"rgb(202,228,246)","--color-primary-light-600-alpha-100":"rgba(202, 228, 246, 0.90)","--color-primary-light-600-alpha-200":"rgba(202, 228, 246, 0.80)","--color-primary-light-600-alpha-300":"rgba(202, 228, 246, 0.70)","--color-primary-light-600-alpha-400":"rgba(202, 228, 246, 0.60)","--color-primary-light-600-alpha-500":"rgba(202, 228, 246, 0.50)","--color-primary-light-600-alpha-600":"rgba(202, 228, 246, 0.40)","--color-primary-light-600-alpha-700":"rgba(202, 228, 246, 0.30)","--color-primary-light-600-alpha-800":"rgba(202, 228, 246, 0.20)","--color-primary-light-600-alpha-900":"rgba(202, 228, 246, 0.10)","--color-primary-light-700":"rgb(213,233,248)","--color-primary-light-700-alpha-100":"rgba(213, 233, 248, 0.90)","--color-primary-light-700-alpha-200":"rgba(213, 233, 248, 0.80)","--color-primary-light-700-alpha-300":"rgba(213, 233, 248, 0.70)","--color-primary-light-700-alpha-400":"rgba(213, 233, 248, 0.60)","--color-primary-light-700-alpha-500":"rgba(213, 233, 248, 0.50)","--color-primary-light-700-alpha-600":"rgba(213, 233, 248, 0.40)","--color-primary-light-700-alpha-700":"rgba(213, 233, 248, 0.30)","--color-primary-light-700-alpha-800":"rgba(213, 233, 248, 0.20)","--color-primary-light-700-alpha-900":"rgba(213, 233, 248, 0.10)","--color-primary-light-800":"rgb(221,237,249)","--color-primary-light-800-alpha-100":"rgba(221, 237, 249, 0.90)","--color-primary-light-800-alpha-200":"rgba(221, 237, 249, 0.80)","--color-primary-light-800-alpha-300":"rgba(221, 237, 249, 0.70)","--color-primary-light-800-alpha-400":"rgba(221, 237, 249, 0.60)","--color-primary-light-800-alpha-500":"rgba(221, 237, 249, 0.50)","--color-primary-light-800-alpha-600":"rgba(221, 237, 249, 0.40)","--color-primary-light-800-alpha-700":"rgba(221, 237, 249, 0.30)","--color-primary-light-800-alpha-800":"rgba(221, 237, 249, 0.20)","--color-primary-light-800-alpha-900":"rgba(221, 237, 249, 0.10)","--color-primary-light-900":"rgb(228,241,250)","--color-primary-light-900-alpha-100":"rgba(228, 241, 250, 0.90)","--color-primary-light-900-alpha-200":"rgba(228, 241, 250, 0.80)","--color-primary-light-900-alpha-300":"rgba(228, 241, 250, 0.70)","--color-primary-light-900-alpha-400":"rgba(228, 241, 250, 0.60)","--color-primary-light-900-alpha-500":"rgba(228, 241, 250, 0.50)","--color-primary-light-900-alpha-600":"rgba(228, 241, 250, 0.40)","--color-primary-light-900-alpha-700":"rgba(228, 241, 250, 0.30)","--color-primary-light-900-alpha-800":"rgba(228, 241, 250, 0.20)","--color-primary-light-900-alpha-900":"rgba(228, 241, 250, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(52, 152, 219)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-700)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#5cbf9b","--color-badge-tertiary":"#5cbf9b"}}},{"id":"blue_plus","name":"蛋雅深蓝","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(77, 131, 175)","--color-primary-dark-100":"rgb(69,118,158)","--color-primary-dark-100-alpha-100":"rgba(69, 118, 158, 0.90)","--color-primary-alpha-100":"rgba(77, 131, 175, 0.90)","--color-primary-dark-100-alpha-200":"rgba(69, 118, 158, 0.80)","--color-primary-alpha-200":"rgba(77, 131, 175, 0.80)","--color-primary-dark-100-alpha-300":"rgba(69, 118, 158, 0.70)","--color-primary-alpha-300":"rgba(77, 131, 175, 0.70)","--color-primary-dark-100-alpha-400":"rgba(69, 118, 158, 0.60)","--color-primary-alpha-400":"rgba(77, 131, 175, 0.60)","--color-primary-dark-100-alpha-500":"rgba(69, 118, 158, 0.50)","--color-primary-alpha-500":"rgba(77, 131, 175, 0.50)","--color-primary-dark-100-alpha-600":"rgba(69, 118, 158, 0.40)","--color-primary-alpha-600":"rgba(77, 131, 175, 0.40)","--color-primary-dark-100-alpha-700":"rgba(69, 118, 158, 0.30)","--color-primary-alpha-700":"rgba(77, 131, 175, 0.30)","--color-primary-dark-100-alpha-800":"rgba(69, 118, 158, 0.20)","--color-primary-alpha-800":"rgba(77, 131, 175, 0.20)","--color-primary-dark-100-alpha-900":"rgba(69, 118, 158, 0.10)","--color-primary-alpha-900":"rgba(77, 131, 175, 0.10)","--color-primary-dark-200":"rgb(62,106,142)","--color-primary-dark-200-alpha-100":"rgba(62, 106, 142, 0.90)","--color-primary-dark-200-alpha-200":"rgba(62, 106, 142, 0.80)","--color-primary-dark-200-alpha-300":"rgba(62, 106, 142, 0.70)","--color-primary-dark-200-alpha-400":"rgba(62, 106, 142, 0.60)","--color-primary-dark-200-alpha-500":"rgba(62, 106, 142, 0.50)","--color-primary-dark-200-alpha-600":"rgba(62, 106, 142, 0.40)","--color-primary-dark-200-alpha-700":"rgba(62, 106, 142, 0.30)","--color-primary-dark-200-alpha-800":"rgba(62, 106, 142, 0.20)","--color-primary-dark-200-alpha-900":"rgba(62, 106, 142, 0.10)","--color-primary-dark-300":"rgb(56,95,128)","--color-primary-dark-300-alpha-100":"rgba(56, 95, 128, 0.90)","--color-primary-dark-300-alpha-200":"rgba(56, 95, 128, 0.80)","--color-primary-dark-300-alpha-300":"rgba(56, 95, 128, 0.70)","--color-primary-dark-300-alpha-400":"rgba(56, 95, 128, 0.60)","--color-primary-dark-300-alpha-500":"rgba(56, 95, 128, 0.50)","--color-primary-dark-300-alpha-600":"rgba(56, 95, 128, 0.40)","--color-primary-dark-300-alpha-700":"rgba(56, 95, 128, 0.30)","--color-primary-dark-300-alpha-800":"rgba(56, 95, 128, 0.20)","--color-primary-dark-300-alpha-900":"rgba(56, 95, 128, 0.10)","--color-primary-dark-400":"rgb(50,86,115)","--color-primary-dark-400-alpha-100":"rgba(50, 86, 115, 0.90)","--color-primary-dark-400-alpha-200":"rgba(50, 86, 115, 0.80)","--color-primary-dark-400-alpha-300":"rgba(50, 86, 115, 0.70)","--color-primary-dark-400-alpha-400":"rgba(50, 86, 115, 0.60)","--color-primary-dark-400-alpha-500":"rgba(50, 86, 115, 0.50)","--color-primary-dark-400-alpha-600":"rgba(50, 86, 115, 0.40)","--color-primary-dark-400-alpha-700":"rgba(50, 86, 115, 0.30)","--color-primary-dark-400-alpha-800":"rgba(50, 86, 115, 0.20)","--color-primary-dark-400-alpha-900":"rgba(50, 86, 115, 0.10)","--color-primary-dark-500":"rgb(45,77,104)","--color-primary-dark-500-alpha-100":"rgba(45, 77, 104, 0.90)","--color-primary-dark-500-alpha-200":"rgba(45, 77, 104, 0.80)","--color-primary-dark-500-alpha-300":"rgba(45, 77, 104, 0.70)","--color-primary-dark-500-alpha-400":"rgba(45, 77, 104, 0.60)","--color-primary-dark-500-alpha-500":"rgba(45, 77, 104, 0.50)","--color-primary-dark-500-alpha-600":"rgba(45, 77, 104, 0.40)","--color-primary-dark-500-alpha-700":"rgba(45, 77, 104, 0.30)","--color-primary-dark-500-alpha-800":"rgba(45, 77, 104, 0.20)","--color-primary-dark-500-alpha-900":"rgba(45, 77, 104, 0.10)","--color-primary-dark-600":"rgb(41,69,94)","--color-primary-dark-600-alpha-100":"rgba(41, 69, 94, 0.90)","--color-primary-dark-600-alpha-200":"rgba(41, 69, 94, 0.80)","--color-primary-dark-600-alpha-300":"rgba(41, 69, 94, 0.70)","--color-primary-dark-600-alpha-400":"rgba(41, 69, 94, 0.60)","--color-primary-dark-600-alpha-500":"rgba(41, 69, 94, 0.50)","--color-primary-dark-600-alpha-600":"rgba(41, 69, 94, 0.40)","--color-primary-dark-600-alpha-700":"rgba(41, 69, 94, 0.30)","--color-primary-dark-600-alpha-800":"rgba(41, 69, 94, 0.20)","--color-primary-dark-600-alpha-900":"rgba(41, 69, 94, 0.10)","--color-primary-dark-700":"rgb(37,62,85)","--color-primary-dark-700-alpha-100":"rgba(37, 62, 85, 0.90)","--color-primary-dark-700-alpha-200":"rgba(37, 62, 85, 0.80)","--color-primary-dark-700-alpha-300":"rgba(37, 62, 85, 0.70)","--color-primary-dark-700-alpha-400":"rgba(37, 62, 85, 0.60)","--color-primary-dark-700-alpha-500":"rgba(37, 62, 85, 0.50)","--color-primary-dark-700-alpha-600":"rgba(37, 62, 85, 0.40)","--color-primary-dark-700-alpha-700":"rgba(37, 62, 85, 0.30)","--color-primary-dark-700-alpha-800":"rgba(37, 62, 85, 0.20)","--color-primary-dark-700-alpha-900":"rgba(37, 62, 85, 0.10)","--color-primary-dark-800":"rgb(33,56,77)","--color-primary-dark-800-alpha-100":"rgba(33, 56, 77, 0.90)","--color-primary-dark-800-alpha-200":"rgba(33, 56, 77, 0.80)","--color-primary-dark-800-alpha-300":"rgba(33, 56, 77, 0.70)","--color-primary-dark-800-alpha-400":"rgba(33, 56, 77, 0.60)","--color-primary-dark-800-alpha-500":"rgba(33, 56, 77, 0.50)","--color-primary-dark-800-alpha-600":"rgba(33, 56, 77, 0.40)","--color-primary-dark-800-alpha-700":"rgba(33, 56, 77, 0.30)","--color-primary-dark-800-alpha-800":"rgba(33, 56, 77, 0.20)","--color-primary-dark-800-alpha-900":"rgba(33, 56, 77, 0.10)","--color-primary-dark-900":"rgb(30,50,69)","--color-primary-dark-900-alpha-100":"rgba(30, 50, 69, 0.90)","--color-primary-dark-900-alpha-200":"rgba(30, 50, 69, 0.80)","--color-primary-dark-900-alpha-300":"rgba(30, 50, 69, 0.70)","--color-primary-dark-900-alpha-400":"rgba(30, 50, 69, 0.60)","--color-primary-dark-900-alpha-500":"rgba(30, 50, 69, 0.50)","--color-primary-dark-900-alpha-600":"rgba(30, 50, 69, 0.40)","--color-primary-dark-900-alpha-700":"rgba(30, 50, 69, 0.30)","--color-primary-dark-900-alpha-800":"rgba(30, 50, 69, 0.20)","--color-primary-dark-900-alpha-900":"rgba(30, 50, 69, 0.10)","--color-primary-dark-1000":"rgb(27,45,62)","--color-primary-dark-1000-alpha-100":"rgba(27, 45, 62, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(27, 45, 62, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(27, 45, 62, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(27, 45, 62, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(27, 45, 62, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(27, 45, 62, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(27, 45, 62, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(27, 45, 62, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(27, 45, 62, 0.10)","--color-primary-light-100":"rgb(113,156,191)","--color-primary-light-100-alpha-100":"rgba(113, 156, 191, 0.90)","--color-primary-light-100-alpha-200":"rgba(113, 156, 191, 0.80)","--color-primary-light-100-alpha-300":"rgba(113, 156, 191, 0.70)","--color-primary-light-100-alpha-400":"rgba(113, 156, 191, 0.60)","--color-primary-light-100-alpha-500":"rgba(113, 156, 191, 0.50)","--color-primary-light-100-alpha-600":"rgba(113, 156, 191, 0.40)","--color-primary-light-100-alpha-700":"rgba(113, 156, 191, 0.30)","--color-primary-light-100-alpha-800":"rgba(113, 156, 191, 0.20)","--color-primary-light-100-alpha-900":"rgba(113, 156, 191, 0.10)","--color-primary-light-200":"rgb(141,176,204)","--color-primary-light-200-alpha-100":"rgba(141, 176, 204, 0.90)","--color-primary-light-200-alpha-200":"rgba(141, 176, 204, 0.80)","--color-primary-light-200-alpha-300":"rgba(141, 176, 204, 0.70)","--color-primary-light-200-alpha-400":"rgba(141, 176, 204, 0.60)","--color-primary-light-200-alpha-500":"rgba(141, 176, 204, 0.50)","--color-primary-light-200-alpha-600":"rgba(141, 176, 204, 0.40)","--color-primary-light-200-alpha-700":"rgba(141, 176, 204, 0.30)","--color-primary-light-200-alpha-800":"rgba(141, 176, 204, 0.20)","--color-primary-light-200-alpha-900":"rgba(141, 176, 204, 0.10)","--color-primary-light-300":"rgb(164,192,214)","--color-primary-light-300-alpha-100":"rgba(164, 192, 214, 0.90)","--color-primary-light-300-alpha-200":"rgba(164, 192, 214, 0.80)","--color-primary-light-300-alpha-300":"rgba(164, 192, 214, 0.70)","--color-primary-light-300-alpha-400":"rgba(164, 192, 214, 0.60)","--color-primary-light-300-alpha-500":"rgba(164, 192, 214, 0.50)","--color-primary-light-300-alpha-600":"rgba(164, 192, 214, 0.40)","--color-primary-light-300-alpha-700":"rgba(164, 192, 214, 0.30)","--color-primary-light-300-alpha-800":"rgba(164, 192, 214, 0.20)","--color-primary-light-300-alpha-900":"rgba(164, 192, 214, 0.10)","--color-primary-light-400":"rgb(182,205,222)","--color-primary-light-400-alpha-100":"rgba(182, 205, 222, 0.90)","--color-primary-light-400-alpha-200":"rgba(182, 205, 222, 0.80)","--color-primary-light-400-alpha-300":"rgba(182, 205, 222, 0.70)","--color-primary-light-400-alpha-400":"rgba(182, 205, 222, 0.60)","--color-primary-light-400-alpha-500":"rgba(182, 205, 222, 0.50)","--color-primary-light-400-alpha-600":"rgba(182, 205, 222, 0.40)","--color-primary-light-400-alpha-700":"rgba(182, 205, 222, 0.30)","--color-primary-light-400-alpha-800":"rgba(182, 205, 222, 0.20)","--color-primary-light-400-alpha-900":"rgba(182, 205, 222, 0.10)","--color-primary-light-500":"rgb(197,215,229)","--color-primary-light-500-alpha-100":"rgba(197, 215, 229, 0.90)","--color-primary-light-500-alpha-200":"rgba(197, 215, 229, 0.80)","--color-primary-light-500-alpha-300":"rgba(197, 215, 229, 0.70)","--color-primary-light-500-alpha-400":"rgba(197, 215, 229, 0.60)","--color-primary-light-500-alpha-500":"rgba(197, 215, 229, 0.50)","--color-primary-light-500-alpha-600":"rgba(197, 215, 229, 0.40)","--color-primary-light-500-alpha-700":"rgba(197, 215, 229, 0.30)","--color-primary-light-500-alpha-800":"rgba(197, 215, 229, 0.20)","--color-primary-light-500-alpha-900":"rgba(197, 215, 229, 0.10)","--color-primary-light-600":"rgb(209,223,234)","--color-primary-light-600-alpha-100":"rgba(209, 223, 234, 0.90)","--color-primary-light-600-alpha-200":"rgba(209, 223, 234, 0.80)","--color-primary-light-600-alpha-300":"rgba(209, 223, 234, 0.70)","--color-primary-light-600-alpha-400":"rgba(209, 223, 234, 0.60)","--color-primary-light-600-alpha-500":"rgba(209, 223, 234, 0.50)","--color-primary-light-600-alpha-600":"rgba(209, 223, 234, 0.40)","--color-primary-light-600-alpha-700":"rgba(209, 223, 234, 0.30)","--color-primary-light-600-alpha-800":"rgba(209, 223, 234, 0.20)","--color-primary-light-600-alpha-900":"rgba(209, 223, 234, 0.10)","--color-primary-light-700":"rgb(218,229,238)","--color-primary-light-700-alpha-100":"rgba(218, 229, 238, 0.90)","--color-primary-light-700-alpha-200":"rgba(218, 229, 238, 0.80)","--color-primary-light-700-alpha-300":"rgba(218, 229, 238, 0.70)","--color-primary-light-700-alpha-400":"rgba(218, 229, 238, 0.60)","--color-primary-light-700-alpha-500":"rgba(218, 229, 238, 0.50)","--color-primary-light-700-alpha-600":"rgba(218, 229, 238, 0.40)","--color-primary-light-700-alpha-700":"rgba(218, 229, 238, 0.30)","--color-primary-light-700-alpha-800":"rgba(218, 229, 238, 0.20)","--color-primary-light-700-alpha-900":"rgba(218, 229, 238, 0.10)","--color-primary-light-800":"rgb(225,234,241)","--color-primary-light-800-alpha-100":"rgba(225, 234, 241, 0.90)","--color-primary-light-800-alpha-200":"rgba(225, 234, 241, 0.80)","--color-primary-light-800-alpha-300":"rgba(225, 234, 241, 0.70)","--color-primary-light-800-alpha-400":"rgba(225, 234, 241, 0.60)","--color-primary-light-800-alpha-500":"rgba(225, 234, 241, 0.50)","--color-primary-light-800-alpha-600":"rgba(225, 234, 241, 0.40)","--color-primary-light-800-alpha-700":"rgba(225, 234, 241, 0.30)","--color-primary-light-800-alpha-800":"rgba(225, 234, 241, 0.20)","--color-primary-light-800-alpha-900":"rgba(225, 234, 241, 0.10)","--color-primary-light-900":"rgb(231,238,244)","--color-primary-light-900-alpha-100":"rgba(231, 238, 244, 0.90)","--color-primary-light-900-alpha-200":"rgba(231, 238, 244, 0.80)","--color-primary-light-900-alpha-300":"rgba(231, 238, 244, 0.70)","--color-primary-light-900-alpha-400":"rgba(231, 238, 244, 0.60)","--color-primary-light-900-alpha-500":"rgba(231, 238, 244, 0.50)","--color-primary-light-900-alpha-600":"rgba(231, 238, 244, 0.40)","--color-primary-light-900-alpha-700":"rgba(231, 238, 244, 0.30)","--color-primary-light-900-alpha-800":"rgba(231, 238, 244, 0.20)","--color-primary-light-900-alpha-900":"rgba(231, 238, 244, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(77, 131, 175)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-600)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"rgba(66.6, 150.7, 171, 1)","--color-badge-tertiary":"rgba(54, 196, 231, 1)"}}},{"id":"orange","name":"橙黄橘绿","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(245, 171, 53)","--color-primary-dark-100":"rgb(221,154,48)","--color-primary-dark-100-alpha-100":"rgba(221, 154, 48, 0.90)","--color-primary-alpha-100":"rgba(245, 171, 53, 0.90)","--color-primary-dark-100-alpha-200":"rgba(221, 154, 48, 0.80)","--color-primary-alpha-200":"rgba(245, 171, 53, 0.80)","--color-primary-dark-100-alpha-300":"rgba(221, 154, 48, 0.70)","--color-primary-alpha-300":"rgba(245, 171, 53, 0.70)","--color-primary-dark-100-alpha-400":"rgba(221, 154, 48, 0.60)","--color-primary-alpha-400":"rgba(245, 171, 53, 0.60)","--color-primary-dark-100-alpha-500":"rgba(221, 154, 48, 0.50)","--color-primary-alpha-500":"rgba(245, 171, 53, 0.50)","--color-primary-dark-100-alpha-600":"rgba(221, 154, 48, 0.40)","--color-primary-alpha-600":"rgba(245, 171, 53, 0.40)","--color-primary-dark-100-alpha-700":"rgba(221, 154, 48, 0.30)","--color-primary-alpha-700":"rgba(245, 171, 53, 0.30)","--color-primary-dark-100-alpha-800":"rgba(221, 154, 48, 0.20)","--color-primary-alpha-800":"rgba(245, 171, 53, 0.20)","--color-primary-dark-100-alpha-900":"rgba(221, 154, 48, 0.10)","--color-primary-alpha-900":"rgba(245, 171, 53, 0.10)","--color-primary-dark-200":"rgb(199,139,43)","--color-primary-dark-200-alpha-100":"rgba(199, 139, 43, 0.90)","--color-primary-dark-200-alpha-200":"rgba(199, 139, 43, 0.80)","--color-primary-dark-200-alpha-300":"rgba(199, 139, 43, 0.70)","--color-primary-dark-200-alpha-400":"rgba(199, 139, 43, 0.60)","--color-primary-dark-200-alpha-500":"rgba(199, 139, 43, 0.50)","--color-primary-dark-200-alpha-600":"rgba(199, 139, 43, 0.40)","--color-primary-dark-200-alpha-700":"rgba(199, 139, 43, 0.30)","--color-primary-dark-200-alpha-800":"rgba(199, 139, 43, 0.20)","--color-primary-dark-200-alpha-900":"rgba(199, 139, 43, 0.10)","--color-primary-dark-300":"rgb(179,125,39)","--color-primary-dark-300-alpha-100":"rgba(179, 125, 39, 0.90)","--color-primary-dark-300-alpha-200":"rgba(179, 125, 39, 0.80)","--color-primary-dark-300-alpha-300":"rgba(179, 125, 39, 0.70)","--color-primary-dark-300-alpha-400":"rgba(179, 125, 39, 0.60)","--color-primary-dark-300-alpha-500":"rgba(179, 125, 39, 0.50)","--color-primary-dark-300-alpha-600":"rgba(179, 125, 39, 0.40)","--color-primary-dark-300-alpha-700":"rgba(179, 125, 39, 0.30)","--color-primary-dark-300-alpha-800":"rgba(179, 125, 39, 0.20)","--color-primary-dark-300-alpha-900":"rgba(179, 125, 39, 0.10)","--color-primary-dark-400":"rgb(161,113,35)","--color-primary-dark-400-alpha-100":"rgba(161, 113, 35, 0.90)","--color-primary-dark-400-alpha-200":"rgba(161, 113, 35, 0.80)","--color-primary-dark-400-alpha-300":"rgba(161, 113, 35, 0.70)","--color-primary-dark-400-alpha-400":"rgba(161, 113, 35, 0.60)","--color-primary-dark-400-alpha-500":"rgba(161, 113, 35, 0.50)","--color-primary-dark-400-alpha-600":"rgba(161, 113, 35, 0.40)","--color-primary-dark-400-alpha-700":"rgba(161, 113, 35, 0.30)","--color-primary-dark-400-alpha-800":"rgba(161, 113, 35, 0.20)","--color-primary-dark-400-alpha-900":"rgba(161, 113, 35, 0.10)","--color-primary-dark-500":"rgb(145,102,32)","--color-primary-dark-500-alpha-100":"rgba(145, 102, 32, 0.90)","--color-primary-dark-500-alpha-200":"rgba(145, 102, 32, 0.80)","--color-primary-dark-500-alpha-300":"rgba(145, 102, 32, 0.70)","--color-primary-dark-500-alpha-400":"rgba(145, 102, 32, 0.60)","--color-primary-dark-500-alpha-500":"rgba(145, 102, 32, 0.50)","--color-primary-dark-500-alpha-600":"rgba(145, 102, 32, 0.40)","--color-primary-dark-500-alpha-700":"rgba(145, 102, 32, 0.30)","--color-primary-dark-500-alpha-800":"rgba(145, 102, 32, 0.20)","--color-primary-dark-500-alpha-900":"rgba(145, 102, 32, 0.10)","--color-primary-dark-600":"rgb(131,92,29)","--color-primary-dark-600-alpha-100":"rgba(131, 92, 29, 0.90)","--color-primary-dark-600-alpha-200":"rgba(131, 92, 29, 0.80)","--color-primary-dark-600-alpha-300":"rgba(131, 92, 29, 0.70)","--color-primary-dark-600-alpha-400":"rgba(131, 92, 29, 0.60)","--color-primary-dark-600-alpha-500":"rgba(131, 92, 29, 0.50)","--color-primary-dark-600-alpha-600":"rgba(131, 92, 29, 0.40)","--color-primary-dark-600-alpha-700":"rgba(131, 92, 29, 0.30)","--color-primary-dark-600-alpha-800":"rgba(131, 92, 29, 0.20)","--color-primary-dark-600-alpha-900":"rgba(131, 92, 29, 0.10)","--color-primary-dark-700":"rgb(118,83,26)","--color-primary-dark-700-alpha-100":"rgba(118, 83, 26, 0.90)","--color-primary-dark-700-alpha-200":"rgba(118, 83, 26, 0.80)","--color-primary-dark-700-alpha-300":"rgba(118, 83, 26, 0.70)","--color-primary-dark-700-alpha-400":"rgba(118, 83, 26, 0.60)","--color-primary-dark-700-alpha-500":"rgba(118, 83, 26, 0.50)","--color-primary-dark-700-alpha-600":"rgba(118, 83, 26, 0.40)","--color-primary-dark-700-alpha-700":"rgba(118, 83, 26, 0.30)","--color-primary-dark-700-alpha-800":"rgba(118, 83, 26, 0.20)","--color-primary-dark-700-alpha-900":"rgba(118, 83, 26, 0.10)","--color-primary-dark-800":"rgb(106,75,23)","--color-primary-dark-800-alpha-100":"rgba(106, 75, 23, 0.90)","--color-primary-dark-800-alpha-200":"rgba(106, 75, 23, 0.80)","--color-primary-dark-800-alpha-300":"rgba(106, 75, 23, 0.70)","--color-primary-dark-800-alpha-400":"rgba(106, 75, 23, 0.60)","--color-primary-dark-800-alpha-500":"rgba(106, 75, 23, 0.50)","--color-primary-dark-800-alpha-600":"rgba(106, 75, 23, 0.40)","--color-primary-dark-800-alpha-700":"rgba(106, 75, 23, 0.30)","--color-primary-dark-800-alpha-800":"rgba(106, 75, 23, 0.20)","--color-primary-dark-800-alpha-900":"rgba(106, 75, 23, 0.10)","--color-primary-dark-900":"rgb(95,68,21)","--color-primary-dark-900-alpha-100":"rgba(95, 68, 21, 0.90)","--color-primary-dark-900-alpha-200":"rgba(95, 68, 21, 0.80)","--color-primary-dark-900-alpha-300":"rgba(95, 68, 21, 0.70)","--color-primary-dark-900-alpha-400":"rgba(95, 68, 21, 0.60)","--color-primary-dark-900-alpha-500":"rgba(95, 68, 21, 0.50)","--color-primary-dark-900-alpha-600":"rgba(95, 68, 21, 0.40)","--color-primary-dark-900-alpha-700":"rgba(95, 68, 21, 0.30)","--color-primary-dark-900-alpha-800":"rgba(95, 68, 21, 0.20)","--color-primary-dark-900-alpha-900":"rgba(95, 68, 21, 0.10)","--color-primary-dark-1000":"rgb(86,61,19)","--color-primary-dark-1000-alpha-100":"rgba(86, 61, 19, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(86, 61, 19, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(86, 61, 19, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(86, 61, 19, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(86, 61, 19, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(86, 61, 19, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(86, 61, 19, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(86, 61, 19, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(86, 61, 19, 0.10)","--color-primary-light-100":"rgb(247,188,93)","--color-primary-light-100-alpha-100":"rgba(247, 188, 93, 0.90)","--color-primary-light-100-alpha-200":"rgba(247, 188, 93, 0.80)","--color-primary-light-100-alpha-300":"rgba(247, 188, 93, 0.70)","--color-primary-light-100-alpha-400":"rgba(247, 188, 93, 0.60)","--color-primary-light-100-alpha-500":"rgba(247, 188, 93, 0.50)","--color-primary-light-100-alpha-600":"rgba(247, 188, 93, 0.40)","--color-primary-light-100-alpha-700":"rgba(247, 188, 93, 0.30)","--color-primary-light-100-alpha-800":"rgba(247, 188, 93, 0.20)","--color-primary-light-100-alpha-900":"rgba(247, 188, 93, 0.10)","--color-primary-light-200":"rgb(249,201,125)","--color-primary-light-200-alpha-100":"rgba(249, 201, 125, 0.90)","--color-primary-light-200-alpha-200":"rgba(249, 201, 125, 0.80)","--color-primary-light-200-alpha-300":"rgba(249, 201, 125, 0.70)","--color-primary-light-200-alpha-400":"rgba(249, 201, 125, 0.60)","--color-primary-light-200-alpha-500":"rgba(249, 201, 125, 0.50)","--color-primary-light-200-alpha-600":"rgba(249, 201, 125, 0.40)","--color-primary-light-200-alpha-700":"rgba(249, 201, 125, 0.30)","--color-primary-light-200-alpha-800":"rgba(249, 201, 125, 0.20)","--color-primary-light-200-alpha-900":"rgba(249, 201, 125, 0.10)","--color-primary-light-300":"rgb(250,212,151)","--color-primary-light-300-alpha-100":"rgba(250, 212, 151, 0.90)","--color-primary-light-300-alpha-200":"rgba(250, 212, 151, 0.80)","--color-primary-light-300-alpha-300":"rgba(250, 212, 151, 0.70)","--color-primary-light-300-alpha-400":"rgba(250, 212, 151, 0.60)","--color-primary-light-300-alpha-500":"rgba(250, 212, 151, 0.50)","--color-primary-light-300-alpha-600":"rgba(250, 212, 151, 0.40)","--color-primary-light-300-alpha-700":"rgba(250, 212, 151, 0.30)","--color-primary-light-300-alpha-800":"rgba(250, 212, 151, 0.20)","--color-primary-light-300-alpha-900":"rgba(250, 212, 151, 0.10)","--color-primary-light-400":"rgb(251,221,172)","--color-primary-light-400-alpha-100":"rgba(251, 221, 172, 0.90)","--color-primary-light-400-alpha-200":"rgba(251, 221, 172, 0.80)","--color-primary-light-400-alpha-300":"rgba(251, 221, 172, 0.70)","--color-primary-light-400-alpha-400":"rgba(251, 221, 172, 0.60)","--color-primary-light-400-alpha-500":"rgba(251, 221, 172, 0.50)","--color-primary-light-400-alpha-600":"rgba(251, 221, 172, 0.40)","--color-primary-light-400-alpha-700":"rgba(251, 221, 172, 0.30)","--color-primary-light-400-alpha-800":"rgba(251, 221, 172, 0.20)","--color-primary-light-400-alpha-900":"rgba(251, 221, 172, 0.10)","--color-primary-light-500":"rgb(252,228,189)","--color-primary-light-500-alpha-100":"rgba(252, 228, 189, 0.90)","--color-primary-light-500-alpha-200":"rgba(252, 228, 189, 0.80)","--color-primary-light-500-alpha-300":"rgba(252, 228, 189, 0.70)","--color-primary-light-500-alpha-400":"rgba(252, 228, 189, 0.60)","--color-primary-light-500-alpha-500":"rgba(252, 228, 189, 0.50)","--color-primary-light-500-alpha-600":"rgba(252, 228, 189, 0.40)","--color-primary-light-500-alpha-700":"rgba(252, 228, 189, 0.30)","--color-primary-light-500-alpha-800":"rgba(252, 228, 189, 0.20)","--color-primary-light-500-alpha-900":"rgba(252, 228, 189, 0.10)","--color-primary-light-600":"rgb(253,233,202)","--color-primary-light-600-alpha-100":"rgba(253, 233, 202, 0.90)","--color-primary-light-600-alpha-200":"rgba(253, 233, 202, 0.80)","--color-primary-light-600-alpha-300":"rgba(253, 233, 202, 0.70)","--color-primary-light-600-alpha-400":"rgba(253, 233, 202, 0.60)","--color-primary-light-600-alpha-500":"rgba(253, 233, 202, 0.50)","--color-primary-light-600-alpha-600":"rgba(253, 233, 202, 0.40)","--color-primary-light-600-alpha-700":"rgba(253, 233, 202, 0.30)","--color-primary-light-600-alpha-800":"rgba(253, 233, 202, 0.20)","--color-primary-light-600-alpha-900":"rgba(253, 233, 202, 0.10)","--color-primary-light-700":"rgb(253,237,213)","--color-primary-light-700-alpha-100":"rgba(253, 237, 213, 0.90)","--color-primary-light-700-alpha-200":"rgba(253, 237, 213, 0.80)","--color-primary-light-700-alpha-300":"rgba(253, 237, 213, 0.70)","--color-primary-light-700-alpha-400":"rgba(253, 237, 213, 0.60)","--color-primary-light-700-alpha-500":"rgba(253, 237, 213, 0.50)","--color-primary-light-700-alpha-600":"rgba(253, 237, 213, 0.40)","--color-primary-light-700-alpha-700":"rgba(253, 237, 213, 0.30)","--color-primary-light-700-alpha-800":"rgba(253, 237, 213, 0.20)","--color-primary-light-700-alpha-900":"rgba(253, 237, 213, 0.10)","--color-primary-light-800":"rgb(253,241,221)","--color-primary-light-800-alpha-100":"rgba(253, 241, 221, 0.90)","--color-primary-light-800-alpha-200":"rgba(253, 241, 221, 0.80)","--color-primary-light-800-alpha-300":"rgba(253, 241, 221, 0.70)","--color-primary-light-800-alpha-400":"rgba(253, 241, 221, 0.60)","--color-primary-light-800-alpha-500":"rgba(253, 241, 221, 0.50)","--color-primary-light-800-alpha-600":"rgba(253, 241, 221, 0.40)","--color-primary-light-800-alpha-700":"rgba(253, 241, 221, 0.30)","--color-primary-light-800-alpha-800":"rgba(253, 241, 221, 0.20)","--color-primary-light-800-alpha-900":"rgba(253, 241, 221, 0.10)","--color-primary-light-900":"rgb(253,244,228)","--color-primary-light-900-alpha-100":"rgba(253, 244, 228, 0.90)","--color-primary-light-900-alpha-200":"rgba(253, 244, 228, 0.80)","--color-primary-light-900-alpha-300":"rgba(253, 244, 228, 0.70)","--color-primary-light-900-alpha-400":"rgba(253, 244, 228, 0.60)","--color-primary-light-900-alpha-500":"rgba(253, 244, 228, 0.50)","--color-primary-light-900-alpha-600":"rgba(253, 244, 228, 0.40)","--color-primary-light-900-alpha-700":"rgba(253, 244, 228, 0.30)","--color-primary-light-900-alpha-800":"rgba(253, 244, 228, 0.20)","--color-primary-light-900-alpha-900":"rgba(253, 244, 228, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(245, 171, 53)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-700)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#9ed458","--color-badge-tertiary":"#9ed458"}}},{"id":"red","name":"热情似火","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(214, 69, 65)","--color-primary-dark-100":"rgb(193,62,59)","--color-primary-dark-100-alpha-100":"rgba(193, 62, 59, 0.90)","--color-primary-alpha-100":"rgba(214, 69, 65, 0.90)","--color-primary-dark-100-alpha-200":"rgba(193, 62, 59, 0.80)","--color-primary-alpha-200":"rgba(214, 69, 65, 0.80)","--color-primary-dark-100-alpha-300":"rgba(193, 62, 59, 0.70)","--color-primary-alpha-300":"rgba(214, 69, 65, 0.70)","--color-primary-dark-100-alpha-400":"rgba(193, 62, 59, 0.60)","--color-primary-alpha-400":"rgba(214, 69, 65, 0.60)","--color-primary-dark-100-alpha-500":"rgba(193, 62, 59, 0.50)","--color-primary-alpha-500":"rgba(214, 69, 65, 0.50)","--color-primary-dark-100-alpha-600":"rgba(193, 62, 59, 0.40)","--color-primary-alpha-600":"rgba(214, 69, 65, 0.40)","--color-primary-dark-100-alpha-700":"rgba(193, 62, 59, 0.30)","--color-primary-alpha-700":"rgba(214, 69, 65, 0.30)","--color-primary-dark-100-alpha-800":"rgba(193, 62, 59, 0.20)","--color-primary-alpha-800":"rgba(214, 69, 65, 0.20)","--color-primary-dark-100-alpha-900":"rgba(193, 62, 59, 0.10)","--color-primary-alpha-900":"rgba(214, 69, 65, 0.10)","--color-primary-dark-200":"rgb(174,56,53)","--color-primary-dark-200-alpha-100":"rgba(174, 56, 53, 0.90)","--color-primary-dark-200-alpha-200":"rgba(174, 56, 53, 0.80)","--color-primary-dark-200-alpha-300":"rgba(174, 56, 53, 0.70)","--color-primary-dark-200-alpha-400":"rgba(174, 56, 53, 0.60)","--color-primary-dark-200-alpha-500":"rgba(174, 56, 53, 0.50)","--color-primary-dark-200-alpha-600":"rgba(174, 56, 53, 0.40)","--color-primary-dark-200-alpha-700":"rgba(174, 56, 53, 0.30)","--color-primary-dark-200-alpha-800":"rgba(174, 56, 53, 0.20)","--color-primary-dark-200-alpha-900":"rgba(174, 56, 53, 0.10)","--color-primary-dark-300":"rgb(157,50,48)","--color-primary-dark-300-alpha-100":"rgba(157, 50, 48, 0.90)","--color-primary-dark-300-alpha-200":"rgba(157, 50, 48, 0.80)","--color-primary-dark-300-alpha-300":"rgba(157, 50, 48, 0.70)","--color-primary-dark-300-alpha-400":"rgba(157, 50, 48, 0.60)","--color-primary-dark-300-alpha-500":"rgba(157, 50, 48, 0.50)","--color-primary-dark-300-alpha-600":"rgba(157, 50, 48, 0.40)","--color-primary-dark-300-alpha-700":"rgba(157, 50, 48, 0.30)","--color-primary-dark-300-alpha-800":"rgba(157, 50, 48, 0.20)","--color-primary-dark-300-alpha-900":"rgba(157, 50, 48, 0.10)","--color-primary-dark-400":"rgb(141,45,43)","--color-primary-dark-400-alpha-100":"rgba(141, 45, 43, 0.90)","--color-primary-dark-400-alpha-200":"rgba(141, 45, 43, 0.80)","--color-primary-dark-400-alpha-300":"rgba(141, 45, 43, 0.70)","--color-primary-dark-400-alpha-400":"rgba(141, 45, 43, 0.60)","--color-primary-dark-400-alpha-500":"rgba(141, 45, 43, 0.50)","--color-primary-dark-400-alpha-600":"rgba(141, 45, 43, 0.40)","--color-primary-dark-400-alpha-700":"rgba(141, 45, 43, 0.30)","--color-primary-dark-400-alpha-800":"rgba(141, 45, 43, 0.20)","--color-primary-dark-400-alpha-900":"rgba(141, 45, 43, 0.10)","--color-primary-dark-500":"rgb(127,41,39)","--color-primary-dark-500-alpha-100":"rgba(127, 41, 39, 0.90)","--color-primary-dark-500-alpha-200":"rgba(127, 41, 39, 0.80)","--color-primary-dark-500-alpha-300":"rgba(127, 41, 39, 0.70)","--color-primary-dark-500-alpha-400":"rgba(127, 41, 39, 0.60)","--color-primary-dark-500-alpha-500":"rgba(127, 41, 39, 0.50)","--color-primary-dark-500-alpha-600":"rgba(127, 41, 39, 0.40)","--color-primary-dark-500-alpha-700":"rgba(127, 41, 39, 0.30)","--color-primary-dark-500-alpha-800":"rgba(127, 41, 39, 0.20)","--color-primary-dark-500-alpha-900":"rgba(127, 41, 39, 0.10)","--color-primary-dark-600":"rgb(114,37,35)","--color-primary-dark-600-alpha-100":"rgba(114, 37, 35, 0.90)","--color-primary-dark-600-alpha-200":"rgba(114, 37, 35, 0.80)","--color-primary-dark-600-alpha-300":"rgba(114, 37, 35, 0.70)","--color-primary-dark-600-alpha-400":"rgba(114, 37, 35, 0.60)","--color-primary-dark-600-alpha-500":"rgba(114, 37, 35, 0.50)","--color-primary-dark-600-alpha-600":"rgba(114, 37, 35, 0.40)","--color-primary-dark-600-alpha-700":"rgba(114, 37, 35, 0.30)","--color-primary-dark-600-alpha-800":"rgba(114, 37, 35, 0.20)","--color-primary-dark-600-alpha-900":"rgba(114, 37, 35, 0.10)","--color-primary-dark-700":"rgb(103,33,32)","--color-primary-dark-700-alpha-100":"rgba(103, 33, 32, 0.90)","--color-primary-dark-700-alpha-200":"rgba(103, 33, 32, 0.80)","--color-primary-dark-700-alpha-300":"rgba(103, 33, 32, 0.70)","--color-primary-dark-700-alpha-400":"rgba(103, 33, 32, 0.60)","--color-primary-dark-700-alpha-500":"rgba(103, 33, 32, 0.50)","--color-primary-dark-700-alpha-600":"rgba(103, 33, 32, 0.40)","--color-primary-dark-700-alpha-700":"rgba(103, 33, 32, 0.30)","--color-primary-dark-700-alpha-800":"rgba(103, 33, 32, 0.20)","--color-primary-dark-700-alpha-900":"rgba(103, 33, 32, 0.10)","--color-primary-dark-800":"rgb(93,30,29)","--color-primary-dark-800-alpha-100":"rgba(93, 30, 29, 0.90)","--color-primary-dark-800-alpha-200":"rgba(93, 30, 29, 0.80)","--color-primary-dark-800-alpha-300":"rgba(93, 30, 29, 0.70)","--color-primary-dark-800-alpha-400":"rgba(93, 30, 29, 0.60)","--color-primary-dark-800-alpha-500":"rgba(93, 30, 29, 0.50)","--color-primary-dark-800-alpha-600":"rgba(93, 30, 29, 0.40)","--color-primary-dark-800-alpha-700":"rgba(93, 30, 29, 0.30)","--color-primary-dark-800-alpha-800":"rgba(93, 30, 29, 0.20)","--color-primary-dark-800-alpha-900":"rgba(93, 30, 29, 0.10)","--color-primary-dark-900":"rgb(84,27,26)","--color-primary-dark-900-alpha-100":"rgba(84, 27, 26, 0.90)","--color-primary-dark-900-alpha-200":"rgba(84, 27, 26, 0.80)","--color-primary-dark-900-alpha-300":"rgba(84, 27, 26, 0.70)","--color-primary-dark-900-alpha-400":"rgba(84, 27, 26, 0.60)","--color-primary-dark-900-alpha-500":"rgba(84, 27, 26, 0.50)","--color-primary-dark-900-alpha-600":"rgba(84, 27, 26, 0.40)","--color-primary-dark-900-alpha-700":"rgba(84, 27, 26, 0.30)","--color-primary-dark-900-alpha-800":"rgba(84, 27, 26, 0.20)","--color-primary-dark-900-alpha-900":"rgba(84, 27, 26, 0.10)","--color-primary-dark-1000":"rgb(76,24,23)","--color-primary-dark-1000-alpha-100":"rgba(76, 24, 23, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(76, 24, 23, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(76, 24, 23, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(76, 24, 23, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(76, 24, 23, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(76, 24, 23, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(76, 24, 23, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(76, 24, 23, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(76, 24, 23, 0.10)","--color-primary-light-100":"rgb(222,106,103)","--color-primary-light-100-alpha-100":"rgba(222, 106, 103, 0.90)","--color-primary-light-100-alpha-200":"rgba(222, 106, 103, 0.80)","--color-primary-light-100-alpha-300":"rgba(222, 106, 103, 0.70)","--color-primary-light-100-alpha-400":"rgba(222, 106, 103, 0.60)","--color-primary-light-100-alpha-500":"rgba(222, 106, 103, 0.50)","--color-primary-light-100-alpha-600":"rgba(222, 106, 103, 0.40)","--color-primary-light-100-alpha-700":"rgba(222, 106, 103, 0.30)","--color-primary-light-100-alpha-800":"rgba(222, 106, 103, 0.20)","--color-primary-light-100-alpha-900":"rgba(222, 106, 103, 0.10)","--color-primary-light-200":"rgb(229,136,133)","--color-primary-light-200-alpha-100":"rgba(229, 136, 133, 0.90)","--color-primary-light-200-alpha-200":"rgba(229, 136, 133, 0.80)","--color-primary-light-200-alpha-300":"rgba(229, 136, 133, 0.70)","--color-primary-light-200-alpha-400":"rgba(229, 136, 133, 0.60)","--color-primary-light-200-alpha-500":"rgba(229, 136, 133, 0.50)","--color-primary-light-200-alpha-600":"rgba(229, 136, 133, 0.40)","--color-primary-light-200-alpha-700":"rgba(229, 136, 133, 0.30)","--color-primary-light-200-alpha-800":"rgba(229, 136, 133, 0.20)","--color-primary-light-200-alpha-900":"rgba(229, 136, 133, 0.10)","--color-primary-light-300":"rgb(234,160,157)","--color-primary-light-300-alpha-100":"rgba(234, 160, 157, 0.90)","--color-primary-light-300-alpha-200":"rgba(234, 160, 157, 0.80)","--color-primary-light-300-alpha-300":"rgba(234, 160, 157, 0.70)","--color-primary-light-300-alpha-400":"rgba(234, 160, 157, 0.60)","--color-primary-light-300-alpha-500":"rgba(234, 160, 157, 0.50)","--color-primary-light-300-alpha-600":"rgba(234, 160, 157, 0.40)","--color-primary-light-300-alpha-700":"rgba(234, 160, 157, 0.30)","--color-primary-light-300-alpha-800":"rgba(234, 160, 157, 0.20)","--color-primary-light-300-alpha-900":"rgba(234, 160, 157, 0.10)","--color-primary-light-400":"rgb(238,179,177)","--color-primary-light-400-alpha-100":"rgba(238, 179, 177, 0.90)","--color-primary-light-400-alpha-200":"rgba(238, 179, 177, 0.80)","--color-primary-light-400-alpha-300":"rgba(238, 179, 177, 0.70)","--color-primary-light-400-alpha-400":"rgba(238, 179, 177, 0.60)","--color-primary-light-400-alpha-500":"rgba(238, 179, 177, 0.50)","--color-primary-light-400-alpha-600":"rgba(238, 179, 177, 0.40)","--color-primary-light-400-alpha-700":"rgba(238, 179, 177, 0.30)","--color-primary-light-400-alpha-800":"rgba(238, 179, 177, 0.20)","--color-primary-light-400-alpha-900":"rgba(238, 179, 177, 0.10)","--color-primary-light-500":"rgb(241,194,193)","--color-primary-light-500-alpha-100":"rgba(241, 194, 193, 0.90)","--color-primary-light-500-alpha-200":"rgba(241, 194, 193, 0.80)","--color-primary-light-500-alpha-300":"rgba(241, 194, 193, 0.70)","--color-primary-light-500-alpha-400":"rgba(241, 194, 193, 0.60)","--color-primary-light-500-alpha-500":"rgba(241, 194, 193, 0.50)","--color-primary-light-500-alpha-600":"rgba(241, 194, 193, 0.40)","--color-primary-light-500-alpha-700":"rgba(241, 194, 193, 0.30)","--color-primary-light-500-alpha-800":"rgba(241, 194, 193, 0.20)","--color-primary-light-500-alpha-900":"rgba(241, 194, 193, 0.10)","--color-primary-light-600":"rgb(244,206,205)","--color-primary-light-600-alpha-100":"rgba(244, 206, 205, 0.90)","--color-primary-light-600-alpha-200":"rgba(244, 206, 205, 0.80)","--color-primary-light-600-alpha-300":"rgba(244, 206, 205, 0.70)","--color-primary-light-600-alpha-400":"rgba(244, 206, 205, 0.60)","--color-primary-light-600-alpha-500":"rgba(244, 206, 205, 0.50)","--color-primary-light-600-alpha-600":"rgba(244, 206, 205, 0.40)","--color-primary-light-600-alpha-700":"rgba(244, 206, 205, 0.30)","--color-primary-light-600-alpha-800":"rgba(244, 206, 205, 0.20)","--color-primary-light-600-alpha-900":"rgba(244, 206, 205, 0.10)","--color-primary-light-700":"rgb(246,216,215)","--color-primary-light-700-alpha-100":"rgba(246, 216, 215, 0.90)","--color-primary-light-700-alpha-200":"rgba(246, 216, 215, 0.80)","--color-primary-light-700-alpha-300":"rgba(246, 216, 215, 0.70)","--color-primary-light-700-alpha-400":"rgba(246, 216, 215, 0.60)","--color-primary-light-700-alpha-500":"rgba(246, 216, 215, 0.50)","--color-primary-light-700-alpha-600":"rgba(246, 216, 215, 0.40)","--color-primary-light-700-alpha-700":"rgba(246, 216, 215, 0.30)","--color-primary-light-700-alpha-800":"rgba(246, 216, 215, 0.20)","--color-primary-light-700-alpha-900":"rgba(246, 216, 215, 0.10)","--color-primary-light-800":"rgb(248,224,223)","--color-primary-light-800-alpha-100":"rgba(248, 224, 223, 0.90)","--color-primary-light-800-alpha-200":"rgba(248, 224, 223, 0.80)","--color-primary-light-800-alpha-300":"rgba(248, 224, 223, 0.70)","--color-primary-light-800-alpha-400":"rgba(248, 224, 223, 0.60)","--color-primary-light-800-alpha-500":"rgba(248, 224, 223, 0.50)","--color-primary-light-800-alpha-600":"rgba(248, 224, 223, 0.40)","--color-primary-light-800-alpha-700":"rgba(248, 224, 223, 0.30)","--color-primary-light-800-alpha-800":"rgba(248, 224, 223, 0.20)","--color-primary-light-800-alpha-900":"rgba(248, 224, 223, 0.10)","--color-primary-light-900":"rgb(249,230,229)","--color-primary-light-900-alpha-100":"rgba(249, 230, 229, 0.90)","--color-primary-light-900-alpha-200":"rgba(249, 230, 229, 0.80)","--color-primary-light-900-alpha-300":"rgba(249, 230, 229, 0.70)","--color-primary-light-900-alpha-400":"rgba(249, 230, 229, 0.60)","--color-primary-light-900-alpha-500":"rgba(249, 230, 229, 0.50)","--color-primary-light-900-alpha-600":"rgba(249, 230, 229, 0.40)","--color-primary-light-900-alpha-700":"rgba(249, 230, 229, 0.30)","--color-primary-light-900-alpha-800":"rgba(249, 230, 229, 0.20)","--color-primary-light-900-alpha-900":"rgba(249, 230, 229, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(214, 69, 65)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-700)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#dfbb6b","--color-badge-tertiary":"#dfbb6b"}}},{"id":"pink","name":"粉装玉琢","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(241, 130, 141)","--color-primary-dark-100":"rgb(217,117,127)","--color-primary-dark-100-alpha-100":"rgba(217, 117, 127, 0.90)","--color-primary-alpha-100":"rgba(241, 130, 141, 0.90)","--color-primary-dark-100-alpha-200":"rgba(217, 117, 127, 0.80)","--color-primary-alpha-200":"rgba(241, 130, 141, 0.80)","--color-primary-dark-100-alpha-300":"rgba(217, 117, 127, 0.70)","--color-primary-alpha-300":"rgba(241, 130, 141, 0.70)","--color-primary-dark-100-alpha-400":"rgba(217, 117, 127, 0.60)","--color-primary-alpha-400":"rgba(241, 130, 141, 0.60)","--color-primary-dark-100-alpha-500":"rgba(217, 117, 127, 0.50)","--color-primary-alpha-500":"rgba(241, 130, 141, 0.50)","--color-primary-dark-100-alpha-600":"rgba(217, 117, 127, 0.40)","--color-primary-alpha-600":"rgba(241, 130, 141, 0.40)","--color-primary-dark-100-alpha-700":"rgba(217, 117, 127, 0.30)","--color-primary-alpha-700":"rgba(241, 130, 141, 0.30)","--color-primary-dark-100-alpha-800":"rgba(217, 117, 127, 0.20)","--color-primary-alpha-800":"rgba(241, 130, 141, 0.20)","--color-primary-dark-100-alpha-900":"rgba(217, 117, 127, 0.10)","--color-primary-alpha-900":"rgba(241, 130, 141, 0.10)","--color-primary-dark-200":"rgb(195,105,114)","--color-primary-dark-200-alpha-100":"rgba(195, 105, 114, 0.90)","--color-primary-dark-200-alpha-200":"rgba(195, 105, 114, 0.80)","--color-primary-dark-200-alpha-300":"rgba(195, 105, 114, 0.70)","--color-primary-dark-200-alpha-400":"rgba(195, 105, 114, 0.60)","--color-primary-dark-200-alpha-500":"rgba(195, 105, 114, 0.50)","--color-primary-dark-200-alpha-600":"rgba(195, 105, 114, 0.40)","--color-primary-dark-200-alpha-700":"rgba(195, 105, 114, 0.30)","--color-primary-dark-200-alpha-800":"rgba(195, 105, 114, 0.20)","--color-primary-dark-200-alpha-900":"rgba(195, 105, 114, 0.10)","--color-primary-dark-300":"rgb(176,95,103)","--color-primary-dark-300-alpha-100":"rgba(176, 95, 103, 0.90)","--color-primary-dark-300-alpha-200":"rgba(176, 95, 103, 0.80)","--color-primary-dark-300-alpha-300":"rgba(176, 95, 103, 0.70)","--color-primary-dark-300-alpha-400":"rgba(176, 95, 103, 0.60)","--color-primary-dark-300-alpha-500":"rgba(176, 95, 103, 0.50)","--color-primary-dark-300-alpha-600":"rgba(176, 95, 103, 0.40)","--color-primary-dark-300-alpha-700":"rgba(176, 95, 103, 0.30)","--color-primary-dark-300-alpha-800":"rgba(176, 95, 103, 0.20)","--color-primary-dark-300-alpha-900":"rgba(176, 95, 103, 0.10)","--color-primary-dark-400":"rgb(158,86,93)","--color-primary-dark-400-alpha-100":"rgba(158, 86, 93, 0.90)","--color-primary-dark-400-alpha-200":"rgba(158, 86, 93, 0.80)","--color-primary-dark-400-alpha-300":"rgba(158, 86, 93, 0.70)","--color-primary-dark-400-alpha-400":"rgba(158, 86, 93, 0.60)","--color-primary-dark-400-alpha-500":"rgba(158, 86, 93, 0.50)","--color-primary-dark-400-alpha-600":"rgba(158, 86, 93, 0.40)","--color-primary-dark-400-alpha-700":"rgba(158, 86, 93, 0.30)","--color-primary-dark-400-alpha-800":"rgba(158, 86, 93, 0.20)","--color-primary-dark-400-alpha-900":"rgba(158, 86, 93, 0.10)","--color-primary-dark-500":"rgb(142,77,84)","--color-primary-dark-500-alpha-100":"rgba(142, 77, 84, 0.90)","--color-primary-dark-500-alpha-200":"rgba(142, 77, 84, 0.80)","--color-primary-dark-500-alpha-300":"rgba(142, 77, 84, 0.70)","--color-primary-dark-500-alpha-400":"rgba(142, 77, 84, 0.60)","--color-primary-dark-500-alpha-500":"rgba(142, 77, 84, 0.50)","--color-primary-dark-500-alpha-600":"rgba(142, 77, 84, 0.40)","--color-primary-dark-500-alpha-700":"rgba(142, 77, 84, 0.30)","--color-primary-dark-500-alpha-800":"rgba(142, 77, 84, 0.20)","--color-primary-dark-500-alpha-900":"rgba(142, 77, 84, 0.10)","--color-primary-dark-600":"rgb(128,69,76)","--color-primary-dark-600-alpha-100":"rgba(128, 69, 76, 0.90)","--color-primary-dark-600-alpha-200":"rgba(128, 69, 76, 0.80)","--color-primary-dark-600-alpha-300":"rgba(128, 69, 76, 0.70)","--color-primary-dark-600-alpha-400":"rgba(128, 69, 76, 0.60)","--color-primary-dark-600-alpha-500":"rgba(128, 69, 76, 0.50)","--color-primary-dark-600-alpha-600":"rgba(128, 69, 76, 0.40)","--color-primary-dark-600-alpha-700":"rgba(128, 69, 76, 0.30)","--color-primary-dark-600-alpha-800":"rgba(128, 69, 76, 0.20)","--color-primary-dark-600-alpha-900":"rgba(128, 69, 76, 0.10)","--color-primary-dark-700":"rgb(115,62,68)","--color-primary-dark-700-alpha-100":"rgba(115, 62, 68, 0.90)","--color-primary-dark-700-alpha-200":"rgba(115, 62, 68, 0.80)","--color-primary-dark-700-alpha-300":"rgba(115, 62, 68, 0.70)","--color-primary-dark-700-alpha-400":"rgba(115, 62, 68, 0.60)","--color-primary-dark-700-alpha-500":"rgba(115, 62, 68, 0.50)","--color-primary-dark-700-alpha-600":"rgba(115, 62, 68, 0.40)","--color-primary-dark-700-alpha-700":"rgba(115, 62, 68, 0.30)","--color-primary-dark-700-alpha-800":"rgba(115, 62, 68, 0.20)","--color-primary-dark-700-alpha-900":"rgba(115, 62, 68, 0.10)","--color-primary-dark-800":"rgb(104,56,61)","--color-primary-dark-800-alpha-100":"rgba(104, 56, 61, 0.90)","--color-primary-dark-800-alpha-200":"rgba(104, 56, 61, 0.80)","--color-primary-dark-800-alpha-300":"rgba(104, 56, 61, 0.70)","--color-primary-dark-800-alpha-400":"rgba(104, 56, 61, 0.60)","--color-primary-dark-800-alpha-500":"rgba(104, 56, 61, 0.50)","--color-primary-dark-800-alpha-600":"rgba(104, 56, 61, 0.40)","--color-primary-dark-800-alpha-700":"rgba(104, 56, 61, 0.30)","--color-primary-dark-800-alpha-800":"rgba(104, 56, 61, 0.20)","--color-primary-dark-800-alpha-900":"rgba(104, 56, 61, 0.10)","--color-primary-dark-900":"rgb(94,50,55)","--color-primary-dark-900-alpha-100":"rgba(94, 50, 55, 0.90)","--color-primary-dark-900-alpha-200":"rgba(94, 50, 55, 0.80)","--color-primary-dark-900-alpha-300":"rgba(94, 50, 55, 0.70)","--color-primary-dark-900-alpha-400":"rgba(94, 50, 55, 0.60)","--color-primary-dark-900-alpha-500":"rgba(94, 50, 55, 0.50)","--color-primary-dark-900-alpha-600":"rgba(94, 50, 55, 0.40)","--color-primary-dark-900-alpha-700":"rgba(94, 50, 55, 0.30)","--color-primary-dark-900-alpha-800":"rgba(94, 50, 55, 0.20)","--color-primary-dark-900-alpha-900":"rgba(94, 50, 55, 0.10)","--color-primary-dark-1000":"rgb(85,45,50)","--color-primary-dark-1000-alpha-100":"rgba(85, 45, 50, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(85, 45, 50, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(85, 45, 50, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(85, 45, 50, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(85, 45, 50, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(85, 45, 50, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(85, 45, 50, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(85, 45, 50, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(85, 45, 50, 0.10)","--color-primary-light-100":"rgb(244,155,164)","--color-primary-light-100-alpha-100":"rgba(244, 155, 164, 0.90)","--color-primary-light-100-alpha-200":"rgba(244, 155, 164, 0.80)","--color-primary-light-100-alpha-300":"rgba(244, 155, 164, 0.70)","--color-primary-light-100-alpha-400":"rgba(244, 155, 164, 0.60)","--color-primary-light-100-alpha-500":"rgba(244, 155, 164, 0.50)","--color-primary-light-100-alpha-600":"rgba(244, 155, 164, 0.40)","--color-primary-light-100-alpha-700":"rgba(244, 155, 164, 0.30)","--color-primary-light-100-alpha-800":"rgba(244, 155, 164, 0.20)","--color-primary-light-100-alpha-900":"rgba(244, 155, 164, 0.10)","--color-primary-light-200":"rgb(246,175,182)","--color-primary-light-200-alpha-100":"rgba(246, 175, 182, 0.90)","--color-primary-light-200-alpha-200":"rgba(246, 175, 182, 0.80)","--color-primary-light-200-alpha-300":"rgba(246, 175, 182, 0.70)","--color-primary-light-200-alpha-400":"rgba(246, 175, 182, 0.60)","--color-primary-light-200-alpha-500":"rgba(246, 175, 182, 0.50)","--color-primary-light-200-alpha-600":"rgba(246, 175, 182, 0.40)","--color-primary-light-200-alpha-700":"rgba(246, 175, 182, 0.30)","--color-primary-light-200-alpha-800":"rgba(246, 175, 182, 0.20)","--color-primary-light-200-alpha-900":"rgba(246, 175, 182, 0.10)","--color-primary-light-300":"rgb(248,191,197)","--color-primary-light-300-alpha-100":"rgba(248, 191, 197, 0.90)","--color-primary-light-300-alpha-200":"rgba(248, 191, 197, 0.80)","--color-primary-light-300-alpha-300":"rgba(248, 191, 197, 0.70)","--color-primary-light-300-alpha-400":"rgba(248, 191, 197, 0.60)","--color-primary-light-300-alpha-500":"rgba(248, 191, 197, 0.50)","--color-primary-light-300-alpha-600":"rgba(248, 191, 197, 0.40)","--color-primary-light-300-alpha-700":"rgba(248, 191, 197, 0.30)","--color-primary-light-300-alpha-800":"rgba(248, 191, 197, 0.20)","--color-primary-light-300-alpha-900":"rgba(248, 191, 197, 0.10)","--color-primary-light-400":"rgb(249,204,209)","--color-primary-light-400-alpha-100":"rgba(249, 204, 209, 0.90)","--color-primary-light-400-alpha-200":"rgba(249, 204, 209, 0.80)","--color-primary-light-400-alpha-300":"rgba(249, 204, 209, 0.70)","--color-primary-light-400-alpha-400":"rgba(249, 204, 209, 0.60)","--color-primary-light-400-alpha-500":"rgba(249, 204, 209, 0.50)","--color-primary-light-400-alpha-600":"rgba(249, 204, 209, 0.40)","--color-primary-light-400-alpha-700":"rgba(249, 204, 209, 0.30)","--color-primary-light-400-alpha-800":"rgba(249, 204, 209, 0.20)","--color-primary-light-400-alpha-900":"rgba(249, 204, 209, 0.10)","--color-primary-light-500":"rgb(250,214,218)","--color-primary-light-500-alpha-100":"rgba(250, 214, 218, 0.90)","--color-primary-light-500-alpha-200":"rgba(250, 214, 218, 0.80)","--color-primary-light-500-alpha-300":"rgba(250, 214, 218, 0.70)","--color-primary-light-500-alpha-400":"rgba(250, 214, 218, 0.60)","--color-primary-light-500-alpha-500":"rgba(250, 214, 218, 0.50)","--color-primary-light-500-alpha-600":"rgba(250, 214, 218, 0.40)","--color-primary-light-500-alpha-700":"rgba(250, 214, 218, 0.30)","--color-primary-light-500-alpha-800":"rgba(250, 214, 218, 0.20)","--color-primary-light-500-alpha-900":"rgba(250, 214, 218, 0.10)","--color-primary-light-600":"rgb(251,222,225)","--color-primary-light-600-alpha-100":"rgba(251, 222, 225, 0.90)","--color-primary-light-600-alpha-200":"rgba(251, 222, 225, 0.80)","--color-primary-light-600-alpha-300":"rgba(251, 222, 225, 0.70)","--color-primary-light-600-alpha-400":"rgba(251, 222, 225, 0.60)","--color-primary-light-600-alpha-500":"rgba(251, 222, 225, 0.50)","--color-primary-light-600-alpha-600":"rgba(251, 222, 225, 0.40)","--color-primary-light-600-alpha-700":"rgba(251, 222, 225, 0.30)","--color-primary-light-600-alpha-800":"rgba(251, 222, 225, 0.20)","--color-primary-light-600-alpha-900":"rgba(251, 222, 225, 0.10)","--color-primary-light-700":"rgb(252,229,231)","--color-primary-light-700-alpha-100":"rgba(252, 229, 231, 0.90)","--color-primary-light-700-alpha-200":"rgba(252, 229, 231, 0.80)","--color-primary-light-700-alpha-300":"rgba(252, 229, 231, 0.70)","--color-primary-light-700-alpha-400":"rgba(252, 229, 231, 0.60)","--color-primary-light-700-alpha-500":"rgba(252, 229, 231, 0.50)","--color-primary-light-700-alpha-600":"rgba(252, 229, 231, 0.40)","--color-primary-light-700-alpha-700":"rgba(252, 229, 231, 0.30)","--color-primary-light-700-alpha-800":"rgba(252, 229, 231, 0.20)","--color-primary-light-700-alpha-900":"rgba(252, 229, 231, 0.10)","--color-primary-light-800":"rgb(253,234,236)","--color-primary-light-800-alpha-100":"rgba(253, 234, 236, 0.90)","--color-primary-light-800-alpha-200":"rgba(253, 234, 236, 0.80)","--color-primary-light-800-alpha-300":"rgba(253, 234, 236, 0.70)","--color-primary-light-800-alpha-400":"rgba(253, 234, 236, 0.60)","--color-primary-light-800-alpha-500":"rgba(253, 234, 236, 0.50)","--color-primary-light-800-alpha-600":"rgba(253, 234, 236, 0.40)","--color-primary-light-800-alpha-700":"rgba(253, 234, 236, 0.30)","--color-primary-light-800-alpha-800":"rgba(253, 234, 236, 0.20)","--color-primary-light-800-alpha-900":"rgba(253, 234, 236, 0.10)","--color-primary-light-900":"rgb(253,238,240)","--color-primary-light-900-alpha-100":"rgba(253, 238, 240, 0.90)","--color-primary-light-900-alpha-200":"rgba(253, 238, 240, 0.80)","--color-primary-light-900-alpha-300":"rgba(253, 238, 240, 0.70)","--color-primary-light-900-alpha-400":"rgba(253, 238, 240, 0.60)","--color-primary-light-900-alpha-500":"rgba(253, 238, 240, 0.50)","--color-primary-light-900-alpha-600":"rgba(253, 238, 240, 0.40)","--color-primary-light-900-alpha-700":"rgba(253, 238, 240, 0.30)","--color-primary-light-900-alpha-800":"rgba(253, 238, 240, 0.20)","--color-primary-light-900-alpha-900":"rgba(253, 238, 240, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(241, 130, 141)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-700)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#f5b684","--color-badge-tertiary":"#f5b684"}}},{"id":"purple","name":"重斤球紫","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(155, 89, 182)","--color-primary-dark-100":"rgb(140,80,164)","--color-primary-dark-100-alpha-100":"rgba(140, 80, 164, 0.90)","--color-primary-alpha-100":"rgba(155, 89, 182, 0.90)","--color-primary-dark-100-alpha-200":"rgba(140, 80, 164, 0.80)","--color-primary-alpha-200":"rgba(155, 89, 182, 0.80)","--color-primary-dark-100-alpha-300":"rgba(140, 80, 164, 0.70)","--color-primary-alpha-300":"rgba(155, 89, 182, 0.70)","--color-primary-dark-100-alpha-400":"rgba(140, 80, 164, 0.60)","--color-primary-alpha-400":"rgba(155, 89, 182, 0.60)","--color-primary-dark-100-alpha-500":"rgba(140, 80, 164, 0.50)","--color-primary-alpha-500":"rgba(155, 89, 182, 0.50)","--color-primary-dark-100-alpha-600":"rgba(140, 80, 164, 0.40)","--color-primary-alpha-600":"rgba(155, 89, 182, 0.40)","--color-primary-dark-100-alpha-700":"rgba(140, 80, 164, 0.30)","--color-primary-alpha-700":"rgba(155, 89, 182, 0.30)","--color-primary-dark-100-alpha-800":"rgba(140, 80, 164, 0.20)","--color-primary-alpha-800":"rgba(155, 89, 182, 0.20)","--color-primary-dark-100-alpha-900":"rgba(140, 80, 164, 0.10)","--color-primary-alpha-900":"rgba(155, 89, 182, 0.10)","--color-primary-dark-200":"rgb(126,72,148)","--color-primary-dark-200-alpha-100":"rgba(126, 72, 148, 0.90)","--color-primary-dark-200-alpha-200":"rgba(126, 72, 148, 0.80)","--color-primary-dark-200-alpha-300":"rgba(126, 72, 148, 0.70)","--color-primary-dark-200-alpha-400":"rgba(126, 72, 148, 0.60)","--color-primary-dark-200-alpha-500":"rgba(126, 72, 148, 0.50)","--color-primary-dark-200-alpha-600":"rgba(126, 72, 148, 0.40)","--color-primary-dark-200-alpha-700":"rgba(126, 72, 148, 0.30)","--color-primary-dark-200-alpha-800":"rgba(126, 72, 148, 0.20)","--color-primary-dark-200-alpha-900":"rgba(126, 72, 148, 0.10)","--color-primary-dark-300":"rgb(113,65,133)","--color-primary-dark-300-alpha-100":"rgba(113, 65, 133, 0.90)","--color-primary-dark-300-alpha-200":"rgba(113, 65, 133, 0.80)","--color-primary-dark-300-alpha-300":"rgba(113, 65, 133, 0.70)","--color-primary-dark-300-alpha-400":"rgba(113, 65, 133, 0.60)","--color-primary-dark-300-alpha-500":"rgba(113, 65, 133, 0.50)","--color-primary-dark-300-alpha-600":"rgba(113, 65, 133, 0.40)","--color-primary-dark-300-alpha-700":"rgba(113, 65, 133, 0.30)","--color-primary-dark-300-alpha-800":"rgba(113, 65, 133, 0.20)","--color-primary-dark-300-alpha-900":"rgba(113, 65, 133, 0.10)","--color-primary-dark-400":"rgb(102,59,120)","--color-primary-dark-400-alpha-100":"rgba(102, 59, 120, 0.90)","--color-primary-dark-400-alpha-200":"rgba(102, 59, 120, 0.80)","--color-primary-dark-400-alpha-300":"rgba(102, 59, 120, 0.70)","--color-primary-dark-400-alpha-400":"rgba(102, 59, 120, 0.60)","--color-primary-dark-400-alpha-500":"rgba(102, 59, 120, 0.50)","--color-primary-dark-400-alpha-600":"rgba(102, 59, 120, 0.40)","--color-primary-dark-400-alpha-700":"rgba(102, 59, 120, 0.30)","--color-primary-dark-400-alpha-800":"rgba(102, 59, 120, 0.20)","--color-primary-dark-400-alpha-900":"rgba(102, 59, 120, 0.10)","--color-primary-dark-500":"rgb(92,53,108)","--color-primary-dark-500-alpha-100":"rgba(92, 53, 108, 0.90)","--color-primary-dark-500-alpha-200":"rgba(92, 53, 108, 0.80)","--color-primary-dark-500-alpha-300":"rgba(92, 53, 108, 0.70)","--color-primary-dark-500-alpha-400":"rgba(92, 53, 108, 0.60)","--color-primary-dark-500-alpha-500":"rgba(92, 53, 108, 0.50)","--color-primary-dark-500-alpha-600":"rgba(92, 53, 108, 0.40)","--color-primary-dark-500-alpha-700":"rgba(92, 53, 108, 0.30)","--color-primary-dark-500-alpha-800":"rgba(92, 53, 108, 0.20)","--color-primary-dark-500-alpha-900":"rgba(92, 53, 108, 0.10)","--color-primary-dark-600":"rgb(83,48,97)","--color-primary-dark-600-alpha-100":"rgba(83, 48, 97, 0.90)","--color-primary-dark-600-alpha-200":"rgba(83, 48, 97, 0.80)","--color-primary-dark-600-alpha-300":"rgba(83, 48, 97, 0.70)","--color-primary-dark-600-alpha-400":"rgba(83, 48, 97, 0.60)","--color-primary-dark-600-alpha-500":"rgba(83, 48, 97, 0.50)","--color-primary-dark-600-alpha-600":"rgba(83, 48, 97, 0.40)","--color-primary-dark-600-alpha-700":"rgba(83, 48, 97, 0.30)","--color-primary-dark-600-alpha-800":"rgba(83, 48, 97, 0.20)","--color-primary-dark-600-alpha-900":"rgba(83, 48, 97, 0.10)","--color-primary-dark-700":"rgb(75,43,87)","--color-primary-dark-700-alpha-100":"rgba(75, 43, 87, 0.90)","--color-primary-dark-700-alpha-200":"rgba(75, 43, 87, 0.80)","--color-primary-dark-700-alpha-300":"rgba(75, 43, 87, 0.70)","--color-primary-dark-700-alpha-400":"rgba(75, 43, 87, 0.60)","--color-primary-dark-700-alpha-500":"rgba(75, 43, 87, 0.50)","--color-primary-dark-700-alpha-600":"rgba(75, 43, 87, 0.40)","--color-primary-dark-700-alpha-700":"rgba(75, 43, 87, 0.30)","--color-primary-dark-700-alpha-800":"rgba(75, 43, 87, 0.20)","--color-primary-dark-700-alpha-900":"rgba(75, 43, 87, 0.10)","--color-primary-dark-800":"rgb(68,39,78)","--color-primary-dark-800-alpha-100":"rgba(68, 39, 78, 0.90)","--color-primary-dark-800-alpha-200":"rgba(68, 39, 78, 0.80)","--color-primary-dark-800-alpha-300":"rgba(68, 39, 78, 0.70)","--color-primary-dark-800-alpha-400":"rgba(68, 39, 78, 0.60)","--color-primary-dark-800-alpha-500":"rgba(68, 39, 78, 0.50)","--color-primary-dark-800-alpha-600":"rgba(68, 39, 78, 0.40)","--color-primary-dark-800-alpha-700":"rgba(68, 39, 78, 0.30)","--color-primary-dark-800-alpha-800":"rgba(68, 39, 78, 0.20)","--color-primary-dark-800-alpha-900":"rgba(68, 39, 78, 0.10)","--color-primary-dark-900":"rgb(61,35,70)","--color-primary-dark-900-alpha-100":"rgba(61, 35, 70, 0.90)","--color-primary-dark-900-alpha-200":"rgba(61, 35, 70, 0.80)","--color-primary-dark-900-alpha-300":"rgba(61, 35, 70, 0.70)","--color-primary-dark-900-alpha-400":"rgba(61, 35, 70, 0.60)","--color-primary-dark-900-alpha-500":"rgba(61, 35, 70, 0.50)","--color-primary-dark-900-alpha-600":"rgba(61, 35, 70, 0.40)","--color-primary-dark-900-alpha-700":"rgba(61, 35, 70, 0.30)","--color-primary-dark-900-alpha-800":"rgba(61, 35, 70, 0.20)","--color-primary-dark-900-alpha-900":"rgba(61, 35, 70, 0.10)","--color-primary-dark-1000":"rgb(55,32,63)","--color-primary-dark-1000-alpha-100":"rgba(55, 32, 63, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(55, 32, 63, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(55, 32, 63, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(55, 32, 63, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(55, 32, 63, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(55, 32, 63, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(55, 32, 63, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(55, 32, 63, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(55, 32, 63, 0.10)","--color-primary-light-100":"rgb(175,122,197)","--color-primary-light-100-alpha-100":"rgba(175, 122, 197, 0.90)","--color-primary-light-100-alpha-200":"rgba(175, 122, 197, 0.80)","--color-primary-light-100-alpha-300":"rgba(175, 122, 197, 0.70)","--color-primary-light-100-alpha-400":"rgba(175, 122, 197, 0.60)","--color-primary-light-100-alpha-500":"rgba(175, 122, 197, 0.50)","--color-primary-light-100-alpha-600":"rgba(175, 122, 197, 0.40)","--color-primary-light-100-alpha-700":"rgba(175, 122, 197, 0.30)","--color-primary-light-100-alpha-800":"rgba(175, 122, 197, 0.20)","--color-primary-light-100-alpha-900":"rgba(175, 122, 197, 0.10)","--color-primary-light-200":"rgb(191,149,209)","--color-primary-light-200-alpha-100":"rgba(191, 149, 209, 0.90)","--color-primary-light-200-alpha-200":"rgba(191, 149, 209, 0.80)","--color-primary-light-200-alpha-300":"rgba(191, 149, 209, 0.70)","--color-primary-light-200-alpha-400":"rgba(191, 149, 209, 0.60)","--color-primary-light-200-alpha-500":"rgba(191, 149, 209, 0.50)","--color-primary-light-200-alpha-600":"rgba(191, 149, 209, 0.40)","--color-primary-light-200-alpha-700":"rgba(191, 149, 209, 0.30)","--color-primary-light-200-alpha-800":"rgba(191, 149, 209, 0.20)","--color-primary-light-200-alpha-900":"rgba(191, 149, 209, 0.10)","--color-primary-light-300":"rgb(204,170,218)","--color-primary-light-300-alpha-100":"rgba(204, 170, 218, 0.90)","--color-primary-light-300-alpha-200":"rgba(204, 170, 218, 0.80)","--color-primary-light-300-alpha-300":"rgba(204, 170, 218, 0.70)","--color-primary-light-300-alpha-400":"rgba(204, 170, 218, 0.60)","--color-primary-light-300-alpha-500":"rgba(204, 170, 218, 0.50)","--color-primary-light-300-alpha-600":"rgba(204, 170, 218, 0.40)","--color-primary-light-300-alpha-700":"rgba(204, 170, 218, 0.30)","--color-primary-light-300-alpha-800":"rgba(204, 170, 218, 0.20)","--color-primary-light-300-alpha-900":"rgba(204, 170, 218, 0.10)","--color-primary-light-400":"rgb(214,187,225)","--color-primary-light-400-alpha-100":"rgba(214, 187, 225, 0.90)","--color-primary-light-400-alpha-200":"rgba(214, 187, 225, 0.80)","--color-primary-light-400-alpha-300":"rgba(214, 187, 225, 0.70)","--color-primary-light-400-alpha-400":"rgba(214, 187, 225, 0.60)","--color-primary-light-400-alpha-500":"rgba(214, 187, 225, 0.50)","--color-primary-light-400-alpha-600":"rgba(214, 187, 225, 0.40)","--color-primary-light-400-alpha-700":"rgba(214, 187, 225, 0.30)","--color-primary-light-400-alpha-800":"rgba(214, 187, 225, 0.20)","--color-primary-light-400-alpha-900":"rgba(214, 187, 225, 0.10)","--color-primary-light-500":"rgb(222,201,231)","--color-primary-light-500-alpha-100":"rgba(222, 201, 231, 0.90)","--color-primary-light-500-alpha-200":"rgba(222, 201, 231, 0.80)","--color-primary-light-500-alpha-300":"rgba(222, 201, 231, 0.70)","--color-primary-light-500-alpha-400":"rgba(222, 201, 231, 0.60)","--color-primary-light-500-alpha-500":"rgba(222, 201, 231, 0.50)","--color-primary-light-500-alpha-600":"rgba(222, 201, 231, 0.40)","--color-primary-light-500-alpha-700":"rgba(222, 201, 231, 0.30)","--color-primary-light-500-alpha-800":"rgba(222, 201, 231, 0.20)","--color-primary-light-500-alpha-900":"rgba(222, 201, 231, 0.10)","--color-primary-light-600":"rgb(229,212,236)","--color-primary-light-600-alpha-100":"rgba(229, 212, 236, 0.90)","--color-primary-light-600-alpha-200":"rgba(229, 212, 236, 0.80)","--color-primary-light-600-alpha-300":"rgba(229, 212, 236, 0.70)","--color-primary-light-600-alpha-400":"rgba(229, 212, 236, 0.60)","--color-primary-light-600-alpha-500":"rgba(229, 212, 236, 0.50)","--color-primary-light-600-alpha-600":"rgba(229, 212, 236, 0.40)","--color-primary-light-600-alpha-700":"rgba(229, 212, 236, 0.30)","--color-primary-light-600-alpha-800":"rgba(229, 212, 236, 0.20)","--color-primary-light-600-alpha-900":"rgba(229, 212, 236, 0.10)","--color-primary-light-700":"rgb(234,221,240)","--color-primary-light-700-alpha-100":"rgba(234, 221, 240, 0.90)","--color-primary-light-700-alpha-200":"rgba(234, 221, 240, 0.80)","--color-primary-light-700-alpha-300":"rgba(234, 221, 240, 0.70)","--color-primary-light-700-alpha-400":"rgba(234, 221, 240, 0.60)","--color-primary-light-700-alpha-500":"rgba(234, 221, 240, 0.50)","--color-primary-light-700-alpha-600":"rgba(234, 221, 240, 0.40)","--color-primary-light-700-alpha-700":"rgba(234, 221, 240, 0.30)","--color-primary-light-700-alpha-800":"rgba(234, 221, 240, 0.20)","--color-primary-light-700-alpha-900":"rgba(234, 221, 240, 0.10)","--color-primary-light-800":"rgb(238,228,243)","--color-primary-light-800-alpha-100":"rgba(238, 228, 243, 0.90)","--color-primary-light-800-alpha-200":"rgba(238, 228, 243, 0.80)","--color-primary-light-800-alpha-300":"rgba(238, 228, 243, 0.70)","--color-primary-light-800-alpha-400":"rgba(238, 228, 243, 0.60)","--color-primary-light-800-alpha-500":"rgba(238, 228, 243, 0.50)","--color-primary-light-800-alpha-600":"rgba(238, 228, 243, 0.40)","--color-primary-light-800-alpha-700":"rgba(238, 228, 243, 0.30)","--color-primary-light-800-alpha-800":"rgba(238, 228, 243, 0.20)","--color-primary-light-800-alpha-900":"rgba(238, 228, 243, 0.10)","--color-primary-light-900":"rgb(241,233,245)","--color-primary-light-900-alpha-100":"rgba(241, 233, 245, 0.90)","--color-primary-light-900-alpha-200":"rgba(241, 233, 245, 0.80)","--color-primary-light-900-alpha-300":"rgba(241, 233, 245, 0.70)","--color-primary-light-900-alpha-400":"rgba(241, 233, 245, 0.60)","--color-primary-light-900-alpha-500":"rgba(241, 233, 245, 0.50)","--color-primary-light-900-alpha-600":"rgba(241, 233, 245, 0.40)","--color-primary-light-900-alpha-700":"rgba(241, 233, 245, 0.30)","--color-primary-light-900-alpha-800":"rgba(241, 233, 245, 0.20)","--color-primary-light-900-alpha-900":"rgba(241, 233, 245, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(155, 89, 182)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-700)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#e5a39f","--color-badge-tertiary":"#e5a39f"}}},{"id":"grey","name":"灰常美丽","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(108, 122, 137)","--color-primary-dark-100":"rgb(97,110,123)","--color-primary-dark-100-alpha-100":"rgba(97, 110, 123, 0.90)","--color-primary-alpha-100":"rgba(108, 122, 137, 0.90)","--color-primary-dark-100-alpha-200":"rgba(97, 110, 123, 0.80)","--color-primary-alpha-200":"rgba(108, 122, 137, 0.80)","--color-primary-dark-100-alpha-300":"rgba(97, 110, 123, 0.70)","--color-primary-alpha-300":"rgba(108, 122, 137, 0.70)","--color-primary-dark-100-alpha-400":"rgba(97, 110, 123, 0.60)","--color-primary-alpha-400":"rgba(108, 122, 137, 0.60)","--color-primary-dark-100-alpha-500":"rgba(97, 110, 123, 0.50)","--color-primary-alpha-500":"rgba(108, 122, 137, 0.50)","--color-primary-dark-100-alpha-600":"rgba(97, 110, 123, 0.40)","--color-primary-alpha-600":"rgba(108, 122, 137, 0.40)","--color-primary-dark-100-alpha-700":"rgba(97, 110, 123, 0.30)","--color-primary-alpha-700":"rgba(108, 122, 137, 0.30)","--color-primary-dark-100-alpha-800":"rgba(97, 110, 123, 0.20)","--color-primary-alpha-800":"rgba(108, 122, 137, 0.20)","--color-primary-dark-100-alpha-900":"rgba(97, 110, 123, 0.10)","--color-primary-alpha-900":"rgba(108, 122, 137, 0.10)","--color-primary-dark-200":"rgb(87,99,111)","--color-primary-dark-200-alpha-100":"rgba(87, 99, 111, 0.90)","--color-primary-dark-200-alpha-200":"rgba(87, 99, 111, 0.80)","--color-primary-dark-200-alpha-300":"rgba(87, 99, 111, 0.70)","--color-primary-dark-200-alpha-400":"rgba(87, 99, 111, 0.60)","--color-primary-dark-200-alpha-500":"rgba(87, 99, 111, 0.50)","--color-primary-dark-200-alpha-600":"rgba(87, 99, 111, 0.40)","--color-primary-dark-200-alpha-700":"rgba(87, 99, 111, 0.30)","--color-primary-dark-200-alpha-800":"rgba(87, 99, 111, 0.20)","--color-primary-dark-200-alpha-900":"rgba(87, 99, 111, 0.10)","--color-primary-dark-300":"rgb(78,89,100)","--color-primary-dark-300-alpha-100":"rgba(78, 89, 100, 0.90)","--color-primary-dark-300-alpha-200":"rgba(78, 89, 100, 0.80)","--color-primary-dark-300-alpha-300":"rgba(78, 89, 100, 0.70)","--color-primary-dark-300-alpha-400":"rgba(78, 89, 100, 0.60)","--color-primary-dark-300-alpha-500":"rgba(78, 89, 100, 0.50)","--color-primary-dark-300-alpha-600":"rgba(78, 89, 100, 0.40)","--color-primary-dark-300-alpha-700":"rgba(78, 89, 100, 0.30)","--color-primary-dark-300-alpha-800":"rgba(78, 89, 100, 0.20)","--color-primary-dark-300-alpha-900":"rgba(78, 89, 100, 0.10)","--color-primary-dark-400":"rgb(70,80,90)","--color-primary-dark-400-alpha-100":"rgba(70, 80, 90, 0.90)","--color-primary-dark-400-alpha-200":"rgba(70, 80, 90, 0.80)","--color-primary-dark-400-alpha-300":"rgba(70, 80, 90, 0.70)","--color-primary-dark-400-alpha-400":"rgba(70, 80, 90, 0.60)","--color-primary-dark-400-alpha-500":"rgba(70, 80, 90, 0.50)","--color-primary-dark-400-alpha-600":"rgba(70, 80, 90, 0.40)","--color-primary-dark-400-alpha-700":"rgba(70, 80, 90, 0.30)","--color-primary-dark-400-alpha-800":"rgba(70, 80, 90, 0.20)","--color-primary-dark-400-alpha-900":"rgba(70, 80, 90, 0.10)","--color-primary-dark-500":"rgb(63,72,81)","--color-primary-dark-500-alpha-100":"rgba(63, 72, 81, 0.90)","--color-primary-dark-500-alpha-200":"rgba(63, 72, 81, 0.80)","--color-primary-dark-500-alpha-300":"rgba(63, 72, 81, 0.70)","--color-primary-dark-500-alpha-400":"rgba(63, 72, 81, 0.60)","--color-primary-dark-500-alpha-500":"rgba(63, 72, 81, 0.50)","--color-primary-dark-500-alpha-600":"rgba(63, 72, 81, 0.40)","--color-primary-dark-500-alpha-700":"rgba(63, 72, 81, 0.30)","--color-primary-dark-500-alpha-800":"rgba(63, 72, 81, 0.20)","--color-primary-dark-500-alpha-900":"rgba(63, 72, 81, 0.10)","--color-primary-dark-600":"rgb(57,65,73)","--color-primary-dark-600-alpha-100":"rgba(57, 65, 73, 0.90)","--color-primary-dark-600-alpha-200":"rgba(57, 65, 73, 0.80)","--color-primary-dark-600-alpha-300":"rgba(57, 65, 73, 0.70)","--color-primary-dark-600-alpha-400":"rgba(57, 65, 73, 0.60)","--color-primary-dark-600-alpha-500":"rgba(57, 65, 73, 0.50)","--color-primary-dark-600-alpha-600":"rgba(57, 65, 73, 0.40)","--color-primary-dark-600-alpha-700":"rgba(57, 65, 73, 0.30)","--color-primary-dark-600-alpha-800":"rgba(57, 65, 73, 0.20)","--color-primary-dark-600-alpha-900":"rgba(57, 65, 73, 0.10)","--color-primary-dark-700":"rgb(51,59,66)","--color-primary-dark-700-alpha-100":"rgba(51, 59, 66, 0.90)","--color-primary-dark-700-alpha-200":"rgba(51, 59, 66, 0.80)","--color-primary-dark-700-alpha-300":"rgba(51, 59, 66, 0.70)","--color-primary-dark-700-alpha-400":"rgba(51, 59, 66, 0.60)","--color-primary-dark-700-alpha-500":"rgba(51, 59, 66, 0.50)","--color-primary-dark-700-alpha-600":"rgba(51, 59, 66, 0.40)","--color-primary-dark-700-alpha-700":"rgba(51, 59, 66, 0.30)","--color-primary-dark-700-alpha-800":"rgba(51, 59, 66, 0.20)","--color-primary-dark-700-alpha-900":"rgba(51, 59, 66, 0.10)","--color-primary-dark-800":"rgb(46,53,59)","--color-primary-dark-800-alpha-100":"rgba(46, 53, 59, 0.90)","--color-primary-dark-800-alpha-200":"rgba(46, 53, 59, 0.80)","--color-primary-dark-800-alpha-300":"rgba(46, 53, 59, 0.70)","--color-primary-dark-800-alpha-400":"rgba(46, 53, 59, 0.60)","--color-primary-dark-800-alpha-500":"rgba(46, 53, 59, 0.50)","--color-primary-dark-800-alpha-600":"rgba(46, 53, 59, 0.40)","--color-primary-dark-800-alpha-700":"rgba(46, 53, 59, 0.30)","--color-primary-dark-800-alpha-800":"rgba(46, 53, 59, 0.20)","--color-primary-dark-800-alpha-900":"rgba(46, 53, 59, 0.10)","--color-primary-dark-900":"rgb(41,48,53)","--color-primary-dark-900-alpha-100":"rgba(41, 48, 53, 0.90)","--color-primary-dark-900-alpha-200":"rgba(41, 48, 53, 0.80)","--color-primary-dark-900-alpha-300":"rgba(41, 48, 53, 0.70)","--color-primary-dark-900-alpha-400":"rgba(41, 48, 53, 0.60)","--color-primary-dark-900-alpha-500":"rgba(41, 48, 53, 0.50)","--color-primary-dark-900-alpha-600":"rgba(41, 48, 53, 0.40)","--color-primary-dark-900-alpha-700":"rgba(41, 48, 53, 0.30)","--color-primary-dark-900-alpha-800":"rgba(41, 48, 53, 0.20)","--color-primary-dark-900-alpha-900":"rgba(41, 48, 53, 0.10)","--color-primary-dark-1000":"rgb(37,43,48)","--color-primary-dark-1000-alpha-100":"rgba(37, 43, 48, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(37, 43, 48, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(37, 43, 48, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(37, 43, 48, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(37, 43, 48, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(37, 43, 48, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(37, 43, 48, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(37, 43, 48, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(37, 43, 48, 0.10)","--color-primary-light-100":"rgb(137,149,161)","--color-primary-light-100-alpha-100":"rgba(137, 149, 161, 0.90)","--color-primary-light-100-alpha-200":"rgba(137, 149, 161, 0.80)","--color-primary-light-100-alpha-300":"rgba(137, 149, 161, 0.70)","--color-primary-light-100-alpha-400":"rgba(137, 149, 161, 0.60)","--color-primary-light-100-alpha-500":"rgba(137, 149, 161, 0.50)","--color-primary-light-100-alpha-600":"rgba(137, 149, 161, 0.40)","--color-primary-light-100-alpha-700":"rgba(137, 149, 161, 0.30)","--color-primary-light-100-alpha-800":"rgba(137, 149, 161, 0.20)","--color-primary-light-100-alpha-900":"rgba(137, 149, 161, 0.10)","--color-primary-light-200":"rgb(161,170,180)","--color-primary-light-200-alpha-100":"rgba(161, 170, 180, 0.90)","--color-primary-light-200-alpha-200":"rgba(161, 170, 180, 0.80)","--color-primary-light-200-alpha-300":"rgba(161, 170, 180, 0.70)","--color-primary-light-200-alpha-400":"rgba(161, 170, 180, 0.60)","--color-primary-light-200-alpha-500":"rgba(161, 170, 180, 0.50)","--color-primary-light-200-alpha-600":"rgba(161, 170, 180, 0.40)","--color-primary-light-200-alpha-700":"rgba(161, 170, 180, 0.30)","--color-primary-light-200-alpha-800":"rgba(161, 170, 180, 0.20)","--color-primary-light-200-alpha-900":"rgba(161, 170, 180, 0.10)","--color-primary-light-300":"rgb(180,187,195)","--color-primary-light-300-alpha-100":"rgba(180, 187, 195, 0.90)","--color-primary-light-300-alpha-200":"rgba(180, 187, 195, 0.80)","--color-primary-light-300-alpha-300":"rgba(180, 187, 195, 0.70)","--color-primary-light-300-alpha-400":"rgba(180, 187, 195, 0.60)","--color-primary-light-300-alpha-500":"rgba(180, 187, 195, 0.50)","--color-primary-light-300-alpha-600":"rgba(180, 187, 195, 0.40)","--color-primary-light-300-alpha-700":"rgba(180, 187, 195, 0.30)","--color-primary-light-300-alpha-800":"rgba(180, 187, 195, 0.20)","--color-primary-light-300-alpha-900":"rgba(180, 187, 195, 0.10)","--color-primary-light-400":"rgb(195,201,207)","--color-primary-light-400-alpha-100":"rgba(195, 201, 207, 0.90)","--color-primary-light-400-alpha-200":"rgba(195, 201, 207, 0.80)","--color-primary-light-400-alpha-300":"rgba(195, 201, 207, 0.70)","--color-primary-light-400-alpha-400":"rgba(195, 201, 207, 0.60)","--color-primary-light-400-alpha-500":"rgba(195, 201, 207, 0.50)","--color-primary-light-400-alpha-600":"rgba(195, 201, 207, 0.40)","--color-primary-light-400-alpha-700":"rgba(195, 201, 207, 0.30)","--color-primary-light-400-alpha-800":"rgba(195, 201, 207, 0.20)","--color-primary-light-400-alpha-900":"rgba(195, 201, 207, 0.10)","--color-primary-light-500":"rgb(207,212,217)","--color-primary-light-500-alpha-100":"rgba(207, 212, 217, 0.90)","--color-primary-light-500-alpha-200":"rgba(207, 212, 217, 0.80)","--color-primary-light-500-alpha-300":"rgba(207, 212, 217, 0.70)","--color-primary-light-500-alpha-400":"rgba(207, 212, 217, 0.60)","--color-primary-light-500-alpha-500":"rgba(207, 212, 217, 0.50)","--color-primary-light-500-alpha-600":"rgba(207, 212, 217, 0.40)","--color-primary-light-500-alpha-700":"rgba(207, 212, 217, 0.30)","--color-primary-light-500-alpha-800":"rgba(207, 212, 217, 0.20)","--color-primary-light-500-alpha-900":"rgba(207, 212, 217, 0.10)","--color-primary-light-600":"rgb(217,221,225)","--color-primary-light-600-alpha-100":"rgba(217, 221, 225, 0.90)","--color-primary-light-600-alpha-200":"rgba(217, 221, 225, 0.80)","--color-primary-light-600-alpha-300":"rgba(217, 221, 225, 0.70)","--color-primary-light-600-alpha-400":"rgba(217, 221, 225, 0.60)","--color-primary-light-600-alpha-500":"rgba(217, 221, 225, 0.50)","--color-primary-light-600-alpha-600":"rgba(217, 221, 225, 0.40)","--color-primary-light-600-alpha-700":"rgba(217, 221, 225, 0.30)","--color-primary-light-600-alpha-800":"rgba(217, 221, 225, 0.20)","--color-primary-light-600-alpha-900":"rgba(217, 221, 225, 0.10)","--color-primary-light-700":"rgb(225,228,231)","--color-primary-light-700-alpha-100":"rgba(225, 228, 231, 0.90)","--color-primary-light-700-alpha-200":"rgba(225, 228, 231, 0.80)","--color-primary-light-700-alpha-300":"rgba(225, 228, 231, 0.70)","--color-primary-light-700-alpha-400":"rgba(225, 228, 231, 0.60)","--color-primary-light-700-alpha-500":"rgba(225, 228, 231, 0.50)","--color-primary-light-700-alpha-600":"rgba(225, 228, 231, 0.40)","--color-primary-light-700-alpha-700":"rgba(225, 228, 231, 0.30)","--color-primary-light-700-alpha-800":"rgba(225, 228, 231, 0.20)","--color-primary-light-700-alpha-900":"rgba(225, 228, 231, 0.10)","--color-primary-light-800":"rgb(231,233,236)","--color-primary-light-800-alpha-100":"rgba(231, 233, 236, 0.90)","--color-primary-light-800-alpha-200":"rgba(231, 233, 236, 0.80)","--color-primary-light-800-alpha-300":"rgba(231, 233, 236, 0.70)","--color-primary-light-800-alpha-400":"rgba(231, 233, 236, 0.60)","--color-primary-light-800-alpha-500":"rgba(231, 233, 236, 0.50)","--color-primary-light-800-alpha-600":"rgba(231, 233, 236, 0.40)","--color-primary-light-800-alpha-700":"rgba(231, 233, 236, 0.30)","--color-primary-light-800-alpha-800":"rgba(231, 233, 236, 0.20)","--color-primary-light-800-alpha-900":"rgba(231, 233, 236, 0.10)","--color-primary-light-900":"rgb(236,237,240)","--color-primary-light-900-alpha-100":"rgba(236, 237, 240, 0.90)","--color-primary-light-900-alpha-200":"rgba(236, 237, 240, 0.80)","--color-primary-light-900-alpha-300":"rgba(236, 237, 240, 0.70)","--color-primary-light-900-alpha-400":"rgba(236, 237, 240, 0.60)","--color-primary-light-900-alpha-500":"rgba(236, 237, 240, 0.50)","--color-primary-light-900-alpha-600":"rgba(236, 237, 240, 0.40)","--color-primary-light-900-alpha-700":"rgba(236, 237, 240, 0.30)","--color-primary-light-900-alpha-800":"rgba(236, 237, 240, 0.20)","--color-primary-light-900-alpha-900":"rgba(236, 237, 240, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(108, 122, 137)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-700)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#b19b9f","--color-badge-tertiary":"#b19b9f"}}},{"id":"ming","name":"青出于黑","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(51, 110, 123)","--color-primary-dark-100":"rgb(46,99,111)","--color-primary-dark-100-alpha-100":"rgba(46, 99, 111, 0.90)","--color-primary-alpha-100":"rgba(51, 110, 123, 0.90)","--color-primary-dark-100-alpha-200":"rgba(46, 99, 111, 0.80)","--color-primary-alpha-200":"rgba(51, 110, 123, 0.80)","--color-primary-dark-100-alpha-300":"rgba(46, 99, 111, 0.70)","--color-primary-alpha-300":"rgba(51, 110, 123, 0.70)","--color-primary-dark-100-alpha-400":"rgba(46, 99, 111, 0.60)","--color-primary-alpha-400":"rgba(51, 110, 123, 0.60)","--color-primary-dark-100-alpha-500":"rgba(46, 99, 111, 0.50)","--color-primary-alpha-500":"rgba(51, 110, 123, 0.50)","--color-primary-dark-100-alpha-600":"rgba(46, 99, 111, 0.40)","--color-primary-alpha-600":"rgba(51, 110, 123, 0.40)","--color-primary-dark-100-alpha-700":"rgba(46, 99, 111, 0.30)","--color-primary-alpha-700":"rgba(51, 110, 123, 0.30)","--color-primary-dark-100-alpha-800":"rgba(46, 99, 111, 0.20)","--color-primary-alpha-800":"rgba(51, 110, 123, 0.20)","--color-primary-dark-100-alpha-900":"rgba(46, 99, 111, 0.10)","--color-primary-alpha-900":"rgba(51, 110, 123, 0.10)","--color-primary-dark-200":"rgb(41,89,100)","--color-primary-dark-200-alpha-100":"rgba(41, 89, 100, 0.90)","--color-primary-dark-200-alpha-200":"rgba(41, 89, 100, 0.80)","--color-primary-dark-200-alpha-300":"rgba(41, 89, 100, 0.70)","--color-primary-dark-200-alpha-400":"rgba(41, 89, 100, 0.60)","--color-primary-dark-200-alpha-500":"rgba(41, 89, 100, 0.50)","--color-primary-dark-200-alpha-600":"rgba(41, 89, 100, 0.40)","--color-primary-dark-200-alpha-700":"rgba(41, 89, 100, 0.30)","--color-primary-dark-200-alpha-800":"rgba(41, 89, 100, 0.20)","--color-primary-dark-200-alpha-900":"rgba(41, 89, 100, 0.10)","--color-primary-dark-300":"rgb(37,80,90)","--color-primary-dark-300-alpha-100":"rgba(37, 80, 90, 0.90)","--color-primary-dark-300-alpha-200":"rgba(37, 80, 90, 0.80)","--color-primary-dark-300-alpha-300":"rgba(37, 80, 90, 0.70)","--color-primary-dark-300-alpha-400":"rgba(37, 80, 90, 0.60)","--color-primary-dark-300-alpha-500":"rgba(37, 80, 90, 0.50)","--color-primary-dark-300-alpha-600":"rgba(37, 80, 90, 0.40)","--color-primary-dark-300-alpha-700":"rgba(37, 80, 90, 0.30)","--color-primary-dark-300-alpha-800":"rgba(37, 80, 90, 0.20)","--color-primary-dark-300-alpha-900":"rgba(37, 80, 90, 0.10)","--color-primary-dark-400":"rgb(33,72,81)","--color-primary-dark-400-alpha-100":"rgba(33, 72, 81, 0.90)","--color-primary-dark-400-alpha-200":"rgba(33, 72, 81, 0.80)","--color-primary-dark-400-alpha-300":"rgba(33, 72, 81, 0.70)","--color-primary-dark-400-alpha-400":"rgba(33, 72, 81, 0.60)","--color-primary-dark-400-alpha-500":"rgba(33, 72, 81, 0.50)","--color-primary-dark-400-alpha-600":"rgba(33, 72, 81, 0.40)","--color-primary-dark-400-alpha-700":"rgba(33, 72, 81, 0.30)","--color-primary-dark-400-alpha-800":"rgba(33, 72, 81, 0.20)","--color-primary-dark-400-alpha-900":"rgba(33, 72, 81, 0.10)","--color-primary-dark-500":"rgb(30,65,73)","--color-primary-dark-500-alpha-100":"rgba(30, 65, 73, 0.90)","--color-primary-dark-500-alpha-200":"rgba(30, 65, 73, 0.80)","--color-primary-dark-500-alpha-300":"rgba(30, 65, 73, 0.70)","--color-primary-dark-500-alpha-400":"rgba(30, 65, 73, 0.60)","--color-primary-dark-500-alpha-500":"rgba(30, 65, 73, 0.50)","--color-primary-dark-500-alpha-600":"rgba(30, 65, 73, 0.40)","--color-primary-dark-500-alpha-700":"rgba(30, 65, 73, 0.30)","--color-primary-dark-500-alpha-800":"rgba(30, 65, 73, 0.20)","--color-primary-dark-500-alpha-900":"rgba(30, 65, 73, 0.10)","--color-primary-dark-600":"rgb(27,59,66)","--color-primary-dark-600-alpha-100":"rgba(27, 59, 66, 0.90)","--color-primary-dark-600-alpha-200":"rgba(27, 59, 66, 0.80)","--color-primary-dark-600-alpha-300":"rgba(27, 59, 66, 0.70)","--color-primary-dark-600-alpha-400":"rgba(27, 59, 66, 0.60)","--color-primary-dark-600-alpha-500":"rgba(27, 59, 66, 0.50)","--color-primary-dark-600-alpha-600":"rgba(27, 59, 66, 0.40)","--color-primary-dark-600-alpha-700":"rgba(27, 59, 66, 0.30)","--color-primary-dark-600-alpha-800":"rgba(27, 59, 66, 0.20)","--color-primary-dark-600-alpha-900":"rgba(27, 59, 66, 0.10)","--color-primary-dark-700":"rgb(24,53,59)","--color-primary-dark-700-alpha-100":"rgba(24, 53, 59, 0.90)","--color-primary-dark-700-alpha-200":"rgba(24, 53, 59, 0.80)","--color-primary-dark-700-alpha-300":"rgba(24, 53, 59, 0.70)","--color-primary-dark-700-alpha-400":"rgba(24, 53, 59, 0.60)","--color-primary-dark-700-alpha-500":"rgba(24, 53, 59, 0.50)","--color-primary-dark-700-alpha-600":"rgba(24, 53, 59, 0.40)","--color-primary-dark-700-alpha-700":"rgba(24, 53, 59, 0.30)","--color-primary-dark-700-alpha-800":"rgba(24, 53, 59, 0.20)","--color-primary-dark-700-alpha-900":"rgba(24, 53, 59, 0.10)","--color-primary-dark-800":"rgb(22,48,53)","--color-primary-dark-800-alpha-100":"rgba(22, 48, 53, 0.90)","--color-primary-dark-800-alpha-200":"rgba(22, 48, 53, 0.80)","--color-primary-dark-800-alpha-300":"rgba(22, 48, 53, 0.70)","--color-primary-dark-800-alpha-400":"rgba(22, 48, 53, 0.60)","--color-primary-dark-800-alpha-500":"rgba(22, 48, 53, 0.50)","--color-primary-dark-800-alpha-600":"rgba(22, 48, 53, 0.40)","--color-primary-dark-800-alpha-700":"rgba(22, 48, 53, 0.30)","--color-primary-dark-800-alpha-800":"rgba(22, 48, 53, 0.20)","--color-primary-dark-800-alpha-900":"rgba(22, 48, 53, 0.10)","--color-primary-dark-900":"rgb(20,43,48)","--color-primary-dark-900-alpha-100":"rgba(20, 43, 48, 0.90)","--color-primary-dark-900-alpha-200":"rgba(20, 43, 48, 0.80)","--color-primary-dark-900-alpha-300":"rgba(20, 43, 48, 0.70)","--color-primary-dark-900-alpha-400":"rgba(20, 43, 48, 0.60)","--color-primary-dark-900-alpha-500":"rgba(20, 43, 48, 0.50)","--color-primary-dark-900-alpha-600":"rgba(20, 43, 48, 0.40)","--color-primary-dark-900-alpha-700":"rgba(20, 43, 48, 0.30)","--color-primary-dark-900-alpha-800":"rgba(20, 43, 48, 0.20)","--color-primary-dark-900-alpha-900":"rgba(20, 43, 48, 0.10)","--color-primary-dark-1000":"rgb(18,39,43)","--color-primary-dark-1000-alpha-100":"rgba(18, 39, 43, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(18, 39, 43, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(18, 39, 43, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(18, 39, 43, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(18, 39, 43, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(18, 39, 43, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(18, 39, 43, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(18, 39, 43, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(18, 39, 43, 0.10)","--color-primary-light-100":"rgb(92,139,149)","--color-primary-light-100-alpha-100":"rgba(92, 139, 149, 0.90)","--color-primary-light-100-alpha-200":"rgba(92, 139, 149, 0.80)","--color-primary-light-100-alpha-300":"rgba(92, 139, 149, 0.70)","--color-primary-light-100-alpha-400":"rgba(92, 139, 149, 0.60)","--color-primary-light-100-alpha-500":"rgba(92, 139, 149, 0.50)","--color-primary-light-100-alpha-600":"rgba(92, 139, 149, 0.40)","--color-primary-light-100-alpha-700":"rgba(92, 139, 149, 0.30)","--color-primary-light-100-alpha-800":"rgba(92, 139, 149, 0.20)","--color-primary-light-100-alpha-900":"rgba(92, 139, 149, 0.10)","--color-primary-light-200":"rgb(125,162,170)","--color-primary-light-200-alpha-100":"rgba(125, 162, 170, 0.90)","--color-primary-light-200-alpha-200":"rgba(125, 162, 170, 0.80)","--color-primary-light-200-alpha-300":"rgba(125, 162, 170, 0.70)","--color-primary-light-200-alpha-400":"rgba(125, 162, 170, 0.60)","--color-primary-light-200-alpha-500":"rgba(125, 162, 170, 0.50)","--color-primary-light-200-alpha-600":"rgba(125, 162, 170, 0.40)","--color-primary-light-200-alpha-700":"rgba(125, 162, 170, 0.30)","--color-primary-light-200-alpha-800":"rgba(125, 162, 170, 0.20)","--color-primary-light-200-alpha-900":"rgba(125, 162, 170, 0.10)","--color-primary-light-300":"rgb(151,181,187)","--color-primary-light-300-alpha-100":"rgba(151, 181, 187, 0.90)","--color-primary-light-300-alpha-200":"rgba(151, 181, 187, 0.80)","--color-primary-light-300-alpha-300":"rgba(151, 181, 187, 0.70)","--color-primary-light-300-alpha-400":"rgba(151, 181, 187, 0.60)","--color-primary-light-300-alpha-500":"rgba(151, 181, 187, 0.50)","--color-primary-light-300-alpha-600":"rgba(151, 181, 187, 0.40)","--color-primary-light-300-alpha-700":"rgba(151, 181, 187, 0.30)","--color-primary-light-300-alpha-800":"rgba(151, 181, 187, 0.20)","--color-primary-light-300-alpha-900":"rgba(151, 181, 187, 0.10)","--color-primary-light-400":"rgb(172,196,201)","--color-primary-light-400-alpha-100":"rgba(172, 196, 201, 0.90)","--color-primary-light-400-alpha-200":"rgba(172, 196, 201, 0.80)","--color-primary-light-400-alpha-300":"rgba(172, 196, 201, 0.70)","--color-primary-light-400-alpha-400":"rgba(172, 196, 201, 0.60)","--color-primary-light-400-alpha-500":"rgba(172, 196, 201, 0.50)","--color-primary-light-400-alpha-600":"rgba(172, 196, 201, 0.40)","--color-primary-light-400-alpha-700":"rgba(172, 196, 201, 0.30)","--color-primary-light-400-alpha-800":"rgba(172, 196, 201, 0.20)","--color-primary-light-400-alpha-900":"rgba(172, 196, 201, 0.10)","--color-primary-light-500":"rgb(189,208,212)","--color-primary-light-500-alpha-100":"rgba(189, 208, 212, 0.90)","--color-primary-light-500-alpha-200":"rgba(189, 208, 212, 0.80)","--color-primary-light-500-alpha-300":"rgba(189, 208, 212, 0.70)","--color-primary-light-500-alpha-400":"rgba(189, 208, 212, 0.60)","--color-primary-light-500-alpha-500":"rgba(189, 208, 212, 0.50)","--color-primary-light-500-alpha-600":"rgba(189, 208, 212, 0.40)","--color-primary-light-500-alpha-700":"rgba(189, 208, 212, 0.30)","--color-primary-light-500-alpha-800":"rgba(189, 208, 212, 0.20)","--color-primary-light-500-alpha-900":"rgba(189, 208, 212, 0.10)","--color-primary-light-600":"rgb(202,217,221)","--color-primary-light-600-alpha-100":"rgba(202, 217, 221, 0.90)","--color-primary-light-600-alpha-200":"rgba(202, 217, 221, 0.80)","--color-primary-light-600-alpha-300":"rgba(202, 217, 221, 0.70)","--color-primary-light-600-alpha-400":"rgba(202, 217, 221, 0.60)","--color-primary-light-600-alpha-500":"rgba(202, 217, 221, 0.50)","--color-primary-light-600-alpha-600":"rgba(202, 217, 221, 0.40)","--color-primary-light-600-alpha-700":"rgba(202, 217, 221, 0.30)","--color-primary-light-600-alpha-800":"rgba(202, 217, 221, 0.20)","--color-primary-light-600-alpha-900":"rgba(202, 217, 221, 0.10)","--color-primary-light-700":"rgb(213,225,228)","--color-primary-light-700-alpha-100":"rgba(213, 225, 228, 0.90)","--color-primary-light-700-alpha-200":"rgba(213, 225, 228, 0.80)","--color-primary-light-700-alpha-300":"rgba(213, 225, 228, 0.70)","--color-primary-light-700-alpha-400":"rgba(213, 225, 228, 0.60)","--color-primary-light-700-alpha-500":"rgba(213, 225, 228, 0.50)","--color-primary-light-700-alpha-600":"rgba(213, 225, 228, 0.40)","--color-primary-light-700-alpha-700":"rgba(213, 225, 228, 0.30)","--color-primary-light-700-alpha-800":"rgba(213, 225, 228, 0.20)","--color-primary-light-700-alpha-900":"rgba(213, 225, 228, 0.10)","--color-primary-light-800":"rgb(221,231,233)","--color-primary-light-800-alpha-100":"rgba(221, 231, 233, 0.90)","--color-primary-light-800-alpha-200":"rgba(221, 231, 233, 0.80)","--color-primary-light-800-alpha-300":"rgba(221, 231, 233, 0.70)","--color-primary-light-800-alpha-400":"rgba(221, 231, 233, 0.60)","--color-primary-light-800-alpha-500":"rgba(221, 231, 233, 0.50)","--color-primary-light-800-alpha-600":"rgba(221, 231, 233, 0.40)","--color-primary-light-800-alpha-700":"rgba(221, 231, 233, 0.30)","--color-primary-light-800-alpha-800":"rgba(221, 231, 233, 0.20)","--color-primary-light-800-alpha-900":"rgba(221, 231, 233, 0.10)","--color-primary-light-900":"rgb(228,236,237)","--color-primary-light-900-alpha-100":"rgba(228, 236, 237, 0.90)","--color-primary-light-900-alpha-200":"rgba(228, 236, 237, 0.80)","--color-primary-light-900-alpha-300":"rgba(228, 236, 237, 0.70)","--color-primary-light-900-alpha-400":"rgba(228, 236, 237, 0.60)","--color-primary-light-900-alpha-500":"rgba(228, 236, 237, 0.50)","--color-primary-light-900-alpha-600":"rgba(228, 236, 237, 0.40)","--color-primary-light-900-alpha-700":"rgba(228, 236, 237, 0.30)","--color-primary-light-900-alpha-800":"rgba(228, 236, 237, 0.20)","--color-primary-light-900-alpha-900":"rgba(228, 236, 237, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(51, 110, 123)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-700)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#6376a2","--color-badge-tertiary":"#6376a2"}}},{"id":"blue2","name":"清热板蓝","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(79, 98, 208)","--color-primary-dark-100":"rgb(71,88,187)","--color-primary-dark-100-alpha-100":"rgba(71, 88, 187, 0.90)","--color-primary-alpha-100":"rgba(79, 98, 208, 0.90)","--color-primary-dark-100-alpha-200":"rgba(71, 88, 187, 0.80)","--color-primary-alpha-200":"rgba(79, 98, 208, 0.80)","--color-primary-dark-100-alpha-300":"rgba(71, 88, 187, 0.70)","--color-primary-alpha-300":"rgba(79, 98, 208, 0.70)","--color-primary-dark-100-alpha-400":"rgba(71, 88, 187, 0.60)","--color-primary-alpha-400":"rgba(79, 98, 208, 0.60)","--color-primary-dark-100-alpha-500":"rgba(71, 88, 187, 0.50)","--color-primary-alpha-500":"rgba(79, 98, 208, 0.50)","--color-primary-dark-100-alpha-600":"rgba(71, 88, 187, 0.40)","--color-primary-alpha-600":"rgba(79, 98, 208, 0.40)","--color-primary-dark-100-alpha-700":"rgba(71, 88, 187, 0.30)","--color-primary-alpha-700":"rgba(79, 98, 208, 0.30)","--color-primary-dark-100-alpha-800":"rgba(71, 88, 187, 0.20)","--color-primary-alpha-800":"rgba(79, 98, 208, 0.20)","--color-primary-dark-100-alpha-900":"rgba(71, 88, 187, 0.10)","--color-primary-alpha-900":"rgba(79, 98, 208, 0.10)","--color-primary-dark-200":"rgb(64,79,168)","--color-primary-dark-200-alpha-100":"rgba(64, 79, 168, 0.90)","--color-primary-dark-200-alpha-200":"rgba(64, 79, 168, 0.80)","--color-primary-dark-200-alpha-300":"rgba(64, 79, 168, 0.70)","--color-primary-dark-200-alpha-400":"rgba(64, 79, 168, 0.60)","--color-primary-dark-200-alpha-500":"rgba(64, 79, 168, 0.50)","--color-primary-dark-200-alpha-600":"rgba(64, 79, 168, 0.40)","--color-primary-dark-200-alpha-700":"rgba(64, 79, 168, 0.30)","--color-primary-dark-200-alpha-800":"rgba(64, 79, 168, 0.20)","--color-primary-dark-200-alpha-900":"rgba(64, 79, 168, 0.10)","--color-primary-dark-300":"rgb(58,71,151)","--color-primary-dark-300-alpha-100":"rgba(58, 71, 151, 0.90)","--color-primary-dark-300-alpha-200":"rgba(58, 71, 151, 0.80)","--color-primary-dark-300-alpha-300":"rgba(58, 71, 151, 0.70)","--color-primary-dark-300-alpha-400":"rgba(58, 71, 151, 0.60)","--color-primary-dark-300-alpha-500":"rgba(58, 71, 151, 0.50)","--color-primary-dark-300-alpha-600":"rgba(58, 71, 151, 0.40)","--color-primary-dark-300-alpha-700":"rgba(58, 71, 151, 0.30)","--color-primary-dark-300-alpha-800":"rgba(58, 71, 151, 0.20)","--color-primary-dark-300-alpha-900":"rgba(58, 71, 151, 0.10)","--color-primary-dark-400":"rgb(52,64,136)","--color-primary-dark-400-alpha-100":"rgba(52, 64, 136, 0.90)","--color-primary-dark-400-alpha-200":"rgba(52, 64, 136, 0.80)","--color-primary-dark-400-alpha-300":"rgba(52, 64, 136, 0.70)","--color-primary-dark-400-alpha-400":"rgba(52, 64, 136, 0.60)","--color-primary-dark-400-alpha-500":"rgba(52, 64, 136, 0.50)","--color-primary-dark-400-alpha-600":"rgba(52, 64, 136, 0.40)","--color-primary-dark-400-alpha-700":"rgba(52, 64, 136, 0.30)","--color-primary-dark-400-alpha-800":"rgba(52, 64, 136, 0.20)","--color-primary-dark-400-alpha-900":"rgba(52, 64, 136, 0.10)","--color-primary-dark-500":"rgb(47,58,122)","--color-primary-dark-500-alpha-100":"rgba(47, 58, 122, 0.90)","--color-primary-dark-500-alpha-200":"rgba(47, 58, 122, 0.80)","--color-primary-dark-500-alpha-300":"rgba(47, 58, 122, 0.70)","--color-primary-dark-500-alpha-400":"rgba(47, 58, 122, 0.60)","--color-primary-dark-500-alpha-500":"rgba(47, 58, 122, 0.50)","--color-primary-dark-500-alpha-600":"rgba(47, 58, 122, 0.40)","--color-primary-dark-500-alpha-700":"rgba(47, 58, 122, 0.30)","--color-primary-dark-500-alpha-800":"rgba(47, 58, 122, 0.20)","--color-primary-dark-500-alpha-900":"rgba(47, 58, 122, 0.10)","--color-primary-dark-600":"rgb(42,52,110)","--color-primary-dark-600-alpha-100":"rgba(42, 52, 110, 0.90)","--color-primary-dark-600-alpha-200":"rgba(42, 52, 110, 0.80)","--color-primary-dark-600-alpha-300":"rgba(42, 52, 110, 0.70)","--color-primary-dark-600-alpha-400":"rgba(42, 52, 110, 0.60)","--color-primary-dark-600-alpha-500":"rgba(42, 52, 110, 0.50)","--color-primary-dark-600-alpha-600":"rgba(42, 52, 110, 0.40)","--color-primary-dark-600-alpha-700":"rgba(42, 52, 110, 0.30)","--color-primary-dark-600-alpha-800":"rgba(42, 52, 110, 0.20)","--color-primary-dark-600-alpha-900":"rgba(42, 52, 110, 0.10)","--color-primary-dark-700":"rgb(38,47,99)","--color-primary-dark-700-alpha-100":"rgba(38, 47, 99, 0.90)","--color-primary-dark-700-alpha-200":"rgba(38, 47, 99, 0.80)","--color-primary-dark-700-alpha-300":"rgba(38, 47, 99, 0.70)","--color-primary-dark-700-alpha-400":"rgba(38, 47, 99, 0.60)","--color-primary-dark-700-alpha-500":"rgba(38, 47, 99, 0.50)","--color-primary-dark-700-alpha-600":"rgba(38, 47, 99, 0.40)","--color-primary-dark-700-alpha-700":"rgba(38, 47, 99, 0.30)","--color-primary-dark-700-alpha-800":"rgba(38, 47, 99, 0.20)","--color-primary-dark-700-alpha-900":"rgba(38, 47, 99, 0.10)","--color-primary-dark-800":"rgb(34,42,89)","--color-primary-dark-800-alpha-100":"rgba(34, 42, 89, 0.90)","--color-primary-dark-800-alpha-200":"rgba(34, 42, 89, 0.80)","--color-primary-dark-800-alpha-300":"rgba(34, 42, 89, 0.70)","--color-primary-dark-800-alpha-400":"rgba(34, 42, 89, 0.60)","--color-primary-dark-800-alpha-500":"rgba(34, 42, 89, 0.50)","--color-primary-dark-800-alpha-600":"rgba(34, 42, 89, 0.40)","--color-primary-dark-800-alpha-700":"rgba(34, 42, 89, 0.30)","--color-primary-dark-800-alpha-800":"rgba(34, 42, 89, 0.20)","--color-primary-dark-800-alpha-900":"rgba(34, 42, 89, 0.10)","--color-primary-dark-900":"rgb(31,38,80)","--color-primary-dark-900-alpha-100":"rgba(31, 38, 80, 0.90)","--color-primary-dark-900-alpha-200":"rgba(31, 38, 80, 0.80)","--color-primary-dark-900-alpha-300":"rgba(31, 38, 80, 0.70)","--color-primary-dark-900-alpha-400":"rgba(31, 38, 80, 0.60)","--color-primary-dark-900-alpha-500":"rgba(31, 38, 80, 0.50)","--color-primary-dark-900-alpha-600":"rgba(31, 38, 80, 0.40)","--color-primary-dark-900-alpha-700":"rgba(31, 38, 80, 0.30)","--color-primary-dark-900-alpha-800":"rgba(31, 38, 80, 0.20)","--color-primary-dark-900-alpha-900":"rgba(31, 38, 80, 0.10)","--color-primary-dark-1000":"rgb(28,34,72)","--color-primary-dark-1000-alpha-100":"rgba(28, 34, 72, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(28, 34, 72, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(28, 34, 72, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(28, 34, 72, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(28, 34, 72, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(28, 34, 72, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(28, 34, 72, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(28, 34, 72, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(28, 34, 72, 0.10)","--color-primary-light-100":"rgb(114,129,217)","--color-primary-light-100-alpha-100":"rgba(114, 129, 217, 0.90)","--color-primary-light-100-alpha-200":"rgba(114, 129, 217, 0.80)","--color-primary-light-100-alpha-300":"rgba(114, 129, 217, 0.70)","--color-primary-light-100-alpha-400":"rgba(114, 129, 217, 0.60)","--color-primary-light-100-alpha-500":"rgba(114, 129, 217, 0.50)","--color-primary-light-100-alpha-600":"rgba(114, 129, 217, 0.40)","--color-primary-light-100-alpha-700":"rgba(114, 129, 217, 0.30)","--color-primary-light-100-alpha-800":"rgba(114, 129, 217, 0.20)","--color-primary-light-100-alpha-900":"rgba(114, 129, 217, 0.10)","--color-primary-light-200":"rgb(142,154,225)","--color-primary-light-200-alpha-100":"rgba(142, 154, 225, 0.90)","--color-primary-light-200-alpha-200":"rgba(142, 154, 225, 0.80)","--color-primary-light-200-alpha-300":"rgba(142, 154, 225, 0.70)","--color-primary-light-200-alpha-400":"rgba(142, 154, 225, 0.60)","--color-primary-light-200-alpha-500":"rgba(142, 154, 225, 0.50)","--color-primary-light-200-alpha-600":"rgba(142, 154, 225, 0.40)","--color-primary-light-200-alpha-700":"rgba(142, 154, 225, 0.30)","--color-primary-light-200-alpha-800":"rgba(142, 154, 225, 0.20)","--color-primary-light-200-alpha-900":"rgba(142, 154, 225, 0.10)","--color-primary-light-300":"rgb(165,174,231)","--color-primary-light-300-alpha-100":"rgba(165, 174, 231, 0.90)","--color-primary-light-300-alpha-200":"rgba(165, 174, 231, 0.80)","--color-primary-light-300-alpha-300":"rgba(165, 174, 231, 0.70)","--color-primary-light-300-alpha-400":"rgba(165, 174, 231, 0.60)","--color-primary-light-300-alpha-500":"rgba(165, 174, 231, 0.50)","--color-primary-light-300-alpha-600":"rgba(165, 174, 231, 0.40)","--color-primary-light-300-alpha-700":"rgba(165, 174, 231, 0.30)","--color-primary-light-300-alpha-800":"rgba(165, 174, 231, 0.20)","--color-primary-light-300-alpha-900":"rgba(165, 174, 231, 0.10)","--color-primary-light-400":"rgb(183,190,236)","--color-primary-light-400-alpha-100":"rgba(183, 190, 236, 0.90)","--color-primary-light-400-alpha-200":"rgba(183, 190, 236, 0.80)","--color-primary-light-400-alpha-300":"rgba(183, 190, 236, 0.70)","--color-primary-light-400-alpha-400":"rgba(183, 190, 236, 0.60)","--color-primary-light-400-alpha-500":"rgba(183, 190, 236, 0.50)","--color-primary-light-400-alpha-600":"rgba(183, 190, 236, 0.40)","--color-primary-light-400-alpha-700":"rgba(183, 190, 236, 0.30)","--color-primary-light-400-alpha-800":"rgba(183, 190, 236, 0.20)","--color-primary-light-400-alpha-900":"rgba(183, 190, 236, 0.10)","--color-primary-light-500":"rgb(197,203,240)","--color-primary-light-500-alpha-100":"rgba(197, 203, 240, 0.90)","--color-primary-light-500-alpha-200":"rgba(197, 203, 240, 0.80)","--color-primary-light-500-alpha-300":"rgba(197, 203, 240, 0.70)","--color-primary-light-500-alpha-400":"rgba(197, 203, 240, 0.60)","--color-primary-light-500-alpha-500":"rgba(197, 203, 240, 0.50)","--color-primary-light-500-alpha-600":"rgba(197, 203, 240, 0.40)","--color-primary-light-500-alpha-700":"rgba(197, 203, 240, 0.30)","--color-primary-light-500-alpha-800":"rgba(197, 203, 240, 0.20)","--color-primary-light-500-alpha-900":"rgba(197, 203, 240, 0.10)","--color-primary-light-600":"rgb(209,213,243)","--color-primary-light-600-alpha-100":"rgba(209, 213, 243, 0.90)","--color-primary-light-600-alpha-200":"rgba(209, 213, 243, 0.80)","--color-primary-light-600-alpha-300":"rgba(209, 213, 243, 0.70)","--color-primary-light-600-alpha-400":"rgba(209, 213, 243, 0.60)","--color-primary-light-600-alpha-500":"rgba(209, 213, 243, 0.50)","--color-primary-light-600-alpha-600":"rgba(209, 213, 243, 0.40)","--color-primary-light-600-alpha-700":"rgba(209, 213, 243, 0.30)","--color-primary-light-600-alpha-800":"rgba(209, 213, 243, 0.20)","--color-primary-light-600-alpha-900":"rgba(209, 213, 243, 0.10)","--color-primary-light-700":"rgb(218,221,245)","--color-primary-light-700-alpha-100":"rgba(218, 221, 245, 0.90)","--color-primary-light-700-alpha-200":"rgba(218, 221, 245, 0.80)","--color-primary-light-700-alpha-300":"rgba(218, 221, 245, 0.70)","--color-primary-light-700-alpha-400":"rgba(218, 221, 245, 0.60)","--color-primary-light-700-alpha-500":"rgba(218, 221, 245, 0.50)","--color-primary-light-700-alpha-600":"rgba(218, 221, 245, 0.40)","--color-primary-light-700-alpha-700":"rgba(218, 221, 245, 0.30)","--color-primary-light-700-alpha-800":"rgba(218, 221, 245, 0.20)","--color-primary-light-700-alpha-900":"rgba(218, 221, 245, 0.10)","--color-primary-light-800":"rgb(225,228,247)","--color-primary-light-800-alpha-100":"rgba(225, 228, 247, 0.90)","--color-primary-light-800-alpha-200":"rgba(225, 228, 247, 0.80)","--color-primary-light-800-alpha-300":"rgba(225, 228, 247, 0.70)","--color-primary-light-800-alpha-400":"rgba(225, 228, 247, 0.60)","--color-primary-light-800-alpha-500":"rgba(225, 228, 247, 0.50)","--color-primary-light-800-alpha-600":"rgba(225, 228, 247, 0.40)","--color-primary-light-800-alpha-700":"rgba(225, 228, 247, 0.30)","--color-primary-light-800-alpha-800":"rgba(225, 228, 247, 0.20)","--color-primary-light-800-alpha-900":"rgba(225, 228, 247, 0.10)","--color-primary-light-900":"rgb(231,233,249)","--color-primary-light-900-alpha-100":"rgba(231, 233, 249, 0.90)","--color-primary-light-900-alpha-200":"rgba(231, 233, 249, 0.80)","--color-primary-light-900-alpha-300":"rgba(231, 233, 249, 0.70)","--color-primary-light-900-alpha-400":"rgba(231, 233, 249, 0.60)","--color-primary-light-900-alpha-500":"rgba(231, 233, 249, 0.50)","--color-primary-light-900-alpha-600":"rgba(231, 233, 249, 0.40)","--color-primary-light-900-alpha-700":"rgba(231, 233, 249, 0.30)","--color-primary-light-900-alpha-800":"rgba(231, 233, 249, 0.20)","--color-primary-light-900-alpha-900":"rgba(231, 233, 249, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(79, 98, 208)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"var(--color-primary-light-600-alpha-700)","--color-main-background":"rgba(255, 255, 255, 1)","--color-nav-font":"var(--color-primary)","--background-image":"none","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#b080db","--color-badge-tertiary":"#b080db"}}},{"id":"black","name":"黑灯瞎火","isDark":true,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(150, 150, 150)","--color-primary-dark-100":"rgb(171,171,171)","--color-primary-dark-100-alpha-100":"rgba(171, 171, 171, 0.90)","--color-primary-alpha-100":"rgba(150, 150, 150, 0.90)","--color-primary-dark-100-alpha-200":"rgba(171, 171, 171, 0.80)","--color-primary-alpha-200":"rgba(150, 150, 150, 0.80)","--color-primary-dark-100-alpha-300":"rgba(171, 171, 171, 0.70)","--color-primary-alpha-300":"rgba(150, 150, 150, 0.70)","--color-primary-dark-100-alpha-400":"rgba(171, 171, 171, 0.60)","--color-primary-alpha-400":"rgba(150, 150, 150, 0.60)","--color-primary-dark-100-alpha-500":"rgba(171, 171, 171, 0.50)","--color-primary-alpha-500":"rgba(150, 150, 150, 0.50)","--color-primary-dark-100-alpha-600":"rgba(171, 171, 171, 0.40)","--color-primary-alpha-600":"rgba(150, 150, 150, 0.40)","--color-primary-dark-100-alpha-700":"rgba(171, 171, 171, 0.30)","--color-primary-alpha-700":"rgba(150, 150, 150, 0.30)","--color-primary-dark-100-alpha-800":"rgba(171, 171, 171, 0.20)","--color-primary-alpha-800":"rgba(150, 150, 150, 0.20)","--color-primary-dark-100-alpha-900":"rgba(171, 171, 171, 0.10)","--color-primary-alpha-900":"rgba(150, 150, 150, 0.10)","--color-primary-dark-200":"rgb(188,188,188)","--color-primary-dark-200-alpha-100":"rgba(188, 188, 188, 0.90)","--color-primary-dark-200-alpha-200":"rgba(188, 188, 188, 0.80)","--color-primary-dark-200-alpha-300":"rgba(188, 188, 188, 0.70)","--color-primary-dark-200-alpha-400":"rgba(188, 188, 188, 0.60)","--color-primary-dark-200-alpha-500":"rgba(188, 188, 188, 0.50)","--color-primary-dark-200-alpha-600":"rgba(188, 188, 188, 0.40)","--color-primary-dark-200-alpha-700":"rgba(188, 188, 188, 0.30)","--color-primary-dark-200-alpha-800":"rgba(188, 188, 188, 0.20)","--color-primary-dark-200-alpha-900":"rgba(188, 188, 188, 0.10)","--color-primary-dark-300":"rgb(201,201,201)","--color-primary-dark-300-alpha-100":"rgba(201, 201, 201, 0.90)","--color-primary-dark-300-alpha-200":"rgba(201, 201, 201, 0.80)","--color-primary-dark-300-alpha-300":"rgba(201, 201, 201, 0.70)","--color-primary-dark-300-alpha-400":"rgba(201, 201, 201, 0.60)","--color-primary-dark-300-alpha-500":"rgba(201, 201, 201, 0.50)","--color-primary-dark-300-alpha-600":"rgba(201, 201, 201, 0.40)","--color-primary-dark-300-alpha-700":"rgba(201, 201, 201, 0.30)","--color-primary-dark-300-alpha-800":"rgba(201, 201, 201, 0.20)","--color-primary-dark-300-alpha-900":"rgba(201, 201, 201, 0.10)","--color-primary-dark-400":"rgb(212,212,212)","--color-primary-dark-400-alpha-100":"rgba(212, 212, 212, 0.90)","--color-primary-dark-400-alpha-200":"rgba(212, 212, 212, 0.80)","--color-primary-dark-400-alpha-300":"rgba(212, 212, 212, 0.70)","--color-primary-dark-400-alpha-400":"rgba(212, 212, 212, 0.60)","--color-primary-dark-400-alpha-500":"rgba(212, 212, 212, 0.50)","--color-primary-dark-400-alpha-600":"rgba(212, 212, 212, 0.40)","--color-primary-dark-400-alpha-700":"rgba(212, 212, 212, 0.30)","--color-primary-dark-400-alpha-800":"rgba(212, 212, 212, 0.20)","--color-primary-dark-400-alpha-900":"rgba(212, 212, 212, 0.10)","--color-primary-dark-500":"rgb(221,221,221)","--color-primary-dark-500-alpha-100":"rgba(221, 221, 221, 0.90)","--color-primary-dark-500-alpha-200":"rgba(221, 221, 221, 0.80)","--color-primary-dark-500-alpha-300":"rgba(221, 221, 221, 0.70)","--color-primary-dark-500-alpha-400":"rgba(221, 221, 221, 0.60)","--color-primary-dark-500-alpha-500":"rgba(221, 221, 221, 0.50)","--color-primary-dark-500-alpha-600":"rgba(221, 221, 221, 0.40)","--color-primary-dark-500-alpha-700":"rgba(221, 221, 221, 0.30)","--color-primary-dark-500-alpha-800":"rgba(221, 221, 221, 0.20)","--color-primary-dark-500-alpha-900":"rgba(221, 221, 221, 0.10)","--color-primary-dark-600":"rgb(228,228,228)","--color-primary-dark-600-alpha-100":"rgba(228, 228, 228, 0.90)","--color-primary-dark-600-alpha-200":"rgba(228, 228, 228, 0.80)","--color-primary-dark-600-alpha-300":"rgba(228, 228, 228, 0.70)","--color-primary-dark-600-alpha-400":"rgba(228, 228, 228, 0.60)","--color-primary-dark-600-alpha-500":"rgba(228, 228, 228, 0.50)","--color-primary-dark-600-alpha-600":"rgba(228, 228, 228, 0.40)","--color-primary-dark-600-alpha-700":"rgba(228, 228, 228, 0.30)","--color-primary-dark-600-alpha-800":"rgba(228, 228, 228, 0.20)","--color-primary-dark-600-alpha-900":"rgba(228, 228, 228, 0.10)","--color-primary-dark-700":"rgb(233,233,233)","--color-primary-dark-700-alpha-100":"rgba(233, 233, 233, 0.90)","--color-primary-dark-700-alpha-200":"rgba(233, 233, 233, 0.80)","--color-primary-dark-700-alpha-300":"rgba(233, 233, 233, 0.70)","--color-primary-dark-700-alpha-400":"rgba(233, 233, 233, 0.60)","--color-primary-dark-700-alpha-500":"rgba(233, 233, 233, 0.50)","--color-primary-dark-700-alpha-600":"rgba(233, 233, 233, 0.40)","--color-primary-dark-700-alpha-700":"rgba(233, 233, 233, 0.30)","--color-primary-dark-700-alpha-800":"rgba(233, 233, 233, 0.20)","--color-primary-dark-700-alpha-900":"rgba(233, 233, 233, 0.10)","--color-primary-dark-800":"rgb(237,237,237)","--color-primary-dark-800-alpha-100":"rgba(237, 237, 237, 0.90)","--color-primary-dark-800-alpha-200":"rgba(237, 237, 237, 0.80)","--color-primary-dark-800-alpha-300":"rgba(237, 237, 237, 0.70)","--color-primary-dark-800-alpha-400":"rgba(237, 237, 237, 0.60)","--color-primary-dark-800-alpha-500":"rgba(237, 237, 237, 0.50)","--color-primary-dark-800-alpha-600":"rgba(237, 237, 237, 0.40)","--color-primary-dark-800-alpha-700":"rgba(237, 237, 237, 0.30)","--color-primary-dark-800-alpha-800":"rgba(237, 237, 237, 0.20)","--color-primary-dark-800-alpha-900":"rgba(237, 237, 237, 0.10)","--color-primary-dark-900":"rgb(241,241,241)","--color-primary-dark-900-alpha-100":"rgba(241, 241, 241, 0.90)","--color-primary-dark-900-alpha-200":"rgba(241, 241, 241, 0.80)","--color-primary-dark-900-alpha-300":"rgba(241, 241, 241, 0.70)","--color-primary-dark-900-alpha-400":"rgba(241, 241, 241, 0.60)","--color-primary-dark-900-alpha-500":"rgba(241, 241, 241, 0.50)","--color-primary-dark-900-alpha-600":"rgba(241, 241, 241, 0.40)","--color-primary-dark-900-alpha-700":"rgba(241, 241, 241, 0.30)","--color-primary-dark-900-alpha-800":"rgba(241, 241, 241, 0.20)","--color-primary-dark-900-alpha-900":"rgba(241, 241, 241, 0.10)","--color-primary-dark-1000":"rgb(244,244,244)","--color-primary-dark-1000-alpha-100":"rgba(244, 244, 244, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(244, 244, 244, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(244, 244, 244, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(244, 244, 244, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(244, 244, 244, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(244, 244, 244, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(244, 244, 244, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(244, 244, 244, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(244, 244, 244, 0.10)","--color-primary-light-100":"rgb(135,135,135)","--color-primary-light-100-alpha-100":"rgba(135, 135, 135, 0.90)","--color-primary-light-100-alpha-200":"rgba(135, 135, 135, 0.80)","--color-primary-light-100-alpha-300":"rgba(135, 135, 135, 0.70)","--color-primary-light-100-alpha-400":"rgba(135, 135, 135, 0.60)","--color-primary-light-100-alpha-500":"rgba(135, 135, 135, 0.50)","--color-primary-light-100-alpha-600":"rgba(135, 135, 135, 0.40)","--color-primary-light-100-alpha-700":"rgba(135, 135, 135, 0.30)","--color-primary-light-100-alpha-800":"rgba(135, 135, 135, 0.20)","--color-primary-light-100-alpha-900":"rgba(135, 135, 135, 0.10)","--color-primary-light-200":"rgb(122,122,122)","--color-primary-light-200-alpha-100":"rgba(122, 122, 122, 0.90)","--color-primary-light-200-alpha-200":"rgba(122, 122, 122, 0.80)","--color-primary-light-200-alpha-300":"rgba(122, 122, 122, 0.70)","--color-primary-light-200-alpha-400":"rgba(122, 122, 122, 0.60)","--color-primary-light-200-alpha-500":"rgba(122, 122, 122, 0.50)","--color-primary-light-200-alpha-600":"rgba(122, 122, 122, 0.40)","--color-primary-light-200-alpha-700":"rgba(122, 122, 122, 0.30)","--color-primary-light-200-alpha-800":"rgba(122, 122, 122, 0.20)","--color-primary-light-200-alpha-900":"rgba(122, 122, 122, 0.10)","--color-primary-light-300":"rgb(110,110,110)","--color-primary-light-300-alpha-100":"rgba(110, 110, 110, 0.90)","--color-primary-light-300-alpha-200":"rgba(110, 110, 110, 0.80)","--color-primary-light-300-alpha-300":"rgba(110, 110, 110, 0.70)","--color-primary-light-300-alpha-400":"rgba(110, 110, 110, 0.60)","--color-primary-light-300-alpha-500":"rgba(110, 110, 110, 0.50)","--color-primary-light-300-alpha-600":"rgba(110, 110, 110, 0.40)","--color-primary-light-300-alpha-700":"rgba(110, 110, 110, 0.30)","--color-primary-light-300-alpha-800":"rgba(110, 110, 110, 0.20)","--color-primary-light-300-alpha-900":"rgba(110, 110, 110, 0.10)","--color-primary-light-400":"rgb(99,99,99)","--color-primary-light-400-alpha-100":"rgba(99, 99, 99, 0.90)","--color-primary-light-400-alpha-200":"rgba(99, 99, 99, 0.80)","--color-primary-light-400-alpha-300":"rgba(99, 99, 99, 0.70)","--color-primary-light-400-alpha-400":"rgba(99, 99, 99, 0.60)","--color-primary-light-400-alpha-500":"rgba(99, 99, 99, 0.50)","--color-primary-light-400-alpha-600":"rgba(99, 99, 99, 0.40)","--color-primary-light-400-alpha-700":"rgba(99, 99, 99, 0.30)","--color-primary-light-400-alpha-800":"rgba(99, 99, 99, 0.20)","--color-primary-light-400-alpha-900":"rgba(99, 99, 99, 0.10)","--color-primary-light-500":"rgb(89,89,89)","--color-primary-light-500-alpha-100":"rgba(89, 89, 89, 0.90)","--color-primary-light-500-alpha-200":"rgba(89, 89, 89, 0.80)","--color-primary-light-500-alpha-300":"rgba(89, 89, 89, 0.70)","--color-primary-light-500-alpha-400":"rgba(89, 89, 89, 0.60)","--color-primary-light-500-alpha-500":"rgba(89, 89, 89, 0.50)","--color-primary-light-500-alpha-600":"rgba(89, 89, 89, 0.40)","--color-primary-light-500-alpha-700":"rgba(89, 89, 89, 0.30)","--color-primary-light-500-alpha-800":"rgba(89, 89, 89, 0.20)","--color-primary-light-500-alpha-900":"rgba(89, 89, 89, 0.10)","--color-primary-light-600":"rgb(80,80,80)","--color-primary-light-600-alpha-100":"rgba(80, 80, 80, 0.90)","--color-primary-light-600-alpha-200":"rgba(80, 80, 80, 0.80)","--color-primary-light-600-alpha-300":"rgba(80, 80, 80, 0.70)","--color-primary-light-600-alpha-400":"rgba(80, 80, 80, 0.60)","--color-primary-light-600-alpha-500":"rgba(80, 80, 80, 0.50)","--color-primary-light-600-alpha-600":"rgba(80, 80, 80, 0.40)","--color-primary-light-600-alpha-700":"rgba(80, 80, 80, 0.30)","--color-primary-light-600-alpha-800":"rgba(80, 80, 80, 0.20)","--color-primary-light-600-alpha-900":"rgba(80, 80, 80, 0.10)","--color-primary-light-700":"rgb(72,72,72)","--color-primary-light-700-alpha-100":"rgba(72, 72, 72, 0.90)","--color-primary-light-700-alpha-200":"rgba(72, 72, 72, 0.80)","--color-primary-light-700-alpha-300":"rgba(72, 72, 72, 0.70)","--color-primary-light-700-alpha-400":"rgba(72, 72, 72, 0.60)","--color-primary-light-700-alpha-500":"rgba(72, 72, 72, 0.50)","--color-primary-light-700-alpha-600":"rgba(72, 72, 72, 0.40)","--color-primary-light-700-alpha-700":"rgba(72, 72, 72, 0.30)","--color-primary-light-700-alpha-800":"rgba(72, 72, 72, 0.20)","--color-primary-light-700-alpha-900":"rgba(72, 72, 72, 0.10)","--color-primary-light-800":"rgb(65,65,65)","--color-primary-light-800-alpha-100":"rgba(65, 65, 65, 0.90)","--color-primary-light-800-alpha-200":"rgba(65, 65, 65, 0.80)","--color-primary-light-800-alpha-300":"rgba(65, 65, 65, 0.70)","--color-primary-light-800-alpha-400":"rgba(65, 65, 65, 0.60)","--color-primary-light-800-alpha-500":"rgba(65, 65, 65, 0.50)","--color-primary-light-800-alpha-600":"rgba(65, 65, 65, 0.40)","--color-primary-light-800-alpha-700":"rgba(65, 65, 65, 0.30)","--color-primary-light-800-alpha-800":"rgba(65, 65, 65, 0.20)","--color-primary-light-800-alpha-900":"rgba(65, 65, 65, 0.10)","--color-primary-light-900":"rgb(59,59,59)","--color-primary-light-900-alpha-100":"rgba(59, 59, 59, 0.90)","--color-primary-light-900-alpha-200":"rgba(59, 59, 59, 0.80)","--color-primary-light-900-alpha-300":"rgba(59, 59, 59, 0.70)","--color-primary-light-900-alpha-400":"rgba(59, 59, 59, 0.60)","--color-primary-light-900-alpha-500":"rgba(59, 59, 59, 0.50)","--color-primary-light-900-alpha-600":"rgba(59, 59, 59, 0.40)","--color-primary-light-900-alpha-700":"rgba(59, 59, 59, 0.30)","--color-primary-light-900-alpha-800":"rgba(59, 59, 59, 0.20)","--color-primary-light-900-alpha-900":"rgba(59, 59, 59, 0.10)","--color-primary-light-1000":"rgb(38,38,38)","--color-primary-light-1000-alpha-100":"rgba(38, 38, 38, 0.90)","--color-primary-light-1000-alpha-200":"rgba(38, 38, 38, 0.80)","--color-primary-light-1000-alpha-300":"rgba(38, 38, 38, 0.70)","--color-primary-light-1000-alpha-400":"rgba(38, 38, 38, 0.60)","--color-primary-light-1000-alpha-500":"rgba(38, 38, 38, 0.50)","--color-primary-light-1000-alpha-600":"rgba(38, 38, 38, 0.40)","--color-primary-light-1000-alpha-700":"rgba(38, 38, 38, 0.30)","--color-primary-light-1000-alpha-800":"rgba(38, 38, 38, 0.20)","--color-primary-light-1000-alpha-900":"rgba(38, 38, 38, 0.10)","--color-theme":"rgb(59,59,59)","--color-1000":"rgb(229, 229, 229)","--color-950":"rgb(218,218,218)","--color-900":"rgb(207,207,207)","--color-850":"rgb(197,197,197)","--color-800":"rgb(187,187,187)","--color-750":"rgb(178,178,178)","--color-700":"rgb(169,169,169)","--color-650":"rgb(161,161,161)","--color-600":"rgb(153,153,153)","--color-550":"rgb(145,145,145)","--color-500":"rgb(138,138,138)","--color-450":"rgb(131,131,131)","--color-400":"rgb(124,124,124)","--color-350":"rgb(118,118,118)","--color-300":"rgb(112,112,112)","--color-250":"rgb(106,106,106)","--color-200":"rgb(101,101,101)","--color-150":"rgb(96,96,96)","--color-100":"rgb(91,91,91)","--color-050":"rgb(86,86,86)","--color-000":"rgb(82,82,82)"},"extInfo":{"--color-app-background":"rgba(0, 0, 0, 0)","--color-main-background":"rgba(19, 19, 19, 0.9)","--color-nav-font":"var(--color-primary)","--background-image":"url(./theme_images/landingMoon.png)","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary-dark-200)","--color-badge-secondary":"var(--color-primary)","--color-badge-tertiary":"var(--color-primary-dark-300)"}}},{"id":"mid_autumn","name":"月里嫦娥","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(74, 55, 82)","--color-primary-dark-100":"rgb(67,50,74)","--color-primary-dark-100-alpha-100":"rgba(67, 50, 74, 0.90)","--color-primary-alpha-100":"rgba(74, 55, 82, 0.90)","--color-primary-dark-100-alpha-200":"rgba(67, 50, 74, 0.80)","--color-primary-alpha-200":"rgba(74, 55, 82, 0.80)","--color-primary-dark-100-alpha-300":"rgba(67, 50, 74, 0.70)","--color-primary-alpha-300":"rgba(74, 55, 82, 0.70)","--color-primary-dark-100-alpha-400":"rgba(67, 50, 74, 0.60)","--color-primary-alpha-400":"rgba(74, 55, 82, 0.60)","--color-primary-dark-100-alpha-500":"rgba(67, 50, 74, 0.50)","--color-primary-alpha-500":"rgba(74, 55, 82, 0.50)","--color-primary-dark-100-alpha-600":"rgba(67, 50, 74, 0.40)","--color-primary-alpha-600":"rgba(74, 55, 82, 0.40)","--color-primary-dark-100-alpha-700":"rgba(67, 50, 74, 0.30)","--color-primary-alpha-700":"rgba(74, 55, 82, 0.30)","--color-primary-dark-100-alpha-800":"rgba(67, 50, 74, 0.20)","--color-primary-alpha-800":"rgba(74, 55, 82, 0.20)","--color-primary-dark-100-alpha-900":"rgba(67, 50, 74, 0.10)","--color-primary-alpha-900":"rgba(74, 55, 82, 0.10)","--color-primary-dark-200":"rgb(60,45,67)","--color-primary-dark-200-alpha-100":"rgba(60, 45, 67, 0.90)","--color-primary-dark-200-alpha-200":"rgba(60, 45, 67, 0.80)","--color-primary-dark-200-alpha-300":"rgba(60, 45, 67, 0.70)","--color-primary-dark-200-alpha-400":"rgba(60, 45, 67, 0.60)","--color-primary-dark-200-alpha-500":"rgba(60, 45, 67, 0.50)","--color-primary-dark-200-alpha-600":"rgba(60, 45, 67, 0.40)","--color-primary-dark-200-alpha-700":"rgba(60, 45, 67, 0.30)","--color-primary-dark-200-alpha-800":"rgba(60, 45, 67, 0.20)","--color-primary-dark-200-alpha-900":"rgba(60, 45, 67, 0.10)","--color-primary-dark-300":"rgb(54,41,60)","--color-primary-dark-300-alpha-100":"rgba(54, 41, 60, 0.90)","--color-primary-dark-300-alpha-200":"rgba(54, 41, 60, 0.80)","--color-primary-dark-300-alpha-300":"rgba(54, 41, 60, 0.70)","--color-primary-dark-300-alpha-400":"rgba(54, 41, 60, 0.60)","--color-primary-dark-300-alpha-500":"rgba(54, 41, 60, 0.50)","--color-primary-dark-300-alpha-600":"rgba(54, 41, 60, 0.40)","--color-primary-dark-300-alpha-700":"rgba(54, 41, 60, 0.30)","--color-primary-dark-300-alpha-800":"rgba(54, 41, 60, 0.20)","--color-primary-dark-300-alpha-900":"rgba(54, 41, 60, 0.10)","--color-primary-dark-400":"rgb(49,37,54)","--color-primary-dark-400-alpha-100":"rgba(49, 37, 54, 0.90)","--color-primary-dark-400-alpha-200":"rgba(49, 37, 54, 0.80)","--color-primary-dark-400-alpha-300":"rgba(49, 37, 54, 0.70)","--color-primary-dark-400-alpha-400":"rgba(49, 37, 54, 0.60)","--color-primary-dark-400-alpha-500":"rgba(49, 37, 54, 0.50)","--color-primary-dark-400-alpha-600":"rgba(49, 37, 54, 0.40)","--color-primary-dark-400-alpha-700":"rgba(49, 37, 54, 0.30)","--color-primary-dark-400-alpha-800":"rgba(49, 37, 54, 0.20)","--color-primary-dark-400-alpha-900":"rgba(49, 37, 54, 0.10)","--color-primary-dark-500":"rgb(44,33,49)","--color-primary-dark-500-alpha-100":"rgba(44, 33, 49, 0.90)","--color-primary-dark-500-alpha-200":"rgba(44, 33, 49, 0.80)","--color-primary-dark-500-alpha-300":"rgba(44, 33, 49, 0.70)","--color-primary-dark-500-alpha-400":"rgba(44, 33, 49, 0.60)","--color-primary-dark-500-alpha-500":"rgba(44, 33, 49, 0.50)","--color-primary-dark-500-alpha-600":"rgba(44, 33, 49, 0.40)","--color-primary-dark-500-alpha-700":"rgba(44, 33, 49, 0.30)","--color-primary-dark-500-alpha-800":"rgba(44, 33, 49, 0.20)","--color-primary-dark-500-alpha-900":"rgba(44, 33, 49, 0.10)","--color-primary-dark-600":"rgb(40,30,44)","--color-primary-dark-600-alpha-100":"rgba(40, 30, 44, 0.90)","--color-primary-dark-600-alpha-200":"rgba(40, 30, 44, 0.80)","--color-primary-dark-600-alpha-300":"rgba(40, 30, 44, 0.70)","--color-primary-dark-600-alpha-400":"rgba(40, 30, 44, 0.60)","--color-primary-dark-600-alpha-500":"rgba(40, 30, 44, 0.50)","--color-primary-dark-600-alpha-600":"rgba(40, 30, 44, 0.40)","--color-primary-dark-600-alpha-700":"rgba(40, 30, 44, 0.30)","--color-primary-dark-600-alpha-800":"rgba(40, 30, 44, 0.20)","--color-primary-dark-600-alpha-900":"rgba(40, 30, 44, 0.10)","--color-primary-dark-700":"rgb(36,27,40)","--color-primary-dark-700-alpha-100":"rgba(36, 27, 40, 0.90)","--color-primary-dark-700-alpha-200":"rgba(36, 27, 40, 0.80)","--color-primary-dark-700-alpha-300":"rgba(36, 27, 40, 0.70)","--color-primary-dark-700-alpha-400":"rgba(36, 27, 40, 0.60)","--color-primary-dark-700-alpha-500":"rgba(36, 27, 40, 0.50)","--color-primary-dark-700-alpha-600":"rgba(36, 27, 40, 0.40)","--color-primary-dark-700-alpha-700":"rgba(36, 27, 40, 0.30)","--color-primary-dark-700-alpha-800":"rgba(36, 27, 40, 0.20)","--color-primary-dark-700-alpha-900":"rgba(36, 27, 40, 0.10)","--color-primary-dark-800":"rgb(32,24,36)","--color-primary-dark-800-alpha-100":"rgba(32, 24, 36, 0.90)","--color-primary-dark-800-alpha-200":"rgba(32, 24, 36, 0.80)","--color-primary-dark-800-alpha-300":"rgba(32, 24, 36, 0.70)","--color-primary-dark-800-alpha-400":"rgba(32, 24, 36, 0.60)","--color-primary-dark-800-alpha-500":"rgba(32, 24, 36, 0.50)","--color-primary-dark-800-alpha-600":"rgba(32, 24, 36, 0.40)","--color-primary-dark-800-alpha-700":"rgba(32, 24, 36, 0.30)","--color-primary-dark-800-alpha-800":"rgba(32, 24, 36, 0.20)","--color-primary-dark-800-alpha-900":"rgba(32, 24, 36, 0.10)","--color-primary-dark-900":"rgb(29,22,32)","--color-primary-dark-900-alpha-100":"rgba(29, 22, 32, 0.90)","--color-primary-dark-900-alpha-200":"rgba(29, 22, 32, 0.80)","--color-primary-dark-900-alpha-300":"rgba(29, 22, 32, 0.70)","--color-primary-dark-900-alpha-400":"rgba(29, 22, 32, 0.60)","--color-primary-dark-900-alpha-500":"rgba(29, 22, 32, 0.50)","--color-primary-dark-900-alpha-600":"rgba(29, 22, 32, 0.40)","--color-primary-dark-900-alpha-700":"rgba(29, 22, 32, 0.30)","--color-primary-dark-900-alpha-800":"rgba(29, 22, 32, 0.20)","--color-primary-dark-900-alpha-900":"rgba(29, 22, 32, 0.10)","--color-primary-dark-1000":"rgb(26,20,29)","--color-primary-dark-1000-alpha-100":"rgba(26, 20, 29, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(26, 20, 29, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(26, 20, 29, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(26, 20, 29, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(26, 20, 29, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(26, 20, 29, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(26, 20, 29, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(26, 20, 29, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(26, 20, 29, 0.10)","--color-primary-light-100":"rgb(110,95,117)","--color-primary-light-100-alpha-100":"rgba(110, 95, 117, 0.90)","--color-primary-light-100-alpha-200":"rgba(110, 95, 117, 0.80)","--color-primary-light-100-alpha-300":"rgba(110, 95, 117, 0.70)","--color-primary-light-100-alpha-400":"rgba(110, 95, 117, 0.60)","--color-primary-light-100-alpha-500":"rgba(110, 95, 117, 0.50)","--color-primary-light-100-alpha-600":"rgba(110, 95, 117, 0.40)","--color-primary-light-100-alpha-700":"rgba(110, 95, 117, 0.30)","--color-primary-light-100-alpha-800":"rgba(110, 95, 117, 0.20)","--color-primary-light-100-alpha-900":"rgba(110, 95, 117, 0.10)","--color-primary-light-200":"rgb(139,127,145)","--color-primary-light-200-alpha-100":"rgba(139, 127, 145, 0.90)","--color-primary-light-200-alpha-200":"rgba(139, 127, 145, 0.80)","--color-primary-light-200-alpha-300":"rgba(139, 127, 145, 0.70)","--color-primary-light-200-alpha-400":"rgba(139, 127, 145, 0.60)","--color-primary-light-200-alpha-500":"rgba(139, 127, 145, 0.50)","--color-primary-light-200-alpha-600":"rgba(139, 127, 145, 0.40)","--color-primary-light-200-alpha-700":"rgba(139, 127, 145, 0.30)","--color-primary-light-200-alpha-800":"rgba(139, 127, 145, 0.20)","--color-primary-light-200-alpha-900":"rgba(139, 127, 145, 0.10)","--color-primary-light-300":"rgb(162,153,167)","--color-primary-light-300-alpha-100":"rgba(162, 153, 167, 0.90)","--color-primary-light-300-alpha-200":"rgba(162, 153, 167, 0.80)","--color-primary-light-300-alpha-300":"rgba(162, 153, 167, 0.70)","--color-primary-light-300-alpha-400":"rgba(162, 153, 167, 0.60)","--color-primary-light-300-alpha-500":"rgba(162, 153, 167, 0.50)","--color-primary-light-300-alpha-600":"rgba(162, 153, 167, 0.40)","--color-primary-light-300-alpha-700":"rgba(162, 153, 167, 0.30)","--color-primary-light-300-alpha-800":"rgba(162, 153, 167, 0.20)","--color-primary-light-300-alpha-900":"rgba(162, 153, 167, 0.10)","--color-primary-light-400":"rgb(181,173,185)","--color-primary-light-400-alpha-100":"rgba(181, 173, 185, 0.90)","--color-primary-light-400-alpha-200":"rgba(181, 173, 185, 0.80)","--color-primary-light-400-alpha-300":"rgba(181, 173, 185, 0.70)","--color-primary-light-400-alpha-400":"rgba(181, 173, 185, 0.60)","--color-primary-light-400-alpha-500":"rgba(181, 173, 185, 0.50)","--color-primary-light-400-alpha-600":"rgba(181, 173, 185, 0.40)","--color-primary-light-400-alpha-700":"rgba(181, 173, 185, 0.30)","--color-primary-light-400-alpha-800":"rgba(181, 173, 185, 0.20)","--color-primary-light-400-alpha-900":"rgba(181, 173, 185, 0.10)","--color-primary-light-500":"rgb(196,189,199)","--color-primary-light-500-alpha-100":"rgba(196, 189, 199, 0.90)","--color-primary-light-500-alpha-200":"rgba(196, 189, 199, 0.80)","--color-primary-light-500-alpha-300":"rgba(196, 189, 199, 0.70)","--color-primary-light-500-alpha-400":"rgba(196, 189, 199, 0.60)","--color-primary-light-500-alpha-500":"rgba(196, 189, 199, 0.50)","--color-primary-light-500-alpha-600":"rgba(196, 189, 199, 0.40)","--color-primary-light-500-alpha-700":"rgba(196, 189, 199, 0.30)","--color-primary-light-500-alpha-800":"rgba(196, 189, 199, 0.20)","--color-primary-light-500-alpha-900":"rgba(196, 189, 199, 0.10)","--color-primary-light-600":"rgb(208,202,210)","--color-primary-light-600-alpha-100":"rgba(208, 202, 210, 0.90)","--color-primary-light-600-alpha-200":"rgba(208, 202, 210, 0.80)","--color-primary-light-600-alpha-300":"rgba(208, 202, 210, 0.70)","--color-primary-light-600-alpha-400":"rgba(208, 202, 210, 0.60)","--color-primary-light-600-alpha-500":"rgba(208, 202, 210, 0.50)","--color-primary-light-600-alpha-600":"rgba(208, 202, 210, 0.40)","--color-primary-light-600-alpha-700":"rgba(208, 202, 210, 0.30)","--color-primary-light-600-alpha-800":"rgba(208, 202, 210, 0.20)","--color-primary-light-600-alpha-900":"rgba(208, 202, 210, 0.10)","--color-primary-light-700":"rgb(217,213,219)","--color-primary-light-700-alpha-100":"rgba(217, 213, 219, 0.90)","--color-primary-light-700-alpha-200":"rgba(217, 213, 219, 0.80)","--color-primary-light-700-alpha-300":"rgba(217, 213, 219, 0.70)","--color-primary-light-700-alpha-400":"rgba(217, 213, 219, 0.60)","--color-primary-light-700-alpha-500":"rgba(217, 213, 219, 0.50)","--color-primary-light-700-alpha-600":"rgba(217, 213, 219, 0.40)","--color-primary-light-700-alpha-700":"rgba(217, 213, 219, 0.30)","--color-primary-light-700-alpha-800":"rgba(217, 213, 219, 0.20)","--color-primary-light-700-alpha-900":"rgba(217, 213, 219, 0.10)","--color-primary-light-800":"rgb(225,221,226)","--color-primary-light-800-alpha-100":"rgba(225, 221, 226, 0.90)","--color-primary-light-800-alpha-200":"rgba(225, 221, 226, 0.80)","--color-primary-light-800-alpha-300":"rgba(225, 221, 226, 0.70)","--color-primary-light-800-alpha-400":"rgba(225, 221, 226, 0.60)","--color-primary-light-800-alpha-500":"rgba(225, 221, 226, 0.50)","--color-primary-light-800-alpha-600":"rgba(225, 221, 226, 0.40)","--color-primary-light-800-alpha-700":"rgba(225, 221, 226, 0.30)","--color-primary-light-800-alpha-800":"rgba(225, 221, 226, 0.20)","--color-primary-light-800-alpha-900":"rgba(225, 221, 226, 0.10)","--color-primary-light-900":"rgb(231,228,232)","--color-primary-light-900-alpha-100":"rgba(231, 228, 232, 0.90)","--color-primary-light-900-alpha-200":"rgba(231, 228, 232, 0.80)","--color-primary-light-900-alpha-300":"rgba(231, 228, 232, 0.70)","--color-primary-light-900-alpha-400":"rgba(231, 228, 232, 0.60)","--color-primary-light-900-alpha-500":"rgba(231, 228, 232, 0.50)","--color-primary-light-900-alpha-600":"rgba(231, 228, 232, 0.40)","--color-primary-light-900-alpha-700":"rgba(231, 228, 232, 0.30)","--color-primary-light-900-alpha-800":"rgba(231, 228, 232, 0.20)","--color-primary-light-900-alpha-900":"rgba(231, 228, 232, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(74, 55, 82)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"rgba(255, 255, 255, 0)","--color-main-background":"rgba(255, 255, 255, 0.9)","--color-nav-font":"var(--color-primary-light-600)","--background-image":"url(./theme_images/jqbg.jpg)","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"#af9479","--color-badge-tertiary":"#af9479"}}},{"id":"naruto","name":"木叶之村","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(87, 144, 167)","--color-primary-dark-100":"rgb(78,130,150)","--color-primary-dark-100-alpha-100":"rgba(78, 130, 150, 0.90)","--color-primary-alpha-100":"rgba(87, 144, 167, 0.90)","--color-primary-dark-100-alpha-200":"rgba(78, 130, 150, 0.80)","--color-primary-alpha-200":"rgba(87, 144, 167, 0.80)","--color-primary-dark-100-alpha-300":"rgba(78, 130, 150, 0.70)","--color-primary-alpha-300":"rgba(87, 144, 167, 0.70)","--color-primary-dark-100-alpha-400":"rgba(78, 130, 150, 0.60)","--color-primary-alpha-400":"rgba(87, 144, 167, 0.60)","--color-primary-dark-100-alpha-500":"rgba(78, 130, 150, 0.50)","--color-primary-alpha-500":"rgba(87, 144, 167, 0.50)","--color-primary-dark-100-alpha-600":"rgba(78, 130, 150, 0.40)","--color-primary-alpha-600":"rgba(87, 144, 167, 0.40)","--color-primary-dark-100-alpha-700":"rgba(78, 130, 150, 0.30)","--color-primary-alpha-700":"rgba(87, 144, 167, 0.30)","--color-primary-dark-100-alpha-800":"rgba(78, 130, 150, 0.20)","--color-primary-alpha-800":"rgba(87, 144, 167, 0.20)","--color-primary-dark-100-alpha-900":"rgba(78, 130, 150, 0.10)","--color-primary-alpha-900":"rgba(87, 144, 167, 0.10)","--color-primary-dark-200":"rgb(70,117,135)","--color-primary-dark-200-alpha-100":"rgba(70, 117, 135, 0.90)","--color-primary-dark-200-alpha-200":"rgba(70, 117, 135, 0.80)","--color-primary-dark-200-alpha-300":"rgba(70, 117, 135, 0.70)","--color-primary-dark-200-alpha-400":"rgba(70, 117, 135, 0.60)","--color-primary-dark-200-alpha-500":"rgba(70, 117, 135, 0.50)","--color-primary-dark-200-alpha-600":"rgba(70, 117, 135, 0.40)","--color-primary-dark-200-alpha-700":"rgba(70, 117, 135, 0.30)","--color-primary-dark-200-alpha-800":"rgba(70, 117, 135, 0.20)","--color-primary-dark-200-alpha-900":"rgba(70, 117, 135, 0.10)","--color-primary-dark-300":"rgb(63,105,122)","--color-primary-dark-300-alpha-100":"rgba(63, 105, 122, 0.90)","--color-primary-dark-300-alpha-200":"rgba(63, 105, 122, 0.80)","--color-primary-dark-300-alpha-300":"rgba(63, 105, 122, 0.70)","--color-primary-dark-300-alpha-400":"rgba(63, 105, 122, 0.60)","--color-primary-dark-300-alpha-500":"rgba(63, 105, 122, 0.50)","--color-primary-dark-300-alpha-600":"rgba(63, 105, 122, 0.40)","--color-primary-dark-300-alpha-700":"rgba(63, 105, 122, 0.30)","--color-primary-dark-300-alpha-800":"rgba(63, 105, 122, 0.20)","--color-primary-dark-300-alpha-900":"rgba(63, 105, 122, 0.10)","--color-primary-dark-400":"rgb(57,95,110)","--color-primary-dark-400-alpha-100":"rgba(57, 95, 110, 0.90)","--color-primary-dark-400-alpha-200":"rgba(57, 95, 110, 0.80)","--color-primary-dark-400-alpha-300":"rgba(57, 95, 110, 0.70)","--color-primary-dark-400-alpha-400":"rgba(57, 95, 110, 0.60)","--color-primary-dark-400-alpha-500":"rgba(57, 95, 110, 0.50)","--color-primary-dark-400-alpha-600":"rgba(57, 95, 110, 0.40)","--color-primary-dark-400-alpha-700":"rgba(57, 95, 110, 0.30)","--color-primary-dark-400-alpha-800":"rgba(57, 95, 110, 0.20)","--color-primary-dark-400-alpha-900":"rgba(57, 95, 110, 0.10)","--color-primary-dark-500":"rgb(51,86,99)","--color-primary-dark-500-alpha-100":"rgba(51, 86, 99, 0.90)","--color-primary-dark-500-alpha-200":"rgba(51, 86, 99, 0.80)","--color-primary-dark-500-alpha-300":"rgba(51, 86, 99, 0.70)","--color-primary-dark-500-alpha-400":"rgba(51, 86, 99, 0.60)","--color-primary-dark-500-alpha-500":"rgba(51, 86, 99, 0.50)","--color-primary-dark-500-alpha-600":"rgba(51, 86, 99, 0.40)","--color-primary-dark-500-alpha-700":"rgba(51, 86, 99, 0.30)","--color-primary-dark-500-alpha-800":"rgba(51, 86, 99, 0.20)","--color-primary-dark-500-alpha-900":"rgba(51, 86, 99, 0.10)","--color-primary-dark-600":"rgb(46,77,89)","--color-primary-dark-600-alpha-100":"rgba(46, 77, 89, 0.90)","--color-primary-dark-600-alpha-200":"rgba(46, 77, 89, 0.80)","--color-primary-dark-600-alpha-300":"rgba(46, 77, 89, 0.70)","--color-primary-dark-600-alpha-400":"rgba(46, 77, 89, 0.60)","--color-primary-dark-600-alpha-500":"rgba(46, 77, 89, 0.50)","--color-primary-dark-600-alpha-600":"rgba(46, 77, 89, 0.40)","--color-primary-dark-600-alpha-700":"rgba(46, 77, 89, 0.30)","--color-primary-dark-600-alpha-800":"rgba(46, 77, 89, 0.20)","--color-primary-dark-600-alpha-900":"rgba(46, 77, 89, 0.10)","--color-primary-dark-700":"rgb(41,69,80)","--color-primary-dark-700-alpha-100":"rgba(41, 69, 80, 0.90)","--color-primary-dark-700-alpha-200":"rgba(41, 69, 80, 0.80)","--color-primary-dark-700-alpha-300":"rgba(41, 69, 80, 0.70)","--color-primary-dark-700-alpha-400":"rgba(41, 69, 80, 0.60)","--color-primary-dark-700-alpha-500":"rgba(41, 69, 80, 0.50)","--color-primary-dark-700-alpha-600":"rgba(41, 69, 80, 0.40)","--color-primary-dark-700-alpha-700":"rgba(41, 69, 80, 0.30)","--color-primary-dark-700-alpha-800":"rgba(41, 69, 80, 0.20)","--color-primary-dark-700-alpha-900":"rgba(41, 69, 80, 0.10)","--color-primary-dark-800":"rgb(37,62,72)","--color-primary-dark-800-alpha-100":"rgba(37, 62, 72, 0.90)","--color-primary-dark-800-alpha-200":"rgba(37, 62, 72, 0.80)","--color-primary-dark-800-alpha-300":"rgba(37, 62, 72, 0.70)","--color-primary-dark-800-alpha-400":"rgba(37, 62, 72, 0.60)","--color-primary-dark-800-alpha-500":"rgba(37, 62, 72, 0.50)","--color-primary-dark-800-alpha-600":"rgba(37, 62, 72, 0.40)","--color-primary-dark-800-alpha-700":"rgba(37, 62, 72, 0.30)","--color-primary-dark-800-alpha-800":"rgba(37, 62, 72, 0.20)","--color-primary-dark-800-alpha-900":"rgba(37, 62, 72, 0.10)","--color-primary-dark-900":"rgb(33,56,65)","--color-primary-dark-900-alpha-100":"rgba(33, 56, 65, 0.90)","--color-primary-dark-900-alpha-200":"rgba(33, 56, 65, 0.80)","--color-primary-dark-900-alpha-300":"rgba(33, 56, 65, 0.70)","--color-primary-dark-900-alpha-400":"rgba(33, 56, 65, 0.60)","--color-primary-dark-900-alpha-500":"rgba(33, 56, 65, 0.50)","--color-primary-dark-900-alpha-600":"rgba(33, 56, 65, 0.40)","--color-primary-dark-900-alpha-700":"rgba(33, 56, 65, 0.30)","--color-primary-dark-900-alpha-800":"rgba(33, 56, 65, 0.20)","--color-primary-dark-900-alpha-900":"rgba(33, 56, 65, 0.10)","--color-primary-dark-1000":"rgb(30,50,59)","--color-primary-dark-1000-alpha-100":"rgba(30, 50, 59, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(30, 50, 59, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(30, 50, 59, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(30, 50, 59, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(30, 50, 59, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(30, 50, 59, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(30, 50, 59, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(30, 50, 59, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(30, 50, 59, 0.10)","--color-primary-light-100":"rgb(121,166,185)","--color-primary-light-100-alpha-100":"rgba(121, 166, 185, 0.90)","--color-primary-light-100-alpha-200":"rgba(121, 166, 185, 0.80)","--color-primary-light-100-alpha-300":"rgba(121, 166, 185, 0.70)","--color-primary-light-100-alpha-400":"rgba(121, 166, 185, 0.60)","--color-primary-light-100-alpha-500":"rgba(121, 166, 185, 0.50)","--color-primary-light-100-alpha-600":"rgba(121, 166, 185, 0.40)","--color-primary-light-100-alpha-700":"rgba(121, 166, 185, 0.30)","--color-primary-light-100-alpha-800":"rgba(121, 166, 185, 0.20)","--color-primary-light-100-alpha-900":"rgba(121, 166, 185, 0.10)","--color-primary-light-200":"rgb(148,184,199)","--color-primary-light-200-alpha-100":"rgba(148, 184, 199, 0.90)","--color-primary-light-200-alpha-200":"rgba(148, 184, 199, 0.80)","--color-primary-light-200-alpha-300":"rgba(148, 184, 199, 0.70)","--color-primary-light-200-alpha-400":"rgba(148, 184, 199, 0.60)","--color-primary-light-200-alpha-500":"rgba(148, 184, 199, 0.50)","--color-primary-light-200-alpha-600":"rgba(148, 184, 199, 0.40)","--color-primary-light-200-alpha-700":"rgba(148, 184, 199, 0.30)","--color-primary-light-200-alpha-800":"rgba(148, 184, 199, 0.20)","--color-primary-light-200-alpha-900":"rgba(148, 184, 199, 0.10)","--color-primary-light-300":"rgb(169,198,210)","--color-primary-light-300-alpha-100":"rgba(169, 198, 210, 0.90)","--color-primary-light-300-alpha-200":"rgba(169, 198, 210, 0.80)","--color-primary-light-300-alpha-300":"rgba(169, 198, 210, 0.70)","--color-primary-light-300-alpha-400":"rgba(169, 198, 210, 0.60)","--color-primary-light-300-alpha-500":"rgba(169, 198, 210, 0.50)","--color-primary-light-300-alpha-600":"rgba(169, 198, 210, 0.40)","--color-primary-light-300-alpha-700":"rgba(169, 198, 210, 0.30)","--color-primary-light-300-alpha-800":"rgba(169, 198, 210, 0.20)","--color-primary-light-300-alpha-900":"rgba(169, 198, 210, 0.10)","--color-primary-light-400":"rgb(186,209,219)","--color-primary-light-400-alpha-100":"rgba(186, 209, 219, 0.90)","--color-primary-light-400-alpha-200":"rgba(186, 209, 219, 0.80)","--color-primary-light-400-alpha-300":"rgba(186, 209, 219, 0.70)","--color-primary-light-400-alpha-400":"rgba(186, 209, 219, 0.60)","--color-primary-light-400-alpha-500":"rgba(186, 209, 219, 0.50)","--color-primary-light-400-alpha-600":"rgba(186, 209, 219, 0.40)","--color-primary-light-400-alpha-700":"rgba(186, 209, 219, 0.30)","--color-primary-light-400-alpha-800":"rgba(186, 209, 219, 0.20)","--color-primary-light-400-alpha-900":"rgba(186, 209, 219, 0.10)","--color-primary-light-500":"rgb(200,218,226)","--color-primary-light-500-alpha-100":"rgba(200, 218, 226, 0.90)","--color-primary-light-500-alpha-200":"rgba(200, 218, 226, 0.80)","--color-primary-light-500-alpha-300":"rgba(200, 218, 226, 0.70)","--color-primary-light-500-alpha-400":"rgba(200, 218, 226, 0.60)","--color-primary-light-500-alpha-500":"rgba(200, 218, 226, 0.50)","--color-primary-light-500-alpha-600":"rgba(200, 218, 226, 0.40)","--color-primary-light-500-alpha-700":"rgba(200, 218, 226, 0.30)","--color-primary-light-500-alpha-800":"rgba(200, 218, 226, 0.20)","--color-primary-light-500-alpha-900":"rgba(200, 218, 226, 0.10)","--color-primary-light-600":"rgb(211,225,232)","--color-primary-light-600-alpha-100":"rgba(211, 225, 232, 0.90)","--color-primary-light-600-alpha-200":"rgba(211, 225, 232, 0.80)","--color-primary-light-600-alpha-300":"rgba(211, 225, 232, 0.70)","--color-primary-light-600-alpha-400":"rgba(211, 225, 232, 0.60)","--color-primary-light-600-alpha-500":"rgba(211, 225, 232, 0.50)","--color-primary-light-600-alpha-600":"rgba(211, 225, 232, 0.40)","--color-primary-light-600-alpha-700":"rgba(211, 225, 232, 0.30)","--color-primary-light-600-alpha-800":"rgba(211, 225, 232, 0.20)","--color-primary-light-600-alpha-900":"rgba(211, 225, 232, 0.10)","--color-primary-light-700":"rgb(220,231,237)","--color-primary-light-700-alpha-100":"rgba(220, 231, 237, 0.90)","--color-primary-light-700-alpha-200":"rgba(220, 231, 237, 0.80)","--color-primary-light-700-alpha-300":"rgba(220, 231, 237, 0.70)","--color-primary-light-700-alpha-400":"rgba(220, 231, 237, 0.60)","--color-primary-light-700-alpha-500":"rgba(220, 231, 237, 0.50)","--color-primary-light-700-alpha-600":"rgba(220, 231, 237, 0.40)","--color-primary-light-700-alpha-700":"rgba(220, 231, 237, 0.30)","--color-primary-light-700-alpha-800":"rgba(220, 231, 237, 0.20)","--color-primary-light-700-alpha-900":"rgba(220, 231, 237, 0.10)","--color-primary-light-800":"rgb(227,236,241)","--color-primary-light-800-alpha-100":"rgba(227, 236, 241, 0.90)","--color-primary-light-800-alpha-200":"rgba(227, 236, 241, 0.80)","--color-primary-light-800-alpha-300":"rgba(227, 236, 241, 0.70)","--color-primary-light-800-alpha-400":"rgba(227, 236, 241, 0.60)","--color-primary-light-800-alpha-500":"rgba(227, 236, 241, 0.50)","--color-primary-light-800-alpha-600":"rgba(227, 236, 241, 0.40)","--color-primary-light-800-alpha-700":"rgba(227, 236, 241, 0.30)","--color-primary-light-800-alpha-800":"rgba(227, 236, 241, 0.20)","--color-primary-light-800-alpha-900":"rgba(227, 236, 241, 0.10)","--color-primary-light-900":"rgb(233,240,244)","--color-primary-light-900-alpha-100":"rgba(233, 240, 244, 0.90)","--color-primary-light-900-alpha-200":"rgba(233, 240, 244, 0.80)","--color-primary-light-900-alpha-300":"rgba(233, 240, 244, 0.70)","--color-primary-light-900-alpha-400":"rgba(233, 240, 244, 0.60)","--color-primary-light-900-alpha-500":"rgba(233, 240, 244, 0.50)","--color-primary-light-900-alpha-600":"rgba(233, 240, 244, 0.40)","--color-primary-light-900-alpha-700":"rgba(233, 240, 244, 0.30)","--color-primary-light-900-alpha-800":"rgba(233, 240, 244, 0.20)","--color-primary-light-900-alpha-900":"rgba(233, 240, 244, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(87, 144, 167)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"rgba(255, 255, 255, 0.15)","--color-main-background":"rgba(255, 255, 255, 0.8)","--color-nav-font":"var(--color-primary)","--background-image":"url(./theme_images/myzcbg.jpg)","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"var(--color-primary)","--color-badge-secondary":"var(--color-primary-light-100)","--color-badge-tertiary":"var(--color-primary-light-100)"}}},{"id":"china_ink","name":"近墨者黑","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgba(47, 47, 47, 1)","--color-primary-dark-100":"rgba(42,42,42, 1)","--color-primary-dark-100-alpha-100":"rgba(42, 42, 42, 0.90)","--color-primary-alpha-100":"rgba(47, 47, 47, 0.90)","--color-primary-dark-100-alpha-200":"rgba(42, 42, 42, 0.80)","--color-primary-alpha-200":"rgba(47, 47, 47, 0.80)","--color-primary-dark-100-alpha-300":"rgba(42, 42, 42, 0.70)","--color-primary-alpha-300":"rgba(47, 47, 47, 0.70)","--color-primary-dark-100-alpha-400":"rgba(42, 42, 42, 0.60)","--color-primary-alpha-400":"rgba(47, 47, 47, 0.60)","--color-primary-dark-100-alpha-500":"rgba(42, 42, 42, 0.50)","--color-primary-alpha-500":"rgba(47, 47, 47, 0.50)","--color-primary-dark-100-alpha-600":"rgba(42, 42, 42, 0.40)","--color-primary-alpha-600":"rgba(47, 47, 47, 0.40)","--color-primary-dark-100-alpha-700":"rgba(42, 42, 42, 0.30)","--color-primary-alpha-700":"rgba(47, 47, 47, 0.30)","--color-primary-dark-100-alpha-800":"rgba(42, 42, 42, 0.20)","--color-primary-alpha-800":"rgba(47, 47, 47, 0.20)","--color-primary-dark-100-alpha-900":"rgba(42, 42, 42, 0.10)","--color-primary-alpha-900":"rgba(47, 47, 47, 0.10)","--color-primary-dark-200":"rgba(38,38,38, 1)","--color-primary-dark-200-alpha-100":"rgba(38, 38, 38, 0.90)","--color-primary-dark-200-alpha-200":"rgba(38, 38, 38, 0.80)","--color-primary-dark-200-alpha-300":"rgba(38, 38, 38, 0.70)","--color-primary-dark-200-alpha-400":"rgba(38, 38, 38, 0.60)","--color-primary-dark-200-alpha-500":"rgba(38, 38, 38, 0.50)","--color-primary-dark-200-alpha-600":"rgba(38, 38, 38, 0.40)","--color-primary-dark-200-alpha-700":"rgba(38, 38, 38, 0.30)","--color-primary-dark-200-alpha-800":"rgba(38, 38, 38, 0.20)","--color-primary-dark-200-alpha-900":"rgba(38, 38, 38, 0.10)","--color-primary-dark-300":"rgba(34,34,34, 1)","--color-primary-dark-300-alpha-100":"rgba(34, 34, 34, 0.90)","--color-primary-dark-300-alpha-200":"rgba(34, 34, 34, 0.80)","--color-primary-dark-300-alpha-300":"rgba(34, 34, 34, 0.70)","--color-primary-dark-300-alpha-400":"rgba(34, 34, 34, 0.60)","--color-primary-dark-300-alpha-500":"rgba(34, 34, 34, 0.50)","--color-primary-dark-300-alpha-600":"rgba(34, 34, 34, 0.40)","--color-primary-dark-300-alpha-700":"rgba(34, 34, 34, 0.30)","--color-primary-dark-300-alpha-800":"rgba(34, 34, 34, 0.20)","--color-primary-dark-300-alpha-900":"rgba(34, 34, 34, 0.10)","--color-primary-dark-400":"rgba(31,31,31, 1)","--color-primary-dark-400-alpha-100":"rgba(31, 31, 31, 0.90)","--color-primary-dark-400-alpha-200":"rgba(31, 31, 31, 0.80)","--color-primary-dark-400-alpha-300":"rgba(31, 31, 31, 0.70)","--color-primary-dark-400-alpha-400":"rgba(31, 31, 31, 0.60)","--color-primary-dark-400-alpha-500":"rgba(31, 31, 31, 0.50)","--color-primary-dark-400-alpha-600":"rgba(31, 31, 31, 0.40)","--color-primary-dark-400-alpha-700":"rgba(31, 31, 31, 0.30)","--color-primary-dark-400-alpha-800":"rgba(31, 31, 31, 0.20)","--color-primary-dark-400-alpha-900":"rgba(31, 31, 31, 0.10)","--color-primary-dark-500":"rgba(28,28,28, 1)","--color-primary-dark-500-alpha-100":"rgba(28, 28, 28, 0.90)","--color-primary-dark-500-alpha-200":"rgba(28, 28, 28, 0.80)","--color-primary-dark-500-alpha-300":"rgba(28, 28, 28, 0.70)","--color-primary-dark-500-alpha-400":"rgba(28, 28, 28, 0.60)","--color-primary-dark-500-alpha-500":"rgba(28, 28, 28, 0.50)","--color-primary-dark-500-alpha-600":"rgba(28, 28, 28, 0.40)","--color-primary-dark-500-alpha-700":"rgba(28, 28, 28, 0.30)","--color-primary-dark-500-alpha-800":"rgba(28, 28, 28, 0.20)","--color-primary-dark-500-alpha-900":"rgba(28, 28, 28, 0.10)","--color-primary-dark-600":"rgba(25,25,25, 1)","--color-primary-dark-600-alpha-100":"rgba(25, 25, 25, 0.90)","--color-primary-dark-600-alpha-200":"rgba(25, 25, 25, 0.80)","--color-primary-dark-600-alpha-300":"rgba(25, 25, 25, 0.70)","--color-primary-dark-600-alpha-400":"rgba(25, 25, 25, 0.60)","--color-primary-dark-600-alpha-500":"rgba(25, 25, 25, 0.50)","--color-primary-dark-600-alpha-600":"rgba(25, 25, 25, 0.40)","--color-primary-dark-600-alpha-700":"rgba(25, 25, 25, 0.30)","--color-primary-dark-600-alpha-800":"rgba(25, 25, 25, 0.20)","--color-primary-dark-600-alpha-900":"rgba(25, 25, 25, 0.10)","--color-primary-dark-700":"rgba(23,23,23, 1)","--color-primary-dark-700-alpha-100":"rgba(23, 23, 23, 0.90)","--color-primary-dark-700-alpha-200":"rgba(23, 23, 23, 0.80)","--color-primary-dark-700-alpha-300":"rgba(23, 23, 23, 0.70)","--color-primary-dark-700-alpha-400":"rgba(23, 23, 23, 0.60)","--color-primary-dark-700-alpha-500":"rgba(23, 23, 23, 0.50)","--color-primary-dark-700-alpha-600":"rgba(23, 23, 23, 0.40)","--color-primary-dark-700-alpha-700":"rgba(23, 23, 23, 0.30)","--color-primary-dark-700-alpha-800":"rgba(23, 23, 23, 0.20)","--color-primary-dark-700-alpha-900":"rgba(23, 23, 23, 0.10)","--color-primary-dark-800":"rgba(21,21,21, 1)","--color-primary-dark-800-alpha-100":"rgba(21, 21, 21, 0.90)","--color-primary-dark-800-alpha-200":"rgba(21, 21, 21, 0.80)","--color-primary-dark-800-alpha-300":"rgba(21, 21, 21, 0.70)","--color-primary-dark-800-alpha-400":"rgba(21, 21, 21, 0.60)","--color-primary-dark-800-alpha-500":"rgba(21, 21, 21, 0.50)","--color-primary-dark-800-alpha-600":"rgba(21, 21, 21, 0.40)","--color-primary-dark-800-alpha-700":"rgba(21, 21, 21, 0.30)","--color-primary-dark-800-alpha-800":"rgba(21, 21, 21, 0.20)","--color-primary-dark-800-alpha-900":"rgba(21, 21, 21, 0.10)","--color-primary-dark-900":"rgba(19,19,19, 1)","--color-primary-dark-900-alpha-100":"rgba(19, 19, 19, 0.90)","--color-primary-dark-900-alpha-200":"rgba(19, 19, 19, 0.80)","--color-primary-dark-900-alpha-300":"rgba(19, 19, 19, 0.70)","--color-primary-dark-900-alpha-400":"rgba(19, 19, 19, 0.60)","--color-primary-dark-900-alpha-500":"rgba(19, 19, 19, 0.50)","--color-primary-dark-900-alpha-600":"rgba(19, 19, 19, 0.40)","--color-primary-dark-900-alpha-700":"rgba(19, 19, 19, 0.30)","--color-primary-dark-900-alpha-800":"rgba(19, 19, 19, 0.20)","--color-primary-dark-900-alpha-900":"rgba(19, 19, 19, 0.10)","--color-primary-dark-1000":"rgba(17,17,17, 1)","--color-primary-dark-1000-alpha-100":"rgba(17, 17, 17, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(17, 17, 17, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(17, 17, 17, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(17, 17, 17, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(17, 17, 17, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(17, 17, 17, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(17, 17, 17, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(17, 17, 17, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(17, 17, 17, 0.10)","--color-primary-light-100":"rgba(89,89,89, 1)","--color-primary-light-100-alpha-100":"rgba(89, 89, 89, 0.90)","--color-primary-light-100-alpha-200":"rgba(89, 89, 89, 0.80)","--color-primary-light-100-alpha-300":"rgba(89, 89, 89, 0.70)","--color-primary-light-100-alpha-400":"rgba(89, 89, 89, 0.60)","--color-primary-light-100-alpha-500":"rgba(89, 89, 89, 0.50)","--color-primary-light-100-alpha-600":"rgba(89, 89, 89, 0.40)","--color-primary-light-100-alpha-700":"rgba(89, 89, 89, 0.30)","--color-primary-light-100-alpha-800":"rgba(89, 89, 89, 0.20)","--color-primary-light-100-alpha-900":"rgba(89, 89, 89, 0.10)","--color-primary-light-200":"rgba(122,122,122, 1)","--color-primary-light-200-alpha-100":"rgba(122, 122, 122, 0.90)","--color-primary-light-200-alpha-200":"rgba(122, 122, 122, 0.80)","--color-primary-light-200-alpha-300":"rgba(122, 122, 122, 0.70)","--color-primary-light-200-alpha-400":"rgba(122, 122, 122, 0.60)","--color-primary-light-200-alpha-500":"rgba(122, 122, 122, 0.50)","--color-primary-light-200-alpha-600":"rgba(122, 122, 122, 0.40)","--color-primary-light-200-alpha-700":"rgba(122, 122, 122, 0.30)","--color-primary-light-200-alpha-800":"rgba(122, 122, 122, 0.20)","--color-primary-light-200-alpha-900":"rgba(122, 122, 122, 0.10)","--color-primary-light-300":"rgba(149,149,149, 1)","--color-primary-light-300-alpha-100":"rgba(149, 149, 149, 0.90)","--color-primary-light-300-alpha-200":"rgba(149, 149, 149, 0.80)","--color-primary-light-300-alpha-300":"rgba(149, 149, 149, 0.70)","--color-primary-light-300-alpha-400":"rgba(149, 149, 149, 0.60)","--color-primary-light-300-alpha-500":"rgba(149, 149, 149, 0.50)","--color-primary-light-300-alpha-600":"rgba(149, 149, 149, 0.40)","--color-primary-light-300-alpha-700":"rgba(149, 149, 149, 0.30)","--color-primary-light-300-alpha-800":"rgba(149, 149, 149, 0.20)","--color-primary-light-300-alpha-900":"rgba(149, 149, 149, 0.10)","--color-primary-light-400":"rgba(170,170,170, 1)","--color-primary-light-400-alpha-100":"rgba(170, 170, 170, 0.90)","--color-primary-light-400-alpha-200":"rgba(170, 170, 170, 0.80)","--color-primary-light-400-alpha-300":"rgba(170, 170, 170, 0.70)","--color-primary-light-400-alpha-400":"rgba(170, 170, 170, 0.60)","--color-primary-light-400-alpha-500":"rgba(170, 170, 170, 0.50)","--color-primary-light-400-alpha-600":"rgba(170, 170, 170, 0.40)","--color-primary-light-400-alpha-700":"rgba(170, 170, 170, 0.30)","--color-primary-light-400-alpha-800":"rgba(170, 170, 170, 0.20)","--color-primary-light-400-alpha-900":"rgba(170, 170, 170, 0.10)","--color-primary-light-500":"rgba(187,187,187, 1)","--color-primary-light-500-alpha-100":"rgba(187, 187, 187, 0.90)","--color-primary-light-500-alpha-200":"rgba(187, 187, 187, 0.80)","--color-primary-light-500-alpha-300":"rgba(187, 187, 187, 0.70)","--color-primary-light-500-alpha-400":"rgba(187, 187, 187, 0.60)","--color-primary-light-500-alpha-500":"rgba(187, 187, 187, 0.50)","--color-primary-light-500-alpha-600":"rgba(187, 187, 187, 0.40)","--color-primary-light-500-alpha-700":"rgba(187, 187, 187, 0.30)","--color-primary-light-500-alpha-800":"rgba(187, 187, 187, 0.20)","--color-primary-light-500-alpha-900":"rgba(187, 187, 187, 0.10)","--color-primary-light-600":"rgba(201,201,201, 1)","--color-primary-light-600-alpha-100":"rgba(201, 201, 201, 0.90)","--color-primary-light-600-alpha-200":"rgba(201, 201, 201, 0.80)","--color-primary-light-600-alpha-300":"rgba(201, 201, 201, 0.70)","--color-primary-light-600-alpha-400":"rgba(201, 201, 201, 0.60)","--color-primary-light-600-alpha-500":"rgba(201, 201, 201, 0.50)","--color-primary-light-600-alpha-600":"rgba(201, 201, 201, 0.40)","--color-primary-light-600-alpha-700":"rgba(201, 201, 201, 0.30)","--color-primary-light-600-alpha-800":"rgba(201, 201, 201, 0.20)","--color-primary-light-600-alpha-900":"rgba(201, 201, 201, 0.10)","--color-primary-light-700":"rgba(212,212,212, 1)","--color-primary-light-700-alpha-100":"rgba(212, 212, 212, 0.90)","--color-primary-light-700-alpha-200":"rgba(212, 212, 212, 0.80)","--color-primary-light-700-alpha-300":"rgba(212, 212, 212, 0.70)","--color-primary-light-700-alpha-400":"rgba(212, 212, 212, 0.60)","--color-primary-light-700-alpha-500":"rgba(212, 212, 212, 0.50)","--color-primary-light-700-alpha-600":"rgba(212, 212, 212, 0.40)","--color-primary-light-700-alpha-700":"rgba(212, 212, 212, 0.30)","--color-primary-light-700-alpha-800":"rgba(212, 212, 212, 0.20)","--color-primary-light-700-alpha-900":"rgba(212, 212, 212, 0.10)","--color-primary-light-800":"rgba(221,221,221, 1)","--color-primary-light-800-alpha-100":"rgba(221, 221, 221, 0.90)","--color-primary-light-800-alpha-200":"rgba(221, 221, 221, 0.80)","--color-primary-light-800-alpha-300":"rgba(221, 221, 221, 0.70)","--color-primary-light-800-alpha-400":"rgba(221, 221, 221, 0.60)","--color-primary-light-800-alpha-500":"rgba(221, 221, 221, 0.50)","--color-primary-light-800-alpha-600":"rgba(221, 221, 221, 0.40)","--color-primary-light-800-alpha-700":"rgba(221, 221, 221, 0.30)","--color-primary-light-800-alpha-800":"rgba(221, 221, 221, 0.20)","--color-primary-light-800-alpha-900":"rgba(221, 221, 221, 0.10)","--color-primary-light-900":"rgba(228,228,228, 1)","--color-primary-light-900-alpha-100":"rgba(228, 228, 228, 0.90)","--color-primary-light-900-alpha-200":"rgba(228, 228, 228, 0.80)","--color-primary-light-900-alpha-300":"rgba(228, 228, 228, 0.70)","--color-primary-light-900-alpha-400":"rgba(228, 228, 228, 0.60)","--color-primary-light-900-alpha-500":"rgba(228, 228, 228, 0.50)","--color-primary-light-900-alpha-600":"rgba(228, 228, 228, 0.40)","--color-primary-light-900-alpha-700":"rgba(228, 228, 228, 0.30)","--color-primary-light-900-alpha-800":"rgba(228, 228, 228, 0.20)","--color-primary-light-900-alpha-900":"rgba(228, 228, 228, 0.10)","--color-primary-light-1000":"rgba(255,255,255, 1)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgba(47, 47, 47, 1)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"rgba(255, 255, 255, 0)","--color-main-background":"rgba(255, 255, 255, 0.8)","--color-nav-font":"var(--color-primary)","--background-image":"url(./theme_images/china_ink.jpg)","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"rgba(183, 212, 208, 1)","--color-btn-min":"rgba(200, 214, 183, 1)","--color-btn-close":"rgba(218, 195, 188, 1)","--color-badge-primary":"rgba(137, 70, 70, 1)","--color-badge-secondary":"rgba(67, 139, 65, 1)","--color-badge-tertiary":"rgba(132, 135, 65, 1)"}}},{"id":"happy_new_year","name":"新年快乐","isDark":false,"isDarkFont":false,"isCustom":false,"config":{"themeColors":{"--color-primary":"rgb(192, 57, 43)","--color-primary-dark-100":"rgb(173,51,39)","--color-primary-dark-100-alpha-100":"rgba(173, 51, 39, 0.90)","--color-primary-alpha-100":"rgba(192, 57, 43, 0.90)","--color-primary-dark-100-alpha-200":"rgba(173, 51, 39, 0.80)","--color-primary-alpha-200":"rgba(192, 57, 43, 0.80)","--color-primary-dark-100-alpha-300":"rgba(173, 51, 39, 0.70)","--color-primary-alpha-300":"rgba(192, 57, 43, 0.70)","--color-primary-dark-100-alpha-400":"rgba(173, 51, 39, 0.60)","--color-primary-alpha-400":"rgba(192, 57, 43, 0.60)","--color-primary-dark-100-alpha-500":"rgba(173, 51, 39, 0.50)","--color-primary-alpha-500":"rgba(192, 57, 43, 0.50)","--color-primary-dark-100-alpha-600":"rgba(173, 51, 39, 0.40)","--color-primary-alpha-600":"rgba(192, 57, 43, 0.40)","--color-primary-dark-100-alpha-700":"rgba(173, 51, 39, 0.30)","--color-primary-alpha-700":"rgba(192, 57, 43, 0.30)","--color-primary-dark-100-alpha-800":"rgba(173, 51, 39, 0.20)","--color-primary-alpha-800":"rgba(192, 57, 43, 0.20)","--color-primary-dark-100-alpha-900":"rgba(173, 51, 39, 0.10)","--color-primary-alpha-900":"rgba(192, 57, 43, 0.10)","--color-primary-dark-200":"rgb(156,46,35)","--color-primary-dark-200-alpha-100":"rgba(156, 46, 35, 0.90)","--color-primary-dark-200-alpha-200":"rgba(156, 46, 35, 0.80)","--color-primary-dark-200-alpha-300":"rgba(156, 46, 35, 0.70)","--color-primary-dark-200-alpha-400":"rgba(156, 46, 35, 0.60)","--color-primary-dark-200-alpha-500":"rgba(156, 46, 35, 0.50)","--color-primary-dark-200-alpha-600":"rgba(156, 46, 35, 0.40)","--color-primary-dark-200-alpha-700":"rgba(156, 46, 35, 0.30)","--color-primary-dark-200-alpha-800":"rgba(156, 46, 35, 0.20)","--color-primary-dark-200-alpha-900":"rgba(156, 46, 35, 0.10)","--color-primary-dark-300":"rgb(140,41,32)","--color-primary-dark-300-alpha-100":"rgba(140, 41, 32, 0.90)","--color-primary-dark-300-alpha-200":"rgba(140, 41, 32, 0.80)","--color-primary-dark-300-alpha-300":"rgba(140, 41, 32, 0.70)","--color-primary-dark-300-alpha-400":"rgba(140, 41, 32, 0.60)","--color-primary-dark-300-alpha-500":"rgba(140, 41, 32, 0.50)","--color-primary-dark-300-alpha-600":"rgba(140, 41, 32, 0.40)","--color-primary-dark-300-alpha-700":"rgba(140, 41, 32, 0.30)","--color-primary-dark-300-alpha-800":"rgba(140, 41, 32, 0.20)","--color-primary-dark-300-alpha-900":"rgba(140, 41, 32, 0.10)","--color-primary-dark-400":"rgb(126,37,29)","--color-primary-dark-400-alpha-100":"rgba(126, 37, 29, 0.90)","--color-primary-dark-400-alpha-200":"rgba(126, 37, 29, 0.80)","--color-primary-dark-400-alpha-300":"rgba(126, 37, 29, 0.70)","--color-primary-dark-400-alpha-400":"rgba(126, 37, 29, 0.60)","--color-primary-dark-400-alpha-500":"rgba(126, 37, 29, 0.50)","--color-primary-dark-400-alpha-600":"rgba(126, 37, 29, 0.40)","--color-primary-dark-400-alpha-700":"rgba(126, 37, 29, 0.30)","--color-primary-dark-400-alpha-800":"rgba(126, 37, 29, 0.20)","--color-primary-dark-400-alpha-900":"rgba(126, 37, 29, 0.10)","--color-primary-dark-500":"rgb(113,33,26)","--color-primary-dark-500-alpha-100":"rgba(113, 33, 26, 0.90)","--color-primary-dark-500-alpha-200":"rgba(113, 33, 26, 0.80)","--color-primary-dark-500-alpha-300":"rgba(113, 33, 26, 0.70)","--color-primary-dark-500-alpha-400":"rgba(113, 33, 26, 0.60)","--color-primary-dark-500-alpha-500":"rgba(113, 33, 26, 0.50)","--color-primary-dark-500-alpha-600":"rgba(113, 33, 26, 0.40)","--color-primary-dark-500-alpha-700":"rgba(113, 33, 26, 0.30)","--color-primary-dark-500-alpha-800":"rgba(113, 33, 26, 0.20)","--color-primary-dark-500-alpha-900":"rgba(113, 33, 26, 0.10)","--color-primary-dark-600":"rgb(102,30,23)","--color-primary-dark-600-alpha-100":"rgba(102, 30, 23, 0.90)","--color-primary-dark-600-alpha-200":"rgba(102, 30, 23, 0.80)","--color-primary-dark-600-alpha-300":"rgba(102, 30, 23, 0.70)","--color-primary-dark-600-alpha-400":"rgba(102, 30, 23, 0.60)","--color-primary-dark-600-alpha-500":"rgba(102, 30, 23, 0.50)","--color-primary-dark-600-alpha-600":"rgba(102, 30, 23, 0.40)","--color-primary-dark-600-alpha-700":"rgba(102, 30, 23, 0.30)","--color-primary-dark-600-alpha-800":"rgba(102, 30, 23, 0.20)","--color-primary-dark-600-alpha-900":"rgba(102, 30, 23, 0.10)","--color-primary-dark-700":"rgb(92,27,21)","--color-primary-dark-700-alpha-100":"rgba(92, 27, 21, 0.90)","--color-primary-dark-700-alpha-200":"rgba(92, 27, 21, 0.80)","--color-primary-dark-700-alpha-300":"rgba(92, 27, 21, 0.70)","--color-primary-dark-700-alpha-400":"rgba(92, 27, 21, 0.60)","--color-primary-dark-700-alpha-500":"rgba(92, 27, 21, 0.50)","--color-primary-dark-700-alpha-600":"rgba(92, 27, 21, 0.40)","--color-primary-dark-700-alpha-700":"rgba(92, 27, 21, 0.30)","--color-primary-dark-700-alpha-800":"rgba(92, 27, 21, 0.20)","--color-primary-dark-700-alpha-900":"rgba(92, 27, 21, 0.10)","--color-primary-dark-800":"rgb(83,24,19)","--color-primary-dark-800-alpha-100":"rgba(83, 24, 19, 0.90)","--color-primary-dark-800-alpha-200":"rgba(83, 24, 19, 0.80)","--color-primary-dark-800-alpha-300":"rgba(83, 24, 19, 0.70)","--color-primary-dark-800-alpha-400":"rgba(83, 24, 19, 0.60)","--color-primary-dark-800-alpha-500":"rgba(83, 24, 19, 0.50)","--color-primary-dark-800-alpha-600":"rgba(83, 24, 19, 0.40)","--color-primary-dark-800-alpha-700":"rgba(83, 24, 19, 0.30)","--color-primary-dark-800-alpha-800":"rgba(83, 24, 19, 0.20)","--color-primary-dark-800-alpha-900":"rgba(83, 24, 19, 0.10)","--color-primary-dark-900":"rgb(75,22,17)","--color-primary-dark-900-alpha-100":"rgba(75, 22, 17, 0.90)","--color-primary-dark-900-alpha-200":"rgba(75, 22, 17, 0.80)","--color-primary-dark-900-alpha-300":"rgba(75, 22, 17, 0.70)","--color-primary-dark-900-alpha-400":"rgba(75, 22, 17, 0.60)","--color-primary-dark-900-alpha-500":"rgba(75, 22, 17, 0.50)","--color-primary-dark-900-alpha-600":"rgba(75, 22, 17, 0.40)","--color-primary-dark-900-alpha-700":"rgba(75, 22, 17, 0.30)","--color-primary-dark-900-alpha-800":"rgba(75, 22, 17, 0.20)","--color-primary-dark-900-alpha-900":"rgba(75, 22, 17, 0.10)","--color-primary-dark-1000":"rgb(68,20,15)","--color-primary-dark-1000-alpha-100":"rgba(68, 20, 15, 0.90)","--color-primary-dark-1000-alpha-200":"rgba(68, 20, 15, 0.80)","--color-primary-dark-1000-alpha-300":"rgba(68, 20, 15, 0.70)","--color-primary-dark-1000-alpha-400":"rgba(68, 20, 15, 0.60)","--color-primary-dark-1000-alpha-500":"rgba(68, 20, 15, 0.50)","--color-primary-dark-1000-alpha-600":"rgba(68, 20, 15, 0.40)","--color-primary-dark-1000-alpha-700":"rgba(68, 20, 15, 0.30)","--color-primary-dark-1000-alpha-800":"rgba(68, 20, 15, 0.20)","--color-primary-dark-1000-alpha-900":"rgba(68, 20, 15, 0.10)","--color-primary-light-100":"rgb(205,97,85)","--color-primary-light-100-alpha-100":"rgba(205, 97, 85, 0.90)","--color-primary-light-100-alpha-200":"rgba(205, 97, 85, 0.80)","--color-primary-light-100-alpha-300":"rgba(205, 97, 85, 0.70)","--color-primary-light-100-alpha-400":"rgba(205, 97, 85, 0.60)","--color-primary-light-100-alpha-500":"rgba(205, 97, 85, 0.50)","--color-primary-light-100-alpha-600":"rgba(205, 97, 85, 0.40)","--color-primary-light-100-alpha-700":"rgba(205, 97, 85, 0.30)","--color-primary-light-100-alpha-800":"rgba(205, 97, 85, 0.20)","--color-primary-light-100-alpha-900":"rgba(205, 97, 85, 0.10)","--color-primary-light-200":"rgb(215,129,119)","--color-primary-light-200-alpha-100":"rgba(215, 129, 119, 0.90)","--color-primary-light-200-alpha-200":"rgba(215, 129, 119, 0.80)","--color-primary-light-200-alpha-300":"rgba(215, 129, 119, 0.70)","--color-primary-light-200-alpha-400":"rgba(215, 129, 119, 0.60)","--color-primary-light-200-alpha-500":"rgba(215, 129, 119, 0.50)","--color-primary-light-200-alpha-600":"rgba(215, 129, 119, 0.40)","--color-primary-light-200-alpha-700":"rgba(215, 129, 119, 0.30)","--color-primary-light-200-alpha-800":"rgba(215, 129, 119, 0.20)","--color-primary-light-200-alpha-900":"rgba(215, 129, 119, 0.10)","--color-primary-light-300":"rgb(223,154,146)","--color-primary-light-300-alpha-100":"rgba(223, 154, 146, 0.90)","--color-primary-light-300-alpha-200":"rgba(223, 154, 146, 0.80)","--color-primary-light-300-alpha-300":"rgba(223, 154, 146, 0.70)","--color-primary-light-300-alpha-400":"rgba(223, 154, 146, 0.60)","--color-primary-light-300-alpha-500":"rgba(223, 154, 146, 0.50)","--color-primary-light-300-alpha-600":"rgba(223, 154, 146, 0.40)","--color-primary-light-300-alpha-700":"rgba(223, 154, 146, 0.30)","--color-primary-light-300-alpha-800":"rgba(223, 154, 146, 0.20)","--color-primary-light-300-alpha-900":"rgba(223, 154, 146, 0.10)","--color-primary-light-400":"rgb(229,174,168)","--color-primary-light-400-alpha-100":"rgba(229, 174, 168, 0.90)","--color-primary-light-400-alpha-200":"rgba(229, 174, 168, 0.80)","--color-primary-light-400-alpha-300":"rgba(229, 174, 168, 0.70)","--color-primary-light-400-alpha-400":"rgba(229, 174, 168, 0.60)","--color-primary-light-400-alpha-500":"rgba(229, 174, 168, 0.50)","--color-primary-light-400-alpha-600":"rgba(229, 174, 168, 0.40)","--color-primary-light-400-alpha-700":"rgba(229, 174, 168, 0.30)","--color-primary-light-400-alpha-800":"rgba(229, 174, 168, 0.20)","--color-primary-light-400-alpha-900":"rgba(229, 174, 168, 0.10)","--color-primary-light-500":"rgb(234,190,185)","--color-primary-light-500-alpha-100":"rgba(234, 190, 185, 0.90)","--color-primary-light-500-alpha-200":"rgba(234, 190, 185, 0.80)","--color-primary-light-500-alpha-300":"rgba(234, 190, 185, 0.70)","--color-primary-light-500-alpha-400":"rgba(234, 190, 185, 0.60)","--color-primary-light-500-alpha-500":"rgba(234, 190, 185, 0.50)","--color-primary-light-500-alpha-600":"rgba(234, 190, 185, 0.40)","--color-primary-light-500-alpha-700":"rgba(234, 190, 185, 0.30)","--color-primary-light-500-alpha-800":"rgba(234, 190, 185, 0.20)","--color-primary-light-500-alpha-900":"rgba(234, 190, 185, 0.10)","--color-primary-light-600":"rgb(238,203,199)","--color-primary-light-600-alpha-100":"rgba(238, 203, 199, 0.90)","--color-primary-light-600-alpha-200":"rgba(238, 203, 199, 0.80)","--color-primary-light-600-alpha-300":"rgba(238, 203, 199, 0.70)","--color-primary-light-600-alpha-400":"rgba(238, 203, 199, 0.60)","--color-primary-light-600-alpha-500":"rgba(238, 203, 199, 0.50)","--color-primary-light-600-alpha-600":"rgba(238, 203, 199, 0.40)","--color-primary-light-600-alpha-700":"rgba(238, 203, 199, 0.30)","--color-primary-light-600-alpha-800":"rgba(238, 203, 199, 0.20)","--color-primary-light-600-alpha-900":"rgba(238, 203, 199, 0.10)","--color-primary-light-700":"rgb(241,213,210)","--color-primary-light-700-alpha-100":"rgba(241, 213, 210, 0.90)","--color-primary-light-700-alpha-200":"rgba(241, 213, 210, 0.80)","--color-primary-light-700-alpha-300":"rgba(241, 213, 210, 0.70)","--color-primary-light-700-alpha-400":"rgba(241, 213, 210, 0.60)","--color-primary-light-700-alpha-500":"rgba(241, 213, 210, 0.50)","--color-primary-light-700-alpha-600":"rgba(241, 213, 210, 0.40)","--color-primary-light-700-alpha-700":"rgba(241, 213, 210, 0.30)","--color-primary-light-700-alpha-800":"rgba(241, 213, 210, 0.20)","--color-primary-light-700-alpha-900":"rgba(241, 213, 210, 0.10)","--color-primary-light-800":"rgb(244,221,219)","--color-primary-light-800-alpha-100":"rgba(244, 221, 219, 0.90)","--color-primary-light-800-alpha-200":"rgba(244, 221, 219, 0.80)","--color-primary-light-800-alpha-300":"rgba(244, 221, 219, 0.70)","--color-primary-light-800-alpha-400":"rgba(244, 221, 219, 0.60)","--color-primary-light-800-alpha-500":"rgba(244, 221, 219, 0.50)","--color-primary-light-800-alpha-600":"rgba(244, 221, 219, 0.40)","--color-primary-light-800-alpha-700":"rgba(244, 221, 219, 0.30)","--color-primary-light-800-alpha-800":"rgba(244, 221, 219, 0.20)","--color-primary-light-800-alpha-900":"rgba(244, 221, 219, 0.10)","--color-primary-light-900":"rgb(246,228,226)","--color-primary-light-900-alpha-100":"rgba(246, 228, 226, 0.90)","--color-primary-light-900-alpha-200":"rgba(246, 228, 226, 0.80)","--color-primary-light-900-alpha-300":"rgba(246, 228, 226, 0.70)","--color-primary-light-900-alpha-400":"rgba(246, 228, 226, 0.60)","--color-primary-light-900-alpha-500":"rgba(246, 228, 226, 0.50)","--color-primary-light-900-alpha-600":"rgba(246, 228, 226, 0.40)","--color-primary-light-900-alpha-700":"rgba(246, 228, 226, 0.30)","--color-primary-light-900-alpha-800":"rgba(246, 228, 226, 0.20)","--color-primary-light-900-alpha-900":"rgba(246, 228, 226, 0.10)","--color-primary-light-1000":"rgb(255,255,255)","--color-primary-light-1000-alpha-100":"rgba(255, 255, 255, 0.90)","--color-primary-light-1000-alpha-200":"rgba(255, 255, 255, 0.80)","--color-primary-light-1000-alpha-300":"rgba(255, 255, 255, 0.70)","--color-primary-light-1000-alpha-400":"rgba(255, 255, 255, 0.60)","--color-primary-light-1000-alpha-500":"rgba(255, 255, 255, 0.50)","--color-primary-light-1000-alpha-600":"rgba(255, 255, 255, 0.40)","--color-primary-light-1000-alpha-700":"rgba(255, 255, 255, 0.30)","--color-primary-light-1000-alpha-800":"rgba(255, 255, 255, 0.20)","--color-primary-light-1000-alpha-900":"rgba(255, 255, 255, 0.10)","--color-theme":"rgb(192, 57, 43)","--color-1000":"rgb(33, 33, 33)","--color-950":"rgb(44,44,44)","--color-900":"rgb(55,55,55)","--color-850":"rgb(66,66,66)","--color-800":"rgb(77,77,77)","--color-750":"rgb(89,89,89)","--color-700":"rgb(100,100,100)","--color-650":"rgb(111,111,111)","--color-600":"rgb(122,122,122)","--color-550":"rgb(133,133,133)","--color-500":"rgb(144,144,144)","--color-450":"rgb(155,155,155)","--color-400":"rgb(166,166,166)","--color-350":"rgb(177,177,177)","--color-300":"rgb(188,188,188)","--color-250":"rgb(200,200,200)","--color-200":"rgb(211,211,211)","--color-150":"rgb(222,222,222)","--color-100":"rgb(233,233,233)","--color-050":"rgb(244,244,244)","--color-000":"rgb(255,255,255)"},"extInfo":{"--color-app-background":"rgba(255, 255, 255, 0.15)","--color-main-background":"rgba(255, 255, 255, 0.8)","--color-nav-font":"var(--color-primary)","--background-image":"url(./theme_images/xnkl.png)","--background-image-position":"center","--background-image-size":"cover","--color-btn-hide":"#3bc2b2","--color-btn-min":"#85c43b","--color-btn-close":"#fab4a0","--color-badge-primary":"#7fb575","--color-badge-secondary":"#dfbb6b","--color-badge-tertiary":"var(--color-primary-light-100)"}}}]');
;// CONCATENATED MODULE: ./src/main/utils/index.ts










const parseEnvParams = () => {
    const cmdParams = {};
    let deeplink = null;
    const rx = /^-\w+/;
    for (let param of process.argv) {
        if (URL_SCHEME_RXP.test(param)) {
            deeplink = param;
        }
        if (!rx.test(param))
            continue;
        param = param.substring(1);
        let index = param.indexOf('=');
        if (index < 0) {
            cmdParams[param] = true;
        }
        else {
            cmdParams[param.substring(0, index)] = param.substring(index + 1);
        }
    }
    return {
        cmdParams,
        deeplink,
    };
};
const primitiveType = ['string', 'boolean', 'number'];
const checkPrimitiveType = (val) => val === null || primitiveType.includes(typeof val);
// const handleMergeSetting = (defaultSetting: LX.AppSetting, currentSetting: Partial<LX.AppSetting>) => {
//   const updatedSettingKeys: Array<keyof LX.AppSetting> = []
//   for (const key of Object.keys(defaultSetting) as Array<keyof LX.AppSetting>) {
//     const currentValue: any = currentSetting[key]
//     const isPrimitive = checkPrimitiveType(currentValue)
//     // if (checkPrimitiveType(value)) {
//     if (!isPrimitive) continue
//     updatedSettingKeys.push(key)
//     // @ts-expect-error
//     defaultSetting[key] = currentValue
//     // } else {
//     //   if (!isPrimitive && currentValue != undefined) handleMergeSetting(value, currentValue)
//     // }
//   }
//   return {
//     setting: defaultSetting,
//     updatedSettingKeys,
//   }
// }
const mergeSetting = (originSetting, targetSetting) => {
    let originSettingCopy = { ...originSetting };
    // const defaultVersion = targetSettingCopy.version
    const updatedSettingKeys = [];
    const updatedSetting = {};
    if (targetSetting) {
        const originSettingKeys = Object.keys(originSettingCopy);
        const targetSettingKeys = Object.keys(targetSetting);
        if (originSettingKeys.length > targetSettingKeys.length) {
            for (const key of targetSettingKeys) {
                const targetValue = targetSetting[key];
                const isPrimitive = checkPrimitiveType(targetValue);
                // if (checkPrimitiveType(value)) {
                if (!isPrimitive || targetValue == originSettingCopy[key] || originSettingCopy[key] === undefined)
                    continue;
                updatedSettingKeys.push(key);
                updatedSetting[key] = targetValue;
                // @ts-expect-error
                originSettingCopy[key] = targetValue;
                // } else {
                //   if (!isPrimitive && currentValue != undefined) handleMergeSetting(value, currentValue)
                // }
            }
        }
        else {
            for (const key of originSettingKeys) {
                const targetValue = targetSetting[key];
                const isPrimitive = checkPrimitiveType(targetValue);
                // if (checkPrimitiveType(value)) {
                if (!isPrimitive || targetValue == originSettingCopy[key])
                    continue;
                updatedSettingKeys.push(key);
                updatedSetting[key] = targetValue;
                // @ts-expect-error
                originSettingCopy[key] = targetValue;
                // } else {
                //   if (!isPrimitive && currentValue != undefined) handleMergeSetting(value, currentValue)
                // }
            }
        }
    }
    return {
        setting: originSettingCopy,
        updatedSettingKeys,
        updatedSetting,
    };
};
const updateSetting = (setting, isInit = false) => {
    const electronStore_config = store(STORE_NAMES.APP_SETTINGS);
    let originSetting;
    if (isInit) {
        setting &&= migrateSetting(setting);
        originSetting = { ...common_defaultSetting };
    }
    else
        originSetting = global.lx.appSetting;
    const result = mergeSetting(originSetting, setting);
    result.setting.version = common_defaultSetting.version;
    electronStore_config.override({ version: result.setting.version, setting: result.setting });
    return result;
};
/**
 * 初始化设置
 */
const initSetting = async () => {
    const electronStore_config = store(STORE_NAMES.APP_SETTINGS);
    let setting = electronStore_config.get('setting');
    // migrate setting
    if (!setting) {
        const config = await parseDataFile('config.json');
        if (config?.setting)
            setting = config.setting;
        await migrateUserApi();
        await migrateDataJson();
    }
    // console.log(setting)
    return updateSetting(setting, true);
};
/**
 * 初始化快捷键设置
 */
const initHotKey = async () => {
    const electronStore_hotKey = store(STORE_NAMES.HOTKEY);
    let localConfig = electronStore_hotKey.get('local');
    let globalConfig = electronStore_hotKey.get('global');
    if (globalConfig) {
        // 移除v2.2.0及之前设置的全局媒体快捷键注册
        if (globalConfig.keys.MediaPlayPause) {
            delete globalConfig.keys.MediaPlayPause;
            delete globalConfig.keys.MediaNextTrack;
            delete globalConfig.keys.MediaPreviousTrack;
            electronStore_hotKey.set('global', globalConfig);
        }
    }
    else {
        // migrate hotKey
        const config = await migrateHotKey();
        if (config) {
            localConfig = config.local;
            globalConfig = config.global;
        }
        else {
            localConfig = JSON.parse(JSON.stringify(defaultHotKey.local));
            globalConfig = JSON.parse(JSON.stringify(defaultHotKey.global));
        }
        electronStore_hotKey.set('local', localConfig);
        electronStore_hotKey.set('global', globalConfig);
    }
    return {
        local: localConfig,
        global: globalConfig,
    };
};
const saveHotKeyConfig = throttle((config) => {
    for (const key of Object.keys(config)) {
        global.lx.hotKey.config[key] = config[key];
        store(STORE_NAMES.HOTKEY).set(key, config[key]);
    }
});
const saveAppHotKeyConfig = (config) => {
    saveHotKeyConfig(config);
};
const openDevTools = (webContents) => {
    webContents.openDevTools({
        mode: 'undocked',
    });
};
let userThemes;
const getAllThemes = () => {
    userThemes ??= store(STORE_NAMES.THEME).get('themes') ?? [];
    return {
        themes: theme_namespaceObject,
        userThemes,
        dataPath: joinPath(global.lxDataPath, 'theme_images'),
    };
};
const saveTheme = (theme) => {
    const targetTheme = userThemes.find(t => t.id === theme.id);
    if (targetTheme)
        Object.assign(targetTheme, theme);
    else
        userThemes.push(theme);
    store(STORE_NAMES.THEME).set('themes', userThemes);
};
const removeTheme = (id) => {
    const index = userThemes.findIndex(t => t.id === id);
    if (index < 0)
        return;
    userThemes.splice(index, 1);
    store(STORE_NAMES.THEME).set('themes', userThemes);
};
const copyTheme = (theme) => {
    return {
        ...theme,
        config: {
            ...theme.config,
            extInfo: { ...theme.config.extInfo },
            themeColors: { ...theme.config.themeColors },
        },
    };
};
const getTheme = () => {
    // fs.promises.readdir()
    const shouldUseDarkColors = external_electron_.nativeTheme.shouldUseDarkColors;
    let themeId = global.lx.appSetting['theme.id'] == 'auto'
        ? shouldUseDarkColors
            ? global.lx.appSetting['theme.darkId']
            : global.lx.appSetting['theme.lightId']
        : global.lx.appSetting['theme.id'];
    // themeId = 'naruto'
    // themeId = 'pink'
    // themeId = 'black'
    let theme = theme_namespaceObject.find(theme => theme.id == themeId);
    if (!theme) {
        userThemes = store(STORE_NAMES.THEME).get('themes') ?? [];
        theme = userThemes.find(theme => theme.id == themeId);
        if (theme) {
            if (theme.config.extInfo['--background-image'] != 'none') {
                theme = copyTheme(theme);
                theme.config.extInfo['--background-image'] =
                    isUrl(theme.config.extInfo['--background-image'])
                        ? `url(${theme.config.extInfo['--background-image']})`
                        : `url(file:///${encodePath(joinPath(global.lxDataPath, 'theme_images', theme.config.extInfo['--background-image']))})`;
            }
        }
        else {
            themeId = global.lx.appSetting['theme.id'] == 'auto' && shouldUseDarkColors ? 'black' : 'green';
            theme = theme_namespaceObject.find(theme => theme.id == themeId);
        }
    }
    const colors = {
        ...theme.config.themeColors,
        ...theme.config.extInfo,
    };
    return {
        shouldUseDarkColors,
        theme: {
            id: global.lx.appSetting['theme.id'],
            name: theme.name,
            isDark: theme.isDark,
            isDarkFont: theme.isDarkFont,
            colors,
        },
    };
};
let powerSaveBlockerId = null;
const setPowerSaveBlocker = (enabled) => {
    let isEnabled = powerSaveBlockerId != null && external_electron_.powerSaveBlocker.isStarted(powerSaveBlockerId);
    if (enabled) {
        if (isEnabled)
            return;
        powerSaveBlockerId = external_electron_.powerSaveBlocker.start('prevent-app-suspension');
    }
    else {
        if (!isEnabled)
            return;
        external_electron_.powerSaveBlocker.stop(powerSaveBlockerId);
        powerSaveBlockerId = null;
    }
};

;// CONCATENATED MODULE: ./src/common/config.ts
const windowSizeList = [
    {
        id: 0,
        name: 'smaller',
        width: 828,
        height: 540,
    },
    {
        id: 1,
        name: 'small',
        width: 920,
        height: 600,
    },
    {
        id: 2,
        name: 'medium',
        width: 1020,
        height: 660,
    },
    {
        id: 3,
        name: 'big',
        width: 1114,
        height: 718,
    },
    {
        id: 4,
        name: 'larger',
        width: 1202,
        height: 776,
    },
    {
        id: 5,
        name: 'oversized',
        width: 1385,
        height: 896,
    },
    {
        id: 6,
        name: 'huge',
        width: 1700,
        height: 1070,
    },
];
const navigationUrlWhiteList = [];
// 基础黑白色
// export const commonColorNames = [
//   '--color-000', '--color-050', '--color-100', '--color-200', '--color-300', '--color-400',
//   '--color-500', '--color-600', '--color-700', '--color-800', '--color-900',
// ] as const
// export const commonLightColorValues = [
//   'rgb(255, 255, 255)',
//   'rgb(217,217,217)',
//   'rgb(184,184,184)',
//   'rgb(156,156,156)',
//   'rgb(133,133,133)',
//   'rgb(113,113,113)',
//   'rgb(96,96,96)',
//   'rgb(82,82,82)',
//   'rgb(70,70,70)',
//   'rgb(60,60,60)',
//   'rgb(51,51,51)',
// ] as const
// export const commonDarkColorValues = [
//   'rgb(11, 11, 11)',
//   'rgb(60,60,60)',
//   'rgb(99,99,99)',
//   'rgb(130,130,130)',
//   'rgb(155,155,155)',
//   'rgb(175,175,175)',
//   'rgb(191,191,191)',
//   'rgb(204,204,204)',
//   'rgb(214,214,214)',
//   'rgb(222,222,222)',
//   'rgb(229,229,229)',
// ] as const

;// CONCATENATED MODULE: ./src/common/ipcNames.ts
const modules = {
    common: {
        get_env_params: 'get_env_params',
        deeplink: 'deeplink',
        clear_env_params_deeplink: 'clear_env_params_deeplink',
        system_theme_change: 'system_theme_change',
        theme_change: 'theme_change',
        get_system_fonts: 'get_system_fonts',
        get_app_setting: 'get_app_setting',
        set_app_setting: 'set_app_setting',
    },
    player: {
        invoke_play_music: 'play_music',
        invoke_play_next: 'play_next',
        invoke_play_prev: 'play_prev',
        invoke_toggle_play: 'toggle_play',
        player_play: 'player_play',
        player_pause: 'player_pause',
        player_stop: 'player_stop',
        player_error: 'player_error',
        list_data_overwire: 'list_data_overwire',
        list_get: 'list_get',
        list_add: 'list_add',
        list_remove: 'list_remove',
        list_update: 'list_update',
        list_update_position: 'list_update_position',
        list_music_get: 'list_music_get',
        list_music_add: 'list_music_add',
        list_music_move: 'list_music_move',
        list_music_remove: 'list_music_remove',
        list_music_update: 'list_music_update',
        list_music_update_position: 'list_music_update_position',
        list_music_overwrite: 'list_music_overwrite',
        list_music_clear: 'list_music_clear',
        list_music_check_exist: 'list_music_check_exist',
        list_music_get_list_ids: 'list_music_get_list_ids',
    },
    dislike: {
        get_dislike_music_infos: 'get_dislike_music_infos',
        add_dislike_music_infos: 'add_dislike_music_infos',
        overwrite_dislike_music_infos: 'overwrite_dislike_music_infos',
        clear_dislike_music_infos: 'clear_dislike_music_infos',
    },
    winMain: {
        focus: 'focus',
        close: 'close',
        min: 'min',
        max: 'max',
        fullscreen: 'fullscreen',
        set_app_name: 'set_app_name',
        clear_cache: 'clear_cache',
        get_cache_size: 'get_cache_size',
        inited: 'inited',
        show_save_dialog: 'show_save_dialog',
        show_select_dialog: 'show_select_dialog',
        show_dialog: 'show_dialog',
        open_dir_in_explorer: 'open_dir_in_explorer',
        open_dev_tools: 'open_dev_tools',
        set_power_save_blocker: 'set_power_save_blocker',
        player_status: 'player_status',
        change_tray: 'change_tray',
        quit_update: 'quit_update',
        update_check: 'update_check',
        update_download_update: 'update_download_update',
        update_available: 'update_available',
        update_error: 'update_error',
        update_progress: 'update_progress',
        update_downloaded: 'update_downloaded',
        update_not_available: 'update_not_available',
        set_ignore_mouse_events: 'set_ignore_mouse_events',
        set_window_size: 'set_window_size',
        handle_request: 'handle_request',
        cancel_request: 'cancel_request',
        restart_window: 'restart_window',
        // lang_s2t: 'lang_s2t',
        handle_kw_decode_lyric: 'handle_kw_decode_lyric',
        handle_tx_decode_lyric: 'handle_tx_decode_lyric',
        get_lyric_info: 'get_lyric_info',
        set_lyric_info: 'set_lyric_info',
        set_config: 'set_config',
        set_hot_key_config: 'set_hot_key_config',
        on_config_change: 'on_config_change',
        key_down: 'key_down',
        quit: 'quit',
        min_toggle: 'min_toggle',
        hide_toggle: 'hide_toggle',
        get_other_source: 'get_other_source',
        save_other_source: 'save_other_source',
        clear_other_source: 'clear_other_source',
        get_other_source_count: 'get_other_source_count',
        get_data: 'get_data',
        save_data: 'save_data',
        get_sound_effect_eq_preset: 'get_sound_effect_eq_preset',
        save_sound_effect_eq_preset: 'save_sound_effect_eq_preset',
        get_sound_effect_convolution_preset: 'get_sound_effect_convolution_preset',
        save_sound_effect_convolution_preset: 'save_sound_effect_convolution_preset',
        // get_sound_effect_pitch_shifter_preset: 'get_sound_effect_pitch_shifter_preset',
        // save_sound_effect_pitch_shifter_preset: 'save_sound_effect_pitch_shifter_preset',
        get_hot_key: 'get_hot_key',
        import_user_api: 'import_user_api',
        remove_user_api: 'remove_user_api',
        set_user_api: 'set_user_api',
        get_user_api_list: 'get_user_api_list',
        request_user_api: 'request_user_api',
        request_user_api_cancel: 'request_user_api_cancel',
        get_user_api_status: 'get_user_api_status',
        user_api_status: 'user_api_status',
        user_api_show_update_alert: 'user_api_show_update_alert',
        user_api_set_allow_update_alert: 'user_api_set_allow_update_alert',
        get_palyer_lyric: 'get_lyric',
        // save_lyric: 'save_lyric',
        // clear_lyric: 'clear_lyric',
        get_lyric_raw: 'get_lyric_raw',
        save_lyric_raw: 'save_lyric_raw',
        clear_lyric_raw: 'clear_lyric_raw',
        get_lyric_raw_count: 'get_lyric_raw_count',
        get_lyric_edited: 'get_lyric_edited',
        save_lyric_edited: 'save_lyric_edited',
        remove_lyric_edited: 'remove_lyric_edited',
        clear_lyric_edited: 'clear_lyric_edited',
        get_lyric_edited_count: 'get_lyric_edited_count',
        get_music_url: 'get_music_url',
        save_music_url: 'save_music_url',
        clear_music_url: 'clear_music_url',
        get_music_url_count: 'get_music_url_count',
        open_api_action: 'open_api_action',
        sync_action: 'sync_action',
        sync_get_server_devices: 'sync_get_server_devices',
        sync_remove_server_device: 'sync_remove_server_device',
        process_new_desktop_lyric_client: 'process_new_desktop_lyric_client',
        player_action_set_buttons: 'player_action_set_buttons',
        // player_action_set_thumbnail_clip: 'player_action_set_thumbnail_clip',
        player_action_on_button_click: 'player_action_on_button_click',
        get_themes: 'get_themes',
        save_theme: 'save_theme',
        remove_theme: 'remove_theme',
        download_list_get: 'download_list_get',
        download_list_add: 'download_list_add',
        download_list_update: 'download_list_update',
        download_list_remove: 'download_list_remove',
        download_list_clear: 'download_list_clear',
    },
    winLyric: {
        close: 'close',
        set_config: 'set_config',
        get_config: 'get_config',
        on_config_change: 'on_config_change',
        main_window_inited: 'main_window_inited',
        set_win_bounds: 'set_win_bounds',
        key_down: 'key_down',
        request_main_window_channel: 'request_main_window_channel',
        provide_main_window_channel: 'provide_main_window_channel',
    },
    hotKey: {
        enable: 'enable',
        status: 'status',
        set_config: 'set_config',
    },
};
for (const moduleName of Object.keys(modules)) {
    let eventNames = modules[moduleName];
    for (const eventName of Object.keys(eventNames)) {
        eventNames[eventName] = `${moduleName}_${eventName}`;
    }
}
// for (const moduleName of Object.keys(modules) as Array<keyof typeof modules>) {
//   let eventNames = modules[moduleName]
//   for (const eventName of Object.keys(eventNames)) {
//     eventNames[eventName] = `${moduleName}_${eventName}`
//   }
// }
const CMMON_EVENT_NAME = modules.common;
const PLAYER_EVENT_NAME = modules.player;
const DISLIKE_EVENT_NAME = modules.dislike;
const WIN_MAIN_RENDERER_EVENT_NAME = modules.winMain;
const WIN_LYRIC_RENDERER_EVENT_NAME = modules.winLyric;
const HOTKEY_RENDERER_EVENT_NAME = modules.hotKey;

;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/common/winRendererEvent.ts

// 发送列表操作事件到渲染进程的注册方法
// 哪个渲染进程需要接收则引入此方法注册
const registerRendererEvents = (sendEvent) => {
    const sendDeeplink = (link) => {
        sendEvent(CMMON_EVENT_NAME.deeplink, link);
    };
    const sendSystemThemeChange = () => {
        sendEvent(CMMON_EVENT_NAME.theme_change, global.lx.theme);
    };
    global.lx.event_app.on('deeplink', sendDeeplink);
    global.lx.event_app.on('theme_change', sendSystemThemeChange);
    return () => {
        global.lx.event_app.off('deeplink', sendDeeplink);
        global.lx.event_app.off('theme_change', sendSystemThemeChange);
    };
};

;// CONCATENATED MODULE: ./src/common/mainIpc.ts

function mainOn(name, listener) {
    external_electron_.ipcMain.on(name, (event, params) => {
        listener({ event, params });
    });
}
function mainOnce(name, listener) {
    ipcMain.once(name, (event, params) => {
        listener({ event, params });
    });
}
const mainOff = (name, listener) => {
    ipcMain.removeListener(name, listener);
};
const mainOffAll = (name) => {
    ipcMain.removeAllListeners(name);
};
function mainHandle(name, listener) {
    external_electron_.ipcMain.handle(name, async (event, params) => {
        return listener({ event, params });
    });
}
function mainHandleOnce(name, listener) {
    ipcMain.handleOnce(name, async (event, params) => {
        return listener({ event, params });
    });
}
const mainHandleRemove = (name) => {
    ipcMain.removeHandler(name);
};
function mainSend(window, name, params) {
    window.webContents.send(name, params);
}

;// CONCATENATED MODULE: external "font-list"
const external_font_list_namespaceObject = require("font-list");
;// CONCATENATED MODULE: ./src/main/utils/fontManage.ts
// const { getAvailableFontFamilies } = require('electron-font-manager')
// exports.getAvailableFontFamilies = getAvailableFontFamilies

// import { getAvailableFontFamilies } from 'electron-font-manager'
// const getFonts = async() => {
//   switch (process.platform) {
//     case 'win32':
//     case 'darwin':
//       return getAvailableFontFamilies()
//     default: return getFontsByCommand()
//   }
// }


;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/common/rendererEvent.ts



// 公共操作事件（公共，只注册一次）
/* harmony default export */ const rendererEvent = (() => {
    mainHandle(CMMON_EVENT_NAME.get_app_setting, async () => {
        return global.lx.appSetting;
    });
    mainHandle(CMMON_EVENT_NAME.set_app_setting, async ({ params: config }) => {
        global.lx.event_app.update_config(config);
    });
    mainHandle(CMMON_EVENT_NAME.get_env_params, async () => {
        return global.envParams;
    });
    mainOn(CMMON_EVENT_NAME.clear_env_params_deeplink, () => {
        global.envParams.deeplink = null;
    });
    mainHandle(CMMON_EVENT_NAME.get_system_fonts, async () => {
        return (0,external_font_list_namespaceObject.getFonts)();
    });
});

;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/common/index.ts



;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/list/winRendererEvent.ts

// 发送列表操作事件到渲染进程的注册方法
// 哪个渲染进程需要接收则引入此方法注册
const winRendererEvent_registerRendererEvents = (sendEvent) => {
    const list_data_overwrite = async (listData) => {
        sendEvent(PLAYER_EVENT_NAME.list_data_overwire, listData);
    };
    const list_create = async (position, listInfos) => {
        sendEvent(PLAYER_EVENT_NAME.list_add, { position, listInfos });
    };
    const list_remove = async (ids) => {
        sendEvent(PLAYER_EVENT_NAME.list_remove, ids);
    };
    const list_update = async (lists) => {
        sendEvent(PLAYER_EVENT_NAME.list_update, lists);
    };
    const list_update_position = async (position, ids) => {
        sendEvent(PLAYER_EVENT_NAME.list_update_position, { position, ids });
    };
    const list_music_add = async (id, musicInfos, addMusicLocationType) => {
        sendEvent(PLAYER_EVENT_NAME.list_music_add, { id, musicInfos, addMusicLocationType });
    };
    const list_music_move = async (fromId, toId, musicInfos, addMusicLocationType) => {
        sendEvent(PLAYER_EVENT_NAME.list_music_move, { fromId, toId, musicInfos, addMusicLocationType });
    };
    const list_music_remove = async (listId, ids) => {
        sendEvent(PLAYER_EVENT_NAME.list_music_remove, { listId, ids });
    };
    const list_music_update = async (musicInfos) => {
        sendEvent(PLAYER_EVENT_NAME.list_music_update, musicInfos);
    };
    const list_music_update_position = async (listId, position, ids) => {
        sendEvent(PLAYER_EVENT_NAME.list_music_update_position, { listId, position, ids });
    };
    const list_music_overwrite = async (listId, musicInfos) => {
        sendEvent(PLAYER_EVENT_NAME.list_music_overwrite, { listId, musicInfos });
    };
    const list_music_clear = async (ids) => {
        sendEvent(PLAYER_EVENT_NAME.list_data_overwire, ids);
    };
    global.lx.event_list.on('list_data_overwrite', list_data_overwrite);
    global.lx.event_list.on('list_create', list_create);
    global.lx.event_list.on('list_remove', list_remove);
    global.lx.event_list.on('list_update', list_update);
    global.lx.event_list.on('list_update_position', list_update_position);
    global.lx.event_list.on('list_music_add', list_music_add);
    global.lx.event_list.on('list_music_move', list_music_move);
    global.lx.event_list.on('list_music_remove', list_music_remove);
    global.lx.event_list.on('list_music_update', list_music_update);
    global.lx.event_list.on('list_music_update_position', list_music_update_position);
    global.lx.event_list.on('list_music_overwrite', list_music_overwrite);
    global.lx.event_list.on('list_music_clear', list_music_clear);
    return () => {
        global.lx.event_list.off('list_data_overwrite', list_data_overwrite);
        global.lx.event_list.off('list_create', list_create);
        global.lx.event_list.off('list_remove', list_remove);
        global.lx.event_list.off('list_update', list_update);
        global.lx.event_list.off('list_update_position', list_update_position);
        global.lx.event_list.off('list_music_add', list_music_add);
        global.lx.event_list.off('list_music_move', list_music_move);
        global.lx.event_list.off('list_music_remove', list_music_remove);
        global.lx.event_list.off('list_music_update', list_music_update);
        global.lx.event_list.off('list_music_update_position', list_music_update_position);
        global.lx.event_list.off('list_music_overwrite', list_music_overwrite);
        global.lx.event_list.off('list_music_clear', list_music_clear);
    };
};

;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/list/rendererEvent.ts


// 列表操作事件（公共，只注册一次）
/* harmony default export */ const list_rendererEvent = (() => {
    mainHandle(PLAYER_EVENT_NAME.list_get, async () => {
        return global.lx.worker.dbService.getAllUserList();
    });
    mainHandle(PLAYER_EVENT_NAME.list_data_overwire, async ({ params: listData }) => {
        await global.lx.event_list.list_data_overwrite(listData, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_add, async ({ params: { position, listInfos } }) => {
        await global.lx.event_list.list_create(position, listInfos, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_remove, async ({ params: ids }) => {
        await global.lx.event_list.list_remove(ids, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_update, async ({ params: listInfos }) => {
        await global.lx.event_list.list_update(listInfos, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_update_position, async ({ params: { position, ids } }) => {
        await global.lx.event_list.list_update_position(position, ids, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_get, async ({ params: listId }) => {
        return global.lx.worker.dbService.getListMusics(listId);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_add, async ({ params: { id, musicInfos, addMusicLocationType } }) => {
        await global.lx.event_list.list_music_add(id, musicInfos, addMusicLocationType, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_move, async ({ params: { fromId, toId, musicInfos, addMusicLocationType } }) => {
        await global.lx.event_list.list_music_move(fromId, toId, musicInfos, addMusicLocationType, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_remove, async ({ params: { listId, ids } }) => {
        await global.lx.event_list.list_music_remove(listId, ids, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_update, async ({ params: musicInfos }) => {
        await global.lx.event_list.list_music_update(musicInfos, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_update_position, async ({ params: { listId, position, ids } }) => {
        await global.lx.event_list.list_music_update_position(listId, position, ids, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_overwrite, async ({ params: { listId, musicInfos } }) => {
        await global.lx.event_list.list_music_overwrite(listId, musicInfos, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_clear, async ({ params: listId }) => {
        await global.lx.event_list.list_music_clear(listId, false);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_check_exist, async ({ params: { listId, musicInfoId } }) => {
        return global.lx.worker.dbService.checkListExistMusic(listId, musicInfoId);
    });
    mainHandle(PLAYER_EVENT_NAME.list_music_get_list_ids, async ({ params: musicInfoId }) => {
        return global.lx.worker.dbService.getMusicExistListIds(musicInfoId);
    });
});

;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/list/index.ts



;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/dislike/winRendererEvent.ts

// 发送列表操作事件到渲染进程的注册方法
// 哪个渲染进程需要接收则引入此方法注册
const dislike_winRendererEvent_registerRendererEvents = (sendEvent) => {
    const dislike_music_add = async (listData) => {
        sendEvent(DISLIKE_EVENT_NAME.add_dislike_music_infos, listData);
    };
    const dislike_data_overwrite = async (rules) => {
        sendEvent(DISLIKE_EVENT_NAME.overwrite_dislike_music_infos, rules);
    };
    const dislike_music_clear = async () => {
        sendEvent(DISLIKE_EVENT_NAME.clear_dislike_music_infos);
    };
    global.lx.event_dislike.on('dislike_music_add', dislike_music_add);
    global.lx.event_dislike.on('dislike_data_overwrite', dislike_data_overwrite);
    global.lx.event_dislike.on('dislike_music_clear', dislike_music_clear);
    return () => {
        global.lx.event_dislike.off('dislike_music_add', dislike_music_add);
        global.lx.event_dislike.off('dislike_data_overwrite', dislike_data_overwrite);
        global.lx.event_dislike.off('dislike_music_clear', dislike_music_clear);
    };
};

;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/dislike/rendererEvent.ts


// 列表操作事件（公共，只注册一次）
/* harmony default export */ const dislike_rendererEvent = (() => {
    mainHandle(DISLIKE_EVENT_NAME.get_dislike_music_infos, async () => {
        return global.lx.worker.dbService.getDislikeListInfo();
    });
    mainHandle(DISLIKE_EVENT_NAME.add_dislike_music_infos, async ({ params: listData }) => {
        await global.lx.event_dislike.dislike_music_add(listData, false);
    });
    mainHandle(DISLIKE_EVENT_NAME.overwrite_dislike_music_infos, async ({ params: rules }) => {
        await global.lx.event_dislike.dislike_data_overwrite(rules, false);
    });
    mainHandle(DISLIKE_EVENT_NAME.clear_dislike_music_infos, async () => {
        await global.lx.event_dislike.dislike_music_clear(false);
    });
});

;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/dislike/index.ts



;// CONCATENATED MODULE: ./src/common/utils/electron.ts

/**
 * 在资源管理器中打开目录
 * @param {string} dir
 */
const openDirInExplorer = (dir) => {
    external_electron_.shell.showItemInFolder(dir);
};
/**
 * 在浏览器打开URL
 * @param {*} url
 */
const openUrl = async (url) => {
    if (!/^https?:\/\//.test(url))
        return;
    await shell.openExternal(url);
};
/**
 * 复制文本到剪贴板
 * @param str
 */
const clipboardWriteText = (str) => {
    clipboard.writeText(str);
};
/**
 * 从剪贴板读取文本
 * @returns
 */
const clipboardReadText = () => {
    return clipboard.readText();
};
const electron_encodePath = (path) => {
    // https://github.com/lyswhut/lx-music-desktop/issues/963
    // https://github.com/lyswhut/lx-music-desktop/issues/1461
    return path.replaceAll('%', '%25').replaceAll('#', '%23');
};

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/app.ts
// const path = require('path')



// import { name as defaultName } from '../../../../../package.json'




/* harmony default export */ const app = (() => {
    // 设置应用名称
    // mainOn(WIN_MAIN_RENDERER_EVENT_NAME.set_app_name, ({ params: name }) => {
    //   if (name == null) {
    //     app.setName(defaultName)
    //   } else {
    //     app.setName(name)
    //   }
    // })
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.quit, () => {
        quitApp();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.min_toggle, () => {
        toggleMinimize();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.hide_toggle, () => {
        toggleHide();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.min, () => {
        minimize();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.max, () => {
        maximize();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.focus, () => {
        showWindow();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.set_power_save_blocker, ({ params: enabled }) => {
        setPowerSaveBlocker(enabled);
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.close, ({ params: isForce }) => {
        if (isForce) {
            external_electron_.app.exit(0);
            return;
        }
        global.lx.isTrafficLightClose = true;
        closeWindow();
    });
    // 全屏
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.fullscreen, async ({ params: isFullscreen }) => {
        global.lx.event_app.main_window_fullscreen(isFullscreen);
        return setFullScreen(isFullscreen);
    });
    // 选择目录
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.show_select_dialog, async ({ params: options }) => {
        return showSelectDialog(options);
    });
    // 显示弹窗信息
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.show_dialog, ({ params }) => {
        showDialog(params);
    });
    // 显示保存弹窗
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.show_save_dialog, async ({ params }) => {
        return showSaveDialog(params);
    });
    // 在资源管理器中定位文件
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.open_dir_in_explorer, async ({ params }) => {
        return openDirInExplorer(params);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.clear_cache, async () => {
        await clearCache();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_cache_size, async () => {
        return getCacheSize();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.open_dev_tools, () => {
        toggleDevTools();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.set_window_size, ({ params }) => {
        setWindowBounds(params);
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.set_ignore_mouse_events, ({ params: isIgnored }) => {
        isIgnored
            ? setIgnoreMouseEvents(isIgnored, { forward: true })
            : setIgnoreMouseEvents(false);
    });
    // mainHandle<Electron.Rectangle>(WIN_MAIN_RENDERER_EVENT_NAME.taskbar_set_thumbnail_clip, async({ params }) => {
    //   return setThumbnailClip(params)
    // })
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.player_status, ({ params }) => {
        // setThumbarButtons(params)
        global.lx.event_app.player_status(params);
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.inited, () => {
        global.lx.event_app.main_window_inited();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_themes, async () => {
        return getAllThemes();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.save_theme, async ({ params: theme }) => {
        saveTheme(theme);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.remove_theme, async ({ params: id }) => {
        removeTheme(id);
    });
});
const sendFocus = () => {
    sendEvent(WIN_MAIN_RENDERER_EVENT_NAME.focus);
};
const sendTaskbarButtonClick = (action) => {
    sendEvent(WIN_MAIN_RENDERER_EVENT_NAME.player_action_on_button_click, action);
};
const sendConfigChange = (setting) => {
    sendEvent(WIN_MAIN_RENDERER_EVENT_NAME.on_config_change, setting);
};

;// CONCATENATED MODULE: ./src/main/modules/winMain/utils.ts
// import fs from 'fs'



const getWindowSizeInfo = (windowSizeId) => {
    return windowSizeList.find(i => i.id == windowSizeId) ?? windowSizeList[0];
};
const getIconPath = (name) => {
    return external_electron_.nativeImage.createFromPath(external_node_path_default().join(global.staticPath, 'images/taskbar', name + '.png'));
};
const createTaskBarButtons = ({ empty = false, collect = false, play = false, next = true, prev = true, }, onClick) => {
    const buttons = [
        collect
            ? {
                icon: getIconPath('collected'),
                click() {
                    onClick('unCollect');
                },
                tooltip: '取消收藏',
                flags: ['nobackground'],
            }
            : {
                icon: getIconPath('collect'),
                click() {
                    onClick('collect');
                },
                tooltip: '收藏',
                flags: ['nobackground'],
            },
        {
            icon: getIconPath('prev'),
            click() {
                onClick('prev');
            },
            tooltip: '上一曲',
            flags: prev ? ['nobackground'] : ['nobackground', 'disabled'],
        },
        play
            ? {
                icon: getIconPath('pause'),
                click() {
                    onClick('pause');
                },
                tooltip: '暂停',
                flags: ['nobackground'],
            }
            : {
                icon: getIconPath('play'),
                click() {
                    onClick('play');
                },
                tooltip: '播放',
                flags: ['nobackground'],
            },
        {
            icon: getIconPath('next'),
            click() {
                onClick('next');
            },
            tooltip: '下一曲',
            flags: next ? ['nobackground'] : ['nobackground', 'disabled'],
        },
    ];
    if (empty) {
        for (const button of buttons) {
            button.flags = ['nobackground', 'disabled'];
        }
    }
    return buttons;
};

;// CONCATENATED MODULE: ./src/main/modules/winMain/main.ts








let browserWindow = null;
const winEvent = () => {
    if (!browserWindow)
        return;
    browserWindow.on('close', event => {
        if (global.lx.isSkipTrayQuit ||
            !global.lx.appSetting['tray.enable'] ||
            // linux下，如果不是点击软件上的关闭按钮退出的操作都直接退出
            // https://github.com/lyswhut/lx-music-desktop/issues/191
            (isLinux && !global.lx.isTrafficLightClose)) {
            browserWindow.setProgressBar(-1);
            // global.lx.mainWindowClosed = true
            global.lx.event_app.main_window_close();
            return;
        }
        global.lx.isTrafficLightClose &&= false;
        event.preventDefault();
        browserWindow.hide();
    });
    browserWindow.on('closed', () => {
        // global.lx.mainWindowClosed = true
        browserWindow = null;
    });
    // browserWindow.on('restore', () => {
    //   browserWindow.webContents.send('restore')
    // })
    browserWindow.on('focus', () => {
        sendFocus();
        global.lx.event_app.main_window_focus();
    });
    browserWindow.on('blur', () => {
        global.lx.event_app.main_window_blur();
    });
    browserWindow.once('ready-to-show', () => {
        showWindow();
        setThumbarButtons();
        global.lx.event_app.main_window_ready_to_show();
    });
    browserWindow.on('show', () => {
        global.lx.event_app.main_window_show();
        // 修复隐藏窗口后再显示时任务栏按钮丢失的问题
        setThumbarButtons();
    });
    browserWindow.on('hide', () => {
        global.lx.event_app.main_window_hide();
    });
};
const createWindow = () => {
    closeWindow();
    const windowSizeInfo = getWindowSizeInfo(global.lx.appSetting['common.windowSizeId']);
    const { shouldUseDarkColors, theme } = global.lx.theme;
    const ses = external_electron_.session.fromPartition('persist:win-main');
    /**
     * Initial window options
     */
    const options = {
        height: windowSizeInfo.height,
        useContentSize: true,
        width: windowSizeInfo.width,
        frame: false,
        transparent: !global.envParams.cmdParams.dt,
        hasShadow: global.envParams.cmdParams.dt,
        // enableRemoteModule: false,
        // icon: join(global.__static, isWin ? 'icons/256x256.ico' : 'icons/512x512.png'),
        resizable: false,
        maximizable: false,
        fullscreenable: true,
        roundedCorners: false,
        show: false,
        webPreferences: {
            session: ses,
            nodeIntegrationInWorker: true,
            contextIsolation: false,
            webSecurity: false,
            nodeIntegration: true,
            sandbox: false,
            enableWebSQL: false,
            webgl: false,
            spellcheck: false, // 禁用拼写检查器
        },
    };
    if (global.envParams.cmdParams.dt)
        options.backgroundColor = theme.colors['--color-primary-light-1000'];
    if (global.lx.appSetting['common.startInFullscreen']) {
        options.fullscreen = true;
        if (isLinux)
            options.resizable = true;
    }
    browserWindow = new external_electron_.BrowserWindow(options);
    const winURL =  false ? 0 : `file://${external_node_path_default().join(electron_encodePath(__dirname), 'index.html')}`;
    void browserWindow.loadURL(winURL + `?dt=${!!global.envParams.cmdParams.dt}&dark=${shouldUseDarkColors}&theme=${encodeURIComponent(JSON.stringify(theme))}`);
    winEvent();
    if (global.envParams.cmdParams.odt)
        openDevTools(browserWindow.webContents);
    // global.lx.mainWindowClosed = false
    // browserWindow.webContents.openDevTools()
};
const isExistWindow = () => !!browserWindow;
const isShowWindow = () => {
    if (!browserWindow)
        return false;
    return browserWindow.isVisible() && (isWin ? true : browserWindow.isFocused());
};
const closeWindow = () => {
    if (!browserWindow)
        return;
    browserWindow.close();
};
const sendEvent = (name, params) => {
    if (!browserWindow)
        return;
    mainSend(browserWindow, name, params);
};
const showSelectDialog = async (options) => {
    if (!browserWindow)
        throw new Error('main window is undefined');
    return external_electron_.dialog.showOpenDialog(browserWindow, options);
};
const showDialog = ({ type, message, detail }) => {
    if (!browserWindow)
        return;
    external_electron_.dialog.showMessageBoxSync(browserWindow, {
        type,
        message,
        detail,
    });
};
const showSaveDialog = async (options) => {
    if (!browserWindow)
        throw new Error('main window is undefined');
    return external_electron_.dialog.showSaveDialog(browserWindow, options);
};
const minimize = () => {
    if (!browserWindow)
        return;
    browserWindow.minimize();
};
const maximize = () => {
    if (!browserWindow)
        return;
    browserWindow.maximize();
};
const unmaximize = () => {
    if (!browserWindow)
        return;
    browserWindow.unmaximize();
};
const toggleHide = () => {
    if (!browserWindow)
        return;
    browserWindow.isVisible()
        ? browserWindow.hide()
        : browserWindow.show();
};
const toggleMinimize = () => {
    if (!browserWindow)
        return;
    if (browserWindow.isVisible()) {
        if (browserWindow.isMinimized())
            browserWindow.restore();
        else
            browserWindow.minimize();
    }
    else
        browserWindow.show();
};
const showWindow = () => {
    if (!browserWindow)
        return;
    if (browserWindow.isVisible()) {
        if (browserWindow.isMinimized())
            browserWindow.restore();
        else
            browserWindow.focus();
    }
    else
        browserWindow.show();
};
const hideWindow = () => {
    if (!browserWindow)
        return;
    browserWindow.hide();
};
const setWindowBounds = (options) => {
    if (!browserWindow)
        return;
    browserWindow.setBounds(options);
};
const setProgressBar = (progress, options) => {
    if (!browserWindow)
        return;
    browserWindow.setProgressBar(progress, options);
};
const setIgnoreMouseEvents = (ignore, options) => {
    if (!browserWindow)
        return;
    browserWindow.setIgnoreMouseEvents(ignore, options);
};
const toggleDevTools = () => {
    if (!browserWindow)
        return;
    if (browserWindow.webContents.isDevToolsOpened()) {
        browserWindow.webContents.closeDevTools();
    }
    else {
        openDevTools(browserWindow.webContents);
    }
};
const setFullScreen = (isFullscreen) => {
    if (!browserWindow)
        return false;
    if (isLinux) { // linux 需要先设置为可调整窗口大小才能全屏
        if (isFullscreen) {
            browserWindow.setResizable(isFullscreen);
            browserWindow.setFullScreen(isFullscreen);
        }
        else {
            browserWindow.setFullScreen(isFullscreen);
            browserWindow.setResizable(isFullscreen);
        }
    }
    else {
        browserWindow.setFullScreen(isFullscreen);
    }
    return isFullscreen;
};
const taskBarButtonFlags = {
    empty: true,
    collect: false,
    play: false,
    next: true,
    prev: true,
};
const setThumbarButtons = ({ empty, collect, play, next, prev } = taskBarButtonFlags) => {
    if (!isWin || !browserWindow)
        return;
    taskBarButtonFlags.empty = empty;
    taskBarButtonFlags.collect = collect;
    taskBarButtonFlags.play = play;
    taskBarButtonFlags.next = next;
    taskBarButtonFlags.prev = prev;
    browserWindow.setThumbarButtons(createTaskBarButtons(taskBarButtonFlags, action => {
        sendTaskbarButtonClick(action);
    }));
};
const setThumbnailClip = (region) => {
    if (!browserWindow)
        return;
    browserWindow.setThumbnailClip(region);
};
const clearCache = async () => {
    if (!browserWindow)
        throw new Error('main window is undefined');
    await browserWindow.webContents.session.clearCache();
};
const getCacheSize = async () => {
    if (!browserWindow)
        throw new Error('main window is undefined');
    return browserWindow.webContents.session.getCacheSize();
};
const getWebContents = () => {
    if (!browserWindow)
        throw new Error('main window is undefined');
    return browserWindow.webContents;
};

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/hotKey.ts



// import getStore from '@common/store'
// const { registerHotkey, unRegisterHotkey } = require('../modules/hotKey/utils')
// mainHandle(ipcMainWindowNames.set_hot_key_config, async(event, { action, data }) => {
//   switch (action) {
//     case 'config':
//       global.lx_event.hotKey.saveConfig(data.data, MAIN_WINDOW_EVENT_NAME.source)
//       return
//     case 'register':
//       return registerHotkey(data)
//     case 'unregister':
//       return unRegisterHotkey(data)
//   }
// })
/* harmony default export */ const rendererEvent_hotKey = (() => {
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_hot_key, async () => {
        // const electronStore_hotKey = getStore('hotKey')
        return {
            local: global.lx.hotKey?.config.local,
            global: global.lx.hotKey?.config.global,
        };
    });
    // global.lx.event_app.on(APP_EVENT_NAMES.hotKeyConfig, (config, source) => {
    //   if (!global.modules.mainWindow || source === MAIN_WINDOW_EVENT_NAME.name) return
    //   mainSend(global.modules.mainWindow, WIN_MAIN_RENDERER_EVENT_NAME.set_hot_key_config, { config, source })
    // })
});
const handleKeyDown = (type, key) => {
    sendEvent(WIN_MAIN_RENDERER_EVENT_NAME.key_down, { type, key });
};
const hotKeyConfigUpdate = (config) => {
    sendEvent(WIN_MAIN_RENDERER_EVENT_NAME.set_hot_key_config, config);
};

// EXTERNAL MODULE: external "zlib"
var external_zlib_ = __webpack_require__(3106);
// EXTERNAL MODULE: ./node_modules/iconv-lite/lib/index.js
var lib = __webpack_require__(5249);
var lib_default = /*#__PURE__*/__webpack_require__.n(lib);
;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/kw_decodeLyric.ts




const handleInflate = async (data) => {
    return new Promise((resolve, reject) => {
        (0,external_zlib_.inflate)(data, (err, result) => {
            if (err) {
                reject(err);
                return;
            }
            resolve(result);
        });
    });
};
const buf_key = Buffer.from('yeelion');
const buf_key_len = buf_key.length;
const decodeLyric = async (buf, isGetLyricx) => {
    // const info = buf.slice(0, index).toString()
    // if (!info.startsWith('tp=content')) return null
    // const isLyric = info.includes('\r\nlrcx=0\r\n')
    if (buf.toString('utf8', 0, 10) != 'tp=content')
        return '';
    // const index = buf.indexOf('\r\n\r\n') + 4
    const lrcData = await handleInflate(buf.slice(buf.indexOf('\r\n\r\n') + 4));
    if (!isGetLyricx)
        return lib_default().decode(lrcData, 'gb18030');
    const buf_str = Buffer.from(lrcData.toString(), 'base64');
    const buf_str_len = buf_str.length;
    const output = new Uint16Array(buf_str_len);
    let i = 0;
    while (i < buf_str_len) {
        let j = 0;
        while (j < buf_key_len && i < buf_str_len) {
            output[i] = buf_str[i] ^ buf_key[j];
            i++;
            j++;
        }
    }
    return lib_default().decode(Buffer.from(output), 'gb18030');
};
/* harmony default export */ const kw_decodeLyric = (() => {
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.handle_kw_decode_lyric, async ({ params: { lrcBase64, isGetLyricx } }) => {
        const lrc = await decodeLyric(Buffer.from(lrcBase64, 'base64'), isGetLyricx);
        return Buffer.from(lrc).toString('base64');
    });
});

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/tx_decodeLyric.ts

// import path from 'path'


// eslint-disable-next-line @typescript-eslint/dot-notation, @typescript-eslint/quotes
// const require = module[`require`].bind(module)
let qrc_decode;
const inflate = async (lrcBuf) => new Promise((resolve, reject) => {
    const buffer_builder = [];
    const decompress_stream = (0,external_node_zlib_namespaceObject.createInflate)()
        .on('data', (chunk) => {
        buffer_builder.push(chunk);
    })
        .on('close', () => {
        resolve(Buffer.concat(buffer_builder).toString());
    })
        .on('error', (err) => {
        // console.log(err)
        if (err.errno !== external_node_zlib_namespaceObject.constants.Z_BUF_ERROR) { // EOF: expected
            reject(err);
        }
    });
    // decompress_stream.write(lrcBuf)
    decompress_stream.end(lrcBuf);
});
const decode = async (str) => {
    if (!str)
        return '';
    const buf = Buffer.from(str, 'hex');
    return inflate(qrc_decode(buf, buf.length));
};
// 感谢某位不愿透露姓名的大佬提供的C++算法源码，但由于作者不希望公开，所以将会以预构建二进制文件的形式加入代码仓库中
const handleDecode = async (lrc, tlrc, rlrc) => {
    if (!qrc_decode) {
        // const nativeBindingPath = path.join(__dirname, '../build/Release/qrc_decode.node')
        // const nativeBindingPath = process.env.NODE_ENV !== 'production' ? path.join(__dirname, '../build/Release/qrc_decode.node')
        // eslint-disable-next-line @typescript-eslint/no-var-requires
        const addon = __webpack_require__(6395);
        // console.log(addon)
        qrc_decode = addon.qrc_decode;
    }
    const [lyric, tlyric, rlyric] = await Promise.all([decode(lrc), decode(tlrc), decode(rlrc)]);
    return {
        lyric,
        tlyric,
        rlyric,
    };
};
/* harmony default export */ const tx_decodeLyric = (() => {
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.handle_tx_decode_lyric, async ({ params: { lrc, tlrc, rlrc } }) => {
        return handleDecode(lrc, tlrc, rlrc);
    });
});

;// CONCATENATED MODULE: ./src/main/modules/userApi/rendererEvent/name.js
const names = {
  initEnv: '',
  init: '',
  request: '',
  response: '',
  openDevTools: '',
  showUpdateAlert: '',
  getProxy: '',
  proxyUpdate: '',
}


for (const key of Object.keys(names)) {
  names[key] = `userApi_${key}`
}

/* harmony default export */ const rendererEvent_name = (names);

;// CONCATENATED MODULE: ./src/main/modules/userApi/config/index.ts
const userApis = [];

;// CONCATENATED MODULE: ./src/main/modules/userApi/utils.ts




let utils_userApis;
let scripts = new Map();
const saveData = () => {
    store(STORE_NAMES.USER_API).set('userApis', utils_userApis.map(api => {
        return {
            ...api,
            script: scripts.get(api.id),
        };
    }));
};
const getUserApis = () => {
    if (utils_userApis)
        return utils_userApis;
    const electronStore_userApi = store(STORE_NAMES.USER_API);
    let infoFull = electronStore_userApi.get('userApis');
    let requiredUpdate = false;
    if (infoFull) {
        for (let i = 0; i < infoFull.length; i++) {
            const api = infoFull[i];
            if (api.version != null)
                continue;
            requiredUpdate ||= true;
            try {
                infoFull.splice(i, 1, {
                    ...parseScriptInfo(api.script),
                    ...api,
                });
            }
            catch (e) {
                infoFull.splice(i, 1);
                i--;
            }
        }
    }
    else {
        infoFull = userApis;
        electronStore_userApi.set('userApis', utils_userApis);
    }
    utils_userApis = infoFull.map(api => {
        if (api.allowShowUpdateAlert == null)
            api.allowShowUpdateAlert = false;
        const { script, ...info } = api;
        scripts.set(api.id, script);
        return info;
    });
    if (requiredUpdate)
        saveData();
    return utils_userApis;
};
const INFO_NAMES = {
    name: 24,
    description: 36,
    author: 56,
    homepage: 1024,
    version: 36,
};
const matchInfo = (scriptInfo) => {
    const infoArr = scriptInfo.split(/\r?\n/);
    const rxp = /^\s?\*\s?@(\w+)\s(.+)$/;
    const infos = {};
    for (const info of infoArr) {
        const result = rxp.exec(info);
        if (!result)
            continue;
        const key = result[1];
        if (INFO_NAMES[key] == null)
            continue;
        infos[key] = result[2].trim();
    }
    for (const [key, len] of Object.entries(INFO_NAMES)) {
        infos[key] ||= '';
        if (infos[key] == null)
            infos[key] = '';
        else if (infos[key].length > len)
            infos[key] = infos[key].substring(0, len) + '...';
    }
    return infos;
};
const parseScriptInfo = (script) => {
    const result = /^\/\*[\S|\s]+?\*\//.exec(script);
    if (!result)
        throw new Error('无效的自定义源文件');
    let scriptInfo = matchInfo(result[0]);
    scriptInfo.name ||= `user_api_${new Date().toLocaleString()}`;
    return scriptInfo;
};
const deflateScript = async (script) => new Promise((resolve, reject) => {
    external_node_zlib_default().deflate(Buffer.from(script, 'utf8'), (err, buf) => {
        if (err) {
            reject(err);
            return;
        }
        resolve('gz_' + buf.toString('base64'));
    });
});
const inflateScript = async (script) => new Promise((resolve, reject) => {
    if (script.startsWith('gz_')) {
        external_node_zlib_default().inflate(Buffer.from(script.substring(3), 'base64'), (err, buf) => {
            if (err) {
                reject(err);
                return;
            }
            resolve(buf.toString('utf8'));
        });
    }
    else
        resolve(script);
});
const importApi = async (scriptRaw) => {
    let scriptInfo = parseScriptInfo(scriptRaw);
    const apiInfo = {
        id: `user_api_${Math.random().toString().substring(2, 5)}_${Date.now()}`,
        ...scriptInfo,
        allowShowUpdateAlert: true,
    };
    utils_userApis ??= [];
    utils_userApis.push(apiInfo);
    const script = await deflateScript(scriptRaw);
    scripts.set(apiInfo.id, script);
    saveData();
    return apiInfo;
};
const removeApi = (ids) => {
    if (!utils_userApis)
        return;
    for (let index = utils_userApis.length - 1; index > -1; index--) {
        if (ids.includes(utils_userApis[index].id)) {
            scripts.delete(utils_userApis[index].id);
            utils_userApis.splice(index, 1);
            ids.splice(index, 1);
        }
    }
    saveData();
};
const setAllowShowUpdateAlert = (id, enable) => {
    const targetApi = utils_userApis?.find(api => api.id == id);
    if (!targetApi)
        return;
    targetApi.allowShowUpdateAlert = enable;
    saveData();
};
const getScript = async (id) => {
    return inflateScript(scripts.get(id) ?? '');
};

;// CONCATENATED MODULE: ./src/main/modules/userApi/main.ts








let main_browserWindow = null;
let html = null;
let dir = null;
const denyEvents = [
    'will-navigate',
    'will-redirect',
    'will-attach-webview',
    'will-prevent-unload',
    'media-started-playing',
];
const getProxy = () => {
    if (global.lx.appSetting['network.proxy.enable'] && global.lx.appSetting['network.proxy.host']) {
        return {
            host: global.lx.appSetting['network.proxy.host'],
            port: global.lx.appSetting['network.proxy.port'],
        };
    }
    const envProxy = envParams.cmdParams['proxy-server'];
    if (envProxy) {
        if (envProxy && typeof envProxy == 'string') {
            const [host, port = ''] = envProxy.split(':');
            return {
                host,
                port,
            };
        }
    }
    return {
        host: '',
        port: '',
    };
};
const handleUpdateProxy = (keys) => {
    if (keys.includes('network.proxy.enable') || (global.lx.appSetting['network.proxy.enable'] && keys.some(k => k.startsWith('network.proxy.')))) {
        main_sendEvent(rendererEvent_name.proxyUpdate, getProxy());
    }
};
const main_winEvent = () => {
    if (!main_browserWindow)
        return;
    main_browserWindow.on('closed', () => {
        main_browserWindow = null;
    });
};
const main_createWindow = async (userApi) => {
    await main_closeWindow();
    dir ??=  false ? 0 : external_node_path_default().join(electron_encodePath(__dirname), 'userApi');
    if (!html) {
        // eslint-disable-next-line require-atomic-updates
        html = await external_fs_default().promises.readFile(external_node_path_default().join(dir, 'renderer/user-api.html'), 'utf8');
    }
    const preloadUrl =  false
        ? 0
        : `${external_node_path_default().join(electron_encodePath(__dirname), 'user-api-preload.js')}`;
    // console.log(preloadUrl)
    /**
     * Initial window options
     */
    main_browserWindow = new external_electron_.BrowserWindow({
        // enableRemoteModule: false,
        resizable: false,
        minimizable: false,
        maximizable: false,
        fullscreenable: false,
        hasShadow: false,
        show: false,
        webPreferences: {
            contextIsolation: true,
            // worldSafeExecuteJavaScript: true,
            nodeIntegration: false,
            nodeIntegrationInWorker: false,
            sandbox: false,
            spellcheck: false,
            autoplayPolicy: 'document-user-activation-required',
            enableWebSQL: false,
            disableDialogs: true,
            // nativeWindowOpen: false,
            webgl: false,
            images: false,
            preload: preloadUrl,
        },
    });
    for (const eventName of denyEvents) {
        // @ts-expect-error
        main_browserWindow.webContents.on(eventName, (event) => {
            event.preventDefault();
        });
    }
    main_browserWindow.webContents.session.setPermissionRequestHandler((webContents, permission, resolve) => {
        if (webContents === main_browserWindow?.webContents) {
            resolve(false);
            return;
        }
        resolve(true);
    });
    main_browserWindow.webContents.setWindowOpenHandler(() => {
        return { action: 'deny' };
    });
    main_winEvent();
    // console.log(html.replace('</body>', `<script>${userApi.script}</script></body>`))
    // const randomNum = Math.random().toString().substring(2, 10)
    await main_browserWindow.loadURL('data:text/html;charset=UTF-8,' + encodeURIComponent(html));
    main_browserWindow.on('ready-to-show', async () => {
        global.lx.event_app.on('updated_config', handleUpdateProxy);
        main_sendEvent(rendererEvent_name.initEnv, { ...userApi, script: await getScript(userApi.id), proxy: getProxy() });
    });
    // global.modules.userApiWindow.loadFile(join(dir, 'renderer/user-api.html'))
    // global.modules.userApiWindow.webContents.openDevTools()
};
const main_closeWindow = async () => {
    global.lx.event_app.off('updated_config', handleUpdateProxy);
    if (!main_browserWindow)
        return;
    await Promise.all([
        main_browserWindow.webContents.session.clearAuthCache(),
        main_browserWindow.webContents.session.clearStorageData(),
        main_browserWindow.webContents.session.clearCache(),
    ]);
    main_browserWindow?.destroy();
    main_browserWindow = null;
};
const main_sendEvent = (name, params) => {
    if (!main_browserWindow)
        return;
    mainSend(main_browserWindow, name, params);
};
const main_openDevTools = () => {
    if (!main_browserWindow)
        return;
    openDevTools(main_browserWindow.webContents);
};

;// CONCATENATED MODULE: ./src/main/modules/userApi/rendererEvent/rendererEvent.ts





let userApi;
let apiStatus = { status: true };
const requestQueue = new Map();
const timeouts = new Map();
const init = () => {
    const handleInit = ({ params: { status, message, data: apiInfo } }) => {
        // console.log('inited')
        // if (!status) {
        //   console.log('init failed:', message)
        //   global.lx_event.userApi.status(status = { status: true, apiInfo: { ...userApi, sources: apiInfo.sources } })
        //   return
        // }
        apiStatus = status
            ? { status: true, apiInfo: { ...userApi, sources: apiInfo.sources } }
            : { status: false, apiInfo: userApi, message };
        sendStatusChange(apiStatus);
    };
    const handleResponse = ({ params: { status, data: { requestKey, result }, message } }) => {
        const request = requestQueue.get(requestKey);
        if (!request)
            return;
        requestQueue.delete(requestKey);
        clearRequestTimeout(requestKey);
        if (status) {
            request[0](result);
        }
        else {
            request[1](new Error(message));
        }
    };
    const handleOpenDevTools = () => {
        main_openDevTools();
    };
    const handleShowUpdateAlert = ({ params: { data } }) => {
        if (!userApi.allowShowUpdateAlert)
            return;
        sendShowUpdateAlert({
            name: userApi.name,
            description: userApi.description,
            log: data.log,
            updateUrl: data.updateUrl,
        });
    };
    const handleGetProxy = () => {
        main_sendEvent(rendererEvent_name.proxyUpdate, getProxy());
    };
    mainOn(rendererEvent_name.init, handleInit);
    mainOn(rendererEvent_name.response, handleResponse);
    mainOn(rendererEvent_name.openDevTools, handleOpenDevTools);
    mainOn(rendererEvent_name.showUpdateAlert, handleShowUpdateAlert);
    mainOn(rendererEvent_name.getProxy, handleGetProxy);
};
const clearRequestTimeout = (requestKey) => {
    const timeout = timeouts.get(requestKey);
    if (timeout) {
        clearTimeout(timeout);
        timeouts.delete(requestKey);
    }
};
const loadApi = async (apiId) => {
    if (!apiId) {
        apiStatus = { status: false, message: 'api id is null' };
        sendStatusChange(apiStatus);
        return;
    }
    const targetApi = getUserApis().find(api => api.id == apiId);
    if (!targetApi)
        throw new Error('api not found');
    userApi = targetApi;
    console.log('load api', userApi.name);
    await main_createWindow(userApi);
    // if (!userApi) return global.lx_event.userApi.status(status = { status: false, message: 'api script is not found' })
    // if (!global.modules.userApiWindow) {
    //   global.lx_event.userApi.status(status = { status: false, message: 'user api runtime is not defined' })
    //   throw new Error('user api window is not defined')
    // }
    // // const path = require('path')
    // // // eslint-disable-next-line no-undef
    // // userApi.script = require('fs').readFileSync(join(process.env.NODE_ENV !== 'production' ? __userApi : __dirname, 'renderer/test-api.js')).toString()
    // console.log('load api', userApi.name)
    // mainSend(global.modules.userApiWindow, USER_API_RENDERER_EVENT_NAME.init, { userApi })
};
const cancelRequest = (requestKey) => {
    if (!requestQueue.has(requestKey))
        return;
    const request = requestQueue.get(requestKey);
    request[1](new Error('Cancel request'));
    requestQueue.delete(requestKey);
    clearRequestTimeout(requestKey);
};
const request = async ({ requestKey, data }) => await new Promise((resolve, reject) => {
    if (!userApi) {
        reject(new Error('user api is not load'));
    }
    // const requestKey = `request__${Math.random().toString().substring(2)}`
    const timeout = timeouts.get(requestKey);
    if (timeout) {
        clearTimeout(timeout);
        timeouts.delete(requestKey);
        cancelRequest(requestKey);
    }
    timeouts.set(requestKey, setTimeout(() => {
        cancelRequest(requestKey);
    }, 20000));
    requestQueue.set(requestKey, [resolve, reject, data]);
    sendRequest({ requestKey, data });
});
const getStatus = () => apiStatus;
const rendererEvent_setAllowShowUpdateAlert = (id, enable) => {
    if (!userApi || userApi.id != id)
        return;
    userApi.allowShowUpdateAlert = enable;
};
const sendRequest = (reqData) => {
    main_sendEvent(rendererEvent_name.request, reqData);
};

;// CONCATENATED MODULE: ./src/main/modules/userApi/index.ts



let userApiId;
const getApiList = getUserApis;
const userApi_importApi = async (script) => {
    return {
        apiInfo: await importApi(script),
        apiList: getUserApis(),
    };
};
const userApi_removeApi = async (ids) => {
    if (userApiId && ids.includes(userApiId)) {
        userApiId = null;
        await main_closeWindow();
    }
    removeApi(ids);
    return getUserApis();
};
const setApi = async (id) => {
    if (userApiId) {
        userApiId = null;
        await main_closeWindow();
    }
    const apiList = getUserApis();
    if (!apiList.some(a => a.id === id))
        return;
    userApiId ||= id;
    await loadApi(id);
};
const userApi_setAllowShowUpdateAlert = (id, enable) => {
    setAllowShowUpdateAlert(id, enable);
    rendererEvent_setAllowShowUpdateAlert(id, enable);
};

/* harmony default export */ const modules_userApi = (() => {
    init();
    global.lx.event_app.on('main_window_close', () => {
        void main_closeWindow();
    });
});

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/userApi.ts




/* harmony default export */ const rendererEvent_userApi = (() => {
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.import_user_api, async ({ params: script }) => {
        return userApi_importApi(script);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.remove_user_api, async ({ params: apiIds }) => {
        return userApi_removeApi(apiIds);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.set_user_api, async ({ params: apiId }) => {
        await setApi(apiId);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_user_api_list, async () => {
        return getApiList();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_user_api_status, async () => {
        return getStatus();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.user_api_set_allow_update_alert, async ({ params: { id, enable } }) => {
        userApi_setAllowShowUpdateAlert(id, enable);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.request_user_api, async ({ params }) => {
        return request(params);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.request_user_api_cancel, async ({ params: requestKey }) => {
        cancelRequest(requestKey);
    });
});
const sendStatusChange = (status) => {
    sendEvent(WIN_MAIN_RENDERER_EVENT_NAME.user_api_status, status);
};
const sendShowUpdateAlert = (info) => {
    sendEvent(WIN_MAIN_RENDERER_EVENT_NAME.user_api_show_update_alert, info);
};

// EXTERNAL MODULE: ./node_modules/needle/lib/needle.js
var needle = __webpack_require__(8747);
var needle_default = /*#__PURE__*/__webpack_require__.n(needle);
// EXTERNAL MODULE: ./node_modules/tunnel/index.js
var tunnel = __webpack_require__(803);
;// CONCATENATED MODULE: ./src/main/utils/request.ts

// import progress from 'request-progress'

// import fs from 'fs'
const requestMsg = {
    fail: '请求异常😮，可以多试几次，若还是不行就换一首吧。。。',
    unachievable: '哦No😱...接口无法访问了！',
    timeout: '请求超时',
    // unachievable: '哦No😱...接口无法访问了！已帮你切换到临时接口，重试下看能不能播放吧~',
    notConnectNetwork: '无法连接到服务器',
    cancelRequest: '取消http请求',
};
const httpsRxp = /^https:/;
let envProxy = null;
const getRequestAgent = (url) => {
    if (envProxy == null) {
        if (global.envParams.cmdParams['proxy-server'] && typeof global.envParams.cmdParams['proxy-server'] == 'string') {
            const [host, port = ''] = global.envParams.cmdParams['proxy-server'].split(':');
            envProxy = {
                host,
                port,
            };
        }
    }
    const proxy = {
        enable: global.lx.appSetting['network.proxy.enable'],
        host: global.lx.appSetting['network.proxy.host'],
        port: global.lx.appSetting['network.proxy.port'],
        envProxy,
    };
    let options;
    if (global.lx.appSetting['network.proxy.enable'] && proxy.host) {
        options = {
            proxy: {
                host: proxy.host,
                port: parseInt(proxy.port || '80'),
            },
        };
    }
    else if (proxy.envProxy) {
        options = {
            proxy: {
                host: proxy.envProxy.host,
                port: parseInt(proxy.envProxy.port || '80'),
            },
        };
    }
    return options ? (httpsRxp.test(url) ? tunnel.httpsOverHttp : tunnel.httpOverHttp)(options) : undefined;
};
const request_request = (url, options, callback) => {
    let data = null;
    if (options.body) {
        data = options.body;
    }
    else if (options.form) {
        data = options.form;
        // data.content_type = 'application/x-www-form-urlencoded'
        options.json = false;
    }
    else if (options.formData) {
        data = options.formData;
        // data.content_type = 'multipart/form-data'
        options.json = false;
    }
    options.response_timeout = options.timeout;
    return needle_default().request(options.method ?? 'get', url, data, options, (err, resp, body) => {
        if (!err) {
            body = resp.body = resp.raw.toString();
            try {
                resp.body = JSON.parse(resp.body);
            }
            catch (_) { }
            body = resp.body;
        }
        callback(err, resp, body);
        // @ts-expect-error
    }).request;
};
const defaultHeaders = {
    'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36',
};
// var proxyUrl = "http://" + user + ":" + password + "@" + host + ":" + port;
// var proxiedRequest = request.defaults({'proxy': proxyUrl});
// interface RequestPromise extends Promise<RequestResponse> {
//   abort: () => void
// }
/**
 * promise 形式的请求方法
 * @param {*} url
 * @param {*} options
 */
const buildHttpPromose = async (url, options) => {
    return new Promise((resolve, reject) => {
        void fetchData(url, options.method, options, (err, resp, body) => {
            // options.isShowProgress && window.api.hideProgress()
            // debugRequest && console.log(`\n---response------${url}------------`)
            // debugRequest && console.log(body)
            // obj.requestObj = null
            // obj.cancelFn = null
            if (err) {
                reject(err);
                return;
            }
            resolve(resp);
        });
        // .then(request => {
        //   // obj.requestObj = ro
        //   // if (obj.isCancelled) obj.cancelHttp()
        //   promise.abort = () => {
        //     request.destroy(new Error('cancelled'))
        //   }
        // })
    });
    // let obj = {
    //   isCancelled: false,
    //   cancelHttp: () => {
    //     if (!obj.requestObj) return obj.isCancelled = true
    //     cancelHttp(obj.requestObj)
    //     obj.requestObj = null
    //     obj.promise = obj.cancelHttp = null
    //     obj.cancelFn(new Error(requestMsg.cancelRequest))
    //     obj.cancelFn = null
    //   },
    // }
    // obj.promise = new Promise((resolve, reject) => {
    //   obj.cancelFn = reject
    //   debugRequest && console.log(`\n---send request------${url}------------`)
    //   fetchData(url, options.method, options, (err, resp, body) => {
    //     // options.isShowProgress && window.api.hideProgress()
    //     debugRequest && console.log(`\n---response------${url}------------`)
    //     debugRequest && console.log(body)
    //     obj.requestObj = null
    //     obj.cancelFn = null
    //     if (err) { reject(err); return }
    //     resolve(resp)
    //   }).then(ro => {
    //     obj.requestObj = ro
    //     if (obj.isCancelled) obj.cancelHttp()
    //   })
    // })
    // return obj
};
/**
 * 请求超时自动重试
 * @param {*} url
 * @param {*} options
 */
const httpFetch = async (url, options = { method: 'get' }) => {
    return buildHttpPromose(url, options).catch(async (err) => {
        // console.log('出错', err)
        if (err.message === 'socket hang up') {
            // window.globalObj.apiSource = 'temp'
            throw new Error(requestMsg.unachievable);
        }
        switch (err.code) {
            case 'ETIMEDOUT':
            case 'ESOCKETTIMEDOUT':
                throw new Error(requestMsg.timeout);
            case 'ENOTFOUND':
                throw new Error(requestMsg.notConnectNetwork);
            default:
                throw err;
        }
    });
    // requestObj.promise = requestObj.promise.catch(async err => {
    //   // console.log('出错', err)
    //   if (err.message === 'socket hang up') {
    //     // window.globalObj.apiSource = 'temp'
    //     return Promise.reject(new Error(requestMsg.unachievable))
    //   }
    //   switch (err.code) {
    //     case 'ETIMEDOUT':
    //     case 'ESOCKETTIMEDOUT':
    //       return Promise.reject(new Error(requestMsg.timeout))
    //     case 'ENOTFOUND':
    //       return Promise.reject(new Error(requestMsg.notConnectNetwork))
    //     default:
    //       return Promise.reject(err)
    //   }
    // })
    // return requestPromise
};
const fetchData = async (url, method, { headers = {}, format = 'json', timeout = 15000, ...options }, callback) => {
    // console.log(url, options)
    console.log('---start---', url);
    headers = Object.assign({}, headers);
    return request_request(url, {
        ...options,
        method,
        headers: Object.assign({}, defaultHeaders, headers),
        timeout,
        agent: getRequestAgent(url),
        json: format === 'json',
    }, (err, resp, body) => {
        callback(err, resp, body);
    });
};

;// CONCATENATED MODULE: external "node:child_process"
const external_node_child_process_namespaceObject = require("node:child_process");
var external_node_child_process_default = /*#__PURE__*/__webpack_require__.n(external_node_child_process_namespaceObject);
;// CONCATENATED MODULE: ./src/main/modules/sync/utils.ts





// https://stackoverflow.com/a/75309339
const getComputerName = () => {
    let name;
    switch (process.platform) {
        case 'win32':
            name = ({"NODE_ENV":"production"}).COMPUTERNAME;
            break;
        case 'darwin':
            try {
                name = external_node_child_process_default().execSync('scutil --get ComputerName').toString().trim();
            }
            catch { }
            break;
        case 'linux':
            // Don't fail even if hostnamectl is unavailable
            try {
                name = external_node_child_process_default().execSync('hostnamectl --pretty').toString().trim();
            }
            catch { }
            break;
    }
    if (!name)
        name = external_node_os_default().hostname();
    return name;
};
const utils_gzip = async (data) => new Promise((resolve, reject) => {
    external_node_zlib_default().gzip(data, (err, buf) => {
        if (err) {
            reject(err);
            return;
        }
        resolve(buf.toString('base64'));
    });
});
const unGzip = async (data) => new Promise((resolve, reject) => {
    external_node_zlib_default().gunzip(Buffer.from(data, 'base64'), (err, buf) => {
        if (err) {
            reject(err);
            return;
        }
        resolve(buf.toString());
    });
});
const encodeData = async (data) => {
    return data.length > 1024
        ? 'cg_' + await utils_gzip(data)
        : data;
};
const decodeData = async (enData) => {
    return enData.substring(0, 3) == 'cg_'
        ? await unGzip(enData.replace('cg_', ''))
        : enData;
};
const aesEncrypt = (text, key) => {
    const cipher = (0,external_node_crypto_namespaceObject.createCipheriv)('aes-128-ecb', Buffer.from(key, 'base64'), '');
    return Buffer.concat([cipher.update(Buffer.from(text)), cipher.final()]).toString('base64');
};
const aesDecrypt = (text, key) => {
    const decipher = (0,external_node_crypto_namespaceObject.createDecipheriv)('aes-128-ecb', Buffer.from(key, 'base64'), '');
    return Buffer.concat([decipher.update(Buffer.from(text, 'base64')), decipher.final()]).toString();
};
const rsaEncrypt = (buffer, key) => {
    return publicEncrypt({ key, padding: constants.RSA_PKCS1_OAEP_PADDING }, buffer).toString('base64');
};
const rsaDecrypt = (buffer, key) => {
    return (0,external_node_crypto_namespaceObject.privateDecrypt)({ key, padding: external_node_crypto_namespaceObject.constants.RSA_PKCS1_OAEP_PADDING }, buffer);
};
const exists = async (path) => external_node_fs_default().promises.stat(path).then(() => true).catch(() => false);

;// CONCATENATED MODULE: ./src/main/modules/sync/client/utils.ts



const utils_request = async (url, options = {}) => {
    return httpFetch(url, {
        ...options,
        timeout: options.timeout ?? 10000,
    }).then(response => {
        return {
            text: response.body,
            code: response.statusCode,
        };
    });
    // const controller = new AbortController()
    // let id: number | null = setTimeout(() => {
    //   id = null
    //   controller.abort()
    // }, timeout)
    // return fetch(url, {
    //   ...options,
    //   signal: controller.signal,
    // // eslint-disable-next-line @typescript-eslint/promise-function-async
    // }).then(async(response) => {
    //   const text = await response.text()
    //   return {
    //     text,
    //     code: response.status,
    //   }
    // }).catch(err => {
    //   // console.log(err, err.code, err.message)
    //   throw err
    // }).finally(() => {
    //   if (id == null) return
    //   clearTimeout(id)
    // })
};
// export const aesEncrypt = (text: string, key: string, iv: string) => {
//   const cipher = createCipheriv('aes-128-cbc', Buffer.from(key, 'base64'), Buffer.from(iv, 'base64'))
//   return Buffer.concat([cipher.update(Buffer.from(text)), cipher.final()]).toString('base64')
// }
// export const aesDecrypt = (text: string, key: string, iv: string) => {
//   const decipher = createDecipheriv('aes-128-cbc', Buffer.from(key, 'base64'), Buffer.from(iv, 'base64'))
//   return Buffer.concat([decipher.update(Buffer.from(text, 'base64')), decipher.final()]).toString()
// }
const generateRsaKey = async () => new Promise((resolve, reject) => {
    (0,external_node_crypto_namespaceObject.generateKeyPair)('rsa', {
        modulusLength: 2048, // It holds a number. It is the key size in bits and is applicable for RSA, and DSA algorithm only.
        publicKeyEncoding: {
            type: 'spki', // Note the type is pkcs1 not spki
            format: 'pem',
        },
        privateKeyEncoding: {
            type: 'pkcs8', // Note again the type is set to pkcs1
            format: 'pem',
            // cipher: "aes-256-cbc", //Optional
            // passphrase: "", //Optional
        },
    }, (err, publicKey, privateKey) => {
        if (err) {
            reject(err);
            return;
        }
        resolve({
            publicKey,
            privateKey,
        });
    });
});
const encryptMsg = async (keyInfo, msg) => {
    return encodeData(msg);
    // if (!keyInfo) return ''
    // return aesEncrypt(msg, keyInfo.key, keyInfo.iv)
};
const decryptMsg = async (keyInfo, enMsg) => {
    return decodeData(enMsg);
    // if (!keyInfo) return ''
    // let msg = ''
    // try {
    //   msg = aesDecrypt(enMsg, keyInfo.key, keyInfo.iv)
    // } catch (err) {
    //   console.log(err)
    // }
    // return msg
};
const parseUrl = (host) => {
    const url = new URL(host);
    let hostPath = url.host + url.pathname;
    let href = url.href;
    if (hostPath.endsWith('/'))
        hostPath = hostPath.replace(/\/$/, '');
    if (href.endsWith('/'))
        href = href.replace(/\/$/, '');
    return {
        wsProtocol: url.protocol == 'https:' ? 'wss:' : 'ws:',
        httpProtocol: url.protocol,
        hostPath,
        href,
    };
};
const sendStatus = (status) => {
    // syncLog.log(JSON.stringify(status))
};

;// CONCATENATED MODULE: ./src/common/constants_sync.ts
const ENV_PARAMS = (/* unused pure expression or super */ null && ([
    'PORT',
    'BIND_IP',
    'CONFIG_PATH',
    'LOG_PATH',
    'DATA_PATH',
    'PROXY_HEADER',
    'MAX_SNAPSHOT_NUM',
    'LIST_ADD_MUSIC_LOCATION_TYPE',
    'LX_USER_',
]));
const constants_sync_LIST_IDS = {
    DEFAULT: 'default',
    LOVE: 'love',
    TEMP: 'temp',
    DOWNLOAD: 'download',
    PLAY_LATER: null,
};
const SYNC_CODE = {
    helloMsg: 'Hello~::^-^::~v4~',
    idPrefix: 'OjppZDo6',
    authMsg: 'lx-music auth::',
    msgAuthFailed: 'Auth failed',
    msgBlockedIp: 'Blocked IP',
    msgConnect: 'lx-music connect',
    authFailed: 'Auth failed',
    missingAuthCode: 'Missing auth code',
    getServiceIdFailed: 'Get service id failed',
    connectServiceFailed: 'Connect service failed',
    connecting: 'Connecting...',
    unknownServiceAddress: 'Unknown service address',
};
const SYNC_CLOSE_CODE = {
    normal: 1000,
    failed: 4100,
};
const TRANS_MODE = {
    merge_local_remote: 'merge_remote_local',
    merge_remote_local: 'merge_local_remote',
    overwrite_local_remote: 'overwrite_remote_local',
    overwrite_remote_local: 'overwrite_local_remote',
    overwrite_local_remote_full: 'overwrite_remote_local_full',
    overwrite_remote_local_full: 'overwrite_local_remote_full',
    cancel: 'cancel',
};
const File = {
    serverDataPath: 'sync/server',
    clientDataPath: 'sync/client',
    serverInfoJSON: 'serverInfo.json',
    userDir: 'users',
    userDevicesJSON: 'devices.json',
    listDir: 'list',
    listSnapshotDir: 'snapshot',
    listSnapshotInfoJSON: 'snapshotInfo.json',
    dislikeDir: 'dislike',
    dislikeSnapshotDir: 'snapshot',
    dislikeSnapshotInfoJSON: 'snapshotInfo.json',
    syncAuthKeysJSON: 'syncAuthKey.json',
};
const FeaturesList = [
    'list',
    'dislike',
];

;// CONCATENATED MODULE: ./src/main/modules/sync/client/data.ts




let syncAuthKeys;
const saveSyncAuthKeys = async () => {
    const syncAuthKeysFilePath = external_node_path_default().join(global.lxDataPath, File.clientDataPath, File.syncAuthKeysJSON);
    return external_node_fs_default().promises.writeFile(syncAuthKeysFilePath, JSON.stringify(syncAuthKeys), 'utf8');
};
const initClientInfo = async () => {
    if (syncAuthKeys != null)
        return;
    const syncAuthKeysFilePath = external_node_path_default().join(global.lxDataPath, File.clientDataPath, File.syncAuthKeysJSON);
    if (await external_node_fs_default().promises.stat(syncAuthKeysFilePath).then(() => true).catch(() => false)) {
        // eslint-disable-next-line require-atomic-updates
        syncAuthKeys = JSON.parse((await external_node_fs_default().promises.readFile(syncAuthKeysFilePath)).toString());
    }
    else {
        // eslint-disable-next-line require-atomic-updates
        syncAuthKeys = {};
        const syncDataPath = external_node_path_default().join(global.lxDataPath, File.clientDataPath);
        if (!await exists(syncDataPath)) {
            await external_node_fs_default().promises.mkdir(syncDataPath, { recursive: true });
        }
        void saveSyncAuthKeys();
    }
};
const getSyncAuthKey = async (serverId) => {
    await initClientInfo();
    return syncAuthKeys[serverId] ?? null;
};
const setSyncAuthKey = async (serverId, info) => {
    await initClientInfo();
    syncAuthKeys[serverId] = info;
    void saveSyncAuthKeys();
};
// let syncHost: string
// export const getSyncHost = async() => {
//   if (syncHost === undefined) {
//     const store = getStore(STORE_NAMES.SYNC)
//     syncHost = (store.get('syncHost') as typeof syncHost | null) ?? ''
//   }
//   return syncHost
// }
// export const setSyncHost = async(host: string) => {
//   // let hostInfo = await getData(syncHostPrefix) || {}
//   // hostInfo.host = host
//   // hostInfo.port = port
//   syncHost = host
//   const store = getStore(STORE_NAMES.SYNC)
//   store.set('syncHost', syncHost)
// }
// let syncHostHistory: string[]
// export const getSyncHostHistory = async() => {
//   if (syncHostHistory === undefined) {
//     const store = getStore(STORE_NAMES.SYNC)
//     syncHostHistory = (store.get('syncHostHistory') as string[]) ?? []
//   }
//   return syncHostHistory
// }
// export const addSyncHostHistory = async(host: string) => {
//   let syncHostHistory = await getSyncHostHistory()
//   if (syncHostHistory.some(h => h == host)) return
//   syncHostHistory.unshift(host)
//   if (syncHostHistory.length > 20) syncHostHistory = syncHostHistory.slice(0, 20) // 最多存储20个
//   const store = getStore(STORE_NAMES.SYNC)
//   store.set('syncHostHistory', syncHostHistory)
// }
// export const removeSyncHostHistory = async(index: number) => {
//   syncHostHistory.splice(index, 1)
//   const store = getStore(STORE_NAMES.SYNC)
//   store.set('syncHostHistory', syncHostHistory)
// }

;// CONCATENATED MODULE: ./src/main/modules/sync/log.ts

/* harmony default export */ const sync_log = ({
    r_info(...params) {
        node_default().info(...params);
    },
    r_warn(...params) {
        node_default().warn(...params);
    },
    r_error(...params) {
        node_default().error(...params);
    },
    info(...params) {
        // if (global.lx.isEnableSyncLog) writeLog.info(...params)
        console.log(...params);
    },
    warn(...params) {
        // if (global.lx.isEnableSyncLog) writeLog.warn(...params)
        console.warn(...params);
    },
    error(...params) {
        // if (global.lx.isEnableSyncLog) writeLog.error(...params)
        console.warn(...params);
    },
});

;// CONCATENATED MODULE: ./src/main/modules/sync/client/auth.ts






const hello = async (urlInfo) => utils_request(`${urlInfo.httpProtocol}//${urlInfo.hostPath}/hello`)
    .then(({ text }) => text == SYNC_CODE.helloMsg)
    .catch((err) => {
    sync_log.error('[auth] hello', err.message);
    console.log(err);
    return false;
});
const getServerId = async (urlInfo) => utils_request(`${urlInfo.httpProtocol}//${urlInfo.hostPath}/id`)
    .then(({ text }) => {
    if (!text.startsWith(SYNC_CODE.idPrefix))
        return '';
    return text.replace(SYNC_CODE.idPrefix, '');
})
    .catch((err) => {
    sync_log.error('[auth] getServerId', err.message);
    console.log(err);
    throw err;
});
const codeAuth = async (urlInfo, serverId, authCode) => {
    let key = nodejs_toMD5(authCode).substring(0, 16);
    // const iv = Buffer.from(key.split('').reverse().join('')).toString('base64')
    key = Buffer.from(key).toString('base64');
    let { publicKey, privateKey } = await generateRsaKey();
    publicKey = publicKey.replace(/\n/g, '')
        .replace('-----BEGIN PUBLIC KEY-----', '')
        .replace('-----END PUBLIC KEY-----', '');
    const msg = aesEncrypt(`${SYNC_CODE.authMsg}\n${publicKey}\n${getComputerName()}\nlx_music_desktop`, key);
    // console.log(msg, key)
    return utils_request(`${urlInfo.httpProtocol}//${urlInfo.hostPath}/ah`, { headers: { m: msg } }).then(async ({ text, code }) => {
        // console.log(text)
        switch (text) {
            case SYNC_CODE.msgBlockedIp:
                throw new Error(SYNC_CODE.msgBlockedIp);
            case SYNC_CODE.authFailed:
                throw new Error(SYNC_CODE.authFailed);
            default:
                if (code != 200)
                    throw new Error(SYNC_CODE.authFailed);
        }
        let msg;
        try {
            msg = rsaDecrypt(Buffer.from(text, 'base64'), privateKey).toString();
        }
        catch (err) {
            sync_log.error('[auth] codeAuth decryptMsg error', err.message);
            throw new Error(SYNC_CODE.authFailed);
        }
        // console.log(msg)
        if (!msg)
            return Promise.reject(new Error(SYNC_CODE.authFailed));
        const info = JSON.parse(msg);
        void setSyncAuthKey(serverId, info);
        return info;
    });
};
const keyAuth = async (urlInfo, keyInfo) => {
    const msg = aesEncrypt(SYNC_CODE.authMsg + getComputerName(), keyInfo.key);
    // eslint-disable-next-line @typescript-eslint/promise-function-async
    return utils_request(`${urlInfo.httpProtocol}//${urlInfo.hostPath}/ah`, { headers: { i: keyInfo.clientId, m: msg } }).then(({ text, code }) => {
        if (code != 200)
            throw new Error(SYNC_CODE.authFailed);
        let msg;
        try {
            msg = aesDecrypt(text, keyInfo.key);
        }
        catch (err) {
            sync_log.error('[auth] keyAuth decryptMsg error', err.message);
            throw new Error(SYNC_CODE.authFailed);
        }
        if (msg != SYNC_CODE.helloMsg)
            return Promise.reject(new Error(SYNC_CODE.authFailed));
    });
};
const auth = async (urlInfo, serverId, authCode) => {
    if (authCode)
        return codeAuth(urlInfo, serverId, authCode);
    const keyInfo = await getSyncAuthKey(serverId);
    if (!keyInfo)
        throw new Error(SYNC_CODE.missingAuthCode);
    await keyAuth(urlInfo, keyInfo);
    return keyInfo;
};
/* harmony default export */ const client_auth = (async (urlInfo, authCode) => {
    console.log('connect: ', urlInfo.href, authCode);
    if (!await hello(urlInfo))
        throw new Error(SYNC_CODE.connectServiceFailed);
    const serverId = await getServerId(urlInfo);
    if (!serverId)
        throw new Error(SYNC_CODE.getServiceIdFailed);
    return auth(urlInfo, serverId, authCode);
});

// EXTERNAL MODULE: ./node_modules/ws/lib/stream.js
var stream = __webpack_require__(3719);
// EXTERNAL MODULE: ./node_modules/ws/lib/receiver.js
var receiver = __webpack_require__(6286);
// EXTERNAL MODULE: ./node_modules/ws/lib/sender.js
var sender = __webpack_require__(914);
// EXTERNAL MODULE: ./node_modules/ws/lib/websocket.js
var websocket = __webpack_require__(1060);
// EXTERNAL MODULE: ./node_modules/ws/lib/websocket-server.js
var websocket_server = __webpack_require__(1722);
;// CONCATENATED MODULE: ./node_modules/ws/wrapper.mjs







/* harmony default export */ const wrapper = (websocket);

;// CONCATENATED MODULE: ./src/main/modules/sync/listEvent.ts

// 构建列表信息对象，用于统一字段位置顺序
const buildUserListInfoFull = ({ id, name, source, sourceListId, list, locationUpdateTime }) => {
    return {
        id,
        name,
        source,
        sourceListId,
        locationUpdateTime,
        list,
    };
};
const getLocalListData = async () => {
    const lists = {
        defaultList: await global.lx.worker.dbService.getListMusics(LIST_IDS.DEFAULT),
        loveList: await global.lx.worker.dbService.getListMusics(LIST_IDS.LOVE),
        userList: [],
    };
    const userListInfos = await global.lx.worker.dbService.getAllUserList();
    for await (const list of userListInfos) {
        lists.userList.push(await global.lx.worker.dbService.getListMusics(list.id)
            .then(musics => buildUserListInfoFull({ ...list, list: musics })));
    }
    return lists;
};
const setLocalListData = async (listData) => {
    await global.lx.event_list.list_data_overwrite(listData, true);
};
const registerListActionEvent = (sendListAction) => {
    const list_data_overwrite = async (listData, isRemote = false) => {
        if (isRemote)
            return;
        await sendListAction({ action: 'list_data_overwrite', data: listData });
    };
    const list_create = async (position, listInfos, isRemote = false) => {
        if (isRemote)
            return;
        await sendListAction({ action: 'list_create', data: { position, listInfos } });
    };
    const list_remove = async (ids, isRemote = false) => {
        if (isRemote)
            return;
        await sendListAction({ action: 'list_remove', data: ids });
    };
    const list_update = async (lists, isRemote = false) => {
        if (isRemote)
            return;
        await sendListAction({ action: 'list_update', data: lists });
    };
    const list_update_position = async (position, ids, isRemote = false) => {
        if (isRemote)
            return;
        await sendListAction({ action: 'list_update_position', data: { position, ids } });
    };
    const list_music_overwrite = async (listId, musicInfos, isRemote = false) => {
        if (isRemote || listId == LIST_IDS.TEMP)
            return;
        await sendListAction({ action: 'list_music_overwrite', data: { listId, musicInfos } });
    };
    const list_music_add = async (id, musicInfos, addMusicLocationType, isRemote = false) => {
        if (isRemote)
            return;
        await sendListAction({ action: 'list_music_add', data: { id, musicInfos, addMusicLocationType } });
    };
    const list_music_move = async (fromId, toId, musicInfos, addMusicLocationType, isRemote = false) => {
        if (isRemote)
            return;
        await sendListAction({ action: 'list_music_move', data: { fromId, toId, musicInfos, addMusicLocationType } });
    };
    const list_music_remove = async (listId, ids, isRemote = false) => {
        if (isRemote || listId == LIST_IDS.TEMP)
            return;
        await sendListAction({ action: 'list_music_remove', data: { listId, ids } });
    };
    const list_music_update = async (musicInfos, isRemote = false) => {
        musicInfos = musicInfos.filter(item => item.id != LIST_IDS.TEMP);
        if (isRemote || !musicInfos.length)
            return;
        await sendListAction({ action: 'list_music_update', data: musicInfos });
    };
    const list_music_clear = async (ids, isRemote = false) => {
        if (isRemote)
            return;
        await sendListAction({ action: 'list_music_clear', data: ids });
    };
    const list_music_update_position = async (listId, position, ids, isRemote = false) => {
        if (isRemote || listId == LIST_IDS.TEMP)
            return;
        await sendListAction({ action: 'list_music_update_position', data: { listId, position, ids } });
    };
    global.lx.event_list.on('list_data_overwrite', list_data_overwrite);
    global.lx.event_list.on('list_create', list_create);
    global.lx.event_list.on('list_remove', list_remove);
    global.lx.event_list.on('list_update', list_update);
    global.lx.event_list.on('list_update_position', list_update_position);
    global.lx.event_list.on('list_music_overwrite', list_music_overwrite);
    global.lx.event_list.on('list_music_add', list_music_add);
    global.lx.event_list.on('list_music_move', list_music_move);
    global.lx.event_list.on('list_music_remove', list_music_remove);
    global.lx.event_list.on('list_music_update', list_music_update);
    global.lx.event_list.on('list_music_clear', list_music_clear);
    global.lx.event_list.on('list_music_update_position', list_music_update_position);
    return () => {
        global.lx.event_list.off('list_data_overwrite', list_data_overwrite);
        global.lx.event_list.off('list_create', list_create);
        global.lx.event_list.off('list_remove', list_remove);
        global.lx.event_list.off('list_update', list_update);
        global.lx.event_list.off('list_update_position', list_update_position);
        global.lx.event_list.off('list_music_overwrite', list_music_overwrite);
        global.lx.event_list.off('list_music_add', list_music_add);
        global.lx.event_list.off('list_music_move', list_music_move);
        global.lx.event_list.off('list_music_remove', list_music_remove);
        global.lx.event_list.off('list_music_update', list_music_update);
        global.lx.event_list.off('list_music_clear', list_music_clear);
        global.lx.event_list.off('list_music_update_position', list_music_update_position);
    };
};
const handleRemoteListAction = async ({ action, data }) => {
    // console.log('handleRemoteListAction', action)
    switch (action) {
        case 'list_data_overwrite':
            await global.lx.event_list.list_data_overwrite(data, true);
            break;
        case 'list_create':
            await global.lx.event_list.list_create(data.position, data.listInfos, true);
            break;
        case 'list_remove':
            await global.lx.event_list.list_remove(data, true);
            break;
        case 'list_update':
            await global.lx.event_list.list_update(data, true);
            break;
        case 'list_update_position':
            await global.lx.event_list.list_update_position(data.position, data.ids, true);
            break;
        case 'list_music_add':
            await global.lx.event_list.list_music_add(data.id, data.musicInfos, data.addMusicLocationType, true);
            break;
        case 'list_music_move':
            await global.lx.event_list.list_music_move(data.fromId, data.toId, data.musicInfos, data.addMusicLocationType, true);
            break;
        case 'list_music_remove':
            await global.lx.event_list.list_music_remove(data.listId, data.ids, true);
            break;
        case 'list_music_update':
            await global.lx.event_list.list_music_update(data, true);
            break;
        case 'list_music_update_position':
            await global.lx.event_list.list_music_update_position(data.listId, data.position, data.ids, true);
            break;
        case 'list_music_overwrite':
            await global.lx.event_list.list_music_overwrite(data.listId, data.musicInfos, true);
            break;
        case 'list_music_clear':
            await global.lx.event_list.list_music_clear(data, true);
            break;
        default:
            throw new Error('unknown list sync action');
    }
};

;// CONCATENATED MODULE: ./src/main/modules/sync/client/modules/list/localEvent.ts


let unregisterLocalListAction;
const registerEvent = (socket) => {
    // socket = _socket
    // socket.onClose(() => {
    //   unregisterLocalListAction?.()
    //   unregisterLocalListAction = null
    // })
    unregisterEvent();
    unregisterLocalListAction = registerListActionEvent((action) => {
        if (!socket.moduleReadys?.list)
            return;
        void socket.remoteQueueList.onListSyncAction(action).catch(err => {
            // TODO send status
            socket.moduleReadys.list = false;
            socket.close(SYNC_CLOSE_CODE.failed);
            console.log(err.message);
        });
    });
};
const unregisterEvent = () => {
    unregisterLocalListAction?.();
    unregisterLocalListAction = null;
};

;// CONCATENATED MODULE: ./src/main/modules/sync/client/modules/list/handler.ts
// 这个文件导出的方法将暴露给服务端调用，第一个参数固定为当前 socket 对象





const logInfo = (eventName, success = false) => {
    sync_log.info(`[${eventName}]${eventName.replace('list:sync:list_sync_', '').replaceAll('_', ' ')}${success ? ' success' : ''}`);
};
// const logError = (eventName: string, err: Error) => {
//   log.error(`[${eventName}]${eventName.replace('list:sync:list_sync_', '').replaceAll('_', ' ')} error: ${err.message}`)
// }
const getSyncMode = async (socket) => new Promise((resolve, reject) => {
    const handleDisconnect = (err) => {
        sendCloseSelectMode();
        removeSelectModeListener();
        reject(err);
    };
    let removeEventClose = socket.onClose(handleDisconnect);
    sendSelectMode(socket.data.keyInfo.serverName, 'list', (mode) => {
        if (mode == null) {
            reject(new Error('cancel'));
            return;
        }
        resolve(mode);
        removeSelectModeListener();
        removeEventClose();
    });
});
const handler = {
    async onListSyncAction(socket, action) {
        if (!socket.moduleReadys?.list)
            return;
        await handleRemoteListAction(action);
    },
    async list_sync_get_md5(socket) {
        logInfo('list:sync:list_sync_get_md5');
        return nodejs_toMD5(JSON.stringify(await getLocalListData()));
    },
    async list_sync_get_sync_mode(socket) {
        return getSyncMode(socket);
    },
    async list_sync_get_list_data(socket) {
        logInfo('list:sync:list_sync_get_list_data');
        return getLocalListData();
    },
    async list_sync_set_list_data(socket, data) {
        logInfo('list:sync:list_sync_set_list_data');
        await setLocalListData(data);
    },
    async list_sync_finished(socket) {
        logInfo('list:sync:finished');
        socket.moduleReadys.list = true;
        registerEvent(socket);
        socket.onClose(() => {
            unregisterEvent();
        });
    },
};
/* harmony default export */ const list_handler = (handler);

;// CONCATENATED MODULE: ./src/main/modules/sync/client/modules/list/index.ts



;// CONCATENATED MODULE: ./src/main/modules/sync/dislikeEvent.ts
const getLocalDislikeData = async () => {
    return (await global.lx.worker.dbService.getDislikeListInfo()).rules;
};
const setLocalDislikeData = async (listData) => {
    await global.lx.event_dislike.dislike_data_overwrite(listData, true);
};
const registerDislikeActionEvent = (sendDislikeAction) => {
    const dislike_music_add = async (listData, isRemote = false) => {
        if (isRemote)
            return;
        await sendDislikeAction({ action: 'dislike_music_add', data: listData });
    };
    const dislike_data_overwrite = async (listInfos, isRemote = false) => {
        if (isRemote)
            return;
        await sendDislikeAction({ action: 'dislike_data_overwrite', data: listInfos });
    };
    const dislike_music_clear = async (isRemote = false) => {
        if (isRemote)
            return;
        await sendDislikeAction({ action: 'dislike_music_clear' });
    };
    global.lx.event_dislike.on('dislike_music_add', dislike_music_add);
    global.lx.event_dislike.on('dislike_data_overwrite', dislike_data_overwrite);
    global.lx.event_dislike.on('dislike_music_clear', dislike_music_clear);
    return () => {
        global.lx.event_dislike.off('dislike_music_add', dislike_music_add);
        global.lx.event_dislike.off('dislike_data_overwrite', dislike_data_overwrite);
        global.lx.event_dislike.off('dislike_music_clear', dislike_music_clear);
    };
};
const handleRemoteDislikeAction = async (event) => {
    // console.log('handleRemoteDislikeAction', event)
    switch (event.action) {
        case 'dislike_music_add':
            await global.lx.event_dislike.dislike_music_add(event.data, true);
            break;
        case 'dislike_data_overwrite':
            await global.lx.event_dislike.dislike_data_overwrite(event.data, true);
            break;
        case 'dislike_music_clear':
            await global.lx.event_dislike.dislike_music_clear(true);
            break;
        default:
            throw new Error('unknown list sync action');
    }
};

;// CONCATENATED MODULE: ./src/main/modules/sync/client/modules/dislike/localEvent.ts


let localEvent_unregisterLocalListAction;
const localEvent_registerEvent = (socket) => {
    // socket = _socket
    // socket.onClose(() => {
    //   unregisterLocalListAction?.()
    //   unregisterLocalListAction = null
    // })
    localEvent_unregisterEvent();
    localEvent_unregisterLocalListAction = registerDislikeActionEvent((action) => {
        if (!socket.moduleReadys?.dislike)
            return;
        void socket.remoteQueueDislike.onDislikeSyncAction(action).catch(err => {
            // TODO send status
            socket.moduleReadys.dislike = false;
            socket.close(SYNC_CLOSE_CODE.failed);
            console.log(err.message);
        });
    });
};
const localEvent_unregisterEvent = () => {
    localEvent_unregisterLocalListAction?.();
    localEvent_unregisterLocalListAction = null;
};

;// CONCATENATED MODULE: ./src/main/modules/sync/client/modules/dislike/handler.ts
// 这个文件导出的方法将暴露给服务端调用，第一个参数固定为当前 socket 对象





const handler_logInfo = (eventName, success = false) => {
    sync_log.info(`[${eventName}]${eventName.replace('dislike:sync:dislike_sync_', '').replaceAll('_', ' ')}${success ? ' success' : ''}`);
};
// const logError = (eventName: string, err: Error) => {
//   log.error(`[${eventName}]${eventName.replace('dislike:sync:dislike_sync_', '').replaceAll('_', ' ')} error: ${err.message}`)
// }
const handler_getSyncMode = async (socket) => new Promise((resolve, reject) => {
    const handleDisconnect = (err) => {
        sendCloseSelectMode();
        removeSelectModeListener();
        reject(err);
    };
    let removeEventClose = socket.onClose(handleDisconnect);
    sendSelectMode(socket.data.keyInfo.serverName, 'dislike', (mode) => {
        if (mode == null) {
            reject(new Error('cancel'));
            return;
        }
        resolve(mode);
        removeSelectModeListener();
        removeEventClose();
    });
});
const handler_handler = {
    async onDislikeSyncAction(socket, action) {
        if (!socket.moduleReadys?.dislike)
            return;
        await handleRemoteDislikeAction(action);
    },
    async dislike_sync_get_md5(socket) {
        handler_logInfo('dislike:sync:dislike_sync_get_md5');
        return nodejs_toMD5((await getLocalDislikeData()).trim());
    },
    async dislike_sync_get_sync_mode(socket) {
        return handler_getSyncMode(socket);
    },
    async dislike_sync_get_list_data(socket) {
        handler_logInfo('dislike:sync:dislike_sync_get_list_data');
        return getLocalDislikeData();
    },
    async dislike_sync_set_list_data(socket, data) {
        handler_logInfo('dislike:sync:dislike_sync_set_list_data');
        await setLocalDislikeData(data);
    },
    async dislike_sync_finished(socket) {
        handler_logInfo('dislike:sync:finished');
        socket.moduleReadys.dislike = true;
        localEvent_registerEvent(socket);
        socket.onClose(() => {
            localEvent_unregisterEvent();
        });
    },
};
/* harmony default export */ const dislike_handler = (handler_handler);

;// CONCATENATED MODULE: ./src/main/modules/sync/client/modules/dislike/index.ts



;// CONCATENATED MODULE: ./src/main/modules/sync/client/modules/index.ts


// export * as theme from './theme'
const callObj = Object.assign({}, list_handler, dislike_handler);
const modules_modules = {
    list: modules_list_namespaceObject,
    dislike: modules_dislike_namespaceObject,
};
const featureVersion = {
    list: 1,
    dislike: 1,
};

;// CONCATENATED MODULE: ./src/main/modules/sync/client/sync/handler.ts
// 这个文件导出的方法将暴露给服务端调用，第一个参数固定为当前 socket 对象
// import { getUserSpace } from '@/user'
// import { modules } from '../modules'

const sync_handler_handler = {
    async getEnabledFeatures(socket, serverType, supportedFeatures) {
        // const userSpace = getUserSpace(socket.userInfo.name)
        const features = {};
        switch (serverType) {
            case 'server':
                if (featureVersion.list == supportedFeatures.list) {
                    features.list = { skipSnapshot: false };
                }
                if (featureVersion.dislike == supportedFeatures.dislike) {
                    features.dislike = { skipSnapshot: false };
                }
                return features;
            case 'desktop-app':
            default:
                if (featureVersion.list == supportedFeatures.list) {
                    features.list = { skipSnapshot: false };
                }
                if (featureVersion.dislike == supportedFeatures.dislike) {
                    features.dislike = { skipSnapshot: false };
                }
                return features;
        }
    },
};
/* harmony default export */ const sync_handler = (sync_handler_handler);

;// CONCATENATED MODULE: ./src/main/modules/sync/client/sync/index.ts



const sync_callObj = {
    ...sync_handler,
    ...callObj,
};

;// CONCATENATED MODULE: ./node_modules/message2call/dist/message2call.esm.js
const nextTick = typeof setImmediate == 'function'
    ? setImmediate
    : typeof queueMicrotask == 'function'
        ? queueMicrotask
        : setTimeout;

const emptyObj = {};
const noop = () => { };
const funcsTools = {
    funcsObj: emptyObj,
    events: emptyObj,
    queueGroups: emptyObj,
    sendMessage: noop,
    onError: noop,
    onCallBeforeParams: undefined,
    timeout: 120 * 1000,
    init(options) {
        this.funcsObj = options.funcsObj;
        this.events = new Map();
        this.queueGroups = new Map();
        this.sendMessage = options.sendMessage;
        if (options.timeout != null)
            this.timeout = options.timeout;
        if (options.onError != null)
            this.onError = options.onError;
        if (options.onCallBeforeParams != null)
            this.onCallBeforeParams = options.onCallBeforeParams;
        return this.createProxy(this, null);
    },
    async handleResponseData(eventName, path, args) {
        let obj = this.funcsObj;
        const name = path.pop();
        for (const _name of path) {
            obj = obj[_name];
            if (obj === undefined) {
                this.sendMessage({
                    name: eventName,
                    error: `${name} is not defined`,
                });
                return;
            }
        }
        if (typeof obj[name] == 'function') {
            let result;
            // console.log('args: ', args)
            try {
                if (this.onCallBeforeParams)
                    args = this.onCallBeforeParams(args);
                result = await obj[name].apply(obj, args);
            }
            catch (err) {
                this.sendMessage({
                    name: eventName,
                    error: err.message,
                });
                return;
            }
            this.sendMessage({
                name: eventName,
                error: null,
                data: result,
            });
        }
        else if (obj[name] === undefined) {
            this.sendMessage({
                name: eventName,
                error: `${name} is not defined`,
            });
        }
        else {
            this.sendMessage({
                name: eventName,
                error: null,
                data: obj[name],
            });
        }
    },
    handleGroupNextTask(groupName, error) {
        nextTick(() => {
            const group = this.queueGroups.get(groupName);
            group.handling = false;
            if (group.queue.length) {
                if (error == null) {
                    group.queue.shift()[0]();
                }
                else {
                    group.queue.shift()[1](error);
                }
            }
        });
    },
    async getData(groupName, pathname, data) {
        // console.log(groupName, pathname, data)
        const eventName = `${pathname.join('.')}__${String(Math.random()).substring(2)}`;
        if (groupName != null) {
            let group = this.queueGroups.get(groupName);
            if (group.handling) {
                await new Promise((resolve, reject) => {
                    group.queue.push([resolve, (error) => {
                            reject(error);
                            this.onError(error, pathname, groupName);
                            this.handleGroupNextTask(groupName, error);
                        }]);
                });
            }
            group.handling = true;
        }
        let promise = new Promise((resolve, reject) => {
            const handler = ((err, data) => {
                if (handler.timeout)
                    clearTimeout(handler.timeout);
                this.events.delete(eventName);
                if (err == null)
                    resolve(data);
                else {
                    const error = new Error(err);
                    this.onError(error, pathname, groupName);
                    reject(error);
                }
            });
            this.events.set(eventName, handler);
            handler.timeout = setTimeout(() => {
                handler.timeout = null;
                handler('timeout');
            }, this.timeout);
            this.sendMessage({
                name: eventName,
                path: pathname,
                data,
            });
        });
        if (groupName != null) {
            promise = promise.then((data) => {
                this.handleGroupNextTask(groupName);
                return data;
                // eslint-disable-next-line @typescript-eslint/promise-function-async
            }).catch((error) => {
                this.handleGroupNextTask(groupName, error);
                return Promise.reject(error);
            });
        }
        return promise;
    },
    async handleGetData(name, err, data) {
        const handler = this.events.get(name);
        if (handler) {
            if (typeof handler == 'function')
                handler(err, data);
            // else if (Array.isArray(handler)) {
            //   for (const h of handler) await h(data)
            // }
        }
    },
    createProxy(context, groupName, path = []) {
        const proxy = new Proxy(function () { }, {
            get: (_target, prop, receiver) => {
                let propName = prop.toString();
                // console.log('get prop name', propName, path)
                if (prop == 'then' && path.length) {
                    const r = context.getData(groupName, path);
                    return r.then.bind(r);
                }
                return context.createProxy(context, groupName, [...path, propName]);
            },
            // eslint-disable-next-line @typescript-eslint/promise-function-async
            apply: (target, thisArg, argumentsList) => {
                return context.getData(groupName, path, argumentsList);
            },
            // deleteProperty
        });
        return proxy;
    },
    onMessage({ name, path, error, data }) {
        if (name) {
            if (path?.length)
                void this.handleResponseData(name, path, data);
            else
                void this.handleGetData(name, error, data);
        }
    },
    onDestroy() {
        for (const handler of this.events.values()) {
            handler('destroy');
        }
    },
};
const createMsg2call = (options) => {
    const tools = Object.create(funcsTools);
    return {
        /**
         * remote proxy object
         */
        remote: tools.init(options),
        /**
         * create remote proxy object of queue calls
         */
        createQueueRemote(groupName) {
            tools.queueGroups.set(groupName, { handling: false, queue: [] });
            return tools.createProxy(tools, groupName);
        },
        /**
         * on message function
         */
        message: tools.onMessage.bind(tools),
        /**
         * destroy
         */
        destroy: tools.onDestroy.bind(tools),
    };
};



;// CONCATENATED MODULE: ./src/main/modules/sync/client/client.ts



// import { action as commonAction } from '@root/store/modules/common'
// import { getStore } from '@root/store'
// import registerSyncListHandler from './syncList'







let client_status = {
    status: false,
    message: '',
    address: [],
};
const sendSyncStatus = (newStatus) => {
    client_status.status = newStatus.status;
    client_status.message = newStatus.message;
    if (client_status.status) {
        client_status.address = getAddress();
    }
    sendClientStatus(client_status);
};
const sendSyncMessage = (message) => {
    client_status.message = message;
    sendClientStatus(client_status);
};
const heartbeatTools = {
    failedNum: 0,
    maxTryNum: 100000,
    stepMs: 3000,
    connectTimeout: null,
    pingTimeout: null,
    delayRetryTimeout: null,
    handleOpen() {
        console.log('open');
        // this.failedNum = 0
        this.heartbeat();
    },
    heartbeat() {
        if (this.pingTimeout)
            clearTimeout(this.pingTimeout);
        // Use `WebSocket#terminate()`, which immediately destroys the connection,
        // instead of `WebSocket#close()`, which waits for the close timer.
        // Delay should be equal to the interval at which your server
        // sends out pings plus a conservative assumption of the latency.
        this.pingTimeout = setTimeout(() => {
            client?.terminate();
        }, 30000 + 1000);
    },
    reConnnect() {
        this.clearTimeout();
        // client = null
        if (!client)
            return;
        if (++this.failedNum > this.maxTryNum) {
            this.failedNum = 0;
            sendSyncStatus({
                status: false,
                message: 'Connect error',
            });
            throw new Error('connect error');
        }
        const waitTime = Math.min(2000 + Math.floor(this.failedNum / 2) * this.stepMs, 15000);
        // sendSyncStatus({
        //   status: false,
        //   message: `Waiting ${waitTime / 1000}s reconnnect...`,
        // })
        this.delayRetryTimeout = setTimeout(() => {
            this.delayRetryTimeout = null;
            if (!client)
                return;
            console.log(dateFormat(new Date()), 'reconnnect...');
            sendSyncStatus({
                status: false,
                message: `Try reconnnect... (${this.failedNum})`,
            });
            connect(client.data.urlInfo, client.data.keyInfo);
        }, waitTime);
    },
    clearTimeout() {
        if (this.connectTimeout) {
            clearTimeout(this.connectTimeout);
            this.connectTimeout = null;
        }
        if (this.delayRetryTimeout) {
            clearTimeout(this.delayRetryTimeout);
            this.delayRetryTimeout = null;
        }
        if (this.pingTimeout) {
            clearTimeout(this.pingTimeout);
            this.pingTimeout = null;
        }
    },
    connect(socket) {
        console.log('heartbeatTools connect');
        this.connectTimeout = setTimeout(() => {
            this.connectTimeout = null;
            if (client) {
                try {
                    client.close(SYNC_CLOSE_CODE.failed);
                }
                catch { }
            }
            if (++this.failedNum > this.maxTryNum) {
                this.failedNum = 0;
                sendSyncStatus({
                    status: false,
                    message: 'Connect error',
                });
                throw new Error('connect error');
            }
            sendSyncStatus({
                status: false,
                message: 'Connect timeout, try reconnect...',
            });
            this.reConnnect();
        }, 2 * 60 * 1000);
        socket.on('open', () => {
            if (this.connectTimeout) {
                clearTimeout(this.connectTimeout);
                this.connectTimeout = null;
            }
            this.handleOpen();
        });
        socket.on('ping', () => {
            this.heartbeat();
        });
        socket.on('close', (code) => {
            console.log(code);
            switch (code) {
                case SYNC_CLOSE_CODE.normal:
                case SYNC_CLOSE_CODE.failed:
                    return;
            }
            this.reConnnect();
        });
    },
};
let client;
// let listSyncPromise: Promise<void>
const connect = (urlInfo, keyInfo) => {
    client = new wrapper(`${urlInfo.wsProtocol}//${urlInfo.hostPath}/socket?i=${encodeURIComponent(keyInfo.clientId)}&t=${encodeURIComponent(aesEncrypt(SYNC_CODE.msgConnect, keyInfo.key))}`, {});
    client.data = {
        keyInfo,
        urlInfo,
    };
    heartbeatTools.connect(client);
    let closeEvents = [];
    let disconnected = true;
    const message2read = createMsg2call({
        funcsObj: {
            ...sync_callObj,
            finished() {
                sync_log.info('sync list success');
                client.isReady = true;
                sendSyncStatus({
                    status: true,
                    message: '',
                });
                heartbeatTools.failedNum = 0;
            },
        },
        timeout: 120 * 1000,
        sendMessage(data) {
            if (disconnected)
                throw new Error('disconnected');
            void encryptMsg(keyInfo, JSON.stringify(data)).then((data) => {
                client?.send(data);
            }).catch((err) => {
                sync_log.error('encrypt msg error: ', err);
                client?.close(SYNC_CLOSE_CODE.failed);
            });
        },
        onCallBeforeParams(rawArgs) {
            return [client, ...rawArgs];
        },
        onError(error, path, groupName) {
            const name = groupName ?? '';
            sync_log.error(`sync call ${name} ${path.join('.')} error:`, error);
            // if (groupName == null) return
            // client?.close(SYNC_CLOSE_CODE.failed)
            // sendSyncStatus({
            //   status: false,
            //   message: error.message,
            // })
        },
    });
    client.remote = message2read.remote;
    client.remoteQueueList = message2read.createQueueRemote('list');
    client.remoteQueueDislike = message2read.createQueueRemote('dislike');
    client.addEventListener('message', ({ data }) => {
        if (data == 'ping')
            return;
        if (typeof data === 'string') {
            void decryptMsg(keyInfo, data).then((data) => {
                let syncData;
                try {
                    syncData = JSON.parse(data);
                }
                catch (err) {
                    sync_log.error('parse msg error: ', err);
                    client?.close(SYNC_CLOSE_CODE.failed);
                    return;
                }
                message2read.message(syncData);
            }).catch((error) => {
                sync_log.error('decrypt msg error: ', error);
                client?.close(SYNC_CLOSE_CODE.failed);
            });
        }
    });
    client.onClose = function (handler) {
        closeEvents.push(handler);
        return () => {
            closeEvents.splice(closeEvents.indexOf(handler), 1);
        };
    };
    const initMessage = 'Wait syncing...';
    client.addEventListener('open', () => {
        sync_log.info('connect');
        // const store = getStore()
        // global.lx.syncKeyInfo = keyInfo
        client.isReady = false;
        client.moduleReadys = {
            list: false,
            dislike: false,
        };
        disconnected = false;
        sendSyncStatus({
            status: false,
            message: initMessage,
        });
    });
    client.addEventListener('close', ({ code }) => {
        const err = new Error('closed');
        try {
            for (const handler of closeEvents)
                void handler(err);
        }
        catch (err) {
            sync_log.error(err?.message);
        }
        closeEvents = [];
        disconnected = true;
        message2read.destroy();
        switch (code) {
            case SYNC_CLOSE_CODE.normal:
                // case SYNC_CLOSE_CODE.failed:
                sendSyncStatus({
                    status: false,
                    message: '',
                });
                break;
            case SYNC_CLOSE_CODE.failed:
                if (!client_status.message || client_status.message == initMessage) {
                    sendSyncStatus({
                        status: false,
                        message: 'failed',
                    });
                }
                break;
        }
    });
    client.addEventListener('error', ({ message }) => {
        sendSyncStatus({
            status: false,
            message,
        });
    });
};
const disconnect = async () => {
    if (!client)
        return;
    sync_log.info('disconnecting...');
    client.close(SYNC_CLOSE_CODE.normal);
    client = null;
    heartbeatTools.clearTimeout();
    heartbeatTools.failedNum = 0;
};
const client_getStatus = () => client_status;

;// CONCATENATED MODULE: ./src/main/modules/sync/migrate.ts




// 迁移 v2 sync 数据
/* harmony default export */ const migrate = (async (dataPath) => {
    const syncDataPath = external_node_path_default().join(dataPath, 'sync');
    // console.log(syncDataPath)
    if (await exists(syncDataPath))
        return;
    const oldInfoPath = external_node_path_default().join(dataPath, 'sync.json');
    // console.log(oldInfoPath)
    if (!await exists(oldInfoPath))
        return;
    const serverSyncDataPath = external_node_path_default().join(dataPath, File.serverDataPath);
    const clientSyncDataPath = external_node_path_default().join(dataPath, File.clientDataPath);
    await external_node_fs_default().promises.mkdir(serverSyncDataPath, { recursive: true });
    await external_node_fs_default().promises.mkdir(clientSyncDataPath, { recursive: true });
    const info = JSON.parse((await external_node_fs_default().promises.readFile(oldInfoPath)).toString());
    const serverInfoPath = external_node_path_default().join(serverSyncDataPath, File.serverInfoJSON);
    const devicesInfoPath = external_node_path_default().join(serverSyncDataPath, File.userDevicesJSON);
    const listDir = external_node_path_default().join(serverSyncDataPath, File.listDir);
    await external_node_fs_default().promises.mkdir(listDir);
    const snapshotInfo = info.snapshotInfo;
    delete info.snapshotInfo;
    snapshotInfo.clients = {};
    for (const device of Object.values(info.clients)) {
        snapshotInfo.clients[device.clientId] = {
            snapshotKey: device.snapshotKey,
            lastSyncDate: device.lastSyncDate,
        };
        device.lastConnectDate = device.lastSyncDate;
        delete device.lastSyncDate;
        delete device.snapshotKey;
    }
    const devicesInfo = {
        userName: 'default',
        clients: info.clients,
    };
    await external_node_fs_default().promises.writeFile(serverInfoPath, JSON.stringify({ serverId: info.serverId, version: 2 }));
    await external_node_fs_default().promises.writeFile(devicesInfoPath, JSON.stringify(devicesInfo));
    await external_node_fs_default().promises.writeFile(external_node_path_default().join(listDir, File.listSnapshotInfoJSON), JSON.stringify(snapshotInfo));
    const snapshotPath = external_node_path_default().join(listDir, File.listSnapshotDir);
    await external_node_fs_default().promises.mkdir(snapshotPath);
    const snapshots = (await external_node_fs_default().promises.readdir(dataPath)).filter(name => name.startsWith('snapshot_'));
    if (snapshots.length) {
        for (const file of snapshots) {
            await external_node_fs_default().promises.copyFile(external_node_path_default().join(dataPath, file), external_node_path_default().join(snapshotPath, file));
        }
    }
    await external_node_fs_default().promises.writeFile(external_node_path_default().join(clientSyncDataPath, File.syncAuthKeysJSON), JSON.stringify(info.syncAuthKey));
    for (const file of snapshots) {
        await external_node_fs_default().promises.unlink(external_node_path_default().join(dataPath, file));
    }
    await external_node_fs_default().promises.unlink(oldInfoPath);
});

;// CONCATENATED MODULE: ./src/main/modules/sync/client/index.ts


// import { getSyncHost } from '@root/utils/data'




let connectId = 0;
const handleConnect = async (host, authCode) => {
    // const hostInfo = await getSyncHost()
    // console.log(hostInfo)
    // if (!hostInfo || !hostInfo.host || !hostInfo.port) throw new Error(SYNC_CODE.unknownServiceAddress)
    const id = connectId;
    const urlInfo = parseUrl(host);
    await client_disconnectServer(false);
    if (id != connectId)
        return;
    const keyInfo = await client_auth(urlInfo, authCode);
    if (id != connectId)
        return;
    connect(urlInfo, keyInfo);
};
const handleDisconnect = async () => {
    await disconnect();
};
const connectServer = async (host, authCode) => {
    sendSyncStatus({
        status: false,
        message: SYNC_CODE.connecting,
    });
    const id = connectId;
    await migrate(global.lxDataPath);
    return handleConnect(host, authCode).catch(async (err) => {
        if (id != connectId)
            return;
        sendSyncStatus({
            status: false,
            message: err.message,
        });
        switch (err.message) {
            case SYNC_CODE.connectServiceFailed:
            case SYNC_CODE.missingAuthCode:
                break;
            default:
                sync_log.r_warn(err.message);
                break;
        }
        return Promise.reject(err);
    });
};
const client_disconnectServer = async (isResetStatus = true) => handleDisconnect().then(() => {
    sync_log.info('disconnect...');
    if (isResetStatus) {
        connectId++;
        sendSyncStatus({
            status: false,
            message: '',
        });
    }
}).catch((err) => {
    sync_log.error(`disconnect error: ${err.message}`);
    sendSyncMessage(err.message);
});



;// CONCATENATED MODULE: external "node:http"
const external_node_http_namespaceObject = require("node:http");
var external_node_http_default = /*#__PURE__*/__webpack_require__.n(external_node_http_namespaceObject);
;// CONCATENATED MODULE: ./src/main/modules/sync/server/utils/index.ts


const createDirSync = (path) => {
    if (!fs.existsSync(path)) {
        try {
            fs.mkdirSync(path, { recursive: true });
        }
        catch (e) {
            if (e.code !== 'EEXIST') {
                console.error('Could not set up log directory, error was: ', e);
                process.exit(1);
            }
        }
    }
};
const utils_fileNameRxp = /[\\/:*?#"<>|]/g;
const utils_filterFileName = (name) => name.replace(utils_fileNameRxp, '');
/**
 * 创建 MD5 hash
 * @param {*} str
 */
const utils_toMD5 = (str) => external_node_crypto_default().createHash('md5').update(str).digest('hex');
const checkAndCreateDirSync = (path) => {
    if (!external_node_fs_default().existsSync(path)) {
        external_node_fs_default().mkdirSync(path, { recursive: true });
    }
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/user/data.ts







const saveServerInfoThrottle = throttle(() => {
    external_node_fs_default().writeFile(external_node_path_default().join(global.lxDataPath, File.serverDataPath, File.serverInfoJSON), JSON.stringify(serverInfo), (err) => {
        if (err)
            console.error(err);
    });
});
let serverInfo;
const initServerInfo = async () => {
    if (serverInfo != null)
        return;
    const serverInfoFilePath = external_node_path_default().join(global.lxDataPath, File.serverDataPath, File.serverInfoJSON);
    if (await exists(serverInfoFilePath)) {
        // eslint-disable-next-line require-atomic-updates
        serverInfo = JSON.parse((await external_node_fs_default().promises.readFile(serverInfoFilePath)).toString());
    }
    else {
        // eslint-disable-next-line require-atomic-updates
        serverInfo = {
            serverId: (0,external_node_crypto_namespaceObject.randomBytes)(4 * 4).toString('base64'),
            version: 2,
        };
        const syncDataPath = external_node_path_default().join(global.lxDataPath, File.serverDataPath);
        if (!await exists(syncDataPath)) {
            await external_node_fs_default().promises.mkdir(syncDataPath, { recursive: true });
        }
        saveServerInfoThrottle();
    }
};
const data_getServerId = () => {
    return serverInfo.serverId;
};
const getVersion = async () => {
    await initServerInfo();
    return serverInfo.version ?? 1;
};
const setVersion = async (version) => {
    await initServerInfo();
    serverInfo.version = version;
    saveServerInfoThrottle();
};
const getUserDirname = (userName) => `${filterFileName(userName)}_${toMD5(userName).substring(0, 6)}`;
const getUserConfig = (userName) => {
    return {
        maxSnapshotNum: global.lx.appSetting['sync.server.maxSsnapshotNum'],
        'list.addMusicLocationType': global.lx.appSetting['list.addMusicLocationType'],
    };
};
// 读取所有用户目录下的devicesInfo信息，建立clientId与用户的对应关系，用于非首次连接
// let deviceUserMap: Map<string, string> = new Map<string, string>()
// const init
// for (const deviceInfo of fs.readdirSync(syncDataPath).map(dirname => {
//   const devicesFilePath = path.join(syncDataPath, dirname, File.userDevicesJSON)
//   if (fs.existsSync(devicesFilePath)) {
//     const devicesInfo = JSON.parse(fs.readFileSync(devicesFilePath).toString()) as DevicesInfo
//     if (getUserDirname(devicesInfo.userName) == dirname) return { userName: devicesInfo.userName, devices: devicesInfo.clients }
//   }
//   return { userName: '', devices: {} }
// })) {
//   for (const device of Object.values(deviceInfo.devices)) {
//     if (deviceInfo.userName) deviceUserMap.set(device.clientId, deviceInfo.userName)
//   }
// }
// export const getUserName = (clientId: string): string | null => {
//   if (!clientId) return null
//   return deviceUserMap.get(clientId) ?? null
// }
// export const setUserName = (clientId: string, dir: string) => {
//   deviceUserMap.set(clientId, dir)
// }
// export const deleteUserName = (clientId: string) => {
//   deviceUserMap.delete(clientId)
// }
const createClientKeyInfo = (deviceName, isMobile) => {
    const keyInfo = {
        clientId: (0,external_node_crypto_namespaceObject.randomBytes)(4 * 4).toString('base64'),
        key: (0,external_node_crypto_namespaceObject.randomBytes)(16).toString('base64'),
        deviceName,
        isMobile,
        lastConnectDate: 0,
    };
    return keyInfo;
};
class UserDataManage {
    userName;
    userDir;
    devicesFilePath;
    devicesInfo;
    saveDevicesInfoThrottle;
    getAllClientKeyInfo = () => {
        return Object.values(this.devicesInfo.clients).sort((a, b) => (b.lastConnectDate ?? 0) - (a.lastConnectDate ?? 0));
    };
    saveClientKeyInfo = (keyInfo) => {
        if (this.devicesInfo.clients[keyInfo.clientId] == null && Object.keys(this.devicesInfo.clients).length > 101)
            throw new Error('max keys');
        this.devicesInfo.clients[keyInfo.clientId] = keyInfo;
        this.saveDevicesInfoThrottle();
    };
    getClientKeyInfo = (clientId) => {
        if (!clientId)
            return null;
        return this.devicesInfo.clients[clientId] ?? null;
    };
    removeClientKeyInfo = async (clientId) => {
        // eslint-disable-next-line @typescript-eslint/no-dynamic-delete
        delete this.devicesInfo.clients[clientId];
        this.saveDevicesInfoThrottle();
    };
    isIncluedsClient = (clientId) => {
        return Object.values(this.devicesInfo.clients).some(client => client.clientId == clientId);
    };
    constructor(userName) {
        this.userName = userName;
        const syncDataPath = external_node_path_default().join(global.lxDataPath, File.serverDataPath);
        this.userDir = syncDataPath;
        this.devicesFilePath = external_node_path_default().join(this.userDir, File.userDevicesJSON);
        this.devicesInfo = external_node_fs_default().existsSync(this.devicesFilePath) ? JSON.parse(external_node_fs_default().readFileSync(this.devicesFilePath).toString()) : { userName, clients: {} };
        this.saveDevicesInfoThrottle = throttle(() => {
            external_node_fs_default().writeFile(this.devicesFilePath, JSON.stringify(this.devicesInfo), 'utf8', (err) => {
                if (err)
                    console.error(err);
            });
        });
    }
}
// type UserDataManages = Map<string, UserDataManage>
// export const createUserDataManage = (user: LX.UserConfig) => {
//   const manage = Object.create(userDataManage) as typeof userDataManage
//   manage.userDir = user.dataPath
// }

;// CONCATENATED MODULE: ./src/main/modules/sync/server/user/index.ts


const users = new Map();
const delayTime = 10 * 1000;
const delayReleaseTimeouts = new Map();
const clearDelayReleaseTimeout = (userName) => {
    if (!delayReleaseTimeouts.has(userName))
        return;
    clearTimeout(delayReleaseTimeouts.get(userName));
    delayReleaseTimeouts.delete(userName);
};
const seartDelayReleaseTimeout = (userName) => {
    clearDelayReleaseTimeout(userName);
    delayReleaseTimeouts.set(userName, setTimeout(() => {
        users.delete(userName);
    }, delayTime));
};
const getUserSpace = (userName = 'default') => {
    clearDelayReleaseTimeout(userName);
    let user = users.get(userName);
    if (!user) {
        console.log('new user data manage:', userName);
        const dataManage = new UserDataManage(userName);
        const listManage = new ListManage(dataManage);
        const dislikeManage = new DislikeManage(dataManage);
        users.set(userName, user = {
            dataManage,
            listManage,
            dislikeManage,
            async getDecices() {
                return this.dataManage.getAllClientKeyInfo();
            },
            async removeDevice(clientId) {
                await listManage.removeDevice(clientId);
                await dataManage.removeClientKeyInfo(clientId);
            },
        });
    }
    return user;
};
const releaseUserSpace = (userName = 'default', force = false) => {
    if (force) {
        clearDelayReleaseTimeout(userName);
        users.delete(userName);
    }
    else
        seartDelayReleaseTimeout(userName);
};


;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/list/sync/handler.ts
// 这个文件导出的方法将暴露给客户端调用，第一个参数固定为当前 socket 对象
// import { throttle } from '@common/utils/common'
// import { sendSyncActionList } from '@main/modules/winMain'
// import { SYNC_CLOSE_CODE } from '@/constants'
// import { SYNC_CLOSE_CODE } from '@common/constants_sync'



// import { encryptMsg } from '@/utils/tools'
// let wss: LX.SocketServer | null
// let removeListener: (() => void) | null
// type listAction = 'list:action'
// const registerListActionEvent = () => {
//   const list_data_overwrite = async(listData: MakeOptional<LX.List.ListDataFull, 'tempList'>, isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_data_overwrite', data: listData })
//   }
//   const list_create = async(position: number, listInfos: LX.List.UserListInfo[], isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_create', data: { position, listInfos } })
//   }
//   const list_remove = async(ids: string[], isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_remove', data: ids })
//   }
//   const list_update = async(lists: LX.List.UserListInfo[], isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_update', data: lists })
//   }
//   const list_update_position = async(position: number, ids: string[], isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_update_position', data: { position, ids } })
//   }
//   const list_music_overwrite = async(listId: string, musicInfos: LX.Music.MusicInfo[], isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_music_overwrite', data: { listId, musicInfos } })
//   }
//   const list_music_add = async(id: string, musicInfos: LX.Music.MusicInfo[], addMusicLocationType: LX.AddMusicLocationType, isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_music_add', data: { id, musicInfos, addMusicLocationType } })
//   }
//   const list_music_move = async(fromId: string, toId: string, musicInfos: LX.Music.MusicInfo[], addMusicLocationType: LX.AddMusicLocationType, isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_music_move', data: { fromId, toId, musicInfos, addMusicLocationType } })
//   }
//   const list_music_remove = async(listId: string, ids: string[], isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_music_remove', data: { listId, ids } })
//   }
//   const list_music_update = async(musicInfos: LX.List.ListActionMusicUpdate, isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_music_update', data: musicInfos })
//   }
//   const list_music_clear = async(ids: string[], isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_music_clear', data: ids })
//   }
//   const list_music_update_position = async(listId: string, position: number, ids: string[], isRemote: boolean = false) => {
//     if (isRemote) return
//     await sendListAction({ action: 'list_music_update_position', data: { listId, position, ids } })
//   }
//   global.event_list.on('list_data_overwrite', list_data_overwrite)
//   global.event_list.on('list_create', list_create)
//   global.event_list.on('list_remove', list_remove)
//   global.event_list.on('list_update', list_update)
//   global.event_list.on('list_update_position', list_update_position)
//   global.event_list.on('list_music_overwrite', list_music_overwrite)
//   global.event_list.on('list_music_add', list_music_add)
//   global.event_list.on('list_music_move', list_music_move)
//   global.event_list.on('list_music_remove', list_music_remove)
//   global.event_list.on('list_music_update', list_music_update)
//   global.event_list.on('list_music_clear', list_music_clear)
//   global.event_list.on('list_music_update_position', list_music_update_position)
//   return () => {
//     global.event_list.off('list_data_overwrite', list_data_overwrite)
//     global.event_list.off('list_create', list_create)
//     global.event_list.off('list_remove', list_remove)
//     global.event_list.off('list_update', list_update)
//     global.event_list.off('list_update_position', list_update_position)
//     global.event_list.off('list_music_overwrite', list_music_overwrite)
//     global.event_list.off('list_music_add', list_music_add)
//     global.event_list.off('list_music_move', list_music_move)
//     global.event_list.off('list_music_remove', list_music_remove)
//     global.event_list.off('list_music_update', list_music_update)
//     global.event_list.off('list_music_clear', list_music_clear)
//     global.event_list.off('list_music_update_position', list_music_update_position)
//   }
// }
// const addMusic = (orderId, callback) => {
//   // ...
// }
// const broadcast = async(socket: LX.Socket, key: string, data: any, excludeIds: string[] = []) => {
//   if (!wss) return
//   const dataStr = JSON.stringify({ action: 'list:sync:action', data })
//   const userSpace = getUserSpace(socket.userInfo.name)
//   for (const client of wss.clients) {
//     if (excludeIds.includes(client.keyInfo.clientId) || !client.isReady || client.userInfo.name != socket.userInfo.name) continue
//     client.send(encryptMsg(client.keyInfo, dataStr), (err) => {
//       if (err) {
//         client.close(SYNC_CLOSE_CODE.failed)
//         return
//       }
//       userSpace.dataManage.updateDeviceSnapshotKey(client.keyInfo, key)
//     })
//   }
// }
// export const sendListAction = async(action: LX.Sync.List.ActionList) => {
//   console.log('sendListAction', action.action)
//   // io.sockets
//   await broadcast('list:sync:action', action)
// }
// export const registerListHandler = (_wss: LX.SocketServer, socket: LX.Socket) => {
//   if (!wss) {
//     wss = _wss
//     // removeListener = registerListActionEvent()
//   }
//   const userSpace = getUserSpace(socket.userInfo.name)
//   socket.onRemoteEvent('list:sync:action', (action) => {
//     if (!socket.isReady) return
//     // console.log(msg)
//     void handleListAction(socket.userInfo.name, action).then(key => {
//       if (!key) return
//       console.log(key)
//       userSpace.dataManage.updateDeviceSnapshotKey(socket.keyInfo, key)
//       void broadcast(socket, key, action, [socket.keyInfo.clientId])
//     })
//     // socket.broadcast.emit('list:action', { action: 'list_remove', data: { id: 'default', index: 0 } })
//   })
//   // socket.on('list:add', addMusic)
// }
// export const unregisterListHandler = () => {
//   wss = null
//   // if (removeListener) {
//   //   removeListener()
//   //   removeListener = null
//   // }
// }
const list_sync_handler_handler = {
    async onListSyncAction(socket, action) {
        if (!socket.moduleReadys.list)
            return;
        await handleRemoteListAction(action);
        const userSpace = getUserSpace(socket.userInfo.name);
        const key = await userSpace.listManage.createSnapshot();
        userSpace.listManage.updateDeviceSnapshotKey(socket.keyInfo.clientId, key);
        const currentUserName = socket.userInfo.name;
        const currentId = socket.keyInfo.clientId;
        socket.broadcast((client) => {
            if (client.keyInfo.clientId == currentId || !client.moduleReadys?.list || client.userInfo.name != currentUserName)
                return;
            void client.remoteQueueList.onListSyncAction(action).then(async () => {
                return userSpace.listManage.updateDeviceSnapshotKey(client.keyInfo.clientId, key);
            }).catch(err => {
                // TODO send status
                client.close(SYNC_CLOSE_CODE.failed);
                // client.moduleReadys.list = false
                console.log(err.message);
            });
        });
    },
};
/* harmony default export */ const list_sync_handler = (list_sync_handler_handler);

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/list/sync/sync.ts
// import { SYNC_CLOSE_CODE } from '../../../../constants'




// import { LIST_IDS } from '@common/constants'
// type ListInfoType = LX.List.UserListInfoFull | LX.List.MyDefaultListInfoFull | LX.List.MyLoveListInfoFull
// let wss: LX.Sync.Server.SocketServer | null
let syncingId = null;
const wait = async (time = 1000) => await new Promise((resolve, reject) => setTimeout(resolve, time));
const patchListData = (listData) => {
    return Object.assign({
        defaultList: [],
        loveList: [],
        userList: [],
    }, listData);
};
const getRemoteListData = async (socket) => {
    console.log('getRemoteListData');
    return patchListData(await socket.remoteQueueList.list_sync_get_list_data());
};
const getRemoteListMD5 = async (socket) => {
    return socket.remoteQueueList.list_sync_get_md5();
};
// const getLocalListData = async(socket: LX.Sync.Server.Socket): Promise<LX.Sync.List.ListData> => {
//   return getUserSpace(socket.userInfo.name).listManage.getListData()
// }
const sync_getSyncMode = async (socket) => new Promise((resolve, reject) => {
    const handleDisconnect = (err) => {
        sendCloseSelectMode();
        removeSelectModeListener();
        reject(err);
    };
    let removeEventClose = socket.onClose(handleDisconnect);
    sendSelectMode(socket.keyInfo.deviceName, 'list', (mode) => {
        if (mode == null) {
            reject(new Error('cancel'));
            return;
        }
        resolve(mode);
        removeSelectModeListener();
        removeEventClose();
    });
});
// const getSyncMode = async(socket: LX.Sync.Server.Socket): Promise<LX.Sync.List.SyncMode> => {
//   return socket.remoteQueueList.list_sync_get_sync_mode()
// }
const finishedSync = async (socket) => {
    await socket.remoteQueueList.list_sync_finished();
};
const setLocalList = async (socket, listData) => {
    await setLocalListData(listData);
    const userSpace = getUserSpace(socket.userInfo.name);
    return userSpace.listManage.createSnapshot();
};
const overwriteRemoteListData = async (socket, listData, key, excludeIds = []) => {
    const action = { action: 'list_data_overwrite', data: listData };
    const tasks = [];
    const userSpace = getUserSpace(socket.userInfo.name);
    socket.broadcast((client) => {
        if (excludeIds.includes(client.keyInfo.clientId) || client.userInfo.name != socket.userInfo.name || !client.moduleReadys?.list)
            return;
        tasks.push(client.remoteQueueList.onListSyncAction(action).then(async () => {
            return userSpace.listManage.updateDeviceSnapshotKey(client.keyInfo.clientId, key);
        }).catch(err => {
            // TODO send status
            client.close(SYNC_CLOSE_CODE.failed);
            // client.moduleReadys.list = false
            console.log(err.message);
        }));
    });
    if (!tasks.length)
        return;
    await Promise.all(tasks);
};
const setRemotelList = async (socket, listData, key) => {
    await socket.remoteQueueList.list_sync_set_list_data(listData);
    const userSpace = getUserSpace(socket.userInfo.name);
    await userSpace.listManage.updateDeviceSnapshotKey(socket.keyInfo.clientId, key);
};
const createUserListDataObj = (listData) => {
    const userListDataObj = new Map();
    for (const list of listData.userList)
        userListDataObj.set(list.id, list);
    return userListDataObj;
};
const handleMergeList = (sourceList, targetList, addMusicLocationType) => {
    let newList;
    switch (addMusicLocationType) {
        case 'top':
            newList = [...targetList, ...sourceList];
            break;
        case 'bottom':
        default:
            newList = [...sourceList, ...targetList];
            break;
    }
    const map = new Map();
    const ids = [];
    switch (addMusicLocationType) {
        case 'top':
            newList = [...targetList, ...sourceList];
            for (let i = newList.length - 1; i > -1; i--) {
                const item = newList[i];
                if (map.has(item.id))
                    continue;
                ids.unshift(item.id);
                map.set(item.id, item);
            }
            break;
        case 'bottom':
        default:
            newList = [...sourceList, ...targetList];
            for (const item of newList) {
                if (map.has(item.id))
                    continue;
                ids.push(item.id);
                map.set(item.id, item);
            }
            break;
    }
    return ids.map(id => map.get(id));
};
const mergeList = (socket, sourceListData, targetListData) => {
    const addMusicLocationType = getUserConfig(socket.userInfo.name)['list.addMusicLocationType'];
    const newListData = {
        defaultList: [],
        loveList: [],
        userList: [],
    };
    newListData.defaultList = handleMergeList(sourceListData.defaultList, targetListData.defaultList, addMusicLocationType);
    newListData.loveList = handleMergeList(sourceListData.loveList, targetListData.loveList, addMusicLocationType);
    const userListDataObj = createUserListDataObj(sourceListData);
    newListData.userList = [...sourceListData.userList];
    targetListData.userList.forEach((list, index) => {
        const targetUpdateTime = list?.locationUpdateTime ?? 0;
        const sourceList = userListDataObj.get(list.id);
        if (sourceList) {
            sourceList.list = handleMergeList(sourceList.list, list.list, addMusicLocationType);
            const sourceUpdateTime = sourceList?.locationUpdateTime ?? 0;
            if (targetUpdateTime >= sourceUpdateTime)
                return;
            // 调整位置
            const [newList] = newListData.userList.splice(newListData.userList.findIndex(l => l.id == list.id), 1);
            newList.locationUpdateTime = targetUpdateTime;
            newListData.userList.splice(index, 0, newList);
        }
        else {
            if (targetUpdateTime) {
                newListData.userList.splice(index, 0, list);
            }
            else {
                newListData.userList.push(list);
            }
        }
    });
    return newListData;
};
const overwriteList = (sourceListData, targetListData) => {
    const newListData = {
        defaultList: [],
        loveList: [],
        userList: [],
    };
    newListData.defaultList = sourceListData.defaultList;
    newListData.loveList = sourceListData.loveList;
    const userListDataObj = createUserListDataObj(sourceListData);
    newListData.userList = [...sourceListData.userList];
    targetListData.userList.forEach((list, index) => {
        if (userListDataObj.has(list.id))
            return;
        if (list?.locationUpdateTime) {
            newListData.userList.splice(index, 0, list);
        }
        else {
            newListData.userList.push(list);
        }
    });
    return newListData;
};
const handleMergeListData = async (socket) => {
    const mode = await sync_getSyncMode(socket);
    if (mode == 'cancel')
        throw new Error('cancel');
    const [remoteListData, localListData] = await Promise.all([getRemoteListData(socket), getLocalListData()]);
    console.log('handleMergeListData', 'remoteListData, localListData');
    let listData;
    let requiredUpdateLocalListData = true;
    let requiredUpdateRemoteListData = true;
    switch (mode) {
        case 'merge_local_remote':
            listData = mergeList(socket, localListData, remoteListData);
            break;
        case 'merge_remote_local':
            listData = mergeList(socket, remoteListData, localListData);
            break;
        case 'overwrite_local_remote':
            listData = overwriteList(localListData, remoteListData);
            break;
        case 'overwrite_remote_local':
            listData = overwriteList(remoteListData, localListData);
            break;
        case 'overwrite_local_remote_full':
            listData = localListData;
            requiredUpdateLocalListData = false;
            break;
        case 'overwrite_remote_local_full':
            listData = remoteListData;
            requiredUpdateRemoteListData = false;
            break;
        // case 'none': return null
        // case 'cancel':
        default: throw new Error('cancel');
    }
    return [listData, requiredUpdateLocalListData, requiredUpdateRemoteListData];
};
const handleSyncList = async (socket) => {
    const [remoteListData, localListData] = await Promise.all([getRemoteListData(socket), getLocalListData()]);
    console.log('handleSyncList', 'remoteListData, localListData');
    console.log('localListData', localListData.defaultList.length || localListData.loveList.length || localListData.userList.length);
    console.log('remoteListData', remoteListData.defaultList.length || remoteListData.loveList.length || remoteListData.userList.length);
    const userSpace = getUserSpace(socket.userInfo.name);
    const clientId = socket.keyInfo.clientId;
    if (localListData.defaultList.length || localListData.loveList.length || localListData.userList.length) {
        if (remoteListData.defaultList.length || remoteListData.loveList.length || remoteListData.userList.length) {
            const [mergedList, requiredUpdateLocalListData, requiredUpdateRemoteListData] = await handleMergeListData(socket);
            console.log('handleMergeListData', 'mergedList', requiredUpdateLocalListData, requiredUpdateRemoteListData);
            let key;
            if (requiredUpdateLocalListData) {
                key = await setLocalList(socket, mergedList);
                await overwriteRemoteListData(socket, mergedList, key, [clientId]);
                if (!requiredUpdateRemoteListData)
                    await userSpace.listManage.updateDeviceSnapshotKey(clientId, key);
            }
            if (requiredUpdateRemoteListData) {
                if (!key)
                    key = await userSpace.listManage.getCurrentListInfoKey();
                await setRemotelList(socket, mergedList, key);
            }
        }
        else {
            await setRemotelList(socket, localListData, await userSpace.listManage.getCurrentListInfoKey());
        }
    }
    else {
        let key;
        if (remoteListData.defaultList.length || remoteListData.loveList.length || remoteListData.userList.length) {
            key = await setLocalList(socket, remoteListData);
            await overwriteRemoteListData(socket, remoteListData, key, [clientId]);
        }
        key ??= await userSpace.listManage.getCurrentListInfoKey();
        await userSpace.listManage.updateDeviceSnapshotKey(clientId, key);
    }
};
const mergeListDataFromSnapshot = (sourceList, targetList, snapshotList, addMusicLocationType) => {
    const removedListIds = new Set();
    const sourceListItemIds = new Set();
    const targetListItemIds = new Set();
    for (const m of sourceList)
        sourceListItemIds.add(m.id);
    for (const m of targetList)
        targetListItemIds.add(m.id);
    if (snapshotList) {
        for (const m of snapshotList) {
            if (!sourceListItemIds.has(m.id) || !targetListItemIds.has(m.id))
                removedListIds.add(m.id);
        }
    }
    let newList;
    const map = new Map();
    const ids = [];
    switch (addMusicLocationType) {
        case 'top':
            newList = [...targetList, ...sourceList];
            for (let i = newList.length - 1; i > -1; i--) {
                const item = newList[i];
                if (map.has(item.id) || removedListIds.has(item.id))
                    continue;
                ids.unshift(item.id);
                map.set(item.id, item);
            }
            break;
        case 'bottom':
        default:
            newList = [...sourceList, ...targetList];
            for (const item of newList) {
                if (map.has(item.id) || removedListIds.has(item.id))
                    continue;
                ids.push(item.id);
                map.set(item.id, item);
            }
            break;
    }
    return ids.map(id => map.get(id));
};
const checkListLatest = async (socket) => {
    const remoteListMD5 = await getRemoteListMD5(socket);
    const userSpace = getUserSpace(socket.userInfo.name);
    const userCurrentListInfoKey = await userSpace.listManage.getDeviceCurrentSnapshotKey(socket.keyInfo.clientId);
    const currentListInfoKey = await userSpace.listManage.getCurrentListInfoKey();
    const latest = remoteListMD5 == currentListInfoKey;
    if (latest && userCurrentListInfoKey != currentListInfoKey)
        await userSpace.listManage.updateDeviceSnapshotKey(socket.keyInfo.clientId, currentListInfoKey);
    return latest;
};
const selectData = (snapshot, local, remote) => {
    return snapshot == local
        ? remote
        // ? (snapshot == remote ? snapshot as T : remote)
        : local;
};
const handleMergeListDataFromSnapshot = async (socket, snapshot) => {
    if (await checkListLatest(socket))
        return;
    const addMusicLocationType = getUserConfig(socket.userInfo.name)['list.addMusicLocationType'];
    const [remoteListData, localListData] = await Promise.all([getRemoteListData(socket), getLocalListData()]);
    const newListData = {
        defaultList: [],
        loveList: [],
        userList: [],
    };
    newListData.defaultList = mergeListDataFromSnapshot(localListData.defaultList, remoteListData.defaultList, snapshot.defaultList, addMusicLocationType);
    newListData.loveList = mergeListDataFromSnapshot(localListData.loveList, remoteListData.loveList, snapshot.loveList, addMusicLocationType);
    const localUserListData = createUserListDataObj(localListData);
    const remoteUserListData = createUserListDataObj(remoteListData);
    const snapshotUserListData = createUserListDataObj(snapshot);
    const removedListIds = new Set();
    const localUserListIds = new Set();
    const remoteUserListIds = new Set();
    for (const l of localListData.userList)
        localUserListIds.add(l.id);
    for (const l of remoteListData.userList)
        remoteUserListIds.add(l.id);
    for (const l of snapshot.userList) {
        if (!localUserListIds.has(l.id) || !remoteUserListIds.has(l.id))
            removedListIds.add(l.id);
    }
    let newUserList = [];
    for (const list of localListData.userList) {
        if (removedListIds.has(list.id))
            continue;
        const remoteList = remoteUserListData.get(list.id);
        let newList;
        if (remoteList) {
            const snapshotList = snapshotUserListData.get(list.id) ?? { name: null, source: null, sourceListId: null, list: [] };
            newList = buildUserListInfoFull({
                id: list.id,
                name: selectData(snapshotList.name, list.name, remoteList.name),
                source: selectData(snapshotList.source, list.source, remoteList.source),
                sourceListId: selectData(snapshotList.sourceListId, list.sourceListId, remoteList.sourceListId),
                locationUpdateTime: list.locationUpdateTime,
                list: mergeListDataFromSnapshot(list.list, remoteList.list, snapshotList.list, addMusicLocationType),
            });
        }
        else {
            newList = { ...list };
        }
        newUserList.push(newList);
    }
    remoteListData.userList.forEach((list, index) => {
        if (removedListIds.has(list.id))
            return;
        const remoteUpdateTime = list?.locationUpdateTime ?? 0;
        if (localUserListData.has(list.id)) {
            const localUpdateTime = localUserListData.get(list.id)?.locationUpdateTime ?? 0;
            if (localUpdateTime >= remoteUpdateTime)
                return;
            // 调整位置
            const [newList] = newUserList.splice(newUserList.findIndex(l => l.id == list.id), 1);
            newList.locationUpdateTime = localUpdateTime;
            newUserList.splice(index, 0, newList);
        }
        else {
            if (remoteUpdateTime) {
                newUserList.splice(index, 0, { ...list });
            }
            else {
                newUserList.push({ ...list });
            }
        }
    });
    newListData.userList = newUserList;
    const key = await setLocalList(socket, newListData);
    const err = await setRemotelList(socket, newListData, key).catch(err => err);
    await overwriteRemoteListData(socket, newListData, key, [socket.keyInfo.clientId]);
    if (err)
        throw err;
};
const syncList = async (socket) => {
    // socket.data.snapshotFilePath = getSnapshotFilePath(socket.keyInfo)
    // console.log(socket.keyInfo)
    if (!socket.feature.list)
        throw new Error('list feature options not available');
    if (!socket.feature.list.skipSnapshot) {
        const user = getUserSpace(socket.userInfo.name);
        const userCurrentListInfoKey = await user.listManage.getDeviceCurrentSnapshotKey(socket.keyInfo.clientId);
        if (userCurrentListInfoKey) {
            const listData = await user.listManage.snapshotDataManage.getSnapshot(userCurrentListInfoKey);
            if (listData) {
                console.log('handleMergeListDataFromSnapshot');
                await handleMergeListDataFromSnapshot(socket, listData);
                return;
            }
        }
    }
    await handleSyncList(socket);
};
// export default async(_wss: LX.Sync.Server.SocketServer, socket: LX.Sync.Server.Socket) => {
//   if (!wss) {
//     wss = _wss
//     _wss.addListener('close', () => {
//       wss = null
//     })
//   }
//   let disconnected = false
//   socket.onClose(() => {
//     disconnected = true
//     if (syncingId == socket.keyInfo.clientId) syncingId = null
//   })
//   while (true) {
//     if (disconnected) throw new Error('disconnected')
//     if (!syncingId) break
//     await wait()
//   }
//   syncingId = socket.keyInfo.clientId
//   await syncList(socket).then(async() => {
//     return finishedSync(socket)
//   }).finally(() => {
//     syncingId = null
//   })
// }
// const removeSnapshot = async(keyInfo: LX.Sync.KeyInfo) => {
//   const filePath = getSnapshotFilePath(keyInfo)
//   await fsPromises.unlink(filePath)
// }
const sync = async (socket) => {
    let disconnected = false;
    socket.onClose(() => {
        disconnected = true;
        if (syncingId == socket.keyInfo.clientId)
            syncingId = null;
    });
    while (true) {
        if (disconnected)
            throw new Error('disconnected');
        if (!syncingId)
            break;
        await wait();
    }
    syncingId = socket.keyInfo.clientId;
    await syncList(socket).then(async () => {
        await finishedSync(socket);
        socket.moduleReadys.list = true;
    }).finally(() => {
        syncingId = null;
    });
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/list/sync/localEvent.ts



// let socket: LX.Sync.Server.Socket | null
let sync_localEvent_unregisterLocalListAction;
const sendListAction = async (wss, action) => {
    // console.log('sendListAction', action.action)
    const userSpace = getUserSpace();
    let key = '';
    for (const client of wss.clients) {
        if (!client.moduleReadys?.list)
            continue;
        // eslint-disable-next-line require-atomic-updates
        if (!key)
            key = await userSpace.listManage.createSnapshot();
        void client.remoteQueueList.onListSyncAction(action).then(async () => {
            return userSpace.listManage.updateDeviceSnapshotKey(client.keyInfo.clientId, key);
        }).catch(err => {
            // TODO send status
            client.close(SYNC_CLOSE_CODE.failed);
            // client.moduleReadys.list = false
            console.log(err.message);
        });
    }
};
const sync_localEvent_registerEvent = (wss) => {
    // socket = _socket
    // socket.onClose(() => {
    //   unregisterLocalListAction?.()
    //   unregisterLocalListAction = null
    // })
    sync_localEvent_unregisterEvent();
    sync_localEvent_unregisterLocalListAction = registerListActionEvent((action) => {
        void sendListAction(wss, action);
    });
};
const sync_localEvent_unregisterEvent = () => {
    sync_localEvent_unregisterLocalListAction?.();
    sync_localEvent_unregisterLocalListAction = null;
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/list/sync/index.ts




;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/list/snapshotDataManage.ts







class SnapshotDataManage {
    userDataManage;
    listDir;
    snapshotDir;
    snapshotInfoFilePath;
    snapshotInfo;
    clientSnapshotKeys;
    saveSnapshotInfoThrottle;
    isIncluedsDevice = (key) => {
        return this.clientSnapshotKeys.includes(key);
    };
    clearOldSnapshot = async () => {
        if (!this.snapshotInfo)
            return;
        const snapshotList = this.snapshotInfo.list.filter(key => !this.isIncluedsDevice(key));
        // console.log(snapshotList.length, lx.config.maxSnapshotNum)
        const userMaxSnapshotNum = getUserConfig(this.userDataManage.userName).maxSnapshotNum;
        let requiredSave = snapshotList.length > userMaxSnapshotNum;
        while (snapshotList.length > userMaxSnapshotNum) {
            const name = snapshotList.pop();
            if (name) {
                await this.removeSnapshot(name);
                this.snapshotInfo.list.splice(this.snapshotInfo.list.indexOf(name), 1);
            }
            else
                break;
        }
        if (requiredSave)
            this.saveSnapshotInfo(this.snapshotInfo);
    };
    updateDeviceSnapshotKey = async (clientId, key) => {
        // console.log('updateDeviceSnapshotKey', key)
        let client = this.snapshotInfo.clients[clientId];
        if (!client)
            client = this.snapshotInfo.clients[clientId] = { snapshotKey: '', lastSyncDate: 0 };
        if (client.snapshotKey)
            this.clientSnapshotKeys.splice(this.clientSnapshotKeys.indexOf(client.snapshotKey), 1);
        client.snapshotKey = key;
        client.lastSyncDate = Date.now();
        this.clientSnapshotKeys.push(key);
        this.saveSnapshotInfoThrottle();
    };
    getDeviceCurrentSnapshotKey = async (clientId) => {
        // console.log('updateDeviceSnapshotKey', key)
        const client = this.snapshotInfo.clients[clientId];
        return client?.snapshotKey;
    };
    getSnapshotInfo = async () => {
        return this.snapshotInfo;
    };
    saveSnapshotInfo = (info) => {
        this.snapshotInfo = info;
        this.saveSnapshotInfoThrottle();
    };
    removeSnapshotInfo = (clientId) => {
        let client = this.snapshotInfo.clients[clientId];
        if (!client)
            return;
        if (client.snapshotKey)
            this.clientSnapshotKeys.splice(this.clientSnapshotKeys.indexOf(client.snapshotKey), 1);
        // eslint-disable-next-line @typescript-eslint/no-dynamic-delete
        delete this.snapshotInfo.clients[clientId];
        this.saveSnapshotInfoThrottle();
    };
    getSnapshot = async (name) => {
        const filePath = external_node_path_default().join(this.snapshotDir, `snapshot_${name}`);
        let listData;
        try {
            listData = JSON.parse((await external_node_fs_default().promises.readFile(filePath)).toString('utf-8'));
        }
        catch (err) {
            sync_log.warn(err);
            return null;
        }
        return listData;
    };
    saveSnapshot = async (name, data) => {
        sync_log.info('saveSnapshot', this.userDataManage.userName, name);
        const filePath = external_node_path_default().join(this.snapshotDir, `snapshot_${name}`);
        try {
            await external_node_fs_default().promises.writeFile(filePath, data);
        }
        catch (err) {
            sync_log.error(err);
            throw err;
        }
    };
    removeSnapshot = async (name) => {
        sync_log.info('removeSnapshot', this.userDataManage.userName, name);
        const filePath = external_node_path_default().join(this.snapshotDir, `snapshot_${name}`);
        try {
            await external_node_fs_default().promises.unlink(filePath);
        }
        catch (err) {
            sync_log.error(err);
        }
    };
    constructor(userDataManage) {
        this.userDataManage = userDataManage;
        this.listDir = external_node_path_default().join(userDataManage.userDir, File.listDir);
        checkAndCreateDirSync(this.listDir);
        this.snapshotDir = external_node_path_default().join(this.listDir, File.listSnapshotDir);
        checkAndCreateDirSync(this.snapshotDir);
        this.snapshotInfoFilePath = external_node_path_default().join(this.listDir, File.listSnapshotInfoJSON);
        this.snapshotInfo = external_node_fs_default().existsSync(this.snapshotInfoFilePath)
            ? JSON.parse(external_node_fs_default().readFileSync(this.snapshotInfoFilePath).toString())
            : { latest: null, time: 0, list: [], clients: {} };
        this.saveSnapshotInfoThrottle = throttle(() => {
            external_node_fs_default().writeFile(this.snapshotInfoFilePath, JSON.stringify(this.snapshotInfo), 'utf8', (err) => {
                if (err)
                    console.error(err);
                void this.clearOldSnapshot();
            });
        });
        this.clientSnapshotKeys = Object.values(this.snapshotInfo.clients).map(device => device.snapshotKey).filter(k => k);
    }
}
// type UserDataManages = Map<string, UserDataManage>
// export const createUserDataManage = (user: LX.UserConfig) => {
//   const manage = Object.create(userDataManage) as typeof userDataManage
//   manage.userDir = user.dataPath
// }

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/list/manage.ts



class ListManage {
    snapshotDataManage;
    constructor(userDataManage) {
        this.snapshotDataManage = new SnapshotDataManage(userDataManage);
    }
    createSnapshot = async () => {
        const listData = JSON.stringify(await this.getListData());
        const md5 = utils_toMD5(listData);
        const snapshotInfo = await this.snapshotDataManage.getSnapshotInfo();
        console.log(md5, snapshotInfo.latest);
        if (snapshotInfo.latest == md5)
            return md5;
        if (snapshotInfo.list.includes(md5)) {
            snapshotInfo.list.splice(snapshotInfo.list.indexOf(md5), 1);
        }
        else
            await this.snapshotDataManage.saveSnapshot(md5, listData);
        if (snapshotInfo.latest)
            snapshotInfo.list.unshift(snapshotInfo.latest);
        snapshotInfo.latest = md5;
        snapshotInfo.time = Date.now();
        this.snapshotDataManage.saveSnapshotInfo(snapshotInfo);
        return md5;
    };
    getCurrentListInfoKey = async () => {
        // const snapshotInfo = await this.snapshotDataManage.getSnapshotInfo()
        // if (snapshotInfo.latest) {
        //   return snapshotInfo.latest
        // }
        // snapshotInfo.latest = toMD5(JSON.stringify(await this.getListData()))
        // this.snapshotDataManage.saveSnapshotInfo(snapshotInfo)
        // return snapshotInfo.latest
        return this.createSnapshot();
    };
    getDeviceCurrentSnapshotKey = async (clientId) => {
        return this.snapshotDataManage.getDeviceCurrentSnapshotKey(clientId);
    };
    updateDeviceSnapshotKey = async (clientId, key) => {
        await this.snapshotDataManage.updateDeviceSnapshotKey(clientId, key);
    };
    removeDevice = async (clientId) => {
        this.snapshotDataManage.removeSnapshotInfo(clientId);
    };
    getListData = async () => {
        return getLocalListData();
    };
}

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/list/index.ts



;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/dislike/sync/handler.ts
// 这个文件导出的方法将暴露给客户端调用，第一个参数固定为当前 socket 对象
// import { throttle } from '@common/utils/common'
// import { sendSyncActionList } from '@main/modules/winMain'
// import { SYNC_CLOSE_CODE } from '@/constants'
// import { SYNC_CLOSE_CODE } from '@common/constants_sync'



// import { encryptMsg } from '@/utils/tools'
const dislike_sync_handler_handler = {
    async onDislikeSyncAction(socket, action) {
        if (!socket.moduleReadys.dislike)
            return;
        await handleRemoteDislikeAction(action);
        const userSpace = getUserSpace(socket.userInfo.name);
        const key = await userSpace.dislikeManage.createSnapshot();
        userSpace.dislikeManage.updateDeviceSnapshotKey(socket.keyInfo.clientId, key);
        const currentUserName = socket.userInfo.name;
        const currentId = socket.keyInfo.clientId;
        socket.broadcast((client) => {
            if (client.keyInfo.clientId == currentId || !client.moduleReadys?.dislike || client.userInfo.name != currentUserName)
                return;
            void client.remoteQueueDislike.onDislikeSyncAction(action).then(async () => {
                return userSpace.dislikeManage.updateDeviceSnapshotKey(client.keyInfo.clientId, key);
            }).catch(err => {
                // TODO send status
                client.close(SYNC_CLOSE_CODE.failed);
                // client.moduleReadys.dislike = false
                console.log(err.message);
            });
        });
    },
};
/* harmony default export */ const dislike_sync_handler = (dislike_sync_handler_handler);

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/dislike/utils.ts

const filterRules = (rules) => {
    const list = [];
    for (const item of rules.split('\n')) {
        if (!item)
            continue;
        let [name, singer] = item.split(SPLIT_CHAR.DISLIKE_NAME);
        if (name) {
            name = name.replaceAll(SPLIT_CHAR.DISLIKE_NAME, SPLIT_CHAR.DISLIKE_NAME_ALIAS).toLocaleLowerCase().trim();
            if (singer) {
                singer = singer.replaceAll(SPLIT_CHAR.DISLIKE_NAME, SPLIT_CHAR.DISLIKE_NAME_ALIAS).toLocaleLowerCase().trim();
                list.push(`${name}${SPLIT_CHAR.DISLIKE_NAME}${singer}`);
            }
            else {
                list.push(name);
            }
        }
        else if (singer) {
            singer = singer.replaceAll(SPLIT_CHAR.DISLIKE_NAME, SPLIT_CHAR.DISLIKE_NAME_ALIAS).toLocaleLowerCase().trim();
            list.push(`${SPLIT_CHAR.DISLIKE_NAME}${singer}`);
        }
    }
    return new Set(list);
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/dislike/sync/sync.ts
// import { SYNC_CLOSE_CODE } from '../../../../constants'





// import { LIST_IDS } from '@common/constants'
// type ListInfoType = LX.Dislike.UserListInfoFull | LX.Dislike.MyDefaultListInfoFull | LX.Dislike.MyLoveListInfoFull
// let wss: LX.Sync.Server.SocketServer | null
let sync_syncingId = null;
const sync_wait = async (time = 1000) => await new Promise((resolve, reject) => setTimeout(resolve, time));
const sync_getRemoteListData = async (socket) => {
    console.log('getRemoteListData');
    return (await socket.remoteQueueDislike.dislike_sync_get_list_data()) ?? '';
};
const getRemoteDataMD5 = async (socket) => {
    return socket.remoteQueueDislike.dislike_sync_get_md5();
};
// const getLocalDislikeData  async(socket: LX.Sync.Server.Socket): Promise<LX.Sync.Dislike.ListData> => {
//   return getUserSpace(socket.userInfo.name).dislikeManage.getListData()
// }
const sync_sync_getSyncMode = async (socket) => new Promise((resolve, reject) => {
    const handleDisconnect = (err) => {
        sendCloseSelectMode();
        removeSelectModeListener();
        reject(err);
    };
    let removeEventClose = socket.onClose(handleDisconnect);
    sendSelectMode(socket.keyInfo.deviceName, 'dislike', (mode) => {
        if (mode == null) {
            reject(new Error('cancel'));
            return;
        }
        resolve(mode);
        removeSelectModeListener();
        removeEventClose();
    });
});
// const getSyncMode = async(socket: LX.Sync.Server.Socket): Promise<LX.Sync.Dislike.SyncMode> => {
//   return socket.remoteQueueDislike.list_sync_get_sync_mode()
// }
const sync_finishedSync = async (socket) => {
    await socket.remoteQueueDislike.dislike_sync_finished();
};
const sync_setLocalList = async (socket, listData) => {
    await setLocalDislikeData(listData);
    const userSpace = getUserSpace(socket.userInfo.name);
    return userSpace.dislikeManage.createSnapshot();
};
const sync_overwriteRemoteListData = async (socket, listData, key, excludeIds = []) => {
    const action = { action: 'dislike_data_overwrite', data: listData };
    const tasks = [];
    const userSpace = getUserSpace(socket.userInfo.name);
    socket.broadcast((client) => {
        if (excludeIds.includes(client.keyInfo.clientId) || client.userInfo?.name != socket.userInfo.name || !client.moduleReadys?.dislike)
            return;
        tasks.push(client.remoteQueueDislike.onDislikeSyncAction(action).then(async () => {
            return userSpace.dislikeManage.updateDeviceSnapshotKey(client.keyInfo.clientId, key);
        }).catch(err => {
            // TODO send status
            client.close(SYNC_CLOSE_CODE.failed);
            // client.moduleReadys.list = false
            console.log(err.message);
        }));
    });
    if (!tasks.length)
        return;
    await Promise.all(tasks);
};
const sync_setRemotelList = async (socket, listData, key) => {
    await socket.remoteQueueDislike.dislike_sync_set_list_data(listData);
    const userSpace = getUserSpace(socket.userInfo.name);
    await userSpace.dislikeManage.updateDeviceSnapshotKey(socket.keyInfo.clientId, key);
};
const sync_mergeList = (socket, sourceListData, targetListData) => {
    return Array.from(filterRules(sourceListData + '\n' + targetListData)).join('\n');
};
const sync_handleMergeListData = async (socket) => {
    const mode = await sync_sync_getSyncMode(socket);
    if (mode == 'cancel')
        throw new Error('cancel');
    const [remoteListData, localListData] = await Promise.all([sync_getRemoteListData(socket), getLocalDislikeData()]);
    console.log('handleMergeListData', 'remoteListData, localListData');
    let listData;
    let requiredUpdateLocalListData = true;
    let requiredUpdateRemoteListData = true;
    switch (mode) {
        case 'merge_local_remote':
            listData = sync_mergeList(socket, localListData, remoteListData);
            break;
        case 'merge_remote_local':
            listData = sync_mergeList(socket, remoteListData, localListData);
            break;
        case 'overwrite_local_remote':
            listData = localListData;
            requiredUpdateLocalListData = false;
            break;
        case 'overwrite_remote_local':
            listData = remoteListData;
            requiredUpdateRemoteListData = false;
            break;
        // case 'none': return null
        // case 'cancel':
        default: throw new Error('cancel');
    }
    return [listData, requiredUpdateLocalListData, requiredUpdateRemoteListData];
};
const sync_handleSyncList = async (socket) => {
    const [remoteListData, localListData] = await Promise.all([sync_getRemoteListData(socket), getLocalDislikeData()]);
    console.log('handleSyncList', 'remoteListData, localListData');
    console.log('localListData', localListData.length);
    console.log('remoteListData', remoteListData.length);
    const userSpace = getUserSpace(socket.userInfo.name);
    const clientId = socket.keyInfo.clientId;
    if (localListData.length) {
        if (remoteListData.length) {
            const [mergedList, requiredUpdateLocalListData, requiredUpdateRemoteListData] = await sync_handleMergeListData(socket);
            console.log('handleMergeListData', 'mergedList', requiredUpdateLocalListData, requiredUpdateRemoteListData);
            let key;
            if (requiredUpdateLocalListData) {
                key = await sync_setLocalList(socket, mergedList);
                await sync_overwriteRemoteListData(socket, mergedList, key, [clientId]);
                if (!requiredUpdateRemoteListData)
                    await userSpace.dislikeManage.updateDeviceSnapshotKey(clientId, key);
            }
            if (requiredUpdateRemoteListData) {
                if (!key)
                    key = await userSpace.dislikeManage.getCurrentListInfoKey();
                await sync_setRemotelList(socket, mergedList, key);
            }
        }
        else {
            await sync_setRemotelList(socket, localListData, await userSpace.dislikeManage.getCurrentListInfoKey());
        }
    }
    else {
        let key;
        if (remoteListData.length) {
            key = await sync_setLocalList(socket, remoteListData);
            await sync_overwriteRemoteListData(socket, remoteListData, key, [clientId]);
        }
        key ??= await userSpace.dislikeManage.getCurrentListInfoKey();
        await userSpace.dislikeManage.updateDeviceSnapshotKey(clientId, key);
    }
};
const mergeDataFromSnapshot = (sourceList, targetList, snapshotList) => {
    const removedRules = new Set();
    const sourceRules = filterRules(sourceList);
    const targetRules = filterRules(targetList);
    if (snapshotList) {
        const snapshotRules = filterRules(snapshotList);
        for (const m of snapshotRules.values()) {
            if (!sourceRules.has(m) || !targetRules.has(m))
                removedRules.add(m);
        }
    }
    return Array.from(new Set(Array.from([...sourceRules, ...targetRules]).filter((rule) => {
        return !removedRules.has(rule);
    }))).join('\n');
};
const sync_checkListLatest = async (socket) => {
    const remoteListMD5 = await getRemoteDataMD5(socket);
    const userSpace = getUserSpace(socket.userInfo.name);
    const userCurrentListInfoKey = await userSpace.dislikeManage.getDeviceCurrentSnapshotKey(socket.keyInfo.clientId);
    const currentListInfoKey = await userSpace.dislikeManage.getCurrentListInfoKey();
    const latest = remoteListMD5 == currentListInfoKey;
    if (latest && userCurrentListInfoKey != currentListInfoKey)
        await userSpace.dislikeManage.updateDeviceSnapshotKey(socket.keyInfo.clientId, currentListInfoKey);
    return latest;
};
const sync_handleMergeListDataFromSnapshot = async (socket, snapshot) => {
    if (await sync_checkListLatest(socket))
        return;
    const [remoteListData, localListData] = await Promise.all([sync_getRemoteListData(socket), getLocalDislikeData()]);
    const newDislikeData = mergeDataFromSnapshot(localListData, remoteListData, snapshot);
    const key = await sync_setLocalList(socket, newDislikeData);
    const err = await sync_setRemotelList(socket, newDislikeData, key).catch(err => err);
    await sync_overwriteRemoteListData(socket, newDislikeData, key, [socket.keyInfo.clientId]);
    if (err)
        throw err;
};
const syncDislike = async (socket) => {
    // socket.data.snapshotFilePath = getSnapshotFilePath(socket.keyInfo)
    // console.log(socket.keyInfo)
    if (!socket.feature.dislike)
        throw new Error('dislike feature options not available');
    if (!socket.feature.dislike.skipSnapshot) {
        const user = getUserSpace(socket.userInfo.name);
        const userCurrentDislikeInfoKey = await user.dislikeManage.getDeviceCurrentSnapshotKey(socket.keyInfo.clientId);
        if (userCurrentDislikeInfoKey) {
            const listData = await user.dislikeManage.snapshotDataManage.getSnapshot(userCurrentDislikeInfoKey);
            if (listData) {
                console.log('handleMergeDislikeDataFromSnapshot');
                await sync_handleMergeListDataFromSnapshot(socket, listData);
                return;
            }
        }
    }
    await sync_handleSyncList(socket);
};
const sync_sync = async (socket) => {
    let disconnected = false;
    socket.onClose(() => {
        disconnected = true;
        if (sync_syncingId == socket.keyInfo.clientId)
            sync_syncingId = null;
    });
    while (true) {
        if (disconnected)
            throw new Error('disconnected');
        if (!sync_syncingId)
            break;
        await sync_wait();
    }
    sync_syncingId = socket.keyInfo.clientId;
    await syncDislike(socket).then(async () => {
        await sync_finishedSync(socket);
        socket.moduleReadys.dislike = true;
    }).finally(() => {
        sync_syncingId = null;
    });
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/dislike/sync/localEvent.ts



// let socket: LX.Sync.Server.Socket | null
let dislike_sync_localEvent_unregisterLocalListAction;
const localEvent_sendListAction = async (wss, action) => {
    // console.log('sendListAction', action.action)
    const userSpace = getUserSpace();
    let key = '';
    for (const client of wss.clients) {
        if (!client.moduleReadys?.dislike)
            continue;
        // eslint-disable-next-line require-atomic-updates
        if (!key)
            key = await userSpace.dislikeManage.createSnapshot();
        void client.remoteQueueDislike.onDislikeSyncAction(action).then(async () => {
            return userSpace.dislikeManage.updateDeviceSnapshotKey(client.keyInfo.clientId, key);
        }).catch(err => {
            // TODO send status
            client.close(SYNC_CLOSE_CODE.failed);
            // client.moduleReadys.dislike = false
            console.log(err.message);
        });
    }
};
const dislike_sync_localEvent_registerEvent = (wss) => {
    // socket = _socket
    // socket.onClose(() => {
    //   unregisterLocalListAction?.()
    //   unregisterLocalListAction = null
    // })
    dislike_sync_localEvent_unregisterEvent();
    dislike_sync_localEvent_unregisterLocalListAction = registerDislikeActionEvent((action) => {
        void localEvent_sendListAction(wss, action);
    });
};
const dislike_sync_localEvent_unregisterEvent = () => {
    dislike_sync_localEvent_unregisterLocalListAction?.();
    dislike_sync_localEvent_unregisterLocalListAction = null;
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/dislike/sync/index.ts




;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/dislike/snapshotDataManage.ts







class snapshotDataManage_SnapshotDataManage {
    userDataManage;
    dislikeDir;
    snapshotDir;
    snapshotInfoFilePath;
    snapshotInfo;
    clientSnapshotKeys;
    saveSnapshotInfoThrottle;
    isIncluedsDevice = (key) => {
        return this.clientSnapshotKeys.includes(key);
    };
    clearOldSnapshot = async () => {
        if (!this.snapshotInfo)
            return;
        const snapshotList = this.snapshotInfo.list.filter(key => !this.isIncluedsDevice(key));
        // console.log(snapshotList.length, lx.config.maxSnapshotNum)
        const userMaxSnapshotNum = getUserConfig(this.userDataManage.userName).maxSnapshotNum;
        let requiredSave = snapshotList.length > userMaxSnapshotNum;
        while (snapshotList.length > userMaxSnapshotNum) {
            const name = snapshotList.pop();
            if (name) {
                await this.removeSnapshot(name);
                this.snapshotInfo.list.splice(this.snapshotInfo.list.indexOf(name), 1);
            }
            else
                break;
        }
        if (requiredSave)
            this.saveSnapshotInfo(this.snapshotInfo);
    };
    updateDeviceSnapshotKey = async (clientId, key) => {
        // console.log('updateDeviceSnapshotKey', key)
        let client = this.snapshotInfo.clients[clientId];
        if (!client)
            client = this.snapshotInfo.clients[clientId] = { snapshotKey: '', lastSyncDate: 0 };
        if (client.snapshotKey)
            this.clientSnapshotKeys.splice(this.clientSnapshotKeys.indexOf(client.snapshotKey), 1);
        client.snapshotKey = key;
        client.lastSyncDate = Date.now();
        this.clientSnapshotKeys.push(key);
        this.saveSnapshotInfoThrottle();
    };
    getDeviceCurrentSnapshotKey = async (clientId) => {
        // console.log('updateDeviceSnapshotKey', key)
        const client = this.snapshotInfo.clients[clientId];
        return client?.snapshotKey;
    };
    getSnapshotInfo = async () => {
        return this.snapshotInfo;
    };
    saveSnapshotInfo = (info) => {
        this.snapshotInfo = info;
        this.saveSnapshotInfoThrottle();
    };
    removeSnapshotInfo = (clientId) => {
        let client = this.snapshotInfo.clients[clientId];
        if (!client)
            return;
        if (client.snapshotKey)
            this.clientSnapshotKeys.splice(this.clientSnapshotKeys.indexOf(client.snapshotKey), 1);
        // eslint-disable-next-line @typescript-eslint/no-dynamic-delete
        delete this.snapshotInfo.clients[clientId];
        this.saveSnapshotInfoThrottle();
    };
    getSnapshot = async (name) => {
        const filePath = external_node_path_default().join(this.snapshotDir, `snapshot_${name}`);
        let listData;
        try {
            listData = (await external_node_fs_default().promises.readFile(filePath)).toString('utf-8');
        }
        catch (err) {
            sync_log.warn(err);
            return null;
        }
        return listData;
    };
    saveSnapshot = async (name, data) => {
        sync_log.info('saveSnapshot', this.userDataManage.userName, name);
        const filePath = external_node_path_default().join(this.snapshotDir, `snapshot_${name}`);
        try {
            external_node_fs_default().writeFileSync(filePath, data);
        }
        catch (err) {
            sync_log.error(err);
            throw err;
        }
    };
    removeSnapshot = async (name) => {
        sync_log.info('removeSnapshot', this.userDataManage.userName, name);
        const filePath = external_node_path_default().join(this.snapshotDir, `snapshot_${name}`);
        try {
            external_node_fs_default().unlinkSync(filePath);
        }
        catch (err) {
            sync_log.error(err);
        }
    };
    constructor(userDataManage) {
        this.userDataManage = userDataManage;
        this.dislikeDir = external_node_path_default().join(userDataManage.userDir, File.dislikeDir);
        checkAndCreateDirSync(this.dislikeDir);
        this.snapshotDir = external_node_path_default().join(this.dislikeDir, File.dislikeSnapshotDir);
        checkAndCreateDirSync(this.snapshotDir);
        this.snapshotInfoFilePath = external_node_path_default().join(this.dislikeDir, File.dislikeSnapshotInfoJSON);
        this.snapshotInfo = external_node_fs_default().existsSync(this.snapshotInfoFilePath)
            ? JSON.parse(external_node_fs_default().readFileSync(this.snapshotInfoFilePath).toString())
            : { latest: null, time: 0, list: [], clients: {} };
        this.saveSnapshotInfoThrottle = throttle(() => {
            external_node_fs_default().writeFile(this.snapshotInfoFilePath, JSON.stringify(this.snapshotInfo), 'utf8', (err) => {
                if (err)
                    console.error(err);
                void this.clearOldSnapshot();
            });
        });
        this.clientSnapshotKeys = Object.values(this.snapshotInfo.clients).map(device => device.snapshotKey).filter(k => k);
    }
}
// type UserDataManages = Map<string, UserDataManage>
// export const createUserDataManage = (user: LX.UserConfig) => {
//   const manage = Object.create(userDataManage) as typeof userDataManage
//   manage.userDir = user.dataPath
// }

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/dislike/manage.ts



class DislikeManage {
    snapshotDataManage;
    constructor(userDataManage) {
        this.snapshotDataManage = new snapshotDataManage_SnapshotDataManage(userDataManage);
    }
    createSnapshot = async () => {
        const listData = await this.getDislikeRules();
        const md5 = utils_toMD5(listData.trim());
        const snapshotInfo = await this.snapshotDataManage.getSnapshotInfo();
        console.log(md5, snapshotInfo.latest);
        if (snapshotInfo.latest == md5)
            return md5;
        if (snapshotInfo.list.includes(md5)) {
            snapshotInfo.list.splice(snapshotInfo.list.indexOf(md5), 1);
        }
        else
            await this.snapshotDataManage.saveSnapshot(md5, listData);
        if (snapshotInfo.latest)
            snapshotInfo.list.unshift(snapshotInfo.latest);
        snapshotInfo.latest = md5;
        snapshotInfo.time = Date.now();
        this.snapshotDataManage.saveSnapshotInfo(snapshotInfo);
        return md5;
    };
    getCurrentListInfoKey = async () => {
        // const snapshotInfo = await this.snapshotDataManage.getSnapshotInfo()
        // if (snapshotInfo.latest) {
        //   return snapshotInfo.latest
        // }
        // snapshotInfo.latest = toMD5((await this.getDislikeRules()).trim())
        // this.snapshotDataManage.saveSnapshotInfo(snapshotInfo)
        // return snapshotInfo.latest
        return this.createSnapshot();
    };
    getDeviceCurrentSnapshotKey = async (clientId) => {
        return this.snapshotDataManage.getDeviceCurrentSnapshotKey(clientId);
    };
    updateDeviceSnapshotKey = async (clientId, key) => {
        await this.snapshotDataManage.updateDeviceSnapshotKey(clientId, key);
    };
    removeDevice = async (clientId) => {
        this.snapshotDataManage.removeSnapshotInfo(clientId);
    };
    getDislikeRules = async () => {
        return getLocalDislikeData();
    };
}

;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/dislike/index.ts



;// CONCATENATED MODULE: ./src/main/modules/sync/server/modules/index.ts


const modules_callObj = Object.assign({}, list_sync_handler, dislike_sync_handler);
const server_modules_modules = {
    list: list_sync_namespaceObject,
    dislike: dislike_sync_namespaceObject,
};


const modules_featureVersion = {
    list: 1,
    dislike: 1,
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/server/sync/handler.ts
// 这个文件导出的方法将暴露给客户端调用，第一个参数固定为当前 socket 对象
// import { getUserSpace } from '@/user'


const server_sync_handler_handler = {
    async onFeatureChanged(socket, feature) {
        // const userSpace = getUserSpace(socket.userInfo.name)
        const beforeFeature = socket.feature;
        for (const name of FeaturesList) {
            const newStatus = feature[name];
            if (newStatus == null)
                continue;
            beforeFeature[name] = feature[name];
            socket.moduleReadys[name] = false;
            if (feature[name])
                await server_modules_modules[name].sync(socket).catch(_ => _);
        }
    },
};
/* harmony default export */ const server_sync_handler = (server_sync_handler_handler);

;// CONCATENATED MODULE: ./src/main/modules/sync/server/server/sync/sync.ts


const sync_sync_sync = async (socket) => {
    let disconnected = false;
    socket.onClose(() => {
        disconnected = true;
    });
    const enabledFeatures = await socket.remote.getEnabledFeatures('desktop-app', modules_featureVersion);
    if (disconnected)
        throw new Error('disconnected');
    for (const moduleName of FeaturesList) {
        if (enabledFeatures[moduleName]) {
            socket.feature[moduleName] = enabledFeatures[moduleName];
            await server_modules_modules[moduleName].sync(socket).catch(_ => _);
        }
        if (disconnected)
            throw new Error('disconnected');
    }
    await socket.remote.finished();
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/server/sync/event.ts

const registerLocalSyncEvent = async (wss) => {
    unregisterLocalSyncEvent();
    for (const module of Object.values(server_modules_modules)) {
        module.registerEvent(wss);
    }
};
const unregisterLocalSyncEvent = () => {
    for (const module of Object.values(server_modules_modules)) {
        module.unregisterEvent();
    }
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/server/sync/index.ts





const server_sync_callObj = {
    ...server_sync_handler,
    ...modules_callObj,
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/utils/tools.ts

// import { join } from 'node:path'

// import getStore from '@/utils/store'
// import syncLog from '../../log'
// import { getUserName } from '../user/data'
// import { saveClientKeyInfo } from './data'
const generateCode = () => {
    return Math.random().toString().substring(2, 8);
};
const getIP = (request) => {
    return request.socket.remoteAddress;
};
const tools_aesEncrypt = (buffer, key) => {
    const cipher = (0,external_node_crypto_namespaceObject.createCipheriv)('aes-128-ecb', Buffer.from(key, 'base64'), '');
    return Buffer.concat([cipher.update(buffer), cipher.final()]).toString('base64');
};
const tools_aesDecrypt = (text, key) => {
    const decipher = (0,external_node_crypto_namespaceObject.createDecipheriv)('aes-128-ecb', Buffer.from(key, 'base64'), '');
    return Buffer.concat([decipher.update(Buffer.from(text, 'base64')), decipher.final()]).toString();
};
const tools_rsaEncrypt = (buffer, key) => {
    return (0,external_node_crypto_namespaceObject.publicEncrypt)({ key, padding: external_node_crypto_namespaceObject.constants.RSA_PKCS1_OAEP_PADDING }, buffer).toString('base64');
};
const tools_rsaDecrypt = (buffer, key) => {
    return privateDecrypt({ key, padding: constants.RSA_PKCS1_OAEP_PADDING }, buffer);
};
const tools_gzip = async (data) => new Promise((resolve, reject) => {
    external_node_zlib_default().gzip(data, (err, buf) => {
        if (err) {
            reject(err);
            return;
        }
        resolve(buf.toString('base64'));
    });
});
const tools_unGzip = async (data) => new Promise((resolve, reject) => {
    external_node_zlib_default().gunzip(Buffer.from(data, 'base64'), (err, buf) => {
        if (err) {
            reject(err);
            return;
        }
        resolve(buf.toString());
    });
});
const tools_encryptMsg = async (keyInfo, msg) => {
    return msg.length > 1024
        ? 'cg_' + await tools_gzip(msg)
        : msg;
    // if (!keyInfo) return ''
    // return aesEncrypt(msg, keyInfo.key, keyInfo.iv)
};
const tools_decryptMsg = async (keyInfo, enMsg) => {
    return enMsg.substring(0, 3) == 'cg_'
        ? await tools_unGzip(enMsg.replace('cg_', ''))
        : enMsg;
    // console.log('decmsg raw: ', len.length, 'en: ', enMsg.length)
    // if (!keyInfo) return ''
    // let msg = ''
    // try {
    //   msg = aesDecrypt(enMsg, keyInfo.key, keyInfo.iv)
    // } catch (err) {
    //   console.log(err)
    // }
    // return msg
};
// export const getSnapshotFilePath = (keyInfo: LX.Sync.KeyInfo): string => {
//   return join(global.lx.snapshotPath, `snapshot_${keyInfo.snapshotKey}.json`)
// }
// export const sendStatus = (status: LX.Sync.ServerStatus) => {
//   syncLog.info('status', status.devices.map(d => `${getUserName(d.clientId) ?? ''} ${d.deviceName}`))
// }

;// CONCATENATED MODULE: external "node:querystring"
const external_node_querystring_namespaceObject = require("node:querystring");
var external_node_querystring_default = /*#__PURE__*/__webpack_require__.n(external_node_querystring_namespaceObject);
;// CONCATENATED MODULE: ./src/main/modules/sync/server/server/auth.ts






const requestIps = new Map();
const getAvailableIP = (req) => {
    let ip = getIP(req);
    return ip && (requestIps.get(ip) ?? 0) < 10 ? ip : null;
};
const verifyByKey = (encryptMsg, userId) => {
    const userSpace = getUserSpace();
    const keyInfo = userSpace.dataManage.getClientKeyInfo(userId);
    if (!keyInfo)
        return null;
    let text;
    try {
        text = tools_aesDecrypt(encryptMsg, keyInfo.key);
    }
    catch (err) {
        return null;
    }
    // console.log(text)
    if (text.startsWith(SYNC_CODE.authMsg)) {
        const deviceName = text.replace(SYNC_CODE.authMsg, '') || 'Unknown';
        if (deviceName != keyInfo.deviceName) {
            keyInfo.deviceName = deviceName;
            userSpace.dataManage.saveClientKeyInfo(keyInfo);
        }
        return tools_aesEncrypt(SYNC_CODE.helloMsg, keyInfo.key);
    }
    return null;
};
const verifyByCode = (encryptMsg, password) => {
    let key = utils_toMD5(password).substring(0, 16);
    // const iv = Buffer.from(key.split('').reverse().join('')).toString('base64')
    key = Buffer.from(key).toString('base64');
    // console.log(req.headers.m, authCode, key)
    let text;
    try {
        text = tools_aesDecrypt(encryptMsg, key);
    }
    catch {
        return null;
    }
    // console.log(text)
    if (text.startsWith(SYNC_CODE.authMsg)) {
        const data = text.split('\n');
        const publicKey = `-----BEGIN PUBLIC KEY-----\n${data[1]}\n-----END PUBLIC KEY-----`;
        const deviceName = data[2] || 'Unknown';
        const isMobile = data[3] == 'lx_music_mobile';
        const keyInfo = createClientKeyInfo(deviceName, isMobile);
        const userSpace = getUserSpace();
        userSpace.dataManage.saveClientKeyInfo(keyInfo);
        return tools_rsaEncrypt(Buffer.from(JSON.stringify({
            clientId: keyInfo.clientId,
            key: keyInfo.key,
            serverName: getComputerName(),
        })), publicKey);
    }
    return null;
};
const authCode = async (req, res, password) => {
    let code = 401;
    let msg = SYNC_CODE.msgAuthFailed;
    let ip = getAvailableIP(req);
    if (ip) {
        if (typeof req.headers.m == 'string' && req.headers.m) {
            const userId = req.headers.i;
            const _msg = typeof userId == 'string' && userId
                ? verifyByKey(req.headers.m, userId)
                : verifyByCode(req.headers.m, password);
            if (_msg != null) {
                msg = _msg;
                code = 200;
            }
        }
        if (code != 200) {
            const num = requestIps.get(ip) ?? 0;
            // if (num > 20) return
            requestIps.set(ip, num + 1);
        }
    }
    else {
        code = 403;
        msg = SYNC_CODE.msgBlockedIp;
    }
    // console.log(req.headers)
    res.writeHead(code);
    res.end(msg);
};
const verifyConnection = (encryptMsg, userId) => {
    const userSpace = getUserSpace();
    const keyInfo = userSpace.dataManage.getClientKeyInfo(userId);
    if (!keyInfo)
        return false;
    let text;
    try {
        text = tools_aesDecrypt(encryptMsg, keyInfo.key);
    }
    catch (err) {
        return false;
    }
    // console.log(text)
    return text == SYNC_CODE.msgConnect;
};
const authConnect = async (req) => {
    let ip = getAvailableIP(req);
    if (ip) {
        const query = external_node_querystring_default().parse((req.url).split('?')[1]);
        const i = query.i;
        const t = query.t;
        if (typeof i == 'string' && typeof t == 'string' && verifyConnection(t, i))
            return;
        const num = requestIps.get(ip) ?? 0;
        requestIps.set(ip, num + 1);
    }
    throw new Error('failed');
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/server/server.ts












let server_status = {
    status: false,
    message: '',
    address: [],
    code: '',
    devices: [],
};
let stopingServer = false;
let host = 'http://localhost';
const codeTools = {
    timeout: null,
    start() {
        this.stop();
        this.timeout = setInterval(() => {
            void generateCode();
        }, 60 * 3 * 1000);
    },
    stop() {
        if (!this.timeout)
            return;
        clearInterval(this.timeout);
        this.timeout = null;
    },
};
const checkDuplicateClient = (newSocket) => {
    for (const client of [...wss.clients]) {
        if (client === newSocket || client.keyInfo.clientId != newSocket.keyInfo.clientId)
            continue;
        sync_log.info('duplicate client', client.userInfo.name, client.keyInfo.deviceName);
        client.isReady = false;
        for (const name of Object.keys(client.moduleReadys)) {
            client.moduleReadys[name] = false;
        }
        client.close(SYNC_CLOSE_CODE.normal);
    }
};
const handleConnection = async (socket, request) => {
    const queryData = new URL(request.url, host).searchParams;
    const clientId = queryData.get('i');
    //   // if (typeof socket.handshake.query.i != 'string') return socket.disconnect(true)
    const userSpace = getUserSpace();
    const keyInfo = userSpace.dataManage.getClientKeyInfo(clientId);
    if (!keyInfo) {
        socket.close(SYNC_CLOSE_CODE.failed);
        return;
    }
    keyInfo.lastConnectDate = Date.now();
    userSpace.dataManage.saveClientKeyInfo(keyInfo);
    //   // socket.lx_keyInfo = keyInfo
    socket.keyInfo = keyInfo;
    socket.userInfo = { name: 'default' };
    checkDuplicateClient(socket);
    try {
        await sync_sync_sync(socket);
    }
    catch (err) {
        // console.log(err)
        sync_log.warn(err);
        return;
    }
    server_status.devices.push(keyInfo);
    // handleConnection(io, socket)
    sendServerStatus(server_status);
    socket.onClose(() => {
        server_status.devices.splice(server_status.devices.findIndex(k => k.clientId == keyInfo.clientId), 1);
        sendServerStatus(server_status);
    });
    // console.log('connection', keyInfo.deviceName)
    sync_log.info('connection', keyInfo.deviceName);
    // console.log(socket.handshake.query)
    socket.isReady = true;
};
const handleUnconnection = () => {
    // console.log('unconnection')
    releaseUserSpace();
};
const authConnection = (req, callback) => {
    // console.log(req.headers)
    // // console.log(req.auth)
    // console.log(req._query.authCode)
    authConnect(req).then(() => {
        callback(null, true);
    }).catch(err => {
        callback(err, false);
    });
};
let wss;
let httpServer;
let sockets = new Set();
function server_noop() { }
function onSocketError(err) {
    console.error(err);
}
const handleStartServer = async (port = 9527, ip = '0.0.0.0') => await new Promise((resolve, reject) => {
    httpServer = external_node_http_default().createServer((req, res) => {
        // console.log(req.url)
        const endUrl = `/${req.url?.split('/').at(-1) ?? ''}`;
        let code;
        let msg;
        switch (endUrl) {
            case '/hello':
                code = 200;
                msg = SYNC_CODE.helloMsg;
                break;
            case '/id':
                code = 200;
                msg = SYNC_CODE.idPrefix + data_getServerId();
                break;
            case '/ah':
                void authCode(req, res, server_status.code);
                break;
            default:
                code = 401;
                msg = 'Forbidden';
                break;
        }
        if (!code)
            return;
        res.writeHead(code);
        res.end(msg);
    });
    wss = new websocket_server({
        noServer: true,
    });
    wss.on('connection', function (socket, request) {
        socket.isReady = false;
        socket.moduleReadys = {
            list: false,
            dislike: false,
        };
        socket.feature = {
            list: false,
            dislike: false,
        };
        socket.on('pong', () => {
            socket.isAlive = true;
        });
        // const events = new Map<keyof ActionsType, Array<(err: Error | null, data: LX.Sync.ActionSyncType[keyof LX.Sync.ActionSyncType]) => void>>()
        // const events = new Map<keyof LX.Sync.ActionSyncType, Array<(err: Error | null, data: LX.Sync.ActionSyncType[keyof LX.Sync.ActionSyncType]) => void>>()
        // let events: Partial<{ [K in keyof LX.Sync.ActionSyncType]: Array<(data: LX.Sync.ActionSyncType[K]) => void> }> = {}
        let closeEvents = [];
        let disconnected = false;
        const msg2call = createMsg2call({
            funcsObj: server_sync_callObj,
            timeout: 120 * 1000,
            sendMessage(data) {
                if (disconnected)
                    throw new Error('disconnected');
                void tools_encryptMsg(socket.keyInfo, JSON.stringify(data)).then((data) => {
                    // console.log('sendData', eventName)
                    socket.send(data);
                }).catch(err => {
                    sync_log.error('encrypt message error:', err);
                    sync_log.error(err.message);
                    socket.close(SYNC_CLOSE_CODE.failed);
                });
            },
            onCallBeforeParams(rawArgs) {
                return [socket, ...rawArgs];
            },
            onError(error, path, groupName) {
                const name = groupName ?? '';
                const deviceName = socket.keyInfo?.deviceName ?? '';
                sync_log.error(`sync call ${deviceName} ${name} ${path.join('.')} error:`, error);
                // if (groupName == null) return
                // socket.close(SYNC_CLOSE_CODE.failed)
            },
        });
        socket.remote = msg2call.remote;
        socket.remoteQueueList = msg2call.createQueueRemote('list');
        socket.remoteQueueDislike = msg2call.createQueueRemote('dislike');
        socket.addEventListener('message', ({ data }) => {
            if (typeof data != 'string')
                return;
            void tools_decryptMsg(socket.keyInfo, data).then((data) => {
                let syncData;
                try {
                    syncData = JSON.parse(data);
                }
                catch (err) {
                    sync_log.error('parse message error:', err);
                    socket.close(SYNC_CLOSE_CODE.failed);
                    return;
                }
                msg2call.message(syncData);
            }).catch(err => {
                sync_log.error('decrypt message error:', err);
                sync_log.error(err.message);
                socket.close(SYNC_CLOSE_CODE.failed);
            });
        });
        socket.addEventListener('close', () => {
            const err = new Error('closed');
            try {
                for (const handler of closeEvents)
                    void handler(err);
            }
            catch (err) {
                sync_log.error(err?.message);
            }
            closeEvents = [];
            disconnected = true;
            msg2call.destroy();
            if (socket.isReady) {
                sync_log.info('deconnection', socket.userInfo.name, socket.keyInfo.deviceName);
                // events = {}
                if (!server_status.devices.length)
                    handleUnconnection();
            }
            else {
                const queryData = new URL(request.url, host).searchParams;
                sync_log.info('deconnection', queryData.get('i'));
            }
        });
        socket.onClose = function (handler) {
            closeEvents.push(handler);
            return () => {
                closeEvents.splice(closeEvents.indexOf(handler), 1);
            };
        };
        socket.broadcast = function (handler) {
            if (!wss)
                return;
            for (const client of wss.clients)
                handler(client);
        };
        void handleConnection(socket, request);
    });
    httpServer.on('upgrade', function upgrade(request, socket, head) {
        socket.addListener('error', onSocketError);
        // This function is not defined on purpose. Implement it with your own logic.
        authConnection(request, err => {
            if (err) {
                console.log(err);
                socket.write('HTTP/1.1 401 Unauthorized\r\n\r\n');
                socket.destroy();
                return;
            }
            socket.removeListener('error', onSocketError);
            wss?.handleUpgrade(request, socket, head, function done(ws) {
                wss?.emit('connection', ws, request);
            });
        });
    });
    const interval = setInterval(() => {
        wss?.clients.forEach(socket => {
            if (socket.isAlive == false) {
                sync_log.info('alive check false:', socket.userInfo.name, socket.keyInfo.deviceName);
                socket.terminate();
                return;
            }
            socket.isAlive = false;
            socket.ping(server_noop);
            if (socket.keyInfo.isMobile)
                socket.send('ping', server_noop);
        });
    }, 30000);
    wss.on('close', function close() {
        clearInterval(interval);
    });
    httpServer.on('error', error => {
        console.log(error);
        reject(error);
    });
    httpServer.on('connection', (socket) => {
        sockets.add(socket);
        socket.once('close', () => {
            sockets.delete(socket);
        });
    });
    httpServer.on('listening', () => {
        const addr = httpServer.address();
        // console.log(addr)
        if (!addr) {
            reject(new Error('address is null'));
            return;
        }
        const bind = typeof addr == 'string' ? `pipe ${addr}` : `port ${addr.port}`;
        sync_log.info(`Listening on ${ip} ${bind}`);
        resolve(null);
        void registerLocalSyncEvent(wss);
    });
    host = `http://${ip}:${port}`;
    httpServer.listen(port, ip);
});
const handleStopServer = async () => new Promise((resolve, reject) => {
    if (!wss)
        return;
    for (const client of wss.clients)
        client.close(SYNC_CLOSE_CODE.normal);
    unregisterLocalSyncEvent();
    wss.close();
    wss = null;
    httpServer.close((err) => {
        if (err) {
            reject(err);
            return;
        }
        resolve();
    });
    for (const socket of sockets)
        socket.destroy();
    sockets.clear();
});
const server_stopServer = async () => {
    codeTools.stop();
    if (!server_status.status) {
        server_status.status = false;
        server_status.message = '';
        server_status.address = [];
        server_status.code = '';
        sendServerStatus(server_status);
        return;
    }
    console.log('stoping sync server...');
    server_status.message = 'stoping...';
    sendServerStatus(server_status);
    stopingServer = true;
    await handleStopServer().then(() => {
        console.log('sync server stoped');
        server_status.status = false;
        server_status.message = '';
        server_status.address = [];
        server_status.code = '';
    }).catch(err => {
        console.log(err);
        server_status.message = err.message;
    }).finally(() => {
        sendServerStatus(server_status);
        stopingServer = false;
    });
};
const startServer = async (port) => {
    // if (status.status) await handleStopServer()
    console.log('status.status', server_status.status, stopingServer);
    if (stopingServer)
        return;
    if (server_status.status)
        await handleStopServer();
    await migrate(global.lxDataPath);
    await initServerInfo();
    sync_log.info('starting sync server');
    await handleStartServer(port).then(() => {
        console.log('sync server started');
        server_status.status = true;
        server_status.message = '';
        server_status.address = getAddress();
        void server_generateCode();
        codeTools.start();
    }).catch(err => {
        console.log(err);
        server_status.status = false;
        server_status.message = err.message;
        server_status.address = [];
        server_status.code = '';
    }).finally(() => {
        sendServerStatus(server_status);
    });
};
const server_getStatus = () => server_status;
const server_generateCode = async () => {
    server_status.code = generateCode();
    sendServerStatus(server_status);
    return server_status.code;
};
const getDevices = async () => {
    const userSpace = getUserSpace();
    return userSpace.getDecices();
};
const removeDevice = async (clientId) => {
    if (wss) {
        for (const client of wss.clients) {
            if (client.keyInfo.clientId == clientId)
                client.close(SYNC_CLOSE_CODE.normal);
        }
    }
    const userSpace = getUserSpace();
    await userSpace.removeDevice(clientId);
};

;// CONCATENATED MODULE: ./src/main/modules/sync/server/server/index.ts


;// CONCATENATED MODULE: ./src/main/modules/sync/server/index.ts


;// CONCATENATED MODULE: ./src/main/modules/sync/index.ts
// import Event from './event/event'


// import eventNames from './event/name'


/* harmony default export */ const modules_sync = (() => {
    global.lx.event_app.on('main_window_close', () => {
        if (global.lx.appSetting['sync.mode'] == 'server') {
            void stopServer();
        }
        else {
            void disconnectServer();
        }
    });
});

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/sync.ts




let selectModeListenr = null;
/* harmony default export */ const rendererEvent_sync = (() => {
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.sync_action, async ({ params: data }) => {
        switch (data.action) {
            case 'enable_server':
                data.data.enable ? await startServer(parseInt(data.data.port)) : await server_stopServer();
                return;
            case 'enable_client':
                data.data.enable ? await connectServer(data.data.host, data.data.authCode) : await client_disconnectServer();
                return;
            case 'get_server_status': return server_getStatus();
            case 'get_client_status': return client_getStatus();
            case 'generate_code': return server_generateCode();
            case 'select_mode':
                if (selectModeListenr) {
                    selectModeListenr(data.data.mode);
                    selectModeListenr = null;
                }
                break;
            default:
                break;
        }
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.sync_get_server_devices, async () => {
        return getDevices();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.sync_remove_server_device, async ({ params: clientId }) => {
        await removeDevice(clientId);
    });
});
const sendSyncAction = (data) => {
    sendEvent(WIN_MAIN_RENDERER_EVENT_NAME.sync_action, data);
};
const sendClientStatus = (status) => {
    sendSyncAction({
        action: 'client_status',
        data: status,
    });
};
const sendServerStatus = (status) => {
    sendSyncAction({
        action: 'server_status',
        data: status,
    });
};
const sendSelectMode = (deviceName, type, listener) => {
    selectModeListenr = listener;
    sendSyncAction({ action: 'select_mode', data: { deviceName, type } });
};
const removeSelectModeListener = () => {
    if (selectModeListenr)
        selectModeListenr(null);
    selectModeListenr = null;
};
const sendCloseSelectMode = () => {
    sendSyncAction({ action: 'close_select_mode' });
};

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/data.ts




/* harmony default export */ const data = (() => {
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_data, ({ params: path }) => {
        return store(STORE_NAMES.DATA).get(path);
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.save_data, ({ params: { path, data } }) => {
        store(STORE_NAMES.DATA).set(path, data);
    });
});

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/music.ts


/* harmony default export */ const music = (() => {
    // =========================歌词=========================
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_palyer_lyric, async ({ params: id }) => {
        // return (getStore(LRC_EDITED, true, false).get(id) as LX.Music.LyricInfo | undefined) ??
        // getStore(LRC_RAW, true, false).get(id, {}) as LX.Music.LyricInfo
        return global.lx.worker.dbService.getPlayerLyric(id);
    });
    // 原始歌词
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_lyric_raw, async ({ params: id }) => {
        return global.lx.worker.dbService.getRawLyric(id);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.save_lyric_raw, async ({ params: { id, lyrics } }) => {
        await global.lx.worker.dbService.rawLyricAdd(id, lyrics);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.clear_lyric_raw, async () => {
        await global.lx.worker.dbService.rawLyricClear();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_lyric_raw_count, async () => {
        return global.lx.worker.dbService.rawLyricCount();
    });
    // 已编辑的歌词
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_lyric_edited, async ({ params: id }) => {
        return global.lx.worker.dbService.getEditedLyric(id);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.save_lyric_edited, async ({ params: { id, lyrics } }) => {
        await global.lx.worker.dbService.editedLyricUpdateAddAndUpdate(id, lyrics);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.remove_lyric_edited, async ({ params: id }) => {
        await global.lx.worker.dbService.editedLyricRemove([id]);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.clear_lyric_edited, async () => {
        await global.lx.worker.dbService.editedLyricClear();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_lyric_edited_count, async () => {
        return global.lx.worker.dbService.editedLyricCount();
    });
    // =========================歌曲URL=========================
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_music_url, async ({ params: id }) => {
        return (await global.lx.worker.dbService.getMusicUrl(id)) ?? '';
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.save_music_url, async ({ params: { id, url } }) => {
        await global.lx.worker.dbService.musicUrlSave([{ id, url }]);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.clear_music_url, async () => {
        await global.lx.worker.dbService.musicUrlClear();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_music_url_count, async () => {
        return global.lx.worker.dbService.musicUrlCount();
    });
    // =========================换源歌曲=========================
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_other_source, async ({ params: id }) => {
        return global.lx.worker.dbService.getMusicInfoOtherSource(id);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.save_other_source, async ({ params: { id, list } }) => {
        await global.lx.worker.dbService.musicInfoOtherSourceAdd(id, list);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.clear_other_source, async () => {
        await global.lx.worker.dbService.musicInfoOtherSourceClear();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_other_source_count, async () => {
        return global.lx.worker.dbService.musicInfoOtherSourceCount();
    });
    // mainHandle<string[]>(WIN_MAIN_RENDERER_EVENT_NAME.remove_dislike_music_infos, async({ params: ids }) => {
    //   await global.lx.worker.dbService.dislikeInfoRemove(ids)
    // })
    // mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.clear_dislike_music_infos, async() => {
    //   await global.lx.worker.dbService.dislikeInfoClear()
    // })
    // =========================我的列表=========================
    // mainHandle<boolean>(WIN_MAIN_RENDERER_EVENT_NAME.get_playlist, async({ params: isIgnoredError = false }) => {
    //   const electronStore_list = getStore('playList', isIgnoredError, false)
    //   return {
    //     defaultList: electronStore_list.get('defaultList'),
    //     loveList: electronStore_list.get('loveList'),
    //     tempList: electronStore_list.get('tempList'),
    //     userList: electronStore_list.get('userList'),
    //     downloadList: getStore('downloadList').get('list'),
    //   }
    // })
    // const handleSaveList = ({ defaultList, loveList, userList, tempList }: Partial<LX.List.MyAllList>) => {
    //   let data: Partial<LX.List.MyAllList> = {}
    //   if (defaultList != null) data.defaultList = defaultList
    //   if (loveList != null) data.loveList = loveList
    //   if (userList != null) data.userList = userList
    //   if (tempList != null) data.tempList = tempList
    //   getStore('playList').set(data)
    // }
    // mainOn<LX.List.ListSaveInfo>(WIN_MAIN_RENDERER_EVENT_NAME.save_playlist, ({ params }) => {
    //   switch (params.type) {
    //     case 'myList':
    //       handleSaveList(params.data)
    //       global.lx.event_app.save_my_list(params.data)
    //       break
    //     case 'downloadList':
    //       getStore('downloadList').set('list', params.data)
    //       break
    //   }
    // })
});

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/download.ts


/* harmony default export */ const download = (() => {
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.download_list_get, async () => {
        return global.lx.worker.dbService.getDownloadList();
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.download_list_add, async ({ params: { list, addMusicLocationType } }) => {
        await global.lx.worker.dbService.downloadInfoSave(list, addMusicLocationType);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.download_list_update, async ({ params: list }) => {
        await global.lx.worker.dbService.downloadInfoUpdate(list);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.download_list_remove, async ({ params: ids }) => {
        await global.lx.worker.dbService.downloadInfoRemove(ids);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.download_list_clear, async () => {
        await global.lx.worker.dbService.downloadInfoClear();
    });
});

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/soundEffect.ts




/* harmony default export */ const soundEffect = (() => {
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_sound_effect_eq_preset, async () => {
        return store(STORE_NAMES.SOUND_EFFECT).get('eqPreset') ?? [];
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.save_sound_effect_eq_preset, ({ params }) => {
        store(STORE_NAMES.SOUND_EFFECT).set('eqPreset', params);
    });
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.get_sound_effect_convolution_preset, async () => {
        return store(STORE_NAMES.SOUND_EFFECT).get('convolutionPreset') ?? [];
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.save_sound_effect_convolution_preset, ({ params }) => {
        store(STORE_NAMES.SOUND_EFFECT).set('convolutionPreset', params);
    });
    // mainHandle<LX.SoundEffect.PitchShifterPreset[]>(WIN_MAIN_RENDERER_EVENT_NAME.get_sound_effect_pitch_shifter_preset, async() => {
    //   return getStore(STORE_NAMES.SOUND_EFFECT).get('pitchShifterPreset') as LX.SoundEffect.PitchShifterPreset[] | null ?? []
    // })
    // mainOn<LX.SoundEffect.PitchShifterPreset[]>(WIN_MAIN_RENDERER_EVENT_NAME.save_sound_effect_pitch_shifter_preset, ({ params }) => {
    //   getStore(STORE_NAMES.SOUND_EFFECT).set('pitchShifterPreset', params)
    // })
});

;// CONCATENATED MODULE: ./src/main/modules/openApi/index.ts



let openApi_status = {
    status: false,
    message: '',
    address: '',
};
let openApi_httpServer;
let openApi_sockets = new Set();
let responses = new Map();
let playerStatusKeys;
const defaultFilter = [
    'status',
    'name',
    'singer',
    'albumName',
    'lyricLineText',
    'duration',
    'progress',
    'playbackRate',
];
const parseFilter = (filter) => {
    if (typeof filter != 'string')
        return defaultFilter;
    filter = filter.split(',');
    const subKeys = playerStatusKeys.filter(k => filter.includes(k));
    return subKeys.length ? subKeys : defaultFilter;
};
const handleSendStatus = (res, query) => {
    const keys = parseFilter(external_node_querystring_default().parse(query ?? '').filter);
    const resp = {};
    for (const k of keys)
        resp[k] = global.lx.player_status[k];
    res.setHeader('Content-Type', 'application/json; charset=utf-8');
    res.setHeader('Access-Control-Allow-Origin', '*');
    res.writeHead(200);
    res.end(JSON.stringify(resp));
};
const handleSubscribePlayerStatus = (req, res, query) => {
    res.writeHead(200, {
        'Content-Type': 'text/event-stream',
        Connection: 'keep-alive',
        'Cache-Control': 'no-cache',
        'Access-Control-Allow-Origin': '*',
    });
    req.socket.setTimeout(0);
    req.on('close', () => {
        res.end('OK');
        responses.delete(res);
    });
    const keys = parseFilter(external_node_querystring_default().parse(query ?? '').filter);
    responses.set(res, keys);
    for (const [k, v] of Object.entries(global.lx.player_status)) {
        if (!keys.includes(k))
            continue;
        res.write(`event: ${k}\n`);
        res.write(`data: ${JSON.stringify(v)}\n\n`);
    }
};
const openApi_handleStartServer = async (port, ip) => new Promise((resolve, reject) => {
    playerStatusKeys = Object.keys(global.lx.player_status);
    openApi_httpServer = external_node_http_default().createServer((req, res) => {
        const [endUrl, query] = `/${req.url?.split('/').at(-1) ?? ''}`.split('?');
        let code;
        let msg;
        switch (endUrl) {
            case '/status':
                handleSendStatus(res, query);
                return;
            // case '/test':
            //   code = 200
            //   res.setHeader('Content-Type', 'text/html; charset=utf-8')
            //   msg = `<!DOCTYPE html>
            //   <html lang="en">
            //     <head>
            //       <meta charset="UTF-8" />
            //       <meta http-equiv="X-UA-Compatible" content="IE=edge" />
            //       <meta name="viewport" content="width=device-width, initial-scale=1.0" />
            //       <title>Nodejs Server-Sent Events</title>
            //     </head>
            //     <body>
            //       <h1>Hello SSE!</h1>
            //       <h2>List of Server-sent events</h2>
            //       <ul id="sse-list"></ul>
            //       <script>
            //         const subscription = new EventSource('/subscribe-player-status');
            //       // Default events
            //       subscription.addEventListener('open', () => {
            //           console.log('Connection opened')
            //       });
            //       subscription.addEventListener('error', (err) => {
            //           console.error(err)
            //       });
            //       subscription.addEventListener('lyricLineText', (event) => {
            //           console.log(event.data)
            //       });
            //       subscription.addEventListener('progress', (event) => {
            //           console.log(event.data)
            //       });
            //       subscription.addEventListener('name', (event) => {
            //           console.log(event.data)
            //       });
            //       subscription.addEventListener('singer', (event) => {
            //           console.log(event.data)
            //       });
            //       </script>
            //     </body>
            //   </html>`
            //   break
            case '/lyric':
                code = 200;
                res.setHeader('Content-Type', 'text/plain; charset=utf-8');
                res.setHeader('Access-Control-Allow-Origin', '*');
                msg = global.lx.player_status.lyric;
                break;
            case '/subscribe-player-status':
                try {
                    handleSubscribePlayerStatus(req, res, query);
                    return;
                }
                catch (err) {
                    console.log(err);
                    code = 500;
                    msg = 'Error';
                }
                break;
            default:
                code = 401;
                msg = 'Forbidden';
                break;
        }
        if (!code)
            return;
        res.writeHead(code);
        res.end(msg);
    });
    openApi_httpServer.on('error', error => {
        console.log(error);
        reject(error);
    });
    openApi_httpServer.on('connection', (socket) => {
        openApi_sockets.add(socket);
        socket.once('close', () => {
            openApi_sockets.delete(socket);
        });
        socket.setTimeout(4000);
    });
    openApi_httpServer.on('listening', () => {
        const addr = openApi_httpServer.address();
        // console.log(addr)
        if (!addr) {
            reject(new Error('address is null'));
            return;
        }
        resolve();
    });
    openApi_httpServer.listen(port, ip);
});
const openApi_handleStopServer = async () => new Promise((resolve, reject) => {
    if (!openApi_httpServer)
        return;
    openApi_httpServer.close((err) => {
        if (err) {
            reject(err);
            return;
        }
        resolve();
    });
    for (const socket of openApi_sockets)
        socket.destroy();
    openApi_sockets.clear();
    responses.clear();
});
const openApi_sendStatus = (status) => {
    if (!responses.size)
        return;
    for (const [resp, keys] of responses) {
        for (const [k, v] of Object.entries(status)) {
            if (!keys.includes(k))
                continue;
            resp.write(`event: ${k}\n`);
            resp.write(`data: ${JSON.stringify(v)}\n\n`);
        }
    }
};
const openApi_stopServer = async () => {
    global.lx.event_app.off('player_status', openApi_sendStatus);
    if (!openApi_status.status) {
        openApi_status.status = false;
        openApi_status.message = '';
        openApi_status.address = '';
        return openApi_status;
    }
    await openApi_handleStopServer().then(() => {
        openApi_status.status = false;
        openApi_status.message = '';
        openApi_status.address = '';
    }).catch(err => {
        console.log(err);
        openApi_status.message = err.message;
    });
    return openApi_status;
};
const openApi_startServer = async (port, bindLan) => {
    if (openApi_status.status)
        await openApi_stopServer();
    await openApi_handleStartServer(port, bindLan ? '0.0.0.0' : '127.0.0.1').then(() => {
        openApi_status.status = true;
        openApi_status.message = '';
        let address = ['127.0.0.1'];
        if (bindLan)
            address = [...address, ...getAddress()];
        openApi_status.address = address.join(', ');
    }).catch(err => {
        console.log(err);
        openApi_status.status = false;
        openApi_status.message = err.message;
        openApi_status.address = '';
    });
    global.lx.event_app.on('player_status', openApi_sendStatus);
    return openApi_status;
};
const openApi_getStatus = () => openApi_status;

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/openAPI.ts



/* harmony default export */ const openAPI = (() => {
    mainHandle(WIN_MAIN_RENDERER_EVENT_NAME.open_api_action, async ({ params: data }) => {
        switch (data.action) {
            case 'enable':
                return data.data.enable ? await openApi_startServer(parseInt(data.data.port), data.data.bindLan) : await openApi_stopServer();
            case 'status': return openApi_getStatus();
        }
    });
});

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/process.ts


// export default () => {
// }
/**
 * 发送桌面歌词进程创建事件
 * @param port 端口
 */
const sendNewDesktopLyricClient = (port) => {
    getWebContents().postMessage(WIN_MAIN_RENDERER_EVENT_NAME.process_new_desktop_lyric_client, null, [port]);
};

;// CONCATENATED MODULE: ./src/main/modules/winMain/rendererEvent/index.ts




















let isInitialized = false;
/* harmony default export */ const winMain_rendererEvent = (() => {
    if (isInitialized)
        return;
    isInitialized = true;
    registerRendererEvents(sendEvent);
    winRendererEvent_registerRendererEvents(sendEvent);
    dislike_winRendererEvent_registerRendererEvents(sendEvent);
    app();
    rendererEvent_hotKey();
    kw_decodeLyric();
    tx_decodeLyric();
    rendererEvent_userApi();
    rendererEvent_sync();
    data();
    music();
    download();
    soundEffect();
    openAPI();
    global.lx.event_app.on('updated_config', (keys, setting) => {
        sendConfigChange(setting);
    });
});

// EXTERNAL MODULE: ./node_modules/electron-updater/out/main.js
var main = __webpack_require__(5879);
;// CONCATENATED MODULE: ./src/main/modules/winMain/autoUpdate.ts





main.autoUpdater.logger = (node_default());
main.autoUpdater.autoDownload = false;
// autoUpdater.forceDevUpdateConfig = true
// autoUpdater.autoDownload = false
// let isFirstCheckedUpdate = true
node_default().info('App starting...');
// -------------------------------------------------------------------
// Open a window that displays the version
//
// THIS SECTION IS NOT REQUIRED
//
// This isn't required for auto-updates to work, but it's easier
// for the app to show a window than to have to click "About" to see
// that updates are working.
// -------------------------------------------------------------------
// let win
function sendStatusToWindow(text) {
    node_default().info(text);
    // ipcMain.send('message', text)
}
// let waitEvent: WaitEvent[] = []
const handleSendEvent = (action) => {
    if (isExistWindow()) {
        setTimeout(() => {
            sendEvent(action.type, action.info);
        }, 1000);
    }
};
/* harmony default export */ const autoUpdate = (() => {
    main.autoUpdater.on('checking-for-update', () => {
        sendStatusToWindow('Checking for update...');
    });
    main.autoUpdater.on('update-available', info => {
        sendStatusToWindow('Update available.');
        handleSendEvent({ type: WIN_MAIN_RENDERER_EVENT_NAME.update_available, info });
    });
    main.autoUpdater.on('update-not-available', info => {
        sendStatusToWindow('Update not available.');
        handleSendEvent({ type: WIN_MAIN_RENDERER_EVENT_NAME.update_not_available, info });
    });
    main.autoUpdater.on('error', err => {
        sendStatusToWindow('Error in auto-updater.');
        handleSendEvent({ type: WIN_MAIN_RENDERER_EVENT_NAME.update_error, info: err.message });
    });
    main.autoUpdater.on('download-progress', progressObj => {
        let log_message = `Download speed: ${progressObj.bytesPerSecond}`;
        log_message = `${log_message} - Downloaded ${progressObj.percent}%`;
        log_message = `${log_message} (progressObj.transferred/${progressObj.total})`;
        sendStatusToWindow(log_message);
        handleSendEvent({ type: WIN_MAIN_RENDERER_EVENT_NAME.update_progress, info: progressObj });
    });
    main.autoUpdater.on('update-downloaded', info => {
        sendStatusToWindow('Update downloaded.');
        handleSendEvent({ type: WIN_MAIN_RENDERER_EVENT_NAME.update_downloaded, info });
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.update_check, () => {
        console.log('check');
        checkUpdate();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.update_download_update, () => {
        if (!main.autoUpdater.isUpdaterActive())
            return;
        void main.autoUpdater.downloadUpdate();
    });
    mainOn(WIN_MAIN_RENDERER_EVENT_NAME.quit_update, () => {
        global.lx.isSkipTrayQuit = true;
        setTimeout(() => {
            main.autoUpdater.quitAndInstall(true, true);
        }, 1000);
    });
});
const checkUpdate = () => {
    // if (!isFirstCheckedUpdate) {
    //   if (waitEvent.length) {
    //     waitEvent.forEach((event, index) => {
    //       setTimeout(() => { // 延迟发送事件，过早发送可能渲染进程还没启动完成
    //         sendEvent(event.type, event.info)
    //       }, 2000 * (index + 1))
    //     })
    //     waitEvent = []
    //   }
    //   return
    // }
    // isFirstCheckedUpdate = false
    // 由于集合安装包中不包含win arm版，这将会导致arm版更新失败
    if (isWin && process.arch.includes('arm')) {
        handleSendEvent({ type: WIN_MAIN_RENDERER_EVENT_NAME.update_error, info: 'failed' });
    }
    else {
        main.autoUpdater.autoDownload = global.lx.appSetting['common.tryAutoUpdate'];
        void main.autoUpdater.checkForUpdates();
    }
};

;// CONCATENATED MODULE: ./src/main/modules/winMain/index.ts






/* harmony default export */ const winMain = (() => {
    winMain_rendererEvent();
    autoUpdate();
    global.lx.event_app.on('hot_key_down', ({ type, key }) => {
        let info = global.lx.hotKey.config.global.keys[key];
        if (info?.type != APP_EVENT_NAMES.winMainName)
            return;
        switch (info.action) {
            case HOTKEY_COMMON.close.action:
                quitApp();
                break;
            case HOTKEY_COMMON.hide_toggle.action:
                toggleHide();
                break;
            case HOTKEY_COMMON.min.action:
                minimize();
                break;
            case HOTKEY_COMMON.min_toggle.action:
                toggleMinimize();
                break;
            default:
                handleKeyDown(type, key);
                break;
        }
    });
    global.lx.event_app.on('hot_key_config_update', (config) => {
        hotKeyConfigUpdate(config);
    });
    global.lx.event_app.on('app_inited', () => {
        createWindow();
    });
    const keys = ['status', 'collect'];
    const taskBarButtonFlags = {
        empty: true,
        collect: false,
        play: false,
        next: true,
        prev: true,
    };
    const progressStatus = {
        progress: -1,
        status: 'none',
    };
    let showProgress = global.lx.appSetting['player.isShowTaskProgess'];
    global.lx.event_app.on('player_status', (status) => {
        if (status.status) {
            switch (status.status) {
                case 'paused':
                    taskBarButtonFlags.play = false;
                    taskBarButtonFlags.empty &&= false;
                    progressStatus.status = 'paused';
                    break;
                case 'error':
                    taskBarButtonFlags.play = false;
                    taskBarButtonFlags.empty &&= false;
                    progressStatus.status = 'error';
                    break;
                case 'playing':
                    taskBarButtonFlags.play = true;
                    taskBarButtonFlags.empty &&= false;
                    progressStatus.status = 'normal';
                    break;
                case 'stoped':
                    taskBarButtonFlags.play &&= false;
                    taskBarButtonFlags.empty = true;
                    progressStatus.status = 'none';
                    progressStatus.progress = 0;
                    break;
            }
            if (showProgress) {
                setProgressBar(progressStatus.progress, {
                    mode: progressStatus.status,
                });
            }
        }
        if (keys.some(k => status[k] != null)) {
            if (status.collect != null)
                taskBarButtonFlags.collect = status.collect;
            setThumbarButtons(taskBarButtonFlags);
        }
        if (showProgress && status.progress != null) {
            const progress = global.lx.player_status.duration ? status.progress / global.lx.player_status.duration : 0;
            if (progress.toFixed(2) != progressStatus.progress.toFixed(2)) {
                progressStatus.progress = progress < 0.01 ? 0.01 : progress;
                setProgressBar(progressStatus.progress, {
                    mode: progressStatus.status,
                });
            }
        }
    });
    global.lx.event_app.on('updated_config', (keys, setting) => {
        if (keys.includes('player.isShowTaskProgess')) {
            showProgress = setting['player.isShowTaskProgess'];
            if (showProgress) {
                setProgressBar(progressStatus.progress, {
                    mode: progressStatus.status,
                });
            }
            else {
                setProgressBar(-1, { mode: 'none' });
            }
        }
    });
});



// EXTERNAL MODULE: external "events"
var external_events_ = __webpack_require__(4434);
;// CONCATENATED MODULE: ./src/main/event/AppEvent.ts


class Event extends external_events_.EventEmitter {
    // closeAll() {
    //   this.emit(COMMON_EVENT_NAME.closeAll)
    // }
    // initSetting() {
    //   this.emit(COMMON_EVENT_NAME.initConfig)
    //   // this.configStatus(null)
    // }
    /**
     * 初始化APP
     */
    app_inited() {
        this.emit('app_inited');
    }
    /**
     * 已更新的配置
     * @param keys 已更新配置的key
     * @param setting 已更新配置
     */
    updated_config(keys, setting) {
        this.emit('updated_config', keys, setting);
    }
    /**
     * 更新配置
     * @param setting 新设置
     */
    update_config(setting) {
        const { setting: newSetting, updatedSettingKeys, updatedSetting } = updateSetting(setting);
        global.lx.appSetting = newSetting;
        if (!updatedSettingKeys.length)
            return;
        this.emit('update_config', newSetting);
        // console.log(updatedSetting)
        this.updated_config(updatedSettingKeys, updatedSetting);
    }
    system_theme_change(isDark) {
        this.emit('system_theme_change', isDark);
    }
    theme_change() {
        this.emit('theme_change');
    }
    deeplink(link) {
        this.emit('deeplink', link);
    }
    player_status(status) {
        for (const [key, value] of Object.entries(status)) {
            // @ts-expect-error
            global.lx.player_status[key] = value;
        }
        this.emit('player_status', status);
    }
    hot_key_down(keyInfo) {
        this.emit('hot_key_down', keyInfo);
    }
    hot_key_config_update(config) {
        saveAppHotKeyConfig(config);
        this.emit('hot_key_config_update', config);
    }
    main_window_ready_to_show() {
        this.emit('main_window_ready_to_show');
    }
    main_window_inited() {
        this.emit('main_window_inited');
    }
    main_window_show() {
        this.emit('main_window_show');
    }
    main_window_hide() {
        this.emit('main_window_hide');
    }
    main_window_focus() {
        this.emit('main_window_focus');
    }
    main_window_blur() {
        this.emit('main_window_blur');
    }
    main_window_close() {
        this.emit('main_window_close');
    }
    main_window_fullscreen(isFullscreen) {
        this.emit('main_window_fullscreen', isFullscreen);
    }
}

;// CONCATENATED MODULE: ./src/main/event/ListEvent.ts

// import {
//   // getAllUserList as getAllUserListByDB,
//   createUserLists,
//   removeUserLists,
//   updateUserLists,
//   updateUserListsPosition,
//   musicsAdd,
//   musicsMove,
//   musicsRemove,
//   musicsUpdate,
//   musicsClear,
//   musicsPositionUpdate,
//   musicOverwrite,
// } from '@main/workers/dbService/modules/list'
// 兼容v2.3.0之前版本插入数字类型的ID导致其意外在末尾追加 .0 的问题，确保所有ID都是字符串类型
const fixListIdType = (lists) => {
    for (const list of lists) {
        if (typeof list.sourceListId == 'number') {
            list.sourceListId = String(list.sourceListId);
            if (typeof list.id == 'number') {
                list.id = String(list.id);
            }
        }
    }
};
class ListEvent_Event extends external_events_.EventEmitter {
    list_changed() {
        this.emit('list_changed');
    }
    /**
     * 覆盖整个列表数据
     * @param listData 列表数据
     * @param isRemote 是否属于远程操作
     */
    async list_data_overwrite(listData, isRemote = false) {
        fixListIdType(listData.userList);
        await global.lx.worker.dbService.listDataOverwrite(listData);
        this.emit('list_data_overwrite', listData, isRemote);
        this.list_changed();
    }
    /**
     * 批量创建列表
     * @param position 列表位置
     * @param lists 列表信息
     * @param isRemote 是否属于远程操作
     */
    async list_create(position, lists, isRemote = false) {
        fixListIdType(lists);
        await global.lx.worker.dbService.createUserLists(position, lists);
        this.emit('list_create', position, lists, isRemote);
        this.list_changed();
    }
    /**
     * 批量删除列表及列表内歌曲
     * @param ids 列表ids
     * @param isRemote 是否属于远程操作
     */
    async list_remove(ids, isRemote = false) {
        await global.lx.worker.dbService.removeUserLists(ids);
        this.emit('list_remove', ids, isRemote);
        this.list_changed();
    }
    /**
     * 批量更新列表信息
     * @param lists 列表信息
     * @param isRemote 是否属于远程操作
     */
    async list_update(lists, isRemote = false) {
        await global.lx.worker.dbService.updateUserLists(lists);
        this.emit('list_update', lists, isRemote);
        this.list_changed();
    }
    /**
     * 批量更新列表位置
     * @param position 列表位置
     * @param ids 列表ids
     * @param isRemote 是否属于远程操作
     */
    async list_update_position(position, ids, isRemote = false) {
        await global.lx.worker.dbService.updateUserListsPosition(position, ids);
        this.emit('list_update_position', position, ids, isRemote);
        this.list_changed();
    }
    /**
     * 覆盖列表内歌曲
     * @param listId 列表id
     * @param musicInfos 音乐信息
     * @param isRemote 是否属于远程操作
     */
    async list_music_overwrite(listId, musicInfos, isRemote = false) {
        await global.lx.worker.dbService.musicOverwrite(listId, musicInfos);
        this.emit('list_music_overwrite', listId, musicInfos, isRemote);
        this.list_changed();
    }
    /**
     * 批量添加歌曲到列表
     * @param listId 列表id
     * @param musicInfos 添加的歌曲信息
     * @param addMusicLocationType 添加在到列表的位置
     * @param isRemote 是否属于远程操作
     */
    async list_music_add(listId, musicInfos, addMusicLocationType, isRemote = false) {
        await global.lx.worker.dbService.musicsAdd(listId, musicInfos, addMusicLocationType);
        this.emit('list_music_add', listId, musicInfos, addMusicLocationType, isRemote);
        this.list_changed();
    }
    /**
     * 批量移动歌曲
     * @param fromId 源列表id
     * @param toId 目标列表id
     * @param musicInfos 移动的歌曲信息
     * @param addMusicLocationType 添加在到列表的位置
     * @param isRemote 是否属于远程操作
     */
    async list_music_move(fromId, toId, musicInfos, addMusicLocationType, isRemote = false) {
        await global.lx.worker.dbService.musicsMove(fromId, toId, musicInfos, addMusicLocationType);
        this.emit('list_music_move', fromId, toId, musicInfos, addMusicLocationType, isRemote);
        this.list_changed();
    }
    /**
     * 批量移除歌曲
     * @param listId
     * @param listId 列表Id
     * @param ids 要删除歌曲的id
     * @param isRemote 是否属于远程操作
     */
    async list_music_remove(listId, ids, isRemote = false) {
        await global.lx.worker.dbService.musicsRemove(listId, ids);
        this.emit('list_music_remove', listId, ids, isRemote);
        this.list_changed();
    }
    /**
     * 批量更新歌曲信息
     * @param musicInfos 歌曲&列表信息
     * @param isRemote 是否属于远程操作
     */
    async list_music_update(musicInfos, isRemote = false) {
        await global.lx.worker.dbService.musicsUpdate(musicInfos);
        this.emit('list_music_update', musicInfos, isRemote);
        this.list_changed();
    }
    /**
     * 清空列表内的歌曲
     * @param ids 列表Id
     * @param isRemote 是否属于远程操作
     */
    async list_music_clear(ids, isRemote = false) {
        await global.lx.worker.dbService.musicsClear(ids);
        this.emit('list_music_clear', ids, isRemote);
        this.list_changed();
    }
    /**
     * 批量更新歌曲位置
     * @param listId 列表ID
     * @param position 新位置
     * @param ids 歌曲id
     * @param isRemote 是否属于远程操作
     */
    async list_music_update_position(listId, position, ids, isRemote = false) {
        await global.lx.worker.dbService.musicsPositionUpdate(listId, position, ids);
        this.emit('list_music_update_position', listId, position, ids, isRemote);
        this.list_changed();
    }
}

;// CONCATENATED MODULE: ./src/main/event/DislikeEvent.ts

class DislikeEvent_Event extends external_events_.EventEmitter {
    dislike_changed() {
        this.emit('dislike_changed');
    }
    /**
     * 覆盖整个列表数据
     * @param dislikeData 列表数据
     * @param isRemote 是否属于远程操作
     */
    async dislike_data_overwrite(dislikeData, isRemote = false) {
        await global.lx.worker.dbService.dislikeInfoOverwrite(dislikeData);
        this.emit('dislike_data_overwrite', dislikeData, isRemote);
        this.dislike_changed();
    }
    /**
     * 批量添加歌曲到列表
     * @param dislikeId 列表id
     * @param musicInfos 添加的歌曲信息
     * @param addMusicLocationType 添加在到列表的位置
     * @param isRemote 是否属于远程操作
     */
    async dislike_music_add(musicInfo, isRemote = false) {
        // const changedIds =
        await global.lx.worker.dbService.dislikeInfoAdd(musicInfo);
        // await checkUpdateDislike(changedIds)
        this.emit('dislike_music_add', musicInfo, isRemote);
        this.dislike_changed();
    }
    /**
     * 清空列表内的歌曲
     * @param ids 列表Id
     * @param isRemote 是否属于远程操作
     */
    async dislike_music_clear(isRemote = false) {
        // const changedIds =
        await global.lx.worker.dbService.dislikeInfoOverwrite('');
        // await checkUpdateDislike(changedIds)
        this.emit('dislike_music_clear', isRemote);
        this.dislike_changed();
    }
}

;// CONCATENATED MODULE: ./src/main/event/index.ts



const createAppEvent = () => {
    return new Event();
};
const createListEvent = () => {
    return new ListEvent_Event();
};
const createDislikeEvent = () => {
    return new DislikeEvent_Event();
};

;// CONCATENATED MODULE: external "node:worker_threads"
const external_node_worker_threads_namespaceObject = require("node:worker_threads");
;// CONCATENATED MODULE: ./node_modules/comlink/dist/esm/comlink.mjs
/**
 * Copyright 2019 Google Inc. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *     http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const proxyMarker = Symbol("Comlink.proxy");
const createEndpoint = Symbol("Comlink.endpoint");
const releaseProxy = Symbol("Comlink.releaseProxy");
const throwMarker = Symbol("Comlink.thrown");
const isObject = (val) => (typeof val === "object" && val !== null) || typeof val === "function";
/**
 * Internal transfer handle to handle objects marked to proxy.
 */
const proxyTransferHandler = {
    canHandle: (val) => isObject(val) && val[proxyMarker],
    serialize(obj) {
        const { port1, port2 } = new MessageChannel();
        expose(obj, port1);
        return [port2, [port2]];
    },
    deserialize(port) {
        port.start();
        return wrap(port);
    },
};
/**
 * Internal transfer handler to handle thrown exceptions.
 */
const throwTransferHandler = {
    canHandle: (value) => isObject(value) && throwMarker in value,
    serialize({ value }) {
        let serialized;
        if (value instanceof Error) {
            serialized = {
                isError: true,
                value: {
                    message: value.message,
                    name: value.name,
                    stack: value.stack,
                },
            };
        }
        else {
            serialized = { isError: false, value };
        }
        return [serialized, []];
    },
    deserialize(serialized) {
        if (serialized.isError) {
            throw Object.assign(new Error(serialized.value.message), serialized.value);
        }
        throw serialized.value;
    },
};
/**
 * Allows customizing the serialization of certain values.
 */
const transferHandlers = new Map([
    ["proxy", proxyTransferHandler],
    ["throw", throwTransferHandler],
]);
function expose(obj, ep = self) {
    ep.addEventListener("message", function callback(ev) {
        if (!ev || !ev.data) {
            return;
        }
        const { id, type, path } = Object.assign({ path: [] }, ev.data);
        const argumentList = (ev.data.argumentList || []).map(fromWireValue);
        let returnValue;
        try {
            const parent = path.slice(0, -1).reduce((obj, prop) => obj[prop], obj);
            const rawValue = path.reduce((obj, prop) => obj[prop], obj);
            switch (type) {
                case "GET" /* GET */:
                    {
                        returnValue = rawValue;
                    }
                    break;
                case "SET" /* SET */:
                    {
                        parent[path.slice(-1)[0]] = fromWireValue(ev.data.value);
                        returnValue = true;
                    }
                    break;
                case "APPLY" /* APPLY */:
                    {
                        returnValue = rawValue.apply(parent, argumentList);
                    }
                    break;
                case "CONSTRUCT" /* CONSTRUCT */:
                    {
                        const value = new rawValue(...argumentList);
                        returnValue = proxy(value);
                    }
                    break;
                case "ENDPOINT" /* ENDPOINT */:
                    {
                        const { port1, port2 } = new MessageChannel();
                        expose(obj, port2);
                        returnValue = transfer(port1, [port1]);
                    }
                    break;
                case "RELEASE" /* RELEASE */:
                    {
                        returnValue = undefined;
                    }
                    break;
                default:
                    return;
            }
        }
        catch (value) {
            returnValue = { value, [throwMarker]: 0 };
        }
        Promise.resolve(returnValue)
            .catch((value) => {
            return { value, [throwMarker]: 0 };
        })
            .then((returnValue) => {
            const [wireValue, transferables] = toWireValue(returnValue);
            ep.postMessage(Object.assign(Object.assign({}, wireValue), { id }), transferables);
            if (type === "RELEASE" /* RELEASE */) {
                // detach and deactive after sending release response above.
                ep.removeEventListener("message", callback);
                closeEndPoint(ep);
            }
        });
    });
    if (ep.start) {
        ep.start();
    }
}
function isMessagePort(endpoint) {
    return endpoint.constructor.name === "MessagePort";
}
function closeEndPoint(endpoint) {
    if (isMessagePort(endpoint))
        endpoint.close();
}
function wrap(ep, target) {
    return createProxy(ep, [], target);
}
function throwIfProxyReleased(isReleased) {
    if (isReleased) {
        throw new Error("Proxy has been released and is not useable");
    }
}
function createProxy(ep, path = [], target = function () { }) {
    let isProxyReleased = false;
    const proxy = new Proxy(target, {
        get(_target, prop) {
            throwIfProxyReleased(isProxyReleased);
            if (prop === releaseProxy) {
                return () => {
                    return requestResponseMessage(ep, {
                        type: "RELEASE" /* RELEASE */,
                        path: path.map((p) => p.toString()),
                    }).then(() => {
                        closeEndPoint(ep);
                        isProxyReleased = true;
                    });
                };
            }
            if (prop === "then") {
                if (path.length === 0) {
                    return { then: () => proxy };
                }
                const r = requestResponseMessage(ep, {
                    type: "GET" /* GET */,
                    path: path.map((p) => p.toString()),
                }).then(fromWireValue);
                return r.then.bind(r);
            }
            return createProxy(ep, [...path, prop]);
        },
        set(_target, prop, rawValue) {
            throwIfProxyReleased(isProxyReleased);
            // FIXME: ES6 Proxy Handler `set` methods are supposed to return a
            // boolean. To show good will, we return true asynchronously ¯\_(ツ)_/¯
            const [value, transferables] = toWireValue(rawValue);
            return requestResponseMessage(ep, {
                type: "SET" /* SET */,
                path: [...path, prop].map((p) => p.toString()),
                value,
            }, transferables).then(fromWireValue);
        },
        apply(_target, _thisArg, rawArgumentList) {
            throwIfProxyReleased(isProxyReleased);
            const last = path[path.length - 1];
            if (last === createEndpoint) {
                return requestResponseMessage(ep, {
                    type: "ENDPOINT" /* ENDPOINT */,
                }).then(fromWireValue);
            }
            // We just pretend that `bind()` didn’t happen.
            if (last === "bind") {
                return createProxy(ep, path.slice(0, -1));
            }
            const [argumentList, transferables] = processArguments(rawArgumentList);
            return requestResponseMessage(ep, {
                type: "APPLY" /* APPLY */,
                path: path.map((p) => p.toString()),
                argumentList,
            }, transferables).then(fromWireValue);
        },
        construct(_target, rawArgumentList) {
            throwIfProxyReleased(isProxyReleased);
            const [argumentList, transferables] = processArguments(rawArgumentList);
            return requestResponseMessage(ep, {
                type: "CONSTRUCT" /* CONSTRUCT */,
                path: path.map((p) => p.toString()),
                argumentList,
            }, transferables).then(fromWireValue);
        },
    });
    return proxy;
}
function myFlat(arr) {
    return Array.prototype.concat.apply([], arr);
}
function processArguments(argumentList) {
    const processed = argumentList.map(toWireValue);
    return [processed.map((v) => v[0]), myFlat(processed.map((v) => v[1]))];
}
const transferCache = new WeakMap();
function transfer(obj, transfers) {
    transferCache.set(obj, transfers);
    return obj;
}
function proxy(obj) {
    return Object.assign(obj, { [proxyMarker]: true });
}
function windowEndpoint(w, context = self, targetOrigin = "*") {
    return {
        postMessage: (msg, transferables) => w.postMessage(msg, targetOrigin, transferables),
        addEventListener: context.addEventListener.bind(context),
        removeEventListener: context.removeEventListener.bind(context),
    };
}
function toWireValue(value) {
    for (const [name, handler] of transferHandlers) {
        if (handler.canHandle(value)) {
            const [serializedValue, transferables] = handler.serialize(value);
            return [
                {
                    type: "HANDLER" /* HANDLER */,
                    name,
                    value: serializedValue,
                },
                transferables,
            ];
        }
    }
    return [
        {
            type: "RAW" /* RAW */,
            value,
        },
        transferCache.get(value) || [],
    ];
}
function fromWireValue(value) {
    switch (value.type) {
        case "HANDLER" /* HANDLER */:
            return transferHandlers.get(value.name).deserialize(value.value);
        case "RAW" /* RAW */:
            return value.value;
    }
}
function requestResponseMessage(ep, msg, transfers) {
    return new Promise((resolve) => {
        const id = generateUUID();
        ep.addEventListener("message", function l(ev) {
            if (!ev.data || !ev.data.id || ev.data.id !== id) {
                return;
            }
            ep.removeEventListener("message", l);
            resolve(ev.data);
        });
        if (ep.start) {
            ep.start();
        }
        ep.postMessage(Object.assign({ id }, msg), transfers);
    });
}
function generateUUID() {
    return new Array(4)
        .fill(0)
        .map(() => Math.floor(Math.random() * Number.MAX_SAFE_INTEGER).toString(16))
        .join("-");
}


//# sourceMappingURL=comlink.mjs.map

;// CONCATENATED MODULE: ./node_modules/comlink/dist/esm/node-adapter.mjs
/**
 * Copyright 2019 Google Inc. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *     http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function nodeEndpoint(nep) {
    const listeners = new WeakMap();
    return {
        postMessage: nep.postMessage.bind(nep),
        addEventListener: (_, eh) => {
            const l = (data) => {
                if ("handleEvent" in eh) {
                    eh.handleEvent({ data });
                }
                else {
                    eh({ data });
                }
            };
            nep.on("message", l);
            listeners.set(eh, l);
        },
        removeEventListener: (_, eh) => {
            const l = listeners.get(eh);
            if (!l) {
                return;
            }
            nep.off("message", l);
            listeners.delete(eh);
        },
        start: nep.start && nep.start.bind(nep),
    };
}

/* harmony default export */ const node_adapter = (nodeEndpoint);
//# sourceMappingURL=node-adapter.mjs.map

;// CONCATENATED MODULE: ./src/main/worker/utils/index.ts



const createDBServiceWorker = () => {
    const worker = new external_node_worker_threads_namespaceObject.Worker(new URL(
    /* webpackChunkName: 'dbService.worker' */
    /* worker import */ __webpack_require__.p + __webpack_require__.u(650), __webpack_require__.b));
    return wrap(node_adapter(worker));
};

;// CONCATENATED MODULE: ./src/main/worker/index.ts

/* harmony default export */ const worker = (() => {
    return {
        dbService: createDBServiceWorker(),
    };
});

;// CONCATENATED MODULE: ./src/main/app.ts













const initGlobalData = () => {
    const envParams = parseEnvParams();
    global.envParams = {
        cmdParams: envParams.cmdParams,
        deeplink: envParams.deeplink,
    };
    global.staticPath =
         false
            ? 0
            : external_node_path_default().join(electron_encodePath(__dirname), 'static');
};
const initSingleInstanceHandle = () => {
    // 单例应用程序
    if (!external_electron_.app.requestSingleInstanceLock()) {
        external_electron_.app.quit();
        process.exit(0);
    }
    external_electron_.app.on('second-instance', (event, argv, cwd) => {
        for (const param of argv) {
            if (URL_SCHEME_RXP.test(param)) {
                global.envParams.deeplink = param;
                break;
            }
        }
        if (isExistWindow()) {
            if (global.envParams.deeplink)
                global.lx.event_app.deeplink(global.envParams.deeplink);
            else
                showWindow();
        }
        else {
            external_electron_.app.quit();
        }
    });
};
const applyElectronEnvParams = () => {
    // Is disable hardware acceleration
    if (global.envParams.cmdParams.dha)
        external_electron_.app.disableHardwareAcceleration();
    if (global.envParams.cmdParams.dhmkh)
        external_electron_.app.commandLine.appendSwitch('disable-features', 'HardwareMediaKeyHandling');
    // fix linux transparent fail. https://github.com/electron/electron/issues/25153#issuecomment-843688494
    if (process.platform == 'linux')
        external_electron_.app.commandLine.appendSwitch('use-gl', 'desktop');
    // https://github.com/electron/electron/issues/22691
    external_electron_.app.commandLine.appendSwitch('wm-window-animations-disabled');
    external_electron_.app.commandLine.appendSwitch('--disable-gpu-sandbox');
    // proxy
    if (global.envParams.cmdParams['proxy-server']) {
        external_electron_.app.commandLine.appendSwitch('proxy-server', global.envParams.cmdParams['proxy-server']);
        external_electron_.app.commandLine.appendSwitch('proxy-bypass-list', global.envParams.cmdParams['proxy-bypass-list'] ?? '<local>');
    }
};
const setUserDataPath = () => {
    // windows平台下如果应用目录下存在 portable 文件夹则将数据存在此文件下
    if (process.platform == 'win32') {
        const portablePath = external_node_path_default().join(external_node_path_default().dirname(external_electron_.app.getPath('exe')), '/portable');
        if ((0,external_fs_.existsSync)(portablePath)) {
            external_electron_.app.setPath('appData', portablePath);
            const appDataPath = external_node_path_default().join(portablePath, '/userData');
            if (!(0,external_fs_.existsSync)(appDataPath))
                (0,external_fs_.mkdirSync)(appDataPath);
            external_electron_.app.setPath('userData', appDataPath);
        }
    }
    const userDataPath = external_electron_.app.getPath('userData');
    global.lxOldDataPath = userDataPath;
    global.lxDataPath = external_node_path_default().join(userDataPath, 'LxDatas');
    if (!(0,external_fs_.existsSync)(global.lxDataPath))
        (0,external_fs_.mkdirSync)(global.lxDataPath);
};
const registerDeeplink = (startApp) => {
    if (false) {}
    else {
        external_electron_.app.setAsDefaultProtocolClient('lxmusic');
    }
    // deep link
    external_electron_.app.on('open-url', (event, url) => {
        if (!URL_SCHEME_RXP.test(url))
            return;
        event.preventDefault();
        global.envParams.deeplink = url;
        if (isExistWindow()) {
            if (global.envParams.deeplink)
                global.lx.event_app.deeplink(global.envParams.deeplink);
            else
                showWindow();
        }
        else {
            startApp();
        }
    });
};
const listenerAppEvent = (startApp) => {
    external_electron_.app.on('web-contents-created', (event, contents) => {
        contents.on('will-navigate', (event, navigationUrl) => {
            if (false) {}
            if (!navigationUrlWhiteList.some(url => url.test(navigationUrl))) {
                event.preventDefault();
                return;
            }
            console.log('navigation to url:', navigationUrl);
        });
        contents.setWindowOpenHandler(({ url }) => {
            if (!/^devtools/.test(url) && /^https?:\/\//.test(url)) {
                void external_electron_.shell.openExternal(url);
            }
            console.log(url);
            return { action: 'deny' };
        });
        contents.on('will-attach-webview', (event, webPreferences, params) => {
            // Strip away preload scripts if unused or verify their location is legitimate
            delete webPreferences.preload;
            // delete webPreferences.preloadURL
            // Disable Node.js integration
            webPreferences.nodeIntegration = false;
            // Verify URL being loaded
            if (!navigationUrlWhiteList.some(url => url.test(params.src))) {
                event.preventDefault();
            }
        });
        // disable create dictionary
        // https://github.com/lyswhut/lx-music-desktop/issues/773
        contents.session.setSpellCheckerDictionaryDownloadURL('http://0.0.0.0');
    });
    external_electron_.app.on('activate', () => {
        if (isExistWindow()) {
            showWindow();
        }
        else {
            startApp();
        }
    });
    external_electron_.app.on('window-all-closed', () => {
        if (isMac)
            return;
        external_electron_.app.quit();
    });
    const initScreenParams = () => {
        global.envParams.workAreaSize = external_electron_.screen.getPrimaryDisplay().workAreaSize;
    };
    external_electron_.app.on('ready', () => {
        external_electron_.screen.on('display-metrics-changed', initScreenParams);
        initScreenParams();
    });
    external_electron_.nativeTheme.addListener('updated', () => {
        const shouldUseDarkColors = external_electron_.nativeTheme.shouldUseDarkColors;
        if (shouldUseDarkColors == global.lx.theme.shouldUseDarkColors)
            return;
        global.lx.theme.shouldUseDarkColors = shouldUseDarkColors;
        global.lx?.event_app.system_theme_change(shouldUseDarkColors);
    });
};
const initTheme = () => {
    global.lx.theme = getTheme();
    const themeConfigKeys = ['theme.id', 'theme.lightId', 'theme.darkId'];
    global.lx.event_app.on('updated_config', (keys) => {
        let requireUpdate = false;
        for (const key of keys) {
            if (themeConfigKeys.includes(key)) {
                requireUpdate = true;
                break;
            }
        }
        if (requireUpdate) {
            global.lx.theme = getTheme();
            global.lx.event_app.theme_change();
        }
    });
    global.lx.event_app.on('system_theme_change', () => {
        if (global.lx.appSetting['theme.id'] == 'auto') {
            global.lx.theme = getTheme();
            global.lx.event_app.theme_change();
        }
    });
};
let app_isInitialized = false;
const initAppSetting = async () => {
    if (!global.lx) {
        const config = await initHotKey();
        global.lx = {
            isTrafficLightClose: false,
            isSkipTrayQuit: false,
            // mainWindowClosed: true,
            event_app: createAppEvent(),
            event_list: createListEvent(),
            event_dislike: createDislikeEvent(),
            appSetting: common_defaultSetting,
            worker: worker(),
            hotKey: {
                enable: true,
                config: {
                    local: config.local,
                    global: config.global,
                },
                state: new Map(),
            },
            theme: {
                shouldUseDarkColors: external_electron_.nativeTheme.shouldUseDarkColors,
                theme: {
                    id: '',
                    name: '',
                    isDark: false,
                    colors: {},
                },
            },
            player_status: {
                status: 'stoped',
                name: '',
                singer: '',
                albumName: '',
                picUrl: '',
                progress: 0,
                duration: 0,
                playbackRate: 1,
                lyricLineText: '',
                lyricLineAllText: '',
                lyric: '',
                collect: false,
            },
        };
    }
    if (!app_isInitialized) {
        let dbFileExists = await global.lx.worker.dbService.init(global.lxDataPath);
        if (dbFileExists === null) {
            const backPath = external_node_path_default().join(global.lxDataPath, `lx.data.db.${Date.now()}.bak`);
            external_electron_.dialog.showMessageBoxSync({
                type: 'warning',
                message: 'Database verify failed',
                detail: `数据库表结构校验失败，我们将把有问题的数据库备份到：${backPath}\n若此问题导致你的数据丢失，你可以尝试从备份文件找回它们。\n\nThe database table structure verification failed, we will back up the problematic database to: ${backPath}\nIf this problem causes your data to be lost, you can try to retrieve them from the backup file.`,
            });
            (0,external_fs_.renameSync)(external_node_path_default().join(global.lxDataPath, 'lx.data.db'), backPath);
            openDirInExplorer(backPath);
            dbFileExists = await global.lx.worker.dbService.init(global.lxDataPath);
        }
        global.lx.appSetting = (await initSetting()).setting;
        if (!dbFileExists)
            await migrateDBData().catch(err => { node_default().error(err); });
        initTheme();
    }
    // global.lx.theme = getTheme()
    app_isInitialized ||= true;
};
const quitApp = () => {
    global.lx.isSkipTrayQuit = true;
    closeWindow();
};

;// CONCATENATED MODULE: ./src/main/modules/hotKey/utils.ts


const utils_handleKeyDown = (key) => {
    if (!global.lx.hotKey.enable)
        return;
    global.lx.event_app.hot_key_down({ type: 'global', key });
};
const transformedKeyRxp = /(^|\+)[a-z]/g;
const transformedKey = (key) => {
    if (key.includes('arrow'))
        key = key.replace(/arrow/g, '');
    return key.replace('mod', 'CommandOrControl').replace(transformedKeyRxp, l => l.toUpperCase());
};
const registerHotkey = ({ key, info }) => {
    let targetKey = global.lx.hotKey.state.get(key);
    if (targetKey?.status)
        return true;
    const transKey = transformedKey(key);
    // console.log('Register key:', transKey)
    if (targetKey) {
        targetKey.info = info;
    }
    else {
        targetKey = {
            status: false,
            info,
        };
        global.lx.hotKey.state.set(key, targetKey);
    }
    const status = targetKey.status = external_electron_.globalShortcut.isRegistered(transKey)
        ? false
        : external_electron_.globalShortcut.register(transKey, () => {
            utils_handleKeyDown(key);
        });
    return status;
};
const unRegisterHotkey = (key) => {
    let transKey = transformedKey(key);
    // console.log('Unregister key:', transKey)
    external_electron_.globalShortcut.unregister(transKey);
    global.lx.hotKey.state.delete(key);
};
const unRegisterHotkeyAll = () => {
    global.lx.hotKey.state.clear();
    external_electron_.globalShortcut.unregisterAll();
};
const handleRegisterHotkey = (data) => {
    let ret = registerHotkey(data);
    if (!ret)
        node_default().info('Register hot key failed:', data.key);
};
const utils_init = (isForce = false) => {
    unRegisterHotkeyAll();
    if (!isForce && !global.lx.hotKey.config.global.enable)
        return;
    // global.lx.hotKey.state = {}
    // console.log(global.lx.hotKey.config.global.keys)
    for (const key of Object.keys(global.lx.hotKey.config.global.keys)) {
        try {
            handleRegisterHotkey({ key, info: global.lx.hotKey.config.global.keys[key] });
        }
        catch (err) {
            node_default().info(err);
        }
    }
};

;// CONCATENATED MODULE: ./src/main/modules/hotKey/rendererEvent.ts



/* harmony default export */ const hotKey_rendererEvent = (() => {
    mainHandle(HOTKEY_RENDERER_EVENT_NAME.set_config, async ({ params }) => {
        switch (params.action) {
            case 'config':
                // global.lx.event_app.saveConfig(data, source)
                global.lx.event_app.hot_key_config_update(params.data);
                return true;
            case 'enable':
                global.lx.hotKey.enable = params.data;
                params.data ? utils_init(true) : unRegisterHotkeyAll();
                return true;
            case 'register':
                return registerHotkey(params.data);
            case 'unregister':
                unRegisterHotkey(params.data);
                return true;
        }
    });
    mainHandle(HOTKEY_RENDERER_EVENT_NAME.status, async () => global.lx.hotKey.state);
    mainHandle(HOTKEY_RENDERER_EVENT_NAME.enable, async ({ params: flag }) => {
        flag ? utils_init() : unRegisterHotkeyAll();
    });
    utils_init();
});

;// CONCATENATED MODULE: ./src/main/modules/hotKey/index.ts



/* harmony default export */ const modules_hotKey = (() => {
    external_electron_.app.on('will-quit', unRegisterHotkeyAll);
    hotKey_rendererEvent();
});

;// CONCATENATED MODULE: ./src/main/modules/tray.ts





let tray;
let isEnableTray = false;
let themeId;
const playerState = {
    empty: false,
    collect: false,
    play: false,
    next: true,
    prev: true,
};
const watchConfigKeys = [
    'desktopLyric.enable',
    'desktopLyric.isLock',
    'desktopLyric.isAlwaysOnTop',
    'tray.themeId',
    'tray.enable',
    'common.langId',
];
const themeList = [
    {
        id: 0,
        fileName: 'trayTemplate',
        isNative: true,
    },
    {
        id: 1,
        fileName: 'tray_origin',
        isNative: false,
    },
    {
        id: 2,
        fileName: 'tray_black',
        isNative: false,
    },
];
const messages = {
    'en-us': {
        collect: 'Collection',
        uncollect: 'Cancel collection',
        play: 'Play',
        pause: 'Pause',
        next: 'Next song',
        prev: 'Previous song',
        hide_win_main: 'Hide Main Window',
        show_win_main: 'Show Main Window',
        hide_win_lyric: 'Close desktop lyrics',
        show_win_lyric: 'Open desktop lyrics',
        lock_win_lyric: 'Lock desktop lyrics',
        unlock_win_lyric: 'Unlock desktop lyrics',
        top_win_lyric: 'Set top lyrics',
        untop_win_lyric: 'Cancel top lyrics',
        exit: 'Exit',
    },
    'zh-cn': {
        collect: '收藏',
        uncollect: '取消收藏',
        play: '播放',
        pause: '暂停',
        next: '下一曲',
        prev: '上一曲',
        hide_win_main: '隐藏主界面',
        show_win_main: '显示主界面',
        hide_win_lyric: '关闭桌面歌词',
        show_win_lyric: '开启桌面歌词',
        lock_win_lyric: '锁定桌面歌词',
        unlock_win_lyric: '解锁桌面歌词',
        top_win_lyric: '置顶歌词',
        untop_win_lyric: '取消置顶',
        exit: '退出',
    },
    'zh-tw': {
        collect: '收藏',
        uncollect: '取消收藏',
        play: '播放',
        pause: '暫停',
        next: '下一曲',
        prev: '上一曲',
        hide_win_main: '隱藏主界面',
        show_win_main: '顯示主界面',
        hide_win_lyric: '關閉桌面歌詞',
        show_win_lyric: '開啟桌面歌詞',
        lock_win_lyric: '鎖定桌面歌詞',
        unlock_win_lyric: '解鎖桌面歌詞',
        top_win_lyric: '置頂歌詞',
        untop_win_lyric: '取消置頂',
        exit: '退出',
    },
};
const i18n = {
    message: messages['zh-cn'],
    fallbackLocale: 'en-us',
    getMessage(key) {
        return this.message[key];
    },
    setLang(lang) {
        this.message = lang
            ? messages[lang] ?? messages[this.fallbackLocale]
            : messages[this.fallbackLocale];
    },
};
const tray_getIconPath = (id) => {
    let theme = themeList.find(item => item.id === id) ?? themeList[0];
    return external_node_path_default().join(global.staticPath, 'images/tray', theme.fileName + (isWin ? '.ico' : '.png'));
};
const createTray = () => {
    // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
    if ((tray && !tray.isDestroyed()) || !global.lx.appSetting['tray.enable'])
        return;
    // 托盘
    tray = new external_electron_.Tray(external_electron_.nativeImage.createFromPath(tray_getIconPath(global.lx.appSetting['tray.themeId'])));
    tray.setToolTip('LX Music');
    createMenu();
    tray.setIgnoreDoubleClickEvents(true);
    tray.on('click', () => {
        showWindow();
    });
};
const destroyTray = () => {
    if (!tray)
        return;
    tray.destroy();
    isEnableTray = false;
    tray = null;
};
const handleUpdateConfig = (config) => {
    global.lx.event_app.update_config(config);
};
const createPlayerMenu = () => {
    let menu = [];
    menu.push(playerState.play ? {
        label: i18n.getMessage('pause'),
        click() {
            sendTaskbarButtonClick('pause');
        },
    } : {
        label: i18n.getMessage('play'),
        click() {
            sendTaskbarButtonClick('play');
        },
    });
    menu.push({
        label: i18n.getMessage('prev'),
        click() {
            sendTaskbarButtonClick('prev');
        },
    });
    menu.push({
        label: i18n.getMessage('next'),
        click() {
            sendTaskbarButtonClick('next');
        },
    });
    menu.push(playerState.collect ? {
        label: i18n.getMessage('uncollect'),
        click() {
            sendTaskbarButtonClick('unCollect');
        },
    } : {
        label: i18n.getMessage('collect'),
        click() {
            sendTaskbarButtonClick('collect');
        },
    });
    return menu;
};
const createMenu = () => {
    if (!tray)
        return;
    let menu = createPlayerMenu();
    if (playerState.empty)
        for (const m of menu)
            m.enabled = false;
    menu.push({ type: 'separator' });
    menu.push(global.lx.appSetting['desktopLyric.enable']
        ? {
            label: i18n.getMessage('hide_win_lyric'),
            click() {
                handleUpdateConfig({ 'desktopLyric.enable': false });
            },
        }
        : {
            label: i18n.getMessage('show_win_lyric'),
            click() {
                handleUpdateConfig({ 'desktopLyric.enable': true });
            },
        });
    menu.push(global.lx.appSetting['desktopLyric.isLock']
        ? {
            label: i18n.getMessage('unlock_win_lyric'),
            click() {
                handleUpdateConfig({ 'desktopLyric.isLock': false });
            },
        }
        : {
            label: i18n.getMessage('lock_win_lyric'),
            click() {
                handleUpdateConfig({ 'desktopLyric.isLock': true });
            },
        });
    menu.push(global.lx.appSetting['desktopLyric.isAlwaysOnTop']
        ? {
            label: i18n.getMessage('untop_win_lyric'),
            click() {
                handleUpdateConfig({ 'desktopLyric.isAlwaysOnTop': false });
            },
        }
        : {
            label: i18n.getMessage('top_win_lyric'),
            click() {
                handleUpdateConfig({ 'desktopLyric.isAlwaysOnTop': true });
            },
        });
    menu.push({ type: 'separator' });
    if (isExistWindow()) {
        const isShow = isShowWindow();
        menu.push(isShow
            ? {
                label: i18n.getMessage('hide_win_main'),
                click() {
                    hideWindow();
                },
            }
            : {
                label: i18n.getMessage('show_win_main'),
                click() {
                    showWindow();
                },
            });
    }
    menu.push({
        label: i18n.getMessage('exit'),
        click() {
            quitApp();
        },
    });
    const contextMenu = external_electron_.Menu.buildFromTemplate(menu);
    tray.setContextMenu(contextMenu);
};
const setTrayImage = (themeId) => {
    if (!tray)
        return;
    tray.setImage(external_electron_.nativeImage.createFromPath(tray_getIconPath(themeId)));
};
const tray_init = () => {
    if (themeId != global.lx.appSetting['tray.themeId']) {
        themeId = global.lx.appSetting['tray.themeId'];
        setTrayImage(themeId);
    }
    if (isEnableTray !== global.lx.appSetting['tray.enable']) {
        isEnableTray = global.lx.appSetting['tray.enable'];
        global.lx.appSetting['tray.enable'] ? createTray() : destroyTray();
    }
    createMenu();
};
/* harmony default export */ const modules_tray = (() => {
    global.lx.event_app.on('updated_config', (keys, setting) => {
        if (!watchConfigKeys.some(key => keys.includes(key)))
            return;
        if (keys.includes('common.langId'))
            i18n.setLang(setting['common.langId']);
        tray_init();
    });
    global.lx.event_app.on('main_window_ready_to_show', () => {
        createMenu();
    });
    global.lx.event_app.on('main_window_show', () => {
        createMenu();
    });
    if (!isWin) {
        global.lx.event_app.on('main_window_focus', () => {
            createMenu();
        });
        global.lx.event_app.on('main_window_blur', () => {
            createMenu();
        });
    }
    global.lx.event_app.on('main_window_hide', () => {
        createMenu();
    });
    global.lx.event_app.on('main_window_close', () => {
        destroyTray();
    });
    global.lx.event_app.on('app_inited', () => {
        i18n.setLang(global.lx.appSetting['common.langId']);
        tray_init();
    });
    global.lx.event_app.on('player_status', (status) => {
        let updated = false;
        if (status.status) {
            switch (status.status) {
                case 'paused':
                    playerState.play = false;
                    playerState.empty &&= false;
                    break;
                case 'error':
                    playerState.play = false;
                    playerState.empty &&= false;
                    break;
                case 'playing':
                    playerState.play = true;
                    playerState.empty &&= false;
                    break;
                case 'stoped':
                    playerState.play &&= false;
                    playerState.empty = true;
                    break;
            }
            updated = true;
        }
        if (status.collect != null) {
            playerState.collect = status.collect;
            updated = true;
        }
        if (updated)
            tray_init();
    });
});

;// CONCATENATED MODULE: ./src/main/modules/appMenu.ts


/* harmony default export */ const appMenu = (() => {
    if (isMac) {
        const template = [
            {
                label: external_electron_.app.getName(),
                submenu: [
                    { label: '关于洛雪音乐', role: 'about' },
                    { type: 'separator' },
                    { label: '隐藏', role: 'hide' },
                    { type: 'separator' },
                    {
                        label: '退出',
                        accelerator: 'Command+Q',
                        click() {
                            global.lx.isSkipTrayQuit = true;
                            external_electron_.app.quit();
                        },
                    },
                ],
            },
            {
                label: '窗口',
                role: 'window',
                submenu: [
                    { label: '最小化', role: 'minimize' },
                    { label: '关闭', role: 'close', accelerator: 'Command+W' },
                ],
            },
            {
                label: '编辑',
                submenu: [
                    { label: '撤销', accelerator: 'Command+Z', role: 'undo' },
                    { label: '恢复', accelerator: 'Shift+Command+Z', role: 'redo' },
                    { type: 'separator' },
                    { label: '剪切', accelerator: 'Command+X', role: 'cut' },
                    { label: '复制', accelerator: 'Command+C', role: 'copy' },
                    { label: '粘贴', accelerator: 'Command+V', role: 'paste' },
                    { label: '选择全部', accelerator: 'Command+A', role: 'selectAll' },
                ],
            },
        ];
        external_electron_.Menu.setApplicationMenu(external_electron_.Menu.buildFromTemplate(template));
    }
    else {
        external_electron_.Menu.setApplicationMenu(null);
    }
});

;// CONCATENATED MODULE: ./src/main/modules/winLyric/utils.ts
// 设置窗口位置、大小
let minWidth = 80;
let minHeight = 50;
// const updateBounds = (bounds: Bounds) => {
//   bounds.x = bounds.x
//   return bounds
// }
/**
 *
 * @param bounds 当前设置
 * @param param 新设置（相对于当前设置）
 * @returns
 */
const getLyricWindowBounds = (bounds, { x = 0, y = 0, w = 0, h = 0 }) => {
    if (w < minWidth)
        w = minWidth;
    if (h < minHeight)
        h = minHeight;
    if (global.lx.appSetting['desktopLyric.isLockScreen']) {
        if (!global.envParams.workAreaSize)
            return bounds;
        const maxWinW = global.envParams.workAreaSize.width;
        const maxWinH = global.envParams.workAreaSize.height;
        if (w > maxWinW)
            w = maxWinW;
        if (h > maxWinH)
            h = maxWinH;
        const maxX = global.envParams.workAreaSize.width - w;
        const maxY = global.envParams.workAreaSize.height - h;
        x += bounds.x;
        y += bounds.y;
        if (x > maxX)
            x = maxX;
        else if (x < 0)
            x = 0;
        if (y > maxY)
            y = maxY;
        else if (y < 0)
            y = 0;
    }
    else {
        y += bounds.y;
        x += bounds.x;
    }
    // console.log('util bounds', bounds)
    return { width: w, height: h, x, y };
};
const utils_watchConfigKeys = [
    'desktopLyric.enable',
    'desktopLyric.isLock',
    'desktopLyric.isAlwaysOnTop',
    'desktopLyric.isAlwaysOnTopLoop',
    'desktopLyric.isShowTaskbar',
    'desktopLyric.audioVisualization',
    'desktopLyric.width',
    'desktopLyric.height',
    'desktopLyric.x',
    'desktopLyric.y',
    'desktopLyric.isLockScreen',
    'desktopLyric.isDelayScroll',
    'desktopLyric.scrollAlign',
    'desktopLyric.isHoverHide',
    'desktopLyric.direction',
    'desktopLyric.style.align',
    'desktopLyric.style.lyricUnplayColor',
    'desktopLyric.style.lyricPlayedColor',
    'desktopLyric.style.lyricShadowColor',
    'desktopLyric.style.font',
    'desktopLyric.style.fontSize',
    'desktopLyric.style.lineGap',
    // 'desktopLyric.style.fontWeight',
    'desktopLyric.style.opacity',
    'desktopLyric.style.ellipsis',
    'desktopLyric.style.isFontWeightFont',
    'desktopLyric.style.isFontWeightLine',
    'desktopLyric.style.isFontWeightExtended',
    'desktopLyric.style.isZoomActiveLrc',
    'common.langId',
    'player.isShowLyricTranslation',
    'player.isShowLyricRoma',
    'player.isPlayLxlrc',
    'player.playbackRate',
];
const buildLyricConfig = (appSetting) => {
    const setting = {};
    for (const key of utils_watchConfigKeys) {
        // @ts-expect-error
        if (key in appSetting)
            setting[key] = appSetting[key];
    }
    return setting;
};
const initWindowSize = (x, y, width, height) => {
    if (x == null || y == null) {
        if (width < minWidth)
            width = minWidth;
        if (height < minHeight)
            height = minHeight;
        if (global.envParams.workAreaSize) {
            x = global.envParams.workAreaSize.width - width;
            y = global.envParams.workAreaSize.height - height;
        }
        else {
            x = y = 0;
        }
    }
    else {
        let bounds = getLyricWindowBounds({ x, y, width, height }, { x: 0, y: 0, w: width, h: height });
        x = bounds.x;
        y = bounds.y;
        width = bounds.width;
        height = bounds.height;
    }
    return {
        x,
        y,
        width,
        height,
    };
};

;// CONCATENATED MODULE: ./src/main/modules/winLyric/main.ts






// require('./event')
// require('./rendererEvent')
let winLyric_main_browserWindow = null;
let isWinBoundsUpdateing = false;
const saveBoundsConfig = debounce((config) => {
    global.lx.event_app.update_config(config);
    if (isWinBoundsUpdateing)
        isWinBoundsUpdateing = false;
}, 500);
const winLyric_main_winEvent = () => {
    if (!winLyric_main_browserWindow)
        return;
    // browserWindow.on('close', () => {
    //   if (global.lx.appSetting['desktopLyric.enable'] && !global.lx.mainWindowClosed) {
    //     browserWindow = null
    //     global.lx.event_app.update_config({ 'desktopLyric.enable': false })
    //   }
    // })
    winLyric_main_browserWindow.on('closed', () => {
        winLyric_main_browserWindow = null;
    });
    winLyric_main_browserWindow.on('move', () => {
        // bounds = browserWindow.getBounds()
        // console.log('move', isWinBoundsUpdateing)
        if (isWinBoundsUpdateing) {
            const bounds = winLyric_main_browserWindow.getBounds();
            saveBoundsConfig({
                'desktopLyric.x': bounds.x,
                'desktopLyric.y': bounds.y,
                'desktopLyric.width': bounds.width,
                'desktopLyric.height': bounds.height,
            });
        }
        else if (isWin) { // Linux 不允许将窗口设置出屏幕之外，MacOS未知，故只在Windows下执行强制设置
            // 非主动调整窗口触发的窗口位置变化将重置回设置值
            winLyric_main_browserWindow.setBounds({
                x: global.lx.appSetting['desktopLyric.x'] ?? 0,
                y: global.lx.appSetting['desktopLyric.y'] ?? 0,
                width: global.lx.appSetting['desktopLyric.width'],
                height: global.lx.appSetting['desktopLyric.height'],
            });
        }
    });
    winLyric_main_browserWindow.on('resize', () => {
        // bounds = browserWindow.getBounds()
        // console.log(bounds)
        const bounds = winLyric_main_browserWindow.getBounds();
        saveBoundsConfig({
            'desktopLyric.x': bounds.x,
            'desktopLyric.y': bounds.y,
            'desktopLyric.width': bounds.width,
            'desktopLyric.height': bounds.height,
        });
    });
    // browserWindow.on('restore', () => {
    //   browserWindow.webContents.send('restore')
    // })
    // browserWindow.on('focus', () => {
    //   browserWindow.webContents.send('focus')
    // })
    winLyric_main_browserWindow.once('ready-to-show', () => {
        main_showWindow();
        if (global.lx.appSetting['desktopLyric.isLock']) {
            winLyric_main_browserWindow.setIgnoreMouseEvents(true, { forward: !isLinux && global.lx.appSetting['desktopLyric.isHoverHide'] });
        }
        // linux下每次重开时貌似要重新设置置顶
        // if (isLinux && global.lx.appSetting['desktopLyric.isAlwaysOnTop']) {
        //   browserWindow!.setAlwaysOnTop(global.lx.appSetting['desktopLyric.isAlwaysOnTop'], 'screen-saver')
        // }
        if (global.lx.appSetting['desktopLyric.isAlwaysOnTop'] && global.lx.appSetting['desktopLyric.isAlwaysOnTopLoop'])
            alwaysOnTopTools.startLoop();
        winLyric_main_browserWindow.blur();
    });
};
const winLyric_main_createWindow = () => {
    winLyric_main_closeWindow();
    if (!global.envParams.workAreaSize)
        return;
    let x = global.lx.appSetting['desktopLyric.x'];
    let y = global.lx.appSetting['desktopLyric.y'];
    let width = global.lx.appSetting['desktopLyric.width'];
    let height = global.lx.appSetting['desktopLyric.height'];
    let isAlwaysOnTop = global.lx.appSetting['desktopLyric.isAlwaysOnTop'];
    // let isLockScreen = global.lx.appSetting['desktopLyric.isLockScreen']
    let isShowTaskbar = global.lx.appSetting['desktopLyric.isShowTaskbar'];
    // let { width: screenWidth, height: screenHeight } = global.envParams.workAreaSize
    const winSize = initWindowSize(x, y, width, height);
    global.lx.event_app.update_config({
        'desktopLyric.x': winSize.x,
        'desktopLyric.y': winSize.y,
        'desktopLyric.width': winSize.width,
        'desktopLyric.height': winSize.height,
    });
    const { shouldUseDarkColors, theme } = global.lx.theme;
    /**
     * Initial window options
     */
    winLyric_main_browserWindow = new external_electron_.BrowserWindow({
        height: winSize.height,
        width: winSize.width,
        x: winSize.x,
        y: winSize.y,
        minWidth: 380,
        minHeight: 80,
        useContentSize: true,
        frame: false,
        transparent: true,
        hasShadow: false,
        // enableRemoteModule: false,
        // icon: join(global.__static, isWin ? 'icons/256x256.ico' : 'icons/512x512.png'),
        resizable: false,
        minimizable: false,
        maximizable: false,
        fullscreenable: false,
        show: false,
        alwaysOnTop: isAlwaysOnTop,
        skipTaskbar: !isShowTaskbar,
        webPreferences: {
            contextIsolation: false,
            webSecurity: false,
            sandbox: false,
            nodeIntegration: true,
            enableWebSQL: false,
            webgl: false,
            spellcheck: false, // 禁用拼写检查器
        },
    });
    const winURL =  false ? 0 : `file://${external_node_path_default().join(electron_encodePath(__dirname), 'lyric.html')}`;
    void winLyric_main_browserWindow.loadURL(winURL + `?dark=${shouldUseDarkColors}&theme=${encodeURIComponent(JSON.stringify(theme))}`);
    winLyric_main_winEvent();
    // browserWindow.webContents.openDevTools()
};
const main_isExistWindow = () => !!winLyric_main_browserWindow;
const winLyric_main_closeWindow = () => {
    if (!winLyric_main_browserWindow)
        return;
    winLyric_main_browserWindow.close();
};
const main_showWindow = () => {
    if (!winLyric_main_browserWindow)
        return;
    winLyric_main_browserWindow.show();
};
const winLyric_main_sendEvent = (name, params) => {
    if (!winLyric_main_browserWindow)
        return;
    mainSend(winLyric_main_browserWindow, name, params);
};
const getBounds = () => {
    if (!winLyric_main_browserWindow)
        throw new Error('window is not available');
    return winLyric_main_browserWindow.getBounds();
};
const setBounds = (bounds) => {
    if (!winLyric_main_browserWindow)
        return;
    isWinBoundsUpdateing = true;
    winLyric_main_browserWindow.setBounds(bounds);
};
const main_setIgnoreMouseEvents = (ignore, options) => {
    if (!winLyric_main_browserWindow)
        return;
    winLyric_main_browserWindow.setIgnoreMouseEvents(ignore, options);
};
const setSkipTaskbar = (skip) => {
    if (!winLyric_main_browserWindow)
        return;
    winLyric_main_browserWindow.setSkipTaskbar(skip);
};
const setAlwaysOnTop = (flag, level, relativeLevel) => {
    if (!winLyric_main_browserWindow)
        return;
    winLyric_main_browserWindow.setAlwaysOnTop(flag, level, relativeLevel);
};
const getMainFrame = () => {
    if (!winLyric_main_browserWindow)
        return null;
    return winLyric_main_browserWindow.webContents.mainFrame;
};
const alwaysOnTopTools = {
    timeout: null,
    setAlwaysOnTop(isLoop) {
        this.clearLoop();
        setAlwaysOnTop(global.lx.appSetting['desktopLyric.isAlwaysOnTop'], 'screen-saver');
        // console.log(isLoop)
        if (isLoop)
            this.startLoop();
    },
    startLoop() {
        this.clearLoop();
        this.timeout = setInterval(() => {
            if (!main_isExistWindow()) {
                this.clearLoop();
                return;
            }
            setAlwaysOnTop(true, 'screen-saver');
        }, 1000);
    },
    clearLoop() {
        if (!this.timeout)
            return;
        clearInterval(this.timeout);
        this.timeout = null;
    },
};

;// CONCATENATED MODULE: ./src/main/modules/winLyric/rendererEvent.ts







/* harmony default export */ const winLyric_rendererEvent = (() => {
    // mainOn(WIN_LYRIC_RENDERER_EVENT_NAME.get_lyric_info, ({ params: action }) => {
    //   sendMainEvent(WIN_MAIN_RENDERER_EVENT_NAME.get_lyric_info, {
    //     name: WIN_LYRIC_RENDERER_EVENT_NAME.set_lyric_info,
    //     modal: 'lyricWindow',
    //     action,
    //   })
    // })
    registerRendererEvents(winLyric_main_sendEvent);
    mainHandle(WIN_LYRIC_RENDERER_EVENT_NAME.set_config, async ({ params: config }) => {
        global.lx.event_app.update_config(config);
    });
    mainHandle(WIN_LYRIC_RENDERER_EVENT_NAME.get_config, async () => {
        return buildLyricConfig(global.lx.appSetting);
    });
    mainOn(WIN_LYRIC_RENDERER_EVENT_NAME.set_win_bounds, ({ params: options }) => {
        setBounds(getLyricWindowBounds(getBounds(), options));
    });
    mainOn(WIN_LYRIC_RENDERER_EVENT_NAME.request_main_window_channel, ({ event }) => {
        if (event.senderFrame !== getMainFrame())
            return;
        // Create a new channel ...
        const { port1, port2 } = new external_electron_.MessageChannelMain();
        // ... send one end to the worker ...
        sendNewDesktopLyricClient(port1);
        // ... and the other end to the main window.
        event.senderFrame.postMessage(WIN_LYRIC_RENDERER_EVENT_NAME.provide_main_window_channel, null, [port2]);
        // Now the main window and the worker can communicate with each other
        // without going through the main process!
        console.log('request_main_window_channel');
    });
});
const rendererEvent_sendConfigChange = (setting) => {
    winLyric_main_sendEvent(WIN_LYRIC_RENDERER_EVENT_NAME.on_config_change, setting);
};
const sendMainWindowInitedEvent = () => {
    winLyric_main_sendEvent(WIN_LYRIC_RENDERER_EVENT_NAME.main_window_inited);
};

;// CONCATENATED MODULE: ./src/main/modules/winLyric/config.ts




let isLock;
let isEnable;
let isAlwaysOnTop;
let isAlwaysOnTopLoop;
let isShowTaskbar;
let isLockScreen;
let isHoverHide;
const setLrcConfig = (keys, setting) => {
    if (!utils_watchConfigKeys.some(key => keys.includes(key)))
        return;
    if (main_isExistWindow()) {
        rendererEvent_sendConfigChange(buildLyricConfig(setting));
        if (keys.includes('desktopLyric.isLock') && isLock != global.lx.appSetting['desktopLyric.isLock']) {
            isLock = global.lx.appSetting['desktopLyric.isLock'];
            if (global.lx.appSetting['desktopLyric.isLock']) {
                main_setIgnoreMouseEvents(true, { forward: !isLinux && global.lx.appSetting['desktopLyric.isHoverHide'] });
            }
            else {
                main_setIgnoreMouseEvents(false, { forward: !isLinux && global.lx.appSetting['desktopLyric.isHoverHide'] });
            }
        }
        if (keys.includes('desktopLyric.isHoverHide') && isHoverHide != global.lx.appSetting['desktopLyric.isHoverHide']) {
            isHoverHide = global.lx.appSetting['desktopLyric.isHoverHide'];
            if (!isLinux) {
                main_setIgnoreMouseEvents(global.lx.appSetting['desktopLyric.isLock'], { forward: global.lx.appSetting['desktopLyric.isHoverHide'] });
            }
        }
        if (keys.includes('desktopLyric.isAlwaysOnTop') && isAlwaysOnTop != global.lx.appSetting['desktopLyric.isAlwaysOnTop']) {
            isAlwaysOnTop = global.lx.appSetting['desktopLyric.isAlwaysOnTop'];
            alwaysOnTopTools.setAlwaysOnTop(global.lx.appSetting['desktopLyric.isAlwaysOnTopLoop']);
            if (isAlwaysOnTop && global.lx.appSetting['desktopLyric.isAlwaysOnTopLoop']) {
                alwaysOnTopTools.startLoop();
            }
            else
                alwaysOnTopTools.clearLoop();
        }
        if (keys.includes('desktopLyric.isShowTaskbar') && isShowTaskbar != global.lx.appSetting['desktopLyric.isShowTaskbar']) {
            isShowTaskbar = global.lx.appSetting['desktopLyric.isShowTaskbar'];
            setSkipTaskbar(!global.lx.appSetting['desktopLyric.isShowTaskbar']);
        }
        if (keys.includes('desktopLyric.isAlwaysOnTopLoop') && isAlwaysOnTopLoop != global.lx.appSetting['desktopLyric.isAlwaysOnTopLoop']) {
            isAlwaysOnTopLoop = global.lx.appSetting['desktopLyric.isAlwaysOnTopLoop'];
            if (!global.lx.appSetting['desktopLyric.isAlwaysOnTop'])
                return;
            if (isAlwaysOnTopLoop) {
                alwaysOnTopTools.startLoop();
            }
            else {
                alwaysOnTopTools.clearLoop();
            }
        }
        if (keys.includes('desktopLyric.isLockScreen') && isLockScreen != global.lx.appSetting['desktopLyric.isLockScreen']) {
            isLockScreen = global.lx.appSetting['desktopLyric.isLockScreen'];
            if (global.lx.appSetting['desktopLyric.isLockScreen']) {
                setBounds(getLyricWindowBounds(getBounds(), {
                    x: 0,
                    y: 0,
                    w: global.lx.appSetting['desktopLyric.width'],
                    h: global.lx.appSetting['desktopLyric.height'],
                }));
            }
        }
        if (keys.includes('desktopLyric.x') && setting['desktopLyric.x'] == null) {
            setBounds(initWindowSize(global.lx.appSetting['desktopLyric.x'], global.lx.appSetting['desktopLyric.y'], global.lx.appSetting['desktopLyric.width'], global.lx.appSetting['desktopLyric.height']));
        }
    }
    if (keys.includes('desktopLyric.enable') && isEnable != global.lx.appSetting['desktopLyric.enable']) {
        isEnable = global.lx.appSetting['desktopLyric.enable'];
        if (global.lx.appSetting['desktopLyric.enable']) {
            winLyric_main_createWindow();
        }
        else {
            alwaysOnTopTools.clearLoop();
            winLyric_main_closeWindow();
        }
    }
};

;// CONCATENATED MODULE: ./src/main/modules/winLyric/index.ts





// import main from './main'
// import { Event, EVENT_NAMES } from './event'
let isMainWidnowFullscreen = false;
/* harmony default export */ const winLyric = (() => {
    winLyric_rendererEvent();
    // global.lx.event_app.winLyric = new Event()
    // global.app_event.winMain.
    global.lx.event_app.on('main_window_inited', () => {
        isMainWidnowFullscreen = global.lx.appSetting['common.startInFullscreen'];
        if (global.lx.appSetting['desktopLyric.enable']) {
            if (global.lx.appSetting['desktopLyric.fullscreenHide'] && isMainWidnowFullscreen) {
                winLyric_main_closeWindow();
            }
            else {
                if (main_isExistWindow())
                    sendMainWindowInitedEvent();
                else
                    winLyric_main_createWindow();
            }
        }
    });
    global.lx.event_app.on('updated_config', (keys, setting) => {
        setLrcConfig(keys, setting);
        if (keys.includes('desktopLyric.fullscreenHide') && global.lx.appSetting['desktopLyric.enable'] && isMainWidnowFullscreen) {
            if (global.lx.appSetting['desktopLyric.fullscreenHide'])
                winLyric_main_closeWindow();
            else if (!main_isExistWindow())
                winLyric_main_createWindow();
        }
    });
    global.lx.event_app.on('main_window_close', () => {
        winLyric_main_closeWindow();
    });
    global.lx.event_app.on('main_window_fullscreen', (isFullscreen) => {
        isMainWidnowFullscreen = isFullscreen;
        if (global.lx.appSetting['desktopLyric.enable'] && global.lx.appSetting['desktopLyric.fullscreenHide']) {
            if (isFullscreen)
                winLyric_main_closeWindow();
            else if (!main_isExistWindow())
                winLyric_main_createWindow();
        }
    });
    // global.lx_event.mainWindow.on(MAIN_WINDOW_EVENT_NAME.setLyricInfo, info => {
    //   if (!global.modules.lyricWindow) return
    //   mainSend(global.modules.lyricWindow, ipcWinLyricNames.set_lyric_info, info)
    // })
    global.lx.event_app.on('hot_key_down', ({ type, key }) => {
        let info = global.lx.hotKey.config.global.keys[key];
        if (!info || info.type != APP_EVENT_NAMES.winLyricName)
            return;
        let newSetting = {};
        let settingKey;
        switch (info.action) {
            case HOTKEY_DESKTOP_LYRIC.toggle_visible.action:
                settingKey = 'desktopLyric.enable';
                break;
            case HOTKEY_DESKTOP_LYRIC.toggle_lock.action:
                settingKey = 'desktopLyric.isLock';
                break;
            case HOTKEY_DESKTOP_LYRIC.toggle_always_top.action:
                settingKey = 'desktopLyric.isAlwaysOnTop';
                break;
            default: return;
        }
        newSetting[settingKey] = !global.lx.appSetting[settingKey];
        global.lx.event_app.update_config(newSetting);
    });
});


// export {
//   EVENT_NAMES,
// }

;// CONCATENATED MODULE: ./src/main/modules/commonRenderers/index.ts



/* harmony default export */ const commonRenderers = (() => {
    rendererEvent();
    list_rendererEvent();
    dislike_rendererEvent();
});

;// CONCATENATED MODULE: ./src/main/modules/index.ts







let isRegistered = false;
/* harmony default export */ const main_modules = (() => {
    if (isRegistered)
        return;
    modules_userApi();
    commonRenderers();
    winMain();
    modules_hotKey();
    modules_tray();
    appMenu();
    winLyric();
    isRegistered = true;
});

;// CONCATENATED MODULE: ./src/main/index.ts







// 初始化应用
const main_init = () => {
    console.log('init');
    void initAppSetting().then(() => {
        main_modules();
        global.lx.event_app.app_inited();
    });
};
initGlobalData();
initSingleInstanceHandle();
applyElectronEnvParams();
setUserDataPath();
registerDeeplink(main_init);
listenerAppEvent(main_init);
// https://github.com/electron/electron/issues/16809
void external_electron_.app.whenReady().then(() => {
    isLinux ? setTimeout(main_init, 300) : main_init();
});


/***/ }),

/***/ 803:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(7469);


/***/ }),

/***/ 7469:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";
var __webpack_unused_export__;


var net = __webpack_require__(9278);
var tls = __webpack_require__(4756);
var http = __webpack_require__(8611);
var https = __webpack_require__(5692);
var events = __webpack_require__(4434);
var assert = __webpack_require__(2613);
var util = __webpack_require__(9023);


exports.httpOverHttp = httpOverHttp;
exports.httpsOverHttp = httpsOverHttp;
__webpack_unused_export__ = httpOverHttps;
__webpack_unused_export__ = httpsOverHttps;


function httpOverHttp(options) {
  var agent = new TunnelingAgent(options);
  agent.request = http.request;
  return agent;
}

function httpsOverHttp(options) {
  var agent = new TunnelingAgent(options);
  agent.request = http.request;
  agent.createSocket = createSecureSocket;
  agent.defaultPort = 443;
  return agent;
}

function httpOverHttps(options) {
  var agent = new TunnelingAgent(options);
  agent.request = https.request;
  return agent;
}

function httpsOverHttps(options) {
  var agent = new TunnelingAgent(options);
  agent.request = https.request;
  agent.createSocket = createSecureSocket;
  agent.defaultPort = 443;
  return agent;
}


function TunnelingAgent(options) {
  var self = this;
  self.options = options || {};
  self.proxyOptions = self.options.proxy || {};
  self.maxSockets = self.options.maxSockets || http.Agent.defaultMaxSockets;
  self.requests = [];
  self.sockets = [];

  self.on('free', function onFree(socket, host, port, localAddress) {
    var options = toOptions(host, port, localAddress);
    for (var i = 0, len = self.requests.length; i < len; ++i) {
      var pending = self.requests[i];
      if (pending.host === options.host && pending.port === options.port) {
        // Detect the request to connect same origin server,
        // reuse the connection.
        self.requests.splice(i, 1);
        pending.request.onSocket(socket);
        return;
      }
    }
    socket.destroy();
    self.removeSocket(socket);
  });
}
util.inherits(TunnelingAgent, events.EventEmitter);

TunnelingAgent.prototype.addRequest = function addRequest(req, host, port, localAddress) {
  var self = this;
  var options = mergeOptions({request: req}, self.options, toOptions(host, port, localAddress));

  if (self.sockets.length >= this.maxSockets) {
    // We are over limit so we'll add it to the queue.
    self.requests.push(options);
    return;
  }

  // If we are under maxSockets create a new one.
  self.createSocket(options, function(socket) {
    socket.on('free', onFree);
    socket.on('close', onCloseOrRemove);
    socket.on('agentRemove', onCloseOrRemove);
    req.onSocket(socket);

    function onFree() {
      self.emit('free', socket, options);
    }

    function onCloseOrRemove(err) {
      self.removeSocket(socket);
      socket.removeListener('free', onFree);
      socket.removeListener('close', onCloseOrRemove);
      socket.removeListener('agentRemove', onCloseOrRemove);
    }
  });
};

TunnelingAgent.prototype.createSocket = function createSocket(options, cb) {
  var self = this;
  var placeholder = {};
  self.sockets.push(placeholder);

  var connectOptions = mergeOptions({}, self.proxyOptions, {
    method: 'CONNECT',
    path: options.host + ':' + options.port,
    agent: false,
    headers: {
      host: options.host + ':' + options.port
    }
  });
  if (options.localAddress) {
    connectOptions.localAddress = options.localAddress;
  }
  if (connectOptions.proxyAuth) {
    connectOptions.headers = connectOptions.headers || {};
    connectOptions.headers['Proxy-Authorization'] = 'Basic ' +
        new Buffer(connectOptions.proxyAuth).toString('base64');
  }

  debug('making CONNECT request');
  var connectReq = self.request(connectOptions);
  connectReq.useChunkedEncodingByDefault = false; // for v0.6
  connectReq.once('response', onResponse); // for v0.6
  connectReq.once('upgrade', onUpgrade);   // for v0.6
  connectReq.once('connect', onConnect);   // for v0.7 or later
  connectReq.once('error', onError);
  connectReq.end();

  function onResponse(res) {
    // Very hacky. This is necessary to avoid http-parser leaks.
    res.upgrade = true;
  }

  function onUpgrade(res, socket, head) {
    // Hacky.
    process.nextTick(function() {
      onConnect(res, socket, head);
    });
  }

  function onConnect(res, socket, head) {
    connectReq.removeAllListeners();
    socket.removeAllListeners();

    if (res.statusCode !== 200) {
      debug('tunneling socket could not be established, statusCode=%d',
        res.statusCode);
      socket.destroy();
      var error = new Error('tunneling socket could not be established, ' +
        'statusCode=' + res.statusCode);
      error.code = 'ECONNRESET';
      options.request.emit('error', error);
      self.removeSocket(placeholder);
      return;
    }
    if (head.length > 0) {
      debug('got illegal response body from proxy');
      socket.destroy();
      var error = new Error('got illegal response body from proxy');
      error.code = 'ECONNRESET';
      options.request.emit('error', error);
      self.removeSocket(placeholder);
      return;
    }
    debug('tunneling connection has established');
    self.sockets[self.sockets.indexOf(placeholder)] = socket;
    return cb(socket);
  }

  function onError(cause) {
    connectReq.removeAllListeners();

    debug('tunneling socket could not be established, cause=%s\n',
          cause.message, cause.stack);
    var error = new Error('tunneling socket could not be established, ' +
                          'cause=' + cause.message);
    error.code = 'ECONNRESET';
    options.request.emit('error', error);
    self.removeSocket(placeholder);
  }
};

TunnelingAgent.prototype.removeSocket = function removeSocket(socket) {
  var pos = this.sockets.indexOf(socket)
  if (pos === -1) {
    return;
  }
  this.sockets.splice(pos, 1);

  var pending = this.requests.shift();
  if (pending) {
    // If we have pending requests and a socket gets closed a new one
    // needs to be created to take over in the pool for the one that closed.
    this.createSocket(pending, function(socket) {
      pending.request.onSocket(socket);
    });
  }
};

function createSecureSocket(options, cb) {
  var self = this;
  TunnelingAgent.prototype.createSocket.call(self, options, function(socket) {
    var hostHeader = options.request.getHeader('host');
    var tlsOptions = mergeOptions({}, self.options, {
      socket: socket,
      servername: hostHeader ? hostHeader.replace(/:.*$/, '') : options.host
    });

    // 0 is dummy port for v0.6
    var secureSocket = tls.connect(0, tlsOptions);
    self.sockets[self.sockets.indexOf(socket)] = secureSocket;
    cb(secureSocket);
  });
}


function toOptions(host, port, localAddress) {
  if (typeof host === 'string') { // since v0.10
    return {
      host: host,
      port: port,
      localAddress: localAddress
    };
  }
  return host; // for v0.11 or later
}

function mergeOptions(target) {
  for (var i = 1, len = arguments.length; i < len; ++i) {
    var overrides = arguments[i];
    if (typeof overrides === 'object') {
      var keys = Object.keys(overrides);
      for (var j = 0, keyLen = keys.length; j < keyLen; ++j) {
        var k = keys[j];
        if (overrides[k] !== undefined) {
          target[k] = overrides[k];
        }
      }
    }
  }
  return target;
}


var debug;
if (({"NODE_ENV":"production"}).NODE_DEBUG && /\btunnel\b/.test(({"NODE_ENV":"production"}).NODE_DEBUG)) {
  debug = function() {
    var args = Array.prototype.slice.call(arguments);
    if (typeof args[0] === 'string') {
      args[0] = 'TUNNEL: ' + args[0];
    } else {
      args.unshift('TUNNEL:');
    }
    console.error.apply(console, args);
  }
} else {
  debug = function() {};
}
__webpack_unused_export__ = debug; // for test


/***/ }),

/***/ 3338:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { EMPTY_BUFFER } = __webpack_require__(2614);

const FastBuffer = Buffer[Symbol.species];

/**
 * Merges an array of buffers into a new buffer.
 *
 * @param {Buffer[]} list The array of buffers to concat
 * @param {Number} totalLength The total length of buffers in the list
 * @return {Buffer} The resulting buffer
 * @public
 */
function concat(list, totalLength) {
  if (list.length === 0) return EMPTY_BUFFER;
  if (list.length === 1) return list[0];

  const target = Buffer.allocUnsafe(totalLength);
  let offset = 0;

  for (let i = 0; i < list.length; i++) {
    const buf = list[i];
    target.set(buf, offset);
    offset += buf.length;
  }

  if (offset < totalLength) {
    return new FastBuffer(target.buffer, target.byteOffset, offset);
  }

  return target;
}

/**
 * Masks a buffer using the given mask.
 *
 * @param {Buffer} source The buffer to mask
 * @param {Buffer} mask The mask to use
 * @param {Buffer} output The buffer where to store the result
 * @param {Number} offset The offset at which to start writing
 * @param {Number} length The number of bytes to mask.
 * @public
 */
function _mask(source, mask, output, offset, length) {
  for (let i = 0; i < length; i++) {
    output[offset + i] = source[i] ^ mask[i & 3];
  }
}

/**
 * Unmasks a buffer using the given mask.
 *
 * @param {Buffer} buffer The buffer to unmask
 * @param {Buffer} mask The mask to use
 * @public
 */
function _unmask(buffer, mask) {
  for (let i = 0; i < buffer.length; i++) {
    buffer[i] ^= mask[i & 3];
  }
}

/**
 * Converts a buffer to an `ArrayBuffer`.
 *
 * @param {Buffer} buf The buffer to convert
 * @return {ArrayBuffer} Converted buffer
 * @public
 */
function toArrayBuffer(buf) {
  if (buf.length === buf.buffer.byteLength) {
    return buf.buffer;
  }

  return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.length);
}

/**
 * Converts `data` to a `Buffer`.
 *
 * @param {*} data The data to convert
 * @return {Buffer} The buffer
 * @throws {TypeError}
 * @public
 */
function toBuffer(data) {
  toBuffer.readOnly = true;

  if (Buffer.isBuffer(data)) return data;

  let buf;

  if (data instanceof ArrayBuffer) {
    buf = new FastBuffer(data);
  } else if (ArrayBuffer.isView(data)) {
    buf = new FastBuffer(data.buffer, data.byteOffset, data.byteLength);
  } else {
    buf = Buffer.from(data);
    toBuffer.readOnly = false;
  }

  return buf;
}

module.exports = {
  concat,
  mask: _mask,
  toArrayBuffer,
  toBuffer,
  unmask: _unmask
};

/* istanbul ignore else  */
if (!({"NODE_ENV":"production"}).WS_NO_BUFFER_UTIL) {
  try {
    const bufferUtil = __webpack_require__(6608);

    module.exports.mask = function (source, mask, output, offset, length) {
      if (length < 48) _mask(source, mask, output, offset, length);
      else bufferUtil.mask(source, mask, output, offset, length);
    };

    module.exports.unmask = function (buffer, mask) {
      if (buffer.length < 32) _unmask(buffer, mask);
      else bufferUtil.unmask(buffer, mask);
    };
  } catch (e) {
    // Continue regardless of the error.
  }
}


/***/ }),

/***/ 2614:
/***/ ((module) => {

"use strict";


module.exports = {
  BINARY_TYPES: ['nodebuffer', 'arraybuffer', 'fragments'],
  EMPTY_BUFFER: Buffer.alloc(0),
  GUID: '258EAFA5-E914-47DA-95CA-C5AB0DC85B11',
  kForOnEventAttribute: Symbol('kIsForOnEventAttribute'),
  kListener: Symbol('kListener'),
  kStatusCode: Symbol('status-code'),
  kWebSocket: Symbol('websocket'),
  NOOP: () => {}
};


/***/ }),

/***/ 597:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { kForOnEventAttribute, kListener } = __webpack_require__(2614);

const kCode = Symbol('kCode');
const kData = Symbol('kData');
const kError = Symbol('kError');
const kMessage = Symbol('kMessage');
const kReason = Symbol('kReason');
const kTarget = Symbol('kTarget');
const kType = Symbol('kType');
const kWasClean = Symbol('kWasClean');

/**
 * Class representing an event.
 */
class Event {
  /**
   * Create a new `Event`.
   *
   * @param {String} type The name of the event
   * @throws {TypeError} If the `type` argument is not specified
   */
  constructor(type) {
    this[kTarget] = null;
    this[kType] = type;
  }

  /**
   * @type {*}
   */
  get target() {
    return this[kTarget];
  }

  /**
   * @type {String}
   */
  get type() {
    return this[kType];
  }
}

Object.defineProperty(Event.prototype, 'target', { enumerable: true });
Object.defineProperty(Event.prototype, 'type', { enumerable: true });

/**
 * Class representing a close event.
 *
 * @extends Event
 */
class CloseEvent extends Event {
  /**
   * Create a new `CloseEvent`.
   *
   * @param {String} type The name of the event
   * @param {Object} [options] A dictionary object that allows for setting
   *     attributes via object members of the same name
   * @param {Number} [options.code=0] The status code explaining why the
   *     connection was closed
   * @param {String} [options.reason=''] A human-readable string explaining why
   *     the connection was closed
   * @param {Boolean} [options.wasClean=false] Indicates whether or not the
   *     connection was cleanly closed
   */
  constructor(type, options = {}) {
    super(type);

    this[kCode] = options.code === undefined ? 0 : options.code;
    this[kReason] = options.reason === undefined ? '' : options.reason;
    this[kWasClean] = options.wasClean === undefined ? false : options.wasClean;
  }

  /**
   * @type {Number}
   */
  get code() {
    return this[kCode];
  }

  /**
   * @type {String}
   */
  get reason() {
    return this[kReason];
  }

  /**
   * @type {Boolean}
   */
  get wasClean() {
    return this[kWasClean];
  }
}

Object.defineProperty(CloseEvent.prototype, 'code', { enumerable: true });
Object.defineProperty(CloseEvent.prototype, 'reason', { enumerable: true });
Object.defineProperty(CloseEvent.prototype, 'wasClean', { enumerable: true });

/**
 * Class representing an error event.
 *
 * @extends Event
 */
class ErrorEvent extends Event {
  /**
   * Create a new `ErrorEvent`.
   *
   * @param {String} type The name of the event
   * @param {Object} [options] A dictionary object that allows for setting
   *     attributes via object members of the same name
   * @param {*} [options.error=null] The error that generated this event
   * @param {String} [options.message=''] The error message
   */
  constructor(type, options = {}) {
    super(type);

    this[kError] = options.error === undefined ? null : options.error;
    this[kMessage] = options.message === undefined ? '' : options.message;
  }

  /**
   * @type {*}
   */
  get error() {
    return this[kError];
  }

  /**
   * @type {String}
   */
  get message() {
    return this[kMessage];
  }
}

Object.defineProperty(ErrorEvent.prototype, 'error', { enumerable: true });
Object.defineProperty(ErrorEvent.prototype, 'message', { enumerable: true });

/**
 * Class representing a message event.
 *
 * @extends Event
 */
class MessageEvent extends Event {
  /**
   * Create a new `MessageEvent`.
   *
   * @param {String} type The name of the event
   * @param {Object} [options] A dictionary object that allows for setting
   *     attributes via object members of the same name
   * @param {*} [options.data=null] The message content
   */
  constructor(type, options = {}) {
    super(type);

    this[kData] = options.data === undefined ? null : options.data;
  }

  /**
   * @type {*}
   */
  get data() {
    return this[kData];
  }
}

Object.defineProperty(MessageEvent.prototype, 'data', { enumerable: true });

/**
 * This provides methods for emulating the `EventTarget` interface. It's not
 * meant to be used directly.
 *
 * @mixin
 */
const EventTarget = {
  /**
   * Register an event listener.
   *
   * @param {String} type A string representing the event type to listen for
   * @param {(Function|Object)} handler The listener to add
   * @param {Object} [options] An options object specifies characteristics about
   *     the event listener
   * @param {Boolean} [options.once=false] A `Boolean` indicating that the
   *     listener should be invoked at most once after being added. If `true`,
   *     the listener would be automatically removed when invoked.
   * @public
   */
  addEventListener(type, handler, options = {}) {
    for (const listener of this.listeners(type)) {
      if (
        !options[kForOnEventAttribute] &&
        listener[kListener] === handler &&
        !listener[kForOnEventAttribute]
      ) {
        return;
      }
    }

    let wrapper;

    if (type === 'message') {
      wrapper = function onMessage(data, isBinary) {
        const event = new MessageEvent('message', {
          data: isBinary ? data : data.toString()
        });

        event[kTarget] = this;
        callListener(handler, this, event);
      };
    } else if (type === 'close') {
      wrapper = function onClose(code, message) {
        const event = new CloseEvent('close', {
          code,
          reason: message.toString(),
          wasClean: this._closeFrameReceived && this._closeFrameSent
        });

        event[kTarget] = this;
        callListener(handler, this, event);
      };
    } else if (type === 'error') {
      wrapper = function onError(error) {
        const event = new ErrorEvent('error', {
          error,
          message: error.message
        });

        event[kTarget] = this;
        callListener(handler, this, event);
      };
    } else if (type === 'open') {
      wrapper = function onOpen() {
        const event = new Event('open');

        event[kTarget] = this;
        callListener(handler, this, event);
      };
    } else {
      return;
    }

    wrapper[kForOnEventAttribute] = !!options[kForOnEventAttribute];
    wrapper[kListener] = handler;

    if (options.once) {
      this.once(type, wrapper);
    } else {
      this.on(type, wrapper);
    }
  },

  /**
   * Remove an event listener.
   *
   * @param {String} type A string representing the event type to remove
   * @param {(Function|Object)} handler The listener to remove
   * @public
   */
  removeEventListener(type, handler) {
    for (const listener of this.listeners(type)) {
      if (listener[kListener] === handler && !listener[kForOnEventAttribute]) {
        this.removeListener(type, listener);
        break;
      }
    }
  }
};

module.exports = {
  CloseEvent,
  ErrorEvent,
  Event,
  EventTarget,
  MessageEvent
};

/**
 * Call an event listener
 *
 * @param {(Function|Object)} listener The listener to call
 * @param {*} thisArg The value to use as `this`` when calling the listener
 * @param {Event} event The event to pass to the listener
 * @private
 */
function callListener(listener, thisArg, event) {
  if (typeof listener === 'object' && listener.handleEvent) {
    listener.handleEvent.call(listener, event);
  } else {
    listener.call(thisArg, event);
  }
}


/***/ }),

/***/ 5926:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { tokenChars } = __webpack_require__(5880);

/**
 * Adds an offer to the map of extension offers or a parameter to the map of
 * parameters.
 *
 * @param {Object} dest The map of extension offers or parameters
 * @param {String} name The extension or parameter name
 * @param {(Object|Boolean|String)} elem The extension parameters or the
 *     parameter value
 * @private
 */
function push(dest, name, elem) {
  if (dest[name] === undefined) dest[name] = [elem];
  else dest[name].push(elem);
}

/**
 * Parses the `Sec-WebSocket-Extensions` header into an object.
 *
 * @param {String} header The field value of the header
 * @return {Object} The parsed object
 * @public
 */
function parse(header) {
  const offers = Object.create(null);
  let params = Object.create(null);
  let mustUnescape = false;
  let isEscaping = false;
  let inQuotes = false;
  let extensionName;
  let paramName;
  let start = -1;
  let code = -1;
  let end = -1;
  let i = 0;

  for (; i < header.length; i++) {
    code = header.charCodeAt(i);

    if (extensionName === undefined) {
      if (end === -1 && tokenChars[code] === 1) {
        if (start === -1) start = i;
      } else if (
        i !== 0 &&
        (code === 0x20 /* ' ' */ || code === 0x09) /* '\t' */
      ) {
        if (end === -1 && start !== -1) end = i;
      } else if (code === 0x3b /* ';' */ || code === 0x2c /* ',' */) {
        if (start === -1) {
          throw new SyntaxError(`Unexpected character at index ${i}`);
        }

        if (end === -1) end = i;
        const name = header.slice(start, end);
        if (code === 0x2c) {
          push(offers, name, params);
          params = Object.create(null);
        } else {
          extensionName = name;
        }

        start = end = -1;
      } else {
        throw new SyntaxError(`Unexpected character at index ${i}`);
      }
    } else if (paramName === undefined) {
      if (end === -1 && tokenChars[code] === 1) {
        if (start === -1) start = i;
      } else if (code === 0x20 || code === 0x09) {
        if (end === -1 && start !== -1) end = i;
      } else if (code === 0x3b || code === 0x2c) {
        if (start === -1) {
          throw new SyntaxError(`Unexpected character at index ${i}`);
        }

        if (end === -1) end = i;
        push(params, header.slice(start, end), true);
        if (code === 0x2c) {
          push(offers, extensionName, params);
          params = Object.create(null);
          extensionName = undefined;
        }

        start = end = -1;
      } else if (code === 0x3d /* '=' */ && start !== -1 && end === -1) {
        paramName = header.slice(start, i);
        start = end = -1;
      } else {
        throw new SyntaxError(`Unexpected character at index ${i}`);
      }
    } else {
      //
      // The value of a quoted-string after unescaping must conform to the
      // token ABNF, so only token characters are valid.
      // Ref: https://tools.ietf.org/html/rfc6455#section-9.1
      //
      if (isEscaping) {
        if (tokenChars[code] !== 1) {
          throw new SyntaxError(`Unexpected character at index ${i}`);
        }
        if (start === -1) start = i;
        else if (!mustUnescape) mustUnescape = true;
        isEscaping = false;
      } else if (inQuotes) {
        if (tokenChars[code] === 1) {
          if (start === -1) start = i;
        } else if (code === 0x22 /* '"' */ && start !== -1) {
          inQuotes = false;
          end = i;
        } else if (code === 0x5c /* '\' */) {
          isEscaping = true;
        } else {
          throw new SyntaxError(`Unexpected character at index ${i}`);
        }
      } else if (code === 0x22 && header.charCodeAt(i - 1) === 0x3d) {
        inQuotes = true;
      } else if (end === -1 && tokenChars[code] === 1) {
        if (start === -1) start = i;
      } else if (start !== -1 && (code === 0x20 || code === 0x09)) {
        if (end === -1) end = i;
      } else if (code === 0x3b || code === 0x2c) {
        if (start === -1) {
          throw new SyntaxError(`Unexpected character at index ${i}`);
        }

        if (end === -1) end = i;
        let value = header.slice(start, end);
        if (mustUnescape) {
          value = value.replace(/\\/g, '');
          mustUnescape = false;
        }
        push(params, paramName, value);
        if (code === 0x2c) {
          push(offers, extensionName, params);
          params = Object.create(null);
          extensionName = undefined;
        }

        paramName = undefined;
        start = end = -1;
      } else {
        throw new SyntaxError(`Unexpected character at index ${i}`);
      }
    }
  }

  if (start === -1 || inQuotes || code === 0x20 || code === 0x09) {
    throw new SyntaxError('Unexpected end of input');
  }

  if (end === -1) end = i;
  const token = header.slice(start, end);
  if (extensionName === undefined) {
    push(offers, token, params);
  } else {
    if (paramName === undefined) {
      push(params, token, true);
    } else if (mustUnescape) {
      push(params, paramName, token.replace(/\\/g, ''));
    } else {
      push(params, paramName, token);
    }
    push(offers, extensionName, params);
  }

  return offers;
}

/**
 * Builds the `Sec-WebSocket-Extensions` header field value.
 *
 * @param {Object} extensions The map of extensions and parameters to format
 * @return {String} A string representing the given object
 * @public
 */
function format(extensions) {
  return Object.keys(extensions)
    .map((extension) => {
      let configurations = extensions[extension];
      if (!Array.isArray(configurations)) configurations = [configurations];
      return configurations
        .map((params) => {
          return [extension]
            .concat(
              Object.keys(params).map((k) => {
                let values = params[k];
                if (!Array.isArray(values)) values = [values];
                return values
                  .map((v) => (v === true ? k : `${k}=${v}`))
                  .join('; ');
              })
            )
            .join('; ');
        })
        .join(', ');
    })
    .join(', ');
}

module.exports = { format, parse };


/***/ }),

/***/ 4759:
/***/ ((module) => {

"use strict";


const kDone = Symbol('kDone');
const kRun = Symbol('kRun');

/**
 * A very simple job queue with adjustable concurrency. Adapted from
 * https://github.com/STRML/async-limiter
 */
class Limiter {
  /**
   * Creates a new `Limiter`.
   *
   * @param {Number} [concurrency=Infinity] The maximum number of jobs allowed
   *     to run concurrently
   */
  constructor(concurrency) {
    this[kDone] = () => {
      this.pending--;
      this[kRun]();
    };
    this.concurrency = concurrency || Infinity;
    this.jobs = [];
    this.pending = 0;
  }

  /**
   * Adds a job to the queue.
   *
   * @param {Function} job The job to run
   * @public
   */
  add(job) {
    this.jobs.push(job);
    this[kRun]();
  }

  /**
   * Removes a job from the queue and runs it if possible.
   *
   * @private
   */
  [kRun]() {
    if (this.pending === this.concurrency) return;

    if (this.jobs.length) {
      const job = this.jobs.shift();

      this.pending++;
      job(this[kDone]);
    }
  }
}

module.exports = Limiter;


/***/ }),

/***/ 2971:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const zlib = __webpack_require__(3106);

const bufferUtil = __webpack_require__(3338);
const Limiter = __webpack_require__(4759);
const { kStatusCode } = __webpack_require__(2614);

const FastBuffer = Buffer[Symbol.species];
const TRAILER = Buffer.from([0x00, 0x00, 0xff, 0xff]);
const kPerMessageDeflate = Symbol('permessage-deflate');
const kTotalLength = Symbol('total-length');
const kCallback = Symbol('callback');
const kBuffers = Symbol('buffers');
const kError = Symbol('error');

//
// We limit zlib concurrency, which prevents severe memory fragmentation
// as documented in https://github.com/nodejs/node/issues/8871#issuecomment-250915913
// and https://github.com/websockets/ws/issues/1202
//
// Intentionally global; it's the global thread pool that's an issue.
//
let zlibLimiter;

/**
 * permessage-deflate implementation.
 */
class PerMessageDeflate {
  /**
   * Creates a PerMessageDeflate instance.
   *
   * @param {Object} [options] Configuration options
   * @param {(Boolean|Number)} [options.clientMaxWindowBits] Advertise support
   *     for, or request, a custom client window size
   * @param {Boolean} [options.clientNoContextTakeover=false] Advertise/
   *     acknowledge disabling of client context takeover
   * @param {Number} [options.concurrencyLimit=10] The number of concurrent
   *     calls to zlib
   * @param {(Boolean|Number)} [options.serverMaxWindowBits] Request/confirm the
   *     use of a custom server window size
   * @param {Boolean} [options.serverNoContextTakeover=false] Request/accept
   *     disabling of server context takeover
   * @param {Number} [options.threshold=1024] Size (in bytes) below which
   *     messages should not be compressed if context takeover is disabled
   * @param {Object} [options.zlibDeflateOptions] Options to pass to zlib on
   *     deflate
   * @param {Object} [options.zlibInflateOptions] Options to pass to zlib on
   *     inflate
   * @param {Boolean} [isServer=false] Create the instance in either server or
   *     client mode
   * @param {Number} [maxPayload=0] The maximum allowed message length
   */
  constructor(options, isServer, maxPayload) {
    this._maxPayload = maxPayload | 0;
    this._options = options || {};
    this._threshold =
      this._options.threshold !== undefined ? this._options.threshold : 1024;
    this._isServer = !!isServer;
    this._deflate = null;
    this._inflate = null;

    this.params = null;

    if (!zlibLimiter) {
      const concurrency =
        this._options.concurrencyLimit !== undefined
          ? this._options.concurrencyLimit
          : 10;
      zlibLimiter = new Limiter(concurrency);
    }
  }

  /**
   * @type {String}
   */
  static get extensionName() {
    return 'permessage-deflate';
  }

  /**
   * Create an extension negotiation offer.
   *
   * @return {Object} Extension parameters
   * @public
   */
  offer() {
    const params = {};

    if (this._options.serverNoContextTakeover) {
      params.server_no_context_takeover = true;
    }
    if (this._options.clientNoContextTakeover) {
      params.client_no_context_takeover = true;
    }
    if (this._options.serverMaxWindowBits) {
      params.server_max_window_bits = this._options.serverMaxWindowBits;
    }
    if (this._options.clientMaxWindowBits) {
      params.client_max_window_bits = this._options.clientMaxWindowBits;
    } else if (this._options.clientMaxWindowBits == null) {
      params.client_max_window_bits = true;
    }

    return params;
  }

  /**
   * Accept an extension negotiation offer/response.
   *
   * @param {Array} configurations The extension negotiation offers/reponse
   * @return {Object} Accepted configuration
   * @public
   */
  accept(configurations) {
    configurations = this.normalizeParams(configurations);

    this.params = this._isServer
      ? this.acceptAsServer(configurations)
      : this.acceptAsClient(configurations);

    return this.params;
  }

  /**
   * Releases all resources used by the extension.
   *
   * @public
   */
  cleanup() {
    if (this._inflate) {
      this._inflate.close();
      this._inflate = null;
    }

    if (this._deflate) {
      const callback = this._deflate[kCallback];

      this._deflate.close();
      this._deflate = null;

      if (callback) {
        callback(
          new Error(
            'The deflate stream was closed while data was being processed'
          )
        );
      }
    }
  }

  /**
   *  Accept an extension negotiation offer.
   *
   * @param {Array} offers The extension negotiation offers
   * @return {Object} Accepted configuration
   * @private
   */
  acceptAsServer(offers) {
    const opts = this._options;
    const accepted = offers.find((params) => {
      if (
        (opts.serverNoContextTakeover === false &&
          params.server_no_context_takeover) ||
        (params.server_max_window_bits &&
          (opts.serverMaxWindowBits === false ||
            (typeof opts.serverMaxWindowBits === 'number' &&
              opts.serverMaxWindowBits > params.server_max_window_bits))) ||
        (typeof opts.clientMaxWindowBits === 'number' &&
          !params.client_max_window_bits)
      ) {
        return false;
      }

      return true;
    });

    if (!accepted) {
      throw new Error('None of the extension offers can be accepted');
    }

    if (opts.serverNoContextTakeover) {
      accepted.server_no_context_takeover = true;
    }
    if (opts.clientNoContextTakeover) {
      accepted.client_no_context_takeover = true;
    }
    if (typeof opts.serverMaxWindowBits === 'number') {
      accepted.server_max_window_bits = opts.serverMaxWindowBits;
    }
    if (typeof opts.clientMaxWindowBits === 'number') {
      accepted.client_max_window_bits = opts.clientMaxWindowBits;
    } else if (
      accepted.client_max_window_bits === true ||
      opts.clientMaxWindowBits === false
    ) {
      delete accepted.client_max_window_bits;
    }

    return accepted;
  }

  /**
   * Accept the extension negotiation response.
   *
   * @param {Array} response The extension negotiation response
   * @return {Object} Accepted configuration
   * @private
   */
  acceptAsClient(response) {
    const params = response[0];

    if (
      this._options.clientNoContextTakeover === false &&
      params.client_no_context_takeover
    ) {
      throw new Error('Unexpected parameter "client_no_context_takeover"');
    }

    if (!params.client_max_window_bits) {
      if (typeof this._options.clientMaxWindowBits === 'number') {
        params.client_max_window_bits = this._options.clientMaxWindowBits;
      }
    } else if (
      this._options.clientMaxWindowBits === false ||
      (typeof this._options.clientMaxWindowBits === 'number' &&
        params.client_max_window_bits > this._options.clientMaxWindowBits)
    ) {
      throw new Error(
        'Unexpected or invalid parameter "client_max_window_bits"'
      );
    }

    return params;
  }

  /**
   * Normalize parameters.
   *
   * @param {Array} configurations The extension negotiation offers/reponse
   * @return {Array} The offers/response with normalized parameters
   * @private
   */
  normalizeParams(configurations) {
    configurations.forEach((params) => {
      Object.keys(params).forEach((key) => {
        let value = params[key];

        if (value.length > 1) {
          throw new Error(`Parameter "${key}" must have only a single value`);
        }

        value = value[0];

        if (key === 'client_max_window_bits') {
          if (value !== true) {
            const num = +value;
            if (!Number.isInteger(num) || num < 8 || num > 15) {
              throw new TypeError(
                `Invalid value for parameter "${key}": ${value}`
              );
            }
            value = num;
          } else if (!this._isServer) {
            throw new TypeError(
              `Invalid value for parameter "${key}": ${value}`
            );
          }
        } else if (key === 'server_max_window_bits') {
          const num = +value;
          if (!Number.isInteger(num) || num < 8 || num > 15) {
            throw new TypeError(
              `Invalid value for parameter "${key}": ${value}`
            );
          }
          value = num;
        } else if (
          key === 'client_no_context_takeover' ||
          key === 'server_no_context_takeover'
        ) {
          if (value !== true) {
            throw new TypeError(
              `Invalid value for parameter "${key}": ${value}`
            );
          }
        } else {
          throw new Error(`Unknown parameter "${key}"`);
        }

        params[key] = value;
      });
    });

    return configurations;
  }

  /**
   * Decompress data. Concurrency limited.
   *
   * @param {Buffer} data Compressed data
   * @param {Boolean} fin Specifies whether or not this is the last fragment
   * @param {Function} callback Callback
   * @public
   */
  decompress(data, fin, callback) {
    zlibLimiter.add((done) => {
      this._decompress(data, fin, (err, result) => {
        done();
        callback(err, result);
      });
    });
  }

  /**
   * Compress data. Concurrency limited.
   *
   * @param {(Buffer|String)} data Data to compress
   * @param {Boolean} fin Specifies whether or not this is the last fragment
   * @param {Function} callback Callback
   * @public
   */
  compress(data, fin, callback) {
    zlibLimiter.add((done) => {
      this._compress(data, fin, (err, result) => {
        done();
        callback(err, result);
      });
    });
  }

  /**
   * Decompress data.
   *
   * @param {Buffer} data Compressed data
   * @param {Boolean} fin Specifies whether or not this is the last fragment
   * @param {Function} callback Callback
   * @private
   */
  _decompress(data, fin, callback) {
    const endpoint = this._isServer ? 'client' : 'server';

    if (!this._inflate) {
      const key = `${endpoint}_max_window_bits`;
      const windowBits =
        typeof this.params[key] !== 'number'
          ? zlib.Z_DEFAULT_WINDOWBITS
          : this.params[key];

      this._inflate = zlib.createInflateRaw({
        ...this._options.zlibInflateOptions,
        windowBits
      });
      this._inflate[kPerMessageDeflate] = this;
      this._inflate[kTotalLength] = 0;
      this._inflate[kBuffers] = [];
      this._inflate.on('error', inflateOnError);
      this._inflate.on('data', inflateOnData);
    }

    this._inflate[kCallback] = callback;

    this._inflate.write(data);
    if (fin) this._inflate.write(TRAILER);

    this._inflate.flush(() => {
      const err = this._inflate[kError];

      if (err) {
        this._inflate.close();
        this._inflate = null;
        callback(err);
        return;
      }

      const data = bufferUtil.concat(
        this._inflate[kBuffers],
        this._inflate[kTotalLength]
      );

      if (this._inflate._readableState.endEmitted) {
        this._inflate.close();
        this._inflate = null;
      } else {
        this._inflate[kTotalLength] = 0;
        this._inflate[kBuffers] = [];

        if (fin && this.params[`${endpoint}_no_context_takeover`]) {
          this._inflate.reset();
        }
      }

      callback(null, data);
    });
  }

  /**
   * Compress data.
   *
   * @param {(Buffer|String)} data Data to compress
   * @param {Boolean} fin Specifies whether or not this is the last fragment
   * @param {Function} callback Callback
   * @private
   */
  _compress(data, fin, callback) {
    const endpoint = this._isServer ? 'server' : 'client';

    if (!this._deflate) {
      const key = `${endpoint}_max_window_bits`;
      const windowBits =
        typeof this.params[key] !== 'number'
          ? zlib.Z_DEFAULT_WINDOWBITS
          : this.params[key];

      this._deflate = zlib.createDeflateRaw({
        ...this._options.zlibDeflateOptions,
        windowBits
      });

      this._deflate[kTotalLength] = 0;
      this._deflate[kBuffers] = [];

      this._deflate.on('data', deflateOnData);
    }

    this._deflate[kCallback] = callback;

    this._deflate.write(data);
    this._deflate.flush(zlib.Z_SYNC_FLUSH, () => {
      if (!this._deflate) {
        //
        // The deflate stream was closed while data was being processed.
        //
        return;
      }

      let data = bufferUtil.concat(
        this._deflate[kBuffers],
        this._deflate[kTotalLength]
      );

      if (fin) {
        data = new FastBuffer(data.buffer, data.byteOffset, data.length - 4);
      }

      //
      // Ensure that the callback will not be called again in
      // `PerMessageDeflate#cleanup()`.
      //
      this._deflate[kCallback] = null;

      this._deflate[kTotalLength] = 0;
      this._deflate[kBuffers] = [];

      if (fin && this.params[`${endpoint}_no_context_takeover`]) {
        this._deflate.reset();
      }

      callback(null, data);
    });
  }
}

module.exports = PerMessageDeflate;

/**
 * The listener of the `zlib.DeflateRaw` stream `'data'` event.
 *
 * @param {Buffer} chunk A chunk of data
 * @private
 */
function deflateOnData(chunk) {
  this[kBuffers].push(chunk);
  this[kTotalLength] += chunk.length;
}

/**
 * The listener of the `zlib.InflateRaw` stream `'data'` event.
 *
 * @param {Buffer} chunk A chunk of data
 * @private
 */
function inflateOnData(chunk) {
  this[kTotalLength] += chunk.length;

  if (
    this[kPerMessageDeflate]._maxPayload < 1 ||
    this[kTotalLength] <= this[kPerMessageDeflate]._maxPayload
  ) {
    this[kBuffers].push(chunk);
    return;
  }

  this[kError] = new RangeError('Max payload size exceeded');
  this[kError].code = 'WS_ERR_UNSUPPORTED_MESSAGE_LENGTH';
  this[kError][kStatusCode] = 1009;
  this.removeListener('data', inflateOnData);
  this.reset();
}

/**
 * The listener of the `zlib.InflateRaw` stream `'error'` event.
 *
 * @param {Error} err The emitted error
 * @private
 */
function inflateOnError(err) {
  //
  // There is no need to call `Zlib#close()` as the handle is automatically
  // closed when an error is emitted.
  //
  this[kPerMessageDeflate]._inflate = null;
  err[kStatusCode] = 1007;
  this[kCallback](err);
}


/***/ }),

/***/ 6286:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { Writable } = __webpack_require__(2203);

const PerMessageDeflate = __webpack_require__(2971);
const {
  BINARY_TYPES,
  EMPTY_BUFFER,
  kStatusCode,
  kWebSocket
} = __webpack_require__(2614);
const { concat, toArrayBuffer, unmask } = __webpack_require__(3338);
const { isValidStatusCode, isValidUTF8 } = __webpack_require__(5880);

const FastBuffer = Buffer[Symbol.species];

const GET_INFO = 0;
const GET_PAYLOAD_LENGTH_16 = 1;
const GET_PAYLOAD_LENGTH_64 = 2;
const GET_MASK = 3;
const GET_DATA = 4;
const INFLATING = 5;
const DEFER_EVENT = 6;

/**
 * HyBi Receiver implementation.
 *
 * @extends Writable
 */
class Receiver extends Writable {
  /**
   * Creates a Receiver instance.
   *
   * @param {Object} [options] Options object
   * @param {Boolean} [options.allowSynchronousEvents=true] Specifies whether
   *     any of the `'message'`, `'ping'`, and `'pong'` events can be emitted
   *     multiple times in the same tick
   * @param {String} [options.binaryType=nodebuffer] The type for binary data
   * @param {Object} [options.extensions] An object containing the negotiated
   *     extensions
   * @param {Boolean} [options.isServer=false] Specifies whether to operate in
   *     client or server mode
   * @param {Number} [options.maxPayload=0] The maximum allowed message length
   * @param {Boolean} [options.skipUTF8Validation=false] Specifies whether or
   *     not to skip UTF-8 validation for text and close messages
   */
  constructor(options = {}) {
    super();

    this._allowSynchronousEvents =
      options.allowSynchronousEvents !== undefined
        ? options.allowSynchronousEvents
        : true;
    this._binaryType = options.binaryType || BINARY_TYPES[0];
    this._extensions = options.extensions || {};
    this._isServer = !!options.isServer;
    this._maxPayload = options.maxPayload | 0;
    this._skipUTF8Validation = !!options.skipUTF8Validation;
    this[kWebSocket] = undefined;

    this._bufferedBytes = 0;
    this._buffers = [];

    this._compressed = false;
    this._payloadLength = 0;
    this._mask = undefined;
    this._fragmented = 0;
    this._masked = false;
    this._fin = false;
    this._opcode = 0;

    this._totalPayloadLength = 0;
    this._messageLength = 0;
    this._fragments = [];

    this._errored = false;
    this._loop = false;
    this._state = GET_INFO;
  }

  /**
   * Implements `Writable.prototype._write()`.
   *
   * @param {Buffer} chunk The chunk of data to write
   * @param {String} encoding The character encoding of `chunk`
   * @param {Function} cb Callback
   * @private
   */
  _write(chunk, encoding, cb) {
    if (this._opcode === 0x08 && this._state == GET_INFO) return cb();

    this._bufferedBytes += chunk.length;
    this._buffers.push(chunk);
    this.startLoop(cb);
  }

  /**
   * Consumes `n` bytes from the buffered data.
   *
   * @param {Number} n The number of bytes to consume
   * @return {Buffer} The consumed bytes
   * @private
   */
  consume(n) {
    this._bufferedBytes -= n;

    if (n === this._buffers[0].length) return this._buffers.shift();

    if (n < this._buffers[0].length) {
      const buf = this._buffers[0];
      this._buffers[0] = new FastBuffer(
        buf.buffer,
        buf.byteOffset + n,
        buf.length - n
      );

      return new FastBuffer(buf.buffer, buf.byteOffset, n);
    }

    const dst = Buffer.allocUnsafe(n);

    do {
      const buf = this._buffers[0];
      const offset = dst.length - n;

      if (n >= buf.length) {
        dst.set(this._buffers.shift(), offset);
      } else {
        dst.set(new Uint8Array(buf.buffer, buf.byteOffset, n), offset);
        this._buffers[0] = new FastBuffer(
          buf.buffer,
          buf.byteOffset + n,
          buf.length - n
        );
      }

      n -= buf.length;
    } while (n > 0);

    return dst;
  }

  /**
   * Starts the parsing loop.
   *
   * @param {Function} cb Callback
   * @private
   */
  startLoop(cb) {
    this._loop = true;

    do {
      switch (this._state) {
        case GET_INFO:
          this.getInfo(cb);
          break;
        case GET_PAYLOAD_LENGTH_16:
          this.getPayloadLength16(cb);
          break;
        case GET_PAYLOAD_LENGTH_64:
          this.getPayloadLength64(cb);
          break;
        case GET_MASK:
          this.getMask();
          break;
        case GET_DATA:
          this.getData(cb);
          break;
        case INFLATING:
        case DEFER_EVENT:
          this._loop = false;
          return;
      }
    } while (this._loop);

    if (!this._errored) cb();
  }

  /**
   * Reads the first two bytes of a frame.
   *
   * @param {Function} cb Callback
   * @private
   */
  getInfo(cb) {
    if (this._bufferedBytes < 2) {
      this._loop = false;
      return;
    }

    const buf = this.consume(2);

    if ((buf[0] & 0x30) !== 0x00) {
      const error = this.createError(
        RangeError,
        'RSV2 and RSV3 must be clear',
        true,
        1002,
        'WS_ERR_UNEXPECTED_RSV_2_3'
      );

      cb(error);
      return;
    }

    const compressed = (buf[0] & 0x40) === 0x40;

    if (compressed && !this._extensions[PerMessageDeflate.extensionName]) {
      const error = this.createError(
        RangeError,
        'RSV1 must be clear',
        true,
        1002,
        'WS_ERR_UNEXPECTED_RSV_1'
      );

      cb(error);
      return;
    }

    this._fin = (buf[0] & 0x80) === 0x80;
    this._opcode = buf[0] & 0x0f;
    this._payloadLength = buf[1] & 0x7f;

    if (this._opcode === 0x00) {
      if (compressed) {
        const error = this.createError(
          RangeError,
          'RSV1 must be clear',
          true,
          1002,
          'WS_ERR_UNEXPECTED_RSV_1'
        );

        cb(error);
        return;
      }

      if (!this._fragmented) {
        const error = this.createError(
          RangeError,
          'invalid opcode 0',
          true,
          1002,
          'WS_ERR_INVALID_OPCODE'
        );

        cb(error);
        return;
      }

      this._opcode = this._fragmented;
    } else if (this._opcode === 0x01 || this._opcode === 0x02) {
      if (this._fragmented) {
        const error = this.createError(
          RangeError,
          `invalid opcode ${this._opcode}`,
          true,
          1002,
          'WS_ERR_INVALID_OPCODE'
        );

        cb(error);
        return;
      }

      this._compressed = compressed;
    } else if (this._opcode > 0x07 && this._opcode < 0x0b) {
      if (!this._fin) {
        const error = this.createError(
          RangeError,
          'FIN must be set',
          true,
          1002,
          'WS_ERR_EXPECTED_FIN'
        );

        cb(error);
        return;
      }

      if (compressed) {
        const error = this.createError(
          RangeError,
          'RSV1 must be clear',
          true,
          1002,
          'WS_ERR_UNEXPECTED_RSV_1'
        );

        cb(error);
        return;
      }

      if (
        this._payloadLength > 0x7d ||
        (this._opcode === 0x08 && this._payloadLength === 1)
      ) {
        const error = this.createError(
          RangeError,
          `invalid payload length ${this._payloadLength}`,
          true,
          1002,
          'WS_ERR_INVALID_CONTROL_PAYLOAD_LENGTH'
        );

        cb(error);
        return;
      }
    } else {
      const error = this.createError(
        RangeError,
        `invalid opcode ${this._opcode}`,
        true,
        1002,
        'WS_ERR_INVALID_OPCODE'
      );

      cb(error);
      return;
    }

    if (!this._fin && !this._fragmented) this._fragmented = this._opcode;
    this._masked = (buf[1] & 0x80) === 0x80;

    if (this._isServer) {
      if (!this._masked) {
        const error = this.createError(
          RangeError,
          'MASK must be set',
          true,
          1002,
          'WS_ERR_EXPECTED_MASK'
        );

        cb(error);
        return;
      }
    } else if (this._masked) {
      const error = this.createError(
        RangeError,
        'MASK must be clear',
        true,
        1002,
        'WS_ERR_UNEXPECTED_MASK'
      );

      cb(error);
      return;
    }

    if (this._payloadLength === 126) this._state = GET_PAYLOAD_LENGTH_16;
    else if (this._payloadLength === 127) this._state = GET_PAYLOAD_LENGTH_64;
    else this.haveLength(cb);
  }

  /**
   * Gets extended payload length (7+16).
   *
   * @param {Function} cb Callback
   * @private
   */
  getPayloadLength16(cb) {
    if (this._bufferedBytes < 2) {
      this._loop = false;
      return;
    }

    this._payloadLength = this.consume(2).readUInt16BE(0);
    this.haveLength(cb);
  }

  /**
   * Gets extended payload length (7+64).
   *
   * @param {Function} cb Callback
   * @private
   */
  getPayloadLength64(cb) {
    if (this._bufferedBytes < 8) {
      this._loop = false;
      return;
    }

    const buf = this.consume(8);
    const num = buf.readUInt32BE(0);

    //
    // The maximum safe integer in JavaScript is 2^53 - 1. An error is returned
    // if payload length is greater than this number.
    //
    if (num > Math.pow(2, 53 - 32) - 1) {
      const error = this.createError(
        RangeError,
        'Unsupported WebSocket frame: payload length > 2^53 - 1',
        false,
        1009,
        'WS_ERR_UNSUPPORTED_DATA_PAYLOAD_LENGTH'
      );

      cb(error);
      return;
    }

    this._payloadLength = num * Math.pow(2, 32) + buf.readUInt32BE(4);
    this.haveLength(cb);
  }

  /**
   * Payload length has been read.
   *
   * @param {Function} cb Callback
   * @private
   */
  haveLength(cb) {
    if (this._payloadLength && this._opcode < 0x08) {
      this._totalPayloadLength += this._payloadLength;
      if (this._totalPayloadLength > this._maxPayload && this._maxPayload > 0) {
        const error = this.createError(
          RangeError,
          'Max payload size exceeded',
          false,
          1009,
          'WS_ERR_UNSUPPORTED_MESSAGE_LENGTH'
        );

        cb(error);
        return;
      }
    }

    if (this._masked) this._state = GET_MASK;
    else this._state = GET_DATA;
  }

  /**
   * Reads mask bytes.
   *
   * @private
   */
  getMask() {
    if (this._bufferedBytes < 4) {
      this._loop = false;
      return;
    }

    this._mask = this.consume(4);
    this._state = GET_DATA;
  }

  /**
   * Reads data bytes.
   *
   * @param {Function} cb Callback
   * @private
   */
  getData(cb) {
    let data = EMPTY_BUFFER;

    if (this._payloadLength) {
      if (this._bufferedBytes < this._payloadLength) {
        this._loop = false;
        return;
      }

      data = this.consume(this._payloadLength);

      if (
        this._masked &&
        (this._mask[0] | this._mask[1] | this._mask[2] | this._mask[3]) !== 0
      ) {
        unmask(data, this._mask);
      }
    }

    if (this._opcode > 0x07) {
      this.controlMessage(data, cb);
      return;
    }

    if (this._compressed) {
      this._state = INFLATING;
      this.decompress(data, cb);
      return;
    }

    if (data.length) {
      //
      // This message is not compressed so its length is the sum of the payload
      // length of all fragments.
      //
      this._messageLength = this._totalPayloadLength;
      this._fragments.push(data);
    }

    this.dataMessage(cb);
  }

  /**
   * Decompresses data.
   *
   * @param {Buffer} data Compressed data
   * @param {Function} cb Callback
   * @private
   */
  decompress(data, cb) {
    const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];

    perMessageDeflate.decompress(data, this._fin, (err, buf) => {
      if (err) return cb(err);

      if (buf.length) {
        this._messageLength += buf.length;
        if (this._messageLength > this._maxPayload && this._maxPayload > 0) {
          const error = this.createError(
            RangeError,
            'Max payload size exceeded',
            false,
            1009,
            'WS_ERR_UNSUPPORTED_MESSAGE_LENGTH'
          );

          cb(error);
          return;
        }

        this._fragments.push(buf);
      }

      this.dataMessage(cb);
      if (this._state === GET_INFO) this.startLoop(cb);
    });
  }

  /**
   * Handles a data message.
   *
   * @param {Function} cb Callback
   * @private
   */
  dataMessage(cb) {
    if (!this._fin) {
      this._state = GET_INFO;
      return;
    }

    const messageLength = this._messageLength;
    const fragments = this._fragments;

    this._totalPayloadLength = 0;
    this._messageLength = 0;
    this._fragmented = 0;
    this._fragments = [];

    if (this._opcode === 2) {
      let data;

      if (this._binaryType === 'nodebuffer') {
        data = concat(fragments, messageLength);
      } else if (this._binaryType === 'arraybuffer') {
        data = toArrayBuffer(concat(fragments, messageLength));
      } else {
        data = fragments;
      }

      if (this._allowSynchronousEvents) {
        this.emit('message', data, true);
        this._state = GET_INFO;
      } else {
        this._state = DEFER_EVENT;
        setImmediate(() => {
          this.emit('message', data, true);
          this._state = GET_INFO;
          this.startLoop(cb);
        });
      }
    } else {
      const buf = concat(fragments, messageLength);

      if (!this._skipUTF8Validation && !isValidUTF8(buf)) {
        const error = this.createError(
          Error,
          'invalid UTF-8 sequence',
          true,
          1007,
          'WS_ERR_INVALID_UTF8'
        );

        cb(error);
        return;
      }

      if (this._state === INFLATING || this._allowSynchronousEvents) {
        this.emit('message', buf, false);
        this._state = GET_INFO;
      } else {
        this._state = DEFER_EVENT;
        setImmediate(() => {
          this.emit('message', buf, false);
          this._state = GET_INFO;
          this.startLoop(cb);
        });
      }
    }
  }

  /**
   * Handles a control message.
   *
   * @param {Buffer} data Data to handle
   * @return {(Error|RangeError|undefined)} A possible error
   * @private
   */
  controlMessage(data, cb) {
    if (this._opcode === 0x08) {
      if (data.length === 0) {
        this._loop = false;
        this.emit('conclude', 1005, EMPTY_BUFFER);
        this.end();
      } else {
        const code = data.readUInt16BE(0);

        if (!isValidStatusCode(code)) {
          const error = this.createError(
            RangeError,
            `invalid status code ${code}`,
            true,
            1002,
            'WS_ERR_INVALID_CLOSE_CODE'
          );

          cb(error);
          return;
        }

        const buf = new FastBuffer(
          data.buffer,
          data.byteOffset + 2,
          data.length - 2
        );

        if (!this._skipUTF8Validation && !isValidUTF8(buf)) {
          const error = this.createError(
            Error,
            'invalid UTF-8 sequence',
            true,
            1007,
            'WS_ERR_INVALID_UTF8'
          );

          cb(error);
          return;
        }

        this._loop = false;
        this.emit('conclude', code, buf);
        this.end();
      }

      this._state = GET_INFO;
      return;
    }

    if (this._allowSynchronousEvents) {
      this.emit(this._opcode === 0x09 ? 'ping' : 'pong', data);
      this._state = GET_INFO;
    } else {
      this._state = DEFER_EVENT;
      setImmediate(() => {
        this.emit(this._opcode === 0x09 ? 'ping' : 'pong', data);
        this._state = GET_INFO;
        this.startLoop(cb);
      });
    }
  }

  /**
   * Builds an error object.
   *
   * @param {function(new:Error|RangeError)} ErrorCtor The error constructor
   * @param {String} message The error message
   * @param {Boolean} prefix Specifies whether or not to add a default prefix to
   *     `message`
   * @param {Number} statusCode The status code
   * @param {String} errorCode The exposed error code
   * @return {(Error|RangeError)} The error
   * @private
   */
  createError(ErrorCtor, message, prefix, statusCode, errorCode) {
    this._loop = false;
    this._errored = true;

    const err = new ErrorCtor(
      prefix ? `Invalid WebSocket frame: ${message}` : message
    );

    Error.captureStackTrace(err, this.createError);
    err.code = errorCode;
    err[kStatusCode] = statusCode;
    return err;
  }
}

module.exports = Receiver;


/***/ }),

/***/ 914:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
/* eslint no-unused-vars: ["error", { "varsIgnorePattern": "^Duplex" }] */



const { Duplex } = __webpack_require__(2203);
const { randomFillSync } = __webpack_require__(6982);

const PerMessageDeflate = __webpack_require__(2971);
const { EMPTY_BUFFER } = __webpack_require__(2614);
const { isValidStatusCode } = __webpack_require__(5880);
const { mask: applyMask, toBuffer } = __webpack_require__(3338);

const kByteLength = Symbol('kByteLength');
const maskBuffer = Buffer.alloc(4);

/**
 * HyBi Sender implementation.
 */
class Sender {
  /**
   * Creates a Sender instance.
   *
   * @param {Duplex} socket The connection socket
   * @param {Object} [extensions] An object containing the negotiated extensions
   * @param {Function} [generateMask] The function used to generate the masking
   *     key
   */
  constructor(socket, extensions, generateMask) {
    this._extensions = extensions || {};

    if (generateMask) {
      this._generateMask = generateMask;
      this._maskBuffer = Buffer.alloc(4);
    }

    this._socket = socket;

    this._firstFragment = true;
    this._compress = false;

    this._bufferedBytes = 0;
    this._deflating = false;
    this._queue = [];
  }

  /**
   * Frames a piece of data according to the HyBi WebSocket protocol.
   *
   * @param {(Buffer|String)} data The data to frame
   * @param {Object} options Options object
   * @param {Boolean} [options.fin=false] Specifies whether or not to set the
   *     FIN bit
   * @param {Function} [options.generateMask] The function used to generate the
   *     masking key
   * @param {Boolean} [options.mask=false] Specifies whether or not to mask
   *     `data`
   * @param {Buffer} [options.maskBuffer] The buffer used to store the masking
   *     key
   * @param {Number} options.opcode The opcode
   * @param {Boolean} [options.readOnly=false] Specifies whether `data` can be
   *     modified
   * @param {Boolean} [options.rsv1=false] Specifies whether or not to set the
   *     RSV1 bit
   * @return {(Buffer|String)[]} The framed data
   * @public
   */
  static frame(data, options) {
    let mask;
    let merge = false;
    let offset = 2;
    let skipMasking = false;

    if (options.mask) {
      mask = options.maskBuffer || maskBuffer;

      if (options.generateMask) {
        options.generateMask(mask);
      } else {
        randomFillSync(mask, 0, 4);
      }

      skipMasking = (mask[0] | mask[1] | mask[2] | mask[3]) === 0;
      offset = 6;
    }

    let dataLength;

    if (typeof data === 'string') {
      if (
        (!options.mask || skipMasking) &&
        options[kByteLength] !== undefined
      ) {
        dataLength = options[kByteLength];
      } else {
        data = Buffer.from(data);
        dataLength = data.length;
      }
    } else {
      dataLength = data.length;
      merge = options.mask && options.readOnly && !skipMasking;
    }

    let payloadLength = dataLength;

    if (dataLength >= 65536) {
      offset += 8;
      payloadLength = 127;
    } else if (dataLength > 125) {
      offset += 2;
      payloadLength = 126;
    }

    const target = Buffer.allocUnsafe(merge ? dataLength + offset : offset);

    target[0] = options.fin ? options.opcode | 0x80 : options.opcode;
    if (options.rsv1) target[0] |= 0x40;

    target[1] = payloadLength;

    if (payloadLength === 126) {
      target.writeUInt16BE(dataLength, 2);
    } else if (payloadLength === 127) {
      target[2] = target[3] = 0;
      target.writeUIntBE(dataLength, 4, 6);
    }

    if (!options.mask) return [target, data];

    target[1] |= 0x80;
    target[offset - 4] = mask[0];
    target[offset - 3] = mask[1];
    target[offset - 2] = mask[2];
    target[offset - 1] = mask[3];

    if (skipMasking) return [target, data];

    if (merge) {
      applyMask(data, mask, target, offset, dataLength);
      return [target];
    }

    applyMask(data, mask, data, 0, dataLength);
    return [target, data];
  }

  /**
   * Sends a close message to the other peer.
   *
   * @param {Number} [code] The status code component of the body
   * @param {(String|Buffer)} [data] The message component of the body
   * @param {Boolean} [mask=false] Specifies whether or not to mask the message
   * @param {Function} [cb] Callback
   * @public
   */
  close(code, data, mask, cb) {
    let buf;

    if (code === undefined) {
      buf = EMPTY_BUFFER;
    } else if (typeof code !== 'number' || !isValidStatusCode(code)) {
      throw new TypeError('First argument must be a valid error code number');
    } else if (data === undefined || !data.length) {
      buf = Buffer.allocUnsafe(2);
      buf.writeUInt16BE(code, 0);
    } else {
      const length = Buffer.byteLength(data);

      if (length > 123) {
        throw new RangeError('The message must not be greater than 123 bytes');
      }

      buf = Buffer.allocUnsafe(2 + length);
      buf.writeUInt16BE(code, 0);

      if (typeof data === 'string') {
        buf.write(data, 2);
      } else {
        buf.set(data, 2);
      }
    }

    const options = {
      [kByteLength]: buf.length,
      fin: true,
      generateMask: this._generateMask,
      mask,
      maskBuffer: this._maskBuffer,
      opcode: 0x08,
      readOnly: false,
      rsv1: false
    };

    if (this._deflating) {
      this.enqueue([this.dispatch, buf, false, options, cb]);
    } else {
      this.sendFrame(Sender.frame(buf, options), cb);
    }
  }

  /**
   * Sends a ping message to the other peer.
   *
   * @param {*} data The message to send
   * @param {Boolean} [mask=false] Specifies whether or not to mask `data`
   * @param {Function} [cb] Callback
   * @public
   */
  ping(data, mask, cb) {
    let byteLength;
    let readOnly;

    if (typeof data === 'string') {
      byteLength = Buffer.byteLength(data);
      readOnly = false;
    } else {
      data = toBuffer(data);
      byteLength = data.length;
      readOnly = toBuffer.readOnly;
    }

    if (byteLength > 125) {
      throw new RangeError('The data size must not be greater than 125 bytes');
    }

    const options = {
      [kByteLength]: byteLength,
      fin: true,
      generateMask: this._generateMask,
      mask,
      maskBuffer: this._maskBuffer,
      opcode: 0x09,
      readOnly,
      rsv1: false
    };

    if (this._deflating) {
      this.enqueue([this.dispatch, data, false, options, cb]);
    } else {
      this.sendFrame(Sender.frame(data, options), cb);
    }
  }

  /**
   * Sends a pong message to the other peer.
   *
   * @param {*} data The message to send
   * @param {Boolean} [mask=false] Specifies whether or not to mask `data`
   * @param {Function} [cb] Callback
   * @public
   */
  pong(data, mask, cb) {
    let byteLength;
    let readOnly;

    if (typeof data === 'string') {
      byteLength = Buffer.byteLength(data);
      readOnly = false;
    } else {
      data = toBuffer(data);
      byteLength = data.length;
      readOnly = toBuffer.readOnly;
    }

    if (byteLength > 125) {
      throw new RangeError('The data size must not be greater than 125 bytes');
    }

    const options = {
      [kByteLength]: byteLength,
      fin: true,
      generateMask: this._generateMask,
      mask,
      maskBuffer: this._maskBuffer,
      opcode: 0x0a,
      readOnly,
      rsv1: false
    };

    if (this._deflating) {
      this.enqueue([this.dispatch, data, false, options, cb]);
    } else {
      this.sendFrame(Sender.frame(data, options), cb);
    }
  }

  /**
   * Sends a data message to the other peer.
   *
   * @param {*} data The message to send
   * @param {Object} options Options object
   * @param {Boolean} [options.binary=false] Specifies whether `data` is binary
   *     or text
   * @param {Boolean} [options.compress=false] Specifies whether or not to
   *     compress `data`
   * @param {Boolean} [options.fin=false] Specifies whether the fragment is the
   *     last one
   * @param {Boolean} [options.mask=false] Specifies whether or not to mask
   *     `data`
   * @param {Function} [cb] Callback
   * @public
   */
  send(data, options, cb) {
    const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];
    let opcode = options.binary ? 2 : 1;
    let rsv1 = options.compress;

    let byteLength;
    let readOnly;

    if (typeof data === 'string') {
      byteLength = Buffer.byteLength(data);
      readOnly = false;
    } else {
      data = toBuffer(data);
      byteLength = data.length;
      readOnly = toBuffer.readOnly;
    }

    if (this._firstFragment) {
      this._firstFragment = false;
      if (
        rsv1 &&
        perMessageDeflate &&
        perMessageDeflate.params[
          perMessageDeflate._isServer
            ? 'server_no_context_takeover'
            : 'client_no_context_takeover'
        ]
      ) {
        rsv1 = byteLength >= perMessageDeflate._threshold;
      }
      this._compress = rsv1;
    } else {
      rsv1 = false;
      opcode = 0;
    }

    if (options.fin) this._firstFragment = true;

    if (perMessageDeflate) {
      const opts = {
        [kByteLength]: byteLength,
        fin: options.fin,
        generateMask: this._generateMask,
        mask: options.mask,
        maskBuffer: this._maskBuffer,
        opcode,
        readOnly,
        rsv1
      };

      if (this._deflating) {
        this.enqueue([this.dispatch, data, this._compress, opts, cb]);
      } else {
        this.dispatch(data, this._compress, opts, cb);
      }
    } else {
      this.sendFrame(
        Sender.frame(data, {
          [kByteLength]: byteLength,
          fin: options.fin,
          generateMask: this._generateMask,
          mask: options.mask,
          maskBuffer: this._maskBuffer,
          opcode,
          readOnly,
          rsv1: false
        }),
        cb
      );
    }
  }

  /**
   * Dispatches a message.
   *
   * @param {(Buffer|String)} data The message to send
   * @param {Boolean} [compress=false] Specifies whether or not to compress
   *     `data`
   * @param {Object} options Options object
   * @param {Boolean} [options.fin=false] Specifies whether or not to set the
   *     FIN bit
   * @param {Function} [options.generateMask] The function used to generate the
   *     masking key
   * @param {Boolean} [options.mask=false] Specifies whether or not to mask
   *     `data`
   * @param {Buffer} [options.maskBuffer] The buffer used to store the masking
   *     key
   * @param {Number} options.opcode The opcode
   * @param {Boolean} [options.readOnly=false] Specifies whether `data` can be
   *     modified
   * @param {Boolean} [options.rsv1=false] Specifies whether or not to set the
   *     RSV1 bit
   * @param {Function} [cb] Callback
   * @private
   */
  dispatch(data, compress, options, cb) {
    if (!compress) {
      this.sendFrame(Sender.frame(data, options), cb);
      return;
    }

    const perMessageDeflate = this._extensions[PerMessageDeflate.extensionName];

    this._bufferedBytes += options[kByteLength];
    this._deflating = true;
    perMessageDeflate.compress(data, options.fin, (_, buf) => {
      if (this._socket.destroyed) {
        const err = new Error(
          'The socket was closed while data was being compressed'
        );

        if (typeof cb === 'function') cb(err);

        for (let i = 0; i < this._queue.length; i++) {
          const params = this._queue[i];
          const callback = params[params.length - 1];

          if (typeof callback === 'function') callback(err);
        }

        return;
      }

      this._bufferedBytes -= options[kByteLength];
      this._deflating = false;
      options.readOnly = false;
      this.sendFrame(Sender.frame(buf, options), cb);
      this.dequeue();
    });
  }

  /**
   * Executes queued send operations.
   *
   * @private
   */
  dequeue() {
    while (!this._deflating && this._queue.length) {
      const params = this._queue.shift();

      this._bufferedBytes -= params[3][kByteLength];
      Reflect.apply(params[0], this, params.slice(1));
    }
  }

  /**
   * Enqueues a send operation.
   *
   * @param {Array} params Send operation parameters.
   * @private
   */
  enqueue(params) {
    this._bufferedBytes += params[3][kByteLength];
    this._queue.push(params);
  }

  /**
   * Sends a frame.
   *
   * @param {Buffer[]} list The frame to send
   * @param {Function} [cb] Callback
   * @private
   */
  sendFrame(list, cb) {
    if (list.length === 2) {
      this._socket.cork();
      this._socket.write(list[0]);
      this._socket.write(list[1], cb);
      this._socket.uncork();
    } else {
      this._socket.write(list[0], cb);
    }
  }
}

module.exports = Sender;


/***/ }),

/***/ 3719:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { Duplex } = __webpack_require__(2203);

/**
 * Emits the `'close'` event on a stream.
 *
 * @param {Duplex} stream The stream.
 * @private
 */
function emitClose(stream) {
  stream.emit('close');
}

/**
 * The listener of the `'end'` event.
 *
 * @private
 */
function duplexOnEnd() {
  if (!this.destroyed && this._writableState.finished) {
    this.destroy();
  }
}

/**
 * The listener of the `'error'` event.
 *
 * @param {Error} err The error
 * @private
 */
function duplexOnError(err) {
  this.removeListener('error', duplexOnError);
  this.destroy();
  if (this.listenerCount('error') === 0) {
    // Do not suppress the throwing behavior.
    this.emit('error', err);
  }
}

/**
 * Wraps a `WebSocket` in a duplex stream.
 *
 * @param {WebSocket} ws The `WebSocket` to wrap
 * @param {Object} [options] The options for the `Duplex` constructor
 * @return {Duplex} The duplex stream
 * @public
 */
function createWebSocketStream(ws, options) {
  let terminateOnDestroy = true;

  const duplex = new Duplex({
    ...options,
    autoDestroy: false,
    emitClose: false,
    objectMode: false,
    writableObjectMode: false
  });

  ws.on('message', function message(msg, isBinary) {
    const data =
      !isBinary && duplex._readableState.objectMode ? msg.toString() : msg;

    if (!duplex.push(data)) ws.pause();
  });

  ws.once('error', function error(err) {
    if (duplex.destroyed) return;

    // Prevent `ws.terminate()` from being called by `duplex._destroy()`.
    //
    // - If the `'error'` event is emitted before the `'open'` event, then
    //   `ws.terminate()` is a noop as no socket is assigned.
    // - Otherwise, the error is re-emitted by the listener of the `'error'`
    //   event of the `Receiver` object. The listener already closes the
    //   connection by calling `ws.close()`. This allows a close frame to be
    //   sent to the other peer. If `ws.terminate()` is called right after this,
    //   then the close frame might not be sent.
    terminateOnDestroy = false;
    duplex.destroy(err);
  });

  ws.once('close', function close() {
    if (duplex.destroyed) return;

    duplex.push(null);
  });

  duplex._destroy = function (err, callback) {
    if (ws.readyState === ws.CLOSED) {
      callback(err);
      process.nextTick(emitClose, duplex);
      return;
    }

    let called = false;

    ws.once('error', function error(err) {
      called = true;
      callback(err);
    });

    ws.once('close', function close() {
      if (!called) callback(err);
      process.nextTick(emitClose, duplex);
    });

    if (terminateOnDestroy) ws.terminate();
  };

  duplex._final = function (callback) {
    if (ws.readyState === ws.CONNECTING) {
      ws.once('open', function open() {
        duplex._final(callback);
      });
      return;
    }

    // If the value of the `_socket` property is `null` it means that `ws` is a
    // client websocket and the handshake failed. In fact, when this happens, a
    // socket is never assigned to the websocket. Wait for the `'error'` event
    // that will be emitted by the websocket.
    if (ws._socket === null) return;

    if (ws._socket._writableState.finished) {
      callback();
      if (duplex._readableState.endEmitted) duplex.destroy();
    } else {
      ws._socket.once('finish', function finish() {
        // `duplex` is not destroyed here because the `'end'` event will be
        // emitted on `duplex` after this `'finish'` event. The EOF signaling
        // `null` chunk is, in fact, pushed when the websocket emits `'close'`.
        callback();
      });
      ws.close();
    }
  };

  duplex._read = function () {
    if (ws.isPaused) ws.resume();
  };

  duplex._write = function (chunk, encoding, callback) {
    if (ws.readyState === ws.CONNECTING) {
      ws.once('open', function open() {
        duplex._write(chunk, encoding, callback);
      });
      return;
    }

    ws.send(chunk, callback);
  };

  duplex.on('end', duplexOnEnd);
  duplex.on('error', duplexOnError);
  return duplex;
}

module.exports = createWebSocketStream;


/***/ }),

/***/ 8237:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { tokenChars } = __webpack_require__(5880);

/**
 * Parses the `Sec-WebSocket-Protocol` header into a set of subprotocol names.
 *
 * @param {String} header The field value of the header
 * @return {Set} The subprotocol names
 * @public
 */
function parse(header) {
  const protocols = new Set();
  let start = -1;
  let end = -1;
  let i = 0;

  for (i; i < header.length; i++) {
    const code = header.charCodeAt(i);

    if (end === -1 && tokenChars[code] === 1) {
      if (start === -1) start = i;
    } else if (
      i !== 0 &&
      (code === 0x20 /* ' ' */ || code === 0x09) /* '\t' */
    ) {
      if (end === -1 && start !== -1) end = i;
    } else if (code === 0x2c /* ',' */) {
      if (start === -1) {
        throw new SyntaxError(`Unexpected character at index ${i}`);
      }

      if (end === -1) end = i;

      const protocol = header.slice(start, end);

      if (protocols.has(protocol)) {
        throw new SyntaxError(`The "${protocol}" subprotocol is duplicated`);
      }

      protocols.add(protocol);
      start = end = -1;
    } else {
      throw new SyntaxError(`Unexpected character at index ${i}`);
    }
  }

  if (start === -1 || end !== -1) {
    throw new SyntaxError('Unexpected end of input');
  }

  const protocol = header.slice(start, i);

  if (protocols.has(protocol)) {
    throw new SyntaxError(`The "${protocol}" subprotocol is duplicated`);
  }

  protocols.add(protocol);
  return protocols;
}

module.exports = { parse };


/***/ }),

/***/ 5880:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


const { isUtf8 } = __webpack_require__(181);

//
// Allowed token characters:
//
// '!', '#', '$', '%', '&', ''', '*', '+', '-',
// '.', 0-9, A-Z, '^', '_', '`', a-z, '|', '~'
//
// tokenChars[32] === 0 // ' '
// tokenChars[33] === 1 // '!'
// tokenChars[34] === 0 // '"'
// ...
//
// prettier-ignore
const tokenChars = [
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 0 - 15
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 16 - 31
  0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 1, 0, // 32 - 47
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, // 48 - 63
  0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 64 - 79
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, // 80 - 95
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, // 96 - 111
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0 // 112 - 127
];

/**
 * Checks if a status code is allowed in a close frame.
 *
 * @param {Number} code The status code
 * @return {Boolean} `true` if the status code is valid, else `false`
 * @public
 */
function isValidStatusCode(code) {
  return (
    (code >= 1000 &&
      code <= 1014 &&
      code !== 1004 &&
      code !== 1005 &&
      code !== 1006) ||
    (code >= 3000 && code <= 4999)
  );
}

/**
 * Checks if a given buffer contains only correct UTF-8.
 * Ported from https://www.cl.cam.ac.uk/%7Emgk25/ucs/utf8_check.c by
 * Markus Kuhn.
 *
 * @param {Buffer} buf The buffer to check
 * @return {Boolean} `true` if `buf` contains only correct UTF-8, else `false`
 * @public
 */
function _isValidUTF8(buf) {
  const len = buf.length;
  let i = 0;

  while (i < len) {
    if ((buf[i] & 0x80) === 0) {
      // 0xxxxxxx
      i++;
    } else if ((buf[i] & 0xe0) === 0xc0) {
      // 110xxxxx 10xxxxxx
      if (
        i + 1 === len ||
        (buf[i + 1] & 0xc0) !== 0x80 ||
        (buf[i] & 0xfe) === 0xc0 // Overlong
      ) {
        return false;
      }

      i += 2;
    } else if ((buf[i] & 0xf0) === 0xe0) {
      // 1110xxxx 10xxxxxx 10xxxxxx
      if (
        i + 2 >= len ||
        (buf[i + 1] & 0xc0) !== 0x80 ||
        (buf[i + 2] & 0xc0) !== 0x80 ||
        (buf[i] === 0xe0 && (buf[i + 1] & 0xe0) === 0x80) || // Overlong
        (buf[i] === 0xed && (buf[i + 1] & 0xe0) === 0xa0) // Surrogate (U+D800 - U+DFFF)
      ) {
        return false;
      }

      i += 3;
    } else if ((buf[i] & 0xf8) === 0xf0) {
      // 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
      if (
        i + 3 >= len ||
        (buf[i + 1] & 0xc0) !== 0x80 ||
        (buf[i + 2] & 0xc0) !== 0x80 ||
        (buf[i + 3] & 0xc0) !== 0x80 ||
        (buf[i] === 0xf0 && (buf[i + 1] & 0xf0) === 0x80) || // Overlong
        (buf[i] === 0xf4 && buf[i + 1] > 0x8f) ||
        buf[i] > 0xf4 // > U+10FFFF
      ) {
        return false;
      }

      i += 4;
    } else {
      return false;
    }
  }

  return true;
}

module.exports = {
  isValidStatusCode,
  isValidUTF8: _isValidUTF8,
  tokenChars
};

if (isUtf8) {
  module.exports.isValidUTF8 = function (buf) {
    return buf.length < 24 ? _isValidUTF8(buf) : isUtf8(buf);
  };
} /* istanbul ignore else  */ else if (!({"NODE_ENV":"production"}).WS_NO_UTF_8_VALIDATE) {
  try {
    const isValidUTF8 = __webpack_require__(1695);

    module.exports.isValidUTF8 = function (buf) {
      return buf.length < 32 ? _isValidUTF8(buf) : isValidUTF8(buf);
    };
  } catch (e) {
    // Continue regardless of the error.
  }
}


/***/ }),

/***/ 1722:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
/* eslint no-unused-vars: ["error", { "varsIgnorePattern": "^Duplex$", "caughtErrors": "none" }] */



const EventEmitter = __webpack_require__(4434);
const http = __webpack_require__(8611);
const { Duplex } = __webpack_require__(2203);
const { createHash } = __webpack_require__(6982);

const extension = __webpack_require__(5926);
const PerMessageDeflate = __webpack_require__(2971);
const subprotocol = __webpack_require__(8237);
const WebSocket = __webpack_require__(1060);
const { GUID, kWebSocket } = __webpack_require__(2614);

const keyRegex = /^[+/0-9A-Za-z]{22}==$/;

const RUNNING = 0;
const CLOSING = 1;
const CLOSED = 2;

/**
 * Class representing a WebSocket server.
 *
 * @extends EventEmitter
 */
class WebSocketServer extends EventEmitter {
  /**
   * Create a `WebSocketServer` instance.
   *
   * @param {Object} options Configuration options
   * @param {Boolean} [options.allowSynchronousEvents=true] Specifies whether
   *     any of the `'message'`, `'ping'`, and `'pong'` events can be emitted
   *     multiple times in the same tick
   * @param {Boolean} [options.autoPong=true] Specifies whether or not to
   *     automatically send a pong in response to a ping
   * @param {Number} [options.backlog=511] The maximum length of the queue of
   *     pending connections
   * @param {Boolean} [options.clientTracking=true] Specifies whether or not to
   *     track clients
   * @param {Function} [options.handleProtocols] A hook to handle protocols
   * @param {String} [options.host] The hostname where to bind the server
   * @param {Number} [options.maxPayload=104857600] The maximum allowed message
   *     size
   * @param {Boolean} [options.noServer=false] Enable no server mode
   * @param {String} [options.path] Accept only connections matching this path
   * @param {(Boolean|Object)} [options.perMessageDeflate=false] Enable/disable
   *     permessage-deflate
   * @param {Number} [options.port] The port where to bind the server
   * @param {(http.Server|https.Server)} [options.server] A pre-created HTTP/S
   *     server to use
   * @param {Boolean} [options.skipUTF8Validation=false] Specifies whether or
   *     not to skip UTF-8 validation for text and close messages
   * @param {Function} [options.verifyClient] A hook to reject connections
   * @param {Function} [options.WebSocket=WebSocket] Specifies the `WebSocket`
   *     class to use. It must be the `WebSocket` class or class that extends it
   * @param {Function} [callback] A listener for the `listening` event
   */
  constructor(options, callback) {
    super();

    options = {
      allowSynchronousEvents: true,
      autoPong: true,
      maxPayload: 100 * 1024 * 1024,
      skipUTF8Validation: false,
      perMessageDeflate: false,
      handleProtocols: null,
      clientTracking: true,
      verifyClient: null,
      noServer: false,
      backlog: null, // use default (511 as implemented in net.js)
      server: null,
      host: null,
      path: null,
      port: null,
      WebSocket,
      ...options
    };

    if (
      (options.port == null && !options.server && !options.noServer) ||
      (options.port != null && (options.server || options.noServer)) ||
      (options.server && options.noServer)
    ) {
      throw new TypeError(
        'One and only one of the "port", "server", or "noServer" options ' +
          'must be specified'
      );
    }

    if (options.port != null) {
      this._server = http.createServer((req, res) => {
        const body = http.STATUS_CODES[426];

        res.writeHead(426, {
          'Content-Length': body.length,
          'Content-Type': 'text/plain'
        });
        res.end(body);
      });
      this._server.listen(
        options.port,
        options.host,
        options.backlog,
        callback
      );
    } else if (options.server) {
      this._server = options.server;
    }

    if (this._server) {
      const emitConnection = this.emit.bind(this, 'connection');

      this._removeListeners = addListeners(this._server, {
        listening: this.emit.bind(this, 'listening'),
        error: this.emit.bind(this, 'error'),
        upgrade: (req, socket, head) => {
          this.handleUpgrade(req, socket, head, emitConnection);
        }
      });
    }

    if (options.perMessageDeflate === true) options.perMessageDeflate = {};
    if (options.clientTracking) {
      this.clients = new Set();
      this._shouldEmitClose = false;
    }

    this.options = options;
    this._state = RUNNING;
  }

  /**
   * Returns the bound address, the address family name, and port of the server
   * as reported by the operating system if listening on an IP socket.
   * If the server is listening on a pipe or UNIX domain socket, the name is
   * returned as a string.
   *
   * @return {(Object|String|null)} The address of the server
   * @public
   */
  address() {
    if (this.options.noServer) {
      throw new Error('The server is operating in "noServer" mode');
    }

    if (!this._server) return null;
    return this._server.address();
  }

  /**
   * Stop the server from accepting new connections and emit the `'close'` event
   * when all existing connections are closed.
   *
   * @param {Function} [cb] A one-time listener for the `'close'` event
   * @public
   */
  close(cb) {
    if (this._state === CLOSED) {
      if (cb) {
        this.once('close', () => {
          cb(new Error('The server is not running'));
        });
      }

      process.nextTick(emitClose, this);
      return;
    }

    if (cb) this.once('close', cb);

    if (this._state === CLOSING) return;
    this._state = CLOSING;

    if (this.options.noServer || this.options.server) {
      if (this._server) {
        this._removeListeners();
        this._removeListeners = this._server = null;
      }

      if (this.clients) {
        if (!this.clients.size) {
          process.nextTick(emitClose, this);
        } else {
          this._shouldEmitClose = true;
        }
      } else {
        process.nextTick(emitClose, this);
      }
    } else {
      const server = this._server;

      this._removeListeners();
      this._removeListeners = this._server = null;

      //
      // The HTTP/S server was created internally. Close it, and rely on its
      // `'close'` event.
      //
      server.close(() => {
        emitClose(this);
      });
    }
  }

  /**
   * See if a given request should be handled by this server instance.
   *
   * @param {http.IncomingMessage} req Request object to inspect
   * @return {Boolean} `true` if the request is valid, else `false`
   * @public
   */
  shouldHandle(req) {
    if (this.options.path) {
      const index = req.url.indexOf('?');
      const pathname = index !== -1 ? req.url.slice(0, index) : req.url;

      if (pathname !== this.options.path) return false;
    }

    return true;
  }

  /**
   * Handle a HTTP Upgrade request.
   *
   * @param {http.IncomingMessage} req The request object
   * @param {Duplex} socket The network socket between the server and client
   * @param {Buffer} head The first packet of the upgraded stream
   * @param {Function} cb Callback
   * @public
   */
  handleUpgrade(req, socket, head, cb) {
    socket.on('error', socketOnError);

    const key = req.headers['sec-websocket-key'];
    const version = +req.headers['sec-websocket-version'];

    if (req.method !== 'GET') {
      const message = 'Invalid HTTP method';
      abortHandshakeOrEmitwsClientError(this, req, socket, 405, message);
      return;
    }

    if (req.headers.upgrade.toLowerCase() !== 'websocket') {
      const message = 'Invalid Upgrade header';
      abortHandshakeOrEmitwsClientError(this, req, socket, 400, message);
      return;
    }

    if (!key || !keyRegex.test(key)) {
      const message = 'Missing or invalid Sec-WebSocket-Key header';
      abortHandshakeOrEmitwsClientError(this, req, socket, 400, message);
      return;
    }

    if (version !== 8 && version !== 13) {
      const message = 'Missing or invalid Sec-WebSocket-Version header';
      abortHandshakeOrEmitwsClientError(this, req, socket, 400, message);
      return;
    }

    if (!this.shouldHandle(req)) {
      abortHandshake(socket, 400);
      return;
    }

    const secWebSocketProtocol = req.headers['sec-websocket-protocol'];
    let protocols = new Set();

    if (secWebSocketProtocol !== undefined) {
      try {
        protocols = subprotocol.parse(secWebSocketProtocol);
      } catch (err) {
        const message = 'Invalid Sec-WebSocket-Protocol header';
        abortHandshakeOrEmitwsClientError(this, req, socket, 400, message);
        return;
      }
    }

    const secWebSocketExtensions = req.headers['sec-websocket-extensions'];
    const extensions = {};

    if (
      this.options.perMessageDeflate &&
      secWebSocketExtensions !== undefined
    ) {
      const perMessageDeflate = new PerMessageDeflate(
        this.options.perMessageDeflate,
        true,
        this.options.maxPayload
      );

      try {
        const offers = extension.parse(secWebSocketExtensions);

        if (offers[PerMessageDeflate.extensionName]) {
          perMessageDeflate.accept(offers[PerMessageDeflate.extensionName]);
          extensions[PerMessageDeflate.extensionName] = perMessageDeflate;
        }
      } catch (err) {
        const message =
          'Invalid or unacceptable Sec-WebSocket-Extensions header';
        abortHandshakeOrEmitwsClientError(this, req, socket, 400, message);
        return;
      }
    }

    //
    // Optionally call external client verification handler.
    //
    if (this.options.verifyClient) {
      const info = {
        origin:
          req.headers[`${version === 8 ? 'sec-websocket-origin' : 'origin'}`],
        secure: !!(req.socket.authorized || req.socket.encrypted),
        req
      };

      if (this.options.verifyClient.length === 2) {
        this.options.verifyClient(info, (verified, code, message, headers) => {
          if (!verified) {
            return abortHandshake(socket, code || 401, message, headers);
          }

          this.completeUpgrade(
            extensions,
            key,
            protocols,
            req,
            socket,
            head,
            cb
          );
        });
        return;
      }

      if (!this.options.verifyClient(info)) return abortHandshake(socket, 401);
    }

    this.completeUpgrade(extensions, key, protocols, req, socket, head, cb);
  }

  /**
   * Upgrade the connection to WebSocket.
   *
   * @param {Object} extensions The accepted extensions
   * @param {String} key The value of the `Sec-WebSocket-Key` header
   * @param {Set} protocols The subprotocols
   * @param {http.IncomingMessage} req The request object
   * @param {Duplex} socket The network socket between the server and client
   * @param {Buffer} head The first packet of the upgraded stream
   * @param {Function} cb Callback
   * @throws {Error} If called more than once with the same socket
   * @private
   */
  completeUpgrade(extensions, key, protocols, req, socket, head, cb) {
    //
    // Destroy the socket if the client has already sent a FIN packet.
    //
    if (!socket.readable || !socket.writable) return socket.destroy();

    if (socket[kWebSocket]) {
      throw new Error(
        'server.handleUpgrade() was called more than once with the same ' +
          'socket, possibly due to a misconfiguration'
      );
    }

    if (this._state > RUNNING) return abortHandshake(socket, 503);

    const digest = createHash('sha1')
      .update(key + GUID)
      .digest('base64');

    const headers = [
      'HTTP/1.1 101 Switching Protocols',
      'Upgrade: websocket',
      'Connection: Upgrade',
      `Sec-WebSocket-Accept: ${digest}`
    ];

    const ws = new this.options.WebSocket(null, undefined, this.options);

    if (protocols.size) {
      //
      // Optionally call external protocol selection handler.
      //
      const protocol = this.options.handleProtocols
        ? this.options.handleProtocols(protocols, req)
        : protocols.values().next().value;

      if (protocol) {
        headers.push(`Sec-WebSocket-Protocol: ${protocol}`);
        ws._protocol = protocol;
      }
    }

    if (extensions[PerMessageDeflate.extensionName]) {
      const params = extensions[PerMessageDeflate.extensionName].params;
      const value = extension.format({
        [PerMessageDeflate.extensionName]: [params]
      });
      headers.push(`Sec-WebSocket-Extensions: ${value}`);
      ws._extensions = extensions;
    }

    //
    // Allow external modification/inspection of handshake headers.
    //
    this.emit('headers', headers, req);

    socket.write(headers.concat('\r\n').join('\r\n'));
    socket.removeListener('error', socketOnError);

    ws.setSocket(socket, head, {
      allowSynchronousEvents: this.options.allowSynchronousEvents,
      maxPayload: this.options.maxPayload,
      skipUTF8Validation: this.options.skipUTF8Validation
    });

    if (this.clients) {
      this.clients.add(ws);
      ws.on('close', () => {
        this.clients.delete(ws);

        if (this._shouldEmitClose && !this.clients.size) {
          process.nextTick(emitClose, this);
        }
      });
    }

    cb(ws, req);
  }
}

module.exports = WebSocketServer;

/**
 * Add event listeners on an `EventEmitter` using a map of <event, listener>
 * pairs.
 *
 * @param {EventEmitter} server The event emitter
 * @param {Object.<String, Function>} map The listeners to add
 * @return {Function} A function that will remove the added listeners when
 *     called
 * @private
 */
function addListeners(server, map) {
  for (const event of Object.keys(map)) server.on(event, map[event]);

  return function removeListeners() {
    for (const event of Object.keys(map)) {
      server.removeListener(event, map[event]);
    }
  };
}

/**
 * Emit a `'close'` event on an `EventEmitter`.
 *
 * @param {EventEmitter} server The event emitter
 * @private
 */
function emitClose(server) {
  server._state = CLOSED;
  server.emit('close');
}

/**
 * Handle socket errors.
 *
 * @private
 */
function socketOnError() {
  this.destroy();
}

/**
 * Close the connection when preconditions are not fulfilled.
 *
 * @param {Duplex} socket The socket of the upgrade request
 * @param {Number} code The HTTP response status code
 * @param {String} [message] The HTTP response body
 * @param {Object} [headers] Additional HTTP response headers
 * @private
 */
function abortHandshake(socket, code, message, headers) {
  //
  // The socket is writable unless the user destroyed or ended it before calling
  // `server.handleUpgrade()` or in the `verifyClient` function, which is a user
  // error. Handling this does not make much sense as the worst that can happen
  // is that some of the data written by the user might be discarded due to the
  // call to `socket.end()` below, which triggers an `'error'` event that in
  // turn causes the socket to be destroyed.
  //
  message = message || http.STATUS_CODES[code];
  headers = {
    Connection: 'close',
    'Content-Type': 'text/html',
    'Content-Length': Buffer.byteLength(message),
    ...headers
  };

  socket.once('finish', socket.destroy);

  socket.end(
    `HTTP/1.1 ${code} ${http.STATUS_CODES[code]}\r\n` +
      Object.keys(headers)
        .map((h) => `${h}: ${headers[h]}`)
        .join('\r\n') +
      '\r\n\r\n' +
      message
  );
}

/**
 * Emit a `'wsClientError'` event on a `WebSocketServer` if there is at least
 * one listener for it, otherwise call `abortHandshake()`.
 *
 * @param {WebSocketServer} server The WebSocket server
 * @param {http.IncomingMessage} req The request object
 * @param {Duplex} socket The socket of the upgrade request
 * @param {Number} code The HTTP response status code
 * @param {String} message The HTTP response body
 * @private
 */
function abortHandshakeOrEmitwsClientError(server, req, socket, code, message) {
  if (server.listenerCount('wsClientError')) {
    const err = new Error(message);
    Error.captureStackTrace(err, abortHandshakeOrEmitwsClientError);

    server.emit('wsClientError', err, socket, req);
  } else {
    abortHandshake(socket, code, message);
  }
}


/***/ }),

/***/ 1060:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
/* eslint no-unused-vars: ["error", { "varsIgnorePattern": "^Duplex|Readable$", "caughtErrors": "none" }] */



const EventEmitter = __webpack_require__(4434);
const https = __webpack_require__(5692);
const http = __webpack_require__(8611);
const net = __webpack_require__(9278);
const tls = __webpack_require__(4756);
const { randomBytes, createHash } = __webpack_require__(6982);
const { Duplex, Readable } = __webpack_require__(2203);
const { URL } = __webpack_require__(7016);

const PerMessageDeflate = __webpack_require__(2971);
const Receiver = __webpack_require__(6286);
const Sender = __webpack_require__(914);
const {
  BINARY_TYPES,
  EMPTY_BUFFER,
  GUID,
  kForOnEventAttribute,
  kListener,
  kStatusCode,
  kWebSocket,
  NOOP
} = __webpack_require__(2614);
const {
  EventTarget: { addEventListener, removeEventListener }
} = __webpack_require__(597);
const { format, parse } = __webpack_require__(5926);
const { toBuffer } = __webpack_require__(3338);

const closeTimeout = 30 * 1000;
const kAborted = Symbol('kAborted');
const protocolVersions = [8, 13];
const readyStates = ['CONNECTING', 'OPEN', 'CLOSING', 'CLOSED'];
const subprotocolRegex = /^[!#$%&'*+\-.0-9A-Z^_`|a-z~]+$/;

/**
 * Class representing a WebSocket.
 *
 * @extends EventEmitter
 */
class WebSocket extends EventEmitter {
  /**
   * Create a new `WebSocket`.
   *
   * @param {(String|URL)} address The URL to which to connect
   * @param {(String|String[])} [protocols] The subprotocols
   * @param {Object} [options] Connection options
   */
  constructor(address, protocols, options) {
    super();

    this._binaryType = BINARY_TYPES[0];
    this._closeCode = 1006;
    this._closeFrameReceived = false;
    this._closeFrameSent = false;
    this._closeMessage = EMPTY_BUFFER;
    this._closeTimer = null;
    this._extensions = {};
    this._paused = false;
    this._protocol = '';
    this._readyState = WebSocket.CONNECTING;
    this._receiver = null;
    this._sender = null;
    this._socket = null;

    if (address !== null) {
      this._bufferedAmount = 0;
      this._isServer = false;
      this._redirects = 0;

      if (protocols === undefined) {
        protocols = [];
      } else if (!Array.isArray(protocols)) {
        if (typeof protocols === 'object' && protocols !== null) {
          options = protocols;
          protocols = [];
        } else {
          protocols = [protocols];
        }
      }

      initAsClient(this, address, protocols, options);
    } else {
      this._autoPong = options.autoPong;
      this._isServer = true;
    }
  }

  /**
   * This deviates from the WHATWG interface since ws doesn't support the
   * required default "blob" type (instead we define a custom "nodebuffer"
   * type).
   *
   * @type {String}
   */
  get binaryType() {
    return this._binaryType;
  }

  set binaryType(type) {
    if (!BINARY_TYPES.includes(type)) return;

    this._binaryType = type;

    //
    // Allow to change `binaryType` on the fly.
    //
    if (this._receiver) this._receiver._binaryType = type;
  }

  /**
   * @type {Number}
   */
  get bufferedAmount() {
    if (!this._socket) return this._bufferedAmount;

    return this._socket._writableState.length + this._sender._bufferedBytes;
  }

  /**
   * @type {String}
   */
  get extensions() {
    return Object.keys(this._extensions).join();
  }

  /**
   * @type {Boolean}
   */
  get isPaused() {
    return this._paused;
  }

  /**
   * @type {Function}
   */
  /* istanbul ignore next */
  get onclose() {
    return null;
  }

  /**
   * @type {Function}
   */
  /* istanbul ignore next */
  get onerror() {
    return null;
  }

  /**
   * @type {Function}
   */
  /* istanbul ignore next */
  get onopen() {
    return null;
  }

  /**
   * @type {Function}
   */
  /* istanbul ignore next */
  get onmessage() {
    return null;
  }

  /**
   * @type {String}
   */
  get protocol() {
    return this._protocol;
  }

  /**
   * @type {Number}
   */
  get readyState() {
    return this._readyState;
  }

  /**
   * @type {String}
   */
  get url() {
    return this._url;
  }

  /**
   * Set up the socket and the internal resources.
   *
   * @param {Duplex} socket The network socket between the server and client
   * @param {Buffer} head The first packet of the upgraded stream
   * @param {Object} options Options object
   * @param {Boolean} [options.allowSynchronousEvents=false] Specifies whether
   *     any of the `'message'`, `'ping'`, and `'pong'` events can be emitted
   *     multiple times in the same tick
   * @param {Function} [options.generateMask] The function used to generate the
   *     masking key
   * @param {Number} [options.maxPayload=0] The maximum allowed message size
   * @param {Boolean} [options.skipUTF8Validation=false] Specifies whether or
   *     not to skip UTF-8 validation for text and close messages
   * @private
   */
  setSocket(socket, head, options) {
    const receiver = new Receiver({
      allowSynchronousEvents: options.allowSynchronousEvents,
      binaryType: this.binaryType,
      extensions: this._extensions,
      isServer: this._isServer,
      maxPayload: options.maxPayload,
      skipUTF8Validation: options.skipUTF8Validation
    });

    this._sender = new Sender(socket, this._extensions, options.generateMask);
    this._receiver = receiver;
    this._socket = socket;

    receiver[kWebSocket] = this;
    socket[kWebSocket] = this;

    receiver.on('conclude', receiverOnConclude);
    receiver.on('drain', receiverOnDrain);
    receiver.on('error', receiverOnError);
    receiver.on('message', receiverOnMessage);
    receiver.on('ping', receiverOnPing);
    receiver.on('pong', receiverOnPong);

    //
    // These methods may not be available if `socket` is just a `Duplex`.
    //
    if (socket.setTimeout) socket.setTimeout(0);
    if (socket.setNoDelay) socket.setNoDelay();

    if (head.length > 0) socket.unshift(head);

    socket.on('close', socketOnClose);
    socket.on('data', socketOnData);
    socket.on('end', socketOnEnd);
    socket.on('error', socketOnError);

    this._readyState = WebSocket.OPEN;
    this.emit('open');
  }

  /**
   * Emit the `'close'` event.
   *
   * @private
   */
  emitClose() {
    if (!this._socket) {
      this._readyState = WebSocket.CLOSED;
      this.emit('close', this._closeCode, this._closeMessage);
      return;
    }

    if (this._extensions[PerMessageDeflate.extensionName]) {
      this._extensions[PerMessageDeflate.extensionName].cleanup();
    }

    this._receiver.removeAllListeners();
    this._readyState = WebSocket.CLOSED;
    this.emit('close', this._closeCode, this._closeMessage);
  }

  /**
   * Start a closing handshake.
   *
   *          +----------+   +-----------+   +----------+
   *     - - -|ws.close()|-->|close frame|-->|ws.close()|- - -
   *    |     +----------+   +-----------+   +----------+     |
   *          +----------+   +-----------+         |
   * CLOSING  |ws.close()|<--|close frame|<--+-----+       CLOSING
   *          +----------+   +-----------+   |
   *    |           |                        |   +---+        |
   *                +------------------------+-->|fin| - - - -
   *    |         +---+                      |   +---+
   *     - - - - -|fin|<---------------------+
   *              +---+
   *
   * @param {Number} [code] Status code explaining why the connection is closing
   * @param {(String|Buffer)} [data] The reason why the connection is
   *     closing
   * @public
   */
  close(code, data) {
    if (this.readyState === WebSocket.CLOSED) return;
    if (this.readyState === WebSocket.CONNECTING) {
      const msg = 'WebSocket was closed before the connection was established';
      abortHandshake(this, this._req, msg);
      return;
    }

    if (this.readyState === WebSocket.CLOSING) {
      if (
        this._closeFrameSent &&
        (this._closeFrameReceived || this._receiver._writableState.errorEmitted)
      ) {
        this._socket.end();
      }

      return;
    }

    this._readyState = WebSocket.CLOSING;
    this._sender.close(code, data, !this._isServer, (err) => {
      //
      // This error is handled by the `'error'` listener on the socket. We only
      // want to know if the close frame has been sent here.
      //
      if (err) return;

      this._closeFrameSent = true;

      if (
        this._closeFrameReceived ||
        this._receiver._writableState.errorEmitted
      ) {
        this._socket.end();
      }
    });

    //
    // Specify a timeout for the closing handshake to complete.
    //
    this._closeTimer = setTimeout(
      this._socket.destroy.bind(this._socket),
      closeTimeout
    );
  }

  /**
   * Pause the socket.
   *
   * @public
   */
  pause() {
    if (
      this.readyState === WebSocket.CONNECTING ||
      this.readyState === WebSocket.CLOSED
    ) {
      return;
    }

    this._paused = true;
    this._socket.pause();
  }

  /**
   * Send a ping.
   *
   * @param {*} [data] The data to send
   * @param {Boolean} [mask] Indicates whether or not to mask `data`
   * @param {Function} [cb] Callback which is executed when the ping is sent
   * @public
   */
  ping(data, mask, cb) {
    if (this.readyState === WebSocket.CONNECTING) {
      throw new Error('WebSocket is not open: readyState 0 (CONNECTING)');
    }

    if (typeof data === 'function') {
      cb = data;
      data = mask = undefined;
    } else if (typeof mask === 'function') {
      cb = mask;
      mask = undefined;
    }

    if (typeof data === 'number') data = data.toString();

    if (this.readyState !== WebSocket.OPEN) {
      sendAfterClose(this, data, cb);
      return;
    }

    if (mask === undefined) mask = !this._isServer;
    this._sender.ping(data || EMPTY_BUFFER, mask, cb);
  }

  /**
   * Send a pong.
   *
   * @param {*} [data] The data to send
   * @param {Boolean} [mask] Indicates whether or not to mask `data`
   * @param {Function} [cb] Callback which is executed when the pong is sent
   * @public
   */
  pong(data, mask, cb) {
    if (this.readyState === WebSocket.CONNECTING) {
      throw new Error('WebSocket is not open: readyState 0 (CONNECTING)');
    }

    if (typeof data === 'function') {
      cb = data;
      data = mask = undefined;
    } else if (typeof mask === 'function') {
      cb = mask;
      mask = undefined;
    }

    if (typeof data === 'number') data = data.toString();

    if (this.readyState !== WebSocket.OPEN) {
      sendAfterClose(this, data, cb);
      return;
    }

    if (mask === undefined) mask = !this._isServer;
    this._sender.pong(data || EMPTY_BUFFER, mask, cb);
  }

  /**
   * Resume the socket.
   *
   * @public
   */
  resume() {
    if (
      this.readyState === WebSocket.CONNECTING ||
      this.readyState === WebSocket.CLOSED
    ) {
      return;
    }

    this._paused = false;
    if (!this._receiver._writableState.needDrain) this._socket.resume();
  }

  /**
   * Send a data message.
   *
   * @param {*} data The message to send
   * @param {Object} [options] Options object
   * @param {Boolean} [options.binary] Specifies whether `data` is binary or
   *     text
   * @param {Boolean} [options.compress] Specifies whether or not to compress
   *     `data`
   * @param {Boolean} [options.fin=true] Specifies whether the fragment is the
   *     last one
   * @param {Boolean} [options.mask] Specifies whether or not to mask `data`
   * @param {Function} [cb] Callback which is executed when data is written out
   * @public
   */
  send(data, options, cb) {
    if (this.readyState === WebSocket.CONNECTING) {
      throw new Error('WebSocket is not open: readyState 0 (CONNECTING)');
    }

    if (typeof options === 'function') {
      cb = options;
      options = {};
    }

    if (typeof data === 'number') data = data.toString();

    if (this.readyState !== WebSocket.OPEN) {
      sendAfterClose(this, data, cb);
      return;
    }

    const opts = {
      binary: typeof data !== 'string',
      mask: !this._isServer,
      compress: true,
      fin: true,
      ...options
    };

    if (!this._extensions[PerMessageDeflate.extensionName]) {
      opts.compress = false;
    }

    this._sender.send(data || EMPTY_BUFFER, opts, cb);
  }

  /**
   * Forcibly close the connection.
   *
   * @public
   */
  terminate() {
    if (this.readyState === WebSocket.CLOSED) return;
    if (this.readyState === WebSocket.CONNECTING) {
      const msg = 'WebSocket was closed before the connection was established';
      abortHandshake(this, this._req, msg);
      return;
    }

    if (this._socket) {
      this._readyState = WebSocket.CLOSING;
      this._socket.destroy();
    }
  }
}

/**
 * @constant {Number} CONNECTING
 * @memberof WebSocket
 */
Object.defineProperty(WebSocket, 'CONNECTING', {
  enumerable: true,
  value: readyStates.indexOf('CONNECTING')
});

/**
 * @constant {Number} CONNECTING
 * @memberof WebSocket.prototype
 */
Object.defineProperty(WebSocket.prototype, 'CONNECTING', {
  enumerable: true,
  value: readyStates.indexOf('CONNECTING')
});

/**
 * @constant {Number} OPEN
 * @memberof WebSocket
 */
Object.defineProperty(WebSocket, 'OPEN', {
  enumerable: true,
  value: readyStates.indexOf('OPEN')
});

/**
 * @constant {Number} OPEN
 * @memberof WebSocket.prototype
 */
Object.defineProperty(WebSocket.prototype, 'OPEN', {
  enumerable: true,
  value: readyStates.indexOf('OPEN')
});

/**
 * @constant {Number} CLOSING
 * @memberof WebSocket
 */
Object.defineProperty(WebSocket, 'CLOSING', {
  enumerable: true,
  value: readyStates.indexOf('CLOSING')
});

/**
 * @constant {Number} CLOSING
 * @memberof WebSocket.prototype
 */
Object.defineProperty(WebSocket.prototype, 'CLOSING', {
  enumerable: true,
  value: readyStates.indexOf('CLOSING')
});

/**
 * @constant {Number} CLOSED
 * @memberof WebSocket
 */
Object.defineProperty(WebSocket, 'CLOSED', {
  enumerable: true,
  value: readyStates.indexOf('CLOSED')
});

/**
 * @constant {Number} CLOSED
 * @memberof WebSocket.prototype
 */
Object.defineProperty(WebSocket.prototype, 'CLOSED', {
  enumerable: true,
  value: readyStates.indexOf('CLOSED')
});

[
  'binaryType',
  'bufferedAmount',
  'extensions',
  'isPaused',
  'protocol',
  'readyState',
  'url'
].forEach((property) => {
  Object.defineProperty(WebSocket.prototype, property, { enumerable: true });
});

//
// Add the `onopen`, `onerror`, `onclose`, and `onmessage` attributes.
// See https://html.spec.whatwg.org/multipage/comms.html#the-websocket-interface
//
['open', 'error', 'close', 'message'].forEach((method) => {
  Object.defineProperty(WebSocket.prototype, `on${method}`, {
    enumerable: true,
    get() {
      for (const listener of this.listeners(method)) {
        if (listener[kForOnEventAttribute]) return listener[kListener];
      }

      return null;
    },
    set(handler) {
      for (const listener of this.listeners(method)) {
        if (listener[kForOnEventAttribute]) {
          this.removeListener(method, listener);
          break;
        }
      }

      if (typeof handler !== 'function') return;

      this.addEventListener(method, handler, {
        [kForOnEventAttribute]: true
      });
    }
  });
});

WebSocket.prototype.addEventListener = addEventListener;
WebSocket.prototype.removeEventListener = removeEventListener;

module.exports = WebSocket;

/**
 * Initialize a WebSocket client.
 *
 * @param {WebSocket} websocket The client to initialize
 * @param {(String|URL)} address The URL to which to connect
 * @param {Array} protocols The subprotocols
 * @param {Object} [options] Connection options
 * @param {Boolean} [options.allowSynchronousEvents=true] Specifies whether any
 *     of the `'message'`, `'ping'`, and `'pong'` events can be emitted multiple
 *     times in the same tick
 * @param {Boolean} [options.autoPong=true] Specifies whether or not to
 *     automatically send a pong in response to a ping
 * @param {Function} [options.finishRequest] A function which can be used to
 *     customize the headers of each http request before it is sent
 * @param {Boolean} [options.followRedirects=false] Whether or not to follow
 *     redirects
 * @param {Function} [options.generateMask] The function used to generate the
 *     masking key
 * @param {Number} [options.handshakeTimeout] Timeout in milliseconds for the
 *     handshake request
 * @param {Number} [options.maxPayload=104857600] The maximum allowed message
 *     size
 * @param {Number} [options.maxRedirects=10] The maximum number of redirects
 *     allowed
 * @param {String} [options.origin] Value of the `Origin` or
 *     `Sec-WebSocket-Origin` header
 * @param {(Boolean|Object)} [options.perMessageDeflate=true] Enable/disable
 *     permessage-deflate
 * @param {Number} [options.protocolVersion=13] Value of the
 *     `Sec-WebSocket-Version` header
 * @param {Boolean} [options.skipUTF8Validation=false] Specifies whether or
 *     not to skip UTF-8 validation for text and close messages
 * @private
 */
function initAsClient(websocket, address, protocols, options) {
  const opts = {
    allowSynchronousEvents: true,
    autoPong: true,
    protocolVersion: protocolVersions[1],
    maxPayload: 100 * 1024 * 1024,
    skipUTF8Validation: false,
    perMessageDeflate: true,
    followRedirects: false,
    maxRedirects: 10,
    ...options,
    socketPath: undefined,
    hostname: undefined,
    protocol: undefined,
    timeout: undefined,
    method: 'GET',
    host: undefined,
    path: undefined,
    port: undefined
  };

  websocket._autoPong = opts.autoPong;

  if (!protocolVersions.includes(opts.protocolVersion)) {
    throw new RangeError(
      `Unsupported protocol version: ${opts.protocolVersion} ` +
        `(supported versions: ${protocolVersions.join(', ')})`
    );
  }

  let parsedUrl;

  if (address instanceof URL) {
    parsedUrl = address;
  } else {
    try {
      parsedUrl = new URL(address);
    } catch (e) {
      throw new SyntaxError(`Invalid URL: ${address}`);
    }
  }

  if (parsedUrl.protocol === 'http:') {
    parsedUrl.protocol = 'ws:';
  } else if (parsedUrl.protocol === 'https:') {
    parsedUrl.protocol = 'wss:';
  }

  websocket._url = parsedUrl.href;

  const isSecure = parsedUrl.protocol === 'wss:';
  const isIpcUrl = parsedUrl.protocol === 'ws+unix:';
  let invalidUrlMessage;

  if (parsedUrl.protocol !== 'ws:' && !isSecure && !isIpcUrl) {
    invalidUrlMessage =
      'The URL\'s protocol must be one of "ws:", "wss:", ' +
      '"http:", "https", or "ws+unix:"';
  } else if (isIpcUrl && !parsedUrl.pathname) {
    invalidUrlMessage = "The URL's pathname is empty";
  } else if (parsedUrl.hash) {
    invalidUrlMessage = 'The URL contains a fragment identifier';
  }

  if (invalidUrlMessage) {
    const err = new SyntaxError(invalidUrlMessage);

    if (websocket._redirects === 0) {
      throw err;
    } else {
      emitErrorAndClose(websocket, err);
      return;
    }
  }

  const defaultPort = isSecure ? 443 : 80;
  const key = randomBytes(16).toString('base64');
  const request = isSecure ? https.request : http.request;
  const protocolSet = new Set();
  let perMessageDeflate;

  opts.createConnection =
    opts.createConnection || (isSecure ? tlsConnect : netConnect);
  opts.defaultPort = opts.defaultPort || defaultPort;
  opts.port = parsedUrl.port || defaultPort;
  opts.host = parsedUrl.hostname.startsWith('[')
    ? parsedUrl.hostname.slice(1, -1)
    : parsedUrl.hostname;
  opts.headers = {
    ...opts.headers,
    'Sec-WebSocket-Version': opts.protocolVersion,
    'Sec-WebSocket-Key': key,
    Connection: 'Upgrade',
    Upgrade: 'websocket'
  };
  opts.path = parsedUrl.pathname + parsedUrl.search;
  opts.timeout = opts.handshakeTimeout;

  if (opts.perMessageDeflate) {
    perMessageDeflate = new PerMessageDeflate(
      opts.perMessageDeflate !== true ? opts.perMessageDeflate : {},
      false,
      opts.maxPayload
    );
    opts.headers['Sec-WebSocket-Extensions'] = format({
      [PerMessageDeflate.extensionName]: perMessageDeflate.offer()
    });
  }
  if (protocols.length) {
    for (const protocol of protocols) {
      if (
        typeof protocol !== 'string' ||
        !subprotocolRegex.test(protocol) ||
        protocolSet.has(protocol)
      ) {
        throw new SyntaxError(
          'An invalid or duplicated subprotocol was specified'
        );
      }

      protocolSet.add(protocol);
    }

    opts.headers['Sec-WebSocket-Protocol'] = protocols.join(',');
  }
  if (opts.origin) {
    if (opts.protocolVersion < 13) {
      opts.headers['Sec-WebSocket-Origin'] = opts.origin;
    } else {
      opts.headers.Origin = opts.origin;
    }
  }
  if (parsedUrl.username || parsedUrl.password) {
    opts.auth = `${parsedUrl.username}:${parsedUrl.password}`;
  }

  if (isIpcUrl) {
    const parts = opts.path.split(':');

    opts.socketPath = parts[0];
    opts.path = parts[1];
  }

  let req;

  if (opts.followRedirects) {
    if (websocket._redirects === 0) {
      websocket._originalIpc = isIpcUrl;
      websocket._originalSecure = isSecure;
      websocket._originalHostOrSocketPath = isIpcUrl
        ? opts.socketPath
        : parsedUrl.host;

      const headers = options && options.headers;

      //
      // Shallow copy the user provided options so that headers can be changed
      // without mutating the original object.
      //
      options = { ...options, headers: {} };

      if (headers) {
        for (const [key, value] of Object.entries(headers)) {
          options.headers[key.toLowerCase()] = value;
        }
      }
    } else if (websocket.listenerCount('redirect') === 0) {
      const isSameHost = isIpcUrl
        ? websocket._originalIpc
          ? opts.socketPath === websocket._originalHostOrSocketPath
          : false
        : websocket._originalIpc
          ? false
          : parsedUrl.host === websocket._originalHostOrSocketPath;

      if (!isSameHost || (websocket._originalSecure && !isSecure)) {
        //
        // Match curl 7.77.0 behavior and drop the following headers. These
        // headers are also dropped when following a redirect to a subdomain.
        //
        delete opts.headers.authorization;
        delete opts.headers.cookie;

        if (!isSameHost) delete opts.headers.host;

        opts.auth = undefined;
      }
    }

    //
    // Match curl 7.77.0 behavior and make the first `Authorization` header win.
    // If the `Authorization` header is set, then there is nothing to do as it
    // will take precedence.
    //
    if (opts.auth && !options.headers.authorization) {
      options.headers.authorization =
        'Basic ' + Buffer.from(opts.auth).toString('base64');
    }

    req = websocket._req = request(opts);

    if (websocket._redirects) {
      //
      // Unlike what is done for the `'upgrade'` event, no early exit is
      // triggered here if the user calls `websocket.close()` or
      // `websocket.terminate()` from a listener of the `'redirect'` event. This
      // is because the user can also call `request.destroy()` with an error
      // before calling `websocket.close()` or `websocket.terminate()` and this
      // would result in an error being emitted on the `request` object with no
      // `'error'` event listeners attached.
      //
      websocket.emit('redirect', websocket.url, req);
    }
  } else {
    req = websocket._req = request(opts);
  }

  if (opts.timeout) {
    req.on('timeout', () => {
      abortHandshake(websocket, req, 'Opening handshake has timed out');
    });
  }

  req.on('error', (err) => {
    if (req === null || req[kAborted]) return;

    req = websocket._req = null;
    emitErrorAndClose(websocket, err);
  });

  req.on('response', (res) => {
    const location = res.headers.location;
    const statusCode = res.statusCode;

    if (
      location &&
      opts.followRedirects &&
      statusCode >= 300 &&
      statusCode < 400
    ) {
      if (++websocket._redirects > opts.maxRedirects) {
        abortHandshake(websocket, req, 'Maximum redirects exceeded');
        return;
      }

      req.abort();

      let addr;

      try {
        addr = new URL(location, address);
      } catch (e) {
        const err = new SyntaxError(`Invalid URL: ${location}`);
        emitErrorAndClose(websocket, err);
        return;
      }

      initAsClient(websocket, addr, protocols, options);
    } else if (!websocket.emit('unexpected-response', req, res)) {
      abortHandshake(
        websocket,
        req,
        `Unexpected server response: ${res.statusCode}`
      );
    }
  });

  req.on('upgrade', (res, socket, head) => {
    websocket.emit('upgrade', res);

    //
    // The user may have closed the connection from a listener of the
    // `'upgrade'` event.
    //
    if (websocket.readyState !== WebSocket.CONNECTING) return;

    req = websocket._req = null;

    if (res.headers.upgrade.toLowerCase() !== 'websocket') {
      abortHandshake(websocket, socket, 'Invalid Upgrade header');
      return;
    }

    const digest = createHash('sha1')
      .update(key + GUID)
      .digest('base64');

    if (res.headers['sec-websocket-accept'] !== digest) {
      abortHandshake(websocket, socket, 'Invalid Sec-WebSocket-Accept header');
      return;
    }

    const serverProt = res.headers['sec-websocket-protocol'];
    let protError;

    if (serverProt !== undefined) {
      if (!protocolSet.size) {
        protError = 'Server sent a subprotocol but none was requested';
      } else if (!protocolSet.has(serverProt)) {
        protError = 'Server sent an invalid subprotocol';
      }
    } else if (protocolSet.size) {
      protError = 'Server sent no subprotocol';
    }

    if (protError) {
      abortHandshake(websocket, socket, protError);
      return;
    }

    if (serverProt) websocket._protocol = serverProt;

    const secWebSocketExtensions = res.headers['sec-websocket-extensions'];

    if (secWebSocketExtensions !== undefined) {
      if (!perMessageDeflate) {
        const message =
          'Server sent a Sec-WebSocket-Extensions header but no extension ' +
          'was requested';
        abortHandshake(websocket, socket, message);
        return;
      }

      let extensions;

      try {
        extensions = parse(secWebSocketExtensions);
      } catch (err) {
        const message = 'Invalid Sec-WebSocket-Extensions header';
        abortHandshake(websocket, socket, message);
        return;
      }

      const extensionNames = Object.keys(extensions);

      if (
        extensionNames.length !== 1 ||
        extensionNames[0] !== PerMessageDeflate.extensionName
      ) {
        const message = 'Server indicated an extension that was not requested';
        abortHandshake(websocket, socket, message);
        return;
      }

      try {
        perMessageDeflate.accept(extensions[PerMessageDeflate.extensionName]);
      } catch (err) {
        const message = 'Invalid Sec-WebSocket-Extensions header';
        abortHandshake(websocket, socket, message);
        return;
      }

      websocket._extensions[PerMessageDeflate.extensionName] =
        perMessageDeflate;
    }

    websocket.setSocket(socket, head, {
      allowSynchronousEvents: opts.allowSynchronousEvents,
      generateMask: opts.generateMask,
      maxPayload: opts.maxPayload,
      skipUTF8Validation: opts.skipUTF8Validation
    });
  });

  if (opts.finishRequest) {
    opts.finishRequest(req, websocket);
  } else {
    req.end();
  }
}

/**
 * Emit the `'error'` and `'close'` events.
 *
 * @param {WebSocket} websocket The WebSocket instance
 * @param {Error} The error to emit
 * @private
 */
function emitErrorAndClose(websocket, err) {
  websocket._readyState = WebSocket.CLOSING;
  websocket.emit('error', err);
  websocket.emitClose();
}

/**
 * Create a `net.Socket` and initiate a connection.
 *
 * @param {Object} options Connection options
 * @return {net.Socket} The newly created socket used to start the connection
 * @private
 */
function netConnect(options) {
  options.path = options.socketPath;
  return net.connect(options);
}

/**
 * Create a `tls.TLSSocket` and initiate a connection.
 *
 * @param {Object} options Connection options
 * @return {tls.TLSSocket} The newly created socket used to start the connection
 * @private
 */
function tlsConnect(options) {
  options.path = undefined;

  if (!options.servername && options.servername !== '') {
    options.servername = net.isIP(options.host) ? '' : options.host;
  }

  return tls.connect(options);
}

/**
 * Abort the handshake and emit an error.
 *
 * @param {WebSocket} websocket The WebSocket instance
 * @param {(http.ClientRequest|net.Socket|tls.Socket)} stream The request to
 *     abort or the socket to destroy
 * @param {String} message The error message
 * @private
 */
function abortHandshake(websocket, stream, message) {
  websocket._readyState = WebSocket.CLOSING;

  const err = new Error(message);
  Error.captureStackTrace(err, abortHandshake);

  if (stream.setHeader) {
    stream[kAborted] = true;
    stream.abort();

    if (stream.socket && !stream.socket.destroyed) {
      //
      // On Node.js >= 14.3.0 `request.abort()` does not destroy the socket if
      // called after the request completed. See
      // https://github.com/websockets/ws/issues/1869.
      //
      stream.socket.destroy();
    }

    process.nextTick(emitErrorAndClose, websocket, err);
  } else {
    stream.destroy(err);
    stream.once('error', websocket.emit.bind(websocket, 'error'));
    stream.once('close', websocket.emitClose.bind(websocket));
  }
}

/**
 * Handle cases where the `ping()`, `pong()`, or `send()` methods are called
 * when the `readyState` attribute is `CLOSING` or `CLOSED`.
 *
 * @param {WebSocket} websocket The WebSocket instance
 * @param {*} [data] The data to send
 * @param {Function} [cb] Callback
 * @private
 */
function sendAfterClose(websocket, data, cb) {
  if (data) {
    const length = toBuffer(data).length;

    //
    // The `_bufferedAmount` property is used only when the peer is a client and
    // the opening handshake fails. Under these circumstances, in fact, the
    // `setSocket()` method is not called, so the `_socket` and `_sender`
    // properties are set to `null`.
    //
    if (websocket._socket) websocket._sender._bufferedBytes += length;
    else websocket._bufferedAmount += length;
  }

  if (cb) {
    const err = new Error(
      `WebSocket is not open: readyState ${websocket.readyState} ` +
        `(${readyStates[websocket.readyState]})`
    );
    process.nextTick(cb, err);
  }
}

/**
 * The listener of the `Receiver` `'conclude'` event.
 *
 * @param {Number} code The status code
 * @param {Buffer} reason The reason for closing
 * @private
 */
function receiverOnConclude(code, reason) {
  const websocket = this[kWebSocket];

  websocket._closeFrameReceived = true;
  websocket._closeMessage = reason;
  websocket._closeCode = code;

  if (websocket._socket[kWebSocket] === undefined) return;

  websocket._socket.removeListener('data', socketOnData);
  process.nextTick(resume, websocket._socket);

  if (code === 1005) websocket.close();
  else websocket.close(code, reason);
}

/**
 * The listener of the `Receiver` `'drain'` event.
 *
 * @private
 */
function receiverOnDrain() {
  const websocket = this[kWebSocket];

  if (!websocket.isPaused) websocket._socket.resume();
}

/**
 * The listener of the `Receiver` `'error'` event.
 *
 * @param {(RangeError|Error)} err The emitted error
 * @private
 */
function receiverOnError(err) {
  const websocket = this[kWebSocket];

  if (websocket._socket[kWebSocket] !== undefined) {
    websocket._socket.removeListener('data', socketOnData);

    //
    // On Node.js < 14.0.0 the `'error'` event is emitted synchronously. See
    // https://github.com/websockets/ws/issues/1940.
    //
    process.nextTick(resume, websocket._socket);

    websocket.close(err[kStatusCode]);
  }

  websocket.emit('error', err);
}

/**
 * The listener of the `Receiver` `'finish'` event.
 *
 * @private
 */
function receiverOnFinish() {
  this[kWebSocket].emitClose();
}

/**
 * The listener of the `Receiver` `'message'` event.
 *
 * @param {Buffer|ArrayBuffer|Buffer[])} data The message
 * @param {Boolean} isBinary Specifies whether the message is binary or not
 * @private
 */
function receiverOnMessage(data, isBinary) {
  this[kWebSocket].emit('message', data, isBinary);
}

/**
 * The listener of the `Receiver` `'ping'` event.
 *
 * @param {Buffer} data The data included in the ping frame
 * @private
 */
function receiverOnPing(data) {
  const websocket = this[kWebSocket];

  if (websocket._autoPong) websocket.pong(data, !this._isServer, NOOP);
  websocket.emit('ping', data);
}

/**
 * The listener of the `Receiver` `'pong'` event.
 *
 * @param {Buffer} data The data included in the pong frame
 * @private
 */
function receiverOnPong(data) {
  this[kWebSocket].emit('pong', data);
}

/**
 * Resume a readable stream
 *
 * @param {Readable} stream The readable stream
 * @private
 */
function resume(stream) {
  stream.resume();
}

/**
 * The listener of the socket `'close'` event.
 *
 * @private
 */
function socketOnClose() {
  const websocket = this[kWebSocket];

  this.removeListener('close', socketOnClose);
  this.removeListener('data', socketOnData);
  this.removeListener('end', socketOnEnd);

  websocket._readyState = WebSocket.CLOSING;

  let chunk;

  //
  // The close frame might not have been received or the `'end'` event emitted,
  // for example, if the socket was destroyed due to an error. Ensure that the
  // `receiver` stream is closed after writing any remaining buffered data to
  // it. If the readable side of the socket is in flowing mode then there is no
  // buffered data as everything has been already written and `readable.read()`
  // will return `null`. If instead, the socket is paused, any possible buffered
  // data will be read as a single chunk.
  //
  if (
    !this._readableState.endEmitted &&
    !websocket._closeFrameReceived &&
    !websocket._receiver._writableState.errorEmitted &&
    (chunk = websocket._socket.read()) !== null
  ) {
    websocket._receiver.write(chunk);
  }

  websocket._receiver.end();

  this[kWebSocket] = undefined;

  clearTimeout(websocket._closeTimer);

  if (
    websocket._receiver._writableState.finished ||
    websocket._receiver._writableState.errorEmitted
  ) {
    websocket.emitClose();
  } else {
    websocket._receiver.on('error', receiverOnFinish);
    websocket._receiver.on('finish', receiverOnFinish);
  }
}

/**
 * The listener of the socket `'data'` event.
 *
 * @param {Buffer} chunk A chunk of data
 * @private
 */
function socketOnData(chunk) {
  if (!this[kWebSocket]._receiver.write(chunk)) {
    this.pause();
  }
}

/**
 * The listener of the socket `'end'` event.
 *
 * @private
 */
function socketOnEnd() {
  const websocket = this[kWebSocket];

  websocket._readyState = WebSocket.CLOSING;
  websocket._receiver.end();
  this.end();
}

/**
 * The listener of the socket `'error'` event.
 *
 * @private
 */
function socketOnError() {
  const websocket = this[kWebSocket];

  this.removeListener('error', socketOnError);
  this.on('error', NOOP);

  if (websocket) {
    websocket._readyState = WebSocket.CLOSING;
    this.destroy();
  }
}


/***/ }),

/***/ 6395:
/***/ ((module) => {

"use strict";
module.exports = require("../build/Release/qrc_decode.node");

/***/ }),

/***/ 6608:
/***/ ((module) => {

"use strict";
module.exports = require("bufferutil");

/***/ }),

/***/ 1695:
/***/ ((module) => {

"use strict";
module.exports = require("utf-8-validate");

/***/ }),

/***/ 2613:
/***/ ((module) => {

"use strict";
module.exports = require("assert");

/***/ }),

/***/ 181:
/***/ ((module) => {

"use strict";
module.exports = require("buffer");

/***/ }),

/***/ 5317:
/***/ ((module) => {

"use strict";
module.exports = require("child_process");

/***/ }),

/***/ 9140:
/***/ ((module) => {

"use strict";
module.exports = require("constants");

/***/ }),

/***/ 6982:
/***/ ((module) => {

"use strict";
module.exports = require("crypto");

/***/ }),

/***/ 4157:
/***/ ((module) => {

"use strict";
module.exports = require("electron");

/***/ }),

/***/ 4434:
/***/ ((module) => {

"use strict";
module.exports = require("events");

/***/ }),

/***/ 9896:
/***/ ((module) => {

"use strict";
module.exports = require("fs");

/***/ }),

/***/ 8611:
/***/ ((module) => {

"use strict";
module.exports = require("http");

/***/ }),

/***/ 5692:
/***/ ((module) => {

"use strict";
module.exports = require("https");

/***/ }),

/***/ 9278:
/***/ ((module) => {

"use strict";
module.exports = require("net");

/***/ }),

/***/ 857:
/***/ ((module) => {

"use strict";
module.exports = require("os");

/***/ }),

/***/ 6928:
/***/ ((module) => {

"use strict";
module.exports = require("path");

/***/ }),

/***/ 3480:
/***/ ((module) => {

"use strict";
module.exports = require("querystring");

/***/ }),

/***/ 2203:
/***/ ((module) => {

"use strict";
module.exports = require("stream");

/***/ }),

/***/ 3193:
/***/ ((module) => {

"use strict";
module.exports = require("string_decoder");

/***/ }),

/***/ 4756:
/***/ ((module) => {

"use strict";
module.exports = require("tls");

/***/ }),

/***/ 2018:
/***/ ((module) => {

"use strict";
module.exports = require("tty");

/***/ }),

/***/ 7016:
/***/ ((module) => {

"use strict";
module.exports = require("url");

/***/ }),

/***/ 9023:
/***/ ((module) => {

"use strict";
module.exports = require("util");

/***/ }),

/***/ 3106:
/***/ ((module) => {

"use strict";
module.exports = require("zlib");

/***/ }),

/***/ 3267:
/***/ ((module) => {

"use strict";
module.exports = /*#__PURE__*/JSON.parse('[["8740","䏰䰲䘃䖦䕸𧉧䵷䖳𧲱䳢𧳅㮕䜶䝄䱇䱀𤊿𣘗𧍒𦺋𧃒䱗𪍑䝏䗚䲅𧱬䴇䪤䚡𦬣爥𥩔𡩣𣸆𣽡晍囻"],["8767","綕夝𨮹㷴霴𧯯寛𡵞媤㘥𩺰嫑宷峼杮薓𩥅瑡璝㡵𡵓𣚞𦀡㻬"],["87a1","𥣞㫵竼龗𤅡𨤍𣇪𠪊𣉞䌊蒄龖鐯䤰蘓墖靊鈘秐稲晠権袝瑌篅枂稬剏遆㓦珄𥶹瓆鿇垳䤯呌䄱𣚎堘穲𧭥讏䚮𦺈䆁𥶙箮𢒼鿈𢓁𢓉𢓌鿉蔄𣖻䂴鿊䓡𪷿拁灮鿋"],["8840","㇀",4,"𠄌㇅𠃑𠃍㇆㇇𠃋𡿨㇈𠃊㇉㇊㇋㇌𠄎㇍㇎ĀÁǍÀĒÉĚÈŌÓǑÒ࿿Ê̄Ế࿿Ê̌ỀÊāáǎàɑēéěèīíǐìōóǒòūúǔùǖǘǚ"],["88a1","ǜü࿿ê̄ế࿿ê̌ềêɡ⏚⏛"],["8940","𪎩𡅅"],["8943","攊"],["8946","丽滝鵎釟"],["894c","𧜵撑会伨侨兖兴农凤务动医华发变团声处备夲头学实実岚庆总斉柾栄桥济炼电纤纬纺织经统缆缷艺苏药视设询车轧轮"],["89a1","琑糼緍楆竉刧"],["89ab","醌碸酞肼"],["89b0","贋胶𠧧"],["89b5","肟黇䳍鷉鸌䰾𩷶𧀎鸊𪄳㗁"],["89c1","溚舾甙"],["89c5","䤑马骏龙禇𨑬𡷊𠗐𢫦两亁亀亇亿仫伷㑌侽㹈倃傈㑽㒓㒥円夅凛凼刅争剹劐匧㗇厩㕑厰㕓参吣㕭㕲㚁咓咣咴咹哐哯唘唣唨㖘唿㖥㖿嗗㗅"],["8a40","𧶄唥"],["8a43","𠱂𠴕𥄫喐𢳆㧬𠍁蹆𤶸𩓥䁓𨂾睺𢰸㨴䟕𨅝𦧲𤷪擝𠵼𠾴𠳕𡃴撍蹾𠺖𠰋𠽤𢲩𨉖𤓓"],["8a64","𠵆𩩍𨃩䟴𤺧𢳂骲㩧𩗴㿭㔆𥋇𩟔𧣈𢵄鵮頕"],["8a76","䏙𦂥撴哣𢵌𢯊𡁷㧻𡁯"],["8aa1","𦛚𦜖𧦠擪𥁒𠱃蹨𢆡𨭌𠜱"],["8aac","䠋𠆩㿺塳𢶍"],["8ab2","𤗈𠓼𦂗𠽌𠶖啹䂻䎺"],["8abb","䪴𢩦𡂝膪飵𠶜捹㧾𢝵跀嚡摼㹃"],["8ac9","𪘁𠸉𢫏𢳉"],["8ace","𡃈𣧂㦒㨆𨊛㕸𥹉𢃇噒𠼱𢲲𩜠㒼氽𤸻"],["8adf","𧕴𢺋𢈈𪙛𨳍𠹺𠰴𦠜羓𡃏𢠃𢤹㗻𥇣𠺌𠾍𠺪㾓𠼰𠵇𡅏𠹌"],["8af6","𠺫𠮩𠵈𡃀𡄽㿹𢚖搲𠾭"],["8b40","𣏴𧘹𢯎𠵾𠵿𢱑𢱕㨘𠺘𡃇𠼮𪘲𦭐𨳒𨶙𨳊閪哌苄喹"],["8b55","𩻃鰦骶𧝞𢷮煀腭胬尜𦕲脴㞗卟𨂽醶𠻺𠸏𠹷𠻻㗝𤷫㘉𠳖嚯𢞵𡃉𠸐𠹸𡁸𡅈𨈇𡑕𠹹𤹐𢶤婔𡀝𡀞𡃵𡃶垜𠸑"],["8ba1","𧚔𨋍𠾵𠹻𥅾㜃𠾶𡆀𥋘𪊽𤧚𡠺𤅷𨉼墙剨㘚𥜽箲孨䠀䬬鼧䧧鰟鮍𥭴𣄽嗻㗲嚉丨夂𡯁屮靑𠂆乛亻㔾尣彑忄㣺扌攵歺氵氺灬爫丬犭𤣩罒礻糹罓𦉪㓁"],["8bde","𦍋耂肀𦘒𦥑卝衤见𧢲讠贝钅镸长门𨸏韦页风飞饣𩠐鱼鸟黄歯龜丷𠂇阝户钢"],["8c40","倻淾𩱳龦㷉袏𤅎灷峵䬠𥇍㕙𥴰愢𨨲辧釶熑朙玺𣊁𪄇㲋𡦀䬐磤琂冮𨜏䀉橣𪊺䈣蘏𠩯稪𩥇𨫪靕灍匤𢁾鏴盙𨧣龧矝亣俰傼丯众龨吴綋墒壐𡶶庒庙忂𢜒斋"],["8ca1","𣏹椙橃𣱣泿"],["8ca7","爀𤔅玌㻛𤨓嬕璹讃𥲤𥚕窓篬糃繬苸薗龩袐龪躹龫迏蕟駠鈡龬𨶹𡐿䁱䊢娚"],["8cc9","顨杫䉶圽"],["8cce","藖𤥻芿𧄍䲁𦵴嵻𦬕𦾾龭龮宖龯曧繛湗秊㶈䓃𣉖𢞖䎚䔶"],["8ce6","峕𣬚諹屸㴒𣕑嵸龲煗䕘𤃬𡸣䱷㥸㑊𠆤𦱁諌侴𠈹妿腬顖𩣺弻"],["8d40","𠮟"],["8d42","𢇁𨥭䄂䚻𩁹㼇龳𪆵䃸㟖䛷𦱆䅼𨚲𧏿䕭㣔𥒚䕡䔛䶉䱻䵶䗪㿈𤬏㙡䓞䒽䇭崾嵈嵖㷼㠏嶤嶹㠠㠸幂庽弥徃㤈㤔㤿㥍惗愽峥㦉憷憹懏㦸戬抐拥挘㧸嚱"],["8da1","㨃揢揻搇摚㩋擀崕嘡龟㪗斆㪽旿晓㫲暒㬢朖㭂枤栀㭘桊梄㭲㭱㭻椉楃牜楤榟榅㮼槖㯝橥橴橱檂㯬檙㯲檫檵櫔櫶殁毁毪汵沪㳋洂洆洦涁㳯涤涱渕渘温溆𨧀溻滢滚齿滨滩漤漴㵆𣽁澁澾㵪㵵熷岙㶊瀬㶑灐灔灯灿炉𠌥䏁㗱𠻘"],["8e40","𣻗垾𦻓焾𥟠㙎榢𨯩孴穉𥣡𩓙穥穽𥦬窻窰竂竃燑𦒍䇊竚竝竪䇯咲𥰁笋筕笩𥌎𥳾箢筯莜𥮴𦱿篐萡箒箸𥴠㶭𥱥蒒篺簆簵𥳁籄粃𤢂粦晽𤕸糉糇糦籴糳糵糎"],["8ea1","繧䔝𦹄絝𦻖璍綉綫焵綳緒𤁗𦀩緤㴓緵𡟹緥𨍭縝𦄡𦅚繮纒䌫鑬縧罀罁罇礶𦋐駡羗𦍑羣𡙡𠁨䕜𣝦䔃𨌺翺𦒉者耈耝耨耯𪂇𦳃耻耼聡𢜔䦉𦘦𣷣𦛨朥肧𨩈脇脚墰𢛶汿𦒘𤾸擧𡒊舘𡡞橓𤩥𤪕䑺舩𠬍𦩒𣵾俹𡓽蓢荢𦬊𤦧𣔰𡝳𣷸芪椛芳䇛"],["8f40","蕋苐茚𠸖𡞴㛁𣅽𣕚艻苢茘𣺋𦶣𦬅𦮗𣗎㶿茝嗬莅䔋𦶥莬菁菓㑾𦻔橗蕚㒖𦹂𢻯葘𥯤葱㷓䓤檧葊𣲵祘蒨𦮖𦹷𦹃蓞萏莑䒠蒓蓤𥲑䉀𥳀䕃蔴嫲𦺙䔧蕳䔖枿蘖"],["8fa1","𨘥𨘻藁𧂈蘂𡖂𧃍䕫䕪蘨㙈𡢢号𧎚虾蝱𪃸蟮𢰧螱蟚蠏噡虬桖䘏衅衆𧗠𣶹𧗤衞袜䙛袴袵揁装睷𧜏覇覊覦覩覧覼𨨥觧𧤤𧪽誜瞓釾誐𧩙竩𧬺𣾏䜓𧬸煼謌謟𥐰𥕥謿譌譍誩𤩺讐讛誯𡛟䘕衏貛𧵔𧶏貫㜥𧵓賖𧶘𧶽贒贃𡤐賛灜贑𤳉㻐起"],["9040","趩𨀂𡀔𤦊㭼𨆼𧄌竧躭躶軃鋔輙輭𨍥𨐒辥錃𪊟𠩐辳䤪𨧞𨔽𣶻廸𣉢迹𪀔𨚼𨔁𢌥㦀𦻗逷𨔼𧪾遡𨕬𨘋邨𨜓郄𨛦邮都酧㫰醩釄粬𨤳𡺉鈎沟鉁鉢𥖹銹𨫆𣲛𨬌𥗛"],["90a1","𠴱錬鍫𨫡𨯫炏嫃𨫢𨫥䥥鉄𨯬𨰹𨯿鍳鑛躼閅閦鐦閠濶䊹𢙺𨛘𡉼𣸮䧟氜陻隖䅬隣𦻕懚隶磵𨫠隽双䦡𦲸𠉴𦐐𩂯𩃥𤫑𡤕𣌊霱虂霶䨏䔽䖅𤫩灵孁霛靜𩇕靗孊𩇫靟鐥僐𣂷𣂼鞉鞟鞱鞾韀韒韠𥑬韮琜𩐳響韵𩐝𧥺䫑頴頳顋顦㬎𧅵㵑𠘰𤅜"],["9140","𥜆飊颷飈飇䫿𦴧𡛓喰飡飦飬鍸餹𤨩䭲𩡗𩤅駵騌騻騐驘𥜥㛄𩂱𩯕髠髢𩬅髴䰎鬔鬭𨘀倴鬴𦦨㣃𣁽魐魀𩴾婅𡡣鮎𤉋鰂鯿鰌𩹨鷔𩾷𪆒𪆫𪃡𪄣𪇟鵾鶃𪄴鸎梈"],["91a1","鷄𢅛𪆓𪈠𡤻𪈳鴹𪂹𪊴麐麕麞麢䴴麪麯𤍤黁㭠㧥㴝伲㞾𨰫鼂鼈䮖鐤𦶢鼗鼖鼹嚟嚊齅馸𩂋韲葿齢齩竜龎爖䮾𤥵𤦻煷𤧸𤍈𤩑玞𨯚𡣺禟𨥾𨸶鍩鏳𨩄鋬鎁鏋𨥬𤒹爗㻫睲穃烐𤑳𤏸煾𡟯炣𡢾𣖙㻇𡢅𥐯𡟸㜢𡛻𡠹㛡𡝴𡣑𥽋㜣𡛀坛𤨥𡏾𡊨"],["9240","𡏆𡒶蔃𣚦蔃葕𤦔𧅥𣸱𥕜𣻻𧁒䓴𣛮𩦝𦼦柹㜳㰕㷧塬𡤢栐䁗𣜿𤃡𤂋𤄏𦰡哋嚞𦚱嚒𠿟𠮨𠸍鏆𨬓鎜仸儫㠙𤐶亼𠑥𠍿佋侊𥙑婨𠆫𠏋㦙𠌊𠐔㐵伩𠋀𨺳𠉵諚𠈌亘"],["92a1","働儍侢伃𤨎𣺊佂倮偬傁俌俥偘僼兙兛兝兞湶𣖕𣸹𣺿浲𡢄𣺉冨凃𠗠䓝𠒣𠒒𠒑赺𨪜𠜎剙劤𠡳勡鍮䙺熌𤎌𠰠𤦬𡃤槑𠸝瑹㻞璙琔瑖玘䮎𤪼𤂍叐㖄爏𤃉喴𠍅响𠯆圝鉝雴鍦埝垍坿㘾壋媙𨩆𡛺𡝯𡜐娬妸銏婾嫏娒𥥆𡧳𡡡𤊕㛵洅瑃娡𥺃"],["9340","媁𨯗𠐓鏠璌𡌃焅䥲鐈𨧻鎽㞠尞岞幞幈𡦖𡥼𣫮廍孏𡤃𡤄㜁𡢠㛝𡛾㛓脪𨩇𡶺𣑲𨦨弌弎𡤧𡞫婫𡜻孄蘔𧗽衠恾𢡠𢘫忛㺸𢖯𢖾𩂈𦽳懀𠀾𠁆𢘛憙憘恵𢲛𢴇𤛔𩅍"],["93a1","摱𤙥𢭪㨩𢬢𣑐𩣪𢹸挷𪑛撶挱揑𤧣𢵧护𢲡搻敫楲㯴𣂎𣊭𤦉𣊫唍𣋠𡣙𩐿曎𣊉𣆳㫠䆐𥖄𨬢𥖏𡛼𥕛𥐥磮𣄃𡠪𣈴㑤𣈏𣆂𤋉暎𦴤晫䮓昰𧡰𡷫晣𣋒𣋡昞𥡲㣑𣠺𣞼㮙𣞢𣏾瓐㮖枏𤘪梶栞㯄檾㡣𣟕𤒇樳橒櫉欅𡤒攑梘橌㯗橺歗𣿀𣲚鎠鋲𨯪𨫋"],["9440","銉𨀞𨧜鑧涥漋𤧬浧𣽿㶏渄𤀼娽渊塇洤硂焻𤌚𤉶烱牐犇犔𤞏𤜥兹𤪤𠗫瑺𣻸𣙟𤩊𤤗𥿡㼆㺱𤫟𨰣𣼵悧㻳瓌琼鎇琷䒟𦷪䕑疃㽣𤳙𤴆㽘畕癳𪗆㬙瑨𨫌𤦫𤦎㫻"],["94a1","㷍𤩎㻿𤧅𤣳釺圲鍂𨫣𡡤僟𥈡𥇧睸𣈲眎眏睻𤚗𣞁㩞𤣰琸璛㺿𤪺𤫇䃈𤪖𦆮錇𥖁砞碍碈磒珐祙𧝁𥛣䄎禛蒖禥樭𣻺稺秴䅮𡛦䄲鈵秱𠵌𤦌𠊙𣶺𡝮㖗啫㕰㚪𠇔𠰍竢婙𢛵𥪯𥪜娍𠉛磰娪𥯆竾䇹籝籭䈑𥮳𥺼𥺦糍𤧹𡞰粎籼粮檲緜縇緓罎𦉡"],["9540","𦅜𧭈綗𥺂䉪𦭵𠤖柖𠁎𣗏埄𦐒𦏸𤥢翝笧𠠬𥫩𥵃笌𥸎駦虅驣樜𣐿㧢𤧷𦖭騟𦖠蒀𧄧𦳑䓪脷䐂胆脉腂𦞴飃𦩂艢艥𦩑葓𦶧蘐𧈛媆䅿𡡀嬫𡢡嫤𡣘蚠蜨𣶏蠭𧐢娂"],["95a1","衮佅袇袿裦襥襍𥚃襔𧞅𧞄𨯵𨯙𨮜𨧹㺭蒣䛵䛏㟲訽訜𩑈彍鈫𤊄旔焩烄𡡅鵭貟賩𧷜妚矃姰䍮㛔踪躧𤰉輰轊䋴汘澻𢌡䢛潹溋𡟚鯩㚵𤤯邻邗啱䤆醻鐄𨩋䁢𨫼鐧𨰝𨰻蓥訫閙閧閗閖𨴴瑅㻂𤣿𤩂𤏪㻧𣈥随𨻧𨹦𨹥㻌𤧭𤩸𣿮琒瑫㻼靁𩂰"],["9640","桇䨝𩂓𥟟靝鍨𨦉𨰦𨬯𦎾銺嬑譩䤼珹𤈛鞛靱餸𠼦巁𨯅𤪲頟𩓚鋶𩗗釥䓀𨭐𤩧𨭤飜𨩅㼀鈪䤥萔餻饍𧬆㷽馛䭯馪驜𨭥𥣈檏騡嫾騯𩣱䮐𩥈馼䮽䮗鍽塲𡌂堢𤦸"],["96a1","𡓨硄𢜟𣶸棅㵽鑘㤧慐𢞁𢥫愇鱏鱓鱻鰵鰐魿鯏𩸭鮟𪇵𪃾鴡䲮𤄄鸘䲰鴌𪆴𪃭𪃳𩤯鶥蒽𦸒𦿟𦮂藼䔳𦶤𦺄𦷰萠藮𦸀𣟗𦁤秢𣖜𣙀䤭𤧞㵢鏛銾鍈𠊿碹鉷鑍俤㑀遤𥕝砽硔碶硋𡝗𣇉𤥁㚚佲濚濙瀞瀞吔𤆵垻壳垊鴖埗焴㒯𤆬燫𦱀𤾗嬨𡞵𨩉"],["9740","愌嫎娋䊼𤒈㜬䭻𨧼鎻鎸𡣖𠼝葲𦳀𡐓𤋺𢰦𤏁妔𣶷𦝁綨𦅛𦂤𤦹𤦋𨧺鋥珢㻩璴𨭣𡢟㻡𤪳櫘珳珻㻖𤨾𤪔𡟙𤩦𠎧𡐤𤧥瑈𤤖炥𤥶銄珦鍟𠓾錱𨫎𨨖鎆𨯧𥗕䤵𨪂煫"],["97a1","𤥃𠳿嚤𠘚𠯫𠲸唂秄𡟺緾𡛂𤩐𡡒䔮鐁㜊𨫀𤦭妰𡢿𡢃𧒄媡㛢𣵛㚰鉟婹𨪁𡡢鍴㳍𠪴䪖㦊僴㵩㵌𡎜煵䋻𨈘渏𩃤䓫浗𧹏灧沯㳖𣿭𣸭渂漌㵯𠏵畑㚼㓈䚀㻚䡱姄鉮䤾轁𨰜𦯀堒埈㛖𡑒烾𤍢𤩱𢿣𡊰𢎽梹楧𡎘𣓥𧯴𣛟𨪃𣟖𣏺𤲟樚𣚭𦲷萾䓟䓎"],["9840","𦴦𦵑𦲂𦿞漗𧄉茽𡜺菭𦲀𧁓𡟛妉媂𡞳婡婱𡤅𤇼㜭姯𡜼㛇熎鎐暚𤊥婮娫𤊓樫𣻹𧜶𤑛𤋊焝𤉙𨧡侰𦴨峂𤓎𧹍𤎽樌𤉖𡌄炦焳𤏩㶥泟勇𤩏繥姫崯㷳彜𤩝𡟟綤萦"],["98a1","咅𣫺𣌀𠈔坾𠣕𠘙㿥𡾞𪊶瀃𩅛嵰玏糓𨩙𩐠俈翧狍猐𧫴猸猹𥛶獁獈㺩𧬘遬燵𤣲珡臶㻊県㻑沢国琙琞琟㻢㻰㻴㻺瓓㼎㽓畂畭畲疍㽼痈痜㿀癍㿗癴㿜発𤽜熈嘣覀塩䀝睃䀹条䁅㗛瞘䁪䁯属瞾矋売砘点砜䂨砹硇硑硦葈𥔵礳栃礲䄃"],["9940","䄉禑禙辻稆込䅧窑䆲窼艹䇄竏竛䇏両筢筬筻簒簛䉠䉺类粜䊌粸䊔糭输烀𠳏総緔緐緽羮羴犟䎗耠耥笹耮耱联㷌垴炠肷胩䏭脌猪脎脒畠脔䐁㬹腖腙腚"],["99a1","䐓堺腼膄䐥膓䐭膥埯臁臤艔䒏芦艶苊苘苿䒰荗险榊萅烵葤惣蒈䔄蒾蓡蓸蔐蔸蕒䔻蕯蕰藠䕷虲蚒蚲蛯际螋䘆䘗袮裿褤襇覑𧥧訩訸誔誴豑賔賲贜䞘塟跃䟭仮踺嗘坔蹱嗵躰䠷軎転軤軭軲辷迁迊迌逳駄䢭飠鈓䤞鈨鉘鉫銱銮銿"],["9a40","鋣鋫鋳鋴鋽鍃鎄鎭䥅䥑麿鐗匁鐝鐭鐾䥪鑔鑹锭関䦧间阳䧥枠䨤靀䨵鞲韂噔䫤惨颹䬙飱塄餎餙冴餜餷饂饝饢䭰駅䮝騼鬏窃魩鮁鯝鯱鯴䱭鰠㝯𡯂鵉鰺"],["9aa1","黾噐鶓鶽鷀鷼银辶鹻麬麱麽黆铜黢黱黸竈齄𠂔𠊷𠎠椚铃妬𠓗塀铁㞹𠗕𠘕𠙶𡚺块煳𠫂𠫍𠮿呪吆𠯋咞𠯻𠰻𠱓𠱥𠱼惧𠲍噺𠲵𠳝𠳭𠵯𠶲𠷈楕鰯螥𠸄𠸎𠻗𠾐𠼭𠹳尠𠾼帋𡁜𡁏𡁶朞𡁻𡂈𡂖㙇𡂿𡃓𡄯𡄻卤蒭𡋣𡍵𡌶讁𡕷𡘙𡟃𡟇乸炻𡠭𡥪"],["9b40","𡨭𡩅𡰪𡱰𡲬𡻈拃𡻕𡼕熘桕𢁅槩㛈𢉼𢏗𢏺𢜪𢡱𢥏苽𢥧𢦓𢫕覥𢫨辠𢬎鞸𢬿顇骽𢱌"],["9b62","𢲈𢲷𥯨𢴈𢴒𢶷𢶕𢹂𢽴𢿌𣀳𣁦𣌟𣏞徱晈暿𧩹𣕧𣗳爁𤦺矗𣘚𣜖纇𠍆墵朎"],["9ba1","椘𣪧𧙗𥿢𣸑𣺹𧗾𢂚䣐䪸𤄙𨪚𤋮𤌍𤀻𤌴𤎖𤩅𠗊凒𠘑妟𡺨㮾𣳿𤐄𤓖垈𤙴㦛𤜯𨗨𩧉㝢𢇃譞𨭎駖𤠒𤣻𤨕爉𤫀𠱸奥𤺥𤾆𠝹軚𥀬劏圿煱𥊙𥐙𣽊𤪧喼𥑆𥑮𦭒釔㑳𥔿𧘲𥕞䜘𥕢𥕦𥟇𤤿𥡝偦㓻𣏌惞𥤃䝼𨥈𥪮𥮉𥰆𡶐垡煑澶𦄂𧰒遖𦆲𤾚譢𦐂𦑊"],["9c40","嵛𦯷輶𦒄𡤜諪𤧶𦒈𣿯𦔒䯀𦖿𦚵𢜛鑥𥟡憕娧晉侻嚹𤔡𦛼乪𤤴陖涏𦲽㘘襷𦞙𦡮𦐑𦡞營𦣇筂𩃀𠨑𦤦鄄𦤹穅鷰𦧺騦𦨭㙟𦑩𠀡禃𦨴𦭛崬𣔙菏𦮝䛐𦲤画补𦶮墶"],["9ca1","㜜𢖍𧁋𧇍㱔𧊀𧊅銁𢅺𧊋錰𧋦𤧐氹钟𧑐𠻸蠧裵𢤦𨑳𡞱溸𤨪𡠠㦤㚹尐秣䔿暶𩲭𩢤襃𧟌𧡘囖䃟𡘊㦡𣜯𨃨𡏅熭荦𧧝𩆨婧䲷𧂯𨦫𧧽𧨊𧬋𧵦𤅺筃祾𨀉澵𪋟樃𨌘厢𦸇鎿栶靝𨅯𨀣𦦵𡏭𣈯𨁈嶅𨰰𨂃圕頣𨥉嶫𤦈斾槕叒𤪥𣾁㰑朶𨂐𨃴𨄮𡾡𨅏"],["9d40","𨆉𨆯𨈚𨌆𨌯𨎊㗊𨑨𨚪䣺揦𨥖砈鉕𨦸䏲𨧧䏟𨧨𨭆𨯔姸𨰉輋𨿅𩃬筑𩄐𩄼㷷𩅞𤫊运犏嚋𩓧𩗩𩖰𩖸𩜲𩣑𩥉𩥪𩧃𩨨𩬎𩵚𩶛纟𩻸𩼣䲤镇𪊓熢𪋿䶑递𪗋䶜𠲜达嗁"],["9da1","辺𢒰边𤪓䔉繿潖檱仪㓤𨬬𧢝㜺躀𡟵𨀤𨭬𨮙𧨾𦚯㷫𧙕𣲷𥘵𥥖亚𥺁𦉘嚿𠹭踎孭𣺈𤲞揞拐𡟶𡡻攰嘭𥱊吚𥌑㷆𩶘䱽嘢嘞罉𥻘奵𣵀蝰东𠿪𠵉𣚺脗鵞贘瘻鱅癎瞹鍅吲腈苷嘥脲萘肽嗪祢噃吖𠺝㗎嘅嗱曱𨋢㘭甴嗰喺咗啲𠱁𠲖廐𥅈𠹶𢱢"],["9e40","𠺢麫絚嗞𡁵抝靭咔賍燶酶揼掹揾啩𢭃鱲𢺳冚㓟𠶧冧呍唞唓癦踭𦢊疱肶蠄螆裇膶萜𡃁䓬猄𤜆宐茋𦢓噻𢛴𧴯𤆣𧵳𦻐𧊶酰𡇙鈈𣳼𪚩𠺬𠻹牦𡲢䝎𤿂𧿹𠿫䃺"],["9ea1","鱝攟𢶠䣳𤟠𩵼𠿬𠸊恢𧖣𠿭"],["9ead","𦁈𡆇熣纎鵐业丄㕷嬍沲卧㚬㧜卽㚥𤘘墚𤭮舭呋垪𥪕𠥹"],["9ec5","㩒𢑥獴𩺬䴉鯭𣳾𩼰䱛𤾩𩖞𩿞葜𣶶𧊲𦞳𣜠挮紥𣻷𣸬㨪逈勌㹴㙺䗩𠒎癀嫰𠺶硺𧼮墧䂿噼鮋嵴癔𪐴麅䳡痹㟻愙𣃚𤏲"],["9ef5","噝𡊩垧𤥣𩸆刴𧂮㖭汊鵼"],["9f40","籖鬹埞𡝬屓擓𩓐𦌵𧅤蚭𠴨𦴢𤫢𠵱"],["9f4f","凾𡼏嶎霃𡷑麁遌笟鬂峑箣扨挵髿篏鬪籾鬮籂粆鰕篼鬉鼗鰛𤤾齚啳寃俽麘俲剠㸆勑坧偖妷帒韈鶫轜呩鞴饀鞺匬愰"],["9fa1","椬叚鰊鴂䰻陁榀傦畆𡝭駚剳"],["9fae","酙隁酜"],["9fb2","酑𨺗捿𦴣櫊嘑醎畺抅𠏼獏籰𥰡𣳽"],["9fc1","𤤙盖鮝个𠳔莾衂"],["9fc9","届槀僭坺刟巵从氱𠇲伹咜哚劚趂㗾弌㗳"],["9fdb","歒酼龥鮗頮颴骺麨麄煺笔"],["9fe7","毺蠘罸"],["9feb","嘠𪙊蹷齓"],["9ff0","跔蹏鸜踁抂𨍽踨蹵竓𤩷稾磘泪詧瘇"],["a040","𨩚鼦泎蟖痃𪊲硓咢贌狢獱謭猂瓱賫𤪻蘯徺袠䒷"],["a055","𡠻𦸅"],["a058","詾𢔛"],["a05b","惽癧髗鵄鍮鮏蟵"],["a063","蠏賷猬霡鮰㗖犲䰇籑饊𦅙慙䰄麖慽"],["a073","坟慯抦戹拎㩜懢厪𣏵捤栂㗒"],["a0a1","嵗𨯂迚𨸹"],["a0a6","僙𡵆礆匲阸𠼻䁥"],["a0ae","矾"],["a0b0","糂𥼚糚稭聦聣絍甅瓲覔舚朌聢𧒆聛瓰脃眤覉𦟌畓𦻑螩蟎臈螌詉貭譃眫瓸蓚㘵榲趦"],["a0d4","覩瑨涹蟁𤀑瓧㷛煶悤憜㳑煢恷"],["a0e2","罱𨬭牐惩䭾删㰘𣳇𥻗𧙖𥔱𡥄𡋾𩤃𦷜𧂭峁𦆭𨨏𣙷𠃮𦡆𤼎䕢嬟𦍌齐麦𦉫"],["a3c0","␀",31,"␡"],["c6a1","①",9,"⑴",9,"ⅰ",9,"丶丿亅亠冂冖冫勹匸卩厶夊宀巛⼳广廴彐彡攴无疒癶辵隶¨ˆヽヾゝゞ〃仝々〆〇ー［］✽ぁ",23],["c740","す",58,"ァアィイ"],["c7a1","ゥ",81,"А",5,"ЁЖ",4],["c840","Л",26,"ёж",25,"⇧↸↹㇏𠃌乚𠂊刂䒑"],["c8a1","龰冈龱𧘇"],["c8cd","￢￤＇＂㈱№℡゛゜⺀⺄⺆⺇⺈⺊⺌⺍⺕⺜⺝⺥⺧⺪⺬⺮⺶⺼⺾⻆⻊⻌⻍⻏⻖⻗⻞⻣"],["c8f5","ʃɐɛɔɵœøŋʊɪ"],["f9fe","￭"],["fa40","𠕇鋛𠗟𣿅蕌䊵珯况㙉𤥂𨧤鍄𡧛苮𣳈砼杄拟𤤳𨦪𠊠𦮳𡌅侫𢓭倈𦴩𧪄𣘀𤪱𢔓倩𠍾徤𠎀𠍇滛𠐟偽儁㑺儎顬㝃萖𤦤𠒇兠𣎴兪𠯿𢃼𠋥𢔰𠖎𣈳𡦃宂蝽𠖳𣲙冲冸"],["faa1","鴴凉减凑㳜凓𤪦决凢卂凭菍椾𣜭彻刋刦刼劵剗劔効勅簕蕂勠蘍𦬓包𨫞啉滙𣾀𠥔𣿬匳卄𠯢泋𡜦栛珕恊㺪㣌𡛨燝䒢卭却𨚫卾卿𡖖𡘓矦厓𨪛厠厫厮玧𥝲㽙玜叁叅汉义埾叙㪫𠮏叠𣿫𢶣叶𠱷吓灹唫晗浛呭𦭓𠵴啝咏咤䞦𡜍𠻝㶴𠵍"],["fb40","𨦼𢚘啇䳭启琗喆喩嘅𡣗𤀺䕒𤐵暳𡂴嘷曍𣊊暤暭噍噏磱囱鞇叾圀囯园𨭦㘣𡉏坆𤆥汮炋坂㚱𦱾埦𡐖堃𡑔𤍣堦𤯵塜墪㕡壠壜𡈼壻寿坃𪅐𤉸鏓㖡够梦㛃湙"],["fba1","𡘾娤啓𡚒蔅姉𠵎𦲁𦴪𡟜姙𡟻𡞲𦶦浱𡠨𡛕姹𦹅媫婣㛦𤦩婷㜈媖瑥嫓𦾡𢕔㶅𡤑㜲𡚸広勐孶斈孼𧨎䀄䡝𠈄寕慠𡨴𥧌𠖥寳宝䴐尅𡭄尓珎尔𡲥𦬨屉䣝岅峩峯嶋𡷹𡸷崐崘嵆𡺤岺巗苼㠭𤤁𢁉𢅳芇㠶㯂帮檊幵幺𤒼𠳓厦亷廐厨𡝱帉廴𨒂"],["fc40","廹廻㢠廼栾鐛弍𠇁弢㫞䢮𡌺强𦢈𢏐彘𢑱彣鞽𦹮彲鍀𨨶徧嶶㵟𥉐𡽪𧃸𢙨釖𠊞𨨩怱暅𡡷㥣㷇㘹垐𢞴祱㹀悞悤悳𤦂𤦏𧩓璤僡媠慤萤慂慈𦻒憁凴𠙖憇宪𣾷"],["fca1","𢡟懓𨮝𩥝懐㤲𢦀𢣁怣慜攞掋𠄘担𡝰拕𢸍捬𤧟㨗搸揸𡎎𡟼撐澊𢸶頔𤂌𥜝擡擥鑻㩦携㩗敍漖𤨨𤨣斅敭敟𣁾斵𤥀䬷旑䃘𡠩无旣忟𣐀昘𣇷𣇸晄𣆤𣆥晋𠹵晧𥇦晳晴𡸽𣈱𨗴𣇈𥌓矅𢣷馤朂𤎜𤨡㬫槺𣟂杞杧杢𤇍𩃭柗䓩栢湐鈼栁𣏦𦶠桝"],["fd40","𣑯槡樋𨫟楳棃𣗍椁椀㴲㨁𣘼㮀枬楡𨩊䋼椶榘㮡𠏉荣傐槹𣙙𢄪橅𣜃檝㯳枱櫈𩆜㰍欝𠤣惞欵歴𢟍溵𣫛𠎵𡥘㝀吡𣭚毡𣻼毜氷𢒋𤣱𦭑汚舦汹𣶼䓅𣶽𤆤𤤌𤤀"],["fda1","𣳉㛥㳫𠴲鮃𣇹𢒑羏样𦴥𦶡𦷫涖浜湼漄𤥿𤂅𦹲蔳𦽴凇沜渝萮𨬡港𣸯瑓𣾂秌湏媑𣁋濸㜍澝𣸰滺𡒗𤀽䕕鏰潄潜㵎潴𩅰㴻澟𤅄濓𤂑𤅕𤀹𣿰𣾴𤄿凟𤅖𤅗𤅀𦇝灋灾炧炁烌烕烖烟䄄㷨熴熖𤉷焫煅媈煊煮岜𤍥煏鍢𤋁焬𤑚𤨧𤨢熺𨯨炽爎"],["fe40","鑂爕夑鑃爤鍁𥘅爮牀𤥴梽牕牗㹕𣁄栍漽犂猪猫𤠣𨠫䣭𨠄猨献珏玪𠰺𦨮珉瑉𤇢𡛧𤨤昣㛅𤦷𤦍𤧻珷琕椃𤨦琹𠗃㻗瑜𢢭瑠𨺲瑇珤瑶莹瑬㜰瑴鏱樬璂䥓𤪌"],["fea1","𤅟𤩹𨮏孆𨰃𡢞瓈𡦈甎瓩甞𨻙𡩋寗𨺬鎅畍畊畧畮𤾂㼄𤴓疎瑝疞疴瘂瘬癑癏癯癶𦏵皐臯㟸𦤑𦤎皡皥皷盌𦾟葢𥂝𥅽𡸜眞眦着撯𥈠睘𣊬瞯𨥤𨥨𡛁矴砉𡍶𤨒棊碯磇磓隥礮𥗠磗礴碱𧘌辸袄𨬫𦂃𢘜禆褀椂禀𥡗禝𧬹礼禩渪𧄦㺨秆𩄍秔"]]');

/***/ }),

/***/ 4488:
/***/ ((module) => {

"use strict";
module.exports = /*#__PURE__*/JSON.parse('[["0","\\u0000",127,"€"],["8140","丂丄丅丆丏丒丗丟丠両丣並丩丮丯丱丳丵丷丼乀乁乂乄乆乊乑乕乗乚乛乢乣乤乥乧乨乪",5,"乲乴",9,"乿",6,"亇亊"],["8180","亐亖亗亙亜亝亞亣亪亯亰亱亴亶亷亸亹亼亽亾仈仌仏仐仒仚仛仜仠仢仦仧仩仭仮仯仱仴仸仹仺仼仾伀伂",6,"伋伌伒",4,"伜伝伡伣伨伩伬伭伮伱伳伵伷伹伻伾",4,"佄佅佇",5,"佒佔佖佡佢佦佨佪佫佭佮佱佲併佷佸佹佺佽侀侁侂侅來侇侊侌侎侐侒侓侕侖侘侙侚侜侞侟価侢"],["8240","侤侫侭侰",4,"侶",8,"俀俁係俆俇俈俉俋俌俍俒",4,"俙俛俠俢俤俥俧俫俬俰俲俴俵俶俷俹俻俼俽俿",11],["8280","個倎倐們倓倕倖倗倛倝倞倠倢倣値倧倫倯",10,"倻倽倿偀偁偂偄偅偆偉偊偋偍偐",4,"偖偗偘偙偛偝",7,"偦",5,"偭",8,"偸偹偺偼偽傁傂傃傄傆傇傉傊傋傌傎",20,"傤傦傪傫傭",4,"傳",6,"傼"],["8340","傽",17,"僐",5,"僗僘僙僛",10,"僨僩僪僫僯僰僱僲僴僶",4,"僼",9,"儈"],["8380","儉儊儌",5,"儓",13,"儢",28,"兂兇兊兌兎兏児兒兓兗兘兙兛兝",4,"兣兤兦內兩兪兯兲兺兾兿冃冄円冇冊冋冎冏冐冑冓冔冘冚冝冞冟冡冣冦",4,"冭冮冴冸冹冺冾冿凁凂凃凅凈凊凍凎凐凒",5],["8440","凘凙凚凜凞凟凢凣凥",5,"凬凮凱凲凴凷凾刄刅刉刋刌刏刐刓刔刕刜刞刟刡刢刣別刦刧刪刬刯刱刲刴刵刼刾剄",5,"剋剎剏剒剓剕剗剘"],["8480","剙剚剛剝剟剠剢剣剤剦剨剫剬剭剮剰剱剳",9,"剾劀劃",4,"劉",6,"劑劒劔",6,"劜劤劥劦劧劮劯劰労",9,"勀勁勂勄勅勆勈勊勌勍勎勏勑勓勔動勗務",5,"勠勡勢勣勥",10,"勱",7,"勻勼勽匁匂匃匄匇匉匊匋匌匎"],["8540","匑匒匓匔匘匛匜匞匟匢匤匥匧匨匩匫匬匭匯",9,"匼匽區卂卄卆卋卌卍卐協単卙卛卝卥卨卪卬卭卲卶卹卻卼卽卾厀厁厃厇厈厊厎厏"],["8580","厐",4,"厖厗厙厛厜厞厠厡厤厧厪厫厬厭厯",6,"厷厸厹厺厼厽厾叀參",4,"収叏叐叒叓叕叚叜叝叞叡叢叧叴叺叾叿吀吂吅吇吋吔吘吙吚吜吢吤吥吪吰吳吶吷吺吽吿呁呂呄呅呇呉呌呍呎呏呑呚呝",4,"呣呥呧呩",7,"呴呹呺呾呿咁咃咅咇咈咉咊咍咑咓咗咘咜咞咟咠咡"],["8640","咢咥咮咰咲咵咶咷咹咺咼咾哃哅哊哋哖哘哛哠",4,"哫哬哯哰哱哴",5,"哻哾唀唂唃唄唅唈唊",4,"唒唓唕",5,"唜唝唞唟唡唥唦"],["8680","唨唩唫唭唲唴唵唶唸唹唺唻唽啀啂啅啇啈啋",4,"啑啒啓啔啗",4,"啝啞啟啠啢啣啨啩啫啯",5,"啹啺啽啿喅喆喌喍喎喐喒喓喕喖喗喚喛喞喠",6,"喨",8,"喲喴営喸喺喼喿",4,"嗆嗇嗈嗊嗋嗎嗏嗐嗕嗗",4,"嗞嗠嗢嗧嗩嗭嗮嗰嗱嗴嗶嗸",4,"嗿嘂嘃嘄嘅"],["8740","嘆嘇嘊嘋嘍嘐",7,"嘙嘚嘜嘝嘠嘡嘢嘥嘦嘨嘩嘪嘫嘮嘯嘰嘳嘵嘷嘸嘺嘼嘽嘾噀",11,"噏",4,"噕噖噚噛噝",4],["8780","噣噥噦噧噭噮噯噰噲噳噴噵噷噸噹噺噽",7,"嚇",6,"嚐嚑嚒嚔",14,"嚤",10,"嚰",6,"嚸嚹嚺嚻嚽",12,"囋",8,"囕囖囘囙囜団囥",5,"囬囮囯囲図囶囷囸囻囼圀圁圂圅圇國",6],["8840","園",9,"圝圞圠圡圢圤圥圦圧圫圱圲圴",4,"圼圽圿坁坃坄坅坆坈坉坋坒",4,"坘坙坢坣坥坧坬坮坰坱坲坴坵坸坹坺坽坾坿垀"],["8880","垁垇垈垉垊垍",4,"垔",6,"垜垝垞垟垥垨垪垬垯垰垱垳垵垶垷垹",8,"埄",6,"埌埍埐埑埓埖埗埛埜埞埡埢埣埥",7,"埮埰埱埲埳埵埶執埻埼埾埿堁堃堄堅堈堉堊堌堎堏堐堒堓堔堖堗堘堚堛堜堝堟堢堣堥",4,"堫",4,"報堲堳場堶",7],["8940","堾",5,"塅",6,"塎塏塐塒塓塕塖塗塙",4,"塟",5,"塦",4,"塭",16,"塿墂墄墆墇墈墊墋墌"],["8980","墍",4,"墔",4,"墛墜墝墠",7,"墪",17,"墽墾墿壀壂壃壄壆",10,"壒壓壔壖",13,"壥",5,"壭壯壱売壴壵壷壸壺",7,"夃夅夆夈",4,"夎夐夑夒夓夗夘夛夝夞夠夡夢夣夦夨夬夰夲夳夵夶夻"],["8a40","夽夾夿奀奃奅奆奊奌奍奐奒奓奙奛",4,"奡奣奤奦",12,"奵奷奺奻奼奾奿妀妅妉妋妌妎妏妐妑妔妕妘妚妛妜妝妟妠妡妢妦"],["8a80","妧妬妭妰妱妳",5,"妺妼妽妿",6,"姇姈姉姌姍姎姏姕姖姙姛姞",4,"姤姦姧姩姪姫姭",11,"姺姼姽姾娀娂娊娋娍娎娏娐娒娔娕娖娗娙娚娛娝娞娡娢娤娦娧娨娪",6,"娳娵娷",4,"娽娾娿婁",4,"婇婈婋",9,"婖婗婘婙婛",5],["8b40","婡婣婤婥婦婨婩婫",8,"婸婹婻婼婽婾媀",17,"媓",6,"媜",13,"媫媬"],["8b80","媭",4,"媴媶媷媹",4,"媿嫀嫃",5,"嫊嫋嫍",4,"嫓嫕嫗嫙嫚嫛嫝嫞嫟嫢嫤嫥嫧嫨嫪嫬",4,"嫲",22,"嬊",11,"嬘",25,"嬳嬵嬶嬸",7,"孁",6],["8c40","孈",7,"孒孖孞孠孡孧孨孫孭孮孯孲孴孶孷學孹孻孼孾孿宂宆宊宍宎宐宑宒宔宖実宧宨宩宬宭宮宯宱宲宷宺宻宼寀寁寃寈寉寊寋寍寎寏"],["8c80","寑寔",8,"寠寢寣實寧審",4,"寯寱",6,"寽対尀専尃尅將專尋尌對導尐尒尓尗尙尛尞尟尠尡尣尦尨尩尪尫尭尮尯尰尲尳尵尶尷屃屄屆屇屌屍屒屓屔屖屗屘屚屛屜屝屟屢層屧",6,"屰屲",6,"屻屼屽屾岀岃",4,"岉岊岋岎岏岒岓岕岝",4,"岤",4],["8d40","岪岮岯岰岲岴岶岹岺岻岼岾峀峂峃峅",5,"峌",5,"峓",5,"峚",6,"峢峣峧峩峫峬峮峯峱",9,"峼",4],["8d80","崁崄崅崈",5,"崏",4,"崕崗崘崙崚崜崝崟",4,"崥崨崪崫崬崯",4,"崵",7,"崿",7,"嵈嵉嵍",10,"嵙嵚嵜嵞",10,"嵪嵭嵮嵰嵱嵲嵳嵵",12,"嶃",21,"嶚嶛嶜嶞嶟嶠"],["8e40","嶡",21,"嶸",12,"巆",6,"巎",12,"巜巟巠巣巤巪巬巭"],["8e80","巰巵巶巸",4,"巿帀帄帇帉帊帋帍帎帒帓帗帞",7,"帨",4,"帯帰帲",4,"帹帺帾帿幀幁幃幆",5,"幍",6,"幖",4,"幜幝幟幠幣",14,"幵幷幹幾庁庂広庅庈庉庌庍庎庒庘庛庝庡庢庣庤庨",4,"庮",4,"庴庺庻庼庽庿",6],["8f40","廆廇廈廋",5,"廔廕廗廘廙廚廜",11,"廩廫",8,"廵廸廹廻廼廽弅弆弇弉弌弍弎弐弒弔弖弙弚弜弝弞弡弢弣弤"],["8f80","弨弫弬弮弰弲",6,"弻弽弾弿彁",14,"彑彔彙彚彛彜彞彟彠彣彥彧彨彫彮彯彲彴彵彶彸彺彽彾彿徃徆徍徎徏徑従徔徖徚徛徝從徟徠徢",5,"復徫徬徯",5,"徶徸徹徺徻徾",4,"忇忈忊忋忎忓忔忕忚忛応忞忟忢忣忥忦忨忩忬忯忰忲忳忴忶忷忹忺忼怇"],["9040","怈怉怋怌怐怑怓怗怘怚怞怟怢怣怤怬怭怮怰",4,"怶",4,"怽怾恀恄",6,"恌恎恏恑恓恔恖恗恘恛恜恞恟恠恡恥恦恮恱恲恴恵恷恾悀"],["9080","悁悂悅悆悇悈悊悋悎悏悐悑悓悕悗悘悙悜悞悡悢悤悥悧悩悪悮悰悳悵悶悷悹悺悽",7,"惇惈惉惌",4,"惒惓惔惖惗惙惛惞惡",4,"惪惱惲惵惷惸惻",4,"愂愃愄愅愇愊愋愌愐",4,"愖愗愘愙愛愜愝愞愡愢愥愨愩愪愬",18,"慀",6],["9140","慇慉態慍慏慐慒慓慔慖",6,"慞慟慠慡慣慤慥慦慩",6,"慱慲慳慴慶慸",18,"憌憍憏",4,"憕"],["9180","憖",6,"憞",8,"憪憫憭",9,"憸",5,"憿懀懁懃",4,"應懌",4,"懓懕",16,"懧",13,"懶",8,"戀",5,"戇戉戓戔戙戜戝戞戠戣戦戧戨戩戫戭戯戰戱戲戵戶戸",4,"扂扄扅扆扊"],["9240","扏扐払扖扗扙扚扜",6,"扤扥扨扱扲扴扵扷扸扺扻扽抁抂抃抅抆抇抈抋",5,"抔抙抜抝択抣抦抧抩抪抭抮抯抰抲抳抴抶抷抸抺抾拀拁"],["9280","拃拋拏拑拕拝拞拠拡拤拪拫拰拲拵拸拹拺拻挀挃挄挅挆挊挋挌挍挏挐挒挓挔挕挗挘挙挜挦挧挩挬挭挮挰挱挳",5,"挻挼挾挿捀捁捄捇捈捊捑捒捓捔捖",7,"捠捤捥捦捨捪捫捬捯捰捲捳捴捵捸捹捼捽捾捿掁掃掄掅掆掋掍掑掓掔掕掗掙",6,"採掤掦掫掯掱掲掵掶掹掻掽掿揀"],["9340","揁揂揃揅揇揈揊揋揌揑揓揔揕揗",6,"揟揢揤",4,"揫揬揮揯揰揱揳揵揷揹揺揻揼揾搃搄搆",4,"損搎搑搒搕",5,"搝搟搢搣搤"],["9380","搥搧搨搩搫搮",5,"搵",4,"搻搼搾摀摂摃摉摋",6,"摓摕摖摗摙",4,"摟",7,"摨摪摫摬摮",9,"摻",6,"撃撆撈",8,"撓撔撗撘撚撛撜撝撟",4,"撥撦撧撨撪撫撯撱撲撳撴撶撹撻撽撾撿擁擃擄擆",6,"擏擑擓擔擕擖擙據"],["9440","擛擜擝擟擠擡擣擥擧",24,"攁",7,"攊",7,"攓",4,"攙",8],["9480","攢攣攤攦",4,"攬攭攰攱攲攳攷攺攼攽敀",4,"敆敇敊敋敍敎敐敒敓敔敗敘敚敜敟敠敡敤敥敧敨敩敪敭敮敯敱敳敵敶數",14,"斈斉斊斍斎斏斒斔斕斖斘斚斝斞斠斢斣斦斨斪斬斮斱",7,"斺斻斾斿旀旂旇旈旉旊旍旐旑旓旔旕旘",7,"旡旣旤旪旫"],["9540","旲旳旴旵旸旹旻",4,"昁昄昅昇昈昉昋昍昐昑昒昖昗昘昚昛昜昞昡昢昣昤昦昩昪昫昬昮昰昲昳昷",4,"昽昿晀時晄",6,"晍晎晐晑晘"],["9580","晙晛晜晝晞晠晢晣晥晧晩",4,"晱晲晳晵晸晹晻晼晽晿暀暁暃暅暆暈暉暊暋暍暎暏暐暒暓暔暕暘",4,"暞",8,"暩",4,"暯",4,"暵暶暷暸暺暻暼暽暿",25,"曚曞",7,"曧曨曪",5,"曱曵曶書曺曻曽朁朂會"],["9640","朄朅朆朇朌朎朏朑朒朓朖朘朙朚朜朞朠",5,"朧朩朮朰朲朳朶朷朸朹朻朼朾朿杁杄杅杇杊杋杍杒杔杕杗",4,"杝杢杣杤杦杧杫杬杮東杴杶"],["9680","杸杹杺杻杽枀枂枃枅枆枈枊枌枍枎枏枑枒枓枔枖枙枛枟枠枡枤枦枩枬枮枱枲枴枹",7,"柂柅",9,"柕柖柗柛柟柡柣柤柦柧柨柪柫柭柮柲柵",7,"柾栁栂栃栄栆栍栐栒栔栕栘",4,"栞栟栠栢",6,"栫",6,"栴栵栶栺栻栿桇桋桍桏桒桖",5],["9740","桜桝桞桟桪桬",7,"桵桸",8,"梂梄梇",7,"梐梑梒梔梕梖梘",9,"梣梤梥梩梪梫梬梮梱梲梴梶梷梸"],["9780","梹",6,"棁棃",5,"棊棌棎棏棐棑棓棔棖棗棙棛",4,"棡棢棤",9,"棯棲棳棴棶棷棸棻棽棾棿椀椂椃椄椆",4,"椌椏椑椓",11,"椡椢椣椥",7,"椮椯椱椲椳椵椶椷椸椺椻椼椾楀楁楃",16,"楕楖楘楙楛楜楟"],["9840","楡楢楤楥楧楨楩楪楬業楯楰楲",4,"楺楻楽楾楿榁榃榅榊榋榌榎",5,"榖榗榙榚榝",9,"榩榪榬榮榯榰榲榳榵榶榸榹榺榼榽"],["9880","榾榿槀槂",7,"構槍槏槑槒槓槕",5,"槜槝槞槡",11,"槮槯槰槱槳",9,"槾樀",9,"樋",11,"標",5,"樠樢",5,"権樫樬樭樮樰樲樳樴樶",6,"樿",4,"橅橆橈",7,"橑",6,"橚"],["9940","橜",4,"橢橣橤橦",10,"橲",6,"橺橻橽橾橿檁檂檃檅",8,"檏檒",4,"檘",7,"檡",5],["9980","檧檨檪檭",114,"欥欦欨",6],["9a40","欯欰欱欳欴欵欶欸欻欼欽欿歀歁歂歄歅歈歊歋歍",11,"歚",7,"歨歩歫",13,"歺歽歾歿殀殅殈"],["9a80","殌殎殏殐殑殔殕殗殘殙殜",4,"殢",7,"殫",7,"殶殸",6,"毀毃毄毆",4,"毌毎毐毑毘毚毜",4,"毢",7,"毬毭毮毰毱毲毴毶毷毸毺毻毼毾",6,"氈",4,"氎氒気氜氝氞氠氣氥氫氬氭氱氳氶氷氹氺氻氼氾氿汃汄汅汈汋",4,"汑汒汓汖汘"],["9b40","汙汚汢汣汥汦汧汫",4,"汱汳汵汷汸決汻汼汿沀沄沇沊沋沍沎沑沒沕沖沗沘沚沜沝沞沠沢沨沬沯沰沴沵沶沷沺泀況泂泃泆泇泈泋泍泎泏泑泒泘"],["9b80","泙泚泜泝泟泤泦泧泩泬泭泲泴泹泿洀洂洃洅洆洈洉洊洍洏洐洑洓洔洕洖洘洜洝洟",5,"洦洨洩洬洭洯洰洴洶洷洸洺洿浀浂浄浉浌浐浕浖浗浘浛浝浟浡浢浤浥浧浨浫浬浭浰浱浲浳浵浶浹浺浻浽",4,"涃涄涆涇涊涋涍涏涐涒涖",4,"涜涢涥涬涭涰涱涳涴涶涷涹",5,"淁淂淃淈淉淊"],["9c40","淍淎淏淐淒淓淔淕淗淚淛淜淟淢淣淥淧淨淩淪淭淯淰淲淴淵淶淸淺淽",7,"渆渇済渉渋渏渒渓渕渘渙減渜渞渟渢渦渧渨渪測渮渰渱渳渵"],["9c80","渶渷渹渻",7,"湅",7,"湏湐湑湒湕湗湙湚湜湝湞湠",10,"湬湭湯",14,"満溁溂溄溇溈溊",4,"溑",6,"溙溚溛溝溞溠溡溣溤溦溨溩溫溬溭溮溰溳溵溸溹溼溾溿滀滃滄滅滆滈滉滊滌滍滎滐滒滖滘滙滛滜滝滣滧滪",5],["9d40","滰滱滲滳滵滶滷滸滺",7,"漃漄漅漇漈漊",4,"漐漑漒漖",9,"漡漢漣漥漦漧漨漬漮漰漲漴漵漷",6,"漿潀潁潂"],["9d80","潃潄潅潈潉潊潌潎",9,"潙潚潛潝潟潠潡潣潤潥潧",5,"潯潰潱潳潵潶潷潹潻潽",6,"澅澆澇澊澋澏",12,"澝澞澟澠澢",4,"澨",10,"澴澵澷澸澺",5,"濁濃",5,"濊",6,"濓",10,"濟濢濣濤濥"],["9e40","濦",7,"濰",32,"瀒",7,"瀜",6,"瀤",6],["9e80","瀫",9,"瀶瀷瀸瀺",17,"灍灎灐",13,"灟",11,"灮灱灲灳灴灷灹灺灻災炁炂炃炄炆炇炈炋炌炍炏炐炑炓炗炘炚炛炞",12,"炰炲炴炵炶為炾炿烄烅烆烇烉烋",12,"烚"],["9f40","烜烝烞烠烡烢烣烥烪烮烰",6,"烸烺烻烼烾",10,"焋",4,"焑焒焔焗焛",10,"焧",7,"焲焳焴"],["9f80","焵焷",13,"煆煇煈煉煋煍煏",12,"煝煟",4,"煥煩",4,"煯煰煱煴煵煶煷煹煻煼煾",5,"熅",4,"熋熌熍熎熐熑熒熓熕熖熗熚",4,"熡",6,"熩熪熫熭",5,"熴熶熷熸熺",8,"燄",9,"燏",4],["a040","燖",9,"燡燢燣燤燦燨",5,"燯",9,"燺",11,"爇",19],["a080","爛爜爞",9,"爩爫爭爮爯爲爳爴爺爼爾牀",6,"牉牊牋牎牏牐牑牓牔牕牗牘牚牜牞牠牣牤牥牨牪牫牬牭牰牱牳牴牶牷牸牻牼牽犂犃犅",4,"犌犎犐犑犓",11,"犠",11,"犮犱犲犳犵犺",6,"狅狆狇狉狊狋狌狏狑狓狔狕狖狘狚狛"],["a1a1","　、。·ˉˇ¨〃々—～‖…‘’“”〔〕〈",7,"〖〗【】±×÷∶∧∨∑∏∪∩∈∷√⊥∥∠⌒⊙∫∮≡≌≈∽∝≠≮≯≤≥∞∵∴♂♀°′″℃＄¤￠￡‰§№☆★○●◎◇◆□■△▲※→←↑↓〓"],["a2a1","ⅰ",9],["a2b1","⒈",19,"⑴",19,"①",9],["a2e5","㈠",9],["a2f1","Ⅰ",11],["a3a1","！＂＃￥％",88,"￣"],["a4a1","ぁ",82],["a5a1","ァ",85],["a6a1","Α",16,"Σ",6],["a6c1","α",16,"σ",6],["a6e0","︵︶︹︺︿﹀︽︾﹁﹂﹃﹄"],["a6ee","︻︼︷︸︱"],["a6f4","︳︴"],["a7a1","А",5,"ЁЖ",25],["a7d1","а",5,"ёж",25],["a840","ˊˋ˙–―‥‵℅℉↖↗↘↙∕∟∣≒≦≧⊿═",35,"▁",6],["a880","█",7,"▓▔▕▼▽◢◣◤◥☉⊕〒〝〞"],["a8a1","āáǎàēéěèīíǐìōóǒòūúǔùǖǘǚǜüêɑ"],["a8bd","ńň"],["a8c0","ɡ"],["a8c5","ㄅ",36],["a940","〡",8,"㊣㎎㎏㎜㎝㎞㎡㏄㏎㏑㏒㏕︰￢￤"],["a959","℡㈱"],["a95c","‐"],["a960","ー゛゜ヽヾ〆ゝゞ﹉",9,"﹔﹕﹖﹗﹙",8],["a980","﹢",4,"﹨﹩﹪﹫"],["a996","〇"],["a9a4","─",75],["aa40","狜狝狟狢",5,"狪狫狵狶狹狽狾狿猀猂猄",5,"猋猌猍猏猐猑猒猔猘猙猚猟猠猣猤猦猧猨猭猯猰猲猳猵猶猺猻猼猽獀",8],["aa80","獉獊獋獌獎獏獑獓獔獕獖獘",7,"獡",10,"獮獰獱"],["ab40","獲",11,"獿",4,"玅玆玈玊玌玍玏玐玒玓玔玕玗玘玙玚玜玝玞玠玡玣",5,"玪玬玭玱玴玵玶玸玹玼玽玾玿珁珃",4],["ab80","珋珌珎珒",6,"珚珛珜珝珟珡珢珣珤珦珨珪珫珬珮珯珰珱珳",4],["ac40","珸",10,"琄琇琈琋琌琍琎琑",8,"琜",5,"琣琤琧琩琫琭琯琱琲琷",4,"琽琾琿瑀瑂",11],["ac80","瑎",6,"瑖瑘瑝瑠",12,"瑮瑯瑱",4,"瑸瑹瑺"],["ad40","瑻瑼瑽瑿璂璄璅璆璈璉璊璌璍璏璑",10,"璝璟",7,"璪",15,"璻",12],["ad80","瓈",9,"瓓",8,"瓝瓟瓡瓥瓧",6,"瓰瓱瓲"],["ae40","瓳瓵瓸",6,"甀甁甂甃甅",7,"甎甐甒甔甕甖甗甛甝甞甠",4,"甦甧甪甮甴甶甹甼甽甿畁畂畃畄畆畇畉畊畍畐畑畒畓畕畖畗畘"],["ae80","畝",7,"畧畨畩畫",6,"畳畵當畷畺",4,"疀疁疂疄疅疇"],["af40","疈疉疊疌疍疎疐疓疕疘疛疜疞疢疦",4,"疭疶疷疺疻疿痀痁痆痋痌痎痏痐痑痓痗痙痚痜痝痟痠痡痥痩痬痭痮痯痲痳痵痶痷痸痺痻痽痾瘂瘄瘆瘇"],["af80","瘈瘉瘋瘍瘎瘏瘑瘒瘓瘔瘖瘚瘜瘝瘞瘡瘣瘧瘨瘬瘮瘯瘱瘲瘶瘷瘹瘺瘻瘽癁療癄"],["b040","癅",6,"癎",5,"癕癗",4,"癝癟癠癡癢癤",6,"癬癭癮癰",7,"癹発發癿皀皁皃皅皉皊皌皍皏皐皒皔皕皗皘皚皛"],["b080","皜",7,"皥",8,"皯皰皳皵",9,"盀盁盃啊阿埃挨哎唉哀皑癌蔼矮艾碍爱隘鞍氨安俺按暗岸胺案肮昂盎凹敖熬翱袄傲奥懊澳芭捌扒叭吧笆八疤巴拔跋靶把耙坝霸罢爸白柏百摆佰败拜稗斑班搬扳般颁板版扮拌伴瓣半办绊邦帮梆榜膀绑棒磅蚌镑傍谤苞胞包褒剥"],["b140","盄盇盉盋盌盓盕盙盚盜盝盞盠",4,"盦",7,"盰盳盵盶盷盺盻盽盿眀眂眃眅眆眊県眎",10,"眛眜眝眞眡眣眤眥眧眪眫"],["b180","眬眮眰",4,"眹眻眽眾眿睂睄睅睆睈",7,"睒",7,"睜薄雹保堡饱宝抱报暴豹鲍爆杯碑悲卑北辈背贝钡倍狈备惫焙被奔苯本笨崩绷甭泵蹦迸逼鼻比鄙笔彼碧蓖蔽毕毙毖币庇痹闭敝弊必辟壁臂避陛鞭边编贬扁便变卞辨辩辫遍标彪膘表鳖憋别瘪彬斌濒滨宾摈兵冰柄丙秉饼炳"],["b240","睝睞睟睠睤睧睩睪睭",11,"睺睻睼瞁瞂瞃瞆",5,"瞏瞐瞓",11,"瞡瞣瞤瞦瞨瞫瞭瞮瞯瞱瞲瞴瞶",4],["b280","瞼瞾矀",12,"矎",8,"矘矙矚矝",4,"矤病并玻菠播拨钵波博勃搏铂箔伯帛舶脖膊渤泊驳捕卜哺补埠不布步簿部怖擦猜裁材才财睬踩采彩菜蔡餐参蚕残惭惨灿苍舱仓沧藏操糙槽曹草厕策侧册测层蹭插叉茬茶查碴搽察岔差诧拆柴豺搀掺蝉馋谗缠铲产阐颤昌猖"],["b340","矦矨矪矯矰矱矲矴矵矷矹矺矻矼砃",5,"砊砋砎砏砐砓砕砙砛砞砠砡砢砤砨砪砫砮砯砱砲砳砵砶砽砿硁硂硃硄硆硈硉硊硋硍硏硑硓硔硘硙硚"],["b380","硛硜硞",11,"硯",7,"硸硹硺硻硽",6,"场尝常长偿肠厂敞畅唱倡超抄钞朝嘲潮巢吵炒车扯撤掣彻澈郴臣辰尘晨忱沉陈趁衬撑称城橙成呈乘程惩澄诚承逞骋秤吃痴持匙池迟弛驰耻齿侈尺赤翅斥炽充冲虫崇宠抽酬畴踌稠愁筹仇绸瞅丑臭初出橱厨躇锄雏滁除楚"],["b440","碄碅碆碈碊碋碏碐碒碔碕碖碙碝碞碠碢碤碦碨",7,"碵碶碷碸確碻碼碽碿磀磂磃磄磆磇磈磌磍磎磏磑磒磓磖磗磘磚",9],["b480","磤磥磦磧磩磪磫磭",4,"磳磵磶磸磹磻",5,"礂礃礄礆",6,"础储矗搐触处揣川穿椽传船喘串疮窗幢床闯创吹炊捶锤垂春椿醇唇淳纯蠢戳绰疵茨磁雌辞慈瓷词此刺赐次聪葱囱匆从丛凑粗醋簇促蹿篡窜摧崔催脆瘁粹淬翠村存寸磋撮搓措挫错搭达答瘩打大呆歹傣戴带殆代贷袋待逮"],["b540","礍",5,"礔",9,"礟",4,"礥",14,"礵",4,"礽礿祂祃祄祅祇祊",8,"祔祕祘祙祡祣"],["b580","祤祦祩祪祫祬祮祰",6,"祹祻",4,"禂禃禆禇禈禉禋禌禍禎禐禑禒怠耽担丹单郸掸胆旦氮但惮淡诞弹蛋当挡党荡档刀捣蹈倒岛祷导到稻悼道盗德得的蹬灯登等瞪凳邓堤低滴迪敌笛狄涤翟嫡抵底地蒂第帝弟递缔颠掂滇碘点典靛垫电佃甸店惦奠淀殿碉叼雕凋刁掉吊钓调跌爹碟蝶迭谍叠"],["b640","禓",6,"禛",11,"禨",10,"禴",4,"禼禿秂秄秅秇秈秊秌秎秏秐秓秔秖秗秙",5,"秠秡秢秥秨秪"],["b680","秬秮秱",6,"秹秺秼秾秿稁稄稅稇稈稉稊稌稏",4,"稕稖稘稙稛稜丁盯叮钉顶鼎锭定订丢东冬董懂动栋侗恫冻洞兜抖斗陡豆逗痘都督毒犊独读堵睹赌杜镀肚度渡妒端短锻段断缎堆兑队对墩吨蹲敦顿囤钝盾遁掇哆多夺垛躲朵跺舵剁惰堕蛾峨鹅俄额讹娥恶厄扼遏鄂饿恩而儿耳尔饵洱二"],["b740","稝稟稡稢稤",14,"稴稵稶稸稺稾穀",5,"穇",9,"穒",4,"穘",16],["b780","穩",6,"穱穲穳穵穻穼穽穾窂窅窇窉窊窋窌窎窏窐窓窔窙窚窛窞窡窢贰发罚筏伐乏阀法珐藩帆番翻樊矾钒繁凡烦反返范贩犯饭泛坊芳方肪房防妨仿访纺放菲非啡飞肥匪诽吠肺废沸费芬酚吩氛分纷坟焚汾粉奋份忿愤粪丰封枫蜂峰锋风疯烽逢冯缝讽奉凤佛否夫敷肤孵扶拂辐幅氟符伏俘服"],["b840","窣窤窧窩窪窫窮",4,"窴",10,"竀",10,"竌",9,"竗竘竚竛竜竝竡竢竤竧",5,"竮竰竱竲竳"],["b880","竴",4,"竻竼竾笀笁笂笅笇笉笌笍笎笐笒笓笖笗笘笚笜笝笟笡笢笣笧笩笭浮涪福袱弗甫抚辅俯釜斧脯腑府腐赴副覆赋复傅付阜父腹负富讣附妇缚咐噶嘎该改概钙盖溉干甘杆柑竿肝赶感秆敢赣冈刚钢缸肛纲岗港杠篙皋高膏羔糕搞镐稿告哥歌搁戈鸽胳疙割革葛格蛤阁隔铬个各给根跟耕更庚羹"],["b940","笯笰笲笴笵笶笷笹笻笽笿",5,"筆筈筊筍筎筓筕筗筙筜筞筟筡筣",10,"筯筰筳筴筶筸筺筼筽筿箁箂箃箄箆",6,"箎箏"],["b980","箑箒箓箖箘箙箚箛箞箟箠箣箤箥箮箯箰箲箳箵箶箷箹",7,"篂篃範埂耿梗工攻功恭龚供躬公宫弓巩汞拱贡共钩勾沟苟狗垢构购够辜菇咕箍估沽孤姑鼓古蛊骨谷股故顾固雇刮瓜剐寡挂褂乖拐怪棺关官冠观管馆罐惯灌贯光广逛瑰规圭硅归龟闺轨鬼诡癸桂柜跪贵刽辊滚棍锅郭国果裹过哈"],["ba40","篅篈築篊篋篍篎篏篐篒篔",4,"篛篜篞篟篠篢篣篤篧篨篩篫篬篭篯篰篲",4,"篸篹篺篻篽篿",7,"簈簉簊簍簎簐",5,"簗簘簙"],["ba80","簚",4,"簠",5,"簨簩簫",12,"簹",5,"籂骸孩海氦亥害骇酣憨邯韩含涵寒函喊罕翰撼捍旱憾悍焊汗汉夯杭航壕嚎豪毫郝好耗号浩呵喝荷菏核禾和何合盒貉阂河涸赫褐鹤贺嘿黑痕很狠恨哼亨横衡恒轰哄烘虹鸿洪宏弘红喉侯猴吼厚候后呼乎忽瑚壶葫胡蝴狐糊湖"],["bb40","籃",9,"籎",36,"籵",5,"籾",9],["bb80","粈粊",6,"粓粔粖粙粚粛粠粡粣粦粧粨粩粫粬粭粯粰粴",4,"粺粻弧虎唬护互沪户花哗华猾滑画划化话槐徊怀淮坏欢环桓还缓换患唤痪豢焕涣宦幻荒慌黄磺蝗簧皇凰惶煌晃幌恍谎灰挥辉徽恢蛔回毁悔慧卉惠晦贿秽会烩汇讳诲绘荤昏婚魂浑混豁活伙火获或惑霍货祸击圾基机畸稽积箕"],["bc40","粿糀糂糃糄糆糉糋糎",6,"糘糚糛糝糞糡",6,"糩",5,"糰",7,"糹糺糼",13,"紋",5],["bc80","紑",14,"紡紣紤紥紦紨紩紪紬紭紮細",6,"肌饥迹激讥鸡姬绩缉吉极棘辑籍集及急疾汲即嫉级挤几脊己蓟技冀季伎祭剂悸济寄寂计记既忌际妓继纪嘉枷夹佳家加荚颊贾甲钾假稼价架驾嫁歼监坚尖笺间煎兼肩艰奸缄茧检柬碱硷拣捡简俭剪减荐槛鉴践贱见键箭件"],["bd40","紷",54,"絯",7],["bd80","絸",32,"健舰剑饯渐溅涧建僵姜将浆江疆蒋桨奖讲匠酱降蕉椒礁焦胶交郊浇骄娇嚼搅铰矫侥脚狡角饺缴绞剿教酵轿较叫窖揭接皆秸街阶截劫节桔杰捷睫竭洁结解姐戒藉芥界借介疥诫届巾筋斤金今津襟紧锦仅谨进靳晋禁近烬浸"],["be40","継",12,"綧",6,"綯",42],["be80","線",32,"尽劲荆兢茎睛晶鲸京惊精粳经井警景颈静境敬镜径痉靖竟竞净炯窘揪究纠玖韭久灸九酒厩救旧臼舅咎就疚鞠拘狙疽居驹菊局咀矩举沮聚拒据巨具距踞锯俱句惧炬剧捐鹃娟倦眷卷绢撅攫抉掘倔爵觉决诀绝均菌钧军君峻"],["bf40","緻",62],["bf80","縺縼",4,"繂",4,"繈",21,"俊竣浚郡骏喀咖卡咯开揩楷凯慨刊堪勘坎砍看康慷糠扛抗亢炕考拷烤靠坷苛柯棵磕颗科壳咳可渴克刻客课肯啃垦恳坑吭空恐孔控抠口扣寇枯哭窟苦酷库裤夸垮挎跨胯块筷侩快宽款匡筐狂框矿眶旷况亏盔岿窥葵奎魁傀"],["c040","繞",35,"纃",23,"纜纝纞"],["c080","纮纴纻纼绖绤绬绹缊缐缞缷缹缻",6,"罃罆",9,"罒罓馈愧溃坤昆捆困括扩廓阔垃拉喇蜡腊辣啦莱来赖蓝婪栏拦篮阑兰澜谰揽览懒缆烂滥琅榔狼廊郎朗浪捞劳牢老佬姥酪烙涝勒乐雷镭蕾磊累儡垒擂肋类泪棱楞冷厘梨犁黎篱狸离漓理李里鲤礼莉荔吏栗丽厉励砾历利傈例俐"],["c140","罖罙罛罜罝罞罠罣",4,"罫罬罭罯罰罳罵罶罷罸罺罻罼罽罿羀羂",7,"羋羍羏",4,"羕",4,"羛羜羠羢羣羥羦羨",6,"羱"],["c180","羳",4,"羺羻羾翀翂翃翄翆翇翈翉翋翍翏",4,"翖翗翙",5,"翢翣痢立粒沥隶力璃哩俩联莲连镰廉怜涟帘敛脸链恋炼练粮凉梁粱良两辆量晾亮谅撩聊僚疗燎寥辽潦了撂镣廖料列裂烈劣猎琳林磷霖临邻鳞淋凛赁吝拎玲菱零龄铃伶羚凌灵陵岭领另令溜琉榴硫馏留刘瘤流柳六龙聋咙笼窿"],["c240","翤翧翨翪翫翬翭翯翲翴",6,"翽翾翿耂耇耈耉耊耎耏耑耓耚耛耝耞耟耡耣耤耫",5,"耲耴耹耺耼耾聀聁聄聅聇聈聉聎聏聐聑聓聕聖聗"],["c280","聙聛",13,"聫",5,"聲",11,"隆垄拢陇楼娄搂篓漏陋芦卢颅庐炉掳卤虏鲁麓碌露路赂鹿潞禄录陆戮驴吕铝侣旅履屡缕虑氯律率滤绿峦挛孪滦卵乱掠略抡轮伦仑沦纶论萝螺罗逻锣箩骡裸落洛骆络妈麻玛码蚂马骂嘛吗埋买麦卖迈脉瞒馒蛮满蔓曼慢漫"],["c340","聾肁肂肅肈肊肍",5,"肔肕肗肙肞肣肦肧肨肬肰肳肵肶肸肹肻胅胇",4,"胏",6,"胘胟胠胢胣胦胮胵胷胹胻胾胿脀脁脃脄脅脇脈脋"],["c380","脌脕脗脙脛脜脝脟",12,"脭脮脰脳脴脵脷脹",4,"脿谩芒茫盲氓忙莽猫茅锚毛矛铆卯茂冒帽貌贸么玫枚梅酶霉煤没眉媒镁每美昧寐妹媚门闷们萌蒙檬盟锰猛梦孟眯醚靡糜迷谜弥米秘觅泌蜜密幂棉眠绵冕免勉娩缅面苗描瞄藐秒渺庙妙蔑灭民抿皿敏悯闽明螟鸣铭名命谬摸"],["c440","腀",5,"腇腉腍腎腏腒腖腗腘腛",4,"腡腢腣腤腦腨腪腫腬腯腲腳腵腶腷腸膁膃",4,"膉膋膌膍膎膐膒",5,"膙膚膞",4,"膤膥"],["c480","膧膩膫",7,"膴",5,"膼膽膾膿臄臅臇臈臉臋臍",6,"摹蘑模膜磨摩魔抹末莫墨默沫漠寞陌谋牟某拇牡亩姆母墓暮幕募慕木目睦牧穆拿哪呐钠那娜纳氖乃奶耐奈南男难囊挠脑恼闹淖呢馁内嫩能妮霓倪泥尼拟你匿腻逆溺蔫拈年碾撵捻念娘酿鸟尿捏聂孽啮镊镍涅您柠狞凝宁"],["c540","臔",14,"臤臥臦臨臩臫臮",4,"臵",5,"臽臿舃與",4,"舎舏舑舓舕",5,"舝舠舤舥舦舧舩舮舲舺舼舽舿"],["c580","艀艁艂艃艅艆艈艊艌艍艎艐",7,"艙艛艜艝艞艠",7,"艩拧泞牛扭钮纽脓浓农弄奴努怒女暖虐疟挪懦糯诺哦欧鸥殴藕呕偶沤啪趴爬帕怕琶拍排牌徘湃派攀潘盘磐盼畔判叛乓庞旁耪胖抛咆刨炮袍跑泡呸胚培裴赔陪配佩沛喷盆砰抨烹澎彭蓬棚硼篷膨朋鹏捧碰坯砒霹批披劈琵毗"],["c640","艪艫艬艭艱艵艶艷艸艻艼芀芁芃芅芆芇芉芌芐芓芔芕芖芚芛芞芠芢芣芧芲芵芶芺芻芼芿苀苂苃苅苆苉苐苖苙苚苝苢苧苨苩苪苬苭苮苰苲苳苵苶苸"],["c680","苺苼",4,"茊茋茍茐茒茓茖茘茙茝",9,"茩茪茮茰茲茷茻茽啤脾疲皮匹痞僻屁譬篇偏片骗飘漂瓢票撇瞥拼频贫品聘乒坪苹萍平凭瓶评屏坡泼颇婆破魄迫粕剖扑铺仆莆葡菩蒲埔朴圃普浦谱曝瀑期欺栖戚妻七凄漆柒沏其棋奇歧畦崎脐齐旗祈祁骑起岂乞企启契砌器气迄弃汽泣讫掐"],["c740","茾茿荁荂荄荅荈荊",4,"荓荕",4,"荝荢荰",6,"荹荺荾",6,"莇莈莊莋莌莍莏莐莑莔莕莖莗莙莚莝莟莡",6,"莬莭莮"],["c780","莯莵莻莾莿菂菃菄菆菈菉菋菍菎菐菑菒菓菕菗菙菚菛菞菢菣菤菦菧菨菫菬菭恰洽牵扦钎铅千迁签仟谦乾黔钱钳前潜遣浅谴堑嵌欠歉枪呛腔羌墙蔷强抢橇锹敲悄桥瞧乔侨巧鞘撬翘峭俏窍切茄且怯窃钦侵亲秦琴勤芹擒禽寝沁青轻氢倾卿清擎晴氰情顷请庆琼穷秋丘邱球求囚酋泅趋区蛆曲躯屈驱渠"],["c840","菮華菳",4,"菺菻菼菾菿萀萂萅萇萈萉萊萐萒",5,"萙萚萛萞",5,"萩",7,"萲",5,"萹萺萻萾",7,"葇葈葉"],["c880","葊",6,"葒",4,"葘葝葞葟葠葢葤",4,"葪葮葯葰葲葴葷葹葻葼取娶龋趣去圈颧权醛泉全痊拳犬券劝缺炔瘸却鹊榷确雀裙群然燃冉染瓤壤攘嚷让饶扰绕惹热壬仁人忍韧任认刃妊纫扔仍日戎茸蓉荣融熔溶容绒冗揉柔肉茹蠕儒孺如辱乳汝入褥软阮蕊瑞锐闰润若弱撒洒萨腮鳃塞赛三叁"],["c940","葽",4,"蒃蒄蒅蒆蒊蒍蒏",7,"蒘蒚蒛蒝蒞蒟蒠蒢",12,"蒰蒱蒳蒵蒶蒷蒻蒼蒾蓀蓂蓃蓅蓆蓇蓈蓋蓌蓎蓏蓒蓔蓕蓗"],["c980","蓘",4,"蓞蓡蓢蓤蓧",4,"蓭蓮蓯蓱",10,"蓽蓾蔀蔁蔂伞散桑嗓丧搔骚扫嫂瑟色涩森僧莎砂杀刹沙纱傻啥煞筛晒珊苫杉山删煽衫闪陕擅赡膳善汕扇缮墒伤商赏晌上尚裳梢捎稍烧芍勺韶少哨邵绍奢赊蛇舌舍赦摄射慑涉社设砷申呻伸身深娠绅神沈审婶甚肾慎渗声生甥牲升绳"],["ca40","蔃",8,"蔍蔎蔏蔐蔒蔔蔕蔖蔘蔙蔛蔜蔝蔞蔠蔢",8,"蔭",9,"蔾",4,"蕄蕅蕆蕇蕋",10],["ca80","蕗蕘蕚蕛蕜蕝蕟",4,"蕥蕦蕧蕩",8,"蕳蕵蕶蕷蕸蕼蕽蕿薀薁省盛剩胜圣师失狮施湿诗尸虱十石拾时什食蚀实识史矢使屎驶始式示士世柿事拭誓逝势是嗜噬适仕侍释饰氏市恃室视试收手首守寿授售受瘦兽蔬枢梳殊抒输叔舒淑疏书赎孰熟薯暑曙署蜀黍鼠属术述树束戍竖墅庶数漱"],["cb40","薂薃薆薈",6,"薐",10,"薝",6,"薥薦薧薩薫薬薭薱",5,"薸薺",6,"藂",6,"藊",4,"藑藒"],["cb80","藔藖",5,"藝",6,"藥藦藧藨藪",14,"恕刷耍摔衰甩帅栓拴霜双爽谁水睡税吮瞬顺舜说硕朔烁斯撕嘶思私司丝死肆寺嗣四伺似饲巳松耸怂颂送宋讼诵搜艘擞嗽苏酥俗素速粟僳塑溯宿诉肃酸蒜算虽隋随绥髓碎岁穗遂隧祟孙损笋蓑梭唆缩琐索锁所塌他它她塔"],["cc40","藹藺藼藽藾蘀",4,"蘆",10,"蘒蘓蘔蘕蘗",15,"蘨蘪",13,"蘹蘺蘻蘽蘾蘿虀"],["cc80","虁",11,"虒虓處",4,"虛虜虝號虠虡虣",7,"獭挞蹋踏胎苔抬台泰酞太态汰坍摊贪瘫滩坛檀痰潭谭谈坦毯袒碳探叹炭汤塘搪堂棠膛唐糖倘躺淌趟烫掏涛滔绦萄桃逃淘陶讨套特藤腾疼誊梯剔踢锑提题蹄啼体替嚏惕涕剃屉天添填田甜恬舔腆挑条迢眺跳贴铁帖厅听烃"],["cd40","虭虯虰虲",6,"蚃",6,"蚎",4,"蚔蚖",5,"蚞",4,"蚥蚦蚫蚭蚮蚲蚳蚷蚸蚹蚻",4,"蛁蛂蛃蛅蛈蛌蛍蛒蛓蛕蛖蛗蛚蛜"],["cd80","蛝蛠蛡蛢蛣蛥蛦蛧蛨蛪蛫蛬蛯蛵蛶蛷蛺蛻蛼蛽蛿蜁蜄蜅蜆蜋蜌蜎蜏蜐蜑蜔蜖汀廷停亭庭挺艇通桐酮瞳同铜彤童桶捅筒统痛偷投头透凸秃突图徒途涂屠土吐兔湍团推颓腿蜕褪退吞屯臀拖托脱鸵陀驮驼椭妥拓唾挖哇蛙洼娃瓦袜歪外豌弯湾玩顽丸烷完碗挽晚皖惋宛婉万腕汪王亡枉网往旺望忘妄威"],["ce40","蜙蜛蜝蜟蜠蜤蜦蜧蜨蜪蜫蜬蜭蜯蜰蜲蜳蜵蜶蜸蜹蜺蜼蜽蝀",6,"蝊蝋蝍蝏蝐蝑蝒蝔蝕蝖蝘蝚",5,"蝡蝢蝦",7,"蝯蝱蝲蝳蝵"],["ce80","蝷蝸蝹蝺蝿螀螁螄螆螇螉螊螌螎",4,"螔螕螖螘",6,"螠",4,"巍微危韦违桅围唯惟为潍维苇萎委伟伪尾纬未蔚味畏胃喂魏位渭谓尉慰卫瘟温蚊文闻纹吻稳紊问嗡翁瓮挝蜗涡窝我斡卧握沃巫呜钨乌污诬屋无芜梧吾吴毋武五捂午舞伍侮坞戊雾晤物勿务悟误昔熙析西硒矽晰嘻吸锡牺"],["cf40","螥螦螧螩螪螮螰螱螲螴螶螷螸螹螻螼螾螿蟁",4,"蟇蟈蟉蟌",4,"蟔",6,"蟜蟝蟞蟟蟡蟢蟣蟤蟦蟧蟨蟩蟫蟬蟭蟯",9],["cf80","蟺蟻蟼蟽蟿蠀蠁蠂蠄",5,"蠋",7,"蠔蠗蠘蠙蠚蠜",4,"蠣稀息希悉膝夕惜熄烯溪汐犀檄袭席习媳喜铣洗系隙戏细瞎虾匣霞辖暇峡侠狭下厦夏吓掀锨先仙鲜纤咸贤衔舷闲涎弦嫌显险现献县腺馅羡宪陷限线相厢镶香箱襄湘乡翔祥详想响享项巷橡像向象萧硝霄削哮嚣销消宵淆晓"],["d040","蠤",13,"蠳",5,"蠺蠻蠽蠾蠿衁衂衃衆",5,"衎",5,"衕衖衘衚",6,"衦衧衪衭衯衱衳衴衵衶衸衹衺"],["d080","衻衼袀袃袆袇袉袊袌袎袏袐袑袓袔袕袗",4,"袝",4,"袣袥",5,"小孝校肖啸笑效楔些歇蝎鞋协挟携邪斜胁谐写械卸蟹懈泄泻谢屑薪芯锌欣辛新忻心信衅星腥猩惺兴刑型形邢行醒幸杏性姓兄凶胸匈汹雄熊休修羞朽嗅锈秀袖绣墟戌需虚嘘须徐许蓄酗叙旭序畜恤絮婿绪续轩喧宣悬旋玄"],["d140","袬袮袯袰袲",4,"袸袹袺袻袽袾袿裀裃裄裇裈裊裋裌裍裏裐裑裓裖裗裚",4,"裠裡裦裧裩",6,"裲裵裶裷裺裻製裿褀褁褃",5],["d180","褉褋",4,"褑褔",4,"褜",4,"褢褣褤褦褧褨褩褬褭褮褯褱褲褳褵褷选癣眩绚靴薛学穴雪血勋熏循旬询寻驯巡殉汛训讯逊迅压押鸦鸭呀丫芽牙蚜崖衙涯雅哑亚讶焉咽阉烟淹盐严研蜒岩延言颜阎炎沿奄掩眼衍演艳堰燕厌砚雁唁彦焰宴谚验殃央鸯秧杨扬佯疡羊洋阳氧仰痒养样漾邀腰妖瑶"],["d240","褸",8,"襂襃襅",24,"襠",5,"襧",19,"襼"],["d280","襽襾覀覂覄覅覇",26,"摇尧遥窑谣姚咬舀药要耀椰噎耶爷野冶也页掖业叶曳腋夜液一壹医揖铱依伊衣颐夷遗移仪胰疑沂宜姨彝椅蚁倚已乙矣以艺抑易邑屹亿役臆逸肄疫亦裔意毅忆义益溢诣议谊译异翼翌绎茵荫因殷音阴姻吟银淫寅饮尹引隐"],["d340","覢",30,"觃觍觓觔觕觗觘觙觛觝觟觠觡觢觤觧觨觩觪觬觭觮觰觱觲觴",6],["d380","觻",4,"訁",5,"計",21,"印英樱婴鹰应缨莹萤营荧蝇迎赢盈影颖硬映哟拥佣臃痈庸雍踊蛹咏泳涌永恿勇用幽优悠忧尤由邮铀犹油游酉有友右佑釉诱又幼迂淤于盂榆虞愚舆余俞逾鱼愉渝渔隅予娱雨与屿禹宇语羽玉域芋郁吁遇喻峪御愈欲狱育誉"],["d440","訞",31,"訿",8,"詉",21],["d480","詟",25,"詺",6,"浴寓裕预豫驭鸳渊冤元垣袁原援辕园员圆猿源缘远苑愿怨院曰约越跃钥岳粤月悦阅耘云郧匀陨允运蕴酝晕韵孕匝砸杂栽哉灾宰载再在咱攒暂赞赃脏葬遭糟凿藻枣早澡蚤躁噪造皂灶燥责择则泽贼怎增憎曾赠扎喳渣札轧"],["d540","誁",7,"誋",7,"誔",46],["d580","諃",32,"铡闸眨栅榨咋乍炸诈摘斋宅窄债寨瞻毡詹粘沾盏斩辗崭展蘸栈占战站湛绽樟章彰漳张掌涨杖丈帐账仗胀瘴障招昭找沼赵照罩兆肇召遮折哲蛰辙者锗蔗这浙珍斟真甄砧臻贞针侦枕疹诊震振镇阵蒸挣睁征狰争怔整拯正政"],["d640","諤",34,"謈",27],["d680","謤謥謧",30,"帧症郑证芝枝支吱蜘知肢脂汁之织职直植殖执值侄址指止趾只旨纸志挚掷至致置帜峙制智秩稚质炙痔滞治窒中盅忠钟衷终种肿重仲众舟周州洲诌粥轴肘帚咒皱宙昼骤珠株蛛朱猪诸诛逐竹烛煮拄瞩嘱主著柱助蛀贮铸筑"],["d740","譆",31,"譧",4,"譭",25],["d780","讇",24,"讬讱讻诇诐诪谉谞住注祝驻抓爪拽专砖转撰赚篆桩庄装妆撞壮状椎锥追赘坠缀谆准捉拙卓桌琢茁酌啄着灼浊兹咨资姿滋淄孜紫仔籽滓子自渍字鬃棕踪宗综总纵邹走奏揍租足卒族祖诅阻组钻纂嘴醉最罪尊遵昨左佐柞做作坐座"],["d840","谸",8,"豂豃豄豅豈豊豋豍",7,"豖豗豘豙豛",5,"豣",6,"豬",6,"豴豵豶豷豻",6,"貃貄貆貇"],["d880","貈貋貍",6,"貕貖貗貙",20,"亍丌兀丐廿卅丕亘丞鬲孬噩丨禺丿匕乇夭爻卮氐囟胤馗毓睾鼗丶亟鼐乜乩亓芈孛啬嘏仄厍厝厣厥厮靥赝匚叵匦匮匾赜卦卣刂刈刎刭刳刿剀剌剞剡剜蒯剽劂劁劐劓冂罔亻仃仉仂仨仡仫仞伛仳伢佤仵伥伧伉伫佞佧攸佚佝"],["d940","貮",62],["d980","賭",32,"佟佗伲伽佶佴侑侉侃侏佾佻侪佼侬侔俦俨俪俅俚俣俜俑俟俸倩偌俳倬倏倮倭俾倜倌倥倨偾偃偕偈偎偬偻傥傧傩傺僖儆僭僬僦僮儇儋仝氽佘佥俎龠汆籴兮巽黉馘冁夔勹匍訇匐凫夙兕亠兖亳衮袤亵脔裒禀嬴蠃羸冫冱冽冼"],["da40","贎",14,"贠赑赒赗赟赥赨赩赪赬赮赯赱赲赸",8,"趂趃趆趇趈趉趌",4,"趒趓趕",9,"趠趡"],["da80","趢趤",12,"趲趶趷趹趻趽跀跁跂跅跇跈跉跊跍跐跒跓跔凇冖冢冥讠讦讧讪讴讵讷诂诃诋诏诎诒诓诔诖诘诙诜诟诠诤诨诩诮诰诳诶诹诼诿谀谂谄谇谌谏谑谒谔谕谖谙谛谘谝谟谠谡谥谧谪谫谮谯谲谳谵谶卩卺阝阢阡阱阪阽阼陂陉陔陟陧陬陲陴隈隍隗隰邗邛邝邙邬邡邴邳邶邺"],["db40","跕跘跙跜跠跡跢跥跦跧跩跭跮跰跱跲跴跶跼跾",6,"踆踇踈踋踍踎踐踑踒踓踕",7,"踠踡踤",4,"踫踭踰踲踳踴踶踷踸踻踼踾"],["db80","踿蹃蹅蹆蹌",4,"蹓",5,"蹚",11,"蹧蹨蹪蹫蹮蹱邸邰郏郅邾郐郄郇郓郦郢郜郗郛郫郯郾鄄鄢鄞鄣鄱鄯鄹酃酆刍奂劢劬劭劾哿勐勖勰叟燮矍廴凵凼鬯厶弁畚巯坌垩垡塾墼壅壑圩圬圪圳圹圮圯坜圻坂坩垅坫垆坼坻坨坭坶坳垭垤垌垲埏垧垴垓垠埕埘埚埙埒垸埴埯埸埤埝"],["dc40","蹳蹵蹷",4,"蹽蹾躀躂躃躄躆躈",6,"躑躒躓躕",6,"躝躟",11,"躭躮躰躱躳",6,"躻",7],["dc80","軃",10,"軏",21,"堋堍埽埭堀堞堙塄堠塥塬墁墉墚墀馨鼙懿艹艽艿芏芊芨芄芎芑芗芙芫芸芾芰苈苊苣芘芷芮苋苌苁芩芴芡芪芟苄苎芤苡茉苷苤茏茇苜苴苒苘茌苻苓茑茚茆茔茕苠苕茜荑荛荜茈莒茼茴茱莛荞茯荏荇荃荟荀茗荠茭茺茳荦荥"],["dd40","軥",62],["dd80","輤",32,"荨茛荩荬荪荭荮莰荸莳莴莠莪莓莜莅荼莶莩荽莸荻莘莞莨莺莼菁萁菥菘堇萘萋菝菽菖萜萸萑萆菔菟萏萃菸菹菪菅菀萦菰菡葜葑葚葙葳蒇蒈葺蒉葸萼葆葩葶蒌蒎萱葭蓁蓍蓐蓦蒽蓓蓊蒿蒺蓠蒡蒹蒴蒗蓥蓣蔌甍蔸蓰蔹蔟蔺"],["de40","轅",32,"轪辀辌辒辝辠辡辢辤辥辦辧辪辬辭辮辯農辳辴辵辷辸辺辻込辿迀迃迆"],["de80","迉",4,"迏迒迖迗迚迠迡迣迧迬迯迱迲迴迵迶迺迻迼迾迿逇逈逌逎逓逕逘蕖蔻蓿蓼蕙蕈蕨蕤蕞蕺瞢蕃蕲蕻薤薨薇薏蕹薮薜薅薹薷薰藓藁藜藿蘧蘅蘩蘖蘼廾弈夼奁耷奕奚奘匏尢尥尬尴扌扪抟抻拊拚拗拮挢拶挹捋捃掭揶捱捺掎掴捭掬掊捩掮掼揲揸揠揿揄揞揎摒揆掾摅摁搋搛搠搌搦搡摞撄摭撖"],["df40","這逜連逤逥逧",5,"逰",4,"逷逹逺逽逿遀遃遅遆遈",4,"過達違遖遙遚遜",5,"遤遦遧適遪遫遬遯",4,"遶",6,"遾邁"],["df80","還邅邆邇邉邊邌",4,"邒邔邖邘邚邜邞邟邠邤邥邧邨邩邫邭邲邷邼邽邿郀摺撷撸撙撺擀擐擗擤擢攉攥攮弋忒甙弑卟叱叽叩叨叻吒吖吆呋呒呓呔呖呃吡呗呙吣吲咂咔呷呱呤咚咛咄呶呦咝哐咭哂咴哒咧咦哓哔呲咣哕咻咿哌哙哚哜咩咪咤哝哏哞唛哧唠哽唔哳唢唣唏唑唧唪啧喏喵啉啭啁啕唿啐唼"],["e040","郂郃郆郈郉郋郌郍郒郔郕郖郘郙郚郞郟郠郣郤郥郩郪郬郮郰郱郲郳郵郶郷郹郺郻郼郿鄀鄁鄃鄅",19,"鄚鄛鄜"],["e080","鄝鄟鄠鄡鄤",10,"鄰鄲",6,"鄺",8,"酄唷啖啵啶啷唳唰啜喋嗒喃喱喹喈喁喟啾嗖喑啻嗟喽喾喔喙嗪嗷嗉嘟嗑嗫嗬嗔嗦嗝嗄嗯嗥嗲嗳嗌嗍嗨嗵嗤辔嘞嘈嘌嘁嘤嘣嗾嘀嘧嘭噘嘹噗嘬噍噢噙噜噌噔嚆噤噱噫噻噼嚅嚓嚯囔囗囝囡囵囫囹囿圄圊圉圜帏帙帔帑帱帻帼"],["e140","酅酇酈酑酓酔酕酖酘酙酛酜酟酠酦酧酨酫酭酳酺酻酼醀",4,"醆醈醊醎醏醓",6,"醜",5,"醤",5,"醫醬醰醱醲醳醶醷醸醹醻"],["e180","醼",10,"釈釋釐釒",9,"針",8,"帷幄幔幛幞幡岌屺岍岐岖岈岘岙岑岚岜岵岢岽岬岫岱岣峁岷峄峒峤峋峥崂崃崧崦崮崤崞崆崛嵘崾崴崽嵬嵛嵯嵝嵫嵋嵊嵩嵴嶂嶙嶝豳嶷巅彳彷徂徇徉後徕徙徜徨徭徵徼衢彡犭犰犴犷犸狃狁狎狍狒狨狯狩狲狴狷猁狳猃狺"],["e240","釦",62],["e280","鈥",32,"狻猗猓猡猊猞猝猕猢猹猥猬猸猱獐獍獗獠獬獯獾舛夥飧夤夂饣饧",5,"饴饷饽馀馄馇馊馍馐馑馓馔馕庀庑庋庖庥庠庹庵庾庳赓廒廑廛廨廪膺忄忉忖忏怃忮怄忡忤忾怅怆忪忭忸怙怵怦怛怏怍怩怫怊怿怡恸恹恻恺恂"],["e340","鉆",45,"鉵",16],["e380","銆",7,"銏",24,"恪恽悖悚悭悝悃悒悌悛惬悻悱惝惘惆惚悴愠愦愕愣惴愀愎愫慊慵憬憔憧憷懔懵忝隳闩闫闱闳闵闶闼闾阃阄阆阈阊阋阌阍阏阒阕阖阗阙阚丬爿戕氵汔汜汊沣沅沐沔沌汨汩汴汶沆沩泐泔沭泷泸泱泗沲泠泖泺泫泮沱泓泯泾"],["e440","銨",5,"銯",24,"鋉",31],["e480","鋩",32,"洹洧洌浃浈洇洄洙洎洫浍洮洵洚浏浒浔洳涑浯涞涠浞涓涔浜浠浼浣渚淇淅淞渎涿淠渑淦淝淙渖涫渌涮渫湮湎湫溲湟溆湓湔渲渥湄滟溱溘滠漭滢溥溧溽溻溷滗溴滏溏滂溟潢潆潇漤漕滹漯漶潋潴漪漉漩澉澍澌潸潲潼潺濑"],["e540","錊",51,"錿",10],["e580","鍊",31,"鍫濉澧澹澶濂濡濮濞濠濯瀚瀣瀛瀹瀵灏灞宀宄宕宓宥宸甯骞搴寤寮褰寰蹇謇辶迓迕迥迮迤迩迦迳迨逅逄逋逦逑逍逖逡逵逶逭逯遄遑遒遐遨遘遢遛暹遴遽邂邈邃邋彐彗彖彘尻咫屐屙孱屣屦羼弪弩弭艴弼鬻屮妁妃妍妩妪妣"],["e640","鍬",34,"鎐",27],["e680","鎬",29,"鏋鏌鏍妗姊妫妞妤姒妲妯姗妾娅娆姝娈姣姘姹娌娉娲娴娑娣娓婀婧婊婕娼婢婵胬媪媛婷婺媾嫫媲嫒嫔媸嫠嫣嫱嫖嫦嫘嫜嬉嬗嬖嬲嬷孀尕尜孚孥孳孑孓孢驵驷驸驺驿驽骀骁骅骈骊骐骒骓骖骘骛骜骝骟骠骢骣骥骧纟纡纣纥纨纩"],["e740","鏎",7,"鏗",54],["e780","鐎",32,"纭纰纾绀绁绂绉绋绌绐绔绗绛绠绡绨绫绮绯绱绲缍绶绺绻绾缁缂缃缇缈缋缌缏缑缒缗缙缜缛缟缡",6,"缪缫缬缭缯",4,"缵幺畿巛甾邕玎玑玮玢玟珏珂珑玷玳珀珉珈珥珙顼琊珩珧珞玺珲琏琪瑛琦琥琨琰琮琬"],["e840","鐯",14,"鐿",43,"鑬鑭鑮鑯"],["e880","鑰",20,"钑钖钘铇铏铓铔铚铦铻锜锠琛琚瑁瑜瑗瑕瑙瑷瑭瑾璜璎璀璁璇璋璞璨璩璐璧瓒璺韪韫韬杌杓杞杈杩枥枇杪杳枘枧杵枨枞枭枋杷杼柰栉柘栊柩枰栌柙枵柚枳柝栀柃枸柢栎柁柽栲栳桠桡桎桢桄桤梃栝桕桦桁桧桀栾桊桉栩梵梏桴桷梓桫棂楮棼椟椠棹"],["e940","锧锳锽镃镈镋镕镚镠镮镴镵長",7,"門",42],["e980","閫",32,"椤棰椋椁楗棣椐楱椹楠楂楝榄楫榀榘楸椴槌榇榈槎榉楦楣楹榛榧榻榫榭槔榱槁槊槟榕槠榍槿樯槭樗樘橥槲橄樾檠橐橛樵檎橹樽樨橘橼檑檐檩檗檫猷獒殁殂殇殄殒殓殍殚殛殡殪轫轭轱轲轳轵轶轸轷轹轺轼轾辁辂辄辇辋"],["ea40","闌",27,"闬闿阇阓阘阛阞阠阣",6,"阫阬阭阯阰阷阸阹阺阾陁陃陊陎陏陑陒陓陖陗"],["ea80","陘陙陚陜陝陞陠陣陥陦陫陭",4,"陳陸",12,"隇隉隊辍辎辏辘辚軎戋戗戛戟戢戡戥戤戬臧瓯瓴瓿甏甑甓攴旮旯旰昊昙杲昃昕昀炅曷昝昴昱昶昵耆晟晔晁晏晖晡晗晷暄暌暧暝暾曛曜曦曩贲贳贶贻贽赀赅赆赈赉赇赍赕赙觇觊觋觌觎觏觐觑牮犟牝牦牯牾牿犄犋犍犏犒挈挲掰"],["eb40","隌階隑隒隓隕隖隚際隝",9,"隨",7,"隱隲隴隵隷隸隺隻隿雂雃雈雊雋雐雑雓雔雖",9,"雡",6,"雫"],["eb80","雬雭雮雰雱雲雴雵雸雺電雼雽雿霂霃霅霊霋霌霐霑霒霔霕霗",4,"霝霟霠搿擘耄毪毳毽毵毹氅氇氆氍氕氘氙氚氡氩氤氪氲攵敕敫牍牒牖爰虢刖肟肜肓肼朊肽肱肫肭肴肷胧胨胩胪胛胂胄胙胍胗朐胝胫胱胴胭脍脎胲胼朕脒豚脶脞脬脘脲腈腌腓腴腙腚腱腠腩腼腽腭腧塍媵膈膂膑滕膣膪臌朦臊膻"],["ec40","霡",8,"霫霬霮霯霱霳",4,"霺霻霼霽霿",18,"靔靕靗靘靚靜靝靟靣靤靦靧靨靪",7],["ec80","靲靵靷",4,"靽",7,"鞆",4,"鞌鞎鞏鞐鞓鞕鞖鞗鞙",4,"臁膦欤欷欹歃歆歙飑飒飓飕飙飚殳彀毂觳斐齑斓於旆旄旃旌旎旒旖炀炜炖炝炻烀炷炫炱烨烊焐焓焖焯焱煳煜煨煅煲煊煸煺熘熳熵熨熠燠燔燧燹爝爨灬焘煦熹戾戽扃扈扉礻祀祆祉祛祜祓祚祢祗祠祯祧祺禅禊禚禧禳忑忐"],["ed40","鞞鞟鞡鞢鞤",6,"鞬鞮鞰鞱鞳鞵",46],["ed80","韤韥韨韮",4,"韴韷",23,"怼恝恚恧恁恙恣悫愆愍慝憩憝懋懑戆肀聿沓泶淼矶矸砀砉砗砘砑斫砭砜砝砹砺砻砟砼砥砬砣砩硎硭硖硗砦硐硇硌硪碛碓碚碇碜碡碣碲碹碥磔磙磉磬磲礅磴礓礤礞礴龛黹黻黼盱眄眍盹眇眈眚眢眙眭眦眵眸睐睑睇睃睚睨"],["ee40","頏",62],["ee80","顎",32,"睢睥睿瞍睽瞀瞌瞑瞟瞠瞰瞵瞽町畀畎畋畈畛畲畹疃罘罡罟詈罨罴罱罹羁罾盍盥蠲钅钆钇钋钊钌钍钏钐钔钗钕钚钛钜钣钤钫钪钭钬钯钰钲钴钶",4,"钼钽钿铄铈",6,"铐铑铒铕铖铗铙铘铛铞铟铠铢铤铥铧铨铪"],["ef40","顯",5,"颋颎颒颕颙颣風",37,"飏飐飔飖飗飛飜飝飠",4],["ef80","飥飦飩",30,"铩铫铮铯铳铴铵铷铹铼铽铿锃锂锆锇锉锊锍锎锏锒",4,"锘锛锝锞锟锢锪锫锩锬锱锲锴锶锷锸锼锾锿镂锵镄镅镆镉镌镎镏镒镓镔镖镗镘镙镛镞镟镝镡镢镤",8,"镯镱镲镳锺矧矬雉秕秭秣秫稆嵇稃稂稞稔"],["f040","餈",4,"餎餏餑",28,"餯",26],["f080","饊",9,"饖",12,"饤饦饳饸饹饻饾馂馃馉稹稷穑黏馥穰皈皎皓皙皤瓞瓠甬鸠鸢鸨",4,"鸲鸱鸶鸸鸷鸹鸺鸾鹁鹂鹄鹆鹇鹈鹉鹋鹌鹎鹑鹕鹗鹚鹛鹜鹞鹣鹦",6,"鹱鹭鹳疒疔疖疠疝疬疣疳疴疸痄疱疰痃痂痖痍痣痨痦痤痫痧瘃痱痼痿瘐瘀瘅瘌瘗瘊瘥瘘瘕瘙"],["f140","馌馎馚",10,"馦馧馩",47],["f180","駙",32,"瘛瘼瘢瘠癀瘭瘰瘿瘵癃瘾瘳癍癞癔癜癖癫癯翊竦穸穹窀窆窈窕窦窠窬窨窭窳衤衩衲衽衿袂袢裆袷袼裉裢裎裣裥裱褚裼裨裾裰褡褙褓褛褊褴褫褶襁襦襻疋胥皲皴矜耒耔耖耜耠耢耥耦耧耩耨耱耋耵聃聆聍聒聩聱覃顸颀颃"],["f240","駺",62],["f280","騹",32,"颉颌颍颏颔颚颛颞颟颡颢颥颦虍虔虬虮虿虺虼虻蚨蚍蚋蚬蚝蚧蚣蚪蚓蚩蚶蛄蚵蛎蚰蚺蚱蚯蛉蛏蚴蛩蛱蛲蛭蛳蛐蜓蛞蛴蛟蛘蛑蜃蜇蛸蜈蜊蜍蜉蜣蜻蜞蜥蜮蜚蜾蝈蜴蜱蜩蜷蜿螂蜢蝽蝾蝻蝠蝰蝌蝮螋蝓蝣蝼蝤蝙蝥螓螯螨蟒"],["f340","驚",17,"驲骃骉骍骎骔骕骙骦骩",6,"骲骳骴骵骹骻骽骾骿髃髄髆",4,"髍髎髏髐髒體髕髖髗髙髚髛髜"],["f380","髝髞髠髢髣髤髥髧髨髩髪髬髮髰",8,"髺髼",6,"鬄鬅鬆蟆螈螅螭螗螃螫蟥螬螵螳蟋蟓螽蟑蟀蟊蟛蟪蟠蟮蠖蠓蟾蠊蠛蠡蠹蠼缶罂罄罅舐竺竽笈笃笄笕笊笫笏筇笸笪笙笮笱笠笥笤笳笾笞筘筚筅筵筌筝筠筮筻筢筲筱箐箦箧箸箬箝箨箅箪箜箢箫箴篑篁篌篝篚篥篦篪簌篾篼簏簖簋"],["f440","鬇鬉",5,"鬐鬑鬒鬔",10,"鬠鬡鬢鬤",10,"鬰鬱鬳",7,"鬽鬾鬿魀魆魊魋魌魎魐魒魓魕",5],["f480","魛",32,"簟簪簦簸籁籀臾舁舂舄臬衄舡舢舣舭舯舨舫舸舻舳舴舾艄艉艋艏艚艟艨衾袅袈裘裟襞羝羟羧羯羰羲籼敉粑粝粜粞粢粲粼粽糁糇糌糍糈糅糗糨艮暨羿翎翕翥翡翦翩翮翳糸絷綦綮繇纛麸麴赳趄趔趑趱赧赭豇豉酊酐酎酏酤"],["f540","魼",62],["f580","鮻",32,"酢酡酰酩酯酽酾酲酴酹醌醅醐醍醑醢醣醪醭醮醯醵醴醺豕鹾趸跫踅蹙蹩趵趿趼趺跄跖跗跚跞跎跏跛跆跬跷跸跣跹跻跤踉跽踔踝踟踬踮踣踯踺蹀踹踵踽踱蹉蹁蹂蹑蹒蹊蹰蹶蹼蹯蹴躅躏躔躐躜躞豸貂貊貅貘貔斛觖觞觚觜"],["f640","鯜",62],["f680","鰛",32,"觥觫觯訾謦靓雩雳雯霆霁霈霏霎霪霭霰霾龀龃龅",5,"龌黾鼋鼍隹隼隽雎雒瞿雠銎銮鋈錾鍪鏊鎏鐾鑫鱿鲂鲅鲆鲇鲈稣鲋鲎鲐鲑鲒鲔鲕鲚鲛鲞",5,"鲥",4,"鲫鲭鲮鲰",7,"鲺鲻鲼鲽鳄鳅鳆鳇鳊鳋"],["f740","鰼",62],["f780","鱻鱽鱾鲀鲃鲄鲉鲊鲌鲏鲓鲖鲗鲘鲙鲝鲪鲬鲯鲹鲾",4,"鳈鳉鳑鳒鳚鳛鳠鳡鳌",4,"鳓鳔鳕鳗鳘鳙鳜鳝鳟鳢靼鞅鞑鞒鞔鞯鞫鞣鞲鞴骱骰骷鹘骶骺骼髁髀髅髂髋髌髑魅魃魇魉魈魍魑飨餍餮饕饔髟髡髦髯髫髻髭髹鬈鬏鬓鬟鬣麽麾縻麂麇麈麋麒鏖麝麟黛黜黝黠黟黢黩黧黥黪黯鼢鼬鼯鼹鼷鼽鼾齄"],["f840","鳣",62],["f880","鴢",32],["f940","鵃",62],["f980","鶂",32],["fa40","鶣",62],["fa80","鷢",32],["fb40","鸃",27,"鸤鸧鸮鸰鸴鸻鸼鹀鹍鹐鹒鹓鹔鹖鹙鹝鹟鹠鹡鹢鹥鹮鹯鹲鹴",9,"麀"],["fb80","麁麃麄麅麆麉麊麌",5,"麔",8,"麞麠",5,"麧麨麩麪"],["fc40","麫",8,"麵麶麷麹麺麼麿",4,"黅黆黇黈黊黋黌黐黒黓黕黖黗黙黚點黡黣黤黦黨黫黬黭黮黰",8,"黺黽黿",6],["fc80","鼆",4,"鼌鼏鼑鼒鼔鼕鼖鼘鼚",5,"鼡鼣",8,"鼭鼮鼰鼱"],["fd40","鼲",4,"鼸鼺鼼鼿",4,"齅",10,"齒",38],["fd80","齹",5,"龁龂龍",11,"龜龝龞龡",4,"郎凉秊裏隣"],["fe40","兀嗀﨎﨏﨑﨓﨔礼﨟蘒﨡﨣﨤﨧﨨﨩"]]');

/***/ }),

/***/ 1166:
/***/ ((module) => {

"use strict";
module.exports = /*#__PURE__*/JSON.parse('[["0","\\u0000",127],["8141","갂갃갅갆갋",4,"갘갞갟갡갢갣갥",6,"갮갲갳갴"],["8161","갵갶갷갺갻갽갾갿걁",9,"걌걎",5,"걕"],["8181","걖걗걙걚걛걝",18,"걲걳걵걶걹걻",4,"겂겇겈겍겎겏겑겒겓겕",6,"겞겢",5,"겫겭겮겱",6,"겺겾겿곀곂곃곅곆곇곉곊곋곍",7,"곖곘",7,"곢곣곥곦곩곫곭곮곲곴곷",4,"곾곿괁괂괃괅괇",4,"괎괐괒괓"],["8241","괔괕괖괗괙괚괛괝괞괟괡",7,"괪괫괮",5],["8261","괶괷괹괺괻괽",6,"굆굈굊",5,"굑굒굓굕굖굗"],["8281","굙",7,"굢굤",7,"굮굯굱굲굷굸굹굺굾궀궃",4,"궊궋궍궎궏궑",10,"궞",5,"궥",17,"궸",7,"귂귃귅귆귇귉",6,"귒귔",7,"귝귞귟귡귢귣귥",18],["8341","귺귻귽귾긂",5,"긊긌긎",5,"긕",7],["8361","긝",18,"긲긳긵긶긹긻긼"],["8381","긽긾긿깂깄깇깈깉깋깏깑깒깓깕깗",4,"깞깢깣깤깦깧깪깫깭깮깯깱",6,"깺깾",5,"꺆",5,"꺍",46,"꺿껁껂껃껅",6,"껎껒",5,"껚껛껝",8],["8441","껦껧껩껪껬껮",5,"껵껶껷껹껺껻껽",8],["8461","꼆꼉꼊꼋꼌꼎꼏꼑",18],["8481","꼤",7,"꼮꼯꼱꼳꼵",6,"꼾꽀꽄꽅꽆꽇꽊",5,"꽑",10,"꽞",5,"꽦",18,"꽺",5,"꾁꾂꾃꾅꾆꾇꾉",6,"꾒꾓꾔꾖",5,"꾝",26,"꾺꾻꾽꾾"],["8541","꾿꿁",5,"꿊꿌꿏",4,"꿕",6,"꿝",4],["8561","꿢",5,"꿪",5,"꿲꿳꿵꿶꿷꿹",6,"뀂뀃"],["8581","뀅",6,"뀍뀎뀏뀑뀒뀓뀕",6,"뀞",9,"뀩",26,"끆끇끉끋끍끏끐끑끒끖끘끚끛끜끞",29,"끾끿낁낂낃낅",6,"낎낐낒",5,"낛낝낞낣낤"],["8641","낥낦낧낪낰낲낶낷낹낺낻낽",6,"냆냊",5,"냒"],["8661","냓냕냖냗냙",6,"냡냢냣냤냦",10],["8681","냱",22,"넊넍넎넏넑넔넕넖넗넚넞",4,"넦넧넩넪넫넭",6,"넶넺",5,"녂녃녅녆녇녉",6,"녒녓녖녗녙녚녛녝녞녟녡",22,"녺녻녽녾녿놁놃",4,"놊놌놎놏놐놑놕놖놗놙놚놛놝"],["8741","놞",9,"놩",15],["8761","놹",18,"뇍뇎뇏뇑뇒뇓뇕"],["8781","뇖",5,"뇞뇠",7,"뇪뇫뇭뇮뇯뇱",7,"뇺뇼뇾",5,"눆눇눉눊눍",6,"눖눘눚",5,"눡",18,"눵",6,"눽",26,"뉙뉚뉛뉝뉞뉟뉡",6,"뉪",4],["8841","뉯",4,"뉶",5,"뉽",6,"늆늇늈늊",4],["8861","늏늒늓늕늖늗늛",4,"늢늤늧늨늩늫늭늮늯늱늲늳늵늶늷"],["8881","늸",15,"닊닋닍닎닏닑닓",4,"닚닜닞닟닠닡닣닧닩닪닰닱닲닶닼닽닾댂댃댅댆댇댉",6,"댒댖",5,"댝",54,"덗덙덚덝덠덡덢덣"],["8941","덦덨덪덬덭덯덲덳덵덶덷덹",6,"뎂뎆",5,"뎍"],["8961","뎎뎏뎑뎒뎓뎕",10,"뎢",5,"뎩뎪뎫뎭"],["8981","뎮",21,"돆돇돉돊돍돏돑돒돓돖돘돚돜돞돟돡돢돣돥돦돧돩",18,"돽",18,"됑",6,"됙됚됛됝됞됟됡",6,"됪됬",7,"됵",15],["8a41","둅",10,"둒둓둕둖둗둙",6,"둢둤둦"],["8a61","둧",4,"둭",18,"뒁뒂"],["8a81","뒃",4,"뒉",19,"뒞",5,"뒥뒦뒧뒩뒪뒫뒭",7,"뒶뒸뒺",5,"듁듂듃듅듆듇듉",6,"듑듒듓듔듖",5,"듞듟듡듢듥듧",4,"듮듰듲",5,"듹",26,"딖딗딙딚딝"],["8b41","딞",5,"딦딫",4,"딲딳딵딶딷딹",6,"땂땆"],["8b61","땇땈땉땊땎땏땑땒땓땕",6,"땞땢",8],["8b81","땫",52,"떢떣떥떦떧떩떬떭떮떯떲떶",4,"떾떿뗁뗂뗃뗅",6,"뗎뗒",5,"뗙",18,"뗭",18],["8c41","똀",15,"똒똓똕똖똗똙",4],["8c61","똞",6,"똦",5,"똭",6,"똵",5],["8c81","똻",12,"뙉",26,"뙥뙦뙧뙩",50,"뚞뚟뚡뚢뚣뚥",5,"뚭뚮뚯뚰뚲",16],["8d41","뛃",16,"뛕",8],["8d61","뛞",17,"뛱뛲뛳뛵뛶뛷뛹뛺"],["8d81","뛻",4,"뜂뜃뜄뜆",33,"뜪뜫뜭뜮뜱",6,"뜺뜼",7,"띅띆띇띉띊띋띍",6,"띖",9,"띡띢띣띥띦띧띩",6,"띲띴띶",5,"띾띿랁랂랃랅",6,"랎랓랔랕랚랛랝랞"],["8e41","랟랡",6,"랪랮",5,"랶랷랹",8],["8e61","럂",4,"럈럊",19],["8e81","럞",13,"럮럯럱럲럳럵",6,"럾렂",4,"렊렋렍렎렏렑",6,"렚렜렞",5,"렦렧렩렪렫렭",6,"렶렺",5,"롁롂롃롅",11,"롒롔",7,"롞롟롡롢롣롥",6,"롮롰롲",5,"롹롺롻롽",7],["8f41","뢅",7,"뢎",17],["8f61","뢠",7,"뢩",6,"뢱뢲뢳뢵뢶뢷뢹",4],["8f81","뢾뢿룂룄룆",5,"룍룎룏룑룒룓룕",7,"룞룠룢",5,"룪룫룭룮룯룱",6,"룺룼룾",5,"뤅",18,"뤙",6,"뤡",26,"뤾뤿륁륂륃륅",6,"륍륎륐륒",5],["9041","륚륛륝륞륟륡",6,"륪륬륮",5,"륶륷륹륺륻륽"],["9061","륾",5,"릆릈릋릌릏",15],["9081","릟",12,"릮릯릱릲릳릵",6,"릾맀맂",5,"맊맋맍맓",4,"맚맜맟맠맢맦맧맩맪맫맭",6,"맶맻",4,"먂",5,"먉",11,"먖",33,"먺먻먽먾먿멁멃멄멅멆"],["9141","멇멊멌멏멐멑멒멖멗멙멚멛멝",6,"멦멪",5],["9161","멲멳멵멶멷멹",9,"몆몈몉몊몋몍",5],["9181","몓",20,"몪몭몮몯몱몳",4,"몺몼몾",5,"뫅뫆뫇뫉",14,"뫚",33,"뫽뫾뫿묁묂묃묅",7,"묎묐묒",5,"묙묚묛묝묞묟묡",6],["9241","묨묪묬",7,"묷묹묺묿",4,"뭆뭈뭊뭋뭌뭎뭑뭒"],["9261","뭓뭕뭖뭗뭙",7,"뭢뭤",7,"뭭",4],["9281","뭲",21,"뮉뮊뮋뮍뮎뮏뮑",18,"뮥뮦뮧뮩뮪뮫뮭",6,"뮵뮶뮸",7,"믁믂믃믅믆믇믉",6,"믑믒믔",35,"믺믻믽믾밁"],["9341","밃",4,"밊밎밐밒밓밙밚밠밡밢밣밦밨밪밫밬밮밯밲밳밵"],["9361","밶밷밹",6,"뱂뱆뱇뱈뱊뱋뱎뱏뱑",8],["9381","뱚뱛뱜뱞",37,"벆벇벉벊벍벏",4,"벖벘벛",4,"벢벣벥벦벩",6,"벲벶",5,"벾벿볁볂볃볅",7,"볎볒볓볔볖볗볙볚볛볝",22,"볷볹볺볻볽"],["9441","볾",5,"봆봈봊",5,"봑봒봓봕",8],["9461","봞",5,"봥",6,"봭",12],["9481","봺",5,"뵁",6,"뵊뵋뵍뵎뵏뵑",6,"뵚",9,"뵥뵦뵧뵩",22,"붂붃붅붆붋",4,"붒붔붖붗붘붛붝",6,"붥",10,"붱",6,"붹",24],["9541","뷒뷓뷖뷗뷙뷚뷛뷝",11,"뷪",5,"뷱"],["9561","뷲뷳뷵뷶뷷뷹",6,"븁븂븄븆",5,"븎븏븑븒븓"],["9581","븕",6,"븞븠",35,"빆빇빉빊빋빍빏",4,"빖빘빜빝빞빟빢빣빥빦빧빩빫",4,"빲빶",4,"빾빿뺁뺂뺃뺅",6,"뺎뺒",5,"뺚",13,"뺩",14],["9641","뺸",23,"뻒뻓"],["9661","뻕뻖뻙",6,"뻡뻢뻦",5,"뻭",8],["9681","뻶",10,"뼂",5,"뼊",13,"뼚뼞",33,"뽂뽃뽅뽆뽇뽉",6,"뽒뽓뽔뽖",44],["9741","뾃",16,"뾕",8],["9761","뾞",17,"뾱",7],["9781","뾹",11,"뿆",5,"뿎뿏뿑뿒뿓뿕",6,"뿝뿞뿠뿢",89,"쀽쀾쀿"],["9841","쁀",16,"쁒",5,"쁙쁚쁛"],["9861","쁝쁞쁟쁡",6,"쁪",15],["9881","쁺",21,"삒삓삕삖삗삙",6,"삢삤삦",5,"삮삱삲삷",4,"삾샂샃샄샆샇샊샋샍샎샏샑",6,"샚샞",5,"샦샧샩샪샫샭",6,"샶샸샺",5,"섁섂섃섅섆섇섉",6,"섑섒섓섔섖",5,"섡섢섥섨섩섪섫섮"],["9941","섲섳섴섵섷섺섻섽섾섿셁",6,"셊셎",5,"셖셗"],["9961","셙셚셛셝",6,"셦셪",5,"셱셲셳셵셶셷셹셺셻"],["9981","셼",8,"솆",5,"솏솑솒솓솕솗",4,"솞솠솢솣솤솦솧솪솫솭솮솯솱",11,"솾",5,"쇅쇆쇇쇉쇊쇋쇍",6,"쇕쇖쇙",6,"쇡쇢쇣쇥쇦쇧쇩",6,"쇲쇴",7,"쇾쇿숁숂숃숅",6,"숎숐숒",5,"숚숛숝숞숡숢숣"],["9a41","숤숥숦숧숪숬숮숰숳숵",16],["9a61","쉆쉇쉉",6,"쉒쉓쉕쉖쉗쉙",6,"쉡쉢쉣쉤쉦"],["9a81","쉧",4,"쉮쉯쉱쉲쉳쉵",6,"쉾슀슂",5,"슊",5,"슑",6,"슙슚슜슞",5,"슦슧슩슪슫슮",5,"슶슸슺",33,"싞싟싡싢싥",5,"싮싰싲싳싴싵싷싺싽싾싿쌁",6,"쌊쌋쌎쌏"],["9b41","쌐쌑쌒쌖쌗쌙쌚쌛쌝",6,"쌦쌧쌪",8],["9b61","쌳",17,"썆",7],["9b81","썎",25,"썪썫썭썮썯썱썳",4,"썺썻썾",5,"쎅쎆쎇쎉쎊쎋쎍",50,"쏁",22,"쏚"],["9c41","쏛쏝쏞쏡쏣",4,"쏪쏫쏬쏮",5,"쏶쏷쏹",5],["9c61","쏿",8,"쐉",6,"쐑",9],["9c81","쐛",8,"쐥",6,"쐭쐮쐯쐱쐲쐳쐵",6,"쐾",9,"쑉",26,"쑦쑧쑩쑪쑫쑭",6,"쑶쑷쑸쑺",5,"쒁",18,"쒕",6,"쒝",12],["9d41","쒪",13,"쒹쒺쒻쒽",8],["9d61","쓆",25],["9d81","쓠",8,"쓪",5,"쓲쓳쓵쓶쓷쓹쓻쓼쓽쓾씂",9,"씍씎씏씑씒씓씕",6,"씝",10,"씪씫씭씮씯씱",6,"씺씼씾",5,"앆앇앋앏앐앑앒앖앚앛앜앟앢앣앥앦앧앩",6,"앲앶",5,"앾앿얁얂얃얅얆얈얉얊얋얎얐얒얓얔"],["9e41","얖얙얚얛얝얞얟얡",7,"얪",9,"얶"],["9e61","얷얺얿",4,"엋엍엏엒엓엕엖엗엙",6,"엢엤엦엧"],["9e81","엨엩엪엫엯엱엲엳엵엸엹엺엻옂옃옄옉옊옋옍옎옏옑",6,"옚옝",6,"옦옧옩옪옫옯옱옲옶옸옺옼옽옾옿왂왃왅왆왇왉",6,"왒왖",5,"왞왟왡",10,"왭왮왰왲",5,"왺왻왽왾왿욁",6,"욊욌욎",5,"욖욗욙욚욛욝",6,"욦"],["9f41","욨욪",5,"욲욳욵욶욷욻",4,"웂웄웆",5,"웎"],["9f61","웏웑웒웓웕",6,"웞웟웢",5,"웪웫웭웮웯웱웲"],["9f81","웳",4,"웺웻웼웾",5,"윆윇윉윊윋윍",6,"윖윘윚",5,"윢윣윥윦윧윩",6,"윲윴윶윸윹윺윻윾윿읁읂읃읅",4,"읋읎읐읙읚읛읝읞읟읡",6,"읩읪읬",7,"읶읷읹읺읻읿잀잁잂잆잋잌잍잏잒잓잕잙잛",4,"잢잧",4,"잮잯잱잲잳잵잶잷"],["a041","잸잹잺잻잾쟂",5,"쟊쟋쟍쟏쟑",6,"쟙쟚쟛쟜"],["a061","쟞",5,"쟥쟦쟧쟩쟪쟫쟭",13],["a081","쟻",4,"젂젃젅젆젇젉젋",4,"젒젔젗",4,"젞젟젡젢젣젥",6,"젮젰젲",5,"젹젺젻젽젾젿졁",6,"졊졋졎",5,"졕",26,"졲졳졵졶졷졹졻",4,"좂좄좈좉좊좎",5,"좕",7,"좞좠좢좣좤"],["a141","좥좦좧좩",18,"좾좿죀죁"],["a161","죂죃죅죆죇죉죊죋죍",6,"죖죘죚",5,"죢죣죥"],["a181","죦",14,"죶",5,"죾죿줁줂줃줇",4,"줎　、。·‥…¨〃­―∥＼∼‘’“”〔〕〈",9,"±×÷≠≤≥∞∴°′″℃Å￠￡￥♂♀∠⊥⌒∂∇≡≒§※☆★○●◎◇◆□■△▲▽▼→←↑↓↔〓≪≫√∽∝∵∫∬∈∋⊆⊇⊂⊃∪∩∧∨￢"],["a241","줐줒",5,"줙",18],["a261","줭",6,"줵",18],["a281","쥈",7,"쥒쥓쥕쥖쥗쥙",6,"쥢쥤",7,"쥭쥮쥯⇒⇔∀∃´～ˇ˘˝˚˙¸˛¡¿ː∮∑∏¤℉‰◁◀▷▶♤♠♡♥♧♣⊙◈▣◐◑▒▤▥▨▧▦▩♨☏☎☜☞¶†‡↕↗↙↖↘♭♩♪♬㉿㈜№㏇™㏂㏘℡€®"],["a341","쥱쥲쥳쥵",6,"쥽",10,"즊즋즍즎즏"],["a361","즑",6,"즚즜즞",16],["a381","즯",16,"짂짃짅짆짉짋",4,"짒짔짗짘짛！",58,"￦］",32,"￣"],["a441","짞짟짡짣짥짦짨짩짪짫짮짲",5,"짺짻짽짾짿쨁쨂쨃쨄"],["a461","쨅쨆쨇쨊쨎",5,"쨕쨖쨗쨙",12],["a481","쨦쨧쨨쨪",28,"ㄱ",93],["a541","쩇",4,"쩎쩏쩑쩒쩓쩕",6,"쩞쩢",5,"쩩쩪"],["a561","쩫",17,"쩾",5,"쪅쪆"],["a581","쪇",16,"쪙",14,"ⅰ",9],["a5b0","Ⅰ",9],["a5c1","Α",16,"Σ",6],["a5e1","α",16,"σ",6],["a641","쪨",19,"쪾쪿쫁쫂쫃쫅"],["a661","쫆",5,"쫎쫐쫒쫔쫕쫖쫗쫚",5,"쫡",6],["a681","쫨쫩쫪쫫쫭",6,"쫵",18,"쬉쬊─│┌┐┘└├┬┤┴┼━┃┏┓┛┗┣┳┫┻╋┠┯┨┷┿┝┰┥┸╂┒┑┚┙┖┕┎┍┞┟┡┢┦┧┩┪┭┮┱┲┵┶┹┺┽┾╀╁╃",7],["a741","쬋",4,"쬑쬒쬓쬕쬖쬗쬙",6,"쬢",7],["a761","쬪",22,"쭂쭃쭄"],["a781","쭅쭆쭇쭊쭋쭍쭎쭏쭑",6,"쭚쭛쭜쭞",5,"쭥",7,"㎕㎖㎗ℓ㎘㏄㎣㎤㎥㎦㎙",9,"㏊㎍㎎㎏㏏㎈㎉㏈㎧㎨㎰",9,"㎀",4,"㎺",5,"㎐",4,"Ω㏀㏁㎊㎋㎌㏖㏅㎭㎮㎯㏛㎩㎪㎫㎬㏝㏐㏓㏃㏉㏜㏆"],["a841","쭭",10,"쭺",14],["a861","쮉",18,"쮝",6],["a881","쮤",19,"쮹",11,"ÆÐªĦ"],["a8a6","Ĳ"],["a8a8","ĿŁØŒºÞŦŊ"],["a8b1","㉠",27,"ⓐ",25,"①",14,"½⅓⅔¼¾⅛⅜⅝⅞"],["a941","쯅",14,"쯕",10],["a961","쯠쯡쯢쯣쯥쯦쯨쯪",18],["a981","쯽",14,"찎찏찑찒찓찕",6,"찞찟찠찣찤æđðħıĳĸŀłøœßþŧŋŉ㈀",27,"⒜",25,"⑴",14,"¹²³⁴ⁿ₁₂₃₄"],["aa41","찥찦찪찫찭찯찱",6,"찺찿",4,"챆챇챉챊챋챍챎"],["aa61","챏",4,"챖챚",5,"챡챢챣챥챧챩",6,"챱챲"],["aa81","챳챴챶",29,"ぁ",82],["ab41","첔첕첖첗첚첛첝첞첟첡",6,"첪첮",5,"첶첷첹"],["ab61","첺첻첽",6,"쳆쳈쳊",5,"쳑쳒쳓쳕",5],["ab81","쳛",8,"쳥",6,"쳭쳮쳯쳱",12,"ァ",85],["ac41","쳾쳿촀촂",5,"촊촋촍촎촏촑",6,"촚촜촞촟촠"],["ac61","촡촢촣촥촦촧촩촪촫촭",11,"촺",4],["ac81","촿",28,"쵝쵞쵟А",5,"ЁЖ",25],["acd1","а",5,"ёж",25],["ad41","쵡쵢쵣쵥",6,"쵮쵰쵲",5,"쵹",7],["ad61","춁",6,"춉",10,"춖춗춙춚춛춝춞춟"],["ad81","춠춡춢춣춦춨춪",5,"춱",18,"췅"],["ae41","췆",5,"췍췎췏췑",16],["ae61","췢",5,"췩췪췫췭췮췯췱",6,"췺췼췾",4],["ae81","츃츅츆츇츉츊츋츍",6,"츕츖츗츘츚",5,"츢츣츥츦츧츩츪츫"],["af41","츬츭츮츯츲츴츶",19],["af61","칊",13,"칚칛칝칞칢",5,"칪칬"],["af81","칮",5,"칶칷칹칺칻칽",6,"캆캈캊",5,"캒캓캕캖캗캙"],["b041","캚",5,"캢캦",5,"캮",12],["b061","캻",5,"컂",19],["b081","컖",13,"컦컧컩컪컭",6,"컶컺",5,"가각간갇갈갉갊감",7,"같",4,"갠갤갬갭갯갰갱갸갹갼걀걋걍걔걘걜거걱건걷걸걺검겁것겄겅겆겉겊겋게겐겔겜겝겟겠겡겨격겪견겯결겸겹겻겼경곁계곈곌곕곗고곡곤곧골곪곬곯곰곱곳공곶과곽관괄괆"],["b141","켂켃켅켆켇켉",6,"켒켔켖",5,"켝켞켟켡켢켣"],["b161","켥",6,"켮켲",5,"켹",11],["b181","콅",14,"콖콗콙콚콛콝",6,"콦콨콪콫콬괌괍괏광괘괜괠괩괬괭괴괵괸괼굄굅굇굉교굔굘굡굣구국군굳굴굵굶굻굼굽굿궁궂궈궉권궐궜궝궤궷귀귁귄귈귐귑귓규균귤그극근귿글긁금급긋긍긔기긱긴긷길긺김깁깃깅깆깊까깍깎깐깔깖깜깝깟깠깡깥깨깩깬깰깸"],["b241","콭콮콯콲콳콵콶콷콹",6,"쾁쾂쾃쾄쾆",5,"쾍"],["b261","쾎",18,"쾢",5,"쾩"],["b281","쾪",5,"쾱",18,"쿅",6,"깹깻깼깽꺄꺅꺌꺼꺽꺾껀껄껌껍껏껐껑께껙껜껨껫껭껴껸껼꼇꼈꼍꼐꼬꼭꼰꼲꼴꼼꼽꼿꽁꽂꽃꽈꽉꽐꽜꽝꽤꽥꽹꾀꾄꾈꾐꾑꾕꾜꾸꾹꾼꿀꿇꿈꿉꿋꿍꿎꿔꿜꿨꿩꿰꿱꿴꿸뀀뀁뀄뀌뀐뀔뀜뀝뀨끄끅끈끊끌끎끓끔끕끗끙"],["b341","쿌",19,"쿢쿣쿥쿦쿧쿩"],["b361","쿪",5,"쿲쿴쿶",5,"쿽쿾쿿퀁퀂퀃퀅",5],["b381","퀋",5,"퀒",5,"퀙",19,"끝끼끽낀낄낌낍낏낑나낙낚난낟날낡낢남납낫",4,"낱낳내낵낸낼냄냅냇냈냉냐냑냔냘냠냥너넉넋넌널넒넓넘넙넛넜넝넣네넥넨넬넴넵넷넸넹녀녁년녈념녑녔녕녘녜녠노녹논놀놂놈놉놋농높놓놔놘놜놨뇌뇐뇔뇜뇝"],["b441","퀮",5,"퀶퀷퀹퀺퀻퀽",6,"큆큈큊",5],["b461","큑큒큓큕큖큗큙",6,"큡",10,"큮큯"],["b481","큱큲큳큵",6,"큾큿킀킂",18,"뇟뇨뇩뇬뇰뇹뇻뇽누눅눈눋눌눔눕눗눙눠눴눼뉘뉜뉠뉨뉩뉴뉵뉼늄늅늉느늑는늘늙늚늠늡늣능늦늪늬늰늴니닉닌닐닒님닙닛닝닢다닥닦단닫",4,"닳담답닷",4,"닿대댁댄댈댐댑댓댔댕댜더덕덖던덛덜덞덟덤덥"],["b541","킕",14,"킦킧킩킪킫킭",5],["b561","킳킶킸킺",5,"탂탃탅탆탇탊",5,"탒탖",4],["b581","탛탞탟탡탢탣탥",6,"탮탲",5,"탹",11,"덧덩덫덮데덱덴델뎀뎁뎃뎄뎅뎌뎐뎔뎠뎡뎨뎬도독돈돋돌돎돐돔돕돗동돛돝돠돤돨돼됐되된될됨됩됫됴두둑둔둘둠둡둣둥둬뒀뒈뒝뒤뒨뒬뒵뒷뒹듀듄듈듐듕드득든듣들듦듬듭듯등듸디딕딘딛딜딤딥딧딨딩딪따딱딴딸"],["b641","턅",7,"턎",17],["b661","턠",15,"턲턳턵턶턷턹턻턼턽턾"],["b681","턿텂텆",5,"텎텏텑텒텓텕",6,"텞텠텢",5,"텩텪텫텭땀땁땃땄땅땋때땍땐땔땜땝땟땠땡떠떡떤떨떪떫떰떱떳떴떵떻떼떽뗀뗄뗌뗍뗏뗐뗑뗘뗬또똑똔똘똥똬똴뙈뙤뙨뚜뚝뚠뚤뚫뚬뚱뛔뛰뛴뛸뜀뜁뜅뜨뜩뜬뜯뜰뜸뜹뜻띄띈띌띔띕띠띤띨띰띱띳띵라락란랄람랍랏랐랑랒랖랗"],["b741","텮",13,"텽",6,"톅톆톇톉톊"],["b761","톋",20,"톢톣톥톦톧"],["b781","톩",6,"톲톴톶톷톸톹톻톽톾톿퇁",14,"래랙랜랠램랩랫랬랭랴략랸럇량러럭런럴럼럽럿렀렁렇레렉렌렐렘렙렛렝려력련렬렴렵렷렸령례롄롑롓로록론롤롬롭롯롱롸롼뢍뢨뢰뢴뢸룀룁룃룅료룐룔룝룟룡루룩룬룰룸룹룻룽뤄뤘뤠뤼뤽륀륄륌륏륑류륙륜률륨륩"],["b841","퇐",7,"퇙",17],["b861","퇫",8,"퇵퇶퇷퇹",13],["b881","툈툊",5,"툑",24,"륫륭르륵른를름릅릇릉릊릍릎리릭린릴림립릿링마막만많",4,"맘맙맛망맞맡맣매맥맨맬맴맵맷맸맹맺먀먁먈먕머먹먼멀멂멈멉멋멍멎멓메멕멘멜멤멥멧멨멩며멱면멸몃몄명몇몌모목몫몬몰몲몸몹못몽뫄뫈뫘뫙뫼"],["b941","툪툫툮툯툱툲툳툵",6,"툾퉀퉂",5,"퉉퉊퉋퉌"],["b961","퉍",14,"퉝",6,"퉥퉦퉧퉨"],["b981","퉩",22,"튂튃튅튆튇튉튊튋튌묀묄묍묏묑묘묜묠묩묫무묵묶문묻물묽묾뭄뭅뭇뭉뭍뭏뭐뭔뭘뭡뭣뭬뮈뮌뮐뮤뮨뮬뮴뮷므믄믈믐믓미믹민믿밀밂밈밉밋밌밍및밑바",4,"받",4,"밤밥밧방밭배백밴밸뱀뱁뱃뱄뱅뱉뱌뱍뱐뱝버벅번벋벌벎범법벗"],["ba41","튍튎튏튒튓튔튖",5,"튝튞튟튡튢튣튥",6,"튭"],["ba61","튮튯튰튲",5,"튺튻튽튾틁틃",4,"틊틌",5],["ba81","틒틓틕틖틗틙틚틛틝",6,"틦",9,"틲틳틵틶틷틹틺벙벚베벡벤벧벨벰벱벳벴벵벼벽변별볍볏볐병볕볘볜보복볶본볼봄봅봇봉봐봔봤봬뵀뵈뵉뵌뵐뵘뵙뵤뵨부북분붇불붉붊붐붑붓붕붙붚붜붤붰붸뷔뷕뷘뷜뷩뷰뷴뷸븀븃븅브븍븐블븜븝븟비빅빈빌빎빔빕빗빙빚빛빠빡빤"],["bb41","틻",4,"팂팄팆",5,"팏팑팒팓팕팗",4,"팞팢팣"],["bb61","팤팦팧팪팫팭팮팯팱",6,"팺팾",5,"퍆퍇퍈퍉"],["bb81","퍊",31,"빨빪빰빱빳빴빵빻빼빽뺀뺄뺌뺍뺏뺐뺑뺘뺙뺨뻐뻑뻔뻗뻘뻠뻣뻤뻥뻬뼁뼈뼉뼘뼙뼛뼜뼝뽀뽁뽄뽈뽐뽑뽕뾔뾰뿅뿌뿍뿐뿔뿜뿟뿡쀼쁑쁘쁜쁠쁨쁩삐삑삔삘삠삡삣삥사삭삯산삳살삵삶삼삽삿샀상샅새색샌샐샘샙샛샜생샤"],["bc41","퍪",17,"퍾퍿펁펂펃펅펆펇"],["bc61","펈펉펊펋펎펒",5,"펚펛펝펞펟펡",6,"펪펬펮"],["bc81","펯",4,"펵펶펷펹펺펻펽",6,"폆폇폊",5,"폑",5,"샥샨샬샴샵샷샹섀섄섈섐섕서",4,"섣설섦섧섬섭섯섰성섶세섹센셀셈셉셋셌셍셔셕션셜셤셥셧셨셩셰셴셸솅소속솎손솔솖솜솝솟송솥솨솩솬솰솽쇄쇈쇌쇔쇗쇘쇠쇤쇨쇰쇱쇳쇼쇽숀숄숌숍숏숑수숙순숟술숨숩숫숭"],["bd41","폗폙",7,"폢폤",7,"폮폯폱폲폳폵폶폷"],["bd61","폸폹폺폻폾퐀퐂",5,"퐉",13],["bd81","퐗",5,"퐞",25,"숯숱숲숴쉈쉐쉑쉔쉘쉠쉥쉬쉭쉰쉴쉼쉽쉿슁슈슉슐슘슛슝스슥슨슬슭슴습슷승시식신싣실싫심십싯싱싶싸싹싻싼쌀쌈쌉쌌쌍쌓쌔쌕쌘쌜쌤쌥쌨쌩썅써썩썬썰썲썸썹썼썽쎄쎈쎌쏀쏘쏙쏜쏟쏠쏢쏨쏩쏭쏴쏵쏸쐈쐐쐤쐬쐰"],["be41","퐸",7,"푁푂푃푅",14],["be61","푔",7,"푝푞푟푡푢푣푥",7,"푮푰푱푲"],["be81","푳",4,"푺푻푽푾풁풃",4,"풊풌풎",5,"풕",8,"쐴쐼쐽쑈쑤쑥쑨쑬쑴쑵쑹쒀쒔쒜쒸쒼쓩쓰쓱쓴쓸쓺쓿씀씁씌씐씔씜씨씩씬씰씸씹씻씽아악안앉않알앍앎앓암압앗았앙앝앞애액앤앨앰앱앳앴앵야약얀얄얇얌얍얏양얕얗얘얜얠얩어억언얹얻얼얽얾엄",6,"엌엎"],["bf41","풞",10,"풪",14],["bf61","풹",18,"퓍퓎퓏퓑퓒퓓퓕"],["bf81","퓖",5,"퓝퓞퓠",7,"퓩퓪퓫퓭퓮퓯퓱",6,"퓹퓺퓼에엑엔엘엠엡엣엥여역엮연열엶엷염",5,"옅옆옇예옌옐옘옙옛옜오옥온올옭옮옰옳옴옵옷옹옻와왁완왈왐왑왓왔왕왜왝왠왬왯왱외왹왼욀욈욉욋욍요욕욘욜욤욥욧용우욱운울욹욺움웁웃웅워웍원월웜웝웠웡웨"],["c041","퓾",5,"픅픆픇픉픊픋픍",6,"픖픘",5],["c061","픞",25],["c081","픸픹픺픻픾픿핁핂핃핅",6,"핎핐핒",5,"핚핛핝핞핟핡핢핣웩웬웰웸웹웽위윅윈윌윔윕윗윙유육윤율윰윱윳융윷으윽은을읊음읍읏응",7,"읜읠읨읫이익인일읽읾잃임입잇있잉잊잎자작잔잖잗잘잚잠잡잣잤장잦재잭잰잴잼잽잿쟀쟁쟈쟉쟌쟎쟐쟘쟝쟤쟨쟬저적전절젊"],["c141","핤핦핧핪핬핮",5,"핶핷핹핺핻핽",6,"햆햊햋"],["c161","햌햍햎햏햑",19,"햦햧"],["c181","햨",31,"점접젓정젖제젝젠젤젬젭젯젱져젼졀졈졉졌졍졔조족존졸졺좀좁좃종좆좇좋좌좍좔좝좟좡좨좼좽죄죈죌죔죕죗죙죠죡죤죵주죽준줄줅줆줌줍줏중줘줬줴쥐쥑쥔쥘쥠쥡쥣쥬쥰쥴쥼즈즉즌즐즘즙즛증지직진짇질짊짐집짓"],["c241","헊헋헍헎헏헑헓",4,"헚헜헞",5,"헦헧헩헪헫헭헮"],["c261","헯",4,"헶헸헺",5,"혂혃혅혆혇혉",6,"혒"],["c281","혖",5,"혝혞혟혡혢혣혥",7,"혮",9,"혺혻징짖짙짚짜짝짠짢짤짧짬짭짯짰짱째짹짼쨀쨈쨉쨋쨌쨍쨔쨘쨩쩌쩍쩐쩔쩜쩝쩟쩠쩡쩨쩽쪄쪘쪼쪽쫀쫄쫌쫍쫏쫑쫓쫘쫙쫠쫬쫴쬈쬐쬔쬘쬠쬡쭁쭈쭉쭌쭐쭘쭙쭝쭤쭸쭹쮜쮸쯔쯤쯧쯩찌찍찐찔찜찝찡찢찧차착찬찮찰참찹찻"],["c341","혽혾혿홁홂홃홄홆홇홊홌홎홏홐홒홓홖홗홙홚홛홝",4],["c361","홢",4,"홨홪",5,"홲홳홵",11],["c381","횁횂횄횆",5,"횎횏횑횒횓횕",7,"횞횠횢",5,"횩횪찼창찾채책챈챌챔챕챗챘챙챠챤챦챨챰챵처척천철첨첩첫첬청체첵첸첼쳄쳅쳇쳉쳐쳔쳤쳬쳰촁초촉촌촐촘촙촛총촤촨촬촹최쵠쵤쵬쵭쵯쵱쵸춈추축춘출춤춥춧충춰췄췌췐취췬췰췸췹췻췽츄츈츌츔츙츠측츤츨츰츱츳층"],["c441","횫횭횮횯횱",7,"횺횼",7,"훆훇훉훊훋"],["c461","훍훎훏훐훒훓훕훖훘훚",5,"훡훢훣훥훦훧훩",4],["c481","훮훯훱훲훳훴훶",5,"훾훿휁휂휃휅",11,"휒휓휔치칙친칟칠칡침칩칫칭카칵칸칼캄캅캇캉캐캑캔캘캠캡캣캤캥캬캭컁커컥컨컫컬컴컵컷컸컹케켁켄켈켐켑켓켕켜켠켤켬켭켯켰켱켸코콕콘콜콤콥콧콩콰콱콴콸쾀쾅쾌쾡쾨쾰쿄쿠쿡쿤쿨쿰쿱쿳쿵쿼퀀퀄퀑퀘퀭퀴퀵퀸퀼"],["c541","휕휖휗휚휛휝휞휟휡",6,"휪휬휮",5,"휶휷휹"],["c561","휺휻휽",6,"흅흆흈흊",5,"흒흓흕흚",4],["c581","흟흢흤흦흧흨흪흫흭흮흯흱흲흳흵",6,"흾흿힀힂",5,"힊힋큄큅큇큉큐큔큘큠크큭큰클큼큽킁키킥킨킬킴킵킷킹타탁탄탈탉탐탑탓탔탕태택탠탤탬탭탯탰탱탸턍터턱턴털턺텀텁텃텄텅테텍텐텔템텝텟텡텨텬텼톄톈토톡톤톨톰톱톳통톺톼퇀퇘퇴퇸툇툉툐투툭툰툴툼툽툿퉁퉈퉜"],["c641","힍힎힏힑",6,"힚힜힞",5],["c6a1","퉤튀튁튄튈튐튑튕튜튠튤튬튱트특튼튿틀틂틈틉틋틔틘틜틤틥티틱틴틸팀팁팃팅파팍팎판팔팖팜팝팟팠팡팥패팩팬팰팸팹팻팼팽퍄퍅퍼퍽펀펄펌펍펏펐펑페펙펜펠펨펩펫펭펴편펼폄폅폈평폐폘폡폣포폭폰폴폼폽폿퐁"],["c7a1","퐈퐝푀푄표푠푤푭푯푸푹푼푿풀풂품풉풋풍풔풩퓌퓐퓔퓜퓟퓨퓬퓰퓸퓻퓽프픈플픔픕픗피픽핀필핌핍핏핑하학한할핥함합핫항해핵핸핼햄햅햇했행햐향허헉헌헐헒험헙헛헝헤헥헨헬헴헵헷헹혀혁현혈혐협혓혔형혜혠"],["c8a1","혤혭호혹혼홀홅홈홉홋홍홑화확환활홧황홰홱홴횃횅회획횐횔횝횟횡효횬횰횹횻후훅훈훌훑훔훗훙훠훤훨훰훵훼훽휀휄휑휘휙휜휠휨휩휫휭휴휵휸휼흄흇흉흐흑흔흖흗흘흙흠흡흣흥흩희흰흴흼흽힁히힉힌힐힘힙힛힝"],["caa1","伽佳假價加可呵哥嘉嫁家暇架枷柯歌珂痂稼苛茄街袈訶賈跏軻迦駕刻却各恪慤殼珏脚覺角閣侃刊墾奸姦干幹懇揀杆柬桿澗癎看磵稈竿簡肝艮艱諫間乫喝曷渴碣竭葛褐蝎鞨勘坎堪嵌感憾戡敢柑橄減甘疳監瞰紺邯鑑鑒龕"],["cba1","匣岬甲胛鉀閘剛堈姜岡崗康强彊慷江畺疆糠絳綱羌腔舡薑襁講鋼降鱇介价個凱塏愷愾慨改槪漑疥皆盖箇芥蓋豈鎧開喀客坑更粳羹醵倨去居巨拒据據擧渠炬祛距踞車遽鉅鋸乾件健巾建愆楗腱虔蹇鍵騫乞傑杰桀儉劍劒檢"],["cca1","瞼鈐黔劫怯迲偈憩揭擊格檄激膈覡隔堅牽犬甄絹繭肩見譴遣鵑抉決潔結缺訣兼慊箝謙鉗鎌京俓倞傾儆勁勍卿坰境庚徑慶憬擎敬景暻更梗涇炅烱璟璥瓊痙硬磬竟競絅經耕耿脛莖警輕逕鏡頃頸驚鯨係啓堺契季屆悸戒桂械"],["cda1","棨溪界癸磎稽系繫繼計誡谿階鷄古叩告呱固姑孤尻庫拷攷故敲暠枯槁沽痼皐睾稿羔考股膏苦苽菰藁蠱袴誥賈辜錮雇顧高鼓哭斛曲梏穀谷鵠困坤崑昆梱棍滾琨袞鯤汨滑骨供公共功孔工恐恭拱控攻珙空蚣貢鞏串寡戈果瓜"],["cea1","科菓誇課跨過鍋顆廓槨藿郭串冠官寬慣棺款灌琯瓘管罐菅觀貫關館刮恝括适侊光匡壙廣曠洸炚狂珖筐胱鑛卦掛罫乖傀塊壞怪愧拐槐魁宏紘肱轟交僑咬喬嬌嶠巧攪敎校橋狡皎矯絞翹膠蕎蛟較轎郊餃驕鮫丘久九仇俱具勾"],["cfa1","區口句咎嘔坵垢寇嶇廐懼拘救枸柩構歐毆毬求溝灸狗玖球瞿矩究絿耉臼舅舊苟衢謳購軀逑邱鉤銶駒驅鳩鷗龜國局菊鞠鞫麴君窘群裙軍郡堀屈掘窟宮弓穹窮芎躬倦券勸卷圈拳捲權淃眷厥獗蕨蹶闕机櫃潰詭軌饋句晷歸貴"],["d0a1","鬼龜叫圭奎揆槻珪硅窺竅糾葵規赳逵閨勻均畇筠菌鈞龜橘克剋劇戟棘極隙僅劤勤懃斤根槿瑾筋芹菫覲謹近饉契今妗擒昑檎琴禁禽芩衾衿襟金錦伋及急扱汲級給亘兢矜肯企伎其冀嗜器圻基埼夔奇妓寄岐崎己幾忌技旗旣"],["d1a1","朞期杞棋棄機欺氣汽沂淇玘琦琪璂璣畸畿碁磯祁祇祈祺箕紀綺羈耆耭肌記譏豈起錡錤飢饑騎騏驥麒緊佶吉拮桔金喫儺喇奈娜懦懶拏拿癩",5,"那樂",4,"諾酪駱亂卵暖欄煖爛蘭難鸞捏捺南嵐枏楠湳濫男藍襤拉"],["d2a1","納臘蠟衲囊娘廊",4,"乃來內奈柰耐冷女年撚秊念恬拈捻寧寗努勞奴弩怒擄櫓爐瑙盧",5,"駑魯",10,"濃籠聾膿農惱牢磊腦賂雷尿壘",7,"嫩訥杻紐勒",5,"能菱陵尼泥匿溺多茶"],["d3a1","丹亶但單團壇彖斷旦檀段湍短端簞緞蛋袒鄲鍛撻澾獺疸達啖坍憺擔曇淡湛潭澹痰聃膽蕁覃談譚錟沓畓答踏遝唐堂塘幢戇撞棠當糖螳黨代垈坮大對岱帶待戴擡玳臺袋貸隊黛宅德悳倒刀到圖堵塗導屠島嶋度徒悼挑掉搗桃"],["d4a1","棹櫂淘渡滔濤燾盜睹禱稻萄覩賭跳蹈逃途道都鍍陶韜毒瀆牘犢獨督禿篤纛讀墩惇敦旽暾沌焞燉豚頓乭突仝冬凍動同憧東桐棟洞潼疼瞳童胴董銅兜斗杜枓痘竇荳讀豆逗頭屯臀芚遁遯鈍得嶝橙燈登等藤謄鄧騰喇懶拏癩羅"],["d5a1","蘿螺裸邏樂洛烙珞絡落諾酪駱丹亂卵欄欒瀾爛蘭鸞剌辣嵐擥攬欖濫籃纜藍襤覽拉臘蠟廊朗浪狼琅瑯螂郞來崍徠萊冷掠略亮倆兩凉梁樑粮粱糧良諒輛量侶儷勵呂廬慮戾旅櫚濾礪藜蠣閭驢驪麗黎力曆歷瀝礫轢靂憐戀攣漣"],["d6a1","煉璉練聯蓮輦連鍊冽列劣洌烈裂廉斂殮濂簾獵令伶囹寧岺嶺怜玲笭羚翎聆逞鈴零靈領齡例澧禮醴隷勞怒撈擄櫓潞瀘爐盧老蘆虜路輅露魯鷺鹵碌祿綠菉錄鹿麓論壟弄朧瀧瓏籠聾儡瀨牢磊賂賚賴雷了僚寮廖料燎療瞭聊蓼"],["d7a1","遼鬧龍壘婁屢樓淚漏瘻累縷蔞褸鏤陋劉旒柳榴流溜瀏琉瑠留瘤硫謬類六戮陸侖倫崙淪綸輪律慄栗率隆勒肋凜凌楞稜綾菱陵俚利厘吏唎履悧李梨浬犁狸理璃異痢籬罹羸莉裏裡里釐離鯉吝潾燐璘藺躪隣鱗麟林淋琳臨霖砬"],["d8a1","立笠粒摩瑪痲碼磨馬魔麻寞幕漠膜莫邈万卍娩巒彎慢挽晩曼滿漫灣瞞萬蔓蠻輓饅鰻唜抹末沫茉襪靺亡妄忘忙望網罔芒茫莽輞邙埋妹媒寐昧枚梅每煤罵買賣邁魅脈貊陌驀麥孟氓猛盲盟萌冪覓免冕勉棉沔眄眠綿緬面麵滅"],["d9a1","蔑冥名命明暝椧溟皿瞑茗蓂螟酩銘鳴袂侮冒募姆帽慕摸摹暮某模母毛牟牡瑁眸矛耗芼茅謀謨貌木沐牧目睦穆鶩歿沒夢朦蒙卯墓妙廟描昴杳渺猫竗苗錨務巫憮懋戊拇撫无楙武毋無珷畝繆舞茂蕪誣貿霧鵡墨默們刎吻問文"],["daa1","汶紊紋聞蚊門雯勿沕物味媚尾嵋彌微未梶楣渼湄眉米美薇謎迷靡黴岷悶愍憫敏旻旼民泯玟珉緡閔密蜜謐剝博拍搏撲朴樸泊珀璞箔粕縛膊舶薄迫雹駁伴半反叛拌搬攀斑槃泮潘班畔瘢盤盼磐磻礬絆般蟠返頒飯勃拔撥渤潑"],["dba1","發跋醱鉢髮魃倣傍坊妨尨幇彷房放方旁昉枋榜滂磅紡肪膀舫芳蒡蚌訪謗邦防龐倍俳北培徘拜排杯湃焙盃背胚裴裵褙賠輩配陪伯佰帛柏栢白百魄幡樊煩燔番磻繁蕃藩飜伐筏罰閥凡帆梵氾汎泛犯範范法琺僻劈壁擘檗璧癖"],["dca1","碧蘗闢霹便卞弁變辨辯邊別瞥鱉鼈丙倂兵屛幷昞昺柄棅炳甁病秉竝輧餠騈保堡報寶普步洑湺潽珤甫菩補褓譜輔伏僕匐卜宓復服福腹茯蔔複覆輹輻馥鰒本乶俸奉封峯峰捧棒烽熢琫縫蓬蜂逢鋒鳳不付俯傅剖副否咐埠夫婦"],["dda1","孚孵富府復扶敷斧浮溥父符簿缶腐腑膚艀芙莩訃負賦賻赴趺部釜阜附駙鳧北分吩噴墳奔奮忿憤扮昐汾焚盆粉糞紛芬賁雰不佛弗彿拂崩朋棚硼繃鵬丕備匕匪卑妃婢庇悲憊扉批斐枇榧比毖毗毘沸泌琵痺砒碑秕秘粃緋翡肥"],["dea1","脾臂菲蜚裨誹譬費鄙非飛鼻嚬嬪彬斌檳殯浜濱瀕牝玭貧賓頻憑氷聘騁乍事些仕伺似使俟僿史司唆嗣四士奢娑寫寺射巳師徙思捨斜斯柶査梭死沙泗渣瀉獅砂社祀祠私篩紗絲肆舍莎蓑蛇裟詐詞謝賜赦辭邪飼駟麝削數朔索"],["dfa1","傘刪山散汕珊産疝算蒜酸霰乷撒殺煞薩三參杉森渗芟蔘衫揷澁鈒颯上傷像償商喪嘗孀尙峠常床庠廂想桑橡湘爽牀狀相祥箱翔裳觴詳象賞霜塞璽賽嗇塞穡索色牲生甥省笙墅壻嶼序庶徐恕抒捿敍暑曙書栖棲犀瑞筮絮緖署"],["e0a1","胥舒薯西誓逝鋤黍鼠夕奭席惜昔晳析汐淅潟石碩蓆釋錫仙僊先善嬋宣扇敾旋渲煽琁瑄璇璿癬禪線繕羨腺膳船蘚蟬詵跣選銑鐥饍鮮卨屑楔泄洩渫舌薛褻設說雪齧剡暹殲纖蟾贍閃陝攝涉燮葉城姓宬性惺成星晟猩珹盛省筬"],["e1a1","聖聲腥誠醒世勢歲洗稅笹細說貰召嘯塑宵小少巢所掃搔昭梳沼消溯瀟炤燒甦疏疎瘙笑篠簫素紹蔬蕭蘇訴逍遡邵銷韶騷俗屬束涑粟續謖贖速孫巽損蓀遜飡率宋悚松淞訟誦送頌刷殺灑碎鎖衰釗修受嗽囚垂壽嫂守岫峀帥愁"],["e2a1","戍手授搜收數樹殊水洙漱燧狩獸琇璲瘦睡秀穗竪粹綏綬繡羞脩茱蒐蓚藪袖誰讐輸遂邃酬銖銹隋隧隨雖需須首髓鬚叔塾夙孰宿淑潚熟琡璹肅菽巡徇循恂旬栒楯橓殉洵淳珣盾瞬筍純脣舜荀蓴蕣詢諄醇錞順馴戌術述鉥崇崧"],["e3a1","嵩瑟膝蝨濕拾習褶襲丞乘僧勝升承昇繩蠅陞侍匙嘶始媤尸屎屍市弑恃施是時枾柴猜矢示翅蒔蓍視試詩諡豕豺埴寔式息拭植殖湜熄篒蝕識軾食飾伸侁信呻娠宸愼新晨燼申神紳腎臣莘薪藎蜃訊身辛辰迅失室實悉審尋心沁"],["e4a1","沈深瀋甚芯諶什十拾雙氏亞俄兒啞娥峨我牙芽莪蛾衙訝阿雅餓鴉鵝堊岳嶽幄惡愕握樂渥鄂鍔顎鰐齷安岸按晏案眼雁鞍顔鮟斡謁軋閼唵岩巖庵暗癌菴闇壓押狎鴨仰央怏昻殃秧鴦厓哀埃崖愛曖涯碍艾隘靄厄扼掖液縊腋額"],["e5a1","櫻罌鶯鸚也倻冶夜惹揶椰爺耶若野弱掠略約若葯蒻藥躍亮佯兩凉壤孃恙揚攘敭暘梁楊樣洋瀁煬痒瘍禳穰糧羊良襄諒讓釀陽量養圄御於漁瘀禦語馭魚齬億憶抑檍臆偃堰彦焉言諺孼蘖俺儼嚴奄掩淹嶪業円予余勵呂女如廬"],["e6a1","旅歟汝濾璵礖礪與艅茹輿轝閭餘驪麗黎亦力域役易曆歷疫繹譯轢逆驛嚥堧姸娟宴年延憐戀捐挻撚椽沇沿涎涓淵演漣烟然煙煉燃燕璉硏硯秊筵緣練縯聯衍軟輦蓮連鉛鍊鳶列劣咽悅涅烈熱裂說閱厭廉念捻染殮炎焰琰艶苒"],["e7a1","簾閻髥鹽曄獵燁葉令囹塋寧嶺嶸影怜映暎楹榮永泳渶潁濚瀛瀯煐營獰玲瑛瑩瓔盈穎纓羚聆英詠迎鈴鍈零霙靈領乂倪例刈叡曳汭濊猊睿穢芮藝蘂禮裔詣譽豫醴銳隸霓預五伍俉傲午吾吳嗚塢墺奧娛寤悟惡懊敖旿晤梧汚澳"],["e8a1","烏熬獒筽蜈誤鰲鼇屋沃獄玉鈺溫瑥瘟穩縕蘊兀壅擁瓮甕癰翁邕雍饔渦瓦窩窪臥蛙蝸訛婉完宛梡椀浣玩琓琬碗緩翫脘腕莞豌阮頑曰往旺枉汪王倭娃歪矮外嵬巍猥畏了僚僥凹堯夭妖姚寥寮尿嶢拗搖撓擾料曜樂橈燎燿瑤療"],["e9a1","窈窯繇繞耀腰蓼蟯要謠遙遼邀饒慾欲浴縟褥辱俑傭冗勇埇墉容庸慂榕涌湧溶熔瑢用甬聳茸蓉踊鎔鏞龍于佑偶優又友右宇寓尤愚憂旴牛玗瑀盂祐禑禹紆羽芋藕虞迂遇郵釪隅雨雩勖彧旭昱栯煜稶郁頊云暈橒殞澐熉耘芸蕓"],["eaa1","運隕雲韻蔚鬱亐熊雄元原員圓園垣媛嫄寃怨愿援沅洹湲源爰猿瑗苑袁轅遠阮院願鴛月越鉞位偉僞危圍委威尉慰暐渭爲瑋緯胃萎葦蔿蝟衛褘謂違韋魏乳侑儒兪劉唯喩孺宥幼幽庾悠惟愈愉揄攸有杻柔柚柳楡楢油洧流游溜"],["eba1","濡猶猷琉瑜由留癒硫紐維臾萸裕誘諛諭踰蹂遊逾遺酉釉鍮類六堉戮毓肉育陸倫允奫尹崙淪潤玧胤贇輪鈗閏律慄栗率聿戎瀜絨融隆垠恩慇殷誾銀隱乙吟淫蔭陰音飮揖泣邑凝應膺鷹依倚儀宜意懿擬椅毅疑矣義艤薏蟻衣誼"],["eca1","議醫二以伊利吏夷姨履已弛彛怡易李梨泥爾珥理異痍痢移罹而耳肄苡荑裏裡貽貳邇里離飴餌匿溺瀷益翊翌翼謚人仁刃印吝咽因姻寅引忍湮燐璘絪茵藺蚓認隣靭靷鱗麟一佚佾壹日溢逸鎰馹任壬妊姙恁林淋稔臨荏賃入卄"],["eda1","立笠粒仍剩孕芿仔刺咨姉姿子字孜恣慈滋炙煮玆瓷疵磁紫者自茨蔗藉諮資雌作勺嚼斫昨灼炸爵綽芍酌雀鵲孱棧殘潺盞岑暫潛箴簪蠶雜丈仗匠場墻壯奬將帳庄張掌暲杖樟檣欌漿牆狀獐璋章粧腸臟臧莊葬蔣薔藏裝贓醬長"],["eea1","障再哉在宰才材栽梓渽滓災縡裁財載齋齎爭箏諍錚佇低儲咀姐底抵杵楮樗沮渚狙猪疽箸紵苧菹著藷詛貯躇這邸雎齟勣吊嫡寂摘敵滴狄炙的積笛籍績翟荻謫賊赤跡蹟迪迹適鏑佃佺傳全典前剪塡塼奠專展廛悛戰栓殿氈澱"],["efa1","煎琠田甸畑癲筌箋箭篆纏詮輾轉鈿銓錢鐫電顚顫餞切截折浙癤竊節絶占岾店漸点粘霑鮎點接摺蝶丁井亭停偵呈姃定幀庭廷征情挺政整旌晶晸柾楨檉正汀淀淨渟湞瀞炡玎珽町睛碇禎程穽精綎艇訂諪貞鄭酊釘鉦鋌錠霆靖"],["f0a1","靜頂鼎制劑啼堤帝弟悌提梯濟祭第臍薺製諸蹄醍除際霽題齊俎兆凋助嘲弔彫措操早晁曺曹朝條棗槽漕潮照燥爪璪眺祖祚租稠窕粗糟組繰肇藻蚤詔調趙躁造遭釣阻雕鳥族簇足鏃存尊卒拙猝倧宗從悰慫棕淙琮種終綜縱腫"],["f1a1","踪踵鍾鐘佐坐左座挫罪主住侏做姝胄呪周嗾奏宙州廚晝朱柱株注洲湊澍炷珠疇籌紂紬綢舟蛛註誅走躊輳週酎酒鑄駐竹粥俊儁准埈寯峻晙樽浚準濬焌畯竣蠢逡遵雋駿茁中仲衆重卽櫛楫汁葺增憎曾拯烝甑症繒蒸證贈之只"],["f2a1","咫地址志持指摯支旨智枝枳止池沚漬知砥祉祗紙肢脂至芝芷蜘誌識贄趾遲直稙稷織職唇嗔塵振搢晉晋桭榛殄津溱珍瑨璡畛疹盡眞瞋秦縉縝臻蔯袗診賑軫辰進鎭陣陳震侄叱姪嫉帙桎瓆疾秩窒膣蛭質跌迭斟朕什執潗緝輯"],["f3a1","鏶集徵懲澄且侘借叉嗟嵯差次此磋箚茶蹉車遮捉搾着窄錯鑿齪撰澯燦璨瓚竄簒纂粲纘讚贊鑽餐饌刹察擦札紮僭參塹慘慙懺斬站讒讖倉倡創唱娼廠彰愴敞昌昶暢槍滄漲猖瘡窓脹艙菖蒼債埰寀寨彩採砦綵菜蔡采釵冊柵策"],["f4a1","責凄妻悽處倜刺剔尺慽戚拓擲斥滌瘠脊蹠陟隻仟千喘天川擅泉淺玔穿舛薦賤踐遷釧闡阡韆凸哲喆徹撤澈綴輟轍鐵僉尖沾添甛瞻簽籤詹諂堞妾帖捷牒疊睫諜貼輒廳晴淸聽菁請靑鯖切剃替涕滯締諦逮遞體初剿哨憔抄招梢"],["f5a1","椒楚樵炒焦硝礁礎秒稍肖艸苕草蕉貂超酢醋醮促囑燭矗蜀觸寸忖村邨叢塚寵悤憁摠總聰蔥銃撮催崔最墜抽推椎楸樞湫皺秋芻萩諏趨追鄒酋醜錐錘鎚雛騶鰍丑畜祝竺筑築縮蓄蹙蹴軸逐春椿瑃出朮黜充忠沖蟲衝衷悴膵萃"],["f6a1","贅取吹嘴娶就炊翠聚脆臭趣醉驟鷲側仄厠惻測層侈値嗤峙幟恥梔治淄熾痔痴癡稚穉緇緻置致蚩輜雉馳齒則勅飭親七柒漆侵寢枕沈浸琛砧針鍼蟄秤稱快他咤唾墮妥惰打拖朶楕舵陀馱駝倬卓啄坼度托拓擢晫柝濁濯琢琸託"],["f7a1","鐸呑嘆坦彈憚歎灘炭綻誕奪脫探眈耽貪塔搭榻宕帑湯糖蕩兌台太怠態殆汰泰笞胎苔跆邰颱宅擇澤撑攄兎吐土討慟桶洞痛筒統通堆槌腿褪退頹偸套妬投透鬪慝特闖坡婆巴把播擺杷波派爬琶破罷芭跛頗判坂板版瓣販辦鈑"],["f8a1","阪八叭捌佩唄悖敗沛浿牌狽稗覇貝彭澎烹膨愎便偏扁片篇編翩遍鞭騙貶坪平枰萍評吠嬖幣廢弊斃肺蔽閉陛佈包匍匏咆哺圃布怖抛抱捕暴泡浦疱砲胞脯苞葡蒲袍褒逋鋪飽鮑幅暴曝瀑爆輻俵剽彪慓杓標漂瓢票表豹飇飄驃"],["f9a1","品稟楓諷豊風馮彼披疲皮被避陂匹弼必泌珌畢疋筆苾馝乏逼下何厦夏廈昰河瑕荷蝦賀遐霞鰕壑學虐謔鶴寒恨悍旱汗漢澣瀚罕翰閑閒限韓割轄函含咸啣喊檻涵緘艦銜陷鹹合哈盒蛤閤闔陜亢伉姮嫦巷恒抗杭桁沆港缸肛航"],["faa1","行降項亥偕咳垓奚孩害懈楷海瀣蟹解該諧邂駭骸劾核倖幸杏荇行享向嚮珦鄕響餉饗香噓墟虛許憲櫶獻軒歇險驗奕爀赫革俔峴弦懸晛泫炫玄玹現眩睍絃絢縣舷衒見賢鉉顯孑穴血頁嫌俠協夾峽挾浹狹脅脇莢鋏頰亨兄刑型"],["fba1","形泂滎瀅灐炯熒珩瑩荊螢衡逈邢鎣馨兮彗惠慧暳蕙蹊醯鞋乎互呼壕壺好岵弧戶扈昊晧毫浩淏湖滸澔濠濩灝狐琥瑚瓠皓祜糊縞胡芦葫蒿虎號蝴護豪鎬頀顥惑或酷婚昏混渾琿魂忽惚笏哄弘汞泓洪烘紅虹訌鴻化和嬅樺火畵"],["fca1","禍禾花華話譁貨靴廓擴攫確碻穫丸喚奐宦幻患換歡晥桓渙煥環紈還驩鰥活滑猾豁闊凰幌徨恍惶愰慌晃晄榥況湟滉潢煌璜皇篁簧荒蝗遑隍黃匯回廻徊恢悔懷晦會檜淮澮灰獪繪膾茴蛔誨賄劃獲宖橫鐄哮嚆孝效斅曉梟涍淆"],["fda1","爻肴酵驍侯候厚后吼喉嗅帿後朽煦珝逅勛勳塤壎焄熏燻薰訓暈薨喧暄煊萱卉喙毁彙徽揮暉煇諱輝麾休携烋畦虧恤譎鷸兇凶匈洶胸黑昕欣炘痕吃屹紇訖欠欽歆吸恰洽翕興僖凞喜噫囍姬嬉希憙憘戱晞曦熙熹熺犧禧稀羲詰"]]');

/***/ }),

/***/ 2324:
/***/ ((module) => {

"use strict";
module.exports = /*#__PURE__*/JSON.parse('[["0","\\u0000",127],["a140","　，、。．‧；：？！︰…‥﹐﹑﹒·﹔﹕﹖﹗｜–︱—︳╴︴﹏（）︵︶｛｝︷︸〔〕︹︺【】︻︼《》︽︾〈〉︿﹀「」﹁﹂『』﹃﹄﹙﹚"],["a1a1","﹛﹜﹝﹞‘’“”〝〞‵′＃＆＊※§〃○●△▲◎☆★◇◆□■▽▼㊣℅¯￣＿ˍ﹉﹊﹍﹎﹋﹌﹟﹠﹡＋－×÷±√＜＞＝≦≧≠∞≒≡﹢",4,"～∩∪⊥∠∟⊿㏒㏑∫∮∵∴♀♂⊕⊙↑↓←→↖↗↙↘∥∣／"],["a240","＼∕﹨＄￥〒￠￡％＠℃℉﹩﹪﹫㏕㎜㎝㎞㏎㎡㎎㎏㏄°兙兛兞兝兡兣嗧瓩糎▁",7,"▏▎▍▌▋▊▉┼┴┬┤├▔─│▕┌┐└┘╭"],["a2a1","╮╰╯═╞╪╡◢◣◥◤╱╲╳０",9,"Ⅰ",9,"〡",8,"十卄卅Ａ",25,"ａ",21],["a340","ｗｘｙｚΑ",16,"Σ",6,"α",16,"σ",6,"ㄅ",10],["a3a1","ㄐ",25,"˙ˉˊˇˋ"],["a3e1","€"],["a440","一乙丁七乃九了二人儿入八几刀刁力匕十卜又三下丈上丫丸凡久么也乞于亡兀刃勺千叉口土士夕大女子孑孓寸小尢尸山川工己已巳巾干廾弋弓才"],["a4a1","丑丐不中丰丹之尹予云井互五亢仁什仃仆仇仍今介仄元允內六兮公冗凶分切刈勻勾勿化匹午升卅卞厄友及反壬天夫太夭孔少尤尺屯巴幻廿弔引心戈戶手扎支文斗斤方日曰月木欠止歹毋比毛氏水火爪父爻片牙牛犬王丙"],["a540","世丕且丘主乍乏乎以付仔仕他仗代令仙仞充兄冉冊冬凹出凸刊加功包匆北匝仟半卉卡占卯卮去可古右召叮叩叨叼司叵叫另只史叱台句叭叻四囚外"],["a5a1","央失奴奶孕它尼巨巧左市布平幼弁弘弗必戊打扔扒扑斥旦朮本未末札正母民氐永汁汀氾犯玄玉瓜瓦甘生用甩田由甲申疋白皮皿目矛矢石示禾穴立丞丟乒乓乩亙交亦亥仿伉伙伊伕伍伐休伏仲件任仰仳份企伋光兇兆先全"],["a640","共再冰列刑划刎刖劣匈匡匠印危吉吏同吊吐吁吋各向名合吃后吆吒因回囝圳地在圭圬圯圩夙多夷夸妄奸妃好她如妁字存宇守宅安寺尖屹州帆并年"],["a6a1","式弛忙忖戎戌戍成扣扛托收早旨旬旭曲曳有朽朴朱朵次此死氖汝汗汙江池汐汕污汛汍汎灰牟牝百竹米糸缶羊羽老考而耒耳聿肉肋肌臣自至臼舌舛舟艮色艾虫血行衣西阡串亨位住佇佗佞伴佛何估佐佑伽伺伸佃佔似但佣"],["a740","作你伯低伶余佝佈佚兌克免兵冶冷別判利刪刨劫助努劬匣即卵吝吭吞吾否呎吧呆呃吳呈呂君吩告吹吻吸吮吵吶吠吼呀吱含吟听囪困囤囫坊坑址坍"],["a7a1","均坎圾坐坏圻壯夾妝妒妨妞妣妙妖妍妤妓妊妥孝孜孚孛完宋宏尬局屁尿尾岐岑岔岌巫希序庇床廷弄弟彤形彷役忘忌志忍忱快忸忪戒我抄抗抖技扶抉扭把扼找批扳抒扯折扮投抓抑抆改攻攸旱更束李杏材村杜杖杞杉杆杠"],["a840","杓杗步每求汞沙沁沈沉沅沛汪決沐汰沌汨沖沒汽沃汲汾汴沆汶沍沔沘沂灶灼災灸牢牡牠狄狂玖甬甫男甸皂盯矣私秀禿究系罕肖肓肝肘肛肚育良芒"],["a8a1","芋芍見角言谷豆豕貝赤走足身車辛辰迂迆迅迄巡邑邢邪邦那酉釆里防阮阱阪阬並乖乳事些亞享京佯依侍佳使佬供例來侃佰併侈佩佻侖佾侏侑佺兔兒兕兩具其典冽函刻券刷刺到刮制剁劾劻卒協卓卑卦卷卸卹取叔受味呵"],["a940","咖呸咕咀呻呷咄咒咆呼咐呱呶和咚呢周咋命咎固垃坷坪坩坡坦坤坼夜奉奇奈奄奔妾妻委妹妮姑姆姐姍始姓姊妯妳姒姅孟孤季宗定官宜宙宛尚屈居"],["a9a1","屆岷岡岸岩岫岱岳帘帚帖帕帛帑幸庚店府底庖延弦弧弩往征彿彼忝忠忽念忿怏怔怯怵怖怪怕怡性怩怫怛或戕房戾所承拉拌拄抿拂抹拒招披拓拔拋拈抨抽押拐拙拇拍抵拚抱拘拖拗拆抬拎放斧於旺昔易昌昆昂明昀昏昕昊"],["aa40","昇服朋杭枋枕東果杳杷枇枝林杯杰板枉松析杵枚枓杼杪杲欣武歧歿氓氛泣注泳沱泌泥河沽沾沼波沫法泓沸泄油況沮泗泅泱沿治泡泛泊沬泯泜泖泠"],["aaa1","炕炎炒炊炙爬爭爸版牧物狀狎狙狗狐玩玨玟玫玥甽疝疙疚的盂盲直知矽社祀祁秉秈空穹竺糾罔羌羋者肺肥肢肱股肫肩肴肪肯臥臾舍芳芝芙芭芽芟芹花芬芥芯芸芣芰芾芷虎虱初表軋迎返近邵邸邱邶采金長門阜陀阿阻附"],["ab40","陂隹雨青非亟亭亮信侵侯便俠俑俏保促侶俘俟俊俗侮俐俄係俚俎俞侷兗冒冑冠剎剃削前剌剋則勇勉勃勁匍南卻厚叛咬哀咨哎哉咸咦咳哇哂咽咪品"],["aba1","哄哈咯咫咱咻咩咧咿囿垂型垠垣垢城垮垓奕契奏奎奐姜姘姿姣姨娃姥姪姚姦威姻孩宣宦室客宥封屎屏屍屋峙峒巷帝帥帟幽庠度建弈弭彥很待徊律徇後徉怒思怠急怎怨恍恰恨恢恆恃恬恫恪恤扁拜挖按拼拭持拮拽指拱拷"],["ac40","拯括拾拴挑挂政故斫施既春昭映昧是星昨昱昤曷柿染柱柔某柬架枯柵柩柯柄柑枴柚查枸柏柞柳枰柙柢柝柒歪殃殆段毒毗氟泉洋洲洪流津洌洱洞洗"],["aca1","活洽派洶洛泵洹洧洸洩洮洵洎洫炫為炳炬炯炭炸炮炤爰牲牯牴狩狠狡玷珊玻玲珍珀玳甚甭畏界畎畋疫疤疥疢疣癸皆皇皈盈盆盃盅省盹相眉看盾盼眇矜砂研砌砍祆祉祈祇禹禺科秒秋穿突竿竽籽紂紅紀紉紇約紆缸美羿耄"],["ad40","耐耍耑耶胖胥胚胃胄背胡胛胎胞胤胝致舢苧范茅苣苛苦茄若茂茉苒苗英茁苜苔苑苞苓苟苯茆虐虹虻虺衍衫要觔計訂訃貞負赴赳趴軍軌述迦迢迪迥"],["ada1","迭迫迤迨郊郎郁郃酋酊重閂限陋陌降面革韋韭音頁風飛食首香乘亳倌倍倣俯倦倥俸倩倖倆值借倚倒們俺倀倔倨俱倡個候倘俳修倭倪俾倫倉兼冤冥冢凍凌准凋剖剜剔剛剝匪卿原厝叟哨唐唁唷哼哥哲唆哺唔哩哭員唉哮哪"],["ae40","哦唧唇哽唏圃圄埂埔埋埃堉夏套奘奚娑娘娜娟娛娓姬娠娣娩娥娌娉孫屘宰害家宴宮宵容宸射屑展屐峭峽峻峪峨峰島崁峴差席師庫庭座弱徒徑徐恙"],["aea1","恣恥恐恕恭恩息悄悟悚悍悔悌悅悖扇拳挈拿捎挾振捕捂捆捏捉挺捐挽挪挫挨捍捌效敉料旁旅時晉晏晃晒晌晅晁書朔朕朗校核案框桓根桂桔栩梳栗桌桑栽柴桐桀格桃株桅栓栘桁殊殉殷氣氧氨氦氤泰浪涕消涇浦浸海浙涓"],["af40","浬涉浮浚浴浩涌涊浹涅浥涔烊烘烤烙烈烏爹特狼狹狽狸狷玆班琉珮珠珪珞畔畝畜畚留疾病症疲疳疽疼疹痂疸皋皰益盍盎眩真眠眨矩砰砧砸砝破砷"],["afa1","砥砭砠砟砲祕祐祠祟祖神祝祗祚秤秣秧租秦秩秘窄窈站笆笑粉紡紗紋紊素索純紐紕級紜納紙紛缺罟羔翅翁耆耘耕耙耗耽耿胱脂胰脅胭胴脆胸胳脈能脊胼胯臭臬舀舐航舫舨般芻茫荒荔荊茸荐草茵茴荏茲茹茶茗荀茱茨荃"],["b040","虔蚊蚪蚓蚤蚩蚌蚣蚜衰衷袁袂衽衹記訐討訌訕訊託訓訖訏訑豈豺豹財貢起躬軒軔軏辱送逆迷退迺迴逃追逅迸邕郡郝郢酒配酌釘針釗釜釙閃院陣陡"],["b0a1","陛陝除陘陞隻飢馬骨高鬥鬲鬼乾偺偽停假偃偌做偉健偶偎偕偵側偷偏倏偯偭兜冕凰剪副勒務勘動匐匏匙匿區匾參曼商啪啦啄啞啡啃啊唱啖問啕唯啤唸售啜唬啣唳啁啗圈國圉域堅堊堆埠埤基堂堵執培夠奢娶婁婉婦婪婀"],["b140","娼婢婚婆婊孰寇寅寄寂宿密尉專將屠屜屝崇崆崎崛崖崢崑崩崔崙崤崧崗巢常帶帳帷康庸庶庵庾張強彗彬彩彫得徙從徘御徠徜恿患悉悠您惋悴惦悽"],["b1a1","情悻悵惜悼惘惕惆惟悸惚惇戚戛扈掠控捲掖探接捷捧掘措捱掩掉掃掛捫推掄授掙採掬排掏掀捻捩捨捺敝敖救教敗啟敏敘敕敔斜斛斬族旋旌旎晝晚晤晨晦晞曹勗望梁梯梢梓梵桿桶梱梧梗械梃棄梭梆梅梔條梨梟梡梂欲殺"],["b240","毫毬氫涎涼淳淙液淡淌淤添淺清淇淋涯淑涮淞淹涸混淵淅淒渚涵淚淫淘淪深淮淨淆淄涪淬涿淦烹焉焊烽烯爽牽犁猜猛猖猓猙率琅琊球理現琍瓠瓶"],["b2a1","瓷甜產略畦畢異疏痔痕疵痊痍皎盔盒盛眷眾眼眶眸眺硫硃硎祥票祭移窒窕笠笨笛第符笙笞笮粒粗粕絆絃統紮紹紼絀細紳組累終紲紱缽羞羚翌翎習耜聊聆脯脖脣脫脩脰脤舂舵舷舶船莎莞莘荸莢莖莽莫莒莊莓莉莠荷荻荼"],["b340","莆莧處彪蛇蛀蚶蛄蚵蛆蛋蚱蚯蛉術袞袈被袒袖袍袋覓規訪訝訣訥許設訟訛訢豉豚販責貫貨貪貧赧赦趾趺軛軟這逍通逗連速逝逐逕逞造透逢逖逛途"],["b3a1","部郭都酗野釵釦釣釧釭釩閉陪陵陳陸陰陴陶陷陬雀雪雩章竟頂頃魚鳥鹵鹿麥麻傢傍傅備傑傀傖傘傚最凱割剴創剩勞勝勛博厥啻喀喧啼喊喝喘喂喜喪喔喇喋喃喳單喟唾喲喚喻喬喱啾喉喫喙圍堯堪場堤堰報堡堝堠壹壺奠"],["b440","婷媚婿媒媛媧孳孱寒富寓寐尊尋就嵌嵐崴嵇巽幅帽幀幃幾廊廁廂廄弼彭復循徨惑惡悲悶惠愜愣惺愕惰惻惴慨惱愎惶愉愀愒戟扉掣掌描揀揩揉揆揍"],["b4a1","插揣提握揖揭揮捶援揪換摒揚揹敞敦敢散斑斐斯普晰晴晶景暑智晾晷曾替期朝棺棕棠棘棗椅棟棵森棧棹棒棲棣棋棍植椒椎棉棚楮棻款欺欽殘殖殼毯氮氯氬港游湔渡渲湧湊渠渥渣減湛湘渤湖湮渭渦湯渴湍渺測湃渝渾滋"],["b540","溉渙湎湣湄湲湩湟焙焚焦焰無然煮焜牌犄犀猶猥猴猩琺琪琳琢琥琵琶琴琯琛琦琨甥甦畫番痢痛痣痙痘痞痠登發皖皓皴盜睏短硝硬硯稍稈程稅稀窘"],["b5a1","窗窖童竣等策筆筐筒答筍筋筏筑粟粥絞結絨絕紫絮絲絡給絢絰絳善翔翕耋聒肅腕腔腋腑腎脹腆脾腌腓腴舒舜菩萃菸萍菠菅萋菁華菱菴著萊菰萌菌菽菲菊萸萎萄菜萇菔菟虛蛟蛙蛭蛔蛛蛤蛐蛞街裁裂袱覃視註詠評詞証詁"],["b640","詔詛詐詆訴診訶詖象貂貯貼貳貽賁費賀貴買貶貿貸越超趁跎距跋跚跑跌跛跆軻軸軼辜逮逵週逸進逶鄂郵鄉郾酣酥量鈔鈕鈣鈉鈞鈍鈐鈇鈑閔閏開閑"],["b6a1","間閒閎隊階隋陽隅隆隍陲隄雁雅雄集雇雯雲韌項順須飧飪飯飩飲飭馮馭黃黍黑亂傭債傲傳僅傾催傷傻傯僇剿剷剽募勦勤勢勣匯嗟嗨嗓嗦嗎嗜嗇嗑嗣嗤嗯嗚嗡嗅嗆嗥嗉園圓塞塑塘塗塚塔填塌塭塊塢塒塋奧嫁嫉嫌媾媽媼"],["b740","媳嫂媲嵩嵯幌幹廉廈弒彙徬微愚意慈感想愛惹愁愈慎慌慄慍愾愴愧愍愆愷戡戢搓搾搞搪搭搽搬搏搜搔損搶搖搗搆敬斟新暗暉暇暈暖暄暘暍會榔業"],["b7a1","楚楷楠楔極椰概楊楨楫楞楓楹榆楝楣楛歇歲毀殿毓毽溢溯滓溶滂源溝滇滅溥溘溼溺溫滑準溜滄滔溪溧溴煎煙煩煤煉照煜煬煦煌煥煞煆煨煖爺牒猷獅猿猾瑯瑚瑕瑟瑞瑁琿瑙瑛瑜當畸瘀痰瘁痲痱痺痿痴痳盞盟睛睫睦睞督"],["b840","睹睪睬睜睥睨睢矮碎碰碗碘碌碉硼碑碓硿祺祿禁萬禽稜稚稠稔稟稞窟窠筷節筠筮筧粱粳粵經絹綑綁綏絛置罩罪署義羨群聖聘肆肄腱腰腸腥腮腳腫"],["b8a1","腹腺腦舅艇蒂葷落萱葵葦葫葉葬葛萼萵葡董葩葭葆虞虜號蛹蜓蜈蜇蜀蛾蛻蜂蜃蜆蜊衙裟裔裙補裘裝裡裊裕裒覜解詫該詳試詩詰誇詼詣誠話誅詭詢詮詬詹詻訾詨豢貊貉賊資賈賄貲賃賂賅跡跟跨路跳跺跪跤跦躲較載軾輊"],["b940","辟農運遊道遂達逼違遐遇遏過遍遑逾遁鄒鄗酬酪酩釉鈷鉗鈸鈽鉀鈾鉛鉋鉤鉑鈴鉉鉍鉅鈹鈿鉚閘隘隔隕雍雋雉雊雷電雹零靖靴靶預頑頓頊頒頌飼飴"],["b9a1","飽飾馳馱馴髡鳩麂鼎鼓鼠僧僮僥僖僭僚僕像僑僱僎僩兢凳劃劂匱厭嗾嘀嘛嘗嗽嘔嘆嘉嘍嘎嗷嘖嘟嘈嘐嗶團圖塵塾境墓墊塹墅塽壽夥夢夤奪奩嫡嫦嫩嫗嫖嫘嫣孵寞寧寡寥實寨寢寤察對屢嶄嶇幛幣幕幗幔廓廖弊彆彰徹慇"],["ba40","愿態慷慢慣慟慚慘慵截撇摘摔撤摸摟摺摑摧搴摭摻敲斡旗旖暢暨暝榜榨榕槁榮槓構榛榷榻榫榴槐槍榭槌榦槃榣歉歌氳漳演滾漓滴漩漾漠漬漏漂漢"],["baa1","滿滯漆漱漸漲漣漕漫漯澈漪滬漁滲滌滷熔熙煽熊熄熒爾犒犖獄獐瑤瑣瑪瑰瑭甄疑瘧瘍瘋瘉瘓盡監瞄睽睿睡磁碟碧碳碩碣禎福禍種稱窪窩竭端管箕箋筵算箝箔箏箸箇箄粹粽精綻綰綜綽綾綠緊綴網綱綺綢綿綵綸維緒緇綬"],["bb40","罰翠翡翟聞聚肇腐膀膏膈膊腿膂臧臺與舔舞艋蓉蒿蓆蓄蒙蒞蒲蒜蓋蒸蓀蓓蒐蒼蓑蓊蜿蜜蜻蜢蜥蜴蜘蝕蜷蜩裳褂裴裹裸製裨褚裯誦誌語誣認誡誓誤"],["bba1","說誥誨誘誑誚誧豪貍貌賓賑賒赫趙趕跼輔輒輕輓辣遠遘遜遣遙遞遢遝遛鄙鄘鄞酵酸酷酴鉸銀銅銘銖鉻銓銜銨鉼銑閡閨閩閣閥閤隙障際雌雒需靼鞅韶頗領颯颱餃餅餌餉駁骯骰髦魁魂鳴鳶鳳麼鼻齊億儀僻僵價儂儈儉儅凜"],["bc40","劇劈劉劍劊勰厲嘮嘻嘹嘲嘿嘴嘩噓噎噗噴嘶嘯嘰墀墟增墳墜墮墩墦奭嬉嫻嬋嫵嬌嬈寮寬審寫層履嶝嶔幢幟幡廢廚廟廝廣廠彈影德徵慶慧慮慝慕憂"],["bca1","慼慰慫慾憧憐憫憎憬憚憤憔憮戮摩摯摹撞撲撈撐撰撥撓撕撩撒撮播撫撚撬撙撢撳敵敷數暮暫暴暱樣樟槨樁樞標槽模樓樊槳樂樅槭樑歐歎殤毅毆漿潼澄潑潦潔澆潭潛潸潮澎潺潰潤澗潘滕潯潠潟熟熬熱熨牖犛獎獗瑩璋璃"],["bd40","瑾璀畿瘠瘩瘟瘤瘦瘡瘢皚皺盤瞎瞇瞌瞑瞋磋磅確磊碾磕碼磐稿稼穀稽稷稻窯窮箭箱範箴篆篇篁箠篌糊締練緯緻緘緬緝編緣線緞緩綞緙緲緹罵罷羯"],["bda1","翩耦膛膜膝膠膚膘蔗蔽蔚蓮蔬蔭蔓蔑蔣蔡蔔蓬蔥蓿蔆螂蝴蝶蝠蝦蝸蝨蝙蝗蝌蝓衛衝褐複褒褓褕褊誼諒談諄誕請諸課諉諂調誰論諍誶誹諛豌豎豬賠賞賦賤賬賭賢賣賜質賡赭趟趣踫踐踝踢踏踩踟踡踞躺輝輛輟輩輦輪輜輞"],["be40","輥適遮遨遭遷鄰鄭鄧鄱醇醉醋醃鋅銻銷鋪銬鋤鋁銳銼鋒鋇鋰銲閭閱霄霆震霉靠鞍鞋鞏頡頫頜颳養餓餒餘駝駐駟駛駑駕駒駙骷髮髯鬧魅魄魷魯鴆鴉"],["bea1","鴃麩麾黎墨齒儒儘儔儐儕冀冪凝劑劓勳噙噫噹噩噤噸噪器噥噱噯噬噢噶壁墾壇壅奮嬝嬴學寰導彊憲憑憩憊懍憶憾懊懈戰擅擁擋撻撼據擄擇擂操撿擒擔撾整曆曉暹曄曇暸樽樸樺橙橫橘樹橄橢橡橋橇樵機橈歙歷氅濂澱澡"],["bf40","濃澤濁澧澳激澹澶澦澠澴熾燉燐燒燈燕熹燎燙燜燃燄獨璜璣璘璟璞瓢甌甍瘴瘸瘺盧盥瞠瞞瞟瞥磨磚磬磧禦積穎穆穌穋窺篙簑築篤篛篡篩篦糕糖縊"],["bfa1","縑縈縛縣縞縝縉縐罹羲翰翱翮耨膳膩膨臻興艘艙蕊蕙蕈蕨蕩蕃蕉蕭蕪蕞螃螟螞螢融衡褪褲褥褫褡親覦諦諺諫諱謀諜諧諮諾謁謂諷諭諳諶諼豫豭貓賴蹄踱踴蹂踹踵輻輯輸輳辨辦遵遴選遲遼遺鄴醒錠錶鋸錳錯錢鋼錫錄錚"],["c040","錐錦錡錕錮錙閻隧隨險雕霎霑霖霍霓霏靛靜靦鞘頰頸頻頷頭頹頤餐館餞餛餡餚駭駢駱骸骼髻髭鬨鮑鴕鴣鴦鴨鴒鴛默黔龍龜優償儡儲勵嚎嚀嚐嚅嚇"],["c0a1","嚏壕壓壑壎嬰嬪嬤孺尷屨嶼嶺嶽嶸幫彌徽應懂懇懦懋戲戴擎擊擘擠擰擦擬擱擢擭斂斃曙曖檀檔檄檢檜櫛檣橾檗檐檠歜殮毚氈濘濱濟濠濛濤濫濯澀濬濡濩濕濮濰燧營燮燦燥燭燬燴燠爵牆獰獲璩環璦璨癆療癌盪瞳瞪瞰瞬"],["c140","瞧瞭矯磷磺磴磯礁禧禪穗窿簇簍篾篷簌篠糠糜糞糢糟糙糝縮績繆縷縲繃縫總縱繅繁縴縹繈縵縿縯罄翳翼聱聲聰聯聳臆臃膺臂臀膿膽臉膾臨舉艱薪"],["c1a1","薄蕾薜薑薔薯薛薇薨薊虧蟀蟑螳蟒蟆螫螻螺蟈蟋褻褶襄褸褽覬謎謗謙講謊謠謝謄謐豁谿豳賺賽購賸賻趨蹉蹋蹈蹊轄輾轂轅輿避遽還邁邂邀鄹醣醞醜鍍鎂錨鍵鍊鍥鍋錘鍾鍬鍛鍰鍚鍔闊闋闌闈闆隱隸雖霜霞鞠韓顆颶餵騁"],["c240","駿鮮鮫鮪鮭鴻鴿麋黏點黜黝黛鼾齋叢嚕嚮壙壘嬸彝懣戳擴擲擾攆擺擻擷斷曜朦檳檬櫃檻檸櫂檮檯歟歸殯瀉瀋濾瀆濺瀑瀏燻燼燾燸獷獵璧璿甕癖癘"],["c2a1","癒瞽瞿瞻瞼礎禮穡穢穠竄竅簫簧簪簞簣簡糧織繕繞繚繡繒繙罈翹翻職聶臍臏舊藏薩藍藐藉薰薺薹薦蟯蟬蟲蟠覆覲觴謨謹謬謫豐贅蹙蹣蹦蹤蹟蹕軀轉轍邇邃邈醫醬釐鎔鎊鎖鎢鎳鎮鎬鎰鎘鎚鎗闔闖闐闕離雜雙雛雞霤鞣鞦"],["c340","鞭韹額顏題顎顓颺餾餿餽餮馥騎髁鬃鬆魏魎魍鯊鯉鯽鯈鯀鵑鵝鵠黠鼕鼬儳嚥壞壟壢寵龐廬懲懷懶懵攀攏曠曝櫥櫝櫚櫓瀛瀟瀨瀚瀝瀕瀘爆爍牘犢獸"],["c3a1","獺璽瓊瓣疇疆癟癡矇礙禱穫穩簾簿簸簽簷籀繫繭繹繩繪羅繳羶羹羸臘藩藝藪藕藤藥藷蟻蠅蠍蟹蟾襠襟襖襞譁譜識證譚譎譏譆譙贈贊蹼蹲躇蹶蹬蹺蹴轔轎辭邊邋醱醮鏡鏑鏟鏃鏈鏜鏝鏖鏢鏍鏘鏤鏗鏨關隴難霪霧靡韜韻類"],["c440","願顛颼饅饉騖騙鬍鯨鯧鯖鯛鶉鵡鵲鵪鵬麒麗麓麴勸嚨嚷嚶嚴嚼壤孀孃孽寶巉懸懺攘攔攙曦朧櫬瀾瀰瀲爐獻瓏癢癥礦礪礬礫竇競籌籃籍糯糰辮繽繼"],["c4a1","纂罌耀臚艦藻藹蘑藺蘆蘋蘇蘊蠔蠕襤覺觸議譬警譯譟譫贏贍躉躁躅躂醴釋鐘鐃鏽闡霰飄饒饑馨騫騰騷騵鰓鰍鹹麵黨鼯齟齣齡儷儸囁囀囂夔屬巍懼懾攝攜斕曩櫻欄櫺殲灌爛犧瓖瓔癩矓籐纏續羼蘗蘭蘚蠣蠢蠡蠟襪襬覽譴"],["c540","護譽贓躊躍躋轟辯醺鐮鐳鐵鐺鐸鐲鐫闢霸霹露響顧顥饗驅驃驀騾髏魔魑鰭鰥鶯鶴鷂鶸麝黯鼙齜齦齧儼儻囈囊囉孿巔巒彎懿攤權歡灑灘玀瓤疊癮癬"],["c5a1","禳籠籟聾聽臟襲襯觼讀贖贗躑躓轡酈鑄鑑鑒霽霾韃韁顫饕驕驍髒鬚鱉鰱鰾鰻鷓鷗鼴齬齪龔囌巖戀攣攫攪曬欐瓚竊籤籣籥纓纖纔臢蘸蘿蠱變邐邏鑣鑠鑤靨顯饜驚驛驗髓體髑鱔鱗鱖鷥麟黴囑壩攬灞癱癲矗罐羈蠶蠹衢讓讒"],["c640","讖艷贛釀鑪靂靈靄韆顰驟鬢魘鱟鷹鷺鹼鹽鼇齷齲廳欖灣籬籮蠻觀躡釁鑲鑰顱饞髖鬣黌灤矚讚鑷韉驢驥纜讜躪釅鑽鑾鑼鱷鱸黷豔鑿鸚爨驪鬱鸛鸞籲"],["c940","乂乜凵匚厂万丌乇亍囗兀屮彳丏冇与丮亓仂仉仈冘勼卬厹圠夃夬尐巿旡殳毌气爿丱丼仨仜仩仡仝仚刌匜卌圢圣夗夯宁宄尒尻屴屳帄庀庂忉戉扐氕"],["c9a1","氶汃氿氻犮犰玊禸肊阞伎优伬仵伔仱伀价伈伝伂伅伢伓伄仴伒冱刓刉刐劦匢匟卍厊吇囡囟圮圪圴夼妀奼妅奻奾奷奿孖尕尥屼屺屻屾巟幵庄异弚彴忕忔忏扜扞扤扡扦扢扙扠扚扥旯旮朾朹朸朻机朿朼朳氘汆汒汜汏汊汔汋"],["ca40","汌灱牞犴犵玎甪癿穵网艸艼芀艽艿虍襾邙邗邘邛邔阢阤阠阣佖伻佢佉体佤伾佧佒佟佁佘伭伳伿佡冏冹刜刞刡劭劮匉卣卲厎厏吰吷吪呔呅吙吜吥吘"],["caa1","吽呏呁吨吤呇囮囧囥坁坅坌坉坋坒夆奀妦妘妠妗妎妢妐妏妧妡宎宒尨尪岍岏岈岋岉岒岊岆岓岕巠帊帎庋庉庌庈庍弅弝彸彶忒忑忐忭忨忮忳忡忤忣忺忯忷忻怀忴戺抃抌抎抏抔抇扱扻扺扰抁抈扷扽扲扴攷旰旴旳旲旵杅杇"],["cb40","杙杕杌杈杝杍杚杋毐氙氚汸汧汫沄沋沏汱汯汩沚汭沇沕沜汦汳汥汻沎灴灺牣犿犽狃狆狁犺狅玕玗玓玔玒町甹疔疕皁礽耴肕肙肐肒肜芐芏芅芎芑芓"],["cba1","芊芃芄豸迉辿邟邡邥邞邧邠阰阨阯阭丳侘佼侅佽侀侇佶佴侉侄佷佌侗佪侚佹侁佸侐侜侔侞侒侂侕佫佮冞冼冾刵刲刳剆刱劼匊匋匼厒厔咇呿咁咑咂咈呫呺呾呥呬呴呦咍呯呡呠咘呣呧呤囷囹坯坲坭坫坱坰坶垀坵坻坳坴坢"],["cc40","坨坽夌奅妵妺姏姎妲姌姁妶妼姃姖妱妽姀姈妴姇孢孥宓宕屄屇岮岤岠岵岯岨岬岟岣岭岢岪岧岝岥岶岰岦帗帔帙弨弢弣弤彔徂彾彽忞忥怭怦怙怲怋"],["cca1","怴怊怗怳怚怞怬怢怍怐怮怓怑怌怉怜戔戽抭抴拑抾抪抶拊抮抳抯抻抩抰抸攽斨斻昉旼昄昒昈旻昃昋昍昅旽昑昐曶朊枅杬枎枒杶杻枘枆构杴枍枌杺枟枑枙枃杽极杸杹枔欥殀歾毞氝沓泬泫泮泙沶泔沭泧沷泐泂沺泃泆泭泲"],["cd40","泒泝沴沊沝沀泞泀洰泍泇沰泹泏泩泑炔炘炅炓炆炄炑炖炂炚炃牪狖狋狘狉狜狒狔狚狌狑玤玡玭玦玢玠玬玝瓝瓨甿畀甾疌疘皯盳盱盰盵矸矼矹矻矺"],["cda1","矷祂礿秅穸穻竻籵糽耵肏肮肣肸肵肭舠芠苀芫芚芘芛芵芧芮芼芞芺芴芨芡芩苂芤苃芶芢虰虯虭虮豖迒迋迓迍迖迕迗邲邴邯邳邰阹阽阼阺陃俍俅俓侲俉俋俁俔俜俙侻侳俛俇俖侺俀侹俬剄剉勀勂匽卼厗厖厙厘咺咡咭咥哏"],["ce40","哃茍咷咮哖咶哅哆咠呰咼咢咾呲哞咰垵垞垟垤垌垗垝垛垔垘垏垙垥垚垕壴复奓姡姞姮娀姱姝姺姽姼姶姤姲姷姛姩姳姵姠姾姴姭宨屌峐峘峌峗峋峛"],["cea1","峞峚峉峇峊峖峓峔峏峈峆峎峟峸巹帡帢帣帠帤庰庤庢庛庣庥弇弮彖徆怷怹恔恲恞恅恓恇恉恛恌恀恂恟怤恄恘恦恮扂扃拏挍挋拵挎挃拫拹挏挌拸拶挀挓挔拺挕拻拰敁敃斪斿昶昡昲昵昜昦昢昳昫昺昝昴昹昮朏朐柁柲柈枺"],["cf40","柜枻柸柘柀枷柅柫柤柟枵柍枳柷柶柮柣柂枹柎柧柰枲柼柆柭柌枮柦柛柺柉柊柃柪柋欨殂殄殶毖毘毠氠氡洨洴洭洟洼洿洒洊泚洳洄洙洺洚洑洀洝浂"],["cfa1","洁洘洷洃洏浀洇洠洬洈洢洉洐炷炟炾炱炰炡炴炵炩牁牉牊牬牰牳牮狊狤狨狫狟狪狦狣玅珌珂珈珅玹玶玵玴珫玿珇玾珃珆玸珋瓬瓮甮畇畈疧疪癹盄眈眃眄眅眊盷盻盺矧矨砆砑砒砅砐砏砎砉砃砓祊祌祋祅祄秕种秏秖秎窀"],["d040","穾竑笀笁籺籸籹籿粀粁紃紈紁罘羑羍羾耇耎耏耔耷胘胇胠胑胈胂胐胅胣胙胜胊胕胉胏胗胦胍臿舡芔苙苾苹茇苨茀苕茺苫苖苴苬苡苲苵茌苻苶苰苪"],["d0a1","苤苠苺苳苭虷虴虼虳衁衎衧衪衩觓訄訇赲迣迡迮迠郱邽邿郕郅邾郇郋郈釔釓陔陏陑陓陊陎倞倅倇倓倢倰倛俵俴倳倷倬俶俷倗倜倠倧倵倯倱倎党冔冓凊凄凅凈凎剡剚剒剞剟剕剢勍匎厞唦哢唗唒哧哳哤唚哿唄唈哫唑唅哱"],["d140","唊哻哷哸哠唎唃唋圁圂埌堲埕埒垺埆垽垼垸垶垿埇埐垹埁夎奊娙娖娭娮娕娏娗娊娞娳孬宧宭宬尃屖屔峬峿峮峱峷崀峹帩帨庨庮庪庬弳弰彧恝恚恧"],["d1a1","恁悢悈悀悒悁悝悃悕悛悗悇悜悎戙扆拲挐捖挬捄捅挶捃揤挹捋捊挼挩捁挴捘捔捙挭捇挳捚捑挸捗捀捈敊敆旆旃旄旂晊晟晇晑朒朓栟栚桉栲栳栻桋桏栖栱栜栵栫栭栯桎桄栴栝栒栔栦栨栮桍栺栥栠欬欯欭欱欴歭肂殈毦毤"],["d240","毨毣毢毧氥浺浣浤浶洍浡涒浘浢浭浯涑涍淯浿涆浞浧浠涗浰浼浟涂涘洯浨涋浾涀涄洖涃浻浽浵涐烜烓烑烝烋缹烢烗烒烞烠烔烍烅烆烇烚烎烡牂牸"],["d2a1","牷牶猀狺狴狾狶狳狻猁珓珙珥珖玼珧珣珩珜珒珛珔珝珚珗珘珨瓞瓟瓴瓵甡畛畟疰痁疻痄痀疿疶疺皊盉眝眛眐眓眒眣眑眕眙眚眢眧砣砬砢砵砯砨砮砫砡砩砳砪砱祔祛祏祜祓祒祑秫秬秠秮秭秪秜秞秝窆窉窅窋窌窊窇竘笐"],["d340","笄笓笅笏笈笊笎笉笒粄粑粊粌粈粍粅紞紝紑紎紘紖紓紟紒紏紌罜罡罞罠罝罛羖羒翃翂翀耖耾耹胺胲胹胵脁胻脀舁舯舥茳茭荄茙荑茥荖茿荁茦茜茢"],["d3a1","荂荎茛茪茈茼荍茖茤茠茷茯茩荇荅荌荓茞茬荋茧荈虓虒蚢蚨蚖蚍蚑蚞蚇蚗蚆蚋蚚蚅蚥蚙蚡蚧蚕蚘蚎蚝蚐蚔衃衄衭衵衶衲袀衱衿衯袃衾衴衼訒豇豗豻貤貣赶赸趵趷趶軑軓迾迵适迿迻逄迼迶郖郠郙郚郣郟郥郘郛郗郜郤酐"],["d440","酎酏釕釢釚陜陟隼飣髟鬯乿偰偪偡偞偠偓偋偝偲偈偍偁偛偊偢倕偅偟偩偫偣偤偆偀偮偳偗偑凐剫剭剬剮勖勓匭厜啵啶唼啍啐唴唪啑啢唶唵唰啒啅"],["d4a1","唌唲啥啎唹啈唭唻啀啋圊圇埻堔埢埶埜埴堀埭埽堈埸堋埳埏堇埮埣埲埥埬埡堎埼堐埧堁堌埱埩埰堍堄奜婠婘婕婧婞娸娵婭婐婟婥婬婓婤婗婃婝婒婄婛婈媎娾婍娹婌婰婩婇婑婖婂婜孲孮寁寀屙崞崋崝崚崠崌崨崍崦崥崏"],["d540","崰崒崣崟崮帾帴庱庴庹庲庳弶弸徛徖徟悊悐悆悾悰悺惓惔惏惤惙惝惈悱惛悷惊悿惃惍惀挲捥掊掂捽掽掞掭掝掗掫掎捯掇掐据掯捵掜捭掮捼掤挻掟"],["d5a1","捸掅掁掑掍捰敓旍晥晡晛晙晜晢朘桹梇梐梜桭桮梮梫楖桯梣梬梩桵桴梲梏桷梒桼桫桲梪梀桱桾梛梖梋梠梉梤桸桻梑梌梊桽欶欳欷欸殑殏殍殎殌氪淀涫涴涳湴涬淩淢涷淶淔渀淈淠淟淖涾淥淜淝淛淴淊涽淭淰涺淕淂淏淉"],["d640","淐淲淓淽淗淍淣涻烺焍烷焗烴焌烰焄烳焐烼烿焆焓焀烸烶焋焂焎牾牻牼牿猝猗猇猑猘猊猈狿猏猞玈珶珸珵琄琁珽琇琀珺珼珿琌琋珴琈畤畣痎痒痏"],["d6a1","痋痌痑痐皏皉盓眹眯眭眱眲眴眳眽眥眻眵硈硒硉硍硊硌砦硅硐祤祧祩祪祣祫祡离秺秸秶秷窏窔窐笵筇笴笥笰笢笤笳笘笪笝笱笫笭笯笲笸笚笣粔粘粖粣紵紽紸紶紺絅紬紩絁絇紾紿絊紻紨罣羕羜羝羛翊翋翍翐翑翇翏翉耟"],["d740","耞耛聇聃聈脘脥脙脛脭脟脬脞脡脕脧脝脢舑舸舳舺舴舲艴莐莣莨莍荺荳莤荴莏莁莕莙荵莔莩荽莃莌莝莛莪莋荾莥莯莈莗莰荿莦莇莮荶莚虙虖蚿蚷"],["d7a1","蛂蛁蛅蚺蚰蛈蚹蚳蚸蛌蚴蚻蚼蛃蚽蚾衒袉袕袨袢袪袚袑袡袟袘袧袙袛袗袤袬袌袓袎覂觖觙觕訰訧訬訞谹谻豜豝豽貥赽赻赹趼跂趹趿跁軘軞軝軜軗軠軡逤逋逑逜逌逡郯郪郰郴郲郳郔郫郬郩酖酘酚酓酕釬釴釱釳釸釤釹釪"],["d840","釫釷釨釮镺閆閈陼陭陫陱陯隿靪頄飥馗傛傕傔傞傋傣傃傌傎傝偨傜傒傂傇兟凔匒匑厤厧喑喨喥喭啷噅喢喓喈喏喵喁喣喒喤啽喌喦啿喕喡喎圌堩堷"],["d8a1","堙堞堧堣堨埵塈堥堜堛堳堿堶堮堹堸堭堬堻奡媯媔媟婺媢媞婸媦婼媥媬媕媮娷媄媊媗媃媋媩婻婽媌媜媏媓媝寪寍寋寔寑寊寎尌尰崷嵃嵫嵁嵋崿崵嵑嵎嵕崳崺嵒崽崱嵙嵂崹嵉崸崼崲崶嵀嵅幄幁彘徦徥徫惉悹惌惢惎惄愔"],["d940","惲愊愖愅惵愓惸惼惾惁愃愘愝愐惿愄愋扊掔掱掰揎揥揨揯揃撝揳揊揠揶揕揲揵摡揟掾揝揜揄揘揓揂揇揌揋揈揰揗揙攲敧敪敤敜敨敥斌斝斞斮旐旒"],["d9a1","晼晬晻暀晱晹晪晲朁椌棓椄棜椪棬棪棱椏棖棷棫棤棶椓椐棳棡椇棌椈楰梴椑棯棆椔棸棐棽棼棨椋椊椗棎棈棝棞棦棴棑椆棔棩椕椥棇欹欻欿欼殔殗殙殕殽毰毲毳氰淼湆湇渟湉溈渼渽湅湢渫渿湁湝湳渜渳湋湀湑渻渃渮湞"],["da40","湨湜湡渱渨湠湱湫渹渢渰湓湥渧湸湤湷湕湹湒湦渵渶湚焠焞焯烻焮焱焣焥焢焲焟焨焺焛牋牚犈犉犆犅犋猒猋猰猢猱猳猧猲猭猦猣猵猌琮琬琰琫琖"],["daa1","琚琡琭琱琤琣琝琩琠琲瓻甯畯畬痧痚痡痦痝痟痤痗皕皒盚睆睇睄睍睅睊睎睋睌矞矬硠硤硥硜硭硱硪确硰硩硨硞硢祴祳祲祰稂稊稃稌稄窙竦竤筊笻筄筈筌筎筀筘筅粢粞粨粡絘絯絣絓絖絧絪絏絭絜絫絒絔絩絑絟絎缾缿罥"],["db40","罦羢羠羡翗聑聏聐胾胔腃腊腒腏腇脽腍脺臦臮臷臸臹舄舼舽舿艵茻菏菹萣菀菨萒菧菤菼菶萐菆菈菫菣莿萁菝菥菘菿菡菋菎菖菵菉萉萏菞萑萆菂菳"],["dba1","菕菺菇菑菪萓菃菬菮菄菻菗菢萛菛菾蛘蛢蛦蛓蛣蛚蛪蛝蛫蛜蛬蛩蛗蛨蛑衈衖衕袺裗袹袸裀袾袶袼袷袽袲褁裉覕覘覗觝觚觛詎詍訹詙詀詗詘詄詅詒詈詑詊詌詏豟貁貀貺貾貰貹貵趄趀趉跘跓跍跇跖跜跏跕跙跈跗跅軯軷軺"],["dc40","軹軦軮軥軵軧軨軶軫軱軬軴軩逭逴逯鄆鄬鄄郿郼鄈郹郻鄁鄀鄇鄅鄃酡酤酟酢酠鈁鈊鈥鈃鈚鈦鈏鈌鈀鈒釿釽鈆鈄鈧鈂鈜鈤鈙鈗鈅鈖镻閍閌閐隇陾隈"],["dca1","隉隃隀雂雈雃雱雰靬靰靮頇颩飫鳦黹亃亄亶傽傿僆傮僄僊傴僈僂傰僁傺傱僋僉傶傸凗剺剸剻剼嗃嗛嗌嗐嗋嗊嗝嗀嗔嗄嗩喿嗒喍嗏嗕嗢嗖嗈嗲嗍嗙嗂圔塓塨塤塏塍塉塯塕塎塝塙塥塛堽塣塱壼嫇嫄嫋媺媸媱媵媰媿嫈媻嫆"],["dd40","媷嫀嫊媴媶嫍媹媐寖寘寙尟尳嵱嵣嵊嵥嵲嵬嵞嵨嵧嵢巰幏幎幊幍幋廅廌廆廋廇彀徯徭惷慉慊愫慅愶愲愮慆愯慏愩慀戠酨戣戥戤揅揱揫搐搒搉搠搤"],["dda1","搳摃搟搕搘搹搷搢搣搌搦搰搨摁搵搯搊搚摀搥搧搋揧搛搮搡搎敯斒旓暆暌暕暐暋暊暙暔晸朠楦楟椸楎楢楱椿楅楪椹楂楗楙楺楈楉椵楬椳椽楥棰楸椴楩楀楯楄楶楘楁楴楌椻楋椷楜楏楑椲楒椯楻椼歆歅歃歂歈歁殛嗀毻毼"],["de40","毹毷毸溛滖滈溏滀溟溓溔溠溱溹滆滒溽滁溞滉溷溰滍溦滏溲溾滃滜滘溙溒溎溍溤溡溿溳滐滊溗溮溣煇煔煒煣煠煁煝煢煲煸煪煡煂煘煃煋煰煟煐煓"],["dea1","煄煍煚牏犍犌犑犐犎猼獂猻猺獀獊獉瑄瑊瑋瑒瑑瑗瑀瑏瑐瑎瑂瑆瑍瑔瓡瓿瓾瓽甝畹畷榃痯瘏瘃痷痾痼痹痸瘐痻痶痭痵痽皙皵盝睕睟睠睒睖睚睩睧睔睙睭矠碇碚碔碏碄碕碅碆碡碃硹碙碀碖硻祼禂祽祹稑稘稙稒稗稕稢稓"],["df40","稛稐窣窢窞竫筦筤筭筴筩筲筥筳筱筰筡筸筶筣粲粴粯綈綆綀綍絿綅絺綎絻綃絼綌綔綄絽綒罭罫罧罨罬羦羥羧翛翜耡腤腠腷腜腩腛腢腲朡腞腶腧腯"],["dfa1","腄腡舝艉艄艀艂艅蓱萿葖葶葹蒏蒍葥葑葀蒆葧萰葍葽葚葙葴葳葝蔇葞萷萺萴葺葃葸萲葅萩菙葋萯葂萭葟葰萹葎葌葒葯蓅蒎萻葇萶萳葨葾葄萫葠葔葮葐蜋蜄蛷蜌蛺蛖蛵蝍蛸蜎蜉蜁蛶蜍蜅裖裋裍裎裞裛裚裌裐覅覛觟觥觤"],["e040","觡觠觢觜触詶誆詿詡訿詷誂誄詵誃誁詴詺谼豋豊豥豤豦貆貄貅賌赨赩趑趌趎趏趍趓趔趐趒跰跠跬跱跮跐跩跣跢跧跲跫跴輆軿輁輀輅輇輈輂輋遒逿"],["e0a1","遄遉逽鄐鄍鄏鄑鄖鄔鄋鄎酮酯鉈鉒鈰鈺鉦鈳鉥鉞銃鈮鉊鉆鉭鉬鉏鉠鉧鉯鈶鉡鉰鈱鉔鉣鉐鉲鉎鉓鉌鉖鈲閟閜閞閛隒隓隑隗雎雺雽雸雵靳靷靸靲頏頍頎颬飶飹馯馲馰馵骭骫魛鳪鳭鳧麀黽僦僔僗僨僳僛僪僝僤僓僬僰僯僣僠"],["e140","凘劀劁勩勫匰厬嘧嘕嘌嘒嗼嘏嘜嘁嘓嘂嗺嘝嘄嗿嗹墉塼墐墘墆墁塿塴墋塺墇墑墎塶墂墈塻墔墏壾奫嫜嫮嫥嫕嫪嫚嫭嫫嫳嫢嫠嫛嫬嫞嫝嫙嫨嫟孷寠"],["e1a1","寣屣嶂嶀嵽嶆嵺嶁嵷嶊嶉嶈嵾嵼嶍嵹嵿幘幙幓廘廑廗廎廜廕廙廒廔彄彃彯徶愬愨慁慞慱慳慒慓慲慬憀慴慔慺慛慥愻慪慡慖戩戧戫搫摍摛摝摴摶摲摳摽摵摦撦摎撂摞摜摋摓摠摐摿搿摬摫摙摥摷敳斠暡暠暟朅朄朢榱榶槉"],["e240","榠槎榖榰榬榼榑榙榎榧榍榩榾榯榿槄榽榤槔榹槊榚槏榳榓榪榡榞槙榗榐槂榵榥槆歊歍歋殞殟殠毃毄毾滎滵滱漃漥滸漷滻漮漉潎漙漚漧漘漻漒滭漊"],["e2a1","漶潳滹滮漭潀漰漼漵滫漇漎潃漅滽滶漹漜滼漺漟漍漞漈漡熇熐熉熀熅熂熏煻熆熁熗牄牓犗犕犓獃獍獑獌瑢瑳瑱瑵瑲瑧瑮甀甂甃畽疐瘖瘈瘌瘕瘑瘊瘔皸瞁睼瞅瞂睮瞀睯睾瞃碲碪碴碭碨硾碫碞碥碠碬碢碤禘禊禋禖禕禔禓"],["e340","禗禈禒禐稫穊稰稯稨稦窨窫窬竮箈箜箊箑箐箖箍箌箛箎箅箘劄箙箤箂粻粿粼粺綧綷緂綣綪緁緀緅綝緎緄緆緋緌綯綹綖綼綟綦綮綩綡緉罳翢翣翥翞"],["e3a1","耤聝聜膉膆膃膇膍膌膋舕蒗蒤蒡蒟蒺蓎蓂蒬蒮蒫蒹蒴蓁蓍蒪蒚蒱蓐蒝蒧蒻蒢蒔蓇蓌蒛蒩蒯蒨蓖蒘蒶蓏蒠蓗蓔蓒蓛蒰蒑虡蜳蜣蜨蝫蝀蜮蜞蜡蜙蜛蝃蜬蝁蜾蝆蜠蜲蜪蜭蜼蜒蜺蜱蜵蝂蜦蜧蜸蜤蜚蜰蜑裷裧裱裲裺裾裮裼裶裻"],["e440","裰裬裫覝覡覟覞觩觫觨誫誙誋誒誏誖谽豨豩賕賏賗趖踉踂跿踍跽踊踃踇踆踅跾踀踄輐輑輎輍鄣鄜鄠鄢鄟鄝鄚鄤鄡鄛酺酲酹酳銥銤鉶銛鉺銠銔銪銍"],["e4a1","銦銚銫鉹銗鉿銣鋮銎銂銕銢鉽銈銡銊銆銌銙銧鉾銇銩銝銋鈭隞隡雿靘靽靺靾鞃鞀鞂靻鞄鞁靿韎韍頖颭颮餂餀餇馝馜駃馹馻馺駂馽駇骱髣髧鬾鬿魠魡魟鳱鳲鳵麧僿儃儰僸儆儇僶僾儋儌僽儊劋劌勱勯噈噂噌嘵噁噊噉噆噘"],["e540","噚噀嘳嘽嘬嘾嘸嘪嘺圚墫墝墱墠墣墯墬墥墡壿嫿嫴嫽嫷嫶嬃嫸嬂嫹嬁嬇嬅嬏屧嶙嶗嶟嶒嶢嶓嶕嶠嶜嶡嶚嶞幩幝幠幜緳廛廞廡彉徲憋憃慹憱憰憢憉"],["e5a1","憛憓憯憭憟憒憪憡憍慦憳戭摮摰撖撠撅撗撜撏撋撊撌撣撟摨撱撘敶敺敹敻斲斳暵暰暩暲暷暪暯樀樆樗槥槸樕槱槤樠槿槬槢樛樝槾樧槲槮樔槷槧橀樈槦槻樍槼槫樉樄樘樥樏槶樦樇槴樖歑殥殣殢殦氁氀毿氂潁漦潾澇濆澒"],["e640","澍澉澌潢潏澅潚澖潶潬澂潕潲潒潐潗澔澓潝漀潡潫潽潧澐潓澋潩潿澕潣潷潪潻熲熯熛熰熠熚熩熵熝熥熞熤熡熪熜熧熳犘犚獘獒獞獟獠獝獛獡獚獙"],["e6a1","獢璇璉璊璆璁瑽璅璈瑼瑹甈甇畾瘥瘞瘙瘝瘜瘣瘚瘨瘛皜皝皞皛瞍瞏瞉瞈磍碻磏磌磑磎磔磈磃磄磉禚禡禠禜禢禛歶稹窲窴窳箷篋箾箬篎箯箹篊箵糅糈糌糋緷緛緪緧緗緡縃緺緦緶緱緰緮緟罶羬羰羭翭翫翪翬翦翨聤聧膣膟"],["e740","膞膕膢膙膗舖艏艓艒艐艎艑蔤蔻蔏蔀蔩蔎蔉蔍蔟蔊蔧蔜蓻蔫蓺蔈蔌蓴蔪蓲蔕蓷蓫蓳蓼蔒蓪蓩蔖蓾蔨蔝蔮蔂蓽蔞蓶蔱蔦蓧蓨蓰蓯蓹蔘蔠蔰蔋蔙蔯虢"],["e7a1","蝖蝣蝤蝷蟡蝳蝘蝔蝛蝒蝡蝚蝑蝞蝭蝪蝐蝎蝟蝝蝯蝬蝺蝮蝜蝥蝏蝻蝵蝢蝧蝩衚褅褌褔褋褗褘褙褆褖褑褎褉覢覤覣觭觰觬諏諆誸諓諑諔諕誻諗誾諀諅諘諃誺誽諙谾豍貏賥賟賙賨賚賝賧趠趜趡趛踠踣踥踤踮踕踛踖踑踙踦踧"],["e840","踔踒踘踓踜踗踚輬輤輘輚輠輣輖輗遳遰遯遧遫鄯鄫鄩鄪鄲鄦鄮醅醆醊醁醂醄醀鋐鋃鋄鋀鋙銶鋏鋱鋟鋘鋩鋗鋝鋌鋯鋂鋨鋊鋈鋎鋦鋍鋕鋉鋠鋞鋧鋑鋓"],["e8a1","銵鋡鋆銴镼閬閫閮閰隤隢雓霅霈霂靚鞊鞎鞈韐韏頞頝頦頩頨頠頛頧颲餈飺餑餔餖餗餕駜駍駏駓駔駎駉駖駘駋駗駌骳髬髫髳髲髱魆魃魧魴魱魦魶魵魰魨魤魬鳼鳺鳽鳿鳷鴇鴀鳹鳻鴈鴅鴄麃黓鼏鼐儜儓儗儚儑凞匴叡噰噠噮"],["e940","噳噦噣噭噲噞噷圜圛壈墽壉墿墺壂墼壆嬗嬙嬛嬡嬔嬓嬐嬖嬨嬚嬠嬞寯嶬嶱嶩嶧嶵嶰嶮嶪嶨嶲嶭嶯嶴幧幨幦幯廩廧廦廨廥彋徼憝憨憖懅憴懆懁懌憺"],["e9a1","憿憸憌擗擖擐擏擉撽撉擃擛擳擙攳敿敼斢曈暾曀曊曋曏暽暻暺曌朣樴橦橉橧樲橨樾橝橭橶橛橑樨橚樻樿橁橪橤橐橏橔橯橩橠樼橞橖橕橍橎橆歕歔歖殧殪殫毈毇氄氃氆澭濋澣濇澼濎濈潞濄澽澞濊澨瀄澥澮澺澬澪濏澿澸"],["ea40","澢濉澫濍澯澲澰燅燂熿熸燖燀燁燋燔燊燇燏熽燘熼燆燚燛犝犞獩獦獧獬獥獫獪瑿璚璠璔璒璕璡甋疀瘯瘭瘱瘽瘳瘼瘵瘲瘰皻盦瞚瞝瞡瞜瞛瞢瞣瞕瞙"],["eaa1","瞗磝磩磥磪磞磣磛磡磢磭磟磠禤穄穈穇窶窸窵窱窷篞篣篧篝篕篥篚篨篹篔篪篢篜篫篘篟糒糔糗糐糑縒縡縗縌縟縠縓縎縜縕縚縢縋縏縖縍縔縥縤罃罻罼罺羱翯耪耩聬膱膦膮膹膵膫膰膬膴膲膷膧臲艕艖艗蕖蕅蕫蕍蕓蕡蕘"],["eb40","蕀蕆蕤蕁蕢蕄蕑蕇蕣蔾蕛蕱蕎蕮蕵蕕蕧蕠薌蕦蕝蕔蕥蕬虣虥虤螛螏螗螓螒螈螁螖螘蝹螇螣螅螐螑螝螄螔螜螚螉褞褦褰褭褮褧褱褢褩褣褯褬褟觱諠"],["eba1","諢諲諴諵諝謔諤諟諰諈諞諡諨諿諯諻貑貒貐賵賮賱賰賳赬赮趥趧踳踾踸蹀蹅踶踼踽蹁踰踿躽輶輮輵輲輹輷輴遶遹遻邆郺鄳鄵鄶醓醐醑醍醏錧錞錈錟錆錏鍺錸錼錛錣錒錁鍆錭錎錍鋋錝鋺錥錓鋹鋷錴錂錤鋿錩錹錵錪錔錌"],["ec40","錋鋾錉錀鋻錖閼闍閾閹閺閶閿閵閽隩雔霋霒霐鞙鞗鞔韰韸頵頯頲餤餟餧餩馞駮駬駥駤駰駣駪駩駧骹骿骴骻髶髺髹髷鬳鮀鮅鮇魼魾魻鮂鮓鮒鮐魺鮕"],["eca1","魽鮈鴥鴗鴠鴞鴔鴩鴝鴘鴢鴐鴙鴟麈麆麇麮麭黕黖黺鼒鼽儦儥儢儤儠儩勴嚓嚌嚍嚆嚄嚃噾嚂噿嚁壖壔壏壒嬭嬥嬲嬣嬬嬧嬦嬯嬮孻寱寲嶷幬幪徾徻懃憵憼懧懠懥懤懨懞擯擩擣擫擤擨斁斀斶旚曒檍檖檁檥檉檟檛檡檞檇檓檎"],["ed40","檕檃檨檤檑橿檦檚檅檌檒歛殭氉濌澩濴濔濣濜濭濧濦濞濲濝濢濨燡燱燨燲燤燰燢獳獮獯璗璲璫璐璪璭璱璥璯甐甑甒甏疄癃癈癉癇皤盩瞵瞫瞲瞷瞶"],["eda1","瞴瞱瞨矰磳磽礂磻磼磲礅磹磾礄禫禨穜穛穖穘穔穚窾竀竁簅簏篲簀篿篻簎篴簋篳簂簉簃簁篸篽簆篰篱簐簊糨縭縼繂縳顈縸縪繉繀繇縩繌縰縻縶繄縺罅罿罾罽翴翲耬膻臄臌臊臅臇膼臩艛艚艜薃薀薏薧薕薠薋薣蕻薤薚薞"],["ee40","蕷蕼薉薡蕺蕸蕗薎薖薆薍薙薝薁薢薂薈薅蕹蕶薘薐薟虨螾螪螭蟅螰螬螹螵螼螮蟉蟃蟂蟌螷螯蟄蟊螴螶螿螸螽蟞螲褵褳褼褾襁襒褷襂覭覯覮觲觳謞"],["eea1","謘謖謑謅謋謢謏謒謕謇謍謈謆謜謓謚豏豰豲豱豯貕貔賹赯蹎蹍蹓蹐蹌蹇轃轀邅遾鄸醚醢醛醙醟醡醝醠鎡鎃鎯鍤鍖鍇鍼鍘鍜鍶鍉鍐鍑鍠鍭鎏鍌鍪鍹鍗鍕鍒鍏鍱鍷鍻鍡鍞鍣鍧鎀鍎鍙闇闀闉闃闅閷隮隰隬霠霟霘霝霙鞚鞡鞜"],["ef40","鞞鞝韕韔韱顁顄顊顉顅顃餥餫餬餪餳餲餯餭餱餰馘馣馡騂駺駴駷駹駸駶駻駽駾駼騃骾髾髽鬁髼魈鮚鮨鮞鮛鮦鮡鮥鮤鮆鮢鮠鮯鴳鵁鵧鴶鴮鴯鴱鴸鴰"],["efa1","鵅鵂鵃鴾鴷鵀鴽翵鴭麊麉麍麰黈黚黻黿鼤鼣鼢齔龠儱儭儮嚘嚜嚗嚚嚝嚙奰嬼屩屪巀幭幮懘懟懭懮懱懪懰懫懖懩擿攄擽擸攁攃擼斔旛曚曛曘櫅檹檽櫡櫆檺檶檷櫇檴檭歞毉氋瀇瀌瀍瀁瀅瀔瀎濿瀀濻瀦濼濷瀊爁燿燹爃燽獶"],["f040","璸瓀璵瓁璾璶璻瓂甔甓癜癤癙癐癓癗癚皦皽盬矂瞺磿礌礓礔礉礐礒礑禭禬穟簜簩簙簠簟簭簝簦簨簢簥簰繜繐繖繣繘繢繟繑繠繗繓羵羳翷翸聵臑臒"],["f0a1","臐艟艞薴藆藀藃藂薳薵薽藇藄薿藋藎藈藅薱薶藒蘤薸薷薾虩蟧蟦蟢蟛蟫蟪蟥蟟蟳蟤蟔蟜蟓蟭蟘蟣螤蟗蟙蠁蟴蟨蟝襓襋襏襌襆襐襑襉謪謧謣謳謰謵譇謯謼謾謱謥謷謦謶謮謤謻謽謺豂豵貙貘貗賾贄贂贀蹜蹢蹠蹗蹖蹞蹥蹧"],["f140","蹛蹚蹡蹝蹩蹔轆轇轈轋鄨鄺鄻鄾醨醥醧醯醪鎵鎌鎒鎷鎛鎝鎉鎧鎎鎪鎞鎦鎕鎈鎙鎟鎍鎱鎑鎲鎤鎨鎴鎣鎥闒闓闑隳雗雚巂雟雘雝霣霢霥鞬鞮鞨鞫鞤鞪"],["f1a1","鞢鞥韗韙韖韘韺顐顑顒颸饁餼餺騏騋騉騍騄騑騊騅騇騆髀髜鬈鬄鬅鬩鬵魊魌魋鯇鯆鯃鮿鯁鮵鮸鯓鮶鯄鮹鮽鵜鵓鵏鵊鵛鵋鵙鵖鵌鵗鵒鵔鵟鵘鵚麎麌黟鼁鼀鼖鼥鼫鼪鼩鼨齌齕儴儵劖勷厴嚫嚭嚦嚧嚪嚬壚壝壛夒嬽嬾嬿巃幰"],["f240","徿懻攇攐攍攉攌攎斄旞旝曞櫧櫠櫌櫑櫙櫋櫟櫜櫐櫫櫏櫍櫞歠殰氌瀙瀧瀠瀖瀫瀡瀢瀣瀩瀗瀤瀜瀪爌爊爇爂爅犥犦犤犣犡瓋瓅璷瓃甖癠矉矊矄矱礝礛"],["f2a1","礡礜礗礞禰穧穨簳簼簹簬簻糬糪繶繵繸繰繷繯繺繲繴繨罋罊羃羆羷翽翾聸臗臕艤艡艣藫藱藭藙藡藨藚藗藬藲藸藘藟藣藜藑藰藦藯藞藢蠀蟺蠃蟶蟷蠉蠌蠋蠆蟼蠈蟿蠊蠂襢襚襛襗襡襜襘襝襙覈覷覶觶譐譈譊譀譓譖譔譋譕"],["f340","譑譂譒譗豃豷豶貚贆贇贉趬趪趭趫蹭蹸蹳蹪蹯蹻軂轒轑轏轐轓辴酀鄿醰醭鏞鏇鏏鏂鏚鏐鏹鏬鏌鏙鎩鏦鏊鏔鏮鏣鏕鏄鏎鏀鏒鏧镽闚闛雡霩霫霬霨霦"],["f3a1","鞳鞷鞶韝韞韟顜顙顝顗颿颽颻颾饈饇饃馦馧騚騕騥騝騤騛騢騠騧騣騞騜騔髂鬋鬊鬎鬌鬷鯪鯫鯠鯞鯤鯦鯢鯰鯔鯗鯬鯜鯙鯥鯕鯡鯚鵷鶁鶊鶄鶈鵱鶀鵸鶆鶋鶌鵽鵫鵴鵵鵰鵩鶅鵳鵻鶂鵯鵹鵿鶇鵨麔麑黀黼鼭齀齁齍齖齗齘匷嚲"],["f440","嚵嚳壣孅巆巇廮廯忀忁懹攗攖攕攓旟曨曣曤櫳櫰櫪櫨櫹櫱櫮櫯瀼瀵瀯瀷瀴瀱灂瀸瀿瀺瀹灀瀻瀳灁爓爔犨獽獼璺皫皪皾盭矌矎矏矍矲礥礣礧礨礤礩"],["f4a1","禲穮穬穭竷籉籈籊籇籅糮繻繾纁纀羺翿聹臛臙舋艨艩蘢藿蘁藾蘛蘀藶蘄蘉蘅蘌藽蠙蠐蠑蠗蠓蠖襣襦覹觷譠譪譝譨譣譥譧譭趮躆躈躄轙轖轗轕轘轚邍酃酁醷醵醲醳鐋鐓鏻鐠鐏鐔鏾鐕鐐鐨鐙鐍鏵鐀鏷鐇鐎鐖鐒鏺鐉鏸鐊鏿"],["f540","鏼鐌鏶鐑鐆闞闠闟霮霯鞹鞻韽韾顠顢顣顟飁飂饐饎饙饌饋饓騲騴騱騬騪騶騩騮騸騭髇髊髆鬐鬒鬑鰋鰈鯷鰅鰒鯸鱀鰇鰎鰆鰗鰔鰉鶟鶙鶤鶝鶒鶘鶐鶛"],["f5a1","鶠鶔鶜鶪鶗鶡鶚鶢鶨鶞鶣鶿鶩鶖鶦鶧麙麛麚黥黤黧黦鼰鼮齛齠齞齝齙龑儺儹劘劗囃嚽嚾孈孇巋巏廱懽攛欂櫼欃櫸欀灃灄灊灈灉灅灆爝爚爙獾甗癪矐礭礱礯籔籓糲纊纇纈纋纆纍罍羻耰臝蘘蘪蘦蘟蘣蘜蘙蘧蘮蘡蘠蘩蘞蘥"],["f640","蠩蠝蠛蠠蠤蠜蠫衊襭襩襮襫觺譹譸譅譺譻贐贔趯躎躌轞轛轝酆酄酅醹鐿鐻鐶鐩鐽鐼鐰鐹鐪鐷鐬鑀鐱闥闤闣霵霺鞿韡顤飉飆飀饘饖騹騽驆驄驂驁騺"],["f6a1","騿髍鬕鬗鬘鬖鬺魒鰫鰝鰜鰬鰣鰨鰩鰤鰡鶷鶶鶼鷁鷇鷊鷏鶾鷅鷃鶻鶵鷎鶹鶺鶬鷈鶱鶭鷌鶳鷍鶲鹺麜黫黮黭鼛鼘鼚鼱齎齥齤龒亹囆囅囋奱孋孌巕巑廲攡攠攦攢欋欈欉氍灕灖灗灒爞爟犩獿瓘瓕瓙瓗癭皭礵禴穰穱籗籜籙籛籚"],["f740","糴糱纑罏羇臞艫蘴蘵蘳蘬蘲蘶蠬蠨蠦蠪蠥襱覿覾觻譾讄讂讆讅譿贕躕躔躚躒躐躖躗轠轢酇鑌鑐鑊鑋鑏鑇鑅鑈鑉鑆霿韣顪顩飋饔饛驎驓驔驌驏驈驊"],["f7a1","驉驒驐髐鬙鬫鬻魖魕鱆鱈鰿鱄鰹鰳鱁鰼鰷鰴鰲鰽鰶鷛鷒鷞鷚鷋鷐鷜鷑鷟鷩鷙鷘鷖鷵鷕鷝麶黰鼵鼳鼲齂齫龕龢儽劙壨壧奲孍巘蠯彏戁戃戄攩攥斖曫欑欒欏毊灛灚爢玂玁玃癰矔籧籦纕艬蘺虀蘹蘼蘱蘻蘾蠰蠲蠮蠳襶襴襳觾"],["f840","讌讎讋讈豅贙躘轤轣醼鑢鑕鑝鑗鑞韄韅頀驖驙鬞鬟鬠鱒鱘鱐鱊鱍鱋鱕鱙鱌鱎鷻鷷鷯鷣鷫鷸鷤鷶鷡鷮鷦鷲鷰鷢鷬鷴鷳鷨鷭黂黐黲黳鼆鼜鼸鼷鼶齃齏"],["f8a1","齱齰齮齯囓囍孎屭攭曭曮欓灟灡灝灠爣瓛瓥矕礸禷禶籪纗羉艭虃蠸蠷蠵衋讔讕躞躟躠躝醾醽釂鑫鑨鑩雥靆靃靇韇韥驞髕魙鱣鱧鱦鱢鱞鱠鸂鷾鸇鸃鸆鸅鸀鸁鸉鷿鷽鸄麠鼞齆齴齵齶囔攮斸欘欙欗欚灢爦犪矘矙礹籩籫糶纚"],["f940","纘纛纙臠臡虆虇虈襹襺襼襻觿讘讙躥躤躣鑮鑭鑯鑱鑳靉顲饟鱨鱮鱭鸋鸍鸐鸏鸒鸑麡黵鼉齇齸齻齺齹圞灦籯蠼趲躦釃鑴鑸鑶鑵驠鱴鱳鱱鱵鸔鸓黶鼊"],["f9a1","龤灨灥糷虪蠾蠽蠿讞貜躩軉靋顳顴飌饡馫驤驦驧鬤鸕鸗齈戇欞爧虌躨钂钀钁驩驨鬮鸙爩虋讟钃鱹麷癵驫鱺鸝灩灪麤齾齉龘碁銹裏墻恒粧嫺╔╦╗╠╬╣╚╩╝╒╤╕╞╪╡╘╧╛╓╥╖╟╫╢╙╨╜║═╭╮╰╯▓"]]');

/***/ }),

/***/ 6406:
/***/ ((module) => {

"use strict";
module.exports = /*#__PURE__*/JSON.parse('[["0","\\u0000",127],["8ea1","｡",62],["a1a1","　、。，．・：；？！゛゜´｀¨＾￣＿ヽヾゝゞ〃仝々〆〇ー―‐／＼～∥｜…‥‘’“”（）〔〕［］｛｝〈",9,"＋－±×÷＝≠＜＞≦≧∞∴♂♀°′″℃￥＄￠￡％＃＆＊＠§☆★○●◎◇"],["a2a1","◆□■△▲▽▼※〒→←↑↓〓"],["a2ba","∈∋⊆⊇⊂⊃∪∩"],["a2ca","∧∨￢⇒⇔∀∃"],["a2dc","∠⊥⌒∂∇≡≒≪≫√∽∝∵∫∬"],["a2f2","Å‰♯♭♪†‡¶"],["a2fe","◯"],["a3b0","０",9],["a3c1","Ａ",25],["a3e1","ａ",25],["a4a1","ぁ",82],["a5a1","ァ",85],["a6a1","Α",16,"Σ",6],["a6c1","α",16,"σ",6],["a7a1","А",5,"ЁЖ",25],["a7d1","а",5,"ёж",25],["a8a1","─│┌┐┘└├┬┤┴┼━┃┏┓┛┗┣┳┫┻╋┠┯┨┷┿┝┰┥┸╂"],["ada1","①",19,"Ⅰ",9],["adc0","㍉㌔㌢㍍㌘㌧㌃㌶㍑㍗㌍㌦㌣㌫㍊㌻㎜㎝㎞㎎㎏㏄㎡"],["addf","㍻〝〟№㏍℡㊤",4,"㈱㈲㈹㍾㍽㍼≒≡∫∮∑√⊥∠∟⊿∵∩∪"],["b0a1","亜唖娃阿哀愛挨姶逢葵茜穐悪握渥旭葦芦鯵梓圧斡扱宛姐虻飴絢綾鮎或粟袷安庵按暗案闇鞍杏以伊位依偉囲夷委威尉惟意慰易椅為畏異移維緯胃萎衣謂違遺医井亥域育郁磯一壱溢逸稲茨芋鰯允印咽員因姻引飲淫胤蔭"],["b1a1","院陰隠韻吋右宇烏羽迂雨卯鵜窺丑碓臼渦嘘唄欝蔚鰻姥厩浦瓜閏噂云運雲荏餌叡営嬰影映曳栄永泳洩瑛盈穎頴英衛詠鋭液疫益駅悦謁越閲榎厭円園堰奄宴延怨掩援沿演炎焔煙燕猿縁艶苑薗遠鉛鴛塩於汚甥凹央奥往応"],["b2a1","押旺横欧殴王翁襖鴬鴎黄岡沖荻億屋憶臆桶牡乙俺卸恩温穏音下化仮何伽価佳加可嘉夏嫁家寡科暇果架歌河火珂禍禾稼箇花苛茄荷華菓蝦課嘩貨迦過霞蚊俄峨我牙画臥芽蛾賀雅餓駕介会解回塊壊廻快怪悔恢懐戒拐改"],["b3a1","魁晦械海灰界皆絵芥蟹開階貝凱劾外咳害崖慨概涯碍蓋街該鎧骸浬馨蛙垣柿蛎鈎劃嚇各廓拡撹格核殻獲確穫覚角赫較郭閣隔革学岳楽額顎掛笠樫橿梶鰍潟割喝恰括活渇滑葛褐轄且鰹叶椛樺鞄株兜竃蒲釜鎌噛鴨栢茅萱"],["b4a1","粥刈苅瓦乾侃冠寒刊勘勧巻喚堪姦完官寛干幹患感慣憾換敢柑桓棺款歓汗漢澗潅環甘監看竿管簡緩缶翰肝艦莞観諌貫還鑑間閑関陥韓館舘丸含岸巌玩癌眼岩翫贋雁頑顔願企伎危喜器基奇嬉寄岐希幾忌揮机旗既期棋棄"],["b5a1","機帰毅気汽畿祈季稀紀徽規記貴起軌輝飢騎鬼亀偽儀妓宜戯技擬欺犠疑祇義蟻誼議掬菊鞠吉吃喫桔橘詰砧杵黍却客脚虐逆丘久仇休及吸宮弓急救朽求汲泣灸球究窮笈級糾給旧牛去居巨拒拠挙渠虚許距鋸漁禦魚亨享京"],["b6a1","供侠僑兇競共凶協匡卿叫喬境峡強彊怯恐恭挟教橋況狂狭矯胸脅興蕎郷鏡響饗驚仰凝尭暁業局曲極玉桐粁僅勤均巾錦斤欣欽琴禁禽筋緊芹菌衿襟謹近金吟銀九倶句区狗玖矩苦躯駆駈駒具愚虞喰空偶寓遇隅串櫛釧屑屈"],["b7a1","掘窟沓靴轡窪熊隈粂栗繰桑鍬勲君薫訓群軍郡卦袈祁係傾刑兄啓圭珪型契形径恵慶慧憩掲携敬景桂渓畦稽系経継繋罫茎荊蛍計詣警軽頚鶏芸迎鯨劇戟撃激隙桁傑欠決潔穴結血訣月件倹倦健兼券剣喧圏堅嫌建憲懸拳捲"],["b8a1","検権牽犬献研硯絹県肩見謙賢軒遣鍵険顕験鹸元原厳幻弦減源玄現絃舷言諺限乎個古呼固姑孤己庫弧戸故枯湖狐糊袴股胡菰虎誇跨鈷雇顧鼓五互伍午呉吾娯後御悟梧檎瑚碁語誤護醐乞鯉交佼侯候倖光公功効勾厚口向"],["b9a1","后喉坑垢好孔孝宏工巧巷幸広庚康弘恒慌抗拘控攻昂晃更杭校梗構江洪浩港溝甲皇硬稿糠紅紘絞綱耕考肯肱腔膏航荒行衡講貢購郊酵鉱砿鋼閤降項香高鴻剛劫号合壕拷濠豪轟麹克刻告国穀酷鵠黒獄漉腰甑忽惚骨狛込"],["baa1","此頃今困坤墾婚恨懇昏昆根梱混痕紺艮魂些佐叉唆嵯左差査沙瑳砂詐鎖裟坐座挫債催再最哉塞妻宰彩才採栽歳済災采犀砕砦祭斎細菜裁載際剤在材罪財冴坂阪堺榊肴咲崎埼碕鷺作削咋搾昨朔柵窄策索錯桜鮭笹匙冊刷"],["bba1","察拶撮擦札殺薩雑皐鯖捌錆鮫皿晒三傘参山惨撒散桟燦珊産算纂蚕讃賛酸餐斬暫残仕仔伺使刺司史嗣四士始姉姿子屍市師志思指支孜斯施旨枝止死氏獅祉私糸紙紫肢脂至視詞詩試誌諮資賜雌飼歯事似侍児字寺慈持時"],["bca1","次滋治爾璽痔磁示而耳自蒔辞汐鹿式識鴫竺軸宍雫七叱執失嫉室悉湿漆疾質実蔀篠偲柴芝屡蕊縞舎写射捨赦斜煮社紗者謝車遮蛇邪借勺尺杓灼爵酌釈錫若寂弱惹主取守手朱殊狩珠種腫趣酒首儒受呪寿授樹綬需囚収周"],["bda1","宗就州修愁拾洲秀秋終繍習臭舟蒐衆襲讐蹴輯週酋酬集醜什住充十従戎柔汁渋獣縦重銃叔夙宿淑祝縮粛塾熟出術述俊峻春瞬竣舜駿准循旬楯殉淳準潤盾純巡遵醇順処初所暑曙渚庶緒署書薯藷諸助叙女序徐恕鋤除傷償"],["bea1","勝匠升召哨商唱嘗奨妾娼宵将小少尚庄床廠彰承抄招掌捷昇昌昭晶松梢樟樵沼消渉湘焼焦照症省硝礁祥称章笑粧紹肖菖蒋蕉衝裳訟証詔詳象賞醤鉦鍾鐘障鞘上丈丞乗冗剰城場壌嬢常情擾条杖浄状畳穣蒸譲醸錠嘱埴飾"],["bfa1","拭植殖燭織職色触食蝕辱尻伸信侵唇娠寝審心慎振新晋森榛浸深申疹真神秦紳臣芯薪親診身辛進針震人仁刃塵壬尋甚尽腎訊迅陣靭笥諏須酢図厨逗吹垂帥推水炊睡粋翠衰遂酔錐錘随瑞髄崇嵩数枢趨雛据杉椙菅頗雀裾"],["c0a1","澄摺寸世瀬畝是凄制勢姓征性成政整星晴棲栖正清牲生盛精聖声製西誠誓請逝醒青静斉税脆隻席惜戚斥昔析石積籍績脊責赤跡蹟碩切拙接摂折設窃節説雪絶舌蝉仙先千占宣専尖川戦扇撰栓栴泉浅洗染潜煎煽旋穿箭線"],["c1a1","繊羨腺舛船薦詮賎践選遷銭銑閃鮮前善漸然全禅繕膳糎噌塑岨措曾曽楚狙疏疎礎祖租粗素組蘇訴阻遡鼠僧創双叢倉喪壮奏爽宋層匝惣想捜掃挿掻操早曹巣槍槽漕燥争痩相窓糟総綜聡草荘葬蒼藻装走送遭鎗霜騒像増憎"],["c2a1","臓蔵贈造促側則即息捉束測足速俗属賊族続卒袖其揃存孫尊損村遜他多太汰詑唾堕妥惰打柁舵楕陀駄騨体堆対耐岱帯待怠態戴替泰滞胎腿苔袋貸退逮隊黛鯛代台大第醍題鷹滝瀧卓啄宅托択拓沢濯琢託鐸濁諾茸凧蛸只"],["c3a1","叩但達辰奪脱巽竪辿棚谷狸鱈樽誰丹単嘆坦担探旦歎淡湛炭短端箪綻耽胆蛋誕鍛団壇弾断暖檀段男談値知地弛恥智池痴稚置致蜘遅馳築畜竹筑蓄逐秩窒茶嫡着中仲宙忠抽昼柱注虫衷註酎鋳駐樗瀦猪苧著貯丁兆凋喋寵"],["c4a1","帖帳庁弔張彫徴懲挑暢朝潮牒町眺聴脹腸蝶調諜超跳銚長頂鳥勅捗直朕沈珍賃鎮陳津墜椎槌追鎚痛通塚栂掴槻佃漬柘辻蔦綴鍔椿潰坪壷嬬紬爪吊釣鶴亭低停偵剃貞呈堤定帝底庭廷弟悌抵挺提梯汀碇禎程締艇訂諦蹄逓"],["c5a1","邸鄭釘鼎泥摘擢敵滴的笛適鏑溺哲徹撤轍迭鉄典填天展店添纏甜貼転顛点伝殿澱田電兎吐堵塗妬屠徒斗杜渡登菟賭途都鍍砥砺努度土奴怒倒党冬凍刀唐塔塘套宕島嶋悼投搭東桃梼棟盗淘湯涛灯燈当痘祷等答筒糖統到"],["c6a1","董蕩藤討謄豆踏逃透鐙陶頭騰闘働動同堂導憧撞洞瞳童胴萄道銅峠鴇匿得徳涜特督禿篤毒独読栃橡凸突椴届鳶苫寅酉瀞噸屯惇敦沌豚遁頓呑曇鈍奈那内乍凪薙謎灘捺鍋楢馴縄畷南楠軟難汝二尼弐迩匂賑肉虹廿日乳入"],["c7a1","如尿韮任妊忍認濡禰祢寧葱猫熱年念捻撚燃粘乃廼之埜嚢悩濃納能脳膿農覗蚤巴把播覇杷波派琶破婆罵芭馬俳廃拝排敗杯盃牌背肺輩配倍培媒梅楳煤狽買売賠陪這蝿秤矧萩伯剥博拍柏泊白箔粕舶薄迫曝漠爆縛莫駁麦"],["c8a1","函箱硲箸肇筈櫨幡肌畑畠八鉢溌発醗髪伐罰抜筏閥鳩噺塙蛤隼伴判半反叛帆搬斑板氾汎版犯班畔繁般藩販範釆煩頒飯挽晩番盤磐蕃蛮匪卑否妃庇彼悲扉批披斐比泌疲皮碑秘緋罷肥被誹費避非飛樋簸備尾微枇毘琵眉美"],["c9a1","鼻柊稗匹疋髭彦膝菱肘弼必畢筆逼桧姫媛紐百謬俵彪標氷漂瓢票表評豹廟描病秒苗錨鋲蒜蛭鰭品彬斌浜瀕貧賓頻敏瓶不付埠夫婦富冨布府怖扶敷斧普浮父符腐膚芙譜負賦赴阜附侮撫武舞葡蕪部封楓風葺蕗伏副復幅服"],["caa1","福腹複覆淵弗払沸仏物鮒分吻噴墳憤扮焚奮粉糞紛雰文聞丙併兵塀幣平弊柄並蔽閉陛米頁僻壁癖碧別瞥蔑箆偏変片篇編辺返遍便勉娩弁鞭保舗鋪圃捕歩甫補輔穂募墓慕戊暮母簿菩倣俸包呆報奉宝峰峯崩庖抱捧放方朋"],["cba1","法泡烹砲縫胞芳萌蓬蜂褒訪豊邦鋒飽鳳鵬乏亡傍剖坊妨帽忘忙房暴望某棒冒紡肪膨謀貌貿鉾防吠頬北僕卜墨撲朴牧睦穆釦勃没殆堀幌奔本翻凡盆摩磨魔麻埋妹昧枚毎哩槙幕膜枕鮪柾鱒桝亦俣又抹末沫迄侭繭麿万慢満"],["cca1","漫蔓味未魅巳箕岬密蜜湊蓑稔脈妙粍民眠務夢無牟矛霧鵡椋婿娘冥名命明盟迷銘鳴姪牝滅免棉綿緬面麺摸模茂妄孟毛猛盲網耗蒙儲木黙目杢勿餅尤戻籾貰問悶紋門匁也冶夜爺耶野弥矢厄役約薬訳躍靖柳薮鑓愉愈油癒"],["cda1","諭輸唯佑優勇友宥幽悠憂揖有柚湧涌猶猷由祐裕誘遊邑郵雄融夕予余与誉輿預傭幼妖容庸揚揺擁曜楊様洋溶熔用窯羊耀葉蓉要謡踊遥陽養慾抑欲沃浴翌翼淀羅螺裸来莱頼雷洛絡落酪乱卵嵐欄濫藍蘭覧利吏履李梨理璃"],["cea1","痢裏裡里離陸律率立葎掠略劉流溜琉留硫粒隆竜龍侶慮旅虜了亮僚両凌寮料梁涼猟療瞭稜糧良諒遼量陵領力緑倫厘林淋燐琳臨輪隣鱗麟瑠塁涙累類令伶例冷励嶺怜玲礼苓鈴隷零霊麗齢暦歴列劣烈裂廉恋憐漣煉簾練聯"],["cfa1","蓮連錬呂魯櫓炉賂路露労婁廊弄朗楼榔浪漏牢狼篭老聾蝋郎六麓禄肋録論倭和話歪賄脇惑枠鷲亙亘鰐詫藁蕨椀湾碗腕"],["d0a1","弌丐丕个丱丶丼丿乂乖乘亂亅豫亊舒弍于亞亟亠亢亰亳亶从仍仄仆仂仗仞仭仟价伉佚估佛佝佗佇佶侈侏侘佻佩佰侑佯來侖儘俔俟俎俘俛俑俚俐俤俥倚倨倔倪倥倅伜俶倡倩倬俾俯們倆偃假會偕偐偈做偖偬偸傀傚傅傴傲"],["d1a1","僉僊傳僂僖僞僥僭僣僮價僵儉儁儂儖儕儔儚儡儺儷儼儻儿兀兒兌兔兢竸兩兪兮冀冂囘册冉冏冑冓冕冖冤冦冢冩冪冫决冱冲冰况冽凅凉凛几處凩凭凰凵凾刄刋刔刎刧刪刮刳刹剏剄剋剌剞剔剪剴剩剳剿剽劍劔劒剱劈劑辨"],["d2a1","辧劬劭劼劵勁勍勗勞勣勦飭勠勳勵勸勹匆匈甸匍匐匏匕匚匣匯匱匳匸區卆卅丗卉卍凖卞卩卮夘卻卷厂厖厠厦厥厮厰厶參簒雙叟曼燮叮叨叭叺吁吽呀听吭吼吮吶吩吝呎咏呵咎呟呱呷呰咒呻咀呶咄咐咆哇咢咸咥咬哄哈咨"],["d3a1","咫哂咤咾咼哘哥哦唏唔哽哮哭哺哢唹啀啣啌售啜啅啖啗唸唳啝喙喀咯喊喟啻啾喘喞單啼喃喩喇喨嗚嗅嗟嗄嗜嗤嗔嘔嗷嘖嗾嗽嘛嗹噎噐營嘴嘶嘲嘸噫噤嘯噬噪嚆嚀嚊嚠嚔嚏嚥嚮嚶嚴囂嚼囁囃囀囈囎囑囓囗囮囹圀囿圄圉"],["d4a1","圈國圍圓團圖嗇圜圦圷圸坎圻址坏坩埀垈坡坿垉垓垠垳垤垪垰埃埆埔埒埓堊埖埣堋堙堝塲堡塢塋塰毀塒堽塹墅墹墟墫墺壞墻墸墮壅壓壑壗壙壘壥壜壤壟壯壺壹壻壼壽夂夊夐夛梦夥夬夭夲夸夾竒奕奐奎奚奘奢奠奧奬奩"],["d5a1","奸妁妝佞侫妣妲姆姨姜妍姙姚娥娟娑娜娉娚婀婬婉娵娶婢婪媚媼媾嫋嫂媽嫣嫗嫦嫩嫖嫺嫻嬌嬋嬖嬲嫐嬪嬶嬾孃孅孀孑孕孚孛孥孩孰孳孵學斈孺宀它宦宸寃寇寉寔寐寤實寢寞寥寫寰寶寳尅將專對尓尠尢尨尸尹屁屆屎屓"],["d6a1","屐屏孱屬屮乢屶屹岌岑岔妛岫岻岶岼岷峅岾峇峙峩峽峺峭嶌峪崋崕崗嵜崟崛崑崔崢崚崙崘嵌嵒嵎嵋嵬嵳嵶嶇嶄嶂嶢嶝嶬嶮嶽嶐嶷嶼巉巍巓巒巖巛巫已巵帋帚帙帑帛帶帷幄幃幀幎幗幔幟幢幤幇幵并幺麼广庠廁廂廈廐廏"],["d7a1","廖廣廝廚廛廢廡廨廩廬廱廳廰廴廸廾弃弉彝彜弋弑弖弩弭弸彁彈彌彎弯彑彖彗彙彡彭彳彷徃徂彿徊很徑徇從徙徘徠徨徭徼忖忻忤忸忱忝悳忿怡恠怙怐怩怎怱怛怕怫怦怏怺恚恁恪恷恟恊恆恍恣恃恤恂恬恫恙悁悍惧悃悚"],["d8a1","悄悛悖悗悒悧悋惡悸惠惓悴忰悽惆悵惘慍愕愆惶惷愀惴惺愃愡惻惱愍愎慇愾愨愧慊愿愼愬愴愽慂慄慳慷慘慙慚慫慴慯慥慱慟慝慓慵憙憖憇憬憔憚憊憑憫憮懌懊應懷懈懃懆憺懋罹懍懦懣懶懺懴懿懽懼懾戀戈戉戍戌戔戛"],["d9a1","戞戡截戮戰戲戳扁扎扞扣扛扠扨扼抂抉找抒抓抖拔抃抔拗拑抻拏拿拆擔拈拜拌拊拂拇抛拉挌拮拱挧挂挈拯拵捐挾捍搜捏掖掎掀掫捶掣掏掉掟掵捫捩掾揩揀揆揣揉插揶揄搖搴搆搓搦搶攝搗搨搏摧摯摶摎攪撕撓撥撩撈撼"],["daa1","據擒擅擇撻擘擂擱擧舉擠擡抬擣擯攬擶擴擲擺攀擽攘攜攅攤攣攫攴攵攷收攸畋效敖敕敍敘敞敝敲數斂斃變斛斟斫斷旃旆旁旄旌旒旛旙无旡旱杲昊昃旻杳昵昶昴昜晏晄晉晁晞晝晤晧晨晟晢晰暃暈暎暉暄暘暝曁暹曉暾暼"],["dba1","曄暸曖曚曠昿曦曩曰曵曷朏朖朞朦朧霸朮朿朶杁朸朷杆杞杠杙杣杤枉杰枩杼杪枌枋枦枡枅枷柯枴柬枳柩枸柤柞柝柢柮枹柎柆柧檜栞框栩桀桍栲桎梳栫桙档桷桿梟梏梭梔條梛梃檮梹桴梵梠梺椏梍桾椁棊椈棘椢椦棡椌棍"],["dca1","棔棧棕椶椒椄棗棣椥棹棠棯椨椪椚椣椡棆楹楷楜楸楫楔楾楮椹楴椽楙椰楡楞楝榁楪榲榮槐榿槁槓榾槎寨槊槝榻槃榧樮榑榠榜榕榴槞槨樂樛槿權槹槲槧樅榱樞槭樔槫樊樒櫁樣樓橄樌橲樶橸橇橢橙橦橈樸樢檐檍檠檄檢檣"],["dda1","檗蘗檻櫃櫂檸檳檬櫞櫑櫟檪櫚櫪櫻欅蘖櫺欒欖鬱欟欸欷盜欹飮歇歃歉歐歙歔歛歟歡歸歹歿殀殄殃殍殘殕殞殤殪殫殯殲殱殳殷殼毆毋毓毟毬毫毳毯麾氈氓气氛氤氣汞汕汢汪沂沍沚沁沛汾汨汳沒沐泄泱泓沽泗泅泝沮沱沾"],["dea1","沺泛泯泙泪洟衍洶洫洽洸洙洵洳洒洌浣涓浤浚浹浙涎涕濤涅淹渕渊涵淇淦涸淆淬淞淌淨淒淅淺淙淤淕淪淮渭湮渮渙湲湟渾渣湫渫湶湍渟湃渺湎渤滿渝游溂溪溘滉溷滓溽溯滄溲滔滕溏溥滂溟潁漑灌滬滸滾漿滲漱滯漲滌"],["dfa1","漾漓滷澆潺潸澁澀潯潛濳潭澂潼潘澎澑濂潦澳澣澡澤澹濆澪濟濕濬濔濘濱濮濛瀉瀋濺瀑瀁瀏濾瀛瀚潴瀝瀘瀟瀰瀾瀲灑灣炙炒炯烱炬炸炳炮烟烋烝烙焉烽焜焙煥煕熈煦煢煌煖煬熏燻熄熕熨熬燗熹熾燒燉燔燎燠燬燧燵燼"],["e0a1","燹燿爍爐爛爨爭爬爰爲爻爼爿牀牆牋牘牴牾犂犁犇犒犖犢犧犹犲狃狆狄狎狒狢狠狡狹狷倏猗猊猜猖猝猴猯猩猥猾獎獏默獗獪獨獰獸獵獻獺珈玳珎玻珀珥珮珞璢琅瑯琥珸琲琺瑕琿瑟瑙瑁瑜瑩瑰瑣瑪瑶瑾璋璞璧瓊瓏瓔珱"],["e1a1","瓠瓣瓧瓩瓮瓲瓰瓱瓸瓷甄甃甅甌甎甍甕甓甞甦甬甼畄畍畊畉畛畆畚畩畤畧畫畭畸當疆疇畴疊疉疂疔疚疝疥疣痂疳痃疵疽疸疼疱痍痊痒痙痣痞痾痿痼瘁痰痺痲痳瘋瘍瘉瘟瘧瘠瘡瘢瘤瘴瘰瘻癇癈癆癜癘癡癢癨癩癪癧癬癰"],["e2a1","癲癶癸發皀皃皈皋皎皖皓皙皚皰皴皸皹皺盂盍盖盒盞盡盥盧盪蘯盻眈眇眄眩眤眞眥眦眛眷眸睇睚睨睫睛睥睿睾睹瞎瞋瞑瞠瞞瞰瞶瞹瞿瞼瞽瞻矇矍矗矚矜矣矮矼砌砒礦砠礪硅碎硴碆硼碚碌碣碵碪碯磑磆磋磔碾碼磅磊磬"],["e3a1","磧磚磽磴礇礒礑礙礬礫祀祠祗祟祚祕祓祺祿禊禝禧齋禪禮禳禹禺秉秕秧秬秡秣稈稍稘稙稠稟禀稱稻稾稷穃穗穉穡穢穩龝穰穹穽窈窗窕窘窖窩竈窰窶竅竄窿邃竇竊竍竏竕竓站竚竝竡竢竦竭竰笂笏笊笆笳笘笙笞笵笨笶筐"],["e4a1","筺笄筍笋筌筅筵筥筴筧筰筱筬筮箝箘箟箍箜箚箋箒箏筝箙篋篁篌篏箴篆篝篩簑簔篦篥籠簀簇簓篳篷簗簍篶簣簧簪簟簷簫簽籌籃籔籏籀籐籘籟籤籖籥籬籵粃粐粤粭粢粫粡粨粳粲粱粮粹粽糀糅糂糘糒糜糢鬻糯糲糴糶糺紆"],["e5a1","紂紜紕紊絅絋紮紲紿紵絆絳絖絎絲絨絮絏絣經綉絛綏絽綛綺綮綣綵緇綽綫總綢綯緜綸綟綰緘緝緤緞緻緲緡縅縊縣縡縒縱縟縉縋縢繆繦縻縵縹繃縷縲縺繧繝繖繞繙繚繹繪繩繼繻纃緕繽辮繿纈纉續纒纐纓纔纖纎纛纜缸缺"],["e6a1","罅罌罍罎罐网罕罔罘罟罠罨罩罧罸羂羆羃羈羇羌羔羞羝羚羣羯羲羹羮羶羸譱翅翆翊翕翔翡翦翩翳翹飜耆耄耋耒耘耙耜耡耨耿耻聊聆聒聘聚聟聢聨聳聲聰聶聹聽聿肄肆肅肛肓肚肭冐肬胛胥胙胝胄胚胖脉胯胱脛脩脣脯腋"],["e7a1","隋腆脾腓腑胼腱腮腥腦腴膃膈膊膀膂膠膕膤膣腟膓膩膰膵膾膸膽臀臂膺臉臍臑臙臘臈臚臟臠臧臺臻臾舁舂舅與舊舍舐舖舩舫舸舳艀艙艘艝艚艟艤艢艨艪艫舮艱艷艸艾芍芒芫芟芻芬苡苣苟苒苴苳苺莓范苻苹苞茆苜茉苙"],["e8a1","茵茴茖茲茱荀茹荐荅茯茫茗茘莅莚莪莟莢莖茣莎莇莊荼莵荳荵莠莉莨菴萓菫菎菽萃菘萋菁菷萇菠菲萍萢萠莽萸蔆菻葭萪萼蕚蒄葷葫蒭葮蒂葩葆萬葯葹萵蓊葢蒹蒿蒟蓙蓍蒻蓚蓐蓁蓆蓖蒡蔡蓿蓴蔗蔘蔬蔟蔕蔔蓼蕀蕣蕘蕈"],["e9a1","蕁蘂蕋蕕薀薤薈薑薊薨蕭薔薛藪薇薜蕷蕾薐藉薺藏薹藐藕藝藥藜藹蘊蘓蘋藾藺蘆蘢蘚蘰蘿虍乕虔號虧虱蚓蚣蚩蚪蚋蚌蚶蚯蛄蛆蚰蛉蠣蚫蛔蛞蛩蛬蛟蛛蛯蜒蜆蜈蜀蜃蛻蜑蜉蜍蛹蜊蜴蜿蜷蜻蜥蜩蜚蝠蝟蝸蝌蝎蝴蝗蝨蝮蝙"],["eaa1","蝓蝣蝪蠅螢螟螂螯蟋螽蟀蟐雖螫蟄螳蟇蟆螻蟯蟲蟠蠏蠍蟾蟶蟷蠎蟒蠑蠖蠕蠢蠡蠱蠶蠹蠧蠻衄衂衒衙衞衢衫袁衾袞衵衽袵衲袂袗袒袮袙袢袍袤袰袿袱裃裄裔裘裙裝裹褂裼裴裨裲褄褌褊褓襃褞褥褪褫襁襄褻褶褸襌褝襠襞"],["eba1","襦襤襭襪襯襴襷襾覃覈覊覓覘覡覩覦覬覯覲覺覽覿觀觚觜觝觧觴觸訃訖訐訌訛訝訥訶詁詛詒詆詈詼詭詬詢誅誂誄誨誡誑誥誦誚誣諄諍諂諚諫諳諧諤諱謔諠諢諷諞諛謌謇謚諡謖謐謗謠謳鞫謦謫謾謨譁譌譏譎證譖譛譚譫"],["eca1","譟譬譯譴譽讀讌讎讒讓讖讙讚谺豁谿豈豌豎豐豕豢豬豸豺貂貉貅貊貍貎貔豼貘戝貭貪貽貲貳貮貶賈賁賤賣賚賽賺賻贄贅贊贇贏贍贐齎贓賍贔贖赧赭赱赳趁趙跂趾趺跏跚跖跌跛跋跪跫跟跣跼踈踉跿踝踞踐踟蹂踵踰踴蹊"],["eda1","蹇蹉蹌蹐蹈蹙蹤蹠踪蹣蹕蹶蹲蹼躁躇躅躄躋躊躓躑躔躙躪躡躬躰軆躱躾軅軈軋軛軣軼軻軫軾輊輅輕輒輙輓輜輟輛輌輦輳輻輹轅轂輾轌轉轆轎轗轜轢轣轤辜辟辣辭辯辷迚迥迢迪迯邇迴逅迹迺逑逕逡逍逞逖逋逧逶逵逹迸"],["eea1","遏遐遑遒逎遉逾遖遘遞遨遯遶隨遲邂遽邁邀邊邉邏邨邯邱邵郢郤扈郛鄂鄒鄙鄲鄰酊酖酘酣酥酩酳酲醋醉醂醢醫醯醪醵醴醺釀釁釉釋釐釖釟釡釛釼釵釶鈞釿鈔鈬鈕鈑鉞鉗鉅鉉鉤鉈銕鈿鉋鉐銜銖銓銛鉚鋏銹銷鋩錏鋺鍄錮"],["efa1","錙錢錚錣錺錵錻鍜鍠鍼鍮鍖鎰鎬鎭鎔鎹鏖鏗鏨鏥鏘鏃鏝鏐鏈鏤鐚鐔鐓鐃鐇鐐鐶鐫鐵鐡鐺鑁鑒鑄鑛鑠鑢鑞鑪鈩鑰鑵鑷鑽鑚鑼鑾钁鑿閂閇閊閔閖閘閙閠閨閧閭閼閻閹閾闊濶闃闍闌闕闔闖關闡闥闢阡阨阮阯陂陌陏陋陷陜陞"],["f0a1","陝陟陦陲陬隍隘隕隗險隧隱隲隰隴隶隸隹雎雋雉雍襍雜霍雕雹霄霆霈霓霎霑霏霖霙霤霪霰霹霽霾靄靆靈靂靉靜靠靤靦靨勒靫靱靹鞅靼鞁靺鞆鞋鞏鞐鞜鞨鞦鞣鞳鞴韃韆韈韋韜韭齏韲竟韶韵頏頌頸頤頡頷頽顆顏顋顫顯顰"],["f1a1","顱顴顳颪颯颱颶飄飃飆飩飫餃餉餒餔餘餡餝餞餤餠餬餮餽餾饂饉饅饐饋饑饒饌饕馗馘馥馭馮馼駟駛駝駘駑駭駮駱駲駻駸騁騏騅駢騙騫騷驅驂驀驃騾驕驍驛驗驟驢驥驤驩驫驪骭骰骼髀髏髑髓體髞髟髢髣髦髯髫髮髴髱髷"],["f2a1","髻鬆鬘鬚鬟鬢鬣鬥鬧鬨鬩鬪鬮鬯鬲魄魃魏魍魎魑魘魴鮓鮃鮑鮖鮗鮟鮠鮨鮴鯀鯊鮹鯆鯏鯑鯒鯣鯢鯤鯔鯡鰺鯲鯱鯰鰕鰔鰉鰓鰌鰆鰈鰒鰊鰄鰮鰛鰥鰤鰡鰰鱇鰲鱆鰾鱚鱠鱧鱶鱸鳧鳬鳰鴉鴈鳫鴃鴆鴪鴦鶯鴣鴟鵄鴕鴒鵁鴿鴾鵆鵈"],["f3a1","鵝鵞鵤鵑鵐鵙鵲鶉鶇鶫鵯鵺鶚鶤鶩鶲鷄鷁鶻鶸鶺鷆鷏鷂鷙鷓鷸鷦鷭鷯鷽鸚鸛鸞鹵鹹鹽麁麈麋麌麒麕麑麝麥麩麸麪麭靡黌黎黏黐黔黜點黝黠黥黨黯黴黶黷黹黻黼黽鼇鼈皷鼕鼡鼬鼾齊齒齔齣齟齠齡齦齧齬齪齷齲齶龕龜龠"],["f4a1","堯槇遙瑤凜熙"],["f9a1","纊褜鍈銈蓜俉炻昱棈鋹曻彅丨仡仼伀伃伹佖侒侊侚侔俍偀倢俿倞偆偰偂傔僴僘兊兤冝冾凬刕劜劦勀勛匀匇匤卲厓厲叝﨎咜咊咩哿喆坙坥垬埈埇﨏塚增墲夋奓奛奝奣妤妺孖寀甯寘寬尞岦岺峵崧嵓﨑嵂嵭嶸嶹巐弡弴彧德"],["faa1","忞恝悅悊惞惕愠惲愑愷愰憘戓抦揵摠撝擎敎昀昕昻昉昮昞昤晥晗晙晴晳暙暠暲暿曺朎朗杦枻桒柀栁桄棏﨓楨﨔榘槢樰橫橆橳橾櫢櫤毖氿汜沆汯泚洄涇浯涖涬淏淸淲淼渹湜渧渼溿澈澵濵瀅瀇瀨炅炫焏焄煜煆煇凞燁燾犱"],["fba1","犾猤猪獷玽珉珖珣珒琇珵琦琪琩琮瑢璉璟甁畯皂皜皞皛皦益睆劯砡硎硤硺礰礼神祥禔福禛竑竧靖竫箞精絈絜綷綠緖繒罇羡羽茁荢荿菇菶葈蒴蕓蕙蕫﨟薰蘒﨡蠇裵訒訷詹誧誾諟諸諶譓譿賰賴贒赶﨣軏﨤逸遧郞都鄕鄧釚"],["fca1","釗釞釭釮釤釥鈆鈐鈊鈺鉀鈼鉎鉙鉑鈹鉧銧鉷鉸鋧鋗鋙鋐﨧鋕鋠鋓錥錡鋻﨨錞鋿錝錂鍰鍗鎤鏆鏞鏸鐱鑅鑈閒隆﨩隝隯霳霻靃靍靏靑靕顗顥飯飼餧館馞驎髙髜魵魲鮏鮱鮻鰀鵰鵫鶴鸙黑"],["fcf1","ⅰ",9,"￢￤＇＂"],["8fa2af","˘ˇ¸˙˝¯˛˚～΄΅"],["8fa2c2","¡¦¿"],["8fa2eb","ºª©®™¤№"],["8fa6e1","ΆΈΉΊΪ"],["8fa6e7","Ό"],["8fa6e9","ΎΫ"],["8fa6ec","Ώ"],["8fa6f1","άέήίϊΐόςύϋΰώ"],["8fa7c2","Ђ",10,"ЎЏ"],["8fa7f2","ђ",10,"ўџ"],["8fa9a1","ÆĐ"],["8fa9a4","Ħ"],["8fa9a6","Ĳ"],["8fa9a8","ŁĿ"],["8fa9ab","ŊØŒ"],["8fa9af","ŦÞ"],["8fa9c1","æđðħıĳĸłŀŉŋøœßŧþ"],["8faaa1","ÁÀÄÂĂǍĀĄÅÃĆĈČÇĊĎÉÈËÊĚĖĒĘ"],["8faaba","ĜĞĢĠĤÍÌÏÎǏİĪĮĨĴĶĹĽĻŃŇŅÑÓÒÖÔǑŐŌÕŔŘŖŚŜŠŞŤŢÚÙÜÛŬǓŰŪŲŮŨǗǛǙǕŴÝŸŶŹŽŻ"],["8faba1","áàäâăǎāąåãćĉčçċďéèëêěėēęǵĝğ"],["8fabbd","ġĥíìïîǐ"],["8fabc5","īįĩĵķĺľļńňņñóòöôǒőōõŕřŗśŝšşťţúùüûŭǔűūųůũǘǜǚǖŵýÿŷźžż"],["8fb0a1","丂丄丅丌丒丟丣两丨丫丮丯丰丵乀乁乄乇乑乚乜乣乨乩乴乵乹乿亍亖亗亝亯亹仃仐仚仛仠仡仢仨仯仱仳仵份仾仿伀伂伃伈伋伌伒伕伖众伙伮伱你伳伵伷伹伻伾佀佂佈佉佋佌佒佔佖佘佟佣佪佬佮佱佷佸佹佺佽佾侁侂侄"],["8fb1a1","侅侉侊侌侎侐侒侓侔侗侙侚侞侟侲侷侹侻侼侽侾俀俁俅俆俈俉俋俌俍俏俒俜俠俢俰俲俼俽俿倀倁倄倇倊倌倎倐倓倗倘倛倜倝倞倢倧倮倰倲倳倵偀偁偂偅偆偊偌偎偑偒偓偗偙偟偠偢偣偦偧偪偭偰偱倻傁傃傄傆傊傎傏傐"],["8fb2a1","傒傓傔傖傛傜傞",4,"傪傯傰傹傺傽僀僃僄僇僌僎僐僓僔僘僜僝僟僢僤僦僨僩僯僱僶僺僾儃儆儇儈儋儌儍儎僲儐儗儙儛儜儝儞儣儧儨儬儭儯儱儳儴儵儸儹兂兊兏兓兕兗兘兟兤兦兾冃冄冋冎冘冝冡冣冭冸冺冼冾冿凂"],["8fb3a1","凈减凑凒凓凕凘凞凢凥凮凲凳凴凷刁刂刅划刓刕刖刘刢刨刱刲刵刼剅剉剕剗剘剚剜剟剠剡剦剮剷剸剹劀劂劅劊劌劓劕劖劗劘劚劜劤劥劦劧劯劰劶劷劸劺劻劽勀勄勆勈勌勏勑勔勖勛勜勡勥勨勩勪勬勰勱勴勶勷匀匃匊匋"],["8fb4a1","匌匑匓匘匛匜匞匟匥匧匨匩匫匬匭匰匲匵匼匽匾卂卌卋卙卛卡卣卥卬卭卲卹卾厃厇厈厎厓厔厙厝厡厤厪厫厯厲厴厵厷厸厺厽叀叅叏叒叓叕叚叝叞叠另叧叵吂吓吚吡吧吨吪启吱吴吵呃呄呇呍呏呞呢呤呦呧呩呫呭呮呴呿"],["8fb5a1","咁咃咅咈咉咍咑咕咖咜咟咡咦咧咩咪咭咮咱咷咹咺咻咿哆哊响哎哠哪哬哯哶哼哾哿唀唁唅唈唉唌唍唎唕唪唫唲唵唶唻唼唽啁啇啉啊啍啐啑啘啚啛啞啠啡啤啦啿喁喂喆喈喎喏喑喒喓喔喗喣喤喭喲喿嗁嗃嗆嗉嗋嗌嗎嗑嗒"],["8fb6a1","嗓嗗嗘嗛嗞嗢嗩嗶嗿嘅嘈嘊嘍",5,"嘙嘬嘰嘳嘵嘷嘹嘻嘼嘽嘿噀噁噃噄噆噉噋噍噏噔噞噠噡噢噣噦噩噭噯噱噲噵嚄嚅嚈嚋嚌嚕嚙嚚嚝嚞嚟嚦嚧嚨嚩嚫嚬嚭嚱嚳嚷嚾囅囉囊囋囏囐囌囍囙囜囝囟囡囤",4,"囱囫园"],["8fb7a1","囶囷圁圂圇圊圌圑圕圚圛圝圠圢圣圤圥圩圪圬圮圯圳圴圽圾圿坅坆坌坍坒坢坥坧坨坫坭",4,"坳坴坵坷坹坺坻坼坾垁垃垌垔垗垙垚垜垝垞垟垡垕垧垨垩垬垸垽埇埈埌埏埕埝埞埤埦埧埩埭埰埵埶埸埽埾埿堃堄堈堉埡"],["8fb8a1","堌堍堛堞堟堠堦堧堭堲堹堿塉塌塍塏塐塕塟塡塤塧塨塸塼塿墀墁墇墈墉墊墌墍墏墐墔墖墝墠墡墢墦墩墱墲壄墼壂壈壍壎壐壒壔壖壚壝壡壢壩壳夅夆夋夌夒夓夔虁夝夡夣夤夨夯夰夳夵夶夿奃奆奒奓奙奛奝奞奟奡奣奫奭"],["8fb9a1","奯奲奵奶她奻奼妋妌妎妒妕妗妟妤妧妭妮妯妰妳妷妺妼姁姃姄姈姊姍姒姝姞姟姣姤姧姮姯姱姲姴姷娀娄娌娍娎娒娓娞娣娤娧娨娪娭娰婄婅婇婈婌婐婕婞婣婥婧婭婷婺婻婾媋媐媓媖媙媜媞媟媠媢媧媬媱媲媳媵媸媺媻媿"],["8fbaa1","嫄嫆嫈嫏嫚嫜嫠嫥嫪嫮嫵嫶嫽嬀嬁嬈嬗嬴嬙嬛嬝嬡嬥嬭嬸孁孋孌孒孖孞孨孮孯孼孽孾孿宁宄宆宊宎宐宑宓宔宖宨宩宬宭宯宱宲宷宺宼寀寁寍寏寖",4,"寠寯寱寴寽尌尗尞尟尣尦尩尫尬尮尰尲尵尶屙屚屜屢屣屧屨屩"],["8fbba1","屭屰屴屵屺屻屼屽岇岈岊岏岒岝岟岠岢岣岦岪岲岴岵岺峉峋峒峝峗峮峱峲峴崁崆崍崒崫崣崤崦崧崱崴崹崽崿嵂嵃嵆嵈嵕嵑嵙嵊嵟嵠嵡嵢嵤嵪嵭嵰嵹嵺嵾嵿嶁嶃嶈嶊嶒嶓嶔嶕嶙嶛嶟嶠嶧嶫嶰嶴嶸嶹巃巇巋巐巎巘巙巠巤"],["8fbca1","巩巸巹帀帇帍帒帔帕帘帟帠帮帨帲帵帾幋幐幉幑幖幘幛幜幞幨幪",4,"幰庀庋庎庢庤庥庨庪庬庱庳庽庾庿廆廌廋廎廑廒廔廕廜廞廥廫异弆弇弈弎弙弜弝弡弢弣弤弨弫弬弮弰弴弶弻弽弿彀彄彅彇彍彐彔彘彛彠彣彤彧"],["8fbda1","彯彲彴彵彸彺彽彾徉徍徏徖徜徝徢徧徫徤徬徯徰徱徸忄忇忈忉忋忐",4,"忞忡忢忨忩忪忬忭忮忯忲忳忶忺忼怇怊怍怓怔怗怘怚怟怤怭怳怵恀恇恈恉恌恑恔恖恗恝恡恧恱恾恿悂悆悈悊悎悑悓悕悘悝悞悢悤悥您悰悱悷"],["8fbea1","悻悾惂惄惈惉惊惋惎惏惔惕惙惛惝惞惢惥惲惵惸惼惽愂愇愊愌愐",4,"愖愗愙愜愞愢愪愫愰愱愵愶愷愹慁慅慆慉慞慠慬慲慸慻慼慿憀憁憃憄憋憍憒憓憗憘憜憝憟憠憥憨憪憭憸憹憼懀懁懂懎懏懕懜懝懞懟懡懢懧懩懥"],["8fbfa1","懬懭懯戁戃戄戇戓戕戜戠戢戣戧戩戫戹戽扂扃扄扆扌扐扑扒扔扖扚扜扤扭扯扳扺扽抍抎抏抐抦抨抳抶抷抺抾抿拄拎拕拖拚拪拲拴拼拽挃挄挊挋挍挐挓挖挘挩挪挭挵挶挹挼捁捂捃捄捆捊捋捎捒捓捔捘捛捥捦捬捭捱捴捵"],["8fc0a1","捸捼捽捿掂掄掇掊掐掔掕掙掚掞掤掦掭掮掯掽揁揅揈揎揑揓揔揕揜揠揥揪揬揲揳揵揸揹搉搊搐搒搔搘搞搠搢搤搥搩搪搯搰搵搽搿摋摏摑摒摓摔摚摛摜摝摟摠摡摣摭摳摴摻摽撅撇撏撐撑撘撙撛撝撟撡撣撦撨撬撳撽撾撿"],["8fc1a1","擄擉擊擋擌擎擐擑擕擗擤擥擩擪擭擰擵擷擻擿攁攄攈攉攊攏攓攔攖攙攛攞攟攢攦攩攮攱攺攼攽敃敇敉敐敒敔敟敠敧敫敺敽斁斅斊斒斕斘斝斠斣斦斮斲斳斴斿旂旈旉旎旐旔旖旘旟旰旲旴旵旹旾旿昀昄昈昉昍昑昒昕昖昝"],["8fc2a1","昞昡昢昣昤昦昩昪昫昬昮昰昱昳昹昷晀晅晆晊晌晑晎晗晘晙晛晜晠晡曻晪晫晬晾晳晵晿晷晸晹晻暀晼暋暌暍暐暒暙暚暛暜暟暠暤暭暱暲暵暻暿曀曂曃曈曌曎曏曔曛曟曨曫曬曮曺朅朇朎朓朙朜朠朢朳朾杅杇杈杌杔杕杝"],["8fc3a1","杦杬杮杴杶杻极构枎枏枑枓枖枘枙枛枰枱枲枵枻枼枽柹柀柂柃柅柈柉柒柗柙柜柡柦柰柲柶柷桒栔栙栝栟栨栧栬栭栯栰栱栳栻栿桄桅桊桌桕桗桘桛桫桮",4,"桵桹桺桻桼梂梄梆梈梖梘梚梜梡梣梥梩梪梮梲梻棅棈棌棏"],["8fc4a1","棐棑棓棖棙棜棝棥棨棪棫棬棭棰棱棵棶棻棼棽椆椉椊椐椑椓椖椗椱椳椵椸椻楂楅楉楎楗楛楣楤楥楦楨楩楬楰楱楲楺楻楿榀榍榒榖榘榡榥榦榨榫榭榯榷榸榺榼槅槈槑槖槗槢槥槮槯槱槳槵槾樀樁樃樏樑樕樚樝樠樤樨樰樲"],["8fc5a1","樴樷樻樾樿橅橆橉橊橎橐橑橒橕橖橛橤橧橪橱橳橾檁檃檆檇檉檋檑檛檝檞檟檥檫檯檰檱檴檽檾檿櫆櫉櫈櫌櫐櫔櫕櫖櫜櫝櫤櫧櫬櫰櫱櫲櫼櫽欂欃欆欇欉欏欐欑欗欛欞欤欨欫欬欯欵欶欻欿歆歊歍歒歖歘歝歠歧歫歮歰歵歽"],["8fc6a1","歾殂殅殗殛殟殠殢殣殨殩殬殭殮殰殸殹殽殾毃毄毉毌毖毚毡毣毦毧毮毱毷毹毿氂氄氅氉氍氎氐氒氙氟氦氧氨氬氮氳氵氶氺氻氿汊汋汍汏汒汔汙汛汜汫汭汯汴汶汸汹汻沅沆沇沉沔沕沗沘沜沟沰沲沴泂泆泍泏泐泑泒泔泖"],["8fc7a1","泚泜泠泧泩泫泬泮泲泴洄洇洊洎洏洑洓洚洦洧洨汧洮洯洱洹洼洿浗浞浟浡浥浧浯浰浼涂涇涑涒涔涖涗涘涪涬涴涷涹涽涿淄淈淊淎淏淖淛淝淟淠淢淥淩淯淰淴淶淼渀渄渞渢渧渲渶渹渻渼湄湅湈湉湋湏湑湒湓湔湗湜湝湞"],["8fc8a1","湢湣湨湳湻湽溍溓溙溠溧溭溮溱溳溻溿滀滁滃滇滈滊滍滎滏滫滭滮滹滻滽漄漈漊漌漍漖漘漚漛漦漩漪漯漰漳漶漻漼漭潏潑潒潓潗潙潚潝潞潡潢潨潬潽潾澃澇澈澋澌澍澐澒澓澔澖澚澟澠澥澦澧澨澮澯澰澵澶澼濅濇濈濊"],["8fc9a1","濚濞濨濩濰濵濹濼濽瀀瀅瀆瀇瀍瀗瀠瀣瀯瀴瀷瀹瀼灃灄灈灉灊灋灔灕灝灞灎灤灥灬灮灵灶灾炁炅炆炔",4,"炛炤炫炰炱炴炷烊烑烓烔烕烖烘烜烤烺焃",4,"焋焌焏焞焠焫焭焯焰焱焸煁煅煆煇煊煋煐煒煗煚煜煞煠"],["8fcaa1","煨煹熀熅熇熌熒熚熛熠熢熯熰熲熳熺熿燀燁燄燋燌燓燖燙燚燜燸燾爀爇爈爉爓爗爚爝爟爤爫爯爴爸爹牁牂牃牅牎牏牐牓牕牖牚牜牞牠牣牨牫牮牯牱牷牸牻牼牿犄犉犍犎犓犛犨犭犮犱犴犾狁狇狉狌狕狖狘狟狥狳狴狺狻"],["8fcba1","狾猂猄猅猇猋猍猒猓猘猙猞猢猤猧猨猬猱猲猵猺猻猽獃獍獐獒獖獘獝獞獟獠獦獧獩獫獬獮獯獱獷獹獼玀玁玃玅玆玎玐玓玕玗玘玜玞玟玠玢玥玦玪玫玭玵玷玹玼玽玿珅珆珉珋珌珏珒珓珖珙珝珡珣珦珧珩珴珵珷珹珺珻珽"],["8fcca1","珿琀琁琄琇琊琑琚琛琤琦琨",9,"琹瑀瑃瑄瑆瑇瑋瑍瑑瑒瑗瑝瑢瑦瑧瑨瑫瑭瑮瑱瑲璀璁璅璆璇璉璏璐璑璒璘璙璚璜璟璠璡璣璦璨璩璪璫璮璯璱璲璵璹璻璿瓈瓉瓌瓐瓓瓘瓚瓛瓞瓟瓤瓨瓪瓫瓯瓴瓺瓻瓼瓿甆"],["8fcda1","甒甖甗甠甡甤甧甩甪甯甶甹甽甾甿畀畃畇畈畎畐畒畗畞畟畡畯畱畹",5,"疁疅疐疒疓疕疙疜疢疤疴疺疿痀痁痄痆痌痎痏痗痜痟痠痡痤痧痬痮痯痱痹瘀瘂瘃瘄瘇瘈瘊瘌瘏瘒瘓瘕瘖瘙瘛瘜瘝瘞瘣瘥瘦瘩瘭瘲瘳瘵瘸瘹"],["8fcea1","瘺瘼癊癀癁癃癄癅癉癋癕癙癟癤癥癭癮癯癱癴皁皅皌皍皕皛皜皝皟皠皢",6,"皪皭皽盁盅盉盋盌盎盔盙盠盦盨盬盰盱盶盹盼眀眆眊眎眒眔眕眗眙眚眜眢眨眭眮眯眴眵眶眹眽眾睂睅睆睊睍睎睏睒睖睗睜睞睟睠睢"],["8fcfa1","睤睧睪睬睰睲睳睴睺睽瞀瞄瞌瞍瞔瞕瞖瞚瞟瞢瞧瞪瞮瞯瞱瞵瞾矃矉矑矒矕矙矞矟矠矤矦矪矬矰矱矴矸矻砅砆砉砍砎砑砝砡砢砣砭砮砰砵砷硃硄硇硈硌硎硒硜硞硠硡硣硤硨硪确硺硾碊碏碔碘碡碝碞碟碤碨碬碭碰碱碲碳"],["8fd0a1","碻碽碿磇磈磉磌磎磒磓磕磖磤磛磟磠磡磦磪磲磳礀磶磷磺磻磿礆礌礐礚礜礞礟礠礥礧礩礭礱礴礵礻礽礿祄祅祆祊祋祏祑祔祘祛祜祧祩祫祲祹祻祼祾禋禌禑禓禔禕禖禘禛禜禡禨禩禫禯禱禴禸离秂秄秇秈秊秏秔秖秚秝秞"],["8fd1a1","秠秢秥秪秫秭秱秸秼稂稃稇稉稊稌稑稕稛稞稡稧稫稭稯稰稴稵稸稹稺穄穅穇穈穌穕穖穙穜穝穟穠穥穧穪穭穵穸穾窀窂窅窆窊窋窐窑窔窞窠窣窬窳窵窹窻窼竆竉竌竎竑竛竨竩竫竬竱竴竻竽竾笇笔笟笣笧笩笪笫笭笮笯笰"],["8fd2a1","笱笴笽笿筀筁筇筎筕筠筤筦筩筪筭筯筲筳筷箄箉箎箐箑箖箛箞箠箥箬箯箰箲箵箶箺箻箼箽篂篅篈篊篔篖篗篙篚篛篨篪篲篴篵篸篹篺篼篾簁簂簃簄簆簉簋簌簎簏簙簛簠簥簦簨簬簱簳簴簶簹簺籆籊籕籑籒籓籙",5],["8fd3a1","籡籣籧籩籭籮籰籲籹籼籽粆粇粏粔粞粠粦粰粶粷粺粻粼粿糄糇糈糉糍糏糓糔糕糗糙糚糝糦糩糫糵紃紇紈紉紏紑紒紓紖紝紞紣紦紪紭紱紼紽紾絀絁絇絈絍絑絓絗絙絚絜絝絥絧絪絰絸絺絻絿綁綂綃綅綆綈綋綌綍綑綖綗綝"],["8fd4a1","綞綦綧綪綳綶綷綹緂",4,"緌緍緎緗緙縀緢緥緦緪緫緭緱緵緶緹緺縈縐縑縕縗縜縝縠縧縨縬縭縯縳縶縿繄繅繇繎繐繒繘繟繡繢繥繫繮繯繳繸繾纁纆纇纊纍纑纕纘纚纝纞缼缻缽缾缿罃罄罇罏罒罓罛罜罝罡罣罤罥罦罭"],["8fd5a1","罱罽罾罿羀羋羍羏羐羑羖羗羜羡羢羦羪羭羴羼羿翀翃翈翎翏翛翟翣翥翨翬翮翯翲翺翽翾翿耇耈耊耍耎耏耑耓耔耖耝耞耟耠耤耦耬耮耰耴耵耷耹耺耼耾聀聄聠聤聦聭聱聵肁肈肎肜肞肦肧肫肸肹胈胍胏胒胔胕胗胘胠胭胮"],["8fd6a1","胰胲胳胶胹胺胾脃脋脖脗脘脜脞脠脤脧脬脰脵脺脼腅腇腊腌腒腗腠腡腧腨腩腭腯腷膁膐膄膅膆膋膎膖膘膛膞膢膮膲膴膻臋臃臅臊臎臏臕臗臛臝臞臡臤臫臬臰臱臲臵臶臸臹臽臿舀舃舏舓舔舙舚舝舡舢舨舲舴舺艃艄艅艆"],["8fd7a1","艋艎艏艑艖艜艠艣艧艭艴艻艽艿芀芁芃芄芇芉芊芎芑芔芖芘芚芛芠芡芣芤芧芨芩芪芮芰芲芴芷芺芼芾芿苆苐苕苚苠苢苤苨苪苭苯苶苷苽苾茀茁茇茈茊茋荔茛茝茞茟茡茢茬茭茮茰茳茷茺茼茽荂荃荄荇荍荎荑荕荖荗荰荸"],["8fd8a1","荽荿莀莂莄莆莍莒莔莕莘莙莛莜莝莦莧莩莬莾莿菀菇菉菏菐菑菔菝荓菨菪菶菸菹菼萁萆萊萏萑萕萙莭萯萹葅葇葈葊葍葏葑葒葖葘葙葚葜葠葤葥葧葪葰葳葴葶葸葼葽蒁蒅蒒蒓蒕蒞蒦蒨蒩蒪蒯蒱蒴蒺蒽蒾蓀蓂蓇蓈蓌蓏蓓"],["8fd9a1","蓜蓧蓪蓯蓰蓱蓲蓷蔲蓺蓻蓽蔂蔃蔇蔌蔎蔐蔜蔞蔢蔣蔤蔥蔧蔪蔫蔯蔳蔴蔶蔿蕆蕏",4,"蕖蕙蕜",6,"蕤蕫蕯蕹蕺蕻蕽蕿薁薅薆薉薋薌薏薓薘薝薟薠薢薥薧薴薶薷薸薼薽薾薿藂藇藊藋藎薭藘藚藟藠藦藨藭藳藶藼"],["8fdaa1","藿蘀蘄蘅蘍蘎蘐蘑蘒蘘蘙蘛蘞蘡蘧蘩蘶蘸蘺蘼蘽虀虂虆虒虓虖虗虘虙虝虠",4,"虩虬虯虵虶虷虺蚍蚑蚖蚘蚚蚜蚡蚦蚧蚨蚭蚱蚳蚴蚵蚷蚸蚹蚿蛀蛁蛃蛅蛑蛒蛕蛗蛚蛜蛠蛣蛥蛧蚈蛺蛼蛽蜄蜅蜇蜋蜎蜏蜐蜓蜔蜙蜞蜟蜡蜣"],["8fdba1","蜨蜮蜯蜱蜲蜹蜺蜼蜽蜾蝀蝃蝅蝍蝘蝝蝡蝤蝥蝯蝱蝲蝻螃",6,"螋螌螐螓螕螗螘螙螞螠螣螧螬螭螮螱螵螾螿蟁蟈蟉蟊蟎蟕蟖蟙蟚蟜蟟蟢蟣蟤蟪蟫蟭蟱蟳蟸蟺蟿蠁蠃蠆蠉蠊蠋蠐蠙蠒蠓蠔蠘蠚蠛蠜蠞蠟蠨蠭蠮蠰蠲蠵"],["8fdca1","蠺蠼衁衃衅衈衉衊衋衎衑衕衖衘衚衜衟衠衤衩衱衹衻袀袘袚袛袜袟袠袨袪袺袽袾裀裊",4,"裑裒裓裛裞裧裯裰裱裵裷褁褆褍褎褏褕褖褘褙褚褜褠褦褧褨褰褱褲褵褹褺褾襀襂襅襆襉襏襒襗襚襛襜襡襢襣襫襮襰襳襵襺"],["8fdda1","襻襼襽覉覍覐覔覕覛覜覟覠覥覰覴覵覶覷覼觔",4,"觥觩觫觭觱觳觶觹觽觿訄訅訇訏訑訒訔訕訞訠訢訤訦訫訬訯訵訷訽訾詀詃詅詇詉詍詎詓詖詗詘詜詝詡詥詧詵詶詷詹詺詻詾詿誀誃誆誋誏誐誒誖誗誙誟誧誩誮誯誳"],["8fdea1","誶誷誻誾諃諆諈諉諊諑諓諔諕諗諝諟諬諰諴諵諶諼諿謅謆謋謑謜謞謟謊謭謰謷謼譂",4,"譈譒譓譔譙譍譞譣譭譶譸譹譼譾讁讄讅讋讍讏讔讕讜讞讟谸谹谽谾豅豇豉豋豏豑豓豔豗豘豛豝豙豣豤豦豨豩豭豳豵豶豻豾貆"],["8fdfa1","貇貋貐貒貓貙貛貜貤貹貺賅賆賉賋賏賖賕賙賝賡賨賬賯賰賲賵賷賸賾賿贁贃贉贒贗贛赥赩赬赮赿趂趄趈趍趐趑趕趞趟趠趦趫趬趯趲趵趷趹趻跀跅跆跇跈跊跎跑跔跕跗跙跤跥跧跬跰趼跱跲跴跽踁踄踅踆踋踑踔踖踠踡踢"],["8fe0a1","踣踦踧踱踳踶踷踸踹踽蹀蹁蹋蹍蹎蹏蹔蹛蹜蹝蹞蹡蹢蹩蹬蹭蹯蹰蹱蹹蹺蹻躂躃躉躐躒躕躚躛躝躞躢躧躩躭躮躳躵躺躻軀軁軃軄軇軏軑軔軜軨軮軰軱軷軹軺軭輀輂輇輈輏輐輖輗輘輞輠輡輣輥輧輨輬輭輮輴輵輶輷輺轀轁"],["8fe1a1","轃轇轏轑",4,"轘轝轞轥辝辠辡辤辥辦辵辶辸达迀迁迆迊迋迍运迒迓迕迠迣迤迨迮迱迵迶迻迾适逄逈逌逘逛逨逩逯逪逬逭逳逴逷逿遃遄遌遛遝遢遦遧遬遰遴遹邅邈邋邌邎邐邕邗邘邙邛邠邡邢邥邰邲邳邴邶邽郌邾郃"],["8fe2a1","郄郅郇郈郕郗郘郙郜郝郟郥郒郶郫郯郰郴郾郿鄀鄄鄅鄆鄈鄍鄐鄔鄖鄗鄘鄚鄜鄞鄠鄥鄢鄣鄧鄩鄮鄯鄱鄴鄶鄷鄹鄺鄼鄽酃酇酈酏酓酗酙酚酛酡酤酧酭酴酹酺酻醁醃醅醆醊醎醑醓醔醕醘醞醡醦醨醬醭醮醰醱醲醳醶醻醼醽醿"],["8fe3a1","釂釃釅釓釔釗釙釚釞釤釥釩釪釬",5,"釷釹釻釽鈀鈁鈄鈅鈆鈇鈉鈊鈌鈐鈒鈓鈖鈘鈜鈝鈣鈤鈥鈦鈨鈮鈯鈰鈳鈵鈶鈸鈹鈺鈼鈾鉀鉂鉃鉆鉇鉊鉍鉎鉏鉑鉘鉙鉜鉝鉠鉡鉥鉧鉨鉩鉮鉯鉰鉵",4,"鉻鉼鉽鉿銈銉銊銍銎銒銗"],["8fe4a1","銙銟銠銤銥銧銨銫銯銲銶銸銺銻銼銽銿",4,"鋅鋆鋇鋈鋋鋌鋍鋎鋐鋓鋕鋗鋘鋙鋜鋝鋟鋠鋡鋣鋥鋧鋨鋬鋮鋰鋹鋻鋿錀錂錈錍錑錔錕錜錝錞錟錡錤錥錧錩錪錳錴錶錷鍇鍈鍉鍐鍑鍒鍕鍗鍘鍚鍞鍤鍥鍧鍩鍪鍭鍯鍰鍱鍳鍴鍶"],["8fe5a1","鍺鍽鍿鎀鎁鎂鎈鎊鎋鎍鎏鎒鎕鎘鎛鎞鎡鎣鎤鎦鎨鎫鎴鎵鎶鎺鎩鏁鏄鏅鏆鏇鏉",4,"鏓鏙鏜鏞鏟鏢鏦鏧鏹鏷鏸鏺鏻鏽鐁鐂鐄鐈鐉鐍鐎鐏鐕鐖鐗鐟鐮鐯鐱鐲鐳鐴鐻鐿鐽鑃鑅鑈鑊鑌鑕鑙鑜鑟鑡鑣鑨鑫鑭鑮鑯鑱鑲钄钃镸镹"],["8fe6a1","镾閄閈閌閍閎閝閞閟閡閦閩閫閬閴閶閺閽閿闆闈闉闋闐闑闒闓闙闚闝闞闟闠闤闦阝阞阢阤阥阦阬阱阳阷阸阹阺阼阽陁陒陔陖陗陘陡陮陴陻陼陾陿隁隂隃隄隉隑隖隚隝隟隤隥隦隩隮隯隳隺雊雒嶲雘雚雝雞雟雩雯雱雺霂"],["8fe7a1","霃霅霉霚霛霝霡霢霣霨霱霳靁靃靊靎靏靕靗靘靚靛靣靧靪靮靳靶靷靸靻靽靿鞀鞉鞕鞖鞗鞙鞚鞞鞟鞢鞬鞮鞱鞲鞵鞶鞸鞹鞺鞼鞾鞿韁韄韅韇韉韊韌韍韎韐韑韔韗韘韙韝韞韠韛韡韤韯韱韴韷韸韺頇頊頙頍頎頔頖頜頞頠頣頦"],["8fe8a1","頫頮頯頰頲頳頵頥頾顄顇顊顑顒顓顖顗顙顚顢顣顥顦顪顬颫颭颮颰颴颷颸颺颻颿飂飅飈飌飡飣飥飦飧飪飳飶餂餇餈餑餕餖餗餚餛餜餟餢餦餧餫餱",4,"餹餺餻餼饀饁饆饇饈饍饎饔饘饙饛饜饞饟饠馛馝馟馦馰馱馲馵"],["8fe9a1","馹馺馽馿駃駉駓駔駙駚駜駞駧駪駫駬駰駴駵駹駽駾騂騃騄騋騌騐騑騖騞騠騢騣騤騧騭騮騳騵騶騸驇驁驄驊驋驌驎驑驔驖驝骪骬骮骯骲骴骵骶骹骻骾骿髁髃髆髈髎髐髒髕髖髗髛髜髠髤髥髧髩髬髲髳髵髹髺髽髿",4],["8feaa1","鬄鬅鬈鬉鬋鬌鬍鬎鬐鬒鬖鬙鬛鬜鬠鬦鬫鬭鬳鬴鬵鬷鬹鬺鬽魈魋魌魕魖魗魛魞魡魣魥魦魨魪",4,"魳魵魷魸魹魿鮀鮄鮅鮆鮇鮉鮊鮋鮍鮏鮐鮔鮚鮝鮞鮦鮧鮩鮬鮰鮱鮲鮷鮸鮻鮼鮾鮿鯁鯇鯈鯎鯐鯗鯘鯝鯟鯥鯧鯪鯫鯯鯳鯷鯸"],["8feba1","鯹鯺鯽鯿鰀鰂鰋鰏鰑鰖鰘鰙鰚鰜鰞鰢鰣鰦",4,"鰱鰵鰶鰷鰽鱁鱃鱄鱅鱉鱊鱎鱏鱐鱓鱔鱖鱘鱛鱝鱞鱟鱣鱩鱪鱜鱫鱨鱮鱰鱲鱵鱷鱻鳦鳲鳷鳹鴋鴂鴑鴗鴘鴜鴝鴞鴯鴰鴲鴳鴴鴺鴼鵅鴽鵂鵃鵇鵊鵓鵔鵟鵣鵢鵥鵩鵪鵫鵰鵶鵷鵻"],["8feca1","鵼鵾鶃鶄鶆鶊鶍鶎鶒鶓鶕鶖鶗鶘鶡鶪鶬鶮鶱鶵鶹鶼鶿鷃鷇鷉鷊鷔鷕鷖鷗鷚鷞鷟鷠鷥鷧鷩鷫鷮鷰鷳鷴鷾鸊鸂鸇鸎鸐鸑鸒鸕鸖鸙鸜鸝鹺鹻鹼麀麂麃麄麅麇麎麏麖麘麛麞麤麨麬麮麯麰麳麴麵黆黈黋黕黟黤黧黬黭黮黰黱黲黵"],["8feda1","黸黿鼂鼃鼉鼏鼐鼑鼒鼔鼖鼗鼙鼚鼛鼟鼢鼦鼪鼫鼯鼱鼲鼴鼷鼹鼺鼼鼽鼿齁齃",4,"齓齕齖齗齘齚齝齞齨齩齭",4,"齳齵齺齽龏龐龑龒龔龖龗龞龡龢龣龥"]]');

/***/ }),

/***/ 9129:
/***/ ((module) => {

"use strict";
module.exports = /*#__PURE__*/JSON.parse('{"uChars":[128,165,169,178,184,216,226,235,238,244,248,251,253,258,276,284,300,325,329,334,364,463,465,467,469,471,473,475,477,506,594,610,712,716,730,930,938,962,970,1026,1104,1106,8209,8215,8218,8222,8231,8241,8244,8246,8252,8365,8452,8454,8458,8471,8482,8556,8570,8596,8602,8713,8720,8722,8726,8731,8737,8740,8742,8748,8751,8760,8766,8777,8781,8787,8802,8808,8816,8854,8858,8870,8896,8979,9322,9372,9548,9588,9616,9622,9634,9652,9662,9672,9676,9680,9702,9735,9738,9793,9795,11906,11909,11913,11917,11928,11944,11947,11951,11956,11960,11964,11979,12284,12292,12312,12319,12330,12351,12436,12447,12535,12543,12586,12842,12850,12964,13200,13215,13218,13253,13263,13267,13270,13384,13428,13727,13839,13851,14617,14703,14801,14816,14964,15183,15471,15585,16471,16736,17208,17325,17330,17374,17623,17997,18018,18212,18218,18301,18318,18760,18811,18814,18820,18823,18844,18848,18872,19576,19620,19738,19887,40870,59244,59336,59367,59413,59417,59423,59431,59437,59443,59452,59460,59478,59493,63789,63866,63894,63976,63986,64016,64018,64021,64025,64034,64037,64042,65074,65093,65107,65112,65127,65132,65375,65510,65536],"gbChars":[0,36,38,45,50,81,89,95,96,100,103,104,105,109,126,133,148,172,175,179,208,306,307,308,309,310,311,312,313,341,428,443,544,545,558,741,742,749,750,805,819,820,7922,7924,7925,7927,7934,7943,7944,7945,7950,8062,8148,8149,8152,8164,8174,8236,8240,8262,8264,8374,8380,8381,8384,8388,8390,8392,8393,8394,8396,8401,8406,8416,8419,8424,8437,8439,8445,8482,8485,8496,8521,8603,8936,8946,9046,9050,9063,9066,9076,9092,9100,9108,9111,9113,9131,9162,9164,9218,9219,11329,11331,11334,11336,11346,11361,11363,11366,11370,11372,11375,11389,11682,11686,11687,11692,11694,11714,11716,11723,11725,11730,11736,11982,11989,12102,12336,12348,12350,12384,12393,12395,12397,12510,12553,12851,12962,12973,13738,13823,13919,13933,14080,14298,14585,14698,15583,15847,16318,16434,16438,16481,16729,17102,17122,17315,17320,17402,17418,17859,17909,17911,17915,17916,17936,17939,17961,18664,18703,18814,18962,19043,33469,33470,33471,33484,33485,33490,33497,33501,33505,33513,33520,33536,33550,37845,37921,37948,38029,38038,38064,38065,38066,38069,38075,38076,38078,39108,39109,39113,39114,39115,39116,39265,39394,189000]}');

/***/ }),

/***/ 5914:
/***/ ((module) => {

"use strict";
module.exports = /*#__PURE__*/JSON.parse('[["a140","",62],["a180","",32],["a240","",62],["a280","",32],["a2ab","",5],["a2e3","€"],["a2ef",""],["a2fd",""],["a340","",62],["a380","",31,"　"],["a440","",62],["a480","",32],["a4f4","",10],["a540","",62],["a580","",32],["a5f7","",7],["a640","",62],["a680","",32],["a6b9","",7],["a6d9","",6],["a6ec",""],["a6f3",""],["a6f6","",8],["a740","",62],["a780","",32],["a7c2","",14],["a7f2","",12],["a896","",10],["a8bc","ḿ"],["a8bf","ǹ"],["a8c1",""],["a8ea","",20],["a958",""],["a95b",""],["a95d",""],["a989","〾⿰",11],["a997","",12],["a9f0","",14],["aaa1","",93],["aba1","",93],["aca1","",93],["ada1","",93],["aea1","",93],["afa1","",93],["d7fa","",4],["f8a1","",93],["f9a1","",93],["faa1","",93],["fba1","",93],["fca1","",93],["fda1","",93],["fe50","⺁⺄㑳㑇⺈⺋㖞㘚㘎⺌⺗㥮㤘㧏㧟㩳㧐㭎㱮㳠⺧⺪䁖䅟⺮䌷⺳⺶⺷䎱䎬⺻䏝䓖䙡䙌"],["fe80","䜣䜩䝼䞍⻊䥇䥺䥽䦂䦃䦅䦆䦟䦛䦷䦶䲣䲟䲠䲡䱷䲢䴓",6,"䶮",93],["8135f437",""]]');

/***/ }),

/***/ 679:
/***/ ((module) => {

"use strict";
module.exports = /*#__PURE__*/JSON.parse('[["0","\\u0000",128],["a1","｡",62],["8140","　、。，．・：；？！゛゜´｀¨＾￣＿ヽヾゝゞ〃仝々〆〇ー―‐／＼～∥｜…‥‘’“”（）〔〕［］｛｝〈",9,"＋－±×"],["8180","÷＝≠＜＞≦≧∞∴♂♀°′″℃￥＄￠￡％＃＆＊＠§☆★○●◎◇◆□■△▲▽▼※〒→←↑↓〓"],["81b8","∈∋⊆⊇⊂⊃∪∩"],["81c8","∧∨￢⇒⇔∀∃"],["81da","∠⊥⌒∂∇≡≒≪≫√∽∝∵∫∬"],["81f0","Å‰♯♭♪†‡¶"],["81fc","◯"],["824f","０",9],["8260","Ａ",25],["8281","ａ",25],["829f","ぁ",82],["8340","ァ",62],["8380","ム",22],["839f","Α",16,"Σ",6],["83bf","α",16,"σ",6],["8440","А",5,"ЁЖ",25],["8470","а",5,"ёж",7],["8480","о",17],["849f","─│┌┐┘└├┬┤┴┼━┃┏┓┛┗┣┳┫┻╋┠┯┨┷┿┝┰┥┸╂"],["8740","①",19,"Ⅰ",9],["875f","㍉㌔㌢㍍㌘㌧㌃㌶㍑㍗㌍㌦㌣㌫㍊㌻㎜㎝㎞㎎㎏㏄㎡"],["877e","㍻"],["8780","〝〟№㏍℡㊤",4,"㈱㈲㈹㍾㍽㍼≒≡∫∮∑√⊥∠∟⊿∵∩∪"],["889f","亜唖娃阿哀愛挨姶逢葵茜穐悪握渥旭葦芦鯵梓圧斡扱宛姐虻飴絢綾鮎或粟袷安庵按暗案闇鞍杏以伊位依偉囲夷委威尉惟意慰易椅為畏異移維緯胃萎衣謂違遺医井亥域育郁磯一壱溢逸稲茨芋鰯允印咽員因姻引飲淫胤蔭"],["8940","院陰隠韻吋右宇烏羽迂雨卯鵜窺丑碓臼渦嘘唄欝蔚鰻姥厩浦瓜閏噂云運雲荏餌叡営嬰影映曳栄永泳洩瑛盈穎頴英衛詠鋭液疫益駅悦謁越閲榎厭円"],["8980","園堰奄宴延怨掩援沿演炎焔煙燕猿縁艶苑薗遠鉛鴛塩於汚甥凹央奥往応押旺横欧殴王翁襖鴬鴎黄岡沖荻億屋憶臆桶牡乙俺卸恩温穏音下化仮何伽価佳加可嘉夏嫁家寡科暇果架歌河火珂禍禾稼箇花苛茄荷華菓蝦課嘩貨迦過霞蚊俄峨我牙画臥芽蛾賀雅餓駕介会解回塊壊廻快怪悔恢懐戒拐改"],["8a40","魁晦械海灰界皆絵芥蟹開階貝凱劾外咳害崖慨概涯碍蓋街該鎧骸浬馨蛙垣柿蛎鈎劃嚇各廓拡撹格核殻獲確穫覚角赫較郭閣隔革学岳楽額顎掛笠樫"],["8a80","橿梶鰍潟割喝恰括活渇滑葛褐轄且鰹叶椛樺鞄株兜竃蒲釜鎌噛鴨栢茅萱粥刈苅瓦乾侃冠寒刊勘勧巻喚堪姦完官寛干幹患感慣憾換敢柑桓棺款歓汗漢澗潅環甘監看竿管簡緩缶翰肝艦莞観諌貫還鑑間閑関陥韓館舘丸含岸巌玩癌眼岩翫贋雁頑顔願企伎危喜器基奇嬉寄岐希幾忌揮机旗既期棋棄"],["8b40","機帰毅気汽畿祈季稀紀徽規記貴起軌輝飢騎鬼亀偽儀妓宜戯技擬欺犠疑祇義蟻誼議掬菊鞠吉吃喫桔橘詰砧杵黍却客脚虐逆丘久仇休及吸宮弓急救"],["8b80","朽求汲泣灸球究窮笈級糾給旧牛去居巨拒拠挙渠虚許距鋸漁禦魚亨享京供侠僑兇競共凶協匡卿叫喬境峡強彊怯恐恭挟教橋況狂狭矯胸脅興蕎郷鏡響饗驚仰凝尭暁業局曲極玉桐粁僅勤均巾錦斤欣欽琴禁禽筋緊芹菌衿襟謹近金吟銀九倶句区狗玖矩苦躯駆駈駒具愚虞喰空偶寓遇隅串櫛釧屑屈"],["8c40","掘窟沓靴轡窪熊隈粂栗繰桑鍬勲君薫訓群軍郡卦袈祁係傾刑兄啓圭珪型契形径恵慶慧憩掲携敬景桂渓畦稽系経継繋罫茎荊蛍計詣警軽頚鶏芸迎鯨"],["8c80","劇戟撃激隙桁傑欠決潔穴結血訣月件倹倦健兼券剣喧圏堅嫌建憲懸拳捲検権牽犬献研硯絹県肩見謙賢軒遣鍵険顕験鹸元原厳幻弦減源玄現絃舷言諺限乎個古呼固姑孤己庫弧戸故枯湖狐糊袴股胡菰虎誇跨鈷雇顧鼓五互伍午呉吾娯後御悟梧檎瑚碁語誤護醐乞鯉交佼侯候倖光公功効勾厚口向"],["8d40","后喉坑垢好孔孝宏工巧巷幸広庚康弘恒慌抗拘控攻昂晃更杭校梗構江洪浩港溝甲皇硬稿糠紅紘絞綱耕考肯肱腔膏航荒行衡講貢購郊酵鉱砿鋼閤降"],["8d80","項香高鴻剛劫号合壕拷濠豪轟麹克刻告国穀酷鵠黒獄漉腰甑忽惚骨狛込此頃今困坤墾婚恨懇昏昆根梱混痕紺艮魂些佐叉唆嵯左差査沙瑳砂詐鎖裟坐座挫債催再最哉塞妻宰彩才採栽歳済災采犀砕砦祭斎細菜裁載際剤在材罪財冴坂阪堺榊肴咲崎埼碕鷺作削咋搾昨朔柵窄策索錯桜鮭笹匙冊刷"],["8e40","察拶撮擦札殺薩雑皐鯖捌錆鮫皿晒三傘参山惨撒散桟燦珊産算纂蚕讃賛酸餐斬暫残仕仔伺使刺司史嗣四士始姉姿子屍市師志思指支孜斯施旨枝止"],["8e80","死氏獅祉私糸紙紫肢脂至視詞詩試誌諮資賜雌飼歯事似侍児字寺慈持時次滋治爾璽痔磁示而耳自蒔辞汐鹿式識鴫竺軸宍雫七叱執失嫉室悉湿漆疾質実蔀篠偲柴芝屡蕊縞舎写射捨赦斜煮社紗者謝車遮蛇邪借勺尺杓灼爵酌釈錫若寂弱惹主取守手朱殊狩珠種腫趣酒首儒受呪寿授樹綬需囚収周"],["8f40","宗就州修愁拾洲秀秋終繍習臭舟蒐衆襲讐蹴輯週酋酬集醜什住充十従戎柔汁渋獣縦重銃叔夙宿淑祝縮粛塾熟出術述俊峻春瞬竣舜駿准循旬楯殉淳"],["8f80","準潤盾純巡遵醇順処初所暑曙渚庶緒署書薯藷諸助叙女序徐恕鋤除傷償勝匠升召哨商唱嘗奨妾娼宵将小少尚庄床廠彰承抄招掌捷昇昌昭晶松梢樟樵沼消渉湘焼焦照症省硝礁祥称章笑粧紹肖菖蒋蕉衝裳訟証詔詳象賞醤鉦鍾鐘障鞘上丈丞乗冗剰城場壌嬢常情擾条杖浄状畳穣蒸譲醸錠嘱埴飾"],["9040","拭植殖燭織職色触食蝕辱尻伸信侵唇娠寝審心慎振新晋森榛浸深申疹真神秦紳臣芯薪親診身辛進針震人仁刃塵壬尋甚尽腎訊迅陣靭笥諏須酢図厨"],["9080","逗吹垂帥推水炊睡粋翠衰遂酔錐錘随瑞髄崇嵩数枢趨雛据杉椙菅頗雀裾澄摺寸世瀬畝是凄制勢姓征性成政整星晴棲栖正清牲生盛精聖声製西誠誓請逝醒青静斉税脆隻席惜戚斥昔析石積籍績脊責赤跡蹟碩切拙接摂折設窃節説雪絶舌蝉仙先千占宣専尖川戦扇撰栓栴泉浅洗染潜煎煽旋穿箭線"],["9140","繊羨腺舛船薦詮賎践選遷銭銑閃鮮前善漸然全禅繕膳糎噌塑岨措曾曽楚狙疏疎礎祖租粗素組蘇訴阻遡鼠僧創双叢倉喪壮奏爽宋層匝惣想捜掃挿掻"],["9180","操早曹巣槍槽漕燥争痩相窓糟総綜聡草荘葬蒼藻装走送遭鎗霜騒像増憎臓蔵贈造促側則即息捉束測足速俗属賊族続卒袖其揃存孫尊損村遜他多太汰詑唾堕妥惰打柁舵楕陀駄騨体堆対耐岱帯待怠態戴替泰滞胎腿苔袋貸退逮隊黛鯛代台大第醍題鷹滝瀧卓啄宅托択拓沢濯琢託鐸濁諾茸凧蛸只"],["9240","叩但達辰奪脱巽竪辿棚谷狸鱈樽誰丹単嘆坦担探旦歎淡湛炭短端箪綻耽胆蛋誕鍛団壇弾断暖檀段男談値知地弛恥智池痴稚置致蜘遅馳築畜竹筑蓄"],["9280","逐秩窒茶嫡着中仲宙忠抽昼柱注虫衷註酎鋳駐樗瀦猪苧著貯丁兆凋喋寵帖帳庁弔張彫徴懲挑暢朝潮牒町眺聴脹腸蝶調諜超跳銚長頂鳥勅捗直朕沈珍賃鎮陳津墜椎槌追鎚痛通塚栂掴槻佃漬柘辻蔦綴鍔椿潰坪壷嬬紬爪吊釣鶴亭低停偵剃貞呈堤定帝底庭廷弟悌抵挺提梯汀碇禎程締艇訂諦蹄逓"],["9340","邸鄭釘鼎泥摘擢敵滴的笛適鏑溺哲徹撤轍迭鉄典填天展店添纏甜貼転顛点伝殿澱田電兎吐堵塗妬屠徒斗杜渡登菟賭途都鍍砥砺努度土奴怒倒党冬"],["9380","凍刀唐塔塘套宕島嶋悼投搭東桃梼棟盗淘湯涛灯燈当痘祷等答筒糖統到董蕩藤討謄豆踏逃透鐙陶頭騰闘働動同堂導憧撞洞瞳童胴萄道銅峠鴇匿得徳涜特督禿篤毒独読栃橡凸突椴届鳶苫寅酉瀞噸屯惇敦沌豚遁頓呑曇鈍奈那内乍凪薙謎灘捺鍋楢馴縄畷南楠軟難汝二尼弐迩匂賑肉虹廿日乳入"],["9440","如尿韮任妊忍認濡禰祢寧葱猫熱年念捻撚燃粘乃廼之埜嚢悩濃納能脳膿農覗蚤巴把播覇杷波派琶破婆罵芭馬俳廃拝排敗杯盃牌背肺輩配倍培媒梅"],["9480","楳煤狽買売賠陪這蝿秤矧萩伯剥博拍柏泊白箔粕舶薄迫曝漠爆縛莫駁麦函箱硲箸肇筈櫨幡肌畑畠八鉢溌発醗髪伐罰抜筏閥鳩噺塙蛤隼伴判半反叛帆搬斑板氾汎版犯班畔繁般藩販範釆煩頒飯挽晩番盤磐蕃蛮匪卑否妃庇彼悲扉批披斐比泌疲皮碑秘緋罷肥被誹費避非飛樋簸備尾微枇毘琵眉美"],["9540","鼻柊稗匹疋髭彦膝菱肘弼必畢筆逼桧姫媛紐百謬俵彪標氷漂瓢票表評豹廟描病秒苗錨鋲蒜蛭鰭品彬斌浜瀕貧賓頻敏瓶不付埠夫婦富冨布府怖扶敷"],["9580","斧普浮父符腐膚芙譜負賦赴阜附侮撫武舞葡蕪部封楓風葺蕗伏副復幅服福腹複覆淵弗払沸仏物鮒分吻噴墳憤扮焚奮粉糞紛雰文聞丙併兵塀幣平弊柄並蔽閉陛米頁僻壁癖碧別瞥蔑箆偏変片篇編辺返遍便勉娩弁鞭保舗鋪圃捕歩甫補輔穂募墓慕戊暮母簿菩倣俸包呆報奉宝峰峯崩庖抱捧放方朋"],["9640","法泡烹砲縫胞芳萌蓬蜂褒訪豊邦鋒飽鳳鵬乏亡傍剖坊妨帽忘忙房暴望某棒冒紡肪膨謀貌貿鉾防吠頬北僕卜墨撲朴牧睦穆釦勃没殆堀幌奔本翻凡盆"],["9680","摩磨魔麻埋妹昧枚毎哩槙幕膜枕鮪柾鱒桝亦俣又抹末沫迄侭繭麿万慢満漫蔓味未魅巳箕岬密蜜湊蓑稔脈妙粍民眠務夢無牟矛霧鵡椋婿娘冥名命明盟迷銘鳴姪牝滅免棉綿緬面麺摸模茂妄孟毛猛盲網耗蒙儲木黙目杢勿餅尤戻籾貰問悶紋門匁也冶夜爺耶野弥矢厄役約薬訳躍靖柳薮鑓愉愈油癒"],["9740","諭輸唯佑優勇友宥幽悠憂揖有柚湧涌猶猷由祐裕誘遊邑郵雄融夕予余与誉輿預傭幼妖容庸揚揺擁曜楊様洋溶熔用窯羊耀葉蓉要謡踊遥陽養慾抑欲"],["9780","沃浴翌翼淀羅螺裸来莱頼雷洛絡落酪乱卵嵐欄濫藍蘭覧利吏履李梨理璃痢裏裡里離陸律率立葎掠略劉流溜琉留硫粒隆竜龍侶慮旅虜了亮僚両凌寮料梁涼猟療瞭稜糧良諒遼量陵領力緑倫厘林淋燐琳臨輪隣鱗麟瑠塁涙累類令伶例冷励嶺怜玲礼苓鈴隷零霊麗齢暦歴列劣烈裂廉恋憐漣煉簾練聯"],["9840","蓮連錬呂魯櫓炉賂路露労婁廊弄朗楼榔浪漏牢狼篭老聾蝋郎六麓禄肋録論倭和話歪賄脇惑枠鷲亙亘鰐詫藁蕨椀湾碗腕"],["989f","弌丐丕个丱丶丼丿乂乖乘亂亅豫亊舒弍于亞亟亠亢亰亳亶从仍仄仆仂仗仞仭仟价伉佚估佛佝佗佇佶侈侏侘佻佩佰侑佯來侖儘俔俟俎俘俛俑俚俐俤俥倚倨倔倪倥倅伜俶倡倩倬俾俯們倆偃假會偕偐偈做偖偬偸傀傚傅傴傲"],["9940","僉僊傳僂僖僞僥僭僣僮價僵儉儁儂儖儕儔儚儡儺儷儼儻儿兀兒兌兔兢竸兩兪兮冀冂囘册冉冏冑冓冕冖冤冦冢冩冪冫决冱冲冰况冽凅凉凛几處凩凭"],["9980","凰凵凾刄刋刔刎刧刪刮刳刹剏剄剋剌剞剔剪剴剩剳剿剽劍劔劒剱劈劑辨辧劬劭劼劵勁勍勗勞勣勦飭勠勳勵勸勹匆匈甸匍匐匏匕匚匣匯匱匳匸區卆卅丗卉卍凖卞卩卮夘卻卷厂厖厠厦厥厮厰厶參簒雙叟曼燮叮叨叭叺吁吽呀听吭吼吮吶吩吝呎咏呵咎呟呱呷呰咒呻咀呶咄咐咆哇咢咸咥咬哄哈咨"],["9a40","咫哂咤咾咼哘哥哦唏唔哽哮哭哺哢唹啀啣啌售啜啅啖啗唸唳啝喙喀咯喊喟啻啾喘喞單啼喃喩喇喨嗚嗅嗟嗄嗜嗤嗔嘔嗷嘖嗾嗽嘛嗹噎噐營嘴嘶嘲嘸"],["9a80","噫噤嘯噬噪嚆嚀嚊嚠嚔嚏嚥嚮嚶嚴囂嚼囁囃囀囈囎囑囓囗囮囹圀囿圄圉圈國圍圓團圖嗇圜圦圷圸坎圻址坏坩埀垈坡坿垉垓垠垳垤垪垰埃埆埔埒埓堊埖埣堋堙堝塲堡塢塋塰毀塒堽塹墅墹墟墫墺壞墻墸墮壅壓壑壗壙壘壥壜壤壟壯壺壹壻壼壽夂夊夐夛梦夥夬夭夲夸夾竒奕奐奎奚奘奢奠奧奬奩"],["9b40","奸妁妝佞侫妣妲姆姨姜妍姙姚娥娟娑娜娉娚婀婬婉娵娶婢婪媚媼媾嫋嫂媽嫣嫗嫦嫩嫖嫺嫻嬌嬋嬖嬲嫐嬪嬶嬾孃孅孀孑孕孚孛孥孩孰孳孵學斈孺宀"],["9b80","它宦宸寃寇寉寔寐寤實寢寞寥寫寰寶寳尅將專對尓尠尢尨尸尹屁屆屎屓屐屏孱屬屮乢屶屹岌岑岔妛岫岻岶岼岷峅岾峇峙峩峽峺峭嶌峪崋崕崗嵜崟崛崑崔崢崚崙崘嵌嵒嵎嵋嵬嵳嵶嶇嶄嶂嶢嶝嶬嶮嶽嶐嶷嶼巉巍巓巒巖巛巫已巵帋帚帙帑帛帶帷幄幃幀幎幗幔幟幢幤幇幵并幺麼广庠廁廂廈廐廏"],["9c40","廖廣廝廚廛廢廡廨廩廬廱廳廰廴廸廾弃弉彝彜弋弑弖弩弭弸彁彈彌彎弯彑彖彗彙彡彭彳彷徃徂彿徊很徑徇從徙徘徠徨徭徼忖忻忤忸忱忝悳忿怡恠"],["9c80","怙怐怩怎怱怛怕怫怦怏怺恚恁恪恷恟恊恆恍恣恃恤恂恬恫恙悁悍惧悃悚悄悛悖悗悒悧悋惡悸惠惓悴忰悽惆悵惘慍愕愆惶惷愀惴惺愃愡惻惱愍愎慇愾愨愧慊愿愼愬愴愽慂慄慳慷慘慙慚慫慴慯慥慱慟慝慓慵憙憖憇憬憔憚憊憑憫憮懌懊應懷懈懃懆憺懋罹懍懦懣懶懺懴懿懽懼懾戀戈戉戍戌戔戛"],["9d40","戞戡截戮戰戲戳扁扎扞扣扛扠扨扼抂抉找抒抓抖拔抃抔拗拑抻拏拿拆擔拈拜拌拊拂拇抛拉挌拮拱挧挂挈拯拵捐挾捍搜捏掖掎掀掫捶掣掏掉掟掵捫"],["9d80","捩掾揩揀揆揣揉插揶揄搖搴搆搓搦搶攝搗搨搏摧摯摶摎攪撕撓撥撩撈撼據擒擅擇撻擘擂擱擧舉擠擡抬擣擯攬擶擴擲擺攀擽攘攜攅攤攣攫攴攵攷收攸畋效敖敕敍敘敞敝敲數斂斃變斛斟斫斷旃旆旁旄旌旒旛旙无旡旱杲昊昃旻杳昵昶昴昜晏晄晉晁晞晝晤晧晨晟晢晰暃暈暎暉暄暘暝曁暹曉暾暼"],["9e40","曄暸曖曚曠昿曦曩曰曵曷朏朖朞朦朧霸朮朿朶杁朸朷杆杞杠杙杣杤枉杰枩杼杪枌枋枦枡枅枷柯枴柬枳柩枸柤柞柝柢柮枹柎柆柧檜栞框栩桀桍栲桎"],["9e80","梳栫桙档桷桿梟梏梭梔條梛梃檮梹桴梵梠梺椏梍桾椁棊椈棘椢椦棡椌棍棔棧棕椶椒椄棗棣椥棹棠棯椨椪椚椣椡棆楹楷楜楸楫楔楾楮椹楴椽楙椰楡楞楝榁楪榲榮槐榿槁槓榾槎寨槊槝榻槃榧樮榑榠榜榕榴槞槨樂樛槿權槹槲槧樅榱樞槭樔槫樊樒櫁樣樓橄樌橲樶橸橇橢橙橦橈樸樢檐檍檠檄檢檣"],["9f40","檗蘗檻櫃櫂檸檳檬櫞櫑櫟檪櫚櫪櫻欅蘖櫺欒欖鬱欟欸欷盜欹飮歇歃歉歐歙歔歛歟歡歸歹歿殀殄殃殍殘殕殞殤殪殫殯殲殱殳殷殼毆毋毓毟毬毫毳毯"],["9f80","麾氈氓气氛氤氣汞汕汢汪沂沍沚沁沛汾汨汳沒沐泄泱泓沽泗泅泝沮沱沾沺泛泯泙泪洟衍洶洫洽洸洙洵洳洒洌浣涓浤浚浹浙涎涕濤涅淹渕渊涵淇淦涸淆淬淞淌淨淒淅淺淙淤淕淪淮渭湮渮渙湲湟渾渣湫渫湶湍渟湃渺湎渤滿渝游溂溪溘滉溷滓溽溯滄溲滔滕溏溥滂溟潁漑灌滬滸滾漿滲漱滯漲滌"],["e040","漾漓滷澆潺潸澁澀潯潛濳潭澂潼潘澎澑濂潦澳澣澡澤澹濆澪濟濕濬濔濘濱濮濛瀉瀋濺瀑瀁瀏濾瀛瀚潴瀝瀘瀟瀰瀾瀲灑灣炙炒炯烱炬炸炳炮烟烋烝"],["e080","烙焉烽焜焙煥煕熈煦煢煌煖煬熏燻熄熕熨熬燗熹熾燒燉燔燎燠燬燧燵燼燹燿爍爐爛爨爭爬爰爲爻爼爿牀牆牋牘牴牾犂犁犇犒犖犢犧犹犲狃狆狄狎狒狢狠狡狹狷倏猗猊猜猖猝猴猯猩猥猾獎獏默獗獪獨獰獸獵獻獺珈玳珎玻珀珥珮珞璢琅瑯琥珸琲琺瑕琿瑟瑙瑁瑜瑩瑰瑣瑪瑶瑾璋璞璧瓊瓏瓔珱"],["e140","瓠瓣瓧瓩瓮瓲瓰瓱瓸瓷甄甃甅甌甎甍甕甓甞甦甬甼畄畍畊畉畛畆畚畩畤畧畫畭畸當疆疇畴疊疉疂疔疚疝疥疣痂疳痃疵疽疸疼疱痍痊痒痙痣痞痾痿"],["e180","痼瘁痰痺痲痳瘋瘍瘉瘟瘧瘠瘡瘢瘤瘴瘰瘻癇癈癆癜癘癡癢癨癩癪癧癬癰癲癶癸發皀皃皈皋皎皖皓皙皚皰皴皸皹皺盂盍盖盒盞盡盥盧盪蘯盻眈眇眄眩眤眞眥眦眛眷眸睇睚睨睫睛睥睿睾睹瞎瞋瞑瞠瞞瞰瞶瞹瞿瞼瞽瞻矇矍矗矚矜矣矮矼砌砒礦砠礪硅碎硴碆硼碚碌碣碵碪碯磑磆磋磔碾碼磅磊磬"],["e240","磧磚磽磴礇礒礑礙礬礫祀祠祗祟祚祕祓祺祿禊禝禧齋禪禮禳禹禺秉秕秧秬秡秣稈稍稘稙稠稟禀稱稻稾稷穃穗穉穡穢穩龝穰穹穽窈窗窕窘窖窩竈窰"],["e280","窶竅竄窿邃竇竊竍竏竕竓站竚竝竡竢竦竭竰笂笏笊笆笳笘笙笞笵笨笶筐筺笄筍笋筌筅筵筥筴筧筰筱筬筮箝箘箟箍箜箚箋箒箏筝箙篋篁篌篏箴篆篝篩簑簔篦篥籠簀簇簓篳篷簗簍篶簣簧簪簟簷簫簽籌籃籔籏籀籐籘籟籤籖籥籬籵粃粐粤粭粢粫粡粨粳粲粱粮粹粽糀糅糂糘糒糜糢鬻糯糲糴糶糺紆"],["e340","紂紜紕紊絅絋紮紲紿紵絆絳絖絎絲絨絮絏絣經綉絛綏絽綛綺綮綣綵緇綽綫總綢綯緜綸綟綰緘緝緤緞緻緲緡縅縊縣縡縒縱縟縉縋縢繆繦縻縵縹繃縷"],["e380","縲縺繧繝繖繞繙繚繹繪繩繼繻纃緕繽辮繿纈纉續纒纐纓纔纖纎纛纜缸缺罅罌罍罎罐网罕罔罘罟罠罨罩罧罸羂羆羃羈羇羌羔羞羝羚羣羯羲羹羮羶羸譱翅翆翊翕翔翡翦翩翳翹飜耆耄耋耒耘耙耜耡耨耿耻聊聆聒聘聚聟聢聨聳聲聰聶聹聽聿肄肆肅肛肓肚肭冐肬胛胥胙胝胄胚胖脉胯胱脛脩脣脯腋"],["e440","隋腆脾腓腑胼腱腮腥腦腴膃膈膊膀膂膠膕膤膣腟膓膩膰膵膾膸膽臀臂膺臉臍臑臙臘臈臚臟臠臧臺臻臾舁舂舅與舊舍舐舖舩舫舸舳艀艙艘艝艚艟艤"],["e480","艢艨艪艫舮艱艷艸艾芍芒芫芟芻芬苡苣苟苒苴苳苺莓范苻苹苞茆苜茉苙茵茴茖茲茱荀茹荐荅茯茫茗茘莅莚莪莟莢莖茣莎莇莊荼莵荳荵莠莉莨菴萓菫菎菽萃菘萋菁菷萇菠菲萍萢萠莽萸蔆菻葭萪萼蕚蒄葷葫蒭葮蒂葩葆萬葯葹萵蓊葢蒹蒿蒟蓙蓍蒻蓚蓐蓁蓆蓖蒡蔡蓿蓴蔗蔘蔬蔟蔕蔔蓼蕀蕣蕘蕈"],["e540","蕁蘂蕋蕕薀薤薈薑薊薨蕭薔薛藪薇薜蕷蕾薐藉薺藏薹藐藕藝藥藜藹蘊蘓蘋藾藺蘆蘢蘚蘰蘿虍乕虔號虧虱蚓蚣蚩蚪蚋蚌蚶蚯蛄蛆蚰蛉蠣蚫蛔蛞蛩蛬"],["e580","蛟蛛蛯蜒蜆蜈蜀蜃蛻蜑蜉蜍蛹蜊蜴蜿蜷蜻蜥蜩蜚蝠蝟蝸蝌蝎蝴蝗蝨蝮蝙蝓蝣蝪蠅螢螟螂螯蟋螽蟀蟐雖螫蟄螳蟇蟆螻蟯蟲蟠蠏蠍蟾蟶蟷蠎蟒蠑蠖蠕蠢蠡蠱蠶蠹蠧蠻衄衂衒衙衞衢衫袁衾袞衵衽袵衲袂袗袒袮袙袢袍袤袰袿袱裃裄裔裘裙裝裹褂裼裴裨裲褄褌褊褓襃褞褥褪褫襁襄褻褶褸襌褝襠襞"],["e640","襦襤襭襪襯襴襷襾覃覈覊覓覘覡覩覦覬覯覲覺覽覿觀觚觜觝觧觴觸訃訖訐訌訛訝訥訶詁詛詒詆詈詼詭詬詢誅誂誄誨誡誑誥誦誚誣諄諍諂諚諫諳諧"],["e680","諤諱謔諠諢諷諞諛謌謇謚諡謖謐謗謠謳鞫謦謫謾謨譁譌譏譎證譖譛譚譫譟譬譯譴譽讀讌讎讒讓讖讙讚谺豁谿豈豌豎豐豕豢豬豸豺貂貉貅貊貍貎貔豼貘戝貭貪貽貲貳貮貶賈賁賤賣賚賽賺賻贄贅贊贇贏贍贐齎贓賍贔贖赧赭赱赳趁趙跂趾趺跏跚跖跌跛跋跪跫跟跣跼踈踉跿踝踞踐踟蹂踵踰踴蹊"],["e740","蹇蹉蹌蹐蹈蹙蹤蹠踪蹣蹕蹶蹲蹼躁躇躅躄躋躊躓躑躔躙躪躡躬躰軆躱躾軅軈軋軛軣軼軻軫軾輊輅輕輒輙輓輜輟輛輌輦輳輻輹轅轂輾轌轉轆轎轗轜"],["e780","轢轣轤辜辟辣辭辯辷迚迥迢迪迯邇迴逅迹迺逑逕逡逍逞逖逋逧逶逵逹迸遏遐遑遒逎遉逾遖遘遞遨遯遶隨遲邂遽邁邀邊邉邏邨邯邱邵郢郤扈郛鄂鄒鄙鄲鄰酊酖酘酣酥酩酳酲醋醉醂醢醫醯醪醵醴醺釀釁釉釋釐釖釟釡釛釼釵釶鈞釿鈔鈬鈕鈑鉞鉗鉅鉉鉤鉈銕鈿鉋鉐銜銖銓銛鉚鋏銹銷鋩錏鋺鍄錮"],["e840","錙錢錚錣錺錵錻鍜鍠鍼鍮鍖鎰鎬鎭鎔鎹鏖鏗鏨鏥鏘鏃鏝鏐鏈鏤鐚鐔鐓鐃鐇鐐鐶鐫鐵鐡鐺鑁鑒鑄鑛鑠鑢鑞鑪鈩鑰鑵鑷鑽鑚鑼鑾钁鑿閂閇閊閔閖閘閙"],["e880","閠閨閧閭閼閻閹閾闊濶闃闍闌闕闔闖關闡闥闢阡阨阮阯陂陌陏陋陷陜陞陝陟陦陲陬隍隘隕隗險隧隱隲隰隴隶隸隹雎雋雉雍襍雜霍雕雹霄霆霈霓霎霑霏霖霙霤霪霰霹霽霾靄靆靈靂靉靜靠靤靦靨勒靫靱靹鞅靼鞁靺鞆鞋鞏鞐鞜鞨鞦鞣鞳鞴韃韆韈韋韜韭齏韲竟韶韵頏頌頸頤頡頷頽顆顏顋顫顯顰"],["e940","顱顴顳颪颯颱颶飄飃飆飩飫餃餉餒餔餘餡餝餞餤餠餬餮餽餾饂饉饅饐饋饑饒饌饕馗馘馥馭馮馼駟駛駝駘駑駭駮駱駲駻駸騁騏騅駢騙騫騷驅驂驀驃"],["e980","騾驕驍驛驗驟驢驥驤驩驫驪骭骰骼髀髏髑髓體髞髟髢髣髦髯髫髮髴髱髷髻鬆鬘鬚鬟鬢鬣鬥鬧鬨鬩鬪鬮鬯鬲魄魃魏魍魎魑魘魴鮓鮃鮑鮖鮗鮟鮠鮨鮴鯀鯊鮹鯆鯏鯑鯒鯣鯢鯤鯔鯡鰺鯲鯱鯰鰕鰔鰉鰓鰌鰆鰈鰒鰊鰄鰮鰛鰥鰤鰡鰰鱇鰲鱆鰾鱚鱠鱧鱶鱸鳧鳬鳰鴉鴈鳫鴃鴆鴪鴦鶯鴣鴟鵄鴕鴒鵁鴿鴾鵆鵈"],["ea40","鵝鵞鵤鵑鵐鵙鵲鶉鶇鶫鵯鵺鶚鶤鶩鶲鷄鷁鶻鶸鶺鷆鷏鷂鷙鷓鷸鷦鷭鷯鷽鸚鸛鸞鹵鹹鹽麁麈麋麌麒麕麑麝麥麩麸麪麭靡黌黎黏黐黔黜點黝黠黥黨黯"],["ea80","黴黶黷黹黻黼黽鼇鼈皷鼕鼡鼬鼾齊齒齔齣齟齠齡齦齧齬齪齷齲齶龕龜龠堯槇遙瑤凜熙"],["ed40","纊褜鍈銈蓜俉炻昱棈鋹曻彅丨仡仼伀伃伹佖侒侊侚侔俍偀倢俿倞偆偰偂傔僴僘兊兤冝冾凬刕劜劦勀勛匀匇匤卲厓厲叝﨎咜咊咩哿喆坙坥垬埈埇﨏"],["ed80","塚增墲夋奓奛奝奣妤妺孖寀甯寘寬尞岦岺峵崧嵓﨑嵂嵭嶸嶹巐弡弴彧德忞恝悅悊惞惕愠惲愑愷愰憘戓抦揵摠撝擎敎昀昕昻昉昮昞昤晥晗晙晴晳暙暠暲暿曺朎朗杦枻桒柀栁桄棏﨓楨﨔榘槢樰橫橆橳橾櫢櫤毖氿汜沆汯泚洄涇浯涖涬淏淸淲淼渹湜渧渼溿澈澵濵瀅瀇瀨炅炫焏焄煜煆煇凞燁燾犱"],["ee40","犾猤猪獷玽珉珖珣珒琇珵琦琪琩琮瑢璉璟甁畯皂皜皞皛皦益睆劯砡硎硤硺礰礼神祥禔福禛竑竧靖竫箞精絈絜綷綠緖繒罇羡羽茁荢荿菇菶葈蒴蕓蕙"],["ee80","蕫﨟薰蘒﨡蠇裵訒訷詹誧誾諟諸諶譓譿賰賴贒赶﨣軏﨤逸遧郞都鄕鄧釚釗釞釭釮釤釥鈆鈐鈊鈺鉀鈼鉎鉙鉑鈹鉧銧鉷鉸鋧鋗鋙鋐﨧鋕鋠鋓錥錡鋻﨨錞鋿錝錂鍰鍗鎤鏆鏞鏸鐱鑅鑈閒隆﨩隝隯霳霻靃靍靏靑靕顗顥飯飼餧館馞驎髙髜魵魲鮏鮱鮻鰀鵰鵫鶴鸙黑"],["eeef","ⅰ",9,"￢￤＇＂"],["f040","",62],["f080","",124],["f140","",62],["f180","",124],["f240","",62],["f280","",124],["f340","",62],["f380","",124],["f440","",62],["f480","",124],["f540","",62],["f580","",124],["f640","",62],["f680","",124],["f740","",62],["f780","",124],["f840","",62],["f880","",124],["f940",""],["fa40","ⅰ",9,"Ⅰ",9,"￢￤＇＂㈱№℡∵纊褜鍈銈蓜俉炻昱棈鋹曻彅丨仡仼伀伃伹佖侒侊侚侔俍偀倢俿倞偆偰偂傔僴僘兊"],["fa80","兤冝冾凬刕劜劦勀勛匀匇匤卲厓厲叝﨎咜咊咩哿喆坙坥垬埈埇﨏塚增墲夋奓奛奝奣妤妺孖寀甯寘寬尞岦岺峵崧嵓﨑嵂嵭嶸嶹巐弡弴彧德忞恝悅悊惞惕愠惲愑愷愰憘戓抦揵摠撝擎敎昀昕昻昉昮昞昤晥晗晙晴晳暙暠暲暿曺朎朗杦枻桒柀栁桄棏﨓楨﨔榘槢樰橫橆橳橾櫢櫤毖氿汜沆汯泚洄涇浯"],["fb40","涖涬淏淸淲淼渹湜渧渼溿澈澵濵瀅瀇瀨炅炫焏焄煜煆煇凞燁燾犱犾猤猪獷玽珉珖珣珒琇珵琦琪琩琮瑢璉璟甁畯皂皜皞皛皦益睆劯砡硎硤硺礰礼神"],["fb80","祥禔福禛竑竧靖竫箞精絈絜綷綠緖繒罇羡羽茁荢荿菇菶葈蒴蕓蕙蕫﨟薰蘒﨡蠇裵訒訷詹誧誾諟諸諶譓譿賰賴贒赶﨣軏﨤逸遧郞都鄕鄧釚釗釞釭釮釤釥鈆鈐鈊鈺鉀鈼鉎鉙鉑鈹鉧銧鉷鉸鋧鋗鋙鋐﨧鋕鋠鋓錥錡鋻﨨錞鋿錝錂鍰鍗鎤鏆鏞鏸鐱鑅鑈閒隆﨩隝隯霳霻靃靍靏靑靕顗顥飯飼餧館馞驎髙"],["fc40","髜魵魲鮏鮱鮻鰀鵰鵫鶴鸙黑"]]');

/***/ }),

/***/ 2145:
/***/ ((module) => {

"use strict";
module.exports = {"rE":"3.2.0"};

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			loaded: false,
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = __webpack_modules__;
/******/ 	
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = __webpack_module_cache__;
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/get javascript chunk filename */
/******/ 	(() => {
/******/ 		// This function allow to reference async chunks
/******/ 		__webpack_require__.u = (chunkId) => {
/******/ 			// return url for filenames based on template
/******/ 			return "" + "dbService.worker" + ".js";
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/node module decorator */
/******/ 	(() => {
/******/ 		__webpack_require__.nmd = (module) => {
/******/ 			module.paths = [];
/******/ 			if (!module.children) module.children = [];
/******/ 			return module;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/publicPath */
/******/ 	(() => {
/******/ 		__webpack_require__.p = "";
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/require chunk loading */
/******/ 	(() => {
/******/ 		__webpack_require__.b = require("url").pathToFileURL(__filename);
/******/ 		
/******/ 		// object to store loaded chunks
/******/ 		// "1" means "loaded", otherwise not loaded yet
/******/ 		var installedChunks = {
/******/ 			792: 1
/******/ 		};
/******/ 		
/******/ 		// no on chunks loaded
/******/ 		
/******/ 		// no chunk install function needed
/******/ 		
/******/ 		// no chunk loading
/******/ 		
/******/ 		// no external install chunk
/******/ 		
/******/ 		// no HMR
/******/ 		
/******/ 		// no HMR manifest
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// module cache are used so entry inlining is disabled
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	var __webpack_exports__ = __webpack_require__(__webpack_require__.s = 1055);
/******/ 	module.exports = __webpack_exports__;
/******/ 	
/******/ })()
;